/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/base/common/path","vs/platform/log/common/log","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/network","vs/base/common/arrays","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/instantiation/common/extensions","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(X){for(var e=[],k=0,T=X.length;k<T;k++)e[k]=te[X[k]];return e};define(te[101],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(T,P){if(!T)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=k}),define(te[67],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function T(n){const E=[];for(let d in n)k.call(n,d)&&E.push(n[d]);return E}e.values=T;function P(n,E){for(let d in n)if(k.call(n,d)&&E({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=P;function R(n,E){const d=Object.create(null);for(const p of n){const h=E(p);let y=d[h];y||(y=d[h]=[]),y.push(p)}return d}e.groupBy=R;function D(n){const E=Object.create(null);return n&&n.forEach((d,p)=>{E[p]=d}),E}e.fromMap=D;function C(n,E){const d=[],p=[];for(let h of n)E.has(h)||d.push(h);for(let h of E)n.has(h)||p.push(h);return{removed:d,added:p}}e.diffSets=C;function w(n,E){const d=[],p=[];for(let[h,y]of n)E.has(h)||d.push(y);for(let[h,y]of E)n.has(h)||p.push(y);return{removed:d,added:p}}e.diffMaps=w;class I{constructor(){this.map=new Map}add(E,d){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(d)}delete(E,d){const p=this.map.get(E);!p||(p.delete(d),p.size===0&&this.map.delete(E))}forEach(E,d){const p=this.map.get(E);!p||p.forEach(d)}}e.SetMap=I}),define(te[68],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(D){return(C,w,I)=>{let n=null,E=null;if(typeof I.value=="function"?(n="value",E=I.value):typeof I.get=="function"&&(n="get",E=I.get),!E)throw new Error("not supported");I[n]=D(E,w)}}e.createDecorator=k;function T(D,C,w){let I=null,n=null;if(typeof w.value=="function"?(I="value",n=w.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(I="get",n=w.get),!n)throw new Error("not supported");const E=`$memoize$${C}`;w[I]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[E]}}e.memoize=T;function P(D,C,w){return k((I,n)=>{const E=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...p){this[d]||(this[d]=w?w():void 0),clearTimeout(this[E]),C&&(this[d]=C(this[d],...p),p=[this[d]]),this[E]=setTimeout(()=>{I.apply(this,p),this[d]=w?w():void 0},D)}})}e.debounce=P;function R(D,C,w){return k((I,n)=>{const E=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,p=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...y){if(this[d]||(this[d]=w?w():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),C&&(this[d]=C(this[d],...y)),this[h])return;const S=this[p]+D;S<=Date.now()?(this[p]=Date.now(),I.apply(this,[this[d]]),this[d]=w?w():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),I.apply(this,[this[d]]),this[d]=w?w():void 0},S-Date.now()))}})}e.throttle=R}),define(te[7],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(i){setTimeout(()=>{throw i.stack?new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.listeners.push(i),()=>{this._removeListener(i)}}emit(i){this.listeners.forEach(s=>{s(i)})}_removeListener(i){this.listeners.splice(this.listeners.indexOf(i),1)}setUnexpectedErrorHandler(i){this.unexpectedErrorHandler=i}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(i){this.unexpectedErrorHandler(i),this.emit(i)}onUnexpectedExternalError(i){this.unexpectedErrorHandler(i)}}e.ErrorHandler=k,e.errorHandler=new k;function T(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function P(l){w(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=P;function R(l){w(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function D(l){if(l instanceof Error){let{name:i,message:s}=l;const r=l.stacktrace||l.stack;return{$isError:!0,name:i,message:s,stack:r}}return l}e.transformErrorForSerialization=D;const C="Canceled";function w(l){return l instanceof Error&&l.name===C&&l.message===C}e.isPromiseCanceledError=w;class I extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=I;function n(){const l=new Error(C);return l.name=l.message,l}e.canceled=n;function E(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=E;function d(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=d;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(l){const i=new Error(`${l} has been disposed`);return i.name="DISPOSED",i}e.disposed=h;function y(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=y;class S extends Error{constructor(i){super("NotImplemented");i&&(this.message=i)}}e.NotImplementedError=S;class m extends Error{constructor(i){super("NotSupported");i&&(this.message=i)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function f(l){const i=l;return i instanceof Error&&Array.isArray(i.actions)}e.isErrorWithActions=f;function c(l,i=Object.create(null)){const s=new Error(l);return i.actions&&(s.actions=i.actions),s}e.createErrorWithActions=c}),define(te[16],ne([0,1,7]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(F,B=0){return F[F.length-(1+B)]}e.tail=T;function P(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=P;function R(F,B,V=(Q,Z)=>Q===Z){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let Q=0,Z=F.length;Q<Z;Q++)if(!V(F[Q],B[Q]))return!1;return!0}e.equals=R;function D(F,B,V){let Q=0,Z=F.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=V(F[G],B);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=D;function C(F,B){let V=0,Q=F.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(F[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=C;function w(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return F<Z.length?w(F,Z,V):F<Z.length+H.length?H[0]:w(F-(Z.length+H.length),G,V)}e.quickSelect=w;function I(F,B){const V=[];let Q;for(const Z of F.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=I;function n(F,B,V){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===F.length){Z(G,0,B.slice(H));break}if(H===B.length){Z(G,F.length-G,[]);break}const re=F[G],ie=B[H],ce=V(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=n;function E(F,B,V){const Q=n(F,B,V),Z=[],G=[];for(const H of Q)Z.push(...F.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=E;function d(F,B,V){if(V===0)return[];const Q=F.slice(0,V).sort(B);return h(F,B,Q,V,F.length),Q}e.top=d;function p(F,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=F.length,ie=F.slice(0,V).sort(B);for(let ce=V,le=Math.min(V+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>V&&await new Promise(de=>setTimeout(de)),Z&&Z.isCancellationRequested)throw(0,k.canceled)();h(F,B,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=p;function h(F,B,V,Q,Z){for(const G=V.length;Q<Z;Q++){const H=F[Q];if(B(H,V[G-1])<0){V.pop();const re=C(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function y(F){return F.filter(B=>!!B)}e.coalesce=y;function S(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.coalesceInPlace=S;function m(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.move=m;function v(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=v;function f(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=f;function c(F,B=V=>V){const V=new Set;return F.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=c;function l(F){const B=Object.create(null);return V=>{const Q=F(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=l;function i(F,B){const V=s(F,B);if(V!==-1)return F[V]}e.findLast=i;function s(F,B){for(let V=F.length-1;V>=0;V--){const Q=F[V];if(B(Q))return V}return-1}e.lastIndex=s;function r(F,B){return F.length>0?F[0]:B}e.firstOrDefault=r;function t(F,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(F.length,B.length);Z<G&&V(F[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function a(F){return[].concat(...F)}e.flatten=a;function o(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=o;function u(F,B,V){return F.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function g(F,B){return F.push(B),()=>b(F,B)}e.insert=g;function b(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.remove=b;function A(F,B,V){const Q=F.slice(0,B),Z=F.slice(B);return Q.concat(V,Z)}e.arrayInsert=A;function U(F,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=F.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),G=F[Q];F[Q]=F[Z],F[Z]=G}}e.shuffle=U;function O(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.pushToStart=O;function q(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.pushToEnd=q;function N(F,B){return Array.isArray(F)?F.map(B):B(F)}e.mapArrayOrNot=N;function L(F){return Array.isArray(F)?F:[F]}e.asArray=L;function $(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=$;function _(F,B){for(const V of F){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=_;function M(F,B,V){const Q=W(F,B),Z=F.length,G=V.length;F.length=Z+G;for(let H=Z-1;H>=Q;H--)F[H+G]=F[H];for(let H=0;H<G;H++)F[H+Q]=V[H]}e.insertInto=M;function j(F,B,V,Q){const Z=W(F,B),G=F.splice(Z,V);return M(F,Z,Q),G}e.splice=j;function W(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}function x(F,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H<V&&(V=H,Q=G)}),Q}e.minIndex=x;function z(F,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H>V&&(V=H,Q=G)}),Q}e.maxIndex=z;class K{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const V=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,V}}e.ArrayQueue=K}),define(te[69],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(T){const P=this;let R=!1,D;return function(){return R||(R=!0,D=T.apply(P,arguments)),D}}e.once=k}),define(te[56],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(T){function P(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=P;const R=Object.freeze([]);function D(){return R}T.empty=D;function*C(l){yield l}T.single=C;function w(l){return l||R}T.from=w;function I(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=I;function n(l){return l[Symbol.iterator]().next().value}T.first=n;function E(l,i){for(const s of l)if(i(s))return!0;return!1}T.some=E;function d(l,i){for(const s of l)if(i(s))return s}T.find=d;function*p(l,i){for(const s of l)i(s)&&(yield s)}T.filter=p;function*h(l,i){let s=0;for(const r of l)yield i(r,s++)}T.map=h;function*y(...l){for(const i of l)for(const s of i)yield s}T.concat=y;function*S(l){for(const i of l)for(const s of i)yield s}T.concatNested=S;function m(l,i,s){let r=s;for(const t of l)r=i(r,t);return r}T.reduce=m;function*v(l,i,s=l.length){for(i<0&&(i+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);i<s;i++)yield l[i]}T.slice=v;function f(l,i=Number.POSITIVE_INFINITY){const s=[];if(i===0)return[s,l];const r=l[Symbol.iterator]();for(let t=0;t<i;t++){const a=r.next();if(a.done)return[s,T.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}T.consume=f;function c(l,i,s=(r,t)=>r===t){const r=l[Symbol.iterator](),t=i[Symbol.iterator]();for(;;){const a=r.next(),o=t.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}T.equals=c})(k=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function D(i,s=!1){let r=0,t=i.length,a="",o=0,u=16,g=0;function b($){let _=0,M=0;for(;_<$;){const j=i.charCodeAt(r);if(j>=48&&j<=57)M=M*16+j-48;else if(j>=65&&j<=70)M=M*16+j-65+10;else if(j>=97&&j<=102)M=M*16+j-97+10;else break;r++,_++}return _<$&&(M=-1),M}function A($){r=$,a="",o=0,u=16,g=0}function U(){const $=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&I(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&I(i.charCodeAt(r)))for(r++;r<i.length&&I(i.charCodeAt(r));)r++;else return g=3,i.substring($,r);let _=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&I(i.charCodeAt(r))){for(r++;r<i.length&&I(i.charCodeAt(r));)r++;_=r}else g=3;return i.substring($,_)}function O(){let $="",_=r;for(;;){if(r>=t){$+=i.substring(_,r),g=2;break}const M=i.charCodeAt(r);if(M===34){$+=i.substring(_,r),r++;break}if(M===92){if($+=i.substring(_,r),r++,r>=t){g=2;break}switch(i.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const W=b(4);W>=0?$+=String.fromCharCode(W):g=4;break;default:g=5}_=r;continue}if(M>=0&&M<=31)if(w(M)){$+=i.substring(_,r),g=2;break}else g=6;r++}return $}function q(){if(a="",g=0,o=r,r>=t)return o=t,u=17;let $=i.charCodeAt(r);if(C($)){do r++,a+=String.fromCharCode($),$=i.charCodeAt(r);while(C($));return u=15}if(w($))return r++,a+=String.fromCharCode($),$===13&&i.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch($){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=O(),u=10;case 47:const _=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<t&&!w(i.charCodeAt(r));)r++;return a=i.substring(_,r),u=12}if(i.charCodeAt(r+1)===42){r+=2;const M=t-1;let j=!1;for(;r<M;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,j=!0;break}r++}return j||(r++,g=1),a=i.substring(_,r),u=13}return a+=String.fromCharCode($),r++,u=16;case 45:if(a+=String.fromCharCode($),r++,r===t||!I(i.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),u=11;default:for(;r<t&&N($);)r++,$=i.charCodeAt(r);if(o!==r){switch(a=i.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),r++,u=16}}function N($){if(C($)||w($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=q();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>r,scan:s?L:q,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>g}}e.createScanner=D;function C(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function w(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var n;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(n||(n={}));function E(i,s){const r=[],t=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(b,A,U,O){o.value=b,o.offset=A,o.length=U,o.type=O,o.colonOffset=void 0,a=o}try{f(i,{onObjectBegin:(b,A)=>{if(s<=b)throw t;a=void 0,u=s>b,r.push("")},onObjectProperty:(b,A,U)=>{if(s<A||(g(b,A,U,"property"),r[r.length-1]=b,s<=A+U))throw t},onObjectEnd:(b,A)=>{if(s<=b)throw t;a=void 0,r.pop()},onArrayBegin:(b,A)=>{if(s<=b)throw t;a=void 0,r.push(0)},onArrayEnd:(b,A)=>{if(s<=b)throw t;a=void 0,r.pop()},onLiteralValue:(b,A,U)=>{if(s<A||(g(b,A,U,l(b)),s<=A+U))throw t},onSeparator:(b,A,U)=>{if(s<=A)throw t;if(b===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(b===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(b){if(b!==t)throw b}return{path:r,previousNode:a,isAtPropertyKey:u,matches:b=>{let A=0;for(let U=0;A<b.length&&U<r.length;U++)if(b[A]===r[U]||b[A]==="*")A++;else if(b[A]!=="**")return!1;return A===b.length}}}e.getLocation=E;function d(i,s=[],r=R.DEFAULT){let t=null,a=[];const o=[];function u(b){Array.isArray(a)?a.push(b):t!==null&&(a[t]=b)}return f(i,{onObjectBegin:()=>{const b={};u(b),o.push(a),a=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const b=[];u(b),o.push(a),a=b,t=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(b,A,U)=>{s.push({error:b,offset:A,length:U})}},r),a[0]}e.parse=d;function p(i,s=[],r=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function o(b){return t.children.push(b),b}f(i,{onObjectBegin:b=>{t=o({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,A,U)=>{t=o({type:"property",offset:A,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:A,length:U,parent:t})},onObjectEnd:(b,A)=>{t.length=b+A-t.offset,t=t.parent,a(b+A)},onArrayBegin:(b,A)=>{t=o({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,A)=>{t.length=b+A-t.offset,t=t.parent,a(b+A)},onLiteralValue:(b,A,U)=>{o({type:l(b),offset:A,length:U,parent:t,value:b}),a(A+U)},onSeparator:(b,A,U)=>{t.type==="property"&&(b===":"?t.colonOffset=A:b===","&&a(A))},onError:(b,A,U)=>{s.push({error:b,offset:A,length:U})}},r);const g=t.children[0];return g&&delete g.parent,g}e.parseTree=p;function h(i,s){if(!i)return;let r=i;for(let t of s)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],a=!0;break}if(!a)return}else{const a=t;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=h;function y(i){if(!i.parent||!i.parent.children)return[];const s=y(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}e.getNodePath=y;function S(i){switch(i.type){case"array":return i.children.map(S);case"object":const s=Object.create(null);for(let r of i.children){const t=r.children[1];t&&(s[r.children[0].value]=S(t))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=S;function m(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}e.contains=m;function v(i,s,r=!1){if(m(i,s,r)){const t=i.children;if(Array.isArray(t))for(let a=0;a<t.length&&t[a].offset<=s;a++){const o=v(t[a],s,r);if(o)return o}return i}}e.findNodeAtOffset=v;function f(i,s,r=R.DEFAULT){const t=D(i,!1);function a(V){return V?()=>V(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(V){return V?Q=>V(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),g=o(s.onObjectProperty),b=a(s.onObjectEnd),A=a(s.onArrayBegin),U=a(s.onArrayEnd),O=o(s.onLiteralValue),q=o(s.onSeparator),N=a(s.onComment),L=o(s.onError),$=r&&r.disallowComments,_=r&&r.allowTrailingComma;function M(){for(;;){const V=t.scan();switch(t.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:$||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(V){case 12:case 13:$?j(10):N();break;case 16:j(1);break;case 15:case 14:break;default:return V}}}function j(V,Q=[],Z=[]){if(L(V),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){M();break}else if(Z.indexOf(G)!==-1)break;G=M()}}}function W(V){const Q=t.getTokenValue();return V?O(Q):g(Q),M(),!0}function x(){switch(t.getToken()){case 11:let V=0;try{V=JSON.parse(t.getTokenValue()),typeof V!="number"&&(j(2),V=0)}catch(Q){j(2)}O(V);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return M(),!0}function z(){return t.getToken()!==10?(j(3,[],[2,5]),!1):(W(!1),t.getToken()===6?(q(":"),M(),B()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function K(){u(),M();let V=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(V||j(4,[],[]),q(","),M(),t.getToken()===2&&_)break}else V&&j(6,[],[]);z()||j(4,[],[2,5]),V=!0}return b(),t.getToken()!==2?j(7,[2],[]):M(),!0}function F(){A(),M();let V=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(V||j(4,[],[]),q(","),M(),t.getToken()===4&&_)break}else V&&j(6,[],[]);B()||j(4,[],[4,5]),V=!0}return U(),t.getToken()!==4?j(8,[4],[]):M(),!0}function B(){switch(t.getToken()){case 3:return F();case 1:return K();case 10:return W(!0);default:return x()}}return M(),t.getToken()===17?r.allowEmptyContent?!0:(j(4,[],[]),!1):B()?(t.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=f;function c(i,s){let r=D(i),t=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&t.push(i.substring(o,u)),s!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return t.join("")}e.stripComments=c;function l(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,32]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(w,I,n){let E,d,p,h,y;if(I){for(h=I.offset,y=h+I.length,p=h;p>0&&!C(w,p-1);)p--;let o=y;for(;o<w.length&&!C(w,o);)o++;d=w.substring(p,o),E=R(d,n)}else d=w,E=0,p=0,h=0,y=w.length;const S=D(n,w);let m=!1,v=0,f;n.insertSpaces?f=P(" ",n.tabSize||4):f="	";const c=(0,k.createScanner)(d,!1);let l=!1;function i(){return S+P(f,E+v)}function s(){let o=c.scan();for(m=!1;o===15||o===14;)m=m||o===14,o=c.scan();return l=o===16||c.getTokenError()!==0,o}const r=[];function t(o,u,g){!l&&u<y&&g>h&&w.substring(u,g)!==o&&r.push({offset:u,length:g-u,content:o})}let a=s();if(a!==17){const o=c.getTokenOffset()+p,u=P(f,E);t(u,p,o)}for(;a!==17;){let o=c.getTokenOffset()+c.getTokenLength()+p,u=s(),g="";for(;!m&&(u===12||u===13);){const A=c.getTokenOffset()+p;t(" ",o,A),o=c.getTokenOffset()+c.getTokenLength()+p,g=u===12?i():"",u=s()}if(u===2)a!==1&&(v--,g=i());else if(u===4)a!==3&&(v--,g=i());else{switch(a){case 3:case 1:v++,g=i();break;case 5:case 12:g=i();break;case 13:m?g=i():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(g=i())}const b=c.getTokenOffset()+p;t(g,o,b),a=u}return r}e.format=T;function P(w,I){let n="";for(let E=0;E<I;E++)n+=w;return n}function R(w,I){let n=0,E=0;const d=I.tabSize||4;for(;n<w.length;){const p=w.charAt(n);if(p===" ")E++;else if(p==="	")E+=d;else break;n++}return Math.floor(E/d)}function D(w,I){for(let n=0;n<I.length;n++){const E=I.charAt(n);if(E==="\r")return n+1<I.length&&I.charAt(n+1)===`
`?`\r
`:"\r";if(E===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=D;function C(w,I){return`\r
`.indexOf(w.charAt(I))!==-1}e.isEOL=C}),define(te[40],ne([0,1,32,48]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(I,n,E){return R(I,n,void 0,E)}e.removeProperty=P;function R(I,n,E,d,p){const h=n.slice(),y=[],S=(0,k.parseTree)(I,y);let m,v;for(;h.length>0&&(v=h.pop(),m=(0,k.findNodeAtLocation)(S,h),m===void 0&&E!==void 0);)typeof v=="string"?E={[v]:E}:E=[E];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const f=(0,k.findNodeAtLocation)(m,[v]);if(f!==void 0)if(E===void 0){if(!f.parent)throw new Error("Malformed AST");const c=m.children.indexOf(f.parent);let l,i=f.parent.offset+f.parent.length;if(c>0){const s=m.children[c-1];l=s.offset+s.length}else l=m.offset+1,m.children.length>1&&(i=m.children[1].offset);return D(I,{offset:l,length:i-l,content:""},d)}else return D(I,{offset:f.offset,length:f.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(E)}`,l=p?p(m.children.map(s=>s.children[0].value)):m.children.length;let i;if(l>0){const s=m.children[l-1];i={offset:s.offset+s.length,length:0,content:","+c}}else m.children.length===0?i={offset:m.offset+1,length:0,content:c}:i={offset:m.offset+1,length:0,content:c+","};return D(I,i,d)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(E!==void 0){const f=`${JSON.stringify(E)}`;let c;if(m.children.length===0||v===0)c={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const l=v===-1||v>m.children.length?m.children.length:v,i=m.children[l-1];c={offset:i.offset+i.length,length:0,content:","+f}}return D(I,c,d)}else{const f=v,c=m.children[f];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const i=m.children[f-1],s=i.offset+i.length,r=m.offset+m.length;l={offset:s,length:r-2-s,content:""}}else l={offset:c.offset,length:m.children[f+1].offset-c.offset,content:""};return D(I,l,d)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return D(I,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(E)},d)}}e.setProperty=R;function D(I,n,E){let d=C(I,n),p=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;p>0&&!(0,T.isEOL)(d,p-1);)p--;for(;h<d.length&&!(0,T.isEOL)(d,h);)h++}const y=(0,T.format)(d,{offset:p,length:h-p},E);for(let m=y.length-1;m>=0;m--){const v=y[m];d=C(d,v),p=Math.min(p,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const S=I.length-(d.length-h)-p;return[{offset:p,length:S,content:d.substring(p,h)}]}e.withFormatting=D;function C(I,n){return I.substring(0,n.offset)+n.content+I.substring(n.offset+n.length)}e.applyEdit=C;function w(I,n){let E=n.slice(0).sort((p,h)=>{const y=p.offset-h.offset;return y===0?p.length-h.length:y}),d=I.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=d)I=C(I,h);else throw new Error("Overlapping edit");d=h.offset}return I}e.applyEdits=w}),define(te[2],ne([0,1,69,56]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const P=!1;let R=null;function D(t){R=t}if(e.setDisposableTracker=D,P){const t="__is_disposable_tracked__";D(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[t]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==v.None)try{a[t]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[t]=!0}catch{}}markAsSingleton(a){}})}function C(t){return R?.trackDisposable(t),t}function w(t){R?.markAsDisposed(t)}function I(t,a){R?.setParent(t,a)}function n(t,a){if(!!R)for(const o of t)R.setParent(o,a)}function E(t){return R?.markAsSingleton(t),t}e.markAsSingleton=E;class d extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=d;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(T.Iterable.is(t)){let a=[];for(const o of t)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new d(a);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function y(...t){const a=S(()=>h(t));return n(t,a),a}e.combinedDisposable=y;function S(t){const a=C({dispose:(0,k.once)(()=>{w(a),t()})});return a}e.toDisposable=S;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(w(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return I(a,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,C(this),I(this._store,this)}dispose(){w(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class f{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&I(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,w(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&I(a,null),a}}e.MutableDisposable=f;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:g}=u,b=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:g,dispose:b}}}e.ReferenceCollection=l;class i{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=i;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(t){const a=new m;try{t(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[102],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(R){this.element=R,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class T{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let R=this._first;for(;R!==k.Undefined;){const D=R.next;R.prev=k.Undefined,R.next=k.Undefined,R=D}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,D){const C=new k(R);if(this._first===k.Undefined)this._first=C,this._last=C;else if(D){const I=this._last;this._last=C,C.prev=I,I.next=C}else{const I=this._first;this._first=C,C.next=I,I.prev=C}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(C))}}shift(){if(this._first!==k.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==k.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==k.Undefined&&R.next!==k.Undefined){const D=R.prev;D.next=R.next,R.next.prev=D}else R.prev===k.Undefined&&R.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):R.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):R.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==k.Undefined;)yield R.element,R=R.next}}e.LinkedList=T}),function(){function X(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function D(w){R.push(w,Date.now())}function C(){const w=[];for(let I=0;I<R.length;I+=2)w.push({name:R[I],startTime:R[I+1]});return w}return{mark:D,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))R.push({name:D.name,startTime:Math.round(P+D.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function k(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=k(T))}(),define(te[4],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let T=!1,P=!1,R=!1,D=!1,C=!1,w=!1,I=!1,n,E=k,d,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const y=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=y&&h?.sandboxed,typeof navigator=="object"&&!y)p=navigator.userAgent,T=p.indexOf("Windows")>=0,P=p.indexOf("Macintosh")>=0,I=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=p.indexOf("Linux")>=0,w=!0,n=navigator.language,E=n;else if(typeof h=="object"){T=h.platform==="win32",P=h.platform==="darwin",R=h.platform==="linux",D=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=k,E=k;const r=h.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),a=t.availableLanguages["*"];n=t.locale,E=a||k,d=t._translationsConfigFile}catch(t){}C=!0}else console.error("Unable to resolve platform.");var S;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function m(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let v=0;P?v=1:T?v=3:R&&(v=2),e.isWindows=T,e.isMacintosh=P,e.isLinux=R,e.isLinuxSnap=D,e.isNative=C,e.isWeb=w,e.isIOS=I,e.platform=v,e.userAgent=p,e.language=E;var f;(function(r){function t(){return e.language}r.value=t;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(f=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let g=0,b=a.length;g<b;g++){const A=a[g];if(A.id===u.data.vscodeSetImmediateId){a.splice(g,1),A.callback();return}}});let o=0;return u=>{const g=++o;a.push({id:g,callback:u}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return a=>t.then(a)}();var c;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=P||I?2:T?1:3;let l=!0,i=!1;function s(){if(!i){i=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,l=new Uint16Array(r.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const P=k.globals.vscode.process;T={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()},nextTick(R){return(0,k.setImmediate)(R)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:T={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},nextTick(P){return(0,k.setImmediate)(P)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(te[9],ne([0,1,31]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,P=97,R=90,D=122,C=46,w=47,I=92,n=58,E=63;class d extends Error{constructor(c,l,i){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const r=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${r} ${s} of type ${l}`;t+=`. Received type ${typeof i}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(f,c){if(typeof f!="string")throw new d(c,"string",f)}function h(f){return f===w||f===I}function y(f){return f===w}function S(f){return f>=T&&f<=R||f>=P&&f<=D}function m(f,c,l,i){let s="",r=0,t=-1,a=0,o=0;for(let u=0;u<=f.length;++u){if(u<f.length)o=f.charCodeAt(u);else{if(i(o))break;o=w}if(i(o)){if(!(t===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const g=s.lastIndexOf(l);g===-1?(s="",r=0):(s=s.slice(0,g),r=s.length-1-s.lastIndexOf(l)),t=u,a=0;continue}else if(s.length!==0){s="",r=0,t=u,a=0;continue}}c&&(s+=s.length>0?`${l}..`:"..",r=2)}else s.length>0?s+=`${l}${f.slice(t+1,u)}`:s=f.slice(t+1,u),r=u-t-1;t=u,a=0}else o===C&&a!==-1?++a:a=-1}return s}function v(f,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const l=c.dir||c.root,i=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${i}`:`${l}${f}${i}`:i}e.win32={resolve(...f){let c="",l="",i=!1;for(let s=f.length-1;s>=-1;s--){let r;if(s>=0){if(r=f[s],p(r,"path"),r.length===0)continue}else c.length===0?r=k.cwd():(r=k.env[`=${c}`]||k.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===I)&&(r=`${c}\\`));const t=r.length;let a=0,o="",u=!1;const g=r.charCodeAt(0);if(t===1)h(g)&&(a=1,u=!0);else if(h(g))if(u=!0,h(r.charCodeAt(1))){let b=2,A=b;for(;b<t&&!h(r.charCodeAt(b));)b++;if(b<t&&b!==A){const U=r.slice(A,b);for(A=b;b<t&&h(r.charCodeAt(b));)b++;if(b<t&&b!==A){for(A=b;b<t&&!h(r.charCodeAt(b));)b++;(b===t||b!==A)&&(o=`\\\\${U}\\${r.slice(A,b)}`,a=b)}}}else a=1;else S(g)&&r.charCodeAt(1)===n&&(o=r.slice(0,2),a=2,t>2&&h(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(i){if(c.length>0)break}else if(l=`${r.slice(a)}\\${l}`,i=u,u&&c.length>0)break}return l=m(l,!i,"\\",h),i?`${c}\\${l}`:`${c}${l}`||"."},normalize(f){p(f,"path");const c=f.length;if(c===0)return".";let l=0,i,s=!1;const r=f.charCodeAt(0);if(c===1)return y(r)?"\\":f;if(h(r))if(s=!0,h(f.charCodeAt(1))){let a=2,o=a;for(;a<c&&!h(f.charCodeAt(a));)a++;if(a<c&&a!==o){const u=f.slice(o,a);for(o=a;a<c&&h(f.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&!h(f.charCodeAt(a));)a++;if(a===c)return`\\\\${u}\\${f.slice(o)}\\`;a!==o&&(i=`\\\\${u}\\${f.slice(o,a)}`,l=a)}}}else l=1;else S(r)&&f.charCodeAt(1)===n&&(i=f.slice(0,2),l=2,c>2&&h(f.charCodeAt(2))&&(s=!0,l=3));let t=l<c?m(f.slice(l),!s,"\\",h):"";return t.length===0&&!s&&(t="."),t.length>0&&h(f.charCodeAt(c-1))&&(t+="\\"),i===void 0?s?`\\${t}`:t:s?`${i}\\${t}`:`${i}${t}`},isAbsolute(f){p(f,"path");const c=f.length;if(c===0)return!1;const l=f.charCodeAt(0);return h(l)||c>2&&S(l)&&f.charCodeAt(1)===n&&h(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let c,l;for(let r=0;r<f.length;++r){const t=f[r];p(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let i=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const r=l.length;r>1&&h(l.charCodeAt(1))&&(++s,r>2&&(h(l.charCodeAt(2))?++s:i=!1))}if(i){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(f,c){if(p(f,"from"),p(c,"to"),f===c)return"";const l=e.win32.resolve(f),i=e.win32.resolve(c);if(l===i||(f=l.toLowerCase(),c=i.toLowerCase(),f===c))return"";let s=0;for(;s<f.length&&f.charCodeAt(s)===I;)s++;let r=f.length;for(;r-1>s&&f.charCodeAt(r-1)===I;)r--;const t=r-s;let a=0;for(;a<c.length&&c.charCodeAt(a)===I;)a++;let o=c.length;for(;o-1>a&&c.charCodeAt(o-1)===I;)o--;const u=o-a,g=t<u?t:u;let b=-1,A=0;for(;A<g;A++){const O=f.charCodeAt(s+A);if(O!==c.charCodeAt(a+A))break;O===I&&(b=A)}if(A!==g){if(b===-1)return i}else{if(u>g){if(c.charCodeAt(a+A)===I)return i.slice(a+A+1);if(A===2)return i.slice(a+A)}t>g&&(f.charCodeAt(s+A)===I?b=A:A===2&&(b=3)),b===-1&&(b=0)}let U="";for(A=s+b+1;A<=r;++A)(A===r||f.charCodeAt(A)===I)&&(U+=U.length===0?"..":"\\..");return a+=b,U.length>0?`${U}${i.slice(a,o)}`:(i.charCodeAt(a)===I&&++a,i.slice(a,o))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const c=e.win32.resolve(f);if(c.length<=2)return f;if(c.charCodeAt(0)===I){if(c.charCodeAt(1)===I){const l=c.charCodeAt(2);if(l!==E&&l!==C)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(S(c.charCodeAt(0))&&c.charCodeAt(1)===n&&c.charCodeAt(2)===I)return`\\\\?\\${c}`;return f},dirname(f){p(f,"path");const c=f.length;if(c===0)return".";let l=-1,i=0;const s=f.charCodeAt(0);if(c===1)return h(s)?f:".";if(h(s)){if(l=i=1,h(f.charCodeAt(1))){let a=2,o=a;for(;a<c&&!h(f.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&h(f.charCodeAt(a));)a++;if(a<c&&a!==o){for(o=a;a<c&&!h(f.charCodeAt(a));)a++;if(a===c)return f;a!==o&&(l=i=a+1)}}}}else S(s)&&f.charCodeAt(1)===n&&(l=c>2&&h(f.charCodeAt(2))?3:2,i=l);let r=-1,t=!0;for(let a=c-1;a>=i;--a)if(h(f.charCodeAt(a))){if(!t){r=a;break}}else t=!1;if(r===-1){if(l===-1)return".";r=l}return f.slice(0,r)},basename(f,c){c!==void 0&&p(c,"ext"),p(f,"path");let l=0,i=-1,s=!0,r;if(f.length>=2&&S(f.charCodeAt(0))&&f.charCodeAt(1)===n&&(l=2),c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,a=-1;for(r=f.length-1;r>=l;--r){const o=f.charCodeAt(r);if(h(o)){if(!s){l=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(i=r):(t=-1,i=a))}return l===i?i=a:i===-1&&(i=f.length),f.slice(l,i)}for(r=f.length-1;r>=l;--r)if(h(f.charCodeAt(r))){if(!s){l=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":f.slice(l,i)},extname(f){p(f,"path");let c=0,l=-1,i=0,s=-1,r=!0,t=0;f.length>=2&&f.charCodeAt(1)===n&&S(f.charCodeAt(0))&&(c=i=2);for(let a=f.length-1;a>=c;--a){const o=f.charCodeAt(a);if(h(o)){if(!r){i=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===C?l===-1?l=a:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||s===-1||t===0||t===1&&l===s-1&&l===i+1?"":f.slice(l,s)},format:v.bind(null,"\\"),parse(f){p(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.length;let i=0,s=f.charCodeAt(0);if(l===1)return h(s)?(c.root=c.dir=f,c):(c.base=c.name=f,c);if(h(s)){if(i=1,h(f.charCodeAt(1))){let b=2,A=b;for(;b<l&&!h(f.charCodeAt(b));)b++;if(b<l&&b!==A){for(A=b;b<l&&h(f.charCodeAt(b));)b++;if(b<l&&b!==A){for(A=b;b<l&&!h(f.charCodeAt(b));)b++;b===l?i=b:b!==A&&(i=b+1)}}}}else if(S(s)&&f.charCodeAt(1)===n){if(l<=2)return c.root=c.dir=f,c;if(i=2,h(f.charCodeAt(2))){if(l===3)return c.root=c.dir=f,c;i=3}}i>0&&(c.root=f.slice(0,i));let r=-1,t=i,a=-1,o=!0,u=f.length-1,g=0;for(;u>=i;--u){if(s=f.charCodeAt(u),h(s)){if(!o){t=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===C?r===-1?r=u:g!==1&&(g=1):r!==-1&&(g=-1)}return a!==-1&&(r===-1||g===0||g===1&&r===a-1&&r===t+1?c.base=c.name=f.slice(t,a):(c.name=f.slice(t,r),c.base=f.slice(t,a),c.ext=f.slice(r,a))),t>0&&t!==i?c.dir=f.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let c="",l=!1;for(let i=f.length-1;i>=-1&&!l;i--){const s=i>=0?f[i]:k.cwd();p(s,"path"),s.length!==0&&(c=`${s}/${c}`,l=s.charCodeAt(0)===w)}return c=m(c,!l,"/",y),l?`/${c}`:c.length>0?c:"."},normalize(f){if(p(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===w,l=f.charCodeAt(f.length-1)===w;return f=m(f,!c,"/",y),f.length===0?c?"/":l?"./":".":(l&&(f+="/"),c?`/${f}`:f)},isAbsolute(f){return p(f,"path"),f.length>0&&f.charCodeAt(0)===w},join(...f){if(f.length===0)return".";let c;for(let l=0;l<f.length;++l){const i=f[l];p(i,"path"),i.length>0&&(c===void 0?c=i:c+=`/${i}`)}return c===void 0?".":e.posix.normalize(c)},relative(f,c){if(p(f,"from"),p(c,"to"),f===c||(f=e.posix.resolve(f),c=e.posix.resolve(c),f===c))return"";const l=1,i=f.length,s=i-l,r=1,t=c.length-r,a=s<t?s:t;let o=-1,u=0;for(;u<a;u++){const b=f.charCodeAt(l+u);if(b!==c.charCodeAt(r+u))break;b===w&&(o=u)}if(u===a)if(t>a){if(c.charCodeAt(r+u)===w)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else s>a&&(f.charCodeAt(l+u)===w?o=u:u===0&&(o=0));let g="";for(u=l+o+1;u<=i;++u)(u===i||f.charCodeAt(u)===w)&&(g+=g.length===0?"..":"/..");return`${g}${c.slice(r+o)}`},toNamespacedPath(f){return f},dirname(f){if(p(f,"path"),f.length===0)return".";const c=f.charCodeAt(0)===w;let l=-1,i=!0;for(let s=f.length-1;s>=1;--s)if(f.charCodeAt(s)===w){if(!i){l=s;break}}else i=!1;return l===-1?c?"/":".":c&&l===1?"//":f.slice(0,l)},basename(f,c){c!==void 0&&p(c,"ext"),p(f,"path");let l=0,i=-1,s=!0,r;if(c!==void 0&&c.length>0&&c.length<=f.length){if(c===f)return"";let t=c.length-1,a=-1;for(r=f.length-1;r>=0;--r){const o=f.charCodeAt(r);if(o===w){if(!s){l=r+1;break}}else a===-1&&(s=!1,a=r+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(i=r):(t=-1,i=a))}return l===i?i=a:i===-1&&(i=f.length),f.slice(l,i)}for(r=f.length-1;r>=0;--r)if(f.charCodeAt(r)===w){if(!s){l=r+1;break}}else i===-1&&(s=!1,i=r+1);return i===-1?"":f.slice(l,i)},extname(f){p(f,"path");let c=-1,l=0,i=-1,s=!0,r=0;for(let t=f.length-1;t>=0;--t){const a=f.charCodeAt(t);if(a===w){if(!s){l=t+1;break}continue}i===-1&&(s=!1,i=t+1),a===C?c===-1?c=t:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||i===-1||r===0||r===1&&c===i-1&&c===l+1?"":f.slice(c,i)},format:v.bind(null,"/"),parse(f){p(f,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return c;const l=f.charCodeAt(0)===w;let i;l?(c.root="/",i=1):i=0;let s=-1,r=0,t=-1,a=!0,o=f.length-1,u=0;for(;o>=i;--o){const g=f.charCodeAt(o);if(g===w){if(!a){r=o+1;break}continue}t===-1&&(a=!1,t=o+1),g===C?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(t!==-1){const g=r===0&&l?1:r;s===-1||u===0||u===1&&s===t-1&&s===r+1?c.base=c.name=f.slice(g,t):(c.name=f.slice(g,s),c.base=f.slice(g,t),c.ext=f.slice(s,t))}return r>0?c.dir=f.slice(0,r-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[103],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var T;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function P(R,...D){const C=D.reduce((n,E)=>(n[E]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(n=>!C[n]).forEach(n=>{for(let E=0;E<w.length;E++)if(n.search(w[E])!==-1){delete R[n];break}})}e.sanitizeProcessEnvironment=P}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var T in k)(typeof exports=="object"?exports:X)[T]=k[T]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function k(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return X[T].call(P.exports,P,P.exports,k),P.l=!0,P.exports}return k.m=X,k.c=e,k.d=function(T,P,R){k.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:R})},k.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},k.t=function(T,P){if(1&P&&(T=k(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(k.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var D in T)k.d(R,D,function(C){return T[C]}.bind(null,D));return R},k.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return k.d(P,"a",P),P},k.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},k.p="",k(k.s=0)}([function(X,e,k){(function(T){var P;e=X.exports=Z,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],w=e.src=[],I=0,n=I++;w[n]="0|[1-9]\\d*";var E=I++;w[E]="[0-9]+";var d=I++;w[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=I++;w[p]="("+w[n]+")\\.("+w[n]+")\\.("+w[n]+")";var h=I++;w[h]="("+w[E]+")\\.("+w[E]+")\\.("+w[E]+")";var y=I++;w[y]="(?:"+w[n]+"|"+w[d]+")";var S=I++;w[S]="(?:"+w[E]+"|"+w[d]+")";var m=I++;w[m]="(?:-("+w[y]+"(?:\\."+w[y]+")*))";var v=I++;w[v]="(?:-?("+w[S]+"(?:\\."+w[S]+")*))";var f=I++;w[f]="[0-9A-Za-z-]+";var c=I++;w[c]="(?:\\+("+w[f]+"(?:\\."+w[f]+")*))";var l=I++,i="v?"+w[p]+w[m]+"?"+w[c]+"?";w[l]="^"+i+"$";var s="[v=\\s]*"+w[h]+w[v]+"?"+w[c]+"?",r=I++;w[r]="^"+s+"$";var t=I++;w[t]="((?:<|>)?=?)";var a=I++;w[a]=w[E]+"|x|X|\\*";var o=I++;w[o]=w[n]+"|x|X|\\*";var u=I++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[m]+")?"+w[c]+"?)?)?";var g=I++;w[g]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[v]+")?"+w[c]+"?)?)?";var b=I++;w[b]="^"+w[t]+"\\s*"+w[u]+"$";var A=I++;w[A]="^"+w[t]+"\\s*"+w[g]+"$";var U=I++;w[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;w[O]="(?:~>?)";var q=I++;w[q]="(\\s*)"+w[O]+"\\s+",C[q]=new RegExp(w[q],"g");var N=I++;w[N]="^"+w[O]+w[u]+"$";var L=I++;w[L]="^"+w[O]+w[g]+"$";var $=I++;w[$]="(?:\\^)";var _=I++;w[_]="(\\s*)"+w[$]+"\\s+",C[_]=new RegExp(w[_],"g");var M=I++;w[M]="^"+w[$]+w[u]+"$";var j=I++;w[j]="^"+w[$]+w[g]+"$";var W=I++;w[W]="^"+w[t]+"\\s*("+s+")$|^$";var x=I++;w[x]="^"+w[t]+"\\s*("+i+")$|^$";var z=I++;w[z]="(\\s*)"+w[t]+"\\s*("+s+"|"+w[u]+")",C[z]=new RegExp(w[z],"g");var K=I++;w[K]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var F=I++;w[F]="^\\s*("+w[g]+")\\s+-\\s+("+w[g]+")\\s*$";var B=I++;w[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)P(V,w[V]),C[V]||(C[V]=new RegExp(w[V]));function Q(ee,ae){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>R||!(ae?C[r]:C[l]).test(ee))return null;try{return new Z(ee,ae)}catch(oe){return null}}function Z(ee,ae){if(ee instanceof Z){if(ee.loose===ae)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Z))return new Z(ee,ae);P("SemVer",ee,ae),this.loose=ae;var oe=ee.trim().match(ae?C[r]:C[l]);if(!oe)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<D)return ye}return pe}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,ae){var oe=Q(ee,ae);return oe?oe.version:null},e.clean=function(ee,ae){var oe=Q(ee.trim().replace(/^[=v]+/,""),ae);return oe?oe.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return P("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ae=0;do{var oe=this.prerelease[ae],pe=ee.prerelease[ae];if(P("prerelease compare",ae,oe,pe),oe===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(oe===void 0)return-1;if(oe!==pe)return H(oe,pe)}while(++ae)},Z.prototype.inc=function(ee,ae){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ae,oe,pe){typeof oe=="string"&&(pe=oe,oe=void 0);try{return new Z(ee,oe).inc(ae,pe).version}catch(ye){return null}},e.diff=function(ee,ae){if(le(ee,ae))return null;var oe=Q(ee),pe=Q(ae);if(oe.prerelease.length||pe.prerelease.length){for(var ye in oe)if((ye==="major"||ye==="minor"||ye==="patch")&&oe[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in oe)if((ye==="major"||ye==="minor"||ye==="patch")&&oe[ye]!==pe[ye])return ye},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,ae){var oe=G.test(ee),pe=G.test(ae);return oe&&pe&&(ee=+ee,ae=+ae),oe&&!pe?-1:pe&&!oe?1:ee<ae?-1:ee>ae?1:0}function re(ee,ae,oe){return new Z(ee,oe).compare(new Z(ae,oe))}function ie(ee,ae,oe){return re(ee,ae,oe)>0}function ce(ee,ae,oe){return re(ee,ae,oe)<0}function le(ee,ae,oe){return re(ee,ae,oe)===0}function de(ee,ae,oe){return re(ee,ae,oe)!==0}function fe(ee,ae,oe){return re(ee,ae,oe)>=0}function be(ee,ae,oe){return re(ee,ae,oe)<=0}function Ce(ee,ae,oe,pe){var ye;switch(ae){case"===":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),ye=ee===oe;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof oe=="object"&&(oe=oe.version),ye=ee!==oe;break;case"":case"=":case"==":ye=le(ee,oe,pe);break;case"!=":ye=de(ee,oe,pe);break;case">":ye=ie(ee,oe,pe);break;case">=":ye=fe(ee,oe,pe);break;case"<":ye=ce(ee,oe,pe);break;case"<=":ye=be(ee,oe,pe);break;default:throw new TypeError("Invalid operator: "+ae)}return ye}function Ee(ee,ae){if(ee instanceof Ee){if(ee.loose===ae)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,ae);P("comparator",ee,ae),this.loose=ae,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(ee,ae){return H(ae,ee)},e.major=function(ee,ae){return new Z(ee,ae).major},e.minor=function(ee,ae){return new Z(ee,ae).minor},e.patch=function(ee,ae){return new Z(ee,ae).patch},e.compare=re,e.compareLoose=function(ee,ae){return re(ee,ae,!0)},e.rcompare=function(ee,ae,oe){return re(ae,ee,oe)},e.sort=function(ee,ae){return ee.sort(function(oe,pe){return e.compare(oe,pe,ae)})},e.rsort=function(ee,ae){return ee.sort(function(oe,pe){return e.rcompare(oe,pe,ae)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=de,e.gte=fe,e.lte=be,e.cmp=Ce,e.Comparator=Ee;var Ae={};function Pe(ee,ae){if(ee instanceof Pe)return ee.loose===ae?ee:new Pe(ee.raw,ae);if(ee instanceof Ee)return new Pe(ee.value,ae);if(!(this instanceof Pe))return new Pe(ee,ae);if(this.loose=ae,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,ae,oe,pe,ye,_e,Re,Y,se,ue,ge,me,Ie){return((ae=Le(oe)?"":Le(pe)?">="+oe+".0.0":Le(ye)?">="+oe+"."+pe+".0":">="+ae)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Ne(ee,ae){for(var oe=0;oe<ee.length;oe++)if(!ee[oe].test(ae))return!1;if(ae.prerelease.length){for(oe=0;oe<ee.length;oe++)if(P(ee[oe].semver),ee[oe].semver!==Ae&&ee[oe].semver.prerelease.length>0){var pe=ee[oe].semver;if(pe.major===ae.major&&pe.minor===ae.minor&&pe.patch===ae.patch)return!0}return!1}return!0}function $e(ee,ae,oe){try{ae=new Pe(ae,oe)}catch(pe){return!1}return ae.test(ee)}function xe(ee,ae,oe,pe){var ye,_e,Re,Y,se;switch(ee=new Z(ee,pe),ae=new Pe(ae,pe),oe){case">":ye=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":ye=ce,_e=fe,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,ae,pe))return!1;for(var ue=0;ue<ae.set.length;++ue){var ge=ae.set[ue],me=null,Ie=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ie=Ie||ke,ye(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ie.semver,pe)&&(Ie=ke)}),me.operator===Y||me.operator===se||(!Ie.operator||Ie.operator===Y)&&_e(ee,Ie.semver)||Ie.operator===se&&Re(ee,Ie.semver))return!1}return!0}Ee.prototype.parse=function(ee){var ae=this.loose?C[W]:C[x],oe=ee.match(ae);if(!oe)throw new TypeError("Invalid comparator: "+ee);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new Z(oe[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return P("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,ae){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(ee.value,ae),$e(this.value,oe,ae);if(ee.operator==="")return oe=new Pe(this.value,ae),$e(ee.semver,oe,ae);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,ae)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||ye||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var ae=this.loose;ee=ee.trim(),P("range",ee,ae);var oe=ae?C[F]:C[K];ee=ee.replace(oe,Fe),P("hyphen replace",ee),ee=ee.replace(C[z],"$1$2$3"),P("comparator trim",ee,C[z]),ee=(ee=(ee=ee.replace(C[q],"$1~")).replace(C[_],"$1^")).split(/\s+/).join(" ");var pe=ae?C[W]:C[x],ye=ee.split(" ").map(function(_e){return function(Re,Y){return P("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){P("caret",me,Ie);var ke=Ie?C[j]:C[M];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return P("caret",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Oe?(P("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+Oe+" <"+(+Se+1)+".0.0"):(P("no pr"),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+" <"+(+Se+1)+".0.0"),P("caret return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),P("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ie){var ke=Ie?C[L]:C[N];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return P("tilde",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Oe?(P("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0"):Me=">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0",P("tilde return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),P("tildes",Re),Re=function(se,ue){return P("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ie){me=me.trim();var ke=Ie?C[A]:C[b];return me.replace(ke,function(Te,Se,we,De,Oe,Me){P("xRange",me,Te,Se,we,De,Oe,Me);var Qe=Le(we),Ye=Qe||Le(De),je=Ye||Le(Oe);return Se==="="&&je&&(Se=""),Qe?Te=Se===">"||Se==="<"?"<0.0.0":"*":Se&&je?(Ye&&(De=0),je&&(Oe=0),Se===">"?(Se=">=",Ye?(we=+we+1,De=0,Oe=0):je&&(De=+De+1,Oe=0)):Se==="<="&&(Se="<",Ye?we=+we+1:De=+De+1),Te=Se+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),P("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),P("xrange",Re),Re=function(se,ue){return P("replaceStars",se,ue),se.trim().replace(C[B],"")}(Re,Y),P("stars",Re),Re}(_e,ae)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(_e){return!!_e.match(pe)})),ye=ye.map(function(_e){return new Ee(_e,ae)})},Pe.prototype.intersects=function(ee,ae){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(pe){return ee.set.some(function(ye){return ye.every(function(_e){return pe.intersects(_e,ae)})})})})},e.toComparators=function(ee,ae){return new Pe(ee,ae).set.map(function(oe){return oe.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,ae,oe){var pe=null,ye=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&ye.compare(Re)!==-1||(ye=new Z(pe=Re,oe)))}),pe},e.minSatisfying=function(ee,ae,oe){var pe=null,ye=null;try{var _e=new Pe(ae,oe)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&ye.compare(Re)!==1||(ye=new Z(pe=Re,oe)))}),pe},e.validRange=function(ee,ae){try{return new Pe(ee,ae).range||"*"}catch(oe){return null}},e.ltr=function(ee,ae,oe){return xe(ee,ae,"<",oe)},e.gtr=function(ee,ae,oe){return xe(ee,ae,">",oe)},e.outside=xe,e.prerelease=function(ee,ae){var oe=Q(ee,ae);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(ee,ae,oe){return ee=new Pe(ee,oe),ae=new Pe(ae,oe),ee.intersects(ae)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var ae=ee.match(C[U]);return ae==null?null:Q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,k(1))},function(X,e){var k,T,P=X.exports={};function R(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function C(S){if(k===setTimeout)return setTimeout(S,0);if((k===R||!k)&&setTimeout)return k=setTimeout,setTimeout(S,0);try{return k(S,0)}catch(m){try{return k.call(null,S,0)}catch(v){return k.call(this,S,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:R}catch(S){k=R}try{T=typeof clearTimeout=="function"?clearTimeout:D}catch(S){T=D}})();var w,I=[],n=!1,E=-1;function d(){n&&w&&(n=!1,w.length?I=w.concat(I):E=-1,I.length&&p())}function p(){if(!n){var S=C(d);n=!0;for(var m=I.length;m;){for(w=I,I=[];++E<m;)w&&w[E].run();E=-1,m=I.length}w=null,n=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===D||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch(f){try{return T.call(null,v)}catch(c){return T.call(this,v)}}}(S)}}function h(S,m){this.fun=S,this.array=m}function y(){}P.nextTick=function(S){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];I.push(new h(S,m)),I.length!==1||n||C(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=y,P.addListener=y,P.once=y,P.off=y,P.removeListener=y,P.removeAllListeners=y,P.emit=y,P.prependListener=y,P.prependOnceListener=y,P.listeners=function(S){return[]},P.binding=function(S){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(S){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(te[104],ne([0,1]),function(X,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(C,w,I){this.level=C,this.key=w,this.value=I,this.forward=[]}}const P=void 0;class R{constructor(C,w=2**16){this.comparator=C,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(w)|0),this._header=new T(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new T(this._maxLevel,P,P)}has(C){return Boolean(R._search(this,C,this.comparator))}get(C){return R._search(this,C,this.comparator)?.value}set(C,w){return R._insert(this,C,w,this.comparator)&&(this._size+=1),this}delete(C){const w=R._delete(this,C,this.comparator);return w&&(this._size-=1),w}forEach(C,w){let I=this._header.forward[0];for(;I;)C.call(w,I.value,I.key,this),I=I.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",w=this._header.forward[0];for(;w;)C+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return C}static _search(C,w,I){let n=C._header;for(let E=C._level-1;E>=0;E--)for(;n.forward[E]&&I(n.forward[E].key,w)<0;)n=n.forward[E];if(n=n.forward[0],n&&I(n.key,w)===0)return n}static _insert(C,w,I,n){let E=[],d=C._header;for(let p=C._level-1;p>=0;p--){for(;d.forward[p]&&n(d.forward[p].key,w)<0;)d=d.forward[p];E[p]=d}if(d=d.forward[0],d&&n(d.key,w)===0)return d.value=I,!1;{let p=R._randomLevel(C);if(p>C._level){for(let h=C._level;h<p;h++)E[h]=C._header;C._level=p}d=new T(p,w,I);for(let h=0;h<p;h++)d.forward[h]=E[h].forward[h],E[h].forward[h]=d;return!0}}static _randomLevel(C,w=.5){let I=1;for(;Math.random()<w&&I<C._maxLevel;)I+=1;return I}static _delete(C,w,I){let n=[],E=C._header;for(let d=C._level-1;d>=0;d--){for(;E.forward[d]&&I(E.forward[d].key,w)<0;)E=E.forward[d];n[d]=E}if(E=E.forward[0],!E||I(E.key,w)!==0)return!1;for(let d=0;d<C._level&&n[d].forward[d]===E;d++)n[d].forward[d]=E.forward[d];for(;C._level>0&&C._header.forward[C._level-1]===P;)C._level-=1;return!0}}e.SkipList=R}),define(te[105],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=k.globals.performance&&typeof k.globals.performance.now=="function";class P{constructor(D){this._highResolution=T&&D,this._startTime=this._now(),this._stopTime=-1}static create(D=!0){return new P(D)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=P}),define(te[3],ne([0,1,7,69,2,102,105]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(c){c.None=()=>P.Disposable.None;function l(_){return(M,j=null,W)=>{let x=!1,z;return z=_(K=>{if(!x)return z?z.dispose():x=!0,M.call(j,K)},null,W),x&&z.dispose(),z}}c.once=l;function i(_,M){return u((j,W=null,x)=>_(z=>j.call(W,M(z)),null,x))}c.map=i;function s(_,M){return u((j,W=null,x)=>_(z=>{M(z),j.call(W,z)},null,x))}c.forEach=s;function r(_,M){return u((j,W=null,x)=>_(z=>M(z)&&j.call(W,z),null,x))}c.filter=r;function t(_){return _}c.signal=t;function a(..._){return(M,j=null,W)=>(0,P.combinedDisposable)(..._.map(x=>x(z=>M.call(j,z),null,W)))}c.any=a;function o(_,M,j){let W=j;return i(_,x=>(W=M(W,x),W))}c.reduce=o;function u(_){let M;const j=new d({onFirstListenerAdd(){M=_(j.fire,j)},onLastListenerRemove(){M.dispose()}});return j.event}function g(_,M,j=100,W=!1,x){let z,K,F,B=0;const V=new d({leakWarningThreshold:x,onFirstListenerAdd(){z=_(Q=>{B++,K=M(K,Q),W&&!F&&(V.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const Z=K;K=void 0,F=void 0,(!W||B>1)&&V.fire(Z),B=0},j)})},onLastListenerRemove(){z.dispose()}});return V.event}c.debounce=g;function b(_,M=(j,W)=>j===W){let j=!0,W;return r(_,x=>{const z=j||!M(x,W);return j=!1,W=x,z})}c.latch=b;function A(_,M){return[c.filter(_,M),c.filter(_,j=>!M(j))]}c.split=A;function U(_,M=!1,j=[]){let W=j.slice(),x=_(F=>{W?W.push(F):K.fire(F)});const z=()=>{W&&W.forEach(F=>K.fire(F)),W=null},K=new d({onFirstListenerAdd(){x||(x=_(F=>K.fire(F)))},onFirstListenerDidAdd(){W&&(M?setTimeout(z):z())},onLastListenerRemove(){x&&x.dispose(),x=null}});return K.event}c.buffer=U;class O{constructor(M){this.event=M}map(M){return new O(i(this.event,M))}forEach(M){return new O(s(this.event,M))}filter(M){return new O(r(this.event,M))}reduce(M,j){return new O(o(this.event,M,j))}latch(){return new O(b(this.event))}debounce(M,j=100,W=!1,x){return new O(g(this.event,M,j,W,x))}on(M,j,W){return this.event(M,j,W)}once(M,j,W){return l(this.event)(M,j,W)}}function q(_){return new O(_)}c.chain=q;function N(_,M,j=W=>W){const W=(...F)=>K.fire(j(...F)),x=()=>_.on(M,W),z=()=>_.removeListener(M,W),K=new d({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}c.fromNodeEventEmitter=N;function L(_,M,j=W=>W){const W=(...F)=>K.fire(j(...F)),x=()=>_.addEventListener(M,W),z=()=>_.removeEventListener(M,W),K=new d({onFirstListenerAdd:x,onLastListenerRemove:z});return K.event}c.fromDOMEventEmitter=L;function $(_){return new Promise(M=>l(_)(M))}c.toPromise=$})(C=e.Event||(e.Event={}));class w{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${w._idPool++}`}start(l){this._stopWatch=new D.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let I=-1;function n(c){const l=I;return I=c,{dispose(){I=l}}}e.setGlobalLeakWarningThreshold=n;class E{constructor(l,i=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=i,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let i=I;if(typeof this.customThreshold=="number"&&(i=this.customThreshold),i<=0||l<i)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=i*.5;let t,a=0;for(const[o,u]of this._stacks)(!t||a<u)&&(t=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${a}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}class d{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=I>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(l,i,s)=>{this._listeners||(this._listeners=new R.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(i?[l,i]:l);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,i);const a=this._leakageMon?.check(this._listeners.size),o=(0,P.toDisposable)(()=>{a&&a(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof P.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let i of this._listeners)this._deliveryQueue.push([i,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[i,s]=this._deliveryQueue.shift();try{typeof i=="function"?i.call(void 0,s):i[0].call(i[1],s)}catch(r){(0,k.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class p extends d{async fireAsync(l,i,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,l]);for(;this._asyncDeliveryQueue.size>0&&!i.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),a=[],o={...t,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,k.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const g of u)g.status==="rejected"&&(0,k.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=p;class h extends d{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class y extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=y;class S extends d{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(i=>super.fire(i)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const i={event:l,listener:null};this.events.push(i),this.hasListeners&&this.hook(i);const s=()=>{this.hasListeners&&this.unhook(i);const r=this.events.indexOf(i);this.events.splice(r,1)};return(0,P.toDisposable)((0,T.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(i=>this.emitter.fire(i))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class v{constructor(){this.buffers=[]}wrapEvent(l){return(i,s,r)=>l(t=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>i.call(s,t)):i.call(s,t)},void 0,r)}bufferEvents(l){const i=[];this.buffers.push(i);const s=l();return this.buffers.pop(),i.forEach(r=>r()),s}}e.EventBufferer=v;class f{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=P.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=f}),define(te[28],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(C,w){const I=setTimeout(C.bind(w),0);return{dispose(){clearTimeout(I)}}});var P;(function(C){function w(I){return I===C.None||I===C.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}C.isCancellationToken=w,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(P=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class D{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=P.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=D}),define(te[49],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new k.Emitter}add(E){const d=this._icons.get(E.id);d?E.description?d.description=E.description:console.error(`Duplicate registration of codicon ${E.id}`):(this._icons.set(E.id,E),this._onDidRegister.fire(E))}get(E){return this._icons.get(E)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new T;e.iconRegistry=P;function R(n,E){return new C(n,E)}e.registerCodicon=R;function D(n){return n?n.replace(/\$\((.*?)\)/g,(E,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=D;class C{constructor(E,d,p){this.id=E,this.definition=d,this.description=p,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function w(n,E){const d=["codicon","codicon-"+n];return E&&d.push("codicon-modifier-"+E),d}e.getClassNamesArray=w;var I;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+",n.iconNameCharacter="[A-Za-z0-9\\-~]";const E=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(y){if(y instanceof C)return["codicon","codicon-"+y.id];const S=E.exec(y.id);if(!S)return d(C.error);let[,m,v]=S;const f=["codicon","codicon-"+m];return v&&f.push("codicon-modifier-"+v.substr(1)),f}n.asClassNameArray=d;function p(y){return d(y).join(" ")}n.asClassName=p;function h(y){return"."+d(y).join(".")}n.asCSSSelector=h})(I=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"})}(C=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,7,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(f){const c=f;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=P;function R(f){const c=f;return c?P(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=R;function D(f,c){return new C(f,c)}e.newWriteableStream=D;class C{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,k.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let i;switch(c){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(l);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(f,c){const l=[];let i;for(;(i=f.read())!==null;)l.push(i);return c(l)}e.consumeReadable=w;function I(f,c,l){const i=[];let s;for(;(s=f.read())!==null&&i.length<l;)i.push(s);return s===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return f.read()}}}e.peekReadable=I;function n(f,c){return new Promise((l,i)=>{const s=[];E(f,{onData:r=>{c&&s.push(r)},onError:r=>{c?i(r):l(void 0)},onEnd:()=>{l(c?c(s):void 0)}})})}e.consumeStream=n;function E(f,c){f.on("error",l=>c.onError(l)),f.on("end",()=>c.onEnd()),f.on("data",l=>c.onData(l))}e.listenStream=E;function d(f,c){return new Promise((l,i)=>{const s=new T.DisposableStore,r=[],t=u=>{if(r.push(u),r.length>c)return s.dispose(),f.pause(),l({stream:f,buffer:r,ended:!1})},a=u=>i(u),o=()=>l({stream:f,buffer:r,ended:!0});s.add((0,T.toDisposable)(()=>f.removeListener("error",a))),f.on("error",a),s.add((0,T.toDisposable)(()=>f.removeListener("end",o))),f.on("end",o),s.add((0,T.toDisposable)(()=>f.removeListener("data",t))),f.on("data",t)})}e.peekStream=d;function p(f,c){const l=D(c);return l.end(f),l}e.toStream=p;function h(){const f=D(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=h;function y(f){let c=!1;return{read:()=>c?null:(c=!0,f)}}e.toReadable=y;function S(f,c,l){const i=D(l);return E(f,{onData:s=>i.write(c.data(s)),onError:s=>i.error(c.error?c.error(s):s),onEnd:()=>i.end()}),i}e.transform=S;function m(f,c,l){let i=!1;return{read:()=>{const s=c.read();return i?s:(i=!0,s!==null?l([f,s]):f)}}}e.prefixedReadable=m;function v(f,c,l){let i=!1;const s=D(l);return E(c,{onData:r=>i?s.write(r):(i=!0,s.write(l([f,r]))),onError:r=>s.error(r),onEnd:()=>{i||(i=!0,s.write(f)),s.end()}}),s}e.prefixedStream=v}),define(te[19],ne([0,1,50]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let P,R;class D{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return T?new D(Buffer.allocUnsafe(t)):new D(new Uint8Array(t))}static wrap(t){return T&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new D(t)}static fromString(t,a){return!(a?.dontUseNodeBuffer||!1)&&T?new D(Buffer.from(t)):(P||(P=new TextEncoder),new D(P.encode(t)))}static concat(t,a){if(typeof a=="undefined"){a=0;for(let g=0,b=t.length;g<b;g++)a+=t[g].byteLength}const o=D.alloc(a);let u=0;for(let g=0,b=t.length;g<b;g++){const A=t[g];o.set(A,u),u+=A.byteLength}return o}toString(){return T?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,a){return new D(this.buffer.subarray(t,a))}set(t,a){t instanceof D?this.buffer.set(t.buffer,a):this.buffer.set(t,a)}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,a){n(this.buffer,t,a)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,a){d(this.buffer,t,a)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,a){h(this.buffer,t,a)}}e.VSBuffer=D;function C(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=C;function w(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255}e.writeUInt16LE=w;function I(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=I;function n(r,t,a){r[a+3]=t,t=t>>>8,r[a+2]=t,t=t>>>8,r[a+1]=t,t=t>>>8,r[a]=t}e.writeUInt32BE=n;function E(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=E;function d(r,t,a){r[a+0]=t&255,t=t>>>8,r[a+1]=t&255,t=t>>>8,r[a+2]=t&255,t=t>>>8,r[a+3]=t&255}e.writeUInt32LE=d;function p(r,t){return r[t]}e.readUInt8=p;function h(r,t,a){r[a]=t}e.writeUInt8=h;function y(r){return k.consumeReadable(r,t=>D.concat(t))}e.readableToBuffer=y;function S(r){return k.toReadable(r)}e.bufferToReadable=S;function m(r){return k.consumeStream(r,t=>D.concat(t))}e.streamToBuffer=m;async function v(r){return r.ended?D.concat(r.buffer):D.concat([...r.buffer,await m(r.stream)])}e.bufferedStreamToBuffer=v;function f(r){return k.toStream(r,t=>D.concat(t))}e.bufferToStream=f;function c(r){return k.transform(r,{data:t=>typeof t=="string"?D.fromString(t):D.wrap(t)},t=>D.concat(t))}e.streamToBufferReadableStream=c;function l(r){return k.newWriteableStream(t=>D.concat(t),r)}e.newWriteableBufferStream=l;function i(r,t){return k.prefixedReadable(r,t,a=>D.concat(a))}e.prefixedBufferReadable=i;function s(r,t){return k.prefixedStream(r,t,a=>D.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function P(Y,...se){return se.length===0?Y:Y.replace(T,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=P;const R=/{([^}]+)}/g;function D(Y,se){return Y.replace(R,(ue,ge)=>se[ge]??ue)}e.format2=D;function C(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function w(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function I(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=I;function n(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=n;function E(Y,se=" "){const ue=d(Y,se);return p(ue,se)}e.trim=E;function d(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=d;function p(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ie=-1;for(;Ie=Y.lastIndexOf(se,me-1),!(Ie===-1||Ie+ue!==me);){if(Ie===0)return"";me=Ie}return Y.substring(0,me)}e.rtrim=p;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function y(Y){return Y.replace(/\*/g,"")}e.stripWildcards=y;function S(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=w(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=S;function m(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function f(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=f;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function l(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=l;function i(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=i;function s(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function t(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=t;function a(Y,se){return o(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function o(Y,se,ue=0,ge=Y.length,me=0,Ie=se.length){for(;ue<ge&&me<Ie;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return t(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ie);u(Se)&&(Se-=32),u(we)&&(we-=32);const De=Se-we;if(De!==0)return De}const ke=ge-ue,Te=Ie-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=o;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function g(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=g;function b(Y,se){return Y.length===se.length&&o(Y,se)===0}e.equalsIgnoreCase=b;function A(Y,se){const ue=se.length;return se.length>Y.length?!1:o(Y,se,0,ue)===0}e.startsWithIgnoreCase=A;function U(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=U;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ie=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ie-ue))return ue;return ge}e.commonSuffixLength=O;function q(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=q;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function L(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=L;function $(Y,se,ue){const ge=Y.charCodeAt(ue);if(q(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(N(me))return L(ge,me)}return ge}e.getNextCodePoint=$;function _(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(q(ge))return L(ge,ue)}return ue}function M(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ie=$(Y,me,se);se+=Ie>=65536?2:1;let ke=ue.getGraphemeBreakType(Ie);for(;se<me;){const Te=$(Y,me,se),Se=ue.getGraphemeBreakType(Te);if($e(ke,Se))break;se+=Te>=65536?2:1,ke=Se}return se-ge}e.nextCharLength=M;function j(Y,se){const ue=ee.getInstance(),ge=se,me=_(Y,se);se-=me>=65536?2:1;let Ie=ue.getGraphemeBreakType(me);for(;se>0;){const ke=_(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ie))break;se-=ke>=65536?2:1,Ie=Te}return ge-se}e.prevCharLength=j;function W(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ie=$(Y,ge,se),ke=ue.getGraphemeBreakType(Ie);se+=Ie>=65536?2:1;let Te=ke;for(;se<ge;){const we=$(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const Se=se;for(se=me,Te=ke;se>0;){const we=_(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,Se]}function x(Y,se){return se>0&&N(Y.charCodeAt(se))?W(Y,se-1):W(Y,se)}e.getCharContainingOffset=x;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return z.test(Y)}e.containsRTL=K;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return F.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,de=/\x1b\[0?m/g;function fe(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(de,"")),Y}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ce(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ie=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ie+1);if(ke<0)return!1;Ie=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ae;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function Ne(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var xe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=ae()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function ae(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function oe(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=_(se,Y);return Y-=ye(ge),Y}e.getLeftDeleteOffset=oe;function pe(Y,se){let ue=_(se,Y);for(Y-=ye(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=_(se,Y),Y-=ye(ue)}if(!!re(ue)){if(Y>=0){const ge=_(se,Y);ge===8205&&(Y-=ye(ge))}return Y}}function ye(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.noBreakWhitespace="\xA0"}),define(te[106],ne([0,1,25]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(m){return P(m,0)}e.hash=T;function P(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?w(m,v):I(m,v);case"string":return C(m,v);case"boolean":return D(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=P;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function D(m,v){return R(m?433:863,v)}function C(m,v){v=R(149417,v);for(let f=0,c=m.length;f<c;f++)v=R(m.charCodeAt(f),v);return v}e.stringHash=C;function w(m,v){return v=R(104579,v),m.reduce((f,c)=>P(c,f),v)}function I(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((f,c)=>(f=C(c,f),P(m[c],f)),v)}class n{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=P(v,this._value),this._value}}e.Hasher=n;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(m,v,f=32){const c=f-v,l=~((1<<c)-1);return(m<<v|(l&m)>>>c)>>>0}function p(m,v=0,f=m.byteLength,c=0){for(let l=0;l<f;l++)m[v+l]=c}function h(m,v,f="0"){for(;m.length<v;)m=f+m;return m}function y(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),v/4)}e.toHexString=y;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const f=v.length;if(f===0)return;const c=this._buff;let l=this._buffLen,i=this._leftoverHighSurrogate,s,r;for(i!==0?(s=i,r=-1,i=0):(s=v.charCodeAt(0),r=0);;){let t=s;if(k.isHighSurrogate(s))if(r+1<f){const a=v.charCodeAt(r+1);k.isLowSurrogate(a)?(r++,t=k.computeCodePoint(s,a)):t=65533}else{i=s;break}else k.isLowSurrogate(s)&&(t=65533);if(l=this._push(c,l,t),r++,r<f)s=v.charCodeAt(r);else break}this._buffLen=l,this._leftoverHighSurrogate=i}_push(v,f,c){return c<128?v[f++]=c:c<2048?(v[f++]=192|(c&1984)>>>6,v[f++]=128|(c&63)>>>0):c<65536?(v[f++]=224|(c&61440)>>>12,v[f++]=128|(c&4032)>>>6,v[f++]=128|(c&63)>>>0):(v[f++]=240|(c&1835008)>>>18,v[f++]=128|(c&258048)>>>12,v[f++]=128|(c&4032)>>>6,v[f++]=128|(c&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=S._bigBlock32,f=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,d(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,i=this._h2,s=this._h3,r=this._h4,t,a,o;for(let u=0;u<80;u++)u<20?(t=l&i|~l&s,a=1518500249):u<40?(t=l^i^s,a=1859775393):u<60?(t=l&i|l&s|i&s,a=2400959708):(t=l^i^s,a=3395469782),o=d(c,5)+t+r+a+v.getUint32(u*4,!1)&4294967295,r=s,s=i,i=d(l,30),l=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var Ct=this&&this.__classPrivateFieldSet||function(X,e,k,T,P){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!P:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?P.call(X,k):P?P.value=k:e.set(X,k),k},Ve=this&&this.__classPrivateFieldGet||function(X,e,k,T){if(k==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!T:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?T:k==="a"?T.call(X):T?T.value:e.get(X)};define(te[41],ne([0,1,16,25]),function(X,e,k,T){"use strict";var P,R,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(r,t,a){let o=r.get(t);return o===void 0&&(o=a,r.set(t,o)),o}e.getOrSet=C;function w(r){const t=[];return r.forEach((a,o)=>{t.push(`${o} => ${a}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=w;function I(r){const t=[];return r.forEach(a=>{t.push(a)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=I;class n{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const a=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=n;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class d{constructor(t=!0,a=!0){this._splitOnBackslash=t,this._caseSensitive=a}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,T.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(S||(S={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new d)}static forStrings(){return new m(new n)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,a){if(a){const o=a.slice(0);(0,k.shuffle)(o);for(let u of o)this.set(u,t)}else{const o=t.slice(0);(0,k.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(t,a){const o=this._iter.reset(t);let u;this._root||(this._root=new y,this._root.segment=o.value());const g=[];for(u=this._root;;){const A=o.cmp(u.segment);if(A>0)u.left||(u.left=new y,u.left.segment=o.value()),g.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new y,u.right.segment=o.value()),g.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new y,u.mid.segment=o.value()),g.push([0,u]),u=u.mid;else break}const b=u.value;u.value=a,u.key=t;for(let A=g.length-1;A>=0;A--){const U=g[A][1];U.updateHeight();const O=U.balanceFactor();if(O<-1||O>1){const q=g[A][0],N=g[A+1][0];if(q===1&&N===1)g[A][1]=U.rotateLeft();else if(q===-1&&N===-1)g[A][1]=U.rotateRight();else if(q===1&&N===-1)U.right=g[A+1][1]=g[A+1][1].rotateRight(),g[A][1]=U.rotateLeft();else if(q===-1&&N===1)U.left=g[A+1][1]=g[A+1][1].rotateLeft(),g[A][1]=U.rotateRight();else throw new Error;if(A>0)switch(g[A-1][0]){case-1:g[A-1][1].left=g[A][1];break;case 1:g[A-1][1].right=g[A][1];break;case 0:g[A-1][1].mid=g[A][1];break}else this._root=g[0][1]}}return b}get(t){return this._getNode(t)?.value}_getNode(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(t){const a=this._getNode(t);return!(a?.value===void 0&&a?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,a){const o=this._iter.reset(t),u=[];let g=this._root;for(;g;){const b=o.cmp(g.segment);if(b>0)u.push([-1,g]),g=g.left;else if(b<0)u.push([1,g]),g=g.right;else if(o.hasNext())o.next(),u.push([0,g]),g=g.mid;else break}if(!!g){if(a?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const b=this._min(g.right),{key:A,value:U,segment:O}=b;this._delete(b.key,!1),g.key=A,g.value=U,g.segment=O}else{const b=g.left??g.right;if(u.length>0){const[A,U]=u[u.length-1];switch(A){case-1:U.left=b;break;case 0:U.mid=b;break;case 1:U.right=b;break}}else this._root=b}for(let b=u.length-1;b>=0;b--){const A=u[b][1];A.updateHeight();const U=A.balanceFactor();if(U>1?(A.right.balanceFactor()>=0||(A.right=u[b+1][1]=u[b+1][1].rotateRight()),u[b][1]=A.rotateLeft()):U<-1&&(A.left.balanceFactor()<=0||(A.left=u[b+1][1]=u[b+1][1].rotateLeft()),u[b][1]=A.rotateRight()),b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const a=this._iter.reset(t);let o=this._root,u;for(;o;){const g=a.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(t){const a=this._iter.reset(t);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[a,o]of this)t(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:t(a.left)&&t(a.right)};return t(this._root)}}e.TernarySearchTree=m;class v{constructor(t,a){this.uri=t,this.value=a}}class f{constructor(t,a){this[P]="ResourceMap",t instanceof f?(this.map=new Map(t.map),this.toKey=a??f.defaultToKey):(this.map=new Map,this.toKey=t??f.defaultToKey)}set(t,a){return this.map.set(this.toKey(t),new v(t,a)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,a){typeof a!="undefined"&&(t=t.bind(a));for(let[o,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=f,f.defaultToKey=r=>r.toString();var c;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,a=0){const o=this._map.get(t);if(!!o)return a!==0&&this.touch(o,a),o.value}set(t,a,o=0){let u=this._map.get(t);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:t,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const a=this._map.get(t);if(!!a)return this._map.delete(t),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,a){const o=this._state;let u=this._head;for(;u;){if(a?t.bind(a)(u.value,u.key,this):t(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.key,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}values(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:o.value,done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}entries(){const t=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const g={value:[o.key,o.value],done:!1};return o=o.next,g}else return{value:void 0,done:!0}}};return u}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>t;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const a=t.next,o=t.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}t.next=void 0,t.previous=void 0,this._state++}touch(t,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(t===this._head)return;const o=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(a===2){if(t===this._tail)return;const o=t.next,u=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((a,o)=>{t.push([o,a])}),t}fromJSON(t){this.clear();for(const[a,o]of t)this.set(a,o)}}e.LinkedMap=l;class i extends l{constructor(t,a=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,a=2){return super.get(t,a)}peek(t){return super.get(t,0)}set(t,a){return super.set(t,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=i;class s{constructor(t){D.set(this,void 0),Ct(this,D,t,"f")}get size(){return Ve(this,D,"f").size}forEach(t,a){Ve(this,D,"f").forEach(t,a)}get(t){return Ve(this,D,"f").get(t)}has(t){return Ve(this,D,"f").has(t)}entries(){return Ve(this,D,"f").entries()}keys(){return Ve(this,D,"f").keys()}values(){return Ve(this,D,"f").values()}[(D=new WeakMap,Symbol.iterator)](){return Ve(this,D,"f").entries()}}e.ReadonlyMapView=s}),define(te[70],ne([0,1,41]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new k.LRUCache(1e4);function P(I){return w(I,"NFC",T)}e.normalizeNFC=P;const R=new k.LRUCache(1e4);function D(I){return w(I,"NFD",R)}e.normalizeNFD=D;const C=/[^\u0000-\u0080]/;function w(I,n,E){if(!I)return I;const d=E.get(I);if(d)return d;let p;return C.test(I)?p=I.normalize(n):p=I,E.set(I,p),p}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(n){return D(n).replace(I,"")}}()}),define(te[17],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(g){return Array.isArray(g)}e.isArray=k;function T(g){return typeof g=="string"}e.isString=T;function P(g){return Array.isArray(g)&&g.every(b=>T(b))}e.isStringArray=P;function R(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=R;function D(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=D;function C(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=C;function w(g){return g===!0||g===!1}e.isBoolean=w;function I(g){return typeof g=="undefined"}e.isUndefined=I;function n(g){return!E(g)}e.isDefined=n;function E(g){return I(g)||g===null}e.isUndefinedOrNull=E;function d(g,b){if(!g)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=d;function p(g){if(E(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function h(...g){const b=[];for(let A=0;A<g.length;A++){const U=g[A];if(E(U))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);b.push(U)}return b}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function S(g){if(!R(g))return!1;for(let b in g)if(y.call(g,b))return!1;return!0}e.isEmptyObject=S;function m(g){return typeof g=="function"}e.isFunction=m;function v(...g){return g.length>0&&g.every(m)}e.areFunctions=v;function f(g,b){const A=Math.min(g.length,b.length);for(let U=0;U<A;U++)c(g[U],b[U])}e.validateConstraints=f;function c(g,b){if(T(b)){if(typeof g!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(m(b)){try{if(g instanceof b)return}catch{}if(!E(g)&&g.constructor===b||b.length===1&&b.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(g){let b=[],A=Object.getPrototypeOf(g);for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}e.getAllPropertyNames=l;function i(g){const b=[];for(const A of l(g))typeof g[A]=="function"&&b.push(A);return b}e.getAllMethodNames=i;function s(g,b){const A=O=>function(){const q=Array.prototype.slice.call(arguments,0);return b(O,q)};let U={};for(const O of g)U[O]=A(O);return U}e.createProxyObject=s;function r(g){return g===null?void 0:g}e.withNullAsUndefined=r;function t(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=t;function a(g){return class{constructor(){return new Proxy({},{get(b,A){if(b[A])return b[A];throw new Error(`Not Implemented: ${g}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function o(g,b="Unreachable"){throw new Error(b)}e.assertNever=o;function u(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=u}),define(te[42],ne([0,1,9,4,25,17]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function C(r){return r.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=C;function w(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=w;function I(r,t=k.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(D(o)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let g=3;const b=g;for(;g<a&&!D(r.charCodeAt(g));g++);if(b!==g&&!D(r.charCodeAt(g+1))){for(g+=1;g<a;g++)if(D(r.charCodeAt(g)))return r.slice(0,g+1).replace(/[\\/]/g,t)}}return t}else if(m(o)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(D(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=I;function n(r){if(!T.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let a=2;const o=a;for(;a<r.length&&(t=r.charCodeAt(a),t!==92);a++);return!(o===a||(t=r.charCodeAt(a+1),isNaN(t)||t===92))}e.isUNC=n;const E=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(r,t=T.isWindows){const a=t?E:d;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||t&&p.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=h;function y(r,t,a){const o=r===t;return!a||o?o:!r||!t?!1:(0,P.equalsIgnoreCase)(r,t)}e.isEqual=y;function S(r,t,a,o=k.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(a){if(!(0,P.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let g=t.length;return t.charAt(t.length-1)===o&&g--,r.charAt(g)===o}return t.charAt(t.length-1)!==o&&(t+=o),r.indexOf(t)===0}e.isEqualOrParent=S;function m(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=m;function v(r,t){return T.isWindows&&r.endsWith(":")&&(r+=k.sep),(0,k.isAbsolute)(r)||(r=(0,k.join)(t,r)),r=(0,k.normalize)(r),T.isWindows?(r=(0,P.rtrim)(r,k.sep),r.endsWith(":")&&(r+=k.sep)):(r=(0,P.rtrim)(r,k.sep),r||(r=k.sep)),r}e.sanitizeFilePath=v;function f(r){const t=(0,k.normalize)(r);return T.isWindows?r.length>3?!1:c(t)&&(r.length===2||t.charCodeAt(2)===92):t===k.posix.sep}e.isRootOrDriveLetter=f;function c(r,t){return(t!==void 0?t:T.isWindows)?m(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(r){return c(r)?r[0]:void 0}e.getDriveLetter=l;function i(r,t,a){return t.length>r.length?-1:r===t?0:(a&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=i;function s(r){const t=r.split(":");let a,o,u;if(t.forEach(g=>{const b=Number(g);(0,R.isNumber)(b)?o===void 0?o=b:u===void 0&&(u=b):a=a?[a,g].join(":"):g}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,17]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const S=Array.isArray(y)?[]:{};return Object.keys(y).forEach(m=>{y[m]&&typeof y[m]=="object"?S[m]=T(y[m]):S[m]=y[m]}),S}e.deepClone=T;function P(y){if(!y||typeof y!="object")return y;const S=[y];for(;S.length>0;){const m=S.shift();Object.freeze(m);for(const v in m)if(R.call(m,v)){const f=m[v];typeof f=="object"&&!Object.isFrozen(f)&&S.push(f)}}return y}e.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function D(y,S){return C(y,S,new Set)}e.cloneAndChange=D;function C(y,S,m){if((0,k.isUndefinedOrNull)(y))return y;const v=S(y);if(typeof v!="undefined")return v;if((0,k.isArray)(y)){const f=[];for(const c of y)f.push(C(c,S,m));return f}if((0,k.isObject)(y)){if(m.has(y))throw new Error("Cannot clone recursive data-structure");m.add(y);const f={};for(let c in y)R.call(y,c)&&(f[c]=C(y[c],S,m));return m.delete(y),f}return y}function w(y,S,m=!0){return(0,k.isObject)(y)?((0,k.isObject)(S)&&Object.keys(S).forEach(v=>{v in y?m&&((0,k.isObject)(y[v])&&(0,k.isObject)(S[v])?w(y[v],S[v],m):y[v]=S[v]):y[v]=S[v]}),y):S}e.mixin=w;function I(y,S){if(y===S)return!0;if(y==null||S===null||S===void 0||typeof y!=typeof S||typeof y!="object"||Array.isArray(y)!==Array.isArray(S))return!1;let m,v;if(Array.isArray(y)){if(y.length!==S.length)return!1;for(m=0;m<y.length;m++)if(!I(y[m],S[m]))return!1}else{const f=[];for(v in y)f.push(v);f.sort();const c=[];for(v in S)c.push(v);if(c.sort(),!I(f,c))return!1;for(m=0;m<f.length;m++)if(!I(y[f[m]],S[f[m]]))return!1}return!0}e.equals=I;function n(y){const S=new Set;return JSON.stringify(y,(m,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(S.has(v))return"[Circular]";S.add(v)}return v})}e.safeStringify=n;function E(y,S,m){const v=S(y);return typeof v=="undefined"?m:v}e.getOrDefault=E;function d(y,S){const m=Object.create(null);return!y||!S||Object.keys(S).forEach(f=>{const c=y[f],l=S[f];I(c,l)||(m[f]=l)}),m}e.distinct=d;function p(y,S){const m=S.toLowerCase(),v=Object.keys(y).find(f=>f.toLowerCase()===m);return v?y[v]:y[S]}e.getCaseInsensitive=p;function h(y,S){const m=Object.create(null);for(const[v,f]of Object.entries(y))S(v,f)&&(m[v]=f);return m}e.filter=h}),define(te[8],ne([0,1,9,4]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,R=/^\//,D=/^\/\//;function C(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!P.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(r,t){return!r&&!t?"file":r}function I(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const n="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,a,o,u,g,b=!1){typeof t=="object"?(this.scheme=t.scheme||n,this.authority=t.authority||n,this.path=t.path||n,this.query=t.query||n,this.fragment=t.fragment||n):(this.scheme=w(t,b),this.authority=a||n,this.path=I(this.scheme,o||n),this.query=u||n,this.fragment=g||n,C(this,b))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return f(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:o,path:u,query:g,fragment:b}=t;return a===void 0?a=this.scheme:a===null&&(a=n),o===void 0?o=this.authority:o===null&&(o=n),u===void 0?u=this.path:u===null&&(u=n),g===void 0?g=this.query:g===null&&(g=n),b===void 0?b=this.fragment:b===null&&(b=n),a===this.scheme&&o===this.authority&&u===this.path&&g===this.query&&b===this.fragment?this:new y(a,o,u,g,b)}static parse(t,a=!1){const o=d.exec(t);return o?new y(o[2]||n,s(o[4]||n),s(o[5]||n),s(o[7]||n),s(o[9]||n),a):new y(n,n,n,n,n)}static file(t){let a=n;if(T.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(a=t.substring(2),t=E):(a=t.substring(2,o),t=t.substring(o)||E)}return new y("file",a,t,n,n)}static from(t){const a=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return C(a,!0),a}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return T.isWindows&&t.scheme==="file"?o=p.file(k.win32.join(f(t,!0),...a)).path:o=k.posix.join(t.path,...a),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const a=new y(t);return a._formatted=t.external,a._fsPath=t._sep===h?t.fsPath:null,a}}else return t}}e.URI=p;const h=T.isWindows?1:void 0;class y extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(r,t){let a,o=-1;for(let u=0;u<r.length;u++){const g=r.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||t&&g===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const b=S[g];b!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=b):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function v(r){let t;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(t===void 0&&(t=r.substr(0,a)),t+=S[o]):t!==void 0&&(t+=r[a])}return t!==void 0?t:r}function f(r,t){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,T.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=f;function c(r,t){const a=t?v:m;let o="",{scheme:u,authority:g,path:b,query:A,fragment:U}=r;if(u&&(o+=u,o+=":"),(g||u==="file")&&(o+=E,o+=E),g){let O=g.indexOf("@");if(O!==-1){const q=g.substr(0,O);g=g.substr(O+1),O=q.indexOf(":"),O===-1?o+=a(q,!1):(o+=a(q.substr(0,O),!1),o+=":",o+=a(q.substr(O+1),!1)),o+="@"}g=g.toLowerCase(),O=g.indexOf(":"),O===-1?o+=a(g,!1):(o+=a(g.substr(0,O),!1),o+=g.substr(O))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const O=b.charCodeAt(1);O>=65&&O<=90&&(b=`/${String.fromCharCode(O+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const O=b.charCodeAt(0);O>=65&&O<=90&&(b=`${String.fromCharCode(O+32)}:${b.substr(2)}`)}o+=a(b,!0)}return A&&(o+="?",o+=a(A,!1)),U&&(o+="#",o+=t?U:m(U,!1)),o}function l(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+l(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(i)?r.replace(i,t=>l(t)):r}}),define(te[107],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(I){const n=I;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=T;function P(I){const n=[];let E;try{const d=JSON.parse(I.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),E=p.__$stack),n.push(...d)}catch(d){n.push("Unable to log remote console arguments",I.arguments)}return{args:n,stack:E}}e.parse=P;function R(I){if(typeof I!="string")return R(P(I).stack);const n=I;if(n){const E=D(n),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:k.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=R;function D(I){if(!I)return I;const n=I.indexOf(`
`);return n===-1?I:I.substring(0,n)}function C(I,n){const{args:E,stack:d}=P(I),p=typeof E[0]=="string"&&E.length===1;let h=D(d);h&&(h=`(${h.trim()})`);let y=[];if(typeof E[0]=="string"?h&&p?y=[`%c[${n}] %c${E[0]} %c${h}`,w("blue"),w(""),w("grey")]:y=[`%c[${n}] %c${E[0]}`,w("blue"),w(""),...E.slice(1)]:y=[`%c[${n}]%`,w("blue"),...E],h&&!p&&y.push(h),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,y)}e.log=C;function w(I){return`color: ${I}`}}),define(te[108],ne([0,1,19,25,8]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(n){return JSON.stringify(n,w)}e.stringify=R;function D(n){let E=JSON.parse(n);return E=I(E),E}e.parse=D;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function w(n,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,T.regExpFlags)(E)}:E}function I(n,E=0){if(!n||E>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return P.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof k.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=I(n[d],E+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=I(n[d],E+1))}return n}e.revive=I}),define(te[15],ne([0,1,4,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls"})(P=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,I,n){this._hosts[w]=I,this._ports[w]=n}setConnectionToken(w,I){this._connectionTokens[w]=I}rewrite(w){if(this._delegate)return this._delegate(w);const I=w.authority;let n=this._hosts[I];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const E=this._ports[I],d=this._connectionTokens[I];let p=`path=${encodeURIComponent(w.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),T.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${n}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new R;class D{asBrowserUri(w,I){const n=this.toUri(w,I);return n.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===P.file&&(k.isNative||typeof k.globals.importScripts=="function"&&k.globals.origin===`${P.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?n.with({scheme:P.vscodeFileResource,authority:n.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(w,I){const n=this.toUri(w,I);return n.scheme===P.vscodeFileResource?n.with({scheme:P.file,authority:n.authority!==D.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,I){return T.URI.isUri(w)?w:T.URI.parse(I.toUrl(w))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(te[18],ne([0,1,42,15,9,4,25,8]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(p){return(0,C.uriToFsPath)(p,!0)}e.originalFSPath=w;class I{constructor(h){this._ignorePathCasing=h}compare(h,y,S=!1){return h===y?0:(0,D.compare)(this.getComparisonKey(h,S),this.getComparisonKey(y,S))}isEqual(h,y,S=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,S)===this.getComparisonKey(y,S)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,S=!1){if(h.scheme===y.scheme){if(h.scheme===T.Schemas.file)return k.isEqualOrParent(w(h),w(y),this._ignorePathCasing(h))&&h.query===y.query&&(S||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return k.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(S||h.fragment===y.fragment)}return!1}joinPath(h,...y){return C.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return P.posix.basename(h.path)}extname(h){return P.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===T.Schemas.file?y=C.URI.file(P.dirname(w(h))).path:(y=P.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===T.Schemas.file?y=C.URI.file(P.normalize(w(h))).path:y=P.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===T.Schemas.file){const v=P.relative(w(h),w(y));return R.isWindows?k.toSlashes(v):v}let S=h.path||"/",m=y.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const f=Math.min(S.length,m.length);v<f&&!(S.charCodeAt(v)!==m.charCodeAt(v)&&S.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);S=m.substr(0,v)+S.substr(v)}return P.posix.relative(S,m)}resolvePath(h,y){if(h.scheme===T.Schemas.file){const S=C.URI.file(P.resolve(w(h),y));return h.with({authority:S.authority,path:S.path})}return y=k.toPosixPath(y),h.with({path:P.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,D.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=P.sep){if(h.scheme===T.Schemas.file){const S=w(h);return S.length>k.getRoot(S).length&&S[S.length-1]===y}else{const S=h.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=P.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=P.sep){let S=!1;if(h.scheme===T.Schemas.file){const m=w(h);S=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=h.path;S=m.length===1&&m.charCodeAt(m.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(p=>p.scheme===T.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(p,h){const y=[];for(let S=0;S<p.length;S++){const m=h(p[S]);p.some((v,f)=>f===S?!1:(0,e.isEqualOrParent)(m,h(v)))||y.push(p[S])}return y}e.distinctParents=n;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(y){const S=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(f=>{const[c,l]=f.split(":");c&&l&&S.set(c,l)});const v=y.path.substring(0,y.path.indexOf(";"));return v&&S.set(p.META_DATA_MIME,v),S}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function d(p,h,y){if(h){let S=p.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),p.with({scheme:y,authority:h,path:S})}return p.with({scheme:y})}e.toLocalResource=d}),define(te[5],ne([0,1,28,7,3,2,18]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(j){return!!j&&typeof j.then=="function"}e.isThenable=C;function w(j){const W=new k.CancellationTokenSource,x=j(W.token),z=new Promise((K,F)=>{const B=W.token.onCancellationRequested(()=>{B.dispose(),W.dispose(),F((0,T.canceled)())});Promise.resolve(x).then(V=>{B.dispose(),W.dispose(),K(V)},V=>{B.dispose(),W.dispose(),F(V)})});return new class{cancel(){W.cancel()}then(K,F){return z.then(K,F)}catch(K){return this.then(void 0,K)}finally(K){return z.finally(K)}}}e.createCancelablePromise=w;function I(j,W,x){return Promise.race([j,new Promise(z=>W.onCancellationRequested(()=>z(x)))])}e.raceCancellation=I;async function n(j){let W=-1;const x=j.map((K,F)=>K.then(B=>(W=F,B))),z=await Promise.race(x);return j.forEach((K,F)=>{F!==W&&K.cancel()}),z}e.raceCancellablePromises=n;function E(j,W,x){let z;const K=setTimeout(()=>{z?.(void 0),x?.()},W);return Promise.race([j.finally(()=>clearTimeout(K)),new Promise(F=>z=F)])}e.raceTimeout=E;function d(j){return new Promise((W,x)=>{const z=j();C(z)?z.then(W,x):W(z)})}e.asPromise=d;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(W){if(this.activePromise){if(this.queuedPromiseFactory=W,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(x,x).then(z)})}return new Promise((x,z)=>{this.queuedPromise.then(x,z)})}return this.activePromise=W(),new Promise((x,z)=>{this.activePromise.then(K=>{this.activePromise=null,x(K)},K=>{this.activePromise=null,z(K)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(W){return this.current=this.current.then(()=>W(),()=>W())}}e.Sequencer=h;class y{constructor(){this.promiseMap=new Map}queue(W,x){const K=(this.promiseMap.get(W)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(W)===K&&this.promiseMap.delete(W)});return this.promiseMap.set(W,K),K}}e.SequencerByKey=y;class S{constructor(W){this.defaultDelay=W,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(W,x=this.defaultDelay){return this.task=W,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,K)=>{this.doResolve=z,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class m{constructor(W){this.delayer=new S(W),this.throttler=new p}trigger(W,x){return this.delayer.trigger(()=>this.throttler.queue(W),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class v{constructor(){this._isOpen=!1,this._promise=new Promise((W,x)=>{this._completePromise=W})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class f extends v{constructor(W){super();this._timeout=setTimeout(()=>this.open(),W)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function c(j,W){return W?new Promise((x,z)=>{const K=setTimeout(()=>{F.dispose(),x()},j),F=W.onCancellationRequested(()=>{clearTimeout(K),F.dispose(),z((0,T.canceled)())})}):w(x=>c(j,x))}e.timeout=c;function l(j,W=0){const x=setTimeout(j,W);return(0,R.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=l;function i(j){const W=[];let x=0;const z=j.length;function K(){return x<z?j[x++]():null}function F(B){B!=null&&W.push(B);const V=K();return V?V.then(F):Promise.resolve(W)}return Promise.resolve(null).then(F)}e.sequence=i;function s(j,W=z=>!!z,x=null){let z=0;const K=j.length,F=()=>{if(z>=K)return Promise.resolve(x);const B=j[z++];return Promise.resolve(B()).then(Q=>W(Q)?Promise.resolve(Q):F())};return F()}e.first=s;function r(j,W=z=>!!z,x=null){if(j.length===0)return Promise.resolve(x);let z=j.length;const K=()=>{z=-1;for(const F of j)F.cancel?.()};return new Promise((F,B)=>{for(const V of j)V.then(Q=>{--z>=0&&W(Q)?(K(),F(Q)):z===0&&F(x)}).catch(Q=>{--z>=0&&(K(),B(Q))})})}e.firstParallel=r;class t{constructor(W){this._size=0,this.maxDegreeOfParalellism=W,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(W){return this._size++,new Promise((x,z)=>{this.outstandingPromises.push({factory:W,c:x,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const W=this.outstandingPromises.shift();this.runningPromises++;const x=W.factory();x.then(W.c,W.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class a extends t{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(W,x=D.extUri){const z=x.getComparisonKey(W);let K=this.queues.get(z);return K||(K=new a,P.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(z)}),this.queues.set(z,K)),K}dispose(){this.queues.forEach(W=>W.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(W,x){this._token=-1,typeof W=="function"&&typeof x=="number"&&this.setIfNotSet(W,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,W()},x)}setIfNotSet(W,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,W()},x))}}e.TimeoutTimer=u;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(W,x){this.cancel(),this._token=setInterval(()=>{W()},x)}}e.IntervalTimer=g;class b{constructor(W,x){this.timeoutToken=-1,this.runner=W,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(W=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,W)}get delay(){return this.timeout}set delay(W){this.timeout=W}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class A{constructor(W,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=W,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(W=this.timeout){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(W/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class U extends b{constructor(W,x){super(W,x);this.units=[]}work(W){this.units.push(W),this.isScheduled()||this.schedule()}doRun(){const W=this.units;this.units=[],this.runner&&this.runner(W)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class O extends R.Disposable{constructor(W,x,z,K){super();this.maxWorkChunkSize=W,this.maxPendingWork=x,this.throttleDelay=z,this.handler=K,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(W){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+W.length>this.maxPendingWork)return!1}else if(this.pending+W.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...W),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{const W=setTimeout(()=>{const z=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(W))}}}:e.runWhenIdle=(j,W)=>{const x=requestIdleCallback(j,typeof W=="number"?{timeout:W}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(x))}}}}();class q{constructor(W){this._didRun=!1,this._executor=()=>{try{this._value=W()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function N(j,W,x){let z;for(let K=0;K<x;K++)try{return await j()}catch(F){z=F,await c(W)}throw z}e.retry=N;class L{hasPending(W){return this._pending?typeof W=="number"?this._pending.taskId===W:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(W,x,z){return this._pending={taskId:W,cancel:()=>z?.(),promise:x},x.then(()=>this.donePending(W),()=>this.donePending(W)),x}donePending(W){this._pending&&W===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const W=this._next;this._next=void 0,W.run().then(W.promiseResolve,W.promiseReject)}}setNext(W){if(this._next)this._next.run=W;else{let x,z;const K=new Promise((F,B)=>{x=F,z=B});this._next={run:W,promise:K,promiseResolve:x,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=L;class ${constructor(W){this.interval=W,this.lastIncrementTime=0,this.value=0}increment(){const W=Date.now();return W-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=W,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((W,x)=>{this.completeCallback=W,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(W){return new Promise(x=>{this.completeCallback(W),this.resolved=!0,x()})}error(W){return new Promise(x=>{this.errorCallback(W),this.rejected=!0,x()})}cancel(){new Promise(W=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,W()})}}e.DeferredPromise=_;var M;(function(j){async function W(z){let K;const F=await Promise.all(z.map(B=>B.then(V=>V,V=>{K||(K=V)})));if(typeof K!="undefined")throw K;return F}j.settled=W;function x(z){return new Promise(async(K,F)=>{try{await z(K,F)}catch(B){F(B)}})}j.withAsyncBody=x})(M=e.Promises||(e.Promises={}))}),define(te[109],ne([0,1,5,42,41,9,25]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const w="**",I="/",n="[/\\\\]",E="[^/\\\\]",d=/\//g;function p(z){switch(z){case 0:return"";case 1:return`${E}*?`;default:return`(?:${n}|${E}+${n}|${n}${E}+)*?`}}function h(z,K){if(!z)return[];const F=[];let B=!1,V=!1,Q="";for(const Z of z){switch(Z){case K:if(!B&&!V){F.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&F.push(Q),F}e.splitGlobAware=h;function y(z){if(!z)return"";let K="";const F=h(z,I);if(F.every(B=>B===w))K=".*";else{let B=!1;F.forEach((V,Q)=>{if(V===w){B||(K+=p(2),B=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===I?ce="":ce=D.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(de=>y(de)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=E;continue;case"*":K+=p(1);continue;default:K+=D.escapeRegExpCharacters(ie)}}Q<F.length-1&&(F[Q+1]!==w||Q+2<F.length)&&(K+=n),B=!1})}return K}const S=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new P.LRUCache(1e4),s=function(){return!1},r=function(){return null};function t(z,K){if(!z)return r;let F;typeof z!="string"?F=z.pattern:F=z,F=F.trim();const B=`${F}_${!!K.trimForExclusions}`;let V=i.get(B);if(V)return a(V,z);let Q;if(S.test(F)){const Z=F.substr(4);V=function(G,H){return typeof G=="string"&&G.endsWith(Z)?F:null}}else(Q=m.exec(o(F,K)))?V=u(Q[1],F):(K.trimForExclusions?f:v).test(F)?V=g(F,K):(Q=c.exec(o(F,K)))?V=b(Q[1].substr(1),F,!0):(Q=l.exec(o(F,K)))?V=b(Q[1],F,!1):V=A(F);return i.set(B,V),a(V,z)}function a(z,K){return typeof K=="string"?z:function(F,B){return T.isEqualOrParent(F,K.base)?z(R.relative(K.base,F),B):null}}function o(z,K){return K.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,K){const F=`/${z}`,B=`\\${z}`,V=function(Z,G){return typeof Z!="string"?null:G?G===z?K:null:Z===z||Z.endsWith(F)||Z.endsWith(B)?K:null},Q=[z];return V.basenames=Q,V.patterns=[K],V.allBasenames=Q,V}function g(z,K){const F=x(z.slice(1,-1).split(",").map(G=>t(G,K)).filter(G=>G!==r),z),B=F.length;if(!B)return r;if(B===1)return F[0];const V=function(G,H){for(let re=0,ie=F.length;re<ie;re++)if(F[re](G,H))return z;return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function b(z,K,F){const B=R.sep===R.posix.sep,V=B?z:z.replace(d,R.sep),Q=R.sep+V,Z=R.posix.sep+z,G=F?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===z||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===z)?K:null};return G.allPaths=[(F?"*/":"./")+z],G}function A(z){try{const K=new RegExp(`^${y(z)}$`);return function(F){return K.lastIndex=0,typeof F=="string"&&K.test(F)?z:null}}catch(K){return r}}function U(z,K,F){return!z||typeof K!="string"?!1:O(z)(K,void 0,F)}e.match=U;function O(z,K={}){if(!z)return s;if(typeof z=="string"||$(z)){const F=t(z,K);if(F===r)return s;const B=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(B.allBasenames=F.allBasenames),F.allPaths&&(B.allPaths=F.allPaths),B}return j(z,K)}e.parse=O;function q(z){if(!z)return;let K;return F=>(K||(K=(z()||Promise.resolve([])).then(B=>B?L(B):{})),K.then(B=>!!B[F]))}e.hasSiblingPromiseFn=q;function N(z){if(!z)return;let K;return F=>{if(!K){const B=z();K=B?L(B):{}}return!!K[F]}}e.hasSiblingFn=N;function L(z){const K={};for(const F of z)K[F]=!0;return K}function $(z){const K=z;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function _(z){return z.allBasenames||[]}e.getBasenameTerms=_;function M(z){return z.allPaths||[]}e.getPathTerms=M;function j(z,K){const F=x(Object.getOwnPropertyNames(z).map(G=>W(G,z[G],K)).filter(G=>G!==r)),B=F.length;if(!B)return r;if(!F.some(G=>!!G.requiresSiblings)){if(B===1)return F[0];const G=function(ie,ce){for(let le=0,de=F.length;le<de;le++){const fe=F[le](ie,ce);if(fe)return fe}return null},H=F.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=F.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const V=function(G,H,re){let ie;for(let ce=0,le=F.length;ce<le;ce++){const de=F[ce];de.requiresSiblings&&re&&(H||(H=R.basename(G)),ie||(ie=H.substr(0,H.length-R.extname(G).length)));const fe=de(G,H,ie,re);if(fe)return fe}return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function W(z,K,F){if(K===!1)return r;const B=t(z,F);if(B===r)return r;if(typeof K=="boolean")return B;if(K){const V=K.when;if(typeof V=="string"){const Q=(Z,G,H,re)=>{if(!re||!B(Z,G))return null;const ie=V.replace("$(basename)",H),ce=re(ie);return(0,k.isThenable)(ce)?ce.then(le=>le?z:null):ce?z:null};return Q.requiresSiblings=!0,Q}}return B}function x(z,K){const F=z.filter(G=>!!G.basenames);if(F.length<2)return z;const B=F.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let V;if(K){V=[];for(let G=0,H=B.length;G<H;G++)V.push(K)}else V=F.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=z.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[110],ne([0,1,109,15,9,18,25]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let w=[],I=[],n=[];function E(t,a=!1){const o=d(t);w.push(o),o.userConfigured?n.push(o):I.push(o),a&&!o.userConfigured&&w.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=E;function d(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,k.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(P.posix.sep)>=0:!1}}function p(t){t?(w=w.filter(a=>!a.userConfigured),n=[]):(w=[],I=[],n=[])}e.clearTextMimes=p;function h(t,a){let o;if(t)switch(t.scheme){case T.Schemas.file:o=t.fsPath;break;case T.Schemas.data:o=R.DataUri.parseMetaData(t).get(R.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[C.unknown];o=o.toLowerCase();const u=(0,P.basename)(o),g=y(o,u,n);if(g)return[g,C.text];const b=y(o,u,I);if(b)return[b,C.text];if(a){const A=S(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=h;function y(t,a,o){let u=null,g=null,b=null;for(let A=o.length-1;A>=0;A--){const U=o[A];if(a===U.filenameLowercase){u=U;break}if(U.filepattern&&(!g||U.filepattern.length>g.filepattern.length)){const O=U.filepatternOnPath?t:a;U.filepatternLowercase?.(O)&&(g=U)}U.extension&&(!b||U.extension.length>b.extension.length)&&a.endsWith(U.extensionLowercase)&&(b=U)}return u?u.mime:g?g.mime:b?b.mime:null}function S(t){if((0,D.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let a=w.length-1;a>=0;a--){const o=w[a];if(!o.firstline)continue;const u=t.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function m(t){return t?typeof t=="string"?t===C.binary||t===C.text||t===C.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const a=(0,P.extname)(t),o=v[a.toLowerCase()];return o!==void 0?o:l(t)}e.getMediaOrTextMime=c;function l(t){const a=(0,P.extname)(t);return f[a.toLowerCase()]}e.getMediaMime=l;function i(t){for(const a in f)if(f[a]===t)return a}e.getExtensionForMimeType=i;const s=/^(.+)\/(.+?)(;.+)?$/;function r(t,a){const o=s.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:t}e.normalizeMimeType=r}),define(te[111],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class P{constructor(E){this._uriTransformer=E}transformIncoming(E){const d=this._uriTransformer.transformIncoming(E);return d===E?E:T(k.URI.from(d))}transformOutgoing(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:T(k.URI.from(d))}transformOutgoingURI(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:k.URI.from(d)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function R(n,E,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof k.URI)return E.transformOutgoing(n);for(let p in n)if(Object.hasOwnProperty.call(n,p)){const h=R(n[p],E,d+1);h!==null&&(n[p]=h)}}return null}function D(n,E){const d=R(n,E,0);return d===null?n:d}e.transformOutgoingURIs=D;function C(n,E,d,p){if(!n||p>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?k.URI.revive(E.transformIncoming(n)):E.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const y=C(n[h],E,d,p+1);y!==null&&(n[h]=y)}}return null}function w(n,E){const d=C(n,E,!1,0);return d===null?n:d}e.transformIncomingURIs=w;function I(n,E){const d=C(n,E,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=I}),define(te[29],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(w){return k.test(w)}e.isUUID=T;const P=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(w){for(let I=0;I<w.length;I++)w[I]=Math.floor(Math.random()*256);return w};function C(){D(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,I="";return I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I+="-",I+=R[P[w++]],I+=R[P[w++]],I+="-",I+=R[P[w++]],I+=R[P[w++]],I+="-",I+=R[P[w++]],I+=R[P[w++]],I+="-",I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I+=R[P[w++]],I}e.generateUuid=C}),define(te[112],ne([0,1,113]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(R="utf8"){this.stringDecoder=new k.StringDecoder(R),this.remaining=null}write(R){const D=[],C=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(C.length<1)return D;let w=0,I,n=w;for(;n<C.length;)if(I=C.charCodeAt(n),I===13||I===10){if(D.push(C.substring(w,n)),n++,n<C.length){const E=I;I=C.charCodeAt(n),(E===13&&I===10||E===10&&I===13)&&n++}w=n}else n++;return this.remaining=w<C.length?C.substr(w):null,D}end(){return this.remaining}}e.LineDecoder=T}),define(te[114],ne([0,1,33]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const C=D.replace(/\-/g,":").toLowerCase();return!T.has(C)}function R(){const D=(0,k.networkInterfaces)();for(let C in D){const w=D[C];if(w){for(const{mac:I}of w)if(P(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[115],ne([0,1,33,7,41,29,114]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=P.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,E=0;const d=(0,k.networkInterfaces)();for(let p in d){const h=d[p];if(h)for(const{mac:y,internal:S}of h)S||(E+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(n+=1))}this._value=E>0?n/E:0}return this._value}};let C;async function w(){return C||(C=(async()=>await I()||R.generateUuid())()),C}e.getMachineId=w;async function I(){try{const n=await new Promise((d,p)=>{X(["crypto"],d,p)}),E=(0,D.getMac)();return n.createHash("sha256").update(E,"utf8").digest("hex")}catch(n){T.onUnexpectedError(n);return}}}),define(te[20],ne([0,1,51,33,246,5,42,70,9,4,18,8,29]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(_,M=p.UNLINK){if((0,D.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return M===p.UNLINK?S(_):y(_)}async function y(_){try{const M=(0,w.join)((0,T.tmpdir)(),(0,d.generateUuid)());try{await e.Promises.rename(_,M)}catch(j){return S(_)}S(M).catch(j=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function S(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,D.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");k.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function v(_,M){return l(await(M?f(_):(0,P.promisify)(k.readdir)(_)))}async function f(_){try{return await(0,P.promisify)(k.readdir)(_,{withFileTypes:!0})}catch(W){console.warn("[node.js fs] readdir with filetypes failed with error: ",W)}const M=[],j=await v(_);for(const W of j){let x=!1,z=!1,K=!1;try{const F=await e.Promises.lstat((0,w.join)(_,W));x=F.isFile(),z=F.isDirectory(),K=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}M.push({name:W,isFile:()=>x,isDirectory:()=>z,isSymbolicLink:()=>K})}return M}function c(_){return l(k.readdirSync(_))}e.readdirSync=c;function l(_){return _.map(M=>typeof M=="string"?I.isMacintosh?(0,C.normalizeNFC)(M):M:(M.name=I.isMacintosh?(0,C.normalizeNFC)(M.name):M.name,M))}async function i(_){const M=await v(_),j=[];for(const W of M)await r.existsDirectory((0,w.join)(_,W))&&j.push(W);return j}function s(_,M=1e3){return new Promise(j=>{let W=!1;const x=setInterval(()=>{W||(W=!0,k.access(_,z=>{W=!1,z&&(clearInterval(x),j(void 0))}))},M)})}e.whenDeleted=s;var r;(function(_){async function M(x){let z;try{if(z=await e.Promises.lstat(x),!z.isSymbolicLink())return{stat:z}}catch(K){}try{return{stat:await e.Promises.stat(x),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(I.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw F}throw K}}_.stat=M;async function j(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isFile()&&K?.dangling!==!0}catch(z){}return!1}_.existsFile=j;async function W(x){try{const{stat:z,symbolicLink:K}=await _.stat(x);return z.isDirectory()&&K?.dangling!==!0}catch(z){}return!1}_.existsDirectory=W})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new R.ResourceQueue;function a(_,M,j){return t.queueFor(E.URI.file(_),n.extUriBiasedIgnorePathCase).queue(()=>{const W=b(j);return new Promise((x,z)=>u(_,M,W,K=>K?z(K):x()))})}let o=!0;function u(_,M,j,W){if(!o)return k.writeFile(_,M,{mode:j.mode,flag:j.flag},W);k.open(_,j.flag,j.mode,(x,z)=>{if(x)return W(x);k.writeFile(z,M,K=>{if(K)return k.close(z,()=>W(K));k.fdatasync(z,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),o=!1),k.close(z,B=>W(B))))})})}function g(_,M,j){const W=b(j);if(!o)return k.writeFileSync(_,M,{mode:W.mode,flag:W.flag});const x=k.openSync(_,W.flag,W.mode);try{k.writeFileSync(x,M);try{k.fdatasyncSync(x)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o=!1}}finally{k.closeSync(x)}}e.writeFileSync=g;function b(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,M){if(_===M)return;async function j(W){try{const x=await e.Promises.lstat(W);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(W,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(_,M),await j(M)}catch(W){if(_.toLowerCase()!==M.toLowerCase()&&W.code==="EXDEV"||_.endsWith("."))await U(_,M,{preserveSymlinks:!1}),await h(_,p.MOVE),await j(M);else throw W}}async function U(_,M,j){return q(_,M,{root:{source:_,target:M},options:j,handledSourcePaths:new Set})}const O=511;async function q(_,M,j){if(j.handledSourcePaths.has(_))return;j.handledSourcePaths.add(_);const{stat:W,symbolicLink:x}=await r.stat(_);if(x){if(j.options.preserveSymlinks)try{return await $(_,M,j)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(x.dangling)return}return W.isDirectory()?N(_,M,W.mode&O,j):L(_,M,W.mode&O)}async function N(_,M,j,W){await e.Promises.mkdir(M,{recursive:!0,mode:j});const x=await v(_);for(const z of x)await q((0,w.join)(_,z),(0,w.join)(M,z),W)}async function L(_,M,j){await e.Promises.copyFile(_,M),await e.Promises.chmod(M,j)}async function $(_,M,j){let W=await e.Promises.readlink(_);(0,D.isEqualOrParent)(W,j.root.source,!I.isLinux)&&(W=(0,w.join)(j.root.target,W.substr(j.root.source.length+1))),await e.Promises.symlink(W,M)}e.Promises=new class{get access(){return(0,P.promisify)(k.access)}get stat(){return(0,P.promisify)(k.stat)}get lstat(){return(0,P.promisify)(k.lstat)}get utimes(){return(0,P.promisify)(k.utimes)}get read(){return(0,P.promisify)(k.read)}get readFile(){return(0,P.promisify)(k.readFile)}get write(){return(0,P.promisify)(k.write)}get appendFile(){return(0,P.promisify)(k.appendFile)}get fdatasync(){return(0,P.promisify)(k.fdatasync)}get truncate(){return(0,P.promisify)(k.truncate)}get rename(){return(0,P.promisify)(k.rename)}get copyFile(){return(0,P.promisify)(k.copyFile)}get open(){return(0,P.promisify)(k.open)}get close(){return(0,P.promisify)(k.close)}get symlink(){return(0,P.promisify)(k.symlink)}get readlink(){return(0,P.promisify)(k.readlink)}get chmod(){return(0,P.promisify)(k.chmod)}get mkdir(){return(0,P.promisify)(k.mkdir)}get unlink(){return(0,P.promisify)(k.unlink)}get rmdir(){return(0,P.promisify)(k.rmdir)}get realpath(){return(0,P.promisify)(k.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return i}get writeFile(){return a}get rm(){return h}get move(){return A}get copy(){return U}}}),define(te[116],ne([0,1,51,9,25,20]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function D(n){const E=(0,T.dirname)(n);if(n===E)return n;const d=((0,T.basename)(n)||n).toLowerCase();try{const h=(0,R.readdirSync)(E).filter(y=>y.toLowerCase()===d);if(h.length===1){const y=D(E);if(y)return(0,T.join)(y,h[0])}else if(h.length>1){const y=h.indexOf(d);if(y>=0){const S=D(E);if(S)return(0,T.join)(S,h[y])}}}catch(p){}return null}e.realcaseSync=D;async function C(n){try{return await R.Promises.realpath(n)}catch(E){const d=I(n);return await R.Promises.access(d,k.constants.R_OK),d}}e.realpath=C;function w(n){try{return k.realpathSync(n)}catch(E){const d=I(n);return k.accessSync(d,k.constants.R_OK),d}}e.realpathSync=w;function I(n){return(0,P.rtrim)((0,T.normalize)(n),T.sep)}}),define(te[117],ne([0,1,57]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function T(C,w,I,n=1){let E=!1;return new Promise(d=>{const p=setTimeout(()=>{if(!E)return E=!0,d(0)},I);P(C,w,n,h=>{if(!E)return E=!0,clearTimeout(p),d(h)})})}e.findFreePort=T;function P(C,w,I,n){if(w===0)return n(0);const E=new k.Socket;E.once("connect",()=>(D(E),P(C+I,w-1,I,n))),E.once("data",()=>{}),E.once("error",d=>(D(E),d.code!=="ECONNREFUSED"?P(C+I,w-1,I,n):n(C))),E.connect(C,"127.0.0.1")}function R(C,w,I){let n=!1,E,d=1;const p=k.createServer({pauseOnConnect:!0});function h(y,S){n||(n=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),S(y))}return new Promise(y=>{E=setTimeout(()=>{h(0,y)},I),p.on("listening",()=>{h(C,y)}),p.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&d<w?(C++,d++,p.listen(C,"127.0.0.1")):h(0,y)}),p.on("close",()=>{h(0,y)}),p.listen(C,"127.0.0.1")})}e.findFreePortFaster=R;function D(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(w){console.error(w)}}}),define(te[71],ne([0,1,33,9,20]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,D=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var w;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(w||(w={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class E{constructor(l,i,s){this.exePath=l,this.displayName=i,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?I===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:l=!1}={}){const i=d({useAlternateBitness:c});if(!i)return null;const s=T.join(i,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let r=-1,t=null;for(const u of await P.Promises.readdir(s)){let g=-1;if(l){const A=u.indexOf("-");if(A<0)continue;const U=u.substring(0,A);if(!R.test(U)||u.substring(A+1)!=="preview")continue;g=parseInt(U,10)}else{if(!R.test(u))continue;g=parseInt(u,10)}if(g<=r)continue;const b=T.join(s,u,"pwsh.exe");!await P.SymlinkSupport.existsFile(b)||(t=b,r=g)}if(!t)return null;const a=i.includes("x86")?" (x86)":"",o=l?" Preview":"";return new E(t,`PowerShell${o}${a}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=c?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(l))if(i.test(r)){const t=T.join(l,r,"pwsh.exe");return new E(t,s)}return null}function y(){const c=T.join(k.homedir(),".dotnet","tools","pwsh.exe");return new E(c,".NET Core PowerShell Global Tool")}function S(){const c=T.join(process.env.windir,I===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(c,"Windows PowerShell",!0)}async function*m(){let c=await p();c&&(yield c),c=await p({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=y(),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await p({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=S(),c&&(yield c)}async function*v(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=v;async function f(){for await(const c of v())return c;return null}e.getFirstAvailablePowerShellInstallation=f}),define(te[118],ne([0,1,43,15]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function P(D){return new Promise((C,w)=>{let I;const n=new Map;function E(p,h,y,S,m){const v=n.get(h);if(p===D||v){const f={name:d(y),cmd:y,pid:p,ppid:h,load:S,mem:m};n.set(p,f),p===D&&(I=f),v&&(v.children||(v.children=[]),v.children.push(f),v.children.length>1&&(v.children=v.children.sort((c,l)=>c.pid-l.pid)))}}function d(p){const h=/--disable-blink-features=Auxclick/,y=/\\watcher\\win32\\CodeHelper\.exe/,S=/--crashes-directory/,m=/\\pipe\\winpty-control/,v=/conhost\.exe/,f=/--type=([a-zA-Z-]+)/;if(y.exec(p))return"watcherService ";if(S.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(v.exec(p))return"console-window-host (Windows internal process)";let c=f.exec(p);if(c&&c.length===2)return c[1]==="renderer"?h.exec(p)?"shared-process":"window":c[1];const l=/[a-zA-Z-]+\.js/g;let i="";do c=l.exec(p),c&&(i+=c+" ");while(c);return i&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${i}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{X(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(D,y=>{h.getProcessCpuUsage(y,S=>{const m=new Map;S.forEach(v=>{const f=p(v.commandLine||"");m.set(v.pid,{name:d(f),cmd:f,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),I=m.get(D),I?(m.forEach(v=>{const f=m.get(v.ppid);f&&(f.children||(f.children=[]),f.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((f,c)=>f.pid-c.pid))}),C(I)):w(new Error(`Root process ${D} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[I];const y=[];for(;h.length;){const m=h.shift();m&&(y.push(m.pid),m.children&&(h=h.concat(m.children)))}let S=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);S+=" "+y.join(" "),(0,k.exec)(S,{},(m,v,f)=>{if(m||f)w(m||new Error(f.toString()));else{const c=v.toString().split(`
`);for(let l=0;l<y.length;l++){const i=n.get(y[l]);i.load=parseFloat(c[l])}if(!I){w(new Error(`Root process ${D} not found`));return}C(I)}})};(0,k.exec)("which ps",{},(h,y,S)=>{if(h||S)if(process.platform!=="linux")w(h||new Error(S.toString()));else{const m=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,k.exec)(m,{},(v,f,c)=>{v||c?w(v||new Error(c.toString())):(R(f,E),p())})}else{const m=y.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,c,l)=>{f||l&&!l.includes("screen size is bogus")?w(f||new Error(l.toString())):(R(c,E),process.platform==="linux"?p():I?C(I):w(new Error(`Root process ${D} not found`)))})}})}})}e.listProcesses=P;function R(D,C){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=D.toString().split(`
`);for(const n of I){const E=w.exec(n.trim());E&&E.length===6&&C(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[119],ne([0,1,51,28,42,2,70,9,4,20]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(h,y,S){return d({path:h,isDirectory:!1},y,S)}e.watchFile=n;function E(h,y,S){return d({path:h,isDirectory:!0},y,S)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function d(h,y,S){if(w.isMacintosh&&(0,P.isEqualOrParent)(h.path,"/Volumes/"))return S(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=(0,C.basename)(h.path),v=new Map;let f=!1,c=[(0,R.toDisposable)(()=>{v.forEach(l=>(0,R.dispose)(l)),v.clear()})];try{const l=(0,k.watch)(h.path);c.push((0,R.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const i=new Set;h.isDirectory&&I.Promises.readdir(h.path).then(s=>s.forEach(r=>i.add(r))),l.on("error",(s,r)=>{f||S(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${r})`)}),l.on("change",(s,r)=>{if(f)return;let t="";if(r&&(t=r.toString(),w.isMacintosh&&(t=(0,D.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const a=h.isDirectory?(0,C.join)(h.path,t):h.path;if(h.isDirectory)if(s==="rename"){const o=v.get(a);o&&(0,R.dispose)(o);const u=setTimeout(async()=>{v.delete(a);const g=await I.Promises.exists(a);if(f)return;let b;g?i.has(t)?b="changed":(b="added",i.add(t)):(i.delete(t),b="deleted"),y(b,a)},e.CHANGE_BUFFER_DELAY);v.set(a,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let o;i.has(t)?o="changed":(o="added",i.add(t)),y(o,a)}else if(s==="rename"||t!==m){const o=setTimeout(async()=>{const u=await I.Promises.exists(a);f||(u?(y("changed",a),c=[d(h,y,S)]):y("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(c),c=[(0,R.toDisposable)(()=>clearTimeout(o))]}else y("changed",a)})}catch(l){I.Promises.exists(h.path).then(i=>{i&&!f&&S(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,R.toDisposable)(()=>{f=!0,c=(0,R.dispose)(c)})}async function p(h,y,S,m=512){const v=await I.Promises.open(h,"r"),f=Buffer.allocUnsafe(m),c=new T.CancellationTokenSource(S);let l,i=!1;const s=n(h,async r=>{if(r==="changed"){if(i)return;i=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await I.Promises.read(v,f,0,m,null);if(!t||c.token.isCancellationRequested)break;y(f.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{i=!1}}},r=>{l=new Error(r),c.dispose(!0)});return new Promise((r,t)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await I.Promises.close(v),l?t(l):r()})})}e.watchFileContents=p});var he=this&&this.__decorate||function(X,e,k,T){var P=arguments.length,R=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,k):T,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(X,e,k,T);else for(var C=X.length-1;C>=0;C--)(D=X[C])&&(R=(P<3?D(R):P>3?D(e,k,R):D(e,k))||R);return P>3&&R&&Object.defineProperty(e,k,R),R};define(te[34],ne([0,1,16,5,19,28,68,7,3,2,108,25,17]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function S(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(m||(m={}));class v{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class f{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var c;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(c||(c={}));function l(x){const z=P.VSBuffer.alloc(4);return z.writeUInt32BE(x,0),z}function i(x){return x.read(4).readUInt32BE(0)}function s(x){const z=P.VSBuffer.alloc(1);return z.writeUInt8(x,0),z}const r={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},t=typeof Buffer!="undefined";function a(x,z){if(typeof z=="undefined")x.write(r.Undefined);else if(typeof z=="string"){const K=P.VSBuffer.fromString(z);x.write(r.String),x.write(l(K.byteLength)),x.write(K)}else if(t&&Buffer.isBuffer(z)){const K=P.VSBuffer.wrap(z);x.write(r.Buffer),x.write(l(K.byteLength)),x.write(K)}else if(z instanceof P.VSBuffer)x.write(r.VSBuffer),x.write(l(z.byteLength)),x.write(z);else if(Array.isArray(z)){x.write(r.Array),x.write(l(z.length));for(const K of z)a(x,K)}else{const K=P.VSBuffer.fromString(JSON.stringify(z));x.write(r.Object),x.write(l(K.byteLength)),x.write(K)}}function o(x){switch(x.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return x.read(i(x)).toString();case c.Buffer:return x.read(i(x)).buffer;case c.VSBuffer:return x.read(i(x));case c.Array:{const K=i(x),F=[];for(let B=0;B<K;B++)F.push(o(x));return F}case c.Object:return JSON.parse(x.read(i(x)).toString())}}class u{constructor(z,K,F=null,B=1e3){this.protocol=z,this.ctx=K,this.logger=F,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger&&this.logger.logOutgoing(K,0,1,S(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(K,z.id,1,S(z.type),z.data);return}}}send(z,K=void 0){const F=new f;return a(F,z),a(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onRawMessage(z){const K=new v(z),F=o(K),B=o(K),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=new R.CancellationTokenSource;let B;try{B=K.call(this.ctx,z.name,z.arg,F.token)}catch(Z){B=Promise.reject(Z)}const V=z.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete(z.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete(z.id)});const Q=(0,I.toDisposable)(()=>F.cancel());this.activeRequests.set(z.id,Q)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=z.id,V=K.listen(this.ctx,z.name,z.arg)(Q=>this.sendResponse({id:F,data:Q,type:204}));this.activeRequests.set(z.id,V)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const F=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:F})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const F of K)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new w.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=K}getChannel(z){const K=this;return{call(F,B,V){return K.isDisposed?Promise.reject(C.canceled()):K.requestPromise(z,F,B,V)},listen(F,B){return K.isDisposed?Promise.reject(C.canceled()):K.requestEvent(z,F,B)}}}requestPromise(z,K,F,B=R.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:z,name:K,arg:F};if(B.isCancellationRequested)return Promise.reject(C.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(C.canceled());const ce=()=>{const be=Ce=>{switch(Ce.type){case 201:this.handlers.delete(V),re(Ce.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ce.data);break}};this.handlers.set(V,be),this.sendRequest(Z)};let le=null;this.state===m.Idle?ce():(le=(0,T.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const de=()=>{le?(le.cancel(),le=null):this.sendRequest({id:V,type:101}),ie(C.canceled())},fe=B.onCancellationRequested(de);G=(0,I.combinedDisposable)((0,I.toDisposable)(de),fe),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(z,K,F){const B=this.lastRequestId++,Q={id:B,type:102,channelName:z,name:K,arg:F};let Z=null;const G=new w.Emitter({onFirstListenerAdd:()=>{Z=(0,T.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(B,H),G.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const F=new f;return a(F,z),a(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onBuffer(z){const K=new v(z),F=o(K),B=o(K),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,S(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],0,S(V),B),this.onResponse({type:F[0],id:F[1],data:B})}}onResponse(z){if(z.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}he([D.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new w.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new w.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:F})=>{w.Event.once(K.onMessage)(V=>{const Q=new v(V),Z=o(Q),G=new u(K,Z),H=new b(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),F(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const F=this;return{call(B,V,Q){let Z;if((0,d.isFunction)(K)){let H=(0,k.getRandomElement)(F.connections.filter(K));Z=H?Promise.resolve(H):w.Event.toPromise(w.Event.filter(F.onDidAddConnection,K))}else Z=K.routeCall(F,B,V);const G=Z.then(H=>H.channelClient.getChannel(z));return O(G).call(B,V,Q)},listen(B,V){if((0,d.isFunction)(K))return F.getMulticastEvent(z,K,B,V);const Q=K.routeEvent(F,B,V).then(Z=>Z.channelClient.getChannel(z));return O(Q).listen(B,V)}}}getMulticastEvent(z,K,F,B){const V=this;let Q=new I.DisposableStore;const Z=new w.Emitter({onFirstListenerAdd:()=>{Q=new I.DisposableStore;const G=new w.EventMultiplexer,H=new Map,re=ce=>{const de=ce.channelClient.getChannel(z).listen(F,B),fe=G.add(de);H.set(ce,fe)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};V.connections.filter(K).forEach(re),w.Event.filter(V.onDidAddConnection,K)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(F=>{F.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class U{constructor(z,K,F=null){const B=new f;a(B,K),z.send(B.buffer),this.channelClient=new b(z,F),this.channelServer=new u(z,K,F)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function O(x){return{call(z,K,F){return x.then(B=>B.call(z,K,F))},listen(z,K){const F=new w.Relay;return x.then(B=>F.input=B.listen(z,K)),F.event}}}e.getDelayedChannel=O;function q(x){let z=!1;return{call(K,F,B){return z?x.call(K,F,B):(0,T.timeout)(0).then(()=>z=!0).then(()=>x.call(K,F,B))},listen(K,F){if(z)return x.listen(K,F);const B=new w.Relay;return(0,T.timeout)(0).then(()=>z=!0).then(()=>B.input=x.listen(K,F)),B.event}}}e.getNextTickChannel=q;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await w.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;var L;(function(x){function z(V,Q){const Z=V,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)F(re)&&H.set(re,w.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(B(ie)){const de=Z[ie];if(typeof de=="function")return de.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let de=0;de<ce.length;de++)ce[de]=(0,n.revive)(ce[de]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}x.fromService=z;function K(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:F(H)?V.listen(H):async function(...re){let ie;Q&&!(0,d.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await V.call(H,ie);return Z?ce:(0,n.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}x.toService=K;function F(V){return V[0]==="o"&&V[1]==="n"&&E.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&E.isUpperAsciiLetter(V.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let z=x.toString();if(z!=="[object Object]")return z}return x}function M(x){return Array.isArray(x)?x.map(_):_(x)}function j(x,z,K,F,B,V,Q){Q=M(Q);const Z=$[B],G=Z[F%Z.length];let H=[`%c[${x}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=j;class W{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,F,B,V){this._totalOutgoing+=z,j(this._outgoingPrefix,this._totalOutgoing,z,K,F,B,V)}logIncoming(z,K,F,B,V){this._totalIncoming+=z,j(this._incomingPrefix,this._totalIncoming,z,K,F,B,V)}}e.IPCLogger=W}),define(te[120],ne([0,1,19,3,34]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(w){this.port=w,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",I=>k.VSBuffer.wrap(I.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class D extends P.IPCClient{constructor(w,I){const n=new R(w);super(n,I);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=D}),define(te[72],ne([0,1,19,3,2,4,31,34]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var w;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function n(){return I||(I=k.VSBuffer.alloc(0)),I}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,a){if(t===0)return n();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const b=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=t),b}if(this._chunks[0].byteLength>t){const b=this._chunks[0].slice(0,t);return a&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),b}let o=k.VSBuffer.alloc(t),u=0,g=0;for(;t>0;){const b=this._chunks[g];if(b.byteLength>t){const A=b.slice(0,t);o.set(A,u),u+=t,a&&(this._chunks[g]=b.slice(t),this._totalLength-=t),t-=t}else o.set(b,u),u+=b.byteLength,a?(this._chunks.shift(),this._totalLength-=b.byteLength):g++,t-=b.byteLength}return o}}e.ChunkStream=E;var d;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(d||(d={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,a,o,u){this.type=t,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class y extends P.Disposable{constructor(t){super();this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(o,u,g,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=k.VSBuffer.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this._writeSoon(a,t.data)}_bufferAdd(t,a){const o=this._totalLength===0;return this._data.push(t,a),this._totalLength+=t.byteLength+a.byteLength,o}_bufferTake(){const t=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,a){this._bufferAdd(t,a)&&R.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends P.Disposable{constructor(t){super();this._onMessage=new T.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new y(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=m;class v extends C.IPCClient{constructor(t,a,o=null){super(t,a,o);this.protocol=t}static fromSocket(t,a){return new v(new m(t),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=v;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new T.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,D.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class c{constructor(t){this.data=t,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],a=0,o=this._first;for(;o;)t[a++]=o.data,o=o.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const a=new c(t);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class i{constructor(){this.lastRuns=[];const t=Date.now();for(let a=0;a<i._HISTORY_LENGTH;a++)this.lastRuns[a]=t-1e3*a;setInterval(()=>{for(let a=i._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return i._INSTANCE||(i._INSTANCE=new i),i._INSTANCE}load(){const t=Date.now(),a=(1+i._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<i._HISTORY_LENGTH;u++)t-this.lastRuns[u]<=a&&o++;return 1-o/i._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}i._HISTORY_LENGTH=10,i._INSTANCE=null;class s{constructor(t,a=null,o=i.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,P.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,n());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const a=new h(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,a){this._isReconnecting=!0,this._socketDisposables=(0,P.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new y(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let a=0,o=t.length;a<o;a++)this._socketWriter.write(t[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new h(6,0,0,n())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new h(1,a,this._incomingAckId,t);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(t){const a=new h(2,0,0,t);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),a=Date.now()-t.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,n());this._socketWriter.write(t)}}e.PersistentProtocol=s}),define(te[121],ne([0,1,73,3,34,120]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class D extends P.IPCServer{static getOnDidClientConnect(){const w=T.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(I,n)=>n);return T.Event.map(w,I=>{const{port1:n,port2:E}=new MessageChannel,p={protocol:new R.Protocol(n),onDidClientDisconnect:T.Event.fromDOMEventEmitter(n,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[E]),p})}constructor(){super(D.getOnDidClientConnect())}}e.Server=D}),define(te[122],ne([0,1,19,7]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function P(C,w){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const I=new XMLHttpRequest;return new Promise((n,E)=>{I.open(C.type||"GET",C.url||"",!0,C.user,C.password),R(I,C),I.responseType="arraybuffer",I.onerror=d=>E(new Error(I.statusText&&"XHR failed: "+I.statusText||"XHR failed")),I.onload=d=>{n({res:{statusCode:I.status,headers:D(I)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(I.response)))})},I.ontimeout=d=>E(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(I.timeout=C.timeout),I.send(C.data),w.onCancellationRequested(()=>{I.abort(),E((0,T.canceled)())})})}e.request=P;function R(C,w){if(w.headers){e:for(let I in w.headers){switch(I){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(I,w.headers[I])}}}function D(C){const w=Object.create(null);for(const I of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(I){const n=I.indexOf(":");w[I.substr(0,n).trim().toLowerCase()]=I.substr(n+1).trim()}return w}}),define(te[74],ne([0,1,5,3,2,17]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=e.StorageHint||(e.StorageHint={}));function C(E){const d=E;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var w;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(w||(w={}));class I extends P.Disposable{constructor(d,p=Object.create(null)){super();this.database=d,this.options=p,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=w.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((p,h)=>this.accept(h,p)),d.deleted?.forEach(p=>this.accept(p,void 0))}accept(d,p){if(this.state===w.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(p)?h=this.cache.delete(d):this.cache.get(d)!==p&&(this.cache.set(d,p),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===w.None&&(this.state=w.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,p){const h=this.cache.get(d);return(0,R.isUndefinedOrNull)(h)?p:h}getBoolean(d,p){const h=this.get(d);return(0,R.isUndefinedOrNull)(h)?p:h==="true"}getNumber(d,p){const h=this.get(d);return(0,R.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(d,p){if(this.state===w.Closed)return;if((0,R.isUndefinedOrNull)(p))return this.delete(d);const h=String(p);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===w.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=w.Closed;try{await this.doFlush(0)}catch(d){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((p,h)=>this.items.set(h,p)),d.delete&&d.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[123],ne([12,13]),function(X,e){return X.create("vs/base/common/date",e)}),define(te[58],ne([0,1,123]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,P=T*60,R=P*24,D=R*7,C=R*30,w=R*365;function I(E,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,k.localize)(0,null,I(new Date().getTime()+p*1e3,!1));if(p<30)return(0,k.localize)(1,null);let h;return p<T?(h=p,d?h===1?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):h===1?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h)):p<P?(h=Math.floor(p/T),d?h===1?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):h===1?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):p<R?(h=Math.floor(p/P),d?h===1?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):h===1?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h)):p<D?(h=Math.floor(p/R),d?h===1?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):h===1?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):p<C?(h=Math.floor(p/D),d?h===1?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):h===1?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h)):p<w?(h=Math.floor(p/C),d?h===1?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):h===1?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):(h=Math.floor(p/w),d?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h))}e.fromNow=I;function n(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[124],ne([12,13]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,17,124]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(I,n){return n&&(I.stack||I.stacktrace)?P.localize(0,null,C(I),D(I.stack)||D(I.stacktrace)):C(I)}function D(I){return Array.isArray(I)?I.join(`
`):I}function C(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?P.localize(1,null,I.message):I.message||P.localize(2,null)}function w(I=null,n=!1){if(!I)return P.localize(3,null);if(Array.isArray(I)){const E=k.coalesce(I),d=w(E[0],n);return E.length>1?P.localize(4,null,d,E.length):d}if(T.isString(I))return I;if(I.detail){const E=I.detail;if(E.error)return R(E.error,n);if(E.exception)return R(E.exception,n)}return I.stack?R(I,n):I.message?I.message:P.localize(5,null)}e.toErrorMessage=w}),define(te[125],ne([12,13]),function(X,e){return X.create("vs/base/node/processes",e)}),define(te[75],ne([0,1,43,42,15,26,9,4,31,103,17,112,20,125]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function h(i){switch(i){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(i,s){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const t=k.execFile("taskkill",["/T","/F","/PID",i.pid.toString()],r);return new Promise(a=>{t.once("error",o=>{a({success:!1,error:o})}),t.once("exit",(o,u)=>{a(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?h(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{k.execFile(r,[i.pid.toString()],{encoding:"utf8",shell:!0},(a,o,u)=>{t(a?{success:!1,error:a}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else i.kill("SIGKILL");return Promise.resolve({success:!0})}function S(i){!i||(delete i.DEBUG,C.isMacintosh&&delete i.DYLD_LIBRARY_PATH,C.isLinux&&delete i.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function m(i=w.env){return i.comspec||"cmd.exe"}e.getWindowsShell=m;class v{constructor(s,r,t,a){if(r!==void 0&&t!==void 0&&a!==void 0)this.cmd=s,this.args=r,this.shell=t,this.options=a;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(w.env).forEach(u=>{o[u]=w.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(D.sep);return r!==-1&&(s=s.substring(r+1)),v.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(w.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let t,a;const o=new Promise((u,g)=>{t=u,a=g});if(r){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=k.exec(u,this.options,(g,b,A)=>{this.childProcess=null;const U=g;U&&U.killed?a({killed:this.terminateRequested,stdout:b.toString(),stderr:A.toString()}):this.handleExec(t,s,g,b,A)})}else{let u=null;const g=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,t,s,a);const A={terminated:this.terminateRequested};n.isNumber(b)&&(A.cmdCode=b),t(A)};if(this.shell&&C.isWindows){const b=R.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let A=!1,U=!1;const O=[];let q=this.ensureQuotes(this.cmd);O.push(q.value),A=q.quoted,this.args&&this.args.forEach(L=>{q=this.ensureQuotes(L),O.push(q.value),U=U&&q.quoted});const N=["/s","/c"];A?U?N.push('"'+O.join(" ")+'"'):O.length>1?N.push('"'+O[0]+'" '+O.slice(1).join(" ")):N.push('"'+O[0]+'"'):N.push(O.join(" ")),u=k.spawn(m(),N,b)}else this.cmd&&(u=k.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(n.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",b=>{this.childProcess=null,a({terminated:this.terminateRequested,error:b})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,t,s,a,!0)))}return o})}handleClose(s,r,t,a){}ensureQuotes(s){return v.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,y(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const r=k.spawn(m(),["/s","/c"]);r.on("error",t=>s(!0)),r.on("exit",t=>s(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class f extends v{constructor(s,r,t,a){super(s,r,t,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,t,a,o){[a,o].forEach((u,g)=>{const b=new E.LineDecoder;b.write(u).forEach(O=>{r({line:O,source:g===0?0:1})});const U=b.end();U&&r({line:U,source:g===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,r,t,a,o){const u=new E.LineDecoder,g=new E.LineDecoder;s.stdout.on("data",b=>{u.write(b).forEach(U=>t({line:U,source:0}))}),s.stderr.on("data",b=>{g.write(b).forEach(U=>t({line:U,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(s,r,t,a){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=f;function c(i){let s=[],r=!1;const t=function(a){if(r){s.push(a);return}(!i.send(a,u=>{if(u&&console.error(u),r=!1,s.length>0){const g=s.slice(0);s=[],g.forEach(b=>t(b))}})||C.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(i){async function s(r,t,a){if(D.isAbsolute(r))return r;if(t===void 0&&(t=w.cwd()),D.dirname(r)!=="."||(a===void 0&&n.isString(w.env.PATH)&&(a=w.env.PATH.split(D.delimiter)),a===void 0||a.length===0))return D.join(t,r);async function u(g){if(await d.Promises.exists(g)){let b;try{b=await d.Promises.stat(g)}catch(A){A.message.startsWith("EACCES")&&(b=await d.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(let g of a){let b;if(D.isAbsolute(g)?b=D.join(g,r):b=D.join(t,g,r),await u(b))return b;let A=b+".com";if(await u(A)||(A=b+".exe",await u(A)))return A}return D.join(t,r)}i.findExecutable=s})(l=e.win32||(e.win32={}))}),define(te[126],ne([0,1,33,4,71,75]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function D(p,h){return p===1?T.isWindows?E():R.getWindowsShell(h):I(p,h)}e.getSystemShell=D;function C(p,h){return p===1?T.isWindows?d(h):R.getWindowsShell(h):I(p,h)}e.getSystemShellSync=C;let w=null;function I(p,h){if(T.isLinux&&p===2||T.isMacintosh&&p===3)return"/bin/bash";if(!w){let y;if(T.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,k.userInfo)().shell}catch(S){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}w=y}return w}let n=null;async function E(){return n||(n=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),n}function d(p){if(n)return n;const h=T.isWindows&&parseFloat((0,k.release)())>=10,y=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${p.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?S:R.getWindowsShell(p)}}),define(te[52],ne([0,1,43,5,19,28,107,7,3,2,26,75,34]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(S){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(v){}},onMessage:w.Event.fromNodeEventEmitter(process,"message",m=>P.VSBuffer.wrap(Buffer.from(m,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(S,m){this.modulePath=S,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new w.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new T.Delayer(v),this.child=null,this._client=null}getChannel(S){const m=this;return{call(v,f,c){return m.requestPromise(S,v,f,c)},listen(v,f){return m.requestEvent(S,v,f)}}}requestPromise(S,m,v,f=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(S),l=(0,T.createCancelablePromise)(r=>c.call(m,v,r)),i=f.onCancellationRequested(()=>l.cancel()),s=(0,I.toDisposable)(()=>l.cancel());return this.activeRequests.add(s),l.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(S,m,v){if(!this.disposeDelayer)return w.Event.None;this.disposeDelayer.cancel();let f;const c=new w.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(S).listen(m,v)(c.fire,c),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,S,m);const v=new w.Emitter;w.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,D.isRemoteConsoleLog)(t)){(0,D.log)(t,`IPC Library: ${this.options.serverName}`);return}v.fire(P.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),i=v.event,s={send:l,onMessage:i};this._client=new d.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,a)=>{process.removeListener("exit",r),this.activeRequests.forEach(o=>(0,I.dispose)(o)),this.activeRequests.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:a})})}return this._client}getCachedChannel(S){let m=this.channels.get(S);return m||(m=this.client.getChannel(S),this.channels.set(S,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[127],ne([12,13]),function(X,e){return X.create("vs/base/node/zip",e)}),define(te[128],ne([12,13]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[129],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(te[130],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(te[131],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/shellEnv",e)}),define(te[132],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[133],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[134],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[135],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[136],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[137],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[138],ne([12,13]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[139],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(te[140],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(te[141],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(te[142],ne([12,13]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[143],ne([12,13]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(te[144],ne([12,13]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[145],ne([12,13]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[146],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[147],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[148],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[149],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[150],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[151],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[152],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var T;(function(D){D.Team="team",D.Internal="internal",D.Insiders="insider",D.Public="public"})(T=e.TargetPopulation||(e.TargetPopulation={}));var P;(function(D){D.Market="X-MSEdge-Market",D.CorpNet="X-FD-Corpnet",D.ApplicationVersion="X-VSCode-AppVersion",D.Build="X-VSCode-Build",D.ClientId="X-MSEdge-ClientId",D.ExtensionName="X-VSCode-ExtensionName",D.Language="X-VSCode-Language",D.TargetPopulation="X-VSCode-TargetPopulation"})(P=e.Filters||(e.Filters={}));class R{constructor(C,w,I,n){this.version=C,this.appName=w,this.machineId=I,this.targetPopulation=n}getFilterValue(C){switch(C){case P.ApplicationVersion:return this.version;case P.Build:return this.appName;case P.ClientId:return this.machineId;case P.Language:return k.language;case P.ExtensionName:return"vscode-core";case P.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let C=new Map,w=Object.values(P);for(let I of w)C.set(I,this.getFilterValue(I));return C}}e.AssignmentFilterProvider=R}),define(te[76],ne([0,1,58,68,15,9,31,18,8]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(y,S,m){this._args=y,this.paths=S,this.productService=m}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",X).fsPath)}get userHome(){return w.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return w.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(w.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return w.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return w.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=D.env.VSCODE_PORTABLE;return y?w.URI.file((0,R.join)(y,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,R.resolve)(y):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,R.resolve)(y):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,R.resolve)(y);const S=D.env.VSCODE_EXTENSIONS;if(S)return S;const m=D.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(S=>/^[^:/?#]+?:\/\//.test(S)?w.URI.parse(S):w.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?w.URI.parse(y):w.URI.file((0,R.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return w.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([T.memoize],I.prototype,"appRoot",null),he([T.memoize],I.prototype,"userHome",null),he([T.memoize],I.prototype,"userDataPath",null),he([T.memoize],I.prototype,"appSettingsHome",null),he([T.memoize],I.prototype,"tmpDir",null),he([T.memoize],I.prototype,"userRoamingDataHome",null),he([T.memoize],I.prototype,"settingsResource",null),he([T.memoize],I.prototype,"userDataSyncHome",null),he([T.memoize],I.prototype,"userDataSyncLogResource",null),he([T.memoize],I.prototype,"sync",null),he([T.memoize],I.prototype,"machineSettingsResource",null),he([T.memoize],I.prototype,"globalStorageHome",null),he([T.memoize],I.prototype,"workspaceStorageHome",null),he([T.memoize],I.prototype,"keybindingsResource",null),he([T.memoize],I.prototype,"keyboardLayoutResource",null),he([T.memoize],I.prototype,"argvResource",null),he([T.memoize],I.prototype,"snippetsHome",null),he([T.memoize],I.prototype,"isExtensionDevelopment",null),he([T.memoize],I.prototype,"untitledWorkspacesHome",null),he([T.memoize],I.prototype,"installSourcePath",null),he([T.memoize],I.prototype,"builtinExtensionsPath",null),he([T.memoize],I.prototype,"extensionsPath",null),he([T.memoize],I.prototype,"extensionDevelopmentLocationURI",null),he([T.memoize],I.prototype,"extensionDevelopmentKind",null),he([T.memoize],I.prototype,"extensionTestsLocationURI",null),he([T.memoize],I.prototype,"debugExtensionHost",null),he([T.memoize],I.prototype,"serviceMachineIdResource",null),he([T.memoize],I.prototype,"telemetryLogResource",null),he([T.memoize],I.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=I;function n(h,y){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=n;function E(h,y){return p(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=E;function d(h,y){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=d;function p(h,y,S,m,v,f){const l=Number(y||h)||(m?null:S),i=l?Boolean(!!y):!1;let s;if(f)try{s=JSON.parse(f)}catch{}return{port:l,break:i,debugId:v,env:s}}}),define(te[153],ne([0,1,247,4,129]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,P.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(14,null)},category:{type:"string",cat:"e",description:(0,P.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,P.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,P.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,P.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,P.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,P.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,P.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,P.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,P.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,P.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(h,y,S=D){const m={},v=[],f=[];for(let s in y){const r=y[s];r.alias&&(m[s]=r.alias),r.type==="string"||r.type==="string[]"?(v.push(s),r.deprecates&&v.push(r.deprecates)):r.type==="boolean"&&(f.push(s),r.deprecates&&f.push(r.deprecates))}const c=k(h,{string:v,boolean:f,alias:m}),l={},i=c;l._=c._.map(s=>String(s)).filter(s=>s.length>0),delete i._;for(let s in y){const r=y[s];r.alias&&delete i[r.alias];let t=i[s];r.deprecates&&i.hasOwnProperty(r.deprecates)&&(t||(t=i[r.deprecates]),delete i[r.deprecates]),typeof t!="undefined"&&(r.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):r.type==="string"&&Array.isArray(t)&&(t=t.pop(),S.onMultipleValues(s,t)),l[s]=t),delete i[s]}for(let s in i)S.onUnknownOption(s);return l}e.parseArgs=C;function w(h,y){let S="";return y.args&&(Array.isArray(y.args)?S=` <${y.args.join("> <")}>`:S=` <${y.args}>`),y.alias?`-${y.alias} --${h}${S}`:`--${h}${S}`}function I(h,y){let S=0,m=[];for(const l in h){const i=h[l],s=w(l,i);S=Math.max(S,s.length),m.push([s,i.description])}let v=S+2+1;if(y-v<25)return m.reduce((l,i)=>l.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);let f=y-v-1,c=[];for(const l of m){let i=l[0],s=E(l[1],f),r=n(v-i.length-2);c.push("  "+i+r+s[0]);for(let t=1;t<s.length;t++)c.push(n(v)+s[t])}return c}e.formatOptions=I;function n(h){return" ".repeat(h)}function E(h,y){let S=[];for(;h.length;){let m=h.length<y?h.length:h.lastIndexOf(" ",y),v=h.slice(0,m).trim();h=h.slice(m),S.push(v)}return S}function d(h,y,S,m,v=!0){const f=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${S}`];c.push(""),c.push(`${(0,P.localize)(32,null)}: ${y} [${(0,P.localize)(33,null)}][${(0,P.localize)(34,null)}...]`),c.push(""),v&&(T.isWindows?c.push((0,P.localize)(35,null,y)):c.push((0,P.localize)(36,null,y)),c.push(""));const l={};for(const i in m){const s=m[i];if(s.description&&s.cat){let r=l[s.cat];r||(l[s.cat]=r={}),r[i]=s}}for(let i in l){const s=i;let r=l[s];r&&(c.push(R[s]),c.push(...I(r,f)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=d;function p(h,y){return`${h||(0,P.localize)(37,null)}
${y||(0,P.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function X(e,k,T,P){function R(C){const w=D(C),I=[w];return e.isAbsolute(w)||I.unshift(P),e.resolve(...I)}function D(C){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,T);const n=C["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(E,"AppData","Roaming")}break;case"darwin":I=e.join(k.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,T)}return{getUserDataPath:R}}if(typeof define=="function")define(te[154],ne([0,155,33,15,18,31]),function(e,k,T,P,R,D){const C=R.dirname(P.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(R.joinPath(C,"package.json").fsPath);return X(k,T,w.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),T=require("os");module.exports=X(k,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[156],ne([0,1,33,76,154]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends T.AbstractNativeEnvironmentService{constructor(C,w){super(C,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,P.getUserDataPath)(C)},w)}}e.NativeEnvironmentService=R}),define(te[157],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,P=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,D=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,w=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(S){const m=S.match(D);return m?m[1]:null}function n(S){if(S.indexOf("://")===-1){const m=S.match(T);return m?I(m[2]):null}try{const m=k.URI.parse(S);if(m.authority)return I(m.authority)}catch(m){}return null}function E(S,m){const v=new Set;let f;for(;f=C.exec(S);){const l=n(f[1]);l&&v.add(l)}const c=new Set(m);return Array.from(v).map(l=>c.has(l)?l:l.replace(w,"a"))}e.getDomainsOfRemotes=E;function d(S){const m=S.match(R);return m?m[2]:null}function p(S,m,v){return S&&m?(v&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${S}${m}`:`${S}/${m}`):null}function h(S,m){if(S.indexOf("://")===-1){const v=S.match(P);if(v)return p(v[2],v[3],m)}try{const v=k.URI.parse(S);if(v.authority)return p(d(v.authority),v.path,m)}catch(v){}return null}function y(S,m=!1){const v=[];let f;for(;f=C.exec(S);){const c=h(f[1],m);c&&v.push(c)}return v}e.getRemotes=y}),define(te[158],ne([0,1,26]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function P(R,D){const C=w=>{if(typeof w!="string")return;const I=T.exec(w);if(!I)return;const n=D[I[1]]??w;return typeof n=="string"?n:typeof n.message=="string"?n.message:w};return(0,k.cloneAndChange)(R,C)}e.localizeManifest=P}),define(te[159],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,D,C,w){return this.channel.call("promptImportantExtensionsInstallNotification",[R,D,C,w])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class T{constructor(R){this.service=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,C){switch(D){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${D}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(te[77],ne([0,1,138]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(d){return d=d.trim(),d==="*"||T.test(d)}e.isValidVersionStr=R;function D(d){if(!R(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=D;function C(d){if(!d)return null;let p=d.majorBase,h=d.majorMustEqual,y=d.minorBase,S=d.minorMustEqual,m=d.patchBase,v=d.patchMustEqual;d.hasCaret&&(p===0||(S=!1),v=!1);let f=0;if(d.preRelease){const c=P.exec(d.preRelease);if(c){const[,l,i,s]=c;f=Date.UTC(Number(l),Number(i)-1,Number(s))}}return{majorBase:p,majorMustEqual:h,minorBase:y,minorMustEqual:S,patchBase:m,patchMustEqual:v,isMinimum:d.hasGreaterEquals,notBefore:f}}e.normalizeVersion=C;function w(d,p,h){let y;typeof d=="string"?y=C(D(d)):y=d;let S;p instanceof Date?S=p.getTime():typeof p=="string"&&(S=new Date(p).getTime());let m;if(typeof h=="string"?m=C(D(h)):m=h,!y||!m)return!1;let v=y.majorBase,f=y.minorBase,c=y.patchBase,l=m.majorBase,i=m.minorBase,s=m.patchBase,r=m.notBefore,t=m.majorMustEqual,a=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?v>l?!0:v<l?!1:f>i?!0:f<i||S&&S<r?!1:c>=s:(v===1&&l===0&&(!t||!a||!o)&&(l=1,i=0,s=0,t=!0,a=!1,o=!1),v<l?!1:v>l?!t:f<i?!1:f>i?!a:c<s?!1:c>s?!o:!(S&&S<r))}e.isValidVersion=w;function I(d,p,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:E(d,p,h.engines.vscode,y)}e.isValidExtensionVersion=I;function n(d,p,h){return d==="*"||E(p,h,d)}e.isEngineValid=n;function E(d,p,h,y=[]){let S=C(D(h));if(!S)return y.push(k.localize(0,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return y.push(k.localize(1,null,h)),!1}else if(!S.majorMustEqual)return y.push(k.localize(2,null,h)),!1;return w(d,p,S)?!0:(y.push(k.localize(3,null,d,h)),!1)}}),define(te[53],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(P,R=[],D=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=k}),define(te[59],ne([0,1,53]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function P(D,C,w){C instanceof k.SyncDescriptor||(C=new k.SyncDescriptor(C,[],w)),T.push([D,C])}e.registerSingleton=P;function R(){return T}e.getSingletonServiceDescriptors=R}),define(te[160],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=k;class T{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let D of this._nodes.values())D.outgoing.size===0&&R.push(D);return R}insertEdge(R,D){const C=this.lookupOrInsertNode(R),w=this.lookupOrInsertNode(D);C.outgoing.set(this._hashFn(D),w),w.incoming.set(this._hashFn(R),C)}removeNode(R){const D=this._hashFn(R);this._nodes.delete(D);for(let C of this._nodes.values())C.outgoing.delete(D),C.incoming.delete(D)}lookupOrInsertNode(R){const D=this._hashFn(R);let C=this._nodes.get(D);return C||(C=new k(R),this._nodes.set(D,C)),C}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[D,C]of this._nodes)R.push(`${D}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,D]of this._nodes){const C=new Set([R]),w=this._findCycle(D,C);if(w)return w}}_findCycle(R,D){for(let[C,w]of R.outgoing){if(D.has(C))return[...D,C].join(" -> ");D.add(C);const I=this._findCycle(w,D);if(I)return I;D.delete(C)}}}e.Graph=T}),define(te[6],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function C(w){return w[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=C})(k=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function T(D,C,w,I){C[k.DI_TARGET]===C?C[k.DI_DEPENDENCIES].push({id:D,index:w,optional:I}):(C[k.DI_DEPENDENCIES]=[{id:D,index:w,optional:I}],C[k.DI_TARGET]=C)}function P(D){if(k.serviceIds.has(D))return k.serviceIds.get(D);const C=function(w,I,n){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(C,w,n,!1)};return C.toString=()=>D,k.serviceIds.set(D,C),C}e.createDecorator=P;function R(D){return D}e.refineServiceDecorator=R}),define(te[161],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[162],ne([0,1,4,25,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=k.userAgent||"";const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",k.isMacintosh),D.set("isLinux",k.isLinux),D.set("isWindows",k.isWindows),D.set("isWeb",k.isWeb),D.set("isMacNative",k.isMacintosh&&!k.isWeb),D.set("isEdge",R.indexOf("Edg/")>=0),D.set("isFirefox",R.indexOf("Firefox")>=0),D.set("isChrome",R.indexOf("Chrome")>=0),D.set("isSafari",R.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var w;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(w=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return d.INSTANCE}static true(){return p.INSTANCE}static has(L){return h.create(L)}static equals(L,$){return y.create(L,$)}static notEquals(L,$){return v.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return S.create(L,$)}static not(L){return f.create(L)}static and(...L){return u.create(L,null)}static or(...L){return g.create(L,null,!0)}static greater(L,$){return l.create(L,$)}static greaterEquals(L,$){return i.create(L,$)}static smaller(L,$){return s.create(L,$)}static smallerEquals(L,$){return r.create(L,$)}static deserialize(L,$=!1){if(!!L)return this._deserializeOrExpression(L,$)}static _deserializeOrExpression(L,$){let _=L.split("||");return g.create(_.map(M=>this._deserializeAndExpression(M,$)),null,!0)}static _deserializeAndExpression(L,$){let _=L.split("&&");return u.create(_.map(M=>this._deserializeOne(M,$)),null)}static _deserializeOne(L,$){if(L=L.trim(),L.indexOf("!=")>=0){let _=L.split("!=");return v.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("==")>=0){let _=L.split("==");return y.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("=~")>=0){let _=L.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],$))}if(L.indexOf(" in ")>=0){let _=L.split(" in ");return S.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const _=L.split(">=");return i.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const _=L.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const _=L.split("<=");return r.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const _=L.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(L)?f.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let _=/^'([^']*)'$/.exec(L);return _?_[1].trim():L}static _deserializeRegexValue(L,$){if((0,T.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=L.indexOf("/"),M=L.lastIndexOf("/");if(_===M||_<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let j=L.slice(_+1,M),W=L[M+1]==="i"?"i":"";try{return new RegExp(j,W)}catch(x){if($)throw new Error(`bad regexp-value '${L}', parse error: ${x}`);return console.warn(`bad regexp-value '${L}', parse error: ${x}`),null}}}e.ContextKeyExpr=I;function n(N,L){const $=N?N.substituteConstants():void 0,_=L?L.substituteConstants():void 0;return!$&&!_?!0:!$||!_?!1:$.equals(_)}e.expressionsAreEqualWithConstantSubstitution=n;function E(N,L){return N.cmp(L)}class d{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(L,$){this.key=L,this.negated=$,this.type=2}static create(L,$=null){const _=D.get(L);return typeof _=="boolean"?_?p.INSTANCE:d.INSTANCE:new h(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=D.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:d.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=4}static create(L,$,_=null){if(typeof $=="boolean")return $?h.create(L,_):f.create(L,_);const M=D.get(L);return typeof M=="boolean"?$===(M?"true":"false")?p.INSTANCE:d.INSTANCE:new y(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=D.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?p.INSTANCE:d.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class S{constructor(L,$){this.key=L,this.valueKey=$,this.type=10,this.negated=null}static create(L,$){return new S(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.valueKey),_=L.getValue(this.key);return Array.isArray($)?$.indexOf(_)>=0:typeof _=="string"&&typeof $=="object"&&$!==null?C.call($,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=S;class m{constructor(L){this._actual=L,this.type=11}static create(L){return new m(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new m(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class v{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=5}static create(L,$,_=null){if(typeof $=="boolean")return $?f.create(L,_):h.create(L,_);const M=D.get(L);return typeof M=="boolean"?$===(M?"true":"false")?d.INSTANCE:p.INSTANCE:new v(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=D.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?d.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class f{constructor(L,$){this.key=L,this.negated=$,this.type=3}static create(L,$=null){const _=D.get(L);return typeof _=="boolean"?_?d.INSTANCE:p.INSTANCE:new f(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=D.get(this.key);return typeof L=="boolean"?L?d.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=f;function c(N,L){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?L(N):d.INSTANCE}class l{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=12}static create(L,$,_=null){return c($,M=>new l(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class i{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=13}static create(L,$,_=null){return c($,M=>new i(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=i;class s{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=14}static create(L,$,_=null){return c($,M=>new s(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=15}static create(L,$,_=null){return c($,M=>new r(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:U(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(L,$){this.key=L,this.regexp=$,this.type=7,this.negated=null}static create(L,$){return new t(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return $<_?-1:$>_?1:0}equals(L){if(L.type===this.type){const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return this.key===L.key&&$===_}return!1}substituteConstants(){return this}evaluate(L){let $=L.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=a.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class a{constructor(L){this._actual=L,this.type=8}static create(L){return new a(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new a(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;function o(N){let L=null;for(let $=0,_=N.length;$<_;$++){const M=N[$].substituteConstants();if(N[$]!==M&&L===null){L=[];for(let j=0;j<$;j++)L[j]=N[j]}L!==null&&(L[$]=M)}return L===null?N:L}class u{constructor(L,$){this.expr=L,this.negated=$,this.type=6}static create(L,$){return u._normalizeArr(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=E(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static _normalizeArr(L,$){const _=[];let M=!1;for(const j of L)if(!!j){if(j.type===1){M=!0;continue}if(j.type===0)return d.INSTANCE;if(j.type===6){_.push(...j.expr);continue}_.push(j)}if(_.length===0&&M)return p.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(E);for(let j=1;j<_.length;j++)_[j-1].equals(_[j])&&(_.splice(j,1),j--);if(_.length===1)return _[0];for(;_.length>1;){const j=_[_.length-1];if(j.type!==9)break;_.pop();const W=_.pop(),x=_.length===0,z=g.create(j.expr.map(K=>u.create([K,W],null)),null,x);z&&(_.push(z),_.sort(E))}return _.length===1?_[0]:new u(_,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new u(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){const L=[];for(let $ of this.expr)L.push($.negate());this.negated=g.create(L,this,!0)}return this.negated}}class g{constructor(L,$){this.expr=L,this.negated=$,this.type=9}static create(L,$,_){return g._normalizeArr(L,$,_)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=E(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:g.create(L,this.negated,!1)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(this.expr[$].evaluate(L))return!0;return!1}static _normalizeArr(L,$,_){let M=[],j=!1;if(L){for(let W=0,x=L.length;W<x;W++){const z=L[W];if(!!z){if(z.type===0){j=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){M=M.concat(z.expr);continue}M.push(z)}}if(M.length===0&&j)return d.INSTANCE;M.sort(E)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(_){for(let W=0;W<M.length;W++)for(let x=W+1;x<M.length;x++)O(M[W],M[x])&&(M.splice(x,1),x--);if(M.length===1)return M[0]}return new g(M,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new g(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){let L=[];for(let $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),_=L.shift(),M=[];for(const W of q($))for(const x of q(_))M.push(u.create([W,x],null));const j=L.length===0;L.unshift(g.create(M,null,j))}this.negated=L[0]}return this.negated}}class b extends h{constructor(L,$,_){super(L,null);this._defaultValue=$,typeof _=="object"?b._info.push({..._,key:L}):_!==!0&&b._info.push({key:L,description:_,type:$!=null?typeof $:void 0})}static all(){return b._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return y.create(this.key,L)}notEqualsTo(L){return v.create(this.key,L)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function A(N,L){return N<L?-1:N>L?1:0}function U(N,L,$,_){return N<$?-1:N>$?1:L<_?-1:L>_?1:0}function O(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const M of L.expr)if(N.equals(M))return!0}const $=N.negate(),_=q($).concat(q(L));_.sort(E);for(let M=0;M<_.length;M++){const W=_[M].negate();for(let x=M+1;x<_.length;x++){const z=_[x];if(W.equals(z))return!0}}return!1}e.implies=O;function q(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function T(P){return!!P.hostName&&!!P.errorMessage}e.isRemoteDiagnosticError=T}),define(te[79],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,133,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var R;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function C(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function w(f,c){switch(f){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=w;function I(f,c){return c==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=I;function n(f,c,l){return I(c,l)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===l?!0:E(l).includes(f)}e.isTargetPlatformCompatible=n;function E(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function d(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=d;var p;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(f){f.Install="install",f.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var S;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(X,e){return function(k,T){e(k,T,X)}};define(te[163],ne([0,1,2,30]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let P=class extends k.Disposable{constructor(D){super();this.extensionManagementService=D,this._register(D),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};P=he([J(0,T.IExtensionManagementService)],P),e.DeprecatedExtensionsCleaner=P}),define(te[164],ne([0,1,3,2,26,8,111,30]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function w(y,S){return R.URI.revive(S?S.transformIncoming(y):y)}function I(y,S){return S?S.transformOutgoingURI(y):y}function n(y,S){S=S||D.DefaultURITransformer;const m=y.manifest;return{...(0,D.transformAndReviveIncomingURIs)({...y,manifest:void 0},S),manifest:m}}function E(y,S){return S?(0,P.cloneAndChange)(y,m=>m instanceof R.URI?S.transformOutgoingURI(m):void 0):y}class d{constructor(S,m){this.service=S,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(S.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(S.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(S.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(S.onDidUninstallExtension,!0)}listen(S,m){const v=this.getUriTransformer(S);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,f=>f.map(c=>({...c,local:c.local?E(c.local,v):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(S,m,v){const f=this.getUriTransformer(S);switch(m){case"zip":return this.service.zip(n(v[0],f)).then(c=>I(c,f));case"unzip":return this.service.unzip(w(v[0],f));case"install":return this.service.install(w(v[0],f),v[1]);case"getManifest":return this.service.getManifest(w(v[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(n(v[0],f),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(v[0],f));case"getInstalled":return this.service.getInstalled(v[0]).then(c=>c.map(l=>E(l,f)));case"updateMetadata":return this.service.updateMetadata(n(v[0],f),v[1]).then(c=>E(c,f));case"updateExtensionScope":return this.service.updateExtensionScope(n(v[0],f),v[1]).then(c=>E(c,f));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends T.Disposable{constructor(S){super();this.channel=S,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?R.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(v=>({...v,local:v.local?n(v.local,null):v.local,source:this.isUriComponents(v.source)?R.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(S){const m=await this.getTargetPlatform();return S.allTargetPlatforms.some(v=>(0,C.isTargetPlatformCompatible)(v,S.allTargetPlatforms,m))}zip(S){return Promise.resolve(this.channel.call("zip",[S]).then(m=>R.URI.revive(m)))}unzip(S){return Promise.resolve(this.channel.call("unzip",[S]))}install(S,m){return Promise.resolve(this.channel.call("install",[S,m])).then(v=>n(v,null))}getManifest(S){return Promise.resolve(this.channel.call("getManifest",[S]))}installFromGallery(S,m){return Promise.resolve(this.channel.call("installFromGallery",[S,m])).then(v=>n(v,null))}uninstall(S,m){return Promise.resolve(this.channel.call("uninstall",[S,m]))}reinstallFromGallery(S){return Promise.resolve(this.channel.call("reinstallFromGallery",[S]))}getInstalled(S=null){return Promise.resolve(this.channel.call("getInstalled",[S])).then(m=>m.map(v=>n(v,null)))}updateMetadata(S,m){return Promise.resolve(this.channel.call("updateMetadata",[S,m])).then(v=>n(v,null))}updateExtensionScope(S,m){return Promise.resolve(this.channel.call("updateExtensionScope",[S,m])).then(v=>n(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(S){this.service=S}listen(S,m){throw new Error("Invalid listen")}call(S,m,v){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(D){D[D.FILE=1]="FILE",D[D.WORKSPACE=2]="WORKSPACE",D[D.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function P(D){switch(D){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=P;var R;(function(D){D.Ignored="ignored",D.Cancelled="cancelled",D.TooMany="toomany",D.IncompatibleWindow="incompatibleWindow",D.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,k.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,41,9,25,17,8,140,6]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function I(_){return _.create===!0}e.isFileOpenForWriteOptions=I;var n;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var E;(function(_){_[_.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function S(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=S;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(M,j){super(M);this.code=j}}e.FileSystemProviderError=v;function f(_,M){const j=new v(_.toString(),M);return l(j,M),j}e.createFileSystemProviderError=f;function c(_){return _||f((0,C.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function l(_,M){return _.name=M?`${M} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function i(_){if(!_)return m.Unknown;if(_ instanceof v)return _.code;const M=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=i;function s(_){if(_ instanceof g)return _.fileOperationResult;switch(i(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(M,j,W){this.resource=M,this.operation=j,this.target=W}isOperation(M){return this.operation===M}}e.FileOperationEvent=t;var a;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor(M,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;const W=new Map;for(const x of M){const z=W.get(x.type);z?z.push([x.resource,x]):W.set(x.type,[[x.resource,x]])}for(const[x,z]of W)switch(x){case 1:this.added=k.TernarySearchTree.forUris(()=>j),this.added.fill(z);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>j),this.updated.fill(z);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>j),this.deleted.fill(z);break}}contains(M,...j){return this.doContains(M,{includeChildren:!1},...j)}affects(M,...j){return this.doContains(M,{includeChildren:!0},...j)}doContains(M,j,...W){if(!M)return!1;const x=W.length>0;return!!((!x||W.includes(1))&&(this.added?.get(M)||j.includeChildren&&this.added?.findSuperstr(M))||(!x||W.includes(0))&&(this.updated?.get(M)||j.includeChildren&&this.updated?.findSuperstr(M))||(!x||W.includes(2))&&(this.deleted?.findSubstr(M)||j.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(_,M,j){return!_||!M||_===M||M.length>_.length?!1:(M.charAt(M.length-1)!==T.sep&&(M+=T.sep),j?(0,P.startsWithIgnoreCase)(_,M):_.indexOf(M)===0)}e.isParent=u;class g extends Error{constructor(M,j,W){super(M);this.fileOperationResult=j,this.options=W}}e.FileOperationError=g;class b extends g{constructor(M,j,W){super(M,2,W);this.stat=j}}e.NotModifiedSinceFileOperationError=b;var A;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=O;async function q(_,M){if(!M.hasProvider(D.URI.from({scheme:_.scheme})))return new Promise(j=>{const W=M.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===_.scheme&&x.added&&(W.dispose(),j())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(M){return(0,R.isNumber)(M)||(M=0),M<N.KB?(0,C.localize)(1,null,M.toFixed(0)):M<N.MB?(0,C.localize)(2,null,(M/N.KB).toFixed(2)):M<N.GB?(0,C.localize)(3,null,(M/N.MB).toFixed(2)):M<N.TB?(0,C.localize)(4,null,(M/N.GB).toFixed(2)):(0,C.localize)(5,null,(M/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var L;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function $(_){return{maxFileSize:_===0?300*N.MB:16*N.GB,maxHeapSize:_===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(te[165],ne([0,1,82,50,14]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(C){this.fileService=C}async checksum(C){const w=(await this.fileService.readFileStream(C)).value;return new Promise((I,n)=>{const E=(0,k.createHash)("md5");(0,T.listenStream)(w,{onData:d=>E.update(d.buffer),onError:d=>n(d),onEnd:()=>I(E.digest("base64").replace(/=+$/,""))})})}};R=he([J(0,P.IFileService)],R),e.ChecksumService=R}),define(te[166],ne([0,1,248,130,153,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function D(d,p){const h={onUnknownOption:S=>{console.warn((0,T.localize)(0,null,S))},onMultipleValues:(S,m)=>{console.warn((0,T.localize)(1,null,S,m))}},y=(0,P.parseArgs)(d,P.OPTIONS,p?h:void 0);return y.goto&&y._.forEach(S=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,T.localize)(2,null))),y["max-memory"]&&k(parseInt(y["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function C(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function w(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=C(p)||[]);const h=!E(process.env);return D(p,h)}e.parseMainProcessArgv=w;function I(d){const[,,...p]=d;return D(p,!0)}e.parseCLIProcessArgv=I;function n(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.addArg=n;function E(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[167],ne([0,1,43,9,131,28,38,7,4,29,126,166,5]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function y(m,v,f){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(f)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(c,l)=>{const i=new R.CancellationTokenSource,s=setTimeout(()=>{i.dispose(!0),l(new Error((0,P.localize)(0,null)))},p);try{c(await S(m,i.token))}catch(r){!(0,C.isPromiseCanceledError)(r)&&!i.token.isCancellationRequested?l(new Error((0,P.localize)(1,null,(0,D.toErrorMessage)(r)))):c({})}finally{clearTimeout(s),i.dispose()}})),h)}e.resolveShellEnv=y;async function S(m,v){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const l=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const r=await(0,n.getSystemShell)(w.OS,s);return m.trace("getUnixShellEnvironment#shell",r),new Promise((t,a)=>{if(v.isCancellationRequested)return a((0,C.canceled)());const o=(0,T.basename)(r);let u,g;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${b} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(u=`'${process.execPath}' ${b} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,o==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),u);const A=(0,k.spawn)(r,[...g,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(A.kill(),a((0,C.canceled)()))),A.on("error",q=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(q)),a(q)});const U=[];A.stdout.on("data",q=>U.push(q));const O=[];A.stderr.on("data",q=>O.push(q)),A.on("close",(q,N)=>{const L=Buffer.concat(U).toString("utf8");m.trace("getUnixShellEnvironment#raw",L);const $=Buffer.concat(O).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),q||N)return a(new Error((0,P.localize)(2,null,q,N)));const _=i.exec(L),M=_?_[1]:"{}";try{const j=JSON.parse(M);f?j.ELECTRON_RUN_AS_NODE=f:delete j.ELECTRON_RUN_AS_NODE,c?j.ELECTRON_NO_ATTACH_CONSOLE=c:delete j.ELECTRON_NO_ATTACH_CONSOLE,delete j.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",j),t(j)}catch(j){m.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(j)),a(j)}})})}}),define(te[83],ne([0,1,19,7,141,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(n,E,d,p,h,y){let S;try{await C(n,E,d,p,h,y)}catch(m){S=m}finally{S&&h.errorTransformer&&(S=h.errorTransformer(S)),typeof S!="undefined"&&d.error(S),d.end()}}e.readFileIntoStream=D;async function C(n,E,d,p,h,y){w(y);const S=await n.open(E,{create:!1});try{w(y);let m=0,v=0,f=h&&typeof h.length=="number"?h.length:void 0,c=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,i=0;do v=await n.read(S,l,c.buffer,i,c.byteLength-i),l+=v,i+=v,m+=v,typeof f=="number"&&(f-=v),i===c.byteLength&&(await d.write(p(c)),c=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof f=="number"?f:h.bufferSize)),i=0);while(v>0&&(typeof f!="number"||f>0)&&w(y)&&I(m,h));if(i>0){let s=i;typeof f=="number"&&(s=Math.min(i,f)),d.write(p(c.slice(0,s)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await n.close(S)}}function w(n){if(n.isCancellationRequested)throw(0,T.canceled)();return!0}function I(n,E){if(E?.limits){if(typeof E.limits.memory=="number"&&n>E.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&n>E.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,8,14]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class D extends k.Disposable{constructor(d,p,h){super();this.onFileChanges=d,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const d=new k.DisposableStore;this.serviceDisposables.value=d,this.service=this.createService(d),this.service.setVerboseLogging(this.verboseLogging),d.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),d.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),d.add(this.service.onDidError(p=>this.onError(p)))}onError(d){this.restartCounter<D.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${d}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${d}`)}restart(d){this.restartCounter++,this.init(),this.watch(d)}async watch(d){this.requests=d,await this.service?.watch(d)}async setVerboseLogging(d){this.verboseLogging=d,await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=D,D.MAX_RESTARTS=5;class C extends k.Disposable{}e.WatcherService=C;function w(E){return E.map(d=>({type:d.type,resource:P.URI.file(d.path)}))}e.toFileChanges=w;function I(E){const d=new n;for(const p of E)d.processEvent(p);return d.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(d){return T.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const p=this.mapPathToChange.get(this.toKey(d));let h=!1;if(p){const y=p.type,S=d.type;p.path!==d.path&&d.type===2?h=!0:y===1&&S===2?(this.mapPathToChange.delete(this.toKey(d)),this.normalized.delete(p)):y===2&&S===1?p.type=0:y===1&&S===0||(p.type=S)}else h=!0;h&&(this.normalized.add(d),this.mapPathToChange.set(this.toKey(d),d))}normalize(){const d=[],p=[];return Array.from(this.normalized).filter(h=>h.type!==2?(d.push(h),!1):!0).sort((h,y)=>h.path.length-y.path.length).filter(h=>p.some(y=>(0,R.isParent)(h.path,y,!T.isLinux))?!1:(p.push(h.path),!0)).concat(d)}}}),define(te[168],ne([0,1,5,2,9,116,20,119,54]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends T.Disposable{constructor(E,d,p,h){super();this.path=E,this.onDidFilesChange=d,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new k.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:d}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(d)try{p=await(0,R.realpath)(p)}catch(h){if(this.onError(h),d.dangling)return}E.isDirectory()?this._register((0,C.watchFolder)(p,(h,y)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,P.join)(this.path,(0,P.basename)(y))})},h=>this.onError(h))):this._register((0,C.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,w.normalizeFileChanges)(d);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I}),define(te[169],ne([0,1,15,34,52,54]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D extends R.WatcherService{constructor(w,I,n){super();this.onDidFilesChange=w,this.onLogMessage=I,this.verboseLogging=n,this.isDisposed=!1,this.startWatching()}startWatching(){const w=this._register(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=T.ProxyChannel.toService((0,T.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(I=>!this.isDisposed&&this.onDidFilesChange(I))),this._register(this.service.onDidLogMessage(I=>this.onLogMessage(I)))}async setVerboseLogging(w){this.verboseLogging=w,this.isDisposed||await this.service?.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}async watch(w){this.isDisposed||await this.service?.watch(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=D}),define(te[170],ne([0,1,15,34,52,54]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D extends R.AbstractWatcherService{constructor(w,I,n){super(w,I,n);this.init()}createService(w){const I=w.add(new P.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(I.onDidProcessExit(({code:n,signal:E})=>this.onError(`terminated by itself with code ${n}, signal: ${E}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(I.getChannel("watcher")))}}e.FileWatcher=D}),define(te[84],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...P){this._entries=new Map;for(let[R,D]of P)this.set(R,D)}set(P,R){const D=this._entries.get(P);return this._entries.set(P,R),D}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=k}),define(te[171],ne([0,1,5,7,53,160,6,84]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class I extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new C.ServiceCollection,y=!1,S){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...y){let S=d.traceInvocation(h),m=!1;try{return h({get:f=>{if(m)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(f,S);if(!c)throw new Error(`[invokeFunction] unknown service '${f}'`);return c}},...y)}finally{m=!0,S.stop()}}createInstance(h,...y){let S,m;return h instanceof P.SyncDescriptor?(S=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(y),S)):(S=d.traceCreation(h),m=this._createInstance(h,y,S)),S.stop(),m}_createInstance(h,y=[],S){let m=D._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),v=[];for(const c of m){let l=this._getOrCreateServiceInstance(c.id,S);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);v.push(l)}let f=m.length>0?m[0].index:y.length;if(y.length!==f){console.warn(`[createInstance] First service dependency of ${h.name} at position ${f+1} conflicts with ${y.length} static arguments`);let c=f-y.length;c>0?y=y.concat(new Array(c)):y=y.slice(0,f)}return new h(...[...y,...v])}_setServiceInstance(h,y){if(this._services.get(h)instanceof P.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let S=this._getServiceInstanceOrDescriptor(h);return S instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,S,y.branch(h,!0)):(y.branch(h,!1),S)}_safeCreateAndCacheServiceInstance(h,y,S){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,S)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,S){const m=new R.Graph(c=>c.id.toString());let v=0;const f=[{id:h,desc:y,_trace:S}];for(;f.length;){const c=f.pop();if(m.lookupOrInsertNode(c),v++>1e3)throw new I(m);for(let l of D._util.getServiceDependencies(c.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(l.id);if(!i&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),i instanceof P.SyncDescriptor){const s={id:l.id,desc:i,_trace:c._trace.branch(l.id,!0)};m.insertEdge(c,s),f.push(s)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof P.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,S=[],m,v){if(this._services.get(h)instanceof P.SyncDescriptor)return this._createServiceInstance(y,S,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,S,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],S,m){if(S){const v=new k.IdleValue(()=>this._createInstance(h,y,m));return new Proxy(Object.create(null),{get(f,c){if(c in f)return f[c];let l=v.value,i=l[c];return typeof i!="function"||(i=i.bind(l),f[c]=i),i},set(f,c,l){return v.value[c]=l,!0}})}else return this._createInstance(h,y,m)}}e.InstantiationService=n;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class d{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return w?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return w?new d(0,h.name):d._None}branch(h,y){let S=new d(2,h.toString());return this._dep.push([h,y,S]),S}stop(){let h=Date.now()-this._start;d._totals+=h;let y=!1;function S(v,f){let c=[],l=new Array(v+1).join("	");for(const[i,s,r]of f._dep)if(s&&r){y=!0,c.push(`${l}CREATES -> ${i}`);let t=S(v+1,r);t&&c.push(t)}else c.push(`${l}uses -> ${i}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(te[172],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(P,R){this.server=P,this.router=R}getChannel(P){return this.server.getChannel(P,this.router)}registerChannel(P,R){this.server.registerChannel(P,R)}}e.MessagePortMainProcessService=k}),define(te[173],ne([0,1,34,53,59,6]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class D{constructor(p,h,y){const S=y.getChannel(p);return C(h)?new h.channelClientCtor(S):k.ProxyChannel.toService(S,h?.proxyOptions)}}function C(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let w=class extends D{constructor(p,h,y){super(p,h,y)}};w=he([J(2,e.IMainProcessService)],w);function I(d,p,h){(0,P.registerSingleton)(d,new T.SyncDescriptor(w,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let n=class extends D{constructor(p,h,y){super(p,h,y)}};n=he([J(2,e.ISharedProcessService)],n);function E(d,p,h){(0,P.registerSingleton)(d,new T.SyncDescriptor(n,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[60],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function T(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}e.isValidLocalization=T}),define(te[174],ne([0,1,2,60]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let P=class extends k.Disposable{constructor(D){super();this.localizationsService=D,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};P=he([J(0,T.ILocalizationsService)],P),e.LocalizationsUpdater=P}),define(te[10],ne([0,1,38,3,2,4,6]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function C(){return new Date().toISOString()}var w;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;function I(s,r,t){switch(r){case w.Trace:s.trace(t);break;case w.Debug:s.debug(t);break;case w.Info:s.info(t);break;case w.Warning:s.warn(t);break;case w.Error:s.error(t);break;case w.Critical:s.critical(t);break;default:throw new Error("Invalid log level")}}e.log=I;function n(s){let r="";for(let t=0;t<s.length;t++){let a=s[t];if(typeof a=="object")try{a=JSON.stringify(a)}catch(o){}r+=(t>0?" ":"")+a}return r}e.format=n;class E extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class d extends E{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(w.Trace)&&this.log(w.Trace,n([r,...t]))}debug(r,...t){this.checkLogLevel(w.Debug)&&this.log(w.Debug,n([r,...t]))}info(r,...t){this.checkLogLevel(w.Info)&&this.log(w.Info,n([r,...t]))}warn(r,...t){this.checkLogLevel(w.Warning)&&this.log(w.Warning,n([r,...t]))}error(r,...t){if(this.checkLogLevel(w.Error))if(r instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=r.stack,this.log(w.Error,n(a))}else this.log(w.Error,n([r,...t]))}critical(r,...t){this.checkLogLevel(w.Critical)&&this.log(w.Critical,n([r,...t]))}flush(){}}e.AbstractMessageLogger=d;class p extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!R.isWindows}trace(r,...t){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}debug(r,...t){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}info(r,...t){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,r,...t):console.log(`[main ${C()}]`,r,...t))}warn(r,...t){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,r,...t):console.warn(`[main ${C()}]`,r,...t))}error(r,...t){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,r,...t):console.error(`[main ${C()}]`,r,...t))}critical(r,...t){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,r,...t):console.error(`[main ${C()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends E{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,k.toErrorMessage)(r,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class S extends E{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const a of this.logServices)a.trace(r,...t)}debug(r,...t){for(const a of this.logServices)a.debug(r,...t)}info(r,...t){for(const a of this.logServices)a.info(r,...t)}warn(r,...t){for(const a of this.logServices)a.warn(r,...t)}error(r,...t){for(const a of this.logServices)a.error(r,...t)}critical(r,...t){for(const a of this.logServices)a.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=S;class m extends P.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=m;class v extends P.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(a))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let a=this.loggers.get(r.toString());return a||(a=this.doCreateLogger(r,t?.always?w.Trace:this.logLevel,t),this.loggers.set(r.toString(),a),t?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class f{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(r){}getLevel(){return w.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=f;function c(s){if(s.verbose)return w.Trace;if(typeof s.logLevel=="string"){const r=l(s.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(s){switch(s){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=l;function i(s){switch(s){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=i}),define(te[175],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends P.Disposable{constructor(E,d){super();this.environmentService=E,this.logService=d,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,R.basename)(this.environmentService.logsPath),d=(0,R.dirname)(this.environmentService.logsPath),y=(await D.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),S=y.slice(0,Math.max(0,y.length-9));S.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${S.join(", ")}'`),await Promise.all(S.map(m=>D.Promises.rm((0,R.join)(d,m)))))}catch(E){(0,T.onUnexpectedError)(E)}}};I=he([J(0,C.IEnvironmentService),J(1,w.ILogService)],I),e.LogsDataCleaner=I}),define(te[176],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class Et extends P.Disposable{constructor(E,d,p){super();this.backupWorkspacesPath=E,this.environmentService=d,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await D.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await D.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length!==Et.NON_EMPTY_WORKSPACE_ID_LENGTH&&p.indexOf(y)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${y}.`),await D.Promises.rm((0,R.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(E){(0,T.onUnexpectedError)(E)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I=he([J(1,C.INativeEnvironmentService),J(2,w.ILogService)],I),e.StorageDataCleaner=I}),define(te[85],ne([0,1,5,19,32,40,11,14,6,10]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var n;(function(d){d.ERROR_INVALID_FILE="ERROR_INVALID_FILE",d.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(n=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,w.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(p,h,y){this.environmentService=p,this.fileService=h,this.logService=y,this.queue=new k.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:y,mtime:S,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let v=y.toString();const f=[];if((0,P.parse)(v,f,{allowTrailingComma:!0,allowEmptyContent:!0}),f.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(p,v,h)[0];if(c){v=v.substring(0,c.offset)+c.content+v.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(v),{etag:m,mtime:S})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},y,S){return h.length?(0,R.setProperty)(y,h,p,S):[{content:JSON.stringify(p,null,S.insertSpaces&&S.tabSize?" ".repeat(S.tabSize):"	"),length:y.length,offset:0}]}};E=he([J(0,D.IEnvironmentService),J(1,C.IFileService),J(2,I.ILogService)],E),e.UserConfigurationFileService=E}),define(te[177],ne([0,1,43,5,38,3,2,15,9,20,11,10]),function(X,e,k,T,P,R,D,C,w,I,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new T.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${S}`)))),I.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(h,y){const S=`vscode:${y}`;if(h.location.scheme===C.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[S]=="string"){const m=h.manifest.scripts[S].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${S} should be a node script`),null):{script:(0,w.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,y,S,m,v){return new Promise((f,c)=>{const l=this.start(h,y,S,v);let i;const s=r=>{i&&(clearTimeout(i),i=null),r?c(r):f(void 0)};l.on("error",r=>{s((0,P.toErrorMessage)(r)||"Unknown")}),l.on("exit",(r,t)=>{s(r?`post-${y} process exited with code ${r}`:void 0)}),m&&(i=setTimeout(()=>{i=null,l.kill(),c("timed out")},5e3))})}start(h,y,S,m){const v={silent:!0,execArgv:void 0},f=(0,k.fork)(h,[`--type=extension-post-${y}`,...S],v);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const c=R.Event.fromNodeEventEmitter(f.stdout,"data"),l=R.Event.fromNodeEventEmitter(f.stderr,"data");c(r=>this.logService.info(m.identifier.id,m.manifest.version,`post-${y}`,r)),l(r=>this.logService.error(m.identifier.id,m.manifest.version,`post-${y}`,r));const i=R.Event.any(R.Event.map(c,r=>({data:`%c${r}`,format:[""]})),R.Event.map(l,r=>({data:`%c${r}`,format:["color: red"]})));return R.Event.debounce(i,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100)(r=>{console.group(m.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),f}getExtensionStoragePath(h){return(0,w.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=he([J(0,n.IEnvironmentService),J(1,E.ILogService)],d),e.ExtensionsLifecycle=d}),define(te[178],ne([0,1,7,2,81,3,43,15,113,4,10,59,26,31]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let h=class extends T.Disposable{constructor(m,v){super();this.id=m,this._logService=v,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null}register(m){this._register(m)}start(m){this._process=(0,D.fork)(C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,d.mixin)({cwd:(0,p.cwd)()},m));const v=this._process.pid;this._logService.info(`Starting extension host with pid ${v}.`);const f=new w.StringDecoder("utf-8");this._process.stdout?.on("data",l=>{const i=typeof l=="string"?l:f.write(l);this._onStdout.fire(i)});const c=new w.StringDecoder("utf-8");return this._process.stderr?.on("data",l=>{const i=typeof l=="string"?l:c.write(l);this._onStderr.fire(i)}),this._process.on("message",l=>{this._onMessage.fire(l)}),this._process.on("error",l=>{this._onError.fire({error:(0,k.transformErrorForSerialization)(l)})}),this._process.on("exit",(l,i)=>{this._onExit.fire({pid:v,code:l,signal:i})}),{pid:v}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):I.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};h=he([J(1,n.ILogService)],h);let y=class bt{constructor(m){this._logService=m,this._extHosts=new Map}dispose(){}_getExtHost(m){const v=this._extHosts.get(m);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(m){return this._getExtHost(m).onStdout}onDynamicStderr(m){return this._getExtHost(m).onStderr}onDynamicMessage(m){return this._getExtHost(m).onMessage}onDynamicError(m){return this._getExtHost(m).onError}onDynamicExit(m){return this._getExtHost(m).onExit}async createExtensionHost(){const m=String(++bt._lastId),v=new h(m,this._logService);return this._extHosts.set(m,v),v.onExit(({pid:f,code:c,signal:l})=>{this._logService.info(`Extension host with pid ${f} exited with code: ${c}, signal: ${l}.`),setTimeout(()=>{v.dispose(),this._extHosts.delete(m)})}),{id:m}}async start(m,v){return this._getExtHost(m).start(v)}async enableInspectPort(m){const v=this._extHosts.get(m);return v?v.enableInspectPort():!1}async kill(m){const v=this._extHosts.get(m);!v||v.kill()}};y._lastId=0,y=he([J(0,n.ILogService)],y),e.ExtensionHostStarter=y,(0,E.registerSingleton)(P.IExtensionHostStarter,y,!0)}),define(te[179],ne([0,1,16,5,7,3,2,9,54,10]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class n extends D.Disposable{constructor(d){super();this.logService=d,this._onDidErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(d,p){return p.recursive?this.watchRecursive(d,p):this.watchNonRecursive(d)}watchRecursive(d,p){const h={path:this.toFilePath(d),excludes:p.excludes},y=(0,k.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,w.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,p){return d.watch(p)}watchNonRecursive(d){const p=this.createNonRecursiveWatcher(this.toFilePath(d),y=>this._onDidChangeFile.fire((0,w.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===I.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)});return(0,D.combinedDisposable)(p,h)}onWatcherLogMessage(d){d.type==="error"&&this._onDidErrorOccur.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,C.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=n}),define(te[180],ne([0,1,16,5,19,28,3,56,2,41,15,181,18,50,139,14,83,10]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class Ke extends w.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new y.FileChangesEvent(l,!0)))),this.watchedResources=I.TernarySearchTree.forUris(l=>{const i=this.getProvider(l.scheme);return i?!this.isPathCaseSensitive(i):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const i=new w.DisposableStore;return i.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),i.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&i.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,w.dispose)(i)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(i){l.push(i)}}),!this.provider.has(c)&&await T.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const i=this.provider.get(c.scheme);return!!(i&&i.capabilities&l)}listCapabilities(){return C.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const i=new Error;throw i.name="ENOPRO",i.message=(0,h.localize)(1,null,c.toString()),i}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l)||(0,y.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(i){throw(0,y.toFileSystemProviderErrorCode)(i)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,y.ensureFileSystemProviderError)(i)}}async doResolveFile(c,l){const i=await this.withProvider(c),s=this.isPathCaseSensitive(i),r=l?.resolveTo,t=l?.resolveSingleChildDescendants,a=l?.resolveMetadata,o=await i.stat(c);let u;return this.toFileStat(i,c,o,void 0,!!a,(g,b)=>(u||(u=I.TernarySearchTree.forUris(()=>!s),u.set(c,!0),r&&u.fill(!0,r)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&t?b===1:!1))}async toFileStat(c,l,i,s,r,t){const{providerExtUri:a}=this.getExtUri(c),o={resource:l,name:a.basename(l),isFile:(i.type&y.FileType.File)!=0,isDirectory:(i.type&y.FileType.Directory)!=0,isSymbolicLink:(i.type&y.FileType.SymbolicLink)!=0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&y.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,y.etag)({mtime:i.mtime,size:i.size})};if(o.isDirectory&&t(o,s)){try{const u=await c.readdir(l),g=await T.Promises.settled(u.map(async([b,A])=>{try{const U=a.joinPath(l,b),O=r?await c.stat(U):{type:A};return await this.toFileStat(c,U,O,u.length,r,t)}catch(U){return this.logService.trace(U),null}}));o.children=(0,k.coalesce)(g)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(c){return T.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(i){return this.logService.trace(i),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(i){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(i){return i}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=P.VSBuffer.fromString(""),i){await this.doValidateCreateFile(c,i);const s=await this.writeFile(c,l);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,s)),s}async writeFile(c,l,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,c,i)||await this.mkdirp(s,r.dirname(c));let a;if((0,y.hasReadWriteCapability)(s)&&!(l instanceof P.VSBuffer))if((0,p.isReadableStream)(l)){const o=await(0,p.peekStream)(l,3);o.ended?a=P.VSBuffer.concat(o.buffer):a=o}else a=(0,p.peekReadable)(l,o=>P.VSBuffer.concat(o),3);else a=l;!(0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasReadWriteCapability)(s)&&a instanceof P.VSBuffer?await this.doWriteUnbuffered(s,c,i,a):await this.doWriteBuffered(s,c,i,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a)}catch(t){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),i)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,i){if(!!i?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let r;try{r=await c.stat(l)}catch(t){return}if((r.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,i);if(this.throwIfFileIsReadonly(l,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,y.etag)({mtime:i.mtime,size:r.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,i);return r}async readFile(c,l){const i=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(i,c,l):this.doReadFile(i,c,l)}async doReadFileAtomic(c,l,i){return new Promise((s,r)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,i);s(t)}catch(t){r(t)}})})}async doReadFile(c,l,i){const s=await this.doReadFileStream(c,l,{...i,preferUnbuffered:!0});return{...s,value:await(0,P.streamToBuffer)(s.value)}}async readFileStream(c,l){const i=await this.withReadProvider(c);return this.doReadFileStream(i,c,l)}async doReadFileStream(c,l,i){const s=new R.CancellationTokenSource,r=this.validateReadFile(l,i).then(a=>a,a=>{throw s.cancel(),a});let t;try{return typeof i?.etag=="string"&&i.etag!==y.ETAG_DISABLED&&await r,!((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasFileReadStreamCapability)(c))||(0,y.hasReadWriteCapability)(c)&&i?.preferUnbuffered?t=this.readFileUnbuffered(c,l,i):(0,y.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,s.token,i):t=this.readFileBuffered(c,l,s.token,i),{...await r,value:t}}catch(a){t&&await(0,p.consumeStream)(t);const o=(0,h.localize)(8,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(a).toString());throw a instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(o,a.stat,i):new y.FileOperationError(o,(0,y.toFileOperationResult)(a),i)}}readFileStreamed(c,l,i,s=Object.create(null)){const r=c.readFileStream(l,s,i);return(0,p.transform)(r,{data:t=>t instanceof P.VSBuffer?t:P.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),s)},t=>P.VSBuffer.concat(t))}readFileBuffered(c,l,i,s=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,S.readFileIntoStream)(c,l,r,t=>t,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),s)},i),r}readFileUnbuffered(c,l,i){const s=(0,p.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r=await c.readFile(l);typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.validateReadFileLimits(l,r.byteLength,i),s.end(P.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(c,l){const i=await this.resolve(c,{resolveMetadata:!0});if(i.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==y.ETAG_DISABLED&&l.etag===i.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),i,l);return this.validateReadFileLimits(c,i.size,l),i}validateReadFileLimits(c,l,i){if(i?.limits){let s;if(typeof i.limits.memory=="number"&&l>i.limits.memory&&(s=9),typeof i.limits.size=="number"&&l>i.limits.size&&(s=7),typeof s=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,l,i){return this.doCanMoveCopy(c,l,"move",i)}async canCopy(c,l,i){return this.doCanMoveCopy(c,l,"copy",i)}async doCanMoveCopy(c,l,i,s){if(c.toString()!==l.toString())try{const r=i==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(r,c,t,l,i,s)}catch(r){return r}return!0}async move(c,l,i){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,r,l,"move",!!i),a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="move"?2:3,a)),a}async copy(c,l,i){const s=await this.withReadProvider(c),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,r,l,"copy",!!i),a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="copy"?3:2,a)),a}async doMoveCopy(c,l,i,s,r,t){if(l.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,l,i,s,r,t);if(a&&!o&&t&&await this.del(s,{recursive:!0}),await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(s)),r==="copy"){if(c===i&&(0,y.hasFileFolderCopyCapability)(c))await c.copy(l,s,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,i,s):await this.doCopyFile(c,l,i,s)}return r}else return c===i?(await c.rename(l,s,{overwrite:t}),r):(await this.doMoveCopy(c,l,i,s,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,i,s){if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(i))return this.doPipeBuffered(c,l,i,s);if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasReadWriteCapability)(i))return this.doPipeBufferedToUnbuffered(c,l,i,s);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(i))return this.doPipeUnbufferedToBuffered(c,l,i,s);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasReadWriteCapability)(i))return this.doPipeUnbuffered(c,l,i,s)}async doCopyFolder(c,l,i,s){await i.mkdir(s),Array.isArray(l.children)&&await T.Promises.settled(l.children.map(async r=>{const t=this.getExtUri(i).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(c,await this.resolve(r.resource),i,t):this.doCopyFile(c,r.resource,i,t)}))}async doValidateMoveCopy(c,l,i,s,r,t){let a=!1;if(c===i){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(c);if(g||(a=u.isEqual(l,s)),a&&r==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!t)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(c===i){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,s))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const i=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,i)),i}async mkdirp(c,l){const i=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(l,s.dirname(l));)try{if(((await c.stat(l)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(s.basename(l)),l=s.dirname(l)}for(let r=i.length-1;r>=0;r--){l=s.joinPath(l,i[r]);try{await c.mkdir(l)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(i){return i}return!0}async doValidateDelete(c,l){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(i.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let r;try{r=await i.stat(c)}catch(a){}if(r)this.throwIfFileIsReadonly(c,r);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const a=await this.resolve(c);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return i}async del(c,l){const i=await this.doValidateDelete(c,l),s=!!l?.useTrash,r=!!l?.recursive;await i.delete(c,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let i,s;{for(const r of c)this.watchedResources.has(r.resource)?(i||(i=[]),i.push(r)):(s||(s=[]),s.push(r));i&&this._onDidFilesChange.fire(new y.FileChangesEvent(i,!l))}if(s){const r=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const i=new w.DisposableStore;let s=!1,r=()=>{s=!0};return i.add((0,w.toDisposable)(()=>r())),this.doWatch(c,l).then(t=>{s?(0,w.dispose)(t):r=()=>(0,w.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),i.add((0,w.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),i}async doWatch(c,l){const i=await this.withProvider(c),s=this.toWatchKey(i,c,l);let r=this.activeWatchers.get(s);return r||(r={count:0,disposable:i.watch(c,l)},this.activeWatchers.set(s,r)),r.count+=1,(0,w.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,w.dispose)(r.disposable),this.activeWatchers.delete(s)))})}toWatchKey(c,l,i){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(l),String(i.recursive),i.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,w.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,i,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const r=await c.open(l,{create:!0,unlock:i?.unlock??!1});try{(0,p.isReadableStream)(s)||(0,p.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,r,s):await this.doWriteReadableBufferedQueued(c,r,s)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await c.close(r)}})}async doWriteStreamBufferedQueued(c,l,i){let s=0,r;if((0,p.isReadableBufferedStream)(i)){if(i.buffer.length>0){const t=P.VSBuffer.concat(i.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,s,0),s+=t.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((t,a)=>{(0,p.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(c,l,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,i){let s=0,r;for(;(r=i.read())!==null;)await this.doWriteBuffer(c,l,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(c,l,i,s,r,t){let a=0;for(;a<s;)a+=await c.write(l,r+a,i.buffer,t+a,s-a)}async doWriteUnbuffered(c,l,i,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,i,s))}async doWriteUnbufferedQueued(c,l,i,s){let r;s instanceof P.VSBuffer?r=s:(0,p.isReadableStream)(s)?r=await(0,P.streamToBuffer)(s):(0,p.isReadableBufferedStream)(s)?r=await(0,P.bufferedStreamToBuffer)(s):r=(0,P.readableToBuffer)(s),await c.writeFile(l,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async doPipeBuffered(c,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,i,s))}async doPipeBufferedQueued(c,l,i,s){let r,t;try{r=await c.open(l,{create:!1}),t=await i.open(s,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,g=0;do g=await c.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(i,t,a,g,o,u),o+=g,u+=g,u===a.byteLength&&(u=0);while(g>0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await T.Promises.settled([typeof r=="number"?c.close(r):Promise.resolve(),typeof t=="number"?i.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,i,s))}async doPipeUnbufferedQueued(c,l,i,s){return i.writeFile(s,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,i,s){return this.writeQueue.queueFor(s,this.getExtUri(i).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,i,s))}async doPipeUnbufferedToBufferedQueued(c,l,i,s){const r=await i.open(s,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(i,r,P.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await i.close(r)}}async doPipeBufferedToUnbuffered(c,l,i,s){const r=await(0,P.streamToBuffer)(this.readFileBuffered(c,l,R.CancellationToken.None));await this.doWriteUnbuffered(i,s,void 0,r)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===n.Schemas.file?c.fsPath:c.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([J(0,m.ILogService)],v),e.FileService=v}),define(te[182],ne([0,1,51,249,5,19,3,42,9,4,18,50,20,142,14,83,168,169,170,179,38]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(k)}catch(i){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(i)}`)}})();class l extends f.AbstractDiskFileSystemProvider{constructor(s,r){super(s);this.options=r,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,I.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:r,symbolicLink:t}=await d.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(r,t),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(s){try{const r=await d.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),t=[];return await Promise.all(r.map(async a=>{try{let o;a.isSymbolicLink()?o=(await this.stat((0,n.joinPath)(s,a.name))).type:o=this.toType(a),t.push([a.name,o])}catch(o){this.logService.trace(o)}})),t}catch(r){throw this.toFileSystemProviderError(r)}}toType(s,r){let t;return r?.dangling?t=h.FileType.Unknown:s.isFile()?t=h.FileType.File:s.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,r&&(t|=h.FileType.SymbolicLink),t}async readFile(s){try{const r=this.toFilePath(s);return await d.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(s,r,t){const a=(0,E.newWriteableStream)(o=>R.VSBuffer.concat(o.map(u=>R.VSBuffer.wrap(u))).buffer);return(0,y.readFileIntoStream)(this,s,a,o=>o.buffer,{...r,bufferSize:256*1024},t),a}async writeFile(s,r,t){let a;try{const o=this.toFilePath(s);if(!t.create||!t.overwrite){if(await d.Promises.exists(o)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:t.unlock}),await this.write(a,0,r,0,r.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(s,o)}finally{typeof a=="number"&&await this.close(a)}}async open(s,r){try{const t=this.toFilePath(s);if((0,h.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:u}=await d.SymlinkSupport.stat(t);u.mode&128||await d.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let a;if((0,h.isFileOpenForWriteOptions)(r)){if(I.isWindows)try{await d.Promises.truncate(t,0),a="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}a||(a="w")}else a="r";const o=await d.Promises.open(t,a);return this.mapHandleToPos.set(o,0),(0,h.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(o,s),o}catch(t){throw(0,h.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(s,t):this.toFileSystemProviderError(t)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await d.Promises.fdatasync(s)}catch(r){this.canFlush=!1,this.logService.error(r)}return await d.Promises.close(s)}catch(r){throw this.toFileSystemProviderError(r)}}async read(s,r,t,a,o){const u=this.normalizePos(s,r);let g=null;try{const b=await d.Promises.read(s,t,a,o,u);return typeof b=="number"?g=b:g=b.bytesRead,g}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(s,u,g)}}normalizePos(s,r){return r===this.mapHandleToPos.get(s)?null:r}updatePos(s,r,t){const a=this.mapHandleToPos.get(s);typeof a=="number"&&(typeof r=="number"||(typeof t=="number"?this.mapHandleToPos.set(s,a+t):this.mapHandleToPos.delete(s)))}async write(s,r,t,a,o){return(0,P.retry)(()=>this.doWrite(s,r,t,a,o),100,3)}async doWrite(s,r,t,a,o){const u=this.normalizePos(s,r);let g=null;try{const b=await d.Promises.write(s,t,a,o,u);return typeof b=="number"?g=b:g=b.bytesWritten,g}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),b)}finally{this.updatePos(s,u,g)}}async mkdir(s){try{await d.Promises.mkdir(this.toFilePath(s))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(s,r){try{const t=this.toFilePath(s);await this.doDelete(t,r)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(s,r){r.recursive?await d.Promises.rm(s,d.RimRafMode.MOVE):await d.Promises.unlink(s)}async rename(s,r,t){const a=this.toFilePath(s),o=this.toFilePath(r);if(a!==o)try{await this.validateTargetDeleted(s,r,"move",t.overwrite),await d.Promises.move(a,o)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,w.basename)(a),(0,w.basename)((0,w.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,r,t){const a=this.toFilePath(s),o=this.toFilePath(r);if(a!==o)try{await this.validateTargetDeleted(s,r,"copy",t.overwrite),await d.Promises.copy(a,o,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,w.basename)(a),(0,w.basename)((0,w.dirname)(o)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,r,t,a){const o=this.toFilePath(s),u=this.toFilePath(r);let g=!1;if(!!(this.capabilities&1024)||(g=(0,C.isEqual)(o,u,!0)),g&&t==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await d.Promises.exists(u)){if(!a)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,r,t){let a,o=!1;return this.options?.watcher?.usePolling?o=!1:o=this.options?.legacyWatcher==="on",o?a=m.FileWatcher:a=v.FileWatcher,new a(u=>s(u),u=>r(u),t,this.options?.watcher)}doWatch(s,r){const t=this.options?.watcher?.usePolling;if(t===!0)for(const a of r)a.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const a of r)t.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,r)}createNonRecursiveWatcher(s,r,t,a){return new S.FileWatcher(s,o=>r(o),o=>t(o),a)}toFileSystemProviderError(s){if(s instanceof h.FileSystemProviderError)return s;let r;switch(s.code){case"ENOENT":r=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=h.FileSystemProviderErrorCode.NoPermissions;break;default:r=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(s,r)}async toFileSystemProviderWriteError(s,r){let t=this.toFileSystemProviderError(r);if(s&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await d.SymlinkSupport.stat(this.toFilePath(s));a.mode&128||(t=(0,h.createFileSystemProviderError)(r,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return t}}e.DiskFileSystemProvider=l}),define(te[86],ne([0,1,3,8,10]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(d){this.service=d,this.onDidChangeLogLevel=k.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=R;class D{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){D.setLevel(this.channel,d)}static setLevel(d,p){return d.call("setLevel",p)}}e.LogLevelChannelClient=D;class C{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,p){throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"createLogger":this.createLogger(T.URI.revive(h[0]),h[1]);return;case"log":return this.log(T.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(d,p){this.loggers.set(d.toString(),this.loggerService.createLogger(d,p))}consoleLog(d,p){let h=console.log;switch(d){case P.LogLevel.Error:h=console.error;break;case P.LogLevel.Warning:h=console.warn;break;case P.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(d,p){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,S]of p)(0,P.log)(h,y,S)}}e.LoggerChannel=C;class w extends P.AbstractLoggerService{constructor(d,p,h){super(d,p);this.channel=h}createConsoleMainLogger(){return new P.AdapterLogger({log:(d,p)=>{this.channel.call("consoleLog",[d,p])}})}doCreateLogger(d,p,h){return new I(this.channel,d,p,h)}}e.LoggerChannelClient=w;class I extends P.AbstractMessageLogger{constructor(d,p,h,y){super(y?.always);this.channel=d,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,p){const h=[[d,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class n extends P.LogService{constructor(d,p){super(p);this.parent=d,this._register(d.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=n}),define(te[61],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[87],ne([0,1,15,4,31,18]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const C=T.globals.vscode.context.configuration();if(C)D=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const C=(0,R.dirname)(k.FileAccess.asFileUri("",X));D=X.__$__nodeRequire((0,R.joinPath)(C,"product.json").fsPath);const w=X.__$__nodeRequire((0,R.joinPath)(C,"package.json").fsPath);P.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`}),Object.assign(D,{version:w.version})}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=D}),define(te[27],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService")}),define(te[183],ne([0,1,5,7,2,9,20,10,27]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends P.Disposable{constructor(E,d,p){super();this.productService=d,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),p=(0,R.dirname)(E),h=(0,R.basename)(E),y=await D.Promises.readdir(p);await Promise.all(y.map(async S=>{if(S===h)return;const m=(0,R.join)(p,S),v=await D.Promises.stat(m);if(v.isDirectory()&&d-v.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${S}.`),D.Promises.rm(m)}))}catch(d){(0,T.onUnexpectedError)(d)}}};I=he([J(1,w.IProductService),J(2,C.ILogService)],I),e.CodeCacheCleaner=I}),define(te[184],ne([0,1,5,7,2,9,20,11,10,27]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends P.Disposable{constructor(d,p,h){super();this.environmentService=d,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),p=JSON.parse(await D.Promises.readFile((0,R.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(p)){const f=p[v];d[`${f.hash}.${v}`]=!0}const h=(0,R.join)(this.environmentService.userDataPath,"clp");if(!await D.Promises.exists(h))return;const S=await D.Promises.readdir(h);for(const v of S){if(d[v]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await D.Promises.rm((0,R.join)(h,v))}const m=Date.now();for(const v of Object.keys(d)){const f=(0,R.join)(h,v),c=await D.Promises.readdir(f);for(const l of c){if(l==="tcf.json")continue;const i=(0,R.join)(f,l),s=await D.Promises.stat(i);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,R.join)(v,l)}`),await D.Promises.rm(i))}}}catch(d){(0,T.onUnexpectedError)(d)}}};n=he([J(0,C.INativeEnvironmentService),J(1,w.ILogService),J(2,I.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[35],ne([0,1,101,17]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(D,C){k.ok(T.isString(D)),k.ok(T.isObject(C)),k.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,C)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new P}),define(te[88],ne([0,1,3,35]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class R{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,I){this.schemasById[P(w)]=I,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new R;T.Registry.add(e.Extensions.JSONContribution,D)}),define(te[39],ne([0,1,16,3,17,128,88,35]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=C.Registry.as(D.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,c=!0){this.registerConfigurations([f],c)}registerConfigurations(f,c=!0){const l=this.doRegisterConfigurations(f,c);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(f){const c=this.doDeregisterConfigurations(f);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:f,remove:c}){const l=[];l.push(...this.doDeregisterConfigurations(c)),l.push(...this.doRegisterConfigurations(f,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,k.distinct)(l))}registerDefaultConfigurations(f){const c=[],l=[];for(const i of f)for(const s in i)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...i[s]};const r={type:"object",default:this.defaultValues[s],description:R.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};l.push(p(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=i[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(f){const c=[];for(const l of f)for(const i in l)if(c.push(i),delete this.defaultValues[i],e.OVERRIDE_PROPERTY_PATTERN.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const c of f)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(f,c){const l=[];return f.forEach(i=>{l.push(...this.validateAndRegisterProperties(i,c,i.extensionInfo)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),l}doDeregisterConfigurations(f){const c=[],l=i=>{if(i.properties)for(const s in i.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,i.properties[s]);i.allOf&&i.allOf.forEach(s=>l(s))};for(const i of f){l(i);const s=this.configurationContributors.indexOf(i);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(f,c=!0,l,i=3){i=P.isUndefinedOrNull(f.scope)?i:f.scope;let s=[],r=f.properties;if(r)for(let a in r){if(c&&S(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=P.isUndefinedOrNull(o.scope)?i:o.scope,o.restricted=P.isUndefinedOrNull(o.restricted)?!!l?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let t=f.allOf;if(t)for(let a of t)s.push(...this.validateAndRegisterProperties(a,c,l,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const c=l=>{let i=l.properties;if(i)for(const r in i)this.updateSchema(r,i[r]);let s=l.allOf;s&&s.forEach(c)};c(f)}updateSchema(f,c){switch(e.allSettings.properties[f]=c,c.scope){case 1:e.applicationSettings.properties[f]=c;break;case 2:e.machineSettings.properties[f]=c;break;case 6:e.machineOverridableSettings.properties[f]=c;break;case 3:e.windowSettings.properties[f]=c;break;case 4:e.resourceSettings.properties[f]=c;break;case 5:e.resourceSettings.properties[f]=c,this.resourceLanguageSettingsSchema.properties[f]=c;break}}removeFromSchema(f,c){switch(delete e.allSettings.properties[f],c.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const c=`[${f}]`,l={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,l),e.allSettings.properties[c]=l,e.applicationSettings.properties[c]=l,e.machineSettings.properties[c]=l,e.machineOverridableSettings.properties[c]=l,e.windowSettings.properties[c]=l,e.resourceSettings.properties[c]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,c){let l=this.defaultValues[f];P.isUndefined(l)&&(l=c.default),P.isUndefined(l)&&(l=h(c.type)),c.default=l}}const d="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(d);function p(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=p;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const y=new E;C.Registry.add(e.Extensions.Configuration,y);function S(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?R.localize(5,null,v):y.getConfigurationProperties()[v]!==void 0?R.localize(6,null,v):null:R.localize(4,null)}e.validateProperty=S;function m(){const v=[],f=y.getConfigurationProperties();for(const c of Object.keys(f))v.push([c,f[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=m}),define(te[21],ne([0,1,26,17,8,39,6,35]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function w(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof P.URI)}e.isConfigurationOverrides=w;var I;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function E(s,r){const t=r?s?r.keys.filter(U=>s.keys.indexOf(U)===-1):[...r.keys]:[],a=s?r?s.keys.filter(U=>r.keys.indexOf(U)===-1):[...s.keys]:[],o=[];if(r&&s){for(const U of s.keys)if(r.keys.indexOf(U)!==-1){const O=m(s.contents,U),q=m(r.contents,U);k.equals(O,q)||o.push(U)}}const u=[],g=U=>{const O={};for(const q of U)for(const N of q.identifiers)O[l(N)]=q;return O},b=r?g(r.overrides):{},A=s?g(s.overrides):{};if(Object.keys(b).length)for(const U of t){const O=b[U];O&&u.push([(0,R.overrideIdentifierFromKey)(U),O.keys])}if(Object.keys(A).length)for(const U of a){const O=A[U];O&&u.push([(0,R.overrideIdentifierFromKey)(U),O.keys])}if(Object.keys(b).length&&Object.keys(A).length)for(const U of o){const O=A[U],q=b[U];if(O&&q){const N=E({contents:O.contents,keys:O.keys,overrides:[]},{contents:q.contents,keys:q.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(U),[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:a,updated:o,overrides:u}}e.compare=E;function d(s,r){const t=[];for(const a of Object.keys(s))if(R.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];t.push({identifiers:[(0,R.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:p(o,r)})}return t}e.toOverrides=d;function p(s,r){const t=Object.create(null);for(let a in s)h(t,a,s[a],r);return t}e.toValuesTree=p;function h(s,r,t,a){const o=r.split("."),u=o.pop();let g=s;for(let b=0;b<o.length;b++){let A=o[b],U=g[A];switch(typeof U){case"undefined":U=g[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,b+1).join(".")} is ${JSON.stringify(U)}`);return}g=U}if(typeof g=="object"&&g!==null)try{g[u]=t}catch(b){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(g)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function y(s,r){const t=r.split(".");S(s,t)}e.removeFromValueTree=y;function S(s,r){const t=r.shift();if(r.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const a=s[t];typeof a=="object"&&!Array.isArray(a)&&(S(a,r),Object.keys(a).length===0&&delete s[t])}}function m(s,r,t){function a(g,b){let A=g;for(const U of b){if(typeof A!="object"||A===null)return;A=A[U]}return A}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?t:u}e.getConfigurationValue=m;function v(s,r,t){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?T.isObject(s[a])&&T.isObject(r[a])?v(s[a],r[a],t):t&&(s[a]=r[a]):s[a]=r[a])})}e.merge=v;function f(){const s=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=f;function c(){const s=Object.create(null),r=C.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let t in r){let a=r[t].default;h(s,t,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=c;function l(s){return`[${s}]`}e.keyFromOverrideIdentifier=l;function i(s,r,t){const a=s.inspect(r),o=s.inspect(t);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=i}),define(te[89],ne([0,1,16,3,32,2,41,26,17,8,21,39,35]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(i={},s=[],r=[]){this._contents=i,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,n.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const r=this.getContentsForOverrideIdentifer(s);return r?i?(0,n.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){let s=this.overrideConfigurations.get(i);return s||(s=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,s)),s}merge(...i){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),t=[...this.keys];for(const a of i){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(g=>k.equals(g.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(C.deepClone(o))}for(const o of a.keys)t.indexOf(o)===-1&&t.push(o)}return new p(s,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const t of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[t],o=s[t];o&&(typeof a=="object"&&typeof o=="object"?(a=C.deepClone(a),this.mergeContents(a,o)):a=o),r[t]=a}return new p(r,this.keys,this.overrides)}mergeContents(i,s){for(const r of Object.keys(s)){if(r in i&&w.isObject(i[r])&&w.isObject(s[r])){this.mergeContents(i[r],s[r]);continue}i[r]=C.deepClone(s[r])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?C.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,n.addToValueTree)(this.contents,i,s,r=>{throw new Error(r)})}removeValue(i){this.removeKey(i)&&(0,n.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let r=0;r<s;r++)i.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const i=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const t of Object.keys(i))E.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(i[t]),contents:(0,n.toValuesTree)(i[t],a=>console.error(`Conflict in default settings file: ${a}`))});super(i,s,r)}}e.DefaultConfigurationModel=h;class y{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!w.isUndefinedOrNull(i)){const r=this.doParseContent(i);this.parseRaw(r,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:r,keys:t,overrides:a,restricted:o}=this.doParseRaw(i,s);this._configurationModel=new p(r,t,a),this._restrictedConfigurations=o||[]}doParseContent(i){let s={},r=null,t=[],a=[],o=[];function u(b){Array.isArray(t)?t.push(b):r!==null&&(t[r]=b)}let g={onObjectBegin:()=>{let b={};u(b),a.push(t),t=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{let b=[];u(b),a.push(t),t=b,r=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:u,onError:(b,A,U)=>{o.push({error:b,offset:A,length:U})}};if(i)try{P.visit(i,g),s=t[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return s}doParseRaw(i,s){const r=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),t=this.filter(i,r,!0,s);i=t.raw;const a=(0,n.toValuesTree)(i,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),o=Object.keys(i),u=(0,n.toOverrides)(i,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:a,keys:o,overrides:u,restricted:t.restricted}}filter(i,s,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:i,restricted:[]};const a={},o=[];for(let u in i)if(E.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const g=this.filter(i[u],s,!1,t);a[u]=g.raw,o.push(...g.restricted)}else{const g=s[u],b=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&o.push(u),(b===void 0||t.scopes===void 0||t.scopes.includes(b))&&(t.skipRestricted&&g?.restricted||(a[u]=i[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=y;class S extends R.Disposable{constructor(i,s,r,t){super();this.userSettingsResource=i,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class m{constructor(i,s,r=new p,t=new p,a=new D.ResourceMap,o=new p,u=new D.ResourceMap,g=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(i,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(i)}updateValue(i,s,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new p,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(i):t.setValue(i,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,r){const t=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),g=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),b=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),U=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,O=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(i):a.freeze().getValue(i):void 0,q=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(i):o.getValue(i),N=t.getValue(i),L=k.distinct(k.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(i,$)!==void 0);return{defaultValue:u,userValue:g,userLocalValue:b,userRemoteValue:A,workspaceValue:U,workspaceFolderValue:O,memoryValue:q,value:N,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a?.freeze().getValue(i),override:s.overrideIdentifier?a?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:q!==void 0?{value:o.getValue(i),override:s.overrideIdentifier?o.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const r=s.filter(t=>E.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const a=(0,E.overrideIdentifierFromKey)(t),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=i.getKeysForOverrideIdentifier(a),g=[...u.filter(b=>o.indexOf(b)===-1),...o.filter(b=>u.indexOf(b)===-1),...o.filter(b=>!C.equals(this._defaultConfiguration.override(a).getValue(b),i.override(a).getValue(b)))];return[a,g]});return this.updateDefaultConfiguration(i),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:r,removed:t,overrides:a}=(0,n.compare)(this.localUserConfiguration,i),o=[...s,...r,...t];return o.length&&this.updateLocalUserConfiguration(i),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:r,removed:t,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,i);let o=[...s,...r,...t];return o.length&&this.updateRemoteUserConfiguration(i),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:r,removed:t,overrides:a}=(0,n.compare)(this.workspaceConfiguration,i);let o=[...s,...r,...t];return o.length&&this.updateWorkspaceConfiguration(i),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(i,s){const r=this.folderConfigurations.get(i),{added:t,updated:a,removed:o,overrides:u}=(0,n.compare)(r,s);let g=[...t,...a,...o];return(g.length||!r)&&this.updateFolderConfiguration(i,s),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:t,removed:a,overrides:o}=(0,n.compare)(s,void 0);return{keys:[...r,...t,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let r=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?r.override(i.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:i},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const t=s.getFolder(i);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const a=this._memoryConfigurationByResource.get(i);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(i);t?(s=r.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=r}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const r=s.getFolder(i);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:r,overrides:t,keys:a}=this._folderConfigurations.get(s);return i.push([s,{contents:r,overrides:t,keys:a}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>i.add(r))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(t=>s.add(t))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),r=this.parseConfigurationModel(i.user),t=this.parseConfigurationModel(i.workspace),a=i.folders.reduce((o,u)=>(o.set(I.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new D.ResourceMap);return new m(s,r,new p,t,a,new p,new D.ResourceMap,!1)}static parseConfigurationModel(i){return new p(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=m;function v(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const i=new Set,s=new Map;for(const t of l)t.keys.forEach(a=>i.add(a)),t.overrides.forEach(([a,o])=>{const u=(0,D.getOrSet)(s,a,new Set);o.forEach(g=>u.add(g))});const r=[];return s.forEach((t,a)=>r.push([a,[...t.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=v;class f{constructor(i,s,r,t){this.change=i,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const a=new Set;i.keys.forEach(u=>a.add(u)),i.overrides.forEach(([,u])=>u.forEach(g=>a.add(g))),this.affectedKeys=[...a.values()];const o=new p;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!C.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(i=i[t],!i)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=f;class c extends f{constructor(i,s,r,t){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=c}),define(te[185],ne([0,1,5,3,2,18,21,89,39,35]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends P.Disposable{constructor(d,p){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,p)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(I.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,p){const h=typeof d=="string"?d:void 0,y=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,y,void 0)}updateValue(d,p,h,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,p,1)}onDidDefaultConfigurationChange(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,d);this.trigger(h,p,6)}trigger(d,p,h){const y=new C.ConfigurationChangeEvent(d,{data:p},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[186],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class P extends Error{constructor(D,C=T.Unknown,w){super(D);this._message=D,this._code=C,this._detail=w,this.isHandled=C===T.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,P.prototype)}static isTemporarilyNotAvailable(D){return D instanceof P&&D._code===T.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof P&&D._code===T.NoResolverFound}static isHandled(D){return D instanceof P&&D.isHandled}}e.RemoteAuthorityResolverError=P}),define(te[187],ne([0,1,5,19,28,7,3,2,29,72,186]),function(X,e,k,T,P,R,D,C,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var d;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const B=new P.CancellationTokenSource;return setTimeout(()=>B.cancel(),F),B.token}function y(F,B){if(F.isCancellationRequested||B.isCancellationRequested)return P.CancellationToken.Cancelled;const V=new P.CancellationTokenSource;return F.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class S{constructor(B){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function m(F,B){const V=new S(B);return V.registerDisposable(F.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=j(Z);G?V.reject(G):V.resolve(Z)})),V.promise}function v(F,B,V,Q,Z,G){const H=new S(G);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&F.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function f(F,B){const V=new S(B);return F.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function c(F,B,V,Q){const Z=z(F,B);F.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await v(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw F.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),F.logService.error(le),le}F.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(G,null),H=F.reconnectionProtocol,re=!1):(H=new I.PersistentProtocol(G,null),re=!0),F.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await f(F.signService.createNewMessage((0,w.generateUuid)()),Q),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(T.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await m(H,y(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(F.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await f(F.signService.validate(ie,le.signedData),Q)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const fe=await f(F.signService.sign(le.data),Q),be={type:"connectionType",commit:F.commit,signedData:fe,desiredConnectionType:B};return V&&(be.args=V),F.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(T.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(F.logService.error(`${Z} the handshake timed out. Error:`),F.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Z} received error control message when negotiating connection. Error:`),F.logService.error(le)),re&&M(H),le}}async function l(F,B,V,Q){const Z=Date.now(),G=z(F,B),{protocol:H,ownsProtocol:re}=await c(F,B,V,Q),ie=new S(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),de=j(le);de?(F.logService.error(`${G} received error control message when negotiating connection. Error:`),F.logService.error(de),re&&M(H),ie.reject(de)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function i(F,B){const{protocol:V}=await l(F,1,void 0,B);return{protocol:V}}async function s(F,B,V){const{protocol:Q,firstMessage:Z}=await l(F,2,B,V),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function r(F,B,V){const Q=Date.now(),Z=z(F,3),{protocol:G}=await c(F,3,B,V);return F.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function t(F,B,V){const{host:Q,port:Z,connectionToken:G}=await F.addressProvider.getAddress();return{commit:F.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:V,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function a(F,B,V){try{const Q=(0,w.generateUuid)(),Z=await t(F,Q,null),{protocol:G}=await i(Z,P.CancellationToken.None);return new $(F,B,V,Q,G)}catch(Q){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(Q),L.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=a;async function o(F,B){try{const V=(0,w.generateUuid)(),Q=await t(F,V,null),{protocol:Z,debugPort:G}=await s(Q,B,P.CancellationToken.None);return new _(F,B,V,Z,G)}catch(V){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(V),L.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=o;async function u(F,B,V){const Q=await t(F,(0,w.generateUuid)(),null);return await r(Q,{host:B,port:V},P.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function g(F){return(0,k.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,F*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var b;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(b=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=A;class U{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=U;class O{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=O;class q{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=q;class N{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class L extends C.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new D.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new q(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=x(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const B=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=g(Z);this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(L._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(E)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,R.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,n.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,B,V,Q)),M(this.protocol)}}L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class $ extends L{constructor(B,V,Q,Z,G){super(1,B,Z,G);this.client=this._register(new I.Client(G,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await i(B,V)}}e.ManagementPersistentConnection=$;class _ extends L{constructor(B,V,Q,Z,G){super(2,B,Q,Z);this._startArguments=V,this.debugPort=G}async _reconnect(B,V){await s(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=_;function M(F){try{F.acceptDisconnect();const B=F.getSocket();F.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function j(F){if(F&&F.type==="error"){const B=new Error(`Connection error: ${F.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function W(F,B){for(;F.length<B;)F+=" ";return F}function x(F,B,V){return`[remote-connection][${W(p(F),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function z(F,B){return`${x(B,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function K(F){return`${Date.now()-F} ms`}}),define(te[188],ne([0,1,15]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(I){return I.scheme===k.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=T;function P(I){if(!I)return;const n=I.indexOf("+");return n<0?I:I.substr(0,n)}e.getRemoteName=P;function R(I){return I.scheme!==k.Schemas.file&&I.scheme!==k.Schemas.vscodeRemote}e.isVirtualResource=R;function D(I){if(I.folders.length)return I.folders.every(n=>R(n.uri))?I.folders[0].uri:void 0;if(I.configuration&&R(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=D;function C(I){return D(I)?.scheme}e.getVirtualWorkspaceScheme=C;function w(I){return D(I)!==void 0}e.isVirtualWorkspace=w}),define(te[90],ne([0,1,25,6,188]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.getWorkspaceSupportTypeMessage=R;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class w{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,S){if(typeof y=="undefined"||y===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof y=="string"||typeof S=="string"){let m=typeof y=="string"?y:y.value,v=typeof S=="string"?S:S.value;return k.equalsIgnoreCase(m,v)}return y._lower===S._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=w;function I(h){return Boolean(h.enableProposedApi)}e.isProposedApiEnabled=I;function n(h){if(!I(h))throw new Error(`[${h.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${h.identifier.value}`)}e.checkProposedApiEnabled=n;function E(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function d(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=d;function p(h,y){if(y&&I(h)){const S=`onResolveRemoteAuthority:${(0,P.getRemoteName)(y)}`;return h.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,90]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,k.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=P;class R{constructor(y,S){this.version=S,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof R?P(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=R;function D(h,y){return`${h}.${y}`}e.getExtensionId=D;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function w(h,y){return C(D(h,y))}e.getGalleryExtensionId=w;function I(h,y){const S=[],m=v=>{for(const f of S)if(f.some(c=>P(y(c),y(v))))return f;return null};for(const v of h){const f=m(v);f?f.push(v):S.push([v])}return S}e.groupByExtension=I;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function d(h){const y=new Set;for(const S of h)S.malicious&&y.add(S.id.id);return y}e.getMaliciousExtensionsSet=d;function p(h,y){const S=[],m=y.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const v=m.shift();if(v&&S.every(f=>!P(f.identifier,{id:v}))){const f=h.filter(c=>P(c.identifier,{id:v}));f.length===1&&(S.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p}),define(te[189],ne([0,1,5,7,2,4,18,62,8,29,20,11,30,36,14,10]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends P.Disposable{constructor(f,c,l,i){super();this.fileService=c,this.extensionGalleryService=l,this.logService=i,this.extensionsDownloadDir=w.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,c){await this.cleanUpPromise;const l=this.getName(f),i=(0,D.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(i)){const s=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(f,s,c);try{await this.rename(s,i,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(t){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return i}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,c,l){try{await n.Promises.rename(f.fsPath,c.fsPath)}catch(i){if(R.isWindows&&i&&i.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${f} to ${c} with 'EPERM' error. Trying again...`),this.rename(f,c,l);throw i}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const c=[],l=[];for(const r of f.children){const t=this.parse(r.name);t&&l.push([t,r])}const i=(0,p.groupByExtension)(l,([r])=>r),s=[];for(const r of i)r.sort((t,a)=>C.rcompare(t[0].version,a[0].version)),c.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await k.Promises.settled(c.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new p.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,I.generateUuid)()}parse(f){const c=S.exec(f);return c&&c[1]&&c[2]?new p.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=he([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,d.IExtensionGalleryService),J(3,y.ILogService)],m),e.ExtensionsDownloader=m}),define(te[190],ne([0,1,2,9,20,90]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends k.Disposable{constructor(w,I){super();this.environmentService=w,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(I.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(w){w.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(w){w.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(te[191],ne([0,1,82,16,5,2,15,9,20,11,30,36,60,10]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(m,v,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new y(v,f)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),v=["en",...Object.keys(m)];return(0,T.distinct)(v)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const v=await this.cache.getLanguagePacks();Object.keys(v).some(f=>v[f]&&v[f].extensions.some(c=>(0,E.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(v);return!(0,T.equals)(Object.keys(m),Object.keys(f))}};h=he([J(0,n.IExtensionManagementService),J(1,I.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let y=class extends R.Disposable{constructor(m,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(v=>{Object.keys(v).forEach(f=>delete v[f]),this.createLanguagePacksFromExtensions(v,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...v){for(const f of v)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,v){const f=v.identifier,c=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const l of c)if(v.location.scheme===D.Schemas.file&&(0,d.isValidLocalization)(l)){let i=m[l.languageId];i||(i={hash:"",extensions:[],translations:{}},m[l.languageId]=i);let s=i.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,f))[0];s?s.version=v.manifest.version:i.extensions.push({extensionIdentifier:f,version:v.manifest.version});for(const r of l.translations)i.translations[r.id]=(0,C.join)(v.location.fsPath,r.path)}}updateHash(m){if(m){const v=(0,k.createHash)("md5");for(const f of m.extensions)v.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=v.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return w.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(c){return{}}}).then(f=>(v=m(f),f)).then(f=>{for(const l of Object.keys(f))f[l]||delete f[l];this.languagePacks=f,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),w.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>v,f=>this.logService.error(f))})}};y=he([J(0,I.INativeEnvironmentService),J(1,p.ILogService)],y)}),define(te[192],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[63],ne([0,1,3,4,6,10]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,P.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,P.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var w;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(w=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function d(h,y){return y?y!==1&&h<1024:!T.isWindows&&h<1024}e.isPortPrivileged=d;let p=class{constructor(y){this.logService=y,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,S){return this._tunnelProvider=y,y?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],S=Array.from(this._tunnels.values());for(let m of S){const v=Array.from(m.values());for(let f of v){const c=await f.value;c&&y.push(c)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:S}of y.values())await S.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,S,m,v,f=!1,c=C.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${m} on local port ${v}.`),!y)return;S||(S="localhost");const i=this.retainOrCreateTunnel(y,S,m,v,f,c,l);return i?i.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==S||s.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const S=this._tunnels.get(y.tunnelRemoteHost);if(S){const m=S.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,S,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${S}.`);const v=m.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(S),v}}async closeTunnel(y,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${S} `);const m=this._tunnels.get(y);if(m&&m.has(S)){const v=m.get(S);v.refcount=0,await this.tryDisposeTunnel(y,S,v)}}addTunnelToMap(y,S,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(S,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,S){const m=this._tunnels.get(y);m&&(await m.get(S)||m.delete(S),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,S){let m=[y];n(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const v=m.map(f=>this._tunnels.get(f));for(const f of v){const c=f?.get(S);if(c)return c}}canTunnel(y){return!!I(y)}createWithProvider(y,S,m,v,f,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${m} on local port ${v}.`);const s={elevationRequired:f?d(v===void 0?m:v):!1},r={remoteAddress:{host:S,port:m},localAddressPort:v,privacy:c,public:c!==C.Private,protocol:l},t=y.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(S,m,t),t}};p=he([J(0,R.ILogService)],p),e.AbstractTunnelService=p}),define(te[193],ne([0,1,10,63,2,7,5]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends P.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new D.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let w=class It extends P.Disposable{constructor(n,E){super();this._tunnelService=n,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(n,E,d,p,h,y){const S=new C,m=await Promise.resolve(this._tunnelService.openTunnel(n,S,d,p,h,y));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${p} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),S.dispose(),await m.dispose(),(0,R.canceled)();return S.setTunnel(m),this._tunnels.set(E,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${d}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(n,E){const d=this._tunnels.get(n);!d||d.setAddress(E)}async destroyTunnel(n){const E=this._tunnels.get(n);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await E.dispose();return}this._disposedTunnels.add(n)}};w._lastId=0,w=he([J(0,T.ISharedTunnelsService),J(1,k.ILogService)],w),e.SharedProcessTunnelService=w}),define(te[194],ne([0,1,122,21,10]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(C,w){this.configurationService=C,this.logService=w}request(C,w){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(C,w)}async resolveProxy(C){}};R=he([J(0,T.IConfigurationService),J(1,P.ILogService)],R),e.RequestService=R}),define(te[44],ne([0,1,19,143,39,6,35]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function C(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=C;function w(h){return h.res.statusCode===204}async function I(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);return w(h)?null:(await(0,k.streamToBuffer)(h.stream)).toString()}e.asText=I;async function n(h){if(!C(h))throw new Error("Server returned "+h.res.statusCode);if(w(h))return null;const S=(await(0,k.streamToBuffer)(h.stream)).toString();try{return JSON.parse(S)}catch(m){throw m.message+=`:
`+S,m}}e.asJson=n;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let d;function p(h){const y=D.Registry.as(P.Extensions.Configuration),S=d;d={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[d],remove:S?[S]:[]})}p(2)}),define(te[195],ne([0,1,28,15,14,44]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(w,I){this.requestService=w,this.fileService=I}async download(w,I,n=k.CancellationToken.None){if(w.scheme===T.Schemas.file||w.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(w,I);return}const E={type:"GET",url:w.toString()},d=await this.requestService.request(E,n);if(d.res.statusCode===200)await this.fileService.writeFile(I,d.stream);else{const p=await(0,R.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};D=he([J(0,R.IRequestService),J(1,P.IFileService)],D),e.DownloadService=D}),define(te[196],ne([0,1,16,28,67,2,18,157,14,10,27,44]),function(X,e,k,T,P,R,D,C,w,I,n,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends R.Disposable{constructor(h,y,S,m){super();this.fileService=h,this.productService=y,this.requestService=S,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,P.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[S,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,D.joinPath)(h,S)),f=new Map;(0,P.forEach)(m.recommendations,({key:l,value:i})=>{if((0,k.isNonEmptyArray)(i.remotes))for(const s of i.remotes)f.set(s,{extensionId:l,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack});else y.push({extensionId:l,extensionName:i.name,configName:m.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack})});const c=(0,C.getDomainsOfRemotes)(v.value.toString(),[...f.keys()]);for(const l of c){const i=f.get(l);i&&y.push(i)}}catch(v){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,E.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=he([J(0,w.IFileService),J(1,n.IProductService),J(2,E.IRequestService),J(3,I.ILogService)],d),e.ExtensionTipsService=d}),define(te[46],ne([0,1,19,29]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(R,D,C){let w=C&&C.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await D.readFile(R.serviceMachineIdResource)).value.toString();w=(0,T.isUUID)(n)?n:null}catch(I){w=null}if(!w){w=(0,T.generateUuid)();try{await D.writeFile(R.serviceMachineIdResource,k.VSBuffer.fromString(w))}catch(I){}}return C&&C.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=P}),define(te[91],ne([0,1,106,6]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function P(R){return(0,k.hash)({moduleId:R.process.moduleId,windowId:R.reply.windowId})}e.hash=P,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[197],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[198],ne([0,1,73,155,28,3,2,15,4,29,11,10,27,91,197]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let y=class{constructor(v,f,c){this.logService=v,this.productService=f,this.environmentService=c,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const f=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${f})`);const c=(0,p.hash)(v);this.processeDisposables.has(c)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${f})`),this.doDisposeWorker(v));const l=new P.CancellationTokenSource;let i,s,r;this.processeDisposables.set(c,u=>{l.dispose(!0),i?.terminate(v,P.CancellationToken.None),s?.close(),r?.close(),this.processeDisposables.delete(c);const g=this.processResolvers.get(c);g&&(this.processResolvers.delete(c),g({reason:u}))}),i=await this.getOrCreateWebWorker(v);const t=new Promise(u=>{this.processResolvers.set(c,u)});if(l.token.isCancellationRequested)return t;const{port1:a,port2:o}=new MessageChannel;return s=a,r=o,await i.spawn(v,r,l.token),l.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${f})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[s])),t}getOrCreateWebWorker(v){let f=this.workers.get(v.process.moduleId);if(!f){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const c=new S(v.process.type,this.logService,this.productService,this.environmentService);f=c.init(),c.onDidProcessSelfTerminate(({configuration:l,reason:i})=>{this.doDisposeWorker(l,i)}),this.workers.set(v.process.moduleId,f)}return f}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,f){const c=this.processeDisposables.get((0,p.hash)(v));c&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),c(f))}};y=he([J(0,E.ILogService),J(1,d.IProductService),J(2,n.INativeEnvironmentService)],y),e.SharedProcessWorkerService=y;class S extends D.Disposable{constructor(v,f,c,l){super();this.type=v,this.logService=f,this.productService=c,this.environmentService=l,this._onDidProcessSelfTerminate=this._register(new R.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let v;const f=new Promise(l=>v=l),c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:i,message:s,configuration:r,nonce:t}=l.data;switch(i){case h.SharedProcessWorkerMessages.Ready:v(c);break;case h.SharedProcessWorkerMessages.Ack:if(t){const a=this.mapMessageNonceToPendingMessageResolve.get(t);a&&(this.mapMessageNonceToPendingMessageResolve.delete(t),a())}break;case h.SharedProcessWorkerMessages.SelfTerminated:r&&s&&this._onDidProcessSelfTerminate.fire({configuration:r,reason:JSON.parse(s)});break;case h.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Info:s&&this.logService.info(s);break;case h.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,s);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),f}async send(v,f,c){const l=await this.workerReady;if(!f.isCancellationRequested)return new Promise(i=>{const s=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(s,i);const r={...v,nonce:s};c?l.postMessage(r,[c]):l.postMessage(r),f.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(s)&&i()})})}spawn(v,f,c){const l={id:h.SharedProcessWorkerMessages.Spawn,configuration:v,environment:this.getSharedProcessWorkerEnvironment()};return this.send(l,c,f)}getSharedProcessWorkerEnvironment(){const v={bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",X).fsPath,env:Object.create(null)};if(w.isLinux){const f={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},c=this.environmentService.args["crash-reporter-id"],l=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&l&&c&&(0,I.isUUID)(c)){const r=l["linux-x64"];f.submitURL=r.concat("&uid=",c,"&iid=",c,"&sid=",c),f.uploadToServer=!0}const s=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;v.env.BREAKPAD_DUMP_LOCATION=(0,T.join)(s,this.type),v.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(f)}return v}terminate(v,f){const c={id:h.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(c,f)}}}),define(te[92],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[199],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((P,R)=>X(["vsda"],P,R))}async createNewMessage(P){try{const R=await this.vsda(),D=new R.validator;if(D){const C=String(k._nextId++);return this.validators.set(C,D),{id:C,data:D.createNewMessage(P)}}}catch(R){}return{id:"",data:P}}async validate(P,R){if(!P.id)return!0;const D=this.validators.get(P.id);if(!D)return!1;this.validators.delete(P.id);try{return D.validate(R)==="ok"}catch(C){return!1}}async sign(P){try{const R=await this.vsda(),D=new R.signer;if(D)return D.sign(P)}catch(R){}return P}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,181,17,74,6]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const I="__$__targetStorageMarker";e.IStorageService=(0,w.createDecorator)("storageService");var n;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(n=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var d;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class p extends P.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,v){v===I?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:v,target:this.getKeyTargets(m)[v]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,v,f){return this.getStorage(v)?.get(m,f)}getBoolean(m,v,f){return this.getStorage(v)?.getBoolean(m,f)}getNumber(m,v,f){return this.getStorage(v)?.getNumber(m,f)}store(m,v,f,c){if((0,D.isUndefinedOrNull)(v)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,c),this.getStorage(f)?.set(m,v)})}remove(m,v){this.withPausedEmitters(()=>{this.updateKeyTarget(m,v,void 0),this.getStorage(v)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,v){const f=[],c=this.getKeyTargets(m);for(const l of Object.keys(c))c[l]===v&&f.push(l);return f}updateKeyTarget(m,v,f){const c=this.getKeyTargets(v);typeof f=="number"?c[m]!==f&&(c[m]=f,this.getStorage(v)?.set(I,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(v)?.set(I,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const v=this.get(I,m);if(v)try{return JSON.parse(v)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=n.NONE){this._onWillSaveState.fire({reason:m});const v=this.getStorage(0),f=this.getStorage(1);switch(m){case n.NONE:await k.Promises.settled([v?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case n.SHUTDOWN:await k.Promises.settled([v?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return y(m,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function y(S,m,v,f){const c=o=>{try{return JSON.parse(o)}catch(u){return o}},l=new Map,i=new Map;S.forEach((o,u)=>{l.set(u,o),i.set(u,c(o))});const s=new Map,r=new Map;m.forEach((o,u)=>{s.set(u,o),r.set(u,c(o))}),console.group(`Storage: Global (path: ${v})`);let t=[];l.forEach((o,u)=>{t.push({key:u,value:o})}),console.table(t),console.groupEnd(),console.log(i),console.group(`Storage: Workspace (path: ${f})`);let a=[];s.forEach((o,u)=>{a.push({key:u,value:o})}),console.table(a),console.groupEnd(),console.log(r)}e.logStorage=y}),define(te[200],ne([0,1,3,2,17,30,36,23]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let w=class extends T.Disposable{constructor(E){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(E)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(E,d){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}async disableExtension(E,d){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let d=this.getDisabledExtensions();return d.every(p=>!(0,D.areSameExtensions)(p,E))?(d.push(E),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(E){let d=this.getDisabledExtensions();for(let p=0;p<d.length;p++){const h=d[p];if((0,D.areSameExtensions)(h,E))return d.splice(p,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(E){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,d){this.storageManger.set(E,d,0)}};w=he([J(0,C.IStorageService)],w),e.GlobalExtensionEnablementService=w;class I extends T.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(E,d){let p;return d===0?((0,P.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,d)),p=this.storage[E]):p=this._get(E,d),JSON.parse(p)}set(E,d,p){let h=JSON.stringify(d.map(({id:S,uuid:m})=>({id:S,uuid:m})));this._get(E,p)!==h&&(p===0&&(d.length?this.storage[E]=h:delete this.storage[E]),this._set(E,d.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,P.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),y=p.filter(m=>!h.some(v=>(0,D.areSameExtensions)(m,v))),S=h.filter(m=>!p.some(v=>(0,D.areSameExtensions)(v,m)));(y.length||S.length)&&this._onDidChange.fire([...y,...S])}}_get(E,d){return this.storageService.get(E,d,"[]")}_set(E,d,p){d?this.storageService.store(E,d,p,1):this.storageService.remove(E,p)}}e.StorageManager=I}),define(te[201],ne([0,1,3,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class P extends T.Disposable{constructor(I,n){super();this.channel=I,this.workspace=n}async getItems(){const I={workspace:this.workspace},n=await this.channel.call("getItems",I);return new Map(n)}updateItems(I){const n={workspace:this.workspace};return I.insert&&(n.insert=Array.from(I.insert.entries())),I.delete&&(n.delete=Array.from(I.delete.values())),this.channel.call("updateItems",n)}}class R extends P{constructor(I){super(I,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(I=>this.onDidChangeGlobalStorage(I)))}onDidChangeGlobalStorage(I){(Array.isArray(I.changed)||Array.isArray(I.deleted))&&this._onDidChangeItemsExternal.fire({changed:I.changed?new Map(I.changed):void 0,deleted:I.deleted?new Set(I.deleted):void 0})}async close(){this.dispose()}}class D extends P{constructor(I,n){super(I,n);this.onDidChangeItemsExternal=k.Event.None}async close(){const I={workspace:this.workspace};return this.channel.call("close",I)}}class C extends T.Disposable{constructor(I,n){super();this.channel=I,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new D(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[202],ne([0,1,5,2,18,74,23,201]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends D.AbstractStorageService{constructor(n,E,d){super();this.mainProcessService=E,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(n)}createGlobalStorage(){const n=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new R.Storage(n.globalStorage);return this._register(E.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),E}createWorkspaceStorage(n){const E=new C.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),n);if(E.workspaceStorage){const d=new R.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=n?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(n){return n===0?this.globalStorage:this.workspaceStorage}getLogDetails(n){return n===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,P.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(D.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(n){const E=this.workspaceStorage,d=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(n),await this.workspaceStorage.init();for(const[p,h]of d)this.workspaceStorage.set(p,h)}}e.NativeStorageService=w}),define(te[203],ne([0,1,4,31,8,29]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(I){if(k.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function C(I,n,E,d,p,h,y,S,m,v){const f=Object.create(null);f["common.machineId"]=y,f.sessionID=(0,R.generateUuid)()+Date.now(),f.commitHash=p,f.version=h,f["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,k.PlatformToString)(k.platform),f["common.nodePlatform"]=T.platform,f["common.nodeArch"]=d,f["common.product"]=v||"desktop";const c=w(S||[]);c&&(f["common.msftInternal"]=c);let l=0;const i=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),k.isLinuxSnap&&(f["common.snap"]="true");const s=D(E);s&&(f["common.platformDetail"]=s);try{const r=await I.readFile(P.URI.file(m));f["common.source"]=r.value.toString().slice(0,30)}catch(r){}return f}e.resolveCommonProperties=C;function w(I){const n=T.env.USERDNSDOMAIN;if(!n)return!1;const E=n.toLowerCase();return I.some(d=>E===d)}e.verifyMicrosoftInternalDomain=w}),define(te[22],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,33,56,5,32,15,9,4,8,115,20,118,78,14,27,22]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(i,s){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,a=new Map,o=2e4;function u(A,U,O,q){const N=U.substring(A.length+1);return P.Promises.withAsyncBody(async L=>{let $;try{$=await E.Promises.readdir(U,{withFileTypes:!0})}catch(j){L();return}if(q.count>=o){q.count+=$.length,q.maxReached=!0,L();return}let _=$.length;if(_===0){L();return}let M=$;q.count+$.length>o&&(q.maxReached=!0,_=o-q.count,M=$.slice(0,_)),q.count+=$.length;for(const j of M)if(j.isDirectory()){if(O.includes(j.name)||await u(A,(0,C.join)(U,j.name),O,q),--_==0){L();return}}else{const W=j.name.lastIndexOf(".");if(W>=0){const x=j.name.substring(W+1);x&&t.set(x,(t.get(x)??0)+1)}for(const x of r)x.relativePathPattern?.test(N)!==!1&&x.filePattern.test(j.name)&&a.set(x.tag,(a.get(x.tag)??0)+1);if(--_==0){L();return}}})}const g={count:0,maxReached:!1};await u(i,i,s,g);const b=await c(i);return{configFiles:v(a),fileTypes:v(t),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:b}}e.collectWorkspaceStats=m;function v(i){return[...T.Iterable.map(i.entries(),([s,r])=>({name:s,count:r}))].sort((s,r)=>r.count-s.count)}function f(){const i={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(n.virtualMachineHint.value()*100)}%`},s=k.cpus();return s&&s.length>0&&(i.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),i}e.getMachineInfo=f;async function c(i){try{const s=new Map,r=(0,C.join)(i,".vscode","launch.json"),t=await E.Promises.readFile(r),a=[],o=(0,R.parse)(t.toString(),a);if(a.length)return console.log(`Unable to parse ${r}`),[];if((0,R.getNodeType)(o)==="object"&&o.configurations)for(const u of o.configurations){const g=u.type;g&&(s.has(g)?s.set(g,s.get(g)+1):s.set(g,1))}return v(s)}catch(s){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(s,r){this.telemetryService=s,this.productService=r}formatMachineInfo(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}formatEnvironment(s){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const t=k.cpus();return t&&t.length>0&&r.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),r.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${k.loadavg().map(a=>Math.round(a)).join(", ")}`),r.push(`VM:               ${Math.round(n.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,d.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async t=>{let[a,o]=t,u=this.formatProcessList(s,a);return r.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,o+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(s,g.processes)}`),g.workspaceMetadata){o+=`
|  Remote: ${g.hostName}`;for(const b of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[b];let U=`${A.fileCount} files`;A.maxFilesReached&&(U=`more than ${U}`),o+=`|    Folder (${b}): ${U}`,o+=this.formatWorkspaceStats(A)}}}),{processInfo:u,workspaceInfo:o}})}async getSystemInfo(s,r){const{memory:t,vmHint:a,os:o,cpus:u}=f(),g={os:o,memory:t,cpus:u,vmHint:a,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(g.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),w.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(s,r){const t=[];return(0,d.listProcesses)(s.mainPID).then(async a=>(t.push(""),t.push(this.formatEnvironment(s)),t.push(""),t.push(this.formatProcessList(s,a)),s.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(s))),r.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(s,o.processes)),o.workspaceMetadata)for(const u of Object.keys(o.workspaceMetadata)){const g=o.workspaceMetadata[u];let b=`${g.fileCount} files`;g.maxFilesReached&&(b=`more than ${b}`),t.push(`Folder (${u}): ${b}`),t.push(this.formatWorkspaceStats(g))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(s){const r=[],t=60;let a=0;const o=(A,U)=>{const O=` ${A}(${U})`;a+O.length>t?(r.push(u),u="|                 ",a=u.length):a+=O.length,u+=O};let u="|      File types:";const g=10;let b=s.fileTypes.length>g?g:s.fileTypes.length;for(let A=0;A<b;A++){const U=s.fileTypes[A];o(U.name,U.count)}if(r.push(u),s.configFiles.length>=0&&(u="|      Conf files:",a=0,s.configFiles.forEach(A=>{o(A.name,A.count)}),r.push(u)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(U=>{A+=U.count>1?` ${U.name}(${U.count})`:` ${U.name}`}),r.push(A)}return r.join(`
`)}expandGPUFeatures(s){const r=Math.max(...Object.keys(s).map(t=>t.length));return Object.keys(s).map(t=>`${t}:  ${" ".repeat(r-t.length)}  ${s[t]}`).join(`
                  `)}formatWorkspaceMetadata(s){const r=[],t=[];return s.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(r.push(`|  Window (${a.title})`),a.folderURIs.forEach(o=>{const u=I.URI.revive(o);if(u.scheme===D.Schemas.file){const g=u.fsPath;t.push(m(g,["node_modules",".git"]).then(b=>{let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,C.basename)(g)}): ${A}`),r.push(this.formatWorkspaceStats(b))}).catch(b=>{r.push(`|      Error: Unable to collect workspace stats for folder ${g} (${b.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(a=>r.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(s,r){const t=new Map;s.windows.forEach(o=>t.set(o.pid,o.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(s.mainPID,t,a,r,0),a.join(`
`)}formatProcessItem(s,r,t,a,o){const u=o===0;let g;u?g=a.pid===s?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(o)} ${a.name}`,a.name==="window"&&(g=`${g} (${r.get(a.pid)})`));const b=process.platform==="win32"?a.mem:k.totalmem()*(a.mem/100);t.push(`${a.load.toFixed(0).padStart(5," ")}	${(b/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(s,r,t,A,o+1))}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const t=I.URI.revive(r);if(t.scheme!==D.Schemas.file)continue;const a=t.fsPath;try{const o=await m(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),o.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),o.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=he([J(0,S.ITelemetryService),J(1,y.IProductService)],l),e.DiagnosticsService=l}),define(te[205],ne([0,1,16,5,28,7,3,2,4,8,132,30,36,10,27,22]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let S=class extends C.Disposable{constructor(l,i,s,r){super();this.galleryService=l,this.telemetryService=i,this.logService=s,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(t=>t.cancel()),this.uninstallingExtensions.forEach(t=>t.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(l){const i=await this.getTargetPlatform();return l.allTargetPlatforms.some(s=>(0,E.isTargetPlatformCompatible)(s,l.allTargetPlatforms,i))}async installFromGallery(l,i={}){if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(n.localize(0,null),E.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(l)){const r=await this.getTargetPlatform(),t=new E.ExtensionManagementError(n.localize(1,null,l.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(r)),E.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",l.identifier.id,t.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(l),void 0,t),t}try{l=await this.checkAndGetCompatibleVersion(l,!i.installGivenVersion)}catch(r){throw this.logService.error((0,R.getErrorMessage)(r)),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(l),void 0,r),r}const s=await this.galleryService.getManifest(l,P.CancellationToken.None);if(s===null){const r=new E.ExtensionManagementError(`Missing manifest for extension ${l.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",l.identifier.id,r.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(l),void 0,r),r}if(s.version!==l.version){const r=new E.ExtensionManagementError(`Cannot install '${l.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);throw this.logService.error(r.message),v(this.telemetryService,"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(l),void 0,r),r}return this.installExtension(s,l,i)}async uninstall(l,i={}){return this.logService.trace("ExtensionManagementService#uninstall",l.identifier.id),this.unininstallExtension(l,i)}async reinstallFromGallery(l){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",l.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const i=await this.findGalleryExtension(l);if(!i)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(l,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsReport(){const l=new Date().getTime();return(!this.reportedExtensions||l-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=l),this.reportedExtensions}registerParticipant(l){this.participants.push(l)}async installExtension(l,i,s){if(!I.URI.isUri(i)){let u=this.installingExtensions.get(new d.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(u)return this.logService.info("Extensions is already requested to install",i.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],t=[],a=this.createInstallExtensionTask(l,i,s);I.URI.isUri(i)||this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(a.identifier,l.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:i}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:l});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const g=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,l,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:b,manifest:A}of g)if(o=o||!!A.extensionDependencies?.some(U=>(0,d.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new d.ExtensionIdentifierWithVersion(b.identifier,b.version).key()))this.logService.info("Extension is already requested to install",b.identifier.id);else{const U=this.createInstallExtensionTask(A,b,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new d.ExtensionIdentifierWithVersion(U.identifier,A.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:b}),this.logService.info("Installing extension:",U.identifier.id),r.push({task:U,manifest:A})}}catch(g){if(I.URI.isUri(a.source))(0,k.isNonEmptyArray)(l.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,g.message),(0,k.isNonEmptyArray)(l.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,g.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(g),g}const u=r.reduce((g,{task:b,manifest:A})=>(g.set(b.identifier.id.toLowerCase(),{task:b,manifest:A}),g),new Map);for(;u.size;){let g;const b=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(U=>u.has(U.toLowerCase())));b.length?g=u.size===1?b:b.filter(({task:A})=>!(A===a&&!o)):(this.logService.info("Found extensions with circular dependencies",b.map(({task:A})=>A.identifier.id)),g=[...u.values()]),await this.joinAllSettled(g.map(async({task:A})=>{const U=new Date().getTime();try{const O=await A.run();if(await this.joinAllSettled(this.participants.map(q=>q.postInstall(O,A.source,s,P.CancellationToken.None))),!I.URI.isUri(A.source)&&(v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-U,void 0),w.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(q){}t.push({local:O,identifier:A.identifier,operation:A.operation,source:A.source})}catch(O){throw I.URI.isUri(A.source)||v(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,d.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-U,O),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(O),O}finally{u.delete(A.identifier.id.toLowerCase())}}))}return t.forEach(({identifier:g})=>this.logService.info("Extension installed successfully:",g.id)),this._onDidInstallExtensions.fire(t),t.filter(({identifier:g})=>(0,d.areSameExtensions)(g,a.identifier))[0].local}catch(u){if(r.forEach(({task:g})=>g.cancel()),t.length)try{const g=await Promise.allSettled(t.map(({local:b})=>this.createUninstallExtensionTask(b,{versionOnly:!0}).run()));for(let b=0;b<g.length;b++){const A=g[b],{identifier:U}=t[b];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,R.getErrorMessage)(A.reason))}}catch(g){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(g),t.map(({identifier:b})=>b.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,R.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:g})=>({identifier:g.identifier,operation:1,source:g.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:E.ExtensionManagementErrorCode.Internal),u}finally{for(const{task:u,manifest:g}of r)if(!I.URI.isUri(u.source)){const b=new d.ExtensionIdentifierWithVersion(u.identifier,g.version).key();this.installingExtensions.delete(b)||this.logService.warn("Installation task is not found in the cache",b)}}}async joinAllSettled(l){const i=[],s=[],r=await Promise.allSettled(l);for(const t of r)t.status==="fulfilled"?i.push(t.value):s.push(t.reason);if(s.length)throw m(s);return i}async getAllDepsAndPackExtensionsToInstall(l,i,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const t=[l,...r.map(u=>u.identifier)],a=[],o=async(u,g)=>{const b=g.extensionDependencies||[],A=[...b];if(g.extensionPack){const U=s?r.find(O=>(0,d.areSameExtensions)(O.identifier,u)):void 0;for(const O of g.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(q=>(0,d.areSameExtensions)({id:q},{id:O}))||A.every(q=>!(0,d.areSameExtensions)({id:q},{id:O}))&&A.push(O)}if(A.length){const U=[...t,...a.map(q=>q.gallery.identifier)],O=A.filter(q=>U.every(N=>!(0,d.areSameExtensions)(N,{id:q})));if(O.length){const q=await this.galleryService.query({names:O,pageSize:A.length},P.CancellationToken.None);for(const N of q.firstPage){if(U.find(M=>(0,d.areSameExtensions)(M,N.identifier)))continue;if(!b.some(M=>(0,d.areSameExtensions)({id:M},N.identifier))&&!await this.canInstall(N)){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}const $=await this.checkAndGetCompatibleVersion(N,!0),_=await this.galleryService.getManifest($,P.CancellationToken.None);if(_===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);a.push({gallery:$,manifest:_}),await o($.identifier,_)}}}};return await o(l,i),r=await this.getInstalled(),a.filter(u=>!r.some(g=>(0,d.areSameExtensions)(g.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(l,i){if(await this.isMalicious(l))throw new E.ExtensionManagementError(n.localize(4,null,l.identifier.id),E.ExtensionManagementErrorCode.Malicious);const s=await this.getCompatibleVersion(l,i);if(!s)throw new E.ExtensionManagementError(n.localize(5,null,l.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);return s}async getCompatibleVersion(l,i){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(l,s)&&(r=l),!r&&i&&(r=await this.galleryService.getCompatibleExtension(l,s)),r}async isMalicious(l){const i=await this.getExtensionsReport();return(0,d.getMaliciousExtensionsSet)(i).has(l.identifier.id)}async unininstallExtension(l,i){const s=this.uninstallingExtensions.get(l.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",l.identifier.id),s.waitUntilTaskIsFinished();const r=(u,g)=>{const b=this.createUninstallExtensionTask(u,g);return this.uninstallingExtensions.set(b.extension.identifier.id.toLowerCase(),b),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),b},t=(u,g)=>{g?this.logService.error("Failed to uninstall extension:",u.identifier.id,g.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,d.getLocalExtensionTelemetryData)(u),void 0,g),this._onDidUninstallExtension.fire({identifier:u.identifier,error:g?.code})},a=[],o=[];try{a.push(r(l,{}));const u=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",l.identifier.id);else{const g=this.getAllPackExtensionsToUninstall(l,u);for(const b of g)this.uninstallingExtensions.has(b.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",b.identifier.id):a.push(r(b,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",l.identifier.id):this.checkForDependents(a.map(g=>g.extension),u,l),await this.joinAllSettled(a.map(async g=>{try{if(await g.run(),await this.joinAllSettled(this.participants.map(b=>b.postUninstall(g.extension,i,P.CancellationToken.None))),g.extension.identifier.uuid)try{await this.galleryService.reportStatistic(g.extension.manifest.publisher,g.extension.manifest.name,g.extension.manifest.version,"uninstall")}catch(b){}t(g.extension)}catch(b){const A=b instanceof E.ExtensionManagementError?b:new E.ExtensionManagementError((0,R.getErrorMessage)(b),E.ExtensionManagementErrorCode.Internal);throw t(g.extension,A),A}finally{o.push(g)}}))}catch(u){const g=u instanceof E.ExtensionManagementError?u:new E.ExtensionManagementError((0,R.getErrorMessage)(u),E.ExtensionManagementErrorCode.Internal);for(const b of a){try{b.cancel()}catch(A){}o.includes(b)||t(b.extension,g)}throw g}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(l,i,s){for(const r of l){const t=this.getDependents(r,i);if(t.length){const a=t.filter(o=>!l.some(u=>(0,d.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(l,i,s){return s===l?i.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,l.manifest.displayName||l.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(l,i,s=[]){if(s.indexOf(l)!==-1)return[];s.push(l);const r=l.manifest.extensionPack?l.manifest.extensionPack:[];if(r.length){const t=i.filter(o=>!o.isBuiltin&&r.some(u=>(0,d.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of t)a.push(...this.getAllPackExtensionsToUninstall(o,i,s));return[...t,...a]}return[]}getDependents(l,i){return i.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,d.areSameExtensions)({id:r},l.identifier)))}async findGalleryExtension(l){if(l.identifier.uuid){const i=await this.findGalleryExtensionById(l.identifier.uuid);return i||this.findGalleryExtensionByName(l.identifier.id)}return this.findGalleryExtensionByName(l.identifier.id)}async findGalleryExtensionById(l){return(await this.galleryService.query({ids:[l],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(l){return(await this.galleryService.query({names:[l],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const l=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${l.length} reported extensions from service`),l}catch(l){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};S=he([J(0,E.IExtensionGalleryService),J(1,y.ITelemetryService),J(2,p.ILogService),J(3,h.IProductService)],S),e.AbstractExtensionManagementService=S;function m(c){const l=Array.isArray(c)?c:[c];return l.length===1?l[0]instanceof Error?l[0]:new Error(l[0]):l.reduce((i,s)=>new Error(`${i.message}${i.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=m;function v(c,l,i,s,r){const t=r?r instanceof E.ExtensionManagementError?r.code:E.ExtensionManagementErrorCode.Internal:void 0;c.publicLogError(l,{...i,success:!r,duration:s,errorcode:t})}e.reportTelemetry=v;class f{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(l=>this.doRun(l))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(l=>new Promise((i,s)=>{const r=l.onCancellationRequested(()=>{r.dispose(),s((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=f}),define(te[206],ne([0,1,16,5,67,3,9,4,31,8,134,11,30,196,80,14,10,61,27,44,23,22]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const i="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends p.ExtensionTipsService{constructor(a,o,u,g,b,A,U,O,q,N){super(U,O,q,N);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=b,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,P.forEach)(O.exeBasedExtensionTips,({key:L,value:$})=>{const _=[],M=[],j=[];(0,P.forEach)($.recommendations,({key:W,value:x})=>{x.important?$.important?_.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):M.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):j.push({extensionId:W,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:_}),M.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:M}),j.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:j})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:g,uninstalled:b}=this.groupByInstalled([...u.keys()],o);for(const O of g){const q=u.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:q.exeName})}for(const O of b){const q=u.get(O);q&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:q.exeName})}const A=this.getPromptedExecutableTips(),U=new Map;for(const O of b){const q=u.get(O);if(q&&(!A[q.exeName]||!A[q.exeName].includes(q.extensionId))){let N=U.get(q.exeName);N||(N=[],U.set(q.exeName,N)),N.push(q)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const b=this._register((0,T.disposableTimeout)(()=>{b.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[g,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(b[0].exeName,b);const U=this._register((0,T.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const q=this._register((0,T.disposableTimeout)(()=>{q.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:g})=>g.toLowerCase()),u=(0,n.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(i,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(i,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],g=[],b=o.reduce((A,U)=>(A.add(U.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{b.has(A.toLowerCase())?u.push(A):g.push(A)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const g of a.keys()){const b=a.get(g);if(!b||!(0,k.isNonEmptyArray)(b.recommendations))continue;const A=[];C.isWindows?b.windowsPath&&A.push(b.windowsPath.replace("%USERPROFILE%",w.env.USERPROFILE).replace("%ProgramFiles(x86)%",w.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",w.env.ProgramFiles).replace("%APPDATA%",w.env.APPDATA).replace("%WINDIR%",w.env.WINDIR)):(A.push((0,D.join)("/usr/local/bin",g)),A.push((0,D.join)("/usr/bin",g)),A.push((0,D.join)(this.environmentService.userHome.fsPath,g)));for(const U of A){let O=u.get(U);if(O===void 0&&(O=await this.fileService.exists(I.URI.file(U)),u.set(U,O)),O)for(const{extensionId:q,extensionName:N,isExtensionPack:L}of b.recommendations)o.push({extensionId:q,extensionName:N,isExtensionPack:L,exeName:g,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath})}}return o}};r=he([J(0,E.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,d.IExtensionManagementService),J(3,c.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,y.IFileService),J(7,v.IProductService),J(8,f.IRequestService),J(9,S.ILogService)],r),e.ExtensionTipsService=r}),define(te[93],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(R){this.appenders=R}listen(R,D){throw new Error(`Event not found: ${D}`)}call(R,D,{eventName:C,data:w}){return this.appenders.forEach(I=>I.log(C,w)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class T{constructor(R){this.channel=R}log(R,D){return this.channel.call("log",{eventName:R,data:D}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(te[45],ne([0,1,26,17,21,22]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,v){return Promise.resolve(void 0)}publicLog2(m,v){return this.publicLog(m,v)}publicLogError(m,v){return Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=D,e.NullTelemetryService=new D;class C{async publicLog(m,v,f){}async publicLogError(m,v,f){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(S,m){return m.onDidChangeConfiguration(v=>{v.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=w;function I(S,m){return!(m.disableTelemetry||!S.enableTelemetry)}e.supportsTelemetry=I;function n(S){const m=S.getValue(R.TELEMETRY_SETTING_ID),v=S.getValue("telemetry.enableCrashReporter");if(S.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=n;function E(S){const m=Object.create(null),v=Object.create(null),f=Object.create(null);p(S,f);for(let c in f){c=c.length>150?c.substr(c.length-149):c;const l=f[c];typeof l=="number"?v[c]=l:typeof l=="boolean"?v[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),m[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[c]=l)}return{properties:m,measurements:v}}e.validateTelemetryData=E;function d(S){if(!S)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{S.indexOf(`${f}+`)===0&&(m=f)}),m}e.cleanRemoteAuthority=d;function p(S,m,v=0,f){if(!!S)for(let c of Object.getOwnPropertyNames(S)){const l=S[c],i=f?f+c:c;Array.isArray(l)?m[i]=(0,k.safeStringify)(l):l instanceof Date?m[i]=l.toISOString():(0,T.isObject)(l)?v<2?p(l,m,v+1,i+"."):m[i]=(0,k.safeStringify)(l):m[i]=l}}function h(S){if(!S)return[];const m=[];return y(m,"",S),m}function y(S,m,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(f=>y(S,m?`${m}.${f}`:f,v[f])):S.push(m)}}),define(te[207],ne([0,1,45,152]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class P{constructor(){}setSharedProperty(w,I){}postEvent(w,I){}}class R{constructor(w,I,n,E,d){this.getMachineId=w,this.configurationService=I,this.productService=n,this.telemetry=E,this.keyValueStorage=d,this.networkInitialized=!1,n.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,h))}get experimentsEnabled(){return!0}async getTreatment(w){await this.overrideInitDelay;const I=this.configurationService.getValue("experiments.override."+w);if(I!==void 0)return I;if(!this.tasClient||!this.experimentsEnabled)return;let n;const E=await this.tasClient;return this.networkInitialized?n=E.getTreatmentVariable("vscode",w):n=await E.getTreatmentVariableAsync("vscode",w,!0),n=E.getTreatmentVariable("vscode",w),n}async setupTASClient(){const w=this.productService.quality==="stable"?T.TargetPopulation.Public:T.TargetPopulation.Insiders,I=await this.getMachineId(),n=new T.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,I,w),E=this.productService.tasConfig,d=new(await new Promise((p,h)=>{X(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[n],telemetry:this.telemetry,storageKey:T.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:T.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=R;class D extends R{constructor(w,I,n){super(()=>Promise.resolve(w),I,n,new P)}}e.AssignmentService=D}),define(te[208],ne([0,1,16,28,7,26,4,31,8,21,11,30,36,77,14,10,27,44,46,23,22,45]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const i=D.isWeb?"web":(0,E.getTargetPlatform)(D.platform,C.arch);var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...G){return String(G.reduce((H,re)=>H|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class b{constructor(H=g){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new b({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new b({...this.state,criteria:ie})}withSortBy(H){return new b({...this.state,sortBy:H})}withSortOrder(H){return new b({...this.state,sortOrder:H})}withFlags(...H){return new b({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new b({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:fe,flags:de}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function U(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=L(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function O(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===a.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return L(G,a.Repository)}function q(G){return{uri:`${G.fallbackAssetUri}/${a.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${a.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=L(G,a.Icon);if(H)return H;const re=E.DefaultIconPath;return{uri:re,fallbackUri:re}}function L(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function $(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,d.adoptToGalleryExtensionId)(ce)):[]}function _(G){const H=G.properties?G.properties.filter(re=>re.key===o.Engine):[];return H.length>0&&H[0].value||""}function M(G){const H=G.properties?G.properties.filter(ie=>ie.key===o.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function j(G){return G.indexOf("preview")!==-1}function W(G){return G.targetPlatform?(0,E.toTargetPlatform)(G.targetPlatform):"undefined"}function x(G){const H=(0,k.distinct)(G.versions.map(W)),re=!!G.tags?.includes(E.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function z(G,H){const re=(0,E.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const de=W(ce);if(de===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(de))for(;le>0&&G[le-1].version===ce.version&&W(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=z;function K(G,H,re,ie,ce){const le=x(G);let de=G.versions[0];return de=G.versions.find(fe=>fe.version===de.version&&(0,E.isTargetPlatformCompatible)(W(fe),le,ce))||de,F(G,de,le,H,re,ie)}function F(G,H,re,ie,ce,le){const de={manifest:L(H,a.Manifest),readme:L(H,a.Details),changelog:L(H,a.Changelog),license:L(H,a.License),repository:O(H),download:q(H),icon:N(H),coreTranslations:U(H)};return{identifier:{id:(0,d.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:A(G.statistics,"install"),rating:A(G.statistics,"averagerating"),ratingCount:A(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:de,properties:{dependencies:$(H,o.Dependency),extensionPack:$(H,o.ExtensionPack),engine:_(H),localizedLanguages:M(H),targetPlatform:W(H)},preview:j(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(H,re,ie,ce,le,de,fe,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=de,this.productService=fe,this.configurationService=be;const Ce=fe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(fe.version,fe,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...H.map(({id:de})=>de.toLowerCase()));H.every(de=>!de.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,i,T.CancellationToken.None);for(let de=0;de<le.length;de++){const fe=le[de];if(!fe.versions.length)continue;const be=(0,d.getGalleryExtensionId)(fe.publisher.publisherName,fe.extensionName),Ce=H.find(Ee=>(0,d.areSameExtensions)(Ee,{id:be}))?.version;if(Ce){const Ee=fe.versions.find(Ae=>Ae.version===Ce);Ee&&ie.push(F(fe,Ee,x(fe),de,ce))}else ie.push(K(fe,de,ce,void 0,i))}return ie}async getCompatibleExtension(H,re){const ie=(0,E.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,E.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let de=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?de=de.withFilter(t.ExtensionId,le):de=de.withFilter(t.ExtensionName,ce);const{galleryExtensions:fe}=await this.queryGallery(de,re,T.CancellationToken.None),[be]=fe;if(!be||!be.versions.length)return null;const Ce=x(be);if((0,E.isNotWebExtensionInWebTargetPlatform)(Ce,re))return null;for(let Ee of be.versions){if(!_(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,re))return F(be,Ee,Ce,0,de)}return null}async isExtensionCompatible(H,re){if(!(0,E.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,p.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,E.isTargetPlatformCompatible)(W(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=T.CancellationToken.isCancellationToken(H)?{}:H,ce=T.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const de=(0,R.getOrDefault)(ie,Pe=>Pe.pageSize,50);let fe=new b().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,de).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(fe=fe.withFilter(t.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(fe=fe.withFilter(t.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),fe=fe.withFilter(t.SearchText,le)),fe=fe.withSortBy(0)):ie.ids?fe=fe.withFilter(t.ExtensionId,...ie.ids):ie.names?fe=fe.withFilter(t.ExtensionName,...ie.names):fe=fe.withSortBy(4),typeof ie.sortBy=="number"&&(fe=fe.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(fe=fe.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ce}=await this.queryGallery(fe,i,ce),Ee=be.map((Pe,Le)=>K(Pe,Le,fe,ie.source,i)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,P.canceled)();const Fe=fe.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,i,Le);return Ne.map(($e,xe)=>K($e,xe,Fe,ie.source,i))};return{firstPage:Ee,total:Ce,pageSize:fe.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,r(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),de={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},fe=new Date().getTime();let be,Ce,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:de},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,m.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Ne=>z(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ce=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-fe,success:!!be&&(0,m.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ce?(0,P.isPromiseCanceledError)(Ce)?"canceled":(0,P.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=D.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),de=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:le,headers:be},T.CancellationToken.None)}catch(Ce){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,d.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),de=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),fe=ie===1?"install":ie===2?"update":"",be=fe?{uri:`${H.assets.download.uri}${w.URI.parse(H.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${H.assets.download.fallbackUri}${w.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:H.assets.download,Ce=await this.getAsset(be);await this.fileService.writeFile(re,Ce.stream),de(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,m.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,m.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=L(H,a.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,m.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,m.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,m.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new b().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(t.ExtensionId,H.identifier.uuid):ie=ie.withFilter(t.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const le=x(ce[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const de=[];for(const fe of ce[0].versions)try{de[de.length-1]?.version!==fe.version&&await this.isRawExtensionVersionCompatible(fe,le,re)&&de.push({version:fe.version,date:fe.lastUpdated})}catch(be){}return de}async getAsset(H,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},de={...ce,...re.headers||{}};re={...re,...le,headers:de};const fe=H.uri,be=H.fallbackUri,Ce={...re,url:fe};try{const Ee=await this.requestService.request(Ce,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,m.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,P.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,P.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=_(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,m.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([J(1,m.IRequestService),J(2,y.ILogService),J(3,n.IEnvironmentService),J(4,c.ITelemetryService),J(5,h.IFileService),J(6,S.IProductService),J(7,I.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ce,le,de,fe,be){super(H,re,ie,ce,le,de,fe,be)}};V=he([J(0,f.IStorageService),J(1,m.IRequestService),J(2,y.ILogService),J(3,n.IEnvironmentService),J(4,c.ITelemetryService),J(5,h.IFileService),J(6,S.IProductService),J(7,I.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ce,le,de,fe){super(void 0,H,re,ie,ce,le,de,fe)}};Q=he([J(0,m.IRequestService),J(1,y.ILogService),J(2,n.IEnvironmentService),J(3,c.ITelemetryService),J(4,h.IFileService),J(5,S.IProductService),J(6,I.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const de={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},fe=await(0,v.getServiceMachineId)(re,ce,le);return(0,l.supportsTelemetry)(H,re)&&(0,l.getTelemetryLevel)(ie)===3&&(de["X-Market-User-Id"]=fe),de}e.resolveMarketplaceHeaders=Z}),define(te[94],ne([0,1,2,11,10,45]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let D=class extends k.Disposable{constructor(w,I,n=""){super();this.prefix=n;const E=w.getLogger(I.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(w.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(w,I){this.logger.trace(`${this.prefix}telemetry/${w}`,(0,R.validateTelemetryData)(I))}};D=he([J(0,P.ILoggerService),J(1,T.IEnvironmentService)],D),e.TelemetryLogAppender=D}),define(te[95],ne([0,1,2,26,4,25,144,21,39,87,35,22,45]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(S,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const f=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(S,m){this._experimentProperties[S]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const S=await this._commonProperties;let m=S.sessionID,v=S["common.instanceId"],f=S["common.machineId"],c=S["common.firstSessionDate"],l=S["common.msftInternal"];return{sessionId:m,instanceId:v,machineId:f,firstSessionDate:c,msftInternal:l}}dispose(){this._disposables.dispose()}_log(S,m,v,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{v=(0,T.mixin)(v,c),v=(0,T.mixin)(v,this._experimentProperties),v=(0,T.cloneAndChange)(v,l=>{if(typeof l=="string")return this._cleanupInfo(l,f)}),this._appenders.forEach(l=>l.log(S,v))},c=>{console.error(c)})}publicLog(S,m,v){return this._log(S,3,m,v)}publicLog2(S,m,v){return this.publicLog(S,m,v)}publicLogError(S,m){return this.sendErrorTelemetry?this._log(S,2,m,!0):Promise.resolve(void 0)}publicLogError2(S,m){return this.publicLogError(S,m)}_anonymizeFilePaths(S){let m=S;const v=[];for(let i of this._cleanupPatterns)for(;;){const s=i.exec(S);if(!s)break;v.push([s.index,i.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const i=c.exec(S);if(!i)break;!f.test(i[0])&&v.every(([s,r])=>i.index<s||i.index>=r)&&(m+=S.substring(l,i.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<S.length&&(m+=S.substr(l)),m}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const m=S.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":v.test(m)?"<REDACTED: email>":S}_cleanupInfo(S,m){let v=S;m&&(v=this._anonymizeFilePaths(v));for(let f of this._cleanupPatterns)v=v.replace(f,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([J(1,C.IConfigurationService)],p),e.TelemetryService=p;function h(){const y=(0,D.localize)(0,null,I.default.nameLong),S=I.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",I.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=P.isWeb?"":(0,D.localize)(3,null),v=(0,D.localize)(4,null),f=(0,D.localize)(5,null),c=(0,D.localize)(6,null),l=(0,D.localize)(7,null),i=`
|       | ${v} | ${f} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,D.localize)(8,null);return`
${y} ${S} ${m}

&nbsp;

${l}
${i}

&nbsp;

${s}
`}n.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(w.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:I.default.privacyStatementUrl?(0,D.localize)(16,null,I.default.nameLong,I.default.privacyStatementUrl):(0,D.localize)(15,null,I.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[209],ne([0,1,7,26,45]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(C,w){const I=await new Promise((E,d)=>{X(["applicationinsights"],E,d)});let n;return I.defaultClient?(n=new I.TelemetryClient(C),n.channel.setUseDiskRetryCaching(!0)):(I.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),n=I.defaultClient),C.indexOf("AIF-")===0&&(n.config.endpointUrl=w?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),n}class D{constructor(w,I,n,E,d){this._eventPrefix=w,this._defaultData=I,this.testCollector=E,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(w){if(!!this._aiClient){if(typeof this._aiClient!="string"){w(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(I=>{w(I)},I=>{(0,k.onUnexpectedError)(I),console.error(I)})}}log(w,I){!this._aiClient||(I=(0,T.mixin)(I,this._defaultData),I=(0,P.validateTelemetryData)(I),this.testCollector&&(I.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+w,properties:I.properties,measurements:I.measurements})))}flush(){return this._aiClient?new Promise(w=>{this._withAIClient(I=>{I.flush({callback:()=>{this._aiClient=void 0,w(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=D}),define(te[210],ne([0,1,15,52,21,11,10,22,93,94,95]),function(X,e,k,T,P,R,D,C,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,y,S){this.configurationService=p,this.telemetryService=h,this.loggerService=y,this.environmentService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),S=Object.create(null);S["common.vscodemachineid"]=h,S["common.vscodesessionid"]=y;const m=[p.id,JSON.stringify(S),p.aiKey],f=new T.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new w.TelemetryAppenderClient(f),new I.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new n.TelemetryService({appenders:c,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,y){await(await this.getCustomTelemetryService(p)).publicLog(h,y)}async publicLogError(p,h,y){await(await this.getCustomTelemetryService(p)).publicLogError(h,y)}};E=he([J(0,P.IConfigurationService),J(1,C.ITelemetryService),J(2,D.ILoggerService),J(3,R.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[211],ne([0,1,5,28,3,2,10]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends R.Disposable{constructor(I,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new P.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((n,E)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,n),this._onCreateRequest.fire({requestId:d,...I});const p=new T.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>E(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,R.toDisposable)(()=>p.cancel())])})}acceptReply(I,n){const E=this._pendingRequests.get(I);E?(this._pendingRequests.delete(I),(0,R.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),E(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};C=he([J(1,D.ILogService)],C),e.RequestStore=C}),define(te[96],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(S){S.Shell="terminal.integrated.shell.",S.ShellArgs="terminal.integrated.shellArgs.",S.DefaultProfile="terminal.integrated.defaultProfile.",S.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var P;(function(S){S.ShellLinux="terminal.integrated.shell.linux",S.ShellMacOs="terminal.integrated.shell.osx",S.ShellWindows="terminal.integrated.shell.windows",S.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",S.AutomationShellLinux="terminal.integrated.automationShell.linux",S.AutomationShellMacOs="terminal.integrated.automationShell.osx",S.AutomationShellWindows="terminal.integrated.automationShell.windows",S.AutomationProfileLinux="terminal.integrated.automationProfile.linux",S.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",S.AutomationProfileWindows="terminal.integrated.automationProfile.windows",S.ShellArgsLinux="terminal.integrated.shellArgs.linux",S.ShellArgsMacOs="terminal.integrated.shellArgs.osx",S.ShellArgsWindows="terminal.integrated.shellArgs.windows",S.ProfilesWindows="terminal.integrated.profiles.windows",S.ProfilesMacOs="terminal.integrated.profiles.osx",S.ProfilesLinux="terminal.integrated.profiles.linux",S.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",S.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",S.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",S.UseWslProfiles="terminal.integrated.useWslProfiles",S.TabsEnabled="terminal.integrated.tabs.enabled",S.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",S.TabsHideCondition="terminal.integrated.tabs.hideCondition",S.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",S.TabsShowActions="terminal.integrated.tabs.showActions",S.TabsLocation="terminal.integrated.tabs.location",S.TabsFocusMode="terminal.integrated.tabs.focusMode",S.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",S.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",S.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",S.CopyOnSelection="terminal.integrated.copyOnSelection",S.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",S.FontFamily="terminal.integrated.fontFamily",S.FontSize="terminal.integrated.fontSize",S.LetterSpacing="terminal.integrated.letterSpacing",S.LineHeight="terminal.integrated.lineHeight",S.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",S.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",S.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",S.BellDuration="terminal.integrated.bellDuration",S.FontWeight="terminal.integrated.fontWeight",S.FontWeightBold="terminal.integrated.fontWeightBold",S.CursorBlinking="terminal.integrated.cursorBlinking",S.CursorStyle="terminal.integrated.cursorStyle",S.CursorWidth="terminal.integrated.cursorWidth",S.Scrollback="terminal.integrated.scrollback",S.DetectLocale="terminal.integrated.detectLocale",S.DefaultLocation="terminal.integrated.defaultLocation",S.GpuAcceleration="terminal.integrated.gpuAcceleration",S.TerminalTitleSeparator="terminal.integrated.tabs.separator",S.TerminalTitle="terminal.integrated.tabs.title",S.TerminalDescription="terminal.integrated.tabs.description",S.RightClickBehavior="terminal.integrated.rightClickBehavior",S.Cwd="terminal.integrated.cwd",S.ConfirmOnExit="terminal.integrated.confirmOnExit",S.ConfirmOnKill="terminal.integrated.confirmOnKill",S.EnableBell="terminal.integrated.enableBell",S.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",S.AllowChords="terminal.integrated.allowChords",S.AllowMnemonics="terminal.integrated.allowMnemonics",S.EnvMacOs="terminal.integrated.env.osx",S.EnvLinux="terminal.integrated.env.linux",S.EnvWindows="terminal.integrated.env.windows",S.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",S.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",S.ShowExitAlert="terminal.integrated.showExitAlert",S.SplitCwd="terminal.integrated.splitCwd",S.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",S.WordSeparators="terminal.integrated.wordSeparators",S.EnableFileLinks="terminal.integrated.enableFileLinks",S.UnicodeVersion="terminal.integrated.unicodeVersion",S.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",S.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",S.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",S.LocalEchoStyle="terminal.integrated.localEchoStyle",S.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",S.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",S.CustomGlyphs="terminal.integrated.customGlyphs",S.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",S.InheritEnv="terminal.integrated.inheritEnv",S.ShowLinkHover="terminal.integrated.showLinkHover",S.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(P=e.TerminalSettingId||(e.TerminalSettingId={}));var R;(function(S){S.CommandPrompt="cmd",S.PowerShell="pwsh",S.Wsl="wsl",S.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var D;(function(S){S[S.Api=0]="Api",S[S.Process=1]="Process",S[S.Sequence=2]="Sequence",S[S.Config=3]="Config"})(D=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(S){S.LocalPty="localPty",S.PtyHost="ptyHost",S.Log="log",S.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var w;(function(S){S.Cwd="cwd",S.InitialCwd="initialCwd",S.FixedDimensions="fixedDimensions",S.Title="title",S.ShellType="shellType",S.HasChildProcesses="hasChildProcesses",S.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",S.OverrideDimensions="overrideDimensions"})(w=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(S){S[S.BeatInterval=5e3]="BeatInterval",S[S.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",S[S.SecondWaitMultiplier=1]="SecondWaitMultiplier",S[S.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(S){S[S.Panel=1]="Panel",S[S.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(S){S.TerminalView="view",S.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(S){S.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(S){S[S.GraceTime=6e4]="GraceTime",S[S.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(S){S[S.HighWatermarkChars=1e5]="HighWatermarkChars",S[S.LowWatermarkChars=5e3]="LowWatermarkChars",S[S.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(S){S.GitBash="Git Bash",S.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(te[212],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[213],ne([0,1,33,26,9,4,31,17,20]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function I(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let d=0;return E&&E.length===4&&(d=parseInt(E[3])),d}e.getWindowsBuildNumber=I;async function n(E,d,p,h=D.env,y=w.Promises.exists){if(P.isAbsolute(E))return await y(E)?E:void 0;if(d===void 0&&(d=D.cwd()),P.dirname(E)!=="."){const f=P.join(d,E);return await y(f)?f:void 0}const m=(0,T.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,C.isString)(m)&&(p=m.split(P.delimiter)),p===void 0||p.length===0){const f=P.join(d,E);return await y(f)?f:void 0}for(let f of p){let c;if(P.isAbsolute(f)?c=P.join(f,E):c=P.join(d,f,E),await y(c))return c;if(R.isWindows){let l=c+".com";if(await y(l)||(l=c+".exe",await y(l)))return l}}const v=P.join(d,E);return await y(v)?v:void 0}e.findExecutable=n}),define(te[214],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[97],ne([0,1,49,3,2,6,35,214]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var w;(function(S){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}S.isThemeColor=m})(w=e.ThemeColor||(e.ThemeColor={}));function I(S){return{id:S}}e.themeColorFromId=I;var n;(function(S){function m(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||w.isThemeColor(s.color))}S.isThemeIcon=m;const v=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function f(s){const r=v.exec(s);if(!r)return;let[,t]=r;return{id:t}}S.fromString=f;function c(s,r){let t=s.id;const a=t.lastIndexOf("~");return a!==-1&&(t=t.substring(0,a)),r&&(t=`${t}~${r}`),{id:t}}S.modify=c;function l(s,r){return s.id===r.id&&s.color?.id===r.color?.id}S.isEqual=l;function i(s,r){return{id:s.id,color:r?I(r):void 0}}S.asThemeIcon=i,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function E(S){switch(S){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,P.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;D.Registry.add(e.Extensions.ThemingContribution,p);function h(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=h;class y extends P.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let f=this.theme.getColor(m);return f&&v&&(f=v(f,this.theme)),f?f.toString():null}}e.Themable=y}),define(te[215],ne([0,1,49,8,97]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(E,d){const p=E.map(h=>({name:h.profileName,description:D(h)}));return d&&p.push(...d.map(h=>({name:h.title,description:C(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=R;function D(E){let d=`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?d+=`
- args: "${E.args}"`:d+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(d+=`
- overrideName: ${E.overrideName}`),E.color&&(d+=`
- color: ${E.color}`),E.env&&(d+=`
- env: ${JSON.stringify(E.env)}`),d}function C(E){return`$(${P.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:k.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function w(E,d){if(!E&&!d)return!0;if(typeof E=="string"&&typeof d=="string")return E===d;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=w;function I(E,d){if(!E&&!d)return!0;if(!E||!d)return!1;if(P.ThemeIcon.isThemeIcon(E)&&P.ThemeIcon.isThemeIcon(d))return E.id===d.id&&E.color===d.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const p=E,h=d;if((T.URI.isUri(p.light)||n(p.light))&&(T.URI.isUri(p.dark)||n(p.dark))&&(T.URI.isUri(h.light)||n(h.light))&&(T.URI.isUri(h.dark)||n(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(T.URI.isUri(E)&&T.URI.isUri(d)||n(E)||n(d)){const p=E,h=d;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=I;function n(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=n}),define(te[216],ne([0,1,49,145,39,35,215]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,f=>f.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,f=>`$(${f.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},I=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),E=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,T.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,T.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,T.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),y={id:"terminal",order:100,title:(0,T.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,T.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,T.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},w]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(25,null)}},{type:"string",markdownDescription:(0,T.localize)(26,null)}],default:[],markdownDeprecationMessage:E},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(28,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(29,null),type:"string"},id:{description:(0,T.localize)(30,null),type:"string"},title:{description:(0,T.localize)(31,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(33,null),type:"string"},id:{description:(0,T.localize)(34,null),type:"string"},title:{description:(0,T.localize)(35,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(37,null),type:"string"},id:{description:(0,T.localize)(38,null),type:"string"},title:{description:(0,T.localize)(39,null),type:"string"},...C}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function S(){R.Registry.as(P.Extensions.Configuration).registerConfiguration(y),v()}e.registerTerminalPlatformConfiguration=S;let m;function v(f,c){const l=R.Registry.as(P.Extensions.Configuration);let i;f&&(i=(0,D.createProfileSchemaEnums)(f?.profiles,c));const s=m;m={id:"terminal",order:100,title:(0,T.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?i?.values:void 0,markdownEnumDescriptions:f?.os===3?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?i?.values:void 0,markdownEnumDescriptions:f?.os===2?i?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?i?.values:void 0,markdownEnumDescriptions:f?.os===1?i?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:s?[s]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(te[217],ne([0,1,43,49,9,4,20,71,213,97]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n,E=!0;function d(s,r,t,a,o=process.env,u,g,b,A){return u=u||{existsFile:D.SymlinkSupport.existsFile,readFile:D.Promises.readFile},R.isWindows?p(t,u,o,g,a.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:a.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:a.getValue("terminal.integrated.defaultProfile.windows"),A,b):c(u,g,t,s&&typeof s=="object"?{...s}:a.getValue(R.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:a.getValue(R.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,b,o)}e.detectAvailableProfiles=d;async function p(s,r,t,a,o,u,g,b,A){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let q=!1;(0,w.getWindowsBuildNumber)()>=16299&&(q=!0),await S(b);const N=new Map;s&&(N.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),l(u,N);const L=await h(N.entries(),g,r,t,a,A);if(s||!s&&o)try{const $=await v(`${O}\\${q?"wsl":"bash"}.exe`,g);for(const _ of $)(!u||!(_.profileName in u))&&L.push(_)}catch($){E&&(a?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return L}async function h(s,r,t,a=process.env,o,u){const g=[];for(const[b,A]of s){if(A===null)continue;let U,O,q;if("source"in A){const $=n?.get(A.source);if(!$)continue;U=$.paths,O=A.args||$.args,A.icon?q=y(A.icon):$.icon&&(q=$.icon)}else U=Array.isArray(A.path)?A.path:[A.path],O=R.isWindows||Array.isArray(A.args)?A.args:void 0,q=y(A.icon)||void 0;const N=await u?.(U)||U.slice(),L=await i(b,r,N,t,a,O,A.env,A.overrideName,A.isAutoDetected,o);L?(L.isAutoDetected=A.isAutoDetected,L.icon=q,L.color=A.color,g.push(L)):o?.trace("profile not validated",b,U)}return g}function y(s){return typeof s=="string"?{id:s}:s}async function S(s){n&&!s||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:I.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const r of(0,C.enumeratePowerShellInstallations)())s.push(r.exePath);return s}async function v(s,r){const t=[],a=await new Promise((g,b)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(A,U)=>{if(A)return b("Problem occurred when getting wsl distros");g(U)})});if(!a)return[];const o=new RegExp(/[\r?\n]/),u=a.split(o).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const b=`${g} (WSL)`,A={profileName:b,path:s,args:["-d",`${g}`],isDefault:b===r,icon:f(g)};t.push(A)}return t}function f(s){return s.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):s.includes("Debian")?I.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function c(s,r,t,a,o,u,g,b){const A=new Map;if(t){const U=(await s.readFile("/etc/shells")).toString(),O=u||U.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),q=new Map;for(const N of O){let L=(0,P.basename)(N),$=q.get(L)||0;$++,$>1&&(L=`${L} (${$})`),q.set(L,$),A.set(L,{path:N,isAutoDetected:!0})}}return l(a,A),await h(A.entries(),o,s,b,r,g)}function l(s,r){if(!!s)for(const[t,a]of Object.entries(s))a===null||!("path"in a)&&!("source"in a)?r.delete(t):r.set(t,a)}async function i(s,r,t,a,o,u,g,b,A,U){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return i(s,r,t,a,o,u,g,b,A);const q={profileName:s,path:O,args:u,env:g,overrideName:b,isAutoDetected:A,isDefault:s===r};if((0,P.basename)(O)===O){const L=o.PATH?o.PATH.split(P.delimiter):void 0;return await(0,w.findExecutable)(O,void 0,L,void 0,a.existsFile)?q:i(s,r,t,a,o,u)}return await a.existsFile((0,P.normalize)(O))?q:i(s,r,t,a,o,u,g,b,A)}}),define(te[218],ne([0,1,3,2,15,4,34,52,21,11,76,167,10,86,22,211,96,216,217]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(i){i[i.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,l=class extends T.Disposable{constructor(s,r,t,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(R.isWindows)return process.env;try{return await(0,E.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new C.Client(P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,s);this._onPtyHostStart.fire(),D.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=D.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(g=>this._onProcessData.fire(g))),this._register(u.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(u.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(u.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(u.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(u.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(u.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,a,o,u,g,b,A,U,O){const q=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(s,r,t,a,o,u,g,b,A,U,O);return clearTimeout(q),c=Math.max(c,N),N}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,a=!1){const o=await this._shellEnv;return(0,v.detectAvailableProfiles)(r,t,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};l=he([J(1,w.IConfigurationService),J(2,I.IEnvironmentService),J(3,d.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[37],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[219],ne([0,1,3,2,8,11,36,14,10,37]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends T.Disposable{constructor(d,p,h,y,S){super();this.extensionsManagementService=d,this.logService=y,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(v=>this.onInstallExtension(v))),this._register(d.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(d.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const m=P.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(k.Event.filter(p.onDidChangeFilesRaw,v=>v.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(d,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),p)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const p of d)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(p=>!(0,D.areSameExtensions)(p,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,D.areSameExtensions)(p,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),p=d.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,D.areSameExtensions)(S,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(S=>(0,D.areSameExtensions)(S,y))?!1:d.every(S=>!(0,D.areSameExtensions)(S.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=d.map(y=>y.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};n=he([J(1,C.IFileService),J(2,R.INativeEnvironmentService),J(3,w.ILogService),J(4,I.IUriIdentityService)],n),e.ExtensionsWatcher=n}),define(te[220],ne([0,1,37,59,14,18,104,3,2]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(d){this.uri=d,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let n=class{constructor(d){this._fileService=d,this._dispooables=new w.DisposableStore,this._limit=2**16;const p=new Map,h=y=>{let S=p.get(y.scheme);return S===void 0&&(S=d.hasProvider(y)&&!this._fileService.hasCapability(y,1024),p.set(y.scheme,S)),S};this._dispooables.add(C.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{p.delete(y.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new D.SkipList((y,S)=>this.extUri.compare(y,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,R.normalizePath)(d));let p=this._canonicalUris.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new I(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};n=he([J(0,P.IFileService)],n),e.UriIdentityService=n,(0,T.registerSingleton)(k.IUriIdentityService,n,!0)}),define(te[55],ne([0,1,40]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(D,C,w,I){const n=(0,k.setProperty)(D,C,w,I)[0];return n&&(D=D.substring(0,n.offset)+n.content+D.substring(n.offset+n.length)),D}e.edit=T;function P(D,C,w){let I=w;for(;I>=0;){if(D.charAt(I)===C.charAt(C.length-1)&&C.length===1)return I+1;if(I--,C.length===2&&I>=0&&D.charAt(I)===C.charAt(0))return I+2}return 0}e.getLineStartOffset=P;function R(D,C,w){let I=w;for(;I>=0;)if(D.charAt(I)===C.charAt(C.length-1)&&C.length===1||(I++,C.length===2&&I>=0&&D.charAt(I)===C.charAt(1)))return I;return D.length-1}e.getLineEndOffset=R}),define(te[221],ne([0,1,26,62]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(E,d,p,h,y){const S=[],m=[],v=[];if(!d){const U=E.filter(({identifier:O})=>y.every(q=>q.toLowerCase()!==O.id.toLowerCase()));return{local:{added:S,removed:m,updated:v},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}E=E.map(I),d=d.map(I),p=p?p.map(I):null;const f=new Map,c=U=>{U.uuid&&f.set(U.id.toLowerCase(),U.uuid)};E.forEach(({identifier:U})=>c(U)),d.forEach(({identifier:U})=>c(U)),p&&p.forEach(({identifier:U})=>c(U));const l=U=>{const O=U.identifier.uuid||f.get(U.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${U.identifier.id.toLowerCase()}`},i=(U,O)=>(U.set(l(O),O),U),s=E.reduce(i,new Map),r=d.reduce(i,new Map),t=d.reduce((U,O)=>{const q=l(O);O=(0,k.deepClone)(O);const N=s.get(q);return N&&(N.installed&&(O.installed=!0),O.version||(O.version=N.version)),i(U,O)},new Map),a=p?p.reduce(i,new Map):null,o=h.reduce(i,new Map),u=y.reduce((U,O)=>{const q=f.get(O.toLowerCase());return U.add(q?`uuid:${q}`:`id:${O.toLowerCase()}`)},new Set),g=R(s,r,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const U=R(a,s,u),O=R(a,r,u),q=(N,L)=>{const $=s.get(N);if($){const _=r.get(N);return{...L?_:$,version:(_.version&&T.gt(_.version,$.version),$.version),state:D($,_,a?.get(N))}}};for(const N of O.removed.values()){const L=s.get(N);L&&m.push(L.identifier)}for(const N of O.added.values())if(U.added.has(N)){if(g.updated.has(N)){const L=q(N,!0);L&&(v.push(n(L,N)),t.set(N,L))}}else{const L=r.get(N);L.installed&&S.push(n(L,N))}for(const N of O.updated.values()){const L=q(N,!0);L&&(v.push(n(L,N)),t.set(N,L))}for(const N of U.added.values())O.added.has(N)||t.set(N,s.get(N));for(const N of U.updated.values())if(!O.removed.has(N)&&!O.updated.has(N)){const L=q(N,!1);L&&(t.get(N)?.installed&&(L.installed=!0),t.set(N,L))}for(const N of U.removed.values())!o.has(N)&&!O.updated.has(N)&&a?.get(N)?.installed&&t.delete(N)}const b=[],A=R(r,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&t.forEach((U,O)=>b.push(n(U,O))),{local:{added:S,removed:m,updated:v},remote:b.length?{added:[...A.added].map(U=>t.get(U)),updated:[...A.updated].map(U=>t.get(U)),removed:[...A.removed].map(U=>r.get(U)),all:b}:null}}e.merge=P;function R(E,d,p,{checkInstalledProperty:h,checkVersionProperty:y}={checkInstalledProperty:!1,checkVersionProperty:!1}){const S=E?[...E.keys()].filter(l=>!p.has(l)):[],m=[...d.keys()].filter(l=>!p.has(l)),v=m.filter(l=>S.indexOf(l)===-1).reduce((l,i)=>(l.add(i),l),new Set),f=S.filter(l=>m.indexOf(l)===-1).reduce((l,i)=>(l.add(i),l),new Set),c=new Set;for(const l of S){if(f.has(l))continue;const i=E.get(l),s=d.get(l);(!s||i.disabled!==s.disabled||!w(i.state,s.state)||y&&i.version!==s.version||h&&i.installed!==s.installed)&&c.add(l)}return{added:v,removed:f,updated:c}}function D(E,d,p){const h=E.state,y=d.state,S=p?.state;if(!d.version||h&&T.gt(E.version,d.version))return h;if(y&&T.gt(d.version,E.version)||!h)return y;if(!y)return h;const m=(0,k.deepClone)(h),v=S?C(S,y):{added:Object.keys(y).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set},f=S?C(S,h):{added:Object.keys(h).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set};for(const c of[...v.added.values(),...v.updated.values()])m[c]=y[c];for(const c of v.removed.values())f.updated.has(c)||delete m[c];return m}function C(E,d){const p=Object.keys(E),h=Object.keys(d),y=h.filter(v=>p.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),S=p.filter(v=>h.indexOf(v)===-1).reduce((v,f)=>(v.add(f),v),new Set),m=new Set;for(const v of p){if(S.has(v))continue;const f=E[v],c=d[v];(0,k.equals)(f,c)||m.add(v)}return{added:y,removed:S,updated:m}}function w(E={},d={}){const{added:p,removed:h,updated:y}=C(E,d);return p.size===0&&h.size===0&&y.size===0}function I(E){return{...E,disabled:!!E.disabled,installed:!!E.installed}}function n(E,d){const p={identifier:{id:E.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return E.version&&(p.version=E.version),E.disabled&&(p.disabled=!0),E.installed&&(p.installed=!0),E.state&&(p.state=E.state),p}}),define(te[98],ne([0,1,16,3,2,36,6,27,23]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,D.createDecorator)("IExtensionsStorageSyncService");const I=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class it extends P.Disposable{constructor(d,p){super();this.storageService=d,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=I.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const d=this.storageService.keys(0,1);for(const p of d){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(d.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,p){this.storageService.store(it.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),y=h?JSON.parse(h):void 0;return y&&p?(0,k.distinct)([...y,...p]):y||p}};n=he([J(0,w.IStorageService),J(1,C.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[99],ne([0,1,16,21,6]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,P.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,w){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return I=I.filter(n=>n!==C&&n!==`-${C}`),w&&I.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}updateSynchronizedExtensions(C,w){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return I=I.filter(n=>n!==C&&n!==`-${C}`),w&&I.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,1)}getIgnoredExtensions(C){const w=C.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),n=[],E=[];if(Array.isArray(I))for(const d of I)d.startsWith("-")?E.push(d.substring(1)):n.push(d);return(0,k.distinct)([...w,...n].filter(d=>E.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(w=>w.toLowerCase())}};R=he([J(0,T.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(te[222],ne([0,1,16,32,26,162,55]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(c){return(0,T.parse)(c)||[]}e.parseKeybindings=C;async function w(c,l,i,s,r){const t=C(c),a=C(l),o=i?C(i):null,u=[...t,...a,...o||[]].map(M=>M.key),g=await r.resolveUserBindings(u);let b=n(t,a,o,g);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=d(t),U=d(a),O=o?d(o):null,q=h(A,U,g),N=O?h(O,A,g):{added:[...A.keys()].reduce((M,j)=>(M.add(j),M),new Set),removed:new Set,updated:new Set},L=O?h(O,U,g):{added:[...U.keys()].reduce((M,j)=>(M.add(j),M),new Set),removed:new Set,updated:new Set},$=I(q,N,L);let _=c;for(const M of $.removed.values())$.conflicts.has(M)||(_=v(_,M,s));for(const M of $.added.values()){if($.conflicts.has(M))continue;const j=U.get(M);if(j.some(W=>W.command!==`-${M}`&&b.conflicts.has(g[W.key]))){$.conflicts.add(M);continue}_=m(_,j,s)}for(const M of $.updated.values()){if($.conflicts.has(M))continue;const j=U.get(M);if(j.some(W=>W.command!==`-${M}`&&b.conflicts.has(g[W.key]))){$.conflicts.add(M);continue}_=f(_,M,j,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=w;function I(c,l,i){const s=new Set,r=new Set,t=new Set,a=new Set;for(const o of l.removed.values())i.updated.has(o)&&a.add(o);for(const o of i.removed.values())a.has(o)||(l.updated.has(o)?a.add(o):r.add(o));for(const o of l.added.values())a.has(o)||i.added.has(o)&&c.updated.has(o)&&a.add(o);for(const o of i.added.values())a.has(o)||(l.added.has(o)?c.updated.has(o)&&a.add(o):s.add(o));for(const o of l.updated.values())a.has(o)||i.updated.has(o)&&c.updated.has(o)&&a.add(o);for(const o of i.updated.values())a.has(o)||(l.updated.has(o)?c.updated.has(o)&&a.add(o):t.add(o));return{added:s,removed:r,updated:t,conflicts:a}}function n(c,l,i,s){const r=new Set,t=E(c,s),a=E(l,s),o=i?E(i,s):null,u=p(t,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const g=o?p(o,t):{added:[...t.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const b=o?p(o,a):{added:[...a.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:A,removed:U,updated:O,conflicts:q}=I(u,g,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:U,updated:O,conflicts:q}}function E(c,l){const i=new Map;for(const s of c){const r=l[s.key];let t=i.get(r);t||(t=[],i.set(r,t)),t.push(s)}return i}function d(c){const l=new Map;for(const i of c){const s=i.command[0]==="-"?i.command.substring(1):i.command;let r=l.get(s);r||(r=[],l.set(s,r)),r.push(i)}return l}function p(c,l){const i=[...c.keys()],s=[...l.keys()],r=s.filter(o=>i.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),t=i.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of i){if(t.has(o))continue;const u=c.get(o).map(b=>({...b,key:o})),g=l.get(o).map(b=>({...b,key:o}));(0,k.equals)(u,g,(b,A)=>S(b,A))||a.add(o)}return{added:r,removed:t,updated:a}}function h(c,l,i){const s=[...c.keys()],r=[...l.keys()],t=r.filter(u=>s.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const g=c.get(u).map(A=>({...A,key:i[A.key]})),b=l.get(u).map(A=>({...A,key:i[A.key]}));y(g,b)||o.add(u)}return{added:t,removed:a,updated:o}}function y(c,l){return!(!(0,k.equals)(c.filter(({command:i})=>i[0]!=="-"),l.filter(({command:i})=>i[0]!=="-"),(i,s)=>S(i,s))||!(0,k.equals)(c.filter(({command:i})=>i[0]==="-"),l.filter(({command:i})=>i[0]==="-"),(i,s)=>S(i,s)))}function S(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const i=R.ContextKeyExpr.deserialize(c.when),s=R.ContextKeyExpr.deserialize(l.when);return!(i&&!s||!i&&s||i&&s&&!i.equals(s)||!P.equals(c.args,l.args))}function m(c,l,i){for(const s of l)c=D.edit(c,[-1],s,i);return c}function v(c,l,i){const s=C(c);for(let r=s.length-1;r>=0;r--)(s[r].command===l||s[r].command===`-${l}`)&&(c=D.edit(c,[r],void 0,i));return c}function f(c,l,i,s){const r=C(c),t=r.findIndex(a=>a.command===l||a.command===`-${l}`);for(let a=r.length-1;a>=0;a--)(r[a].command===l||r[a].command===`-${l}`)&&(c=D.edit(c,[a],void 0,s));for(let a=i.length-1;a>=0;a--)c=D.edit(c,[t],i[a],s);return c}}),define(te[223],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(R,D,C){const w={},I={},n=new Set;if(!D)return{local:{added:w,updated:I,removed:[...n.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const E=T(R,D);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:w,updated:I,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=T(C,R),p=T(C,D),h={},y={},S=new Set,m=new Set;for(const v of d.removed.values())p.updated.has(v)?w[v]=D[v]:S.add(v);for(const v of p.removed.values())m.has(v)||(d.updated.has(v)?m.add(v):n.add(v));for(const v of d.updated.values())m.has(v)||(p.updated.has(v)?E.updated.has(v)&&m.add(v):y[v]=R[v]);for(const v of p.updated.values())m.has(v)||(d.updated.has(v)?E.updated.has(v)&&m.add(v):R[v]!==void 0&&(I[v]=D[v]));for(const v of d.added.values())m.has(v)||(p.added.has(v)?E.updated.has(v)&&m.add(v):h[v]=R[v]);for(const v of p.added.values())m.has(v)||(d.added.has(v)?E.updated.has(v)&&m.add(v):w[v]=D[v]);return{local:{added:w,removed:[...n.values()],updated:I},remote:{added:h,removed:[...S.values()],updated:y},conflicts:[...m.values()]}}e.merge=k;function T(R,D){const C=R?Object.keys(R):[],w=D?Object.keys(D):[],I=w.filter(d=>C.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),n=C.filter(d=>w.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),E=new Set;for(const d of C){if(n.has(d))continue;const p=R[d],h=D[d];p!==h&&E.add(d)}return{added:I,removed:n,updated:E}}function P(R,D){const{added:C,removed:w,updated:I}=T(R,D);return C.size===0&&w.size===0&&I.size===0}e.areSame=P}),define(te[24],ne([0,1,16,18,17,150,39,30,6,88,35]),function(X,e,k,T,P,R,D,C,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function d(){const o=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(A=>!!o[A].ignoreSync),g=Object.keys(o).filter(A=>o[A].scope===2||o[A].scope===6),b=E();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...b])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",u=n.Registry.as(D.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=n.Registry.as(I.Extensions.JSONContribution),b=()=>{const A=E(),U=d().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(D.allSettings.properties).filter(L=>U.indexOf(L)===-1),q=U.filter(L=>A.indexOf(L)===-1),N={items:{type:"string",enum:[...O,...q.map(L=>`-${L}`)]}};g.registerSchema(o,N)};return u.onDidUpdateConfiguration(()=>b())}e.registerConfiguration=p;function h(o){return o&&(0,P.isObject)(o)&&(0,P.isString)(o.id)&&(0,P.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function S(o,u,g){return g.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=S,e.IUserDataSyncStoreManagementService=(0,w.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,w.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,w.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=m;var v;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class f extends Error{constructor(u,g,b,A){super(u);this.code=g,this.resource=b,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=f;class c extends f{constructor(u,g,b,A,U){super(u,b,void 0,U);this.url=g,this.serverCode=A}}e.UserDataSyncStoreError=c;class l extends f{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=l,function(o){function u(g){if(g instanceof o)return g;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(b&&b[1]){const A=b[2]==="unknown"?void 0:b[2],U=b[3]==="unknown"?void 0:b[3];return new o(g.message,b[1],A,U)}return new o(g.message,"Unknown")}o.toUserDataSyncError=u}(f=e.UserDataSyncError||(e.UserDataSyncError={}));var i;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(i=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,w.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,w.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,w.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,w.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,w.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,w.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,T.isEqualOrParent)(o,(0,T.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[47],ne([0,1,16,5,19,28,3,32,2,25,17,8,146,21,11,14,46,23,22,37,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function l(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=l;let i=class extends w.Disposable{constructor(o,u,g,b,A,U,O,q,N,L,$){super();this.resource=o,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=O,this.telemetryService=q,this.logService=N,this.configurationService=L,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new D.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=$.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(o,g,this.extUri),this.currentMachineIdPromise=(0,S.getServiceMachineId)(g,u,b)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),R.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,g={}){return this._sync(o,!1,u,g)}async apply(o,u={}){try{this.syncHeaders={...u};const g=await this.doApply(o);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,g,b){try{if(this.syncHeaders={...b},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const U=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(o,U);return A=await this.performSync(O,U,u,g),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,b),U=await this.isRemoteDataFromCurrentMachine(A),O=await this.generateSyncPreview({ref:A.ref,syncData:g},b,U,this.getUserDataSyncConfiguration(),R.CancellationToken.None),q=[];for(const N of O){const L=await this.getAcceptResult(N,N.remoteResource,void 0,R.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,R.CancellationToken.None);q.push([N,{...L,remoteChange:$!==0?$:2}])}await this.applyResult(A,b,q,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const g=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,g,b){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,g,b)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,g,b);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,g,b)}throw A}}async doSync(o,u,g,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(U=>this.doGenerateSyncResourcePreview(o,u,g,b,U)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:U})=>U==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g?.content||""));const b=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,R.CancellationToken.None):void 0;return u.acceptResult=b,u.mergeState=g.hasConflicts?"conflict":b?"accepted":"preview",u.localChange=b?b.localChange:g.localChange,u.remoteChange=b?b.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async g=>{const b=await this.getAcceptResult(g,o,u,R.CancellationToken.None);return g.acceptResult=b,g.mergeState="accepted",g.localChange=b.localChange,g.remoteChange=b.remoteChange,g}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,P.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const b=g.resourcePreviews.findIndex(({localResource:A,remoteResource:U,previewResource:O})=>this.extUri.isEqual(A,o)||this.extUri.isEqual(U,o)||this.extUri.isEqual(O,o));b!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const U=[...g.resourcePreviews];return U[b]=await u(U[b]),{...g,resourcePreviews:U}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,u,(g,b)=>this.extUri.isEqual(g.previewResource,b.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(o){return E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,o))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,o))return g.remoteContent;if(this.extUri.isEqual(g.localResource,o))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,g,b,A){const U=await this.isRemoteDataFromCurrentMachine(o),O=await this.generateSyncPreview(o,u,U,b,A),q=[];for(const N of O){const L=N.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)q.push({...N,acceptedResource:L,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=g?await this.getMergeResult(N,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,P.VSBuffer.fromString($?.content||""));const _=$&&!$.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,A):void 0;q.push({...N,acceptResult:_,mergeState:$?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:$?$.localChange:N.localChange,remoteChange:_?_.remoteChange:$?$.remoteChange:N.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:q,isLastSyncFromCurrentMachine:U}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const b=u;if(b.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(b.content);if(l(A))return{...u,syncData:A,content:void 0}}catch(o){o instanceof y.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),b={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(b)))}async getRemoteUserData(o){const{ref:u,content:g}=await this.getUserData(o);let b=null;return g!==null&&(b=this.parseSyncData(g)),{ref:u,syncData:b}}parseSyncData(o){try{const u=JSON.parse(o);if(l(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,n.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const g=await this.currentMachineIdPromise,b={version:this.version,machineId:g,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(b),u,this.syncHeaders),{ref:u,syncData:b}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};i=he([J(1,y.IFileService),J(2,h.IEnvironmentService),J(3,m.IStorageService),J(4,c.IUserDataSyncStoreService),J(5,c.IUserDataSyncBackupStoreService),J(6,c.IUserDataSyncResourceEnablementService),J(7,v.ITelemetryService),J(8,c.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,f.IUriIdentityService)],i),e.AbstractSynchroniser=i;let s=class extends i{constructor(o,u,g,b,A,U,O,q,N,L,$,_){super(u,g,b,A,U,O,q,N,L,$,_);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,g){try{u?await this.writeFileContent(o,u,g):await this.fileService.createFile(this.file,P.VSBuffer.fromString(o),{overwrite:g})}catch(b){throw b instanceof y.FileOperationError&&b.fileOperationResult===1||b instanceof y.FileOperationError&&b.fileOperationResult===3?new c.UserDataSyncError(b.message,"LocalPreconditionFailed"):b}}async writeFileContent(o,u,g){await this.fileService.writeFile(this.file,P.VSBuffer.fromString(o),g?void 0:u)}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,c.IUserDataSyncStoreService),J(6,c.IUserDataSyncBackupStoreService),J(7,c.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,c.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,f.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,g,b,A,U,O,q,N,L,$,_,M){super(o,u,g,b,A,U,O,q,N,L,_,M);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,C.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,c.IUserDataSyncStoreService),J(6,c.IUserDataSyncBackupStoreService),J(7,c.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,c.IUserDataSyncLogService),J(10,c.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,f.IUriIdentityService)],r),e.AbstractJsonFileSynchroniser=r;let t=class{constructor(o,u,g,b,A){this.resource=o,this.environmentService=u,this.logService=g,this.fileService=b,this.extUri=A.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:g})}catch(A){this.logService.error(A)}}parseSyncData(o){try{const u=JSON.parse(o);if(l(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const g={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,P.VSBuffer.fromString(JSON.stringify(g)))}};t=he([J(1,h.IEnvironmentService),J(2,c.IUserDataSyncLogService),J(3,y.IFileService),J(4,f.IUriIdentityService)],t),e.AbstractInitializer=t}),define(te[224],ne([0,1,5,28,7,3,40,48,25,8,21,11,30,36,14,23,22,37,47,221,98,99,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(u,g){const b=JSON.parse(u.content);if(u.version===1||u.version===2){const A=(await g.getInstalled(0)).filter(U=>U.isBuiltin);for(const U of b)u.version===1&&(U.enabled===!1&&(U.disabled=!0),delete U.enabled),u.version===2&&A.every(O=>!(0,p.areSameExtensions)(O.identifier,U.identifier))&&(U.installed=!0)}return b}function r(u,g,b){const A=b.get((0,p.getExtensionId)(u,g),0)||"{}";return JSON.parse(A)}e.getExtensionStorageState=r;function t(u,g,b,A){A.store((0,p.getExtensionId)(u,g),JSON.stringify(b),0,1)}e.storeExtensionStorageState=t;let a=class gt extends v.AbstractSynchroniser{constructor(g,b,A,U,O,q,N,L,$,_,M,j,W,x,z){super("extensions",b,g,A,U,O,j,W,$,M,z);this.storageService=A,this.extensionManagementService=q,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=_,this.extensionsStorageSyncService=x,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,K=>K.some(({local:F})=>!!F)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(g,b){const A=g.syncData?await s(g.syncData,this.extensionManagementService):null,U=b?.skippedExtensions||[],O=b?.syncData?await s(b.syncData,this.extensionManagementService):null,q=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(q),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(q);A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:_}=(0,f.merge)(N,A,O,U,L),M={local:$,remote:_,content:this.getPreviewContent(N,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:_!==null?2:0};return[{skippedExtensions:U,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:A?this.format(A):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(g,b,A,U){const O=[...b,...A],q=new Set,N=L=>{q.add(L.id.toLowerCase()),L.uuid&&q.add(L.uuid)};O.forEach(({identifier:L})=>N(L)),U.forEach(N);for(const L of g)q.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&q.has(L.identifier.uuid)||O.push(L);return this.format(O)}async getMergeResult(g,b){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,b,A,U){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(b,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),U=(0,f.merge)(g.localExtensions,null,null,g.skippedExtensions,A),{local:O,remote:q}=U;return{content:g.localContent,local:O,remote:q,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:q!==null?2:0}}async acceptRemote(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),U=g.remoteContent?JSON.parse(g.remoteContent):null;if(U!==null){const O=(0,f.merge)(g.localExtensions,U,g.localExtensions,[],A),{local:q,remote:N}=O;return{content:g.remoteContent,local:q,remote:N,localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(g,b,A,U){let{skippedExtensions:O,localExtensions:q}=A[0][0],{local:N,remote:L,localChange:$,remoteChange:_}=A[0][1];if($===0&&_===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(q)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(L.all);g=await this.updateRemoteUserData(M,U?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(j=>j.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(j=>j.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(j=>j.identifier.id))}.`:""}`)}b?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(g,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,gt.EXTENSIONS_DATA_URI)){const A=await this.extensionManagementService.getInstalled(),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(A),O=this.getLocalExtensions(A).filter(q=>!U.some(N=>(0,p.areSameExtensions)({id:N},q.identifier)));return this.format(O)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let b=await super.resolveContent(g);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(g)),b){const A=this.parseSyncData(b);if(A)switch(this.extUri.basename(g)){case"extensions.json":return this.format(this.parseExtensions(A))}}return null}format(g){g.sort((U,O)=>!U.identifier.uuid&&O.identifier.uuid?-1:U.identifier.uuid&&!O.identifier.uuid?1:(0,w.compare)(U.identifier.id,O.identifier.id));const b=JSON.stringify(g),A=(0,C.format)(b,void 0,{});return(0,D.applyEdits)(b,A)}async hasLocalData(){try{const g=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(g).some(A=>A.installed||A.disabled))return!0}catch(g){}return!1}async updateLocalExtensions(g,b,A,U){const O=[],q=[],N=await this.extensionManagementService.getInstalled();if(b.length){const $=N.filter(({identifier:_,isBuiltin:M})=>!M&&b.some(j=>(0,p.areSameExtensions)(_,j)));await k.Promises.settled($.map(async _=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,_.identifier.id),await this.extensionManagementService.uninstall(_,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,_.identifier.id),O.push(_.identifier)}))}(g.length||A.length)&&await k.Promises.settled([...g,...A].map(async $=>{const _=N.find(j=>(0,p.areSameExtensions)(j.identifier,$.identifier));if(_&&_.isBuiltin){$.state&&_.manifest.version===$.version&&this.updateExtensionState($.state,_.manifest.publisher,_.manifest.name,_.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),O.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],T.CancellationToken.None))[0];if($.state&&(_?_.manifest.version===$.version:!!M)){const j=_?_.manifest.publisher:M.publisher,W=_?_.manifest.name:M.name;this.updateExtensionState($.state,j,W,_?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),_||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),q.push($)))}catch(j){q.push($),j instanceof d.ExtensionManagementError&&j.code===d.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else q.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const L=[];for(const $ of U)O.some(_=>(0,p.areSameExtensions)(_,$.identifier))||L.push($);for(const $ of q)L.some(_=>(0,p.areSameExtensions)(_.identifier,$.identifier))||L.push($);return L}updateExtensionState(g,b,A,U){const O=r(b,A,this.storageService),q=U?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(b,A),version:U}):void 0;q?q.forEach(N=>{O[N]=g[N]}):Object.keys(g).forEach(N=>O[N]=g[N]),t(b,A,O,this.storageService)}parseExtensions(g){return JSON.parse(g.content)}getLocalExtensions(g){const b=this.extensionEnablementService.getDisabledExtensions();return g.map(({identifier:A,isBuiltin:U,manifest:O})=>{const q={identifier:A,version:O.version};b.some(N=>(0,p.areSameExtensions)(N,A))&&(q.disabled=!0),U||(q.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:A.id,version:O.version});if(N){const L=r(O.publisher,O.name,this.storageService);q.state=Object.keys(L).reduce(($,_)=>(N.includes(_)&&($[_]=L[_]),$),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,P.getErrorMessage)(N))}return q})}};a.EXTENSIONS_DATA_URI=I.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),a=he([J(0,E.IEnvironmentService),J(1,h.IFileService),J(2,y.IStorageService),J(3,i.IUserDataSyncStoreService),J(4,i.IUserDataSyncBackupStoreService),J(5,d.IExtensionManagementService),J(6,d.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,i.IUserDataSyncLogService),J(9,d.IExtensionGalleryService),J(10,n.IConfigurationService),J(11,i.IUserDataSyncResourceEnablementService),J(12,S.ITelemetryService),J(13,c.IExtensionsStorageSyncService),J(14,m.IUriIdentityService)],a),e.ExtensionsSynchroniser=a;let o=class extends v.AbstractInitializer{constructor(g,b,A,U,O,q){super("extensions",U,O,A,q);this.extensionManagementService=g,this.ignoredExtensionsManagementService=b}async parseExtensions(g){return g.syncData?await s(g.syncData,this.extensionManagementService):null}generatePreview(g,b){const A=[],U=[],O=[];for(const q of g){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(q.identifier.id))continue;const N=b.find(L=>(0,p.areSameExtensions)(L.identifier,q.identifier));N?(A.push(N),q.disabled&&O.push(q.identifier)):q.installed&&(U.push(q.identifier),q.disabled&&O.push(q.identifier))}return{installedExtensions:A,newExtensions:U,disabledExtensions:O,remoteExtensions:g}}};o=he([J(0,d.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,E.IEnvironmentService),J(4,i.IUserDataSyncLogService),J(5,m.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(te[225],ne([0,1,26,24]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function P(C,w,I,n,E){if(!w)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const d=R(C,w);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=I?R(I,w):{added:Object.keys(w).reduce((v,f)=>(v.add(f),v),new Set),removed:new Set,updated:new Set},h=I?R(I,C):{added:Object.keys(C).reduce((v,f)=>(v.add(f),v),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},S=k.deepClone(w),m=!I;for(const v of h.added.values())v!==T.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(v)||(S[v]=C[v]);for(const v of h.updated.values())S[v]=C[v];for(const v of h.removed.values())n.unregistered.includes(v)||delete S[v];for(const v of p.added.values()){const f=w[v];if(n.machine.includes(v)){E.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(I&&h.added.has(v))continue;const c=C[v];c&&c.value===f.value||v===T.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(v)||(c?y.updated[v]=f:y.added[v]=f)}for(const v of p.updated.values()){const f=w[v];if(n.machine.includes(v)){E.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const c=C[v];c&&c.value===f.value||(y.updated[v]=f)}for(const v of p.removed.values()){if(n.machine.includes(v)){E.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||y.removed.push(v)}return{local:y,remote:D(S,w)?null:S}}e.merge=P;function R(C,w){const I=Object.keys(C),n=Object.keys(w),E=n.filter(h=>I.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),d=I.filter(h=>n.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),p=new Set;for(const h of I){if(d.has(h))continue;const y=C[h],S=w[h];k.equals(y,S)||p.add(h)}return{added:E,removed:d,updated:p}}function D(C,w){const{added:I,removed:n,updated:E}=R(C,w);return I.size===0&&n.size===0&&E.size===0}}),define(te[226],ne([0,1,19,7,3,32,40,48,4,8,29,21,11,14,10,46,23,22,37,47,55,225,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",r=["locale"];function t(b){const A=b.storage?Object.keys(b.storage).sort():[],U={};A.forEach(N=>U[N]=b.storage[N]),b.storage=U;const O=JSON.stringify(b),q=(0,C.format)(O,void 0,{});return(0,D.applyEdits)(O,q)}const a=1;let o=class mt extends f.AbstractSynchroniser{constructor(A,U,O,q,N,L,$,_,M,j){super("globalState",A,N,M,U,O,L,$,q,_,j);this.storageService=M,this.version=a,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:i.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(P.Event.any(P.Event.filter(A.onDidFilesChange,W=>W.contains(this.environmentService.argvResource)),P.Event.filter(M.onDidChangeValue,W=>W.scope===0&&W.target!==void 0?W.target===0:M.keys(0,0).includes(W.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(A,U,O){const q=A.syncData?JSON.parse(A.syncData.content):null;U=U===null&&O?A:U;const N=U&&U.syncData?JSON.parse(U.syncData.content):null,L=await this.getLocalGlobalState();q?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(N),{local:_,remote:M}=(0,l.merge)(L.storage,q?q.storage:null,N?N.storage:null,$,this.logService),j={content:null,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:t(L),localUserData:L,remoteResource:this.remoteResource,remoteContent:q?t(q):null,previewResource:this.previewResource,previewResult:j,localChange:j.localChange,remoteChange:j.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(A,U){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,U,O,q){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(U,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:A.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(A){if(A.remoteContent!==null){const U=JSON.parse(A.remoteContent),{local:O,remote:q}=(0,l.merge)(A.localUserData.storage,U.storage,null,A.storageKeys,this.logService);return{content:A.remoteContent,local:O,remote:q,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(A,U,O,q){let{localUserData:N}=O[0][0],{local:L,remote:$,localChange:_,remoteChange:M}=O[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(L),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const j=JSON.stringify({storage:$});A=await this.updateRemoteUserData(j,q?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}U?.ref!==A.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(A),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:A}){return[{resource:this.extUri.joinPath(A,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(A){if(this.extUri.isEqual(A,mt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return t(O)}if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A))return this.resolvePreviewContent(A);let U=await super.resolveContent(A);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(A)),U){const O=this.parseSyncData(U);if(O)switch(this.extUri.basename(A)){case"globalState.json":return t(JSON.parse(O.content))}}return null}async hasLocalData(){try{const{storage:A}=await this.getLocalGlobalState();if(Object.keys(A).length>1||A[`${s}.locale`]?.value!=="en")return!0}catch(A){}return!1}async getLocalGlobalState(){const A={},U=await this.getLocalArgvContent(),O=(0,R.parse)(U);for(const q of r)O[q]!==void 0&&(A[`${s}${q}`]={version:1,value:O[q]});for(const q of this.storageService.keys(0,0)){const N=this.storageService.get(q,0);N&&(A[q]={version:1,value:N})}return{storage:A}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const A=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),A.value.toString()}catch(A){this.logService.debug((0,T.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:U,updated:O}){const q={},N={},L=(_,M)=>{for(const j of _){if(j.startsWith(s)){q[j.substring(s.length)]=M?M[j].value:void 0;continue}if(M){const W=M[j];W.value!==String(this.storageService.get(j,0))&&(N[j]=W.value)}else this.storageService.get(j,0)!==void 0&&(N[j]=void 0)}};if(L(Object.keys(A),A),L(Object.keys(O),O),L(U),Object.keys(q).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(q),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(N))this.storageService.store(_,N[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(A){const U=await this.getLocalArgvContent();let O=U;for(const q of Object.keys(A))O=(0,c.edit)(O,[q],A[q],{});U!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(A){const U=this.storageService.keys(0,0),O=this.storageService.keys(0,1),q=[...U,...O],N=A?.storage?Object.keys(A.storage).filter(L=>!L.startsWith(s)&&!q.includes(L)&&this.storageService.get(L,0)!==void 0):[];if(!w.isWeb){const L=[...i.ALL_SYNC_RESOURCES.map($=>(0,i.getEnablementKey)($)),i.SYNC_SERVICE_URL_TYPE];N.push(...L),O.push(...L)}return{user:U,machine:O,unregistered:N}}};o.GLOBAL_STATE_DATA_URI=I.URI.from({scheme:i.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=he([J(0,p.IFileService),J(1,i.IUserDataSyncStoreService),J(2,i.IUserDataSyncBackupStoreService),J(3,i.IUserDataSyncLogService),J(4,d.IEnvironmentService),J(5,i.IUserDataSyncResourceEnablementService),J(6,m.ITelemetryService),J(7,E.IConfigurationService),J(8,S.IStorageService),J(9,v.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let u=class extends f.AbstractInitializer{constructor(A,U,O,q,N){super("globalState",O,q,U,N);this.storageService=A}async doInitialize(A){const U=A.syncData?JSON.parse(A.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},q={};for(const N of Object.keys(U.storage))N.startsWith(s)?O[N.substring(s.length)]=U.storage[N].value:this.storageService.get(N,0)===void 0&&(q[N]=U.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(L){}for(const L of Object.keys(O))N=(0,c.edit)(N,[L],O[L],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(N))}if(Object.keys(q).length)for(const N of Object.keys(q))this.storageService.store(N,q[N],0,0)}};u=he([J(0,S.IStorageService),J(1,p.IFileService),J(2,d.IEnvironmentService),J(3,i.IUserDataSyncLogService),J(4,v.IUriIdentityService)],u),e.GlobalStateInitializer=u;let g=class{constructor(A,U,O,q,N){this.userDataSyncStoreClient=A,this.storageService=U,this.environmentService=O,this.fileService=q,this.logService=N}getSyncStoreType(A){return this.parseGlobalState(A)?.storage[i.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const U=(0,i.createSyncHeaders)((0,n.generateUuid)());try{return await this.doSync(A,U)}catch(O){if(O instanceof i.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(A,U)}throw O}}async doSync(A,U){const O=await this.userDataSyncStoreClient.read("globalState",null,U),q=this.parseGlobalState(O)||{storage:{}};q.storage[i.SYNC_SERVICE_URL_TYPE]={value:A,version:a};const N=await(0,y.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),L={version:a,machineId:N,content:t(q)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(L),O.ref,U)}parseGlobalState({content:A}){if(!A)return null;const U=JSON.parse(A);if((0,f.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};g=he([J(1,S.IStorageService),J(2,d.IEnvironmentService),J(3,p.IFileService),J(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[227],ne([0,1,16,19,3,32,4,17,147,21,11,14,23,22,37,47,222,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(l,i,s){try{const r=JSON.parse(l);if(!i)return(0,C.isUndefined)(r.all)?null:r.all;switch(D.OS){case 2:return(0,C.isUndefined)(r.mac)?null:r.mac;case 3:return(0,C.isUndefined)(r.linux)?null:r.linux;case 1:return(0,C.isUndefined)(r.windows)?null:r.windows}}catch(r){return s.error(r),null}}e.getKeybindingsContentFromSyncContent=v;let f=class extends y.AbstractJsonFileSynchroniser{constructor(i,s,r,t,a,o,u,g,b,A,U){super(u.keybindingsResource,"keybindings",o,u,g,i,s,a,A,r,b,t,U);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(P.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(i,s,r,t){const a=i.syncData?v(i.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&r?i:s;const o=s?this.getKeybindingsContentFromLastSyncUserData(s):null,u=await this.getLocalFileContent(),g=await this.getFormattingOptions();let b=null,A=!1,U=!1,O=!1;if(a){let N=u?u.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new m.UserDataSyncError((0,w.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==N||o!==a){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const L=await(0,S.merge)(N,a,o,g,this.userDataSyncUtilService);L.hasChanges&&(b=L.mergeContent,O=L.hasConflicts,A=O||L.mergeContent!==N,U=O||L.mergeContent!==a)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=u.value.toString(),U=!0);const q={content:b,localChange:A?u?2:1:0,remoteChange:U?2:0,hasConflicts:O};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:q.localChange,remoteResource:this.remoteResource,remoteContent:a,remoteChange:q.remoteChange,previewResource:this.previewResource,previewResult:q,acceptedResource:this.acceptedResource}]}async getMergeResult(i,s){return i.previewResult}async getAcceptResult(i,s,r,t){if(this.extUri.isEqual(s,this.localResource))return{content:i.fileContent?i.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:i.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return r===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(i,s,r,t){const{fileContent:a}=r[0][0];let{content:o,localChange:u,remoteChange:g}=r[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,w.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),a&&await this.backupLocal(this.toSyncContent(a.value.toString())),await this.updateLocalFileContent(o||"[]",a,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const b=this.toSyncContent(o||"[]",i.syncData?.content);i=await this.updateRemoteUserData(b,t?null:i.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(b){}s?.ref!==i.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(i,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const i=await this.getLocalFileContent();if(i){const s=(0,R.parse)(i.value.toString());if((0,k.isNonEmptyArray)(s))return!0}}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:i}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(i,"keybindings.json"),comparableResource:s}]}async resolveContent(i){if(this.extUri.isEqual(this.remoteResource,i)||this.extUri.isEqual(this.localResource,i)||this.extUri.isEqual(this.acceptedResource,i))return this.resolvePreviewContent(i);let s=await super.resolveContent(i);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(i)),s){const r=this.parseSyncData(s);if(r)switch(this.extUri.basename(i)){case"keybindings.json":return v(r.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(i){return!i.syncData||i.platformSpecific!==void 0&&i.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(i.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(i,s){let r={};try{r=JSON.parse(s||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=i,D.OS){case 2:r.mac=i;break;case 3:r.linux=i;break;case 1:r.windows=i;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,I.IConfigurationService),J(4,m.IUserDataSyncResourceEnablementService),J(5,E.IFileService),J(6,n.IEnvironmentService),J(7,d.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let c=class extends y.AbstractInitializer{constructor(i,s,r,t){super("keybindings",s,r,i,t)}async doInitialize(i){const s=i.syncData?this.getKeybindingsContentFromSyncContent(i.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(s)),await this.updateLastSyncUserData(i)}async isEmpty(){try{const i=await this.fileService.readFile(this.environmentService.settingsResource),s=(0,R.parse)(i.value.toString());return!(0,k.isNonEmptyArray)(s)}catch(i){return i.fileOperationResult===1}}getKeybindingsContentFromSyncContent(i){try{return v(i,!0,this.logService)}catch(s){return this.logService.error(s),null}}};c=he([J(0,E.IFileService),J(1,n.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[228],ne([0,1,16,32,40,48,26,55,24]),function(X,e,k,T,P,R,D,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function I(o,u,g){let b=[];g?b=E(g):b=n(u);const A=[],U=[...(0,w.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const O of b)O.startsWith("-")?U.push(O.substring(1)):A.push(O);return(0,k.distinct)([...o,...A].filter(O=>U.indexOf(O)===-1))}e.getIgnoredSettings=I;function n(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const u=(0,T.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function d(o,u,g,b){if(g.length){const A=a(u),U=(0,T.parse)(u),O=(0,T.parse)(o),q=[];for(const N of g){const L=U[N],$=O[N];L===void 0?o=C.edit(o,[N],void 0,b):$!==void 0?o=C.edit(o,[N],L,b):q.push(l(N,A))}q.sort((N,L)=>N.startOffset-L.startOffset),q.forEach(N=>o=m(N.setting.key,u,o,b))}return o}e.updateIgnoredSettings=d;function p(o,u,g,b,A,U){const O=d(o,u,b,U),q=g!==O,N=g!==u;if(!q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(q&&!N)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(N&&!q)return{conflictsSettings:[],localContent:d(u,o,b,U),remoteContent:null,hasConflicts:!1};if(g===null&&y(o)){const H=h(o,u,b)?null:d(u,o,b,U);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let L=o,$=u;const _=(0,T.parse)(o),M=(0,T.parse)(u),j=g?(0,T.parse)(g):null,W=b.reduce((H,re)=>(H.add(re),H),new Set),x=S(_,M,W),z=S(j,_,W),K=S(j,M,W),F=new Map,B=new Set,V=H=>{B.add(H);const re=A.filter(({key:ie})=>ie===H)[0];re?(L=C.edit(L,[H],re.value,U),$=C.edit($,[H],re.value,U)):F.set(H,{key:H,localValue:_[H],remoteValue:M[H]})};for(const H of z.removed.values())K.updated.has(H)?V(H):$=C.edit($,[H],void 0,U);for(const H of K.removed.values())B.has(H)||(z.updated.has(H)?V(H):L=C.edit(L,[H],void 0,U));for(const H of z.updated.values())B.has(H)||(K.updated.has(H)?x.updated.has(H)&&V(H):$=C.edit($,[H],_[H],U));for(const H of K.updated.values())B.has(H)||(z.updated.has(H)?x.updated.has(H)&&V(H):L=C.edit(L,[H],M[H],U));for(const H of z.added.values())B.has(H)||(K.added.has(H)?x.updated.has(H)&&V(H):$=m(H,L,$,U));for(const H of K.added.values())B.has(H)||(z.added.has(H)?x.updated.has(H)&&V(H):L=m(H,$,L,U));const Q=F.size>0||!h(L,$,b),Z=Q||!h(L,o,[]),G=Q||!h($,u,[]);return{localContent:Z?L:null,remoteContent:G?$:null,conflictsSettings:[...F.values()],hasConflicts:Q}}e.merge=p;function h(o,u,g){if(o===u)return!0;const b=(0,T.parse)(o),A=(0,T.parse)(u),U=g.reduce((N,L)=>(N.add(L),N),new Set),O=a(o).filter(N=>!(N.setting&&U.has(N.setting.key))),q=a(u).filter(N=>!(N.setting&&U.has(N.setting.key)));if(O.length!==q.length)return!1;for(let N=0;N<O.length;N++){const L=O[N],$=q[N];if(L.setting&&$.setting){if(L.setting.key!==$.setting.key||!D.equals(b[L.setting.key],A[L.setting.key]))return!1}else if(!L.setting&&!$.setting){if(L.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?a(o).length===0:!0}e.isEmpty=y;function S(o,u,g){const b=o?Object.keys(o).filter(N=>!g.has(N)):[],A=Object.keys(u).filter(N=>!g.has(N)),U=A.filter(N=>b.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),O=b.filter(N=>A.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),q=new Set;if(o)for(const N of b){if(O.has(N))continue;const L=o[N],$=u[N];D.equals(L,$)||q.add(N)}return{added:U,removed:O,updated:q}}function m(o,u,g,b){const A=(0,T.parse)(u),U=a(u),O=a(g),q=v(o,U,O);return f(g,o,A[o],q,O,b)}e.addSetting=m;function v(o,u,g){const b=u.findIndex(U=>U.setting?.key===o),A=u[b-1];if(A){if(A.setting){const O=l(A.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!0}}else{const O=i(b,u);if(O){const q=l(O.setting.key,g);if(q){const N=s(g.indexOf(q),g),L=r(u,O,u[b]);if(N){const $=r(g,q,N),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.indexOf(N),insertAfter:!1}}else{const $=r(g,q,g[g.length-1]),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const U=u[b+1];if(U)if(U.setting){const O=l(U.setting.key,g);if(O)return{index:g.indexOf(O),insertAfter:!1}}else{const O=s(b,u);if(O){const q=l(O.setting.key,g);if(q){const N=i(g.indexOf(q),g),L=r(u,u[b],O);if(N){const $=r(g,N,q),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:g.indexOf(N),insertAfter:!0}}else{const $=r(g,g[0],q),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function f(o,u,g,b,A,U){let O;return b.index===-1?O=(0,P.setProperty)(o,[u],g,U):O=c(o,u,g,b,A,U).map(q=>(0,P.withFormatting)(o,q,U)[0]),(0,P.applyEdits)(o,O)}function c(o,u,g,b,A,U){const O=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,q=(0,R.getEOL)(U,o),N=A[b.index];if(b.insertAfter){const L=[];if(N.setting)L.push({offset:N.endOffset,length:0,content:","+O});else{const $=s(b.index,A),_=i(b.index,A),M=_?.setting?.commaOffset;_&&M===void 0&&L.push({offset:_.endOffset,length:0,content:","});const j=M!==void 0&&M>N.endOffset;L.push({offset:j?M+1:N.endOffset,length:0,content:$?q+O+",":q+O})}return L}else{if(N.setting)return[{offset:N.startOffset,length:0,content:O+","}];const L=(A[b.index-1]&&!A[b.index-1].setting?q:"")+O+(s(b.index,A)?",":"")+q;return[{offset:N.startOffset,length:0,content:L}]}}function l(o,u){return u.filter(g=>g.setting?.key===o)[0]}function i(o,u){for(let g=o-1;g>=0;g--)if(u[g].setting)return u[g]}function s(o,u){for(let g=o+1;g<u.length;g++)if(u[g].setting)return u[g]}function r(o,u,g){const b=o.indexOf(u),A=o.indexOf(g);return o.filter((U,O)=>b<O&&O<A)}function t(o,u){if(o.length&&u.length){let g=0;for(;g<u.length&&g<o.length;g++)if(o[g].value!==u[g].value)return u[g-1];return u[g-1]}}function a(o){const u=[];let g=-1,b,A;const U={onObjectBegin:O=>{g++},onObjectProperty:(O,q,N)=>{g===0&&(b=q,A=O)},onObjectEnd:(O,q)=>{g--,g===0&&u.push({startOffset:b,endOffset:O+q,value:o.substring(b,O+q),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(O,q)=>{g++},onArrayEnd:(O,q)=>{g--,g===0&&u.push({startOffset:b,endOffset:O+q,value:o.substring(b,O+q),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(O,q,N)=>{g===0&&u.push({startOffset:b,endOffset:q+N,value:o.substring(b,q+N),setting:{key:A,commaOffset:void 0}})},onSeparator:(O,q,N)=>{if(g===0&&O===","){let L=u.length-1;for(;L>=0&&!u[L].setting;L--);const $=u[L];$&&u.splice(L,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:q}})}},onComment:(O,q)=>{g===0&&u.push({startOffset:O,endOffset:O+q,value:o.substring(O,O+q)})}};return(0,T.visit)(o,U),u}}),define(te[229],ne([0,1,19,3,40,148,21,89,85,11,30,14,23,22,37,47,55,228,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function f(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function c(r){const t=JSON.parse(r);return f(t)?t:{settings:r}}e.parseSettingsSyncContent=c;let l=class extends y.AbstractJsonFileSynchroniser{constructor(t,a,o,u,g,b,A,U,O,q,N,L,$){super(a.settingsResource,"settings",t,a,o,u,g,O,q,b,A,U,$);this.extensionManagementService=N,this.userConfigurationFileService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const a=await this.getLastSyncUserData(),o=await this.getLatestRemoteUserData(t,a),u=this.getSettingsSyncContent(o),g=new C.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&g.parse(u.settings),g.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,a,o){const u=await this.getLocalFileContent(),g=await this.getFormattingOptions(),b=this.getSettingsSyncContent(t);a=a===null&&o?t:a;const A=a?this.getSettingsSyncContent(a):null,U=await this.getIgnoredSettings();let O=null,q=!1,N=!1,L=!1;if(b){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(_,b.settings,A?A.settings:null,U,[],g);O=M.localContent||M.remoteContent,q=M.localContent!==null,N=M.remoteContent!==null,L=M.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),O=u.value.toString(),N=!0);const $={content:O,localChange:q?2:0,remoteChange:N?2:0,hasConflicts:L};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:b?b.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,o):null}}async getAcceptResult(t,a,o,u){const g=await this.getFormattingOptions(),b=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",b,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return o===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:o!==null?(0,m.updateIgnoredSettings)(o,t.fileContent?t.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(t,a,o,u){const{fileContent:g}=o[0][0];let{content:b,localChange:A,remoteChange:U}=o[0][1];if(A===0&&U===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),b=b?b.trim():"{}",b=b||"{}",this.validateContent(b),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(b,g,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),U!==0){const O=await this.getFormattingOptions(),q=this.getSettingsSyncContent(t),N=await this.getIgnoredSettings(b);b=(0,m.updateIgnoredSettings)(b,q?q.settings:"{}",N,O),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(b)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(O){}a?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const a=await this.getFormattingOptions(),o=(0,S.edit)(t.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,m.isEmpty)(o)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:a}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let a=await super.resolveContent(t);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(t)),a){const o=this.parseSyncData(a);if(o){const u=this.parseSettingsSyncContent(o.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let a=await super.resolvePreviewContent(t);if(a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();a=(0,m.updateIgnoredSettings)(a,"{}",u,o)}return a}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return c(t)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const o=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:g})=>!!g)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{o.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(a,this.configurationService,t)}async writeFileContent(t,a,o){await this.userConfigurationFileService.write(k.VSBuffer.fromString(t),o?void 0:{etag:a.etag,mtime:a.mtime})}validateContent(t){if(this.hasErrors(t))throw new v.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const a=JSON.parse(t.value.toString());if(!s(a))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const o=this.parseSettingsSyncContent(a.content);if(!o||!o.settings)return;let u=o.settings;const g=await this.getFormattingOptions();for(const b in a)if(["version","content","machineId"].indexOf(b)===-1&&a[b]!==void 0){const A=(0,P.setProperty)(u,[b],a[b],g);A.length&&(u=(0,P.applyEdits)(u,A))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(u))}catch(t){}}};l=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,d.IStorageService),J(3,v.IUserDataSyncStoreService),J(4,v.IUserDataSyncBackupStoreService),J(5,v.IUserDataSyncLogService),J(6,v.IUserDataSyncUtilService),J(7,D.IConfigurationService),J(8,v.IUserDataSyncResourceEnablementService),J(9,p.ITelemetryService),J(10,n.IExtensionManagementService),J(11,w.IUserConfigurationFileService),J(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let i=class extends y.AbstractInitializer{constructor(t,a,o,u){super("settings",a,o,t,u)}async doInitialize(t){const a=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return c(t)}catch(a){this.logService.error(a)}return null}};i=he([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,v.IUserDataSyncLogService),J(3,h.IUriIdentityService)],i),e.SettingsInitializer=i;function s(r){return!!(r&&r.version!==void 0&&typeof r.version=="number"&&r.content!==void 0&&typeof r.content=="string"&&r.machineId!==void 0&&typeof r.machineId=="string")}}),define(te[230],ne([0,1,19,3,26,21,11,14,23,22,37,47,223,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,v,f,c,l,i,s,r,t,a){super("snippets",v,m,f,c,l,r,t,i,s,a);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,v,f){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),i=m.syncData?this.parseSnippets(m.syncData):null;v=v===null&&f?m:v;const s=v&&v.syncData?this.parseSnippets(v.syncData):null;i?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const r=(0,d.merge)(l,i,s);return this.getResourcePreviews(r,c,i||{})}async getMergeResult(m,v){return m.previewResult}async getAcceptResult(m,v,f,c){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return f===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:f,localChange:f===null?m.fileContent!==null?3:0:2,remoteChange:f===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(m,v,f,c){const l=f.map(([i,s])=>({...i,acceptResult:s}));l.every(({localChange:i,remoteChange:s})=>i===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:i})=>i!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:i})=>i!==0)&&(m=await this.updateRemoteSnippets(l,m,c)),v?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:i}of l)try{await this.fileService.del(i)}catch(s){}}getResourcePreviews(m,v,f){const c=new Map;for(const l of Object.keys(m.local.added)){const i={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const i={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const i={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const i={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const i={content:v[l]?v[l].value.toString():null,hasConflicts:!0,localChange:v[l]?2:1,remoteChange:f[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v))if(!c.has(l)){const i={content:v[l]?v[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let v=await super.resolveContent(m);if(v){const f=this.parseSyncData(v);if(f){const c=this.parseSnippets(f),l=[];for(const i of Object.keys(c)){const s=this.extUri.joinPath(m,i),r=this.extUri.joinPath(this.snippetsFolder,i),t=await this.fileService.exists(r);l.push({resource:s,comparableResource:t?r:this.extUri.joinPath(this.syncPreviewFolder,i).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let v=await super.resolveContent(m);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(m)),v){const f=this.parseSyncData(v);if(f)return this.parseSnippets(f)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const v={};for(const f of m)f.fileContent&&(v[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(m,v){for(const{fileContent:f,acceptResult:c,localResource:l,remoteResource:i,localChange:s}of m)if(s!==0){const r=i?this.extUri.basename(i):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,r);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,k.VSBuffer.fromString(c.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,k.VSBuffer.fromString(c.content),v?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,v,f){const c=v.syncData?this.parseSnippets(v.syncData):{},l=(0,P.deepClone)(c);for(const{acceptResult:i,localResource:s,remoteResource:r,remoteChange:t}of m)if(t!==0){const a=s?this.extUri.basename(s):this.extUri.basename(r);t===3?delete l[a]:l[a]=i.content}return(0,d.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(l),f?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const v={};for(const f of Object.keys(m))v[f]=m[f].value.toString();return v}async getSnippetsFileContents(){const m={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof C.FileOperationError&&f.fileOperationResult===1)return m;throw f}for(const f of v.children||[]){const c=f.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const i=this.extUri.relativePath(this.snippetsFolder,c),s=await this.fileService.readFile(c);m[i]=s}}return m}};h=he([J(0,D.IEnvironmentService),J(1,C.IFileService),J(2,w.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,R.IConfigurationService),J(7,p.IUserDataSyncResourceEnablementService),J(8,I.ITelemetryService),J(9,n.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let y=class extends E.AbstractInitializer{constructor(m,v,f,c){super("snippets",v,f,m,c)}async doInitialize(m){const v=m.syncData?JSON.parse(m.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(v)){const l=v[c];if(l){const i=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(i,k.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(i))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=he([J(0,C.IFileService),J(1,D.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,n.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(te[64],ne([0,1,3,2,6,24]),function(X,e,k,T,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,P.createDecorator)("IUserDataSyncAccountService");let D=class extends T.Disposable{constructor(w,I){super();this.userDataSyncStoreService=w,this.logService=I,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(w.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(w.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(w){(w&&this._account?w.token!==this._account.token||w.authenticationProviderId!==this._account.authenticationProviderId:w!==this._account)&&(this._account=w,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(w))}};D=he([J(0,R.IUserDataSyncStoreService),J(1,R.IUserDataSyncLogService)],D),e.UserDataSyncAccountService=D}),define(te[231],ne([0,1,5,19,58,2,18,21,11,14,24]),function(X,e,k,T,P,R,D,C,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends R.Disposable{constructor(p,h,y,S){super();this.environmentService=p,this.fileService=h,this.configurationService=y,this.logService=S,n.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,p),y=await this.fileService.resolve(h);return y.children?y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const y=await this.getAllRefs(p);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,D.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(p,h){const y=(0,D.joinPath)(this.environmentService.userDataSyncHome,p),S=(0,D.joinPath)(y,`${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(S,T.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,D.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(S){return}const y=await this.fileService.resolve(h);if(y.children){const S=y.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=S.filter(c=>Date.now()-this.getCreationTime(c)>m);const f=S.length-v.length;f<10&&(v=v.slice(10-f)),await k.Promises.settled(v.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=he([J(0,w.IEnvironmentService),J(1,I.IFileService),J(2,C.IConfigurationService),J(3,n.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[232],ne([0,1,2,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class P{constructor(d){this.service=d}listen(d,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=P;class R{constructor(d){this.service=d}listen(d,p){throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class D{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=D;class C{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class w{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=w;class I{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class n extends k.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:T.URI.revive(d.url),type:d.type,defaultUrl:T.URI.revive(d.defaultUrl),insidersUrl:T.URI.revive(d.insidersUrl),stableUrl:T.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[233],ne([0,1,11,10]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let P=class extends T.AbstractLogger{constructor(D,C){super();this.logger=this._register(D.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(D,...C){this.logger.trace(D,...C)}debug(D,...C){this.logger.debug(D,...C)}info(D,...C){this.logger.info(D,...C)}warn(D,...C){this.logger.warn(D,...C)}error(D,...C){this.logger.error(D,...C)}critical(D,...C){this.logger.critical(D,...C)}flush(){this.logger.flush()}};P=he([J(0,T.ILoggerService),J(1,k.IEnvironmentService)],P),e.UserDataSyncLogService=P}),define(te[65],ne([0,1,3,2,4,25,151,11,14,6,27,46,23,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class tt extends T.Disposable{constructor(m,v,f,c,l,i){super();this.storageService=f,this.userDataSyncStoreService=c,this.logService=l,this.productService=i,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,v,f)}async getMachines(m){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===v}))}async addCurrentMachine(m){const v=await this.currentMachineIdPromise,f=await this.readMachinesData(m);f.machines.some(({id:c})=>c===v)||(f.machines.push({id:v,name:this.computeCurrentMachineName(f.machines)}),await this.writeMachinesData(f))}async removeCurrentMachine(m){const v=await this.currentMachineIdPromise,f=await this.readMachinesData(m),c=f.machines.filter(({id:l})=>l!==v);c.length!==f.machines.length&&(f.machines=c,await this.writeMachinesData(f))}async renameMachine(m,v,f){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(f),i=l.machines.find(({id:s})=>s===m);i&&(i.name=v,await this.writeMachinesData(l),l.machines.some(({id:s})=>s===c)&&this.storageService.store(h,v,0,1))}async setEnablement(m,v){const f=await this.readMachinesData(),c=f.machines.find(({id:l})=>l===m);c&&(c.disabled=v?void 0:!0,await this.writeMachinesData(f))}computeCurrentMachineName(m){const v=this.storageService.get(h,0);if(v)return v;const f=`${this.productService.nameLong} (${(0,P.PlatformToString)(P.isWeb?0:P.platform)})`,c=new RegExp(`${(0,R.escapeRegExpCharacters)(f)}\\s#(\\d+)`);let l=0;for(const i of m){const s=c.exec(i.name),r=s?parseInt(s[1]):0;l=r>l?r:l}return`${f} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const v=this.parse(this.userData);if(v.version!==tt.VERSION)throw new Error((0,D.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(m){const v=JSON.stringify(m),f=await this.userDataSyncStoreService.write(tt.RESOURCE,v,this.userData?.ref||null);this.userData={ref:f,content:v},this._onDidChange.fire()}async readUserData(m){if(this.userData){const v=m&&m.latest?m.latest[tt.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(v){this.logService.error(v)}return{version:tt.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=he([J(0,C.IEnvironmentService),J(1,w.IFileService),J(2,d.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,n.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[100],ne([0,1,5,58,38,7,3,2,4,18,8,149,11,27,23,22,24,64,65]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const f="sync.enable",c="sync.disableMachineEventually",l="sync.sessionId",i="sync.storeUrl",s="sync.productQuality";let r=class extends C.Disposable{constructor(u,g,b){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=b,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(f,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(f,u,0,1)}onDidStorageChange(u){if(u.scope===0&&f===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([J(0,h.IStorageService),J(1,d.IEnvironmentService),J(2,S.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let t=class extends C.Disposable{constructor(u,g,b,A,U,O,q,N,L,$,_){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=b,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=U,this.logService=O,this.userDataSyncAccountService=q,this.telemetryService=N,this.userDataSyncMachinesService=L,this.storageService=$,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new k.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(q.onDidChangeAccount(()=>this.updateAutoSync())),this._register(b.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(D.Event.debounce(U.onDidChangeLocal,(M,j)=>M?[...M,j]:[j],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(D.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(i,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(i,u.toString(),0,1):this.storageService.remove(i,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(b=>this.onDidFinishSync(b))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,b){try{this.userDataSyncAccountService.account&&!b&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(g)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(f,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=S.UserDataSyncError.toUserDataSyncError(u);g instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?w.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,g,b){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",b)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([J(0,p.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncResourceEnablementService),J(4,S.IUserDataSyncService),J(5,S.IUserDataSyncLogService),J(6,m.IUserDataSyncAccountService),J(7,y.ITelemetryService),J(8,v.IUserDataSyncMachinesService),J(9,h.IStorageService),J(10,S.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class a extends C.Disposable{constructor(u,g,b,A,U,O,q,N){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=b,this.userDataSyncStoreService=A,this.userDataSyncService=U,this.userDataSyncMachinesService=O,this.logService=q,this.storageService=N,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new D.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new D.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const b=(0,k.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(U){if((0,R.isPromiseCanceledError)(U))return}return this.doSync(u,g,A)});return this.syncPromise=b,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,I.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,I.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,I.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,b){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),b.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const U=this.storageService.get(l,0);if(U&&this.manifest&&U!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(b.isCancellationRequested)return;const q=O.find(N=>N.isCurrent);if(q?.disabled)throw new S.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new S.UserDataAutoSyncError((0,P.toErrorMessage)(N),N instanceof S.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==U&&this.storageService.store(l,this.manifest.session,0,1),b.isCancellationRequested)return;q||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(U){this.logService.error(U),A=U}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[234],ne([0,1,3,2,4,23,22,24]),function(X,e,k,T,P,R,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let w=class extends T.Disposable{constructor(n,E){super();this.storageService=n,this.telemetryService=E,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(n){return this.storageService.getBoolean((0,C.getEnablementKey)(n),0,!0)}setResourceEnablement(n,E){if(this.isResourceEnabled(n)!==E){const d=(0,C.getEnablementKey)(n);this.telemetryService.publicLog2(d,{enabled:E}),this.storeResourceEnablement(d,E)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,E){this.storageService.store(n,E,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const E=C.ALL_SYNC_RESOURCES.filter(d=>(0,C.getEnablementKey)(d)===n.key)[0];if(E){this._onDidChangeResourceEnablement.fire([E,this.isResourceEnabled(E)]);return}}}};w=he([J(0,R.IStorageService),J(1,D.ITelemetryService)],w),e.UserDataSyncResourceEnablementService=w}),define(te[235],ne([0,1,16,5,38,7,3,2,18,29,21,6,23,22,224,226,227,229,230,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends C.Disposable{constructor(t,a,o,u,g,b,A){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=g,this.telemetryService=b,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new D.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new D.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(S.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(y.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=D.Event.any(...this.synchronisers.map(U=>D.Event.map(U.onDidChangeLocal,()=>U.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,a){await this.checkEnablement();const o=(0,I.generateUuid)();try{const A=(0,f.createSyncHeaders)(o);a&&(A["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,A)}catch(A){const U=f.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(U,o),U}let u=!1;const g=this;let b;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return b=(0,T.createCancelablePromise)(A=>g.sync(t,o,A)),b.finally(()=>b=void 0)},async stop(){if(b&&b.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,I.generateUuid)(),a=(0,f.createSyncHeaders)(t);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const g=f.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,t),g}return new i(t,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(t,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,f.createSyncHeaders)(a);for(const b of this.synchronisers){if(o.isCancellationRequested)return;try{await b.sync(t,g)}catch(A){let U=!1;if(A instanceof f.UserDataSyncError)switch(A.code){case"TooLarge":A=new f.UserDataSyncError(A.message,A.code,b.resource),U=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":U=!0;break}const O=f.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(O,a),U)throw O;this.logService.error(A),this.logService.error(`${b.resource}: ${(0,P.toErrorMessage)(A)}`),this._syncErrors.push([b.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(g){const b=f.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(b,a),b}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(a){this.logService.error(a)}}async replace(t){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(t))return}async accept(t,a,o,u){await this.checkEnablement();const g=this.getSynchroniser(t);await g.accept(a,o),u&&await g.apply(!1,(0,f.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(t){for(const a of this.synchronisers){const o=await a.resolveContent(t);if(o)return o}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,a){return this.getSynchroniser(t).getAssociatedResources(a)}getMachineId(t,a){return this.getSynchroniser(t).getMachineId(a)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of t)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(a){this.logService.error(`${t.resource}: ${(0,P.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const a=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,k.equals)(this._conflicts,t,([a,o],[u,g])=>a===a&&(0,k.equals)(o,g,(b,A)=>(0,w.isEqual)(b.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,a){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof f.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof f.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(s)])}getSynchroniser(t){return this.synchronisers.find(a=>a.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=he([J(0,f.IUserDataSyncStoreService),J(1,f.IUserDataSyncStoreManagementService),J(2,E.IInstantiationService),J(3,n.IConfigurationService),J(4,f.IUserDataSyncLogService),J(5,p.ITelemetryService),J(6,d.IStorageService)],l),e.UserDataSyncService=l;class i extends C.Disposable{constructor(t,a,o,u,g,b){super();this.id=t,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=g,this.logService=b,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new D.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,a){try{return await this.performAction(t,o=>o.accept(t,a))}catch(o){throw this.logService.error(o),o}}async merge(t){try{return t?await this.performAction(t,a=>a.merge(t)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(t){try{return await this.performAction(t,a=>a.discard(t))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&t.push(o.previewResource);for(const a of t)await this.discard(a);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===a);for(const b of o.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&await u.merge(b.previewResource);const g=await u.apply(!1,this.syncHeaders);g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,a]of this.previews){this.synchronizingResources.push([t,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===t);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(a){(0,R.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(t,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:L,previewResource:$,remoteResource:_})=>(0,w.isEqual)(t,L)||(0,w.isEqual)(t,$)||(0,w.isEqual)(t,_)));if(o===-1)return this.previews;const[u,g]=this.previews[o],b=g.resourcePreviews.find(({localResource:N,remoteResource:L,previewResource:$})=>(0,w.isEqual)(N,t)||(0,w.isEqual)(L,t)||(0,w.isEqual)($,t));if(!b)return this.previews;let A=this.synchronizingResources.find(N=>N[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(N=>(0,w.isEqual)(N,b.localResource))||(A[1].push(b.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const U=this.synchronisers.find(N=>N.resource===this.previews[o][0]),O=await a(U);O?this.previews.splice(o,1,this.toSyncResourcePreview(U.resource,O)):this.previews.splice(o,1);const q=this.synchronizingResources.findIndex(N=>N[0]===u);return this.synchronizingResources[q][1].splice(A[1].findIndex(N=>(0,w.isEqual)(N,b.localResource)),1),A[1].length||(this.synchronizingResources.splice(q,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===a);let g=o;for(const b of o.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&(g=await u.merge(b.previewResource));g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const g=await u.preview(this.manifest,o,this.syncHeaders);g&&a.push(this.toSyncResourcePreview(u.resource,g))}return a}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(f.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...a}}toSyncResourcePreview(t,a){return[t,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[236],ne([0,1,3,2,17,8,24]),function(X,e,k,T,P,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(E,d){this.service=E,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(E,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(E,d,p){try{return await this._call(E,d,p)}catch(h){throw this.logService.error(h),h}}async _call(E,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],R.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),y=p[0],S=this.getManualSyncTask(y);switch(p=p.slice(1),h){case"preview":return S.preview();case"accept":return S.accept(R.URI.revive(p[0]),p[1]);case"merge":return S.merge(R.URI.revive(p[0]));case"discard":return S.discard(R.URI.revive(p[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(E){const d=this.manualSyncTasks.get(this.createKey(E));if(!d)throw new Error(`Manual sync taks not found: ${E}`);return d.manualSyncTask}async createManualSyncTask(){const E=new T.DisposableStore,d=E.add(await this.service.createManualSyncTask());return E.add(d.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:p}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:E}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(E){E.dispose();const d=this.createKey(E.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=C;class w extends T.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,p,h){return E.call(d,p,h).then(null,y=>{throw D.UserDataSyncError.toUserDataSyncError(y)})},listen(d,p){return E.listen(d,p)}},this.channel.call("_getInitialData").then(([d,p,h])=>{this.updateStatus(d),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([p,h])=>[p,D.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:d,status:p}=await this.channel.call("createManualSyncTask"),h=this,y=new I(E,d,p,{async call(S,m,v){return h.channel.call(`manualSync/${S}`,[E,...(0,P.isArray)(m)?m:[m]],v)},listen(S,m){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${S}`,m),v=>!y.isDiposed()&&v.manualSyncTaskId===E),v=>v.data)}});return y}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,d,p,h){return this.channel.call("accept",[E,d,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getAssociatedResources(E,d){return(await this.channel.call("getAssociatedResources",[E,d])).map(({resource:h,comparableResource:y})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(y)}))}async getMachineId(E,d){return this.channel.call("getMachineId",[E,d])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([d,p])=>[d,p.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=w;class I extends T.Disposable{constructor(E,d,p,h){super();this.id=E,this.manifest=d,this._disposed=!1,this._status=p;const y=this;this.channel={async call(S,m,v){try{const f=await h.call(S,m,v);return y.isDiposed()||(y._status=await h.call("_getStatus")),f}catch(f){throw D.UserDataSyncError.toUserDataSyncError(f)}},listen(S,m){return h.listen(S,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,d){const p=await this.channel.call("accept",[E,d]);return this.deserializePreviews(p)}async merge(E){const d=await this.channel.call("merge",[E]);return this.deserializePreviews(d)}async discard(E){const d=await this.channel.call("discard",[E]);return this.deserializePreviews(d)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([d,p])=>[d,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(te[237],ne([0,1,5,28,7,3,2,110,4,18,17,8,29,21,11,14,27,44,46,23,24]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",i="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",t=100,a=1e3*60*5;let o=class extends D.Disposable{constructor(O,q,N){super();this.productService=O,this.configurationService=q,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new R.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(R.Event.filter(N.onDidChangeValue,L=>L.key===c.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,O,0,w.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,q){O=w.isWeb&&O?.web?{...O,...O.web}:O;const N={...O||{},...q||{}};if(N&&(0,n.isString)(N.url)&&(0,n.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>(0,n.isArray)(N.authenticationProviders[L].scopes))){const L=N,$=!!L.canSwitch&&!q?.url,_=L.url===L.insidersUrl?"insiders":"stable",M=($?this.userDataSyncStoreType:void 0)||_,j=q?.url||(M==="insiders"?L.insidersUrl:M==="stable"?L.stableUrl:L.url);return{url:E.URI.parse(j),type:M,defaultType:_,defaultUrl:E.URI.parse(L.url),stableUrl:E.URI.parse(L.stableUrl),insidersUrl:E.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((W,x)=>(W.push({id:x,scopes:L.authenticationProviders[x].scopes}),W),[])}}}};o=he([J(0,S.IProductService),J(1,p.IConfigurationService),J(2,f.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,q,N){super(O,q,N);const L=this.storageService.get(l,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const $=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([J(0,S.IProductService),J(1,p.IConfigurationService),J(2,f.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends D.Disposable{constructor(O,q,N,L,$,_,M){super();this.requestService=N,this.logService=L,this.storageService=M,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new R.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new R.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,v.getServiceMachineId)($,_,M).then(j=>{const W={"X-Client-Name":`${q.applicationName}${w.isWeb?"-web":""}`,"X-Client-Version":q.version};return q.commit&&(W["X-Client-Commit"]=q.commit),W}),this.session=new A(t,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,D.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,q){this.authToken={token:O,type:q}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(i,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(i,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(q=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),q).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,q=>null)):this.storageService.remove(i,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),N={},L=await this.request(q.toString(),{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,m.asJson)(L)||[]).map(({url:_,created:M})=>({ref:(0,I.relativePath)(q,q.with({path:_})),created:M*1e3}))}async resolveContent(O,q){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,q).toString(),L={};L["Cache-Control"]="no-cache";const $=await this.request(N,{type:"GET",headers:L},[],T.CancellationToken.None);return await(0,m.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),N={};await this.request(q,{type:"DELETE",headers:N},[],T.CancellationToken.None)}async read(O,q,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();N={...N},N["Cache-Control"]="no-cache",q&&(N["If-None-Match"]=q.ref);const $=await this.request(L,{type:"GET",headers:N},[304],T.CancellationToken.None);let _=null;if($.res.statusCode===304&&(_=q),_===null){const M=$.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,m.asText)($);if(!j&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",L,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);_={ref:M,content:j}}return _}async write(O,q,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();L={...L},L["Content-Type"]=C.Mimes.text,N&&(L["If-Match"]=N);const _=await this.request($,{type:"POST",data:q,headers:L},[],T.CancellationToken.None),M=_.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",_.res.statusCode,_.res.headers[c.HEADER_OPERATION_ID]);return M}async manifest(O,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();q={...q},q["Content-Type"]="application/json",O&&(q["If-None-Match"]=O.ref);const L=await this.request(N,{type:"GET",headers:q},[304],T.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=O),!$){const M=L.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);const j=await(0,m.asText)(L);if(!j&&L.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);j&&($={...JSON.parse(j),ref:M})}const _=this.storageService.get(s,0);return _&&$&&_!==$.session&&this.clearSession(),$===null&&_&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),q={"Content-Type":C.Mimes.text};await this.request(O,{type:"DELETE",headers:q},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,q,N,L){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;q.headers={...q.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(q.headers),this.logService.trace("Sending request to server",{url:O,type:q.type,headers:{...q.headers,authorization:void 0}});let _;try{_=await this.session.request(O,q,L)}catch(x){if(!(x instanceof c.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,P.getErrorMessage)(x).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,P.isPromiseCanceledError)(x)&&(z="RequestCanceled"),x=new c.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,z,void 0,void 0)}throw this.logService.info("Request failed",O),x}const M=_.res.headers[c.HEADER_OPERATION_ID],j={url:O,status:_.res.statusCode,"execution-id":q.headers[c.HEADER_EXECUTION_ID],"operation-id":M},W=(0,m.isSuccess)(_)||_.res.statusCode&&N.indexOf(_.res.statusCode)!==-1;if(W?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",_.res.statusCode,M);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",_.res.statusCode,M);if(_.res.statusCode===410)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",_.res.statusCode,M);if(_.res.statusCode===412)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",_.res.statusCode,M);if(_.res.statusCode===413)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",_.res.statusCode,M);if(_.res.statusCode===426)throw new c.UserDataSyncStoreError(`${q.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",_.res.statusCode,M);if(_.res.statusCode===429){const x=_.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",_.res.statusCode,M)):new c.UserDataSyncStoreError(`${q.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",_.res.statusCode,M)}if(!W)throw new c.UserDataSyncStoreError("Server returned "+_.res.statusCode,O,"Unknown",_.res.statusCode,M);return _}addSessionHeaders(O){let q=this.storageService.get(r,0);q===void 0&&(q=(0,d.generateUuid)(),this.storageService.store(r,q,0,1)),O["X-Machine-Session-Id"]=q;const N=this.storageService.get(s,0);N!==void 0&&(O["X-User-Session-Id"]=N)}};g=he([J(1,S.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,f.IStorageService)],g),e.UserDataSyncStoreClient=g;let b=class extends g{constructor(O,q,N,L,$,_,M){super(O.userDataSyncStore?.url,q,N,L,$,_,M);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};b=he([J(0,c.IUserDataSyncStoreManagementService),J(1,S.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,f.IStorageService)],b),e.UserDataSyncStoreService=b;class A{constructor(O,q,N,L){this.limit=O,this.interval=q,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(O,q,N){if(this.isExpired()&&this.reset(),q.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(q,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[238],ne([0,1,3,61,27,23,22,100,24,64,65]),function(X,e,k,T,P,R,D,C,w,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends C.UserDataAutoSyncService{constructor(p,h,y,S,m,v,f,c,l,i,s,r){super(p,h,y,S,m,f,c,l,i,s,r);this._register(k.Event.debounce(k.Event.any(k.Event.map(v.onDidFocusWindow,()=>"windowFocus"),k.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(t,a)=>t?[...t,a]:[a],1e3)(t=>this.triggerSync(t,!0,!1)))}};E=he([J(0,P.IProductService),J(1,w.IUserDataSyncStoreManagementService),J(2,w.IUserDataSyncStoreService),J(3,w.IUserDataSyncResourceEnablementService),J(4,w.IUserDataSyncService),J(5,T.INativeHostService),J(6,w.IUserDataSyncLogService),J(7,I.IUserDataSyncAccountService),J(8,D.ITelemetryService),J(9,n.IUserDataSyncMachinesService),J(10,R.IStorageService),J(11,w.IUserDataAutoSyncEnablementService)],E),e.UserDataAutoSyncService=E}),define(te[239],ne([0,1,5,3,2]),function(X,e,k,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends P.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:w,getActiveWindowId:I}){super();this.disposables=this._register(new P.DisposableStore),T.Event.latch(T.Event.any(C,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>I()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[66],ne([0,1,51,5,9,17,20,127,250,251]),function(X,e,k,T,P,R,D,C,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(i,s){let r=s.message;switch(i){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=i,this.cause=s}}e.ExtractError=n;function E(l){const i=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>i&s).reduce((s,r)=>s+r,i&61440)}function d(l){if(l instanceof n)return l;let i;return/end of central directory record signature not found/.test(l.message)&&(i="CorruptZip"),new n(i,l)}function p(l,i,s,r,t,a){const o=P.dirname(i),u=P.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(C.localize(0,null,i)));const g=P.join(r,i);let b;return a.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(D.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,U)=>{if(!a.isCancellationRequested)try{b=(0,k.createWriteStream)(g,{mode:s}),b.once("close",()=>A()),b.once("error",U),l.once("error",U),l.pipe(b)}catch(O){U(O)}}))}function h(l,i,s,r){let t=(0,T.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((o,u)=>{const g=new T.Sequencer,b=A=>{A.isCancellationRequested||(a++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{r.isCancellationRequested||l.entryCount===a?o():u(new n("Incomplete",new Error(C.localize(1,null,a,l.entryCount))))},u)),l.readEntry(),l.on("entry",A=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){b(r);return}const U=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(U)){const N=P.join(i,U);t=(0,T.createCancelablePromise)(L=>D.Promises.mkdir(N,{recursive:!0}).then(()=>b(L)).then(void 0,u));return}const O=S(l,A),q=E(A);t=(0,T.createCancelablePromise)(N=>g.queue(()=>O.then(L=>p(L,U,q,i,s,N).then(()=>b(N)))).then(null,u))})})}function y(l,i=!1){return new Promise((s,r)=>{(0,w.open)(l,i?{lazyEntries:!0}:void 0,(t,a)=>{t?r(d(t)):s((0,R.assertIsDefined)(a))})})}function S(l,i){return new Promise((s,r)=>{l.openReadStream(i,(t,a)=>{t?r(d(t)):s((0,R.assertIsDefined)(a))})})}function m(l,i){return new Promise((s,r)=>{const t=new I.ZipFile;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const a=(0,k.createWriteStream)(l);t.outputStream.pipe(a),t.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(l))})}e.zip=m;function v(l,i,s={},r){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=y(l,!0);return s.overwrite&&(a=a.then(o=>D.Promises.rm(i).then(()=>o))),a.then(o=>h(o,i,{sourcePathRegex:t},r))}e.extract=v;function f(l,i){return y(l).then(s=>new Promise((r,t)=>{s.on("entry",a=>{a.fileName===i&&S(s,a).then(o=>r(o),o=>t(o))}),s.once("close",()=>t(new Error(C.localize(2,null,i))))}))}function c(l,i){return f(l,i).then(s=>new Promise((r,t)=>{const a=[];s.once("error",t),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=c}),define(te[240],ne([0,1,66,136]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(R){return(0,k.buffer)(R,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch(C){throw new Error((0,T.localize)(0,null))}})}e.getManifest=P}),define(te[241],ne([0,1,16,5,7,2,15,9,4,18,62,8,29,20,66,137,11,30,36,158,14,10,27]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends R.Disposable{constructor(t,a,o,u,g){super();this.beforeRemovingExtension=t,this.fileService=a,this.logService=o,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const a=[];(t===null||t===0)&&a.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&a.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(a);return(0,k.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[a,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(u=>!a[new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(o=(0,v.groupByExtension)(o,g=>g.identifier).map(g=>g.sort((b,A)=>n.rcompare(b.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,a,o,u){const g=t.key(),b=C.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),A=C.join(this.extensionsPath,g);try{await p.Promises.rm(A)}catch(O){try{await p.Promises.rm(A)}catch(q){}throw new m.ExtensionManagementError((0,y.localize)(0,null,A,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,a,b,u);let U=await this.scanExtension(E.URI.file(b),1);if(!U)throw new Error((0,y.localize)(1,null,b));await this.storeMetadata(U,{...o,installedTimestamp:Date.now()});try{await this.rename(t,b,A,Date.now()+2*60*1e3),this.logService.info("Renamed to",A)}catch(O){try{await p.Promises.rm(b)}catch(q){}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(O)}. Deleted from extracted location`,b),O}try{U=await this.scanExtension(E.URI.file(A),1)}catch(O){}if(U)return U;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,a){return this.setMetadata(t,a),await this.storeMetadata(t,{...a,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const o=C.join(t.location.fsPath,"package.json"),u=await p.Promises.readFile(o,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=a,await p.Promises.writeFile(o,JSON.stringify(g,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const a=t.map(o=>new v.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{a.forEach(u=>o[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const o=(await this.scanExtensions(1)).find(u=>new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let o={};if(a)try{o=JSON.parse(a)}catch(u){}return t&&(t(o),Object.keys(o).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await p.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,a){this.logService.trace(`Deleting ${a} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new v.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,a,o,u){this.logService.trace(`Started extracting the extension from ${a} to ${o}`);try{await p.Promises.rm(o)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(a,o,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(g){try{await p.Promises.rm(o)}catch(A){}let b=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?b=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(b=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,b)}}async rename(t,a,o,u){try{await p.Promises.rename(a,o)}catch(g){if(w.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${a} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,a,o,u);throw new m.ExtensionManagementError(g.message||(0,y.localize)(3,null,a,o),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const a=this.scanDevSystemExtensions(),[o,u]=await Promise.all([t,a]);return[...o,...u]}async scanExtensionsInDir(t,a){const o=new T.Limiter(10),u=await this.fileService.resolve(E.URI.file(t));return u.children?(await Promise.all(u.children.filter(b=>b.isDirectory).map(b=>o.queue(async()=>a===1&&(0,I.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,a))))).filter(b=>b&&b.identifier):[]}async scanExtension(t,a){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:u,metadata:g}=await this.readManifest(t.fsPath),b=o.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,A=o.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource,U={id:(0,v.getGalleryExtensionId)(u.publisher,u.name)},O={type:a,identifier:U,manifest:u,location:t,readmeUrl:b,changelogUrl:A,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return g&&(this.setMetadata(O,g),O.installedTimestamp=g.installedTimestamp),O}}catch(o){a!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(o=>t.some(u=>(0,v.areSameExtensions)(o.identifier,{id:u})))}else return[]}setMetadata(t,a){t.publisherDisplayName=a.publisherDisplayName||null,t.publisherId=a.publisherId||null,t.identifier.uuid=a.id,t.isMachineScoped=!!a.isMachineScoped,t.isBuiltin=t.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),o=new Set;for(const b of a)t[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]||o.add(b.identifier.id.toLowerCase());const u=(0,v.groupByExtension)(a,b=>b.identifier);await T.Promises.settled(u.map(async b=>{const A=b.sort((U,O)=>n.rcompare(U.manifest.version,O.manifest.version))[0];o.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const g=a.filter(b=>t[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]);await T.Promises.settled(g.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),a=[],o=(0,v.groupByExtension)(t,u=>u.identifier);a.push(...(0,k.flatten)(o.map(u=>u.sort((g,b)=>n.rcompare(g.manifest.version,b.manifest.version)).slice(1)))),await T.Promises.settled(a.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const a=Array.isArray(t)?t:[t];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(D.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const a=[p.Promises.readFile(C.join(t,"package.json"),"utf8").then(b=>this.parseManifest(b)),p.Promises.readFile(C.join(t,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:o,metadata:u},g]=await Promise.all(a);return{manifest:(0,f.localizeManifest)(o,g),metadata:u}}parseManifest(t){return new Promise((a,o)=>{try{const u=JSON.parse(t),g=u.__metadata||null;a({manifest:u,metadata:g})}catch(u){o(new Error((0,y.localize)(4,null)))}})}};s=he([J(1,c.IFileService),J(2,l.ILogService),J(3,S.INativeEnvironmentService),J(4,i.IProductService)],s),e.ExtensionsScanner=s}),define(te[242],ne([0,1,38,7,15,9,4,31,18,62,8,29,20,66,135,79,11,205,30,36,189,177,240,190,241,219,77,14,6,10,27,22,37]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l,i,s,r,t,a,o,u,g,b,A,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends m.AbstractExtensionManagementService{constructor(M,j,W,x,z,K,F,B,V){super(M,j,W,B);this.environmentService=x,this.downloadService=z,this.fileService=F;const Q=this._register(K.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(r.ExtensionsScanner,G=>Q.postUninstall(G))),this.manifestCache=this._register(new s.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(K.createInstance(c.ExtensionsDownloader));const Z=this._register(new t.ExtensionsWatcher(this,F,x,W,V));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:G,removed:H})=>{G.length&&this._onDidInstallExtensions.fire(G.map(re=>({identifier:re.identifier,operation:0,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),j=(0,v.getTargetPlatform)(M?"alpine":D.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",j),j})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let M;try{M=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(j){try{M=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(W){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(W))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const j=await this.collectFiles(M),W=await(0,p.zip)((0,w.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,j);return n.URI.file(W)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const j=await this.downloadVsix(M),W=R.resolve(j.fsPath);return(0,i.getManifest)(W)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,j={}){this.logService.trace("ExtensionManagementService#install",M.toString());const W=await this.downloadVsix(M),x=await(0,i.getManifest)(R.resolve(W.fsPath));if(x.engines&&x.engines.vscode&&!(0,a.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,f.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,W,j)}async updateMetadata(M,j){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...j}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,j){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:j}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===P.Schemas.file)return M;const j=(0,w.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(M,j),j}createInstallExtensionTask(M,j,W){return n.URI.isUri(j)?new L(M,j,W,this.galleryService,this.extensionsScanner,this.logService):new N(j,W,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,j){return new $(M,j,this.extensionsScanner)}async collectFiles(M){const j=async x=>{let z=await d.Promises.readdir(x);z=z.map(B=>R.join(x,B));const K=await Promise.all(z.map(B=>d.Promises.stat(B)));let F=Promise.resolve([]);return K.forEach((B,V)=>{const Q=z[V];B.isFile()&&(F=F.then(Z=>[...Z,Q])),B.isDirectory()&&(F=F.then(Z=>j(Q).then(G=>[...Z,...G])))}),F};return(await j(M.location.fsPath)).map(x=>({path:`extension/${R.relative(M.location.fsPath,x)}`,localPath:x}))}};O=he([J(0,v.IExtensionGalleryService),J(1,A.ITelemetryService),J(2,g.ILogService),J(3,S.INativeEnvironmentService),J(4,y.IDownloadService),J(5,u.IInstantiationService),J(6,o.IFileService),J(7,b.IProductService),J(8,U.IUriIdentityService)],O),e.ExtensionManagementService=O;class q extends m.AbstractExtensionTask{constructor(M,j,W,x){super();this.identifier=M,this.source=j,this.extensionsScanner=W,this.logService=x,this._operation=1}get operation(){return this._operation}async installExtension(M,j){try{const W=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(W)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(W,M.metadata):W}catch(W){throw D.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(h.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(M,j)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const W=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),W}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:j,metadata:W},x){let z=await this.extensionsScanner.extractUserExtension(j,M,W,x);return this.logService.info("Extracting completed.",j.id),z}}class N extends q{constructor(M,j,W,x,z){super(M.identifier,M,x,z);this.gallery=M,this.options=j,this.extensionsDownloader=W}async doRun(M){const W=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,f.areSameExtensions)(z.identifier,this.gallery.identifier));W&&(this._operation=2);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||W?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||W?.isBuiltin;try{const z=await this.installExtension(x,M);return W&&I.neq(W.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(W),z}catch(z){throw await this.deleteDownloadedVSIX(x.zipPath),z}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(n.URI.file(M))}catch(j){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,T.getErrorMessage)(j))}}async downloadInstallableExtension(M,j){const W={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",M.identifier.id),x=(await this.extensionsDownloader.downloadExtension(M,j)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,x)}catch(z){throw new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Download)}try{const z=await(0,i.getManifest)(x);return{zipPath:x,identifierWithVersion:new f.ExtensionIdentifierWithVersion(M.identifier,z.version),metadata:W}}catch(z){throw await this.deleteDownloadedVSIX(x),new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Invalid)}}}class L extends q{constructor(M,j,W,x,z,K){super({id:(0,f.getGalleryExtensionId)(M.publisher,M.name)},j,z,K);this.manifest=M,this.location=j,this.options=W,this.galleryService=x}async doRun(M){const j=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,f.areSameExtensions)(this.identifier,K.identifier)),z=await this.getMetadata(this.identifier.id,M);if(z.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=2,j.equals(new f.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch(K){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else I.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const K=await this.unsetUninstalledAndGetLocal(j);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(F){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:j,metadata:z},M)}async getMetadata(M,j){try{const W=(await this.galleryService.query({names:[M],pageSize:1},j)).firstPage[0];if(W)return{id:W.identifier.uuid,publisherDisplayName:W.publisherDisplayName,publisherId:W.publisherId}}catch(W){}return{}}}class $ extends m.AbstractExtensionTask{constructor(M,j,W){super();this.extension=M,this.options=j,this.extensionsScanner=W}async doRun(M){const j=[],W=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);j.push(...W.filter(z=>x.equals(new f.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else j.push(...W.filter(x=>(0,f.areSameExtensions)(x.identifier,this.extension.identifier)));if(!j.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...j),this.options.remove)for(const x of j)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(z){throw new Error(h.localize(6,null,(0,k.toErrorMessage)(z)))}}}}),define(te[243],ne([0,1,82,57,33,19,7,3,2,9,4,29,34,72,252]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(u){this.socket=u,this._errorListener=g=>{if(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const g=b=>u(R.VSBuffer.wrap(b));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(u){const g=b=>{u({type:0,hadError:b,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,D.onUnexpectedError)(g)}}end(){this.socket.end()}drain(){return new Promise((u,g)=>{if(this.socket.bufferSize===0){u();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),u()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=y;var S;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var m;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(m||(m={}));class v extends w.Disposable{constructor(u,g,b,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=A,g?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",U=>{console.error(U),(0,D.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibInflate.on("data",U=>{this._pendingInflateData.push(U)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",U=>{console.error(U),(0,D.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})}),this._zlibDeflate.on("data",U=>{this._pendingDeflateData.push(U)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):R.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(R.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,g){let b=2;u.byteLength<126?b+=0:u.byteLength<2**16?b+=2:b+=8;const A=R.VSBuffer.alloc(b);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let U=1;A.writeUInt8(u.byteLength>>>8&255,++U),A.writeUInt8(u.byteLength>>>0&255,++U)}else{A.writeUInt8(127,1);let U=1;A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(0,++U),A.writeUInt8(u.byteLength>>>24&255,++U),A.writeUInt8(u.byteLength>>>16&255,++U),A.writeUInt8(u.byteLength>>>8&255,++U),A.writeUInt8(u.byteLength>>>0&255,++U)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(R.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),b=g.readUInt8(0),A=(b&128)>>>7,U=(b&64)>>>6,O=g.readUInt8(1),q=(O&128)>>>7,N=O&127;this._state.state=2,this._state.readLen=2+(q?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),b=g.readUInt8(1),A=(b&128)>>>7;let U=b&127,O=1;U===126?U=g.readUInt8(++O)*2**8+g.readUInt8(++O):U===127&&(U=g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*0+g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O));let q=0;A&&(q=g.readUInt8(++O)*2**24+g.readUInt8(++O)*2**16+g.readUInt8(++O)*2**8+g.readUInt8(++O)),this._state.state=3,this._state.readLen=U,this._state.mask=q}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);f(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(R.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function f(o,u){if(u===0)return;let g=o.byteLength>>>2;for(let N=0;N<g;N++){const L=o.readUInt32BE(N*4);o.writeUInt32BE(L^u,N*4)}let b=g*4,A=o.byteLength-b;const U=u>>>24&255,O=u>>>16&255,q=u>>>8&255;A>=1&&o.writeUInt8(o.readUInt8(b)^U,b),A>=2&&o.writeUInt8(o.readUInt8(b+1)^O,b+1),A>=3&&o.writeUInt8(o.readUInt8(b+2)^q,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const o=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,I.join)((0,P.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=l;function i(o,u,g){const b=(0,k.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${g}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,I.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${g}-${u}.sock`):A=(0,I.join)(o,`${g}-${u}.sock`),s(A),A}e.createStaticIPCHandle=i;function s(o){const u=c[n.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends d.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const g=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(g,b=>({protocol:new p.Protocol(new y(b)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(o){return new Promise((u,g)=>{const b=(0,T.createServer)();b.on("error",g),b.listen(o,()=>{b.removeListener("error",g),u(new r(b))})})}e.serve=t;function a(o,u){return new Promise((g,b)=>{const A=(0,T.createConnection)(o,()=>{A.removeListener("error",b),g(p.Client.fromSocket(new y(A),u))});A.once("error",b)})}e.connect=a}),define(te[244],ne([0,1,57,243]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(P,R,D,C){const w=n=>C(n,void 0),I=k.createConnection({host:P,port:R},()=>{I.removeListener("error",w);const n=Buffer.alloc(16);for(let h=0;h<16;h++)n[h]=Math.round(Math.random()*256);const E=n.toString("base64");let d=[`GET ws://${/:/.test(P)?`[${P}]`:P}:${R}/?${D}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`];I.write(d.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",p),C(void 0,new T.NodeSocket(I)))};I.on("data",p)});I.once("error",w)}}}),define(te[245],ne([0,1,57,117,244,5,2,21,10,27,187,63,92]),function(X,e,k,T,P,R,D,C,w,I,n,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(v,f,c,l,i){return new h(v,f,c,l,i).waitForReady()}class h extends D.Disposable{constructor(f,c,l,i,s){super();this.defaultTunnelHost=c,this.suggestedLocalPort=s,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=f,this._server=k.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=i,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let f=await(0,T.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(f=0,this._server.listen(f,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(f){f.pause();const c=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,n.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),i=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&f.write(s.buffer),f.on("end",()=>{this._socketsDispose.delete(f.localAddress),i.end()}),f.on("close",()=>i.end()),f.on("error",()=>{this._socketsDispose.delete(f.localAddress),i.destroy()}),i.on("end",()=>f.end()),i.on("close",()=>f.end()),i.on("error",()=>{f.destroy()}),f.pipe(i),i.pipe(f),this._socketsDispose.set(f.localAddress,()=>{f.end(),i.end()})}}let y=class extends E.AbstractTunnelService{constructor(f,c,l,i,s){super(c);this.socketFactory=f,this.signService=l,this.productService=i,this.configurationService=s}get defaultTunnelHost(){const f=this.configurationService.getValue("remote.localPortHost");return!f||f==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(f,c,l,i,s,r,t){const a=this.getTunnelFromMap(c,l);if(a)return++a.refcount,a.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,i,s,r,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${i}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:f,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(o,this.defaultTunnelHost,c,l,i);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};y=he([J(1,w.ILogService),J(2,d.ISignService),J(3,I.IProductService),J(4,C.IConfigurationService)],y),e.BaseTunnelService=y;let S=class extends y{constructor(f,c,l,i){super(P.nodeSocketFactory,f,c,l,i)}};S=he([J(0,w.ILogService),J(1,d.ISignService),J(2,I.IProductService),J(3,C.IConfigurationService)],S),e.TunnelService=S;let m=class extends D.Disposable{constructor(f,c,l,i){super();this.logService=f,this.productService=c,this.signService=l,this.configurationService=i,this._tunnelServices=new Map}async openTunnel(f,c,l,i,s,r,t,a){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${i} on local port ${s}.`),!this._tunnelServices.has(f)){const o=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(f,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(f))})}return this._tunnelServices.get(f).openTunnel(c,l,i,s,r,t,a)}};m=he([J(0,w.ILogService),J(1,I.IProductService),J(2,d.ISignService),J(3,C.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[253],ne([0,1,73,33,38,7,2,15,18,8,34,121,183,163,184,174,175,176,161,165,21,185,78,204,79,195,11,156,200,208,30,164,206,242,80,159,14,180,182,53,6,171,84,172,173,60,191,10,86,61,87,27,194,44,23,202,203,22,93,94,95,45,209,210,96,212,218,98,99,100,24,64,231,232,233,65,234,235,236,237,238,239,81,178,92,199,63,245,192,193,91,198,85,207,37,220]),function(X,e,k,T,P,R,D,C,w,I,n,E,d,p,h,y,S,m,v,f,c,l,i,s,r,t,a,o,u,g,b,A,U,O,q,N,L,$,_,M,j,W,x,z,K,F,B,V,Q,Z,G,H,re,ie,ce,le,de,fe,be,Ce,Ee,Ae,Pe,Le,Fe,Ne,$e,xe,ee,ae,oe,pe,ye,_e,Re,Y,se,ue,ge,me,Ie,ke,Te,Se,we,De,Oe,Me,Qe,Ye,je,Pt,vt,Dt,Rt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends D.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",qe=(He,ze)=>this.onDisposeWorker(ze);k.ipcRenderer.on(Ue,qe),this._register((0,D.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,qe)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,oe.registerConfiguration)(),ve.invokeFunction(Ue=>{const qe=Ue.get(V.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(qe)}),this._register((0,D.combinedDisposable)(ve.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(S.LogsDataCleaner),ve.createInstance(y.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new x.ServiceCollection,Ue={_serviceBrand:void 0,...G.default};ve.set(H.IProductService,Ue);const qe=new n.StaticRouter(Be=>Be==="main"),He=new z.MessagePortMainProcessService(this.server,qe);ve.set(K.IMainProcessService,He);const ze=new o.NativeEnvironmentService(this.configuration.args,Ue);ve.set(a.INativeEnvironmentService,ze);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));ve.set(V.ILoggerService,Ze);const ot=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,w.joinPath)(I.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Q.FollowerLogService(rt,ot));ve.set(V.ILogService,Ge),this.sharedProcessWorkerService=new Pt.SharedProcessWorkerService(Ge,Ue,ze),ve.set(je.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ve.set(L.IFileService,Je);const ct=this._register(new _.DiskFileSystemProvider(Ge));Je.registerProvider(C.Schemas.file,ct);const We=this._register(new l.ConfigurationService(ze.settingsResource,Je));ve.set(c.IConfigurationService,We);const nt=new le.NativeStorageService(void 0,He,ze);ve.set(ce.IStorageService,nt),this._register((0,D.toDisposable)(()=>nt.flush())),await Promise.all([We.initialize(),nt.initialize()]),ve.set(vt.IUserConfigurationFileService,n.ProxyChannel.toService(He.getChannel(vt.UserConfigurationFileServiceId))),ve.set(Rt.IUriIdentityService,new kt.UriIdentityService(Je)),ve.set(ie.IRequestService,new M.SyncDescriptor(re.RequestService)),ve.set(v.IChecksumService,new M.SyncDescriptor(f.ChecksumService));const st=n.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(r.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new ke.ActiveWindowManager(st)),ut=new n.StaticRouter(Be=>lt.getActiveClientId().then(ft=>Be===ft));ve.set(q.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Dt.AssignmentService(this.configuration.machineId,We,Ue);let Xe;const et=[];if((0,Ae.supportsTelemetry)(Ue,ze)){const Be=new Ce.TelemetryLogAppender(Ze,ze);et.push(Be);const{appRoot:ft,extensionsPath:_t,installSourcePath:Ot}=ze;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const at=await ht.getTreatment("telemetryMigration")??!1,dt=Ue.quality!=="stable";if(dt&&at){const wt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,at,!0);this._register((0,D.toDisposable)(()=>wt.flush())),et.push(wt)}const yt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,dt?!1:at,at&&dt);this._register((0,D.toDisposable)(()=>yt.flush())),et.push(yt)}Xe=new Ee.TelemetryService({appenders:et,commonProperties:(0,de.resolveCommonProperties)(Je,(0,T.release)(),(0,T.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[ft,_t]},We)}else{Xe=Ae.NullTelemetryService;const Be=Ae.NullAppender;et.push(Be)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(et)),ve.set(fe.ITelemetryService,Xe);const At=new Le.CustomEndpointTelemetryService(We,Xe,Ze,ze);ve.set(fe.ICustomEndpointTelemetryService,At),ve.set(b.IExtensionManagementService,new M.SyncDescriptor(O.ExtensionManagementService)),ve.set(b.IExtensionGalleryService,new M.SyncDescriptor(g.ExtensionGalleryService)),ve.set(b.IExtensionTipsService,new M.SyncDescriptor(U.ExtensionTipsService)),ve.set(F.ILocalizationsService,new M.SyncDescriptor(B.LocalizationsService)),ve.set(i.IDiagnosticsService,new M.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new M.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(oe.IUserDataSyncLogService,new M.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(oe.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(b.IGlobalExtensionEnablementService,new M.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(xe.IExtensionsStorageSyncService,new M.SyncDescriptor(xe.ExtensionsStorageSyncService)),ve.set(oe.IUserDataSyncStoreManagementService,new M.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(oe.IUserDataSyncStoreService,new M.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new M.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(oe.IUserDataSyncBackupStoreService,new M.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(oe.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(ae.UserDataAutoSyncEnablementService)),ve.set(oe.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(oe.IUserDataSyncService,new M.SyncDescriptor(ue.UserDataSyncService));const St=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:We.getValue("terminal.integrated.persistentSessionScrollback")??100},We,ze,Ge,Xe);return await St.initialize(),ve.set(Ne.ILocalPtyService,this._register(St)),ve.set(Te.IExtensionHostStarter,this._register(new Se.ExtensionHostStarter(Ge))),ve.set(we.ISignService,new M.SyncDescriptor(De.SignService)),ve.set(Oe.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),ve.set(Qe.ISharedProcessTunnelService,new M.SyncDescriptor(Ye.SharedProcessTunnelService)),new W.InstantiationService(ve)}initChannels(ve){const Ue=new A.ExtensionManagementChannel(ve.get(b.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const qe=n.ProxyChannel.fromService(ve.get(F.ILocalizationsService));this.server.registerChannel("localizations",qe);const He=n.ProxyChannel.fromService(ve.get(i.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const ze=new A.ExtensionTipsChannel(ve.get(b.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=n.ProxyChannel.fromService(ve.get(v.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const ot=n.ProxyChannel.fromService(ve.get(fe.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ot);const Ge=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(oe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ct=new ge.UserDataSyncChannel(ve.get(oe.IUserDataSyncService),ve.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const We=this._register(ve.get(j.IInstantiationService).createInstance(Ie.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(We);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),lt=n.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=n.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,ut);const ht=n.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,ht);const Xe=n.ProxyChannel.fromService(ve.get(je.ISharedProcessWorkerService));this.server.registerChannel(je.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,R.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Ue=>{const qe=(0,P.toErrorMessage)(Ue,!0);!qe||ve.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Lt(pt){const ve=new Tt(pt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Lt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bef4dba21f68bbdb8d9f08fe04b2e1858597722b/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
