/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","os","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Y=function(z){for(var t=[],L=0,I=z.length;L<I;L++)t[L]=J[z[L]];return t};define(J[56],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function L(I,b){if(!I)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}t.ok=L}),define(J[46],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function L(T){return(w,c,d)=>{let p=null,C=null;if(typeof d.value=="function"?(p="value",C=d.value):typeof d.get=="function"&&(p="get",C=d.get),!C)throw new Error("not supported");d[p]=T(C,c)}}t.createDecorator=L;function I(T,w,c){let d=null,p=null;if(typeof c.value=="function"?(d="value",p=c.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",p=c.get),!p)throw new Error("not supported");const C=`$memoize$${w}`;c[d]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,f)}),this[C]}}t.memoize=I;function b(T,w,c){return L((d,p)=>{const C=`$debounce$${p}`,f=`$debounce$result$${p}`;return function(...S){this[f]||(this[f]=c?c():void 0),clearTimeout(this[C]),w&&(this[f]=w(this[f],...S),S=[this[f]]),this[C]=setTimeout(()=>{d.apply(this,S),this[f]=c?c():void 0},T)}})}t.debounce=b;function D(T,w,c){return L((d,p)=>{const C=`$throttle$timer$${p}`,f=`$throttle$result$${p}`,S=`$throttle$lastRun$${p}`,l=`$throttle$pending$${p}`;return function(...h){if(this[f]||(this[f]=c?c():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),w&&(this[f]=w(this[f],...h)),this[l])return;const v=this[S]+T;v<=Date.now()?(this[S]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0):(this[l]=!0,this[C]=setTimeout(()=>{this[l]=!1,this[S]=Date.now(),d.apply(this,[this[f]]),this[f]=c?c():void 0},v-Date.now()))}})}t.throttle=D}),define(J[57],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var L;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(L=t.ScanError||(t.ScanError={}));var I;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(I=t.SyntaxKind||(t.SyntaxKind={}));var b;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(b=t.ParseErrorCode||(t.ParseErrorCode={}));var D;(function(e){e.DEFAULT={allowTrailingComma:!0}})(D=t.ParseOptions||(t.ParseOptions={}));function T(e,r=!1){let i=0,n=e.length,a="",m=0,y=16,R=0;function P(ne){let he=0,B=0;for(;he<ne;){const q=e.charCodeAt(i);if(q>=48&&q<=57)B=B*16+q-48;else if(q>=65&&q<=70)B=B*16+q-65+10;else if(q>=97&&q<=102)B=B*16+q-97+10;else break;i++,he++}return he<ne&&(B=-1),B}function O(ne){i=ne,a="",m=0,y=16,R=0}function U(){const ne=i;if(e.charCodeAt(i)===48)i++;else for(i++;i<e.length&&d(e.charCodeAt(i));)i++;if(i<e.length&&e.charCodeAt(i)===46)if(i++,i<e.length&&d(e.charCodeAt(i)))for(i++;i<e.length&&d(e.charCodeAt(i));)i++;else return R=3,e.substring(ne,i);let he=i;if(i<e.length&&(e.charCodeAt(i)===69||e.charCodeAt(i)===101))if(i++,(i<e.length&&e.charCodeAt(i)===43||e.charCodeAt(i)===45)&&i++,i<e.length&&d(e.charCodeAt(i))){for(i++;i<e.length&&d(e.charCodeAt(i));)i++;he=i}else R=3;return e.substring(ne,he)}function G(){let ne="",he=i;for(;;){if(i>=n){ne+=e.substring(he,i),R=2;break}const B=e.charCodeAt(i);if(B===34){ne+=e.substring(he,i),i++;break}if(B===92){if(ne+=e.substring(he,i),i++,i>=n){R=2;break}switch(e.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:const re=P(4);re>=0?ne+=String.fromCharCode(re):R=4;break;default:R=5}he=i;continue}if(B>=0&&B<=31)if(c(B)){ne+=e.substring(he,i),R=2;break}else R=6;i++}return ne}function ee(){if(a="",R=0,m=i,i>=n)return m=n,y=17;let ne=e.charCodeAt(i);if(w(ne)){do i++,a+=String.fromCharCode(ne),ne=e.charCodeAt(i);while(w(ne));return y=15}if(c(ne))return i++,a+=String.fromCharCode(ne),ne===13&&e.charCodeAt(i)===10&&(i++,a+=`
`),y=14;switch(ne){case 123:return i++,y=1;case 125:return i++,y=2;case 91:return i++,y=3;case 93:return i++,y=4;case 58:return i++,y=6;case 44:return i++,y=5;case 34:return i++,a=G(),y=10;case 47:const he=i-1;if(e.charCodeAt(i+1)===47){for(i+=2;i<n&&!c(e.charCodeAt(i));)i++;return a=e.substring(he,i),y=12}if(e.charCodeAt(i+1)===42){i+=2;const B=n-1;let q=!1;for(;i<B;){if(e.charCodeAt(i)===42&&e.charCodeAt(i+1)===47){i+=2,q=!0;break}i++}return q||(i++,R=1),a=e.substring(he,i),y=13}return a+=String.fromCharCode(ne),i++,y=16;case 45:if(a+=String.fromCharCode(ne),i++,i===n||!d(e.charCodeAt(i)))return y=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=U(),y=11;default:for(;i<n&&ce(ne);)i++,ne=e.charCodeAt(i);if(m!==i){switch(a=e.substring(m,i),a){case"true":return y=8;case"false":return y=9;case"null":return y=7}return y=16}return a+=String.fromCharCode(ne),i++,y=16}}function ce(ne){if(w(ne)||c(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:O,getPosition:()=>i,scan:r?le:ee,getToken:()=>y,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>i-m,getTokenError:()=>R}}t.createScanner=T;function w(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var p;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(p||(p={}));function C(e,r){const i=[],n=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let y=!1;function R(P,O,U,G){m.value=P,m.offset=O,m.length=U,m.type=G,m.colonOffset=void 0,a=m}try{u(e,{onObjectBegin:(P,O)=>{if(r<=P)throw n;a=void 0,y=r>P,i.push("")},onObjectProperty:(P,O,U)=>{if(r<O||(R(P,O,U,"property"),i[i.length-1]=P,r<=O+U))throw n},onObjectEnd:(P,O)=>{if(r<=P)throw n;a=void 0,i.pop()},onArrayBegin:(P,O)=>{if(r<=P)throw n;a=void 0,i.push(0)},onArrayEnd:(P,O)=>{if(r<=P)throw n;a=void 0,i.pop()},onLiteralValue:(P,O,U)=>{if(r<O||(R(P,O,U,o(P)),r<=O+U))throw n},onSeparator:(P,O,U)=>{if(r<=O)throw n;if(P===":"&&a&&a.type==="property")a.colonOffset=O,y=!1,a=void 0;else if(P===","){const G=i[i.length-1];typeof G=="number"?i[i.length-1]=G+1:(y=!0,i[i.length-1]=""),a=void 0}}})}catch(P){if(P!==n)throw P}return{path:i,previousNode:a,isAtPropertyKey:y,matches:P=>{let O=0;for(let U=0;O<P.length&&U<i.length;U++)if(P[O]===i[U]||P[O]==="*")O++;else if(P[O]!=="**")return!1;return O===P.length}}}t.getLocation=C;function f(e,r=[],i=D.DEFAULT){let n=null,a=[];const m=[];function y(P){Array.isArray(a)?a.push(P):n!==null&&(a[n]=P)}return u(e,{onObjectBegin:()=>{const P={};y(P),m.push(a),a=P,n=null},onObjectProperty:P=>{n=P},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const P=[];y(P),m.push(a),a=P,n=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:y,onError:(P,O,U)=>{r.push({error:P,offset:O,length:U})}},i),a[0]}t.parse=f;function S(e,r=[],i=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(P){n.type==="property"&&(n.length=P-n.offset,n=n.parent)}function m(P){return n.children.push(P),P}u(e,{onObjectBegin:P=>{n=m({type:"object",offset:P,length:-1,parent:n,children:[]})},onObjectProperty:(P,O,U)=>{n=m({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:P,offset:O,length:U,parent:n})},onObjectEnd:(P,O)=>{n.length=P+O-n.offset,n=n.parent,a(P+O)},onArrayBegin:(P,O)=>{n=m({type:"array",offset:P,length:-1,parent:n,children:[]})},onArrayEnd:(P,O)=>{n.length=P+O-n.offset,n=n.parent,a(P+O)},onLiteralValue:(P,O,U)=>{m({type:o(P),offset:O,length:U,parent:n,value:P}),a(O+U)},onSeparator:(P,O,U)=>{n.type==="property"&&(P===":"?n.colonOffset=O:P===","&&a(O))},onError:(P,O,U)=>{r.push({error:P,offset:O,length:U})}},i);const R=n.children[0];return R&&delete R.parent,R}t.parseTree=S;function l(e,r){if(!e)return;let i=e;for(let n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let a=!1;for(const m of i.children)if(Array.isArray(m.children)&&m.children[0].value===n){i=m.children[1],a=!0;break}if(!a)return}else{const a=n;if(i.type!=="array"||a<0||!Array.isArray(i.children)||a>=i.children.length)return;i=i.children[a]}return i}t.findNodeAtLocation=l;function h(e){if(!e.parent||!e.parent.children)return[];const r=h(e.parent);if(e.parent.type==="property"){const i=e.parent.children[0].value;r.push(i)}else if(e.parent.type==="array"){const i=e.parent.children.indexOf(e);i!==-1&&r.push(i)}return r}t.getNodePath=h;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const r=Object.create(null);for(let i of e.children){const n=i.children[1];n&&(r[i.children[0].value]=v(n))}return r;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function g(e,r,i=!1){return r>=e.offset&&r<e.offset+e.length||i&&r===e.offset+e.length}t.contains=g;function E(e,r,i=!1){if(g(e,r,i)){const n=e.children;if(Array.isArray(n))for(let a=0;a<n.length&&n[a].offset<=r;a++){const m=E(n[a],r,i);if(m)return m}return e}}t.findNodeAtOffset=E;function u(e,r,i=D.DEFAULT){const n=T(e,!1);function a(X){return X?()=>X(n.getTokenOffset(),n.getTokenLength()):()=>!0}function m(X){return X?Z=>X(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const y=a(r.onObjectBegin),R=m(r.onObjectProperty),P=a(r.onObjectEnd),O=a(r.onArrayBegin),U=a(r.onArrayEnd),G=m(r.onLiteralValue),ee=m(r.onSeparator),ce=a(r.onComment),le=m(r.onError),ne=i&&i.disallowComments,he=i&&i.allowTrailingComma;function B(){for(;;){const X=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ne||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(X){case 12:case 13:ne?q(10):ce();break;case 16:q(1);break;case 15:case 14:break;default:return X}}}function q(X,Z=[],_=[]){if(le(X),Z.length+_.length>0){let N=n.getToken();for(;N!==17;){if(Z.indexOf(N)!==-1){B();break}else if(_.indexOf(N)!==-1)break;N=B()}}}function re(X){const Z=n.getTokenValue();return X?G(Z):R(Z),B(),!0}function M(){switch(n.getToken()){case 11:let X=0;try{X=JSON.parse(n.getTokenValue()),typeof X!="number"&&(q(2),X=0)}catch(Z){q(2)}G(X);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return B(),!0}function k(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(re(!1),n.getToken()===6?(ee(":"),B(),te()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function j(){y(),B();let X=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(X||q(4,[],[]),ee(","),B(),n.getToken()===2&&he)break}else X&&q(6,[],[]);k()||q(4,[],[2,5]),X=!0}return P(),n.getToken()!==2?q(7,[2],[]):B(),!0}function H(){O(),B();let X=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(X||q(4,[],[]),ee(","),B(),n.getToken()===4&&he)break}else X&&q(6,[],[]);te()||q(4,[],[4,5]),X=!0}return U(),n.getToken()!==4?q(8,[4],[]):B(),!0}function te(){switch(n.getToken()){case 3:return H();case 1:return j();case 10:return re(!0);default:return M()}}return B(),n.getToken()===17?i.allowEmptyContent?!0:(q(4,[],[]),!1):te()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}t.visit=u;function s(e,r){let i=T(e),n=[],a,m=0,y;do switch(y=i.getPosition(),a=i.scan(),a){case 12:case 13:case 17:m!==y&&n.push(e.substring(m,y)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),m=i.getPosition();break}while(a!==17);return n.join("")}t.stripComments=s;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function z(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function T(c){D.push(c,Date.now())}function w(){const c=[];for(let d=0;d<D.length;d+=2)c.push({name:D[d],startTime:D[d+1]});return c}return{mark:T,getMarks:w}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const T of performance.getEntriesByType("mark"))D.push({name:T.name,startTime:Math.round(b+T.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function L(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=t()),b.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=L(I))}(),define(J[58],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var L;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(L=t.Source||(t.Source={}));var I;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(I=t.TerminateResponseCode||(t.TerminateResponseCode={}));function b(D,...T){const w=T.reduce((p,C)=>(p[C]=!0,p),{}),c=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(p=>!w[p]).forEach(p=>{for(let C=0;C<c.length;C++)if(p.search(c[C])!==-1){delete D[p];break}})}t.sanitizeProcessEnvironment=b}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var L=t();for(var I in L)(typeof exports=="object"?exports:z)[I]=L[I]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function L(I){if(t[I])return t[I].exports;var b=t[I]={i:I,l:!1,exports:{}};return z[I].call(b.exports,b,b.exports,L),b.l=!0,b.exports}return L.m=z,L.c=t,L.d=function(I,b,D){L.o(I,b)||Object.defineProperty(I,b,{enumerable:!0,get:D})},L.r=function(I){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},L.t=function(I,b){if(1&b&&(I=L(I)),8&b||4&b&&typeof I=="object"&&I&&I.__esModule)return I;var D=Object.create(null);if(L.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:I}),2&b&&typeof I!="string")for(var T in I)L.d(D,T,function(w){return I[w]}.bind(null,T));return D},L.n=function(I){var b=I&&I.__esModule?function(){return I.default}:function(){return I};return L.d(b,"a",b),b},L.o=function(I,b){return Object.prototype.hasOwnProperty.call(I,b)},L.p="",L(L.s=0)}([function(z,t,L){(function(I){var b;t=z.exports=_,b=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var D=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,w=t.re=[],c=t.src=[],d=0,p=d++;c[p]="0|[1-9]\\d*";var C=d++;c[C]="[0-9]+";var f=d++;c[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=d++;c[S]="("+c[p]+")\\.("+c[p]+")\\.("+c[p]+")";var l=d++;c[l]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var h=d++;c[h]="(?:"+c[p]+"|"+c[f]+")";var v=d++;c[v]="(?:"+c[C]+"|"+c[f]+")";var g=d++;c[g]="(?:-("+c[h]+"(?:\\."+c[h]+")*))";var E=d++;c[E]="(?:-?("+c[v]+"(?:\\."+c[v]+")*))";var u=d++;c[u]="[0-9A-Za-z-]+";var s=d++;c[s]="(?:\\+("+c[u]+"(?:\\."+c[u]+")*))";var o=d++,e="v?"+c[S]+c[g]+"?"+c[s]+"?";c[o]="^"+e+"$";var r="[v=\\s]*"+c[l]+c[E]+"?"+c[s]+"?",i=d++;c[i]="^"+r+"$";var n=d++;c[n]="((?:<|>)?=?)";var a=d++;c[a]=c[C]+"|x|X|\\*";var m=d++;c[m]=c[p]+"|x|X|\\*";var y=d++;c[y]="[v=\\s]*("+c[m]+")(?:\\.("+c[m]+")(?:\\.("+c[m]+")(?:"+c[g]+")?"+c[s]+"?)?)?";var R=d++;c[R]="[v=\\s]*("+c[a]+")(?:\\.("+c[a]+")(?:\\.("+c[a]+")(?:"+c[E]+")?"+c[s]+"?)?)?";var P=d++;c[P]="^"+c[n]+"\\s*"+c[y]+"$";var O=d++;c[O]="^"+c[n]+"\\s*"+c[R]+"$";var U=d++;c[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=d++;c[G]="(?:~>?)";var ee=d++;c[ee]="(\\s*)"+c[G]+"\\s+",w[ee]=new RegExp(c[ee],"g");var ce=d++;c[ce]="^"+c[G]+c[y]+"$";var le=d++;c[le]="^"+c[G]+c[R]+"$";var ne=d++;c[ne]="(?:\\^)";var he=d++;c[he]="(\\s*)"+c[ne]+"\\s+",w[he]=new RegExp(c[he],"g");var B=d++;c[B]="^"+c[ne]+c[y]+"$";var q=d++;c[q]="^"+c[ne]+c[R]+"$";var re=d++;c[re]="^"+c[n]+"\\s*("+r+")$|^$";var M=d++;c[M]="^"+c[n]+"\\s*("+e+")$|^$";var k=d++;c[k]="(\\s*)"+c[n]+"\\s*("+r+"|"+c[y]+")",w[k]=new RegExp(c[k],"g");var j=d++;c[j]="^\\s*("+c[y]+")\\s+-\\s+("+c[y]+")\\s*$";var H=d++;c[H]="^\\s*("+c[R]+")\\s+-\\s+("+c[R]+")\\s*$";var te=d++;c[te]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)b(X,c[X]),w[X]||(w[X]=new RegExp(c[X]));function Z(F,V){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(V?w[i]:w[o]).test(F))return null;try{return new _(F,V)}catch($){return null}}function _(F,V){if(F instanceof _){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,V);b("SemVer",F,V),this.loose=V;var $=F.trim().match(V?w[i]:w[o]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var fe=+ae;if(fe>=0&&fe<T)return fe}return ae}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}t.parse=Z,t.valid=function(F,V){var $=Z(F,V);return $?$.version:null},t.clean=function(F,V){var $=Z(F.trim().replace(/^[=v]+/,""),V);return $?$.version:null},t.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),A(this.major,F.major)||A(this.minor,F.minor)||A(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var $=this.prerelease[V],ae=F.prerelease[V];if(b("prerelease compare",V,$,ae),$===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if($===void 0)return-1;if($!==ae)return A($,ae)}while(++V)},_.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},t.inc=function(F,V,$,ae){typeof $=="string"&&(ae=$,$=void 0);try{return new _(F,$).inc(V,ae).version}catch(fe){return null}},t.diff=function(F,V){if(Q(F,V))return null;var $=Z(F),ae=Z(V);if($.prerelease.length||ae.prerelease.length){for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return"pre"+fe;return"prerelease"}for(var fe in $)if((fe==="major"||fe==="minor"||fe==="patch")&&$[fe]!==ae[fe])return fe},t.compareIdentifiers=A;var N=/^[0-9]+$/;function A(F,V){var $=N.test(F),ae=N.test(V);return $&&ae&&(F=+F,V=+V),$&&!ae?-1:ae&&!$?1:F<V?-1:F>V?1:0}function W(F,V,$){return new _(F,$).compare(new _(V,$))}function x(F,V,$){return W(F,V,$)>0}function K(F,V,$){return W(F,V,$)<0}function Q(F,V,$){return W(F,V,$)===0}function se(F,V,$){return W(F,V,$)!==0}function ie(F,V,$){return W(F,V,$)>=0}function me(F,V,$){return W(F,V,$)<=0}function ye(F,V,$,ae){var fe;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),fe=F!==$;break;case"":case"=":case"==":fe=Q(F,$,ae);break;case"!=":fe=se(F,$,ae);break;case">":fe=x(F,$,ae);break;case">=":fe=ie(F,$,ae);break;case"<":fe=K(F,$,ae);break;case"<=":fe=me(F,$,ae);break;default:throw new TypeError("Invalid operator: "+V)}return fe}function ue(F,V){if(F instanceof ue){if(F.loose===V)return F;F=F.value}if(!(this instanceof ue))return new ue(F,V);b("comparator",F,V),this.loose=V,this.parse(F),this.semver===Ie?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}t.rcompareIdentifiers=function(F,V){return A(V,F)},t.major=function(F,V){return new _(F,V).major},t.minor=function(F,V){return new _(F,V).minor},t.patch=function(F,V){return new _(F,V).patch},t.compare=W,t.compareLoose=function(F,V){return W(F,V,!0)},t.rcompare=function(F,V,$){return W(V,F,$)},t.sort=function(F,V){return F.sort(function($,ae){return t.compare($,ae,V)})},t.rsort=function(F,V){return F.sort(function($,ae){return t.rcompare($,ae,V)})},t.gt=x,t.lt=K,t.eq=Q,t.neq=se,t.gte=ie,t.lte=me,t.cmp=ye,t.Comparator=ue;var Ie={};function ve(F,V){if(F instanceof ve)return F.loose===V?F:new ve(F.raw,V);if(F instanceof ue)return new ve(F.value,V);if(!(this instanceof ve))return new ve(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Fe(F,V,$,ae,fe,Ce,we,Oe,Pe,Re,Ne,De,Te){return((V=Ee($)?"":Ee(ae)?">="+$+".0.0":Ee(fe)?">="+$+"."+ae+".0":">="+V)+" "+(Oe=Ee(Pe)?"":Ee(Re)?"<"+(+Pe+1)+".0.0":Ee(Ne)?"<"+Pe+"."+(+Re+1)+".0":De?"<="+Pe+"."+Re+"."+Ne+"-"+De:"<="+Oe)).trim()}function Me(F,V){for(var $=0;$<F.length;$++)if(!F[$].test(V))return!1;if(V.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==Ie&&F[$].semver.prerelease.length>0){var ae=F[$].semver;if(ae.major===V.major&&ae.minor===V.minor&&ae.patch===V.patch)return!0}return!1}return!0}function ze(F,V,$){try{V=new ve(V,$)}catch(ae){return!1}return V.test(F)}function xe(F,V,$,ae){var fe,Ce,we,Oe,Pe;switch(F=new _(F,ae),V=new ve(V,ae),$){case">":fe=x,Ce=me,we=K,Oe=">",Pe=">=";break;case"<":fe=K,Ce=ie,we=x,Oe="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(F,V,ae))return!1;for(var Re=0;Re<V.set.length;++Re){var Ne=V.set[Re],De=null,Te=null;if(Ne.forEach(function(ke){ke.semver===Ie&&(ke=new ue(">=0.0.0")),De=De||ke,Te=Te||ke,fe(ke.semver,De.semver,ae)?De=ke:we(ke.semver,Te.semver,ae)&&(Te=ke)}),De.operator===Oe||De.operator===Pe||(!Te.operator||Te.operator===Oe)&&Ce(F,Te.semver)||Te.operator===Pe&&we(F,Te.semver))return!1}return!0}ue.prototype.parse=function(F){var V=this.loose?w[re]:w[M],$=F.match(V);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=Ie},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===Ie||(typeof F=="string"&&(F=new _(F,this.loose)),ye(F,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(F,V){if(!(F instanceof ue))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new ve(F.value,V),ze(this.value,$,V);if(F.operator==="")return $=new ve(this.value,V),ze(F.semver,$,V);var ae=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Oe=ye(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ye(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return ae||fe||Ce&&we||Oe||Pe},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),b("range",F,V);var $=V?w[H]:w[j];F=F.replace($,Fe),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[he],"$1^")).split(/\s+/).join(" ");var ae=V?w[re]:w[M],fe=F.split(" ").map(function(Ce){return function(we,Oe){return b("comp",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){b("caret",De,Te);var ke=Te?w[q]:w[B];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("caret",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=ge==="0"?">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+".0 <"+(+ge+1)+".0.0":be?(b("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+be+" <"+(+ge+1)+".0.0"):(b("no pr"),Le=ge==="0"?pe==="0"?">="+ge+"."+pe+"."+Se+" <"+ge+"."+pe+"."+(+Se+1):">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0":">="+ge+"."+pe+"."+Se+" <"+(+ge+1)+".0.0"),b("caret return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("caret",we),we=function(Pe,Re){return Pe.trim().split(/\s+/).map(function(Ne){return function(De,Te){var ke=Te?w[le]:w[ce];return De.replace(ke,function(Ae,ge,pe,Se,be){var Le;return b("tilde",De,Ae,ge,pe,Se,be),Ee(ge)?Le="":Ee(pe)?Le=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?Le=">="+ge+"."+pe+".0 <"+ge+"."+(+pe+1)+".0":be?(b("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Le=">="+ge+"."+pe+"."+Se+be+" <"+ge+"."+(+pe+1)+".0"):Le=">="+ge+"."+pe+"."+Se+" <"+ge+"."+(+pe+1)+".0",b("tilde return",Le),Le})}(Ne,Re)}).join(" ")}(we,Oe),b("tildes",we),we=function(Pe,Re){return b("replaceXRanges",Pe,Re),Pe.split(/\s+/).map(function(Ne){return function(De,Te){De=De.trim();var ke=Te?w[O]:w[P];return De.replace(ke,function(Ae,ge,pe,Se,be,Le){b("xRange",De,Ae,ge,pe,Se,be,Le);var We=Ee(pe),Ve=We||Ee(Se),je=Ve||Ee(be);return ge==="="&&je&&(ge=""),We?Ae=ge===">"||ge==="<"?"<0.0.0":"*":ge&&je?(Ve&&(Se=0),je&&(be=0),ge===">"?(ge=">=",Ve?(pe=+pe+1,Se=0,be=0):je&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?pe=+pe+1:Se=+Se+1),Ae=ge+pe+"."+Se+"."+be):Ve?Ae=">="+pe+".0.0 <"+(+pe+1)+".0.0":je&&(Ae=">="+pe+"."+Se+".0 <"+pe+"."+(+Se+1)+".0"),b("xRange return",Ae),Ae})}(Ne,Re)}).join(" ")}(we,Oe),b("xrange",we),we=function(Pe,Re){return b("replaceStars",Pe,Re),Pe.trim().replace(w[te],"")}(we,Oe),b("stars",we),we}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ce){return!!Ce.match(ae)})),fe=fe.map(function(Ce){return new ue(Ce,V)})},ve.prototype.intersects=function(F,V){if(!(F instanceof ve))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(ae){return F.set.some(function(fe){return fe.every(function(Ce){return ae.intersects(Ce,V)})})})})},t.toComparators=function(F,V){return new ve(F,V).set.map(function($){return $.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var V=0;V<this.set.length;V++)if(Me(this.set[V],F))return!0;return!1},t.satisfies=ze,t.maxSatisfying=function(F,V,$){var ae=null,fe=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==-1||(fe=new _(ae=we,$)))}),ae},t.minSatisfying=function(F,V,$){var ae=null,fe=null;try{var Ce=new ve(V,$)}catch(we){return null}return F.forEach(function(we){Ce.test(we)&&(ae&&fe.compare(we)!==1||(fe=new _(ae=we,$)))}),ae},t.validRange=function(F,V){try{return new ve(F,V).range||"*"}catch($){return null}},t.ltr=function(F,V,$){return xe(F,V,"<",$)},t.gtr=function(F,V,$){return xe(F,V,">",$)},t.outside=xe,t.prerelease=function(F,V){var $=Z(F,V);return $&&$.prerelease.length?$.prerelease:null},t.intersects=function(F,V,$){return F=new ve(F,$),V=new ve(V,$),F.intersects(V)},t.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var V=F.match(w[U]);return V==null?null:Z((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,L(1))},function(z,t){var L,I,b=z.exports={};function D(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function w(v){if(L===setTimeout)return setTimeout(v,0);if((L===D||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch(g){try{return L.call(null,v,0)}catch(E){return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:D}catch(v){L=D}try{I=typeof clearTimeout=="function"?clearTimeout:T}catch(v){I=T}})();var c,d=[],p=!1,C=-1;function f(){p&&c&&(p=!1,c.length?d=c.concat(d):C=-1,d.length&&S())}function S(){if(!p){var v=w(f);p=!0;for(var g=d.length;g;){for(c=d,d=[];++C<g;)c&&c[C].run();C=-1,g=d.length}c=null,p=!1,function(E){if(I===clearTimeout)return clearTimeout(E);if((I===T||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(E);try{I(E)}catch(u){try{return I.call(null,E)}catch(s){return I.call(this,E)}}}(v)}}function l(v,g){this.fun=v,this.array=g}function h(){}b.nextTick=function(v){var g=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)g[E-1]=arguments[E];d.push(new l(v,g)),d.length!==1||p||w(S)},l.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(v){return[]},b.binding=function(v){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(v){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Y([0,1]),function(z,t){"use strict";var L;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class I{constructor(w,c,d){this.level=w,this.key=c,this.value=d,this.forward=[]}}const b=void 0;class D{constructor(w,c=2**16){this.comparator=w,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new I(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new I(this._maxLevel,b,b)}has(w){return Boolean(D._search(this,w,this.comparator))}get(w){return D._search(this,w,this.comparator)?.value}set(w,c){return D._insert(this,w,c,this.comparator)&&(this._size+=1),this}delete(w){const c=D._delete(this,w,this.comparator);return c&&(this._size-=1),c}forEach(w,c){let d=this._header.forward[0];for(;d;)w.call(c,d.value,d.key,this),d=d.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",c=this._header.forward[0];for(;c;)w+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return w}static _search(w,c,d){let p=w._header;for(let C=w._level-1;C>=0;C--)for(;p.forward[C]&&d(p.forward[C].key,c)<0;)p=p.forward[C];if(p=p.forward[0],p&&d(p.key,c)===0)return p}static _insert(w,c,d,p){let C=[],f=w._header;for(let S=w._level-1;S>=0;S--){for(;f.forward[S]&&p(f.forward[S].key,c)<0;)f=f.forward[S];C[S]=f}if(f=f.forward[0],f&&p(f.key,c)===0)return f.value=d,!1;{let S=D._randomLevel(w);if(S>w._level){for(let l=w._level;l<S;l++)C[l]=w._header;w._level=S}f=new I(S,c,d);for(let l=0;l<S;l++)f.forward[l]=C[l].forward[l],C[l].forward[l]=f;return!0}}static _randomLevel(w,c=.5){let d=1;for(;Math.random()<c&&d<w._maxLevel;)d+=1;return d}static _delete(w,c,d){let p=[],C=w._header;for(let f=w._level-1;f>=0;f--){for(;C.forward[f]&&d(C.forward[f].key,c)<0;)C=C.forward[f];p[f]=C}if(C=C.forward[0],!C||d(C.key,c)!==0)return!1;for(let f=0;f<w._level&&p[f].forward[f]===C;f++)p[f].forward[f]=C.forward[f];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}t.SkipList=D}),define(J[38],Y([0,1,7,2]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function b(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=b;function D(u){const s=u;return s?b(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=D;function T(u,s){return new w(u,s)}t.newWriteableStream=T;class w{constructor(s,o){this.reducer=s,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(o=>o(s))}emitError(s){this.listeners.error.length===0?(0,L.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(o=>o(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,o){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(s,o){if(this.state.destroyed)return;let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const r=e.indexOf(o);r>=0&&e.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function c(u,s){const o=[];let e;for(;(e=u.read())!==null;)o.push(e);return s(o)}t.consumeReadable=c;function d(u,s,o){const e=[];let r;for(;(r=u.read())!==null&&e.length<o;)e.push(r);return r===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return u.read()}}}t.peekReadable=d;function p(u,s){return new Promise((o,e)=>{const r=[];C(u,{onData:i=>{s&&r.push(i)},onError:i=>{s?e(i):o(void 0)},onEnd:()=>{o(s?s(r):void 0)}})})}t.consumeStream=p;function C(u,s){u.on("error",o=>s.onError(o)),u.on("end",()=>s.onEnd()),u.on("data",o=>s.onData(o))}t.listenStream=C;function f(u,s){return new Promise((o,e)=>{const r=new I.DisposableStore,i=[],n=y=>{if(i.push(y),i.length>s)return r.dispose(),u.pause(),o({stream:u,buffer:i,ended:!1})},a=y=>e(y),m=()=>o({stream:u,buffer:i,ended:!0});r.add((0,I.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),r.add((0,I.toDisposable)(()=>u.removeListener("end",m))),u.on("end",m),r.add((0,I.toDisposable)(()=>u.removeListener("data",n))),u.on("data",n)})}t.peekStream=f;function S(u,s){const o=T(s);return o.end(u),o}t.toStream=S;function l(){const u=T(()=>{throw new Error("not supported")});return u.end(),u}t.emptyStream=l;function h(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}t.toReadable=h;function v(u,s,o){const e=T(o);return C(u,{onData:r=>e.write(s.data(r)),onError:r=>e.error(s.error?s.error(r):r),onEnd:()=>e.end()}),e}t.transform=v;function g(u,s,o){let e=!1;return{read:()=>{const r=s.read();return e?r:(e=!0,r!==null?o([u,r]):u)}}}t.prefixedReadable=g;function E(u,s,o){let e=!1;const r=T(o);return C(s,{onData:i=>e?r.write(i):(e=!0,r.write(o([u,i]))),onError:i=>r.error(i),onEnd:()=>{e||(e=!0,r.write(u)),r.end()}}),r}t.prefixedStream=E}),define(J[17],Y([0,1,38]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const I=typeof Buffer!="undefined";let b,D;class T{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return I?new T(Buffer.allocUnsafe(n)):new T(new Uint8Array(n))}static wrap(n){return I&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new T(n)}static fromString(n,a){return!(a?.dontUseNodeBuffer||!1)&&I?new T(Buffer.from(n)):(b||(b=new TextEncoder),new T(b.encode(n)))}static concat(n,a){if(typeof a=="undefined"){a=0;for(let R=0,P=n.length;R<P;R++)a+=n[R].byteLength}const m=T.alloc(a);let y=0;for(let R=0,P=n.length;R<P;R++){const O=n[R];m.set(O,y),y+=O.byteLength}return m}toString(){return I?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(n,a){return new T(this.buffer.subarray(n,a))}set(n,a){n instanceof T?this.buffer.set(n.buffer,a):this.buffer.set(n,a)}readUInt32BE(n){return d(this.buffer,n)}writeUInt32BE(n,a){p(this.buffer,n,a)}readUInt32LE(n){return C(this.buffer,n)}writeUInt32LE(n,a){f(this.buffer,n,a)}readUInt8(n){return S(this.buffer,n)}writeUInt8(n,a){l(this.buffer,n,a)}}t.VSBuffer=T;function w(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0}t.readUInt16LE=w;function c(i,n,a){i[a+0]=n&255,n=n>>>8,i[a+1]=n&255}t.writeUInt16LE=c;function d(i,n){return i[n]*2**24+i[n+1]*2**16+i[n+2]*2**8+i[n+3]}t.readUInt32BE=d;function p(i,n,a){i[a+3]=n,n=n>>>8,i[a+2]=n,n=n>>>8,i[a+1]=n,n=n>>>8,i[a]=n}t.writeUInt32BE=p;function C(i,n){return i[n+0]<<0>>>0|i[n+1]<<8>>>0|i[n+2]<<16>>>0|i[n+3]<<24>>>0}t.readUInt32LE=C;function f(i,n,a){i[a+0]=n&255,n=n>>>8,i[a+1]=n&255,n=n>>>8,i[a+2]=n&255,n=n>>>8,i[a+3]=n&255}t.writeUInt32LE=f;function S(i,n){return i[n]}t.readUInt8=S;function l(i,n,a){i[a]=n}t.writeUInt8=l;function h(i){return L.consumeReadable(i,n=>T.concat(n))}t.readableToBuffer=h;function v(i){return L.toReadable(i)}t.bufferToReadable=v;function g(i){return L.consumeStream(i,n=>T.concat(n))}t.streamToBuffer=g;async function E(i){return i.ended?T.concat(i.buffer):T.concat([...i.buffer,await g(i.stream)])}t.bufferedStreamToBuffer=E;function u(i){return L.toStream(i,n=>T.concat(n))}t.bufferToStream=u;function s(i){return L.transform(i,{data:n=>typeof n=="string"?T.fromString(n):T.wrap(n)},n=>T.concat(n))}t.streamToBufferReadableStream=s;function o(i){return L.newWriteableStream(n=>T.concat(n),i)}t.newWriteableBufferStream=o;function e(i,n){return L.prefixedReadable(i,n,a=>T.concat(a))}t.prefixedBufferReadable=e;function r(i,n){return L.prefixedStream(i,n,a=>T.concat(a))}t.prefixedBufferStream=r}),define(J[18],Y([0,1,11]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function I(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.keys(h).forEach(g=>{h[g]&&typeof h[g]=="object"?v[g]=I(h[g]):v[g]=h[g]}),v}t.deepClone=I;function b(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const g=v.shift();Object.freeze(g);for(const E in g)if(D.call(g,E)){const u=g[E];typeof u=="object"&&!Object.isFrozen(u)&&v.push(u)}}return h}t.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function T(h,v){return w(h,v,new Set)}t.cloneAndChange=T;function w(h,v,g){if((0,L.isUndefinedOrNull)(h))return h;const E=v(h);if(typeof E!="undefined")return E;if((0,L.isArray)(h)){const u=[];for(const s of h)u.push(w(s,v,g));return u}if((0,L.isObject)(h)){if(g.has(h))throw new Error("Cannot clone recursive data-structure");g.add(h);const u={};for(let s in h)D.call(h,s)&&(u[s]=w(h[s],v,g));return g.delete(h),u}return h}function c(h,v,g=!0){return(0,L.isObject)(h)?((0,L.isObject)(v)&&Object.keys(v).forEach(E=>{E in h?g&&((0,L.isObject)(h[E])&&(0,L.isObject)(v[E])?c(h[E],v[E],g):h[E]=v[E]):h[E]=v[E]}),h):v}t.mixin=c;function d(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let g,E;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(g=0;g<h.length;g++)if(!d(h[g],v[g]))return!1}else{const u=[];for(E in h)u.push(E);u.sort();const s=[];for(E in v)s.push(E);if(s.sort(),!d(u,s))return!1;for(g=0;g<u.length;g++)if(!d(h[u[g]],v[u[g]]))return!1}return!0}t.equals=d;function p(h){const v=new Set;return JSON.stringify(h,(g,E)=>{if((0,L.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}t.safeStringify=p;function C(h,v,g){const E=v(h);return typeof E=="undefined"?g:E}t.getOrDefault=C;function f(h,v){const g=Object.create(null);return!h||!v||Object.keys(v).forEach(u=>{const s=h[u],o=v[u];d(s,o)||(g[u]=o)}),g}t.distinct=f;function S(h,v){const g=v.toLowerCase(),E=Object.keys(h).find(u=>u.toLowerCase()===g);return E?h[E]:h[v]}t.getCaseInsensitive=S;function l(h,v){const g=Object.create(null);for(const[E,u]of Object.entries(h))v(E,u)&&(g[E]=u);return g}t.filter=l}),define(J[60],Y([0,1,8]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function I(d){const p=d;return p&&typeof p.type=="string"&&typeof p.severity=="string"}t.isRemoteConsoleLog=I;function b(d){const p=[];let C;try{const f=JSON.parse(d.arguments),S=f[f.length-1];S&&S.__$stack&&(f.pop(),C=S.__$stack),p.push(...f)}catch(f){p.push("Unable to log remote console arguments",d.arguments)}return{args:p,stack:C}}t.parse=b;function D(d){if(typeof d!="string")return D(b(d).stack);const p=d;if(p){const C=T(p),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:L.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}t.getFirstFrame=D;function T(d){if(!d)return d;const p=d.indexOf(`
`);return p===-1?d:d.substring(0,p)}function w(d,p){const{args:C,stack:f}=b(d),S=typeof C[0]=="string"&&C.length===1;let l=T(f);l&&(l=`(${l.trim()})`);let h=[];if(typeof C[0]=="string"?l&&S?h=[`%c[${p}] %c${C[0]} %c${l}`,c("blue"),c(""),c("grey")]:h=[`%c[${p}] %c${C[0]}`,c("blue"),c(""),...C.slice(1)]:h=[`%c[${p}]%`,c("blue"),...C],l&&!S&&h.push(l),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,h)}t.log=w;function c(d){return`color: ${d}`}}),define(J[61],Y([0,1,17,27,8]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function D(p){return JSON.stringify(p,c)}t.stringify=D;function T(p){let C=JSON.parse(p);return C=d(C),C}t.parse=T;var w;(function(p){p[p.Uri=1]="Uri",p[p.Regexp=2]="Regexp",p[p.ScmResource=3]="ScmResource",p[p.ScmResourceGroup=4]="ScmResourceGroup",p[p.ScmProvider=5]="ScmProvider",p[p.CommentController=6]="CommentController",p[p.CommentThread=7]="CommentThread",p[p.CommentThreadReply=8]="CommentThreadReply",p[p.CommentNode=9]="CommentNode",p[p.CommentThreadNode=10]="CommentThreadNode",p[p.TimelineActionContext=11]="TimelineActionContext",p[p.NotebookCellActionContext=12]="NotebookCellActionContext",p[p.TestItemContext=13]="TestItemContext"})(w=t.MarshalledId||(t.MarshalledId={}));function c(p,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,I.regExpFlags)(C)}:C}function d(p,C=0){if(!p||C>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return b.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof L.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let f=0;f<p.length;++f)p[f]=d(p[f],C+1);else for(const f in p)Object.hasOwnProperty.call(p,f)&&(p[f]=d(p[f],C+1))}return p}t.revive=d}),define(J[62],Y([0,1,47,9,6,12,19,27,8]),function(z,t,L,I,b,D,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(n,a,m){if(typeof n=="string"&&(n=c.URI.file(n)),m){const R=m.getWorkspaceFolder(n);if(R){const P=m.getWorkspace().folders.length>1;let O;if((0,T.isEqual)(R.uri,n)?O="":O=(0,T.relativePath)(R.uri,n),P){const U=R.name?R.name:(0,T.basename)(R.uri);O=O?U+" \u2022 "+O:U}return O}}if(n.scheme!==I.Schemas.file&&n.scheme!==I.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,L.hasDriveLetter)(n.fsPath))return(0,b.normalize)(C(n.fsPath));let y=(0,b.normalize)(n.fsPath);return!D.isWindows&&a?.userHome&&(y=S(y,a.userHome.fsPath)),y}t.getPathLabel=d;function p(n){if(!n)return;typeof n=="string"&&(n=c.URI.file(n));const a=(0,T.basename)(n)||(n.scheme===I.Schemas.file?n.fsPath:n.path);return D.isWindows&&(0,L.isRootOrDriveLetter)(a)?C(a):a}t.getBaseLabel=p;function C(n,a){return(0,L.hasDriveLetter)(n,a)?n.charAt(0).toUpperCase()+n.slice(1):n}t.normalizeDriveLetter=C;let f=Object.create(null);function S(n,a){if(D.isWindows||!n||!a)return n;let m=f.original===a?f.normalized:void 0;return m||(m=`${(0,w.rtrim)(a,b.posix.sep)}${b.posix.sep}`,f={original:a,normalized:m}),(D.isLinux?n.startsWith(m):(0,w.startsWithIgnoreCase)(n,m))&&(n=`~/${n.substr(m.length)}`),n}t.tildify=S;function l(n,a){return n.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=l;const h="\u2026",v="\\\\",g="~";function E(n,a=b.sep){const m=new Array(n.length);let y=!1;for(let R=0;R<n.length;R++){let P=n[R];if(P===""){m[R]=`.${a}`;continue}if(!P){m[R]=P;continue}y=!0;let O="";P.indexOf(v)===0?(O=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(a)===0?(O=P.substr(0,P.indexOf(a)+a.length),P=P.substr(P.indexOf(a)+a.length)):P.indexOf(g)===0&&(O=P.substr(0,P.indexOf(g)+g.length),P=P.substr(P.indexOf(g)+g.length));const U=P.split(a);for(let G=1;y&&G<=U.length;G++)for(let ee=U.length-G;y&&ee>=0;ee--){y=!1;let ce=U.slice(ee,ee+G).join(a);for(let le=0;!y&&le<n.length;le++)if(le!==R&&n[le]&&n[le].indexOf(ce)>-1){const ne=ee+G===U.length,he=ee>0&&n[le].indexOf(a)>-1?a+ce:ce,B=n[le].endsWith(he);y=!ne||B}if(!y){let le="";(U[0].endsWith(":")||O!=="")&&(ee===1&&(ee=0,G++,ce=U[0]+a+ce),ee>0&&(le=U[0]+a),le=O+le),ee>0&&(le=le+h+a),le=le+ce,ee+G<U.length&&(le=le+a+h),m[R]=le}}y&&(m[R]=P)}return m}t.shorten=E;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function s(n,a=Object.create(null)){const m=[];let y=!1,R="";for(const P of n)if(P==="$"||y&&P==="{")R&&m.push({value:R,type:u.TEXT}),R="",y=!0;else if(P==="}"&&y){const O=a[R];if(typeof O=="string")O.length&&m.push({value:O,type:u.VARIABLE});else if(O){const U=m[m.length-1];(!U||U.type!==u.SEPARATOR)&&m.push({value:O.label,type:u.SEPARATOR})}R="",y=!1}else R+=P;return R&&!y&&m.push({value:R,type:u.TEXT}),m.filter((P,O)=>{if(P.type===u.SEPARATOR){const U=m[O-1],G=m[O+1];return[U,G].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(P=>P.value).join("")}t.template=s;function o(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(n,a){return D.isMacintosh||a?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,m=>m==="&"?"&&":"&"):n.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function r(n){return n.replace(/&/g,"&&")}t.unmnemonicLabel=r;function i(n){const a=n.indexOf("/")!==-1?b.posix:b.win32,m=a.basename(n),y=a.dirname(n);return m.length?{name:m,parentPath:y}:{name:y,parentPath:""}}t.splitName=i}),define(J[63],Y([0,1,131]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class I{constructor(D="utf8"){this.stringDecoder=new L.StringDecoder(D),this.remaining=null}write(D){const T=[],w=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(w.length<1)return T;let c=0,d,p=c;for(;p<w.length;)if(d=w.charCodeAt(p),d===13||d===10){if(T.push(w.substring(c,p)),p++,p<w.length){const C=d;d=w.charCodeAt(p),(C===13&&d===10||C===10&&d===13)&&p++}c=p}else p++;return this.remaining=c<w.length?w.substr(c):null,T}end(){return this.remaining}}t.LineDecoder=I}),define(J[64],Y([0,1,48,6,27,13]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function T(p){const C=(0,I.dirname)(p);if(p===C)return p;const f=((0,I.basename)(p)||p).toLowerCase();try{const l=(0,D.readdirSync)(C).filter(h=>h.toLowerCase()===f);if(l.length===1){const h=T(C);if(h)return(0,I.join)(h,l[0])}else if(l.length>1){const h=l.indexOf(f);if(h>=0){const v=T(C);if(v)return(0,I.join)(v,l[h])}}}catch(S){}return null}t.realcaseSync=T;async function w(p){try{return await D.Promises.realpath(p)}catch(C){const f=d(p);return await D.Promises.access(f,L.constants.R_OK),f}}t.realpath=w;function c(p){try{return L.realpathSync(p)}catch(C){const f=d(p);return L.accessSync(f,L.constants.R_OK),f}}t.realpathSync=c;function d(p){return(0,b.rtrim)((0,I.normalize)(p),I.sep)}}),define(J[65],Y([0,1,34,6,13]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,T=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var c;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class C{constructor(o,e,r){this.exePath=o,this.displayName=e,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:s=!1}={}){return s?d===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:s=!1,findPreview:o=!1}={}){const e=f({useAlternateBitness:s});if(!e)return null;const r=I.join(e,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const y of await b.Promises.readdir(r)){let R=-1;if(o){const O=y.indexOf("-");if(O<0)continue;const U=y.substring(0,O);if(!D.test(U)||y.substring(O+1)!=="preview")continue;R=parseInt(U,10)}else{if(!D.test(y))continue;R=parseInt(y,10)}if(R<=i)continue;const P=I.join(r,y,"pwsh.exe");!await b.SymlinkSupport.existsFile(P)||(n=P,i=R)}if(!n)return null;const a=e.includes("x86")?" (x86)":"",m=o?" Preview":"";return new C(n,`PowerShell${m}${a}`,!0)}async function l({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const o=I.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:r}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await b.Promises.readdir(o))if(e.test(i)){const n=I.join(o,i,"pwsh.exe");return new C(n,r)}return null}function h(){const s=I.join(L.homedir(),".dotnet","tools","pwsh.exe");return new C(s,".NET Core PowerShell Global Tool")}function v(){const s=I.join(process.env.windir,d===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(s,"Windows PowerShell",!0)}async function*g(){let s=await S();s&&(yield s),s=await S({useAlternateBitness:!0}),s&&(yield s),s=await l(),s&&(yield s),s=h(),s&&(yield s),s=await S({findPreview:!0}),s&&(yield s),s=await l({findPreview:!0}),s&&(yield s),s=await S({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=v(),s&&(yield s)}async function*E(){for await(const s of g())await s.exists()&&(yield s)}t.enumeratePowerShellInstallations=E;async function u(){for await(const s of E())return s;return null}t.getFirstAvailablePowerShellInstallation=u});var de=this&&this.__decorate||function(z,t,L,I){var b=arguments.length,D=b<3?t:I===null?I=Object.getOwnPropertyDescriptor(t,L):I,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(z,t,L,I);else for(var w=z.length-1;w>=0;w--)(T=z[w])&&(D=(b<3?T(D):b>3?T(t,L,D):T(t,L))||D);return b>3&&D&&Object.defineProperty(t,L,D),D};define(J[39],Y([0,1,20,3,17,24,46,7,10,2,61,27,11]),function(z,t,L,I,b,D,T,w,c,d,p,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=t.RequestType||(t.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(h=t.ResponseType||(t.ResponseType={}));function v(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(g||(g={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class u{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function o(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function e(M){return M.read(4).readUInt32BE(0)}function r(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},n=typeof Buffer!="undefined";function a(M,k){if(typeof k=="undefined")M.write(i.Undefined);else if(typeof k=="string"){const j=b.VSBuffer.fromString(k);M.write(i.String),M.write(o(j.byteLength)),M.write(j)}else if(n&&Buffer.isBuffer(k)){const j=b.VSBuffer.wrap(k);M.write(i.Buffer),M.write(o(j.byteLength)),M.write(j)}else if(k instanceof b.VSBuffer)M.write(i.VSBuffer),M.write(o(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(i.Array),M.write(o(k.length));for(const j of k)a(M,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(k));M.write(i.Object),M.write(o(j.byteLength)),M.write(j)}}function m(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(e(M)).toString();case s.Buffer:return M.read(e(M)).buffer;case s.VSBuffer:return M.read(e(M));case s.Array:{const j=e(M),H=[];for(let te=0;te<j;te++)H.push(m(M));return H}case s.Object:return JSON.parse(M.read(e(M)).toString())}}class y{constructor(k,j,H=null,te=1e3){this.protocol=k,this.ctx=j,this.logger=H,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,v(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,v(k.type),k.data);return}}}send(k,j=void 0){const H=new u;return a(H,k),a(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onRawMessage(k){const j=new E(k),H=m(j),te=m(j),X=H[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}: ${H[2]}.${H[3]}`,te),this.onPromise({type:X,id:H[1],channelName:H[2],name:H[3],arg:te});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}: ${H[2]}.${H[3]}`,te),this.onEventListen({type:X,id:H[1],channelName:H[2],name:H[3],arg:te});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${l(X)}`),this.disposeActiveRequest({type:X,id:H[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=new D.CancellationTokenSource;let te;try{te=j.call(this.ctx,k.name,k.arg,H.token)}catch(_){te=Promise.reject(_)}const X=k.id;te.then(_=>{this.sendResponse({id:X,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:X,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:X,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,d.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=k.id,X=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,X)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}t.ChannelServer=y;var R;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(R=t.RequestInitiator||(t.RequestInitiator={}));class P{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(k){const j=this;return{call(H,te,X){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,H,te,X)},listen(H,te){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,H,te)}}}requestPromise(k,j,H,te=D.CancellationToken.None){const X=this.lastRequestId++,_={id:X,type:100,channelName:k,name:j,arg:H};if(te.isCancellationRequested)return Promise.reject(w.canceled());let N;return new Promise((W,x)=>{if(te.isCancellationRequested)return x(w.canceled());const K=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(X),W(ye.data);break;case 202:this.handlers.delete(X);const ue=new Error(ye.data.message);ue.stack=ye.data.stack,ue.name=ye.data.name,x(ue);break;case 203:this.handlers.delete(X),x(ye.data);break}};this.handlers.set(X,me),this.sendRequest(_)};let Q=null;this.state===g.Idle?K():(Q=(0,I.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,K()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:X,type:101}),x(w.canceled())},ie=te.onCancellationRequested(se);N=(0,d.combinedDisposable)((0,d.toDisposable)(se),ie),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(k,j,H){const te=this.lastRequestId++,Z={id:te,type:102,channelName:k,name:j,arg:H};let _=null;const N=new c.Emitter({onFirstListenerAdd:()=>{_=(0,I.createCancelablePromise)(W=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(N),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(N),this.sendRequest({id:te,type:103}))}}),A=W=>N.fire(W.data);return this.handlers.set(te,A),N.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${l(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,l(k.type));return}}}send(k,j=void 0){const H=new u;return a(H,k),a(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onBuffer(k){const j=new E(k),H=m(j),te=m(j),X=H[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,v(X)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,v(X),te),this.onResponse({type:H[0],id:H[1],data:te})}}onResponse(k){if(k.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}de([T.memoize],P.prototype,"onDidInitializePromise",null),t.ChannelClient=P;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:H})=>{c.Event.once(j.onMessage)(X=>{const Z=new E(X),_=m(Z),N=new y(j,_),A=new P(j);this.channels.forEach((x,K)=>N.registerChannel(K,x));const W={channelServer:N,channelClient:A,ctx:_};this._connections.add(W),this._onDidAddConnection.fire(W),H(()=>{N.dispose(),A.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const H=this;return{call(te,X,Z){let _;if((0,f.isFunction)(j)){let A=(0,L.getRandomElement)(H.connections.filter(j));_=A?Promise.resolve(A):c.Event.toPromise(c.Event.filter(H.onDidAddConnection,j))}else _=j.routeCall(H,te,X);const N=_.then(A=>A.channelClient.getChannel(k));return G(N).call(te,X,Z)},listen(te,X){if((0,f.isFunction)(j))return H.getMulticastEvent(k,j,te,X);const Z=j.routeEvent(H,te,X).then(_=>_.channelClient.getChannel(k));return G(Z).listen(te,X)}}}getMulticastEvent(k,j,H,te){const X=this;let Z=new d.DisposableStore;const _=new c.Emitter({onFirstListenerAdd:()=>{Z=new d.DisposableStore;const N=new c.EventMultiplexer,A=new Map,W=K=>{const se=K.channelClient.getChannel(k).listen(H,te),ie=N.add(se);A.set(K,ie)},x=K=>{const Q=A.get(K);!Q||(Q.dispose(),A.delete(K))};X.connections.filter(j).forEach(W),c.Event.filter(X.onDidAddConnection,j)(W,void 0,Z),X.onDidRemoveConnection(x,void 0,Z),N.event(_.fire,_,Z),Z.add(N)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(H=>{H.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class U{constructor(k,j,H=null){const te=new u;a(te,j),k.send(te.buffer),this.channelClient=new P(k,H),this.channelServer=new y(k,j,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function G(M){return{call(k,j,H){return M.then(te=>te.call(k,j,H))},listen(k,j){const H=new c.Relay;return M.then(te=>H.input=te.listen(k,j)),H.event}}}t.getDelayedChannel=G;function ee(M){let k=!1;return{call(j,H,te){return k?M.call(j,H,te):(0,I.timeout)(0).then(()=>k=!0).then(()=>M.call(j,H,te))},listen(j,H){if(k)return M.listen(j,H);const te=new c.Relay;return(0,I.timeout)(0).then(()=>k=!0).then(()=>te.input=M.listen(j,H)),te.event}}}t.getNextTickChannel=ee;class ce{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await c.Event.toPromise(k.onDidAddConnection),await this.route(k)}}t.StaticRouter=ce;var le;(function(M){function k(X,Z){const _=X,N=Z&&Z.disableMarshalling,A=new Map;for(const W in _)H(W)&&A.set(W,c.Event.buffer(_[W],!0));return new class{listen(W,x,K){const Q=A.get(x);if(Q)return Q;if(te(x)){const se=_[x];if(typeof se=="function")return se.call(_,K)}throw new Error(`Event not found: ${x}`)}call(W,x,K){const Q=_[x];if(typeof Q=="function"){if(!N&&Array.isArray(K))for(let se=0;se<K.length;se++)K[se]=(0,p.revive)(K[se]);return Q.apply(_,K)}throw new Error(`Method not found: ${x}`)}}}M.fromService=k;function j(X,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(N,A){if(typeof A=="string")return Z?.properties?.has(A)?Z.properties.get(A):te(A)?function(W){return X.listen(A,W)}:H(A)?X.listen(A):async function(...W){let x;Z&&!(0,f.isUndefinedOrNull)(Z.context)?x=[Z.context,...W]:x=W;const K=await X.call(A,x);return _?K:(0,p.revive)(K)};throw new Error(`Property not found: ${String(A)}`)}})}M.toService=j;function H(X){return X[0]==="o"&&X[1]==="n"&&C.isUpperAsciiLetter(X.charCodeAt(2))}function te(X){return/^onDynamic/.test(X)&&C.isUpperAsciiLetter(X.charCodeAt(9))}})(le=t.ProxyChannel||(t.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function B(M){return Array.isArray(M)?M.map(he):he(M)}function q(M,k,j,H,te,X,Z){Z=B(Z);const _=ne[te],N=_[H%_.length];let A=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(X)?(A=A.concat(Z),A.push(")")):A.push(Z),console.log.apply(console,A)}t.logWithColors=q;class re{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,H,te,X){this._totalOutgoing+=k,q(this._outgoingPrefix,this._totalOutgoing,k,j,H,te,X)}logIncoming(k,j,H,te,X){this._totalIncoming+=k,q(this._incomingPrefix,this._totalIncoming,k,j,H,te,X)}}t.IPCLogger=re}),define(J[66],Y([0,1,3,10,2,11]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=t.StorageHint||(t.StorageHint={}));function w(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}t.isStorageItemsChangeEvent=w;var c;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(c||(c={}));class d extends b.Disposable{constructor(f,S=Object.create(null)){super();this.database=f,this.options=S,this._onDidChangeStorage=this._register(new I.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((S,l)=>this.accept(l,S)),f.deleted?.forEach(S=>this.accept(S,void 0))}accept(f,S){if(this.state===c.Closed)return;let l=!1;(0,D.isUndefinedOrNull)(S)?l=this.cache.delete(f):this.cache.get(f)!==S&&(this.cache.set(f,S),l=!0),l&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,S){const l=this.cache.get(f);return(0,D.isUndefinedOrNull)(l)?S:l}getBoolean(f,S){const l=this.get(f);return(0,D.isUndefinedOrNull)(l)?S:l==="true"}getNumber(f,S){const l=this.get(f);return(0,D.isUndefinedOrNull)(l)?S:parseInt(l,10)}async set(f,S){if(this.state===c.Closed)return;if((0,D.isUndefinedOrNull)(S))return this.delete(f);const l=String(S);if(this.cache.get(f)!==l)return this.cache.set(f,l),this.pendingInserts.set(f,l),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===c.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=I.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((S,l)=>this.items.set(l,S)),f.delete&&f.delete.forEach(S=>this.items.delete(S))}async close(){}}t.InMemoryStorageDatabase=p}),define(J[67],Y([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(J[68],Y([0,1,67]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const I=60,b=I*60,D=b*24,T=D*7,w=D*30,c=D*365;function d(C,f){typeof C!="number"&&(C=C.getTime());const S=Math.round((new Date().getTime()-C)/1e3);if(S<-30)return(0,L.localize)(0,null,d(new Date().getTime()+S*1e3,!1));if(S<30)return(0,L.localize)(1,null);let l;return S<I?(l=S,f?l===1?(0,L.localize)(2,null,l):(0,L.localize)(3,null,l):l===1?(0,L.localize)(4,null,l):(0,L.localize)(5,null,l)):S<b?(l=Math.floor(S/I),f?l===1?(0,L.localize)(6,null,l):(0,L.localize)(7,null,l):l===1?(0,L.localize)(8,null,l):(0,L.localize)(9,null,l)):S<D?(l=Math.floor(S/b),f?l===1?(0,L.localize)(10,null,l):(0,L.localize)(11,null,l):l===1?(0,L.localize)(12,null,l):(0,L.localize)(13,null,l)):S<T?(l=Math.floor(S/D),f?l===1?(0,L.localize)(14,null,l):(0,L.localize)(15,null,l):l===1?(0,L.localize)(16,null,l):(0,L.localize)(17,null,l)):S<w?(l=Math.floor(S/T),f?l===1?(0,L.localize)(18,null,l):(0,L.localize)(19,null,l):l===1?(0,L.localize)(20,null,l):(0,L.localize)(21,null,l)):S<c?(l=Math.floor(S/w),f?l===1?(0,L.localize)(22,null,l):(0,L.localize)(23,null,l):l===1?(0,L.localize)(24,null,l):(0,L.localize)(25,null,l)):(l=Math.floor(S/c),f?l===1?(0,L.localize)(26,null,l):(0,L.localize)(27,null,l):l===1?(0,L.localize)(28,null,l):(0,L.localize)(29,null,l))}t.fromNow=d;function p(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=p}),define(J[69],Y([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(J[28],Y([0,1,20,11,69]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function D(d,p){return p&&(d.stack||d.stacktrace)?b.localize(0,null,w(d),T(d.stack)||T(d.stacktrace)):w(d)}function T(d){return Array.isArray(d)?d.join(`
`):d}function w(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?b.localize(1,null,d.message):d.message||b.localize(2,null)}function c(d=null,p=!1){if(!d)return b.localize(3,null);if(Array.isArray(d)){const C=L.coalesce(d),f=c(C[0],p);return C.length>1?b.localize(4,null,f,C.length):f}if(I.isString(d))return d;if(d.detail){const C=d.detail;if(C.error)return D(C.error,p);if(C.exception)return D(C.exception,p)}return d.stack?D(d,p):d.message?d.message:b.localize(5,null)}t.toErrorMessage=c}),define(J[70],Y([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(J[49],Y([0,1,40,47,9,18,6,12,29,58,11,63,13,70]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function l(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(e,r){if(w.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};r&&(i.cwd=r);const n=L.execFile("taskkill",["/T","/F","/PID",e.pid.toString()],i);return new Promise(a=>{n.once("error",m=>{a({success:!1,error:m})}),n.once("exit",(m,y)=>{a(m===0?{success:!0}:{success:!1,code:m!==null?m:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?l(i.status):1})}else if(w.isLinux||w.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(n=>{L.execFile(i,[e.pid.toString()],{encoding:"utf8",shell:!0},(a,m,y)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else e.kill("SIGKILL");return Promise.resolve({success:!0})}function v(e){!e||(delete e.DEBUG,w.isMacintosh&&delete e.DYLD_LIBRARY_PATH,w.isLinux&&delete e.LD_PRELOAD)}t.removeDangerousEnvVariables=v;function g(e=c.env){return e.comspec||"cmd.exe"}t.getWindowsShell=g;class E{constructor(r,i,n,a){if(i!==void 0&&n!==void 0&&a!==void 0)this.cmd=r,this.args=i,this.shell=n,this.options=a;else{const m=r;this.cmd=m.command,this.shell=m.isShellCommand,this.args=m.args.slice(0),this.options=m.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const m=Object.create(null);Object.keys(c.env).forEach(y=>{m[y]=c.env[y]}),Object.keys(this.options.env).forEach(y=>{m[y]=this.options.env[y]}),this.options.env=m}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const i=r.lastIndexOf(T.sep);return i!==-1&&(r=r.substring(i+1)),E.WellKnowCommands[r]?r:"other"}start(r){return w.isWindows&&(this.options&&this.options.cwd&&I.isUNC(this.options.cwd)||!this.options&&I.isUNC(c.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let n,a;const m=new Promise((y,R)=>{n=y,a=R});if(i){let y=this.cmd;this.args&&(y=y+" "+this.args.join(" ")),this.childProcess=L.exec(y,this.options,(R,P,O)=>{this.childProcess=null;const U=R;U&&U.killed?a({killed:this.terminateRequested,stdout:P.toString(),stderr:O.toString()}):this.handleExec(n,r,R,P,O)})}else{let y=null;const R=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,n,r,a);const O={terminated:this.terminateRequested};p.isNumber(P)&&(O.cmdCode=P),n(O)};if(this.shell&&w.isWindows){const P=D.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let O=!1,U=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),O=ee.quoted,this.args&&this.args.forEach(le=>{ee=this.ensureQuotes(le),G.push(ee.value),U=U&&ee.quoted});const ce=["/s","/c"];O?U?ce.push('"'+G.join(" ")+'"'):G.length>1?ce.push('"'+G[0]+'" '+G.slice(1).join(" ")):ce.push('"'+G[0]+'"'):ce.push(G.join(" ")),y=L.spawn(g(),ce,P)}else this.cmd&&(y=L.spawn(this.cmd,this.args,this.options));y&&(this.childProcess=y,this.childProcessPromise=Promise.resolve(y),this.pidResolve&&(this.pidResolve(p.isNumber(y.pid)?y.pid:-1),this.pidResolve=void 0),y.on("error",P=>{this.childProcess=null,a({terminated:this.terminateRequested,error:P})}),y.pid&&(this.childProcess.on("close",R),this.handleSpawn(y,n,r,a,!0)))}return m})}handleClose(r,i,n,a){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,h(r,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!w.isWindows)return r(!1);const i=L.spawn(g(),["/s","/c"]);i.on("error",n=>r(!0)),i.on("exit",n=>r(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class u extends E{constructor(r,i,n,a){super(r,i,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,i,n,a,m){[a,m].forEach((y,R)=>{const P=new C.LineDecoder;P.write(y).forEach(G=>{i({line:G,source:R===0?0:1})});const U=P.end();U&&i({line:U,source:R===0?0:1})}),r({terminated:this.terminateRequested,error:n})}handleSpawn(r,i,n,a,m){const y=new C.LineDecoder,R=new C.LineDecoder;r.stdout.on("data",P=>{y.write(P).forEach(U=>n({line:U,source:0}))}),r.stderr.on("data",P=>{R.write(P).forEach(U=>n({line:U,source:1}))}),this.stdoutLineDecoder=y,this.stderrLineDecoder=R}handleClose(r,i,n,a){const m=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;m&&n({line:m,source:0});const y=this.stderrLineDecoder?this.stderrLineDecoder.end():null;y&&n({line:y,source:1})}}t.LineProcess=u;function s(e){let r=[],i=!1;const n=function(a){if(i){r.push(a);return}(!e.send(a,y=>{if(y&&console.error(y),i=!1,r.length>0){const R=r.slice(0);r=[],R.forEach(P=>n(P))}})||w.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=s;var o;(function(e){async function r(i,n,a){if(T.isAbsolute(i))return i;if(n===void 0&&(n=c.cwd()),T.dirname(i)!=="."||(a===void 0&&p.isString(c.env.PATH)&&(a=c.env.PATH.split(T.delimiter)),a===void 0||a.length===0))return T.join(n,i);async function y(R){if(await f.Promises.exists(R)){let P;try{P=await f.Promises.stat(R)}catch(O){O.message.startsWith("EACCES")&&(P=await f.Promises.lstat(R))}return P?!P.isDirectory():!1}return!1}for(let R of a){let P;if(T.isAbsolute(R)?P=T.join(R,i):P=T.join(n,R,i),await y(P))return P;let O=P+".com";if(await y(O)||(O=P+".exe",await y(O)))return O}return T.join(n,i)}e.findExecutable=r})(o=t.win32||(t.win32={}))}),define(J[71],Y([0,1,34,12,65,49]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function T(S,l){return S===1?I.isWindows?C():D.getWindowsShell(l):d(S,l)}t.getSystemShell=T;function w(S,l){return S===1?I.isWindows?f(l):D.getWindowsShell(l):d(S,l)}t.getSystemShellSync=w;let c=null;function d(S,l){if(I.isLinux&&S===2||I.isMacintosh&&S===3)return"/bin/bash";if(!c){let h;if(I.isWindows)h="/bin/bash";else{if(h=l.SHELL,!h)try{h=(0,L.userInfo)().shell}catch(v){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}c=h}return c}let p=null;async function C(){return p||(p=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),p}function f(S){if(p)return p;const l=I.isWindows&&parseFloat((0,L.release)())>=10,h=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?v:D.getWindowsShell(S)}}),define(J[50],Y([0,1,40,3,17,24,60,7,10,2,18,49,39]),function(z,t,L,I,b,D,T,w,c,d,p,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class S extends f.ChannelServer{constructor(v){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch(E){}},onMessage:c.Event.fromNodeEventEmitter(process,"message",g=>b.VSBuffer.wrap(Buffer.from(g,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=S;class l{constructor(v,g){this.modulePath=v,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new I.Delayer(E),this.child=null,this._client=null}getChannel(v){const g=this;return{call(E,u,s){return g.requestPromise(v,E,u,s)},listen(E,u){return g.requestEvent(v,E,u)}}}requestPromise(v,g,E,u=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(v),o=(0,I.createCancelablePromise)(i=>s.call(g,E,i)),e=u.onCancellationRequested(()=>o.cancel()),r=(0,d.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{e.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(v,g,E){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let u;const s=new c.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(v).listen(g,E)(s.fire,s),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,L.fork)(this.modulePath,v,g);const E=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,T.isRemoteConsoleLog)(n)){(0,T.log)(n,`IPC Library: ${this.options.serverName}`);return}E.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const s=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,o=n=>this.child&&this.child.connected&&s.send(n.buffer.toString("base64")),e=E.event,r={send:o,onMessage:e};this._client=new f.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(m=>(0,d.dispose)(m)),this.activeRequests.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:a})})}return this._client}getCachedChannel(v){let g=this.channels.get(v);return g||(g=this.client.getChannel(v),this.channels.set(v,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=l}),define(J[72],Y([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(J[73],Y([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(J[74],Y([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(J[75],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(J[76],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(J[77],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(J[78],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(J[79],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(J[80],Y([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(J[81],Y([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(J[82],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(J[83],Y([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(J[84],Y([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(J[85],Y([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(J[86],Y([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(J[87],Y([0,1,68,46,9,6,29,19,8]),function(z,t,L,I,b,D,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(h,v,g){this._args=h,this.paths=v,this.productService=g}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",z).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(c.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return c.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return c.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=T.env.VSCODE_PORTABLE;return h?c.URI.file((0,D.join)(h,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,D.resolve)(h):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,D.resolve)(h):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,D.resolve)(h);const v=T.env.VSCODE_EXTENSIONS;if(v)return v;const g=T.env.VSCODE_PORTABLE;return g?(0,D.join)(g,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?c.URI.parse(v):c.URI.file((0,D.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?c.URI.parse(h):c.URI.file((0,D.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return c.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([I.memoize],d.prototype,"appRoot",null),de([I.memoize],d.prototype,"userHome",null),de([I.memoize],d.prototype,"userDataPath",null),de([I.memoize],d.prototype,"appSettingsHome",null),de([I.memoize],d.prototype,"tmpDir",null),de([I.memoize],d.prototype,"userRoamingDataHome",null),de([I.memoize],d.prototype,"settingsResource",null),de([I.memoize],d.prototype,"userDataSyncHome",null),de([I.memoize],d.prototype,"userDataSyncLogResource",null),de([I.memoize],d.prototype,"sync",null),de([I.memoize],d.prototype,"machineSettingsResource",null),de([I.memoize],d.prototype,"globalStorageHome",null),de([I.memoize],d.prototype,"workspaceStorageHome",null),de([I.memoize],d.prototype,"keybindingsResource",null),de([I.memoize],d.prototype,"keyboardLayoutResource",null),de([I.memoize],d.prototype,"argvResource",null),de([I.memoize],d.prototype,"snippetsHome",null),de([I.memoize],d.prototype,"isExtensionDevelopment",null),de([I.memoize],d.prototype,"untitledWorkspacesHome",null),de([I.memoize],d.prototype,"installSourcePath",null),de([I.memoize],d.prototype,"builtinExtensionsPath",null),de([I.memoize],d.prototype,"extensionsPath",null),de([I.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([I.memoize],d.prototype,"extensionDevelopmentKind",null),de([I.memoize],d.prototype,"extensionTestsLocationURI",null),de([I.memoize],d.prototype,"debugExtensionHost",null),de([I.memoize],d.prototype,"serviceMachineIdResource",null),de([I.memoize],d.prototype,"telemetryLogResource",null),de([I.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function p(l,h){return S(l["inspect-extensions"],l["inspect-brk-extensions"],5870,h,l.debugId,l.extensionEnvironment)}t.parseExtensionHostPort=p;function C(l,h){return S(l["inspect-search"],l["inspect-brk-search"],5876,h,l.extensionEnvironment)}t.parseSearchPort=C;function f(l,h){return S(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,h,l.extensionEnvironment)}t.parsePtyHostPort=f;function S(l,h,v,g,E,u){const o=Number(h||l)||(g?null:v),e=o?Boolean(!!h):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:o,break:e,debugId:E,env:r}}}),function(){"use strict";function z(t,L,I,b){function D(w){const c=T(w),d=[c];return t.isAbsolute(c)||d.unshift(b),t.resolve(...d)}function T(w){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,I);const p=w["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(C,"AppData","Roaming")}break;case"darwin":d=t.join(L.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,I)}return{getUserDataPath:D}}if(typeof define=="function")define(J[88],Y([0,132,34,9,19,29]),function(t,L,I,b,D,T){const w=D.dirname(b.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(D.joinPath(w,"package.json").fsPath);return z(L,I,c.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),L=require("path"),I=require("os");module.exports=z(L,I,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Y([0,1,34,87,88]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class D extends I.AbstractNativeEnvironmentService{constructor(w,c){super(w,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},c)}}t.NativeEnvironmentService=D}),define(J[90],Y([0,1,18]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const I=/^%([\w\d.-]+)%$/i;function b(D,T){const w=c=>{if(typeof c!="string")return;const d=I.exec(c);if(!d)return;const p=T[d[1]]??c;return typeof p=="string"?p:typeof p.message=="string"?p.message:c};return(0,L.cloneAndChange)(D,w)}t.localizeManifest=b}),define(J[51],Y([0,1,81]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(f){return f=f.trim(),f==="*"||I.test(f)}t.isValidVersionStr=D;function T(f){if(!D(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=f.match(I);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}t.parseVersion=T;function w(f){if(!f)return null;let S=f.majorBase,l=f.majorMustEqual,h=f.minorBase,v=f.minorMustEqual,g=f.patchBase,E=f.patchMustEqual;f.hasCaret&&(S===0||(v=!1),E=!1);let u=0;if(f.preRelease){const s=b.exec(f.preRelease);if(s){const[,o,e,r]=s;u=Date.UTC(Number(o),Number(e)-1,Number(r))}}return{majorBase:S,majorMustEqual:l,minorBase:h,minorMustEqual:v,patchBase:g,patchMustEqual:E,isMinimum:f.hasGreaterEquals,notBefore:u}}t.normalizeVersion=w;function c(f,S,l){let h;typeof f=="string"?h=w(T(f)):h=f;let v;S instanceof Date?v=S.getTime():typeof S=="string"&&(v=new Date(S).getTime());let g;if(typeof l=="string"?g=w(T(l)):g=l,!h||!g)return!1;let E=h.majorBase,u=h.minorBase,s=h.patchBase,o=g.majorBase,e=g.minorBase,r=g.patchBase,i=g.notBefore,n=g.majorMustEqual,a=g.minorMustEqual,m=g.patchMustEqual;return g.isMinimum?E>o?!0:E<o?!1:u>e?!0:u<e||v&&v<i?!1:s>=r:(E===1&&o===0&&(!n||!a||!m)&&(o=1,e=0,r=0,n=!0,a=!1,m=!1),E<o?!1:E>o?!n:u<e?!1:u>e?!a:s<r?!1:s>r?!m:!(v&&v<i))}t.isValidVersion=c;function d(f,S,l,h){return l.isBuiltin||typeof l.main=="undefined"?!0:C(f,S,l.engines.vscode,h)}t.isValidExtensionVersion=d;function p(f,S,l){return f==="*"||C(S,l,f)}t.isEngineValid=p;function C(f,S,l,h=[]){let v=w(T(l));if(!v)return h.push(L.localize(0,null,l)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return h.push(L.localize(1,null,l)),!1}else if(!v.majorMustEqual)return h.push(L.localize(2,null,l)),!1;return c(f,S,v)?!0:(h.push(L.localize(3,null,f,l)),!1)}}),define(J[41],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class L{constructor(b,D=[],T=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=T}}t.SyncDescriptor=L}),define(J[91],Y([0,1,41]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const I=[];function b(T,w,c){w instanceof L.SyncDescriptor||(w=new L.SyncDescriptor(w,[],c)),I.push([T,w])}t.registerSingleton=b;function D(){return I}t.getSingletonServiceDescriptors=D}),define(J[92],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class L{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}t.Node=L;class I{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let T of this._nodes.values())T.outgoing.size===0&&D.push(T);return D}insertEdge(D,T){const w=this.lookupOrInsertNode(D),c=this.lookupOrInsertNode(T);w.outgoing.set(this._hashFn(T),c),c.incoming.set(this._hashFn(D),w)}removeNode(D){const T=this._hashFn(D);this._nodes.delete(T);for(let w of this._nodes.values())w.outgoing.delete(T),w.incoming.delete(T)}lookupOrInsertNode(D){const T=this._hashFn(D);let w=this._nodes.get(T);return w||(w=new L(D),this._nodes.set(T,w)),w}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[T,w]of this._nodes)D.push(`${T}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,T]of this._nodes){const w=new Set([D]),c=this._findCycle(T,w);if(c)return c}}_findCycle(D,T){for(let[w,c]of D.outgoing){if(T.has(w))return[...T,w].join(" -> ");T.add(w);const d=this._findCycle(c,T);if(d)return d;T.delete(w)}}}t.Graph=I}),define(J[52],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,L.createDecorator)("downloadService")}),define(J[21],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,L.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,L.refineServiceDecorator)(t.IEnvironmentService)}),define(J[22],Y([0,1,9,76,14]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var D;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(D=t.TargetPlatform||(t.TargetPlatform={}));function T(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=T;function w(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=w;function c(u,s){switch(u){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=c;function d(u,s){return s==="web"&&!u.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function p(u,s,o){return d(s,o)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===o?!0:C(o).includes(u)}t.isTargetPlatformCompatible=p;function C(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=C;function f(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}t.isIExtensionIdentifier=f;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=t.SortBy||(t.SortBy={}));var l;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(l=t.SortOrder||(t.SortOrder={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h=t.StatisticType||(t.StatisticType={}));var v;(function(u){u[u.None=0]="None",u[u.Install=1]="Install",u[u.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var g;(function(u){u.Unsupported="Unsupported",u.Malicious="Malicious",u.Incompatible="Incompatible",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(g=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(s,o){super(s);this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,I.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,I.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Y([0,1,40,6,74,24,28,7,12,31,71,133,3]),function(z,t,L,I,b,D,T,w,c,d,p,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const S=1e4;let l;async function h(g,E,u){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(u)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(u)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),l||(l=f.Promises.withAsyncBody(async(s,o)=>{const e=new D.CancellationTokenSource,r=setTimeout(()=>{e.dispose(!0),o(new Error((0,b.localize)(0,null)))},S);try{s(await v(g,e.token))}catch(i){!(0,w.isPromiseCanceledError)(i)&&!e.token.isCancellationRequested?o(new Error((0,b.localize)(1,null,(0,T.toErrorMessage)(i)))):s({})}finally{clearTimeout(r),e.dispose()}})),l)}t.resolveShellEnv=h;async function v(g,E){const u=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",u);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",s);const o=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",r);const i=await(0,p.getSystemShell)(c.OS,r);return g.trace("getUnixShellEnvironment#shell",i),new Promise((n,a)=>{if(E.isCancellationRequested)return a((0,w.canceled)());const m=(0,I.basename)(i);let y,R;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(m)?(y=`& '${process.execPath}' ${P} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,R=["-Login","-Command"]):(y=`'${process.execPath}' ${P} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,m==="tcsh"?R=["-ic"]:R=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),y);const O=(0,L.spawn)(i,[...R,y],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});E.onCancellationRequested(()=>(O.kill(),a((0,w.canceled)()))),O.on("error",ee=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(ee)),a(ee)});const U=[];O.stdout.on("data",ee=>U.push(ee));const G=[];O.stderr.on("data",ee=>G.push(ee)),O.on("close",(ee,ce)=>{const le=Buffer.concat(U).toString("utf8");g.trace("getUnixShellEnvironment#raw",le);const ne=Buffer.concat(G).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),ee||ce)return a(new Error((0,b.localize)(2,null,ee,ce)));const he=e.exec(le),B=he?he[1]:"{}";try{const q=JSON.parse(B);u?q.ELECTRON_RUN_AS_NODE=u:delete q.ELECTRON_RUN_AS_NODE,s?q.ELECTRON_NO_ATTACH_CONSOLE=s:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(q)),a(q)}})})}}),define(J[53],Y([0,1,17,7,83,16]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(p,C,f,S,l,h){let v;try{await w(p,C,f,S,l,h)}catch(g){v=g}finally{v&&l.errorTransformer&&(v=l.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}t.readFileIntoStream=T;async function w(p,C,f,S,l,h){c(h);const v=await p.open(C,{create:!1});try{c(h);let g=0,E=0,u=l&&typeof l.length=="number"?l.length:void 0,s=L.VSBuffer.alloc(Math.min(l.bufferSize,typeof u=="number"?u:l.bufferSize)),o=l&&typeof l.position=="number"?l.position:0,e=0;do E=await p.read(v,o,s.buffer,e,s.byteLength-e),o+=E,e+=E,g+=E,typeof u=="number"&&(u-=E),e===s.byteLength&&(await f.write(S(s)),s=L.VSBuffer.alloc(Math.min(l.bufferSize,typeof u=="number"?u:l.bufferSize)),e=0);while(E>0&&(typeof u!="number"||u>0)&&c(h)&&d(g,l));if(e>0){let r=e;typeof u=="number"&&(r=Math.min(e,u)),f.write(S(s.slice(0,r)))}}catch(g){throw(0,D.ensureFileSystemProviderError)(g)}finally{await p.close(v)}}function c(p){if(p.isCancellationRequested)throw(0,I.canceled)();return!0}function d(p,C){if(C?.limits){if(typeof C.limits.memory=="number"&&p>C.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&p>C.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[35],Y([0,1,2,12,8,16]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=t.WatcherService=t.AbstractWatcherService=void 0;class T extends L.Disposable{constructor(f,S,l){super();this.onFileChanges=f,this.onLogMessage=S,this.verboseLogging=l,this.serviceDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new L.DisposableStore;this.serviceDisposables.value=f,this.service=this.createService(f),this.service.setVerboseLogging(this.verboseLogging),f.add(this.service.onDidChangeFile(S=>this.onFileChanges(S))),f.add(this.service.onDidLogMessage(S=>this.onLogMessage(S))),f.add(this.service.onDidError(S=>this.onError(S)))}onError(f){this.restartCounter<T.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.service?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${f}`})}dispose(){return this.service=void 0,super.dispose()}}t.AbstractWatcherService=T,T.MAX_RESTARTS=5;class w extends L.Disposable{}t.WatcherService=w;function c(C){return C.map(f=>({type:f.type,resource:b.URI.file(f.path)}))}t.toFileChanges=c;function d(C){const f=new p;for(const S of C)f.processEvent(S);return f.normalize()}t.normalizeFileChanges=d;class p{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(f){return I.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const S=this.mapPathToChange.get(this.toKey(f));let l=!1;if(S){const h=S.type,v=f.type;S.path!==f.path&&f.type===2?l=!0:h===1&&v===2?(this.mapPathToChange.delete(this.toKey(f)),this.normalized.delete(S)):h===2&&v===1?S.type=0:h===1&&v===0||(S.type=v)}else l=!0;l&&(this.normalized.add(f),this.mapPathToChange.set(this.toKey(f),f))}normalize(){const f=[],S=[];return Array.from(this.normalized).filter(l=>l.type!==2?(f.push(l),!1):!0).sort((l,h)=>l.path.length-h.path.length).filter(l=>S.some(h=>(0,D.isParent)(l.path,h,!I.isLinux))?!1:(S.push(l.path),!0)).concat(f)}}}),define(J[94],Y([0,1,3,2,6,64,13,134,35]),function(z,t,L,I,b,D,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends I.Disposable{constructor(C,f,S,l){super();this.path=C,this.onDidFilesChange=f,this.onLogMessage=S,this.verboseLogging=l,this.fileChangesDelayer=this._register(new L.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:f}=await T.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(f)try{S=await(0,D.realpath)(S)}catch(l){if(this.onError(l),f.dangling)return}C.isDirectory()?this._register((0,w.watchFolder)(S,(l,h)=>{this.onFileChange({type:l==="changed"?0:l==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(h))})},l=>this.onError(l))):this._register((0,w.watchFile)(S,l=>{this.onFileChange({type:l==="changed"?0:2,path:this.path})},l=>this.onError(l)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,c.normalizeFileChanges)(f);if(this.verboseLogging)for(const l of S)this.onVerbose(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(J[95],Y([0,1,9,39,50,35]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.WatcherService{constructor(c,d,p){super();this.onDidFilesChange=c,this.onLogMessage=d,this.verboseLogging=p,this.isDisposed=!1,this.startWatching()}startWatching(){const c=this._register(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=I.ProxyChannel.toService((0,I.getNextTickChannel)(c.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d)))}async setVerboseLogging(c){this.verboseLogging=c,this.isDisposed||await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${c}`})}async watch(c){this.isDisposed||await this.service?.watch(c)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=T}),define(J[96],Y([0,1,9,39,50,35]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class T extends D.AbstractWatcherService{constructor(c,d,p){super(c,d,p);this.init()}createService(c){const d=c.add(new b.Client(L.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:p,signal:C})=>this.onError(`terminated by itself with code ${p}, signal: ${C}`))),I.ProxyChannel.toService((0,I.getNextTickChannel)(d.getChannel("watcher")))}}t.FileWatcher=T}),define(J[54],Y([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class L{constructor(...b){this._entries=new Map;for(let[D,T]of b)this.set(D,T)}set(b,D){const T=this._entries.get(b);return this._entries.set(b,D),T}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}t.ServiceCollection=L}),define(J[97],Y([0,1,3,7,41,92,14,54]),function(z,t,L,I,b,D,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class p{constructor(l=new w.ServiceCollection,h=!1,v){this._activeInstantiations=new Set,this._services=l,this._strict=h,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(l){return new p(l,this._strict,this)}invokeFunction(l,...h){let v=f.traceInvocation(l),g=!1;try{return l({get:u=>{if(g)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(u,v);if(!s)throw new Error(`[invokeFunction] unknown service '${u}'`);return s}},...h)}finally{g=!0,v.stop()}}createInstance(l,...h){let v,g;return l instanceof b.SyncDescriptor?(v=f.traceCreation(l.ctor),g=this._createInstance(l.ctor,l.staticArguments.concat(h),v)):(v=f.traceCreation(l),g=this._createInstance(l,h,v)),v.stop(),g}_createInstance(l,h=[],v){let g=T._util.getServiceDependencies(l).sort((s,o)=>s.index-o.index),E=[];for(const s of g){let o=this._getOrCreateServiceInstance(s.id,v);if(!o&&this._strict&&!s.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${s.id}.`);E.push(o)}let u=g.length>0?g[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${l.name} at position ${u+1} conflicts with ${h.length} static arguments`);let s=u-h.length;s>0?h=h.concat(new Array(s)):h=h.slice(0,u)}return new l(...[...h,...E])}_setServiceInstance(l,h){if(this._services.get(l)instanceof b.SyncDescriptor)this._services.set(l,h);else if(this._parent)this._parent._setServiceInstance(l,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let h=this._services.get(l);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):h}_getOrCreateServiceInstance(l,h){let v=this._getServiceInstanceOrDescriptor(l);return v instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,v,h.branch(l,!0)):(h.branch(l,!1),v)}_safeCreateAndCacheServiceInstance(l,h,v){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,h,v)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,h,v){const g=new D.Graph(s=>s.id.toString());let E=0;const u=[{id:l,desc:h,_trace:v}];for(;u.length;){const s=u.pop();if(g.lookupOrInsertNode(s),E++>1e3)throw new d(g);for(let o of T._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${l} depends on ${o.id} which is NOT registered.`),e instanceof b.SyncDescriptor){const r={id:o.id,desc:e,_trace:s._trace.branch(o.id,!0)};g.insertEdge(s,r),u.push(r)}}}for(;;){const s=g.roots();if(s.length===0){if(!g.isEmpty())throw new d(g);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof b.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}g.removeNode(o)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,h,v=[],g,E){if(this._services.get(l)instanceof b.SyncDescriptor)return this._createServiceInstance(h,v,g,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,h,v,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(l,h=[],v,g){if(v){const E=new L.IdleValue(()=>this._createInstance(l,h,g));return new Proxy(Object.create(null),{get(u,s){if(s in u)return u[s];let o=E.value,e=o[s];return typeof e!="function"||(e=e.bind(o),u[s]=e),e},set(u,s,o){return E.value[s]=o,!0}})}else return this._createInstance(l,h,g)}}t.InstantiationService=p;var C;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(C||(C={}));class f{constructor(l,h){this.type=l,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return c?new f(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(l){return c?new f(0,l.name):f._None}branch(l,h){let v=new f(2,l.toString());return this._dep.push([l,h,v]),v}stop(){let l=Date.now()-this._start;f._totals+=l;let h=!1;function v(E,u){let s=[],o=new Array(E+1).join("	");for(const[e,r,i]of u._dep)if(r&&i){h=!0,s.push(`${o}CREATES -> ${e}`);let n=v(E+1,i);n&&s.push(n)}else s.push(`${o}uses -> ${e}`);return s.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(l>2||h)&&console.log(g.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(J[55],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,L.createDecorator)("localizationsService");function I(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}t.isValidLocalization=I}),define(J[15],Y([0,1,28,10,2,12,14]),function(z,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,T.createDecorator)("logService"),t.ILoggerService=(0,T.createDecorator)("loggerService");function w(){return new Date().toISOString()}var c;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function d(r,i,n){switch(i){case c.Trace:r.trace(n);break;case c.Debug:r.debug(n);break;case c.Info:r.info(n);break;case c.Warning:r.warn(n);break;case c.Error:r.error(n);break;case c.Critical:r.critical(n);break;default:throw new Error("Invalid log level")}}t.log=d;function p(r){let i="";for(let n=0;n<r.length;n++){let a=r[n];if(typeof a=="object")try{a=JSON.stringify(a)}catch(m){}i+=(n>0?" ":"")+a}return i}t.format=p;class C extends b.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...n){this.checkLogLevel(c.Trace)&&this.log(c.Trace,p([i,...n]))}debug(i,...n){this.checkLogLevel(c.Debug)&&this.log(c.Debug,p([i,...n]))}info(i,...n){this.checkLogLevel(c.Info)&&this.log(c.Info,p([i,...n]))}warn(i,...n){this.checkLogLevel(c.Warning)&&this.log(c.Warning,p([i,...n]))}error(i,...n){if(this.checkLogLevel(c.Error))if(i instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=i.stack,this.log(c.Error,p(a))}else this.log(c.Error,p([i,...n]))}critical(i,...n){this.checkLogLevel(c.Critical)&&this.log(c.Critical,p([i,...n]))}flush(){}}t.AbstractMessageLogger=f;class S extends C{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!D.isWindows}trace(i,...n){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}debug(i,...n){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}info(i,...n){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,i,...n):console.log(`[main ${w()}]`,i,...n))}warn(i,...n){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,i,...n):console.warn(`[main ${w()}]`,i,...n))}error(i,...n){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,i,...n):console.error(`[main ${w()}]`,i,...n))}critical(i,...n){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,i,...n):console.error(`[main ${w()}]`,i,...n))}dispose(){}flush(){}}t.ConsoleMainLogger=S;class l extends C{constructor(i=t.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...n){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",i,...n)}debug(i,...n){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...n)}info(i,...n){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",i,...n)}warn(i,...n){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",i,...n)}error(i,...n){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",i,...n)}critical(i,...n){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...n)}dispose(){}flush(){}}t.ConsoleLogger=l;class h extends C{constructor(i,n=t.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(n)}trace(i,...n){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(i),...n])}debug(i,...n){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(i),...n])}info(i,...n){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(i),...n])}warn(i,...n){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(i),...n])}error(i,...n){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(i),...n])}critical(i,...n){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(i),...n])}extractMessage(i){return typeof i=="string"?i:(0,L.toErrorMessage)(i,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=h;class v extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const n of this.logServices)n.setLevel(i);super.setLevel(i)}trace(i,...n){for(const a of this.logServices)a.trace(i,...n)}debug(i,...n){for(const a of this.logServices)a.debug(i,...n)}info(i,...n){for(const a of this.logServices)a.info(i,...n)}warn(i,...n){for(const a of this.logServices)a.warn(i,...n)}error(i,...n){for(const a of this.logServices)a.error(i,...n)}critical(i,...n){for(const a of this.logServices)a.critical(i,...n)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}t.MultiplexLogService=v;class g extends b.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...n){this.logger.trace(i,...n)}debug(i,...n){this.logger.debug(i,...n)}info(i,...n){this.logger.info(i,...n)}warn(i,...n){this.logger.warn(i,...n)}error(i,...n){this.logger.error(i,...n)}critical(i,...n){this.logger.critical(i,...n)}flush(){this.logger.flush()}}t.LogService=g;class E extends b.Disposable{constructor(i,n){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(m=>m.setLevel(a))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,n){let a=this.loggers.get(i.toString());return a||(a=this.doCreateLogger(i,n?.always?c.Trace:this.logLevel,n),this.loggers.set(i.toString(),a),n?.always||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=E;class u{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(i){}getLevel(){return c.Info}trace(i,...n){}debug(i,...n){}info(i,...n){}warn(i,...n){}error(i,...n){}critical(i,...n){}dispose(){}flush(){}}t.NullLogService=u;function s(r){if(r.verbose)return c.Trace;if(typeof r.logLevel=="string"){const i=o(r.logLevel.toLowerCase());if(i!==void 0)return i}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=s;function o(r){switch(r){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=o;function e(r){switch(r){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=e});var oe=this&&this.__param||function(z,t){return function(L,I){t(L,I,z)}};define(J[98],Y([0,1,40,3,28,10,2,9,6,13,21,15]),function(z,t,L,I,b,D,T,w,c,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(l,h){super();this.environmentService=l,this.logService=h,this.processesLimiter=new I.Limiter(5)}async postUninstall(l){const h=this.parseScript(l,"uninstall");return h&&(this.logService.info(l.identifier.id,l.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(h.script,"uninstall",h.args,!0,l).then(()=>this.logService.info(l.identifier.id,l.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(l.identifier.id,l.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(l)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(l,h){const v=`vscode:${h}`;if(l.location.scheme===w.Schemas.file&&l.manifest&&l.manifest.scripts&&typeof l.manifest.scripts[v]=="string"){const g=l.manifest.scripts[v].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(l.identifier.id,l.manifest.version,`${v} should be a node script`),null):{script:(0,c.join)(l.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(l,h,v,g,E){return new Promise((u,s)=>{const o=this.start(l,h,v,E);let e;const r=i=>{e&&(clearTimeout(e),e=null),i?s(i):u(void 0)};o.on("error",i=>{r((0,b.toErrorMessage)(i)||"Unknown")}),o.on("exit",(i,n)=>{r(i?`post-${h} process exited with code ${i}`:void 0)}),g&&(e=setTimeout(()=>{e=null,o.kill(),s("timed out")},5e3))})}start(l,h,v,g){const E={silent:!0,execArgv:void 0},u=(0,L.fork)(l,[`--type=extension-post-${h}`,...v],E);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const s=D.Event.fromNodeEventEmitter(u.stdout,"data"),o=D.Event.fromNodeEventEmitter(u.stderr,"data");s(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${h}`,i)),o(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${h}`,i));const e=D.Event.any(D.Event.map(s,i=>({data:`%c${i}`,format:[""]})),D.Event.map(o,i=>({data:`%c${i}`,format:["color: red"]})));return D.Event.debounce(e,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),u}getExtensionStoragePath(l){return(0,c.join)(this.environmentService.globalStorageHome.fsPath,l.identifier.id.toLowerCase())}};f=de([oe(0,p.IEnvironmentService),oe(1,C.ILogService)],f),t.ExtensionsLifecycle=f}),define(J[99],Y([0,1,20,3,7,10,2,6,35,15]),function(z,t,L,I,b,D,T,w,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class p extends T.Disposable{constructor(f){super();this.logService=f,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new I.ThrottledDelayer(0))}watch(f,S){return S.recursive?this.watchRecursive(f,S):this.watchNonRecursive(f)}watchRecursive(f,S){const l={path:this.toFilePath(f),excludes:S.excludes},h=(0,L.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{h(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,b.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,c.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,S){return f.watch(S)}watchNonRecursive(f){const S=this.createNonRecursiveWatcher(this.toFilePath(f),h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)});return(0,T.combinedDisposable)(S,l)}onWatcherLogMessage(f){f.type==="error"&&this._onDidErrorOccur.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,w.normalize)(f.fsPath)}}t.AbstractDiskFileSystemProvider=p}),define(J[100],Y([0,1,20,3,17,24,10,135,2,101,9,102,19,38,82,16,53,15]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let E=class Ue extends c.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new T.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new h.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new I.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new h.FileChangesEvent(o,!0)))),this.watchedResources=d.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new I.ResourceQueue)}registerProvider(s,o){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:o});const e=new c.DisposableStore;return e.add(o.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:s}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,c.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:o}),this.provider.delete(s),(0,c.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){o.push(e)}}),!this.provider.has(s)&&await I.Promises.settled(o)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,o){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return w.Iterable.map(this.provider,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async withProvider(s){if(!(0,f.isAbsolutePath)(s))throw new h.FileOperationError((0,l.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const o=this.provider.get(s.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,l.localize)(1,null,s.toString()),e}return o}async withReadProvider(s){const o=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o)||(0,h.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const o=await this.withProvider(s);if((0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.doResolveFile(s,o)}catch(e){throw(0,h.toFileSystemProviderErrorCode)(e)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,l.localize)(2,null,this.resourceForError(s)),1):(0,h.ensureFileSystemProviderError)(e)}}async doResolveFile(s,o){const e=await this.withProvider(s),r=this.isPathCaseSensitive(e),i=o?.resolveTo,n=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,m=await e.stat(s);let y;return this.toFileStat(e,s,m,void 0,!!a,(R,P)=>(y||(y=d.TernarySearchTree.forUris(()=>!r),y.set(s,!0),i&&y.fill(!0,i)),y.get(R.resource)||y.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&n?P===1:!1))}async toFileStat(s,o,e,r,i,n){const{providerExtUri:a}=this.getExtUri(s),m={resource:o,name:a.basename(o),isFile:(e.type&h.FileType.File)!=0,isDirectory:(e.type&h.FileType.Directory)!=0,isSymbolicLink:(e.type&h.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&h.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,h.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&n(m,r)){try{const y=await s.readdir(o),R=await I.Promises.settled(y.map(async([P,O])=>{try{const U=a.joinPath(o,P),G=i?await s.stat(U):{type:O};return await this.toFileStat(s,U,G,y.length,i,n)}catch(U){return this.logService.trace(U),null}}));m.children=(0,L.coalesce)(R)}catch(y){this.logService.trace(y),m.children=[]}return m}return m}async resolveAll(s){return I.Promises.settled(s.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const o=await this.withProvider(s);try{return!!await o.stat(s)}catch(e){return!1}}async canCreateFile(s,o){try{await this.doValidateCreateFile(s,o)}catch(e){return e}return!0}async doValidateCreateFile(s,o){if(!o?.overwrite&&await this.exists(s))throw new h.FileOperationError((0,l.localize)(3,null,this.resourceForError(s)),3,o)}async createFile(s,o=b.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const r=await this.writeFile(s,o);return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,r)),r}async writeFile(s,o,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,e)||await this.mkdirp(r,i.dirname(s));let a;if((0,h.hasReadWriteCapability)(r)&&!(o instanceof b.VSBuffer))if((0,S.isReadableStream)(o)){const m=await(0,S.peekStream)(o,3);m.ended?a=b.VSBuffer.concat(m.buffer):a=m}else a=(0,S.peekReadable)(o,m=>b.VSBuffer.concat(m),3);else a=o;!(0,h.hasOpenReadWriteCloseCapability)(r)||(0,h.hasReadWriteCapability)(r)&&a instanceof b.VSBuffer?await this.doWriteUnbuffered(r,s,e,a):await this.doWriteBuffered(r,s,e,a instanceof b.VSBuffer?(0,b.bufferToReadable)(a):a)}catch(n){throw new h.FileOperationError((0,l.localize)(4,null,this.resourceForError(s),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,o,e){if(!!e?.unlock&&!(s.capabilities&8192))throw new Error((0,l.localize)(5,null,this.resourceForError(o)));let i;try{i=await s.stat(o)}catch(n){return}if((i.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,l.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,i),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==h.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&e.mtime<i.mtime&&e.etag!==(0,h.etag)({mtime:e.mtime,size:i.size}))throw new h.FileOperationError((0,l.localize)(7,null),3,e);return i}async readFile(s,o){const e=await this.withReadProvider(s);return o?.atomic?this.doReadFileAtomic(e,s,o):this.doReadFile(e,s,o)}async doReadFileAtomic(s,o,e){return new Promise((r,i)=>{this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(s,o,e);r(n)}catch(n){i(n)}})})}async doReadFile(s,o,e){const r=await this.doReadFileStream(s,o,{...e,preferUnbuffered:!0});return{...r,value:await(0,b.streamToBuffer)(r.value)}}async readFileStream(s,o){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,o)}async doReadFileStream(s,o,e){const r=new D.CancellationTokenSource,i=this.validateReadFile(o,e).then(a=>a,a=>{throw r.cancel(),a});let n;try{return typeof e?.etag=="string"&&e.etag!==h.ETAG_DISABLED&&await i,!((0,h.hasOpenReadWriteCloseCapability)(s)||(0,h.hasFileReadStreamCapability)(s))||(0,h.hasReadWriteCapability)(s)&&e?.preferUnbuffered?n=this.readFileUnbuffered(s,o,e):(0,h.hasFileReadStreamCapability)(s)?n=this.readFileStreamed(s,o,r.token,e):n=this.readFileBuffered(s,o,r.token,e),{...await i,value:n}}catch(a){n&&await(0,S.consumeStream)(n);const m=(0,l.localize)(8,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(a).toString());throw a instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(m,a.stat,e):new h.FileOperationError(m,(0,h.toFileOperationResult)(a),e)}}readFileStreamed(s,o,e,r=Object.create(null)){const i=s.readFileStream(o,r,e);return(0,S.transform)(i,{data:n=>n instanceof b.VSBuffer?n:b.VSBuffer.wrap(n),error:n=>new h.FileOperationError((0,l.localize)(9,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},n=>b.VSBuffer.concat(n))}readFileBuffered(s,o,e,r=Object.create(null)){const i=(0,b.newWriteableBufferStream)();return(0,v.readFileIntoStream)(s,o,i,n=>n,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new h.FileOperationError((0,l.localize)(10,null,this.resourceForError(o),(0,h.ensureFileSystemProviderError)(n).toString()),(0,h.toFileOperationResult)(n),r)},e),i}readFileUnbuffered(s,o,e){const r=(0,S.newWriteableStream)(i=>b.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(o);typeof e?.position=="number"&&(i=i.slice(e.position)),typeof e?.length=="number"&&(i=i.slice(0,e.length)),this.validateReadFileLimits(o,i.byteLength,e),r.end(b.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,o){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new h.FileOperationError((0,l.localize)(11,null,this.resourceForError(s)),0,o);if(typeof o?.etag=="string"&&o.etag!==h.ETAG_DISABLED&&o.etag===e.etag)throw new h.NotModifiedSinceFileOperationError((0,l.localize)(12,null),e,o);return this.validateReadFileLimits(s,e.size,o),e}validateReadFileLimits(s,o,e){if(e?.limits){let r;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(r=9),typeof e.limits.size=="number"&&o>e.limits.size&&(r=7),typeof r=="number")throw new h.FileOperationError((0,l.localize)(13,null,this.resourceForError(s)),r)}}async canMove(s,o,e){return this.doCanMoveCopy(s,o,"move",e)}async canCopy(s,o,e){return this.doCanMoveCopy(s,o,"copy",e)}async doCanMoveCopy(s,o,e,r){if(s.toString()!==o.toString())try{const i=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(i,s,n,o,e,r)}catch(i){return i}return!0}async move(s,o,e){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=await this.doMoveCopy(r,s,i,o,"move",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="move"?2:3,a)),a}async copy(s,o,e){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=await this.doMoveCopy(r,s,i,o,"copy",!!e),a=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,n==="copy"?3:2,a)),a}async doMoveCopy(s,o,e,r,i,n){if(o.toString()===r.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(s,o,e,r,i,n);if(a&&!m&&n&&await this.del(r,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(r)),i==="copy"){if(s===e&&(0,h.hasFileFolderCopyCapability)(s))await s.copy(o,r,{overwrite:n});else{const y=await this.resolve(o);y.isDirectory?await this.doCopyFolder(s,y,e,r):await this.doCopyFile(s,o,e,r)}return i}else return s===e?(await s.rename(o,r,{overwrite:n}),i):(await this.doMoveCopy(s,o,e,r,"copy",n),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(s,o,e,r){if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,o,e,r);if((0,h.hasOpenReadWriteCloseCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,o,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,o,e,r);if((0,h.hasReadWriteCapability)(s)&&(0,h.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,o,e,r)}async doCopyFolder(s,o,e,r){await e.mkdir(r),Array.isArray(o.children)&&await I.Promises.settled(o.children.map(async i=>{const n=this.getExtUri(e).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),e,n):this.doCopyFile(s,i.resource,e,n)}))}async doValidateMoveCopy(s,o,e,r,i,n){let a=!1;if(s===e){const{providerExtUri:y,isPathCaseSensitive:R}=this.getExtUri(s);if(R||(a=y.isEqual(o,r)),a&&i==="copy")throw new Error((0,l.localize)(14,null,this.resourceForError(o),this.resourceForError(r)));if(!a&&y.isEqualOrParent(r,o))throw new Error((0,l.localize)(15,null,this.resourceForError(o),this.resourceForError(r)))}const m=await this.exists(r);if(m&&!a){if(!n)throw new h.FileOperationError((0,l.localize)(16,null,this.resourceForError(o),this.resourceForError(r)),4);if(s===e){const{providerExtUri:y}=this.getExtUri(s);if(y.isEqualOrParent(o,r))throw new Error((0,l.localize)(17,null,this.resourceForError(o),this.resourceForError(r)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(s){const o=this.isPathCaseSensitive(s);return{providerExtUri:o?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(o,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(s,0,e)),e}async mkdirp(s,o){const e=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(o,r.dirname(o));)try{if(((await s.stat(o)).type&h.FileType.Directory)==0)throw new Error((0,l.localize)(18,null,this.resourceForError(o)));break}catch(i){if((0,h.toFileSystemProviderErrorCode)(i)!==h.FileSystemProviderErrorCode.FileNotFound)throw i;e.push(r.basename(o)),o=r.dirname(o)}for(let i=e.length-1;i>=0;i--){o=r.joinPath(o,e[i]);try{await s.mkdir(o)}catch(n){if((0,h.toFileSystemProviderErrorCode)(n)!==h.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(s,o){try{await this.doValidateDelete(s,o)}catch(e){return e}return!0}async doValidateDelete(s,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,l.localize)(19,null,this.resourceForError(s)));let i;try{i=await e.stat(s)}catch(a){}if(i)this.throwIfFileIsReadonly(s,i);else throw new h.FileOperationError((0,l.localize)(20,null,this.resourceForError(s)),1);if(!!!o?.recursive){const a=await this.resolve(s);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,l.localize)(21,null,this.resourceForError(s)))}return e}async del(s,o){const e=await this.doValidateDelete(s,o),r=!!o?.useTrash,i=!!o?.recursive;await e.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new h.FileOperationEvent(s,1))}onDidChangeFile(s,o){this._onDidChangeFilesRaw.fire({changes:s});let e,r;{for(const i of s)this.watchedResources.has(i.resource)?(e||(e=[]),e.push(i)):(r||(r=[]),r.push(i));e&&this._onDidFilesChange.fire(new h.FileChangesEvent(e,!o))}if(r){const i=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,o={recursive:!1,excludes:[]}){const e=new c.DisposableStore;let r=!1,i=()=>{r=!0};return e.add((0,c.toDisposable)(()=>i())),this.doWatch(s,o).then(n=>{r?(0,c.dispose)(n):i=()=>(0,c.dispose)(n)},n=>this.logService.error(n)),o.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),e.add((0,c.toDisposable)(()=>{const n=this.watchedResources.get(s);typeof n=="number"&&(n<=1?this.watchedResources.delete(s):this.watchedResources.set(s,n-1))}))),e}async doWatch(s,o){const e=await this.withProvider(s),r=this.toWatchKey(e,s,o);let i=this.activeWatchers.get(r);return i||(i={count:0,disposable:e.watch(s,o)},this.activeWatchers.set(r,i)),i.count+=1,(0,c.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,c.dispose)(i.disposable),this.activeWatchers.delete(r)))})}toWatchKey(s,o,e){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,c.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,o,e,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,S.isReadableStream)(r)||(0,S.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,o,e){let r=0,i;if((0,S.isReadableBufferedStream)(e)){if(e.buffer.length>0){const n=b.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,o,n,n.byteLength,r,0),r+=n.byteLength}if(e.ended)return;i=e.stream}else i=e;return new Promise((n,a)=>{(0,S.listenStream)(i,{onData:async m=>{i.pause();try{await this.doWriteBuffer(s,o,m,m.byteLength,r,0)}catch(y){return a(y)}r+=m.byteLength,setTimeout(()=>i.resume())},onError:m=>a(m),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(s,o,e){let r=0,i;for(;(i=e.read())!==null;)await this.doWriteBuffer(s,o,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,o,e,r,i,n){let a=0;for(;a<r;)a+=await s.write(o,i+a,e.buffer,n+a,r-a)}async doWriteUnbuffered(s,o,e,r){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,o,e,r))}async doWriteUnbufferedQueued(s,o,e,r){let i;r instanceof b.VSBuffer?i=r:(0,S.isReadableStream)(r)?i=await(0,b.streamToBuffer)(r):(0,S.isReadableBufferedStream)(r)?i=await(0,b.bufferedStreamToBuffer)(r):i=(0,b.readableToBuffer)(r),await s.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,o,e,r))}async doPipeBufferedQueued(s,o,e,r){let i,n;try{i=await s.open(o,{create:!1}),n=await e.open(r,{create:!0,unlock:!1});const a=b.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,y=0,R=0;do R=await s.read(i,m,a.buffer,y,a.byteLength-y),await this.doWriteBuffer(e,n,a,R,m,y),m+=R,y+=R,y===a.byteLength&&(y=0);while(R>0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await I.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof n=="number"?e.close(n):Promise.resolve()])}}async doPipeUnbuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,o,e,r))}async doPipeUnbufferedQueued(s,o,e,r){return e.writeFile(r,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,o,e,r){return this.writeQueue.queueFor(r,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,o,e,r))}async doPipeUnbufferedToBufferedQueued(s,o,e,r){const i=await e.open(r,{create:!0,unlock:!1});try{const n=await s.readFile(o);await this.doWriteBuffer(e,i,b.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,h.ensureFileSystemProviderError)(n)}finally{await e.close(i)}}async doPipeBufferedToUnbuffered(s,o,e,r){const i=await(0,b.streamToBuffer)(this.readFileBuffered(s,o,D.CancellationToken.None));await this.doWriteUnbuffered(e,r,void 0,i)}throwIfFileSystemIsReadonly(s,o){if(s.capabilities&2048)throw new h.FileOperationError((0,l.localize)(22,null,this.resourceForError(o)),6);return s}throwIfFileIsReadonly(s,o){if((o.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,l.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===p.Schemas.file?s.fsPath:s.toString(!0)}};E.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},E=de([oe(0,g.ILogService)],E),t.FileService=E}),define(J[103],Y([0,1,48,136,3,17,10,47,6,12,19,38,13,84,16,53,94,95,96,99,28]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g,E,u,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,I.gracefulify)(L)}catch(e){console.error(`Error enabling graceful-fs: ${(0,s.toErrorMessage)(e)}`)}})();class o extends u.AbstractDiskFileSystemProvider{constructor(r,i){super(r);this.options=i,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:i,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(r){try{const i=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,p.joinPath)(r,a.name))).type:m=this.toType(a),n.push([a.name,m])}catch(m){this.logService.trace(m)}})),n}catch(i){throw this.toFileSystemProviderError(i)}}toType(r,i){let n;return i?.dangling?n=l.FileType.Unknown:r.isFile()?n=l.FileType.File:r.isDirectory()?n=l.FileType.Directory:n=l.FileType.Unknown,i&&(n|=l.FileType.SymbolicLink),n}async readFile(r){try{const i=this.toFilePath(r);return await f.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(r,i,n){const a=(0,C.newWriteableStream)(m=>D.VSBuffer.concat(m.map(y=>D.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,r,a,m=>m.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){let a;try{const m=this.toFilePath(r);if(!n.create||!n.overwrite){if(await f.Promises.exists(m)){if(!n.overwrite)throw(0,l.createFileSystemProviderError)((0,S.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,l.createFileSystemProviderError)((0,S.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(m){throw await this.toFileSystemProviderWriteError(r,m)}finally{typeof a=="number"&&await this.close(a)}}async open(r,i){try{const n=this.toFilePath(r);if((0,l.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:y}=await f.SymlinkSupport.stat(n);y.mode&128||await f.Promises.chmod(n,y.mode|128)}catch(y){this.logService.trace(y)}let a;if((0,l.isFileOpenForWriteOptions)(i)){if(d.isWindows)try{await f.Promises.truncate(n,0),a="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}a||(a="w")}else a="r";const m=await f.Promises.open(n,a);return this.mapHandleToPos.set(m,0),(0,l.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(m,r),m}catch(n){throw(0,l.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await f.Promises.fdatasync(r)}catch(i){this.canFlush=!1,this.logService.error(i)}return await f.Promises.close(r)}catch(i){throw this.toFileSystemProviderError(i)}}async read(r,i,n,a,m){const y=this.normalizePos(r,i);let R=null;try{const P=await f.Promises.read(r,n,a,m,y);return typeof P=="number"?R=P:R=P.bytesRead,R}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(r,y,R)}}normalizePos(r,i){return i===this.mapHandleToPos.get(r)?null:i}updatePos(r,i,n){const a=this.mapHandleToPos.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,a+n):this.mapHandleToPos.delete(r)))}async write(r,i,n,a,m){return(0,b.retry)(()=>this.doWrite(r,i,n,a,m),100,3)}async doWrite(r,i,n,a,m){const y=this.normalizePos(r,i);let R=null;try{const P=await f.Promises.write(r,n,a,m,y);return typeof P=="number"?R=P:R=P.bytesWritten,R}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),P)}finally{this.updatePos(r,y,R)}}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(r,i){try{const n=this.toFilePath(r);await this.doDelete(n,i)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(r,i){i.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}async rename(r,i,n){const a=this.toFilePath(r),m=this.toFilePath(i);if(a!==m)try{await this.validateTargetDeleted(r,i,"move",n.overwrite),await f.Promises.move(a,m)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,S.localize)(2,null,(0,c.basename)(a),(0,c.basename)((0,c.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(r,i,n){const a=this.toFilePath(r),m=this.toFilePath(i);if(a!==m)try{await this.validateTargetDeleted(r,i,"copy",n.overwrite),await f.Promises.copy(a,m,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,S.localize)(3,null,(0,c.basename)(a),(0,c.basename)((0,c.dirname)(m)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(r,i,n,a){const m=this.toFilePath(r),y=this.toFilePath(i);let R=!1;if(!!(this.capabilities&1024)||(R=(0,w.isEqual)(m,y,!0)),R&&n==="copy")throw(0,l.createFileSystemProviderError)((0,S.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(!R&&await f.Promises.exists(y)){if(!a)throw(0,l.createFileSystemProviderError)((0,S.localize)(5,null),l.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,i,n){let a,m=!1;return this.options?.watcher?.usePolling?m=!1:m=this.options?.legacyWatcher==="on",m?a=g.FileWatcher:a=E.FileWatcher,new a(y=>r(y),y=>i(y),n,this.options?.watcher)}doWatch(r,i){const n=this.options?.watcher?.usePolling;if(n===!0)for(const a of i)a.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const a of i)n.includes(a.path)&&(a.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,i)}createNonRecursiveWatcher(r,i,n,a){return new v.FileWatcher(r,m=>i(m),m=>n(m),a)}toFileSystemProviderError(r){if(r instanceof l.FileSystemProviderError)return r;let i;switch(r.code){case"ENOENT":i=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=l.FileSystemProviderErrorCode.NoPermissions;break;default:i=l.FileSystemProviderErrorCode.Unknown}return(0,l.createFileSystemProviderError)(r,i)}async toFileSystemProviderWriteError(r,i){let n=this.toFileSystemProviderError(i);if(r&&n.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await f.SymlinkSupport.stat(this.toFilePath(r));a.mode&128||(n=(0,l.createFileSystemProviderError)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return n}}t.DiskFileSystemProvider=o}),define(J[104],Y([0,1,16,15]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function b(c,d,p,C){try{const f=await new Promise((S,l)=>{z(["spdlog"],S,l)});return f.setFlushOn(I.LogLevel.Trace),f.createAsyncRotatingLogger(c,d,p,C)}catch(f){console.error(f)}return null}function D(c,d,p,C){const f=z.__$__nodeRequire("spdlog");return f.setFlushOn(I.LogLevel.Trace),f.createRotatingLogger(c,d,p,C)}t.createRotatingLogger=D;function T(c,d,p){switch(d){case I.LogLevel.Trace:c.trace(p);break;case I.LogLevel.Debug:c.debug(p);break;case I.LogLevel.Info:c.info(p);break;case I.LogLevel.Warning:c.warn(p);break;case I.LogLevel.Error:c.error(p);break;case I.LogLevel.Critical:c.critical(p);break;default:throw new Error("Invalid log level")}}class w extends I.AbstractMessageLogger{constructor(d,p,C,f){super();this.name=d,this.filepath=p,this.rotating=C,this.buffer=[],this.setLevel(f),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const d=this.rotating?6:1,p=30/d*L.ByteSize.MB;return b(this.name,this.filepath,p,d).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:f,message:S}of this.buffer)T(this._logger,f,S);this.buffer=[]}})}log(d,p){this._logger?T(this._logger,d,p):this.getLevel()<=d&&this.buffer.push({level:d,message:p})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=w}),define(J[32],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,L.createDecorator)("productService")}),define(J[25],Y([0,1,56,11]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class b{constructor(){this.data=new Map}add(T,w){L.ok(I.isString(T)),L.ok(I.isObject(w)),L.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,w)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}t.Registry=new b}),define(J[105],Y([0,1,10,25]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[b(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new D;I.Registry.add(t.Extensions.JSONContribution,T)}),define(J[33],Y([0,1,20,10,11,73,105,25]),function(z,t,L,I,b,D,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var c;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(c=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const p=w.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const o=this.doRegisterConfigurations(u,s);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:u,remove:s}){const o=[];o.push(...this.doDeregisterConfigurations(s)),o.push(...this.doRegisterConfigurations(u,!1)),p.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,L.distinct)(o))}registerDefaultConfigurations(u){const s=[],o=[];for(const e of u)for(const r in e)if(s.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]={...this.defaultValues[r]||{},...e[r]};const i={type:"object",default:this.defaultValues[r],description:D.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};o.push(S(r)),this.configurationProperties[r]=i,this.defaultLanguageConfigurationOverridesNode.properties[r]=i}else{this.defaultValues[r]=e[r];const i=this.configurationProperties[r];i&&(this.updatePropertyDefaultValue(r,i),this.updateSchema(r,i))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(u){const s=[];for(const o of u)for(const e in o)if(s.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const r=this.configurationProperties[e];r&&(this.updatePropertyDefaultValue(e,r),this.updateSchema(e,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const o=[];return u.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,s,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(u){const s=[],o=e=>{if(e.properties)for(const r in e.properties)s.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,e.properties[r]);e.allOf&&e.allOf.forEach(r=>o(r))};for(const e of u){o(e);const r=this.configurationContributors.indexOf(e);r!==-1&&this.configurationContributors.splice(r,1)}return s}validateAndRegisterProperties(u,s=!0,o,e=3){e=b.isUndefinedOrNull(u.scope)?e:u.scope;let r=[],i=u.properties;if(i)for(let a in i){if(s&&v(a)){delete i[a];continue}const m=i[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=b.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=b.isUndefinedOrNull(m.restricted)?!!o?.restrictedConfigurations?.includes(a):m.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),r.push(a)}let n=u.allOf;if(n)for(let a of n)r.push(...this.validateAndRegisterProperties(a,s,o,e));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const s=o=>{let e=o.properties;if(e)for(const i in e)this.updateSchema(i,e[i]);let r=o.allOf;r&&r.forEach(s)};s(u)}updateSchema(u,s){switch(t.allSettings.properties[u]=s,s.scope){case 1:t.applicationSettings.properties[u]=s;break;case 2:t.machineSettings.properties[u]=s;break;case 6:t.machineOverridableSettings.properties[u]=s;break;case 3:t.windowSettings.properties[u]=s;break;case 4:t.resourceSettings.properties[u]=s;break;case 5:t.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete t.allSettings.properties[u],s.scope){case 1:delete t.applicationSettings.properties[u];break;case 2:delete t.machineSettings.properties[u];break;case 6:delete t.machineOverridableSettings.properties[u];break;case 3:delete t.windowSettings.properties[u];break;case 4:case 5:delete t.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,o={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,o),t.allSettings.properties[s]=o,t.applicationSettings.properties[s]=o,t.machineSettings.properties[s]=o,t.machineOverridableSettings.properties[s]=o,t.windowSettings.properties[s]=o,t.resourceSettings.properties[s]=o}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){let o=this.defaultValues[u];b.isUndefined(o)&&(o=s.default),b.isUndefined(o)&&(o=l(s.type)),s.default=o}}const f="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function S(E){return E.substring(1,E.length-1)}t.overrideIdentifierFromKey=S;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const h=new C;w.Registry.add(t.Extensions.Configuration,h);function v(E){return E.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(E)?D.localize(5,null,E):h.getConfigurationProperties()[E]!==void 0?D.localize(6,null,E):null:D.localize(4,null)}t.validateProperty=v;function g(){const E=[],u=h.getConfigurationProperties();for(const s of Object.keys(u))E.push([s,u[s].scope]);return E.push(["launch",4]),E.push(["task",4]),E}t.getScopes=g}),define(J[26],Y([0,1,18,11,8,33,14,25]),function(z,t,L,I,b,D,T,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,T.createDecorator)("configurationService");function c(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof b.URI)}t.isConfigurationOverrides=c;var d;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function p(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=p;function C(r,i){const n=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],a=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],m=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const G=g(r.contents,U),ee=g(i.contents,U);L.equals(G,ee)||m.push(U)}}const y=[],R=U=>{const G={};for(const ee of U)for(const ce of ee.identifiers)G[o(ce)]=ee;return G},P=i?R(i.overrides):{},O=r?R(r.overrides):{};if(Object.keys(P).length)for(const U of n){const G=P[U];G&&y.push([(0,D.overrideIdentifierFromKey)(U),G.keys])}if(Object.keys(O).length)for(const U of a){const G=O[U];G&&y.push([(0,D.overrideIdentifierFromKey)(U),G.keys])}if(Object.keys(P).length&&Object.keys(O).length)for(const U of m){const G=O[U],ee=P[U];if(G&&ee){const ce=C({contents:G.contents,keys:G.keys,overrides:[]},{contents:ee.contents,keys:ee.keys,overrides:[]});y.push([(0,D.overrideIdentifierFromKey)(U),[...ce.added,...ce.removed,...ce.updated]])}}return{added:n,removed:a,updated:m,overrides:y}}t.compare=C;function f(r,i){const n=[];for(const a of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const y in r[a])m[y]=r[a][y];n.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:S(m,i)})}return n}t.toOverrides=f;function S(r,i){const n=Object.create(null);for(let a in r)l(n,a,r[a],i);return n}t.toValuesTree=S;function l(r,i,n,a){const m=i.split("."),y=m.pop();let R=r;for(let P=0;P<m.length;P++){let O=m[P],U=R[O];switch(typeof U){case"undefined":U=R[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${m.slice(0,P+1).join(".")} is ${JSON.stringify(U)}`);return}R=U}if(typeof R=="object"&&R!==null)try{R[y]=n}catch(P){a(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(R)}`)}else a(`Ignoring ${i} as ${m.join(".")} is ${JSON.stringify(R)}`)}t.addToValueTree=l;function h(r,i){const n=i.split(".");v(r,n)}t.removeFromValueTree=h;function v(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const a=r[n];typeof a=="object"&&!Array.isArray(a)&&(v(a,i),Object.keys(a).length===0&&delete r[n])}}function g(r,i,n){function a(R,P){let O=R;for(const U of P){if(typeof O!="object"||O===null)return;O=O[U]}return O}const m=i.split("."),y=a(r,m);return typeof y=="undefined"?n:y}t.getConfigurationValue=g;function E(r,i,n){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in r?I.isObject(r[a])&&I.isObject(i[a])?E(r[a],i[a],n):n&&(r[a]=i[a]):r[a]=i[a])})}t.merge=E;function u(){const r=w.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}t.getConfigurationKeys=u;function s(){const r=Object.create(null),i=w.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let n in i){let a=i[n].default;l(r,n,a,m=>console.error(`Conflict in default settings: ${m}`))}return r}t.getDefaultValues=s;function o(r){return`[${r}]`}t.keyFromOverrideIdentifier=o;function e(r,i,n){const a=r.inspect(i),m=r.inspect(n);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(J[106],Y([0,1,20,10,57,2,101,18,11,8,26,33,25]),function(z,t,L,I,b,D,T,w,c,d,p,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class S{constructor(e={},r=[],i=[]){this._contents=e,this._keys=r,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,p.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,r){const i=this.getContentsForOverrideIdentifer(r);return i?e?(0,p.getConfigurationValue)(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.keys;return[]}override(e){let r=this.overrideConfigurations.get(e);return r||(r=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,r)),r}merge(...e){const r=w.deepClone(this.contents),i=w.deepClone(this.overrides),n=[...this.keys];for(const a of e){this.mergeContents(r,a.contents);for(const m of a.overrides){const[y]=i.filter(R=>L.equals(R.identifiers,m.identifiers));y?this.mergeContents(y.contents,m.contents):i.push(w.deepClone(m))}for(const m of a.keys)n.indexOf(m)===-1&&n.push(m)}return new S(r,n,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const r=this.getContentsForOverrideIdentifer(e);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const n of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let a=this.contents[n],m=r[n];m&&(typeof a=="object"&&typeof m=="object"?(a=w.deepClone(a),this.mergeContents(a,m)):a=m),i[n]=a}return new S(i,this.keys,this.overrides)}mergeContents(e,r){for(const i of Object.keys(r)){if(i in e&&c.isObject(e[i])&&c.isObject(r[i])){this.mergeContents(e[i],r[i]);continue}e[i]=w.deepClone(r[i])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const r of this.overrides)if(r.identifiers.indexOf(e)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,r){this.addKey(e),(0,p.addToValueTree)(this.contents,e,r,i=>{throw new Error(i)})}removeValue(e){this.removeKey(e)&&(0,p.removeFromValueTree)(this.contents,e)}addKey(e){let r=this.keys.length;for(let i=0;i<r;i++)e.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,e)}removeKey(e){let r=this.keys.indexOf(e);return r!==-1?(this.keys.splice(r,1),!0):!1}}t.ConfigurationModel=S;class l extends S{constructor(){const e=(0,p.getDefaultValues)(),r=(0,p.getConfigurationKeys)(),i=[];for(const n of Object.keys(e))C.OVERRIDE_PROPERTY_PATTERN.test(n)&&i.push({identifiers:[(0,C.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(e[n]),contents:(0,p.toValuesTree)(e[n],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,r,i)}}t.DefaultConfigurationModel=l;class h{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,r){if(!c.isUndefinedOrNull(e)){const i=this.doParseContent(e);this.parseRaw(i,r)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,r){this._raw=e;const{contents:i,keys:n,overrides:a,restricted:m}=this.doParseRaw(e,r);this._configurationModel=new S(i,n,a),this._restrictedConfigurations=m||[]}doParseContent(e){let r={},i=null,n=[],a=[],m=[];function y(P){Array.isArray(n)?n.push(P):i!==null&&(n[i]=P)}let R={onObjectBegin:()=>{let P={};y(P),a.push(n),n=P,i=null},onObjectProperty:P=>{i=P},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{let P=[];y(P),a.push(n),n=P,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:y,onError:(P,O,U)=>{m.push({error:P,offset:O,length:U})}};if(e)try{b.visit(e,R),r=n[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return r}doParseRaw(e,r){const i=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),n=this.filter(e,i,!0,r);e=n.raw;const a=(0,p.toValuesTree)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),m=Object.keys(e),y=(0,p.toOverrides)(e,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:a,keys:m,overrides:y,restricted:n.restricted}}filter(e,r,i,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let y in e)if(C.OVERRIDE_PROPERTY_PATTERN.test(y)&&i){const R=this.filter(e[y],r,!1,n);a[y]=R.raw,m.push(...R.restricted)}else{const R=r[y],P=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&m.push(y),(P===void 0||n.scopes===void 0||n.scopes.includes(P))&&(n.skipRestricted&&R?.restricted||(a[y]=e[y]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=h;class v extends D.Disposable{constructor(e,r,i,n){super();this.userSettingsResource=e,this.scopes=r,this.fileService=n,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class g{constructor(e,r,i=new S,n=new S,a=new T.ResourceMap,m=new S,y=new T.ResourceMap,R=!0){this._defaultConfiguration=e,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=n,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=y,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(e)}updateValue(e,r,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource),n||(n=new S,this._memoryConfigurationByResource.set(i.resource,n))):n=this._memoryConfiguration,r===void 0?n.removeValue(e):n.setValue(e,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,r,i){const n=this.getConsolidateConfigurationModel(r,i),a=this.getFolderConfigurationModelForResource(r.resource,i),m=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,y=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),R=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),P=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,G=a?r.overrideIdentifier?a.freeze().override(r.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,ee=r.overrideIdentifier?m.override(r.overrideIdentifier).getValue(e):m.getValue(e),ce=n.getValue(e),le=L.distinct(L.flatten(n.overrides.map(ne=>ne.identifiers))).filter(ne=>n.getOverrideValue(e,ne)!==void 0);return{defaultValue:y,userValue:R,userLocalValue:P,userRemoteValue:O,workspaceValue:U,workspaceFolderValue:G,memoryValue:ee,value:ce,default:y!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:a?.freeze().getValue(e),override:r.overrideIdentifier?a?.freeze().getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,memory:ee!==void 0?{value:m.getValue(e),override:r.overrideIdentifier?m.getOverrideValue(e,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(e){const r=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,r){this._folderConfigurations.set(e,r),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,r){const i=r.filter(n=>C.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const a=(0,C.overrideIdentifierFromKey)(n),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),y=e.getKeysForOverrideIdentifier(a),R=[...y.filter(P=>m.indexOf(P)===-1),...m.filter(P=>y.indexOf(P)===-1),...m.filter(P=>!w.equals(this._defaultConfiguration.override(a).getValue(P),e.override(a).getValue(P)))];return[a,R]});return this.updateDefaultConfiguration(e),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.localUserConfiguration,e),m=[...r,...i,...n];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.remoteUserConfiguration,e);let m=[...r,...i,...n];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:r,updated:i,removed:n,overrides:a}=(0,p.compare)(this.workspaceConfiguration,e);let m=[...r,...i,...n];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,r){const i=this.folderConfigurations.get(e),{added:n,updated:a,removed:m,overrides:y}=(0,p.compare)(i,r);let R=[...n,...a,...m];return(R.length||!i)&&this.updateFolderConfiguration(e,r),{keys:R,overrides:y}}compareAndDeleteFolderConfiguration(e){const r=this.folderConfigurations.get(e);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:a,overrides:m}=(0,p.compare)(r,void 0);return{keys:[...i,...n,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,r){let i=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&e){const n=r.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const a=this._memoryConfigurationByResource.get(e);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let r=this._foldersConsolidatedConfigurations.get(e);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(r=i.merge(n),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(e,r)):r=i}return r}getFolderConfigurationModelForResource(e,r){if(r&&e){const i=r.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,r)=>{const{contents:i,overrides:n,keys:a}=this._folderConfigurations.get(r);return e.push([r,{contents:i,overrides:n,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>e.add(r)),this.userConfiguration.freeze().keys.forEach(r=>e.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>e.add(i))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(n=>r.add(n))),[...r.values()]}static parse(e){const r=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),n=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,y)=>(m.set(d.URI.revive(y[0]),this.parseConfigurationModel(y[1])),m),new T.ResourceMap);return new g(r,i,new S,n,a,new S,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=g;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,r=new Map;for(const n of o)n.keys.forEach(a=>e.add(a)),n.overrides.forEach(([a,m])=>{const y=(0,T.getOrSet)(r,a,new Set);m.forEach(R=>y.add(R))});const i=[];return r.forEach((n,a)=>i.push([a,[...n.values()]])),{keys:[...e.values()],overrides:i}}t.mergeChanges=E;class u{constructor(e,r,i,n){this.change=e,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=n,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(y=>a.add(y)),e.overrides.forEach(([,y])=>y.forEach(R=>a.add(R))),this.affectedKeys=[...a.values()];const m=new S;this.affectedKeys.forEach(y=>m.setValue(y,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(e,r,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(e,r,this.currentWorkspace);return!w.equals(i,n)}return!0}return!1}doesAffectedKeysTreeContains(e,r){let i=(0,p.toValuesTree)({[r]:!0},()=>{}),n;for(;typeof i=="object"&&(n=Object.keys(i)[0]);){if(e=e[n],!e)return!1;i=i[n]}return!0}}t.ConfigurationChangeEvent=u;class s extends u{constructor(e,r,i,n){super({keys:e.allKeys(),overrides:[]},void 0,e,r);this.source=i,this.sourceConfig=n}}t.AllKeysConfigurationChangeEvent=s}),define(J[107],Y([0,1,3,10,2,19,26,106,33,25]),function(z,t,L,I,b,D,T,w,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class p extends b.Disposable{constructor(f,S){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new I.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,S)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(c.Extensions.Configuration).onDidUpdateConfiguration(l=>this.onDidDefaultConfigurationChange(l))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,S){const l=typeof f=="string"?f:void 0,h=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(l,h,void 0)}updateValue(f,S,l,h){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const S=this.configuration.toData(),l=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(l,S,1)}onDidDefaultConfigurationChange(f){const S=this.configuration.toData(),l=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,f);this.trigger(l,S,6)}trigger(f,S,l){const h=new w.ConfigurationChangeEvent(f,{data:S},this.configuration);h.source=l,h.sourceConfig=this.getTargetConfiguration(l),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=p}),define(J[108],Y([0,1,9]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function I(d){return d.scheme===L.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=I;function b(d){if(!d)return;const p=d.indexOf("+");return p<0?d:d.substr(0,p)}t.getRemoteName=b;function D(d){return d.scheme!==L.Schemas.file&&d.scheme!==L.Schemas.vscodeRemote}t.isVirtualResource=D;function T(d){if(d.folders.length)return d.folders.every(p=>D(p.uri))?d.folders[0].uri:void 0;if(d.configuration&&D(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=T;function w(d){return T(d)?.scheme}t.getVirtualWorkspaceScheme=w;function c(d){return T(d)!==void 0}t.isVirtualWorkspace=c}),define(J[42],Y([0,1,27,14,108]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.checkProposedApiEnabled=t.isProposedApiEnabled=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}t.getWorkspaceSupportTypeMessage=D;function T(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=T,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(w=t.ExtensionType||(t.ExtensionType={}));class c{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,v){if(typeof h=="undefined"||h===null)return typeof v=="undefined"||v===null;if(typeof v=="undefined"||v===null)return!1;if(typeof h=="string"||typeof v=="string"){let g=typeof h=="string"?h:h.value,E=typeof v=="string"?v:v.value;return L.equalsIgnoreCase(g,E)}return h._lower===v._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}t.ExtensionIdentifier=c;function d(l){return Boolean(l.enableProposedApi)}t.isProposedApiEnabled=d;function p(l){if(!d(l))throw new Error(`[${l.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`)}t.checkProposedApiEnabled=p;function C(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}t.isLanguagePackExtension=C;function f(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=f;function S(l,h){if(h&&d(l)){const v=`onResolveRemoteAuthority:${(0,b.getRemoteName)(h)}`;return l.activationEvents?.indexOf(v)!==-1}return!1}t.isResolverExtension=S,t.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Y([0,1,27,42]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function b(l,h){return l.uuid&&h.uuid?l.uuid===h.uuid:l.id===h.id?!0:(0,L.compareIgnoreCase)(l.id,h.id)===0}t.areSameExtensions=b;class D{constructor(h,v){this.version=v,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof D?b(this,h)&&this.version===h.version:!1}}t.ExtensionIdentifierWithVersion=D;function T(l,h){return`${l}.${h}`}t.getExtensionId=T;function w(l){return l.toLocaleLowerCase()}t.adoptToGalleryExtensionId=w;function c(l,h){return w(T(l,h))}t.getGalleryExtensionId=c;function d(l,h){const v=[],g=E=>{for(const u of v)if(u.some(s=>b(h(s),h(E))))return u;return null};for(const E of l){const u=g(E);u?u.push(E):v.push([E])}return v}t.groupByExtension=d;function p(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=p;function C(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}t.getGalleryExtensionTelemetryData=C,t.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function f(l){const h=new Set;for(const v of l)v.malicious&&h.add(v.id.id);return h}t.getMaliciousExtensionsSet=f;function S(l,h){const v=[],g=h.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const E=g.shift();if(E&&v.every(u=>!b(u.identifier,{id:E}))){const u=l.filter(s=>b(s.identifier,{id:E}));u.length===1&&(v.push(u[0]),g.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=S}),define(J[109],Y([0,1,24,7,62,9,43,8,77,22,23,42]),function(z,t,L,I,b,D,T,w,c,d,p,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const f=E=>(0,c.localize)(0,null,E),S=(0,c.localize)(1,null,"ms-dotnettools.csharp");function l(E,u){return u?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}const h=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(E){const u=h.exec(E);return u&&u[1]?[(0,p.adoptToGalleryExtensionId)(u[1]),u[2]]:[(0,p.adoptToGalleryExtensionId)(E),void 0]}t.getIdAndVersion=v;let g=class{constructor(u,s){this.extensionManagementService=u,this.extensionGalleryService=s}get location(){}async listExtensions(u,s,o=console){let e=await this.extensionManagementService.getInstalled(1);const r=C.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(s&&s!==""){if(r.indexOf(s.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(n=>n.manifest.categories?n.manifest.categories.map(m=>m.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){o.log("Possible Categories: "),r.forEach(n=>{o.log(n)});return}this.location&&o.log((0,c.localize)(2,null,this.location)),e=e.sort((n,a)=>n.identifier.id.localeCompare(a.identifier.id));let i;for(let n of e)i!==n.identifier.id&&(i=n.identifier.id,o.log(l(n.manifest,u)))}async installExtensions(u,s,o,e,r=console){const i=[],n=[];u.length&&r.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(P,O)=>{const U=a.find(G=>(0,p.areSameExtensions)(G.identifier,{id:P}));if(U){if(!O&&!e)return r.log((0,c.localize)(5,null,P,U.manifest.version,P)),!1;if(O&&U.manifest.version===O)return r.log((0,c.localize)(6,null,`${P}@${O}`)),!1}return!0},y=[],R=[];for(const P of u)if(P instanceof w.URI)y.push(P);else{const[O,U]=v(P);m(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const P of s){const[O,U]=v(P);m(O,U)&&R.push({id:O,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(y.length&&await Promise.all(y.map(async P=>{try{const O=await this.installVSIX(P,{isBuiltin:!1,isMachineScoped:o},e,r);O&&n.push(O)}catch(O){r.error(O.message||O.stack||O),i.push(P.toString())}})),R.length){const P=await this.getGalleryExtensions(R);await Promise.all(R.map(async O=>{const U=P.get(O.id.toLowerCase());if(U)try{const G=await this.installFromGallery(O,U,a,e,r);G&&n.push(G)}catch(G){r.error(G.message||G.stack||G),i.push(O.id)}else r.error(`${f(O.version?`${O.id}@${O.version}`:O.id)}
${S}`),i.push(O.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(u,s,o,e){const r=await this.extensionManagementService.getManifest(u);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,o,e))try{return await this.extensionManagementService.install(u,s),e.log((0,c.localize)(8,null,(0,b.getBaseLabel)(u))),r}catch(n){if((0,I.isPromiseCanceledError)(n))return e.log((0,c.localize)(9,null,(0,b.getBaseLabel)(u))),null;throw n}return null}async getGalleryExtensions(u){const s=new Map,o=await this.extensionGalleryService.getExtensions(u,L.CancellationToken.None);for(const e of o)s.set(e.identifier.id.toLowerCase(),e);return s}async installFromGallery({id:u,version:s,installOptions:o},e,r,i,n){const a=await this.extensionGalleryService.getManifest(e,L.CancellationToken.None);if(a&&!this.validateExtensionKind(a,n))return null;const m=r.find(y=>(0,p.areSameExtensions)(y.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return n.log((0,c.localize)(10,null,s?`${u}@${s}`:u)),null;n.log((0,c.localize)(11,null,u,e.version))}try{return o.isBuiltin?n.log(s?(0,c.localize)(12,null,u,s):(0,c.localize)(13,null,u)):n.log(s?(0,c.localize)(14,null,u,s):(0,c.localize)(15,null,u)),await this.extensionManagementService.installFromGallery(e,{...o,installGivenVersion:!!s}),n.log((0,c.localize)(16,null,u,e.version)),a}catch(y){if((0,I.isPromiseCanceledError)(y))return n.log((0,c.localize)(17,null,u)),null;throw y}}validateExtensionKind(u,s){return!0}async validateVSIX(u,s,o){const e={id:(0,p.getGalleryExtensionId)(u.publisher,u.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,p.areSameExtensions)(e,n.identifier)&&(0,T.gt)(n.manifest.version,u.version));return i&&!s?(o.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,u.version)),!1):this.validateExtensionKind(u,o)}async uninstallExtensions(u,s,o=console){const e=async i=>{if(i instanceof w.URI){const n=await this.extensionManagementService.getManifest(i);return l(n)}return i},r=[];for(const i of u){const n=await e(i),m=(await this.extensionManagementService.getInstalled()).filter(y=>(0,p.areSameExtensions)(y.identifier,{id:n}));if(!m.length)throw new Error(`${this.notInstalled(n)}
${S}`);if(m.some(y=>y.type===0)){o.log((0,c.localize)(19,null,n));return}if(!s&&m.some(y=>y.isBuiltin)){o.log((0,c.localize)(20,null,n));return}o.log((0,c.localize)(21,null,n));for(const y of m)await this.extensionManagementService.uninstall(y),r.push(y);this.location?o.log((0,c.localize)(22,null,n,this.location)):o.log((0,c.localize)(23,null,n))}}async locateExtension(u,s=console){const o=await this.extensionManagementService.getInstalled();u.forEach(e=>{o.forEach(r=>{if(r.identifier.id===e&&r.location.scheme===D.Schemas.file){s.log(r.location.fsPath);return}})})}notInstalled(u){return this.location?(0,c.localize)(24,null,u,this.location):(0,c.localize)(25,null,u)}};g=de([oe(0,d.IExtensionManagementService),oe(1,d.IExtensionGalleryService)],g),t.ExtensionManagementCLIService=g}),define(J[110],Y([0,1,3,7,2,12,19,43,8,31,13,21,22,23,16,15]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends b.Disposable{constructor(u,s,o,e){super();this.fileService=s,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,s){await this.cleanUpPromise;const o=this.getName(u),e=(0,T.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const r=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(u,r,s);try{await this.rename(r,e,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(n){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,r.path),i}}return e}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,s,o){try{await p.Promises.rename(u.fsPath,s.fsPath)}catch(e){if(D.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${u} to ${s} with 'EPERM' error. Trying again...`),this.rename(u,s,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const s=[],o=[];for(const i of u.children){const n=this.parse(i.name);n&&o.push([n,i])}const e=(0,S.groupByExtension)(o,([i])=>i),r=[];for(const i of e)i.sort((n,a)=>w.rcompare(n[0].version,a[0].version)),s.push(...i.slice(1).map(n=>n[1].resource)),r.push(i[0][1]);r.sort((i,n)=>i.mtime-n.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await L.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?`${new S.ExtensionIdentifierWithVersion(u.identifier,u.version).key().toLowerCase()}${u.properties.targetPlatform!=="undefined"?`-${u.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(u){const s=v.exec(u);return s&&s[1]&&s[2]?new S.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};g=de([oe(0,C.INativeEnvironmentService),oe(1,l.IFileService),oe(2,f.IExtensionGalleryService),oe(3,h.ILogService)],g),t.ExtensionsDownloader=g}),define(J[111],Y([0,1,2,6,13,42]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class T extends L.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,I.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(p=>this.onDidInstallExtensions(p))),this._register(d.onDidUninstallExtension(p=>this.onDidUnInstallExtension(p)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=T}),define(J[112],Y([0,1,137,20,3,2,9,6,13,21,22,23,55,15]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let l=class extends D.Disposable{constructor(g,E,u){super();this.extensionManagementService=g,this.logService=u,this.cache=this._register(new h(E,u)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),E=["en",...Object.keys(g)];return(0,I.distinct)(E)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const E=await this.cache.getLanguagePacks();Object.keys(E).some(u=>E[u]&&E[u].extensions.some(s=>(0,C.areSameExtensions)(s.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(E);return!(0,I.equals)(Object.keys(g),Object.keys(u))}};l=de([oe(0,p.IExtensionManagementService),oe(1,d.INativeEnvironmentService),oe(2,S.ILogService)],l),t.LocalizationsService=l;let h=class extends D.Disposable{constructor(g,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(E=>{Object.keys(E).forEach(u=>delete E[u]),this.createLanguagePacksFromExtensions(E,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...E){for(const u of E)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,u);Object.keys(g).forEach(u=>this.updateHash(g[u]))}createLanguagePacksFromExtension(g,E){const u=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of s)if(E.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(o)){let e=g[o.languageId];e||(e={hash:"",extensions:[],translations:{}},g[o.languageId]=e);let r=e.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,u))[0];r?r.version=E.manifest.version:e.extensions.push({extensionIdentifier:u,version:E.manifest.version});for(const i of o.translations)e.translations[i.id]=(0,w.join)(E.location.fsPath,i.path)}}updateHash(g){if(g){const E=(0,L.createHash)("md5");for(const u of g.extensions)E.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);g.hash=E.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch(s){return{}}}).then(u=>(E=g(u),u)).then(u=>{for(const o of Object.keys(u))u[o]||delete u[o];this.languagePacks=u,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>E,u=>this.logService.error(u))})}};h=de([oe(0,d.INativeEnvironmentService),oe(1,S.ILogService)],h)}),define(J[44],Y([0,1,17,85,33,14,25]),function(z,t,L,I,b,D,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,D.createDecorator)("requestService");function w(l){return l.res.statusCode&&l.res.statusCode>=200&&l.res.statusCode<300||l.res.statusCode===1223}t.isSuccess=w;function c(l){return l.res.statusCode===204}async function d(l){if(!w(l))throw new Error("Server returned "+l.res.statusCode);return c(l)?null:(await(0,L.streamToBuffer)(l.stream)).toString()}t.asText=d;async function p(l){if(!w(l))throw new Error("Server returned "+l.res.statusCode);if(c(l))return null;const v=(await(0,L.streamToBuffer)(l.stream)).toString();try{return JSON.parse(v)}catch(g){throw g.message+=`:
`+v,g}}t.asJson=p;function C(l){S(l)}t.updateProxyConfigurationsScope=C;let f;function S(l){const h=T.Registry.as(b.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,I.localize)(0,null),type:"object",scope:l,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,I.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,I.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,I.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,I.localize)(4,null),(0,I.localize)(5,null),(0,I.localize)(6,null),(0,I.localize)(7,null)],default:"override",description:(0,I.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,I.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[f],remove:v?[v]:[]})}S(2)}),define(J[113],Y([0,1,24,9,16,44]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let T=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,p=L.CancellationToken.None){if(c.scheme===I.Schemas.file||c.scheme===I.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const C={type:"GET",url:c.toString()},f=await this.requestService.request(C,p);if(f.res.statusCode===200)await this.fileService.writeFile(d,f.stream);else{const S=await(0,D.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${S}`)}}};T=de([oe(0,D.IRequestService),oe(1,b.IFileService)],T),t.DownloadService=T}),define(J[114],Y([0,1,115,11]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function b(T,w){return T.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:T.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(T,w,c={}){const d=(0,L.parse)(T),p=c.proxyUrl||b(d,w);if(!p)return null;const C=(0,L.parse)(p);if(!/^https?:$/.test(C.protocol||""))return null;const f={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,I.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((S,l)=>{z(["http-proxy-agent"],S,l)}))(f):new(await new Promise((S,l)=>{z(["https-proxy-agent"],S,l)}))(f)}t.getProxyAgent=D}),define(J[116],Y([0,1,17,31]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function b(D,T,w){let c=w&&w.get("storage.serviceMachineId",0)||null;if(c)return c;try{const p=(await T.readFile(D.serviceMachineIdResource)).value.toString();c=(0,I.isUUID)(p)?p:null}catch(d){c=null}if(!c){c=(0,I.generateUuid)();try{await T.writeFile(D.serviceMachineIdResource,L.VSBuffer.fromString(c))}catch(d){}}return w&&w.store("storage.serviceMachineId",c,0,1),c}t.getServiceMachineId=b}),define(J[117],Y([0,1,3,10,2,102,11,66,14]),function(z,t,L,I,b,D,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var p;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(p=t.WillSaveStateReason||(t.WillSaveStateReason={}));var C;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(C=t.StorageScope||(t.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=t.StorageTarget||(t.StorageTarget={}));class S extends b.Disposable{constructor(g={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new I.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new I.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new I.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,E){E===d?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:E,target:this.getKeyTargets(g)[E]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,E,u){return this.getStorage(E)?.get(g,u)}getBoolean(g,E,u){return this.getStorage(E)?.getBoolean(g,u)}getNumber(g,E,u){return this.getStorage(E)?.getNumber(g,u)}store(g,E,u,s){if((0,T.isUndefinedOrNull)(E)){this.remove(g,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,u,s),this.getStorage(u)?.set(g,E)})}remove(g,E){this.withPausedEmitters(()=>{this.updateKeyTarget(g,E,void 0),this.getStorage(E)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,E){const u=[],s=this.getKeyTargets(g);for(const o of Object.keys(s))s[o]===E&&u.push(o);return u}updateKeyTarget(g,E,u){const s=this.getKeyTargets(E);typeof u=="number"?s[g]!==u&&(s[g]=u,this.getStorage(E)?.set(d,JSON.stringify(s))):typeof s[g]=="number"&&(delete s[g],this.getStorage(E)?.set(d,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const E=this.get(d,g);if(E)try{return JSON.parse(E)}catch(u){}return Object.create(null)}isNew(g){return this.getBoolean(t.IS_NEW_KEY,g)===!0}async flush(g=p.NONE){this._onWillSaveState.fire({reason:g});const E=this.getStorage(0),u=this.getStorage(1);switch(g){case p.NONE:await L.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await L.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return h(g,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class l extends S{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}t.InMemoryStorageService=l;async function h(v,g,E,u){const s=m=>{try{return JSON.parse(m)}catch(y){return m}},o=new Map,e=new Map;v.forEach((m,y)=>{o.set(y,m),e.set(y,s(m))});const r=new Map,i=new Map;g.forEach((m,y)=>{r.set(y,m),i.set(y,s(m))}),console.group(`Storage: Global (path: ${E})`);let n=[];o.forEach((m,y)=>{n.push({key:y,value:m})}),console.table(n),console.groupEnd(),console.log(e),console.group(`Storage: Workspace (path: ${u})`);let a=[];r.forEach((m,y)=>{a.push({key:y,value:m})}),console.table(a),console.groupEnd(),console.log(i)}t.logStorage=h}),define(J[118],Y([0,1,12,29,8,31]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function T(d){if(L.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function w(d,p,C,f,S,l,h,v,g,E){const u=Object.create(null);u["common.machineId"]=h,u.sessionID=(0,D.generateUuid)()+Date.now(),u.commitHash=S,u.version=l,u["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.PlatformToString)(L.platform),u["common.nodePlatform"]=I.platform,u["common.nodeArch"]=f,u["common.product"]=E||"desktop";const s=c(v||[]);s&&(u["common.msftInternal"]=s);let o=0;const e=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),L.isLinuxSnap&&(u["common.snap"]="true");const r=T(C);r&&(u["common.platformDetail"]=r);try{const i=await d.readFile(b.URI.file(g));u["common.source"]=i.value.toString().slice(0,30)}catch(i){}return u}t.resolveCommonProperties=w;function c(d){const p=I.env.USERDNSDOMAIN;if(!p)return!1;const C=p.toLowerCase();return d.some(f=>C===f)}t.verifyMicrosoftInternalDomain=c}),define(J[30],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,L.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(I=t.TelemetryLevel||(t.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(J[119],Y([0,1,20,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let v=class extends w.Disposable{constructor(o,e,r,i){super();this.galleryService=o,this.telemetryService=e,this.logService=r,this.productService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(r=>(0,C.isTargetPlatformCompatible)(r,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(p.localize(0,null),C.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(o)){const i=await this.getTargetPlatform(),n=new C.ExtensionManagementError(p.localize(1,null,o.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(i)),C.ExtensionManagementErrorCode.Incompatible);throw this.logService.error("Cannot install extension.",o.identifier.id,n.message),E(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(o),void 0,n),n}try{o=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion)}catch(i){throw this.logService.error((0,D.getErrorMessage)(i)),E(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(o),void 0,i),i}const r=await this.galleryService.getManifest(o,b.CancellationToken.None);if(r===null){const i=new C.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error("Failed to install extension:",o.identifier.id,i.message),E(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(o),void 0,i),i}if(r.version!==o.version){const i=new C.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);throw this.logService.error(i.message),E(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(o),void 0,i),i}return this.installExtension(r,o,e)}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(p.localize(2,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(p.localize(3,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const o=new Date().getTime();return(!this.reportedExtensions||o-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=o),this.reportedExtensions}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,r){if(!d.URI.isUri(e)){let y=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(y)return this.logService.info("Extensions is already requested to install",e.identifier.id),y.waitUntilTaskIsFinished();r={...r,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],a=this.createInstallExtensionTask(o,e,r);d.URI.isUri(e)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(a.identifier,o.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),i.push({task:a,manifest:o});let m=!1;try{if(r.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const R=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,o,!!r.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:P,manifest:O}of R)if(m=m||!!O.extensionDependencies?.some(U=>(0,f.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(P.identifier,P.version).key()))this.logService.info("Extension is already requested to install",P.identifier.id);else{const U=this.createInstallExtensionTask(O,P,{...r,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:P}),this.logService.info("Installing extension:",U.identifier.id),i.push({task:U,manifest:O})}}catch(R){if(d.URI.isUri(a.source))(0,L.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,R.message),(0,L.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,R.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(R),R}const y=i.reduce((R,{task:P,manifest:O})=>(R.set(P.identifier.id.toLowerCase(),{task:P,manifest:O}),R),new Map);for(;y.size;){let R;const P=[...y.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>y.has(U.toLowerCase())));P.length?R=y.size===1?P:P.filter(({task:O})=>!(O===a&&!m)):(this.logService.info("Found extensions with circular dependencies",P.map(({task:O})=>O.identifier.id)),R=[...y.values()]),await this.joinAllSettled(R.map(async({task:O})=>{const U=new Date().getTime();try{const G=await O.run();if(await this.joinAllSettled(this.participants.map(ee=>ee.postInstall(G,O.source,r,b.CancellationToken.None))),!d.URI.isUri(O.source)&&(E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),c.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(G.manifest.publisher,G.manifest.name,G.manifest.version,"install")}catch(ee){}n.push({local:G,identifier:O.identifier,operation:O.operation,source:O.source})}catch(G){throw d.URI.isUri(O.source)||E(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,G),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(G),G}finally{y.delete(O.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:R})=>this.logService.info("Extension installed successfully:",R.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:R})=>(0,f.areSameExtensions)(R,a.identifier))[0].local}catch(y){if(i.forEach(({task:R})=>R.cancel()),n.length)try{const R=await Promise.allSettled(n.map(({local:P})=>this.createUninstallExtensionTask(P,{versionOnly:!0}).run()));for(let P=0;P<R.length;P++){const O=R[P],{identifier:U}=n[P];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,D.getErrorMessage)(O.reason))}}catch(R){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(R),n.map(({identifier:P})=>P.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,D.getErrorMessage)(y)),this._onDidInstallExtensions.fire(i.map(({task:R})=>({identifier:R.identifier,operation:1,source:R.source}))),y instanceof Error&&(y.name=y&&y.code?y.code:C.ExtensionManagementErrorCode.Internal),y}finally{for(const{task:y,manifest:R}of i)if(!d.URI.isUri(y.source)){const P=new f.ExtensionIdentifierWithVersion(y.identifier,R.version).key();this.installingExtensions.delete(P)||this.logService.warn("Installation task is not found in the cache",P)}}}async joinAllSettled(o){const e=[],r=[],i=await Promise.allSettled(o);for(const n of i)n.status==="fulfilled"?e.push(n.value):r.push(n.reason);if(r.length)throw g(r);return e}async getAllDepsAndPackExtensionsToInstall(o,e,r){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[o,...i.map(y=>y.identifier)],a=[],m=async(y,R)=>{const P=R.extensionDependencies||[],O=[...P];if(R.extensionPack){const U=r?i.find(G=>(0,f.areSameExtensions)(G.identifier,y)):void 0;for(const G of R.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(ee=>(0,f.areSameExtensions)({id:ee},{id:G}))||O.every(ee=>!(0,f.areSameExtensions)({id:ee},{id:G}))&&O.push(G)}if(O.length){const U=[...n,...a.map(ee=>ee.gallery.identifier)],G=O.filter(ee=>U.every(ce=>!(0,f.areSameExtensions)(ce,{id:ee})));if(G.length){const ee=await this.galleryService.query({names:G,pageSize:O.length},b.CancellationToken.None);for(const ce of ee.firstPage){if(U.find(B=>(0,f.areSameExtensions)(B,ce.identifier)))continue;if(!P.some(B=>(0,f.areSameExtensions)({id:B},ce.identifier))&&!await this.canInstall(ce)){this.logService.info("Skipping the packed extension as it cannot be installed",ce.identifier.id);continue}const ne=await this.checkAndGetCompatibleVersion(ce,!0),he=await this.galleryService.getManifest(ne,b.CancellationToken.None);if(he===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${ne.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);a.push({gallery:ne,manifest:he}),await m(ne.identifier,he)}}}};return await m(o,e),i=await this.getInstalled(),a.filter(y=>!i.some(R=>(0,f.areSameExtensions)(R.identifier,y.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e){if(await this.isMalicious(o))throw new C.ExtensionManagementError(p.localize(4,null,o.identifier.id),C.ExtensionManagementErrorCode.Malicious);const r=await this.getCompatibleVersion(o,e);if(!r)throw new C.ExtensionManagementError(p.localize(5,null,o.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);return r}async getCompatibleVersion(o,e){const r=await this.getTargetPlatform();let i=null;return await this.galleryService.isExtensionCompatible(o,r)&&(i=o),!i&&e&&(i=await this.galleryService.getCompatibleExtension(o,r)),i}async isMalicious(o){const e=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(e).has(o.identifier.id)}async unininstallExtension(o,e){const r=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(r)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),r.waitUntilTaskIsFinished();const i=(y,R)=>{const P=this.createUninstallExtensionTask(y,R);return this.uninstallingExtensions.set(P.extension.identifier.id.toLowerCase(),P),this.logService.info("Uninstalling extension:",y.identifier.id),this._onUninstallExtension.fire(y.identifier),P},n=(y,R)=>{R?this.logService.error("Failed to uninstall extension:",y.identifier.id,R.message):this.logService.info("Successfully uninstalled extension:",y.identifier.id),E(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(y),void 0,R),this._onDidUninstallExtension.fire({identifier:y.identifier,error:R?.code})},a=[],m=[];try{a.push(i(o,{}));const y=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const R=this.getAllPackExtensionsToUninstall(o,y);for(const P of R)this.uninstallingExtensions.has(P.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",P.identifier.id):a.push(i(P,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(a.map(R=>R.extension),y,o),await this.joinAllSettled(a.map(async R=>{try{if(await R.run(),await this.joinAllSettled(this.participants.map(P=>P.postUninstall(R.extension,e,b.CancellationToken.None))),R.extension.identifier.uuid)try{await this.galleryService.reportStatistic(R.extension.manifest.publisher,R.extension.manifest.name,R.extension.manifest.version,"uninstall")}catch(P){}n(R.extension)}catch(P){const O=P instanceof C.ExtensionManagementError?P:new C.ExtensionManagementError((0,D.getErrorMessage)(P),C.ExtensionManagementErrorCode.Internal);throw n(R.extension,O),O}finally{m.push(R)}}))}catch(y){const R=y instanceof C.ExtensionManagementError?y:new C.ExtensionManagementError((0,D.getErrorMessage)(y),C.ExtensionManagementErrorCode.Internal);for(const P of a){try{P.cancel()}catch(O){}m.includes(P)||n(P.extension,R)}throw R}finally{for(const y of a)this.uninstallingExtensions.delete(y.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",y.extension.identifier.id)}}checkForDependents(o,e,r){for(const i of o){const n=this.getDependents(i,e);if(n.length){const a=n.filter(m=>!o.some(y=>(0,f.areSameExtensions)(y.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(i,a,r))}}}getDependentsErrorMessage(o,e,r){return r===o?e.length===1?p.localize(6,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(7,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(8,null,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?p.localize(9,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?p.localize(10,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):p.localize(11,null,r.manifest.displayName||r.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,r=[]){if(r.indexOf(o)!==-1)return[];r.push(o);const i=o.manifest.extensionPack?o.manifest.extensionPack:[];if(i.length){const n=e.filter(m=>!m.isBuiltin&&i.some(y=>(0,f.areSameExtensions)({id:y},m.identifier))),a=[];for(const m of n)a.push(...this.getAllPackExtensionsToUninstall(m,e,r));return[...n,...a]}return[]}getDependents(o,e){return e.filter(r=>r.manifest.extensionDependencies&&r.manifest.extensionDependencies.some(i=>(0,f.areSameExtensions)({id:i},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${o.length} reported extensions from service`),o}catch(o){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=de([oe(0,C.IExtensionGalleryService),oe(1,h.ITelemetryService),oe(2,S.ILogService),oe(3,l.IProductService)],v),t.AbstractExtensionManagementService=v;function g(s){const o=Array.isArray(s)?s:[s];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,r)=>new Error(`${e.message}${e.message?",":""}${r instanceof Error?r.message:r}`),new Error(""))}t.joinErrors=g;function E(s,o,e,r,i){const n=i?i instanceof C.ExtensionManagementError?i.code:C.ExtensionManagementErrorCode.Internal:void 0;s.publicLogError(o,{...e,success:!i,duration:r,errorcode:n})}t.reportTelemetry=E;class u{constructor(){this.barrier=new I.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,I.createCancelablePromise)(o=>new Promise((e,r)=>{const i=o.onCancellationRequested(()=>{i.dispose(),r((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=u}),define(J[36],Y([0,1,18,11,26,30]),function(z,t,L,I,b,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,E){return Promise.resolve(void 0)}publicLog2(g,E){return this.publicLog(g,E)}publicLogError(g,E){return Promise.resolve(void 0)}publicLogError2(g,E){return this.publicLogError(g,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=T,t.NullTelemetryService=new T;class w{async publicLog(g,E,u){}async publicLogError(g,E,u){}}t.NullEndpointTelemetryService=w,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function c(v,g){return g.onDidChangeConfiguration(E=>{E.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(E.source),configurationKeys:l(E.sourceConfig)})})}t.configurationTelemetry=c;function d(v,g){return!(g.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=d;function p(v){const g=v.getValue(D.TELEMETRY_SETTING_ID),E=v.getValue("telemetry.enableCrashReporter");if(v.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=p;function C(v){const g=Object.create(null),E=Object.create(null),u=Object.create(null);S(v,u);for(let s in u){s=s.length>150?s.substr(s.length-149):s;const o=u[s];typeof o=="number"?E[s]=o:typeof o=="boolean"?E[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),g[s]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(g[s]=o)}return{properties:g,measurements:E}}t.validateTelemetryData=C;function f(v){if(!v)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{v.indexOf(`${u}+`)===0&&(g=u)}),g}t.cleanRemoteAuthority=f;function S(v,g,E=0,u){if(!!v)for(let s of Object.getOwnPropertyNames(v)){const o=v[s],e=u?u+s:s;Array.isArray(o)?g[e]=(0,L.safeStringify)(o):o instanceof Date?g[e]=o.toISOString():(0,I.isObject)(o)?E<2?S(o,g,E+1,e+"."):g[e]=(0,L.safeStringify)(o):g[e]=o}}function l(v){if(!v)return[];const g=[];return h(g,"",v),g}function h(v,g,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(u=>h(v,g?`${g}.${u}`:u,E[u])):v.push(g)}}),define(J[120],Y([0,1,20,24,7,18,12,29,8,26,21,22,23,51,16,15,32,44,116,117,30,36]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g,E,u,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=T.isWeb?"web":(0,C.getTargetPlatform)(T.platform,w.arch);var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...N){return String(N.reduce((A,W)=>A|W,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},R={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class P{constructor(A=R){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,W=this.state.pageSize){return new P({...this.state,pageNumber:A,pageSize:W})}withFilter(A,...W){const x=[...this.state.criteria,...W.length?W.map(K=>({filterType:A,value:K})):[{filterType:A}]];return new P({...this.state,criteria:x})}withSortBy(A){return new P({...this.state,sortBy:A})}withSortOrder(A){return new P({...this.state,sortOrder:A})}withFlags(...A){return new P({...this.state,flags:A.reduce((W,x)=>W|x,0)})}withAssetTypes(...A){return new P({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:W,pageSize:x,sortBy:K,sortOrder:Q,flags:se,assetTypes:ie}=this.state;return{filters:[{criteria:A,pageNumber:W,pageSize:x,sortBy:K,sortOrder:Q}],assetTypes:ie,flags:se}}get searchText(){const A=this.state.criteria.filter(W=>W.filterType===n.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(N,A){const W=(N||[]).filter(x=>x.statisticName===A)[0];return W?W.value:0}function U(N){const A="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(x=>x.assetType.indexOf(A)===0).reduce((x,K)=>{const Q=le(N,K.assetType);return Q&&x.push([K.assetType.substring(A.length),Q]),x},[])}function G(N){if(N.properties){const A=N.properties.filter(K=>K.key===a.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=A.filter(K=>W.test(K.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return le(N,a.Repository)}function ee(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ce(N){const A=le(N,a.Icon);if(A)return A;const W=C.DefaultIconPath;return{uri:W,fallbackUri:W}}function le(N,A){return N.files.filter(x=>x.assetType===A)[0]?{uri:`${N.assetUri}/${A}`,fallbackUri:`${N.fallbackAssetUri}/${A}`}:null}function ne(N,A){const W=N.properties?N.properties.filter(K=>K.key===A):[],x=W.length>0&&W[0].value;return x?x.split(",").map(K=>(0,f.adoptToGalleryExtensionId)(K)):[]}function he(N){const A=N.properties?N.properties.filter(W=>W.key===m.Engine):[];return A.length>0&&A[0].value||""}function B(N){const A=N.properties?N.properties.filter(x=>x.key===m.LocalizedLanguages):[],W=A.length>0&&A[0].value||"";return W?W.split(","):[]}function q(N){return N.indexOf("preview")!==-1}function re(N){return N.targetPlatform?(0,C.toTargetPlatform)(N.targetPlatform):"undefined"}function M(N){const A=(0,L.distinct)(N.versions.map(re)),W=!!N.tags?.includes(C.WEB_EXTENSION_TAG),x=A.indexOf("web");return W?x===-1&&A.push("web"):x!==-1&&A.splice(x,1),A}function k(N,A){const W=(0,C.getFallbackTargetPlarforms)(A);for(let x=0;x<N.length;x++){const K=N[x];if(K.version===N[x-1]?.version){let Q=x;const se=re(K);if(se===A)for(;Q>0&&N[Q-1].version===K.version;)Q--;else if(W.includes(se))for(;Q>0&&N[Q-1].version===K.version&&re(N[Q-1])!==A;)Q--;Q!==x&&(N.splice(x,1),N.splice(Q,0,K))}}return N}t.sortExtensionVersions=k;function j(N,A,W,x,K){const Q=M(N);let se=N.versions[0];return se=N.versions.find(ie=>ie.version===se.version&&(0,C.isTargetPlatformCompatible)(re(ie),Q,K))||se,H(N,se,Q,A,W,x)}function H(N,A,W,x,K,Q){const se={manifest:le(A,a.Manifest),readme:le(A,a.Details),changelog:le(A,a.Changelog),license:le(A,a.License),repository:G(A),download:ee(A),icon:ce(A),coreTranslations:U(A)};return{identifier:{id:(0,f.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:A.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,description:N.shortDescription||"",installCount:O(N.statistics,"install"),rating:O(N.statistics,"averagerating"),ratingCount:O(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:W,assets:se,properties:{dependencies:ne(A,m.Dependency),extensionPack:ne(A,m.ExtensionPack),engine:he(A),localizedLanguages:B(A),targetPlatform:re(A)},preview:q(N.flags),telemetryData:{index:(K.pageNumber-1)*K.pageSize+x,querySource:Q}}}let te=class{constructor(A,W,x,K,Q,se,ie,me){this.requestService=W,this.logService=x,this.environmentService=K,this.telemetryService=Q,this.fileService=se,this.productService=ie,this.configurationService=me;const ye=ie.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=_(ie.version,ie,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,W){const x=[];let K=new P().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,A.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...A.map(({id:se})=>se.toLowerCase()));A.every(se=>!se.version)&&(K=K.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(K,e,I.CancellationToken.None);for(let se=0;se<Q.length;se++){const ie=Q[se];if(!ie.versions.length)continue;const me=(0,f.getGalleryExtensionId)(ie.publisher.publisherName,ie.extensionName),ye=A.find(ue=>(0,f.areSameExtensions)(ue,{id:me}))?.version;if(ye){const ue=ie.versions.find(Ie=>Ie.version===ye);ue&&x.push(H(ie,ue,M(ie),se,K))}else x.push(j(ie,se,K,void 0,e))}return x}async getCompatibleExtension(A,W){const x=(0,C.isIExtensionIdentifier)(A)?null:A;if(x){if((0,C.isNotWebExtensionInWebTargetPlatform)(x.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(x,W))return x}const{id:K,uuid:Q}=x?x.identifier:A;let se=new P().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(n.ExtensionId,Q):se=se.withFilter(n.ExtensionName,K);const{galleryExtensions:ie}=await this.queryGallery(se,W,I.CancellationToken.None),[me]=ie;if(!me||!me.versions.length)return null;const ye=M(me);if((0,C.isNotWebExtensionInWebTargetPlatform)(ye,W))return null;for(let ue of me.versions){if(!he(ue)){const Ie=await this.getEngine(ue);ue={...ue,properties:[...ue.properties||[],{key:m.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ue,ye,W))return H(me,ue,ye,0,se)}return null}async isExtensionCompatible(A,W){if(!(0,C.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,W))return!1;let x=A.properties.engine;if(!x){const K=await this.getManifest(A,I.CancellationToken.None);if(!K)throw new Error("Manifest was not found");x=K.engines.vscode}return(0,S.isEngineValid)(x,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,W,x){if(!(0,C.isTargetPlatformCompatible)(re(A),W,x))return!1;const K=await this.getEngine(A);return(0,S.isEngineValid)(K,this.productService.version,this.productService.date)}async query(A,W){const x=I.CancellationToken.isCancellationToken(A)?{}:A,K=I.CancellationToken.isCancellationToken(A)?A:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=x.text||"";const se=(0,D.getOrDefault)(x,ve=>ve.pageSize,50);let ie=new P().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,se).withFilter(n.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Category,Fe||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,Ee,Fe)=>(ie=ie.withFilter(n.Tag,Fe||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(n.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),ie=ie.withFilter(n.SearchText,Q)),ie=ie.withSortBy(0)):x.ids?ie=ie.withFilter(n.ExtensionId,...x.ids):x.names?ie=ie.withFilter(n.ExtensionName,...x.names):ie=ie.withSortBy(4),typeof x.sortBy=="number"&&(ie=ie.withSortBy(x.sortBy)),typeof x.sortOrder=="number"&&(ie=ie.withSortOrder(x.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(ie,e,K),ue=me.map((ve,Ee)=>j(ve,Ee,ie,x.source,e)),Ie=async(ve,Ee)=>{if(Ee.isCancellationRequested)throw(0,b.canceled)();const Fe=ie.withPage(ve+1),{galleryExtensions:Me}=await this.queryGallery(Fe,e,Ee);return Me.map((ze,xe)=>j(ze,xe,Fe,x.source,e))};return{firstPage:ue,total:ye,pageSize:ie.pageSize,getPage:Ie}}async queryGallery(A,W,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,r.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,i(r.Unpublished));const K=await this.commonHeadersPromise,Q=JSON.stringify(A.raw),se={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},ie=new Date().getTime();let me,ye,ue=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},x),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:ue};const Ie=await(0,g.asJson)(me);if(Ie){const ve=Ie.results[0],Ee=ve.extensions;Ee.forEach(Me=>k(Me.versions,W));const Fe=ve.resultMetadata&&ve.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return ue=Fe&&Fe.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:ue}}return{galleryExtensions:[],total:ue}}catch(Ie){throw ye=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-ie,success:!!me&&(0,g.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,b.isPromiseCanceledError)(ye)?"canceled":(0,b.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(A,W,x,K){if(!this.isEnabled())return;const Q=T.isWeb?this.api(`/itemName/${A}.${W}/version/${x}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${W}/${x}/stats?statType=${K}`),se=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},I.CancellationToken.None)}catch(ye){}}async download(A,W,x){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const K=(0,f.getGalleryExtensionTelemetryData)(A),Q=new Date().getTime(),se=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...K,duration:ue}),ie=x===1?"install":x===2?"update":"",me=ie?{uri:`${A.assets.download.uri}${c.URI.parse(A.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${A.assets.download.fallbackUri}${c.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:A.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(W,ye.stream),se(new Date().getTime()-Q)}async getReadme(A,W){if(A.assets.readme){const x=await this.getAsset(A.assets.readme,{},W);return await(0,g.asText)(x)||""}return""}async getManifest(A,W){if(A.assets.manifest){const x=await this.getAsset(A.assets.manifest,{},W),K=await(0,g.asText)(x);return K?JSON.parse(K):null}return null}async getManifestFromRawExtensionVersion(A,W){const x=le(A,a.Manifest);if(!x)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},Q=await this.getAsset(x,{headers:K});return await(0,g.asJson)(Q)}async getCoreTranslation(A,W){const x=A.assets.coreTranslations.filter(K=>K[0]===W.toUpperCase())[0];if(x){const K=await this.getAsset(x[1]),Q=await(0,g.asText)(K);return Q?JSON.parse(Q):null}return null}async getChangelog(A,W){if(A.assets.changelog){const x=await this.getAsset(A.assets.changelog,{},W);return await(0,g.asText)(x)||""}return""}async getAllCompatibleVersions(A,W){let x=new P().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?x=x.withFilter(n.ExtensionId,A.identifier.uuid):x=x.withFilter(n.ExtensionName,A.identifier.id);const{galleryExtensions:K}=await this.queryGallery(x,W,I.CancellationToken.None);if(!K.length)return[];const Q=M(K[0]);if((0,C.isNotWebExtensionInWebTargetPlatform)(Q,W))return[];const se=[];for(const ie of K[0].versions)try{se[se.length-1]?.version!==ie.version&&await this.isRawExtensionVersionCompatible(ie,Q,W)&&se.push({version:ie.version,date:ie.lastUpdated})}catch(me){}return se}async getAsset(A,W={},x=I.CancellationToken.None){const K=await this.commonHeadersPromise,Q={type:"GET"},se={...K,...W.headers||{}};W={...W,...Q,headers:se};const ie=A.uri,me=A.fallbackUri,ye={...W,url:ie};try{const ue=await this.requestService.request(ye,x);if(ue.res.statusCode===200)return ue;const Ie=await(0,g.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${Ie}`)}catch(ue){if((0,b.isPromiseCanceledError)(ue))throw ue;const Ie=(0,b.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ie,message:Ie});const ve={...W,url:me};return this.requestService.request(ve,x)}}async getEngine(A){let W=he(A);if(!W){const x=await this.getManifestFromRawExtensionVersion(A,I.CancellationToken.None);if(!x)throw new Error("Manifest was not found");W=x.engines.vscode}return W}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},I.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,g.asJson)(A),x=new Map;if(W)for(const K of W.malicious){const Q=x.get(K)||{id:{id:K},malicious:!0,slow:!1};Q.malicious=!0,x.set(K,Q)}return[...x.values()]}};te=de([oe(1,g.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,l.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],te);let X=class extends te{constructor(A,W,x,K,Q,se,ie,me){super(A,W,x,K,Q,se,ie,me)}};X=de([oe(0,u.IStorageService),oe(1,g.IRequestService),oe(2,h.ILogService),oe(3,p.IEnvironmentService),oe(4,s.ITelemetryService),oe(5,l.IFileService),oe(6,v.IProductService),oe(7,d.IConfigurationService)],X),t.ExtensionGalleryService=X;let Z=class extends te{constructor(A,W,x,K,Q,se,ie){super(void 0,A,W,x,K,Q,se,ie)}};Z=de([oe(0,g.IRequestService),oe(1,h.ILogService),oe(2,p.IEnvironmentService),oe(3,s.ITelemetryService),oe(4,l.IFileService),oe(5,v.IProductService),oe(6,d.IConfigurationService)],Z),t.ExtensionGalleryServiceWithNoStorageService=Z;async function _(N,A,W,x,K,Q){const se={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},ie=await(0,E.getServiceMachineId)(W,K,Q);return(0,o.supportsTelemetry)(A,W)&&(0,o.getTelemetryLevel)(x)===3&&(se["X-Market-User-Id"]=ie),se}t.resolveMarketplaceHeaders=_}),define(J[121],Y([0,1,2,18,12,27,86,26,33,122,25,30,36]),function(z,t,L,I,b,D,T,w,c,d,p,C,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let S=class{constructor(v,g){this._configurationService=g,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const u=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(v,g){this._experimentProperties[v]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let g=v.sessionID,E=v["common.instanceId"],u=v["common.machineId"],s=v["common.firstSessionDate"],o=v["common.msftInternal"];return{sessionId:g,instanceId:E,machineId:u,firstSessionDate:s,msftInternal:o}}dispose(){this._disposables.dispose()}_log(v,g,E,u){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(s=>{E=(0,I.mixin)(E,s),E=(0,I.mixin)(E,this._experimentProperties),E=(0,I.cloneAndChange)(E,o=>{if(typeof o=="string")return this._cleanupInfo(o,u)}),this._appenders.forEach(o=>o.log(v,E))},s=>{console.error(s)})}publicLog(v,g,E){return this._log(v,3,g,E)}publicLog2(v,g,E){return this.publicLog(v,g,E)}publicLogError(v,g){return this.sendErrorTelemetry?this._log(v,2,g,!0):Promise.resolve(void 0)}publicLogError2(v,g){return this.publicLogError(v,g)}_anonymizeFilePaths(v){let g=v;const E=[];for(let e of this._cleanupPatterns)for(;;){const r=e.exec(v);if(!r)break;E.push([r.index,e.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(g="";;){const e=s.exec(v);if(!e)break;!u.test(e[0])&&E.every(([r,i])=>e.index<r||e.index>=i)&&(g+=v.substring(o,e.index)+"<REDACTED: user-file-path>",o=s.lastIndex)}return o<v.length&&(g+=v.substr(o)),g}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const g=v.toLowerCase(),E=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(g)?"<REDACTED: secret>":E.test(g)?"<REDACTED: email>":v}_cleanupInfo(v,g){let E=v;g&&(E=this._anonymizeFilePaths(E));for(let u of this._cleanupPatterns)E=E.replace(u,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([oe(1,w.IConfigurationService)],S),t.TelemetryService=S;function l(){const h=(0,T.localize)(0,null,d.default.nameLong),v=d.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=b.isWeb?"":(0,T.localize)(3,null),E=(0,T.localize)(4,null),u=(0,T.localize)(5,null),s=(0,T.localize)(6,null),o=(0,T.localize)(7,null),e=`
|       | ${E} | ${u} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,T.localize)(8,null);return`
${h} ${v} ${g}

&nbsp;

${o}
${e}

&nbsp;

${r}
`}p.Registry.as(c.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:l(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.Registry.as(c.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,T.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,T.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Y([0,1,7,18,36]),function(z,t,L,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function D(w,c){const d=await new Promise((C,f)=>{z(["applicationinsights"],C,f)});let p;return d.defaultClient?(p=new d.TelemetryClient(w),p.channel.setUseDiskRetryCaching(!0)):(d.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),p=d.defaultClient),w.indexOf("AIF-")===0&&(p.config.endpointUrl=c?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),p}class T{constructor(c,d,p,C,f){this._eventPrefix=c,this._defaultData=d,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof p=="function"?this._aiClient=p():this._aiClient=p,this._asyncAIClient=null}_withAIClient(c){if(!!this._aiClient){if(typeof this._aiClient!="string"){c(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(d=>{c(d)},d=>{(0,L.onUnexpectedError)(d),console.error(d)})}}log(c,d){!this._aiClient||(d=(0,I.mixin)(d,this._defaultData),d=(0,b.validateTelemetryData)(d),this.testCollector&&(d.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(p=>p.trackEvent({name:this._eventPrefix+"/"+c,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(c=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,c(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=T}),define(J[124],Y([0,1,6,13]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function b(D,T){const w=Object.create(null),c=(p,C)=>{const f=JSON.parse(p);w[C]=f};if(T){const p=[],C=await I.Promises.readdir(T);for(const S of C)try{(await I.Promises.stat((0,L.join)(T,S))).isDirectory()&&p.push(S)}catch{}const f=[];for(const S of p)(await I.Promises.readdir((0,L.join)(T,S))).filter(h=>h==="telemetry.json").length===1&&f.push(S);for(const S of f){const l=(await I.Promises.readFile((0,L.join)(T,S,"telemetry.json"))).toString();c(l,S)}}let d=(await I.Promises.readFile((0,L.join)(D,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await I.Promises.readFile((0,L.join)(D,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(w,null,4)}t.buildTelemetryMessage=b}),define(J[37],Y([0,1,14]),function(z,t,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(J[125],Y([0,1,10,2,8,21,23,16,15,37]),function(z,t,L,I,b,D,T,w,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let p=class extends I.Disposable{constructor(f,S,l,h,v){super();this.extensionsManagementService=f,this.logService=h,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(E=>this.onInstallExtension(E))),this._register(f.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(f.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const g=b.URI.file(l.extensionsPath);this._register(S.watch(g)),this._register(L.Event.filter(S.onDidChangeFilesRaw,E=>E.changes.some(u=>this.doesChangeAffects(u,g)))(()=>this.onDidChange()))}doesChangeAffects(f,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),S)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const S of f)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(S=>!(0,T.areSameExtensions)(S,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,T.areSameExtensions)(S,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),S=f.filter(h=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,h.identifier))?!1:h.installedTimestamp&&h.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",h.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",h.identifier.id),!1)),l=this.installedExtensions.filter(h=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,h))?!1:f.every(v=>!(0,T.areSameExtensions)(v.identifier,h))?(this.logService.info("Detected extension removed from another source",h.id),!0):!1);this.installedExtensions=f.map(h=>h.identifier),(S.length||l.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:l})}}};p=de([oe(1,w.IFileService),oe(2,D.INativeEnvironmentService),oe(3,c.ILogService),oe(4,d.IUriIdentityService)],p),t.ExtensionsWatcher=p}),define(J[126],Y([0,1,37,91,16,19,59,10,2]),function(z,t,L,I,b,D,T,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(f){this.uri=f,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let p=class{constructor(f){this._fileService=f,this._dispooables=new c.DisposableStore,this._limit=2**16;const S=new Map,l=h=>{let v=S.get(h.scheme);return v===void 0&&(v=f.hasProvider(h)&&!this._fileService.hasCapability(h,1024),S.set(h.scheme,v)),v};this._dispooables.add(w.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(h=>{S.delete(h.scheme)})),this.extUri=new D.ExtUri(l),this._canonicalUris=new T.SkipList((h,v)=>this.extUri.compare(h,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,D.normalizePath)(f));let S=this._canonicalUris.get(f);return S?S.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new d(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((l,h)=>l[1].touch<h[1].touch?1:l[1].touch>h[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let l=0;l<S;l++)this._canonicalUris.set(f[l][0],f[l][1].touch())}};p=de([oe(0,b.IFileService)],p),t.UriIdentityService=p,(0,I.registerSingleton)(L.IUriIdentityService,p,!0)}),define(J[45],Y([0,1,48,3,6,11,13,72,138,139]),function(z,t,L,I,b,D,T,w,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class p extends Error{constructor(e,r){let i=r.message;switch(e){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=e,this.cause=r}}t.ExtractError=p;function C(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>e&r).reduce((r,i)=>r+i,e&61440)}function f(o){if(o instanceof p)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new p(e,o)}function S(o,e,r,i,n,a){const m=b.dirname(e),y=b.join(i,m);if(!y.startsWith(i))return Promise.reject(new Error(w.localize(0,null,e)));const R=b.join(i,e);let P;return a.onCancellationRequested(()=>{P&&P.destroy()}),Promise.resolve(T.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((O,U)=>{if(!a.isCancellationRequested)try{P=(0,L.createWriteStream)(R,{mode:r}),P.once("close",()=>O()),P.once("error",U),o.once("error",U),o.pipe(P)}catch(G){U(G)}}))}function l(o,e,r,i){let n=(0,I.createCancelablePromise)(()=>Promise.resolve()),a=0;return i.onCancellationRequested(()=>{n.cancel(),o.close()}),new Promise((m,y)=>{const R=new I.Sequencer,P=O=>{O.isCancellationRequested||(a++,o.readEntry())};o.once("error",y),o.once("close",()=>n.then(()=>{i.isCancellationRequested||o.entryCount===a?m():y(new p("Incomplete",new Error(w.localize(1,null,a,o.entryCount))))},y)),o.readEntry(),o.on("entry",O=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(O.fileName)){P(i);return}const U=O.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const ce=b.join(e,U);n=(0,I.createCancelablePromise)(le=>T.Promises.mkdir(ce,{recursive:!0}).then(()=>P(le)).then(void 0,y));return}const G=v(o,O),ee=C(O);n=(0,I.createCancelablePromise)(ce=>R.queue(()=>G.then(le=>S(le,U,ee,e,r,ce).then(()=>P(ce)))).then(null,y))})})}function h(o,e=!1){return new Promise((r,i)=>{(0,c.open)(o,e?{lazyEntries:!0}:void 0,(n,a)=>{n?i(f(n)):r((0,D.assertIsDefined)(a))})})}function v(o,e){return new Promise((r,i)=>{o.openReadStream(e,(n,a)=>{n?i(f(n)):r((0,D.assertIsDefined)(a))})})}function g(o,e){return new Promise((r,i)=>{const n=new d.ZipFile;e.forEach(m=>{m.contents?n.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&n.addFile(m.localPath,m.path)}),n.end();const a=(0,L.createWriteStream)(o);n.outputStream.pipe(a),n.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>r(o))})}t.zip=g;function E(o,e,r={},i){const n=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let a=h(o,!0);return r.overwrite&&(a=a.then(m=>T.Promises.rm(e).then(()=>m))),a.then(m=>l(m,e,{sourcePathRegex:n},i))}t.extract=E;function u(o,e){return h(o).then(r=>new Promise((i,n)=>{r.on("entry",a=>{a.fileName===e&&v(r,a).then(m=>i(m),m=>n(m))}),r.once("close",()=>n(new Error(w.localize(2,null,e))))}))}function s(o,e){return u(o,e).then(r=>new Promise((i,n)=>{const a=[];r.once("error",n),r.on("data",m=>a.push(m)),r.on("end",()=>i(Buffer.concat(a)))}))}t.buffer=s}),define(J[127],Y([0,1,45,79]),function(z,t,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function b(D){return(0,L.buffer)(D,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch(w){throw new Error((0,I.localize)(0,null))}})}t.getManifest=b}),define(J[128],Y([0,1,20,3,7,2,9,6,12,19,43,8,31,13,45,80,21,22,23,90,16,15,32]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g,E,u,s,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let r=class extends D.Disposable{constructor(n,a,m,y,R){super();this.beforeRemovingExtension=n,this.fileService=a,this.logService=m,this.environmentService=y,this.productService=R,this._devSystemExtensionsPath=null,this.systemExtensionsPath=y.builtinExtensionsPath,this.extensionsPath=y.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new I.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const a=[];(n===null||n===0)&&a.push(this.scanSystemExtensions().then(null,m=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(m).message,g.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&a.push(this.scanUserExtensions(!0).then(null,m=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(m).message,g.ExtensionManagementErrorCode.Internal))));try{const m=await Promise.all(a);return(0,L.flatten)(m)}catch(m){throw this.joinErrors(m)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[a,m]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return m=m.filter(y=>!a[new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).key()]),n&&(m=(0,E.groupByExtension)(m,R=>R.identifier).map(R=>R.sort((P,O)=>p.rcompare(P.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",m.length),m}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,a,m,y){const R=n.key(),P=w.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),O=w.join(this.extensionsPath,R);try{await S.Promises.rm(O)}catch(G){try{await S.Promises.rm(O)}catch(ee){}throw new g.ExtensionManagementError((0,h.localize)(0,null,O,n.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,a,P,y);let U=await this.scanExtension(C.URI.file(P),1);if(!U)throw new Error((0,h.localize)(1,null,P));await this.storeMetadata(U,{...m,installedTimestamp:Date.now()});try{await this.rename(n,P,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(G){try{await S.Promises.rm(P)}catch(ee){}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(G)}. Deleted from extracted location`,P),G}try{U=await this.scanExtension(C.URI.file(O),1)}catch(G){}if(U)return U;throw new Error((0,h.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,a){return this.setMetadata(n,a),await this.storeMetadata(n,{...a,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,a){a.isMachineScoped=a.isMachineScoped||void 0,a.isBuiltin=a.isBuiltin||void 0,a.installedTimestamp=a.installedTimestamp||void 0;const m=w.join(n.location.fsPath,"package.json"),y=await S.Promises.readFile(m,"utf8"),{manifest:R}=await this.parseManifest(y);return R.__metadata=a,await S.Promises.writeFile(m,JSON.stringify(R,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const a=n.map(m=>new E.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version));await this.withUninstalledExtensions(m=>{a.forEach(y=>m[y.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(y=>delete y[n.key()]);const m=(await this.scanExtensions(1)).find(y=>new E.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(n))||null;return m?(await this.storeMetadata(m,{installedTimestamp:Date.now()}),this.scanExtension(m.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let a;try{a=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(y){if(y.code!=="ENOENT")throw y}let m={};if(a)try{m=JSON.parse(a)}catch(y){}return n&&(n(m),Object.keys(m).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(m)):await S.Promises.rm(this.uninstalledPath)),m})}async removeExtension(n,a){this.logService.trace(`Deleting ${a} extension from disk`,n.identifier.id,n.location.fsPath),await S.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(a=>delete a[new E.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,a,m,y){this.logService.trace(`Started extracting the extension from ${a} to ${m}`);try{await S.Promises.rm(m)}catch(R){throw new g.ExtensionManagementError(this.joinErrors(R).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,l.extract)(a,m,{sourcePath:"extension",overwrite:!0},y),this.logService.info(`Extracted extension to ${m}:`,n.id)}catch(R){try{await S.Promises.rm(m)}catch(O){}let P=g.ExtensionManagementErrorCode.Extract;throw R instanceof l.ExtractError&&(R.type==="CorruptZip"?P=g.ExtensionManagementErrorCode.CorruptZip:R.type==="Incomplete"&&(P=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(R.message,P)}}async rename(n,a,m,y){try{await S.Promises.rename(a,m)}catch(R){if(c.isWindows&&R&&R.code==="EPERM"&&Date.now()<y)return this.logService.info(`Failed renaming ${a} to ${m} with 'EPERM' error. Trying again...`,n.id),this.rename(n,a,m,y);throw new g.ExtensionManagementError(R.message||(0,h.localize)(3,null,a,m),R.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const a=this.scanDevSystemExtensions(),[m,y]=await Promise.all([n,a]);return[...m,...y]}async scanExtensionsInDir(n,a){const m=new I.Limiter(10),y=await this.fileService.resolve(C.URI.file(n));return y.children?(await Promise.all(y.children.filter(P=>P.isDirectory).map(P=>m.queue(async()=>a===1&&(0,d.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,a))))).filter(P=>P&&P.identifier):[]}async scanExtension(n,a){try{const m=await this.fileService.resolve(n);if(m.children){const{manifest:y,metadata:R}=await this.readManifest(n.fsPath),P=m.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,O=m.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,U={id:(0,E.getGalleryExtensionId)(y.publisher,y.name)},G={type:a,identifier:U,manifest:y,location:n,readmeUrl:P,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:a===0};return R&&(this.setMetadata(G,R),G.installedTimestamp=R.installedTimestamp),G}}catch(m){a!==0&&this.logService.trace(m)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const a=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",a.length),a.filter(m=>n.some(y=>(0,E.areSameExtensions)(m.identifier,{id:y})))}else return[]}setMetadata(n,a){n.publisherDisplayName=a.publisherDisplayName||null,n.publisherId=a.publisherId||null,n.identifier.uuid=a.id,n.isMachineScoped=!!a.isMachineScoped,n.isBuiltin=n.type===0||!!a.isBuiltin}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),a=await this.scanAllUserExtensions(),m=new Set;for(const P of a)n[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||m.add(P.identifier.id.toLowerCase());const y=(0,E.groupByExtension)(a,P=>P.identifier);await I.Promises.settled(y.map(async P=>{const O=P.sort((U,G)=>p.rcompare(U.manifest.version,G.manifest.version))[0];m.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const R=a.filter(P=>n[new E.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await I.Promises.settled(R.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),a=[],m=(0,E.groupByExtension)(n,y=>y.identifier);a.push(...(0,L.flatten)(m.map(y=>y.sort((R,P)=>p.rcompare(R.manifest.version,P.manifest.version)).slice(1)))),await I.Promises.settled(a.map(y=>this.removeExtension(y,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const a=Array.isArray(n)?n:[n];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((m,y)=>new Error(`${m.message}${m.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(T.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const a=[S.Promises.readFile(w.join(n,"package.json"),"utf8").then(P=>this.parseManifest(P)),S.Promises.readFile(w.join(n,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:m,metadata:y},R]=await Promise.all(a);return{manifest:(0,u.localizeManifest)(m,R),metadata:y}}parseManifest(n){return new Promise((a,m)=>{try{const y=JSON.parse(n),R=y.__metadata||null;a({manifest:y,metadata:R})}catch(y){m(new Error((0,h.localize)(4,null)))}})}};r=de([oe(1,s.IFileService),oe(2,o.ILogService),oe(3,v.INativeEnvironmentService),oe(4,e.IProductService)],r),t.ExtensionsScanner=r}),define(J[129],Y([0,1,28,7,9,6,12,29,19,43,8,31,13,45,78,52,21,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g,E,u,s,o,e,r,i,n,a,m,y,R,P,O,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let G=class extends g.AbstractExtensionManagementService{constructor(B,q,re,M,k,j,H,te,X){super(B,q,re,te);this.environmentService=M,this.downloadService=k,this.fileService=H;const Z=this._register(j.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(i.ExtensionsScanner,N=>Z.postUninstall(N))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(s.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,H,M,re,X));this._register(_.onDidChangeExtensionsByAnotherSource(({added:N,removed:A})=>{N.length&&this._onDidInstallExtensions.fire(N.map(W=>({identifier:W.identifier,operation:0,local:W}))),A.forEach(W=>this._onDidUninstallExtension.fire({identifier:W}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const B=await this.isAlpineLinux(),q=(0,E.getTargetPlatform)(B?"alpine":T.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let B;try{B=(await this.fileService.readFile(p.URI.file("/etc/os-release"))).value.toString()}catch(q){try{B=(await this.fileService.readFile(p.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,I.getErrorMessage)(re))}}return!!B&&(B.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(B){this.logService.trace("ExtensionManagementService#zip",B.identifier.id);const q=await this.collectFiles(B),re=await(0,S.zip)((0,c.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,q);return p.URI.file(re)}async unzip(B){return this.logService.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const q=await this.downloadVsix(B),re=D.resolve(q.fsPath);return(0,e.getManifest)(re)}getInstalled(B=null){return this.extensionsScanner.scanExtensions(B)}async install(B,q={}){this.logService.trace("ExtensionManagementService#install",B.toString());const re=await this.downloadVsix(B),M=await(0,e.getManifest)(D.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,a.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(l.localize(0,null,(0,u.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,q)}async updateMetadata(B,q){return this.logService.trace("ExtensionManagementService#updateMetadata",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),B}async updateExtensionScope(B,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",B.identifier.id),B=await this.extensionsScanner.saveMetadataForLocalExtension(B,{...B.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),B}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(B){if(B.scheme===b.Schemas.file)return B;const q=(0,c.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(B,q),q}createInstallExtensionTask(B,q,re){return p.URI.isUri(q)?new le(B,q,re,this.galleryService,this.extensionsScanner,this.logService):new ce(q,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(B,q){return new ne(B,q,this.extensionsScanner)}async collectFiles(B){const q=async M=>{let k=await f.Promises.readdir(M);k=k.map(te=>D.join(M,te));const j=await Promise.all(k.map(te=>f.Promises.stat(te)));let H=Promise.resolve([]);return j.forEach((te,X)=>{const Z=k[X];te.isFile()&&(H=H.then(_=>[..._,Z])),te.isDirectory()&&(H=H.then(_=>q(Z).then(N=>[..._,...N])))}),H};return(await q(B.location.fsPath)).map(M=>({path:`extension/${D.relative(B.location.fsPath,M)}`,localPath:M}))}};G=de([oe(0,E.IExtensionGalleryService),oe(1,O.ITelemetryService),oe(2,R.ILogService),oe(3,v.INativeEnvironmentService),oe(4,h.IDownloadService),oe(5,y.IInstantiationService),oe(6,m.IFileService),oe(7,P.IProductService),oe(8,U.IUriIdentityService)],G),t.ExtensionManagementService=G;class ee extends g.AbstractExtensionTask{constructor(B,q,re,M){super();this.identifier=B,this.source=q,this.extensionsScanner=re,this.logService=M,this._operation=1}get operation(){return this._operation}async installExtension(B,q){try{const re=await this.unsetUninstalledAndGetLocal(B.identifierWithVersion);if(re)return B.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,B.metadata):re}catch(re){throw T.isMacintosh?new E.ExtensionManagementError(l.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(l.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(B,q)}async unsetUninstalledAndGetLocal(B){if(!await this.isUninstalled(B))return null;this.logService.trace("Removing the extension from uninstalled list:",B.id);const re=await this.extensionsScanner.setInstalled(B);return this.logService.info("Removed the extension from uninstalled list:",B.id),re}async isUninstalled(B){return!!(await this.extensionsScanner.getUninstalledExtensions())[B.key()]}async extract({zipPath:B,identifierWithVersion:q,metadata:re},M){let k=await this.extensionsScanner.extractUserExtension(q,B,re,M);return this.logService.info("Extracting completed.",q.id),k}}class ce extends ee{constructor(B,q,re,M,k){super(B.identifier,B,M,k);this.gallery=B,this.options=q,this.extensionsDownloader=re}async doRun(B){const re=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,u.areSameExtensions)(k.identifier,this.gallery.identifier));re&&(this._operation=2);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin;try{const k=await this.installExtension(M,B);return re&&d.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(B){try{await this.extensionsDownloader.delete(p.URI.file(B))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",B.toString(),(0,I.getErrorMessage)(q))}}async downloadInstallableExtension(B,q){const re={id:B.identifier.uuid,publisherId:B.publisherId,publisherDisplayName:B.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",B.identifier.id),M=(await this.extensionsDownloader.downloadExtension(B,q)).fsPath,this.logService.info("Downloaded extension:",B.identifier.id,M)}catch(k){throw new E.ExtensionManagementError((0,g.joinErrors)(k).message,E.ExtensionManagementErrorCode.Download)}try{const k=await(0,e.getManifest)(M);return{zipPath:M,identifierWithVersion:new u.ExtensionIdentifierWithVersion(B.identifier,k.version),metadata:re}}catch(k){throw await this.deleteDownloadedVSIX(M),new E.ExtensionManagementError((0,g.joinErrors)(k).message,E.ExtensionManagementErrorCode.Invalid)}}}class le extends ee{constructor(B,q,re,M,k,j){super({id:(0,u.getGalleryExtensionId)(B.publisher,B.name)},q,k,j);this.manifest=B,this.location=q,this.options=re,this.galleryService=M}async doRun(B){const q=new u.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,B);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=2,q.equals(new u.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(j){throw new Error(l.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal(q);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(H){throw new Error(l.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:q,metadata:k},B)}async getMetadata(B,q){try{const re=(await this.galleryService.query({names:[B],pageSize:1},q)).firstPage[0];if(re)return{id:re.identifier.uuid,publisherDisplayName:re.publisherDisplayName,publisherId:re.publisherId}}catch(re){}return{}}}class ne extends g.AbstractExtensionTask{constructor(B,q,re){super();this.extension=B,this.options=q,this.extensionsScanner=re}async doRun(B){const q=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new u.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...re.filter(k=>M.equals(new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else q.push(...re.filter(M=>(0,u.areSameExtensions)(M.identifier,this.extension.identifier)));if(!q.length)throw new Error(l.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const M of q)try{B.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(l.localize(6,null,(0,L.toErrorMessage)(k)))}}}}),define(J[130],Y([0,1,115,3,17,7,2,11,26,21,93,15,114,140]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let l=class extends T.Disposable{constructor(v,g,E){super();this.environmentService=g,this.logService=E,this.configure(v.getValue()),this._register(v.onDidChangeConfiguration(()=>this.configure(v.getValue()),this))}configure(v){this.proxyUrl=v.http&&v.http.proxy,this.strictSSL=!!(v.http&&v.http.proxyStrictSSL),this.authorization=v.http&&v.http.proxyAuthorization}async request(v,g){this.logService.trace("RequestService#request",v.url);const{proxyUrl:E,strictSSL:u}=this;let s;try{s=await(0,p.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.logService.error("RequestService#request resolving shell environment failed",r)}const o={...process.env,...s},e=v.agent?v.agent:await(0,f.getProxyAgent)(v.url||"",o,{proxyUrl:E,strictSSL:u});return v.agent=e,v.strictSSL=u,this.authorization&&(v.headers={...v.headers||{},"Proxy-Authorization":this.authorization}),this._request(v,g)}async getNodeRequest(v){return((0,L.parse)(v.url).protocol==="https:"?await new Promise((u,s)=>{z(["https"],u,s)}):await new Promise((u,s)=>{z(["http"],u,s)})).request}_request(v,g){return I.Promises.withAsyncBody(async(E,u)=>{let s;const o=(0,L.parse)(v.url),e=v.getRawRequest?v.getRawRequest(v):await this.getNodeRequest(v),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:v.type||"GET",headers:v.headers,agent:v.agent,rejectUnauthorized:(0,w.isBoolean)(v.strictSSL)?v.strictSSL:!0};v.user&&v.password&&(r.auth=v.user+":"+v.password),s=e(r,i=>{const n=(0,w.isNumber)(v.followRedirects)?v.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...v,url:i.headers.location,followRedirects:n-1},g).then(E,u);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,S.createGunzip)())),E({res:i,stream:(0,b.streamToBufferReadableStream)(a)})}}),s.on("error",u),v.timeout&&s.setTimeout(v.timeout),v.data&&typeof v.data=="string"&&s.write(v.data),s.end(),g.onCancellationRequested(()=>{s.abort(),u((0,D.canceled)())})})}async resolveProxy(v){}};l=de([oe(0,c.IConfigurationService),oe(1,d.INativeEnvironmentService),oe(2,C.ILogService)],l),t.RequestService=l}),define(J[141],Y([0,1,34,3,17,28,7,2,9,6,29,8,13,26,107,52,113,21,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(z,t,L,I,b,D,T,w,c,d,p,C,f,S,l,h,v,g,E,u,s,o,e,r,i,n,a,m,y,R,P,O,U,G,ee,ce,le,ne,he,B,q,re,M,k,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async N=>{const A=N.get(O.ILogService),W=N.get(r.IFileService),x=N.get(g.INativeEnvironmentService),K=N.get(s.IExtensionManagementCLIService);A.info("CLI main",this.argv),this.registerErrorHandler(A),await this.doRun(x,K,W),await Promise.all(_.map(Q=>{(0,I.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const Z=new y.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const N=new E.NativeEnvironmentService(this.argv,_);Z.set(g.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(me=>me?f.Promises.mkdir(me,{recursive:!0}):void 0));const A=(0,O.getLogLevel)(N),W=[];W.push(new U.SpdLogLogger("cli",(0,d.join)(N.logsPath,"cli.log"),!0,A)),A===O.LogLevel.Trace&&W.push(new O.ConsoleLogger(A));const x=this._register(new O.MultiplexLogService(W));Z.set(O.ILogService,x);const K=this._register(new i.FileService(x));Z.set(r.IFileService,K);const Q=this._register(new n.DiskFileSystemProvider(x));K.registerProvider(c.Schemas.file,Q);const se=this._register(new l.ConfigurationService(N.settingsResource,K));Z.set(S.IConfigurationService,se),await se.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(K)),Z.set(ce.IRequestService,new a.SyncDescriptor(le.RequestService)),Z.set(h.IDownloadService,new a.SyncDescriptor(v.DownloadService)),Z.set(s.IExtensionManagementService,new a.SyncDescriptor(e.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new a.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new a.SyncDescriptor(o.ExtensionManagementCLIService)),Z.set(R.ILocalizationsService,new a.SyncDescriptor(P.LocalizationsService));const ie=[];if((0,q.supportsTelemetry)(_,N)){_.aiConfig&&_.aiConfig.asimovKey&&ie.push(new re.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:ue}=N,Ie={appenders:ie,sendErrorTelemetry:!1,commonProperties:(async()=>{let ve;try{const Ee=await f.Promises.readFile((0,d.join)(N.userDataPath,"storage.json"));ve=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&x.error(Ee)}return(0,ne.resolveCommonProperties)(K,(0,L.release)(),(0,L.hostname)(),process.arch,_.commit,_.version,ve,_.msftInternalDomains,ue)})(),piiPaths:[me,ye]};Z.set(he.ITelemetryService,new a.SyncDescriptor(B.TelemetryService,[Ie]))}else Z.set(he.ITelemetryService,q.NullTelemetryService);return[new m.InstantiationService(Z),ie]}registerErrorHandler(Z){(0,T.setUnexpectedErrorHandler)(_=>{const N=(0,D.toErrorMessage)(_,!0);!N||Z.error(`[uncaught exception in CLI]: ${N}`)}),process.on("uncaughtException",_=>(0,T.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,T.onUnexpectedError)(_))}async doRun(Z,_,N){if(this.argv["install-source"])return this.setInstallSource(Z,N,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?C.URI.file((0,d.isAbsolute)(_)?_:(0,d.join)((0,p.cwd)(),_)):_)}async setInstallSource(Z,_,N){await _.writeFile(C.URI.file(Z.installSourcePath),b.VSBuffer.fromString(N.slice(0,30)))}}async function te(X){const Z=new H(X);try{await Z.run()}finally{Z.dispose()}}t.main=te})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bef4dba21f68bbdb8d9f08fe04b2e1858597722b/core/vs/code/node/cliProcessMain.js.map
