/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[57],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=g}),define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(i){const I=[];for(let c in i)g.call(i,c)&&I.push(i[c]);return I}e.values=L;function D(i,I){for(let c in i)if(g.call(i,c)&&I({key:c,value:i[c]},function(){delete i[c]})===!1)return}e.forEach=D;function S(i,I){const c=Object.create(null);for(const p of i){const f=I(p);let w=c[f];w||(w=c[f]=[]),w.push(p)}return c}e.groupBy=S;function A(i){const I=Object.create(null);return i&&i.forEach((c,p)=>{I[p]=c}),I}e.fromMap=A;function k(i,I){const c=[],p=[];for(let f of i)I.has(f)||c.push(f);for(let f of I)i.has(f)||p.push(f);return{removed:c,added:p}}e.diffSets=k;function E(i,I){const c=[],p=[];for(let[f,w]of i)I.has(f)||c.push(w);for(let[f,w]of I)i.has(f)||p.push(w);return{removed:c,added:p}}e.diffMaps=E;class C{constructor(){this.map=new Map}add(I,c){let p=this.map.get(I);p||(p=new Set,this.map.set(I,p)),p.add(c)}delete(I,c){const p=this.map.get(I);!p||(p.delete(c),p.size===0&&this.map.delete(I))}forEach(I,c){const p=this.map.get(I);!p||p.forEach(c)}}e.SetMap=C}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(A){return(k,E,C)=>{let i=null,I=null;if(typeof C.value=="function"?(i="value",I=C.value):typeof C.get=="function"&&(i="get",I=C.get),!I)throw new Error("not supported");C[i]=A(I,E)}}e.createDecorator=g;function L(A,k,E){let C=null,i=null;if(typeof E.value=="function"?(C="value",i=E.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(C="get",i=E.get),!i)throw new Error("not supported");const I=`$memoize$${k}`;E[C]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,c)}),this[I]}}e.memoize=L;function D(A,k,E){return g((C,i)=>{const I=`$debounce$${i}`,c=`$debounce$result$${i}`;return function(...p){this[c]||(this[c]=E?E():void 0),clearTimeout(this[I]),k&&(this[c]=k(this[c],...p),p=[this[c]]),this[I]=setTimeout(()=>{C.apply(this,p),this[c]=E?E():void 0},A)}})}e.debounce=D;function S(A,k,E){return g((C,i)=>{const I=`$throttle$timer$${i}`,c=`$throttle$result$${i}`,p=`$throttle$lastRun$${i}`,f=`$throttle$pending$${i}`;return function(...w){if(this[c]||(this[c]=E?E():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...w)),this[f])return;const _=this[p]+A;_<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[c]]),this[c]=E?E():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[p]=Date.now(),C.apply(this,[this[c]]),this[c]=E?E():void 0},_-Date.now()))}})}e.throttle=S}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(h=>{h(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=g,e.errorHandler=new g;function L(v){e.errorHandler.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function D(v){E(v)||e.errorHandler.onUnexpectedError(v)}e.onUnexpectedError=D;function S(v){E(v)||e.errorHandler.onUnexpectedExternalError(v)}e.onUnexpectedExternalError=S;function A(v){if(v instanceof Error){let{name:n,message:h}=v;const r=v.stacktrace||v.stack;return{$isError:!0,name:n,message:h,stack:r}}return v}e.transformErrorForSerialization=A;const k="Canceled";function E(v){return v instanceof Error&&v.name===k&&v.message===k}e.isPromiseCanceledError=E;class C extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=C;function i(){const v=new Error(k);return v.name=v.message,v}e.canceled=i;function I(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.illegalArgument=I;function c(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.illegalState=c;function p(v){return v?new Error(`readonly property '${v} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function f(v){const n=new Error(`${v} has been disposed`);return n.name="DISPOSED",n}e.disposed=f;function w(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.getErrorMessage=w;class _ extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=_;class P extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=P;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function s(v){const n=v;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=s;function a(v,n=Object.create(null)){const h=new Error(v);return n.actions&&(h.actions=n.actions),h}e.createErrorWithActions=a}),define(fe[15],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(H,X=0){return H[H.length-(1+X)]}e.tail=L;function D(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.tail2=D;function S(H,X,Q=(de,_e)=>de===_e){if(H===X)return!0;if(!H||!X||H.length!==X.length)return!1;for(let de=0,_e=H.length;de<_e;de++)if(!Q(H[de],X[de]))return!1;return!0}e.equals=S;function A(H,X,Q){let de=0,_e=H.length-1;for(;de<=_e;){const Ie=(de+_e)/2|0,Pe=Q(H[Ie],X);if(Pe<0)de=Ie+1;else if(Pe>0)_e=Ie-1;else return Ie}return-(de+1)}e.binarySearch=A;function k(H,X){let Q=0,de=H.length;if(de===0)return 0;for(;Q<de;){const _e=Math.floor((Q+de)/2);X(H[_e])?de=_e:Q=_e+1}return Q}e.findFirstInSorted=k;function E(H,X,Q){if(H=H|0,H>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],_e=[],Ie=[],Pe=[];for(let We of X){const Be=Q(We,de);Be<0?_e.push(We):Be>0?Ie.push(We):Pe.push(We)}return H<_e.length?E(H,_e,Q):H<_e.length+Pe.length?Pe[0]:E(H-(_e.length+Pe.length),Ie,Q)}e.quickSelect=E;function C(H,X){const Q=[];let de;for(const _e of H.slice(0).sort(X))!de||X(de[0],_e)!==0?(de=[_e],Q.push(de)):de.push(_e);return Q}e.groupBy=C;function i(H,X,Q){const de=[];function _e(We,Be,He){if(Be===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===We?(G.deleteCount+=Be,G.toInsert.push(...He)):de.push({start:We,deleteCount:Be,toInsert:He})}let Ie=0,Pe=0;for(;;){if(Ie===H.length){_e(Ie,0,X.slice(Pe));break}if(Pe===X.length){_e(Ie,H.length-Ie,[]);break}const We=H[Ie],Be=X[Pe],He=Q(We,Be);He===0?(Ie+=1,Pe+=1):He<0?(_e(Ie,1,[]),Ie+=1):He>0&&(_e(Ie,0,[Be]),Pe+=1)}return de}e.sortedDiff=i;function I(H,X,Q){const de=i(H,X,Q),_e=[],Ie=[];for(const Pe of de)_e.push(...H.slice(Pe.start,Pe.start+Pe.deleteCount)),Ie.push(...Pe.toInsert);return{removed:_e,added:Ie}}e.delta=I;function c(H,X,Q){if(Q===0)return[];const de=H.slice(0,Q).sort(X);return f(H,X,de,Q,H.length),de}e.top=c;function p(H,X,Q,de,_e){return Q===0?Promise.resolve([]):new Promise((Ie,Pe)=>{(async()=>{const We=H.length,Be=H.slice(0,Q).sort(X);for(let He=Q,G=Math.min(Q+de,We);He<We;He=G,G=Math.min(G+de,We)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),_e&&_e.isCancellationRequested)throw(0,g.canceled)();f(H,X,Be,He,G)}return Be})().then(Ie,Pe)})}e.topAsync=p;function f(H,X,Q,de,_e){for(const Ie=Q.length;de<_e;de++){const Pe=H[de];if(X(Pe,Q[Ie-1])<0){Q.pop();const We=k(Q,Be=>X(Pe,Be)<0);Q.splice(We,0,Pe)}}}function w(H){return H.filter(X=>!!X)}e.coalesce=w;function _(H){let X=0;for(let Q=0;Q<H.length;Q++)H[Q]&&(H[X]=H[Q],X+=1);H.length=X}e.coalesceInPlace=_;function P(H,X,Q){H.splice(Q,0,H.splice(X,1)[0])}e.move=P;function b(H){return!Array.isArray(H)||H.length===0}e.isFalsyOrEmpty=b;function s(H){return Array.isArray(H)&&H.length>0}e.isNonEmptyArray=s;function a(H,X=Q=>Q){const Q=new Set;return H.filter(de=>{const _e=X(de);return Q.has(_e)?!1:(Q.add(_e),!0)})}e.distinct=a;function v(H){const X=Object.create(null);return Q=>{const de=H(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=v;function n(H,X){const Q=h(H,X);if(Q!==-1)return H[Q]}e.findLast=n;function h(H,X){for(let Q=H.length-1;Q>=0;Q--){const de=H[Q];if(X(de))return Q}return-1}e.lastIndex=h;function r(H,X){return H.length>0?H[0]:X}e.firstOrDefault=r;function t(H,X,Q=(de,_e)=>de===_e){let de=0;for(let _e=0,Ie=Math.min(H.length,X.length);_e<Ie&&Q(H[_e],X[_e]);_e++)de++;return de}e.commonPrefixLength=t;function l(H){return[].concat(...H)}e.flatten=l;function o(H,X){let Q=typeof X=="number"?H:0;typeof X=="number"?Q=H:(Q=0,X=H);const de=[];if(Q<=X)for(let _e=Q;_e<X;_e++)de.push(_e);else for(let _e=Q;_e>X;_e--)de.push(_e);return de}e.range=o;function d(H,X,Q){return H.reduce((de,_e)=>(de[X(_e)]=Q?Q(_e):_e,de),Object.create(null))}e.index=d;function m(H,X){return H.push(X),()=>u(H,X)}e.insert=m;function u(H,X){const Q=H.indexOf(X);if(Q>-1)return H.splice(Q,1),X}e.remove=u;function y(H,X,Q){const de=H.slice(0,X),_e=H.slice(X);return de.concat(Q,_e)}e.arrayInsert=y;function T(H,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const _e=Math.sin(de++)*179426549;return _e-Math.floor(_e)}}else Q=Math.random;for(let de=H.length-1;de>0;de-=1){const _e=Math.floor(Q()*(de+1)),Ie=H[de];H[de]=H[_e],H[_e]=Ie}}e.shuffle=T;function R(H,X){const Q=H.indexOf(X);Q>-1&&(H.splice(Q,1),H.unshift(X))}e.pushToStart=R;function $(H,X){const Q=H.indexOf(X);Q>-1&&(H.splice(Q,1),H.push(X))}e.pushToEnd=$;function B(H,X){return Array.isArray(H)?H.map(X):X(H)}e.mapArrayOrNot=B;function F(H){return Array.isArray(H)?H:[H]}e.asArray=F;function W(H){return H[Math.floor(Math.random()*H.length)]}e.getRandomElement=W;function M(H,X){for(const Q of H){const de=X(Q);if(de!==void 0)return de}}e.mapFind=M;function z(H,X,Q){const de=U(H,X),_e=H.length,Ie=Q.length;H.length=_e+Ie;for(let Pe=_e-1;Pe>=de;Pe--)H[Pe+Ie]=H[Pe];for(let Pe=0;Pe<Ie;Pe++)H[Pe+de]=Q[Pe]}e.insertInto=z;function N(H,X,Q,de){const _e=U(H,X),Ie=H.splice(_e,Q);return z(H,_e,de),Ie}e.splice=N;function U(H,X){return X<0?Math.max(X+H.length,0):Math.min(X,H.length)}function x(H,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return H.forEach((_e,Ie)=>{const Pe=X(_e);Pe<Q&&(Q=Pe,de=Ie)}),de}e.minIndex=x;function O(H,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return H.forEach((_e,Ie)=>{const Pe=X(_e);Pe>Q&&(Q=Pe,de=Ie)}),de}e.maxIndex=O;class j{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const Q=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,Q}}e.ArrayQueue=j}),define(fe[75],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const D=this;let S=!1,A;return function(){return S||(S=!0,A=L.apply(D,arguments)),A}}e.once=g}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function D(v){return v&&typeof v=="object"&&typeof v[Symbol.iterator]=="function"}L.is=D;const S=Object.freeze([]);function A(){return S}L.empty=A;function*k(v){yield v}L.single=k;function E(v){return v||S}L.from=E;function C(v){return!v||v[Symbol.iterator]().next().done===!0}L.isEmpty=C;function i(v){return v[Symbol.iterator]().next().value}L.first=i;function I(v,n){for(const h of v)if(n(h))return!0;return!1}L.some=I;function c(v,n){for(const h of v)if(n(h))return h}L.find=c;function*p(v,n){for(const h of v)n(h)&&(yield h)}L.filter=p;function*f(v,n){let h=0;for(const r of v)yield n(r,h++)}L.map=f;function*w(...v){for(const n of v)for(const h of n)yield h}L.concat=w;function*_(v){for(const n of v)for(const h of n)yield h}L.concatNested=_;function P(v,n,h){let r=h;for(const t of v)r=n(r,t);return r}L.reduce=P;function*b(v,n,h=v.length){for(n<0&&(n+=v.length),h<0?h+=v.length:h>v.length&&(h=v.length);n<h;n++)yield v[n]}L.slice=b;function s(v,n=Number.POSITIVE_INFINITY){const h=[];if(n===0)return[h,v];const r=v[Symbol.iterator]();for(let t=0;t<n;t++){const l=r.next();if(l.done)return[h,L.empty()];h.push(l.value)}return[h,{[Symbol.iterator](){return r}}]}L.consume=s;function a(v,n,h=(r,t)=>r===t){const r=v[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const l=r.next(),o=t.next();if(l.done!==o.done)return!1;if(l.done)return!0;if(!h(l.value,o.value))return!1}}L.equals=a})(g=e.Iterable||(e.Iterable={}))}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(n){n.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function A(n,h=!1){let r=0,t=n.length,l="",o=0,d=16,m=0;function u(W){let M=0,z=0;for(;M<W;){const N=n.charCodeAt(r);if(N>=48&&N<=57)z=z*16+N-48;else if(N>=65&&N<=70)z=z*16+N-65+10;else if(N>=97&&N<=102)z=z*16+N-97+10;else break;r++,M++}return M<W&&(z=-1),z}function y(W){r=W,l="",o=0,d=16,m=0}function T(){const W=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&C(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&C(n.charCodeAt(r)))for(r++;r<n.length&&C(n.charCodeAt(r));)r++;else return m=3,n.substring(W,r);let M=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&C(n.charCodeAt(r))){for(r++;r<n.length&&C(n.charCodeAt(r));)r++;M=r}else m=3;return n.substring(W,M)}function R(){let W="",M=r;for(;;){if(r>=t){W+=n.substring(M,r),m=2;break}const z=n.charCodeAt(r);if(z===34){W+=n.substring(M,r),r++;break}if(z===92){if(W+=n.substring(M,r),r++,r>=t){m=2;break}switch(n.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:const U=u(4);U>=0?W+=String.fromCharCode(U):m=4;break;default:m=5}M=r;continue}if(z>=0&&z<=31)if(E(z)){W+=n.substring(M,r),m=2;break}else m=6;r++}return W}function $(){if(l="",m=0,o=r,r>=t)return o=t,d=17;let W=n.charCodeAt(r);if(k(W)){do r++,l+=String.fromCharCode(W),W=n.charCodeAt(r);while(k(W));return d=15}if(E(W))return r++,l+=String.fromCharCode(W),W===13&&n.charCodeAt(r)===10&&(r++,l+=`
`),d=14;switch(W){case 123:return r++,d=1;case 125:return r++,d=2;case 91:return r++,d=3;case 93:return r++,d=4;case 58:return r++,d=6;case 44:return r++,d=5;case 34:return r++,l=R(),d=10;case 47:const M=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<t&&!E(n.charCodeAt(r));)r++;return l=n.substring(M,r),d=12}if(n.charCodeAt(r+1)===42){r+=2;const z=t-1;let N=!1;for(;r<z;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,N=!0;break}r++}return N||(r++,m=1),l=n.substring(M,r),d=13}return l+=String.fromCharCode(W),r++,d=16;case 45:if(l+=String.fromCharCode(W),r++,r===t||!C(n.charCodeAt(r)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=T(),d=11;default:for(;r<t&&B(W);)r++,W=n.charCodeAt(r);if(o!==r){switch(l=n.substring(o,r),l){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return l+=String.fromCharCode(W),r++,d=16}}function B(W){if(k(W)||E(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let W;do W=$();while(W>=12&&W<=15);return W}return{setPosition:y,getPosition:()=>r,scan:h?F:$,getToken:()=>d,getTokenValue:()=>l,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>m}}e.createScanner=A;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function C(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,h){const r=[],t=new Object;let l;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function m(u,y,T,R){o.value=u,o.offset=y,o.length=T,o.type=R,o.colonOffset=void 0,l=o}try{s(n,{onObjectBegin:(u,y)=>{if(h<=u)throw t;l=void 0,d=h>u,r.push("")},onObjectProperty:(u,y,T)=>{if(h<y||(m(u,y,T,"property"),r[r.length-1]=u,h<=y+T))throw t},onObjectEnd:(u,y)=>{if(h<=u)throw t;l=void 0,r.pop()},onArrayBegin:(u,y)=>{if(h<=u)throw t;l=void 0,r.push(0)},onArrayEnd:(u,y)=>{if(h<=u)throw t;l=void 0,r.pop()},onLiteralValue:(u,y,T)=>{if(h<y||(m(u,y,T,v(u)),h<=y+T))throw t},onSeparator:(u,y,T)=>{if(h<=y)throw t;if(u===":"&&l&&l.type==="property")l.colonOffset=y,d=!1,l=void 0;else if(u===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(d=!0,r[r.length-1]=""),l=void 0}}})}catch(u){if(u!==t)throw u}return{path:r,previousNode:l,isAtPropertyKey:d,matches:u=>{let y=0;for(let T=0;y<u.length&&T<r.length;T++)if(u[y]===r[T]||u[y]==="*")y++;else if(u[y]!=="**")return!1;return y===u.length}}}e.getLocation=I;function c(n,h=[],r=S.DEFAULT){let t=null,l=[];const o=[];function d(u){Array.isArray(l)?l.push(u):t!==null&&(l[t]=u)}return s(n,{onObjectBegin:()=>{const u={};d(u),o.push(l),l=u,t=null},onObjectProperty:u=>{t=u},onObjectEnd:()=>{l=o.pop()},onArrayBegin:()=>{const u=[];d(u),o.push(l),l=u,t=null},onArrayEnd:()=>{l=o.pop()},onLiteralValue:d,onError:(u,y,T)=>{h.push({error:u,offset:y,length:T})}},r),l[0]}e.parse=c;function p(n,h=[],r=S.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(u){t.type==="property"&&(t.length=u-t.offset,t=t.parent)}function o(u){return t.children.push(u),u}s(n,{onObjectBegin:u=>{t=o({type:"object",offset:u,length:-1,parent:t,children:[]})},onObjectProperty:(u,y,T)=>{t=o({type:"property",offset:y,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:u,offset:y,length:T,parent:t})},onObjectEnd:(u,y)=>{t.length=u+y-t.offset,t=t.parent,l(u+y)},onArrayBegin:(u,y)=>{t=o({type:"array",offset:u,length:-1,parent:t,children:[]})},onArrayEnd:(u,y)=>{t.length=u+y-t.offset,t=t.parent,l(u+y)},onLiteralValue:(u,y,T)=>{o({type:v(u),offset:y,length:T,parent:t,value:u}),l(y+T)},onSeparator:(u,y,T)=>{t.type==="property"&&(u===":"?t.colonOffset=y:u===","&&l(y))},onError:(u,y,T)=>{h.push({error:u,offset:y,length:T})}},r);const m=t.children[0];return m&&delete m.parent,m}e.parseTree=p;function f(n,h){if(!n)return;let r=n;for(let t of h)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let l=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],l=!0;break}if(!l)return}else{const l=t;if(r.type!=="array"||l<0||!Array.isArray(r.children)||l>=r.children.length)return;r=r.children[l]}return r}e.findNodeAtLocation=f;function w(n){if(!n.parent||!n.parent.children)return[];const h=w(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;h.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&h.push(r)}return h}e.getNodePath=w;function _(n){switch(n.type){case"array":return n.children.map(_);case"object":const h=Object.create(null);for(let r of n.children){const t=r.children[1];t&&(h[r.children[0].value]=_(t))}return h;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=_;function P(n,h,r=!1){return h>=n.offset&&h<n.offset+n.length||r&&h===n.offset+n.length}e.contains=P;function b(n,h,r=!1){if(P(n,h,r)){const t=n.children;if(Array.isArray(t))for(let l=0;l<t.length&&t[l].offset<=h;l++){const o=b(t[l],h,r);if(o)return o}return n}}e.findNodeAtOffset=b;function s(n,h,r=S.DEFAULT){const t=A(n,!1);function l(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(Q){return Q?de=>Q(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const d=l(h.onObjectBegin),m=o(h.onObjectProperty),u=l(h.onObjectEnd),y=l(h.onArrayBegin),T=l(h.onArrayEnd),R=o(h.onLiteralValue),$=o(h.onSeparator),B=l(h.onComment),F=o(h.onError),W=r&&r.disallowComments,M=r&&r.allowTrailingComma;function z(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:W||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Q){case 12:case 13:W?N(10):B();break;case 16:N(1);break;case 15:case 14:break;default:return Q}}}function N(Q,de=[],_e=[]){if(F(Q),de.length+_e.length>0){let Ie=t.getToken();for(;Ie!==17;){if(de.indexOf(Ie)!==-1){z();break}else if(_e.indexOf(Ie)!==-1)break;Ie=z()}}}function U(Q){const de=t.getTokenValue();return Q?R(de):m(de),z(),!0}function x(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(N(2),Q=0)}catch(de){N(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return z(),!0}function O(){return t.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),t.getToken()===6?($(":"),z(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function j(){d(),z();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),$(","),z(),t.getToken()===2&&M)break}else Q&&N(6,[],[]);O()||N(4,[],[2,5]),Q=!0}return u(),t.getToken()!==2?N(7,[2],[]):z(),!0}function H(){y(),z();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),$(","),z(),t.getToken()===4&&M)break}else Q&&N(6,[],[]);X()||N(4,[],[4,5]),Q=!0}return T(),t.getToken()!==4?N(8,[4],[]):z(),!0}function X(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return U(!0);default:return x()}}return z(),t.getToken()===17?r.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(t.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=s;function a(n,h){let r=A(n),t=[],l,o=0,d;do switch(d=r.getPosition(),l=r.scan(),l){case 12:case 13:case 17:o!==d&&t.push(n.substring(o,d)),h!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,h)),o=r.getPosition();break}while(l!==17);return t.join("")}e.stripComments=a;function v(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(fe[139],me([0,1,60]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(E,C,i){let I,c,p,f,w;if(C){for(f=C.offset,w=f+C.length,p=f;p>0&&!k(E,p-1);)p--;let o=w;for(;o<E.length&&!k(E,o);)o++;c=E.substring(p,o),I=S(c,i)}else c=E,I=0,p=0,f=0,w=E.length;const _=A(i,E);let P=!1,b=0,s;i.insertSpaces?s=D(" ",i.tabSize||4):s="	";const a=(0,g.createScanner)(c,!1);let v=!1;function n(){return _+D(s,I+b)}function h(){let o=a.scan();for(P=!1;o===15||o===14;)P=P||o===14,o=a.scan();return v=o===16||a.getTokenError()!==0,o}const r=[];function t(o,d,m){!v&&d<w&&m>f&&E.substring(d,m)!==o&&r.push({offset:d,length:m-d,content:o})}let l=h();if(l!==17){const o=a.getTokenOffset()+p,d=D(s,I);t(d,p,o)}for(;l!==17;){let o=a.getTokenOffset()+a.getTokenLength()+p,d=h(),m="";for(;!P&&(d===12||d===13);){const y=a.getTokenOffset()+p;t(" ",o,y),o=a.getTokenOffset()+a.getTokenLength()+p,m=d===12?n():"",d=h()}if(d===2)l!==1&&(b--,m=n());else if(d===4)l!==3&&(b--,m=n());else{switch(l){case 3:case 1:b++,m=n();break;case 5:case 12:m=n();break;case 13:P?m=n():m=" ";break;case 6:m=" ";break;case 10:if(d===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?m=" ":d!==5&&d!==17&&(v=!0);break;case 16:v=!0;break}P&&(d===12||d===13)&&(m=n())}const u=a.getTokenOffset()+p;t(m,o,u),l=d}return r}e.format=L;function D(E,C){let i="";for(let I=0;I<C;I++)i+=E;return i}function S(E,C){let i=0,I=0;const c=C.tabSize||4;for(;i<E.length;){const p=E.charAt(i);if(p===" ")I++;else if(p==="	")I+=c;else break;i++}return Math.floor(I/c)}function A(E,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=A;function k(E,C){return`\r
`.indexOf(E.charAt(C))!==-1}e.isEOL=k}),define(fe[140],me([0,1,60,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,i,I){return S(C,i,void 0,I)}e.removeProperty=D;function S(C,i,I,c,p){const f=i.slice(),w=[],_=(0,g.parseTree)(C,w);let P,b;for(;f.length>0&&(b=f.pop(),P=(0,g.findNodeAtLocation)(_,f),P===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(P)if(P.type==="object"&&typeof b=="string"&&Array.isArray(P.children)){const s=(0,g.findNodeAtLocation)(P,[b]);if(s!==void 0)if(I===void 0){if(!s.parent)throw new Error("Malformed AST");const a=P.children.indexOf(s.parent);let v,n=s.parent.offset+s.parent.length;if(a>0){const h=P.children[a-1];v=h.offset+h.length}else v=P.offset+1,P.children.length>1&&(n=P.children[1].offset);return A(C,{offset:v,length:n-v,content:""},c)}else return A(C,{offset:s.offset,length:s.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const a=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,v=p?p(P.children.map(h=>h.children[0].value)):P.children.length;let n;if(v>0){const h=P.children[v-1];n={offset:h.offset+h.length,length:0,content:","+a}}else P.children.length===0?n={offset:P.offset+1,length:0,content:a}:n={offset:P.offset+1,length:0,content:a+","};return A(C,n,c)}}else if(P.type==="array"&&typeof b=="number"&&Array.isArray(P.children))if(I!==void 0){const s=`${JSON.stringify(I)}`;let a;if(P.children.length===0||b===0)a={offset:P.offset+1,length:0,content:P.children.length===0?s:s+","};else{const v=b===-1||b>P.children.length?P.children.length:b,n=P.children[v-1];a={offset:n.offset+n.length,length:0,content:","+s}}return A(C,a,c)}else{const s=b,a=P.children[s];let v;if(P.children.length===1)v={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===s){const n=P.children[s-1],h=n.offset+n.length,r=P.offset+P.length;v={offset:h,length:r-2-h,content:""}}else v={offset:a.offset,length:P.children[s+1].offset-a.offset,content:""};return A(C,v,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${P.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return A(C,{offset:_?_.offset:0,length:_?_.length:0,content:JSON.stringify(I)},c)}}e.setProperty=S;function A(C,i,I){let c=k(C,i),p=i.offset,f=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;p>0&&!(0,L.isEOL)(c,p-1);)p--;for(;f<c.length&&!(0,L.isEOL)(c,f);)f++}const w=(0,L.format)(c,{offset:p,length:f-p},I);for(let P=w.length-1;P>=0;P--){const b=w[P];c=k(c,b),p=Math.min(p,b.offset),f=Math.max(f,b.offset+b.length),f+=b.content.length-b.length}const _=C.length-(c.length-f)-p;return[{offset:p,length:_,content:c.substring(p,f)}]}e.withFormatting=A;function k(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=k;function E(C,i){let I=i.slice(0).sort((p,f)=>{const w=p.offset-f.offset;return w===0?p.length-f.length:w}),c=C.length;for(let p=I.length-1;p>=0;p--){let f=I[p];if(f.offset+f.length<=c)C=k(C,f);else throw new Error("Overlapping edit");c=f.offset}return C}e.applyEdits=E}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new g(()=>D(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,75,77]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let S=null;function A(t){S=t}if(e.setDisposableTracker=A,D){const t="__is_disposable_tracked__";A(new class{trackDisposable(l){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[t]||console.log(o)},3e3)}setParent(l,o){if(l&&l!==b.None)try{l[t]=!0}catch{}}markAsDisposed(l){if(l&&l!==b.None)try{l[t]=!0}catch{}}markAsSingleton(l){}})}function k(t){return S?.trackDisposable(t),t}function E(t){S?.markAsDisposed(t)}function C(t,l){S?.setParent(t,l)}function i(t,l){if(!!S)for(const o of t)S.setParent(o,l)}function I(t){return S?.markAsSingleton(t),t}e.markAsSingleton=I;class c extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=c;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function f(t){if(L.Iterable.is(t)){let l=[];for(const o of t)if(o)try{o.dispose()}catch(d){l.push(d)}if(l.length===1)throw l[0];if(l.length>1)throw new c(l);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=f;function w(...t){const l=_(()=>f(t));return i(t,l),l}e.combinedDisposable=w;function _(t){const l=k({dispose:(0,g.once)(()=>{E(l),t()})});return l}e.toDisposable=_;class P{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(E(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return C(l,this),this._isDisposed?P.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=P,P.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new P,k(this),C(this._store,this)}dispose(){E(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class s{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&C(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,E(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&C(l,null),l}}e.MutableDisposable=s;class a{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class v{constructor(){this.references=new Map}acquire(l,...o){let d=this.references.get(l);d||(d={counter:0,object:this.createReferencedObject(l,...o)},this.references.set(l,d));const{object:m}=d,u=(0,g.once)(()=>{--d.counter==0&&(this.destroyReferencedObject(l,d.object),this.references.delete(l))});return d.counter++,{object:m,dispose:u}}}e.ReferenceCollection=v;class n{constructor(l){this.referenceCollection=l}async acquire(l,...o){const d=this.referenceCollection.acquire(l,...o);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(m){throw d.dispose(),m}}}e.AsyncReferenceCollection=n;class h{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=h;function r(t){const l=new P;try{t(l)}finally{l.dispose()}}e.disposeOnReturn=r}),define(fe[93],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(S){this.element=S,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let S=this._first;for(;S!==g.Undefined;){const A=S.next;S.prev=g.Undefined,S.next=g.Undefined,S=A}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,A){const k=new g(S);if(this._first===g.Undefined)this._first=k,this._last=k;else if(A){const C=this._last;this._last=k,k.prev=C,C.next=k}else{const C=this._first;this._first=k,k.next=C,C.prev=k}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(k))}}shift(){if(this._first!==g.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==g.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==g.Undefined&&S.next!==g.Undefined){const A=S.prev;A.next=S.next,S.next.prev=A}else S.prev===g.Undefined&&S.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):S.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):S.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==g.Undefined;)yield S.element,S=S.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,De){for(var Te=0;Te<De.length;Te++){var se=De[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,De,Te){return De&&Y(Re.prototype,De),Te&&Y(Re,Te),Re}function g(Re,De){if(!!Re){if(typeof Re=="string")return L(Re,De);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,De)}}function L(Re,De){(De==null||De>Re.length)&&(De=Re.length);for(var Te=0,se=new Array(De);Te<De;Te++)se[Te]=Re[Te];return se}function D(Re,De){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||De&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var S={exports:{}};function A(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){S.exports.defaults=Re}S.exports={defaults:A(),getDefaults:A,changeDefaults:k};var E=/[&<>"']/,C=/[&<>"']/g,i=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(De){return c[De]};function f(Re,De){if(De){if(E.test(Re))return Re.replace(C,p)}else if(i.test(Re))return Re.replace(I,p);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function _(Re){return Re.replace(w,function(De,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var P=/(^|[^\[])\^/g;function b(Re,De){Re=Re.source||Re,De=De||"";var Te={replace:function(ue,we){return we=we.source||we,we=we.replace(P,"$1"),Re=Re.replace(ue,we),Te},getRegex:function(){return new RegExp(Re,De)}};return Te}var s=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(Re,De,Te){if(Re){var se;try{se=decodeURIComponent(_(Te)).replace(s,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}De&&!a.test(Te)&&(Te=l(De,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var n={},h=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(Re,De){n[" "+Re]||(h.test(Re)?n[" "+Re]=Re+"/":n[" "+Re]=u(Re,"/",!0)),Re=n[" "+Re];var Te=Re.indexOf(":")===-1;return De.substring(0,2)==="//"?Te?De:Re.replace(r,"$1")+De:De.charAt(0)==="/"?Te?De:Re.replace(t,"$1")+De:Re+De}var o={exec:function(){}};function d(Re){for(var De=1,Te,se;De<arguments.length;De++){Te=arguments[De];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Re[se]=Te[se])}return Re}function m(Re,De){var Te=Re.replace(/\|/g,function(we,ve,Fe){for(var qe=!1,ze=ve;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>De)se.splice(De);else for(;se.length<De;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function u(Re,De,Te){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var we=Re.charAt(se-ue-1);if(we===De&&!Te)ue++;else if(we!==De&&Te)ue++;else break}return Re.substr(0,se-ue)}function y(Re,De){if(Re.indexOf(De[1])===-1)return-1;for(var Te=Re.length,se=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===De[0])se++;else if(Re[ue]===De[1]&&(se--,se<0))return ue;return-1}function T(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,De){if(De<1)return"";for(var Te="";De>1;)De&1&&(Te+=Re),De>>=1,Re+=Re;return Te+Re}var $={escape:f,unescape:_,edit:b,cleanUrl:v,resolveUrl:l,noopTest:o,merge:d,splitCells:m,rtrim:u,findClosingBracket:y,checkSanitizeDeprecation:T,repeatString:R},B=S.exports.defaults,F=$.rtrim,W=$.splitCells,M=$.escape,z=$.findClosingBracket;function N(Re,De,Te,se){var ue=De.href,we=De.title?M(De.title):null,ve=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:we,text:ve,tokens:se.inlineTokens(ve,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:we,text:M(ve)}}function U(Re,De){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return De;var se=Te[1];return De.split(`
`).map(function(ue){var we=ue.match(/^\s+/);if(we===null)return ue;var ve=we[0];return ve.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var x=function(){function Re(Te){this.options=Te||B}var De=Re.prototype;return De.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},De.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var we=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?we:F(we,`
`)}}},De.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var we=ue[0],ve=U(we,ue[3]||"");return{type:"code",raw:we,lang:ue[2]?ue[2].trim():ue[2],text:ve}}},De.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var we=ue[2].trim();if(/#$/.test(we)){var ve=F(we,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&(we=ve.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:we,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},De.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},De.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var we=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},De.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var we,ve,Fe,qe,ze,Ye,lt,xe,ge,be,ae=ue[1].trim(),K=ae.length>1,Se={type:"list",raw:"",ordered:K,start:K?+ae.slice(0,-1):"",loose:!1,items:[]};ae=K?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=K?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,be=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),be=ge[0].slice(qe-ue[1].length)),Ye=!1,we=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(we=ue[1]+ge.slice(0,2).join(`
`)+`
`,Se.loose=!0,ge=[]);var it=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),it.test(xe)){we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=qe?be+=`
`+xe.slice(qe):be+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){be+=`
`+xe.slice(qe);continue}else{we=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Se.loose||(lt?Se.loose=!0:/\n *\n *$/.test(we)&&(lt=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(be),ve&&(Fe=ve[0]!=="[ ] ",be=be.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:we,task:!!ve,checked:Fe,loose:!1,text:be}),Se.raw+=we,se=se.slice(we.length)}Se.items[Se.items.length-1].raw=we.trimRight(),Se.items[Se.items.length-1].text=be.trimRight(),Se.raw=Se.raw.trimRight();var Ge=Se.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Se.items[ze].tokens=this.lexer.blockTokens(Se.items[ze].text,[]),Se.items[ze].tokens.some(function(mt){return mt.type==="space"})&&(Se.loose=!0,Se.items[ze].loose=!0);return Se}},De.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var we={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(we.type="paragraph",we.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),we.tokens=[],this.lexer.inline(we.text,we.tokens)),we}},De.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var we=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:ue[0],href:ue[2],title:ue[3]}}},De.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var we={type:"table",header:W(ue[1]).map(function(lt){return{text:lt}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=ue[0];var ve=we.align.length,Fe,qe,ze,Ye;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test(we.align[Fe])?we.align[Fe]="right":/^ *:-+: *$/.test(we.align[Fe])?we.align[Fe]="center":/^ *:-+ *$/.test(we.align[Fe])?we.align[Fe]="left":we.align[Fe]=null;for(ve=we.rows.length,Fe=0;Fe<ve;Fe++)we.rows[Fe]=W(we.rows[Fe],we.header.length).map(function(lt){return{text:lt}});for(ve=we.header.length,qe=0;qe<ve;qe++)we.header[qe].tokens=[],this.lexer.inlineTokens(we.header[qe].text,we.header[qe].tokens);for(ve=we.rows.length,qe=0;qe<ve;qe++)for(Ye=we.rows[qe],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return we}}},De.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var we={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var we={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var we={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(we.text,we.tokens),we}},De.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},De.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},De.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var we=ue[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var ve=F(we.slice(0,-1),"\\");if((we.length-ve.length)%2==0)return}else{var Fe=z(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],lt="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],lt=xe[3])}else lt=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(we)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:lt&&lt.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},De.reflink=function(se,ue){var we;if((we=this.rules.inline.reflink.exec(se))||(we=this.rules.inline.nolink.exec(se))){var ve=(we[2]||we[1]).replace(/\s+/g," ");if(ve=ue[ve.toLowerCase()],!ve||!ve.href){var Fe=we[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(we,ve,we[0],this.lexer)}},De.emStrong=function(se,ue,we){we===void 0&&(we="");var ve=this.rules.inline.emStrong.lDelim.exec(se);if(!!ve&&!(ve[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&(we===""||this.rules.inline.punctuation.exec(we))){var qe=ve[0].length-1,ze,Ye,lt=qe,xe=0,ge=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(ve=ge.exec(ue))!=null;)if(ze=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!ze){if(Ye=ze.length,ve[3]||ve[4]){lt+=Ye;continue}else if((ve[5]||ve[6])&&qe%3&&!((qe+Ye)%3)){xe+=Ye;continue}if(lt-=Ye,!(lt>0)){if(Ye=Math.min(Ye,Ye+lt+xe),Math.min(qe,Ye)%2){var be=se.slice(1,qe+ve.index+Ye);return{type:"em",raw:se.slice(0,qe+ve.index+Ye+1),text:be,tokens:this.lexer.inlineTokens(be,[])}}var ae=se.slice(2,qe+ve.index+Ye-1);return{type:"strong",raw:se.slice(0,qe+ve.index+Ye+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},De.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var we=ue[2].replace(/\n/g," "),ve=/[^ ]/.test(we),Fe=/^ /.test(we)&&/ $/.test(we);return ve&&Fe&&(we=we.substring(1,we.length-1)),we=M(we,!0),{type:"codespan",raw:ue[0],text:we}}},De.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},De.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},De.autolink=function(se,ue){var we=this.rules.inline.autolink.exec(se);if(we){var ve,Fe;return we[2]==="@"?(ve=M(this.options.mangle?ue(we[1]):we[1]),Fe="mailto:"+ve):(ve=M(we[1]),Fe=ve),{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.url=function(se,ue){var we;if(we=this.rules.inline.url.exec(se)){var ve,Fe;if(we[2]==="@")ve=M(this.options.mangle?ue(we[0]):we[0]),Fe="mailto:"+ve;else{var qe;do qe=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(qe!==we[0]);ve=M(we[0]),we[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:we[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},De.inlineText=function(se,ue){var we=this.rules.inline.text.exec(se);if(we){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):M(we[0]):we[0]:ve=M(this.options.smartypants?ue(we[0]):we[0]),{type:"text",raw:we[0],text:ve}}},Re}(),O=$.noopTest,j=$.edit,H=$.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=j(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=j(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=j(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=j(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=j(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=j(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=H({},X),X.gfm=H({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=j(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=H({},X.normal,{html:j(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:j(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=j(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=j(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=j(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=j(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=j(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=j(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=j(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=j(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=j(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=j(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=H({},Q),Q.pedantic=H({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=H({},Q.normal,{escape:j(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=j(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=H({},Q.gfm,{br:j(Q.br).replace("{2,}","*").getRegex(),text:j(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},_e=x,Ie=S.exports.defaults,Pe=de.block,We=de.inline,Be=$.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var De="",Te,se,ue=Re.length;for(Te=0;Te<ue;Te++)se=Re.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),De+="&#"+se+";";return De}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||Ie,this.options.tokenizer=this.options.tokenizer||new _e,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:Pe.normal,inline:We.normal};this.options.pedantic?(se.block=Pe.pedantic,se.inline=We.pedantic):this.options.gfm&&(se.block=Pe.gfm,this.options.breaks?se.inline=We.breaks:se.inline=We.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var we=new Re(ue);return we.lex(se)},Re.lexInline=function(se,ue){var we=new Re(ue);return we.inlineTokens(se)};var De=Re.prototype;return De.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},De.blockTokens=function(se,ue){var we=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var ve,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(lt){return(ve=lt.call({lexer:we},se,ue))?(se=se.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.space(se)){se=se.substring(ve.raw.length),ve.type&&ue.push(ve);continue}if(ve=this.tokenizer.code(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(ve=this.tokenizer.fences(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.heading(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.hr(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.blockquote(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.list(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.html(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.def(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.lheading(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var lt=Infinity,xe=se.slice(1),ge=void 0;we.options.extensions.startBlock.forEach(function(be){ge=be.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(lt=Math.min(lt,ge))}),lt<Infinity&&lt>=0&&(qe=se.substring(0,lt+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve),ze=qe.length!==se.length,se=se.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(ve);continue}if(se){var Ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},De.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},De.inlineTokens=function(se,ue){var we=this;ue===void 0&&(ue=[]);var ve,Fe,qe,ze=se,Ye,lt,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+Be("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(lt||(xe=""),lt=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(ve=ae.call({lexer:we},se,ue))?(se=se.substring(ve.raw.length),ue.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.tag(se)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.link(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(ve.raw.length),Fe=ue[ue.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(ve=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.codespan(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.br(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.del(se)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(ve=this.tokenizer.autolink(se,G)){se=se.substring(ve.raw.length),ue.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(se,G))){se=se.substring(ve.raw.length),ue.push(ve);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,K=se.slice(1),Se=void 0;we.options.extensions.startInline.forEach(function(Le){Se=Le.call({lexer:this},K),typeof Se=="number"&&Se>=0&&(ae=Math.min(ae,Se))}),ae<Infinity&&ae>=0&&(qe=se.substring(0,ae+1))}(),ve=this.tokenizer.inlineText(qe,He)){se=se.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(xe=ve.raw.slice(-1)),lt=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ue.push(ve);continue}if(se){var be="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(be);break}else throw new Error(be)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:We}}}]),Re}(),ie=S.exports.defaults,ce=$.cleanUrl,Z=$.escape,re=function(){function Re(Te){this.options=Te||ie}var De=Re.prototype;return De.code=function(se,ue,we){var ve=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,ve);Fe!=null&&Fe!==se&&(we=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+Z(ve,!0)+'">'+(we?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(we?se:Z(se,!0))+`</code></pre>
`},De.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},De.html=function(se){return se},De.heading=function(se,ue,we,ve){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+ve.slug(we)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(se,ue,we){var ve=ue?"ol":"ul",Fe=ue&&we!==1?' start="'+we+'"':"";return"<"+ve+Fe+`>
`+se+"</"+ve+`>
`},De.listitem=function(se){return"<li>"+se+`</li>
`},De.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(se){return"<p>"+se+`</p>
`},De.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},De.tablerow=function(se){return`<tr>
`+se+`</tr>
`},De.tablecell=function(se,ue){var we=ue.header?"th":"td",ve=ue.align?"<"+we+' align="'+ue.align+'">':"<"+we+">";return ve+se+"</"+we+`>
`},De.strong=function(se){return"<strong>"+se+"</strong>"},De.em=function(se){return"<em>"+se+"</em>"},De.codespan=function(se){return"<code>"+se+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(se){return"<del>"+se+"</del>"},De.link=function(se,ue,we){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return we;var ve='<a href="'+Z(se)+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=">"+we+"</a>",ve},De.image=function(se,ue,we){if(se=ce(this.options.sanitize,this.options.baseUrl,se),se===null)return we;var ve='<img src="'+se+'" alt="'+we+'"';return ue&&(ve+=' title="'+ue+'"'),ve+=this.options.xhtml?"/>":">",ve},De.text=function(se){return se},Re}(),pe=function(){function Re(){}var De=Re.prototype;return De.strong=function(se){return se},De.em=function(se){return se},De.codespan=function(se){return se},De.del=function(se){return se},De.html=function(se){return se},De.text=function(se){return se},De.link=function(se,ue,we){return""+we},De.image=function(se,ue,we){return""+we},De.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var De=Re.prototype;return De.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(se,ue){var we=se,ve=0;if(this.seen.hasOwnProperty(we)){ve=this.seen[se];do ve++,we=se+"-"+ve;while(this.seen.hasOwnProperty(we))}return ue||(this.seen[se]=ve,this.seen[we]=0),we},De.slug=function(se,ue){ue===void 0&&(ue={});var we=this.serialize(se);return this.getNextSafeSlug(we,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=S.exports.defaults,ct=$.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(se,ue){var we=new Re(ue);return we.parse(se)},Re.parseInline=function(se,ue){var we=new Re(ue);return we.parseInline(se)};var De=Re.prototype;return De.parse=function(se,ue){ue===void 0&&(ue=!0);var we="",ve,Fe,qe,ze,Ye,lt,xe,ge,be,ae,K,Se,Le,it,Ge,mt,yt,Et,gt,bt=se.length;for(ve=0;ve<bt;ve++){if(ae=se[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(gt=this.options.extensions.renderers[ae.type].call({parser:this},ae),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){we+=gt||"";continue}switch(ae.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,ct(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(ge="",xe="",ze=ae.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(ge+=this.renderer.tablerow(xe),be="",ze=ae.rows.length,Fe=0;Fe<ze;Fe++){for(lt=ae.rows[Fe],xe="",Ye=lt.length,qe=0;qe<Ye;qe++)xe+=this.renderer.tablecell(this.parseInline(lt[qe].tokens),{header:!1,align:ae.align[qe]});be+=this.renderer.tablerow(xe)}we+=this.renderer.table(ge,be);continue}case"blockquote":{be=this.parse(ae.tokens),we+=this.renderer.blockquote(be);continue}case"list":{for(K=ae.ordered,Se=ae.start,Le=ae.loose,ze=ae.items.length,be="",Fe=0;Fe<ze;Fe++)Ge=ae.items[Fe],mt=Ge.checked,yt=Ge.task,it="",Ge.task&&(Et=this.renderer.checkbox(mt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=Et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=Et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:Et}):it+=Et),it+=this.parse(Ge.tokens,Le),be+=this.renderer.listitem(it,yt,mt);we+=this.renderer.list(be,K,Se);continue}case"html":{we+=this.renderer.html(ae.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(be=ae.tokens?this.parseInline(ae.tokens):ae.text;ve+1<bt&&se[ve+1].type==="text";)ae=se[++ve],be+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);we+=ue?this.renderer.paragraph(be):be;continue}default:{var vt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return we},De.parseInline=function(se,ue){ue=ue||this.renderer;var we="",ve,Fe,qe,ze=se.length;for(ve=0;ve<ze;ve++){if(Fe=se[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){we+=qe||"";continue}switch(Fe.type){case"escape":{we+=ue.text(Fe.text);break}case"html":{we+=ue.html(Fe.text);break}case"link":{we+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{we+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{we+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{we+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{we+=ue.codespan(Fe.text);break}case"br":{we+=ue.br();break}case"del":{we+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{we+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return we},Re}(),at=ee,J=ye,ne=x,Ee=re,Qe=pe,et=Me,le=$.merge,ke=$.checkSanitizeDeprecation,Ne=$.escape,Xe=S.exports.getDefaults,nt=S.exports.changeDefaults,ft=S.exports.defaults;function tt(Re,De,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof De=="function"&&(Te=De,De=null),De=le({},tt.defaults,De||{}),ke(De),Te){var se=De.highlight,ue;try{ue=at.lex(Re,De)}catch(qe){return Te(qe)}var we=function(ze){var Ye;if(!ze)try{De.walkTokens&&tt.walkTokens(ue,De.walkTokens),Ye=J.parse(ue,De)}catch(lt){ze=lt}return De.highlight=se,ze?Te(ze):Te(null,Ye)};if(!se||se.length<3||(delete De.highlight,!ue.length))return we();var ve=0;tt.walkTokens(ue,function(qe){qe.type==="code"&&(ve++,setTimeout(function(){se(qe.text,qe.lang,function(ze,Ye){if(ze)return we(ze);Ye!=null&&Ye!==qe.text&&(qe.text=Ye,qe.escaped=!0),ve--,ve===0&&we()})},0))}),ve===0&&we();return}try{var Fe=at.lex(Re,De);return De.walkTokens&&tt.walkTokens(Fe,De.walkTokens),J.parse(Fe,De)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(qe.message+"",!0)+"</pre>";throw qe}}tt.options=tt.setOptions=function(Re){return le(tt.defaults,Re),nt(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,De=arguments.length,Te=new Array(De),se=0;se<De;se++)Te[se]=arguments[se];var ue=le.apply(void 0,[{}].concat(Te)),we=tt.defaults.extensions||{renderers:{},childTokens:{}},ve;Te.forEach(function(Fe){if(Fe.extensions&&(ve=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=we.renderers?we.renderers[ze.name]:null;Ye?we.renderers[ze.name]=function(){for(var lt=arguments.length,xe=new Array(lt),ge=0;ge<lt;ge++)xe[ge]=arguments[ge];var be=ze.renderer.apply(this,xe);return be===!1&&(be=Ye.apply(this,xe)),be}:we.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");we[ze.level]?we[ze.level].unshift(ze.tokenizer):we[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?we.startBlock?we.startBlock.push(ze.start):we.startBlock=[ze.start]:ze.level==="inline"&&(we.startInline?we.startInline.push(ze.start):we.startInline=[ze.start]))}ze.childTokens&&(we.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new Ee,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Se=0;Se<ae;Se++)K[Se]=arguments[Se];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=be.apply(ze,K)),Le}};for(var lt in Fe.renderer)Ye(lt);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ne,Ye=function(ge){var be=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Se=0;Se<ae;Se++)K[Se]=arguments[Se];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=be.apply(ze,K)),Le}};for(var lt in Fe.tokenizer)Ye(lt);ue.tokenizer=ze}(),Fe.walkTokens){var qe=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}ve&&(ue.extensions=we),tt.setOptions(ue)})},tt.walkTokens=function(Re,De){for(var Te=function(){var ve=ue.value;switch(De(ve),ve.type){case"table":{for(var Fe=D(ve.header),qe;!(qe=Fe()).done;){var ze=qe.value;tt.walkTokens(ze.tokens,De)}for(var Ye=D(ve.rows),lt;!(lt=Ye()).done;)for(var xe=lt.value,ge=D(xe),be;!(be=ge()).done;){var ae=be.value;tt.walkTokens(ae.tokens,De)}break}case"list":{tt.walkTokens(ve.items,De);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[ve.type]?tt.defaults.extensions.childTokens[ve.type].forEach(function(K){tt.walkTokens(ve[K],De)}):ve.tokens&&tt.walkTokens(ve.tokens,De)}},se=D(Re),ue;!(ue=se()).done;)Te()},tt.parseInline=function(Re,De){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");De=le({},tt.defaults,De||{}),ke(De);try{var Te=at.lexInline(Re,De);return De.walkTokens&&tt.walkTokens(Te,De.walkTokens),J.parseInline(Te,De)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ne(se.message+"",!0)+"</pre>";throw se}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=Ee,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ne,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(A,k,E){return Math.min(Math.max(A,k),E)}e.clamp=g;function L(A,k){return(k+A%k)%k}e.rot=L;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class S{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function Y(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function A(E){S.push(E,Date.now())}function k(){const E=[];for(let C=0;C<S.length;C+=2)E.push({name:S[C],startTime:S[C+1]});return E}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const A of performance.getEntriesByType("mark"))S.push({name:A.name,startTime:Math.round(D+A.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,D=!1,S=!1,A=!1,k=!1,E=!1,C=!1,i,I=g,c,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const w=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=w&&f?.sandboxed,typeof navigator=="object"&&!w)p=navigator.userAgent,L=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=p.indexOf("Linux")>=0,E=!0,i=navigator.language,I=i;else if(typeof f=="object"){L=f.platform==="win32",D=f.platform==="darwin",S=f.platform==="linux",A=S&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,i=g,I=g;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const t=JSON.parse(r),l=t.availableLanguages["*"];i=t.locale,I=l||g,c=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var _;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(_=e.Platform||(e.Platform={}));function P(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=P;let b=0;D?b=1:L?b=3:S&&(b=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=S,e.isLinuxSnap=A,e.isNative=k,e.isWeb=E,e.isIOS=C,e.platform=b,e.userAgent=p,e.language=I;var s;(function(r){function t(){return e.language}r.value=t;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=l;function o(){return e.language==="en"}r.isDefault=o})(s=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",d=>{if(d.data&&d.data.vscodeSetImmediateId)for(let m=0,u=l.length;m<u;m++){const y=l[m];if(y.id===d.data.vscodeSetImmediateId){l.splice(m,1),y.callback();return}}});let o=0;return d=>{const m=++o;l.push({id:m,callback:d}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof f?.nextTick=="function")return f.nextTick.bind(f);const t=Promise.resolve();return l=>t.then(l)}();var a;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:L?1:3;let v=!0,n=!1;function h(){if(!n){n=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,v=new Uint16Array(r.buffer)[0]===(2<<8)+1}return v}e.isLittleEndian=h}),define(fe[37],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const D=g.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,g.setImmediate)(S)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,g.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[9],me([0,1,37]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,S=90,A=122,k=46,E=47,C=92,i=58,I=63;class c extends Error{constructor(a,v,n){let h;typeof v=="string"&&v.indexOf("not ")===0?(h="must not be",v=v.replace(/^not /,"")):h="must be";const r=a.indexOf(".")!==-1?"property":"argument";let t=`The "${a}" ${r} ${h} of type ${v}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(s,a){if(typeof s!="string")throw new c(a,"string",s)}function f(s){return s===E||s===C}function w(s){return s===E}function _(s){return s>=L&&s<=S||s>=D&&s<=A}function P(s,a,v,n){let h="",r=0,t=-1,l=0,o=0;for(let d=0;d<=s.length;++d){if(d<s.length)o=s.charCodeAt(d);else{if(n(o))break;o=E}if(n(o)){if(!(t===d-1||l===1))if(l===2){if(h.length<2||r!==2||h.charCodeAt(h.length-1)!==k||h.charCodeAt(h.length-2)!==k){if(h.length>2){const m=h.lastIndexOf(v);m===-1?(h="",r=0):(h=h.slice(0,m),r=h.length-1-h.lastIndexOf(v)),t=d,l=0;continue}else if(h.length!==0){h="",r=0,t=d,l=0;continue}}a&&(h+=h.length>0?`${v}..`:"..",r=2)}else h.length>0?h+=`${v}${s.slice(t+1,d)}`:h=s.slice(t+1,d),r=d-t-1;t=d,l=0}else o===k&&l!==-1?++l:l=-1}return h}function b(s,a){if(a===null||typeof a!="object")throw new c("pathObject","Object",a);const v=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return v?v===a.root?`${v}${n}`:`${v}${s}${n}`:n}e.win32={resolve(...s){let a="",v="",n=!1;for(let h=s.length-1;h>=-1;h--){let r;if(h>=0){if(r=s[h],p(r,"path"),r.length===0)continue}else a.length===0?r=g.cwd():(r=g.env[`=${a}`]||g.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===C)&&(r=`${a}\\`));const t=r.length;let l=0,o="",d=!1;const m=r.charCodeAt(0);if(t===1)f(m)&&(l=1,d=!0);else if(f(m))if(d=!0,f(r.charCodeAt(1))){let u=2,y=u;for(;u<t&&!f(r.charCodeAt(u));)u++;if(u<t&&u!==y){const T=r.slice(y,u);for(y=u;u<t&&f(r.charCodeAt(u));)u++;if(u<t&&u!==y){for(y=u;u<t&&!f(r.charCodeAt(u));)u++;(u===t||u!==y)&&(o=`\\\\${T}\\${r.slice(y,u)}`,l=u)}}}else l=1;else _(m)&&r.charCodeAt(1)===i&&(o=r.slice(0,2),l=2,t>2&&f(r.charCodeAt(2))&&(d=!0,l=3));if(o.length>0)if(a.length>0){if(o.toLowerCase()!==a.toLowerCase())continue}else a=o;if(n){if(a.length>0)break}else if(v=`${r.slice(l)}\\${v}`,n=d,d&&a.length>0)break}return v=P(v,!n,"\\",f),n?`${a}\\${v}`:`${a}${v}`||"."},normalize(s){p(s,"path");const a=s.length;if(a===0)return".";let v=0,n,h=!1;const r=s.charCodeAt(0);if(a===1)return w(r)?"\\":s;if(f(r))if(h=!0,f(s.charCodeAt(1))){let l=2,o=l;for(;l<a&&!f(s.charCodeAt(l));)l++;if(l<a&&l!==o){const d=s.slice(o,l);for(o=l;l<a&&f(s.charCodeAt(l));)l++;if(l<a&&l!==o){for(o=l;l<a&&!f(s.charCodeAt(l));)l++;if(l===a)return`\\\\${d}\\${s.slice(o)}\\`;l!==o&&(n=`\\\\${d}\\${s.slice(o,l)}`,v=l)}}}else v=1;else _(r)&&s.charCodeAt(1)===i&&(n=s.slice(0,2),v=2,a>2&&f(s.charCodeAt(2))&&(h=!0,v=3));let t=v<a?P(s.slice(v),!h,"\\",f):"";return t.length===0&&!h&&(t="."),t.length>0&&f(s.charCodeAt(a-1))&&(t+="\\"),n===void 0?h?`\\${t}`:t:h?`${n}\\${t}`:`${n}${t}`},isAbsolute(s){p(s,"path");const a=s.length;if(a===0)return!1;const v=s.charCodeAt(0);return f(v)||a>2&&_(v)&&s.charCodeAt(1)===i&&f(s.charCodeAt(2))},join(...s){if(s.length===0)return".";let a,v;for(let r=0;r<s.length;++r){const t=s[r];p(t,"path"),t.length>0&&(a===void 0?a=v=t:a+=`\\${t}`)}if(a===void 0)return".";let n=!0,h=0;if(typeof v=="string"&&f(v.charCodeAt(0))){++h;const r=v.length;r>1&&f(v.charCodeAt(1))&&(++h,r>2&&(f(v.charCodeAt(2))?++h:n=!1))}if(n){for(;h<a.length&&f(a.charCodeAt(h));)h++;h>=2&&(a=`\\${a.slice(h)}`)}return e.win32.normalize(a)},relative(s,a){if(p(s,"from"),p(a,"to"),s===a)return"";const v=e.win32.resolve(s),n=e.win32.resolve(a);if(v===n||(s=v.toLowerCase(),a=n.toLowerCase(),s===a))return"";let h=0;for(;h<s.length&&s.charCodeAt(h)===C;)h++;let r=s.length;for(;r-1>h&&s.charCodeAt(r-1)===C;)r--;const t=r-h;let l=0;for(;l<a.length&&a.charCodeAt(l)===C;)l++;let o=a.length;for(;o-1>l&&a.charCodeAt(o-1)===C;)o--;const d=o-l,m=t<d?t:d;let u=-1,y=0;for(;y<m;y++){const R=s.charCodeAt(h+y);if(R!==a.charCodeAt(l+y))break;R===C&&(u=y)}if(y!==m){if(u===-1)return n}else{if(d>m){if(a.charCodeAt(l+y)===C)return n.slice(l+y+1);if(y===2)return n.slice(l+y)}t>m&&(s.charCodeAt(h+y)===C?u=y:y===2&&(u=3)),u===-1&&(u=0)}let T="";for(y=h+u+1;y<=r;++y)(y===r||s.charCodeAt(y)===C)&&(T+=T.length===0?"..":"\\..");return l+=u,T.length>0?`${T}${n.slice(l,o)}`:(n.charCodeAt(l)===C&&++l,n.slice(l,o))},toNamespacedPath(s){if(typeof s!="string")return s;if(s.length===0)return"";const a=e.win32.resolve(s);if(a.length<=2)return s;if(a.charCodeAt(0)===C){if(a.charCodeAt(1)===C){const v=a.charCodeAt(2);if(v!==I&&v!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(_(a.charCodeAt(0))&&a.charCodeAt(1)===i&&a.charCodeAt(2)===C)return`\\\\?\\${a}`;return s},dirname(s){p(s,"path");const a=s.length;if(a===0)return".";let v=-1,n=0;const h=s.charCodeAt(0);if(a===1)return f(h)?s:".";if(f(h)){if(v=n=1,f(s.charCodeAt(1))){let l=2,o=l;for(;l<a&&!f(s.charCodeAt(l));)l++;if(l<a&&l!==o){for(o=l;l<a&&f(s.charCodeAt(l));)l++;if(l<a&&l!==o){for(o=l;l<a&&!f(s.charCodeAt(l));)l++;if(l===a)return s;l!==o&&(v=n=l+1)}}}}else _(h)&&s.charCodeAt(1)===i&&(v=a>2&&f(s.charCodeAt(2))?3:2,n=v);let r=-1,t=!0;for(let l=a-1;l>=n;--l)if(f(s.charCodeAt(l))){if(!t){r=l;break}}else t=!1;if(r===-1){if(v===-1)return".";r=v}return s.slice(0,r)},basename(s,a){a!==void 0&&p(a,"ext"),p(s,"path");let v=0,n=-1,h=!0,r;if(s.length>=2&&_(s.charCodeAt(0))&&s.charCodeAt(1)===i&&(v=2),a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let t=a.length-1,l=-1;for(r=s.length-1;r>=v;--r){const o=s.charCodeAt(r);if(f(o)){if(!h){v=r+1;break}}else l===-1&&(h=!1,l=r+1),t>=0&&(o===a.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=l))}return v===n?n=l:n===-1&&(n=s.length),s.slice(v,n)}for(r=s.length-1;r>=v;--r)if(f(s.charCodeAt(r))){if(!h){v=r+1;break}}else n===-1&&(h=!1,n=r+1);return n===-1?"":s.slice(v,n)},extname(s){p(s,"path");let a=0,v=-1,n=0,h=-1,r=!0,t=0;s.length>=2&&s.charCodeAt(1)===i&&_(s.charCodeAt(0))&&(a=n=2);for(let l=s.length-1;l>=a;--l){const o=s.charCodeAt(l);if(f(o)){if(!r){n=l+1;break}continue}h===-1&&(r=!1,h=l+1),o===k?v===-1?v=l:t!==1&&(t=1):v!==-1&&(t=-1)}return v===-1||h===-1||t===0||t===1&&v===h-1&&v===n+1?"":s.slice(v,h)},format:b.bind(null,"\\"),parse(s){p(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const v=s.length;let n=0,h=s.charCodeAt(0);if(v===1)return f(h)?(a.root=a.dir=s,a):(a.base=a.name=s,a);if(f(h)){if(n=1,f(s.charCodeAt(1))){let u=2,y=u;for(;u<v&&!f(s.charCodeAt(u));)u++;if(u<v&&u!==y){for(y=u;u<v&&f(s.charCodeAt(u));)u++;if(u<v&&u!==y){for(y=u;u<v&&!f(s.charCodeAt(u));)u++;u===v?n=u:u!==y&&(n=u+1)}}}}else if(_(h)&&s.charCodeAt(1)===i){if(v<=2)return a.root=a.dir=s,a;if(n=2,f(s.charCodeAt(2))){if(v===3)return a.root=a.dir=s,a;n=3}}n>0&&(a.root=s.slice(0,n));let r=-1,t=n,l=-1,o=!0,d=s.length-1,m=0;for(;d>=n;--d){if(h=s.charCodeAt(d),f(h)){if(!o){t=d+1;break}continue}l===-1&&(o=!1,l=d+1),h===k?r===-1?r=d:m!==1&&(m=1):r!==-1&&(m=-1)}return l!==-1&&(r===-1||m===0||m===1&&r===l-1&&r===t+1?a.base=a.name=s.slice(t,l):(a.name=s.slice(t,r),a.base=s.slice(t,l),a.ext=s.slice(r,l))),t>0&&t!==n?a.dir=s.slice(0,t-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...s){let a="",v=!1;for(let n=s.length-1;n>=-1&&!v;n--){const h=n>=0?s[n]:g.cwd();p(h,"path"),h.length!==0&&(a=`${h}/${a}`,v=h.charCodeAt(0)===E)}return a=P(a,!v,"/",w),v?`/${a}`:a.length>0?a:"."},normalize(s){if(p(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===E,v=s.charCodeAt(s.length-1)===E;return s=P(s,!a,"/",w),s.length===0?a?"/":v?"./":".":(v&&(s+="/"),a?`/${s}`:s)},isAbsolute(s){return p(s,"path"),s.length>0&&s.charCodeAt(0)===E},join(...s){if(s.length===0)return".";let a;for(let v=0;v<s.length;++v){const n=s[v];p(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(s,a){if(p(s,"from"),p(a,"to"),s===a||(s=e.posix.resolve(s),a=e.posix.resolve(a),s===a))return"";const v=1,n=s.length,h=n-v,r=1,t=a.length-r,l=h<t?h:t;let o=-1,d=0;for(;d<l;d++){const u=s.charCodeAt(v+d);if(u!==a.charCodeAt(r+d))break;u===E&&(o=d)}if(d===l)if(t>l){if(a.charCodeAt(r+d)===E)return a.slice(r+d+1);if(d===0)return a.slice(r+d)}else h>l&&(s.charCodeAt(v+d)===E?o=d:d===0&&(o=0));let m="";for(d=v+o+1;d<=n;++d)(d===n||s.charCodeAt(d)===E)&&(m+=m.length===0?"..":"/..");return`${m}${a.slice(r+o)}`},toNamespacedPath(s){return s},dirname(s){if(p(s,"path"),s.length===0)return".";const a=s.charCodeAt(0)===E;let v=-1,n=!0;for(let h=s.length-1;h>=1;--h)if(s.charCodeAt(h)===E){if(!n){v=h;break}}else n=!1;return v===-1?a?"/":".":a&&v===1?"//":s.slice(0,v)},basename(s,a){a!==void 0&&p(a,"ext"),p(s,"path");let v=0,n=-1,h=!0,r;if(a!==void 0&&a.length>0&&a.length<=s.length){if(a===s)return"";let t=a.length-1,l=-1;for(r=s.length-1;r>=0;--r){const o=s.charCodeAt(r);if(o===E){if(!h){v=r+1;break}}else l===-1&&(h=!1,l=r+1),t>=0&&(o===a.charCodeAt(t)?--t==-1&&(n=r):(t=-1,n=l))}return v===n?n=l:n===-1&&(n=s.length),s.slice(v,n)}for(r=s.length-1;r>=0;--r)if(s.charCodeAt(r)===E){if(!h){v=r+1;break}}else n===-1&&(h=!1,n=r+1);return n===-1?"":s.slice(v,n)},extname(s){p(s,"path");let a=-1,v=0,n=-1,h=!0,r=0;for(let t=s.length-1;t>=0;--t){const l=s.charCodeAt(t);if(l===E){if(!h){v=t+1;break}continue}n===-1&&(h=!1,n=t+1),l===k?a===-1?a=t:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||n===-1||r===0||r===1&&a===n-1&&a===v+1?"":s.slice(a,n)},format:b.bind(null,"/"),parse(s){p(s,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(s.length===0)return a;const v=s.charCodeAt(0)===E;let n;v?(a.root="/",n=1):n=0;let h=-1,r=0,t=-1,l=!0,o=s.length-1,d=0;for(;o>=n;--o){const m=s.charCodeAt(o);if(m===E){if(!l){r=o+1;break}continue}t===-1&&(l=!1,t=o+1),m===k?h===-1?h=o:d!==1&&(d=1):h!==-1&&(d=-1)}if(t!==-1){const m=r===0&&v?1:r;h===-1||d===0||d===1&&h===t-1&&h===r+1?a.base=a.name=s.slice(m,t):(a.name=s.slice(m,h),a.base=s.slice(m,t),a.ext=s.slice(h,t))}return r>0?a.dir=s.slice(0,r-1):v&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(S,...A){const k=A.reduce((i,I)=>(i[I]=!0,i),{}),E=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(i=>!k[i]).forEach(i=>{for(let I=0;I<E.length;I++)if(i.search(E[I])!==-1){delete S[i];break}})}e.sanitizeProcessEnvironment=D}),define(fe[46],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class D{constructor(A){this._highResolution=L&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new D(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=D}),define(fe[3],me([0,1,18,75,6,93,46]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(a){a.None=()=>D.Disposable.None;function v(M){return(z,N=null,U)=>{let x=!1,O;return O=M(j=>{if(!x)return O?O.dispose():x=!0,z.call(N,j)},null,U),x&&O.dispose(),O}}a.once=v;function n(M,z){return d((N,U=null,x)=>M(O=>N.call(U,z(O)),null,x))}a.map=n;function h(M,z){return d((N,U=null,x)=>M(O=>{z(O),N.call(U,O)},null,x))}a.forEach=h;function r(M,z){return d((N,U=null,x)=>M(O=>z(O)&&N.call(U,O),null,x))}a.filter=r;function t(M){return M}a.signal=t;function l(...M){return(z,N=null,U)=>(0,D.combinedDisposable)(...M.map(x=>x(O=>z.call(N,O),null,U)))}a.any=l;function o(M,z,N){let U=N;return n(M,x=>(U=z(U,x),U))}a.reduce=o;function d(M){let z;const N=new c({onFirstListenerAdd(){z=M(N.fire,N)},onLastListenerRemove(){z.dispose()}});return N.event}function m(M,z,N=100,U=!1,x){let O,j,H,X=0;const Q=new c({leakWarningThreshold:x,onFirstListenerAdd(){O=M(de=>{X++,j=z(j,de),U&&!H&&(Q.fire(j),j=void 0),clearTimeout(H),H=setTimeout(()=>{const _e=j;j=void 0,H=void 0,(!U||X>1)&&Q.fire(_e),X=0},N)})},onLastListenerRemove(){O.dispose()}});return Q.event}a.debounce=m;function u(M,z=(N,U)=>N===U){let N=!0,U;return r(M,x=>{const O=N||!z(x,U);return N=!1,U=x,O})}a.latch=u;function y(M,z){return[a.filter(M,z),a.filter(M,N=>!z(N))]}a.split=y;function T(M,z=!1,N=[]){let U=N.slice(),x=M(H=>{U?U.push(H):j.fire(H)});const O=()=>{U&&U.forEach(H=>j.fire(H)),U=null},j=new c({onFirstListenerAdd(){x||(x=M(H=>j.fire(H)))},onFirstListenerDidAdd(){U&&(z?setTimeout(O):O())},onLastListenerRemove(){x&&x.dispose(),x=null}});return j.event}a.buffer=T;class R{constructor(z){this.event=z}map(z){return new R(n(this.event,z))}forEach(z){return new R(h(this.event,z))}filter(z){return new R(r(this.event,z))}reduce(z,N){return new R(o(this.event,z,N))}latch(){return new R(u(this.event))}debounce(z,N=100,U=!1,x){return new R(m(this.event,z,N,U,x))}on(z,N,U){return this.event(z,N,U)}once(z,N,U){return v(this.event)(z,N,U)}}function $(M){return new R(M)}a.chain=$;function B(M,z,N=U=>U){const U=(...H)=>j.fire(N(...H)),x=()=>M.on(z,U),O=()=>M.removeListener(z,U),j=new c({onFirstListenerAdd:x,onLastListenerRemove:O});return j.event}a.fromNodeEventEmitter=B;function F(M,z,N=U=>U){const U=(...H)=>j.fire(N(...H)),x=()=>M.addEventListener(z,U),O=()=>M.removeEventListener(z,U),j=new c({onFirstListenerAdd:x,onLastListenerRemove:O});return j.event}a.fromDOMEventEmitter=F;function W(M){return new Promise(z=>v(M)(z))}a.toPromise=W})(k=e.Event||(e.Event={}));class E{constructor(v){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${v}_${E._idPool++}`}start(v){this._stopWatch=new A.StopWatch(!0),this._listenerCount=v}stop(){if(this._stopWatch){const v=this._stopWatch.elapsed();this._elapsedOverall+=v,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${v.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let C=-1;function i(a){const v=C;return C=a,{dispose(){C=v}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(v,n=Math.random().toString(18).slice(2,5)){this.customThreshold=v,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(v){let n=C;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||v<n)return;this._stacks||(this._stacks=new Map);const h=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(h)||0;if(this._stacks.set(h,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,l=0;for(const[o,d]of this._stacks)(!t||l<d)&&(t=o,l=d);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${l}):`),console.warn(t)}return()=>{const t=this._stacks.get(h)||0;this._stacks.set(h,t-1)}}}class c{constructor(v){this._disposed=!1,this._options=v,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(v,n,h)=>{this._listeners||(this._listeners=new S.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[v,n]:v);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,v,n);const l=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{l&&l(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return h instanceof D.DisposableStore?h.add(o):Array.isArray(h)&&h.push(o),o}),this._event}fire(v){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,v]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,h]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,h):n[0].call(n[1],h)}catch(r){(0,g.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class p extends c{async fireAsync(v,n,h){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,v]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[r,t]=this._asyncDeliveryQueue.shift(),l=[],o={...t,waitUntil:d=>{if(Object.isFrozen(l))throw new Error("waitUntil can NOT be called asynchronous");h&&(d=h(d,typeof r=="function"?r:r[0])),l.push(d)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(d){(0,g.onUnexpectedError)(d);continue}Object.freeze(l),await Promise.allSettled(l).then(d=>{for(const m of d)m.status==="rejected"&&(0,g.onUnexpectedError)(m.reason)})}}}}e.AsyncEmitter=p;class f extends c{constructor(v){super(v);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=v?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const v=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(v))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(v){this._listeners&&(this._isPaused!==0?this._eventQueue.push(v):super.fire(v))}}e.PauseableEmitter=f;class w extends f{constructor(v){super(v);this._delay=v.delay??100}fire(v){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(v)}}e.DebounceEmitter=w;class _ extends c{constructor(v){super(v);this._queuedEvents=[],this._mergeFn=v?.merge}fire(v){this._queuedEvents.push(v),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=_;class P{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(v){const n={event:v,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const h=()=>{this.hasListeners&&this.unhook(n);const r=this.events.indexOf(n);this.events.splice(r,1)};return(0,D.toDisposable)((0,L.once)(h))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(v=>this.hook(v))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(v=>this.unhook(v))}hook(v){v.listener=v.event(n=>this.emitter.fire(n))}unhook(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=P;class b{constructor(){this.buffers=[]}wrapEvent(v){return(n,h,r)=>v(t=>{const l=this.buffers[this.buffers.length-1];l?l.push(()=>n.call(h,t)):n.call(h,t)},void 0,r)}bufferEvents(v){const n=[];this.buffers.push(n);const h=v();return this.buffers.pop(),n.forEach(r=>r()),h}}e.EventBufferer=b;class s{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=D.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(v){this.inputEvent=v,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=v(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=s}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,E){const C=setTimeout(k.bind(E),0);return{dispose(){clearTimeout(C)}}});var D;(function(k){function E(C){return C===k.None||C===k.Cancelled||C instanceof S?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}k.isCancellationToken=E,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=A}),define(fe[47],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const c=this._icons.get(I.id);c?I.description?c.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function S(i,I){return new k(i,I)}e.registerCodicon=S;function A(i){return i?i.replace(/\$\((.*?)\)/g,(I,c)=>` ${c} `).trim():""}e.getCodiconAriaLabel=A;class k{constructor(I,c,p){this.id=I,this.definition=c,this.description=p,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function E(i,I){const c=["codicon","codicon-"+i];return I&&c.push("codicon-modifier-"+I),c}e.getClassNamesArray=E;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+",i.iconNameCharacter="[A-Za-z0-9\\-~]";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function c(w){if(w instanceof k)return["codicon","codicon-"+w.id];const _=I.exec(w.id);if(!_)return c(k.error);let[,P,b]=_;const s=["codicon","codicon-"+P];return b&&s.push("codicon-modifier-"+b.substr(1)),s}i.asClassNameArray=c;function p(w){return c(w).join(" ")}i.asClassName=p;function f(w){return"."+c(w).join(".")}i.asCSSSelector=f})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"})}(k=e.Codicon||(e.Codicon={}))}),define(fe[95],me([0,1,18,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(s){const a=s;return a?[a.on,a.pause,a.resume,a.destroy].every(v=>typeof v=="function"):!1}e.isReadableStream=D;function S(s){const a=s;return a?D(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(s,a){return new k(s,a)}e.newWriteableStream=A;class k{constructor(a,v){this.reducer=a,this.options=v,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(v=>this.pendingWritePromises.push(v))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(v=>v(a))}emitError(a){this.listeners.error.length===0?(0,g.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(v=>v(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,v){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(v),this.resume();break;case"end":this.listeners.end.push(v),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(v),this.state.flowing&&this.flowErrors();break}}removeListener(a,v){if(this.state.destroyed)return;let n;switch(a){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const h=n.indexOf(v);h>=0&&n.splice(h,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const v=[...this.pendingWritePromises];this.pendingWritePromises.length=0,v.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(s,a){const v=[];let n;for(;(n=s.read())!==null;)v.push(n);return a(v)}e.consumeReadable=E;function C(s,a,v){const n=[];let h;for(;(h=s.read())!==null&&n.length<v;)n.push(h);return h===null&&n.length>0?a(n):{read:()=>{if(n.length>0)return n.shift();if(typeof h!="undefined"){const r=h;return h=void 0,r}return s.read()}}}e.peekReadable=C;function i(s,a){return new Promise((v,n)=>{const h=[];I(s,{onData:r=>{a&&h.push(r)},onError:r=>{a?n(r):v(void 0)},onEnd:()=>{v(a?a(h):void 0)}})})}e.consumeStream=i;function I(s,a){s.on("error",v=>a.onError(v)),s.on("end",()=>a.onEnd()),s.on("data",v=>a.onData(v))}e.listenStream=I;function c(s,a){return new Promise((v,n)=>{const h=new L.DisposableStore,r=[],t=d=>{if(r.push(d),r.length>a)return h.dispose(),s.pause(),v({stream:s,buffer:r,ended:!1})},l=d=>n(d),o=()=>v({stream:s,buffer:r,ended:!0});h.add((0,L.toDisposable)(()=>s.removeListener("error",l))),s.on("error",l),h.add((0,L.toDisposable)(()=>s.removeListener("end",o))),s.on("end",o),h.add((0,L.toDisposable)(()=>s.removeListener("data",t))),s.on("data",t)})}e.peekStream=c;function p(s,a){const v=A(a);return v.end(s),v}e.toStream=p;function f(){const s=A(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=f;function w(s){let a=!1;return{read:()=>a?null:(a=!0,s)}}e.toReadable=w;function _(s,a,v){const n=A(v);return I(s,{onData:h=>n.write(a.data(h)),onError:h=>n.error(a.error?a.error(h):h),onEnd:()=>n.end()}),n}e.transform=_;function P(s,a,v){let n=!1;return{read:()=>{const h=a.read();return n?h:(n=!0,h!==null?v([s,h]):s)}}}e.prefixedReadable=P;function b(s,a,v){let n=!1;const h=A(v);return I(a,{onData:r=>n?h.write(r):(n=!0,h.write(v([s,r]))),onError:r=>h.error(r),onEnd:()=>{n||(n=!0,h.write(s)),h.end()}}),h}e.prefixedStream=b}),define(fe[22],me([0,1,95]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,S;class A{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new A(Buffer.allocUnsafe(t)):new A(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new A(t)}static fromString(t,l){return!(l?.dontUseNodeBuffer||!1)&&L?new A(Buffer.from(t)):(D||(D=new TextEncoder),new A(D.encode(t)))}static concat(t,l){if(typeof l=="undefined"){l=0;for(let m=0,u=t.length;m<u;m++)l+=t[m].byteLength}const o=A.alloc(l);let d=0;for(let m=0,u=t.length;m<u;m++){const y=t[m];o.set(y,d),d+=y.byteLength}return o}toString(){return L?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(t,l){return new A(this.buffer.subarray(t,l))}set(t,l){t instanceof A?this.buffer.set(t.buffer,l):this.buffer.set(t,l)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,l){i(this.buffer,t,l)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,l){c(this.buffer,t,l)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,l){f(this.buffer,t,l)}}e.VSBuffer=A;function k(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0}e.readUInt16LE=k;function E(r,t,l){r[l+0]=t&255,t=t>>>8,r[l+1]=t&255}e.writeUInt16LE=E;function C(r,t){return r[t]*2**24+r[t+1]*2**16+r[t+2]*2**8+r[t+3]}e.readUInt32BE=C;function i(r,t,l){r[l+3]=t,t=t>>>8,r[l+2]=t,t=t>>>8,r[l+1]=t,t=t>>>8,r[l]=t}e.writeUInt32BE=i;function I(r,t){return r[t+0]<<0>>>0|r[t+1]<<8>>>0|r[t+2]<<16>>>0|r[t+3]<<24>>>0}e.readUInt32LE=I;function c(r,t,l){r[l+0]=t&255,t=t>>>8,r[l+1]=t&255,t=t>>>8,r[l+2]=t&255,t=t>>>8,r[l+3]=t&255}e.writeUInt32LE=c;function p(r,t){return r[t]}e.readUInt8=p;function f(r,t,l){r[l]=t}e.writeUInt8=f;function w(r){return g.consumeReadable(r,t=>A.concat(t))}e.readableToBuffer=w;function _(r){return g.toReadable(r)}e.bufferToReadable=_;function P(r){return g.consumeStream(r,t=>A.concat(t))}e.streamToBuffer=P;async function b(r){return r.ended?A.concat(r.buffer):A.concat([...r.buffer,await P(r.stream)])}e.bufferedStreamToBuffer=b;function s(r){return g.toStream(r,t=>A.concat(t))}e.bufferToStream=s;function a(r){return g.transform(r,{data:t=>typeof t=="string"?A.fromString(t):A.wrap(t)},t=>A.concat(t))}e.streamToBufferReadableStream=a;function v(r){return g.newWriteableStream(t=>A.concat(t),r)}e.newWriteableBufferStream=v;function n(r,t){return g.prefixedReadable(r,t,l=>A.concat(l))}e.prefixedBufferReadable=n;function h(r,t){return g.prefixedStream(r,t,l=>A.concat(l))}e.prefixedBufferStream=h}),define(fe[8],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(le){return!le||typeof le!="string"?!0:le.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function D(le,...ke){return ke.length===0?le:le.replace(L,function(Ne,Xe){const nt=parseInt(Xe,10);return isNaN(nt)||nt<0||nt>=ke.length?Ne:ke[nt]})}e.format=D;const S=/{([^}]+)}/g;function A(le,ke){return le.replace(S,(Ne,Xe)=>ke[Xe]??Ne)}e.format2=A;function k(le){return le.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.escape=k;function E(le){return le.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function C(le,ke){let Ne=0;const Xe=ke.charCodeAt(0);for(let nt=le.length-1;nt>=0;nt--)le.charCodeAt(nt)===Xe&&Ne++;return Ne}e.count=C;function i(le,ke,Ne="\u2026"){return le.length<=ke?le:`${le.substr(0,ke)}${Ne}`}e.truncate=i;function I(le,ke=" "){const Ne=c(le,ke);return p(Ne,ke)}e.trim=I;function c(le,ke){if(!le||!ke)return le;const Ne=ke.length;if(Ne===0||le.length===0)return le;let Xe=0;for(;le.indexOf(ke,Xe)===Xe;)Xe=Xe+Ne;return le.substring(Xe)}e.ltrim=c;function p(le,ke){if(!le||!ke)return le;const Ne=ke.length,Xe=le.length;if(Ne===0||Xe===0)return le;let nt=Xe,ft=-1;for(;ft=le.lastIndexOf(ke,nt-1),!(ft===-1||ft+Ne!==nt);){if(ft===0)return"";nt=ft}return le.substring(0,nt)}e.rtrim=p;function f(le){return le.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function w(le){return le.replace(/\*/g,"")}e.stripWildcards=w;function _(le,ke,Ne={}){if(!le)throw new Error("Cannot create regex from empty string");ke||(le=E(le)),Ne.wholeWord&&(/\B/.test(le.charAt(0))||(le="\\b"+le),/\B/.test(le.charAt(le.length-1))||(le=le+"\\b"));let Xe="";return Ne.global&&(Xe+="g"),Ne.matchCase||(Xe+="i"),Ne.multiline&&(Xe+="m"),Ne.unicode&&(Xe+="u"),new RegExp(le,Xe)}e.createRegExp=_;function P(le){return le.source==="^"||le.source==="^$"||le.source==="$"||le.source==="^\\s*$"?!1:!!(le.exec("")&&le.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function b(le){return!!le.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function s(le){return(le.global?"g":"")+(le.ignoreCase?"i":"")+(le.multiline?"m":"")+(le.unicode?"u":"")}e.regExpFlags=s;function a(le){return le.split(/\r\n|\r|\n/)}e.splitLines=a;function v(le){for(let ke=0,Ne=le.length;ke<Ne;ke++){const Xe=le.charCodeAt(ke);if(Xe!==32&&Xe!==9)return ke}return-1}e.firstNonWhitespaceIndex=v;function n(le,ke=0,Ne=le.length){for(let Xe=ke;Xe<Ne;Xe++){const nt=le.charCodeAt(Xe);if(nt!==32&&nt!==9)return le.substring(ke,Xe)}return le.substring(ke,Ne)}e.getLeadingWhitespace=n;function h(le,ke=le.length-1){for(let Ne=ke;Ne>=0;Ne--){const Xe=le.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ne}return-1}e.lastNonWhitespaceIndex=h;function r(le,ke){return le<ke?-1:le>ke?1:0}e.compare=r;function t(le,ke,Ne=0,Xe=le.length,nt=0,ft=ke.length){for(;Ne<Xe&&nt<ft;Ne++,nt++){let Re=le.charCodeAt(Ne),De=ke.charCodeAt(nt);if(Re<De)return-1;if(Re>De)return 1}const tt=Xe-Ne,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function l(le,ke){return o(le,ke,0,le.length,0,ke.length)}e.compareIgnoreCase=l;function o(le,ke,Ne=0,Xe=le.length,nt=0,ft=ke.length){for(;Ne<Xe&&nt<ft;Ne++,nt++){let Re=le.charCodeAt(Ne),De=ke.charCodeAt(nt);if(Re===De)continue;if(Re>=128||De>=128)return t(le.toLowerCase(),ke.toLowerCase(),Ne,Xe,nt,ft);d(Re)&&(Re-=32),d(De)&&(De-=32);const Te=Re-De;if(Te!==0)return Te}const tt=Xe-Ne,ut=ft-nt;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=o;function d(le){return le>=97&&le<=122}e.isLowerAsciiLetter=d;function m(le){return le>=65&&le<=90}e.isUpperAsciiLetter=m;function u(le,ke){return le.length===ke.length&&o(le,ke)===0}e.equalsIgnoreCase=u;function y(le,ke){const Ne=ke.length;return ke.length>le.length?!1:o(le,ke,0,Ne)===0}e.startsWithIgnoreCase=y;function T(le,ke){let Ne,Xe=Math.min(le.length,ke.length);for(Ne=0;Ne<Xe;Ne++)if(le.charCodeAt(Ne)!==ke.charCodeAt(Ne))return Ne;return Xe}e.commonPrefixLength=T;function R(le,ke){let Ne,Xe=Math.min(le.length,ke.length);const nt=le.length-1,ft=ke.length-1;for(Ne=0;Ne<Xe;Ne++)if(le.charCodeAt(nt-Ne)!==ke.charCodeAt(ft-Ne))return Ne;return Xe}e.commonSuffixLength=R;function $(le){return 55296<=le&&le<=56319}e.isHighSurrogate=$;function B(le){return 56320<=le&&le<=57343}e.isLowSurrogate=B;function F(le,ke){return(le-55296<<10)+(ke-56320)+65536}e.computeCodePoint=F;function W(le,ke,Ne){const Xe=le.charCodeAt(Ne);if($(Xe)&&Ne+1<ke){const nt=le.charCodeAt(Ne+1);if(B(nt))return F(Xe,nt)}return Xe}e.getNextCodePoint=W;function M(le,ke){const Ne=le.charCodeAt(ke-1);if(B(Ne)&&ke>1){const Xe=le.charCodeAt(ke-2);if($(Xe))return F(Xe,Ne)}return Ne}function z(le,ke){const Ne=ye.getInstance(),Xe=ke,nt=le.length,ft=W(le,nt,ke);ke+=ft>=65536?2:1;let tt=Ne.getGraphemeBreakType(ft);for(;ke<nt;){const ut=W(le,nt,ke),Re=Ne.getGraphemeBreakType(ut);if(rt(tt,Re))break;ke+=ut>=65536?2:1,tt=Re}return ke-Xe}e.nextCharLength=z;function N(le,ke){const Ne=ye.getInstance(),Xe=ke,nt=M(le,ke);ke-=nt>=65536?2:1;let ft=Ne.getGraphemeBreakType(nt);for(;ke>0;){const tt=M(le,ke),ut=Ne.getGraphemeBreakType(tt);if(rt(ut,ft))break;ke-=tt>=65536?2:1,ft=ut}return Xe-ke}e.prevCharLength=N;function U(le,ke){const Ne=ye.getInstance(),Xe=le.length,nt=ke,ft=W(le,Xe,ke),tt=Ne.getGraphemeBreakType(ft);ke+=ft>=65536?2:1;let ut=tt;for(;ke<Xe;){const De=W(le,Xe,ke),Te=Ne.getGraphemeBreakType(De);if(rt(ut,Te))break;ke+=De>=65536?2:1,ut=Te}const Re=ke;for(ke=nt,ut=tt;ke>0;){const De=M(le,ke),Te=Ne.getGraphemeBreakType(De);if(rt(Te,ut))break;ke-=De>=65536?2:1,ut=Te}return[ke,Re]}function x(le,ke){return ke>0&&B(le.charCodeAt(ke))?U(le,ke-1):U(le,ke)}e.getCharContainingOffset=x;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function j(le){return O.test(le)}e.containsRTL=j;const H=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(le){return H.test(le)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(le){return Q.test(le)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function _e(le){return e.UNUSUAL_LINE_TERMINATORS.test(le)}e.containsUnusualLineTerminators=_e;function Ie(le){for(let ke=0,Ne=le.length;ke<Ne;ke++)if(Pe(le.charCodeAt(ke)))return!0;return!1}e.containsFullWidthCharacter=Ie;function Pe(le){return le>=11904&&le<=55215||le>=63744&&le<=64255||le>=65281&&le<=65374}e.isFullWidthCharacter=Pe;function We(le){return le>=127462&&le<=127487||le===8986||le===8987||le===9200||le===9203||le>=9728&&le<=10175||le===11088||le===11093||le>=127744&&le<=128591||le>=128640&&le<=128764||le>=128992&&le<=129003||le>=129280&&le<=129535||le>=129648&&le<=129750}e.isEmojiImprecise=We;function Be(le,ke){if(le.length<ke)return le;const Ne=/\b/g;let Xe=0;for(;Ne.test(le)&&!(le.length-Ne.lastIndex<ke);)Xe=Ne.lastIndex,Ne.lastIndex+=1;return le.substring(Xe).replace(/^\s/,"")}e.lcut=Be;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ie(le){return le&&(le=le.replace(He,""),le=le.replace(G,""),le=le.replace(ee,"")),le}e.removeAnsiEscapeCodes=ie,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(le){return!!(le&&le.length>0&&le.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function Z(le){return ce(le)?le.substr(1):le}e.stripUTF8BOM=Z;function re(le,ke){if(!le||!ke||le.length<ke.length)return!1;const Ne=ke.length,Xe=le.toLowerCase();let nt=0,ft=-1;for(;nt<Ne;){const tt=Xe.indexOf(ke[nt],ft+1);if(tt<0)return!1;ft=tt,nt++}return!0}e.fuzzyContains=re;function pe(le,ke=!1){return le?(ke&&(le=le.replace(/\\./g,"")),le.toLowerCase()!==le):!1}e.containsUppercaseCharacter=pe;function Me(le){return le.charAt(0).toUpperCase()+le.slice(1)}e.uppercaseFirstLetter=Me;function je(le,ke=1){if(ke===0)return"";let Ne=-1;do Ne=le.indexOf(`
`,Ne+1),ke--;while(ke>0&&Ne>=0);return Ne===-1?le:(le[Ne-1]==="\r"&&Ne--,le.substr(0,Ne))}e.getNLines=je;function Ke(le){const ke=90-65+1;return le=le%(2*ke),le<ke?String.fromCharCode(97+le):String.fromCharCode(65+le-ke)}e.singleLetterHash=Ke;function Ze(le){return ye.getInstance().getGraphemeBreakType(le)}e.getGraphemeBreakType=Ze;function rt(le,ke){return le===0?ke!==5&&ke!==7:le===2&&ke===3?!1:le===4||le===2||le===3||ke===4||ke===2||ke===3?!0:!(le===8&&(ke===8||ke===9||ke===11||ke===12)||(le===11||le===9)&&(ke===9||ke===10)||(le===12||le===10)&&ke===10||ke===5||ke===13||ke===7||le===1||le===13&&ke===14||le===6&&ke===6)}e.breakBetweenGraphemeBreakType=rt;var ct;(function(le){le[le.Other=0]="Other",le[le.Prepend=1]="Prepend",le[le.CR=2]="CR",le[le.LF=3]="LF",le[le.Control=4]="Control",le[le.Extend=5]="Extend",le[le.Regional_Indicator=6]="Regional_Indicator",le[le.SpacingMark=7]="SpacingMark",le[le.L=8]="L",le[le.V=9]="V",le[le.T=10]="T",le[le.LV=11]="LV",le[le.LVT=12]="LVT",le[le.ZWJ=13]="ZWJ",le[le.Extended_Pictographic=14]="Extended_Pictographic"})(ct=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Ne=this._data,Xe=Ne.length/3;let nt=1;for(;nt<=Xe;)if(ke<Ne[3*nt])nt=2*nt;else if(ke>Ne[3*nt+1])nt=2*nt+1;else return Ne[3*nt+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(le,ke){if(le===0)return 0;const Ne=ne(le,ke);if(Ne!==void 0)return Ne;const Xe=M(ke,le);return le-=Ee(Xe),le}e.getLeftDeleteOffset=J;function ne(le,ke){let Ne=M(ke,le);for(le-=Ee(Ne);Qe(Ne)||Ne===65039||Ne===8419;){if(le===0)return;Ne=M(ke,le),le-=Ee(Ne)}if(!!We(Ne)){if(le>=0){const Xe=M(ke,le);Xe===8205&&(le-=Ee(Xe))}return le}}function Ee(le){return le>=65536?2:1}function Qe(le){return 127995<=le&&le<=127999}var et;(function(le){le[le.zwj=8205]="zwj",le[le.emojiVariantSelector=65039]="emojiVariantSelector",le[le.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.noBreakWhitespace="\xA0"}),define(fe[48],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(P){return D(P,0)}e.hash=L;function D(P,b){switch(typeof P){case"object":return P===null?S(349,b):Array.isArray(P)?E(P,b):C(P,b);case"string":return k(P,b);case"boolean":return A(P,b);case"number":return S(P,b);case"undefined":return S(937,b);default:return S(617,b)}}e.doHash=D;function S(P,b){return(b<<5)-b+P|0}e.numberHash=S;function A(P,b){return S(P?433:863,b)}function k(P,b){b=S(149417,b);for(let s=0,a=P.length;s<a;s++)b=S(P.charCodeAt(s),b);return b}e.stringHash=k;function E(P,b){return b=S(104579,b),P.reduce((s,a)=>D(a,s),b)}function C(P,b){return b=S(181387,b),Object.keys(P).sort().reduce((s,a)=>(s=k(a,s),D(P[a],s)),b)}class i{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=D(b,this._value),this._value}}e.Hasher=i;var I;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(P,b,s=32){const a=s-b,v=~((1<<a)-1);return(P<<b|(v&P)>>>a)>>>0}function p(P,b=0,s=P.byteLength,a=0){for(let v=0;v<s;v++)P[b+v]=a}function f(P,b,s="0"){for(;P.length<b;)P=s+P;return P}function w(P,b=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(s=>s.toString(16).padStart(2,"0")).join(""):f((P>>>0).toString(16),b/4)}e.toHexString=w;class _{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const s=b.length;if(s===0)return;const a=this._buff;let v=this._buffLen,n=this._leftoverHighSurrogate,h,r;for(n!==0?(h=n,r=-1,n=0):(h=b.charCodeAt(0),r=0);;){let t=h;if(g.isHighSurrogate(h))if(r+1<s){const l=b.charCodeAt(r+1);g.isLowSurrogate(l)?(r++,t=g.computeCodePoint(h,l)):t=65533}else{n=h;break}else g.isLowSurrogate(h)&&(t=65533);if(v=this._push(a,v,t),r++,r<s)h=b.charCodeAt(r);else break}this._buffLen=v,this._leftoverHighSurrogate=n}_push(b,s,a){return a<128?b[s++]=a:a<2048?(b[s++]=192|(a&1984)>>>6,b[s++]=128|(a&63)>>>0):a<65536?(b[s++]=224|(a&61440)>>>12,b[s++]=128|(a&4032)>>>6,b[s++]=128|(a&63)>>>0):(b[s++]=240|(a&1835008)>>>18,b[s++]=128|(a&258048)>>>12,b[s++]=128|(a&4032)>>>6,b[s++]=128|(a&63)>>>0),s>=64&&(this._step(),s-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),s}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=_._bigBlock32,s=this._buffDV;for(let d=0;d<64;d+=4)b.setUint32(d,s.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)b.setUint32(d,c(b.getUint32(d-12,!1)^b.getUint32(d-32,!1)^b.getUint32(d-56,!1)^b.getUint32(d-64,!1),1),!1);let a=this._h0,v=this._h1,n=this._h2,h=this._h3,r=this._h4,t,l,o;for(let d=0;d<80;d++)d<20?(t=v&n|~v&h,l=1518500249):d<40?(t=v^n^h,l=1859775393):d<60?(t=v&n|v&h|n&h,l=2400959708):(t=v^n^h,l=3395469782),o=c(a,5)+t+r+l+b.getUint32(d*4,!1)&4294967295,r=h,h=n,n=c(v,30),v=a,a=o;this._h0=this._h0+a&4294967295,this._h1=this._h1+v&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+h&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=_,_._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,15,8]),function(Y,e,g,L){"use strict";var D,S,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(r,t,l){let o=r.get(t);return o===void 0&&(o=l,r.set(t,o)),o}e.getOrSet=k;function E(r){const t=[];return r.forEach((l,o)=>{t.push(`${o} => ${l}`)}),`Map(${r.size}) {${t.join(", ")}}`}e.mapToString=E;function C(r){const t=[];return r.forEach(l=>{t.push(l)}),`Set(${r.size}) {${t.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const l=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return l-o}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class c{constructor(t=!0,l=!0){this._splitOnBackslash=t,this._caseSensitive=l}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var p;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(p||(p={}));class f{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var _;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(_||(_={}));class P{constructor(t){this._iter=t}static forUris(t=()=>!1){return new P(new f(t))}static forPaths(){return new P(new c)}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new I)}clear(){this._root=void 0}fill(t,l){if(l){const o=l.slice(0);(0,g.shuffle)(o);for(let d of o)this.set(d,t)}else{const o=t.slice(0);(0,g.shuffle)(o);for(let d of o)this.set(d[0],d[1])}}set(t,l){const o=this._iter.reset(t);let d;this._root||(this._root=new w,this._root.segment=o.value());const m=[];for(d=this._root;;){const y=o.cmp(d.segment);if(y>0)d.left||(d.left=new w,d.left.segment=o.value()),m.push([-1,d]),d=d.left;else if(y<0)d.right||(d.right=new w,d.right.segment=o.value()),m.push([1,d]),d=d.right;else if(o.hasNext())o.next(),d.mid||(d.mid=new w,d.mid.segment=o.value()),m.push([0,d]),d=d.mid;else break}const u=d.value;d.value=l,d.key=t;for(let y=m.length-1;y>=0;y--){const T=m[y][1];T.updateHeight();const R=T.balanceFactor();if(R<-1||R>1){const $=m[y][0],B=m[y+1][0];if($===1&&B===1)m[y][1]=T.rotateLeft();else if($===-1&&B===-1)m[y][1]=T.rotateRight();else if($===1&&B===-1)T.right=m[y+1][1]=m[y+1][1].rotateRight(),m[y][1]=T.rotateLeft();else if($===-1&&B===1)T.left=m[y+1][1]=m[y+1][1].rotateLeft(),m[y][1]=T.rotateRight();else throw new Error;if(y>0)switch(m[y-1][0]){case-1:m[y-1][1].left=m[y][1];break;case 1:m[y-1][1].right=m[y][1];break;case 0:m[y-1][1].mid=m[y][1];break}else this._root=m[0][1]}}return u}get(t){return this._getNode(t)?.value}_getNode(t){const l=this._iter.reset(t);let o=this._root;for(;o;){const d=l.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(l.hasNext())l.next(),o=o.mid;else break}return o}has(t){const l=this._getNode(t);return!(l?.value===void 0&&l?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,l){const o=this._iter.reset(t),d=[];let m=this._root;for(;m;){const u=o.cmp(m.segment);if(u>0)d.push([-1,m]),m=m.left;else if(u<0)d.push([1,m]),m=m.right;else if(o.hasNext())o.next(),d.push([0,m]),m=m.mid;else break}if(!!m){if(l?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this._min(m.right),{key:y,value:T,segment:R}=u;this._delete(u.key,!1),m.key=y,m.value=T,m.segment=R}else{const u=m.left??m.right;if(d.length>0){const[y,T]=d[d.length-1];switch(y){case-1:T.left=u;break;case 0:T.mid=u;break;case 1:T.right=u;break}}else this._root=u}for(let u=d.length-1;u>=0;u--){const y=d[u][1];y.updateHeight();const T=y.balanceFactor();if(T>1?(y.right.balanceFactor()>=0||(y.right=d[u+1][1]=d[u+1][1].rotateRight()),d[u][1]=y.rotateLeft()):T<-1&&(y.left.balanceFactor()<=0||(y.left=d[u+1][1]=d[u+1][1].rotateLeft()),d[u][1]=y.rotateRight()),u>0)switch(d[u-1][0]){case-1:d[u-1][1].left=d[u][1];break;case 1:d[u-1][1].right=d[u][1];break;case 0:d[u-1][1].mid=d[u][1];break}else this._root=d[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const l=this._iter.reset(t);let o=this._root,d;for(;o;){const m=l.cmp(o.segment);if(m>0)o=o.left;else if(m<0)o=o.right;else if(l.hasNext())l.next(),d=o.value||d,o=o.mid;else break}return o&&o.value||d}findSuperstr(t){const l=this._iter.reset(t);let o=this._root;for(;o;){const d=l.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(l.hasNext())l.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[l,o]of this)t(o,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=l=>{if(!l)return!0;const o=l.balanceFactor();return o<-1||o>1?!1:t(l.left)&&t(l.right)};return t(this._root)}}e.TernarySearchTree=P;class b{constructor(t,l){this.uri=t,this.value=l}}class s{constructor(t,l){this[D]="ResourceMap",t instanceof s?(this.map=new Map(t.map),this.toKey=l??s.defaultToKey):(this.map=new Map,this.toKey=t??s.defaultToKey)}set(t,l){return this.map.set(this.toKey(t),new b(t,l)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,l){typeof l!="undefined"&&(t=t.bind(l));for(let[o,d]of this.map)t(d.value,d.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=s,s.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class v{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,l=0){const o=this._map.get(t);if(!!o)return l!==0&&this.touch(o,l),o.value}set(t,l,o=0){let d=this._map.get(t);if(d)d.value=l,o!==0&&this.touch(d,o);else{switch(d={key:t,value:l,next:void 0,previous:void 0},o){case 0:this.addItemLast(d);break;case 1:this.addItemFirst(d);break;case 2:this.addItemLast(d);break;default:this.addItemLast(d);break}this._map.set(t,d),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const l=this._map.get(t);if(!!l)return this._map.delete(t),this.removeItem(l),this._size--,l.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,l){const o=this._state;let d=this._head;for(;d;){if(l?t.bind(l)(d.value,d.key,this):t(d.value,d.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const t=this,l=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.key,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return d}values(){const t=this,l=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:o.value,done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return d}entries(){const t=this,l=this._state;let o=this._head;const d={[Symbol.iterator](){return d},next(){if(t._state!==l)throw new Error("LinkedMap got modified during iteration.");if(o){const m={value:[o.key,o.value],done:!1};return o=o.next,m}else return{value:void 0,done:!0}}};return d}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let l=this._head,o=this.size;for(;l&&o>t;)this._map.delete(l.key),l=l.next,o--;this._head=l,this._size=o,l&&(l.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const l=t.next,o=t.previous;if(!l||!o)throw new Error("Invalid list");l.previous=o,o.next=l}t.next=void 0,t.previous=void 0,this._state++}touch(t,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(t===this._head)return;const o=t.next,d=t.previous;t===this._tail?(d.next=void 0,this._tail=d):(o.previous=d,d.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(l===2){if(t===this._tail)return;const o=t.next,d=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=d,d.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((l,o)=>{t.push([o,l])}),t}fromJSON(t){this.clear();for(const[l,o]of t)this.set(l,o)}}e.LinkedMap=v;class n extends v{constructor(t,l=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,l=2){return super.get(t,l)}peek(t){return super.get(t,0)}set(t,l){return super.set(t,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class h{constructor(t){A.set(this,void 0),st(this,A,t,"f")}get size(){return Oe(this,A,"f").size}forEach(t,l){Oe(this,A,"f").forEach(t,l)}get(t){return Oe(this,A,"f").get(t)}has(t){return Oe(this,A,"f").has(t)}entries(){return Oe(this,A,"f").entries()}keys(){return Oe(this,A,"f").keys()}values(){return Oe(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return Oe(this,A,"f").entries()}}e.ReadonlyMapView=h}),define(fe[96],me([0,1,24,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=D,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function A(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=A;function k(Z,re){return E(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=k;function E(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=E(Z,re,pe+1,Me+1))?P({start:Me,end:Me+1},je):null}return E(Z,re,pe,Me+1)}function C(Z){return 97<=Z&&Z<=122}function i(Z){return 65<=Z&&Z<=90}e.isUpper=i;function I(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>p.add(Z.charCodeAt(0)));function f(Z){return c(Z)||p.has(Z)}function w(Z,re){return Z===re||f(Z)&&f(re)}function _(Z){return C(Z)||i(Z)||I(Z)}function P(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function b(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(i(Me)||I(Me)||pe>0&&!_(Z.charCodeAt(pe-1)))return pe}return Z.length}function s(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=s(Z,re,pe+1,Me+1);!je&&(Ke=b(re,Ke))<re.length;)je=s(Z,re,pe+1,Ke),Ke++;return je===null?null:P({start:Me,end:Me+1},je)}}function a(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),i(Ke)&&re++,C(Ke)&&pe++,_(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,ct=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:ct,numericPercent:ye}}function v(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function n(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function h(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),i(Me)&&re++,C(Me)&&pe++,c(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function r(Z,re){if(!re||(re=re.trim(),re.length===0)||!h(Z)||re.length>60)return null;const pe=a(re);if(!n(pe)){if(!v(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=s(Z,re,0,je))===null;)je=b(re,je+1);return Me}e.matchesCamelCase=r;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=l(Z,re,0,je,pe))===null;)je=o(re,je+1);return Me}e.matchesWords=t;function l(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(w(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=l(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=o(re,Ze))<re.length;)Ke=l(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:P({start:Me,end:Me+1},Ke)}else return null}function o(Z,re){for(let pe=re;pe<Z.length;pe++)if(f(Z.charCodeAt(pe))||pe>0&&f(Z.charCodeAt(pe-1)))return pe;return Z.length}const d=D(e.matchesPrefix,r,A),m=D(e.matchesPrefix,r,k),u=new g.LRUCache(1e4);function y(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=u.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),u.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?m(Z,re):d(Z,re)}e.matchesFuzzy=y;function T(Z,re){const pe=We(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?$(pe):null}e.matchesFuzzy2=T;function R(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=We(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function $(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=$;const B=128;function F(){const Z=[],re=[];for(let pe=0;pe<=B;pe++)re[pe]=0;for(let pe=0;pe<=B;pe++)Z.push(re.slice(0));return Z}function W(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const M=W(2*B),z=W(2*B),N=F(),U=F(),x=F(),O=!1;function j(Z,re,pe,Me,je){function Ke(rt,ct,ye=" "){for(;rt.length<ct;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(ct=>Ke(ct.toString(),3)).join("|")+`
`;return Ze}function H(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(j(U,Z,Z.length,pe,pe.length)),console.log(j(x,Z,Z.length,pe,pe.length)),console.log(j(N,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function Q(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function _e(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(M[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=_e;var Ie;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function We(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>B?B:Z.length,ct=Me.length>B?B:Me.length;if(pe>=rt||Ke>=ct||rt-pe>ct-Ke||!_e(re,pe,rt,je,Ke,ct,!0))return;Be(rt,ct,pe,Ke,re,je);let ye=1,at=1,J=pe,ne=Ke;const Ee=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ne=M[J],Xe=z[J],nt=J+1<rt?z[J+1]:ct;for(at=Ne-Ke+1,ne=Ne;ne<nt;at++,ne++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ne<=Xe&&(ft=He(Z,re,J,pe,Me,je,ne,ct,Ke,N[ye-1][at-1]===0,Ee));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+U[ye-1][at-1]);const Re=ne>Ne,De=Re?U[ye][at-1]+(N[ye][at-1]>0?-5:0):0,Te=ne>Ne+1&&N[ye][at-1]>0,se=Te?U[ye][at-2]+(N[ye][at-2]>0?-5:0):0;if(Te&&(!Re||se>=De)&&(!tt||se>=ut))U[ye][at]=se,x[ye][at]=3,N[ye][at]=0;else if(Re&&(!tt||De>=ut))U[ye][at]=De,x[ye][at]=2,N[ye][at]=0;else if(tt)U[ye][at]=ut,x[ye][at]=1,N[ye][at]=N[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&H(Z,pe,Me,Ke),!Ee[0]&&!Ze)return;ye--,at--;const Qe=[U[ye][at],Ke];let et=0,le=0;for(;ye>=1;){let Ne=at;do{const Xe=x[ye][Ne];if(Xe===3)Ne=Ne-2;else if(Xe===2)Ne=Ne-1;else break}while(Ne>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ne+Ke-1,Me,je)&&et+1>N[ye][Ne]&&(Ne=at),Ne===at?et++:et=1,le||(le=Ne),ye--,at=Ne-1,Qe.push(at)}ct===rt&&(Qe[0]+=2);const ke=le-rt;return Qe[0]-=ke,Qe}e.fuzzyScore=We;function Be(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(z[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ne=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ne=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||Q(Ke,Ze-1))&&(J=5,ne=!0),J>1&&pe===Me&&(at[0]=!0),ne||(ne=de(Ze,je,Ke)||X(Ke,Ze-1)||Q(Ke,Ze-1)),pe===Me?Ze>ct&&(J-=ne?3:5):ye?J+=ne?2:0:J+=ne?0:1,Ze+1===rt&&(J-=ne?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return ie(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function ie(Z,re,pe,Me,je,Ke,Ze,rt){let ct=We(Z,re,pe,Me,je,Ke,rt);if(ct&&!Ze)return ct;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=ce(Z,at);if(J){const ne=We(J,J.toLowerCase(),pe,Me,je,Ke,rt);ne&&(ne[0]-=3,(!ct||ne[0]>ct[0])&&(ct=ne))}}}return ct}function ce(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[142],me([0,1,47,96,8]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(g.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${S.source}`,"g");function E(_){return _.replace(k,(P,b)=>b?P:`\\${P}`)}e.escapeIcons=E;const C=new RegExp(`\\\\${S.source}`,"g");function i(_){return _.replace(C,P=>`\\${P}`)}e.markdownEscapeEscapedIcons=i;const I=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function c(_){return _.indexOf(e.iconStartMarker)===-1?_:_.replace(I,(P,b,s,a)=>s?P:b||a||"")}e.stripIcons=c;function p(_){const P=_.indexOf(e.iconStartMarker);return P===-1?{text:_}:f(_,P)}e.parseLabelWithIcons=p;function f(_,P){const b=[];let s="";function a(d){if(d){s+=d;for(const m of d)b.push(h)}}let v=-1,n="",h=0,r,t,l=P;const o=_.length;for(a(_.substr(0,P));l<o;)r=_[l],t=_[l+1],r===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(v=l,a(n),n=e.iconStartMarker,l++):r===")"&&v!==-1?(h+=l-v+1,v=-1,n=""):v!==-1?A.test(r)?n+=r:(a(n),v=-1,n=""):a(r),l++;return a(n),{text:s,iconOffsets:b}}function w(_,P,b=!1){const{text:s,iconOffsets:a}=P;if(!a||a.length===0)return(0,L.matchesFuzzy)(_,s,b);const v=(0,D.ltrim)(s," "),n=s.length-v.length,h=(0,L.matchesFuzzy)(_,v,b);if(h)for(const r of h){const t=a[r.start+n]+n;r.start+=t,r.end+=t}return h}e.matchesFuzzyIconAware=w}),define(fe[97],me([0,1,18,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var D;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(D=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(p="",f=!1){if(this.value=p,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=f.isTrusted??void 0,this.supportThemeIcons=f.supportThemeIcons??!1,this.supportHtml=f.supportHtml??!1)}appendText(p,f=0){return this.value+=C(this.supportThemeIcons?(0,L.escapeIcons)(p):p).replace(/([ \t]+)/g,(w,_)=>"&nbsp;".repeat(_.length)).replace(/\>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,f){return this.value+="\n```",this.value+=p,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=S;function A(c){return k(c)?!c.value:Array.isArray(c)?c.every(A):!0}e.isEmptyMarkdownString=A;function k(c){return c instanceof S?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function E(c,p){return c===p?!0:!c||!p?!1:c.value===p.value&&c.isTrusted===p.isTrusted&&c.supportThemeIcons===p.supportThemeIcons}e.markdownStringEqual=E;function C(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function i(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=i;function I(c){const p=[],f=c.split("|").map(_=>_.trim());c=f[0];const w=f[1];if(w){const _=/height=(\d+)/.exec(w),P=/width=(\d+)/.exec(w),b=_?_[1]:"",s=P?P[1]:"",a=isFinite(parseInt(s)),v=isFinite(parseInt(b));a&&p.push(`width="${s}"`),v&&p.push(`height="${b}"`)}return{href:c,dimensions:p}}e.parseHrefAndDimensions=I}),define(fe[79],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function D(C){return E(C,"NFC",L)}e.normalizeNFC=D;const S=new g.LRUCache(1e4);function A(C){return E(C,"NFD",S)}e.normalizeNFD=A;const k=/[^\u0000-\u0080]/;function E(C,i,I){if(!C)return C;const c=I.get(C);if(c)return c;let p;return k.test(C)?p=C.normalize(i):p=C,I.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(i){return A(i).replace(C,"")}}()}),define(fe[49],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const S="error",A="warning",k="warn",E="info",C="ignore";function i(c){return c?g.equalsIgnoreCase(S,c)?D.Error:g.equalsIgnoreCase(A,c)||g.equalsIgnoreCase(k,c)?D.Warning:g.equalsIgnoreCase(E,c)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function I(c){switch(c){case D.Error:return S;case D.Warning:return A;case D.Info:return E;default:return C}}D.toString=I}(L||(L={})),e.default=L}),define(fe[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(m){return Array.isArray(m)}e.isArray=g;function L(m){return typeof m=="string"}e.isString=L;function D(m){return Array.isArray(m)&&m.every(u=>L(u))}e.isStringArray=D;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function k(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=k;function E(m){return m===!0||m===!1}e.isBoolean=E;function C(m){return typeof m=="undefined"}e.isUndefined=C;function i(m){return!I(m)}e.isDefined=i;function I(m){return C(m)||m===null}e.isUndefinedOrNull=I;function c(m,u){if(!m)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}e.assertType=c;function p(m){if(I(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=p;function f(...m){const u=[];for(let y=0;y<m.length;y++){const T=m[y];if(I(T))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);u.push(T)}return u}e.assertAllDefined=f;const w=Object.prototype.hasOwnProperty;function _(m){if(!S(m))return!1;for(let u in m)if(w.call(m,u))return!1;return!0}e.isEmptyObject=_;function P(m){return typeof m=="function"}e.isFunction=P;function b(...m){return m.length>0&&m.every(P)}e.areFunctions=b;function s(m,u){const y=Math.min(m.length,u.length);for(let T=0;T<y;T++)a(m[T],u[T])}e.validateConstraints=s;function a(m,u){if(L(u)){if(typeof m!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(P(u)){try{if(m instanceof u)return}catch{}if(!I(m)&&m.constructor===u||u.length===1&&u.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function v(m){let u=[],y=Object.getPrototypeOf(m);for(;Object.prototype!==y;)u=u.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return u}e.getAllPropertyNames=v;function n(m){const u=[];for(const y of v(m))typeof m[y]=="function"&&u.push(y);return u}e.getAllMethodNames=n;function h(m,u){const y=R=>function(){const $=Array.prototype.slice.call(arguments,0);return u(R,$)};let T={};for(const R of m)T[R]=y(R);return T}e.createProxyObject=h;function r(m){return m===null?void 0:m}e.withNullAsUndefined=r;function t(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=t;function l(m){return class{constructor(){return new Proxy({},{get(u,y){if(u[y])return u[y];throw new Error(`Not Implemented: ${m}->${String(y)}`)}})}}}e.NotImplementedProxy=l;function o(m,u="Unreachable"){throw new Error(u)}e.assertNever=o;function d(m){return!!m&&typeof m.then=="function"&&typeof m.catch=="function"}e.isPromise=d}),define(fe[29],me([0,1,9,12,8,13]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(r){return r===47||r===92}e.isPathSeparator=A;function k(r){return r.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=k;function E(r){return r.indexOf("/")===-1&&(r=k(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function C(r,t=g.posix.sep){if(!r)return"";const l=r.length,o=r.charCodeAt(0);if(A(o)){if(A(r.charCodeAt(1))&&!A(r.charCodeAt(2))){let m=3;const u=m;for(;m<l&&!A(r.charCodeAt(m));m++);if(u!==m&&!A(r.charCodeAt(m+1))){for(m+=1;m<l;m++)if(A(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,t)}}return t}else if(P(o)&&r.charCodeAt(1)===58)return A(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let d=r.indexOf("://");if(d!==-1){for(d+=3;d<l;d++)if(A(r.charCodeAt(d)))return r.slice(0,d+1)}return""}e.getRoot=C;function i(r){if(!L.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let l=2;const o=l;for(;l<r.length&&(t=r.charCodeAt(l),t!==92);l++);return!(o===l||(t=r.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,t=L.isWindows){const l=t?I:c;return!(!r||r.length===0||/^\s+$/.test(r)||(l.lastIndex=0,l.test(r))||t&&p.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function w(r,t,l){const o=r===t;return!l||o?o:!r||!t?!1:(0,D.equalsIgnoreCase)(r,t)}e.isEqual=w;function _(r,t,l,o=g.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let m=t.length;return t.charAt(t.length-1)===o&&m--,r.charAt(m)===o}return t.charAt(t.length-1)!==o&&(t+=o),r.indexOf(t)===0}e.isEqualOrParent=_;function P(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=P;function b(r,t){return L.isWindows&&r.endsWith(":")&&(r+=g.sep),(0,g.isAbsolute)(r)||(r=(0,g.join)(t,r)),r=(0,g.normalize)(r),L.isWindows?(r=(0,D.rtrim)(r,g.sep),r.endsWith(":")&&(r+=g.sep)):(r=(0,D.rtrim)(r,g.sep),r||(r=g.sep)),r}e.sanitizeFilePath=b;function s(r){const t=(0,g.normalize)(r);return L.isWindows?r.length>3?!1:a(t)&&(r.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=s;function a(r,t){return(t!==void 0?t:L.isWindows)?P(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function v(r){return a(r)?r[0]:void 0}e.getDriveLetter=v;function n(r,t,l){return t.length>r.length?-1:r===t?0:(l&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=n;function h(r){const t=r.split(":");let l,o,d;if(t.forEach(m=>{const u=Number(m);(0,S.isNumber)(u)?o===void 0?o=u:d===void 0&&(d=u):l=l?[l,m].join(":"):m}),!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:o!==void 0?o:void 0,column:d!==void 0?d:o!==void 0?1:void 0}}e.parseLineAndColumnAware=h}),define(fe[25],me([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const _=Array.isArray(w)?[]:{};return Object.keys(w).forEach(P=>{w[P]&&typeof w[P]=="object"?_[P]=L(w[P]):_[P]=w[P]}),_}e.deepClone=L;function D(w){if(!w||typeof w!="object")return w;const _=[w];for(;_.length>0;){const P=_.shift();Object.freeze(P);for(const b in P)if(S.call(P,b)){const s=P[b];typeof s=="object"&&!Object.isFrozen(s)&&_.push(s)}}return w}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function A(w,_){return k(w,_,new Set)}e.cloneAndChange=A;function k(w,_,P){if((0,g.isUndefinedOrNull)(w))return w;const b=_(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const s=[];for(const a of w)s.push(k(a,_,P));return s}if((0,g.isObject)(w)){if(P.has(w))throw new Error("Cannot clone recursive data-structure");P.add(w);const s={};for(let a in w)S.call(w,a)&&(s[a]=k(w[a],_,P));return P.delete(w),s}return w}function E(w,_,P=!0){return(0,g.isObject)(w)?((0,g.isObject)(_)&&Object.keys(_).forEach(b=>{b in w?P&&((0,g.isObject)(w[b])&&(0,g.isObject)(_[b])?E(w[b],_[b],P):w[b]=_[b]):w[b]=_[b]}),w):_}e.mixin=E;function C(w,_){if(w===_)return!0;if(w==null||_===null||_===void 0||typeof w!=typeof _||typeof w!="object"||Array.isArray(w)!==Array.isArray(_))return!1;let P,b;if(Array.isArray(w)){if(w.length!==_.length)return!1;for(P=0;P<w.length;P++)if(!C(w[P],_[P]))return!1}else{const s=[];for(b in w)s.push(b);s.sort();const a=[];for(b in _)a.push(b);if(a.sort(),!C(s,a))return!1;for(P=0;P<s.length;P++)if(!C(w[s[P]],_[s[P]]))return!1}return!0}e.equals=C;function i(w){const _=new Set;return JSON.stringify(w,(P,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(_.has(b))return"[Circular]";_.add(b)}return b})}e.safeStringify=i;function I(w,_,P){const b=_(w);return typeof b=="undefined"?P:b}e.getOrDefault=I;function c(w,_){const P=Object.create(null);return!w||!_||Object.keys(_).forEach(s=>{const a=w[s],v=_[s];C(a,v)||(P[s]=v)}),P}e.distinct=c;function p(w,_){const P=_.toLowerCase(),b=Object.keys(w).find(s=>s.toLowerCase()===P);return b?w[b]:w[_]}e.getCaseInsensitive=p;function f(w,_){const P=Object.create(null);for(const[b,s]of Object.entries(w))_(b,s)&&(P[b]=s);return P}e.filter=f}),define(fe[98],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(S){return S<0?0:S>255?255:S|0}e.toUint8=L;function D(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=D}),define(fe[2],me([0,1,9,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,A=/^\/\//;function k(r,t){if(!r.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!S.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,t){return!r&&!t?"file":r}function C(r,t){switch(r){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const i="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,l,o,d,m,u=!1){typeof t=="object"?(this.scheme=t.scheme||i,this.authority=t.authority||i,this.path=t.path||i,this.query=t.query||i,this.fragment=t.fragment||i):(this.scheme=E(t,u),this.authority=l||i,this.path=C(this.scheme,o||i),this.query=d||i,this.fragment=m||i,k(this,u))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return s(this,!1)}with(t){if(!t)return this;let{scheme:l,authority:o,path:d,query:m,fragment:u}=t;return l===void 0?l=this.scheme:l===null&&(l=i),o===void 0?o=this.authority:o===null&&(o=i),d===void 0?d=this.path:d===null&&(d=i),m===void 0?m=this.query:m===null&&(m=i),u===void 0?u=this.fragment:u===null&&(u=i),l===this.scheme&&o===this.authority&&d===this.path&&m===this.query&&u===this.fragment?this:new w(l,o,d,m,u)}static parse(t,l=!1){const o=c.exec(t);return o?new w(o[2]||i,h(o[4]||i),h(o[5]||i),h(o[7]||i),h(o[9]||i),l):new w(i,i,i,i,i)}static file(t){let l=i;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const o=t.indexOf(I,2);o===-1?(l=t.substring(2),t=I):(l=t.substring(2,o),t=t.substring(o)||I)}return new w("file",l,t,i,i)}static from(t){const l=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(l,!0),l}static joinPath(t,...l){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.isWindows&&t.scheme==="file"?o=p.file(g.win32.join(s(t,!0),...l)).path:o=g.posix.join(t.path,...l),t.with({path:o})}toString(t=!1){return a(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const l=new w(t);return l._formatted=t.external,l._fsPath=t._sep===f?t.fsPath:null,l}}else return t}}e.URI=p;const f=L.isWindows?1:void 0;class w extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=s(this,!1)),this._fsPath}toString(t=!1){return t?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=f),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const _={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(r,t){let l,o=-1;for(let d=0;d<r.length;d++){const m=r.charCodeAt(d);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||t&&m===47)o!==-1&&(l+=encodeURIComponent(r.substring(o,d)),o=-1),l!==void 0&&(l+=r.charAt(d));else{l===void 0&&(l=r.substr(0,d));const u=_[m];u!==void 0?(o!==-1&&(l+=encodeURIComponent(r.substring(o,d)),o=-1),l+=u):o===-1&&(o=d)}}return o!==-1&&(l+=encodeURIComponent(r.substring(o))),l!==void 0?l:r}function b(r){let t;for(let l=0;l<r.length;l++){const o=r.charCodeAt(l);o===35||o===63?(t===void 0&&(t=r.substr(0,l)),t+=_[o]):t!==void 0&&(t+=r[l])}return t!==void 0?t:r}function s(r,t){let l;return r.authority&&r.path.length>1&&r.scheme==="file"?l=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?t?l=r.path.substr(1):l=r.path[1].toLowerCase()+r.path.substr(2):l=r.path,L.isWindows&&(l=l.replace(/\//g,"\\")),l}e.uriToFsPath=s;function a(r,t){const l=t?b:P;let o="",{scheme:d,authority:m,path:u,query:y,fragment:T}=r;if(d&&(o+=d,o+=":"),(m||d==="file")&&(o+=I,o+=I),m){let R=m.indexOf("@");if(R!==-1){const $=m.substr(0,R);m=m.substr(R+1),R=$.indexOf(":"),R===-1?o+=l($,!1):(o+=l($.substr(0,R),!1),o+=":",o+=l($.substr(R+1),!1)),o+="@"}m=m.toLowerCase(),R=m.indexOf(":"),R===-1?o+=l(m,!1):(o+=l(m.substr(0,R),!1),o+=m.substr(R))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const R=u.charCodeAt(1);R>=65&&R<=90&&(u=`/${String.fromCharCode(R+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const R=u.charCodeAt(0);R>=65&&R<=90&&(u=`${String.fromCharCode(R+32)}:${u.substr(2)}`)}o+=l(u,!0)}return y&&(o+="?",o+=l(y,!1)),T&&(o+="#",o+=t?T:P(T,!1)),o}function v(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+v(r.substr(3)):r}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(r){return r.match(n)?r.replace(n,t=>v(t)):r}}),define(fe[61],me([0,1,22,8,2]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,E)}e.stringify=S;function A(i){let I=JSON.parse(i);return I=C(I),I}e.parse=A;var k;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function E(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function C(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof g.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let c=0;c<i.length;++c)i[c]=C(i[c],I+1);else for(const c in i)Object.hasOwnProperty.call(i,c)&&(i[c]=C(i[c],I+1))}return i}e.revive=C}),define(fe[10],me([0,1,12,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,C,i){this._hosts[E]=C,this._ports[E]=i}setConnectionToken(E,C){this._connectionTokens[E]=C}rewrite(E){if(this._delegate)return this._delegate(E);const C=E.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],c=this._connectionTokens[C];let p=`path=${encodeURIComponent(E.path)}`;return typeof c=="string"&&(p+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new S;class A{asBrowserUri(E,C){const i=this.toUri(E,C);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${D.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(E,C){const i=this.toUri(E,C);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==A.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(E,C){return L.URI.isUri(E)?E:L.URI.parse(C.toUrl(E))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(fe[23],me([0,1,29,10,9,12,8,2]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(p){return(0,k.uriToFsPath)(p,!0)}e.originalFSPath=E;class C{constructor(f){this._ignorePathCasing=f}compare(f,w,_=!1){return f===w?0:(0,A.compare)(this.getComparisonKey(f,_),this.getComparisonKey(w,_))}isEqual(f,w,_=!1){return f===w?!0:!f||!w?!1:this.getComparisonKey(f,_)===this.getComparisonKey(w,_)}getComparisonKey(f,w=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,w,_=!1){if(f.scheme===w.scheme){if(f.scheme===L.Schemas.file)return g.isEqualOrParent(E(f),E(w),this._ignorePathCasing(f))&&f.query===w.query&&(_||f.fragment===w.fragment);if((0,e.isEqualAuthority)(f.authority,w.authority))return g.isEqualOrParent(f.path,w.path,this._ignorePathCasing(f),"/")&&f.query===w.query&&(_||f.fragment===w.fragment)}return!1}joinPath(f,...w){return k.URI.joinPath(f,...w)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return D.posix.basename(f.path)}extname(f){return D.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let w;return f.scheme===L.Schemas.file?w=k.URI.file(D.dirname(E(f))).path:(w=D.posix.dirname(f.path),f.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),w="/")),f.with({path:w})}normalizePath(f){if(!f.path.length)return f;let w;return f.scheme===L.Schemas.file?w=k.URI.file(D.normalize(E(f))).path:w=D.posix.normalize(f.path),f.with({path:w})}relativePath(f,w){if(f.scheme!==w.scheme||!(0,e.isEqualAuthority)(f.authority,w.authority))return;if(f.scheme===L.Schemas.file){const b=D.relative(E(f),E(w));return S.isWindows?g.toSlashes(b):b}let _=f.path||"/",P=w.path||"/";if(this._ignorePathCasing(f)){let b=0;for(const s=Math.min(_.length,P.length);b<s&&!(_.charCodeAt(b)!==P.charCodeAt(b)&&_.charAt(b).toLowerCase()!==P.charAt(b).toLowerCase());b++);_=P.substr(0,b)+_.substr(b)}return D.posix.relative(_,P)}resolvePath(f,w){if(f.scheme===L.Schemas.file){const _=k.URI.file(D.resolve(E(f),w));return f.with({authority:_.authority,path:_.path})}return w=g.toPosixPath(w),f.with({path:D.posix.resolve(f.path,w)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,w){return f===w||f!==void 0&&w!==void 0&&(0,A.equalsIgnoreCase)(f,w)}hasTrailingPathSeparator(f,w=D.sep){if(f.scheme===L.Schemas.file){const _=E(f);return _.length>g.getRoot(_).length&&_[_.length-1]===w}else{const _=f.path;return _.length>1&&_.charCodeAt(_.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,w=D.sep){return(0,e.hasTrailingPathSeparator)(f,w)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,w=D.sep){let _=!1;if(f.scheme===L.Schemas.file){const P=E(f);_=P!==void 0&&P.length===g.getRoot(P).length&&P[P.length-1]===w}else{w="/";const P=f.path;_=P.length===1&&P.charCodeAt(P.length-1)===47}return!_&&!(0,e.hasTrailingPathSeparator)(f,w)?f.with({path:f.path+"/"}):f}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===L.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(p,f){const w=[];for(let _=0;_<p.length;_++){const P=f(p[_]);p.some((b,s)=>s===_?!1:(0,e.isEqualOrParent)(P,f(b)))||w.push(p[_])}return w}e.distinctParents=i;var I;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function f(w){const _=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(s=>{const[a,v]=s.split(":");a&&v&&_.set(a,v)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&_.set(p.META_DATA_MIME,b),_}p.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function c(p,f,w){if(f){let _=p.path;return _&&_[0]!==D.posix.sep&&(_=D.posix.sep+_),p.with({scheme:w,authority:f,path:_})}return p.with({scheme:w})}e.toLocalResource=c}),define(fe[16],me([0,1,21,18,3,6,23]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(N){return!!N&&typeof N.then=="function"}e.isThenable=k;function E(N){const U=new g.CancellationTokenSource,x=N(U.token),O=new Promise((j,H)=>{const X=U.token.onCancellationRequested(()=>{X.dispose(),U.dispose(),H((0,L.canceled)())});Promise.resolve(x).then(Q=>{X.dispose(),U.dispose(),j(Q)},Q=>{X.dispose(),U.dispose(),H(Q)})});return new class{cancel(){U.cancel()}then(j,H){return O.then(j,H)}catch(j){return this.then(void 0,j)}finally(j){return O.finally(j)}}}e.createCancelablePromise=E;function C(N,U,x){return Promise.race([N,new Promise(O=>U.onCancellationRequested(()=>O(x)))])}e.raceCancellation=C;async function i(N){let U=-1;const x=N.map((j,H)=>j.then(X=>(U=H,X))),O=await Promise.race(x);return N.forEach((j,H)=>{H!==U&&j.cancel()}),O}e.raceCancellablePromises=i;function I(N,U,x){let O;const j=setTimeout(()=>{O?.(void 0),x?.()},U);return Promise.race([N.finally(()=>clearTimeout(j)),new Promise(H=>O=H)])}e.raceTimeout=I;function c(N){return new Promise((U,x)=>{const O=N();k(O)?O.then(U,x):U(O)})}e.asPromise=c;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(x,x).then(O)})}return new Promise((x,O)=>{this.queuedPromise.then(x,O)})}return this.activePromise=U(),new Promise((x,O)=>{this.activePromise.then(j=>{this.activePromise=null,x(j)},j=>{this.activePromise=null,O(j)})})}}e.Throttler=p;class f{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=f;class w{constructor(){this.promiseMap=new Map}queue(U,x){const j=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(U)===j&&this.promiseMap.delete(U)});return this.promiseMap.set(U,j),j}}e.SequencerByKey=w;class _{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,x=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,j)=>{this.doResolve=O,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=_;class P{constructor(U){this.delayer=new _(U),this.throttler=new p}trigger(U,x){return this.delayer.trigger(()=>this.throttler.queue(U),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class b{constructor(){this._isOpen=!1,this._promise=new Promise((U,x)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class s extends b{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function a(N,U){return U?new Promise((x,O)=>{const j=setTimeout(()=>{H.dispose(),x()},N),H=U.onCancellationRequested(()=>{clearTimeout(j),H.dispose(),O((0,L.canceled)())})}):E(x=>a(N,x))}e.timeout=a;function v(N,U=0){const x=setTimeout(N,U);return(0,S.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=v;function n(N){const U=[];let x=0;const O=N.length;function j(){return x<O?N[x++]():null}function H(X){X!=null&&U.push(X);const Q=j();return Q?Q.then(H):Promise.resolve(U)}return Promise.resolve(null).then(H)}e.sequence=n;function h(N,U=O=>!!O,x=null){let O=0;const j=N.length,H=()=>{if(O>=j)return Promise.resolve(x);const X=N[O++];return Promise.resolve(X()).then(de=>U(de)?Promise.resolve(de):H())};return H()}e.first=h;function r(N,U=O=>!!O,x=null){if(N.length===0)return Promise.resolve(x);let O=N.length;const j=()=>{O=-1;for(const H of N)H.cancel?.()};return new Promise((H,X)=>{for(const Q of N)Q.then(de=>{--O>=0&&U(de)?(j(),H(de)):O===0&&H(x)}).catch(de=>{--O>=0&&(j(),X(de))})})}e.firstParallel=r;class t{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((x,O)=>{this.outstandingPromises.push({factory:U,c:x,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const x=U.factory();x.then(U.c,U.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class l extends t{constructor(){super(1)}}e.Queue=l;class o{constructor(){this.queues=new Map}queueFor(U,x=A.extUri){const O=x.getComparisonKey(U);let j=this.queues.get(O);return j||(j=new l,D.Event.once(j.onFinished)(()=>{j?.dispose(),this.queues.delete(O)}),this.queues.set(O,j)),j}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=o;class d{constructor(U,x){this._token=-1,typeof U=="function"&&typeof x=="number"&&this.setIfNotSet(U,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},x)}setIfNotSet(U,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},x))}}e.TimeoutTimer=d;class m{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,x){this.cancel(),this._token=setInterval(()=>{U()},x)}}e.IntervalTimer=m;class u{constructor(U,x){this.timeoutToken=-1,this.runner=U,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=u;class y{constructor(U,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class T extends u{constructor(U,x){super(U,x);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=T;class R extends S.Disposable{constructor(U,x,O,j){super();this.maxWorkChunkSize=U,this.maxPendingWork=x,this.throttleDelay=O,this.handler=j,this.pendingWork=[],this.throttler=this._register(new S.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new u(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const U=setTimeout(()=>{const O=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(U))}}}:e.runWhenIdle=(N,U)=>{const x=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(x))}}}}();class ${constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function B(N,U,x){let O;for(let j=0;j<x;j++)try{return await N()}catch(H){O=H,await a(U)}throw O}e.retry=B;class F{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,x,O){return this._pending={taskId:U,cancel:()=>O?.(),promise:x},x.then(()=>this.donePending(U),()=>this.donePending(U)),x}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let x,O;const j=new Promise((H,X)=>{x=H,O=X});this._next={run:U,promise:j,promiseResolve:x,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class W{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=W;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,x)=>{this.completeCallback=U,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(x=>{this.completeCallback(U),this.resolved=!0,x()})}error(U){return new Promise(x=>{this.errorCallback(U),this.rejected=!0,x()})}cancel(){new Promise(U=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=M;var z;(function(N){async function U(O){let j;const H=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{j||(j=Q)})));if(typeof j!="undefined")throw j;return H}N.settled=U;function x(O){return new Promise(async(j,H)=>{try{await O(j,H)}catch(X){H(X)}})}N.withAsyncBody=x})(z=e.Promises||(e.Promises={}))}),define(fe[99],me([0,1,16,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new g.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),S=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,y,T=!1){const R=u||"",$=y||"",B=D.value.collator.compare(R,$);return D.value.collatorIsNumeric&&B===0&&R!==$?R<$?-1:1:B}e.compareFileNames=k;function E(u,y){const T=S.value.collator;return u=u||"",y=y||"",v(T,u,y)}e.compareFileNamesDefault=E;function C(u,y){const T=S.value.collator;return u=u||"",y=y||"",t(u,y)||v(T,u,y)}e.compareFileNamesUpper=C;function i(u,y){const T=S.value.collator;return u=u||"",y=y||"",r(u,y)||v(T,u,y)}e.compareFileNamesLower=i;function I(u,y){return u=u||"",y=y||"",u===y?0:u<y?-1:1}e.compareFileNamesUnicode=I;function c(u,y,T=!1){T||(u=u&&u.toLowerCase(),y=y&&y.toLowerCase());const[R,$]=s(u),[B,F]=s(y);return R!==B?R<B?-1:1:$===F?0:$<F?-1:1}e.noIntlCompareFileNames=c;function p(u,y){const[T,R]=s(u),[$,B]=s(y);let F=D.value.collator.compare(R,B);if(F===0){if(D.value.collatorIsNumeric&&R!==B)return R<B?-1:1;if(F=D.value.collator.compare(T,$),D.value.collatorIsNumeric&&F===0&&T!==$)return T<$?-1:1}return F}e.compareFileExtensions=p;function f(u,y){u=u||"",y=y||"";const T=a(u),R=a(y),$=S.value.collator,B=A.value.collator;return v(B,T,R)||v($,u,y)}e.compareFileExtensionsDefault=f;function w(u,y){u=u||"",y=y||"";const T=a(u),R=a(y),$=S.value.collator,B=A.value.collator;return v(B,T,R)||t(u,y)||v($,u,y)}e.compareFileExtensionsUpper=w;function _(u,y){u=u||"",y=y||"";const T=a(u),R=a(y),$=S.value.collator,B=A.value.collator;return v(B,T,R)||r(u,y)||v($,u,y)}e.compareFileExtensionsLower=_;function P(u,y){u=u||"",y=y||"";const T=a(u).toLowerCase(),R=a(y).toLowerCase();return T!==R?T<R?-1:1:u!==y?u<y?-1:1:0}e.compareFileExtensionsUnicode=P;const b=/^(.*?)(\.([^.]*))?$/;function s(u,y=!1){const T=u?b.exec(u):[];let R=[T&&T[1]||"",T&&T[3]||""];return y&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function a(u){const y=u?b.exec(u):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function v(u,y,T){let R=u.compare(y,T);return R!==0?R:y.length!==T.length?y.length<T.length?-1:1:0}function n(u){const y=u.charAt(0);return y.toLocaleUpperCase()!==y}function h(u){const y=u.charAt(0);return y.toLocaleLowerCase()!==y}function r(u,y){return n(u)&&h(y)?-1:h(u)&&n(y)?1:0}function t(u,y){return h(u)&&n(y)?-1:n(u)&&h(y)?1:0}function l(u,y,T=!1){return T||(u=u&&u.toLowerCase(),y=y&&y.toLowerCase()),u===y?0:u<y?-1:1}function o(u,y,T=!1){const R=u.split(L.sep),$=y.split(L.sep),B=R.length-1,F=$.length-1;let W,M;for(let z=0;;z++){if(W=B===z,M=F===z,W&&M)return k(R[z],$[z],T);if(W)return-1;if(M)return 1;const N=l(R[z],$[z],T);if(N!==0)return N}}e.comparePaths=o;function d(u,y,T){const R=u.toLowerCase(),$=y.toLowerCase(),B=m(u,y,T);if(B)return B;const F=R.endsWith(T),W=$.endsWith(T);if(F!==W)return F?-1:1;const M=k(R,$);return M!==0?M:R.localeCompare($)}e.compareAnything=d;function m(u,y,T){const R=u.toLowerCase(),$=y.toLowerCase(),B=R.startsWith(T),F=$.startsWith(T);if(B!==F)return B?-1:1;if(B&&F){if(R.length<$.length)return-1;if(R.length>$.length)return 1}return 0}e.compareByPrefix=m}),define(fe[100],me([0,1,99,96,48,9,12,8]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const E=0,C=[E,[]];function i(N,U,x,O){if(!N||!U)return C;const j=N.length,H=U.length;if(j<H)return C;const X=N.toLowerCase();return I(U,x,H,N,X,j,O)}e.scoreFuzzy=i;function I(N,U,x,O,j,H,X){const Q=[],de=[];for(let We=0;We<x;We++){const Be=We*H,He=Be-H,G=We>0,ee=N[We],ie=U[We];for(let ce=0;ce<H;ce++){const Z=ce>0,re=Be+ce,pe=re-1,Me=He+ce-1,je=Z?Q[pe]:0,Ke=G&&Z?Q[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=c(ee,ie,O,j,ce,Ze),rt&&Ke+rt>=je&&(X||G||j.startsWith(U,ce))?(de[re]=Ze+1,Q[re]=Ke+rt):(de[re]=E,Q[re]=je)}}const _e=[];let Ie=x-1,Pe=H-1;for(;Ie>=0&&Pe>=0;){const We=Ie*H+Pe;de[We]===E||(_e.push(Pe),Ie--),Pe--}return[Q[x*H-1],_e.reverse()]}function c(N,U,x,O,j,H){let X=0;if(!p(U,O[j]))return X;if(X+=1,H>0&&(X+=H*5),N===x[j]&&(X+=1),j===0)X+=8;else{const Q=f(x.charCodeAt(j-1));Q?X+=Q:(0,L.isUpper)(x.charCodeAt(j))&&H===0&&(X+=2)}return X}function p(N,U){return N===U?!0:N==="/"||N==="\\"?U==="/"||U==="\\":!1}function f(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function _(N,U,x=0,O=0){const j=U;return j.values&&j.values.length>1?P(N,j.values,x,O):b(N,U,x,O)}e.scoreFuzzy2=_;function P(N,U,x,O){let j=0;const H=[];for(const X of U){const[Q,de]=b(N,X,x,O);if(typeof Q!="number")return w;j+=Q,H.push(...de)}return[j,m(H)]}function b(N,U,x,O){const j=(0,L.fuzzyScore)(U.original,U.originalLowercase,x,N,N.toLowerCase(),O,!0);return j?[j[0],(0,L.createMatches)(j)]:w}const s=Object.freeze({score:0}),a=1<<18,v=1<<17,n=1<<16;function h(N,U,x,O){const j=O.values?O.values:[O];return(0,D.hash)({[O.normalized]:{values:j.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:N,description:U,allowNonContiguousMatches:x}})}function r(N,U,x,O,j){if(!N||!U.normalized)return s;const H=O.getItemLabel(N);if(!H)return s;const X=O.getItemDescription(N),Q=h(H,X,x,U),de=j[Q];if(de)return de;const _e=t(H,X,O.getItemPath(N),U,x);return j[Q]=_e,_e}e.scoreItemFuzzy=r;function t(N,U,x,O,j){const H=!x||!O.containsPathSeparator;return x&&(A.isLinux?O.pathNormalized===x:(0,k.equalsIgnoreCase)(O.pathNormalized,x))?{score:a,labelMatch:[{start:0,end:N.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:O.values&&O.values.length>1?l(N,U,x,O.values,H,j):o(N,U,x,O,H,j)}function l(N,U,x,O,j,H){let X=0;const Q=[],de=[];for(const _e of O){const{score:Ie,labelMatch:Pe,descriptionMatch:We}=o(N,U,x,_e,j,H);if(Ie===E)return s;X+=Ie,Pe&&Q.push(...Pe),We&&de.push(...We)}return{score:X,labelMatch:m(Q),descriptionMatch:m(de)}}function o(N,U,x,O,j,H){if(j||!U){const[X,Q]=i(N,O.normalized,O.normalizedLowercase,H&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,N);let _e;return de?(_e=v,_e+=Math.round(O.normalized.length/N.length*100)):_e=n,{score:_e+X,labelMatch:de||d(Q)}}}if(U){let X=U;x&&(X=`${U}${S.sep}`);const Q=X.length,de=`${X}${N}`,[_e,Ie]=i(de,O.normalized,O.normalizedLowercase,H&&!O.expectContiguousMatch);if(_e){const Pe=d(Ie),We=[],Be=[];return Pe.forEach(He=>{He.start<Q&&He.end>Q?(We.push({start:0,end:He.end-Q}),Be.push({start:He.start,end:Q})):He.start>=Q?We.push({start:He.start-Q,end:He.end-Q}):Be.push(He)}),{score:_e,labelMatch:We,descriptionMatch:Be}}}return s}function d(N){const U=[];if(!N)return U;let x;for(const O of N)x&&x.end===O?x.end+=1:(x={start:O,end:O+1},U.push(x));return U}function m(N){const U=N.sort((j,H)=>j.start-H.start),x=[];let O;for(const j of U)!O||!u(O,j)?(O=j,x.push(j)):(O.start=Math.min(O.start,j.start),O.end=Math.max(O.end,j.end));return x}function u(N,U){return!(N.end<U.start||U.end<N.start)}function y(N,U,x,O,j,H){const X=r(N,x,O,j,H),Q=r(U,x,O,j,H),de=X.score,_e=Q.score;if((de===a||_e===a)&&de!==_e)return de===a?-1:1;if(de>n||_e>n){if(de!==_e)return de>_e?-1:1;if(de<v&&_e<v){const ee=R(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=j.getItemLabel(N)||"",G=j.getItemLabel(U)||"";if(He.length!==G.length)return He.length-G.length}if(de!==_e)return de>_e?-1:1;const Ie=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(Ie&&!Pe)return-1;if(Pe&&!Ie)return 1;const We=T(N,X,j),Be=T(U,Q,j);return We&&Be&&We!==Be?Be>We?-1:1:$(N,U,x,j)}e.compareItemsByFuzzyScore=y;function T(N,U,x){let O=-1,j=-1;if(U.descriptionMatch&&U.descriptionMatch.length?O=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(O=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(j=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const H=x.getItemDescription(N);H&&(j+=H.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(j=U.descriptionMatch[U.descriptionMatch.length-1].end);return j-O}function R(N,U){if(!N&&!U||(!N||!N.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!N||!N.length)return 1;const x=N[0].start,j=N[N.length-1].end-x,H=U[0].start,Q=U[U.length-1].end-H;return j===Q?0:Q<j?1:-1}function $(N,U,x,O){const j=O.getItemLabel(N)||"",H=O.getItemLabel(U)||"",X=O.getItemDescription(N),Q=O.getItemDescription(U),de=j.length+(X?X.length:0),_e=H.length+(Q?Q.length:0);if(de!==_e)return de-_e;const Ie=O.getItemPath(N),Pe=O.getItemPath(U);return Ie&&Pe&&Ie.length!==Pe.length?Ie.length-Pe.length:j!==H?(0,g.compareAnything)(j,H,x.normalized):X&&Q&&X!==Q?(0,g.compareAnything)(X,Q,x.normalized):Ie&&Pe&&Ie!==Pe?(0,g.compareAnything)(Ie,Pe,x.normalized):0}function B(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function W(N){typeof N!="string"&&(N="");const U=N.toLowerCase(),{pathNormalized:x,normalized:O,normalizedLowercase:j}=M(N),H=x.indexOf(S.sep)>=0,X=B(N);let Q;const de=N.split(F);if(de.length>1)for(const _e of de){const Ie=B(_e),{pathNormalized:Pe,normalized:We,normalizedLowercase:Be}=M(_e);We&&(Q||(Q=[]),Q.push({original:_e,originalLowercase:_e.toLowerCase(),pathNormalized:Pe,normalized:We,normalizedLowercase:Be,expectContiguousMatch:Ie}))}return{original:N,originalLowercase:U,pathNormalized:x,normalized:O,normalizedLowercase:j,values:Q,containsPathSeparator:H,expectContiguousMatch:X}}e.prepareQuery=W;function M(N){let U;A.isWindows?U=N.replace(/\//g,S.sep):U=N.replace(/\\/g,S.sep);const x=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:x,normalizedLowercase:x.toLowerCase()}}function z(N){return Array.isArray(N)?W(N.map(U=>U.original).join(F)):W(N.original)}e.pieceToQuery=z}),define(fe[30],me([0,1,16,29,24,9,8]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const E="**",C="/",i="[/\\\\]",I="[^/\\\\]",c=/\//g;function p(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function f(O,j){if(!O)return[];const H=[];let X=!1,Q=!1,de="";for(const _e of O){switch(_e){case j:if(!X&&!Q){H.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=_e}return de&&H.push(de),H}e.splitGlobAware=f;function w(O){if(!O)return"";let j="";const H=f(O,C);if(H.every(X=>X===E))j=".*";else{let X=!1;H.forEach((Q,de)=>{if(Q===E){X||(j+=p(2),X=!0);return}let _e=!1,Ie="",Pe=!1,We="";for(const Be of Q){if(Be!=="}"&&_e){Ie+=Be;continue}if(Pe&&(Be!=="]"||!We)){let He;Be==="-"?He=Be:(Be==="^"||Be==="!")&&!We?He="^":Be===C?He="":He=A.escapeRegExpCharacters(Be),We+=He;continue}switch(Be){case"{":_e=!0;continue;case"[":Pe=!0;continue;case"}":j+=`(?:${f(Ie,",").map(ee=>w(ee)).join("|")})`,_e=!1,Ie="";break;case"]":j+="["+We+"]",Pe=!1,We="";break;case"?":j+=I;continue;case"*":j+=p(1);continue;default:j+=A.escapeRegExpCharacters(Be)}}de<H.length-1&&(H[de+1]!==E||de+2<H.length)&&(j+=i),X=!1})}return j}const _=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.LRUCache(1e4),h=function(){return!1},r=function(){return null};function t(O,j){if(!O)return r;let H;typeof O!="string"?H=O.pattern:H=O,H=H.trim();const X=`${H}_${!!j.trimForExclusions}`;let Q=n.get(X);if(Q)return l(Q,O);let de;if(_.test(H)){const _e=H.substr(4);Q=function(Ie,Pe){return typeof Ie=="string"&&Ie.endsWith(_e)?H:null}}else(de=P.exec(o(H,j)))?Q=d(de[1],H):(j.trimForExclusions?s:b).test(H)?Q=m(H,j):(de=a.exec(o(H,j)))?Q=u(de[1].substr(1),H,!0):(de=v.exec(o(H,j)))?Q=u(de[1],H,!1):Q=y(H);return n.set(X,Q),l(Q,O)}function l(O,j){return typeof j=="string"?O:function(H,X){return L.isEqualOrParent(H,j.base)?O(S.relative(j.base,H),X):null}}function o(O,j){return j.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function d(O,j){const H=`/${O}`,X=`\\${O}`,Q=function(_e,Ie){return typeof _e!="string"?null:Ie?Ie===O?j:null:_e===O||_e.endsWith(H)||_e.endsWith(X)?j:null},de=[O];return Q.basenames=de,Q.patterns=[j],Q.allBasenames=de,Q}function m(O,j){const H=x(O.slice(1,-1).split(",").map(Ie=>t(Ie,j)).filter(Ie=>Ie!==r),O),X=H.length;if(!X)return r;if(X===1)return H[0];const Q=function(Ie,Pe){for(let We=0,Be=H.length;We<Be;We++)if(H[We](Ie,Pe))return O;return null},de=H.find(Ie=>!!Ie.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=H.reduce((Ie,Pe)=>Pe.allPaths?Ie.concat(Pe.allPaths):Ie,[]);return _e.length&&(Q.allPaths=_e),Q}function u(O,j,H){const X=S.sep===S.posix.sep,Q=X?O:O.replace(c,S.sep),de=S.sep+Q,_e=S.posix.sep+O,Ie=H?function(Pe,We){return typeof Pe=="string"&&(Pe===Q||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(_e)))?j:null}:function(Pe,We){return typeof Pe=="string"&&(Pe===Q||!X&&Pe===O)?j:null};return Ie.allPaths=[(H?"*/":"./")+O],Ie}function y(O){try{const j=new RegExp(`^${w(O)}$`);return function(H){return j.lastIndex=0,typeof H=="string"&&j.test(H)?O:null}}catch(j){return r}}function T(O,j,H){return!O||typeof j!="string"?!1:R(O)(j,void 0,H)}e.match=T;function R(O,j={}){if(!O)return h;if(typeof O=="string"||W(O)){const H=t(O,j);if(H===r)return h;const X=function(Q,de){return!!H(Q,de)};return H.allBasenames&&(X.allBasenames=H.allBasenames),H.allPaths&&(X.allPaths=H.allPaths),X}return N(O,j)}e.parse=R;function $(O){if(!O)return;let j;return H=>(j||(j=(O()||Promise.resolve([])).then(X=>X?F(X):{})),j.then(X=>!!X[H]))}e.hasSiblingPromiseFn=$;function B(O){if(!O)return;let j;return H=>{if(!j){const X=O();j=X?F(X):{}}return!!j[H]}}e.hasSiblingFn=B;function F(O){const j={};for(const H of O)j[H]=!0;return j}function W(O){const j=O;return j&&typeof j.base=="string"&&typeof j.pattern=="string"}e.isRelativePattern=W;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function z(O){return O.allPaths||[]}e.getPathTerms=z;function N(O,j){const H=x(Object.getOwnPropertyNames(O).map(Ie=>U(Ie,O[Ie],j)).filter(Ie=>Ie!==r)),X=H.length;if(!X)return r;if(!H.some(Ie=>!!Ie.requiresSiblings)){if(X===1)return H[0];const Ie=function(Be,He){for(let G=0,ee=H.length;G<ee;G++){const ie=H[G](Be,He);if(ie)return ie}return null},Pe=H.find(Be=>!!Be.allBasenames);Pe&&(Ie.allBasenames=Pe.allBasenames);const We=H.reduce((Be,He)=>He.allPaths?Be.concat(He.allPaths):Be,[]);return We.length&&(Ie.allPaths=We),Ie}const Q=function(Ie,Pe,We){let Be;for(let He=0,G=H.length;He<G;He++){const ee=H[He];ee.requiresSiblings&&We&&(Pe||(Pe=S.basename(Ie)),Be||(Be=Pe.substr(0,Pe.length-S.extname(Ie).length)));const ie=ee(Ie,Pe,Be,We);if(ie)return ie}return null},de=H.find(Ie=>!!Ie.allBasenames);de&&(Q.allBasenames=de.allBasenames);const _e=H.reduce((Ie,Pe)=>Pe.allPaths?Ie.concat(Pe.allPaths):Ie,[]);return _e.length&&(Q.allPaths=_e),Q}function U(O,j,H){if(j===!1)return r;const X=t(O,H);if(X===r)return r;if(typeof j=="boolean")return X;if(j){const Q=j.when;if(typeof Q=="string"){const de=(_e,Ie,Pe,We)=>{if(!We||!X(_e,Ie))return null;const Be=Q.replace("$(basename)",Pe),He=We(Be);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function x(O,j){const H=O.filter(Ie=>!!Ie.basenames);if(H.length<2)return O;const X=H.reduce((Ie,Pe)=>{const We=Pe.basenames;return We?Ie.concat(We):Ie},[]);let Q;if(j){Q=[];for(let Ie=0,Pe=X.length;Ie<Pe;Ie++)Q.push(j)}else Q=H.reduce((Ie,Pe)=>{const We=Pe.patterns;return We?Ie.concat(We):Ie},[]);const de=function(Ie,Pe){if(typeof Ie!="string")return null;if(!Pe){let Be;for(Be=Ie.length;Be>0;Be--){const He=Ie.charCodeAt(Be-1);if(He===47||He===92)break}Pe=Ie.substr(Be)}const We=X.indexOf(Pe);return We!==-1?Q[We]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const _e=O.filter(Ie=>!Ie.basenames);return _e.push(de),_e}}),define(fe[80],me([0,1,29,10,9,12,23,8,2]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(t,l,o){if(typeof t=="string"&&(t=E.URI.file(t)),o){const m=o.getWorkspaceFolder(t);if(m){const u=o.getWorkspace().folders.length>1;let y;if((0,A.isEqual)(m.uri,t)?y="":y=(0,A.relativePath)(m.uri,t),u){const T=m.name?m.name:(0,A.basename)(m.uri);y=y?T+" \u2022 "+y:T}return y}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,D.normalize)(I(t.fsPath));let d=(0,D.normalize)(t.fsPath);return!S.isWindows&&l?.userHome&&(d=p(d,l.userHome.fsPath)),d}e.getPathLabel=C;function i(t){if(!t)return;typeof t=="string"&&(t=E.URI.file(t));const l=(0,A.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return S.isWindows&&(0,g.isRootOrDriveLetter)(l)?I(l):l}e.getBaseLabel=i;function I(t,l){return(0,g.hasDriveLetter)(t,l)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let c=Object.create(null);function p(t,l){if(S.isWindows||!t||!l)return t;let o=c.original===l?c.normalized:void 0;return o||(o=`${(0,k.rtrim)(l,D.posix.sep)}${D.posix.sep}`,c={original:l,normalized:o}),(S.isLinux?t.startsWith(o):(0,k.startsWithIgnoreCase)(t,o))&&(t=`~/${t.substr(o.length)}`),t}e.tildify=p;function f(t,l){return t.replace(/^~($|\/|\\)/,`${l}$1`)}e.untildify=f;const w="\u2026",_="\\\\",P="~";function b(t,l=D.sep){const o=new Array(t.length);let d=!1;for(let m=0;m<t.length;m++){let u=t[m];if(u===""){o[m]=`.${l}`;continue}if(!u){o[m]=u;continue}d=!0;let y="";u.indexOf(_)===0?(y=u.substr(0,u.indexOf(_)+_.length),u=u.substr(u.indexOf(_)+_.length)):u.indexOf(l)===0?(y=u.substr(0,u.indexOf(l)+l.length),u=u.substr(u.indexOf(l)+l.length)):u.indexOf(P)===0&&(y=u.substr(0,u.indexOf(P)+P.length),u=u.substr(u.indexOf(P)+P.length));const T=u.split(l);for(let R=1;d&&R<=T.length;R++)for(let $=T.length-R;d&&$>=0;$--){d=!1;let B=T.slice($,$+R).join(l);for(let F=0;!d&&F<t.length;F++)if(F!==m&&t[F]&&t[F].indexOf(B)>-1){const W=$+R===T.length,M=$>0&&t[F].indexOf(l)>-1?l+B:B,z=t[F].endsWith(M);d=!W||z}if(!d){let F="";(T[0].endsWith(":")||y!=="")&&($===1&&($=0,R++,B=T[0]+l+B),$>0&&(F=T[0]+l),F=y+F),$>0&&(F=F+w+l),F=F+B,$+R<T.length&&(F=F+l+w),o[m]=F}}d&&(o[m]=u)}return o}e.shorten=b;var s;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function a(t,l=Object.create(null)){const o=[];let d=!1,m="";for(const u of t)if(u==="$"||d&&u==="{")m&&o.push({value:m,type:s.TEXT}),m="",d=!0;else if(u==="}"&&d){const y=l[m];if(typeof y=="string")y.length&&o.push({value:y,type:s.VARIABLE});else if(y){const T=o[o.length-1];(!T||T.type!==s.SEPARATOR)&&o.push({value:y.label,type:s.SEPARATOR})}m="",d=!1}else m+=u;return m&&!d&&o.push({value:m,type:s.TEXT}),o.filter((u,y)=>{if(u.type===s.SEPARATOR){const T=o[y-1],R=o[y+1];return[T,R].every($=>$&&($.type===s.VARIABLE||$.type===s.TEXT)&&$.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=a;function v(t,l){return S.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):t.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=v;function n(t,l){return S.isMacintosh||l?t.replace(/\(&&\w\)|&&/g,""):S.isWindows?t.replace(/&&|&/g,o=>o==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function h(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=h;function r(t){const l=t.indexOf("/")!==-1?D.posix:D.win32,o=l.basename(t),d=l.dirname(t);return o.length?{name:o,parentPath:d}:{name:d,parentPath:""}}e.splitName=r}),define(fe[101],me([0,1,30,10,9,23,8]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let E=[],C=[],i=[];function I(t,l=!1){const o=c(t);E.push(o),o.userConfigured?i.push(o):C.push(o),l&&!o.userConfigured&&E.forEach(d=>{d.mime===o.mime||d.userConfigured||(o.extension&&d.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&d.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&d.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&d.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=I;function c(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(E=E.filter(l=>!l.userConfigured),i=[]):(E=[],C=[],i=[])}e.clearTextMimes=p;function f(t,l){let o;if(t)switch(t.scheme){case L.Schemas.file:o=t.fsPath;break;case L.Schemas.data:o=S.DataUri.parseMetaData(t).get(S.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[k.unknown];o=o.toLowerCase();const d=(0,D.basename)(o),m=w(o,d,i);if(m)return[m,k.text];const u=w(o,d,C);if(u)return[u,k.text];if(l){const y=_(l);if(y)return[y,k.text]}return[k.unknown]}e.guessMimeTypes=f;function w(t,l,o){let d=null,m=null,u=null;for(let y=o.length-1;y>=0;y--){const T=o[y];if(l===T.filenameLowercase){d=T;break}if(T.filepattern&&(!m||T.filepattern.length>m.filepattern.length)){const R=T.filepatternOnPath?t:l;T.filepatternLowercase?.(R)&&(m=T)}T.extension&&(!u||T.extension.length>u.extension.length)&&l.endsWith(T.extensionLowercase)&&(u=T)}return d?d.mime:m?m.mime:u?u.mime:null}function _(t){if((0,A.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let l=E.length-1;l>=0;l--){const o=E[l];if(!o.firstline)continue;const d=t.match(o.firstline);if(d&&d.length>0)return o.mime}return null}function P(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&P(t[0]):!0}e.isUnspecific=P;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(t){const l=(0,D.extname)(t),o=b[l.toLowerCase()];return o!==void 0?o:v(t)}e.getMediaOrTextMime=a;function v(t){const l=(0,D.extname)(t);return s[l.toLowerCase()]}e.getMediaMime=v;function n(t){for(const l in s)if(s[l]===t)return l}e.getExtensionForMimeType=n;const h=/^(.+)\/(.+?)(;.+)?$/;function r(t,l){const o=h.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:l?void 0:t}e.normalizeMimeType=r}),define(fe[102],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:L(g.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:L(g.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:g.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function S(i,I,c){if(!i||c>200)return null;if(typeof i=="object"){if(i instanceof g.URI)return I.transformOutgoing(i);for(let p in i)if(Object.hasOwnProperty.call(i,p)){const f=S(i[p],I,c+1);f!==null&&(i[p]=f)}}return null}function A(i,I){const c=S(i,I,0);return c===null?i:c}e.transformOutgoingURIs=A;function k(i,I,c,p){if(!i||p>200)return null;if(typeof i=="object"){if(i.$mid===1)return c?g.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let f in i)if(Object.hasOwnProperty.call(i,f)){const w=k(i[f],I,c,p+1);w!==null&&(i[f]=w)}}return null}function E(i,I){const c=k(i,I,!1,0);return c===null?i:c}e.transformIncomingURIs=E;function C(i,I){const c=k(i,I,!0,0);return c===null?i:c}e.transformAndReviveIncomingURIs=C}),define(fe[31],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(E){return g.test(E)}e.isUUID=L;const D=new Uint8Array(16),S=[];for(let E=0;E<256;E++)S.push(E.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(E){for(let C=0;C<E.length;C++)E[C]=Math.floor(Math.random()*256);return E};function k(){A(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,C="";return C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C+="-",C+=S[D[E++]],C+=S[D[E++]],C+="-",C+=S[D[E++]],C+=S[D[E++]],C+="-",C+=S[D[E++]],C+=S[D[E++]],C+="-",C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C+=S[D[E++]],C}e.generateUuid=k}),define(fe[143],me([0,1,103]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(S="utf8"){this.stringDecoder=new g.StringDecoder(S),this.remaining=null}write(S){const A=[],k=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(k.length<1)return A;let E=0,C,i=E;for(;i<k.length;)if(C=k.charCodeAt(i),C===13||C===10){if(A.push(k.substring(E,i)),i++,i<k.length){const I=C;C=k.charCodeAt(i),(I===13&&C===10||I===10&&C===13)&&i++}E=i}else i++;return this.remaining=E<k.length?k.substr(E):null,A}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,62,81,293,16,29,79,9,12,23,2,31]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function f(M,z=p.UNLINK){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return z===p.UNLINK?_(M):w(M)}async function w(M){try{const z=(0,E.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(M,z)}catch(N){return _(M)}_(z).catch(N=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function _(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function P(M){if((0,A.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=P;async function b(M,z){return v(await(z?s(M):(0,D.promisify)(g.readdir)(M)))}async function s(M){try{return await(0,D.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const z=[],N=await b(M);for(const U of N){let x=!1,O=!1,j=!1;try{const H=await e.Promises.lstat((0,E.join)(M,U));x=H.isFile(),O=H.isDirectory(),j=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}z.push({name:U,isFile:()=>x,isDirectory:()=>O,isSymbolicLink:()=>j})}return z}function a(M){return v(g.readdirSync(M))}e.readdirSync=a;function v(M){return M.map(z=>typeof z=="string"?C.isMacintosh?(0,k.normalizeNFC)(z):z:(z.name=C.isMacintosh?(0,k.normalizeNFC)(z.name):z.name,z))}async function n(M){const z=await b(M),N=[];for(const U of z)await r.existsDirectory((0,E.join)(M,U))&&N.push(U);return N}function h(M,z=1e3){return new Promise(N=>{let U=!1;const x=setInterval(()=>{U||(U=!0,g.access(M,O=>{U=!1,O&&(clearInterval(x),N(void 0))}))},z)})}e.whenDeleted=h;var r;(function(M){async function z(x){let O;try{if(O=await e.Promises.lstat(x),!O.isSymbolicLink())return{stat:O}}catch(j){}try{return{stat:await e.Promises.stat(x),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(C.isWindows&&j.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw H}throw j}}M.stat=z;async function N(x){try{const{stat:O,symbolicLink:j}=await M.stat(x);return O.isFile()&&j?.dangling!==!0}catch(O){}return!1}M.existsFile=N;async function U(x){try{const{stat:O,symbolicLink:j}=await M.stat(x);return O.isDirectory()&&j?.dangling!==!0}catch(O){}return!1}M.existsDirectory=U})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new S.ResourceQueue;function l(M,z,N){return t.queueFor(I.URI.file(M),i.extUriBiasedIgnorePathCase).queue(()=>{const U=u(N);return new Promise((x,O)=>d(M,z,U,j=>j?O(j):x()))})}let o=!0;function d(M,z,N,U){if(!o)return g.writeFile(M,z,{mode:N.mode,flag:N.flag},U);g.open(M,N.flag,N.mode,(x,O)=>{if(x)return U(x);g.writeFile(O,z,j=>{if(j)return g.close(O,()=>U(j));g.fdatasync(O,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o=!1),g.close(O,X=>U(X))))})})}function m(M,z,N){const U=u(N);if(!o)return g.writeFileSync(M,z,{mode:U.mode,flag:U.flag});const x=g.openSync(M,U.flag,U.mode);try{g.writeFileSync(x,z);try{g.fdatasyncSync(x)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),o=!1}}finally{g.closeSync(x)}}e.writeFileSync=m;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function y(M,z){if(M===z)return;async function N(U){try{const x=await e.Promises.lstat(U);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(U,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(M,z),await N(z)}catch(U){if(M.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await T(M,z,{preserveSymlinks:!1}),await f(M,p.MOVE),await N(z);else throw U}}async function T(M,z,N){return $(M,z,{root:{source:M,target:z},options:N,handledSourcePaths:new Set})}const R=511;async function $(M,z,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:U,symbolicLink:x}=await r.stat(M);if(x){if(N.options.preserveSymlinks)try{return await W(M,z,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(x.dangling)return}return U.isDirectory()?B(M,z,U.mode&R,N):F(M,z,U.mode&R)}async function B(M,z,N,U){await e.Promises.mkdir(z,{recursive:!0,mode:N});const x=await b(M);for(const O of x)await $((0,E.join)(M,O),(0,E.join)(z,O),U)}async function F(M,z,N){await e.Promises.copyFile(M,z),await e.Promises.chmod(z,N)}async function W(M,z,N){let U=await e.Promises.readlink(M);(0,A.isEqualOrParent)(U,N.root.source,!C.isLinux)&&(U=(0,E.join)(N.root.target,U.substr(N.root.source.length+1))),await e.Promises.symlink(U,z)}e.Promises=new class{get access(){return(0,D.promisify)(g.access)}get stat(){return(0,D.promisify)(g.stat)}get lstat(){return(0,D.promisify)(g.lstat)}get utimes(){return(0,D.promisify)(g.utimes)}get read(){return(0,D.promisify)(g.read)}get readFile(){return(0,D.promisify)(g.readFile)}get write(){return(0,D.promisify)(g.write)}get appendFile(){return(0,D.promisify)(g.appendFile)}get fdatasync(){return(0,D.promisify)(g.fdatasync)}get truncate(){return(0,D.promisify)(g.truncate)}get rename(){return(0,D.promisify)(g.rename)}get copyFile(){return(0,D.promisify)(g.copyFile)}get open(){return(0,D.promisify)(g.open)}get close(){return(0,D.promisify)(g.close)}get symlink(){return(0,D.promisify)(g.symlink)}get readlink(){return(0,D.promisify)(g.readlink)}get chmod(){return(0,D.promisify)(g.chmod)}get mkdir(){return(0,D.promisify)(g.mkdir)}get unlink(){return(0,D.promisify)(g.unlink)}get rmdir(){return(0,D.promisify)(g.rmdir)}get realpath(){return(0,D.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return n}get writeFile(){return l}get rm(){return f}get move(){return y}get copy(){return T}}}),define(fe[104],me([0,1,62,9,8,28]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(i){const I=(0,L.dirname)(i);if(i===I)return i;const c=((0,L.basename)(i)||i).toLowerCase();try{const f=(0,S.readdirSync)(I).filter(w=>w.toLowerCase()===c);if(f.length===1){const w=A(I);if(w)return(0,L.join)(w,f[0])}else if(f.length>1){const w=f.indexOf(c);if(w>=0){const _=A(I);if(_)return(0,L.join)(_,f[w])}}}catch(p){}return null}e.realcaseSync=A;async function k(i){try{return await S.Promises.realpath(i)}catch(I){const c=C(i);return await S.Promises.access(c,g.constants.R_OK),c}}e.realpath=k;function E(i){try{return g.realpathSync(i)}catch(I){const c=C(i);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=E;function C(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var D=arguments.length,S=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(Y,e,g,L);else for(var k=Y.length-1;k>=0;k--)(A=Y[k])&&(S=(D<3?A(S):D>3?A(e,g,S):A(e,g))||S);return D>3&&S&&Object.defineProperty(e,g,S),S};define(fe[105],me([0,1,15,16,22,21,59,18,3,6,61,8,13]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function f(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function _(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(P||(P={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const j=this.buffer.slice(this.pos,this.pos+O);return this.pos+=j.byteLength,j}}class s{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var a;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(a||(a={}));function v(x){const O=D.VSBuffer.alloc(4);return O.writeUInt32BE(x,0),O}function n(x){return x.read(4).readUInt32BE(0)}function h(x){const O=D.VSBuffer.alloc(1);return O.writeUInt8(x,0),O}const r={Undefined:h(a.Undefined),String:h(a.String),Buffer:h(a.Buffer),VSBuffer:h(a.VSBuffer),Array:h(a.Array),Object:h(a.Object)},t=typeof Buffer!="undefined";function l(x,O){if(typeof O=="undefined")x.write(r.Undefined);else if(typeof O=="string"){const j=D.VSBuffer.fromString(O);x.write(r.String),x.write(v(j.byteLength)),x.write(j)}else if(t&&Buffer.isBuffer(O)){const j=D.VSBuffer.wrap(O);x.write(r.Buffer),x.write(v(j.byteLength)),x.write(j)}else if(O instanceof D.VSBuffer)x.write(r.VSBuffer),x.write(v(O.byteLength)),x.write(O);else if(Array.isArray(O)){x.write(r.Array),x.write(v(O.length));for(const j of O)l(x,j)}else{const j=D.VSBuffer.fromString(JSON.stringify(O));x.write(r.Object),x.write(v(j.byteLength)),x.write(j)}}function o(x){switch(x.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return x.read(n(x)).toString();case a.Buffer:return x.read(n(x)).buffer;case a.VSBuffer:return x.read(n(x));case a.Array:{const j=n(x),H=[];for(let X=0;X<j;X++)H.push(o(x));return H}case a.Object:return JSON.parse(x.read(n(x)).toString())}}class d{constructor(O,j,H=null,X=1e3){this.protocol=O,this.ctx=j,this.logger=H,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,j){this.channels.set(O,j),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const j=this.send([O.type]);this.logger&&this.logger.logOutgoing(j,0,1,_(O.type));return}case 201:case 202:case 204:case 203:{const j=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(j,O.id,1,_(O.type),O.data);return}}}send(O,j=void 0){const H=new s;return l(H,O),l(H,j),this.sendBuffer(H.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(j){return 0}}onRawMessage(O){const j=new b(O),H=o(j),X=o(j),Q=H[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${f(Q)}: ${H[2]}.${H[3]}`,X),this.onPromise({type:Q,id:H[1],channelName:H[2],name:H[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${f(Q)}: ${H[2]}.${H[3]}`,X),this.onEventListen({type:Q,id:H[1],channelName:H[2],name:H[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],1,`${f(Q)}`),this.disposeActiveRequest({type:Q,id:H[1]})}}onPromise(O){const j=this.channels.get(O.channelName);if(!j){this.collectPendingRequest(O);return}const H=new S.CancellationTokenSource;let X;try{X=j.call(this.ctx,O.name,O.arg,H.token)}catch(_e){X=Promise.reject(_e)}const Q=O.id;X.then(_e=>{this.sendResponse({id:Q,data:_e,type:201}),this.activeRequests.delete(O.id)},_e=>{_e instanceof Error?this.sendResponse({id:Q,data:{message:_e.message,name:_e.name,stack:_e.stack?_e.stack.split?_e.stack.split(`
`):_e.stack:void 0},type:202}):this.sendResponse({id:Q,data:_e,type:203}),this.activeRequests.delete(O.id)});const de=(0,C.toDisposable)(()=>H.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const j=this.channels.get(O.channelName);if(!j){this.collectPendingRequest(O);return}const H=O.id,Q=j.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:H,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const j=this.activeRequests.get(O.id);j&&(j.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let j=this.pendingRequests.get(O.channelName);j||(j=[],this.pendingRequests.set(O.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:O,timeoutTimer:H})}flushPendingRequests(O){const j=this.pendingRequests.get(O);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=d;var m;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(O,j=null){this.protocol=O,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(O){const j=this;return{call(H,X,Q){return j.isDisposed?Promise.reject(k.canceled()):j.requestPromise(O,H,X,Q)},listen(H,X){return j.isDisposed?Promise.reject(k.canceled()):j.requestEvent(O,H,X)}}}requestPromise(O,j,H,X=S.CancellationToken.None){const Q=this.lastRequestId++,_e={id:Q,type:100,channelName:O,name:j,arg:H};if(X.isCancellationRequested)return Promise.reject(k.canceled());let Ie;return new Promise((We,Be)=>{if(X.isCancellationRequested)return Be(k.canceled());const He=()=>{const ce=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),We(Z.data);break;case 202:this.handlers.delete(Q);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,Be(re);break;case 203:this.handlers.delete(Q),Be(Z.data);break}};this.handlers.set(Q,ce),this.sendRequest(_e)};let G=null;this.state===P.Idle?He():(G=(0,L.createCancelablePromise)(ce=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Q,type:101}),Be(k.canceled())},ie=X.onCancellationRequested(ee);Ie=(0,C.combinedDisposable)((0,C.toDisposable)(ee),ie),this.activeRequests.add(Ie)}).finally(()=>{this.activeRequests.delete(Ie)})}requestEvent(O,j,H){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:j,arg:H};let _e=null;const Ie=new E.Emitter({onFirstListenerAdd:()=>{_e=(0,L.createCancelablePromise)(We=>this.whenInitialized()),_e.then(()=>{_e=null,this.activeRequests.add(Ie),this.sendRequest(de)})},onLastListenerRemove:()=>{_e?(_e.cancel(),_e=null):(this.activeRequests.delete(Ie),this.sendRequest({id:X,type:103}))}}),Pe=We=>Ie.fire(We.data);return this.handlers.set(X,Pe),Ie.event}sendRequest(O){switch(O.type){case 100:case 102:{const j=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(j,O.id,0,`${f(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const j=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(j,O.id,0,f(O.type));return}}}send(O,j=void 0){const H=new s;return l(H,O),l(H,j),this.sendBuffer(H.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(j){return 0}}onBuffer(O){const j=new b(O),H=o(j),X=o(j),Q=H[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,_(Q)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,H[1],0,_(Q),X),this.onResponse({type:H[0],id:H[1],data:X})}}onResponse(O){if(O.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(O.id);j&&j(O)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([A.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class y{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:j,onDidClientDisconnect:H})=>{E.Event.once(j.onMessage)(Q=>{const de=new b(Q),_e=o(de),Ie=new d(j,_e),Pe=new u(j);this.channels.forEach((Be,He)=>Ie.registerChannel(He,Be));const We={channelServer:Ie,channelClient:Pe,ctx:_e};this._connections.add(We),this._onDidAddConnection.fire(We),H(()=>{Ie.dispose(),Pe.dispose(),this._connections.delete(We),this._onDidRemoveConnection.fire(We)})})})}get connections(){const O=[];return this._connections.forEach(j=>O.push(j)),O}getChannel(O,j){const H=this;return{call(X,Q,de){let _e;if((0,c.isFunction)(j)){let Pe=(0,g.getRandomElement)(H.connections.filter(j));_e=Pe?Promise.resolve(Pe):E.Event.toPromise(E.Event.filter(H.onDidAddConnection,j))}else _e=j.routeCall(H,X,Q);const Ie=_e.then(Pe=>Pe.channelClient.getChannel(O));return R(Ie).call(X,Q,de)},listen(X,Q){if((0,c.isFunction)(j))return H.getMulticastEvent(O,j,X,Q);const de=j.routeEvent(H,X,Q).then(_e=>_e.channelClient.getChannel(O));return R(de).listen(X,Q)}}}getMulticastEvent(O,j,H,X){const Q=this;let de=new C.DisposableStore;const _e=new E.Emitter({onFirstListenerAdd:()=>{de=new C.DisposableStore;const Ie=new E.EventMultiplexer,Pe=new Map,We=He=>{const ee=He.channelClient.getChannel(O).listen(H,X),ie=Ie.add(ee);Pe.set(He,ie)},Be=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};Q.connections.filter(j).forEach(We),E.Event.filter(Q.onDidAddConnection,j)(We,void 0,de),Q.onDidRemoveConnection(Be,void 0,de),Ie.event(_e.fire,_e,de),de.add(Ie)},onLastListenerRemove:()=>{de.dispose()}});return _e.event}registerChannel(O,j){this.channels.set(O,j),this._connections.forEach(H=>{H.channelServer.registerChannel(O,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=y;class T{constructor(O,j,H=null){const X=new s;l(X,j),O.send(X.buffer),this.channelClient=new u(O,H),this.channelServer=new d(O,j,H)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,j){this.channelServer.registerChannel(O,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function R(x){return{call(O,j,H){return x.then(X=>X.call(O,j,H))},listen(O,j){const H=new E.Relay;return x.then(X=>H.input=X.listen(O,j)),H.event}}}e.getDelayedChannel=R;function $(x){let O=!1;return{call(j,H,X){return O?x.call(j,H,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>x.call(j,H,X))},listen(j,H){if(O)return x.listen(j,H);const X=new E.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=x.listen(j,H)),X.event}}}e.getNextTickChannel=$;class B{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const j of O.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await E.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=B;var F;(function(x){function O(Q,de){const _e=Q,Ie=de&&de.disableMarshalling,Pe=new Map;for(const We in _e)H(We)&&Pe.set(We,E.Event.buffer(_e[We],!0));return new class{listen(We,Be,He){const G=Pe.get(Be);if(G)return G;if(X(Be)){const ee=_e[Be];if(typeof ee=="function")return ee.call(_e,He)}throw new Error(`Event not found: ${Be}`)}call(We,Be,He){const G=_e[Be];if(typeof G=="function"){if(!Ie&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,i.revive)(He[ee]);return G.apply(_e,He)}throw new Error(`Method not found: ${Be}`)}}}x.fromService=O;function j(Q,de){const _e=de&&de.disableMarshalling;return new Proxy({},{get(Ie,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(We){return Q.listen(Pe,We)}:H(Pe)?Q.listen(Pe):async function(...We){let Be;de&&!(0,c.isUndefinedOrNull)(de.context)?Be=[de.context,...We]:Be=We;const He=await Q.call(Pe,Be);return _e?He:(0,i.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}x.toService=j;function H(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let O=x.toString();if(O!=="[object Object]")return O}return x}function z(x){return Array.isArray(x)?x.map(M):M(x)}function N(x,O,j,H,X,Q,de){de=z(de);const _e=W[X],Ie=_e[H%_e.length];let Pe=[`%c[${x}]%c[${String(O).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${Ie}`];/\($/.test(Q)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=N;class U{constructor(O,j){this._outgoingPrefix=O,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,j,H,X,Q){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,j,H,X,Q)}logIncoming(O,j,H,X,Q){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,j,H,X,Q)}}e.IPCLogger=U}),define(fe[106],me([0,1,22,3,6,12,37,105]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var E;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function i(){return C||(C=g.VSBuffer.alloc(0)),C}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,l){if(t===0)return i();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const u=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=t),u}if(this._chunks[0].byteLength>t){const u=this._chunks[0].slice(0,t);return l&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),u}let o=g.VSBuffer.alloc(t),d=0,m=0;for(;t>0;){const u=this._chunks[m];if(u.byteLength>t){const y=u.slice(0,t);o.set(y,d),d+=t,l&&(this._chunks[m]=u.slice(t),this._totalLength-=t),t-=t}else o.set(u,d),d+=u.byteLength,l?(this._chunks.shift(),this._totalLength-=u.byteLength):m++,t-=u.byteLength}return o}}e.ChunkStream=I;var c;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var p;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(t,l,o,d){this.type=t,this.id=l,this.ack=o,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5);else{const o=this._state.messageType,d=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(o,d,m,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class _{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=g.VSBuffer.alloc(13);l.writeUInt8(t.type,0),l.writeUInt32BE(t.id,1),l.writeUInt32BE(t.ack,5),l.writeUInt32BE(t.data.byteLength,9),this._writeSoon(l,t.data)}_bufferAdd(t,l){const o=this._totalLength===0;return this._data.push(t,l),this._totalLength+=t.byteLength+l.byteLength,o}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,l){this._bufferAdd(t,l)&&S.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends D.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new _(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new f(1,0,0,t))}}e.Protocol=P;class b extends k.IPCClient{constructor(t,l,o=null){super(t,l,o);this.protocol=t}static fromSocket(t,l){return new b(new P(t),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class s{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,A.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=s;class a{constructor(t){this.data=t,this.next=null}}class v{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],l=0,o=this._first;for(;o;)t[l++]=o.data,o=o.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const l=new a(t);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let l=0;l<n._HISTORY_LENGTH;l++)this.lastRuns[l]=t-1e3*l;setInterval(()=>{for(let l=n._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),l=(1+n._HISTORY_LENGTH)*1e3;let o=0;for(let d=0;d<n._HISTORY_LENGTH;d++)t-this.lastRuns[d]<=l&&o++;return 1-o/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class h{constructor(t,l=null,o=n.getInstance()){this._onControlMessage=new s,this.onControlMessage=this._onControlMessage.event,this._onMessage=new s,this.onMessage=this._onMessage.event,this._onDidDispose=new s,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new s,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new s,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new v,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),l&&this._socketReader.acceptChunk(l),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new f(5,0,0,i());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const l=new f(4,0,0,i());this._socketWriter.write(l),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,l){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new _(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let l=0,o=t.length;l<o;l++)this._socketWriter.write(t[l]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new f(6,0,0,i())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const l=this._outgoingUnackMsg.toArray();for(let o=0,d=l.length;o<d;o++)this._socketWriter.write(l[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new f(1,l,this._incomingAckId,t);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(t){const l=new f(2,0,0,t);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),l=Date.now()-t.writtenTime;if(l>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-l,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new f(3,0,this._incomingAckId,i());this._socketWriter.write(t)}}e.PersistentProtocol=h}),define(fe[107],me([0,1,98]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let E=(0,g.toUint8)(k);this._defaultValue=E,this._asciiMap=L._createAsciiMap(E),this._map=new Map}static _createAsciiMap(k){let E=new Uint8Array(256);for(let C=0;C<256;C++)E[C]=k;return E}set(k,E){let C=(0,g.toUint8)(E);k>=0&&k<256?this._asciiMap[k]=C:this._map.set(k,C)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var D;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(D||(D={}));class S{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=S}),define(fe[144],me([0,1,107]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends g.CharacterClassifier{constructor(k){super(0);for(let E=0,C=k.length;E<C;E++)this.set(k.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function S(A){let k={};return E=>(k.hasOwnProperty(E)||(k[E]=A(E)),k[E])}e.getMapForWordSeparators=S(A=>new D(A))}),define(fe[50],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(D,S){this.lineNumber=D,this.column=S}with(D=this.lineNumber,S=this.column){return D===this.lineNumber&&S===this.column?this:new g(D,S)}delta(D=0,S=0){return this.with(this.lineNumber+D,this.column+S)}equals(D){return g.equals(this,D)}static equals(D,S){return!D&&!S?!0:!!D&&!!S&&D.lineNumber===S.lineNumber&&D.column===S.column}isBefore(D){return g.isBefore(this,D)}static isBefore(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<S.column}isBeforeOrEqual(D){return g.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,S){return D.lineNumber<S.lineNumber?!0:S.lineNumber<D.lineNumber?!1:D.column<=S.column}static compare(D,S){let A=D.lineNumber|0,k=S.lineNumber|0;if(A===k){let E=D.column|0,C=S.column|0;return E-C}return A-k}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new g(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=g}),define(fe[41],me([0,1,50]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(S,A,k,E){S>k||S===k&&A>E?(this.startLineNumber=k,this.startColumn=E,this.endLineNumber=S,this.endColumn=A):(this.startLineNumber=S,this.startColumn=A,this.endLineNumber=k,this.endColumn=E)}isEmpty(){return L.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return L.containsPosition(this,S)}static containsPosition(S,A){return!(A.lineNumber<S.startLineNumber||A.lineNumber>S.endLineNumber||A.lineNumber===S.startLineNumber&&A.column<S.startColumn||A.lineNumber===S.endLineNumber&&A.column>S.endColumn)}containsRange(S){return L.containsRange(this,S)}static containsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>S.endColumn)}strictContainsRange(S){return L.strictContainsRange(this,S)}static strictContainsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<=S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>=S.endColumn)}plusRange(S){return L.plusRange(this,S)}static plusRange(S,A){let k,E,C,i;return A.startLineNumber<S.startLineNumber?(k=A.startLineNumber,E=A.startColumn):A.startLineNumber===S.startLineNumber?(k=A.startLineNumber,E=Math.min(A.startColumn,S.startColumn)):(k=S.startLineNumber,E=S.startColumn),A.endLineNumber>S.endLineNumber?(C=A.endLineNumber,i=A.endColumn):A.endLineNumber===S.endLineNumber?(C=A.endLineNumber,i=Math.max(A.endColumn,S.endColumn)):(C=S.endLineNumber,i=S.endColumn),new L(k,E,C,i)}intersectRanges(S){return L.intersectRanges(this,S)}static intersectRanges(S,A){let k=S.startLineNumber,E=S.startColumn,C=S.endLineNumber,i=S.endColumn,I=A.startLineNumber,c=A.startColumn,p=A.endLineNumber,f=A.endColumn;return k<I?(k=I,E=c):k===I&&(E=Math.max(E,c)),C>p?(C=p,i=f):C===p&&(i=Math.min(i,f)),k>C||k===C&&E>i?null:new L(k,E,C,i)}equalsRange(S){return L.equalsRange(this,S)}static equalsRange(S,A){return!!S&&!!A&&S.startLineNumber===A.startLineNumber&&S.startColumn===A.startColumn&&S.endLineNumber===A.endLineNumber&&S.endColumn===A.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(S){return new g.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(S){return new g.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,A){return new L(this.startLineNumber,this.startColumn,S,A)}setStartPosition(S,A){return new L(S,A,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(S){return new L(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,A=S){return new L(S.lineNumber,S.column,A.lineNumber,A.column)}static lift(S){return S?new L(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn)}static areIntersecting(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,A){if(S&&A){const C=S.startLineNumber|0,i=A.startLineNumber|0;if(C===i){const I=S.startColumn|0,c=A.startColumn|0;if(I===c){const p=S.endLineNumber|0,f=A.endLineNumber|0;if(p===f){const w=S.endColumn|0,_=A.endColumn|0;return w-_}return p-f}return I-c}return C-i}return(S?1:0)-(A?1:0)}static compareRangesUsingEnds(S,A){return S.endLineNumber===A.endLineNumber?S.endColumn===A.endColumn?S.startLineNumber===A.startLineNumber?S.startColumn-A.startColumn:S.startLineNumber-A.startLineNumber:S.endColumn-A.endColumn:S.endLineNumber-A.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,50,41]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class S extends L.Range{constructor(k,E,C,i){super(k,E,C,i);this.selectionStartLineNumber=k,this.selectionStartColumn=E,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return S.selectionsEqual(this,k)}static selectionsEqual(k,E){return k.selectionStartLineNumber===E.selectionStartLineNumber&&k.selectionStartColumn===E.selectionStartColumn&&k.positionLineNumber===E.positionLineNumber&&k.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,E){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,k,E):new S(k,E,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,E){return this.getDirection()===0?new S(k,E,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,k,E)}static fromPositions(k,E=k){return new S(k.lineNumber,k.column,E.lineNumber,E.column)}static fromRange(k,E){return E===0?new S(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new S(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new S(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,E){if(k&&!E||!k&&E)return!1;if(!k&&!E)return!0;if(k.length!==E.length)return!1;for(let C=0,i=k.length;C<i;C++)if(!this.selectionsEqual(k[C],E[C]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,E,C,i,I){return I===0?new S(k,E,C,i):new S(C,i,k,E)}}e.Selection=S}),define(fe[108],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var D;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(D=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class E{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=E;class C{constructor(s,a){this._findMatchBrand=void 0,this.range=s,this.matches=a}}e.FindMatch=C;var i;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(i=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class c{constructor(s,a,v){this.visibleColumn=s,this.className=a,this.horizontalLine=v}}e.IndentGuide=c;class p{constructor(s,a){this.top=s,this.endColumn=a}}e.IndentGuideHorizontalLine=p;var f;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(f=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class _{constructor(s,a,v,n,h,r){this.identifier=s,this.range=a,this.text=v,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=h,this._isTracked=r}}e.ValidAnnotatedEditOperation=_;class P{constructor(s,a,v){this.reverseEdits=s,this.changes=a,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=P}),define(fe[146],me([0,1,8,144,50,41,108]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class E{constructor(s,a,v,n){this.searchString=s,this.isRegex=a,this.matchCase=v,this.wordSeparators=n}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=C(this.searchString):s=this.searchString.indexOf(`
`)>=0;let a=null;try{a=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(n){return null}if(!a)return null;let v=!this.isRegex&&!s;return v&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(v=this.matchCase),new i(a,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,v?this.searchString:null)}}e.SearchParams=E;function C(b){if(!b||b.length===0)return!1;for(let s=0,a=b.length;s<a;s++)if(b.charCodeAt(s)===92){if(s++,s>=a)break;const n=b.charCodeAt(s);if(n===110||n===114||n===87)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(s,a,v){this.regex=s,this.wordSeparators=a,this.simpleSearch=v}}e.SearchData=i;function I(b,s,a){if(!a)return new A.FindMatch(b,null);let v=[];for(let n=0,h=s.length;n<h;n++)v[n]=s[n];return new A.FindMatch(b,v)}e.createFindMatch=I;class c{constructor(s){let a=[],v=0;for(let n=0,h=s.length;n<h;n++)s.charCodeAt(n)===10&&(a[v++]=n);this._lineFeedsOffsets=a}findLineFeedCountBeforeOffset(s){const a=this._lineFeedsOffsets;let v=0,n=a.length-1;if(n===-1||s<=a[0])return 0;for(;v<n;){const h=v+((n-v)/2>>0);a[h]>=s?n=h-1:a[h+1]>=s?(v=h,n=h):v=h+1}return v+1}}class p{static findMatches(s,a,v,n,h){const r=a.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(s,v,new P(r.wordSeparators,r.regex),n,h):this._doFindMatchesLineByLine(s,v,r,n,h):[]}static _getMultilineMatchRange(s,a,v,n,h,r){let t,l=0;n?(l=n.findLineFeedCountBeforeOffset(h),t=a+h+l):t=a+h;let o;if(n){let y=n.findLineFeedCountBeforeOffset(h+r.length)-l;o=t+r.length+y}else o=t+r.length;const d=s.getPositionAt(t),m=s.getPositionAt(o);return new S.Range(d.lineNumber,d.column,m.lineNumber,m.column)}static _doFindMatchesMultiline(s,a,v,n,h){const r=s.getOffsetAt(a.getStartPosition()),t=s.getValueInRange(a,1),l=s.getEOL()===`\r
`?new c(t):null,o=[];let d=0,m;for(v.reset(0);m=v.next(t);)if(o[d++]=I(this._getMultilineMatchRange(s,r,t,l,m.index,m[0]),m,n),d>=h)return o;return o}static _doFindMatchesLineByLine(s,a,v,n,h){const r=[];let t=0;if(a.startLineNumber===a.endLineNumber){const o=s.getLineContent(a.startLineNumber).substring(a.startColumn-1,a.endColumn-1);return t=this._findMatchesInLine(v,o,a.startLineNumber,a.startColumn-1,t,r,n,h),r}const l=s.getLineContent(a.startLineNumber).substring(a.startColumn-1);t=this._findMatchesInLine(v,l,a.startLineNumber,a.startColumn-1,t,r,n,h);for(let o=a.startLineNumber+1;o<a.endLineNumber&&t<h;o++)t=this._findMatchesInLine(v,s.getLineContent(o),o,0,t,r,n,h);if(t<h){const o=s.getLineContent(a.endLineNumber).substring(0,a.endColumn-1);t=this._findMatchesInLine(v,o,a.endLineNumber,0,t,r,n,h)}return r}static _findMatchesInLine(s,a,v,n,h,r,t,l){const o=s.wordSeparators;if(!t&&s.simpleSearch){const u=s.simpleSearch,y=u.length,T=a.length;let R=-y;for(;(R=a.indexOf(u,R+y))!==-1;)if((!o||_(o,a,T,R,y))&&(r[h++]=new A.FindMatch(new S.Range(v,R+1+n,v,R+1+y+n),null),h>=l))return h;return h}const d=new P(s.wordSeparators,s.regex);let m;d.reset(0);do if(m=d.next(a),m&&(r[h++]=I(new S.Range(v,m.index+1+n,v,m.index+1+m[0].length+n),m,t),h>=l))return h;while(m);return h}static findNextMatch(s,a,v,n){const h=a.parseSearchRequest();if(!h)return null;const r=new P(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindNextMatchMultiline(s,v,r,n):this._doFindNextMatchLineByLine(s,v,r,n)}static _doFindNextMatchMultiline(s,a,v,n){const h=new D.Position(a.lineNumber,1),r=s.getOffsetAt(h),t=s.getLineCount(),l=s.getValueInRange(new S.Range(h.lineNumber,h.column,t,s.getLineMaxColumn(t)),1),o=s.getEOL()===`\r
`?new c(l):null;v.reset(a.column-1);let d=v.next(l);return d?I(this._getMultilineMatchRange(s,r,l,o,d.index,d[0]),d,n):a.lineNumber!==1||a.column!==1?this._doFindNextMatchMultiline(s,new D.Position(1,1),v,n):null}static _doFindNextMatchLineByLine(s,a,v,n){const h=s.getLineCount(),r=a.lineNumber,t=s.getLineContent(r),l=this._findFirstMatchInLine(v,t,r,a.column,n);if(l)return l;for(let o=1;o<=h;o++){const d=(r+o-1)%h,m=s.getLineContent(d+1),u=this._findFirstMatchInLine(v,m,d+1,1,n);if(u)return u}return null}static _findFirstMatchInLine(s,a,v,n,h){s.reset(n-1);const r=s.next(a);return r?I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,h):null}static findPreviousMatch(s,a,v,n){const h=a.parseSearchRequest();if(!h)return null;const r=new P(h.wordSeparators,h.regex);return h.regex.multiline?this._doFindPreviousMatchMultiline(s,v,r,n):this._doFindPreviousMatchLineByLine(s,v,r,n)}static _doFindPreviousMatchMultiline(s,a,v,n){const h=this._doFindMatchesMultiline(s,new S.Range(1,1,a.lineNumber,a.column),v,n,10*k);if(h.length>0)return h[h.length-1];const r=s.getLineCount();return a.lineNumber!==r||a.column!==s.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(s,new D.Position(r,s.getLineMaxColumn(r)),v,n):null}static _doFindPreviousMatchLineByLine(s,a,v,n){const h=s.getLineCount(),r=a.lineNumber,t=s.getLineContent(r).substring(0,a.column-1),l=this._findLastMatchInLine(v,t,r,n);if(l)return l;for(let o=1;o<=h;o++){const d=(h+r-o-1)%h,m=s.getLineContent(d+1),u=this._findLastMatchInLine(v,m,d+1,n);if(u)return u}return null}static _findLastMatchInLine(s,a,v,n){let h=null,r;for(s.reset(0);r=s.next(a);)h=I(new S.Range(v,r.index+1,v,r.index+1+r[0].length),r,n);return h}}e.TextModelSearch=p;function f(b,s,a,v,n){if(v===0)return!0;const h=s.charCodeAt(v-1);if(b.get(h)!==0||h===13||h===10)return!0;if(n>0){const r=s.charCodeAt(v);if(b.get(r)!==0)return!0}return!1}function w(b,s,a,v,n){if(v+n===a)return!0;const h=s.charCodeAt(v+n);if(b.get(h)!==0||h===13||h===10)return!0;if(n>0){const r=s.charCodeAt(v+n-1);if(b.get(r)!==0)return!0}return!1}function _(b,s,a,v,n){return f(b,s,a,v,n)&&w(b,s,a,v,n)}e.isValidMatch=_;class P{constructor(s,a){this._wordSeparators=s,this._searchRegex=a,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const a=s.length;let v;do{if(this._prevMatchStartIndex+this._prevMatchLength===a||(v=this._searchRegex.exec(s),!v))return null;const n=v.index,h=v[0].length;if(n===this._prevMatchStartIndex&&h===this._prevMatchLength){if(h===0){g.getNextCodePoint(s,a,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=n,this._prevMatchLength=h,!this._wordSeparators||_(this._wordSeparators,s,a,n,h))return v}while(v);return null}}e.Searcher=P}),define(fe[109],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)k.indexOf(C)>=0||(E+="\\"+C);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=g();function L(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let C="g";k.ignoreCase&&(C+="i"),k.multiline&&(C+="m"),k.unicode&&(C+="u"),E=new RegExp(k.source,C)}return E.lastIndex=0,E}e.ensureValidWordDefinition=L;const D={maxLen:1e3,windowSize:15,timeBudget:150};function S(k,E,C,i,I=D){if(C.length>I.maxLen){let _=k-I.maxLen/2;return _<0?_=0:i+=_,C=C.substring(_,k+I.maxLen/2),S(k,E,C,i,I)}const c=Date.now(),p=k-1-i;let f=-1,w=null;for(let _=1;!(Date.now()-c>=I.timeBudget);_++){const P=p-I.windowSize*_;E.lastIndex=Math.max(0,P);const b=A(E,C,p,f);if(!b&&w||(w=b,P<=0))break;f=P}if(w){let _={word:w[0],startColumn:i+1+w.index,endColumn:i+1+w.index+w[0].length};return E.lastIndex=0,_}return null}e.getWordAtText=S;function A(k,E,C,i){let I;for(;I=k.exec(E);){const c=I.index||0;if(c<=C&&k.lastIndex>=C)return I;if(i>0&&c>i)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let E=0,C=k.notIn.length;E<C;E++)switch(k.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class D{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of k)S(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),S(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),S(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),S(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&S(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function S(A,k,E){A.has(k)?A.get(k).push(E):A.set(k,[E])}}),define(fe[82],me([0,1,30,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(S,A,k,E){if(Array.isArray(S)){let C=0;for(const i of S){const I=D(i,A,k,E);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof S=="string")return E?S==="*"?5:S===k?10:0:0;if(S){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:c}=S;if(!E&&!c)return 0;let p=0;if(I)if(I===A.scheme)p=10;else if(I==="*")p=5;else return 0;if(C)if(C===k)p=10;else if(C==="*")p=Math.max(p,5);else return 0;if(i){let f;if(typeof i=="string"?f=i:f={...i,base:(0,L.normalize)(i.base)},f===A.fsPath||(0,g.match)(f,A.fsPath))p=10;else return 0}return p}else return 0}}e.score=D}),define(fe[148],me([0,1,107]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(p){p[p.Invalid=0]="Invalid",p[p.Start=1]="Start",p[p.H=2]="H",p[p.HT=3]="HT",p[p.HTT=4]="HTT",p[p.HTTP=5]="HTTP",p[p.F=6]="F",p[p.FI=7]="FI",p[p.FIL=8]="FIL",p[p.BeforeColon=9]="BeforeColon",p[p.AfterColon=10]="AfterColon",p[p.AlmostThere=11]="AlmostThere",p[p.End=12]="End",p[p.Accept=13]="Accept",p[p.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class D{constructor(f,w,_){const P=new Uint8Array(f*w);for(let b=0,s=f*w;b<s;b++)P[b]=_;this._data=P,this.rows=f,this.cols=w}get(f,w){return this._data[f*this.cols+w]}set(f,w,_){this._data[f*this.cols+w]=_}}e.Uint8Matrix=D;class S{constructor(f){let w=0,_=0;for(let b=0,s=f.length;b<s;b++){let[a,v,n]=f[b];v>w&&(w=v),a>_&&(_=a),n>_&&(_=n)}w++,_++;let P=new D(_,w,0);for(let b=0,s=f.length;b<s;b++){let[a,v,n]=f[b];P.set(a,v,n)}this._states=P,this._maxCharCode=w}nextState(f,w){return w<0||w>=this._maxCharCode?0:this._states.get(f,w)}}e.StateMachine=S;let A=null;function k(){return A===null&&(A=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(p){p[p.None=0]="None",p[p.ForceTermination=1]="ForceTermination",p[p.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let C=null;function i(){if(C===null){C=new g.CharacterClassifier(0);const p=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<p.length;w++)C.set(p.charCodeAt(w),1);const f=".,;";for(let w=0;w<f.length;w++)C.set(f.charCodeAt(w),2)}return C}class I{static _createLink(f,w,_,P,b){let s=b-1;do{const a=w.charCodeAt(s);if(f.get(a)!==2)break;s--}while(s>P);if(P>0){const a=w.charCodeAt(P-1),v=w.charCodeAt(s);(a===40&&v===41||a===91&&v===93||a===123&&v===125)&&s--}return{range:{startLineNumber:_,startColumn:P+1,endLineNumber:_,endColumn:s+2},url:w.substring(P,s+1)}}static computeLinks(f,w=k()){const _=i();let P=[];for(let b=1,s=f.getLineCount();b<=s;b++){const a=f.getLineContent(b),v=a.length;let n=0,h=0,r=0,t=1,l=!1,o=!1,d=!1,m=!1;for(;n<v;){let u=!1;const y=a.charCodeAt(n);if(t===13){let T;switch(y){case 40:l=!0,T=0;break;case 41:T=l?0:1;break;case 91:d=!0,o=!0,T=0;break;case 93:d=!1,T=o?0:1;break;case 123:m=!0,T=0;break;case 125:T=m?0:1;break;case 39:T=r===34||r===96?0:1;break;case 34:T=r===39||r===96?0:1;break;case 96:T=r===39||r===34?0:1;break;case 42:T=r===42?1:0;break;case 124:T=r===124?1:0;break;case 32:T=d?0:1;break;default:T=_.get(y)}T===1&&(P.push(I._createLink(_,a,b,h,n)),u=!0)}else if(t===12){let T;y===91?(o=!0,T=0):T=_.get(y),T===1?u=!0:t=13}else t=w.nextState(t,y),t===0&&(u=!0);u&&(t=1,l=!1,o=!1,m=!1,h=n+1,r=y),n++}t===13&&P.push(I._createLink(_,a,b,h,v))}return P}}e.LinkComputer=I;function c(p){return!p||typeof p.getLineCount!="function"||typeof p.getLineContent!="function"?[]:I.computeLinks(p)}e.computeLinks=c}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,k){return this._map.set(A,k),this.fire([A]),(0,L.toDisposable)(()=>{this._map.get(A)===k&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,k){let E=null,C=!1;return this._promises.set(A,k.then(i=>{this._promises.delete(A),!(C||!i)&&(E=this.register(A,i))})),(0,L.toDisposable)(()=>{C=!0,E&&E.dispose()})}getPromise(A){const k=this.get(A);if(k)return Promise.resolve(k);const E=this._promises.get(A);return E?E.then(C=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(fe[110],me([0,1,22,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function S(I){for(let c=0,p=I.length;c<p;c+=4){const f=I[c+0],w=I[c+1],_=I[c+2],P=I[c+3];I[c+0]=P,I[c+1]=_,I[c+2]=w,I[c+3]=f}}function A(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||S(c),g.VSBuffer.wrap(c)}function k(I){const c=I.buffer;if(L.isLittleEndian()||S(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function E(I){const c=new Uint32Array(C(I));let p=0;if(c[p++]=I.id,I.type==="full")c[p++]=1,c[p++]=I.data.length,c.set(I.data,p),p+=I.data.length;else{c[p++]=2,c[p++]=I.deltas.length;for(const f of I.deltas)c[p++]=f.start,c[p++]=f.deleteCount,f.data?(c[p++]=f.data.length,c.set(f.data,p),p+=f.data.length):c[p++]=0}return A(c)}e.encodeSemanticTokensDto=E;function C(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const p of I.deltas)p.data&&(c+=p.data.length)}return c}function i(I){const c=k(I);let p=0;const f=c[p++];if(c[p++]===1){const b=c[p++],s=c.subarray(p,p+b);return p+=b,{id:f,type:"full",data:s}}const _=c[p++];let P=[];for(let b=0;b<_;b++){const s=c[p++],a=c[p++],v=c[p++];let n;v>0&&(n=c.subarray(p,p+v),p+=v),P[b]={start:s,deleteCount:a,data:n}}return{id:f,type:"delta",deltas:P}}e.decodeSemanticTokensDto=i}),define(fe[111],me([0,1,15,98]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class D{constructor(E){this.values=E,this.prefixSum=new Uint32Array(E.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(E,C){E=(0,L.toUint32)(E);const i=this.values,I=this.prefixSum,c=C.length;return c===0?!1:(this.values=new Uint32Array(i.length+c),this.values.set(i.subarray(0,E),0),this.values.set(i.subarray(E),E+c),this.values.set(C,E),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(E,C){return E=(0,L.toUint32)(E),C=(0,L.toUint32)(C),this.values[E]===C?!1:(this.values[E]=C,E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),!0)}removeValues(E,C){E=(0,L.toUint32)(E),C=(0,L.toUint32)(C);const i=this.values,I=this.prefixSum;if(E>=i.length)return!1;let c=i.length-E;return C>=c&&(C=c),C===0?!1:(this.values=new Uint32Array(i.length-C),this.values.set(i.subarray(0,E),0),this.values.set(i.subarray(E+C),E),this.prefixSum=new Uint32Array(this.values.length),E-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=E-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(E){return E<0?0:(E=(0,L.toUint32)(E),this._getPrefixSum(E))}_getPrefixSum(E){if(E<=this.prefixSumValidIndex[0])return this.prefixSum[E];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),E>=this.values.length&&(E=this.values.length-1);for(let i=C;i<=E;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],E),this.prefixSum[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let C=0,i=this.values.length-1,I=0,c=0,p=0;for(;C<=i;)if(I=C+(i-C)/2|0,c=this.prefixSum[I],p=c-this.values[I],E<p)i=I-1;else if(E>=c)C=I+1;else break;return new A(I,E-p)}}e.PrefixSumComputer=D;class S{constructor(E){this._values=E,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(E){return this._ensureValid(),E===0?0:this._prefixSum[E-1]}getIndexOf(E){this._ensureValid();const C=this._indexBySum[E],i=C>0?this._prefixSum[C-1]:0;return new A(C,E-i)}removeValues(E,C){this._values.splice(E,C),this._invalidate(E)}insertValues(E,C){this._values=(0,g.arrayInsert)(this._values,E,C),this._invalidate(E)}_invalidate(E){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,E-1)}_ensureValid(){if(!this._isValid){for(let E=this._validEndIndex+1,C=this._values.length;E<C;E++){const i=this._values[E],I=E>0?this._prefixSum[E-1]:0;this._prefixSum[E]=I+i;for(let c=0;c<i;c++)this._indexBySum[I+c]=E}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(E,C){this._values[E]!==C&&(this._values[E]=C,this._invalidate(E))}}e.ConstantTimePrefixSumComputer=S;class A{constructor(E,C){this.index=E,this.remainder=C,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=C}}e.PrefixSumIndexOfResult=A}),define(fe[150],me([0,1,8,50,111]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(k,E,C,i){this._uri=k,this._lines=E,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const E=k.changes;for(const C of E)this._acceptDeleteRange(C.range),this._acceptInsertText(new L.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,E=this._lines.length,C=new Uint32Array(E);for(let i=0;i<E;i++)C[i]=this._lines[i].length+k;this._lineStarts=new D.PrefixSumComputer(C)}}_setLineText(k,E){this._lines[k]=E,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,E){if(E.length===0)return;let C=(0,g.splitLines)(E);if(C.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}C[C.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(k.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,i)}}e.MirrorTextModel=S}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,S=D*24,A=S*7,k=S*30,E=S*365;function C(I,c){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,g.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,g.localize)(1,null);let f;return p<L?(f=p,c?f===1?(0,g.localize)(2,null,f):(0,g.localize)(3,null,f):f===1?(0,g.localize)(4,null,f):(0,g.localize)(5,null,f)):p<D?(f=Math.floor(p/L),c?f===1?(0,g.localize)(6,null,f):(0,g.localize)(7,null,f):f===1?(0,g.localize)(8,null,f):(0,g.localize)(9,null,f)):p<S?(f=Math.floor(p/D),c?f===1?(0,g.localize)(10,null,f):(0,g.localize)(11,null,f):f===1?(0,g.localize)(12,null,f):(0,g.localize)(13,null,f)):p<A?(f=Math.floor(p/S),c?f===1?(0,g.localize)(14,null,f):(0,g.localize)(15,null,f):f===1?(0,g.localize)(16,null,f):(0,g.localize)(17,null,f)):p<k?(f=Math.floor(p/A),c?f===1?(0,g.localize)(18,null,f):(0,g.localize)(19,null,f):f===1?(0,g.localize)(20,null,f):(0,g.localize)(21,null,f)):p<E?(f=Math.floor(p/k),c?f===1?(0,g.localize)(22,null,f):(0,g.localize)(23,null,f):f===1?(0,g.localize)(24,null,f):(0,g.localize)(25,null,f)):(f=Math.floor(p/E),c?f===1?(0,g.localize)(26,null,f):(0,g.localize)(27,null,f):f===1?(0,g.localize)(28,null,f):(0,g.localize)(29,null,f))}e.fromNow=C;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[51],me([0,1,15,13,153]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(C,i){return i&&(C.stack||C.stacktrace)?D.localize(0,null,k(C),A(C.stack)||A(C.stacktrace)):k(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function k(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function E(C=null,i=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const I=g.coalesce(C),c=E(I[0],i);return I.length>1?D.localize(4,null,c,I.length):c}if(L.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return S(I.error,i);if(I.exception)return S(I.exception,i)}return C.stack?S(C,i):C.message?C.message:D.localize(5,null)}e.toErrorMessage=E}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[112],me([0,1,38,29,10,25,9,12,37,94,13,143,28,154]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function f(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(n,h){if(k.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};h&&(r.cwd=h);const t=g.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],r);return new Promise(l=>{t.once("error",o=>{l({success:!1,error:o})}),t.once("exit",(o,d)=>{l(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?f(r.status):1})}else if(k.isLinux||k.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(r,[n.pid.toString()],{encoding:"utf8",shell:!0},(l,o,d)=>{t(l?{success:!1,error:l}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function _(n){!n||(delete n.DEBUG,k.isMacintosh&&delete n.DYLD_LIBRARY_PATH,k.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=_;function P(n=E.env){return n.comspec||"cmd.exe"}e.getWindowsShell=P;class b{constructor(h,r,t,l){if(r!==void 0&&t!==void 0&&l!==void 0)this.cmd=h,this.args=r,this.shell=t,this.options=l;else{const o=h;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(E.env).forEach(d=>{o[d]=E.env[d]}),Object.keys(this.options.env).forEach(d=>{o[d]=this.options.env[d]}),this.options.env=o}}getSanitizedCommand(){let h=this.cmd.toLowerCase();const r=h.lastIndexOf(A.sep);return r!==-1&&(h=h.substring(r+1)),b.WellKnowCommands[h]?h:"other"}start(h){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(E.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(r=>{let t,l;const o=new Promise((d,m)=>{t=d,l=m});if(r){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=g.exec(d,this.options,(m,u,y)=>{this.childProcess=null;const T=m;T&&T.killed?l({killed:this.terminateRequested,stdout:u.toString(),stderr:y.toString()}):this.handleExec(t,h,m,u,y)})}else{let d=null;const m=u=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(u,t,h,l);const y={terminated:this.terminateRequested};i.isNumber(u)&&(y.cmdCode=u),t(y)};if(this.shell&&k.isWindows){const u=S.deepClone(this.options);u.windowsVerbatimArguments=!0,u.detached=!1;let y=!1,T=!1;const R=[];let $=this.ensureQuotes(this.cmd);R.push($.value),y=$.quoted,this.args&&this.args.forEach(F=>{$=this.ensureQuotes(F),R.push($.value),T=T&&$.quoted});const B=["/s","/c"];y?T?B.push('"'+R.join(" ")+'"'):R.length>1?B.push('"'+R[0]+'" '+R.slice(1).join(" ")):B.push('"'+R[0]+'"'):B.push(R.join(" ")),d=g.spawn(P(),B,u)}else this.cmd&&(d=g.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(i.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",u=>{this.childProcess=null,l({terminated:this.terminateRequested,error:u})}),d.pid&&(this.childProcess.on("close",m),this.handleSpawn(d,t,h,l,!0)))}return o})}handleClose(h,r,t,l){}ensureQuotes(h){return b.regexp.test(h)?{value:'"'+h+'"',quoted:!0}:{value:h,quoted:h.length>0&&h[0]==='"'&&h[h.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(h=>h.pid,h=>-1):new Promise(h=>{this.pidResolve=h})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(h=>(this.terminateRequested=!0,w(h,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),h=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(h=>{if(!this.shell||!k.isWindows)return h(!1);const r=g.spawn(P(),["/s","/c"]);r.on("error",t=>h(!0)),r.on("exit",t=>h(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class s extends b{constructor(h,r,t,l){super(h,r,t,l);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(h,r,t,l,o){[l,o].forEach((d,m)=>{const u=new I.LineDecoder;u.write(d).forEach(R=>{r({line:R,source:m===0?0:1})});const T=u.end();T&&r({line:T,source:m===0?0:1})}),h({terminated:this.terminateRequested,error:t})}handleSpawn(h,r,t,l,o){const d=new I.LineDecoder,m=new I.LineDecoder;h.stdout.on("data",u=>{d.write(u).forEach(T=>t({line:T,source:0}))}),h.stderr.on("data",u=>{m.write(u).forEach(T=>t({line:T,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=m}handleClose(h,r,t,l){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&t({line:d,source:1})}}e.LineProcess=s;function a(n){let h=[],r=!1;const t=function(l){if(r){h.push(l);return}(!n.send(l,d=>{if(d&&console.error(d),r=!1,h.length>0){const m=h.slice(0);h=[],m.forEach(u=>t(u))}})||k.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=a;var v;(function(n){async function h(r,t,l){if(A.isAbsolute(r))return r;if(t===void 0&&(t=E.cwd()),A.dirname(r)!=="."||(l===void 0&&i.isString(E.env.PATH)&&(l=E.env.PATH.split(A.delimiter)),l===void 0||l.length===0))return A.join(t,r);async function d(m){if(await c.Promises.exists(m)){let u;try{u=await c.Promises.stat(m)}catch(y){y.message.startsWith("EACCES")&&(u=await c.Promises.lstat(m))}return u?!u.isDirectory():!1}return!1}for(let m of l){let u;if(A.isAbsolute(m)?u=A.join(m,r):u=A.join(t,m,r),await d(u))return u;let y=u+".com";if(await d(y)||(y=u+".exe",await d(y)))return y}return A.join(t,r)}n.findExecutable=h})(v=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[113],me([0,1,155,12,109]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=A;class k{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,Ee){this._values[ne]=Ee}}e.ValidatedEditorOptions=k;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class C{constructor(ne,Ee,Qe,et){this.id=ne,this.name=Ee,this.defaultValue=Qe,this.schema=et}compute(ne,Ee,Qe){return Qe}}class i{constructor(ne,Ee=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=Ee}validate(ne){return this.defaultValue}}class I{constructor(ne,Ee,Qe,et){this.id=ne,this.name=Ee,this.defaultValue=Qe,this.schema=et}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,Ee,Qe){return Qe}}function c(J,ne){return typeof J=="undefined"?ne:J==="false"?!1:Boolean(J)}e.boolean=c;class p extends I{constructor(ne,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ne,Ee,Qe,et)}validate(ne){return c(ne,this.defaultValue)}}function f(J,ne,Ee,Qe){if(typeof J=="undefined")return ne;let et=parseInt(J,10);return isNaN(et)?ne:(et=Math.max(Ee,et),et=Math.min(Qe,et),et|0)}e.clampedInt=f;class w extends I{constructor(ne,Ee,Qe,et,le,ke=void 0){typeof ke!="undefined"&&(ke.type="integer",ke.default=Qe,ke.minimum=et,ke.maximum=le),super(ne,Ee,Qe,ke),this.minimum=et,this.maximum=le}static clampedInt(ne,Ee,Qe,et){return f(ne,Ee,Qe,et)}validate(ne){return w.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class _ extends I{constructor(ne,Ee,Qe,et,le){typeof le!="undefined"&&(le.type="number",le.default=Qe),super(ne,Ee,Qe,le),this.validationFn=et}static clamp(ne,Ee,Qe){return ne<Ee?Ee:ne>Qe?Qe:ne}static float(ne,Ee){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return Ee;const Qe=parseFloat(ne);return isNaN(Qe)?Ee:Qe}validate(ne){return this.validationFn(_.float(ne,this.defaultValue))}}class P extends I{static string(ne,Ee){return typeof ne!="string"?Ee:ne}constructor(ne,Ee,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ne,Ee,Qe,et)}validate(ne){return P.string(ne,this.defaultValue)}}function b(J,ne,Ee){return typeof J!="string"||Ee.indexOf(J)===-1?ne:J}e.stringSet=b;class s extends I{constructor(ne,Ee,Qe,et,le=void 0){typeof le!="undefined"&&(le.type="string",le.enum=et,le.default=Qe),super(ne,Ee,Qe,le),this._allowedValues=et}validate(ne){return b(ne,this.defaultValue,this._allowedValues)}}class a extends C{constructor(ne,Ee,Qe,et,le,ke,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=le,Ne.default=et),super(ne,Ee,Qe,Ne),this._allowedValues=le,this._convert=ke}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function v(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,Ee,Qe){return Qe===0?ne.accessibilitySupport:Qe}}class h extends C{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertSpace:c(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(l=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(J){switch(J){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function d(J){switch(J){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class m extends i{constructor(){super(126,[65,33])}compute(ne,Ee,Qe){const et=["monaco-editor"];return Ee.get(33)&&et.push(Ee.get(33)),ne.extraEditorClassName&&et.push(ne.extraEditorClassName),Ee.get(65)==="default"?et.push("mouse-default"):Ee.get(65)==="copy"&&et.push("mouse-copy"),Ee.get(99)&&et.push("showUnused"),Ee.get(124)&&et.push("showDeprecated"),et.join(" ")}}class u extends p{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ne,Ee,Qe){return Qe&&ne.emptySelectionClipboard}}class y extends C{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ne.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:g.localize(18,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{cursorMoveOnType:c(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ne.seedSearchStringFromSelection=="boolean"?ne.seedSearchStringFromSelection?"always":"never":b(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":b(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(Ee.loop,this.defaultValue.loop)}}}class T extends C{constructor(){super(44,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?T.OFF:ne==="true"?T.ON:ne:Boolean(ne)?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class R extends i{constructor(){super(43)}compute(ne,Ee,Qe){return ne.fontInfo}}class $ extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ne){let Ee=_.float(ne,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:_.clamp(Ee,6,100)}compute(ne,Ee,Qe){return ne.fontInfo.fontSize}}class B extends C{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.MINIMUM_VALUE,maximum:B.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(w.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,B.MINIMUM_VALUE,B.MAXIMUM_VALUE))}}B.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],B.MINIMUM_VALUE=1,B.MAXIMUM_VALUE=1e3;class F extends C{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),...Ee},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{multiple:b(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??b(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??b(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??b(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??b(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??b(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:P.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:P.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:P.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:P.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:P.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class W extends C{constructor(){const ne={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ne.above,description:g.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:c(Ee.enabled,this.defaultValue.enabled),delay:w.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:c(Ee.sticky,this.defaultValue.sticky),above:c(Ee.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class z extends i{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ne,Ee,Qe){return z.computeLayout(Ee,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const Ee=ne.height/ne.lineHeight,Qe=ne.scrollBeyondLastLine?Ee-1:0,et=(ne.viewLineCount+Qe)/(ne.pixelRatio*ne.height),le=Math.floor(ne.viewLineCount/et);return{typicalViewportLineCount:Ee,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:le}}static _computeMinimapLayout(ne,Ee){const Qe=ne.outerWidth,et=ne.outerHeight,le=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(le*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const ke=Ee.stableMinimapLayoutInput,Ne=ke&&ne.outerHeight===ke.outerHeight&&ne.lineHeight===ke.lineHeight&&ne.typicalHalfwidthCharacterWidth===ke.typicalHalfwidthCharacterWidth&&ne.pixelRatio===ke.pixelRatio&&ne.scrollBeyondLastLine===ke.scrollBeyondLastLine&&ne.minimap.enabled===ke.minimap.enabled&&ne.minimap.side===ke.minimap.side&&ne.minimap.size===ke.minimap.size&&ne.minimap.showSlider===ke.minimap.showSlider&&ne.minimap.renderCharacters===ke.minimap.renderCharacters&&ne.minimap.maxColumn===ke.minimap.maxColumn&&ne.minimap.scale===ke.minimap.scale&&ne.verticalScrollbarWidth===ke.verticalScrollbarWidth&&ne.isViewportWrapping===ke.isViewportWrapping,Xe=ne.lineHeight,nt=ne.typicalHalfwidthCharacterWidth,ft=ne.scrollBeyondLastLine,tt=ne.minimap.renderCharacters;let ut=le>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Re=ne.minimap.maxColumn,De=ne.minimap.size,Te=ne.minimap.side,se=ne.verticalScrollbarWidth,ue=ne.viewLineCount,we=ne.remainingWidth,ve=ne.isViewportWrapping,Fe=tt?2:3;let qe=Math.floor(le*et);const ze=qe/le;let Ye=!1,lt=!1,xe=Fe*ut,ge=ut/le,be=1;if(De==="fill"||De==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:yt,desiredRatio:Et,minimapLineCount:gt}=z.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:le});if(ue/gt>1)Ye=!0,lt=!0,ut=1,xe=1,ge=ut/le;else{let vt=!1,Tt=ut+1;if(De==="fit"){const Dt=Math.ceil((ue+yt)*xe);ve&&Ne&&we<=Ee.stableFitRemainingWidth?(vt=!0,Tt=Ee.stableFitMaxMinimapScale):vt=Dt>qe}if(De==="fill"||vt){Ye=!0;const Dt=ut;xe=Math.min(Xe*le,Math.max(1,Math.floor(1/Et))),ve&&Ne&&we<=Ee.stableFitRemainingWidth&&(Tt=Ee.stableFitMaxMinimapScale),ut=Math.min(Tt,Math.max(1,Math.floor(xe/Fe))),ut>Dt&&(be=Math.min(2,ut/Dt)),ge=ut/le/be,qe=Math.ceil(Math.max(mt,ue+yt)*xe),ve?(Ee.stableMinimapLayoutInput=ne,Ee.stableFitRemainingWidth=we,Ee.stableFitMaxMinimapScale=ut):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ae=Math.floor(Re*ge),K=Math.min(ae,Math.max(0,Math.floor((we-se-2)*ge/(nt+ge)))+e.MINIMAP_GUTTER_WIDTH);let Se=Math.floor(le*K);const Le=Se/le;Se=Math.floor(Se*be);const it=tt?1:2,Ge=Te==="left"?0:Qe-K-se;return{renderMinimap:it,minimapLeft:Ge,minimapWidth:K,minimapHeightIsEditorHeight:Ye,minimapIsSampling:lt,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Se,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ne,Ee){const Qe=Ee.outerWidth|0,et=Ee.outerHeight|0,le=Ee.lineHeight|0,ke=Ee.lineNumbersDigitCount|0,Ne=Ee.typicalHalfwidthCharacterWidth,Xe=Ee.maxDigitWidth,nt=Ee.pixelRatio,ft=Ee.viewLineCount,tt=ne.get(121),ut=tt==="inherit"?ne.get(120):tt,Re=ut==="inherit"?ne.get(116):ut,De=ne.get(119),Te=ne.get(2),se=Ee.isDominatedByLongLines,ue=ne.get(49),we=ne.get(59).renderType!==0,ve=ne.get(60),Fe=ne.get(93),qe=ne.get(64),ze=ne.get(91),Ye=ze.verticalScrollbarSize,lt=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,be=ne.get(57),ae=ne.get(37);let K;if(typeof be=="string"&&/^\d+(\.\d+)?ch$/.test(be)){const kt=parseFloat(be.substr(0,be.length-2));K=w.clampedInt(kt*Ne,0,0,1e3)}else K=w.clampedInt(be,0,0,1e3);ae&&(K+=16);let Se=0;if(we){const kt=Math.max(ke,ve);Se=Math.round(kt*Xe)}let Le=0;ue&&(Le=le);let it=0,Ge=it+Le,mt=Ge+Se,yt=mt+K;const Et=Qe-Le-Se-K;let gt=!1,bt=!1,vt=-1;Te!==2&&(ut==="inherit"&&se?(gt=!0,bt=!0):Re==="on"||Re==="bounded"?bt=!0:Re==="wordWrapColumn"&&(vt=De));const Tt=z._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:le,typicalHalfwidthCharacterWidth:Ne,pixelRatio:nt,scrollBeyondLastLine:Fe,minimap:qe,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:Et,isViewportWrapping:bt},Ee.memory||new E);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(it+=Tt.minimapWidth,Ge+=Tt.minimapWidth,mt+=Tt.minimapWidth,yt+=Tt.minimapWidth);const Dt=Et-Tt.minimapWidth,$t=Math.max(1,Math.floor((Dt-Ye-2)/Ne)),jt=lt?xe:0;return bt&&(vt=Math.max(1,$t),Re==="bounded"&&(vt=Math.min(vt,De))),{width:Qe,height:et,glyphMarginLeft:it,glyphMarginWidth:Le,lineNumbersLeft:Ge,lineNumbersWidth:Se,decorationsLeft:mt,decorationsWidth:K,contentLeft:yt,contentWidth:Dt,minimap:Tt,viewportColumn:$t,isWordWrapMinified:gt,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:jt,width:Ye,height:et-2*jt,right:0}}}}e.EditorLayoutInfoComputer=z;class N extends C{constructor(){const ne={enabled:!0};super(56,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:g.localize(43,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:c(ne.enabled,this.defaultValue.enabled)}}}class U extends C{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:c(Ee.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:P.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class x extends _{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>_.clamp(ne,0,150),{markdownDescription:g.localize(47,null)})}compute(ne,Ee,Qe){return ne.fontInfo.lineHeight}}class O extends C{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ne.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:g.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:c(Ee.enabled,this.defaultValue.enabled),size:b(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(Ee.side,this.defaultValue.side,["right","left"]),showSlider:b(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(Ee.scale,1,1,3),maxColumn:w.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function j(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class H extends C{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{top:w.clampedInt(Ee.top,0,0,1e3),bottom:w.clampedInt(Ee.bottom,0,0,1e3)}}}class X extends C{constructor(){const ne={enabled:!0,cycle:!1};super(75,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:g.localize(61,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:c(Ee.enabled,this.defaultValue.enabled),cycle:c(Ee.cycle,this.defaultValue.cycle)}}}class Q extends i{constructor(){super(127)}compute(ne,Ee,Qe){return ne.pixelRatio}}class de extends C{constructor(){const ne={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ne.comments,description:g.localize(63,null)},other:{type:"boolean",default:ne.other,description:g.localize(64,null)}}}],default:ne,description:g.localize(65,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const Ee=ne,Qe={other:c(Ee.other,this.defaultValue.other),comments:c(Ee.comments,this.defaultValue.comments),strings:c(Ee.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var _e;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(_e=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends C{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ne){let Ee=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(Ee=4,Qe=ne):ne==="interval"?Ee=3:ne==="relative"?Ee=2:ne==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Qe}}}function Pe(J){const ne=J.get(86);return ne==="editable"?J.get(80):ne!=="on"}e.filterValidationDecorations=Pe;class We extends C{constructor(){const ne=[],Ee={type:"number",description:g.localize(71,null)};super(90,"rulers",ne,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ne,description:g.localize(73,null)})}validate(ne){if(Array.isArray(ne)){let Ee=[];for(let Qe of ne)if(typeof Qe=="number")Ee.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;Ee.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return Ee.sort((Qe,et)=>Qe.column-et.column),Ee}return this.defaultValue}}function Be(J,ne){if(typeof J!="string")return ne;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends C{constructor(){const ne={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ne,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ne.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ne.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ne.scrollByPage,description:g.localize(84,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne,Qe=w.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Be(Ee.vertical,this.defaultValue.vertical),horizontal:Be(Ee.horizontal,this.defaultValue.horizontal),useShadows:c(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(Ee.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(Ee.verticalSliderSize,et,0,1e3),scrollByPage:c(Ee.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends C{constructor(){const ne={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:g.localize(85,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{enabled:c(Ee.enabled,this.defaultValue.enabled),mode:b(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends C{constructor(){const ne={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ne,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ne.enabled,description:g.localize(86,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:c(ne.enabled,this.defaultValue.enabled)}}}class ie extends C{constructor(){const ne={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ne,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ne.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ne.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ne.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ne.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ne.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{bracketPairs:ce(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ce(J,ne,Ee){const Qe=Ee.indexOf(J);return Qe===-1?ne:Ee[Qe]}class Z extends C{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ne.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const Ee=ne;return{insertMode:b(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:c(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:c(Ee.preview,this.defaultValue.preview),previewMode:b(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(Ee.showMethods,this.defaultValue.showMethods),showFunctions:c(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:c(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(Ee.showDeprecated,this.defaultValue.showDeprecated),showFields:c(Ee.showFields,this.defaultValue.showFields),showVariables:c(Ee.showVariables,this.defaultValue.showVariables),showClasses:c(Ee.showClasses,this.defaultValue.showClasses),showStructs:c(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:c(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:c(Ee.showModules,this.defaultValue.showModules),showProperties:c(Ee.showProperties,this.defaultValue.showProperties),showEvents:c(Ee.showEvents,this.defaultValue.showEvents),showOperators:c(Ee.showOperators,this.defaultValue.showOperators),showUnits:c(Ee.showUnits,this.defaultValue.showUnits),showValues:c(Ee.showValues,this.defaultValue.showValues),showConstants:c(Ee.showConstants,this.defaultValue.showConstants),showEnums:c(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:c(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(Ee.showKeywords,this.defaultValue.showKeywords),showWords:c(Ee.showWords,this.defaultValue.showWords),showColors:c(Ee.showColors,this.defaultValue.showColors),showFiles:c(Ee.showFiles,this.defaultValue.showFiles),showReferences:c(Ee.showReferences,this.defaultValue.showReferences),showFolders:c(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:c(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:c(Ee.showUsers,this.defaultValue.showUsers),showIssues:c(Ee.showIssues,this.defaultValue.showIssues)}}}class re extends C{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends i{constructor(){super(128,[80])}compute(ne,Ee,Qe){return Ee.get(80)?!0:ne.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends i{constructor(){super(130,[129])}compute(ne,Ee,Qe){const et=Ee.get(129);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?ct:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new p(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new n),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new P(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new a(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new p(10,"automaticLayout",!1)),autoSurround:ye(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new ie),stickyTabStops:ye(new p(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new p(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new P(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new p(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new p(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new h),contextmenu:ye(new p(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new p(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new a(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new p(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new a(24,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],d,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new p(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new p(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new p(30,"domReadOnly",!1)),dragAndDrop:ye(new p(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new u),extraEditorClassName:ye(new P(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new _(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new y),fixedOverflowWidgets:ye(new p(36,"fixedOverflowWidgets",!1)),folding:ye(new p(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new s(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new p(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new p(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new p(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new P(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new T),fontSize:ye(new $),fontWeight:ye(new B),formatOnPaste:ye(new p(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new p(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new p(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new p(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new W),inDiffEditor:ye(new p(53,"inDiffEditor",!1)),letterSpacing:ye(new _(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>_.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new N),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new x),lineNumbers:ye(new Ie),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new p(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new p(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new s(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new _(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new p(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new p(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new a(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],j,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new p(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new p(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new H),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new p(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new p(80,"readOnly",!1)),renameOnType:ye(new p(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new p(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new p(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new s(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new p(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new s(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new p(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new We),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new p(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new p(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new p(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new p(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new p(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new p(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new p(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new U),snippetSuggestions:ye(new s(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new re),smoothScrolling:ye(new p(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new p(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new s(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new s(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new s(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new p(113,"useShadowDOM",!0)),useTabStops:ye(new p(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new P(115,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new s(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new P(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new P(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new s(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new a(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new s(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new m),pixelRatio:ye(new Q),tabFocusMode:ye(new pe),layoutInfo:ye(new z),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var D;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function S(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=S;function A(c){if(!S(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=c.match(L);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=A;function k(c){if(!c)return null;let p=c.majorBase,f=c.majorMustEqual,w=c.minorBase,_=c.minorMustEqual,P=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(p===0||(_=!1),b=!1);let s=0;if(c.preRelease){const a=D.exec(c.preRelease);if(a){const[,v,n,h]=a;s=Date.UTC(Number(v),Number(n)-1,Number(h))}}return{majorBase:p,majorMustEqual:f,minorBase:w,minorMustEqual:_,patchBase:P,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:s}}e.normalizeVersion=k;function E(c,p,f){let w;typeof c=="string"?w=k(A(c)):w=c;let _;p instanceof Date?_=p.getTime():typeof p=="string"&&(_=new Date(p).getTime());let P;if(typeof f=="string"?P=k(A(f)):P=f,!w||!P)return!1;let b=w.majorBase,s=w.minorBase,a=w.patchBase,v=P.majorBase,n=P.minorBase,h=P.patchBase,r=P.notBefore,t=P.majorMustEqual,l=P.minorMustEqual,o=P.patchMustEqual;return P.isMinimum?b>v?!0:b<v?!1:s>n?!0:s<n||_&&_<r?!1:a>=h:(b===1&&v===0&&(!t||!l||!o)&&(v=1,n=0,h=0,t=!0,l=!1,o=!1),b<v?!1:b>v?!t:s<n?!1:s>n?!l:a<h?!1:a>h?!o:!(_&&_<r))}e.isValidVersion=E;function C(c,p,f,w){return f.isBuiltin||typeof f.main=="undefined"?!0:I(c,p,f.engines.vscode,w)}e.isValidExtensionVersion=C;function i(c,p,f){return c==="*"||I(p,f,c)}e.isEngineValid=i;function I(c,p,f,w=[]){let _=k(A(f));if(!_)return w.push(g.localize(0,null,f)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return w.push(g.localize(1,null,f)),!1}else if(!_.majorMustEqual)return w.push(g.localize(2,null,f)),!1;return E(c,p,_)?!0:(w.push(g.localize(3,null,c,f)),!1)}}),define(fe[114],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(D,S=[],A=!1){this.ctor=D,this.staticArguments=S,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=g}),define(fe[83],me([0,1,114]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function D(A,k,E){k instanceof g.SyncDescriptor||(k=new g.SyncDescriptor(k,[],E)),L.push([A,k])}e.registerSingleton=D;function S(){return L}e.getSingletonServiceDescriptors=S}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=g;class L{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let A of this._nodes.values())A.outgoing.size===0&&S.push(A);return S}insertEdge(S,A){const k=this.lookupOrInsertNode(S),E=this.lookupOrInsertNode(A);k.outgoing.set(this._hashFn(A),E),E.incoming.set(this._hashFn(S),k)}removeNode(S){const A=this._hashFn(S);this._nodes.delete(A);for(let k of this._nodes.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(S){const A=this._hashFn(S);let k=this._nodes.get(A);return k||(k=new g(S),this._nodes.set(A,k)),k}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[A,k]of this._nodes)S.push(`${A}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,A]of this._nodes){const k=new Set([S]),E=this._findCycle(A,k);if(E)return E}}_findCycle(S,A){for(let[k,E]of S.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const C=this._findCycle(E,A);if(C)return C;A.delete(k)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function k(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=k})(g=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(A,k,E,C){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:A,index:E,optional:C}):(k[g.DI_DEPENDENCIES]=[{id:A,index:E,optional:C}],k[g.DI_TARGET]=k)}function D(A){if(g.serviceIds.has(A))return g.serviceIds.get(A);const k=function(E,C,i){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,E,i,!1)};return k.toString=()=>A,g.serviceIds.set(A,k),k}e.createDecorator=D;function S(A){return A}e.refineServiceDecorator=S}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,48,6,24,78,82,183]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(C):!!w.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(_,P){let b={selector:_,provider:P,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(b){let s=this._entries.indexOf(b);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(_){return this.all(_).length>0}all(_){if(!_)return[];this._updateScores(_);const P=[];for(let b of this._entries)b._score>0&&P.push(b.provider);return P}ordered(_){const P=[];return this._orderedForEach(_,b=>P.push(b.provider)),P}orderedGroups(_){const P=[];let b,s;return this._orderedForEach(_,a=>{b&&s===a._score?b.push(a.provider):(s=a._score,b=[a.provider],P.push(b))}),P}_orderedForEach(_,P){if(!!_){this._updateScores(_);for(const b of this._entries)b._score>0&&P(b)}}_updateScores(_){let P={uri:_.uri.toString(),language:_.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===P.language&&this._lastCandidate.uri===P.uri)){this._lastCandidate=P;for(let b of this._entries)if(b._score=(0,k.score)(b.selector,_.uri,_.getLanguageId(),(0,E.shouldSynchronizeModel)(_)),C(b.selector)&&b._score>0){for(let s of this._entries)s._score=0;b._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(_,P){return _._score<P._score?1:_._score>P._score?-1:_._time<P._time?1:_._time>P._time?-1:0}}e.LanguageFeatureRegistry=i;const I=new WeakMap;let c=0;function p(w){let _=I.get(w);return _===void 0&&(_=++c,I.set(w,_)),_}class f{constructor(_,P,b=Number.MAX_SAFE_INTEGER){this._registry=_,this.min=P,this.max=b,this._cache=new S.LRUCache(50,.7)}_key(_){return _.id+this._registry.all(_).reduce((P,b)=>(0,L.doHash)(p(b),P),0)}_clamp(_){return _===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(_*1.3)))}get(_){const P=this._key(_),b=this._cache.get(P);return this._clamp(b?.value)}update(_,P){const b=this._key(_);let s=this._cache.get(b);return s||(s=new A.MovingAverage,this._cache.set(b,s)),s.update(P),this.get(_)}}e.LanguageFeatureRequestDelays=f}),define(fe[84],me([0,1,2,41,184,149,47]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var E;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(E=e.FontStyle||(e.FontStyle={}));var C;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(C=e.ColorId||(e.ColorId={}));var i;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(i=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let T=this.getForeground(y),R="mtk"+T,$=this.getFontStyle(y);return $&1&&(R+=" mtki"),$&2&&(R+=" mtkb"),$&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(y,T){const R=this.getForeground(y),$=this.getFontStyle(y);let B=`color: ${T[R]};`;return $&1&&(B+="font-style: italic;"),$&2&&(B+="font-weight: bold;"),$&4&&(B+="text-decoration: underline;"),B}}e.TokenMetadata=c;var p;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(p=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(y){const T=u[y];let R=T&&A.iconRegistry.get(T);return R||(console.info("No codicon found for CompletionItemKind "+y),R=A.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(y,T){let R=u[y];return typeof R=="undefined"&&!T&&(R=9),R}}();var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var _;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var P;(function(u){u[u.Automatic=0]="Automatic",u[u.Explicit=1]="Explicit"})(P=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(u){return u&&g.URI.isUri(u.uri)&&L.Range.isIRange(u.range)&&(L.Range.isIRange(u.originSelectionRange)||L.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=v;var n;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var h;(function(u){u[u.Deprecated=1]="Deprecated"})(h=e.SymbolTag||(e.SymbolTag={}));var r;(function(u){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const T=new Map;T.set(0,"file"),T.set(1,"module"),T.set(2,"namespace"),T.set(3,"package"),T.set(4,"class"),T.set(5,"method"),T.set(6,"property"),T.set(7,"field"),T.set(8,"constructor"),T.set(9,"enum"),T.set(10,"interface"),T.set(11,"function"),T.set(12,"variable"),T.set(13,"constant"),T.set(14,"string"),T.set(15,"number"),T.set(16,"boolean"),T.set(17,"array"),T.set(18,"object"),T.set(19,"key"),T.set(20,"null"),T.set(21,"enum-member"),T.set(22,"struct"),T.set(23,"event"),T.set(24,"operator"),T.set(25,"type-parameter");function R(F){return y.get(F)}u.fromString=R;function $(F){return T.get(F)}u.toString=$;function B(F,W){const M=T.get(F);let z=M&&A.iconRegistry.get("symbol-"+M);return z||(console.info("No codicon found for SymbolKind "+F),z=A.Codicon.symbolProperty),`${W?"inline":"block"} ${z.classNames}`}u.toCssClassName=B})(r=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(y){this.value=y}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var l;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(l=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var d;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(d=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var m;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(m=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[52],me([0,1,12,8,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=g.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",g.isMacintosh),A.set("isLinux",g.isLinux),A.set("isWindows",g.isWindows),A.set("isWeb",g.isWeb),A.set("isMacNative",g.isMacintosh&&!g.isWeb),A.set("isEdge",S.indexOf("Edg/")>=0),A.set("isFirefox",S.indexOf("Firefox")>=0),A.set("isChrome",S.indexOf("Chrome")>=0),A.set("isSafari",S.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var E;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return c.INSTANCE}static true(){return p.INSTANCE}static has(F){return f.create(F)}static equals(F,W){return w.create(F,W)}static notEquals(F,W){return b.create(F,W)}static regex(F,W){return t.create(F,W)}static in(F,W){return _.create(F,W)}static not(F){return s.create(F)}static and(...F){return d.create(F,null)}static or(...F){return m.create(F,null,!0)}static greater(F,W){return v.create(F,W)}static greaterEquals(F,W){return n.create(F,W)}static smaller(F,W){return h.create(F,W)}static smallerEquals(F,W){return r.create(F,W)}static deserialize(F,W=!1){if(!!F)return this._deserializeOrExpression(F,W)}static _deserializeOrExpression(F,W){let M=F.split("||");return m.create(M.map(z=>this._deserializeAndExpression(z,W)),null,!0)}static _deserializeAndExpression(F,W){let M=F.split("&&");return d.create(M.map(z=>this._deserializeOne(z,W)),null)}static _deserializeOne(F,W){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],W))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],W))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return _.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return h.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?s.create(F.substr(1).trim()):f.create(F)}static _deserializeValue(F,W){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,W){if((0,L.isFalsyOrWhitespace)(F)){if(W)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),z=F.lastIndexOf("/");if(M===z||M<0){if(W)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(M+1,z),U=F[z+1]==="i"?"i":"";try{return new RegExp(N,U)}catch(x){if(W)throw new Error(`bad regexp-value '${F}', parse error: ${x}`);return console.warn(`bad regexp-value '${F}', parse error: ${x}`),null}}}e.ContextKeyExpr=C;function i(B,F){const W=B?B.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!W&&!M?!0:!W||!M?!1:W.equals(M)}e.expressionsAreEqualWithConstantSubstitution=i;function I(B,F){return B.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class p{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class f{constructor(F,W){this.key=F,this.negated=W,this.type=2}static create(F,W=null){const M=A.get(F);return typeof M=="boolean"?M?p.INSTANCE:c.INSTANCE:new f(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=A.get(this.key);return typeof F=="boolean"?F?p.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class w{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=4}static create(F,W,M=null){if(typeof W=="boolean")return W?f.create(F,M):s.create(F,M);const z=A.get(F);return typeof z=="boolean"?W===(z?"true":"false")?p.INSTANCE:c.INSTANCE:new w(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=A.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?p.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class _{constructor(F,W){this.key=F,this.valueKey=W,this.type=10,this.negated=null}static create(F,W){return new _(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const W=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray(W)?W.indexOf(M)>=0:typeof M=="string"&&typeof W=="object"&&W!==null?k.call(W,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=P.create(this)),this.negated}}e.ContextKeyInExpr=_;class P{constructor(F){this._actual=F,this.type=11}static create(F){return new P(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new P(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=P;class b{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=5}static create(F,W,M=null){if(typeof W=="boolean")return W?s.create(F,M):f.create(F,M);const z=A.get(F);return typeof z=="boolean"?W===(z?"true":"false")?c.INSTANCE:p.INSTANCE:new b(F,W,M)}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=A.get(this.key);if(typeof F=="boolean"){const W=F?"true":"false";return this.value===W?c.INSTANCE:p.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class s{constructor(F,W){this.key=F,this.negated=W,this.type=3}static create(F,W=null){const M=A.get(F);return typeof M=="boolean"?M?c.INSTANCE:p.INSTANCE:new s(F,W)}cmp(F){return F.type!==this.type?this.type-F.type:y(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=A.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:p.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function a(B,F){if(typeof B=="string"){const W=parseFloat(B);isNaN(W)||(B=W)}return typeof B=="string"||typeof B=="number"?F(B):c.INSTANCE}class v{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=12}static create(F,W,M=null){return a(W,z=>new v(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=v;class n{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=13}static create(F,W,M=null){return a(W,z=>new n(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=n;class h{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=14}static create(F,W,M=null){return a(W,z=>new h(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=h;class r{constructor(F,W,M){this.key=F,this.value=W,this.negated=M,this.type=15}static create(F,W,M=null){return a(W,z=>new r(F,z,M))}cmp(F){return F.type!==this.type?this.type-F.type:T(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(F,W){this.key=F,this.regexp=W,this.type=7,this.negated=null}static create(F,W){return new t(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return W<M?-1:W>M?1:0}equals(F){if(F.type===this.type){const W=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&W===M}return!1}substituteConstants(){return this}evaluate(F){let W=F.getValue(this.key);return this.regexp?this.regexp.test(W):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=l.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class l{constructor(F){this._actual=F,this.type=8}static create(F){return new l(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new l(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;function o(B){let F=null;for(let W=0,M=B.length;W<M;W++){const z=B[W].substituteConstants();if(B[W]!==z&&F===null){F=[];for(let N=0;N<W;N++)F[N]=B[N]}F!==null&&(F[W]=z)}return F===null?B:F}class d{constructor(F,W){this.expr=F,this.negated=W,this.type=6}static create(F,W){return d._normalizeArr(F,W)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const z=I(this.expr[W],F.expr[W]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:d.create(F,this.negated)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].evaluate(F))return!1;return!0}static _normalizeArr(F,W){const M=[];let z=!1;for(const N of F)if(!!N){if(N.type===1){z=!0;continue}if(N.type===0)return c.INSTANCE;if(N.type===6){M.push(...N.expr);continue}M.push(N)}if(M.length===0&&z)return p.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let N=1;N<M.length;N++)M[N-1].equals(M[N])&&(M.splice(N,1),N--);if(M.length===1)return M[0];for(;M.length>1;){const N=M[M.length-1];if(N.type!==9)break;M.pop();const U=M.pop(),x=M.length===0,O=m.create(N.expr.map(j=>d.create([j,U],null)),null,x);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new d(M,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new d(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){const F=[];for(let W of this.expr)F.push(W.negate());this.negated=m.create(F,this,!0)}return this.negated}}class m{constructor(F,W){this.expr=F,this.negated=W,this.type=9}static create(F,W,M){return m._normalizeArr(F,W,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let W=0,M=this.expr.length;W<M;W++){const z=I(this.expr[W],F.expr[W]);if(z!==0)return z}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let W=0,M=this.expr.length;W<M;W++)if(!this.expr[W].equals(F.expr[W]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:m.create(F,this.negated,!1)}evaluate(F){for(let W=0,M=this.expr.length;W<M;W++)if(this.expr[W].evaluate(F))return!0;return!1}static _normalizeArr(F,W,M){let z=[],N=!1;if(F){for(let U=0,x=F.length;U<x;U++){const O=F[U];if(!!O){if(O.type===0){N=!0;continue}if(O.type===1)return p.INSTANCE;if(O.type===9){z=z.concat(O.expr);continue}z.push(O)}}if(z.length===0&&N)return c.INSTANCE;z.sort(I)}if(z.length!==0){if(z.length===1)return z[0];for(let U=1;U<z.length;U++)z[U-1].equals(z[U])&&(z.splice(U,1),U--);if(z.length===1)return z[0];if(M){for(let U=0;U<z.length;U++)for(let x=U+1;x<z.length;x++)R(z[U],z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0]}return new m(z,W)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let W of this.expr)F.push(...W.keys());return F}map(F){return new m(this.expr.map(W=>W.map(F)),null)}negate(){if(!this.negated){let F=[];for(let W of this.expr)F.push(W.negate());for(;F.length>1;){const W=F.shift(),M=F.shift(),z=[];for(const U of $(W))for(const x of $(M))z.push(d.create([U,x],null));const N=F.length===0;F.unshift(m.create(z,null,N))}this.negated=F[0]}return this.negated}}class u extends f{constructor(F,W,M){super(F,null);this._defaultValue=W,typeof M=="object"?u._info.push({...M,key:F}):M!==!0&&u._info.push({key:F,description:M,type:W!=null?typeof W:void 0})}static all(){return u._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=u,u._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(B,F){return B<F?-1:B>F?1:0}function T(B,F,W,M){return B<W?-1:B>W?1:F<M?-1:F>M?1:0}function R(B,F){if(F.type===6&&B.type!==9&&B.type!==6){for(const z of F.expr)if(B.equals(z))return!0}const W=B.negate(),M=$(W).concat($(F));M.sort(I);for(let z=0;z<M.length;z++){const U=M[z].negate();for(let x=z+1;x<M.length;x++){const O=M[x];if(U.equals(O))return!0}}return!1}e.implies=R;function $(B){return B.type===9?B.expr:[B]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var S;(function(s){s.WIN32_X64="win32-x64",s.WIN32_IA32="win32-ia32",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));function A(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=A;function k(s){switch(s){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function E(s,a){switch(s){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=E;function C(s,a){return a==="web"&&!s.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function i(s,a,v){return C(a,v)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===v?!0:I(v).includes(s)}e.isTargetPlatformCompatible=i;function I(s){switch(s){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function c(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.isIExtensionIdentifier=c;var p;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var f;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var w;(function(s){s.Install="install",s.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var _;(function(s){s[s.None=0]="None",s[s.Install=1]="Install",s[s.Update=2]="Update"})(_=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var P;(function(s){s.Unsupported="Unsupported",s.Malicious="Malicious",s.Incompatible="Incompatible",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Internal="Internal"})(P=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(a,v){super(a);this.code=v,this.name=v}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,38,10,9,12,94,28,112,159,187]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=C.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:p.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class p extends c{openTerminal(a,v){return this.spawnTerminal(g,a,E.getWindowsShell(),v)}spawnTerminal(a,v,n,h){const r=v.windowsExec||p.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const t=D.basename(r).toLowerCase();if(t==="cmder"||t==="cmder.exe")return a.spawn(r,h?[h]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return r.indexOf(" ")>=0&&l.push('""'),l.push(r),(t==="wt"||t==="wt.exe")&&l.push("-d ."),new Promise((o,d)=>{const m=_(process),u=a.spawn(n,l,{cwd:h,env:m});u.on("error",d),u.on("exit",()=>o())})}runInTerminal(a,v,n,h,r){const t="windowsExec"in r&&r.windowsExec?r.windowsExec:p.getDefaultTerminalWindows();return new Promise((l,o)=>{const d=`"${v} - ${I}"`,m=`""${n.join('" "')}" & pause"`,u=["/c","start",d,"/wait",t,"/c",m],y=Object.assign({},_(process),h);Object.keys(y).filter($=>y[$]===null).forEach($=>delete y[$]);const T={cwd:v,env:y,windowsVerbatimArguments:!0};g.spawn(p.CMD,u,T).on("error",$=>{o(P($))}),l(void 0)})}static getDefaultTerminalWindows(){if(!p._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");p._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return p._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=p,p.CMD="cmd.exe";class f extends c{openTerminal(a,v){return this.spawnTerminal(g,a,v)}runInTerminal(a,v,n,h,r){const t=r.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((l,o)=>{if(t===i.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const d=t===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",u=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`,Y).fsPath,"-t",a||I,"-w",v];for(let R of n)u.push("-a"),u.push(R);if(h){const R=Object.assign({},_(process),h);for(let $ in R){const B=R[$];B===null?(u.push("-u"),u.push($)):(u.push("-e"),u.push(`${$}=${B}`))}}let y="";const T=g.spawn(f.OSASCRIPT,u);T.on("error",R=>{o(P(R))}),T.stderr.on("data",R=>{y+=R.toString()}),T.on("exit",R=>{if(R===0)l(void 0);else if(y){const $=y.split(`
`,1);o(new Error($[0]))}else o(new Error(C.localize(1,null,d,R)))})}else o(new Error(C.localize(2,null,t)))})}spawnTerminal(a,v,n){const h=v.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((r,t)=>{const l=["-a",h];n&&l.push(n);const o=_(process),d=a.spawn("/usr/bin/open",l,{cwd:n,env:o});d.on("error",t),d.on("exit",()=>r())})}}e.MacExternalTerminalService=f,f.OSASCRIPT="/usr/bin/osascript";class w extends c{openTerminal(a,v){return this.spawnTerminal(g,a,v)}runInTerminal(a,v,n,h,r){const t=r.linuxExec?Promise.resolve(r.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,o)=>{let d=[];t.then(m=>{m.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const u=`${b(n)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;d.push(`''${u}''`);const y=Object.assign({},_(process),h);Object.keys(y).filter(B=>y[B]===null).forEach(B=>delete y[B]);const T={cwd:v,env:y};let R="";const $=g.spawn(m,d,T);$.on("error",B=>{o(P(B))}),$.stderr.on("data",B=>{R+=B.toString()}),$.on("exit",B=>{if(B===0)l(void 0);else if(R){const F=R.split(`
`,1);o(new Error(F[0]))}else o(new Error(C.localize(4,null,m,B)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!S.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(v=>{a?v("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?v("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?v("konsole"):process.env.COLORTERM?v(process.env.COLORTERM):process.env.TERM?v(process.env.TERM):v("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,v,n){const h=v.linuxExec?Promise.resolve(v.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((r,t)=>{h.then(l=>{const o=_(process),d=a.spawn(l,[],{cwd:n,env:o});d.on("error",t),d.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=C.localize(3,null);function _(s){const a={...s.env};return(0,A.sanitizeProcessEnvironment)(a),a}function P(s){return"errno"in s&&s.errno==="ENOENT"&&"path"in s&&typeof s.path=="string"?new Error(C.localize(5,null,s.path)):s}function b(s){let a="";for(let v of s)v.indexOf(" ")>=0?a+='"'+v+'"':a+=v,a+=" ";return a}}),define(fe[42],me([0,1,24,9,8,13,2,160,4]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function f(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=f;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function _(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=_;var P;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(z,N){super(z);this.code=N}}e.FileSystemProviderError=b;function s(M,z){const N=new b(M.toString(),z);return v(N,z),N}e.createFileSystemProviderError=s;function a(M){return M||s((0,k.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=a;function v(M,z){return M.name=z?`${z} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=v;function n(M){if(!M)return P.Unknown;if(M instanceof b)return M.code;const z=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=n;function h(M){if(M instanceof m)return M.fileOperationResult;switch(n(M)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=h;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(z,N,U){this.resource=z,this.operation=N,this.target=U}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var l;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class o{constructor(z,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const x of z){const O=U.get(x.type);O?O.push([x.resource,x]):U.set(x.type,[[x.resource,x]])}for(const[x,O]of U)switch(x){case 1:this.added=g.TernarySearchTree.forUris(()=>N),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>N),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>N),this.deleted.fill(O);break}}contains(z,...N){return this.doContains(z,{includeChildren:!1},...N)}affects(z,...N){return this.doContains(z,{includeChildren:!0},...N)}doContains(z,N,...U){if(!z)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.added?.get(z)||N.includeChildren&&this.added?.findSuperstr(z))||(!x||U.includes(0))&&(this.updated?.get(z)||N.includeChildren&&this.updated?.findSuperstr(z))||(!x||U.includes(2))&&(this.deleted?.findSubstr(z)||N.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function d(M,z,N){return!M||!z||M===z||z.length>M.length?!1:(z.charAt(z.length-1)!==L.sep&&(z+=L.sep),N?(0,D.startsWithIgnoreCase)(M,z):M.indexOf(z)===0)}e.isParent=d;class m extends Error{constructor(z,N,U){super(z);this.fileOperationResult=N,this.options=U}}e.FileOperationError=m;class u extends m{constructor(z,N,U){super(z,2,U);this.stat=N}}e.NotModifiedSinceFileOperationError=u;var y;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function $(M,z){if(!z.hasProvider(A.URI.from({scheme:M.scheme})))return new Promise(N=>{const U=z.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===M.scheme&&x.added&&(U.dispose(),N())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(z){return(0,S.isNumber)(z)||(z=0),z<B.KB?(0,k.localize)(1,null,z.toFixed(0)):z<B.MB?(0,k.localize)(2,null,(z/B.KB).toFixed(2)):z<B.GB?(0,k.localize)(3,null,(z/B.MB).toFixed(2)):z<B.TB?(0,k.localize)(4,null,(z/B.GB).toFixed(2)):(0,k.localize)(5,null,(z/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function W(M){return{maxFileSize:M===0?300*B.MB:16*B.GB,maxHeapSize:M===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=W}),define(fe[85],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...D){this._entries=new Map;for(let[S,A]of D)this.set(S,A)}set(D,S){const A=this._entries.get(D);return this._entries.set(D,S),A}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=g}),define(fe[189],me([0,1,16,18,114,182,4,85]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class C extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class i{constructor(f=new k.ServiceCollection,w=!1,_){this._activeInstantiations=new Set,this._services=f,this._strict=w,this._parent=_,this._services.set(A.IInstantiationService,this)}createChild(f){return new i(f,this._strict,this)}invokeFunction(f,...w){let _=c.traceInvocation(f),P=!1;try{return f({get:s=>{if(P)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(s,_);if(!a)throw new Error(`[invokeFunction] unknown service '${s}'`);return a}},...w)}finally{P=!0,_.stop()}}createInstance(f,...w){let _,P;return f instanceof D.SyncDescriptor?(_=c.traceCreation(f.ctor),P=this._createInstance(f.ctor,f.staticArguments.concat(w),_)):(_=c.traceCreation(f),P=this._createInstance(f,w,_)),_.stop(),P}_createInstance(f,w=[],_){let P=A._util.getServiceDependencies(f).sort((a,v)=>a.index-v.index),b=[];for(const a of P){let v=this._getOrCreateServiceInstance(a.id,_);if(!v&&this._strict&&!a.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`);b.push(v)}let s=P.length>0?P[0].index:w.length;if(w.length!==s){console.warn(`[createInstance] First service dependency of ${f.name} at position ${s+1} conflicts with ${w.length} static arguments`);let a=s-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,s)}return new f(...[...w,...b])}_setServiceInstance(f,w){if(this._services.get(f)instanceof D.SyncDescriptor)this._services.set(f,w);else if(this._parent)this._parent._setServiceInstance(f,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let w=this._services.get(f);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):w}_getOrCreateServiceInstance(f,w){let _=this._getServiceInstanceOrDescriptor(f);return _ instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,_,w.branch(f,!0)):(w.branch(f,!1),_)}_safeCreateAndCacheServiceInstance(f,w,_){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,w,_)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,w,_){const P=new S.Graph(a=>a.id.toString());let b=0;const s=[{id:f,desc:w,_trace:_}];for(;s.length;){const a=s.pop();if(P.lookupOrInsertNode(a),b++>1e3)throw new C(P);for(let v of A._util.getServiceDependencies(a.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(v.id);if(!n&&!v.optional&&console.warn(`[createInstance] ${f} depends on ${v.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const h={id:v.id,desc:n,_trace:a._trace.branch(v.id,!0)};P.insertEdge(a,h),s.push(h)}}}for(;;){const a=P.roots();if(a.length===0){if(!P.isEmpty())throw new C(P);break}for(const{data:v}of a){if(this._getServiceInstanceOrDescriptor(v.id)instanceof D.SyncDescriptor){const h=this._createServiceInstanceWithOwner(v.id,v.desc.ctor,v.desc.staticArguments,v.desc.supportsDelayedInstantiation,v._trace);this._setServiceInstance(v.id,h)}P.removeNode(v)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,w,_=[],P,b){if(this._services.get(f)instanceof D.SyncDescriptor)return this._createServiceInstance(w,_,P,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,w,_,P,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(f,w=[],_,P){if(_){const b=new g.IdleValue(()=>this._createInstance(f,w,P));return new Proxy(Object.create(null),{get(s,a){if(a in s)return s[a];let v=b.value,n=v[a];return typeof n!="function"||(n=n.bind(v),s[a]=n),n},set(s,a,v){return b.value[a]=v,!0}})}else return this._createInstance(f,w,P)}}e.InstantiationService=i;var I;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(I||(I={}));class c{constructor(f,w){this.type=f,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new c(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(f){return E?new c(0,f.name):c._None}branch(f,w){let _=new c(2,f.toString());return this._dep.push([f,w,_]),_}stop(){let f=Date.now()-this._start;c._totals+=f;let w=!1;function _(b,s){let a=[],v=new Array(b+1).join("	");for(const[n,h,r]of s._dep)if(h&&r){w=!0,a.push(`${v}CREATES -> ${n}`);let t=_(b+1,r);t&&a.push(t)}else a.push(`${v}uses -> ${n}`);return a.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${_(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(f>2||w)&&console.log(P.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(fe[11],me([0,1,51,3,6,12,4]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function k(){return new Date().toISOString()}var E;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function C(h,r,t){switch(r){case E.Trace:h.trace(t);break;case E.Debug:h.debug(t);break;case E.Info:h.info(t);break;case E.Warning:h.warn(t);break;case E.Error:h.error(t);break;case E.Critical:h.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function i(h){let r="";for(let t=0;t<h.length;t++){let l=h[t];if(typeof l=="object")try{l=JSON.stringify(l)}catch(o){}r+=(t>0?" ":"")+l}return r}e.format=i;class I extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class c extends I{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...t){this.checkLogLevel(E.Trace)&&this.log(E.Trace,i([r,...t]))}debug(r,...t){this.checkLogLevel(E.Debug)&&this.log(E.Debug,i([r,...t]))}info(r,...t){this.checkLogLevel(E.Info)&&this.log(E.Info,i([r,...t]))}warn(r,...t){this.checkLogLevel(E.Warning)&&this.log(E.Warning,i([r,...t]))}error(r,...t){if(this.checkLogLevel(E.Error))if(r instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=r.stack,this.log(E.Error,i(l))}else this.log(E.Error,i([r,...t]))}critical(r,...t){this.checkLogLevel(E.Critical)&&this.log(E.Critical,i([r,...t]))}flush(){}}e.AbstractMessageLogger=c;class p extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!S.isWindows}trace(r,...t){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}debug(r,...t){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}info(r,...t){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,r,...t):console.log(`[main ${k()}]`,r,...t))}warn(r,...t){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,r,...t):console.warn(`[main ${k()}]`,r,...t))}error(r,...t){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,r,...t):console.error(`[main ${k()}]`,r,...t))}critical(r,...t){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,r,...t):console.error(`[main ${k()}]`,r,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class f extends I{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...t){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",r,...t)}debug(r,...t){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...t)}info(r,...t){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",r,...t)}warn(r,...t){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",r,...t)}error(r,...t){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",r,...t)}critical(r,...t){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...t)}dispose(){}flush(){}}e.ConsoleLogger=f;class w extends I{constructor(r,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(t)}trace(r,...t){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(r),...t])}debug(r,...t){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(r),...t])}info(r,...t){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(r),...t])}warn(r,...t){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(r),...t])}error(r,...t){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(r),...t])}critical(r,...t){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(r),...t])}extractMessage(r){return typeof r=="string"?r:(0,g.toErrorMessage)(r,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class _ extends I{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const t of this.logServices)t.setLevel(r);super.setLevel(r)}trace(r,...t){for(const l of this.logServices)l.trace(r,...t)}debug(r,...t){for(const l of this.logServices)l.debug(r,...t)}info(r,...t){for(const l of this.logServices)l.info(r,...t)}warn(r,...t){for(const l of this.logServices)l.warn(r,...t)}error(r,...t){for(const l of this.logServices)l.error(r,...t)}critical(r,...t){for(const l of this.logServices)l.critical(r,...t)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=_;class P extends D.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...t){this.logger.trace(r,...t)}debug(r,...t){this.logger.debug(r,...t)}info(r,...t){this.logger.info(r,...t)}warn(r,...t){this.logger.warn(r,...t)}error(r,...t){this.logger.error(r,...t)}critical(r,...t){this.logger.critical(r,...t)}flush(){this.logger.flush()}}e.LogService=P;class b extends D.Disposable{constructor(r,t){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(l))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,t){let l=this.loggers.get(r.toString());return l||(l=this.doCreateLogger(r,t?.always?E.Trace:this.logLevel,t),this.loggers.set(r.toString(),l),t?.always||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class s{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(r){}getLevel(){return E.Info}trace(r,...t){}debug(r,...t){}info(r,...t){}warn(r,...t){}error(r,...t){}critical(r,...t){}dispose(){}flush(){}}e.NullLogService=s;function a(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const r=v(h.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function v(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=v;function n(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=n}),define(fe[190],me([0,1,42,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(E,C,i,I){try{const c=await new Promise((p,f)=>{Y(["spdlog"],p,f)});return c.setFlushOn(L.LogLevel.Trace),c.createAsyncRotatingLogger(E,C,i,I)}catch(c){console.error(c)}return null}function S(E,C,i,I){const c=Y.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(E,C,i,I)}e.createRotatingLogger=S;function A(E,C,i){switch(C){case L.LogLevel.Trace:E.trace(i);break;case L.LogLevel.Debug:E.debug(i);break;case L.LogLevel.Info:E.info(i);break;case L.LogLevel.Warning:E.warn(i);break;case L.LogLevel.Error:E.error(i);break;case L.LogLevel.Critical:E.critical(i);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(C,i,I,c){super();this.name=C,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(p=>{this._logger&&this._logger.setLevel(p)}))}_createSpdLogLogger(){const C=this.rotating?6:1,i=30/C*g.ByteSize.MB;return D(this.name,this.filepath,i,C).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:c,message:p}of this.buffer)A(this._logger,c,p);this.buffer=[]}})}log(C,i){this._logger?A(this._logger,C,i):this.getLevel()<=C&&this.buffer.push({level:C,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(fe[115],me([0,1,49,161,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function C(f,w){return w-f}E.compare=C;const i=Object.create(null);i[E.Error]=(0,L.localize)(0,null),i[E.Warning]=(0,L.localize)(1,null),i[E.Info]=(0,L.localize)(2,null);function I(f){return i[f]||""}E.toString=I;function c(f){switch(f){case g.default.Error:return E.Error;case g.default.Warning:return E.Warning;case g.default.Info:return E.Info;case g.default.Ignore:return E.Hint}}E.fromSeverity=c;function p(f){switch(f){case E.Error:return g.default.Error;case E.Warning:return g.default.Warning;case E.Info:return g.default.Info;case E.Hint:return g.default.Ignore}}E.toSeverity=p}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(E){const C="";function i(c){return I(c,!0)}E.makeKey=i;function I(c,p){let f=[C];return c.source?f.push(c.source.replace("\xA6","\\\xA6")):f.push(C),c.code?typeof c.code=="string"?f.push(c.code.replace("\xA6","\\\xA6")):f.push(c.code.value.replace("\xA6","\\\xA6")):f.push(C),c.severity!==void 0&&c.severity!==null?f.push(A.toString(c.severity)):f.push(C),c.message&&p?f.push(c.message.replace("\xA6","\\\xA6")):f.push(C),c.startLineNumber!==void 0&&c.startLineNumber!==null?f.push(c.startLineNumber.toString()):f.push(C),c.startColumn!==void 0&&c.startColumn!==null?f.push(c.startColumn.toString()):f.push(C),c.endLineNumber!==void 0&&c.endLineNumber!==null?f.push(c.endLineNumber.toString()):f.push(C),c.endColumn!==void 0&&c.endColumn!==null?f.push(c.endColumn.toString()):f.push(C),f.push(C),f.join("\xA6")}E.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,D.createDecorator)("markerService")}),define(fe[191],me([0,1,3,49,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,D.createDecorator)("notificationService");var S;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new E,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=k;class E{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=E}),define(fe[192],me([0,1,6,8,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,S.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(E){return{resolved:E,dispose(){}}}});function A(E,C){return D.URI.isUri(E)?(0,L.equalsIgnoreCase)(E.scheme,C):(0,L.startsWithIgnoreCase)(E,C+":")}e.matchesScheme=A;function k(E,...C){return C.some(i=>A(E,i))}e.matchesSomeScheme=k}),define(fe[193],me([0,1,10,12,37,23]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)A=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,S.dirname)(g.FileAccess.asFileUri("",Y));A=Y.__$__nodeRequire((0,S.joinPath)(k,"product.json").fsPath);const E=Y.__$__nodeRequire((0,S.joinPath)(k,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:E.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var $e=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[116],me([0,1,16,21,6,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,S.createDecorator)("progressService");var A;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(I,c){super();this.deferred=new g.DeferredPromise,c.withProgress(I,p=>(this.reporter=p,this.lastStep&&p.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};E=Ve([$e(1,e.IProgressService)],E),e.UnmanagedProgress=E;class C extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,p=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>p.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:p.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,S.createDecorator)("editorProgressService")}),define(fe[34],me([0,1,57,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(A,k){g.ok(L.isString(A)),g.ok(L.isObject(k)),g.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,k)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new D}),define(fe[117],me([0,1,3,34]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class S{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,C){this.schemasById[D(E)]=C,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new S;L.Registry.add(e.Extensions.JSONContribution,A)}),define(fe[86],me([0,1,15,3,13,156,117,34]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var E;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(E=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=k.Registry.as(A.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:S.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const v=this.doRegisterConfigurations(s,a);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(s){const a=this.doDeregisterConfigurations(s);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}updateConfigurations({add:s,remove:a}){const v=[];v.push(...this.doDeregisterConfigurations(a)),v.push(...this.doRegisterConfigurations(s,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(v))}registerDefaultConfigurations(s){const a=[],v=[];for(const n of s)for(const h in n)if(a.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]={...this.defaultValues[h]||{},...n[h]};const r={type:"object",default:this.defaultValues[h],description:S.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};v.push(p(h)),this.configurationProperties[h]=r,this.defaultLanguageConfigurationOverridesNode.properties[h]=r}else{this.defaultValues[h]=n[h];const r=this.configurationProperties[h];r&&(this.updatePropertyDefaultValue(h,r),this.updateSchema(h,r))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(s){const a=[];for(const v of s)for(const n in v)if(a.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const a of s)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,a){const v=[];return s.forEach(n=>{v.push(...this.validateAndRegisterProperties(n,a,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),v}doDeregisterConfigurations(s){const a=[],v=n=>{if(n.properties)for(const h in n.properties)a.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,n.properties[h]);n.allOf&&n.allOf.forEach(h=>v(h))};for(const n of s){v(n);const h=this.configurationContributors.indexOf(n);h!==-1&&this.configurationContributors.splice(h,1)}return a}validateAndRegisterProperties(s,a=!0,v,n=3){n=D.isUndefinedOrNull(s.scope)?n:s.scope;let h=[],r=s.properties;if(r)for(let l in r){if(a&&_(l)){delete r[l];continue}const o=r[l];if(this.updatePropertyDefaultValue(l,o),e.OVERRIDE_PROPERTY_PATTERN.test(l)?o.scope=void 0:(o.scope=D.isUndefinedOrNull(o.scope)?n:o.scope,o.restricted=D.isUndefinedOrNull(o.restricted)?!!v?.restrictedConfigurations?.includes(l):o.restricted),r[l].hasOwnProperty("included")&&!r[l].included){this.excludedConfigurationProperties[l]=r[l],delete r[l];continue}else this.configurationProperties[l]=r[l];!r[l].deprecationMessage&&r[l].markdownDeprecationMessage&&(r[l].deprecationMessage=r[l].markdownDeprecationMessage),h.push(l)}let t=s.allOf;if(t)for(let l of t)h.push(...this.validateAndRegisterProperties(l,a,v,n));return h}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(s){const a=v=>{let n=v.properties;if(n)for(const r in n)this.updateSchema(r,n[r]);let h=v.allOf;h&&h.forEach(a)};a(s)}updateSchema(s,a){switch(e.allSettings.properties[s]=a,a.scope){case 1:e.applicationSettings.properties[s]=a;break;case 2:e.machineSettings.properties[s]=a;break;case 6:e.machineOverridableSettings.properties[s]=a;break;case 3:e.windowSettings.properties[s]=a;break;case 4:e.resourceSettings.properties[s]=a;break;case 5:e.resourceSettings.properties[s]=a,this.resourceLanguageSettingsSchema.properties[s]=a;break}}removeFromSchema(s,a){switch(delete e.allSettings.properties[s],a.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const a=`[${s}]`,v={type:"object",description:S.localize(2,null),errorMessage:S.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,v),e.allSettings.properties[a]=v,e.applicationSettings.properties[a]=v,e.machineSettings.properties[a]=v,e.machineOverridableSettings.properties[a]=v,e.windowSettings.properties[a]=v,e.resourceSettings.properties[a]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,a){let v=this.defaultValues[s];D.isUndefined(v)&&(v=a.default),D.isUndefined(v)&&(v=f(a.type)),a.default=v}}const c="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function p(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=p;function f(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const w=new I;k.Registry.add(e.Extensions.Configuration,w);function _(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?S.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?S.localize(6,null,b):null:S.localize(4,null)}e.validateProperty=_;function P(){const b=[],s=w.getConfigurationProperties();for(const a of Object.keys(s))b.push([a,s[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=P}),define(fe[118],me([0,1,25,13,2,86,4,34]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,A.createDecorator)("configurationService");function E(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof D.URI)}e.isConfigurationOverrides=E;var C;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(h,r){const t=r?h?r.keys.filter(T=>h.keys.indexOf(T)===-1):[...r.keys]:[],l=h?r?h.keys.filter(T=>r.keys.indexOf(T)===-1):[...h.keys]:[],o=[];if(r&&h){for(const T of h.keys)if(r.keys.indexOf(T)!==-1){const R=P(h.contents,T),$=P(r.contents,T);g.equals(R,$)||o.push(T)}}const d=[],m=T=>{const R={};for(const $ of T)for(const B of $.identifiers)R[v(B)]=$;return R},u=r?m(r.overrides):{},y=h?m(h.overrides):{};if(Object.keys(u).length)for(const T of t){const R=u[T];R&&d.push([(0,S.overrideIdentifierFromKey)(T),R.keys])}if(Object.keys(y).length)for(const T of l){const R=y[T];R&&d.push([(0,S.overrideIdentifierFromKey)(T),R.keys])}if(Object.keys(u).length&&Object.keys(y).length)for(const T of o){const R=y[T],$=u[T];if(R&&$){const B=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});d.push([(0,S.overrideIdentifierFromKey)(T),[...B.added,...B.removed,...B.updated]])}}return{added:t,removed:l,updated:o,overrides:d}}e.compare=I;function c(h,r){const t=[];for(const l of Object.keys(h))if(S.OVERRIDE_PROPERTY_PATTERN.test(l)){const o={};for(const d in h[l])o[d]=h[l][d];t.push({identifiers:[(0,S.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(o),contents:p(o,r)})}return t}e.toOverrides=c;function p(h,r){const t=Object.create(null);for(let l in h)f(t,l,h[l],r);return t}e.toValuesTree=p;function f(h,r,t,l){const o=r.split("."),d=o.pop();let m=h;for(let u=0;u<o.length;u++){let y=o[u],T=m[y];switch(typeof T){case"undefined":T=m[y]=Object.create(null);break;case"object":break;default:l(`Ignoring ${r} as ${o.slice(0,u+1).join(".")} is ${JSON.stringify(T)}`);return}m=T}if(typeof m=="object"&&m!==null)try{m[d]=t}catch(u){l(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(m)}`)}else l(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=f;function w(h,r){const t=r.split(".");_(h,t)}e.removeFromValueTree=w;function _(h,r){const t=r.shift();if(r.length===0){delete h[t];return}if(Object.keys(h).indexOf(t)!==-1){const l=h[t];typeof l=="object"&&!Array.isArray(l)&&(_(l,r),Object.keys(l).length===0&&delete h[t])}}function P(h,r,t){function l(m,u){let y=m;for(const T of u){if(typeof y!="object"||y===null)return;y=y[T]}return y}const o=r.split("."),d=l(h,o);return typeof d=="undefined"?t:d}e.getConfigurationValue=P;function b(h,r,t){Object.keys(r).forEach(l=>{l!=="__proto__"&&(l in h?L.isObject(h[l])&&L.isObject(r[l])?b(h[l],r[l],t):t&&(h[l]=r[l]):h[l]=r[l])})}e.merge=b;function s(){const h=k.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(h)}e.getConfigurationKeys=s;function a(){const h=Object.create(null),r=k.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let t in r){let l=r[t].default;f(h,t,l,o=>console.error(`Conflict in default settings: ${o}`))}return h}e.getDefaultValues=a;function v(h){return`[${h}]`}e.keyFromOverrideIdentifier=v;function n(h,r,t){const l=h.inspect(r),o=h.inspect(t);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:l.defaultValue}e.getMigratedSettingValue=n}),define(fe[194],me([0,1,15,3,60,6,24,25,13,2,118,86,34]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},h=[],r=[]){this._contents=n,this._keys=h,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,h){const r=this.getContentsForOverrideIdentifer(h);return r?n?(0,i.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){for(const h of this.overrides)if(h.identifiers.indexOf(n)!==-1)return h.keys;return[]}override(n){let h=this.overrideConfigurations.get(n);return h||(h=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,h)),h}merge(...n){const h=k.deepClone(this.contents),r=k.deepClone(this.overrides),t=[...this.keys];for(const l of n){this.mergeContents(h,l.contents);for(const o of l.overrides){const[d]=r.filter(m=>g.equals(m.identifiers,o.identifiers));d?this.mergeContents(d.contents,o.contents):r.push(k.deepClone(o))}for(const o of l.keys)t.indexOf(o)===-1&&t.push(o)}return new p(h,t,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const h=this.getContentsForOverrideIdentifer(n);if(!h||typeof h!="object"||!Object.keys(h).length)return this;let r={};for(const t of g.distinct([...Object.keys(this.contents),...Object.keys(h)])){let l=this.contents[t],o=h[t];o&&(typeof l=="object"&&typeof o=="object"?(l=k.deepClone(l),this.mergeContents(l,o)):l=o),r[t]=l}return new p(r,this.keys,this.overrides)}mergeContents(n,h){for(const r of Object.keys(h)){if(r in n&&E.isObject(n[r])&&E.isObject(h[r])){this.mergeContents(n[r],h[r]);continue}n[r]=k.deepClone(h[r])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?k.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const h of this.overrides)if(h.identifiers.indexOf(n)!==-1)return h.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,h){this.addKey(n),(0,i.addToValueTree)(this.contents,n,h,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let h=this.keys.length;for(let r=0;r<h;r++)n.indexOf(this.keys[r])===0&&(h=r);this.keys.splice(h,1,n)}removeKey(n){let h=this.keys.indexOf(n);return h!==-1?(this.keys.splice(h,1),!0):!1}}e.ConfigurationModel=p;class f extends p{constructor(){const n=(0,i.getDefaultValues)(),h=(0,i.getConfigurationKeys)(),r=[];for(const t of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,i.toValuesTree)(n[t],l=>console.error(`Conflict in default settings file: ${l}`))});super(n,h,r)}}e.DefaultConfigurationModel=f;class w{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,h){if(!E.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,h)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,h){this._raw=n;const{contents:r,keys:t,overrides:l,restricted:o}=this.doParseRaw(n,h);this._configurationModel=new p(r,t,l),this._restrictedConfigurations=o||[]}doParseContent(n){let h={},r=null,t=[],l=[],o=[];function d(u){Array.isArray(t)?t.push(u):r!==null&&(t[r]=u)}let m={onObjectBegin:()=>{let u={};d(u),l.push(t),t=u,r=null},onObjectProperty:u=>{r=u},onObjectEnd:()=>{t=l.pop()},onArrayBegin:()=>{let u=[];d(u),l.push(t),t=u,r=null},onArrayEnd:()=>{t=l.pop()},onLiteralValue:d,onError:(u,y,T)=>{o.push({error:u,offset:y,length:T})}};if(n)try{D.visit(n,m),h=t[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return h}doParseRaw(n,h){const r=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,r,!0,h);n=t.raw;const l=(0,i.toValuesTree)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),o=Object.keys(n),d=(0,i.toOverrides)(n,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:l,keys:o,overrides:d,restricted:t.restricted}}filter(n,h,r,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const l={},o=[];for(let d in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(d)&&r){const m=this.filter(n[d],h,!1,t);l[d]=m.raw,o.push(...m.restricted)}else{const m=h[d],u=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&o.push(d),(u===void 0||t.scopes===void 0||t.scopes.includes(u))&&(t.skipRestricted&&m?.restricted||(l[d]=n[d]))}return{raw:l,restricted:o}}}e.ConfigurationModelParser=w;class _ extends S.Disposable{constructor(n,h,r,t){super();this.userSettingsResource=n,this.scopes=h,this.fileService=t,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=_;class P{constructor(n,h,r=new p,t=new p,l=new A.ResourceMap,o=new p,d=new A.ResourceMap,m=!0){this._defaultConfiguration=n,this._localUserConfiguration=h,this._remoteUserConfiguration=r,this._workspaceConfiguration=t,this._folderConfigurations=l,this._memoryConfiguration=o,this._memoryConfigurationByResource=d,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,h,r){return this.getConsolidateConfigurationModel(h,r).getValue(n)}updateValue(n,h,r={}){let t;r.resource?(t=this._memoryConfigurationByResource.get(r.resource),t||(t=new p,this._memoryConfigurationByResource.set(r.resource,t))):t=this._memoryConfiguration,h===void 0?t.removeValue(n):t.setValue(n,h),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,h,r){const t=this.getConsolidateConfigurationModel(h,r),l=this.getFolderConfigurationModelForResource(h.resource,r),o=h.resource?this._memoryConfigurationByResource.get(h.resource)||this._memoryConfiguration:this._memoryConfiguration,d=h.overrideIdentifier?this._defaultConfiguration.freeze().override(h.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),m=h.overrideIdentifier?this.userConfiguration.freeze().override(h.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),u=h.overrideIdentifier?this.localUserConfiguration.freeze().override(h.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),y=h.overrideIdentifier?this.remoteUserConfiguration.freeze().override(h.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),T=r?h.overrideIdentifier?this._workspaceConfiguration.freeze().override(h.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,R=l?h.overrideIdentifier?l.freeze().override(h.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,$=h.overrideIdentifier?o.override(h.overrideIdentifier).getValue(n):o.getValue(n),B=t.getValue(n),F=g.distinct(g.flatten(t.overrides.map(W=>W.identifiers))).filter(W=>t.getOverrideValue(n,W)!==void 0);return{defaultValue:d,userValue:m,userLocalValue:u,userRemoteValue:y,workspaceValue:T,workspaceFolderValue:R,memoryValue:$,value:B,default:d!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:h.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:h.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:h.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:h.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:h.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:l?.freeze().getValue(n),override:h.overrideIdentifier?l?.freeze().getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:o.getValue(n),override:h.overrideIdentifier?o.getOverrideValue(n,h.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(n){const h=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:h?h.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,h){this._folderConfigurations.set(n,h),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,h){const r=h.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const l=(0,I.overrideIdentifierFromKey)(t),o=this._defaultConfiguration.getKeysForOverrideIdentifier(l),d=n.getKeysForOverrideIdentifier(l),m=[...d.filter(u=>o.indexOf(u)===-1),...o.filter(u=>d.indexOf(u)===-1),...o.filter(u=>!k.equals(this._defaultConfiguration.override(l).getValue(u),n.override(l).getValue(u)))];return[l,m]});return this.updateDefaultConfiguration(n),{keys:h,overrides:r}}compareAndUpdateLocalUserConfiguration(n){const{added:h,updated:r,removed:t,overrides:l}=(0,i.compare)(this.localUserConfiguration,n),o=[...h,...r,...t];return o.length&&this.updateLocalUserConfiguration(n),{keys:o,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:h,updated:r,removed:t,overrides:l}=(0,i.compare)(this.remoteUserConfiguration,n);let o=[...h,...r,...t];return o.length&&this.updateRemoteUserConfiguration(n),{keys:o,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:h,updated:r,removed:t,overrides:l}=(0,i.compare)(this.workspaceConfiguration,n);let o=[...h,...r,...t];return o.length&&this.updateWorkspaceConfiguration(n),{keys:o,overrides:l}}compareAndUpdateFolderConfiguration(n,h){const r=this.folderConfigurations.get(n),{added:t,updated:l,removed:o,overrides:d}=(0,i.compare)(r,h);let m=[...t,...l,...o];return(m.length||!r)&&this.updateFolderConfiguration(n,h),{keys:m,overrides:d}}compareAndDeleteFolderConfiguration(n){const h=this.folderConfigurations.get(n);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:t,removed:l,overrides:o}=(0,i.compare)(h,void 0);return{keys:[...r,...t,...l],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,h){let r=this.getConsolidatedConfigurationModelForResource(n,h);return n.overrideIdentifier?r.override(n.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:n},h){let r=this.getWorkspaceConsolidatedConfiguration();if(h&&n){const t=h.getFolder(n);t&&(r=this.getFolderConsolidatedConfiguration(t.uri)||r);const l=this._memoryConfigurationByResource.get(n);l&&(r=r.merge(l))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let h=this._foldersConsolidatedConfigurations.get(n);if(!h){const r=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(h=r.merge(t),this._freeze&&(h=h.freeze()),this._foldersConsolidatedConfigurations.set(n,h)):h=r}return h}getFolderConfigurationModelForResource(n,h){if(h&&n){const r=h.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,h)=>{const{contents:r,overrides:t,keys:l}=this._folderConfigurations.get(h);return n.push([h,{contents:r,overrides:t,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(h=>n.add(h)),this.userConfiguration.freeze().keys.forEach(h=>n.add(h)),this._workspaceConfiguration.freeze().keys.forEach(h=>n.add(h)),this._folderConfigurations.forEach(h=>h.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const h=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>h.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>h.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>h.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(t=>h.add(t))),[...h.values()]}static parse(n){const h=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((o,d)=>(o.set(C.URI.revive(d[0]),this.parseConfigurationModel(d[1])),o),new A.ResourceMap);return new P(h,r,new p,t,l,new p,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=P;function b(...v){if(v.length===0)return{keys:[],overrides:[]};if(v.length===1)return v[0];const n=new Set,h=new Map;for(const t of v)t.keys.forEach(l=>n.add(l)),t.overrides.forEach(([l,o])=>{const d=(0,A.getOrSet)(h,l,new Set);o.forEach(m=>d.add(m))});const r=[];return h.forEach((t,l)=>r.push([l,[...t.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=b;class s{constructor(n,h,r,t){this.change=n,this.previous=h,this.currentConfiguraiton=r,this.currentWorkspace=t,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(d=>l.add(d)),n.overrides.forEach(([,d])=>d.forEach(m=>l.add(m))),this.affectedKeys=[...l.values()];const o=new p;this.affectedKeys.forEach(d=>o.setValue(d,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,h){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(h){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,h,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,h,this.currentWorkspace);return!k.equals(r,t)}return!0}return!1}doesAffectedKeysTreeContains(n,h){let r=(0,i.toValuesTree)({[h]:!0},()=>{}),t;for(;typeof r=="object"&&(t=Object.keys(r)[0]);){if(n=n[t],!n)return!1;r=r[t]}return!0}}e.ConfigurationChangeEvent=s;class a extends s{constructor(n,h,r,t){super({keys:n.allKeys(),overrides:[]},void 0,n,h);this.source=r,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=a}),define(fe[119],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(A,k=L.Unknown,E){super(A);this._message=A,this._code=k,this._detail=E,this.isHandled=k===L.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(A){return A instanceof D&&A._code===L.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof D&&A._code===L.NoResolverFound}static isHandled(A){return A instanceof D&&A.isHandled}}e.RemoteAuthorityResolverError=D}),define(fe[63],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=L;function D(C){if(!C)return;const i=C.indexOf("+");return i<0?C:C.substr(0,i)}e.getRemoteName=D;function S(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=S;function A(C){if(C.folders.length)return C.folders.every(i=>S(i.uri))?C.folders[0].uri:void 0;if(C.configuration&&S(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=A;function k(C){return A(C)?.scheme}e.getVirtualWorkspaceScheme=k;function E(C){return A(C)!==void 0}e.isVirtualWorkspace=E}),define(fe[26],me([0,1,8,4,63]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function S(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=S;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class E{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,_){if(typeof w=="undefined"||w===null)return typeof _=="undefined"||_===null;if(typeof _=="undefined"||_===null)return!1;if(typeof w=="string"||typeof _=="string"){let P=typeof w=="string"?w:w.value,b=typeof _=="string"?_:_.value;return g.equalsIgnoreCase(P,b)}return w._lower===_._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=E;function C(f){return Boolean(f.enableProposedApi)}e.isProposedApiEnabled=C;function i(f){if(!C(f))throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.checkProposedApiEnabled=i;function I(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function c(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=c;function p(f,w){if(w&&C(f)){const _=`onResolveRemoteAuthority:${(0,D.getRemoteName)(w)}`;return f.activationEvents?.indexOf(_)!==-1}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,8,26]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(f,w){return f.uuid&&w.uuid?f.uuid===w.uuid:f.id===w.id?!0:(0,g.compareIgnoreCase)(f.id,w.id)===0}e.areSameExtensions=D;class S{constructor(w,_){this.version=_,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof S?D(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=S;function A(f,w){return`${f}.${w}`}e.getExtensionId=A;function k(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function E(f,w){return k(A(f,w))}e.getGalleryExtensionId=E;function C(f,w){const _=[],P=b=>{for(const s of _)if(s.some(a=>D(w(a),w(b))))return s;return null};for(const b of f){const s=P(b);s?s.push(b):_.push([b])}return _}e.groupByExtension=C;function i(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(f){const w=new Set;for(const _ of f)_.malicious&&w.add(_.id.id);return w}e.getMaliciousExtensionsSet=c;function p(f,w){const _=[],P=w.manifest.extensionDependencies?.slice(0)??[];for(;P.length;){const b=P.shift();if(b&&_.every(s=>!D(s.identifier,{id:b}))){const s=f.filter(a=>D(a.identifier,{id:b}));s.length===1&&(_.push(s[0]),P.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return _}e.getExtensionDependencies=p}),define(fe[120],me([0,1,3,12,4,11]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var A;(function(f){f.Http="http",f.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function c(f,w){return w?w!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=c;let p=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,_){return this._tunnelProvider=w,w?(this._canElevate=_.elevation,this._privacyOptions=_.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],_=Array.from(this._tunnels.values());for(let P of _){const b=Array.from(P.values());for(let s of b){const a=await s.value;a&&w.push(a)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:_}of w.values())await _.then(P=>P?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,_,P,b,s=!1,a=k.Private,v){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${_}:${P} on local port ${b}.`),!w)return;_||(_="localhost");const n=this.retainOrCreateTunnel(w,_,P,b,s,a,v);return n?n.then(h=>{if(!h){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(_,P);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(h);return(h.tunnelRemoteHost!==_||h.tunnelRemotePort!==P)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const _=this._tunnels.get(w.tunnelRemoteHost);if(_){const P=_.get(w.tunnelRemotePort);P&&(P.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,P))}}}}async tryDisposeTunnel(w,_,P){if(P.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${_}.`);const b=P.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(_),b}}async closeTunnel(w,_){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${_} `);const P=this._tunnels.get(w);if(P&&P.has(_)){const b=P.get(_);b.refcount=0,await this.tryDisposeTunnel(w,_,b)}}addTunnelToMap(w,_,P){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(_,{refcount:1,value:P})}async removeEmptyTunnelFromMap(w,_){const P=this._tunnels.get(w);P&&(await P.get(_)||P.delete(_),P.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,_){let P=[w];i(w)?(P.push(...e.LOCALHOST_ADDRESSES),P.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&P.push(...e.ALL_INTERFACES_ADDRESSES);const b=P.map(s=>this._tunnels.get(s));for(const s of b){const a=s?.get(_);if(a)return a}}canTunnel(w){return!!C(w)}createWithProvider(w,_,P,b,s,a,v){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${_}:${P} on local port ${b}.`);const h={elevationRequired:s?c(b===void 0?P:b):!1},r={remoteAddress:{host:_,port:P},localAddressPort:b,privacy:a,public:a!==k.Private,protocol:v},t=w.forwardPort(r,h);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(_,P,t),t}};p=Ve([$e(0,S.ILogService)],p),e.AbstractTunnelService=p}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((D,S)=>Y(["vsda"],D,S))}async createNewMessage(D){try{const S=await this.vsda(),A=new S.validator;if(A){const k=String(g._nextId++);return this.validators.set(k,A),{id:k,data:A.createNewMessage(D)}}}catch(S){}return{id:"",data:D}}async validate(D,S){if(!D.id)return!0;const A=this.validators.get(D.id);if(!A)return!1;this.validators.delete(D.id);try{return A.validate(S)==="ok"}catch(k){return!1}}async sign(D){try{const S=await this.vsda(),A=new S.signer;if(A)return A.sign(D)}catch(S){}return D}}e.SignService=g,g._nextId=1}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,S,A=5){let k;return k=S(E=>{const C=typeof E=="string"?E:E.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(D),A);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),k.dispose()}},this._terminalBufferMap.set(D,i)}),k}stopBuffering(D){const S=this._terminalBufferMap.get(D);S&&S.dispose()}flushBuffer(D){const S=this._terminalBufferMap.get(D);S&&(this._terminalBufferMap.delete(D),this._callback(D,S.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[64],me([0,1,47,3,6,4,34,198]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,S.createDecorator)("themeService");var E;(function(_){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}_.isThemeColor=P})(E=e.ThemeColor||(e.ThemeColor={}));function C(_){return{id:_}}e.themeColorFromId=C;var i;(function(_){function P(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color=="undefined"||E.isThemeColor(h.color))}_.isThemeIcon=P;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function s(h){const r=b.exec(h);if(!r)return;let[,t]=r;return{id:t}}_.fromString=s;function a(h,r){let t=h.id;const l=t.lastIndexOf("~");return l!==-1&&(t=t.substring(0,l)),r&&(t=`${t}~${r}`),{id:t}}_.modify=a;function v(h,r){return h.id===r.id&&h.color?.id===r.color?.id}_.isEqual=v;function n(h,r){return{id:h.id,color:r?C(r):void 0}}_.asThemeIcon=n,_.asClassNameArray=g.CSSIcon.asClassNameArray,_.asClassName=g.CSSIcon.asClassName,_.asCSSSelector=g.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(_){switch(_){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,D.toDisposable)(()=>{const b=this.themingParticipants.indexOf(P);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new c;A.Registry.add(e.Extensions.ThemingContribution,p);function f(_){return p.onColorThemeChange(_)}e.registerThemingParticipant=f;class w extends D.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,b){let s=this.theme.getColor(P);return s&&b&&(s=b(s,this.theme)),s?s.toString():null}}e.Themable=w}),define(fe[199],me([0,1,16,47,3,162,117,34,64]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(P,b,s,a){const v=this.iconsById[P];if(v){if(s&&!v.description){v.description=s,this.iconSchema.properties[P].markdownDescription=`${s} $(${P})`;const r=this.iconReferenceSchema.enum.indexOf(P);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=s),this._onDidChange.fire()}return v}let n={id:P,description:s,defaults:b,deprecationMessage:a};this.iconsById[P]=n;let h={$ref:"#/definitions/icons"};return a&&(h.deprecationMessage=a),s&&(h.markdownDescription=`${s}: $(${P})`),this.iconSchema.properties[P]=h,this.iconReferenceSchema.enum.push(P),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:P}}deregisterIcon(P){delete this.iconsById[P],delete this.iconSchema.properties[P];const b=this.iconReferenceSchema.enum.indexOf(P);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(P=>this.iconsById[P])}getIcon(P){return this.iconsById[P]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(P,b){const s=this.iconFontsById[P];if(s)return s;let a={id:P,definition:b};return this.iconFontsById[P]=a,this._onDidChange.fire(),a}deregisterIconFont(P){delete this.iconFontsById[P]}getIconFonts(){return Object.keys(this.iconFontsById).map(P=>this.iconFontsById[P])}getIconFont(P){return this.iconFontsById[P]}toString(){const P=(v,n)=>v.id.localeCompare(n.id),b=v=>{for(;E.ThemeIcon.isThemeIcon(v.defaults);)v=this.iconsById[v.defaults.id];return`codicon codicon-${v?v.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.iconsById).map(v=>this.iconsById[v]);for(const v of a.filter(n=>!!n.description).sort(P))s.push(`|<i class="${b(v)}"></i>|${v.id}|${E.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const v of a.filter(n=>!E.ThemeIcon.isThemeIcon(n.defaults)).sort(P))s.push(`|<i class="${b(v)}"></i>|${v.id}|`);return s.join(`
`)}}const i=new C;k.Registry.add(e.Extensions.IconContribution,i);function I(_,P,b,s){return i.registerIcon(_,P,b,s)}e.registerIcon=I;function c(){return i}e.getIconRegistry=c;function p(){for(const _ of L.iconRegistry.all)i.registerIcon(_.id,_.definition,_.description);L.iconRegistry.onDidRegister(_=>i.registerIcon(_.id,_.definition,_.description))}p(),e.iconsSchemaId="vscode://schemas/icons";let f=k.Registry.as(A.Extensions.JSONContribution);f.registerSchema(e.iconsSchemaId,i.getIconSchema());const w=new g.RunOnceScheduler(()=>f.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,S.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,S.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,S.localize)(4,null)),e.syncing=E.ThemeIcon.modify(L.Codicon.sync,"spin")}),define(fe[43],me([0,1,24,23,2,4]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");var A;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const p=c;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.isWorkspace=k;function E(c){const p=c;return!!(p&&typeof p=="object"&&D.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.isWorkspaceFolder=E;class C{constructor(p,f,w,_,P){this._id=p,this._transient=w,this._configuration=_,this._ignorePathCasing=P,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(p){this._id=p.id,this._configuration=p.configuration,this._transient=p.transient,this._ignorePathCasing=p._ignorePathCasing,this.folders=p.folders}get folders(){return this._folders}set folders(p){this._folders=p,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(p){this._configuration=p}getFolder(p){return p&&this._foldersMap.findSubstr(p.with({scheme:p.scheme,authority:p.authority,path:p.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const p of this.folders)this._foldersMap.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class i{constructor(p,f){this.raw=f,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,L.joinPath)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(c){return new i({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(fe[200],me([0,1,29,60,140,80,10,9,12,23,2,163,4,63,43]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function _(M){return(typeof M=="string"?(0,k.extname)(M):(0,C.extname)(M))===w}e.hasWorkspaceFileExtension=_,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function P(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function s(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=s;function a(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=a;function v(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=v;function n(M){const z=M;return typeof z?.id=="string"&&i.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=n;function h(M){const z=M;if(z?.uri)return{id:z.id,uri:i.URI.revive(z.uri)};const N=M;if(N?.configPath)return{id:N.id,configPath:i.URI.revive(N.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=h;function r(M,z){return C.extUriBiasedIgnorePathCase.isEqualOrParent(M,z.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function t(M){return l(M)||o(M)}e.isStoredWorkspaceFolder=t;function l(M){const z=M;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=l;function o(M){const z=M;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=o;function d(M,z,N,U,x=!E.isWindows,O){if(M.scheme!==U.scheme)return{name:N,uri:M.toString(!0)};let j=z?void 0:O.relativePath(U,M);if(j!==void 0)j.length===0?j=".":E.isWindows&&M.scheme===A.Schemas.file&&!x&&(j=j.replace(/\//g,"\\"));else if(M.scheme===A.Schemas.file)j=M.fsPath,E.isWindows&&(j=(0,S.normalizeDriveLetter)(j),x&&(j=(0,g.toSlashes)(j)));else{if(!O.isEqualAuthority(M.authority,U.authority))return{name:N,uri:M.toString(!0)};j=M.path}return{name:N,path:j}}e.getStoredWorkspaceFolder=d;function m(M,z,N){let U=[],x=new Set;const O=N.dirname(z);for(let j of M){let H;if(l(j))j.path&&(H=N.resolvePath(O,j.path));else if(o(j))try{H=i.URI.parse(j.uri),H.path[0]!=="/"&&(H=H.with({path:"/"+H.path}))}catch(X){console.warn(X)}if(H){let X=N.getComparisonKey(H);if(!x.has(X)){x.add(X);const Q=j.name||N.basenameOrAuthority(H);U.push(new f.WorkspaceFolder({uri:H,name:Q,index:U.length},j))}}}return U}e.toWorkspaceFolders=m;function u(M,z,N,U,x){let O=y(z,M);const j=x.dirname(z),H=x.dirname(U),X=[],Q=T(O.folders);for(const Pe of O.folders){const We=l(Pe)?x.resolvePath(j,Pe.path):i.URI.parse(Pe.uri);let Be;N?Be=!1:Be=!l(Pe)||(0,k.isAbsolute)(Pe.path),X.push(d(We,Be,Pe.name,H,Q,x))}const de={insertSpaces:!1,tabSize:4,eol:E.isLinux||E.isMacintosh?`
`:`\r
`},_e=D.setProperty(M,["folders"],X,de);let Ie=D.applyEdits(M,_e);return(0,C.isEqualAuthority)(O.remoteAuthority,(0,p.getRemoteAuthority)(U))&&(Ie=D.applyEdits(Ie,D.removeProperty(Ie,["remoteAuthority"],de))),Ie}e.rewriteWorkspaceFileForNewLocation=u;function y(M,z){let N=L.parse(z);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>t(U));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function T(M){return E.isWindows?M.some(z=>l(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function $(M){return typeof M.folderUri=="string"}function B(M){return typeof M.fileUri=="string"}function F(M,z){const N={workspaces:[],files:[]};if(M){const U=function(O,j){for(let H=0;H<O.length;H++)try{j(O[H],H)}catch(X){z.warn(`Error restoring recent entry ${JSON.stringify(O[H])}: ${X.toString()}. Skip entry.`)}},x=M;if(Array.isArray(x.entries))U(x.entries,O=>{const j=O.label,H=O.remoteAuthority;R(O)?N.workspaces.push({label:j,remoteAuthority:H,workspace:{id:O.workspace.id,configPath:i.URI.parse(O.workspace.configPath)}}):$(O)?N.workspaces.push({label:j,remoteAuthority:H,folderUri:i.URI.parse(O.folderUri)}):B(O)&&N.files.push({label:j,remoteAuthority:H,fileUri:i.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&U(O.workspaces3,(j,H)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[H]||void 0;typeof j=="object"&&typeof j.id=="string"&&typeof j.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:j.id,configPath:i.URI.parse(j.configURIPath)}}):typeof j=="string"&&N.workspaces.push({label:X,folderUri:i.URI.parse(j)})}),Array.isArray(O.files2)&&U(O.files2,(j,H)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[H]||void 0;typeof j=="string"&&N.files.push({label:X,fileUri:i.URI.parse(j)})})}}return N}e.restoreRecentlyOpened=F;function W(M){const z={entries:[]};for(const N of M.workspaces)b(N)?z.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):z.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)z.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return z}e.toStoreData=W}),define(fe[87],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const S=this._idPool++;return this._data.set(S,D),this.logDebugInfo(),S}get(D,S){return this._data.has(D)?this._data.get(D)[S]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[44],me([0,1,10,23,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const E=this._providerInfo.get(k.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(k,E){E===null?this._providerInfo.delete(k):this._providerInfo.set(k,E)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=(0,D.createDecorator)("IExtHostFileSystemInfo")}),define(fe[27],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,11,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let D=class extends g.LogService{constructor(A,k){super(A.createLogger(k.logFile))}};D=Ve([$e(0,g.ILoggerService),$e(1,L.IExtHostInitDataService)],D),e.ExtHostLogService=D}),define(fe[202],me([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(A,k,E){this._deferredPromises=new Map,this._id=A,this._shared=k,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this._init}get(A,k){let E=this._value[A];return typeof E=="undefined"&&(E=k),E}update(A,k){this._value[A]=k;let E=this._deferredPromises.get(A);if(E!==void 0)return E.p;const C=new g.DeferredPromise;return this._deferredPromises.set(A,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class D extends L{constructor(A,k){super(A.identifier.value,!0,k);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=D}),define(fe[203],me([0,1,3,2,11]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(k,E){this._logService=k,this._notebooksAndEditors=E,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,E,C){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(E.value,C)}$acceptDirtyStateChanged(k,E){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(E)}$acceptModelSaved(k){const E=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(E.apiNotebook)}$acceptDocumentPropertiesChanged(k,E){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,E);const C=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));C.acceptDocumentPropertiesChanged(E),E.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};S=Ve([$e(0,D.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[204],me([0,1,26,3]),function(Y,e,g,L){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(k,E){D.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(k.identifier),st(this,D,E,"f"),Oe(this,D,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(k){return Oe(this,D,"f").get(this._id,k)}store(k,E){return Oe(this,D,"f").store(this._id,k,E)}delete(k){return Oe(this,D,"f").delete(this._id,k)}}e.ExtensionSecrets=S,D=new WeakMap}),define(fe[121],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[65],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,D=(b,s)=>{const a={controllerId:s};return L.set(b,a),a};e.createPrivateApiFor=D;const S=b=>L.get(b);e.getPrivateApiFor=S;const A=(b,s,a,v)=>{let n=a;return{enumerable:!0,configurable:!1,get(){return n},set(h){if(!v(n,h)){const r=n;n=h,b.listener?.({op:3,key:s,value:h,previous:r})}}}},k=(b,s)=>b===s,E={range:(b,s)=>b===s?!0:!b||!s?!1:b.isEqual(s),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(b,s)=>!(b.length!==s.length||b.some(a=>!s.find(v=>a.id===v.id)))},C=Object.keys(E),i=(b,s)=>({range:A(b,"range",void 0,E.range),label:A(b,"label",s,E.label),description:A(b,"description",void 0,E.description),canResolveChildren:A(b,"canResolveChildren",!1,E.canResolveChildren),busy:A(b,"busy",!1,E.busy),error:A(b,"error",void 0,E.error),tags:A(b,"tags",[],E.tags)}),I=(b,s)=>{const a=new Map;for(const v of C)E[v](b[v],s[v])||a.set(v,s[v]);return a};e.diffTestItems=I;class c extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=c;class p extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class f extends Error{constructor(s,a,v){super(`TestItem with ID "${s}" is from controller "${a}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=f;const w=b=>{const s=(0,e.getPrivateApiFor)(b);let a=new Map;return{get size(){return a.size},forEach(v,n){for(const h of a.values())v.call(n,h,this)},replace(v){const n=new Map,h=new Set(a.keys()),r={op:4,ops:[]};for(const t of v){if(!(t instanceof _))throw new p(t.id);const l=(0,e.getPrivateApiFor)(t).controllerId;if(l!==s.controllerId)throw new f(t.id,l,s.controllerId);if(n.has(t.id))throw new c(t.id);n.set(t.id,t),h.delete(t.id),r.ops.push({op:0,item:t})}for(const t of h.keys())r.ops.push({op:1,id:t});s.listener?.(r),a=n},add(v){if(!(v instanceof _))throw new p(v.id);a.set(v.id,v),s.listener?.({op:0,item:v})},delete(v){a.delete(v)&&s.listener?.({op:1,id:v})},get(v){return a.get(v)},toJSON(){return Array.from(a.values())},[Symbol.iterator](){return a.values()}}};class _{constructor(s,a,v,n){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const h=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:n,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof P?void 0:h.parent}},children:{value:w(this),enumerable:!0,writable:!1},...i(h,v)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=_;class P extends _{constructor(s,a){super(s,s,a,void 0)}}e.TestItemRootImpl=P}),define(fe[53],me([0,1,4,120,3,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(E){function C(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}E.fromApiTunnel=C;function i(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}E.fromServiceTunnel=i})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(C){this.onDidChangeTunnels=new D.Emitter().event}async $applyCandidateFilter(C){return C}async openTunnel(C,i){}async getTunnels(){return[]}async setTunnelExtensionFunctions(C){return{dispose:()=>{}}}registerPortsAttributesProvider(C,i){return{dispose:()=>{}}}async $providePortAttributes(C,i,I,c,p){return[]}async $forwardPort(C,i){}async $closeTunnel(C){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([$e(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,15,18,97,24,101,8,13,2,31,42,119]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";var p,f,w,_,P,b,s,a,v,n,h,r,t,l,o,d,m,u,y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function V(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(V,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(V,q),Object.setPrototypeOf(V.prototype,q.prototype),V}let $=P=class{constructor(V){p.set(this,void 0),st(this,p,V,"f")}static from(...V){let oe=V;return new P(function(){if(oe){for(const Ce of oe)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();oe=void 0}})}dispose(){typeof Oe(this,p,"f")=="function"&&(Oe(this,p,"f").call(this),st(this,p,void 0,"f"))}};p=new WeakMap,$=P=Ve([R],$),e.Disposable=$;let B=b=class{constructor(V,oe){if(V<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=V,this._character=oe}static Min(...V){if(V.length===0)throw new TypeError;let oe=V[0];for(let Ce=1;Ce<V.length;Ce++){const Je=V[Ce];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...V){if(V.length===0)throw new TypeError;let oe=V[0];for(let Ce=1;Ce<V.length;Ce++){const Je=V[Ce];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(V){if(!V)return!1;if(V instanceof b)return!0;let{line:oe,character:Ce}=V;return typeof oe=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<V._character}isBeforeOrEqual(V){return this._line<V._line?!0:V._line<this._line?!1:this._character<=V._character}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this._line===V._line&&this._character===V._character}compareTo(V){return this._line<V._line?-1:this._line>V.line?1:this._character<V._character?-1:this._character>V._character?1:0}translate(V,oe=0){if(V===null||oe===null)throw(0,L.illegalArgument)();let Ce;return typeof V=="undefined"?Ce=0:typeof V=="number"?Ce=V:(Ce=typeof V.lineDelta=="number"?V.lineDelta:0,oe=typeof V.characterDelta=="number"?V.characterDelta:0),Ce===0&&oe===0?this:new b(this.line+Ce,this.character+oe)}with(V,oe=this.character){if(V===null||oe===null)throw(0,L.illegalArgument)();let Ce;return typeof V=="undefined"?Ce=this.line:typeof V=="number"?Ce=V:(Ce=typeof V.line=="number"?V.line:this.line,oe=typeof V.character=="number"?V.character:this.character),Ce===this.line&&oe===this.character?this:new b(Ce,oe)}toJSON(){return{line:this.line,character:this.character}}};B=b=Ve([R],B),e.Position=B;let F=s=class{constructor(V,oe,Ce,Je){let ot,ht;if(typeof V=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Je=="number"?(ot=new B(V,oe),ht=new B(Ce,Je)):V instanceof B&&oe instanceof B&&(ot=V,ht=oe),!ot||!ht)throw new Error("Invalid arguments");ot.isBefore(ht)?(this._start=ot,this._end=ht):(this._start=ht,this._end=ot)}static isRange(V){return V instanceof s?!0:V?B.isPosition(V.start)&&B.isPosition(V.end):!1}get start(){return this._start}get end(){return this._end}contains(V){return V instanceof s?this.contains(V._start)&&this.contains(V._end):V instanceof B?!(V.isBefore(this._start)||this._end.isBefore(V)):!1}isEqual(V){return this._start.isEqual(V._start)&&this._end.isEqual(V._end)}intersection(V){const oe=B.Max(V.start,this._start),Ce=B.Min(V.end,this._end);if(!oe.isAfter(Ce))return new s(oe,Ce)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const oe=B.Min(V.start,this._start),Ce=B.Max(V.end,this.end);return new s(oe,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(V,oe=this.end){if(V===null||oe===null)throw(0,L.illegalArgument)();let Ce;return V?B.isPosition(V)?Ce=V:(Ce=V.start||this.start,oe=V.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&oe.isEqual(this.end)?this:new s(Ce,oe)}toJSON(){return[this.start,this.end]}};F=s=Ve([R],F),e.Range=F;let W=a=class extends F{constructor(V,oe,Ce,Je){let ot,ht;if(typeof V=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Je=="number"?(ot=new B(V,oe),ht=new B(Ce,Je)):V instanceof B&&oe instanceof B&&(ot=V,ht=oe),!ot||!ht)throw new Error("Invalid arguments");super(ot,ht);this._anchor=ot,this._active=ht}static isSelection(V){return V instanceof a?!0:V?F.isRange(V)&&B.isPosition(V.anchor)&&B.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=a=Ve([R],W),e.Selection=W;class M{constructor(V,oe,Ce){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,L.illegalArgument)("connectionToken");this.host=V,this.port=Math.round(oe),this.connectionToken=Ce}}e.ResolvedAuthority=M;class z extends Error{constructor(V,oe=c.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(V);this._message=V,this._code=oe,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,z.prototype)}static NotAvailable(V,oe){return new z(V,c.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(V){return new z(V,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=z;var N;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var U;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let x=v=class{constructor(V,oe){this._range=V,this._newText=oe}static isTextEdit(V){return V instanceof v?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,oe){return new v(V,oe)}static insert(V,oe){return v.replace(new F(V,V),oe)}static delete(V){return v.replace(V,"")}static setEndOfLine(V){const oe=new v(new F(new B(0,0),new B(0,0)),"");return oe.newEol=V,oe}get range(){return this._range}set range(V){if(V&&!F.isRange(V))throw(0,L.illegalArgument)("range");this._range=V}get newText(){return this._newText||""}set newText(V){if(V&&typeof V!="string")throw(0,L.illegalArgument)("newText");this._newText=V}get newEol(){return this._newEol}set newEol(V){if(V&&typeof V!="number")throw(0,L.illegalArgument)("newEol");this._newEol=V}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};x=v=Ve([R],x),e.TextEdit=x;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let j=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(V,oe,Ce,Je){this._edits.push({_type:1,from:V,to:oe,options:Ce,metadata:Je})}createFile(V,oe,Ce){this._edits.push({_type:1,from:void 0,to:V,options:oe,metadata:Ce})}deleteFile(V,oe,Ce){this._edits.push({_type:1,from:V,to:void 0,options:oe,metadata:Ce})}replaceNotebookMetadata(V,oe,Ce){this._edits.push({_type:3,metadata:Ce,uri:V,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(V,oe,Ce,Je,ot){let ht,pt,It=[],Rt;if(Vt.isNotebookRange(oe)&&Mt.isNotebookCellDataArray(Ce)&&!Mt.isNotebookCellDataArray(Je)?(ht=oe.start,pt=oe.end,It=Ce,Rt=Je):typeof oe=="number"&&typeof Ce=="number"&&Mt.isNotebookCellDataArray(Je)&&(ht=oe,pt=Ce,It=Je,Rt=ot),ht===void 0||pt===void 0)throw new Error("Invalid arguments");(ht!==pt||It.length>0)&&this._edits.push({_type:5,uri:V,index:ht,count:pt-ht,cells:It,metadata:Rt})}replaceNotebookCellMetadata(V,oe,Ce,Je){this._edits.push({_type:3,metadata:Je,uri:V,edit:{editType:8,index:oe,metadata:Ce}})}replace(V,oe,Ce,Je){this._edits.push({_type:2,uri:V,edit:new x(oe,Ce),metadata:Je})}insert(V,oe,Ce,Je){this.replace(V,new F(oe,oe),Ce,Je)}delete(V,oe,Ce){this.replace(V,oe,"",Ce)}has(V){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===V.toString())}set(V,oe){if(oe)for(const Ce of oe)Ce&&this._edits.push({_type:2,uri:V,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Je=this._edits[Ce];Je._type===2&&Je.uri.toString()===V.toString()&&(this._edits[Ce]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(V){const oe=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===V.toString()&&oe.push(Ce.edit);return oe}entries(){const V=new S.ResourceMap;for(let oe of this._edits)if(oe._type===2){let Ce=V.get(oe.uri);Ce||(Ce=[oe.uri,[]],V.set(oe.uri,Ce)),Ce[1].push(oe.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};j=Ve([R],j),e.WorkspaceEdit=j;let H=n=class{constructor(V){this._tabstop=1,this.value=V||""}static isSnippetString(V){return V instanceof n?!0:V?typeof V.value=="string":!1}static _escape(V){return V.replace(/\$|}|\\/g,"\\$&")}appendText(V){return this.value+=n._escape(V),this}appendTabstop(V=this._tabstop++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,oe=this._tabstop++){if(typeof V=="function"){const Ce=new n;Ce._tabstop=this._tabstop,V(Ce),this._tabstop=Ce._tabstop,V=Ce.value}else V=n._escape(V);return this.value+="${",this.value+=oe,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,oe=this._tabstop++){const Ce=V.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(V,oe){if(typeof oe=="function"){const Ce=new n;Ce._tabstop=this._tabstop,oe(Ce),this._tabstop=Ce._tabstop,oe=Ce.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};H=n=Ve([R],H),e.SnippetString=H;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=h=class{constructor(V,oe){if(this.uri=V,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof B)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(V){return V instanceof h?!0:V?F.isRange(V.range)&&C.URI.isUri(V.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=h=Ve([R],de),e.Location=de;let _e=class{constructor(V,oe){this.location=V,this.message=oe}static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&C.URI.isUri(V.location.uri):!1}static isEqual(V,oe){return V===oe?!0:!V||!oe?!1:V.message===oe.message&&V.location.range.isEqual(oe.location.range)&&V.location.uri.toString()===oe.location.uri.toString()}};_e=Ve([R],_e),e.DiagnosticRelatedInformation=_e;let Ie=class{constructor(V,oe,Ce=Q.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=V,this.message=oe,this.severity=Ce}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,oe){return V===oe?!0:!V||!oe?!1:V.message===oe.message&&V.severity===oe.severity&&V.code===oe.code&&V.severity===oe.severity&&V.source===oe.source&&V.range.isEqual(oe.range)&&(0,g.equals)(V.tags,oe.tags)&&(0,g.equals)(V.relatedInformation,oe.relatedInformation,_e.isEqual)}};Ie=Ve([R],Ie),e.Diagnostic=Ie;let Pe=class{constructor(V,oe){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=oe}};Pe=Ve([R],Pe),e.Hover=Pe;var We;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(We=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Be=class{constructor(V,oe=We.Text){this.range=V,this.kind=oe}toJSON(){return{range:this.range,kind:We[this.kind]}}};Be=Ve([R],Be),e.DocumentHighlight=Be;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=r=class{constructor(V,oe,Ce,Je,ot){this.name=V,this.kind=oe,this.containerName=ot,typeof Ce=="string"&&(this.containerName=Ce),Je instanceof de?this.location=Je:Ce instanceof F&&(this.location=new de(Je,Ce)),r.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=r=Ve([R],ee),e.SymbolInformation=ee;let ie=t=class{constructor(V,oe,Ce,Je,ot){this.name=V,this.detail=oe,this.kind=Ce,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children&&V.children.forEach(t.validate)}};ie=t=Ve([R],ie),e.DocumentSymbol=ie;var ce;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(ce=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(V,oe){this.title=V,this.kind=oe}};Z=Ve([R],Z),e.CodeAction=Z;let re=l=class{constructor(V){this.value=V}append(V){return new l(this.value?this.value+l.sep+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+l.sep)}};re.sep=".",re=l=Ve([R],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(V,oe){if(this.range=V,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(V,oe,Ce,Je,ot,ht){this.kind=V,this.name=oe,this.detail=Ce,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.CallHierarchyItem=Me;class je{constructor(V,oe){this.fromRanges=oe,this.from=V}}e.CallHierarchyIncomingCall=je;class Ke{constructor(V,oe){this.fromRanges=oe,this.to=V}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(V,oe){this.range=V,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let ct=o=class{constructor(V,oe=!1){f.set(this,void 0),st(this,f,new D.MarkdownString(V,{supportThemeIcons:oe}),"f")}static isMarkdownString(V){return V instanceof o?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}get value(){return Oe(this,f,"f").value}set value(V){Oe(this,f,"f").value=V}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(V){Oe(this,f,"f").isTrusted=V}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(V){Oe(this,f,"f").supportThemeIcons=V}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(V){Oe(this,f,"f").supportHtml=V}appendText(V){return Oe(this,f,"f").appendText(V),this}appendMarkdown(V){return Oe(this,f,"f").appendMarkdown(V),this}appendCodeblock(V,oe){return Oe(this,f,"f").appendCodeblock(oe??"",V),this}};f=new WeakMap,ct=o=Ve([R],ct),e.MarkdownString=ct;let ye=class{constructor(V,oe){this.label=V,this.documentation=oe}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(V,oe){this.label=V,this.documentation=oe,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ne;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ee;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(Ee=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(V,oe,Ce){this.text=V,this.position=oe,this.kind=Ce}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var le;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(le=e.CompletionItemKind||(e.CompletionItemKind={}));var ke;(function(q){q[q.Deprecated=1]="Deprecated"})(ke=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(V,oe){this.label=V,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Ve([R],Ne),e.CompletionItem=Ne;let Xe=class{constructor(V=[],oe=!1){this.items=V,this.isIncomplete=oe}};Xe=Ve([R],Xe),e.CompletionList=Xe;let nt=class{constructor(V,oe,Ce){this.text=V,this.range=oe,this.command=Ce}};nt=Ve([R],nt),e.InlineSuggestion=nt;let ft=class{constructor(V){this.items=V}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var De;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(De=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var we;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(we=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function V(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=V}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ve=class{constructor(V,oe){if(oe&&!C.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.target=oe}};ve=Ve([R],ve),e.DocumentLink=ve;let Fe=class{constructor(V,oe,Ce,Je){this.red=V,this.green=oe,this.blue=Ce,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let qe=class{constructor(V,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(V)||V.isEmpty)throw(0,L.illegalArgument)("range");this.range=V,this.color=oe}};qe=Ve([R],qe),e.ColorInformation=qe;let ze=class{constructor(V){if(!V||typeof V!="string")throw(0,L.illegalArgument)("label");this.label=V}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var lt;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(lt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(V,oe,Ce){if(this.startIndex=V,this.length=oe,this.tooltip=Ce,typeof V!="number"||V<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class be{constructor(V){this.options=V,typeof V!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=be;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Se=d=class{constructor(V,oe){if(this.label=oe,typeof V!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=V}static from(V){switch(V){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}get id(){return this._id}};Se.Clean=new d("clean","Clean"),Se.Build=new d("build","Build"),Se.Rebuild=new d("rebuild","Rebuild"),Se.Test=new d("test","Test"),Se=d=Ve([R],Se),e.TaskGroup=Se;function Le(q){let V="";for(let oe=0;oe<q.length;oe++)V+=q[oe].replace(/,/g,",,")+",";return V}let it=class{constructor(V,oe,Ce){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=V,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=Ce):this._options=oe)}get process(){return this._process}set process(V){if(typeof V!="string")throw(0,L.illegalArgument)("process");this._process=V}get args(){return this._args}set args(V){Array.isArray(V)||(V=[]),this._args=V}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("process"),this._process!==void 0&&V.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)V.push(oe);return Le(V)}};it=Ve([R],it),e.ProcessExecution=it;let Ge=class{constructor(V,oe,Ce){if(this._args=[],Array.isArray(oe)){if(!V)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V,this._args=oe,this._options=Ce}else{if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(V){if(typeof V!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=V}get command(){return this._command?this._command:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,L.illegalArgument)("command");this._command=V}get args(){return this._args}set args(V){this._args=V||[]}get options(){return this._options}set options(V){this._options=V}computeId(){const V=[];if(V.push("shell"),this._commandLine!==void 0&&V.push(this._commandLine),this._command!==void 0&&V.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)V.push(typeof oe=="string"?oe:oe.value);return Le(V)}};Ge=Ve([R],Ge),e.ShellExecution=Ge;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var yt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(yt=e.TaskScope||(e.TaskScope={}));class Et{constructor(V){this._callback=V}computeId(){return"customExecution"+(0,i.generateUuid)()}set callback(V){this._callback=V}get callback(){return this._callback}}e.CustomExecution=Et;let gt=m=class{constructor(V,oe,Ce,Je,ot,ht){this.__deprecated=!1,this._definition=this.definition=V;let pt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=Ce,this.execution=Je,pt=ot,this.__deprecated=!0):oe===yt.Global||oe===yt.Workspace?(this.target=oe,this._name=this.name=Ce,this._source=this.source=Je,this.execution=ot,pt=ht):(this.target=oe,this._name=this.name=Ce,this._source=this.source=Je,this.execution=ot,pt=ht),typeof pt=="string"?(this._problemMatchers=[pt],this._hasDefinedMatchers=!0):Array.isArray(pt)?(this._problemMatchers=pt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(V){this.__id=V}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,i.generateUuid)()}}get definition(){return this._definition}set definition(V){if(V==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=V}get scope(){return this._scope}set target(V){this.clear(),this._scope=V}get name(){return this._name}set name(V){if(typeof V!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=V}get execution(){return this._execution}set execution(V){V===null&&(V=void 0),this.clear(),this._execution=V;const oe=this._definition.type;(m.EmptyType===oe||m.ProcessType===oe||m.ShellType===oe||m.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(V){if(Array.isArray(V))this.clear(),this._problemMatchers=V,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.clear(),this._isBackground=V}get source(){return this._source}set source(V){if(typeof V!="string"||V.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=V}get group(){return this._group}set group(V){V===null&&(V=void 0),this.clear(),this._group=V}get detail(){return this._detail}set detail(V){V===null&&(V=void 0),this._detail=V}get presentationOptions(){return this._presentationOptions}set presentationOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._presentationOptions=V}get runOptions(){return this._runOptions}set runOptions(V){V==null&&(V=Object.create(null)),this.clear(),this._runOptions=V}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=m=Ve([R],gt),e.Task=gt;var bt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(V,oe=Tt.None){this.collapsibleState=oe,C.URI.isUri(V)?this.resourceUri=V:this.label=V}};vt=Ve([R],vt),e.TreeItem=vt;var Tt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Dt=class{constructor(V,oe){this.id=V,this.color=oe}};Dt=Ve([R],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let $t=class{constructor(V){this.id=V}};$t=Ve([R],$t),e.ThemeColor=$t;var jt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(V,oe){if(typeof V!="string"&&(!V||!C.URI.isUri(V)&&!C.URI.isUri(V.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof V=="string"?(this.baseFolder=C.URI.file(V),this.base=V):C.URI.isUri(V)?(this.baseFolder=V,this.base=V.fsPath):(this.baseFolder=V.uri,this.base=V.uri.fsPath),this.pattern=oe}};kt=Ve([R],kt),e.RelativePattern=kt;let Wt=class{constructor(V,oe,Ce,Je){this.enabled=typeof V=="boolean"?V:!0,typeof oe=="string"&&(this.condition=oe),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,i.generateUuid)()),this._id}};Wt=Ve([R],Wt),e.Breakpoint=Wt;let ii=class extends Wt{constructor(V,oe,Ce,Je,ot){super(oe,Ce,Je,ot);if(V===null)throw(0,L.illegalArgument)("location");this.location=V}};ii=Ve([R],ii),e.SourceBreakpoint=ii;let _t=class extends Wt{constructor(V,oe,Ce,Je,ot){super(oe,Ce,Je,ot);this.functionName=V}};_t=Ve([R],_t),e.FunctionBreakpoint=_t;let Xt=class extends Wt{constructor(V,oe,Ce,Je,ot,ht,pt){super(Je,ot,ht,pt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=V,this.dataId=oe,this.canPersist=Ce}};Xt=Ve([R],Xt),e.DataBreakpoint=Xt;let qt=class{constructor(V,oe,Ce){this.command=V,this.args=oe||[],this.options=Ce}};qt=Ve([R],qt),e.DebugAdapterExecutable=qt;let ni=class{constructor(V,oe){this.port=V,this.host=oe}};ni=Ve([R],ni),e.DebugAdapterServer=ni;let ri=class{constructor(V){this.path=V}};ri=Ve([R],ri),e.DebugAdapterNamedPipeServer=ri;let At=class{constructor(V){this.implementation=V}};At=Ve([R],At),e.DebugAdapterInlineImplementation=At;let Yt=class{constructor(V,oe){this.range=V,this.expression=oe}};Yt=Ve([R],Yt),e.EvaluatableExpression=Yt;var bi;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(V,oe){this.range=V,this.text=oe}};Ht=Ve([R],Ht),e.InlineValueText=Ht;let zt=class{constructor(V,oe,Ce=!0){this.range=V,this.variableName=oe,this.caseSensitiveLookup=Ce}};zt=Ve([R],zt),e.InlineValueVariableLookup=zt;let wt=class{constructor(V,oe){this.range=V,this.expression=oe}};wt=Ve([R],wt),e.InlineValueEvaluatableExpression=wt;let si=class{constructor(V,oe){this.frameId=V,this.stoppedLocation=oe}};si=Ve([R],si),e.InlineValueContext=si;var Nt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=u=class extends Error{constructor(V,oe=I.FileSystemProviderErrorCode.Unknown,Ce){super(C.URI.isUri(V)?V.toString(!0):V);this.code=Ce?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(V){return new u(V,I.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(V){return new u(V,I.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(V){return new u(V,I.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(V){return new u(V,I.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(V){return new u(V,I.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}};Ut=u=Ve([R],Ut),e.FileSystemError=Ut;let Jt=class{constructor(V,oe,Ce){this.start=V,this.end=oe,this.kind=Ce}};Jt=Ve([R],Jt),e.FoldingRange=Jt;var Ei;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(V,oe=[]){this.tokenTypes=V,this.tokenModifiers=oe}}e.SemanticTokensLegend=mi;function Zt(q){return typeof q=="undefined"||(0,E.isStringArray)(q)}class oi{constructor(V){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,V){this._hasLegend=!0;for(let oe=0,Ce=V.tokenTypes.length;oe<Ce;oe++)this._tokenTypeStrToInt.set(V.tokenTypes[oe],oe);for(let oe=0,Ce=V.tokenModifiers.length;oe<Ce;oe++)this._tokenModifierStrToInt.set(V.tokenModifiers[oe],oe)}}push(V,oe,Ce,Je,ot){if(typeof V=="number"&&typeof oe=="number"&&typeof Ce=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(V,oe,Ce,Je,ot);if(F.isRange(V)&&typeof oe=="string"&&Zt(Ce))return this._push(V,oe,Ce);throw(0,L.illegalArgument)()}_push(V,oe,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=V.start.line,ot=V.start.character,ht=V.end.character-V.start.character,pt=this._tokenTypeStrToInt.get(oe);let It=0;if(Ce)for(const Rt of Ce){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(Rt);It|=1<<Ft>>>0}this._pushEncoded(Je,ot,ht,pt,It)}_pushEncoded(V,oe,Ce,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(V<this._prevLine||V===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Rt=0,Ft=0;for(let Ot=0;Ot<It;Ot++){let xt=this._data[5*Ot],di=this._data[5*Ot+1];xt===0?(xt=Rt,di+=Ft):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=di,Rt=xt,Ft=di}}let ht=V,pt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(pt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=pt,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=V,this._prevChar=oe}static _sortAndDeltaEncode(V){let oe=[];const Ce=V.length/5|0;for(let pt=0;pt<Ce;pt++)oe[pt]=pt;oe.sort((pt,It)=>{const Rt=V[5*pt],Ft=V[5*It];if(Rt===Ft){const Ot=V[5*pt+1],xt=V[5*It+1];return Ot-xt}return Rt-Ft});const Je=new Uint32Array(V.length);let ot=0,ht=0;for(let pt=0;pt<Ce;pt++){const It=5*oe[pt],Rt=V[It+0],Ft=V[It+1],Ot=V[It+2],xt=V[It+3],di=V[It+4],xi=Rt-ot,Gi=xi===0?Ft-ht:Ft,hi=5*pt;Je[hi+0]=xi,Je[hi+1]=Gi,Je[hi+2]=Ot,Je[hi+3]=xt,Je[hi+4]=di,ot=Rt,ht=Ft}return Je}build(V){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),V):new Gt(oi._sortAndDeltaEncode(this._data),V)}}e.SemanticTokensBuilder=oi;class Gt{constructor(V,oe){this.resultId=oe,this.data=V}}e.SemanticTokens=Gt;class ai{constructor(V,oe,Ce){this.start=V,this.deleteCount=oe,this.data=Ce}}e.SemanticTokensEdit=ai;class Si{constructor(V,oe){this.resultId=oe,this.edits=V}}e.SemanticTokensEdits=Si;var yi;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(yi=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new Dt("arrow-left")},ei=Ve([R],ei),e.QuickInputButtons=ei;var Di;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(V,oe,Ce){this.badge=V,this.tooltip=oe,this.color=Ce}static validate(V){if(V.badge){let oe=(0,k.nextCharLength)(V.badge,0);if(oe<V.badge.length&&(oe+=(0,k.nextCharLength)(V.badge,oe)),V.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let li=class{constructor(V){this.kind=V}};li=Ve([R],li),e.ColorTheme=li;var ci;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(ci=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(V,oe){if(V<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");V<=oe?(this._start=V,this._end=oe):(this._start=oe,this._end=V)}static isNotebookRange(V){return V instanceof Vt?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(V){let oe=this._start,Ce=this._end;return V.start!==void 0&&(oe=V.start),V.end!==void 0&&(Ce=V.end),oe===this._start&&Ce===this._end?this:new Vt(oe,Ce)}}e.NotebookRange=Vt;class Mt{constructor(V,oe,Ce,Je,ot,ht,pt){this.kind=V,this.value=oe,this.languageId=Ce,this.mime=Je,this.outputs=ot??[],this.metadata=ht,this.executionSummary=pt,Mt.validate(this)}static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(oe=>Mt.isNotebookCellData(oe))}static isNotebookCellData(V){return!0}}e.NotebookCellData=Mt;class Ue{constructor(V){this.cells=V}}e.NotebookData=Ue;class Lt{constructor(V,oe){this.data=V,this.mime=oe;const Ce=(0,A.normalizeMimeType)(oe,!0);if(!Ce)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(V){return V instanceof Lt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const oe={name:V.name,message:V.message,stack:V.stack};return Lt.json(oe,"application/vnd.code.notebook.error")}static stdout(V){return Lt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Lt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,oe="application/octet-stream"){return new Lt(V,oe)}static text(V,oe=A.Mimes.text){const Ce=Oe(Lt,w,"f",_).encode(String(V));return new Lt(Ce,oe)}static json(V,oe="application/json"){const Ce=JSON.stringify(V,void 0,"	");return Lt.text(Ce,oe)}}e.NotebookCellOutputItem=Lt,w=Lt,_={value:new TextEncoder};class Qt{constructor(V,oe,Ce){this.items=Qt.ensureUniqueMimeTypes(V,!0),typeof oe=="string"?(this.id=oe,this.metadata=Ce):(this.id=(0,i.generateUuid)(),this.metadata=oe??Ce)}static isNotebookCellOutput(V){return V instanceof Qt?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&(0,E.isArray)(V.items)}static ensureUniqueMimeTypes(V,oe=!1){const Ce=new Set,Je=new Set;for(let ot=0;ot<V.length;ot++){const ht=V[ot],pt=(0,A.normalizeMimeType)(ht.mime);if(!Ce.has(pt)){Ce.add(pt);continue}Je.add(ot),oe&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?V:V.filter((ot,ht)=>!Je.has(ht))}}e.NotebookCellOutput=Qt;var St;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(St=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ii;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Ii=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(V,oe){this.text=V,this.alignment=oe}}e.NotebookCellStatusBarItem=pi;var Pi;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(V,oe=[]){this.uri=V,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=Ti;let ui=class{constructor(V,oe){this.label=V,this.timestamp=oe}};ui=Ve([R],ui),e.TimelineItem=ui;var Ai;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var vi;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(vi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(V,oe){this.ranges=V,this.wordPattern=oe}}e.LinkedEditingRanges=Li;class Fi{constructor(V,oe){this._port=V,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Oi;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(Oi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let te=class{constructor(V=void 0,oe=void 0,Ce=void 0){this.include=V,this.exclude=oe,this.profile=Ce}};te=Ve([R],te),e.TestRunRequest=te;let he=y=class{constructor(V){this.message=V}static diff(V,oe,Ce){const Je=new y(V);return Je.expectedOutput=oe,Je.actualOutput=Ce,Je}};he=y=Ve([R],he),e.TestMessage=he;let Ae=class{constructor(V){this.id=V}};Ae=Ve([R],Ae),e.TestTag=Ae;let dt=class{constructor(V,oe){this.covered=V,this.total=oe}};dt=Ve([R],dt),e.CoveredCount=dt;let Ct=T=class{constructor(V,oe,Ce,Je){this.uri=V,this.statementCoverage=oe,this.branchCoverage=Ce,this.functionCoverage=Je}static fromDetails(V,oe){const Ce=new dt(0,0),Je=new dt(0,0),ot=new dt(0,0);for(const pt of oe)if("branches"in pt){Ce.total+=1,Ce.covered+=pt.executionCount>0?1:0;for(const It of pt.branches)Je.total+=1,Je.covered+=It.executionCount>0?1:0}else ot.total+=1,ot.covered+=pt.executionCount>0?1:0;const ht=new T(V,Ce,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return ht.detailedCoverage=oe,ht}};Ct=T=Ve([R],Ct),e.FileCoverage=Ct;let Pt=class{constructor(V,oe,Ce=[]){this.executionCount=V,this.location=oe,this.branches=Ce}};Pt=Ve([R],Pt),e.StatementCoverage=Pt;let Ni=class{constructor(V,oe){this.executionCount=V,this.location=oe}};Ni=Ve([R],Ni),e.BranchCoverage=Ni;let Ui=class{constructor(V,oe){this.executionCount=V,this.location=oe}};Ui=Ve([R],Ui),e.FunctionCoverage=Ui;var zi;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(zi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(V,oe,Ce,Je,ot,ht){this.kind=V,this.name=oe,this.detail=Ce,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.TypeHierarchyItem=qi}),define(fe[122],me([0,1,57,10,8,150,109,7,15]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(f,w){w?C.set(f,w):C.delete(f)}e.setWordDefinitionFor=i;function I(f){return C.get(f)}e.getWordDefinitionFor=I;class c extends S.MirrorTextModel{constructor(w,_,P,b,s,a,v,n){super(_,P,b,s);this._proxy=w,this._languageId=a,this._isDirty=v,this._notebook=n,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,E.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(_){return _?w._getTextInRange(_):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(_){return w._lineAt(_)},offsetAt(_){return w._offsetAt(_)},positionAt(_){return w._positionAt(_)},validateRange(_){return w._validateRange(_)},validatePosition(_){return w._validatePosition(_)},getWordRangeAtPosition(_,P){return w._getWordRangeAtPosition(_,P)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const _=this._validateRange(w);if(_.isEmpty)return"";if(_.isSingleLine)return this._lines[_.start.line].substring(_.start.character,_.end.character);const P=this._eol,b=_.start.line,s=_.end.line,a=[];a.push(this._lines[b].substring(_.start.character));for(let v=b+1;v<s;v++)a.push(this._lines[v]);return a.push(this._lines[s].substring(0,_.end.character)),a.join(P)}_lineAt(w){let _;if(w instanceof k.Position?_=w.line:typeof w=="number"&&(_=w),typeof _!="number"||_<0||_>=this._lines.length||Math.floor(_)!==_)throw new Error("Illegal value for `line`");return new p(_,this._lines[_],_===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const _=this._lineStarts.getIndexOf(w),P=this._lines[_.index].length;return new k.Position(_.index,Math.min(_.remainder,P))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const _=this._validatePosition(w.start),P=this._validatePosition(w.end);return _===w.start&&P===w.end?w:new k.Range(_.line,_.character,P.line,P.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:_,character:P}=w,b=!1;if(_<0)_=0,P=0,b=!0;else if(_>=this._lines.length)_=this._lines.length-1,P=this._lines[_].length,b=!0;else{const s=this._lines[_].length;P<0?(P=0,b=!0):P>s&&(P=s,b=!0)}return b?new k.Position(_,P):w}_getWordRangeAtPosition(w,_){const P=this._validatePosition(w);if(!_)_=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(_))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${_.source}' because it matches the empty string.`);const b=(0,A.getWordAtText)(P.character+1,(0,A.ensureValidWordDefinition)(_),this._lines[P.line],0);if(b)return new k.Range(P.line,b.startColumn-1,P.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class p{constructor(w,_,P){this._line=w,this._text=_,this._isLastLine=P}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=p}),define(fe[205],me([0,1,7,3,111,6,82,24,2,31]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(c,p,f,w){this._notebook=f,this._selector=w,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(p.onDidChangeDocument(P=>{const b=this._cellUris.get(P.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const _=P=>{P===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(P=>_(P.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],p=[];for(const f of this._notebook.getCells())f.kind===g.NotebookCellKind.Code&&(!this._selector||(0,A.score)(this._selector,f.document.uri,f.document.languageId,!0))&&(this._cellUris.set(f.document.uri,this._cells.length),this._cells.push(f),c.push(f.document.getText().length+1),p.push(f.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(p))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const s of this._cells)b+=s.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const p=this.locationAt(c.start),f=this.locationAt(c.end),w=this._cellUris.get(p.uri),_=this._cellUris.get(f.uri);if(w===void 0||_===void 0)return"";if(w===_)return this._cells[w].document.getText(new g.Range(p.range.start,f.range.end));const P=[this._cells[w].document.getText(new g.Range(p.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<_;b++)P.push(this._cells[b].document.getText());return P.push(this._cells[_].document.getText(new g.Range(new g.Position(0,0),f.range.end))),P.join(`
`)}offsetAt(c){const p=this._cellLines.getIndexOf(c.line),f=this._cellLengths.getPrefixSum(p.index-1),w=this._cells[p.index].document.offsetAt(c.with(p.remainder));return f+w}positionAt(c){if(typeof c=="number"){const f=this._cellLengths.getIndexOf(c),w=this._cellLines.getPrefixSum(f.index-1);return this._cells[f.index].document.positionAt(f.remainder).translate(w)}const p=this._cellUris.get(c.uri);if(p!==void 0){const f=this._cellLines.getPrefixSum(p-1);return new g.Position(f+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const p=this._cellLines.getIndexOf(c.start.line);let f=p;c.isEmpty||(f=this._cellLines.getIndexOf(c.end.line));const w=new g.Position(p.remainder,c.start.character),_=new g.Position(f.remainder,c.end.character),P=new g.Range(w,_),b=this._cells[p.index];return new g.Location(b.document.uri,b.document.validateRange(P))}contains(c){return this._cellUris.has(c)}validateRange(c){const p=this.validatePosition(c.start),f=this.validatePosition(c.end);return c.with(p,f)}validatePosition(c){const p=this._cellLines.getIndexOf(c.line),f=new g.Position(p.remainder,c.character),w=this._cells[p.index].document.validatePosition(f),_=this._cellLines.getPrefixSum(p.index-1);return new g.Position(_+w.line,w.character)}}e.ExtHostNotebookConcatDocument=i}),define(fe[206],me([0,1,7,14,3]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(k){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let E=k==="light"?g.ColorThemeKind.Light:k==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(fe[66],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=L}),define(fe[207],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(E){let C=this.buffers.indexOf(E);return C<0&&(C=this.buffers.length,this.buffers.push(E)),C}}function D(k,E){if(E.serializeBuffersForPostMessage){const C=new L,i=(p,f)=>{if(f instanceof ArrayBuffer){const w=C.add(f);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(f)){const w=S(f);if(w){const _=C.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:_,view:{type:w,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},I=JSON.stringify(k,i),c=C.buffers.map(p=>{const f=new Uint8Array(p);return g.VSBuffer.wrap(f)});return{message:I,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=D;function S(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(k,E){const C=E.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),i=E.length?(c,p)=>{if(typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const f=p,{index:w}=f,_=C[w];if(f.view)switch(f.view.type){case 1:return new Int8Array(_,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(_,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(_,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(_,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(_,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(_,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(_,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(_,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(_,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(_,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(_,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return _}return p}:void 0;return{message:JSON.parse(k,i),arrayBuffers:C}}e.deserializeWebviewMessage=A}),define(fe[208],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function D(A){const k={items:new Map};return A.types.forEach((E,C)=>{k.items.set(E,{asString:async()=>A.items[C].asString})}),k}L.toITreeDataTransfer=D;async function S(A){const k={types:[],items:[]},E=Array.from(A.items.entries());for(const C of E)k.types.push(C[0]),k.items.push({asString:await C[1].asString()});return k}L.toTreeDataTransferDTO=S})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[88],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(k,E){return k.scheme===g.Schemas.http||k.scheme===g.Schemas.https?k:(E&&E.authority&&E.isRemote&&k.scheme===g.Schemas.file&&(k=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:E.authority,path:k.path})),L.URI.from({scheme:g.Schemas.https,authority:`${k.scheme}+${S(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=D;function S(k){return k.replace(/./g,E=>{const C=E.charCodeAt(0);return C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57?E:"-"+C.toString(16).padStart(4,"0")})}function A(k){return k.replace(/-([0-9a-f]{4})/g,(E,C)=>String.fromCharCode(parseInt(C,16)))}e.decodeAuthority=A}),define(fe[209],me([0,1,3,6,88]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(k,E,C){this._proxy=k,this._editors=E,this._initData=C,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const i=E.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,E,C,i,I){let c;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===k){c=s;break}if(!c)throw new Error("not a visible editor");const p=this,f=this._handlePool++,w=new g.Emitter,_=new g.Emitter,P=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,D.asWebviewUri)(s,p._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(s){this._options=s,p._proxy.$setOptions(f,s)}get options(){return this._options}set html(s){this._html=s,p._proxy.$setHtml(f,s)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(s){return p._proxy.$postMessage(f,s)}},b=new class{constructor(){this.editor=k,this.line=E,this.height=C,this.webview=P,this.onDidDispose=_.event}dispose(){p._insets.has(f)&&(p._insets.delete(f),p._proxy.$disposeEditorInset(f),_.fire(),_.dispose(),w.dispose())}};return this._proxy.$createEditorInset(f,c.id,c.value.document.uri,E+1,C,i||{},I.identifier,I.extensionLocation),this._insets.set(f,{editor:k,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(k){const E=this._insets.get(k);E&&E.inset.dispose()}$onDidReceiveMessage(k,E){const C=this._insets.get(k);C&&C.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=S}),define(fe[210],me([0,1,173,13,2,6,4,52,34,42,15,10]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(B,F,W){for(const M of W.visibleEditorPanes)if(M.group.id===F&&B.matches(M.input))return M.getViewState()}e.findViewStateForEditor=c;function p(B){if(v(B))return!1;const F=B;return D.URI.isUri(F?.resource)}e.isResourceEditorInput=p;function f(B){if(v(B))return!1;const F=B;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=f;function w(B){if(v(B)||f(B))return!1;const F=B;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function _(B){if(v(B))return!1;const F=B;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=_;var P;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(P=e.Verbosity||(e.Verbosity={}));var b;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var s;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends S.Disposable{}e.AbstractEditorInput=a;function v(B){return B instanceof a}e.isEditorInput=v;function n(B){const F=B;return D.URI.isUri(F?.preferredResource)}function h(B){const F=B;return v(F?.primary)&&v(F?.secondary)}e.isSideBySideEditorInput=h;function r(B){const F=B;return v(F?.modified)&&v(F?.original)}e.isDiffEditorInput=r;function t(B){return v(B?.editor)}e.isEditorInputWithOptions=t;function l(B){const F=B;return t(B)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function o(B){const F=B;return typeof F?.groupId=="number"&&v(F.editor)}e.isEditorIdentifier=o;var d;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(d=e.EditorCloseContext||(e.EditorCloseContext={}));var m;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(m=e.SideBySideEditor||(e.SideBySideEditor={}));class u{getOriginalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:z,secondary:N}=this.getSideEditors(F);if(z&&N){if(W?.supportSideBySide===m.BOTH)return{primary:this.getOriginalUri(z,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===m.ANY)return this.getOriginalUri(z,{filterByScheme:W.filterByScheme})??this.getOriginalUri(N,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===m.PRIMARY?z:N}}if(f(F)||w(F))return;const M=n(F)?F.preferredResource:F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}getSideEditors(F){return h(F)||w(F)?{primary:F.primary,secondary:F.secondary}:r(F)||f(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,W){if(!F)return;if(W?.supportSideBySide){const{primary:z,secondary:N}=this.getSideEditors(F);if(z&&N){if(W?.supportSideBySide===m.BOTH)return{primary:this.getCanonicalUri(z,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===m.ANY)return this.getCanonicalUri(z,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:W.filterByScheme});F=W.supportSideBySide===m.PRIMARY?z:N}}if(f(F)||w(F))return;const M=F.resource;return!M||!W||!W.filterByScheme?M:this.filterUri(M,W.filterByScheme)}filterUri(F,W){if(Array.isArray(W)){if(W.some(M=>F.scheme===M))return F}else if(W===F.scheme)return F}}e.EditorResourceAccessor=new u;var y;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class T{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const W=this.instantiationService=F.get(A.IInstantiationService);for(const[M,z]of this.editorSerializerConstructors)this.createEditorSerializer(M,z,W);this.editorSerializerConstructors.clear()}createEditorSerializer(F,W,M){const z=M.createInstance(W);this.editorSerializerInstances.set(F,z)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,W){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,W,this.instantiationService):this.editorSerializerConstructors.set(F,W),(0,S.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}E.Registry.add(e.EditorExtensions.EditorFactory,new T);async function R(B,F){if(!B||!B.length)return[];const W=await Promise.all(B.map(async M=>{const z=D.URI.revive(M.fileUri);if(!z||!await F.canHandleResource(z))return;let U=M.exists,x=M.type;if(typeof U!="boolean"||typeof x!="number")try{x=(await F.resolve(z)).isFile?C.FileType.File:C.FileType.Unknown,U=!0}catch{U=!1}if(!U&&M.openOnlyIfExists||x!==C.FileType.File)return;const O={selection:U?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let j;return U?j={resource:z,options:O}:j={resource:z,options:O,forceUntitled:!0},j}));return(0,i.coalesce)(W)}e.pathsToEditors=R;var $;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})($=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[211],me([0,1,3,52,174,4,6,24,34,15,58,25,47,199]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,p.registerIcon)("default-view-icon",c.Codicon.window,(0,D.localize)(0,null));var f;(function(l){l.ViewContainersRegistry="workbench.registry.view.containers",l.ViewsRegistry="workbench.registry.view"})(f=e.Extensions||(e.Extensions={}));var w;(function(l){l[l.Sidebar=0]="Sidebar",l[l.Panel=1]="Panel",l[l.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function _(l){switch(l){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=_;function P(l){return`viewContainer.${l}.enabled`}e.getEnabledViewContainerContextKey=P;class b extends A.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(o,d,m){const u=this.get(o.id);if(u)return u;const y=o;return y.openCommandActionDescriptor=m?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,k.getOrSet)(this.viewContainers,d,[]).push(y),m?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:d}),y}deregisterViewContainer(o){for(const d of this.viewContainers.keys()){const m=this.viewContainers.get(d),u=m?.indexOf(o);if(u!==-1){m?.splice(u,1),m.length===0&&this.viewContainers.delete(d),this._onDidDeregister.fire({viewContainer:o,viewContainerLocation:d});return}}}get(o){return this.all.filter(d=>d.id===o)[0]}getViewContainers(o){return[...this.viewContainers.get(o)||[]]}getViewContainerLocation(o){return[...this.viewContainers.keys()].filter(d=>this.getViewContainers(d).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.defaultViewContainers.find(d=>this.getViewContainerLocation(d)===o)}}E.Registry.add(f.ViewContainersRegistry,new b);var s;(function(l){l.Open="2_open",l.Debug="4_debug",l.SCM="5_scm",l.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function a(l,o){const d=l.group??s.More,m=o.group??s.More;return d!==m?d.localeCompare(m):(l.order??5)-(o.order??5)}class v extends A.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(o,d){this.registerViews2([{views:o,viewContainer:d}])}registerViews2(o){o.forEach(({views:d,viewContainer:m})=>this.addViews(d,m)),this._onViewsRegistered.fire(o)}deregisterViews(o,d){const m=this.removeViews(o,d);m.length&&this._onViewsDeregistered.fire({views:m,viewContainer:d})}moveViews(o,d){for(const m of this._views.keys())if(m!==d){const u=this.removeViews(o,m);u.length&&(this.addViews(u,d),this._onDidChangeContainer.fire({views:u,from:m,to:d}))}}getViews(o){return this._views.get(o)||[]}getView(o){for(const d of this._viewContainers){const m=(this._views.get(d)||[]).filter(u=>u.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const d of this._viewContainers)if((this._views.get(d)||[]).filter(u=>u.id===o)[0])return d;return null}registerViewWelcomeContent(o,d){return this._viewWelcomeContents.add(o,d),this._onDidChangeViewWelcomeContent.fire(o),(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(o,d),this._onDidChangeViewWelcomeContent.fire(o)})}registerViewWelcomeContent2(o,d){const m=new Map;for(const[u,y]of d)this._viewWelcomeContents.add(o,y),m.set(u,(0,A.toDisposable)(()=>{this._viewWelcomeContents.delete(o,y),this._onDidChangeViewWelcomeContent.fire(o)}));return this._onDidChangeViewWelcomeContent.fire(o),m}getViewWelcomeContent(o){const d=[];return this._viewWelcomeContents.forEach(o,m=>d.push(m)),d.sort(a)}addViews(o,d){let m=this._views.get(d);m||(m=[],this._views.set(d,m),this._viewContainers.push(d));for(const u of o){if(this.getView(u.id)!==null)throw new Error((0,D.localize)(1,null,u.id));m.push(u)}}removeViews(o,d){const m=this._views.get(d);if(!m)return[];const u=[],y=[];for(const T of m)o.includes(T)?u.push(T):y.push(T);return u.length&&(y.length?this._views.set(d,y):(this._views.delete(d),this._viewContainers.splice(this._viewContainers.indexOf(d),1))),u}}E.Registry.add(f.ViewsRegistry,new v),e.IViewsService=(0,S.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,D.localize)(2,null));function n(l){return`view.${l}.visible`}e.getVisbileViewContextKey=n,e.IViewDescriptorService=(0,S.createDecorator)("viewDescriptorService");var h;(function(l){l[l.Default=0]="Default",l[l.Expand=1]="Expand"})(h=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(l){l[l.None=0]="None",l[l.Collapsed=1]="Collapsed",l[l.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(o,d){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,o),this._hasResolve=!!d,this.resolve=async m=>{if(d&&!this.resolved){const u=await d(m);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}m.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[123],me([0,1,3,16,175]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,E,C,i){const I={command:k};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof i=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.pendingRequests.get(I.seq);if(p){this.pendingRequests.delete(I.seq);const f={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,D.localize)(0,null,i,k)};p(f)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,E){return k.type!=="event"||E.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const E=k,C=this.pendingRequests.get(E.request_seq);C&&(this.pendingRequests.delete(E.request_seq),C(E));break}}}internalSend(k,E){E.type=k,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((E,C)=>k.set(C,E)),await(0,L.timeout)(500),k.forEach((E,C)=>{E({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(fe[212],me([0,1,8,2,9,25,10]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function E(r,t,l){return r.replace(k,function(o,d){return t&&d.length>0&&d[0]!=="_"?o:l&&l.hasOwnProperty(d)?l[d]:o})}e.formatPII=E;function C(r){const t={};for(const l of Object.keys(r))l.startsWith("!")||(t[l]=r[l]);return t}e.filterExceptionsFromTelemetry=C;function i(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||i(r.parentSession))}e.isSessionAttach=i;function I(r){let t=r.configuration.type;if(!!t)return t==="vslsShare"&&(t=r.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function p(r,t,l){let o,d=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,u=null;for(;u=m.exec(r);){let y=u.index+1,T=y+u[0].length;if(y<=t&&T>=l){o=u[0],d=y;break}}if(o){let y=/\w+/g,T=null;for(;(T=y.exec(o))&&!(T.index+1+d+T[0].length>=l););T&&(o=o.substring(0,y.lastIndex))}return o?{start:d,end:d+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=p;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(r){return!!(r&&r.match(f))}e.isUri=w;function _(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(w(r.path))return L.URI.parse(r.path);if((0,D.isAbsolute)(r.path))return L.URI.file(r.path)}return r.path}function P(r){if(typeof r.path=="object"){const t=L.URI.revive(r.path);if(t)return t.scheme===A.Schemas.file?t.fsPath:t.toString()}return r.path}function b(r,t){const l=t?_:P,o=(0,S.deepClone)(r);return a(o,(d,m)=>{d&&m&&(m.path=l(m))}),o}e.convertToDAPaths=b;function s(r,t){const l=t?_:P,o=(0,S.deepClone)(r);return a(o,(d,m)=>{!d&&m&&(m.path=l(m))}),o}e.convertToVSCPaths=s;function a(r,t){switch(r.type){case"event":const l=r;switch(l.event){case"output":t(!1,l.body.source);break;case"loadedSource":t(!1,l.body.source);break;case"breakpoint":t(!1,l.body.breakpoint.source);break;default:break}break;case"request":const o=r;switch(o.command){case"setBreakpoints":t(!0,o.arguments.source);break;case"breakpointLocations":t(!0,o.arguments.source);break;case"source":t(!0,o.arguments.source);break;case"gotoTargets":t(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>t(!1,m));break;default:break}break;case"response":const d=r;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(m=>t(!1,m.source));break;case"loadedSources":d.body.sources.forEach(m=>t(!1,m));break;case"scopes":d.body.scopes.forEach(m=>t(!1,m.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(m=>t(!1,m.source));break;case"setBreakpoints":d.body.breakpoints.forEach(m=>t(!1,m.source));break;default:break}break}}function v(r){return r.filter(t=>!t.presentation?.hidden).sort((t,l)=>t.presentation?l.presentation?t.presentation.group?l.presentation.group?t.presentation.group!==l.presentation.group?t.presentation.group.localeCompare(l.presentation.group):n(t.presentation.order,l.presentation.order):-1:l.presentation.group?1:n(t.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=v;function n(r,t){return typeof r!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:r-t}async function h(r,t){const l=r.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(l!=="none"&&(await t.saveAll(),l==="allEditorsInActiveGroup")){const o=t.activeEditorPane;o&&await t.save({editor:o.input,groupId:o.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=h}),define(fe[213],me([0,1,28,38,176,124,9,8,25,12,186,123]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,s){this.outputStream=s,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",a=>this.handleData(a))}sendMessage(b){if(this.outputStream){const s=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(s,"utf8")}${c.TWO_CRLF}${s}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const s=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,s.length>0)try{this.acceptMessage(JSON.parse(s))}catch(a){this._onError.fire(new Error((a.message||a)+`
`+s))}continue}}else{const s=this.rawData.indexOf(c.TWO_CRLF);if(s!==-1){const v=this.rawData.toString("utf8",0,s).split(c.HEADER_LINESEPARATOR);for(const n of v){const h=n.split(c.HEADER_FIELDSEPARATOR);h[0]==="Content-Length"&&(this.contentLength=Number(h[1]))}this.rawData=this.rawData.slice(s+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class p extends c{startSession(){return new Promise((b,s)=>{let a=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),a=!0}),this.socket.on("close",()=>{a?this._onError.fire(new Error("connection closed")):s(new Error("connection closed"))}),this.socket.on("error",v=>{a?this._onError.fire(v):s(v)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=p;class f extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=f;class w extends p{constructor(b){super();this.adapterServer=b}createConnection(b){return S.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class _ extends c{constructor(b,s,a){super();this.adapterExecutable=b,this.debugType=s,this.outputService=a}async startSession(){const b=this.adapterExecutable.command,s=this.adapterExecutable.args,a=this.adapterExecutable.options||{};try{if(b)if(A.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(D.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(D.localize(1,null,this.debugType));let v=process.env;if(a.env&&Object.keys(a.env).length>0&&(v=E.mixin(E.deepClone(process.env),a.env)),b==="node")if(Array.isArray(s)&&s.length>0){const h=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,r={env:v,execArgv:h?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};a.cwd&&(r.cwd=a.cwd);const t=L.fork(s[0],s.slice(1),r);if(!t.pid)throw new Error(D.localize(2,null,s[0]));this.serverProcess=t}else throw new Error(D.localize(3,null));else{const h={env:v};a.cwd&&(h.cwd=a.cwd),this.serverProcess=L.spawn(b,s,h)}this.serverProcess.on("error",h=>{this._onError.fire(h)}),this.serverProcess.on("exit",(h,r)=>{this._onExit.fire(h)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",h=>{this._onError.fire(h)}),this.serverProcess.stdin.on("error",h=>{this._onError.fire(h)});const n=this.outputService;if(n){const h=r=>r.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",r=>{const t=n.getChannel(i.ExtensionsChannelId);t&&t.append(h(r))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(v){this._onError.fire(v)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),C.isWindows?new Promise((b,s)=>{const a=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(v,n,h){if(v)return s(v)});a.on("exit",b),a.on("error",s)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,s){if(!b)return;const a=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?a.runtime=A.join(s,b.runtime):a.runtime=b.runtime),b.runtimeArgs&&(a.runtimeArgs=b.runtimeArgs),b.program&&(A.isAbsolute(b.program)?a.program=b.program:a.program=A.join(s,b.program)),b.args&&(a.args=b.args);const v=b;return v.win&&(a.win=_.extract(v.win,s)),v.winx86&&(a.winx86=_.extract(v.winx86,s)),v.windows&&(a.windows=_.extract(v.windows,s)),v.osx&&(a.osx=_.extract(v.osx,s)),v.linux&&(a.linux=_.extract(v.linux,s)),a}static platformAdapterExecutable(b,s){let a=Object.create(null);s=s.toLowerCase();for(const l of b)if(l.contributes){const o=l.contributes.debuggers;o&&o.length>0&&o.filter(d=>typeof d.type=="string"&&k.equalsIgnoreCase(d.type,s)).forEach(d=>{const m=_.extract(d,l.extensionLocation.fsPath);a=E.mixin(a,m,l.isBuiltin)})}let v;C.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?v=a.winx86||a.win||a.windows:C.isWindows?v=a.win||a.windows:C.isMacintosh?v=a.osx:C.isLinux&&(v=a.linux),v=v||a;let n=v.program||a.program;const h=v.args||a.args;let r=v.runtime||a.runtime;const t=v.runtimeArgs||a.runtimeArgs;if(r)return{type:"executable",command:r,args:(t||[]).concat(typeof n=="string"?[n]:[]).concat(h||[])};if(n)return{type:"executable",command:n,args:h||[]}}}e.ExecutableDebugAdapter=_}),define(fe[214],me([0,1,38,12,29,188]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(c,p){return new Promise((f,w)=>{let _="";const P=g.spawn(c,p);P.pid&&P.stdout.on("data",b=>{_+=b.toString()}),P.on("error",b=>{w(b)}),P.on("close",b=>{f(_)})})}let k;function E(c,p){if(!k)if(L.isWindows)k=new S.WindowsExternalTerminalService;else if(L.isMacintosh)k=new S.MacExternalTerminalService;else if(L.isLinux)k=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const f=p.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},f.external||{})}e.runInExternalTerminal=E;async function C(c){if(c)if(L.isWindows){const p=await new Promise((f,w)=>{Y(["windows-process-tree"],f,w)});return new Promise(f=>{p.getProcessTree(c,w=>{f(w.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(c)]).then(p=>{const f=p.trim();return!(f.length===0||f.indexOf(" tmux")>=0)},p=>!0);return Promise.resolve(!0)}e.hasChildProcesses=C;var i;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(i||(i={}));function I(c,p,f,w){c=c.trim().toLowerCase();let _;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?_=1:c.indexOf("cmd.exe")>=0?_=0:c.indexOf("bash")>=0?_=2:L.isWindows?_=0:_=2;let P,b=" ";switch(_){case 1:if(P=a=>(a=a.replace(/\'/g,"''"),a.length>0&&a.charAt(a.length-1)==="\\"?`'${a}\\'`:`'${a}'`),f){const a=(0,D.getDriveLetter)(f);a&&(b+=`${a}:; `),b+=`cd ${P(f)}; `}if(w)for(let a in w){const v=w[a];v===null?b+=`Remove-Item env:${a}; `:b+=`\${env:${a}}='${v}'; `}if(p.length>0){const a=P(p.shift());b+=a[0]==="'"?`& ${a} `:`${a} `;for(let v of p)b+=`${P(v)} `}break;case 0:if(P=a=>(a=a.replace(/\"/g,'""'),a.indexOf(" ")>=0||a.indexOf('"')>=0||a.length===0?`"${a}"`:a),f){const a=(0,D.getDriveLetter)(f);a&&(b+=`${a}: && `),b+=`cd ${P(f)} && `}if(w){b+='cmd /C "';for(let a in w){let v=w[a];v===null?b+=`set "${a}=" && `:(v=v.replace(/[\^\&\|\<\>]/g,n=>`^${n}`),b+=`set "${a}=${v}" && `)}}for(let a of p)b+=`${P(a)} `;w&&(b+='"');break;case 2:P=a=>(a=a.replace(/(["'\\\$])/g,"\\$1"),a.indexOf(" ")>=0||a.indexOf(";")>=0||a.length===0?`"${a}"`:a);const s=a=>/[^\w@%\/+=,.:^-]/.test(a)?`'${a.replace(/'/g,"'\\''")}'`:a;if(f&&(b+=`cd ${P(f)} ; `),w){b+="/usr/bin/env";for(let a in w){const v=w[a];v===null?b+=` -u ${s(a)}`:b+=` ${s(`${a}=${v}`)}`}b+=" "}for(let a of p)b+=`${P(a)} `;break}return b}e.prepareCommand=I}),define(fe[125],me([0,1,30,77,101,10,9,12,52]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",D.Mimes.latex,D.Mimes.markdown,"image/png","image/jpeg",D.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[D.Mimes.latex,D.Mimes.markdown,"application/json",D.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var i;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(i=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var p;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(p=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var _;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(_=e.CellEditType||(e.CellEditType={}));var P;(function(y){y.scheme=S.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function R(M,z){return M.with({scheme:y.scheme,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}y.generate=R;function $(M){if(M.scheme!==y.scheme)return;const z=T.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}y.parse=$;function B(M){if(M.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const z=T.exec(M.fragment);return z?{handle:Number(z[1]),notebook:M.with({scheme:M.fragment.substr(z[0].length)||S.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=B;function F(M,z,N){return M.with({scheme:N,fragment:`ch${z.toString().padStart(7,"0")}${M.scheme!==S.Schemas.file?M.scheme:""}`})}y.generateCellUri=F;function W(M,z){if(M.scheme!==z)return;const N=T.exec(M.fragment);return N?{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||S.Schemas.file,fragment:null})}:void 0}y.parseCellUri=W})(P=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[D.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(y){return b.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function a(y){return b.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=a;function v(y){return b.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=v;const n=y=>k.isWindows?y.replace(/\//g,"\\"):y;class h{constructor(T=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(T)].map($=>({pattern:$,matches:g.parse(n($))}))}sort(T){const R=new Map(L.Iterable.map(T,B=>[B,n(B)]));let $=[];for(const{matches:B}of this.order)for(const[F,W]of R)if(B(W)){$.push(F),R.delete(F);break}return R.size&&($=$.concat([...R.keys()].sort((B,F)=>this.defaultOrder.indexOf(B)-this.defaultOrder.indexOf(F)))),$}prioritize(T,R){const $=this.findIndex(T);if($===-1){this.order.unshift({pattern:T,matches:g.parse(n(T))});return}const B=new Set(R.map(W=>this.findIndex(W,$)));B.delete(-1);const F=Array.from(B).sort();this.order.splice($+1,0,...F.map(W=>this.order[W]));for(let W=F.length-1;W>=0;W--)this.order.splice(F[W],1)}toArray(){return this.order.map(T=>T.pattern)}findIndex(T,R=this.order.length){const $=n(T);for(let B=0;B<R;B++)if(this.order[B].matches($))return B;return-1}}e.MimeTypeDisplayOrder=h;function r(y,T,R,$=(B,F)=>B===F){const B=[];function F(z,N,U){if(N===0&&U.length===0)return;const x=B[B.length-1];x&&x.start+x.deleteCount===z?(x.deleteCount+=N,x.toInsert.push(...U)):B.push({start:z,deleteCount:N,toInsert:U})}let W=0,M=0;for(;;){if(W===y.length){F(W,0,T.slice(M));break}if(M===T.length){F(W,y.length-W,[]);break}const z=y[W],N=T[M];if($(z,N)){W+=1,M+=1;continue}R(N)?(F(W,1,[]),W+=1):(F(W,0,[N]),M+=1)}return B}e.diff=r,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new E.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(y){y.default="default",y.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function l(y){const T=y;return!!((typeof T.include=="string"||g.isRelativePattern(T.include))&&(typeof T.exclude=="string"||g.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=l;function o(y,T,R){if(Array.isArray(y.viewType)&&y.viewType.indexOf(T)>=0||y.viewType===T)return!0;if(y.filenamePattern){let $=l(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,B=l(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(g.match($,(0,A.basename)(R.fsPath).toLowerCase()))return!(B&&g.match(B,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=o;class d{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)T[R]=this.textModel.cells[R].getHashValue();return T}}e.CellSequence=d,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var m;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(m=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(T){return`${u._prefix}${T}`}static parse(T){if(T.startsWith(u._prefix))return T.substr(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(fe[215],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(D){D[D.Output=1]="Output",D[D.OutputItems=2]="OutputItems",D[D.ExecutionState=3]="ExecutionState",D[D.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[216],me([0,1,4,52]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,g.createDecorator)(e.OUTPUT_SERVICE_ID);var D;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(D=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(fe[217],me([0,1,178,4,52]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[218],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=g;function L(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=L}),define(fe[126],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(D=e.TestMessageType||(e.TestMessageType={}));var S;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(S=e.TestItemExpandState||(e.TestItemExpandState={}));const A=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=A;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var E;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(E=e.TestDiffOpType||(e.TestDiffOpType={}));class C{add(c){}update(c){}remove(c,p){}complete(){}}e.IncrementalChangeCollector=C;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const p=this.createChangeCollector();for(const f of c)switch(f[0]){case 0:{const w=f[1];if(w.parent){if(this.items.has(w.parent)){const _=this.items.get(w.parent);_.children.add(w.item.extId);const P=this.createItem(w,_);this.items.set(w.item.extId,P),p.add(P)}}else{const _=this.createItem(w);this.roots.add(_),this.items.set(w.item.extId,_),p.add(_)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=f[1],_=this.items.get(w.extId);if(!_)break;w.expand!==void 0&&(_.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(_,w),p.update(_);break}case 2:{const w=this.items.get(f[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const _=[[f[1]]];for(;_.length;)for(const P of _.pop()){const b=this.items.get(P);b&&(_.push(b.children),this.items.delete(P),p.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(f[1]);break;case 3:this.updatePendingRoots(f[1]);break;case 5:this._tags.set(f[1].id,f[1]);break;case 6:this._tags.delete(f[1]);break}p.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new C}}e.AbstractIncrementalTestCollection=i}),define(fe[89],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(S){S.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(S){S[S.IsSame=0]="IsSame",S[S.Disconnected=1]="Disconnected",S[S.IsChild=2]="IsChild",S[S.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class D{constructor(A,k=A.length){if(this.path=A,this.viewEnd=k,A.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(A,k,E=A.parent){if(A.id===k)return new D([k]);let C=[A.id];for(let i=E;i&&i.id!==k;i=i.parent)C.push(i.id);return C.push(k),new D(C.reverse())}static isRoot(A){return!A.includes("\0")}static fromString(A){return new D(A.split("\0"))}static join(A,k){return new D([...A.path,k])}static joinToString(A,k){return A.toString()+"\0"+k}static compare(A,k){return A===k?0:k.startsWith(A+"\0")?2:A.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new D(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let A=1;A<=this.viewEnd;A++)yield new D(this.path,A)}compare(A){if(typeof A=="string")return D.compare(this.toString(),A);for(let k=0;k<A.viewEnd&&k<this.viewEnd;k++)if(A.path[k]!==this.path[k])return 1;return A.viewEnd>this.viewEnd?2:A.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let A=1;A<this.viewEnd;A++)this.stringifed+="\0",this.stringifed+=this.path[A]}return this.stringifed}}e.TestId=D}),define(fe[219],me([0,1,9,37,13,25,12,80,179]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,c,p){this._contributedVariables=new Map,this._context=I,this._labelService=c,p&&(this._envVariablesPromise=p.then(f=>this.prepareEnv(f)))}prepareEnv(I){if(A.isWindows){const c=Object.create(null);return Object.keys(I).forEach(p=>{c[p.toLowerCase()]=I[p]}),c}return I}resolveWithEnvironment(I,c,p){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,p)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,p,f){const w=S.deepClone(c);return A.isWindows&&w.windows?Object.keys(w.windows).forEach(_=>w[_]=w.windows[_]):A.isMacintosh&&w.osx?Object.keys(w.osx).forEach(_=>w[_]=w.osx[_]):A.isLinux&&w.linux&&Object.keys(w.linux).forEach(_=>w[_]=w.linux[_]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,p,f)}async resolveAnyAsync(I,c,p){return this.resolveAnyBase(I,c,p)}async resolveAnyMap(I,c,p){const f=new Map;return{newConfig:await this.resolveAnyBase(I,c,p,f),resolvedVariables:f}}resolveWithInteractionReplace(I,c,p,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,p,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,p,f,w){if(D.isString(p))return this.resolveString(I,c,p,f,w);if(D.isArray(p))return p.map(_=>this.recursiveResolve(I,c,_,f,w));if(D.isObject(p)){let _=Object.create(null);return Object.keys(p).forEach(P=>{const b=this.resolveString(I,c,P,f,w);_[b]=this.recursiveResolve(I,c,p[P],f,w)}),_}return p}resolveString(I,c,p,f,w){return p.replace(C.VARIABLE_REGEXP,(P,b)=>{if(b.includes(C.VARIABLE_LHS))return P;let s=this.evaluateSingleVariable(I,P,b,c,f);return w&&w.set(b,s),s!==P&&D.isString(s)&&s.match(C.VARIABLE_REGEXP)&&(s=this.resolveString(I,c,s,f,w)),s})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,p,f,w){let _;const P=p.split(":");P.length>1&&(p=P[0],_=P[1]);const b=()=>{const v=this._context.getFilePath();if(v)return v;throw new Error((0,E.localize)(0,null,c))},s=()=>{const v=b();if(this._context.getWorkspaceFolderPathForFile){const n=this._context.getWorkspaceFolderPathForFile();if(n)return n}throw new Error((0,E.localize)(1,null,c,g.basename(v)))},a=()=>{if(_){const v=this._context.getFolderUri(_);if(v)return v;throw new Error((0,E.localize)(2,null,c,_))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,c)):new Error((0,E.localize)(4,null,c))};switch(p){case"env":if(_){if(I){const v=I[A.isWindows?_.toLowerCase():_];if(D.isString(v))return v}return""}throw new Error((0,E.localize)(5,null,c));case"config":if(_){const v=this._context.getConfigurationValue(f,_);if(D.isUndefinedOrNull(v))throw new Error((0,E.localize)(6,null,c,_));if(D.isObject(v))throw new Error((0,E.localize)(7,null,c,_));return v}throw new Error((0,E.localize)(8,null,c));case"command":return this.resolveFromMap(c,_,w,"command");case"input":return this.resolveFromMap(c,_,w,"input");default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(a()));case"cwd":return f||_?(0,k.normalizeDriveLetter)(this.fsPath(a())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(a()));case"lineNumber":const v=this._context.getLineNumber();if(v)return v;throw new Error((0,E.localize)(9,null,c));case"selectedText":const n=this._context.getSelectedText();if(n)return n;throw new Error((0,E.localize)(10,null,c));case"file":return b();case"fileWorkspaceFolder":return s();case"relativeFile":return f||_?g.relative(this.fsPath(a()),b()):b();case"relativeFileDirname":const h=g.dirname(b());if(f||_){const o=g.relative(this.fsPath(a()),h);return o.length===0?".":o}return h;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const r=g.basename(b());return r.slice(0,r.length-g.extname(r).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||c;case"execInstallFolder":const l=this._context.getAppRoot();return l||c;case"pathSeparator":return g.sep;default:try{const o=_?`${p}:${_}`:p;return this.resolveFromMap(c,o,w,void 0)}catch(o){return c}}}}resolveFromMap(I,c,p,f){if(c&&p){const w=f===void 0?p[c]:p[f+":"+c];if(typeof w=="string")return w;throw new Error((0,E.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[127],me([0,1,4,210]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var D;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(D=e.GroupDirection||(e.GroupDirection={}));var S;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var A;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(A=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function C(w){const _=w;return(0,L.isEditorInput)(_?.editor)&&(0,L.isEditorInput)(_?.replacement)}e.isEditorReplacement=C;var i;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(i=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function p(w){const _=w;return!!_&&typeof _.id=="number"&&Array.isArray(_.editors)}e.isEditorGroup=p;function f(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=f}),define(fe[220],me([0,1,4,127]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function D(S){const A=S;return typeof S=="number"||(0,L.isEditorGroup)(A)}e.isPreferredGroup=D}),define(fe[17],me([0,1,15,22,97,294,61,25,13,2,41,84,180,115,65,125,89,220,7]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ge){function be(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:it,positionColumn:Ge}=K,mt=new b.Position(Se-1,Le-1),yt=new b.Position(it-1,Ge-1);return new b.Selection(mt,yt)}ge.to=be;function ae(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ae})(s=e.Selection||(e.Selection={}));var a;(function(ge){function be(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=be;function ae(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:it,endColumn:Ge}=K;return new b.Range(Se-1,Le-1,it-1,Ge-1)}ge.to=ae})(a=e.Range||(e.Range={}));var v;(function(ge){function be(ae){switch(ae){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=be})(v=e.TokenType||(e.TokenType={}));var n;(function(ge){function be(K){return new b.Position(K.lineNumber-1,K.column-1)}ge.to=be;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ae})(n=e.Position||(e.Position={}));var h;(function(ge){function be(Se,Le){return(0,g.coalesce)((0,g.asArray)(Se).map(it=>ae(it,Le)))}ge.from=be;function ae(Se,Le){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:typeof Se.pattern=="undefined"?void 0:le.from(Se.pattern),exclusive:Se.exclusive}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(h=e.DocumentSelector||(e.DocumentSelector={}));var r;(function(ge){function be(K){switch(K){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=be;function ae(K){switch(K){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=ae})(r=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function be(K){let Se;return K.code&&((0,E.isString)(K.code)||(0,E.isNumber)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...a.from(K.range),message:K.message,source:K.source,code:Se,severity:o.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(l.from),tags:Array.isArray(K.tags)?(0,g.coalesce)(K.tags.map(r.from)):void 0}}ge.from=be;function ae(K){const Se=new b.Diagnostic(a.to(K),K.message,o.to(K.severity));return Se.source=K.source,Se.code=(0,E.isString)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(l.to),Se.tags=K.tags&&(0,g.coalesce)(K.tags.map(r.to)),Se}ge.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var l;(function(ge){function be(K){return{...a.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=be;function ae(K){return new b.DiagnosticRelatedInformation(new b.Location(K.resource,a.to(K)),K.message)}ge.to=ae})(l=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var o;(function(ge){function be(K){switch(K){case b.DiagnosticSeverity.Error:return p.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return p.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return p.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return p.MarkerSeverity.Hint}return p.MarkerSeverity.Error}ge.from=be;function ae(K){switch(K){case p.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case p.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case p.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case p.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=ae})(o=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var d;(function(ge){function be(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?P.SIDE_GROUP:P.ACTIVE_GROUP}ge.from=be;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ae})(d=e.ViewColumn||(e.ViewColumn={}));function m(ge){return typeof ge.range!="undefined"}function u(ge){return ge.length===0?!0:!!m(ge[0])}e.isDecorationOptionsArr=u;var y;(function(ge){function be(Ge){return Ge.map(ge.from)}ge.fromMany=be;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let mt;if(ae(Ge)){const{language:bt,value:vt}=Ge;mt={value:"```"+bt+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ge)?mt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?mt={value:Ge}:mt={value:""};const yt=Object.create(null);mt.uris=yt;const Et=bt=>{try{let vt=C.URI.parse(bt,!0);vt=vt.with({query:Se(vt.query,yt)}),yt[bt]=vt}catch(vt){}return""},gt=new S.Renderer;return gt.link=Et,gt.image=bt=>Et(D.parseHrefAndDimensions(bt).href),S(mt.value,{renderer:gt}),mt}ge.from=K;function Se(Ge,mt){if(!Ge)return Ge;let yt;try{yt=(0,A.parse)(Ge)}catch(gt){}if(!yt)return Ge;let Et=!1;return yt=(0,k.cloneAndChange)(yt,gt=>{if(C.URI.isUri(gt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[bt]=gt,Et=!0,bt}else return}),Et?JSON.stringify(yt):Ge}function Le(Ge){const mt=new b.MarkdownString(Ge.value,Ge.supportThemeIcons);return mt.isTrusted=Ge.isTrusted,mt.supportHtml=Ge.supportHtml,mt}ge.to=Le;function it(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=it})(y=e.MarkdownString||(e.MarkdownString={}));function T(ge){return u(ge)?ge.map(be=>({range:a.from(be.range),hoverMessage:Array.isArray(be.hoverMessage)?y.fromMany(be.hoverMessage):be.hoverMessage?y.from(be.hoverMessage):void 0,renderOptions:be.renderOptions})):ge.map(be=>({range:a.from(be)}))}e.fromRangeOrRangeWithMessage=T;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?C.URI.file(ge):ge}e.pathOrURIToURI=R;var $;(function(ge){function be(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ge.from=be})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var B;(function(ge){function be(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?$.from(ae.before):void 0,after:ae.after?$.from(ae.after):void 0}}ge.from=be})(B=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function be(ae){if(typeof ae=="undefined")return ae;switch(ae){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=be})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var W;(function(ge){function be(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?B.from(ae.light):void 0,dark:ae.dark?B.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?$.from(ae.before):void 0,after:ae.after?$.from(ae.after):void 0}}ge.from=be})(W=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function be(K){return{text:K.newText,eol:K.newEol&&J.from(K.newEol),range:a.from(K.range)}}ge.from=be;function ae(K){const Se=new b.TextEdit(a.to(K.range),K.text);return Se.newEol=typeof K.eol=="undefined"?void 0:J.to(K.eol),Se}ge.to=ae})(M=e.TextEdit||(e.TextEdit={}));var z;(function(ge){function be(K,Se,Le){const it={edits:[]};if(K instanceof b.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)it.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const mt=Se?.getDocument(Ge.uri);it.edits.push({_type:2,resource:Ge.uri,edit:M.from(Ge.edit),modelVersionId:mt?.version,metadata:Ge.metadata})}else Ge._type===3?it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&it.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}});return it}ge.from=be;function ae(K){const Se=new b.WorkspaceEdit;for(const Le of K.edits)Le.edit?Se.replace(C.URI.revive(Le.resource),a.to(Le.edit.range),Le.edit.text):Se.renameFile(C.URI.revive(Le.oldUri),C.URI.revive(Le.newUri),Le.options);return Se}ge.to=ae})(z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const be=Object.create(null);be[b.SymbolKind.File]=0,be[b.SymbolKind.Module]=1,be[b.SymbolKind.Namespace]=2,be[b.SymbolKind.Package]=3,be[b.SymbolKind.Class]=4,be[b.SymbolKind.Method]=5,be[b.SymbolKind.Property]=6,be[b.SymbolKind.Field]=7,be[b.SymbolKind.Constructor]=8,be[b.SymbolKind.Enum]=9,be[b.SymbolKind.Interface]=10,be[b.SymbolKind.Function]=11,be[b.SymbolKind.Variable]=12,be[b.SymbolKind.Constant]=13,be[b.SymbolKind.String]=14,be[b.SymbolKind.Number]=15,be[b.SymbolKind.Boolean]=16,be[b.SymbolKind.Array]=17,be[b.SymbolKind.Object]=18,be[b.SymbolKind.Key]=19,be[b.SymbolKind.Null]=20,be[b.SymbolKind.EnumMember]=21,be[b.SymbolKind.Struct]=22,be[b.SymbolKind.Event]=23,be[b.SymbolKind.Operator]=24,be[b.SymbolKind.TypeParameter]=25;function ae(Se){return typeof be[Se]=="number"?be[Se]:6}ge.from=ae;function K(Se){for(const Le in be)if(be[Le]===Se)return Number(Le);return b.SymbolKind.Property}ge.to=K})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(ge){function be(K){switch(K){case b.SymbolTag.Deprecated:return 1}}ge.from=be;function ae(K){switch(K){case 1:return b.SymbolTag.Deprecated}}ge.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var x;(function(ge){function be(K){return{name:K.name,kind:N.from(K.kind),tags:K.tags&&K.tags.map(U.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=be;function ae(K){const Se=new b.SymbolInformation(K.name,N.to(K.kind),K.containerName,Q.to(K.location));return Se.tags=K.tags&&K.tags.map(U.to),Se}ge.to=ae})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function be(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:a.from(K.range),selectionRange:a.from(K.selectionRange),kind:N.from(K.kind),tags:K.tags?.map(U.from)??[]};return K.children&&(Se.children=K.children.map(be)),Se}ge.from=be;function ae(K){const Se=new b.DocumentSymbol(K.name,K.detail,N.to(K.kind),a.to(K.range),a.to(K.selectionRange));return(0,g.isNonEmptyArray)(K.tags)&&(Se.tags=K.tags.map(U.to)),K.children&&(Se.children=K.children.map(ae)),Se}ge.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(ge){function be(K){const Se=new b.CallHierarchyItem(N.to(K.kind),K.name,K.detail||"",C.URI.revive(K.uri),a.to(K.range),a.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=be;function ae(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:N.from(K.kind),uri:K.uri,range:a.from(K.range),selectionRange:a.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var H;(function(ge){function be(ae){return new b.CallHierarchyIncomingCall(j.to(ae.from),ae.fromRanges.map(K=>a.to(K)))}ge.to=be})(H=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function be(ae){return new b.CallHierarchyOutgoingCall(j.to(ae.to),ae.fromRanges.map(K=>a.to(K)))}ge.to=be})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function be(K){return{range:K.range&&a.from(K.range),uri:K.uri}}ge.from=be;function ae(K){return new b.Location(C.URI.revive(K.uri),a.to(K.range))}ge.to=ae})(Q=e.location||(e.location={}));var de;(function(ge){function be(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?a.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:a.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?a.from(Se.targetSelectionRange):void 0}}ge.from=be;function ae(K){return{targetUri:C.URI.revive(K.uri),targetRange:a.to(K.range),targetSelectionRange:K.targetSelectionRange?a.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?a.to(K.originSelectionRange):void 0}}ge.to=ae})(de=e.DefinitionLink||(e.DefinitionLink={}));var _e;(function(ge){function be(K){return{range:a.from(K.range),contents:y.fromMany(K.contents)}}ge.from=be;function ae(K){return new b.Hover(K.contents.map(y.to),a.to(K.range))}ge.to=ae})(_e=e.Hover||(e.Hover={}));var Ie;(function(ge){function be(K){return{range:a.from(K.range),expression:K.expression}}ge.from=be;function ae(K){return new b.EvaluatableExpression(a.to(K.range),K.expression)}ge.to=ae})(Ie=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function be(K){if(K instanceof b.InlineValueText)return{type:"text",range:a.from(K.range),text:K.text};if(K instanceof b.InlineValueVariableLookup)return{type:"variable",range:a.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=be;function ae(K){switch(K.type){case"text":return{range:a.to(K.range),text:K.text};case"variable":return{range:a.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:a.to(K.range),expression:K.expression}}}ge.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var We;(function(ge){function be(K){return{frameId:K.frameId,stoppedLocation:a.from(K.stoppedLocation)}}ge.from=be;function ae(K){return new b.InlineValueContext(K.frameId,a.to(K.stoppedLocation))}ge.to=ae})(We=e.InlineValueContext||(e.InlineValueContext={}));var Be;(function(ge){function be(K){return{range:a.from(K.range),kind:K.kind}}ge.from=be;function ae(K){return new b.DocumentHighlight(a.to(K.range),K.kind)}ge.to=ae})(Be=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function be(ae){switch(ae){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=be})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function be(ae){return{triggerKind:He.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ge.to=be})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function be(K){switch(K){case b.CompletionItemTag.Deprecated:return 1}}ge.from=be;function ae(K){switch(K){case 1:return b.CompletionItemTag.Deprecated}}ge.to=ae})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var ie;(function(ge){const be=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ae(Le){return be.get(Le)??9}ge.from=ae;const K=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??b.CompletionItemKind.Property}ge.to=Se})(ie=e.CompletionItemKind||(e.CompletionItemKind={}));var ce;(function(ge){function be(ae,K){const Se=new b.CompletionItem(ae.label);return Se.insertText=ae.insertText,Se.kind=ie.to(ae.kind),Se.tags=ae.tags?.map(ee.to),Se.detail=ae.detail,Se.documentation=D.isMarkdownString(ae.documentation)?y.to(ae.documentation):ae.documentation,Se.sortText=ae.sortText,Se.filterText=ae.filterText,Se.preselect=ae.preselect,Se.commitCharacters=ae.commitCharacters,i.Range.isIRange(ae.range)?Se.range=a.to(ae.range):typeof ae.range=="object"&&(Se.range={inserting:a.to(ae.range.insert),replacing:a.to(ae.range.replace)}),Se.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Se.insertText=new b.SnippetString(ae.insertText):(Se.insertText=ae.insertText,Se.textEdit=Se.range instanceof b.Range?new b.TextEdit(Se.range,Se.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Se.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),Se.command=K&&ae.command?K.fromInternal(ae.command):void 0,Se}ge.to=be})(ce=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function be(K){return{label:K.label,documentation:K.documentation?y.fromStrict(K.documentation):void 0}}ge.from=be;function ae(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?y.to(K.documentation):K.documentation}}ge.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function be(K){return{label:K.label,documentation:K.documentation?y.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=be;function ae(K){return{label:K.label,documentation:D.isMarkdownString(K.documentation)?y.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.from):[]}}ge.from=be;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.to):[]}}ge.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function be(K){return{text:K.text,position:n.from(K.position),kind:je.from(K.kind??b.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=be;function ae(K){const Se=new b.InlayHint(K.text,n.to(K.position),je.to(K.kind));return Se.whitespaceAfter=K.whitespaceAfter,Se.whitespaceBefore=K.whitespaceBefore,Se}ge.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function be(K){return K}ge.from=be;function ae(K){return K}ge.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function be(K){return{range:a.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=be;function ae(K){let Se;if(K.url)try{Se=typeof K.url=="string"?C.URI.parse(K.url,!0):C.URI.revive(K.url)}catch(Le){}return new b.DocumentLink(a.to(K.range),Se)}ge.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function be(K){const Se=new b.ColorPresentation(K.label);return K.textEdit&&(Se.textEdit=M.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>M.to(Le))),Se}ge.to=be;function ae(K){return{label:K.label,textEdit:K.textEdit?M.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>M.from(Se)):void 0}}ge.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function be(K){return new b.Color(K[0],K[1],K[2],K[3])}ge.to=be;function ae(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ae})(rt=e.Color||(e.Color={}));var ct;(function(ge){function be(K){return{range:a.from(K.range)}}ge.from=be;function ae(K){return new b.SelectionRange(a.to(K.range))}ge.to=ae})(ct=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function be(ae){switch(ae){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=be})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function be(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=be;function ae(K){switch(K){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=ae})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function be(K){if(K===b.EndOfLine.CRLF)return 1;if(K===b.EndOfLine.LF)return 0}ge.from=be;function ae(K){if(K===1)return b.EndOfLine.CRLF;if(K===0)return b.EndOfLine.LF}ge.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var ne;(function(ge){function be(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=be})(ne=e.ProgressLocation||(e.ProgressLocation={}));var Ee;(function(ge){function be(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=Qe.from(ae.kind)),K}ge.from=be})(Ee=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function be(ae){if(ae)switch(ae){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=be})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function be(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?a.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.EditorResolution.DISABLED:void 0}}ge.from=be})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(ge){function be(K){return K instanceof b.RelativePattern||typeof K=="string"?K:ae(K)?new b.RelativePattern(K.base,K.pattern):K}ge.from=be;function ae(K){const Se=K;return Se&&typeof Se.base=="string"&&typeof Se.pattern=="string"}})(le=e.GlobPattern||(e.GlobPattern={}));var ke;(function(ge){function be(ae){if(ae){if(Array.isArray(ae))return ae.map(be);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:le.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=be})(ke=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ge){function be(K){return{start:K.start,end:K.end}}ge.from=be;function ae(K){return new b.NotebookRange(K.start,K.end)}ge.to=ae})(Ne=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function be(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=be;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ae})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var nt;(function(ge){function be(K){switch(K){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=be;function ae(K){switch(K){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=ae})(nt=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function be(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)b.NotebookCellData.validate(Le),Se.cells.push(tt.from(Le));return Se}ge.from=be;function ae(K){const Se=new b.NotebookData(K.cells.map(tt.to));return(0,E.isEmptyObject)(K.metadata)||(Se.metadata=K.metadata),Se}ge.to=ae})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function be(K){return{cellKind:nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=be;function ae(K){return new b.NotebookCellData(nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ae})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function be(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ge.from=be;function ae(K){return new b.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ae})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function be(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ge.from=be;function ae(K){const Se=K.items.map(ut.to);return new b.NotebookCellOutput(Se,K.outputId,K.metadata)}ge.to=ae})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var De;(function(ge){function be(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Se(Le))return new b.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:le.from(Le.include)||void 0,exclude:le.from(Le.exclude)||void 0}}}ge.from=be;function ae(Le){return typeof Le=="string"?Le:Se(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ae;function K(Le){const it=Le,Ge=le.from(it.include);if(!(Ge&&Ge instanceof b.RelativePattern||typeof Ge=="string"))return!1;const mt=le.from(it.exclude);return!!(mt&&mt instanceof b.RelativePattern||typeof mt=="string")}function Se(Le){const it=Le;return it&&typeof it.base=="string"&&typeof it.pattern=="string"}})(De=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function be(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?$.from(ae.top):void 0}}ge.from=be})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function be(ae,K,Se){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ge.from=be})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function be(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}ge.from=be})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var we;(function(ge){function be(K){return{uri:K.uri,provides:K.provides}}ge.from=be;function ae(K){return new b.NotebookRendererScript(C.URI.revive(K.uri),K.provides)}ge.to=ae})(we=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ve;(function(ge){function be(K){return{message:y.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=be;function ae(K){const Se=new b.TestMessage(typeof K.message=="string"?K.message:y.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.location=K.location?Q.to(K.location):void 0,Se}ge.to=ae})(ve=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let be;(function(ae){ae.Delimiter="\0"})(be||(be={})),ge.namespace=(ae,K)=>ae+"\0"+K,ge.denamespace=ae=>{const K=ae.indexOf("\0");return{ctrlId:ae.slice(0,K),tagId:ae.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function be(Le){const it=(0,f.getPrivateApiFor)(Le).controllerId;return{extId:_.TestId.fromExtHostTestItem(Le,it).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(it,Ge.id)),range:a.from(Le.range)||null,description:Le.description||null,error:Le.error&&y.fromStrict(Le.error)||null}}ge.from=be;function ae(Le){return{parent:void 0,error:void 0,id:_.TestId.fromString(Le.extId).localId,label:Le.label,uri:C.URI.revive(Le.uri),tags:(Le.tags||[]).map(it=>{const{tagId:Ge}=Fe.denamespace(it);return new b.TestTag(Ge)}),range:a.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ae;function K(Le){const it=_.TestId.fromString(Le.extId),Ge=new f.TestItemImpl(it.controllerId,it.localId,Le.label,C.URI.revive(Le.uri));return Ge.range=a.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Se(Le){let it;for(const Ge of Le.tests){const mt=K(Ge.item);(0,f.getPrivateApiFor)(mt).parent=it,it=mt}return it}ge.toItemFromContext=Se})(qe=e.TestItem||(e.TestItem={})),function(ge){function be(K){return{id:K.id}}ge.from=be;function ae(K){return new b.TestTag(K.id)}ge.to=ae}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const be=(K,Se)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(it=>({state:it.state,duration:it.duration,messages:it.messages.filter(Ge=>Ge.type===0).map(ve.to)})),children:K.children.map(it=>Se.get(it)).filter(E.isDefined).map(it=>be(it,Se))};for(const it of Le.children)it.parent=Le;return Le};function ae(K){const Se=[],Le=new Map;for(const it of K.items)Le.set(it.item.extId,it),K.request.targets.some(Ge=>Ge.controllerId===it.controllerId&&Ge.testIds.includes(it.item.extId))&&Se.push(it);return{completedAt:K.completedAt,results:Se.map(it=>be(it,Le))}}ge.to=ae})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function be(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?n.from(Le):a.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(it=>({count:it.executionCount,location:it.location&&ae(it.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}ge.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:be(Le.statementCoverage),branch:Le.branchCoverage&&be(Le.branchCoverage),function:Le.functionCoverage&&be(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Se})(Ye=e.TestCoverage||(e.TestCoverage={}));var lt;(function(ge){function be(ae){switch(ae){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=be})(lt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function be(K){const Se=new b.TypeHierarchyItem(N.to(K.kind),K.name,K.detail||"",C.URI.revive(K.uri),a.to(K.range),a.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ge.to=be;function ae(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:N.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:a.from(K.range),selectionRange:a.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[221],me([0,1,2,18,7,17,93]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(C,i,I,c={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,c)=>{const f={dispose:this._callbacks.push([i,I,C])};return Array.isArray(c)&&c.push(f),f}}async $participateInSave(C,i){const I=g.URI.revive(C);let c=!1;const p=setTimeout(()=>c=!0,this._thresholds.timeout),f=[];try{for(let w of[...this._callbacks]){if(c)break;const _=this._documents.getDocument(I),P=await this._deliverEventAsyncAndBlameBadListeners(w,{document:_,reason:S.TextDocumentSaveReason.to(i)});f.push(P)}}finally{clearTimeout(p)}return f}_deliverEventAsyncAndBlameBadListeners([C,i,I],c){const p=this._badListeners.get(C);return typeof p=="number"&&p>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,c).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const w=this._badListeners.get(C);this._badListeners.set(C,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,c){const p=[],f=Date.now(),{document:w,reason:_}=c,{version:P}=w,b=Object.freeze({document:w,reason:_,waitUntil(s){if(Object.isFrozen(p))throw(0,L.illegalState)("waitUntil can not be called async");p.push(Promise.resolve(s))}});try{i.apply(I,[b])}catch(s){return Promise.reject(s)}return Object.freeze(p),new Promise((s,a)=>{const v=setTimeout(()=>a(new Error("timeout")),this._thresholds.timeout);return Promise.all(p).then(n=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(v),s(n)}).catch(n=>{clearTimeout(v),a(n)})}).then(s=>{const a={edits:[]};for(const v of s)if(Array.isArray(v)&&v.every(n=>n instanceof D.TextEdit))for(const{newText:n,newEol:h,range:r}of v)a.edits.push({_type:2,resource:w.uri,edit:{range:r&&S.Range.from(r),text:n,eol:h&&S.EndOfLine.from(h)}});if(a.edits.length!==0)return P===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(fe[222],me([0,1,3,30,2,17,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(i,I,c,p,f){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),p&&(this._config+=2),f&&(this._config+=4);const w=(0,L.parse)(I),_=i(P=>{if(!c)for(let b of P.created){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidCreate.fire(s)}if(!p)for(let b of P.changed){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidChange.fire(s)}if(!f)for(let b of P.deleted){const s=D.URI.revive(b);w(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=A.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,_)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class E{constructor(i,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(i,I,c,p){return new k(this._onFileSystemEvent.event,i,I,c,p)}$onFileEvent(i){this._onFileSystemEvent.fire(i)}$onDidRunFileOperation(i,I){switch(i){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:D.URI.revive(c.source),newUri:D.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>D.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>D.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(i){return this._createWillExecuteEvent(i,this._onWillRenameFile)}getOnWillCreateFileEvent(i){return this._createWillExecuteEvent(i,this._onWillCreateFile)}getOnWillDeleteFileEvent(i){return this._createWillExecuteEvent(i,this._onWillDeleteFile)}_createWillExecuteEvent(i,I){return(c,p,f)=>{const w=function(P){c.call(p,P)};return w.extension=i,I.event(w,void 0,f)}}async $onWillRunFileOperation(i,I,c,p){switch(i){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(f=>({oldUri:D.URI.revive(f.source),newUri:D.URI.revive(f.target)}))},c,p);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(f=>D.URI.revive(f.target))},c,p);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(f=>D.URI.revive(f.target))},c,p)}}async _fireWillEvent(i,I,c,p){const f=new Set,w=[];if(await i.fireAsync(I,p,async(P,b)=>{const s=Date.now(),a=await Promise.resolve(P);a instanceof A.WorkspaceEdit&&(w.push(a),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-s>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),p.isCancellationRequested||w.length===0)return;const _={edits:[]};for(let P of w){let{edits:b}=S.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);_.edits=_.edits.concat(b)}return{edit:_,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=E}),define(fe[223],me([0,1,10,25,2,17,7,125]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(c,p,f,w){this.start=c,this.deletedCount=p,this.deletedItems=f,this.items=w}static asApiEvents(c){return c.map(p=>({start:p.start,deletedCount:p.deletedCount,deletedItems:p.deletedItems,items:p.items.map(f=>f.apiCell)}))}}class C{constructor(c,p,f){this.notebook=c,this._extHostDocument=p,this._cellData=f,this.handle=f.handle,this.uri=D.URI.revive(f.uri),this.cellKind=f.cellKind,this._outputs=f.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=f.internalMetadata??{},this._metadata=Object.freeze(f.metadata??{}),this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(f.internalMetadata??{}))}static asModelAddData(c,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,p=this._extHostDocument.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:p.document,get mime(){return c._mime},set mime(f){c._mime=f},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(S.NotebookCellOutput.to)}setOutputItems(c,p,f){const w=f.map(S.NotebookCellOutputItem.to),_=this._outputs.find(P=>P.id===c);_&&(p||(_.items.length=0),_.items.push(...w))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(S.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=C;class i{constructor(c,p,f,w,_,P){this._proxy=c,this._textDocumentsAndEditors=p,this._textDocuments=f,this._emitter=w,this.uri=_,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=P.viewType,this._metadata=Object.freeze(P.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,P.cells]],!0),this._versionId=P.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(p){return p=c._validateIndex(p),c._cells[p].apiCell},getCells(p){return(p?c._getCells(p):c._cells).map(w=>w.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,p){this._versionId=c.versionId,this._isDirty=p;for(const f of c.rawEvents)f.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(f.changes,!1):f.kind===k.NotebookCellsChangeType.Move?this._moveCell(f.index,f.newIdx):f.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(f.index,f.outputs):f.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(f.index,f.outputId,f.append,f.outputItems):f.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(f.index,f.language):f.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(f.index,f.mime):f.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(f.index,f.metadata):f.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(f.index,f.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let p=c.start|0,f=c.end|0;return p<0&&(p=0),f>this._cells.length&&(f=this._cells.length),c.with({start:p,end:f})}_getCells(c){c=this._validateRange(c);const p=[];for(let f=c.start;f<c.end;f++)p.push(this._cells[f]);return p}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,p){if(this._disposed)return;const f=[],w=[],_=[];c.reverse().forEach(P=>{const s=P[2].map(n=>{const h=new C(this,this._textDocumentsAndEditors,n);return p||w.push(C.asModelAddData(this.apiNotebook,n)),h}),a=new E(P[0],P[1],[],s),v=this._cells.splice(P[0],P[1],...s);for(const n of v)_.push(n.uri),a.deletedItems.push(n.apiCell);f.push(a)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:_}),p||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(f)}))}_moveCell(c,p){const f=this._cells.splice(c,1);this._cells.splice(p,0,...f);const w=[new E(c,1,f.map(_=>_.apiCell),[]),new E(p,0,[],f)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(w)}))}_setCellOutputs(c,p){const f=this._cells[c];f.setOutputs(p),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[f.apiCell]}))}_setCellOutputItems(c,p,f,w){const _=this._cells[c];_.setOutputItems(p,f,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[_.apiCell]}))}_changeCellLanguage(c,p){const f=this._cells[c];f.apiCell.document.languageId!==p&&this._textDocuments.$acceptModelModeChanged(f.uri,p)}_changeCellMime(c,p){const f=this._cells[c];f.apiCell.mime=p}_changeCellMetadata(c,p){const f=this._cells[c],w=f.apiCell.metadata;f.setMetadata(p);const _=f.apiCell.metadata;(0,L.equals)(w,_)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell}))}_changeCellInternalMetadata(c,p){const f=this._cells[c],w=f.internalMetadata;if(f.setInternalMetadata(p),w.runState!==p.runState){const _=p.runState??A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,state:_}))}}getCellFromApiCell(c){return this._cells.find(p=>p.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(p=>p.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(fe[128],me([0,1,7,17,18]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:C})}replaceCells(E,C,i){this._throwIfFinalized(),!(E===C&&i.length===0)&&this._collectedEdits.push({editType:1,index:E,count:C-E,cells:i.map(L.NotebookCellData.from)})}}class A{constructor(E,C,i,I,c,p){this.id=E,this._proxy=C,this.notebookData=i,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=p}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get selections(){return E._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw(0,D.illegalArgument)("selections");E._selections=C,E._trySetSelections(C)},get visibleRanges(){return E._visibleRanges},revealRange(C,i){E._proxy.$tryRevealRange(E.id,L.NotebookRange.from(C),i??g.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(C){const i=new S(this.document.version);return C(i),E._applyEdit(i.finalize())},setDecorations(C,i){return E.setDecorations(C,i)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(L.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const C=[];let i=-1;for(let I=0;I<E.cellEdits.length;I++){if(i<0){C.push(E.cellEdits[I]),i++;continue}const p=C[i],f=E.cellEdits[I];if(p.editType===1&&f.editType===1&&p.index===f.index){p.cells.push(...E.cellEdits[I].cells),p.count+=E.cellEdits[I].count;continue}C.push(E.cellEdits[I]),i++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,C)}setDecorations(E,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(E.key)))return C.isEmpty?this._hasDecorationsForKey.delete(E.key):this._hasDecorationsForKey.add(E.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(C),E.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(fe[224],me([0,1,17,116,166,21,59,18]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,p,f){const w=this._handles++,{title:_,location:P,cancellable:b}=p,s={label:(0,D.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(P),title:_,source:s,cancellable:b},c).catch(k.onUnexpectedExternalError),this._withProgress(w,f,!!b)}_withProgress(c,p,f){let w;f&&(w=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,w));const _=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let P;try{P=p(new i(this._proxy,c),f&&w?w.token:S.CancellationToken.None)}catch(b){throw _(c),b}return P.then(b=>_(c),b=>_(c)),P}$acceptProgressCanceled(c){const p=this._mapHandleToCancellationSource.get(c);p&&(p.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=E;function C(I,c){return I.message=c.message,typeof c.increment=="number"&&(typeof I.increment=="number"?I.increment+=c.increment:I.increment=c.increment),I}class i extends L.Progress{constructor(c,p){super(f=>this.throttledReport(f));this._proxy=c,this._handle=p}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Ve([(0,A.throttle)(100,(I,c)=>C(I,c),()=>Object.create(null))],i.prototype,"throttledReport",null)}),define(fe[129],me([0,1,57,18,76,17,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,p,f){const w=k._Keys.nextId();c.$registerTextEditorDecorationType(p.identifier,w,S.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:w,dispose(){c.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(c,p){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=p.undoStopBefore,this._undoStopAfter=p.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,p){this._throwIfFinalized();let f=null;if(c instanceof A.Position)f=new A.Range(c,c);else if(c instanceof A.Range)f=c;else throw new Error("Unrecognized location");this._pushEdit(f,p,!1)}insert(c,p){this._throwIfFinalized(),this._pushEdit(new A.Range(c,c),p,!0)}delete(c){this._throwIfFinalized();let p=null;if(c instanceof A.Range)p=c;else throw new Error("Unrecognized location");this._pushEdit(p,null,!0)}_pushEdit(c,p,f){const w=this._document.validateRange(c);this._collectedEdits.push({range:w,text:p,forceMoveMarkers:f})}setEndOfLine(c){if(this._throwIfFinalized(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=E;class C{constructor(c,p,f,w){this._proxy=c,this._id=p,this._accept(f),this._logService=w;const _=this;this.value={get tabSize(){return _._tabSize},set tabSize(P){_._setTabSize(P)},get insertSpaces(){return _._insertSpaces},set insertSpaces(P){_._setInsertSpaces(P)},get cursorStyle(){return _._cursorStyle},set cursorStyle(P){_._setCursorStyle(P)},get lineNumbers(){return _._lineNumbers},set lineNumbers(P){_._setLineNumbers(P)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}_setTabSize(c){const p=this._validateTabSize(c);if(p!==null){if(typeof p=="number"){if(this._tabSize===p)return;this._tabSize=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:p}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const p=this._validateInsertSpaces(c);if(typeof p=="boolean"){if(this._insertSpaces===p)return;this._insertSpaces=p}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:p}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let f=!1;if(typeof c.tabSize!="undefined"){const w=this._validateTabSize(c.tabSize);w==="auto"?(f=!0,p.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,f=!0,p.tabSize=w)}if(typeof c.insertSpaces!="undefined"){const w=this._validateInsertSpaces(c.insertSpaces);w==="auto"?(f=!0,p.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,f=!0,p.insertSpaces=w)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,f=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,f=!0,p.lineNumbers=S.TextEditorLineNumbersStyle.from(c.lineNumbers)),f&&this._warnOnError(this._proxy.$trySetOptions(this._id,p))}_warnOnError(c){c.catch(p=>this._logService.warn(p))}}e.ExtHostTextEditorOptions=C;class i{constructor(c,p,f,w,_,P,b,s){this.id=c,this._proxy=p,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=_,this._options=new C(this._proxy,this.id,P,f),this._visibleRanges=b,this._viewColumn=s;const a=this;this.value=Object.freeze({get document(){return w.getValue()},set document(v){throw(0,L.readonly)("document")},get selection(){return a._selections&&a._selections[0]},set selection(v){if(!(v instanceof A.Selection))throw(0,L.illegalArgument)("selection");a._selections=[v],a._trySetSelection()},get selections(){return a._selections},set selections(v){if(!Array.isArray(v)||v.some(n=>!(n instanceof A.Selection)))throw(0,L.illegalArgument)("selections");a._selections=v,a._trySetSelection()},get visibleRanges(){return a._visibleRanges},set visibleRanges(v){throw(0,L.readonly)("visibleRanges")},get options(){return a._options.value},set options(v){a._disposed||a._options.assign(v)},get viewColumn(){return a._viewColumn},set viewColumn(v){throw(0,L.readonly)("viewColumn")},edit(v,n={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new E(w.getValue(),n);return v(h),a._applyEdit(h)},insertSnippet(v,n,h={undoStopBefore:!0,undoStopAfter:!0}){if(a._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=a._selections.map(t=>S.Range.from(t));else if(n instanceof A.Position){const{lineNumber:t,column:l}=S.Position.from(n);r=[{startLineNumber:t,startColumn:l,endLineNumber:t,endColumn:l}]}else if(n instanceof A.Range)r=[S.Range.from(n)];else{r=[];for(const t of n)if(t instanceof A.Range)r.push(S.Range.from(t));else{const{lineNumber:l,column:o}=S.Position.from(t);r.push({startLineNumber:l,startColumn:o,endLineNumber:l,endColumn:o})}}return p.$tryInsertSnippet(c,v.value,r,h)},setDecorations(v,n){const h=n.length===0;h&&!a._hasDecorationsForKey.has(v.key)||(h?a._hasDecorationsForKey.delete(v.key):a._hasDecorationsForKey.add(v.key),a._runOnProxy(()=>{if(S.isDecorationOptionsArr(n))return p.$trySetDecorations(c,v.key,S.fromRangeOrRangeWithMessage(n));{const r=new Array(4*n.length);for(let t=0,l=n.length;t<l;t++){const o=n[t];r[4*t]=o.start.line+1,r[4*t+1]=o.start.character+1,r[4*t+2]=o.end.line+1,r[4*t+3]=o.end.character+1}return p.$trySetDecorationsFast(c,v.key,r)}}))},revealRange(v,n){a._runOnProxy(()=>p.$tryRevealRange(c,S.Range.from(v),n||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(c,S.ViewColumn.from(v))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const f=p.edits.map(_=>_.range);f.sort((_,P)=>_.end.line===P.end.line?_.end.character===P.end.character?_.start.line===P.start.line?_.start.character-P.start.character:_.start.line-P.start.line:_.end.character-P.end.character:_.end.line-P.end.line);for(let _=0,P=f.length-1;_<P;_++){const b=f[_].end;if(f[_+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=p.edits.map(_=>({range:S.Range.from(_.range),text:_.text,forceMoveMarkers:_.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,p.documentVersionId,w,{setEndOfLine:typeof p.setEndOfLine=="number"?S.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this._logService.warn(p),null))}}e.ExtHostTextEditor=i}),define(fe[225],me([0,1,169,23,2,3,6,211,16,7,13,15,17,21,208]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,s){if((0,i.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let a;return Array.isArray(b.highlights)&&(a=b.highlights.filter(v=>v.length===2&&typeof v[0]=="number"&&typeof v[1]=="number"),a=a.length?a:void 0),{label:b.label,highlights:a}}}class _{constructor(s,a,v){this._proxy=s,this.commands=a,this.logService=v,this.treeViews=new Map;function n(h){return h&&h.$treeViewId&&h.$treeItemHandle}a.registerArgumentProcessor({processArgument:h=>n(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(r=>n(r)?this.convertArgument(r):r):h})}registerTreeDataProvider(s,a,v){const n=this.createTreeView(s,{treeDataProvider:a},v);return{dispose:()=>n.dispose()}}createTreeView(s,a,v){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=a.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,canDragAndDrop:n}),r=this.createExtHostTreeView(s,a,v);return{get onDidCollapseElement(){return r.onDidCollapseElement},get onDidExpandElement(){return r.onDidExpandElement},get selection(){return r.selectedElements},get onDidChangeSelection(){return r.onDidChangeSelection},get visible(){return r.visible},get onDidChangeVisibility(){return r.onDidChangeVisibility},get message(){return r.message},set message(t){r.message=t},get title(){return r.title},set title(t){r.title=t},get description(){return r.description},set description(t){r.description=t},reveal:(t,l)=>r.reveal(t,l),dispose:async()=>{await h,this.treeViews.delete(s),r.dispose()}}}$getChildren(s,a){const v=this.treeViews.get(s);return v?v.getChildren(a):Promise.reject(new Error((0,g.localize)(0,null,s)))}async $onDrop(s,a,v){const n=this.treeViews.get(s);if(!n)return Promise.reject(new Error((0,g.localize)(1,null,s)));const h=f.TreeDataTransferConverter.toITreeDataTransfer(a);if(h.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await h.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(l=>n.getExtensionElement(l)).filter(l=>!!l);t.length>0?h.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):h.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return n.onDrop(h,v)}async $hasResolve(s){const a=this.treeViews.get(s);if(!a)throw new Error((0,g.localize)(2,null,s));return a.hasResolve}$resolve(s,a,v){const n=this.treeViews.get(s);if(!n)throw new Error((0,g.localize)(3,null,s));return n.resolveTreeItem(a,v)}$setExpanded(s,a,v){const n=this.treeViews.get(s);if(!n)throw new Error((0,g.localize)(4,null,s));n.setExpanded(a,v)}$setSelection(s,a){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(5,null,s));v.setSelection(a)}$setVisible(s,a){const v=this.treeViews.get(s);if(!v)throw new Error((0,g.localize)(6,null,s));v.setVisible(a)}createExtHostTreeView(s,a,v){const n=new P(s,a,this._proxy,this.commands.converter,this.logService,v);return this.treeViews.set(s,n),n}convertArgument(s){const a=this.treeViews.get(s.$treeViewId);return a?a.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=_;class P extends A.Disposable{constructor(s,a,v,n,h,r){super();if(this.viewId=s,this.proxy=v,this.commands=n,this.logService=h,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new p.CancellationTokenSource,r.contributes&&r.contributes.views)for(const o in r.contributes.views)for(const d of r.contributes.views[o])d.id===s&&(this._title=d.name);this.dataProvider=a.treeDataProvider,this.dndController=a.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(o=>this._onDidChangeData.fire({message:!1,element:o}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let t,l;this._register(S.Event.debounce(this._onDidChangeData.event,(o,d)=>(o||(o={message:!1,elements:[]}),d.element!==!1&&(t||(t=new Promise(m=>l=m),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(d.element)?o.elements.push(...d.element):o.elements.push(d.element)),d.message&&(o.message=!0),o),200,!0)(({message:o,elements:d})=>{d.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=l;return t=null,this.refresh(d).then(()=>m())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,i.isUndefinedOrNull)(s))}async getChildren(s){const a=s?this.getExtensionElement(s):void 0;if(s&&!a)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let v=this.getChildrenNodes(s);return v||(v=await this.fetchChildrenNodes(a)),v?v.map(n=>n.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,a){a=a||{select:!0,focus:!1};const v=(0,i.isUndefinedOrNull)(a.select)?!0:a.select,n=(0,i.isUndefinedOrNull)(a.focus)?!1:a.focus,h=(0,i.isUndefinedOrNull)(a.expand)?!1:a.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(r=>this.resolveTreeNode(s,r[r.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:r.map(l=>l.item)},{select:v,focus:n,expand:h})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:v,focus:n,expand:h})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,a){const v=this.getExtensionElement(s);v&&(a?this._onDidExpandElement.fire(Object.freeze({element:v})):this._onDidCollapseElement.fire(Object.freeze({element:v})))}setSelection(s){(0,I.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,a){const v=this.getExtensionElement(a);if(!!v)return(0,E.asPromise)(()=>this.dndController?.onDrop(s,v))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,a){if(!this.dataProvider.resolveTreeItem)return;const v=this.elements.get(s);if(v){const n=this.nodes.get(v);if(n){const h=await this.dataProvider.resolveTreeItem(n.extensionItem,v,a)??n.extensionItem;return n.item.tooltip=this.getTooltip(h.tooltip),n.item.command=this.getCommand(n.disposableStore,h.command),n.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(a=>a?this.resolveUnknownParentChain(a).then(v=>this.resolveTreeNode(a,v[v.length-1]).then(n=>(v.push(n),v))):Promise.resolve([]))}resolveParent(s){const a=this.nodes.get(s);return a?Promise.resolve(a.parent?this.elements.get(a.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,a){const v=this.nodes.get(s);return v?Promise.resolve(v):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(n=>this.createHandle(s,n,a,!0)).then(n=>this.getChildren(a?a.item.handle:void 0).then(()=>{const h=this.getExtensionElement(n);if(h){const r=this.nodes.get(h);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${n}`)}))}getChildrenNodes(s){if(s){let a;if(typeof s=="string"){const v=this.getExtensionElement(s);a=v?this.nodes.get(v):void 0}else a=s;return a&&a.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const a=new p.CancellationTokenSource(this._refreshCancellationSource.token);try{const v=s?this.nodes.get(s):void 0,n=await this.dataProvider.getChildren(s);if(a.token.isCancellationRequested)return;const h=await Promise.all((0,I.coalesce)(n||[]).map(async r=>{const t=await this.dataProvider.getTreeItem(r);return t&&!a.token.isCancellationRequested?this.createAndRegisterTreeNode(r,t,v):null}));return a.token.isCancellationRequested?void 0:(0,I.coalesce)(h)}finally{a.dispose()}}refresh(s){if(s.some(v=>!v))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new p.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const v=this.getHandlesToRefresh(s);if(v.length)return this.refreshHandles(v)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const a=new Set,v=s.map(h=>this.nodes.get(h));for(const h of v)if(h&&!a.has(h.item.handle)){let r=h;for(;r&&r.parent&&v.findIndex(t=>r&&r.parent&&t&&t.item.handle===r.parent.item.handle)===-1;){const t=this.elements.get(r.parent.item.handle);r=t?this.nodes.get(t):void 0}r&&!r.parent&&a.add(h.item.handle)}const n=[];return a.forEach(h=>{const r=this.elements.get(h);if(r){const t=this.nodes.get(r);t&&(!t.parent||!a.has(t.parent.item.handle))&&n.push(h)}}),n}refreshHandles(s){const a={};return Promise.all(s.map(v=>this.refreshNode(v).then(n=>{n&&(a[v]=n.item)}))).then(()=>Object.keys(a).length?this.proxy.$refresh(this.viewId,a):void 0)}refreshNode(s){const a=this.getExtensionElement(s);if(a){const v=this.nodes.get(a);if(v)return this.clearChildren(a),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(a)).then(n=>{if(n){const h=this.createTreeNode(a,n,v.parent);return this.updateNodeCache(a,h,v,v.parent),v.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,a,v){const n=this.createTreeNode(s,a,v);if(a.id&&this.elements.has(n.item.handle))throw new Error((0,g.localize)(7,null,a.id));return this.addNodeToCache(s,n),this.addNodeToParentCache(n,v),n}getTooltip(s){return C.MarkdownString.isMarkdownString(s)?c.MarkdownString.from(s):s}getCommand(s,a){return a?this.commands.toInternal(a,s):void 0}createTreeNode(s,a,v){const n=new A.DisposableStore,h=this.createHandle(s,a,v),r=this.getLightIconPath(a);return{item:{handle:h,parentHandle:v?v.item.handle:void 0,label:w(a.label,this.extension),description:a.description,resourceUri:a.resourceUri,tooltip:this.getTooltip(a.tooltip),command:this.getCommand(n,a.command),contextValue:a.contextValue,icon:r,iconDark:this.getDarkIconPath(a)||r,themeIcon:this.getThemeIcon(a),collapsibleState:(0,i.isUndefinedOrNull)(a.collapsibleState)?C.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation},extensionItem:a,parent:v,children:void 0,disposableStore:n,dispose(){n.dispose()}}}getThemeIcon(s){return s.iconPath instanceof C.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:a,label:v,resourceUri:n},h,r){if(a)return`${P.ID_HANDLE_PREFIX}/${a}`;const t=w(v,this.extension),l=h?h.item.handle:P.LABEL_HANDLE_PREFIX;let o=t?t.label:n?(0,L.basename)(n):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const d=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,m=this.getChildrenNodes(h)||[];let u,y=0;do{if(u=`${l}/${y}:${o}`,r||!this.elements.has(u)||d===u)break;y++}while(y<=m.length);return u}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof C.ThemeIcon))return typeof s.iconPath=="string"||D.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof C.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return D.URI.isUri(s)?s:D.URI.file(s)}addNodeToCache(s,a){this.elements.set(a.item.handle,s),this.nodes.set(s,a)}updateNodeCache(s,a,v,n){this.elements.delete(a.item.handle),this.nodes.delete(s),a.item.handle!==v.item.handle&&this.elements.delete(v.item.handle),this.addNodeToCache(s,a);const h=this.getChildrenNodes(n)||[],r=h.filter(t=>t.item.handle===v.item.handle)[0];r&&h.splice(h.indexOf(r),1,a)}addNodeToParentCache(s,a){a?(a.children||(a.children=[]),a.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const a=this.nodes.get(s);if(a){if(a.children)for(const v of a.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}a.children=void 0}}else this.clearAll()}clear(s){const a=this.nodes.get(s);if(a){if(a.children)for(const v of a.children){const n=this.elements.get(v.item.handle);n&&this.clear(n)}this.nodes.delete(s),this.elements.delete(a.item.handle),a.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}P.LABEL_HANDLE_PREFIX="0",P.ID_HANDLE_PREFIX="1"}),define(fe[226],me([0,1,16,3,6,13,65,17,126,89]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class i extends D.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new A.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const p of this.tree.values())this.updateExpandability(p)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const p=this.diff[this.diff.length-1];if(p&&c[0]===1){if(p[0]===1&&p[1].extId===c[1].extId){(0,E.applyTestItemUpdate)(p[1],c[1]);return}if(p[0]===0&&p[1].item.extId===c[1].extId){(0,E.applyTestItemUpdate)(p[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,p){const f=this.tree.get(c);if(!!f){if((f.expandLevels===void 0||p>f.expandLevels)&&(f.expandLevels=p),f.expand===1){const w=this.resolveChildren(f);return w.isOpen()?this.expandChildren(f,p-1):w.wait().then(()=>this.expandChildren(f,p-1))}else if(f.expand===3)return f.resolveBarrier?.isOpen()===!1?f.resolveBarrier.wait().then(()=>this.expandChildren(f,p-1)):this.expandChildren(f,p-1)}}dispose(){for(const c of this.tree.values())(0,A.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,p){switch(p.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(C.TestId.joinToString(c.fullId,p.id));break;case 0:this.upsertItem(p.item,c);break;case 4:for(const b of p.ops)this.onTestItemEvent(c,b);break;case 3:const{key:f,value:w,previous:_}=p,P=c.fullId.toString();switch(f){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(w,_,P);break;case"range":this.pushDiff([1,{extId:P,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:P,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:P,item:{[f]:w??null}}]);break}break;default:(0,S.assertNever)(p)}}upsertItem(c,p){if(!(c instanceof A.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const f=C.TestId.fromExtHostTestItem(c,this.root.id,p?.actual),w=(0,A.getPrivateApiFor)(c);w.parent&&w.parent!==p?.actual&&w.parent.children.delete(c.id);let _=this.tree.get(f.toString());if(!_){_={fullId:f,actual:c,parent:p?f.parentId:null,expandLevels:p?.expandLevels?p.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(c,p),this.pushDiff([0,{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:k.TestItem.from(c)}]),this.connectItemAndChildren(c,_,p);return}if(_.actual===c){this.connectItem(c,_,p);return}const P=_.actual.children,b=_.actual,s=(0,A.diffTestItems)(b,c);(0,A.getPrivateApiFor)(b).listener=void 0,_.actual=c,_.expand=0;for(const[a,v]of s)this.onTestItemEvent(_,{op:3,key:a,value:v,previous:b[a]});this.connectItemAndChildren(c,_,p);for(const a of P)c.children.get(a.id)||this.removeItem(C.TestId.joinToString(f,a.id))}diffTagRefs(c,p,f){const w=new Set(p.map(_=>_.id));for(const _ of c)w.delete(_.id)||this.incrementTagRefs(_);this.pushDiff([1,{extId:f,item:{tags:c.map(_=>k.TestTag.namespace(this.controllerId,_.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const p=this.tags.get(c.id);p?p.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const p=this.tags.get(c);p&&!--p.refCount&&(this.tags.delete(c),this.pushDiff([6,k.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,p){(0,A.getPrivateApiFor)(c).parent=p&&p.actual!==this.root?p.actual:void 0}connectItem(c,p,f){this.setItemParent(c,f);const w=(0,A.getPrivateApiFor)(c);w.parent=f?.actual,w.listener=_=>this.onTestItemEvent(p,_),this.updateExpandability(p)}connectItemAndChildren(c,p,f){this.connectItem(c,p,f);for(const w of c.children)this.upsertItem(w,p)}updateExpandability(c){let p;this._resolveHandler?c.resolveBarrier?p=c.resolveBarrier.isOpen()?3:2:p=c.actual.canResolveChildren?1:0:p=0,p!==c.expand&&(c.expand=p,this.pushDiff([1,{extId:c.fullId.toString(),expand:p}]),p===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,p){if(p<0)return;const f=[];for(const w of c.actual.children){const _=this.expand(C.TestId.joinToString(c.fullId,w.id),p);(0,g.isThenable)(_)&&f.push(_)}if(f.length)return Promise.all(f).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const _=new g.Barrier;return _.open(),_}c.expand=2,this.pushExpandStateUpdate(c);const p=c.resolveBarrier=new g.Barrier,f=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=_.stack||_.message||String(_))};let w;try{w=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(_){f(_)}return(0,g.isThenable)(w)?w.catch(f).then(()=>{p.open(),this.updateExpandability(c)}):(p.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const p=this.tree.get(c);if(!p)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const f=[p];for(;f.length;){const w=f.pop();if(!!w){(0,A.getPrivateApiFor)(w.actual).listener=void 0;for(const _ of w.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(w.fullId.toString());for(const _ of w.actual.children)f.push(this.tree.get(C.TestId.joinToString(w.fullId,_.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=i}),define(fe[227],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[228],me([0,1,26,3,9]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=S;class A{constructor(i){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(c=>I.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const c=A._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(p=>p.identifier)),I.length>0){const p=new Set;I.forEach(f=>p.add(g.ExtensionIdentifier.toKey(f))),this._extensionDescriptions=this._extensionDescriptions.filter(f=>!p.has(g.ExtensionIdentifier.toKey(f.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(c)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(_){this._nodesSet.has(_)||(this._nodesSet.add(_),this._nodesArr.push(_))}addArc(_,P){this.addNode(_),this.addNode(P),this._arcs.has(_)?this._arcs.get(_).push(P):this._arcs.set(_,[P])}getArcs(_){return this._arcs.has(_)?this._arcs.get(_):[]}hasOnlyGoodArcs(_,P){const b=I.getArcs(_);for(let s=0;s<b.length;s++)if(!P.has(b[s]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let _ of i){const P=g.ExtensionIdentifier.toKey(_.identifier);if(c.set(P,_),_.extensionDependencies)for(let b of _.extensionDependencies){const s=g.ExtensionIdentifier.toKey(b);I.addArc(P,s)}}let p=new Set;I.getNodes().filter(_=>I.getArcs(_).length===0).forEach(_=>p.add(_));let f=I.getNodes().filter(_=>!p.has(_)),w;do{w=!1;for(let _=0;_<f.length;_++){const P=f[_];I.hasOnlyGoodArcs(P,p)&&(f.splice(_,1),_--,p.add(P),w=!0)}}while(w);return f.map(_=>c.get(_))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=A;var k;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(k||(k={}));function E(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==c)return I-c;const p=D.posix.basename(C.extensionLocation.path),f=D.posix.basename(i.extensionLocation.path);return p<f?-1:p>f?1:0}}),define(fe[229],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function S(k){const E=g.VSBuffer.alloc(1);switch(k){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=S;function A(k,E){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=A}),define(fe[130],me([0,1,3,2,4,26,195]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");var k;(function(b){b[b.None=0]="None",b[b.LocalProcess=1]="LocalProcess",b[b.LocalWebWorker=2]="LocalWebWorker",b[b.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function E(b){switch(b){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=E;class C{constructor(s){this.dependency=s}}e.MissingExtensionDependency=C;var i;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(i=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(b){switch(b){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;class c{constructor(s,a,v,n){this.codeLoadingTime=s,this.activateCallTime=a,this.activateResolvedTime=v,this.activationReason=n}}e.ActivationTimes=c;class p{constructor(s,a){this.description=s,this.value=a}}e.ExtensionPointContribution=p,e.ExtensionHostLogFileName="exthost";var f;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(f=e.ActivationKind||(e.ActivationKind={}));function w(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,A.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=w;function _(b,s){return{identifier:new S.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!s,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=_;class P{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(s){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(s){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(s,a){return Promise.resolve()}_onWillActivateExtension(s){}_onDidActivateExtension(s,a,v,n,h){}_onDidActivateExtensionError(s,a){}_onExtensionRuntimeError(s,a){}_onExtensionHostExit(s){}}e.NullExtensionService=P}),define(fe[230],me([0,1,26,130,11]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class A{constructor(f,w,_,P){this.startup=f,this.codeLoadingTime=w,this.activateCallTime=_,this.activateResolvedTime=P}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class k{constructor(f){this._startup=f,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(f,w){return f===-1||w===-1?-1:w-f}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class E{constructor(f,w,_,P,b,s){this.activationFailed=f,this.activationFailedError=w,this.activationTimes=_,this.module=P,this.exports=b,this.subscriptions=s}}e.ActivatedExtension=E;class C extends E{constructor(f){super(!1,null,f,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends E{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends E{constructor(f){super(!0,f,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(f,w,_,P,b){this._logService=b,this._registry=f,this._resolvedExtensionsSet=new Set,w.forEach(s=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,_.forEach(s=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(s),s)),this._host=P,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(f){const w=g.ExtensionIdentifier.toKey(f);return this._activatedExtensions.has(w)}getActivatedExtension(f){const w=g.ExtensionIdentifier.toKey(f),_=this._activatedExtensions.get(w);if(!_)throw new Error("Extension `"+f.value+"` is not known or not activated");return _}activateByEvent(f,w){if(this._alreadyActivatedEvents[f])return S;const _=this._registry.getExtensionDescriptionsForActivationEvent(f);return this._activateExtensions(_.map(P=>({id:P.identifier,reason:{startup:w,extensionId:P.identifier,activationEvent:f}}))).then(()=>{this._alreadyActivatedEvents[f]=!0})}activateById(f,w){const _=this._registry.getExtensionDescription(f);if(!_)throw new Error("Extension `"+f+"` is not known");return this._activateExtensions([{id:_.identifier,reason:w}])}_handleActivateRequest(f,w,_){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(f.id))){w[g.ExtensionIdentifier.toKey(f.id)]=f;return}const P=this._registry.getExtensionDescription(f.id);if(!P){const a=new Error(`Cannot activate unknown extension '${f.id.value}'`);this._host.onExtensionActivationError(f.id,a,new L.MissingExtensionDependency(f.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(f.id),new I(a));return}const b=typeof P.extensionDependencies=="undefined"?[]:P.extensionDependencies;let s=!0;for(let a=0,v=b.length;a<v;a++){const n=b[a];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(n)))continue;const h=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(n));if(h&&!h.activationFailed)continue;if(h&&h.activationFailed){const o=P.displayName||P.identifier.value,d=this._registry.getExtensionDescription(n),m=d&&d.displayName||n,u=new Error(`Cannot activate the '${o}' extension because its dependency '${m}' failed to activate`);u.detail=h.activationFailedError,this._host.onExtensionActivationError(P.identifier,u,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(u));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(n))){s=!1,w[g.ExtensionIdentifier.toKey(n)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(n)),reason:f.reason};continue}const r=this._registry.getExtensionDescription(n);if(r){if(!r.main&&!r.browser)continue;s=!1,w[g.ExtensionIdentifier.toKey(n)]={id:r.identifier,reason:f.reason};continue}const t=P.displayName||P.identifier.value,l=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${n}'`);this._host.onExtensionActivationError(P.identifier,l,new L.MissingExtensionDependency(n)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(P.identifier),new I(l));return}s?w[g.ExtensionIdentifier.toKey(P.identifier)]=f:_.push(f)}_activateExtensions(f){if(f.length===0||(f=f.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),f.length===0))return Promise.resolve(void 0);const w=Object.create(null),_=[];for(let b=0,s=f.length;b<s;b++)this._handleActivateRequest(f[b],w,_);for(let b=0,s=_.length;b<s;b++){const a=g.ExtensionIdentifier.toKey(_[b].id);w[a]&&delete w[a]}const P=Object.keys(w).map(b=>w[b]);return _.length===0?Promise.all(P.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(P).then(b=>this._activateExtensions(_))}_activateExtension(f,w){const _=g.ExtensionIdentifier.toKey(f);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const P=this._activatingExtensions.get(_);if(P)return P;const b=this._host.actualActivateExtension(f,w).then(void 0,s=>{const a=new Error;return s&&s.name&&(a.name=s.name),s&&s.message?a.message=`Activating extension '${f.value}' failed: ${s.message}.`:a.message=`Activating extension '${f.value}' failed: ${s}.`,s&&s.stack&&(a.stack=s.stack),this._host.onExtensionActivationError(f,a,null),this._logService.error(`Activating extension ${f.value} failed due to an error:`),this._logService.error(s),new I(s)}).then(s=>{this._activatedExtensions.set(_,s),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,b),b}};c=Ve([$e(4,D.ILogService)],c),e.ExtensionsActivator=c}),define(fe[231],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,A)=>{this._actualOk=S,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):(0,g.onUnexpectedError)(S))}then(S,A){return this._ensureActual().then(S,A)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=L}),define(fe[54],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(C,i){this._proxyIdentifierBrand=void 0,this.isMain=C,this.sid=i,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function D(E){const C=new g(!0,E);return L[C.nid]=C,C}e.createMainContextProxyIdentifier=D;function S(E){const C=new g(!1,E);return L[C.nid]=C,C}e.createExtHostContextProxyIdentifier=S;function A(E){return L[E].sid}e.getStringIdentifierForProxy=A;class k{constructor(C){this.value=C}}e.SerializableObjectWithBuffers=k}),define(fe[5],me([0,1,61,2,54]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var A;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(s){s.name="$ident";function a(n,h){return Object.defineProperty(n,s.name,{value:h,enumerable:!0}),n}s.mixin=a;function v(n){return n[s.name]}s.of=v})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class p{static mixin(a){return a._id=p._n++,a}}e.IdObject=p,p._n=0;var f;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var _;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(_=e.WorkspaceEditType||(e.WorkspaceEditType={}));function P(s){if(s&&s.edits)for(const a of s.edits)typeof a.resource=="object"?a.resource=L.URI.revive(a.resource):(a.newUri=L.URI.revive(a.newUri),a.oldUri=L.URI.revive(a.oldUri)),a.metadata&&a.metadata.iconPath&&(a.metadata=(0,g.revive)(a.metadata));return s}e.reviveWorkspaceEditDto=P;var b;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,D.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,D.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[90],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,E){return this._proxy.$getPassword(k,E)}store(k,E,C){return this._proxy.$setPassword(k,E,C)}delete(k,E){return this._proxy.$deletePassword(k,E)}}e.ExtHostSecretState=S,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(fe[67],me([0,1,4,11,5,14]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let A=class{constructor(E,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,C,i){const I=this.getUsageKey(E,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:E}))}getUsageKey(E,C){return`${E}-${C.identifier.value}`}};A=Ve([$e(0,S.IExtHostRpcService),$e(1,L.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(k,E,C){}})}),define(fe[232],me([0,1,3,5,7,26]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,C,i,I={}){const c=S.ExtensionIdentifier.toKey(E.identifier),p=this._inFlightRequests.get(c)||[],f=[...i].sort().join(" ");let w=p.find(_=>_.scopes===f);if(w)return w.result;{const _=this._getSession(E,c,C,i,I);w={scopes:f,result:_},p.push(w),this._inFlightRequests.set(c,p);try{await _}finally{const P=p.findIndex(b=>b.scopes===f);P>-1&&(p.splice(P),this._inFlightRequests.set(c,p))}return _}}async _getSession(E,C,i,I,c={}){await this._proxy.$ensureProvider(i);const p=E.displayName||E.name;return this._proxy.$getSession(i,I,C,p,c)}async removeSession(E,C){const i=this._authenticationProviders.get(E);return i?i.provider.removeSession(C):this._proxy.$removeSession(E,C)}registerAuthenticationProvider(E,C,i,I){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:C,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(p=>p.id===E)||this._providers.push({id:E,label:C});const c=i.onDidChangeSessions(p=>{this._proxy.$sendDidChangeSessions(E,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,C,I?.supportsMultipleAccounts??!1),new D.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(E);const p=this._providers.findIndex(f=>f.id===E);p>-1&&this._providers.splice(p),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,C){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,C){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,C){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,C){return this._onDidChangeSessions.fire({provider:{id:E,label:C}}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(fe[233],me([0,1,5,14,17]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(k,E){this._extHostDocumentsAndEditors=E,this._proxy=k.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const E=D.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(fe[234],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(S){const A=S.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(k){return A.$writeText(k)}})}}e.ExtHostClipboard=L}),define(fe[39],me([0,1,13,7,17,25,5,15,11,61,41,50,2,6,4,14,65,22,54,51]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let a=class{constructor(l,o){this._commands=new Map,this._apiCommands=new Map,this._proxy=l.getProxy(A.MainContext.MainThreadCommands),this._logService=o,this.converter=new v(this,d=>{const m=this._apiCommands.get(d);return m?.result===h.Void?m:void 0},o),this._argumentProcessors=[{processArgument(d){return(0,C.revive)(d)}},{processArgument(d){return(0,S.cloneAndChange)(d,function(m){if(i.Range.isIRange(m))return D.Range.to(m);if(I.Position.isIPosition(m))return D.Position.to(m);if(i.Range.isIRange(m.range)&&c.URI.isUri(m.uri))return D.location.to(m);if(m instanceof P.VSBuffer)return m.buffer.buffer;if(!Array.isArray(m))return m})}}]}registerArgumentProcessor(l){this._argumentProcessors.push(l)}registerApiCommand(l){const o=this.registerCommand(!1,l.id,async(...d)=>{const m=l.args.map((y,T)=>{if(!y.validate(d[T]))throw new Error(`Invalid argument '${y.name}' when running '${l.id}', received: ${d[T]}`);return y.convert(d[T])}),u=await this.executeCommand(l.internalId,...m);return l.result.convert(u,d,this.converter)},void 0,{description:l.description,args:l.args,returns:l.result.description});return this._apiCommands.set(l.id,l),new L.Disposable(()=>{o.dispose(),this._apiCommands.delete(l.id)})}registerCommand(l,o,d,m,u,y){if(this._logService.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this._commands.has(o))throw new Error(`command '${o}' already exists`);return this._commands.set(o,{callback:d,thisArg:m,description:u,extension:y}),l&&this._proxy.$registerCommand(o),new L.Disposable(()=>{this._commands.delete(o)&&l&&this._proxy.$unregisterCommand(o)})}executeCommand(l,...o){return this._logService.trace("ExtHostCommands#executeCommand",l),this._doExecuteCommand(l,o,!0)}async _doExecuteCommand(l,o,d){if(this._commands.has(l))return this._executeContributedCommand(l,o,!1);{let m=!1;const u=(0,S.cloneAndChange)(o,function(y){if(y instanceof L.Position)return D.Position.from(y);if(y instanceof L.Range)return D.Range.from(y);if(y instanceof L.Location)return D.location.from(y);if(L.NotebookRange.isNotebookRange(y))return D.NotebookRange.from(y);if(y instanceof ArrayBuffer)return m=!0,P.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return m=!0,P.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(l,m?new b.SerializableObjectWithBuffers(u):u,d);return(0,C.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(l,o,!1);throw y}}}async _executeContributedCommand(l,o,d){const m=this._commands.get(l);if(!m)throw new Error("Unknown command");let{callback:u,thisArg:y,description:T}=m;if(T)for(let R=0;R<T.args.length;R++)try{(0,g.validateConstraint)(o[R],T.args[R].constraint)}catch($){throw new Error(`Running the contributed command: '${l}' failed. Illegal argument '${T.args[R].name}' - ${T.args[R].description}`)}try{return await u.apply(y,o)}catch(R){if(l===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...o);$&&(l=$.command)}throw this._logService.error(R,l,m.extension?.identifier),d?new class extends Error{constructor(){super((0,s.toErrorMessage)(R));this.id=l,this.source=m.extension?.displayName??m.extension?.name}}:R}}$executeContributedCommand(l,...o){return this._logService.trace("ExtHostCommands#$executeContributedCommand",l),this._commands.has(l)?(o=o.map(d=>this._argumentProcessors.reduce((m,u)=>u.processArgument(m),d)),this._executeContributedCommand(l,o,!0)):Promise.reject(new Error(`Contributed command '${l}' does not exist.`))}getCommands(l=!1){return this._logService.trace("ExtHostCommands#getCommands",l),this._proxy.$getCommands().then(o=>(l&&(o=o.filter(d=>d[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const l=Object.create(null);for(let[o,d]of this._commands){let{description:m}=d;m&&(l[o]=m)}return Promise.resolve(l)}};a=Ve([$e(0,w.IExtHostRpcService),$e(1,E.ILogService)],a),e.ExtHostCommands=a,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class v{constructor(l,o,d){this._commands=l,this._lookupApiCommand=o,this._logService=d,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(l,o){if(!l)return;const d={$ident:void 0,id:l.command,title:l.title,tooltip:l.tooltip};if(!l.command)return d;const m=this._lookupApiCommand(l.command);if(m)d.id=m.internalId,d.arguments=m.args.map((u,y)=>u.convert(l.arguments&&l.arguments[y]));else if((0,k.isNonEmptyArray)(l.arguments)){const u=++this._cachIdPool;this._cache.set(u,l),o.add((0,p.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),d.$ident=u,d.id=this.delegatingCommandId,d.arguments=[u],this._logService.trace("CommandsConverter#CREATE",l.command,u)}return d}fromInternal(l){const o=A.ObjectIdentifier.of(l);return typeof o=="number"?this._cache.get(o):{command:l.id,title:l.title,arguments:l.arguments}}getActualCommand(...l){return this._cache.get(l[0])}_executeConvertedCommand(...l){const o=this.getActualCommand(...l);return this._logService.trace("CommandsConverter#EXECUTE",l[0],o?o.command:"MISSING"),o?this._commands.executeCommand(o.command,...o.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=v;class n{constructor(l,o,d,m){this.name=l,this.description=o,this.validate=d,this.convert=m}optional(){return new n(this.name,`(optional) ${this.description}`,l=>l==null||this.validate(l),l=>l===void 0?void 0:l===null?null:this.convert(l))}with(l,o){return new n(l??this.name,o??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>L.Position.isPosition(t),D.Position.from),n.Range=new n("range","A range in a text document",t=>L.Range.isRange(t),D.Range.from),n.Selection=new n("selection","A selection in a text document",t=>L.Selection.isSelection(t),D.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,D.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,D.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof _.TestItemImpl,D.TestItem.from);class h{constructor(l,o){this.description=l,this.convert=o}}e.ApiCommandResult=h,h.Void=new h("no result",t=>t);class r{constructor(l,o,d,m,u){this.id=l,this.internalId=o,this.description=d,this.args=m,this.result=u}}e.ApiCommand=r}),define(fe[235],me([0,1,17,7,84,39,15,110]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",i(g.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,p)=>{if((0,A.isFalsyOrEmpty)(c))return;class f extends L.SymbolInformation{static to(_){const P=new f(_.name,g.SymbolKind.to(_.kind),_.containerName||"",new L.Location(p[0],g.Range.to(_.range)));return P.detail=_.detail,P.range=P.location.range,P.selectionRange=g.Range.to(_.selectionRange),P.children=_.children?_.children.map(f.to):[],P}}return c.map(f.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new S.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",i(g.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",i(g.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",i(g.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(p=>L.Position.isPosition(p)),c=>c.map(g.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(p=>{let f;for(const w of p.reverse())f=new L.SelectionRange(g.Range.to(w),f);return f}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const p=[];if(Array.isArray(c))for(let f of c)p.push(...f[1].map(g.WorkspaceSymbol.to));return p})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:g.Range.to(c.range),placeholder:c.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const p=(0,k.decodeSemanticTokensDto)(c);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const p=(0,k.decodeSemanticTokensDto)(c);if(p.type==="full")return new L.SemanticTokens(p.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,p,f)=>{if(!c)return new L.CompletionList([]);const w=c.suggestions.map(_=>g.CompletionItem.to(_,f));return new L.CompletionList(w,c.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,p,f)=>i(w=>new L.CodeLens(g.Range.to(w.range),w.command&&f.fromInternal(w.command)))(c))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,p,f)=>i(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return f.fromInternal(w.command)}else{const _=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(_.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(_.command=f.fromInternal(w.command)),_.isPreferred=w.isPreferred,_}})(c))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(p=>new L.ColorInformation(g.Range.to(p.range),g.Color.to(p.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,g.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",i(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(p=>g.NotebookExclusiveDocumentPattern.to(p))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void)];class C{static register(p){E.forEach(p.registerApiCommand,p)}}e.ExtHostApiCommands=C;function i(c){return p=>{if(Array.isArray(p))return p.map(c)}}function I(c){if(!Array.isArray(c))return;const p=[];for(const f of c)D.isLocationLink(f)?p.push(g.DefinitionLink.to(f)):p.push(g.location.to(f));return p}}),define(fe[236],me([0,1,16,59,3,6,2,84,26,17,7,5]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(p,f,w){const _=p.getProxy(I.MainContext.MainThreadComments);class P{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,f.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const l=this._commentControllers.get(t.handle);return l||t}else if(t&&t.$mid===7){const l=this._commentControllers.get(t.commentControlHandle);if(!l)return t;const o=l.getCommentThread(t.commentThreadHandle);return o||t}else if(t&&t.$mid===8){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const o=l.getCommentThread(t.thread.commentThreadHandle);return o?{thread:o,text:t.text}:t}else if(t&&t.$mid===9){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const o=l.getCommentThread(t.thread.commentThreadHandle);if(!o)return t;let d=t.commentUniqueId,m=o.getCommentByUniqueId(d);return m||t}else if(t&&t.$mid===10){const l=this._commentControllers.get(t.thread.commentControlHandle);if(!l)return t;const o=l.getCommentThread(t.thread.commentThreadHandle);if(!o)return t;let d=t.text,m=t.commentUniqueId,u=o.getCommentByUniqueId(m);return u?(u.body=d,u):t}return t}})}createCommentController(t,l,o){const d=P.handlePool++,m=new s(t,d,l,o);this._commentControllers.set(m.handle,m);const u=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return u.push(m),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),u),m.value}$createCommentThreadTemplate(t,l,o){const d=this._commentControllers.get(t);!d||d.$createCommentThreadTemplate(l,o)}async $updateCommentThreadTemplate(t,l,o){const d=this._commentControllers.get(t);!d||d.$updateCommentThreadTemplate(l,o)}$deleteCommentThread(t,l){const o=this._commentControllers.get(t);o&&o.$deleteCommentThread(l)}$provideCommentingRanges(t,l,o){const d=this._commentControllers.get(t);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const m=w.getDocument(A.URI.revive(l));return(0,g.asPromise)(()=>d.commentingRangeProvider.provideCommentingRanges(m,o)).then(u=>u?u.map(y=>C.Range.from(y)):void 0)}$toggleReaction(t,l,o,d,m){const u=this._commentControllers.get(t);return!u||!u.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const y=u.getCommentThread(l);if(y){const T=y.getCommentByUniqueId(d.uniqueIdInThread);if(u!==void 0&&T&&u.reactionHandler)return u.reactionHandler(T,n(m))}return Promise.resolve(void 0)})}dispose(){}}P.handlePool=0;class b{constructor(t,l,o,d,m,u,y){this._commentControllerHandle=l,this._id=o,this._uri=d,this._range=m,this._comments=u,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),_.$createCommentThread(l,this.handle,this._id,this._uri,C.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=u,this._localDisposables.push({dispose:()=>{_.$deleteCommentThread(l,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(R){T.range=R},get comments(){return T.comments},set comments(R){T.comments=R},get collapsibleState(){return T.collapsibleState},set collapsibleState(R){T.collapsibleState=R},get canReply(){return T.canReply},set canReply(R){T.canReply=R},get contextValue(){return T.contextValue},set contextValue(R){T.contextValue=R},get label(){return T.label},set label(R){T.label=R},dispose:()=>{T.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const t=o=>Object.prototype.hasOwnProperty.call(this.modifications,o),l={};t("range")&&(l.range=C.Range.from(this._range)),t("label")&&(l.label=this.label),t("contextValue")&&(l.contextValue=this.contextValue??null),t("comments")&&(l.comments=this._comments.map(o=>a(this,o,this._commentsMap))),t("collapsibleState")&&(l.collapseState=h(this._collapseState)),t("canReply")&&(l.canReply=this.canReply),this.modifications={},_.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,l)}getCommentByUniqueId(t){for(let l of this._commentsMap){let o=l[0],d=l[1];if(t===d)return o}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(t,l,o,d){this._extension=t,this._handle=l,this._id=o,this._label=d,this._threads=new Map,_.$registerCommentController(this.handle,o,d);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(u){m.options=u},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(u){m.commentingRangeProvider=u},get reactionHandler(){return m.reactionHandler},set reactionHandler(u){m.reactionHandler=u},createCommentThread(u,y,T){return m.createCommentThread(u,y,T).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{_.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,_.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,_.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,_.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,l,o,d){if(typeof t=="string"){const m=new b(this.id,this.handle,t,l,o,d,this._extension.identifier);return this._threads.set(m.handle,m),m}else{const m=new b(this.id,this.handle,void 0,t,l,o,this._extension.identifier);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(t,l){const o=new b(this.id,this.handle,void 0,A.URI.revive(t),C.Range.to(l),[],this._extension.identifier);return o.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(o.handle,o),o}$updateCommentThreadTemplate(t,l){let o=this._threads.get(t);o&&(o.range=C.Range.to(l))}$deleteCommentThread(t){let l=this._threads.get(t);l&&l.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function a(r,t,l){let o=l.get(t);o||(o=++r.commentHandle,l.set(t,o));const d=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:o,body:C.MarkdownString.from(t.body),userName:t.author.name,userIconPath:d,label:t.label,commentReactions:t.reactions?t.reactions.map(m=>v(m)):void 0}}function v(r){return{label:r.label,iconPath:r.iconPath?C.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function n(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function h(r){if(r!==void 0)switch(r){case i.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new P}e.createExtHostComments=c}),define(fe[131],me([0,1,2,5,7,4,14,11,15,8,9]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wi{constructor(p,f){this._logService=f,this._provider=new Map,this._proxy=p.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,f){const w=wi._handlePool++;this._provider.set(w,{provider:p,extensionId:f}),this._proxy.$registerDecorationProvider(w,f.value);const _=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(P=>{if(!P){this._proxy.$onDidChange(w,null);return}let b=(0,E.asArray)(P);if(b.length<=wi._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,b.length);const s=b.map(n=>({uri:n,rank:(0,C.count)(n.path,"/")})),a=(0,E.groupBy)(s,(n,h)=>n.rank-h.rank||(0,C.compare)(n.uri.path,h.uri.path));let v=[];e:for(let n of a){let h;for(let r of n){let t=(0,i.dirname)(r.uri.path);if(h!==t&&(h=t,v.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(w,v)});return new D.Disposable(()=>{_?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(p,f,w){if(!this._provider.has(p))return Object.create(null);const _=Object.create(null),{provider:P,extensionId:b}=this._provider.get(p);return await Promise.all(f.map(async s=>{try{const{uri:a,id:v}=s,n=await Promise.resolve(P.provideFileDecoration(g.URI.revive(a),w));if(!n)return;try{D.FileDecoration.validate(n),_[v]=[n.propagate,n.tooltip,n.badge,n.color]}catch(h){this._logService.warn(`INVALID decoration from extension '${b.value}': ${h}`)}}catch(a){this._logService.error(a)}})),_}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,A.IExtHostRpcService),$e(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,S.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[237],me([0,1,164,115,2,5,7,17,3,11,24,44]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";var c,p,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,s,a,v,n,h){this._name=b,this._owner=s,this._maxDiagnosticsPerFile=a,c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,st(this,f,new i.ResourceMap(r=>v.getComparisonKey(r)),"f"),st(this,c,n,"f"),st(this,p,h,"f")}dispose(){this._isDisposed||(Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,c,"f")&&Oe(this,c,"f").$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,s){if(!b){this.clear();return}this._checkDisposed();let a=[];if(D.URI.isUri(b)){if(!s){this.delete(b);return}Oe(this,f,"f").set(b,s.slice()),a=[b]}else if(Array.isArray(b)){a=[];let n;b=[...b].sort(w._compareIndexedTuplesByUri);for(const h of b){const[r,t]=h;if((!n||r.toString()!==n.toString())&&(n&&Oe(this,f,"f").get(n).length===0&&Oe(this,f,"f").delete(n),n=r,a.push(r),Oe(this,f,"f").set(r,[])),t){const l=Oe(this,f,"f").get(r);l&&l.push(...t)}else{const l=Oe(this,f,"f").get(r);l&&(l.length=0)}}}if(Oe(this,p,"f").fire(a),!Oe(this,c,"f"))return;const v=[];for(let n of a){let h=[];const r=Oe(this,f,"f").get(n);if(r)if(r.length>this._maxDiagnosticsPerFile){h=[];const t=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(let o of r)if(o.severity===t[l]&&h.push(k.Diagnostic.from(o))===this._maxDiagnosticsPerFile)break e;h.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:h[h.length-1].startLineNumber,startColumn:h[h.length-1].startColumn,endLineNumber:h[h.length-1].endLineNumber,endColumn:h[h.length-1].endColumn})}else h=r.map(t=>k.Diagnostic.from(t));v.push([n,h])}Oe(this,c,"f").$changeMany(this._owner,v)}delete(b){this._checkDisposed(),Oe(this,p,"f").fire([b]),Oe(this,f,"f").delete(b),Oe(this,c,"f")&&Oe(this,c,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Oe(this,p,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,c,"f")&&Oe(this,c,"f").$clear(this._owner)}forEach(b,s){this._checkDisposed();for(let a of Oe(this,f,"f").keys())b.apply(s,[a,this.get(a),this])}get(b){this._checkDisposed();const s=Oe(this,f,"f").get(b);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,s){return b[0].toString()<s[0].toString()?-1:b[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=w,c=new WeakMap,p=new WeakMap,f=new WeakMap;let _=class ti{constructor(b,s,a){this._logService=s,this._fileSystemInfoService=a,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=b.getProxy(S.MainContext.MainThreadDiagnostics)}static _mapper(b){const s=new i.ResourceMap;for(const a of b)s.set(a,a);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(b,s){const{_collections:a,_proxy:v,_onDidChangeDiagnostics:n,_logService:h,_fileSystemInfoService:r}=this,t=new class{$changeMany(d,m){v.$changeMany(d,m),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,d,m.length===0?"CLEARING":m)}$clear(d){v.$clear(d),h.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,d)}dispose(){v.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+ti._idPool++,l=s;else if(!a.has(s))l=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+ti._idPool++;while(a.has(l))}return new class extends w{constructor(){super(s,l,ti._maxDiagnosticsPerFile,r.extUri,t,n);a.set(l,this)}dispose(){super.dispose(),a.delete(l)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const s=new Map,a=[];for(const v of this._collections.values())v.forEach((n,h)=>{let r=s.get(n.toString());typeof r=="undefined"&&(r=a.length,s.set(n.toString(),r),a.push([n,[]])),a[r][1]=a[r][1].concat(...h)});return a}}_getDiagnostics(b){let s=[];for(let a of this._collections.values())a.has(b)&&(s=s.concat(a.get(b)));return s}$acceptMarkersChange(b){if(!this._mirrorCollection){const s="_generated_mirror",a=new w(s,s,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,a),this._mirrorCollection=a}for(const[s,a]of b)this._mirrorCollection.set(D.URI.revive(s),a.map(k.Diagnostic.to))}};_._idPool=0,_._maxDiagnosticsPerFile=1e3,_=Ve([$e(1,C.ILogService),$e(2,I.IExtHostFileSystemInfo)],_),e.ExtHostDiagnostics=_}),define(fe[238],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(A){this._proxy=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(k=>k?k.map(E=>g.URI.revive(E)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(k=>k?g.URI.revive(k):void 0)}}e.ExtHostDialogs=D}),define(fe[239],me([0,1,18,2,7,5,10,21,8]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,c,p){this._documentsAndEditors=c,this._logService=p,this._documentContentProviders=new Map,this._proxy=I.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const p=C._handlePool++;this._documentContentProviders.set(p,c),this._proxy.$registerTextContentProvider(p,I);let f;return typeof c.onDidChange=="function"&&(f=c.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(p,w).then(_=>{if(!_&&typeof _!="string")return;const P=this._documentsAndEditors.getDocument(w);if(!P)return;const b=(0,E.splitLines)(_);if(!P.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,_)},g.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(p)&&this._proxy.$unregisterTextContentProvider(p),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(I,c){const p=this._documentContentProviders.get(I);return p?Promise.resolve(p.provideTextDocumentContent(L.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(fe[240],me([0,1,3,6,2,5,122,17,13,25,7]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(p,f){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=p.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const _ of w)this._onDidRemoveDocument.fire(_.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const _ of w)this._onDidAddDocument.fire(_.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(p){if(!p)return;const f=this._documentsAndEditors.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this._documentsAndEditors.getDocument(p);if(f)return Promise.resolve(f);let w=this._documentLoader.get(p.toString());return w||(w=this._proxy.$tryOpenDocument(p).then(_=>{this._documentLoader.delete(p.toString());const P=D.URI.revive(_);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(P))},_=>(this._documentLoader.delete(p.toString()),Promise.reject(_))),this._documentLoader.set(p.toString(),w)),w}createDocumentData(p){return this._proxy.$tryCreateDocument(p).then(f=>D.URI.revive(f))}$acceptModelModeChanged(p,f){const w=D.URI.revive(p),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");this._onDidRemoveDocument.fire(_.document),_._acceptLanguageId(f),this._onDidAddDocument.fire(_.document)}$acceptModelSaved(p){const f=D.URI.revive(p),w=this._documentsAndEditors.getDocument(f);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(p,f){const w=D.URI.revive(p),_=this._documentsAndEditors.getDocument(w);if(!_)throw new Error("unknown document");_._acceptIsDirty(f),this._onDidChangeDocument.fire({document:_.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,w){const _=D.URI.revive(p),P=this._documentsAndEditors.getDocument(_);if(!P)throw new Error("unknown document");P._acceptIsDirty(w),P.onEvents(f);let b;f.isUndoing?b=i.TextDocumentChangeReason.Undo:f.isRedoing&&(b=i.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:P.document,contentChanges:f.changes.map(s=>({range:k.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:b}))}setWordDefinitionFor(p,f){(0,A.setWordDefinitionFor)(p,f)}}e.ExtHostDocuments=I}),define(fe[45],me([0,1,57,3,6,2,4,5,122,14,129,17,11,24,10,77,141]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class P{constructor(a){this.value=a,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(a,v){this._extHostRpc=a,this._logService=v,this._activeEditorId=null,this._editors=new Map,this._documents=new p.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const v=[],n=[],h=[];if(a.removedDocuments)for(const r of a.removedDocuments){const t=S.URI.revive(r),l=this._documents.get(t);l?.unref()&&(this._documents.delete(t),v.push(l.value))}if(a.addedDocuments)for(const r of a.addedDocuments){const t=S.URI.revive(r.uri);let l=this._documents.get(t);if(l&&t.scheme!==f.Schemas.vscodeNotebookCell&&t.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);l||(l=new P(new E.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(t,l),n.push(l.value)),l.ref()}if(a.removedEditors)for(const r of a.removedEditors){const t=this._editors.get(r);this._editors.delete(r),t&&h.push(t)}if(a.addedEditors)for(const r of a.addedEditors){const t=S.URI.revive(r.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const l=this._documents.get(t).value,o=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new _.Lazy(()=>l.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(d=>I.Range.to(d)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,o)}a.newActiveEditor!==void 0&&(g.ok(a.newActiveEditor===null||this._editors.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this._activeEditorId=a.newActiveEditor),(0,D.dispose)(v),(0,D.dispose)(h),a.removedDocuments&&this._onDidRemoveDocuments.fire(v),a.addedDocuments&&this._onDidAddDocuments.fire(n),(a.removedEditors||a.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),a.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(a){return this._documents.get(a)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),a=>a.value)}getEditor(a){return this._editors.get(a)}activeEditor(a){if(!this._activeEditorId)return;const v=this._editors.get(this._activeEditorId);return a?v:v?.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,C.IExtHostRpcService),$e(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[55],me([0,1,17,5,2,3,4,14,16]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");let C=class{constructor(I){this._onDidChangeTabs=new S.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new S.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let c=-1;this._tabs=I.map((f,w)=>(f.isActive&&(c=w),Object.freeze({label:f.label,viewColumn:g.ViewColumn.to(f.viewColumn),index:w,resource:D.URI.revive(f.resource),additionalResourcesAndViewIds:f.additionalResourcesAndViewIds.map(({resource:_,viewId:P})=>({resource:D.URI.revive(_),viewId:P})),viewId:f.editorId,isActive:f.isActive,move:async(_,P)=>{this._proxy.$moveTab(f,_,g.ViewColumn.from(P)),await(0,E.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(f),await(0,E.raceTimeout)(S.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((f,w)=>f.viewColumn===w.viewColumn?f.index-w.index:f.viewColumn-w.viewColumn);const p=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==p&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};C=Ve([$e(0,k.IExtHostRpcService)],C),e.ExtHostEditorTabs=C}),define(fe[241],me([0,1,2,5,6,7,17,148,8,22]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(p){this._stateMachine=void 0,this._schemes.push(p)}delete(p){const f=this._schemes.indexOf(p);f>=0&&(this._schemes.splice(f,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const p=this._schemes.sort(),f=[];let w,_,P=14,b=14;for(const s of p){let a=w?(0,E.commonPrefixLength)(w,s):0;for(a===0?_=1:_=b;a<s.length;a++)a+1===s.length?(P=b,b=9):b+=1,f.push([_,s.toUpperCase().charCodeAt(a),b]),f.push([_,s.toLowerCase().charCodeAt(a),b]),_=b;w=s,b=P}f.push([9,58,10]),f.push([10,47,12]),this._stateMachine=new k.StateMachine(f)}}provideDocumentLinks(p){this._initStateMachine();const f=[],w=k.LinkComputer.computeLinks({getLineContent(_){return p.lineAt(_-1).text},getLineCount(){return p.lineCount}},this._stateMachine);for(const _ of w){const P=A.DocumentLink.to(_);P.target&&f.push(P)}return f}}class I{constructor(p,f){this._extHostLanguageFeatures=f,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=p.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(p,f,w,_={}){if(this._registeredSchemes.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const P=this._handlePool++;this._linkProvider.add(f),this._registeredSchemes.add(f),this._fsProvider.set(P,w);let b=2;_.isCaseSensitive&&(b+=1024),_.isReadonly&&(b+=2048),typeof w.copy=="function"&&(b+=8),typeof w.open=="function"&&typeof w.close=="function"&&typeof w.read=="function"&&typeof w.write=="function"&&(b+=4),this._proxy.$registerFileSystemProvider(P,f,b).catch(a=>{console.error(`FAILED to register filesystem provider of ${p.value}-extension for the scheme ${f}`),console.error(a)});const s=w.onDidChangeFile(a=>{const v=[];for(const n of a){let{uri:h,type:r}=n;if(h.scheme!==f)continue;let t;switch(r){case S.FileChangeType.Changed:t=0;break;case S.FileChangeType.Created:t=1;break;case S.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}v.push({resource:h,type:t})}this._proxy.$onFileSystemChange(P,v)});return(0,D.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(f),this._registeredSchemes.delete(f),this._fsProvider.delete(P),this._proxy.$unregisterProvider(P)})}static _asIStat(p){const{type:f,ctime:w,mtime:_,size:P,permissions:b}=p;return{type:f,ctime:w,mtime:_,size:P,permissions:b}}$stat(p,f){return Promise.resolve(this._getFsProvider(p).stat(g.URI.revive(f))).then(w=>I._asIStat(w))}$readdir(p,f){return Promise.resolve(this._getFsProvider(p).readDirectory(g.URI.revive(f)))}$readFile(p,f){return Promise.resolve(this._getFsProvider(p).readFile(g.URI.revive(f))).then(w=>C.VSBuffer.wrap(w))}$writeFile(p,f,w,_){return Promise.resolve(this._getFsProvider(p).writeFile(g.URI.revive(f),w.buffer,_))}$delete(p,f,w){return Promise.resolve(this._getFsProvider(p).delete(g.URI.revive(f),w))}$rename(p,f,w,_){return Promise.resolve(this._getFsProvider(p).rename(g.URI.revive(f),g.URI.revive(w),_))}$copy(p,f,w,_){const P=this._getFsProvider(p);if(!P.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(P.copy(g.URI.revive(f),g.URI.revive(w),_))}$mkdir(p,f){return Promise.resolve(this._getFsProvider(p).createDirectory(g.URI.revive(f)))}$watch(p,f,w,_){const P=this._getFsProvider(p).watch(g.URI.revive(w),_);this._watches.set(f,P)}$unwatch(p,f){const w=this._watches.get(f);w&&(w.dispose(),this._watches.delete(f))}$open(p,f,w){const _=this._getFsProvider(p);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(g.URI.revive(f),w))}$close(p,f){const w=this._getFsProvider(p);if(!w.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(w.close(f))}$read(p,f,w,_){const P=this._getFsProvider(p);if(!P.read)throw new Error('FileSystemProvider does not implement "read"');const b=C.VSBuffer.alloc(_);return Promise.resolve(P.read(f,w,b.buffer,0,_)).then(s=>b.slice(0,s))}$write(p,f,w,_){const P=this._getFsProvider(p);if(!P.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(P.write(f,w,_.buffer,0,_.byteLength))}_getFsProvider(p){const f=this._fsProvider.get(p);if(!f){const w=new Error;throw w.name="ENOPRO",w.message="no provider",w}return f}}e.ExtHostFileSystem=I}),define(fe[68],me([0,1,5,42,7,22,4,14,44]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Bt{constructor(I,c){const p=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(f){return p.$stat(f).catch(Bt._handleError)},readDirectory(f){return p.$readdir(f).catch(Bt._handleError)},createDirectory(f){return p.$mkdir(f).catch(Bt._handleError)},async readFile(f){return p.$readFile(f).then(w=>w.buffer).catch(Bt._handleError)},writeFile(f,w){return p.$writeFile(f,S.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(f,w){return p.$delete(f,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(f,w,_){return p.$rename(f,w,{overwrite:!1,..._}).catch(Bt._handleError)},copy(f,w,_){return p.$copy(f,w,{overwrite:!1,..._}).catch(Bt._handleError)},isWritableFileSystem(f){const w=c.getCapabilities(f);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};C=Ve([$e(0,k.IExtHostRpcService),$e(1,E.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[242],me([0,1,2,39]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class D{constructor(A,k,E,C){this._extHostNotebooks=k,this._textDocumentsAndEditors=E,this._commands=C;const i=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(i)}$willAddInteractiveDocument(A,k,E,C){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(C))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=D}),define(fe[243],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(A){this._handlePool=0,this._proxy=A.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,A),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=D}),define(fe[244],me([0,1,2,25,17,7,5,8,41,15,13,145,6,110,76,87,46,18,3]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentSymbols(ie,ee);if(!(0,C.isFalsyOrEmpty)(ce))return ce[0]instanceof S.DocumentSymbol?ce.map(D.DocumentSymbol.from):s._asDocumentSymbolTree(ce)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((ce,Z)=>{let re=ce.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(ce.location.range.end)),re});const ee=[],ie=[];for(const ce of G){const Z={name:ce.name||"!!MISSING: name!!",kind:D.SymbolKind.from(ce.kind),tags:ce.tags?.map(D.SymbolTag.from)||[],detail:"",containerName:ce.containerName,range:D.Range.from(ce.location.range),selectionRange:D.Range.from(ce.location.range),children:[]};for(;;){if(ie.length===0){ie.push(Z),ee.push(Z);break}const re=ie[ie.length-1];if(E.Range.containsRange(re.range,Z.range)&&!E.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),ie.push(Z);break}ie.pop()}}return ee}}class a{constructor(G,ee,ie){this._documents=G,this._commands=ee,this._provider=ie,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideCodeLenses(ie,ee);if(!ce||ee.isCancellationRequested)return;const Z=this._cache.add(ce),re=new c.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<ce.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:D.Range.from(ce[Me].range),command:this._commands.toInternal(ce[Me].command,re)});return pe}async resolveCodeLens(G,ee){const ie=G.cacheId&&this._cache.get(...G.cacheId);if(!ie)return;let ce;if(typeof this._provider.resolveCodeLens!="function"||ie.isResolved?ce=ie:ce=await this._provider.resolveCodeLens(ie,ee),ce||(ce=ie),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(ce.command??a._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function v(He){return Array.isArray(He)?He.map(D.DefinitionLink.from):He?[D.DefinitionLink.from(He)]:[]}class n{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDefinition(ce,Z,ie);return v(re)}}class h{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDeclaration(ce,Z,ie);return v(re)}}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideImplementation(ce,Z,ie);return v(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideTypeDefinition(ce,Z,ie);return v(re)}}class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideHover(ce,Z,ie);if(!(!re||(0,C.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=ce.getWordRangeAtPosition(Z)),re.range||(re.range=new S.Range(Z,Z)),D.Hover.from(re)}}class o{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideEvaluatableExpression(ce,Z,ie);if(re)return D.EvaluatableExpression.from(re)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,D.Range.to(ee),D.InlineValueContext.to(ie),ce);if(Array.isArray(re))return re.map(pe=>D.InlineValue.from(pe))}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideDocumentHighlights(ce,Z,ie);if(Array.isArray(re))return re.map(D.DocumentHighlight.from)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(ce,Z,ie);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.coalesce)(re.ranges.map(D.Range.from)),wordPattern:re.wordPattern}}}class y{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=await this._provider.provideReferences(Z,re,ie,ce);if(Array.isArray(pe))return pe.map(D.location.from)}}class T{constructor(G,ee,ie,ce,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=ie,this._provider=ce,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?D.Selection.to(ee):D.Range.to(ee),pe=[];for(const ct of this._diagnostics.getDiagnostics(G))if(re.intersection(ct.range)&&pe.push(ct)>T._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:ie.only?new S.CodeActionKind(ie.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ie.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,ce);if(!(0,C.isNonEmptyArray)(je)||ce.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new c.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let ct=0;ct<je.length;ct++){const ye=je[ct];!ye||(T._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,ct],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(D.Diagnostic.from),edit:ye.edit&&D.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[ie,ce]=G,Z=this._cache.get(ie,ce);if(!Z||T._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?D.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}T._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(ce,ee,ie);if(Array.isArray(Z))return Z.map(D.TextEdit.from)}}class ${constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,ie,ce);if(Array.isArray(pe))return pe.map(D.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,ie,ce,Z){const re=this._documents.getDocument(G),pe=D.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,ie,ce,Z);if(Array.isArray(Me))return Me.map(D.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const ie=A.IdObject.mixin({symbols:[]}),ce=await this._provider.provideWorkspaceSymbols(G,ee);if((0,C.isNonEmptyArray)(ce))for(const Z of ce){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=A.IdObject.mixin(D.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),ie.symbols.push(re)}return ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ie=this._symbolCache.get(G._id);if(ie){const ce=await this._provider.resolveWorkspaceSymbol(ie,ee);return ce&&(0,L.mixin)(G,D.WorkspaceSymbol.from(ce),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[ie,ce]=ee;ie<=ce;ie++)this._symbolCache.delete(ie);this._resultCache.delete(G)}}}class W{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,ie,ce);return pe?D.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=W._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const ce=this._documents.getDocument(G),Z=D.Position.to(ee);try{const re=await this._provider.prepareRename(ce,Z,ie);let pe,Me;if(S.Range.isRange(re)?(pe=re,Me=ce.getText(re)):(0,i.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(pe),text:Me}}catch(re){const pe=W._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class z{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,ie){const ce=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(ce,Z.resultId,ie):await this._provider.provideDocumentSemanticTokens(ce,ie);return Z&&this._previousResults.delete(ee),re?(re=z._fixProvidedSemanticTokens(re),this._send(z._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return z._isSemanticTokens(G)?z._isCorrectSemanticTokens(G)?G:new S.SemanticTokens(new Uint32Array(G.data),G.resultId):z._isSemanticTokensEdits(G)?z._isCorrectSemanticTokensEdits(G)?G:new S.SemanticTokensEdits(G.edits.map(ee=>new S.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!z._isSemanticTokens(ee)||!G||!G.tokens)return ee;const ie=G.tokens,ce=ie.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(ce,re);for(;pe<Me&&ie[pe]===Z[pe];)pe++;if(pe===ce&&pe===re)return new S.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&ie[ce-je-1]===Z[re-je-1];)je++;return new S.SemanticTokensEdits([{start:pe,deleteCount:ce-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(z._isSemanticTokens(G)){const ie=this._nextResultId++;return this._previousResults.set(ie,new M(G.resultId,G.data)),(0,p.encodeSemanticTokensDto)({id:ie,type:"full",data:G.data})}if(z._isSemanticTokensEdits(G)){const ie=this._nextResultId++;return z._isSemanticTokens(ee)?this._previousResults.set(ie,new M(ee.resultId,ee.data)):this._previousResults.set(ie,new M(G.resultId)),(0,p.encodeSemanticTokensDto)({id:ie,type:"delta",deltas:(G.edits||[]).map(ce=>({start:ce.start,deleteCount:ce.deleteCount,data:ce.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class N{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(ce,D.Range.to(ee),ie);return Z?this._send(Z):null}_send(G){return(0,p.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(G,ee,ie,ce,Z){this._documents=G,this._commands=ee,this._provider=ie,this._apiDeprecation=ce,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new S.Range(re,re),Me=pe.with({end:re}),je=new _.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,ce,D.CompletionContext.to(ie));if(!Ke||ce.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new S.CompletionList(Ke):Ke,rt=U.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),ct=new c.DisposableStore;this._disposables.set(rt,ct);const ye=[],at={x:rt,b:ye,a:{replace:D.Range.from(pe),insert:D.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ne=Ze.items[J],Ee=this._convertCompletionItem(ne,[rt,J],Me,pe);ye.push(Ee)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...G);if(!ie)return;const ce=await this._provider.resolveCompletionItem(ie,ee);if(!!ce)return this._convertCompletionItem(ce,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,ie,ce){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?D.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(D.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof S.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),S.Range.isRange(pe)?re.j=D.Range.from(pe):pe&&(!ie?.isEqual(pe.inserting)||!ce?.isEqual(pe.replacing))&&(re.j={insert:D.Range.from(pe.inserting),replace:D.Range.from(pe.replacing)}),re}}class x{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._commands=ie,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:ie.selectedSuggestionInfo?{range:D.Range.to(ie.selectedSuggestionInfo.range),text:ie.selectedSuggestionInfo.text}:void 0,triggerKind:ie.triggerKind},ce);if(!pe||ce.isCancellationRequested)return;const Me=(0,i.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let ct;return Ze.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(je,Ke)),ct=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?D.Range.from(Ze.range):void 0,command:ct,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const ie=this._cache.get(G,ee);ie&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class j{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,ie,ce){const Z=this._documents.getDocument(G),re=D.Position.to(ee),pe=this.reviveContext(ie),Me=await this._provider.provideSignatureHelp(Z,re,ce,pe);if(Me){const je=this._cache.add([Me]);return{...D.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const ie=D.SignatureHelp.to(G.activeSignatureHelp),ce=this._cache.get(G.activeSignatureHelp.id,0);ce?(ee=ce,ee.activeSignature=ie.activeSignature,ee.activeParameter=ie.activeParameter):ee=ie}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class H{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(ce,D.Range.to(ee),ie);return Z?{hints:Z.map(D.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentLinks(ie,ee);if(!(!Array.isArray(ce)||ce.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:ce.filter(X._validateLink).map(D.DocumentLink.from)};{const Z=this._cache.add(ce),re={links:[],id:Z};for(let pe=0;pe<ce.length;pe++){if(!X._validateLink(ce[pe]))continue;const Me=D.DocumentLink.from(ce[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...G);if(!ie)return;const ce=await this._provider.resolveDocumentLink(ie,ee);if(!(!ce||!X._validateLink(ce)))return D.DocumentLink.from(ce)}releaseLinks(G){this._cache.delete(G)}}class Q{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const ie=this._documents.getDocument(G),ce=await this._provider.provideDocumentColors(ie,ee);return Array.isArray(ce)?ce.map(re=>({color:D.Color.from(re.color),range:D.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Range.to(ee.range),re=D.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:ce,range:Z},ie);if(!!Array.isArray(pe))return pe.map(D.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(ce,ee,ie);if(!!Array.isArray(Z))return Z.map(D.FoldingRange.from)}}class _e{constructor(G,ee,ie){this._documents=G,this._provider=ee,this._logService=ie}async provideSelectionRanges(G,ee,ie){const ce=this._documents.getDocument(G),Z=ee.map(D.Position.to),re=await this._provider.provideSelectionRanges(ce,Z,ie);if(!(0,C.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(D.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class Ie{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.prepareCallHierarchy(ce,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(ce,ie);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>D.Range.from(pe))}))}async provideCallsFrom(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(ce,ie);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>D.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),ce=D.CallHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ie){const ce=this._documents.getDocument(G),Z=D.Position.to(ee),re=await this._provider.prepareTypeHierarchy(ce,Z,ie);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(ce,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,ie){const ce=this._itemFromCache(G,ee);if(!ce)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(ce,ie);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ie=this._cache.get(G),ce=D.TypeHierarchyItem.from(ee,G,ie.size.toString(36));return ie.set(ce._itemId,ee),ce}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class We{constructor(G,ee){this.adapter=G,this.extension=ee}}class Be{constructor(G,ee,ie,ce,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=ce,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return D.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new S.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return Be._handlePool++}_withAdapter(G,ee,ie,ce,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(ce);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=ie(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof P.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const ie=this._nextHandle();return this._adapter.set(ie,new We(G,ee)),ie}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new s(this._documents,ie),G),re=ce&&ce.label||Be._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,ie){return this._withAdapter(G,s,ce=>ce.provideDocumentSymbols(g.URI.revive(ee),ie),void 0)}registerCodeLensProvider(G,ee,ie){const ce=this._nextHandle(),Z=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(ce,new We(new a(this._documents,this._commands.converter,ie),G)),this._proxy.$registerCodeLensSupport(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ie.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,ie){return this._withAdapter(G,a,ce=>ce.provideCodeLenses(g.URI.revive(ee),ie),void 0)}$resolveCodeLens(G,ee,ie){return this._withAdapter(G,a,ce=>ce.resolveCodeLens(ee,ie),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,a,ie=>Promise.resolve(ie.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,ie){const ce=this._addNewAdapter(new n(this._documents,ie),G);return this._proxy.$registerDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDefinition(G,ee,ie,ce){return this._withAdapter(G,n,Z=>Z.provideDefinition(g.URI.revive(ee),ie,ce),[])}registerDeclarationProvider(G,ee,ie){const ce=this._addNewAdapter(new h(this._documents,ie),G);return this._proxy.$registerDeclarationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDeclaration(G,ee,ie,ce){return this._withAdapter(G,h,Z=>Z.provideDeclaration(g.URI.revive(ee),ie,ce),[])}registerImplementationProvider(G,ee,ie){const ce=this._addNewAdapter(new r(this._documents,ie),G);return this._proxy.$registerImplementationSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideImplementation(G,ee,ie,ce){return this._withAdapter(G,r,Z=>Z.provideImplementation(g.URI.revive(ee),ie,ce),[])}registerTypeDefinitionProvider(G,ee,ie){const ce=this._addNewAdapter(new t(this._documents,ie),G);return this._proxy.$registerTypeDefinitionSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideTypeDefinition(G,ee,ie,ce){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),ie,ce),[])}registerHoverProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new l(this._documents,ie),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,ie,ce){return this._withAdapter(G,l,Z=>Z.provideHover(g.URI.revive(ee),ie,ce),void 0)}registerEvaluatableExpressionProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new o(this._documents,ie),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,ie,ce){return this._withAdapter(G,o,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),ie,ce),void 0)}registerInlineValuesProvider(G,ee,ie,ce){const Z=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new d(this._documents,ie),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=ie.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=S.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,ie,ce,Z){return this._withAdapter(G,d,re=>re.provideInlineValues(g.URI.revive(ee),ie,ce,Z),void 0)}registerDocumentHighlightProvider(G,ee,ie){const ce=this._addNewAdapter(new m(this._documents,ie),G);return this._proxy.$registerDocumentHighlightProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentHighlights(G,ee,ie,ce){return this._withAdapter(G,m,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),ie,ce),void 0)}registerLinkedEditingRangeProvider(G,ee,ie){const ce=this._addNewAdapter(new u(this._documents,ie),G);return this._proxy.$registerLinkedEditingRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideLinkedEditingRanges(G,ee,ie,ce){return this._withAdapter(G,u,async Z=>{const re=await Z.provideLinkedEditingRanges(g.URI.revive(ee),ie,ce);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Be._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,ie){const ce=this._addNewAdapter(new y(this._documents,ie),G);return this._proxy.$registerReferenceSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideReferences(G,ee,ie,ce,Z){return this._withAdapter(G,y,re=>re.provideReferences(g.URI.revive(ee),ie,ce,Z),void 0)}registerCodeActionProvider(G,ee,ie,ce){const Z=new c.DisposableStore,re=this._addNewAdapter(new T(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:ce?.providedCodeActionKinds?.map(pe=>pe.value),documentation:ce?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},Be._extLabel(G),Boolean(ie.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,ie,ce,Z){return this._withAdapter(G,T,re=>re.provideCodeActions(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveCodeAction(G,ee,ie){return this._withAdapter(G,T,ce=>ce.resolveCodeAction(ee,ie),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,T,ie=>Promise.resolve(ie.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,ie){const ce=this._addNewAdapter(new R(this._documents,ie),G);return this._proxy.$registerDocumentFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentFormattingEdits(G,ee,ie,ce){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),ie,ce),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,ie){const ce=this._addNewAdapter(new $(this._documents,ie),G);return this._proxy.$registerRangeFormattingSupport(ce,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(ce)}$provideDocumentRangeFormattingEdits(G,ee,ie,ce,Z){return this._withAdapter(G,$,re=>re.provideDocumentRangeFormattingEdits(g.URI.revive(ee),ie,ce,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new B(this._documents,ie),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),ce,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,ie,ce,Z,re){return this._withAdapter(G,B,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),ie,ce,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const ie=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(G,ee,ie){return this._withAdapter(G,F,ce=>ce.provideWorkspaceSymbols(ee,ie),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,ie){return this._withAdapter(G,F,ce=>ce.resolveWorkspaceSymbol(ee,ie),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,ie=>ie.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,ie){const ce=this._addNewAdapter(new W(this._documents,ie,this._logService),G);return this._proxy.$registerRenameSupport(ce,this._transformDocumentSelector(ee),W.supportsResolving(ie)),this._createDisposable(ce)}$provideRenameEdits(G,ee,ie,ce,Z){return this._withAdapter(G,W,re=>re.provideRenameEdits(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveRenameLocation(G,ee,ie,ce){return this._withAdapter(G,W,Z=>Z.resolveRenameLocation(g.URI.revive(ee),ie,ce),void 0)}registerDocumentSemanticTokensProvider(G,ee,ie,ce){const Z=this._nextHandle(),re=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new We(new z(this._documents,ie),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce,re);let pe=this._createDisposable(Z);if(re){const Me=ie.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=S.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,ie,ce){return this._withAdapter(G,z,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),ie,ce),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,z,ie=>ie.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new N(this._documents,ie),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),ce),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,ie,ce){return this._withAdapter(G,N,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),ie,ce),null,!0)}registerCompletionItemProvider(G,ee,ie,ce){const Z=this._addNewAdapter(new U(this._documents,this._commands.converter,ie,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),ce,U.supportsResolving(ie),`${G.identifier.value}(${ce.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,ie,ce,Z){return this._withAdapter(G,U,re=>re.provideCompletionItems(g.URI.revive(ee),ie,ce,Z),void 0)}$resolveCompletionItem(G,ee,ie){return this._withAdapter(G,U,ce=>ce.resolveCompletionItem(ee,ie),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,U,ie=>ie.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,ie){const ce=this._addNewAdapter(new x(this._documents,ie,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideInlineCompletions(G,ee,ie,ce,Z){return this._withAdapter(G,x,re=>re.provideInlineCompletions(g.URI.revive(ee),ie,ce,Z),void 0)}$handleInlineCompletionDidShow(G,ee,ie){this._withAdapter(G,x,async ce=>{ce.handleDidShowCompletionItem(ee,ie)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,x,async ie=>{ie.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,ie,ce){const Z=Array.isArray(ce)?{triggerCharacters:ce,retriggerCharacters:[]}:ce,re=this._addNewAdapter(new j(this._documents,ie),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,ie,ce,Z){return this._withAdapter(G,j,re=>re.provideSignatureHelp(g.URI.revive(ee),ie,ce,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,j,ie=>ie.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,ie){const ce=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new H(this._documents,ie),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),ce);let re=this._createDisposable(Z);if(ce!==void 0){const pe=ie.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(ce));re=S.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,ie,ce){return this._withAdapter(G,H,Z=>Z.provideInlayHints(g.URI.revive(ee),ie,ce),void 0)}registerDocumentLinkProvider(G,ee,ie){const ce=this._addNewAdapter(new X(this._documents,ie),G);return this._proxy.$registerDocumentLinkProvider(ce,this._transformDocumentSelector(ee),typeof ie.resolveDocumentLink=="function"),this._createDisposable(ce)}$provideDocumentLinks(G,ee,ie){return this._withAdapter(G,X,ce=>ce.provideLinks(g.URI.revive(ee),ie),void 0)}$resolveDocumentLink(G,ee,ie){return this._withAdapter(G,X,ce=>ce.resolveLink(ee,ie),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,ie=>ie.releaseLinks(ee),void 0)}registerColorProvider(G,ee,ie){const ce=this._addNewAdapter(new Q(this._documents,ie),G);return this._proxy.$registerDocumentColorProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideDocumentColors(G,ee,ie){return this._withAdapter(G,Q,ce=>ce.provideColors(g.URI.revive(ee),ie),[])}$provideColorPresentations(G,ee,ie,ce){return this._withAdapter(G,Q,Z=>Z.provideColorPresentations(g.URI.revive(ee),ie,ce),void 0)}registerFoldingRangeProvider(G,ee,ie){const ce=this._nextHandle(),Z=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(ce,new We(new de(this._documents,ie),G)),this._proxy.$registerFoldingRangeProvider(ce,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(ce);if(Z!==void 0){const pe=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=S.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,ie,ce){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),ie,ce),void 0)}registerSelectionRangeProvider(G,ee,ie){const ce=this._addNewAdapter(new _e(this._documents,ie,this._logService),G);return this._proxy.$registerSelectionRangeProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$provideSelectionRanges(G,ee,ie,ce){return this._withAdapter(G,_e,Z=>Z.provideSelectionRanges(g.URI.revive(ee),ie,ce),[])}registerCallHierarchyProvider(G,ee,ie){const ce=this._addNewAdapter(new Ie(this._documents,ie),G);return this._proxy.$registerCallHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareCallHierarchy(G,ee,ie,ce){return this._withAdapter(G,Ie,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,ce)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,ie,ce){return this._withAdapter(G,Ie,Z=>Z.provideCallsTo(ee,ie,ce),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,ie,ce){return this._withAdapter(G,Ie,Z=>Z.provideCallsFrom(ee,ie,ce),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,Ie,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,ie){const ce=this._addNewAdapter(new Pe(this._documents,ie),G);return this._proxy.$registerTypeHierarchyProvider(ce,this._transformDocumentSelector(ee)),this._createDisposable(ce)}$prepareTypeHierarchy(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ie,ce)),void 0)}$provideTypeHierarchySupertypes(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,ie,ce),void 0)}$provideTypeHierarchySubtypes(G,ee,ie,ce){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,ie,ce),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,ie=>Promise.resolve(ie.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:Be._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:Be._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?Be._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?Be._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:Be._serializeRegExp(G.beforeText),afterText:G.afterText?Be._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?Be._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(Be._serializeOnEnterRule)}setLanguageConfiguration(G,ee,ie){let{wordPattern:ce}=ie;if(ce&&(0,k.regExpLeadsToEndlessLoop)(ce))throw new Error(`Invalid language configuration: wordPattern '${ce}' is not allowed to match the empty string.`);ce?this._documents.setWordDefinitionFor(ee,ce):this._documents.setWordDefinitionFor(ee,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?Be._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?Be._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?Be._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=Be,Be._handlePool=0}),define(fe[245],me([0,1,5,17,7,49,16,6]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(i,I,c,p){this._documents=I,this._commands=c,this._uriTransformer=p,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=i.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(i){this._languageIds=i}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(i,I){await this._proxy.$changeLanguage(i,I);const c=this._documents.getDocumentData(i);if(!c)throw new Error(`document '${i.toString}' NOT found`);return c.document}async tokenAtPosition(i,I){const c=i.version,p=L.Position.from(I),f=await this._proxy.$tokensAtPosition(i.uri,p),w={type:D.StandardTokenType.Other,range:i.getWordRangeAtPosition(I)??new D.Range(I.line,I.character,I.line,I.character)};if(!f)return w;const _={range:L.Range.to(f.range),type:L.TokenType.to(f.type)};return!_.range.contains(I)||c!==i.version?w:_}createLanguageStatusItem(i,I,c){const p=this._handlePool++,f=this._proxy,w=this._ids,_=`${i.identifier.value}/${I}`;if(w.has(_))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(_);const P={selector:c,id:I,name:i.displayName??i.name,severity:D.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,s=new k.DisposableStore;const a=()=>{b?.dispose(),b=(0,A.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(p,{id:_,name:P.name??i.displayName??i.name,source:i.displayName??i.name,selector:L.DocumentSelector.from(P.selector,this._uriTransformer),label:P.text,detail:P.detail??"",severity:P.severity===D.LanguageStatusSeverity.Error?S.default.Error:P.severity===D.LanguageStatusSeverity.Warning?S.default.Warning:S.default.Info,command:P.command&&this._commands.toInternal(P.command,s),accessibilityInfo:P.accessibilityInformation})},0)},v={dispose(){s.dispose(),b?.dispose(),f.$removeLanguageStatus(p),w.delete(_)},get id(){return P.id},get name(){return P.name},set name(n){P.name=n,a()},get selector(){return P.selector},set selector(n){P.selector=n,a()},get text(){return P.text},set text(n){P.text=n,a()},get detail(){return P.detail},set detail(n){P.detail=n,a()},get severity(){return P.severity},set severity(n){P.severity=n,a()},get accessibilityInformation(){return P.accessibilityInformation},set accessibilityInformation(n){P.accessibilityInformation=n,a()},get command(){return P.command},set command(n){P.command=n,a()}};return a(),v}}e.ExtHostLanguages=E}),define(fe[132],me([0,1,11,5,27,14,3]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends g.AbstractLoggerService{constructor(i,I){const c=new A.Emitter;super(I.logLevel,c.event);this._proxy=i.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(i){this._onDidChangeLogLevel.fire(i)}doCreateLogger(i,I,c){return new E(this._proxy,i,I,c)}};k=Ve([$e(0,S.IExtHostRpcService),$e(1,D.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class E extends g.AbstractMessageLogger{constructor(i,I,c,p){super(p?.always);this.proxy=i,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(I,p).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(i,I){const c=[[i,I]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(i){this.proxy.$log(this.file,i)}}}),define(fe[246],me([0,1,5,26,11]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(k){return k&&k.title}let A=class{constructor(E,C){this._logService=C,this._proxy=E.getProxy(g.MainContext.MainThreadMessageService)}showMessage(E,C,i,I,c){const p={extension:E};let f;typeof I=="string"||S(I)?f=[I,...c]:(p.modal=I?.modal,p.useCustom=I?.useCustom,p.detail=I?.detail,f=c),p.useCustom&&(0,L.checkProposedApiEnabled)(E);const w=[];for(let _=0;_<f.length;_++){const P=f[_];if(typeof P=="string")w.push({title:P,handle:_,isCloseAffordance:!1});else if(typeof P=="object"){let{title:b,isCloseAffordance:s}=P;w.push({title:b,isCloseAffordance:!!s,handle:_})}else this._logService.warn("Invalid message item:",P)}return this._proxy.$showMessage(C,i,p,w).then(_=>{if(typeof _=="number")return f[_]})}};A=Ve([$e(1,D.ILogService)],A),e.ExtHostMessageService=A}),define(fe[247],me([0,1,22,3,48,6,24,8,13,2,87,5,17,7,54,223,128]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class P{constructor(s,a,v,n,h){this._textDocumentsAndEditors=v,this._textDocuments=n,this._extensionStoragePaths=h,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new i.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=a.converter,a.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const t=r.notebookEditor?.notebookUri,l=r.cell.handle,d=this._documents.get(t)?.getCell(l);if(d)return d.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const a=this._editors.get(s);if(!a)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return a}getIdByEditor(s){for(const[a,v]of this._editors)if(v.apiEditor===s)return a}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,a){const v=this._documents.get(s);if(!v&&!a)throw new Error(`NO notebook document for '${s}'`);return v}_getProviderData(s){const a=this._notebookContentProviders.get(s);if(!a)throw new Error(`NO provider for '${s}'`);return a}registerNotebookContentProvider(s,a,v,n,h){if((0,k.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(a))throw new Error(`Notebook provider for '${a}' already registered`);this._notebookContentProviders.set(a,{extension:s,provider:v});let r;return v.onDidChangeNotebookContentOptions&&(r=v.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(v.options);this._notebookProxy.$updateNotebookProviderOptions(a,t)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},a,c.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(s,h)),new p.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(a),this._notebookProxy.$unregisterNotebookProvider(a)})}static _convertNotebookRegistrationData(s,a){if(!a)return;const v=a.filenamePattern.map(n=>c.NotebookExclusiveDocumentPattern.from(n)).filter(n=>n!==void 0);if(a.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${a.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:a.displayName,filenamePattern:v,exclusive:a.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,a,v){const n=P._notebookStatusBarItemProviderHandlePool++,h=typeof v.onDidChangeCellStatusBarItems=="function"?P._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(n,v),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(n,h,a);let r;return h!==void 0&&(r=v.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(h))),new p.Disposable(()=>{this._notebookStatusBarItemProviders.delete(n),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(n,h),r&&r.dispose()})}async createNotebookDocument(s){const a=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&c.NotebookData.from(s.content)});return C.URI.revive(a)}async openNotebookDocument(s){const a=this._documents.get(s);if(a)return a.apiNotebook;const v=await this._notebookDocumentsProxy.$tryOpenNotebook(s),n=this._documents.get(C.URI.revive(v));return(0,E.assertIsDefined)(n?.apiNotebook)}async showNotebookDocument(s,a){C.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let v;typeof a=="object"?v={position:c.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selections:a.selections&&a.selections.map(c.NotebookRange.from),pinned:typeof a.preview=="boolean"?!a.preview:void 0}:v={preserveFocus:!1};const n=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,v),h=n&&this._editors.get(n)?.apiEditor;if(h)return h;throw n?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,a,v,n){const h=this._notebookStatusBarItemProviders.get(s),r=C.URI.revive(a),t=this._documents.get(r);if(!t||!h)return;const l=t.getCellFromIndex(v);if(!l)return;const o=await h.provideCellStatusBarItems(l.apiCell,n);if(!o)return;const d=new S.DisposableStore,m=this._statusBarCache.add([d]),y=(Array.isArray(o)?o:[o]).map(T=>c.NotebookStatusBarItem.from(T,this._commandsConverter,d));return{cacheId:m,items:y}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,a,v,n,h){if((0,k.isFalsyOrWhitespace)(a))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,v),this._notebookProxy.$registerNotebookSerializer(r,{id:s.identifier,location:s.extensionLocation},a,c.NotebookDocumentContentOptions.from(n),P._convertNotebookRegistrationData(s,h)),(0,S.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(s,a,v){const n=this._notebookSerializer.get(s);if(!n)throw new Error("NO serializer found");const h=await n.deserializeNotebook(a.buffer,v);return new f.SerializableObjectWithBuffers(c.NotebookData.from(h))}async $notebookToData(s,a,v){const n=this._notebookSerializer.get(s);if(!n)throw new Error("NO serializer found");const h=await n.serializeNotebook(c.NotebookData.to(a.value),v);return g.VSBuffer.wrap(h)}async $openNotebook(s,a,v,n,h){const{provider:r}=this._getProviderData(s),t=await r.openNotebook(C.URI.revive(a),{backupId:v,untitledDocumentData:n?.buffer},h);return new f.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(s,a,v){const n=this.getNotebookDocument(C.URI.revive(a)),{provider:h}=this._getProviderData(s);return await h.saveNotebook(n.apiNotebook,v),!0}async $saveNotebookAs(s,a,v,n){const h=this.getNotebookDocument(C.URI.revive(a)),{provider:r}=this._getProviderData(s);return await r.saveNotebookAs(C.URI.revive(v),h.apiNotebook,n),!0}async $backupNotebook(s,a,v){const n=this.getNotebookDocument(C.URI.revive(a)),h=this._getProviderData(s),r=this._extensionStoragePaths.workspaceValue(h.extension)??this._extensionStoragePaths.globalValue(h.extension),t=String((0,D.hash)([n.uri.toString(),this._backupIdPool++])),l=C.URI.joinPath(r,t),o=await h.provider.backupNotebook(n.apiNotebook,{destination:l},v);return n.updateBackup(o),o.id}_createExtHostEditor(s,a,v){if(this._editors.has(a))throw new Error(`editor with id ALREADY EXSIST: ${a}`);const n=new _.ExtHostNotebookEditor(a,this._notebookEditorsProxy,s,v.visibleRanges.map(c.NotebookRange.to),v.selections.map(c.NotebookRange.to),typeof v.viewColumn=="number"?c.ViewColumn.to(v.viewColumn):void 0);this._editors.set(a,n)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const v of s.value.removedDocuments){const n=C.URI.revive(v),h=this._documents.get(n);h&&(h.dispose(),this._documents.delete(n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(h.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===n.toString()&&this._editors.delete(r.id)}if(s.value.addedDocuments){const v=[];for(const n of s.value.addedDocuments){const h=C.URI.revive(n.uri);if(this._documents.has(h))throw new Error(`adding EXISTING notebook ${h} `);const r=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(l){r._onDidChangeNotebookCells.fire(l)},emitCellOutputsChange(l){r._onDidChangeCellOutputs.fire(l)},emitCellMetadataChange(l){r._onDidChangeCellMetadata.fire(l)},emitCellExecutionStateChange(l){r._onDidChangeCellExecutionState.fire(l)}},h,n);v.push(...n.cells.map(l=>w.ExtHostCell.asModelAddData(t.apiNotebook,l))),this._documents.get(h)?.dispose(),this._documents.set(h,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(s.value.addedEditors)for(const v of s.value.addedEditors){if(this._editors.has(v.id))return;const n=C.URI.revive(v.documentUri),h=this._documents.get(n);h&&this._createExtHostEditor(h,v.id,v)}const a=[];if(s.value.removedEditors)for(const v of s.value.removedEditors){const n=this._editors.get(v);n&&(this._editors.delete(v),this._activeNotebookEditor?.id===n.id&&(this._activeNotebookEditor=void 0),a.push(n))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(n=>this._editors.get(n)).filter(n=>!!n);const v=new Set;this._visibleNotebookEditors.forEach(n=>v.add(n.id));for(const n of this._editors.values()){const h=v.has(n.id);n._acceptVisibility(h)}this._visibleNotebookEditors=[...this._editors.values()].map(n=>n).filter(n=>n.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=P,P._notebookStatusBarItemProviderHandlePool=0}),define(fe[248],me([0,1,3,76,11,5,14,17]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class E{constructor(I,c){const p=E._Keys.nextId();I.$registerNotebookEditorDecorationType(p,k.NotebookDecorationRenderOptions.from(c)),this.value={key:p,dispose(){I.$removeNotebookEditorDecorationType(p)}}}}E._Keys=new L.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,c,p){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=p,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new E(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const p=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&p._acceptVisibleRanges(c.visibleRanges.ranges.map(k.NotebookRange.to)),c.selections&&p._acceptSelections(c.selections.selections.map(k.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(k.ViewColumn.to(I[c]))}};C=Ve([$e(0,D.ILogService),$e(1,A.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(fe[249],me([0,1,15,16,21,3,6,24,2,26,11,5,39,17,7,88,215,54]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(h,r,t,l,o){this._initData=r,this._extHostNotebook=t,this._commands=l,this._logService=o,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=h.getProxy(I.MainContext.MainThreadNotebookKernels);const d=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",m=>!0,m=>{if(m&&"notebookEditor"in m&&"id"in m){const u=this._extHostNotebook.getIdByEditor(m.notebookEditor);return{id:m.id,extension:m.extension,notebookEditorId:u}}else if(m&&"notebookEditor"in m){const u=this._extHostNotebook.getIdByEditor(m.notebookEditor);if(u===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${m.notebookEditor.document.uri.toString()}`);return{notebookEditorId:u}}return m})],c.ApiCommandResult.Void);this._commands.registerApiCommand(d)}createNotebookController(h,r,t,l,o,d){for(let O of this._kernelData.values())if(O.controller.id===r&&C.ExtensionIdentifier.equals(h.identifier,O.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const m=this._handlePool++,u=this;this._logService.trace(`NotebookController[${m}], CREATED by ${h.identifier.value}, ${r}`);const y=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${h.identifier}'`);let T=!1;const R=new A.DisposableStore,$=new S.Emitter,B=new S.Emitter,F={id:`${h.identifier.value}/${r}`,notebookType:t,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:l||h.identifier.value,preloads:d?d.map(p.NotebookRendererScript.from):[]};let W=o??y,M;this._proxy.$addKernel(m,F).catch(O=>{console.log(O),T=!0});let z=0;const N=()=>{if(T)return;const O=++z;Promise.resolve().then(()=>{O===z&&this._proxy.$updateKernel(m,F)})},U=new k.ResourceMap,x={get id(){return r},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:$.event,get label(){return F.label},set label(O){F.label=O??h.displayName??h.name,N()},get detail(){return F.detail??""},set detail(O){F.detail=O,N()},get description(){return F.description??""},set description(O){F.description=O,N()},get kind(){return(0,C.checkProposedApiEnabled)(h),F.kind??""},set kind(O){(0,C.checkProposedApiEnabled)(h),F.kind=O,N()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(O){F.supportedLanguages=O,N()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(O){F.supportsExecutionOrder=O,N()},get rendererScripts(){return F.preloads?F.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(O){W=O??y},get interruptHandler(){return M},set interruptHandler(O){M=O,F.supportsInterrupt=Boolean(O),N()},createNotebookCellExecution(O){if(T)throw new Error("notebook controller is DISPOSED");if(!U.has(O.notebook.uri))throw u._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(U.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${O.notebook.uri.toString()}`);return u._createNotebookCellExecution(O)},dispose:()=>{T||(this._logService.trace(`NotebookController[${m}], DISPOSED`),T=!0,this._kernelData.delete(m),R.dispose(),$.dispose(),B.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(O,j){u._proxy.$updateNotebookPriority(m,O.uri,j)},onDidReceiveMessage:B.event,postMessage(O,j){return(0,C.checkProposedApiEnabled)(h),u._proxy.$postMessage(m,j&&u._extHostNotebook.getIdByEditor(j),O)},asWebviewUri(O){return(0,C.checkProposedApiEnabled)(h),(0,w.asWebviewUri)(O,u._initData.remote)}};return this._kernelData.set(m,{extensionId:h.identifier,controller:x,onDidReceiveMessage:B,onDidChangeSelection:$,associatedNotebooks:U}),x}$acceptNotebookAssociation(h,r,t){const l=this._kernelData.get(h);if(l){const o=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));t?l.associatedNotebooks.set(o.uri,!0):l.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,o.uri.toString(),t),l.onDidChangeSelection.fire({selected:t,notebook:o.apiNotebook})}}async $executeCells(h,r,t){const l=this._kernelData.get(h);if(!l)return;const o=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),d=[];for(let m of t){const u=o.getCell(m);u&&d.push(u.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,o.uri.toString(),d.length),await l.controller.executeHandler.call(l.controller,d,o.apiNotebook,l.controller)}catch(m){this._logService.error(`NotebookController[${h}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(h,r,t){const l=this._kernelData.get(h);if(!l)return;const o=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,o.apiNotebook);else for(let d of t){const m=o.getCell(d);m&&this._activeExecutions.get(m.uri)?.cancel()}}$acceptKernelMessageFromRenderer(h,r,t){const l=this._kernelData.get(h);if(!l)return;const o=this._extHostNotebook.getEditorById(r);l.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:t}))}_createNotebookCellExecution(h){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!t)throw new Error("invalid cell");if(this._activeExecutions.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const l=new a(t.notebook,t,this._proxy);this._activeExecutions.set(t.uri,l);const o=l.onDidChangeState(()=>{l.state===s.Resolved&&(l.dispose(),o.dispose(),this._activeExecutions.delete(t.uri))});return l.asApiObject()}};b=Ve([$e(4,i.ILogService)],b),e.ExtHostNotebookKernels=b;var s;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(s||(s={}));class a extends A.Disposable{constructor(h,r,t){super();this._document=h,this._cell=r,this._proxy=t,this._handle=a.HANDLE++,this._onDidChangeState=new S.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new D.CancellationTokenSource),this._collector=new v(10,l=>this.update(l)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(h){await this._collector.addItem(h)}async update(h){const r=Array.isArray(h)?h:[h];return this._proxy.$updateExecutions(new P.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(h){let r=this._cell;if(h&&(r=this._document.getCellFromApiCell(h)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(h){return h.map(r=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?p.NotebookCellOutput.from(r):p.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(h,r,t){const l=this.cellIndexToHandle(r),o=this.validateAndConvertOutputs((0,g.asArray)(h));return this.updateSoon({editType:_.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:l,append:t,outputs:o})}async updateOutputItems(h,r,t){return h=f.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(h),!0),this.updateSoon({editType:_.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:h.map(p.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const h=this;return Object.freeze({get token(){return h._tokenSource.token},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(t){h._executionOrder=t,h.update([{editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:h._handle,executionOrder:h._executionOrder}])},start(t){if(h._state===s.Resolved||h._state===s.Started)throw new Error("Cannot call start again");h._state=s.Started,h._onDidChangeState.fire(),h.update({editType:_.CellExecutionUpdateType.ExecutionState,executionHandle:h._handle,runStartTime:t})},end(t,l){if(h._state===s.Resolved)throw new Error("Cannot call resolve twice");h._state=s.Resolved,h._onDidChangeState.fire(),h.updateSoon({editType:_.CellExecutionUpdateType.Complete,executionHandle:h._handle,runEndTime:l,lastRunSuccess:t}),h._collector.flush(),h._proxy.$removeExecution(h._handle)},clearOutput(t){return h.verifyStateForOutput(),h.updateOutputs([],t,!1)},appendOutput(t,l){return h.verifyStateForOutput(),h.updateOutputs(t,l,!0)},replaceOutput(t,l){return h.verifyStateForOutput(),h.updateOutputs(t,l,!1)},appendOutputItems(t,l){return h.verifyStateForOutput(),h.updateOutputItems(t,l,!0)},replaceOutputItems(t,l){return h.verifyStateForOutput(),h.updateOutputItems(t,l,!1)}})}}a.HANDLE=0;class v{constructor(h,r){this.delay=h,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(h){return this.batch.push(h),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const h=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>h.complete())}}}),define(fe[250],me([0,1,3,26,5,128]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(E,C){this._extHostNotebook=C,this._rendererMessageEmitters=new Map,this.proxy=E.getProxy(D.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(E,C,i){const I=this._extHostNotebook.getEditorById(E);this._rendererMessageEmitters.get(C)?.fire({editor:I.apiEditor,message:i})}createRendererMessaging(E,C){if(!E.contributes?.notebookRenderer?.some(p=>p.id===C))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${C})`);const i=(0,L.isProposedApiEnabled)(E),I=new WeakMap;return{onDidReceiveMessage:(p,f,w)=>{const _=i?p:P=>{const b={};I.set(b,P.editor),p({editor:b,message:P.message})};return this.getOrCreateEmitterFor(C).event(_,f,w)},postMessage:(p,f)=>{S.ExtHostNotebookEditor.apiEditorsToExtHost.has(p)&&([p,f]=[f,p]);const w=i?f:I.get(f),_=w&&S.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(_?.id,C,p)}}}getOrCreateEmitterFor(E){let C=this._rendererMessageEmitters.get(E);return C||(C=new g.Emitter({onLastListenerRemove:()=>{C?.dispose(),this._rendererMessageEmitters.delete(E)}}),this._rendererMessageEmitters.set(E,C),C)}}e.ExtHostNotebookRenderers=A}),define(fe[133],me([0,1,5,6,4,14,11,216,68,27,44,152,22]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class p extends L.Disposable{constructor(_,P,b,s){super();this.id=_,this.name=P,this.logger=b,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,_)}replace(_){const P=this.offset;this.write(_),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,P),this.visible&&this.logger.flush()}show(_,P){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:P))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=c.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=p;let f=class{constructor(_,P,b,s,a){this.extHostFileSystem=b,this.extHostFileSystemInfo=s,this.loggerService=a,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(g.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(P.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[P,b]of this.channels)b.visible=P===this.visibleChannelId}createOutputChannel(_,P){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(_,P);return b.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,b)}async doCreateOutputChannel(_,P){const b=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),v=await this.proxy.$register(_,!1,s,P.identifier.value);return new p(v,_,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,P){let b=!1;const s=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return _},append(a){s(),P.then(v=>v.append(a))},appendLine(a){s(),P.then(v=>v.appendLine(a))},clear(){s(),P.then(a=>a.clear())},replace(a){s(),P.then(v=>v.replace(a))},show(a,v){s(),P.then(n=>n.show(a,v))},hide(){s(),P.then(a=>a.hide())},dispose(){b=!0,P.then(a=>a.dispose())}}}};f=Ve([$e(0,S.IExtHostRpcService),$e(1,C.IExtHostInitDataService),$e(2,E.IExtHostConsumerFileSystem),$e(3,i.IExtHostFileSystemInfo),$e(4,A.ILoggerService)],f),e.ExtHostOutputService=f,e.IExtHostOutputService=(0,D.createDecorator)("IExtHostOutputService")}),define(fe[251],me([0,1,16,21,3,6,5,2,7,18,15,49,64]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(f,w,_){const P=f.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(o,d){this._sessions=new Map,this._instances=0,this._workspace=o,this._commands=d}showQuickPick(o,d,m,u=L.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(o),T=++this._instances,R=P.$show(T,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},u),$={},B=R.then(()=>$);return Promise.race([B,y]).then(F=>{if(F!==$)return y.then(W=>{const M=[];for(let z=0;z<W.length;z++){const N=W[z];let U,x,O,j,H;typeof N=="string"?U=N:(U=N.label,x=N.description,O=N.detail,j=N.picked,H=N.alwaysShow),M.push({label:U,description:x,handle:z,detail:O,picked:j,alwaysShow:H})}return m&&typeof m.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{m.onDidSelectItem(W[z])}),P.$setItems(T,M),R.then(z=>{if(typeof z=="number")return W[z];if(Array.isArray(z))return z.map(N=>W[N])})})}).then(void 0,F=>{if(!(0,C.isPromiseCanceledError)(F))return P.$setError(T,F),Promise.reject(F)})}$onItemSelected(o){this._onDidSelectItem&&this._onDidSelectItem(o)}showInput(o,d=L.CancellationToken.None){return this._validateInput=o?o.validateInput:void 0,P.$input(o,typeof this._validateInput=="function",d).then(void 0,m=>{if(!(0,C.isPromiseCanceledError)(m))return Promise.reject(m)})}$validateInput(o){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(o)):Promise.resolve(void 0)}async showWorkspaceFolderPick(o,d=L.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[o]);if(!m)return;const u=await this._workspace.getWorkspaceFolders2();if(!!u)return u.find(y=>y.uri.toString()===m.uri.toString())}createQuickPick(o,d){const m=new r(o,()=>this._sessions.delete(m._id));return this._sessions.set(m._id,m),m}createInputBox(o){const d=new t(o,()=>this._sessions.delete(d._id));return this._sessions.set(d._id,d),d}$onDidChangeValue(o,d){const m=this._sessions.get(o);m&&m._fireDidChangeValue(d)}$onDidAccept(o){const d=this._sessions.get(o);d&&d._fireDidAccept()}$onDidChangeActive(o,d){const m=this._sessions.get(o);m instanceof r&&m._fireDidChangeActive(d)}$onDidChangeSelection(o,d){const m=this._sessions.get(o);m instanceof r&&m._fireDidChangeSelection(d)}$onDidTriggerButton(o,d){const m=this._sessions.get(o);m&&m._fireDidTriggerButton(d)}$onDidTriggerItemButton(o,d,m){const u=this._sessions.get(o);u instanceof r&&u._fireDidTriggerItemButton(d,m)}$onDidHide(o){const d=this._sessions.get(o);d&&d._fireDidHide()}}class s{constructor(o,d){this._extensionId=o,this._onDidDispose=d,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(o){this._title=o,this.update({title:o})}get step(){return this._steps}set step(o){this._steps=o,this.update({step:o})}get totalSteps(){return this._totalSteps}set totalSteps(o){this._totalSteps=o,this.update({totalSteps:o})}get enabled(){return this._enabled}set enabled(o){this._enabled=o,this.update({enabled:o})}get busy(){return this._busy}set busy(o){this._busy=o,this.update({busy:o})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(o){this._ignoreFocusOut=o,this.update({ignoreFocusOut:o})}get value(){return this._value}set value(o){this._value=o,this.update({value:o})}get placeholder(){return this._placeholder}set placeholder(o){this._placeholder=o,this.update({placeholder:o})}get buttons(){return this._buttons}set buttons(o){this._buttons=o.slice(),this._handlesToButtons.clear(),o.forEach((d,m)=>{const u=d===E.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(u,d)}),this.update({buttons:o.map((d,m)=>({...h(d),tooltip:d.tooltip,handle:d===E.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(o){this._value=o,this._onDidChangeValueEmitter.fire(o)}_fireDidTriggerButton(o){const d=this._handlesToButtons.get(o);d&&this._onDidTriggerButtonEmitter.fire(d)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,S.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),P.$dispose(this._id))}update(o){if(!this._disposed){for(const d of Object.keys(o)){const m=o[d];this._pendingUpdate[d]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){P.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function a(l){if(l instanceof E.ThemeIcon)return{id:l.id};const o=n(l),d=v(l);return{dark:typeof o=="string"?k.URI.file(o):o,light:typeof d=="string"?k.URI.file(d):d}}function v(l){return typeof l=="object"&&"light"in l?l.light:l}function n(l){return typeof l=="object"&&"dark"in l?l.dark:l}function h(l){const o=a(l.iconPath);let d,m;return"id"in o?m=c.ThemeIcon.asClassName(o):d=o,{iconPath:d,iconClass:m}}class r extends s{constructor(o,d){super(o,d);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this._onDidTriggerItemButtonEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(o){this._items=o.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),o.forEach((d,m)=>{this._handlesToItems.set(m,d),this._itemsToHandles.set(d,m)}),this.update({items:o.map((d,m)=>({label:d.label,description:d.description,handle:m,detail:d.detail,picked:d.picked,alwaysShow:d.alwaysShow,buttons:d.buttons?.map((u,y)=>({...h(u),tooltip:u.tooltip,handle:y}))}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(o){this._canSelectMany=o,this.update({canSelectMany:o})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(o){this._matchOnDescription=o,this.update({matchOnDescription:o})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(o){this._matchOnDetail=o,this.update({matchOnDetail:o})}get sortByLabel(){return this._sortByLabel}set sortByLabel(o){this._sortByLabel=o,this.update({sortByLabel:o})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(o){this._keepScrollPosition=o,this.update({keepScrollPosition:o})}get activeItems(){return this._activeItems}set activeItems(o){this._activeItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({activeItems:this._activeItems.map(d=>this._itemsToHandles.get(d))})}get selectedItems(){return this._selectedItems}set selectedItems(o){this._selectedItems=o.filter(d=>this._itemsToHandles.has(d)),this.update({selectedItems:this._selectedItems.map(d=>this._itemsToHandles.get(d))})}_fireDidChangeActive(o){const d=(0,i.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._activeItems=d,this._onDidChangeActiveEmitter.fire(d)}_fireDidChangeSelection(o){const d=(0,i.coalesce)(o.map(m=>this._handlesToItems.get(m)));this._selectedItems=d,this._onDidChangeSelectionEmitter.fire(d)}_fireDidTriggerItemButton(o,d){const m=this._handlesToItems.get(o);if(!m||!m.buttons||!m.buttons.length)return;const u=m.buttons[d];u&&this._onDidTriggerItemButtonEmitter.fire({button:u,item:m})}}class t extends s{constructor(o,d){super(o,d);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(o){this._password=o,this.update({password:o})}get prompt(){return this._prompt}set prompt(o){this._prompt=o,this.update({prompt:o})}get validationMessage(){return this._validationMessage}set validationMessage(o){this._validationMessage=o,this.update({validationMessage:o,severity:o?I.default.Error:I.default.Ignore})}}return new b(w,_)}e.createExtHostQuickOpen=p}),define(fe[252],me([0,1,2,3,59,6,16,5,15,99,11,26,64,17]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function f(l){if(l)return typeof l.iconPath=="string"?g.URI.file(l.iconPath):g.URI.isUri(l.iconPath)||c.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function w(l,o){if(!l.iconPath&&!o.iconPath)return 0;if(l.iconPath){if(!o.iconPath)return 1}else return-1;const d=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,m=typeof o.iconPath=="string"?o.iconPath:g.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,C.comparePaths)(d,m)}function _(l,o){let d=0;if(l.strikeThrough!==o.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==o.faded)return l.faded?1:-1;if(l.tooltip!==o.tooltip)return(l.tooltip||"").localeCompare(o.tooltip||"");if(d=w(l,o),d!==0)return d;if(l.light&&o.light)d=w(l.light,o.light);else{if(l.light)return 1;if(o.light)return-1}if(d!==0)return d;if(l.dark&&o.dark)d=w(l.dark,o.dark);else{if(l.dark)return 1;if(o.dark)return-1}return d}function P(l,o){if(l.command!==o.command)return l.command<o.command?-1:1;if(l.title!==o.title)return l.title<o.title?-1:1;if(l.tooltip!==o.tooltip){if(l.tooltip!==void 0&&o.tooltip!==void 0)return l.tooltip<o.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(l.arguments===o.arguments)return 0;if(l.arguments)if(o.arguments){if(l.arguments.length!==o.arguments.length)return l.arguments.length-o.arguments.length}else return 1;else return-1;for(let d=0;d<l.arguments.length;d++){const m=l.arguments[d],u=o.arguments[d];if(m!==u)return m<u?-1:1}return 0}function b(l,o){let d=(0,C.comparePaths)(l.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(d!==0)return d;if(l.command&&o.command)d=P(l.command,o.command);else{if(l.command)return 1;if(o.command)return-1}if(d!==0)return d;if(l.decorations&&o.decorations)d=_(l.decorations,o.decorations);else{if(l.decorations)return 1;if(o.decorations)return-1}return d}function s(l,o){for(let d=0;d<l.length;d++)if(l[d]!==o[d])return!1;return!0}function a(l,o){return l.command===o.command&&l.title===o.title&&l.tooltip===o.tooltip&&(l.arguments&&o.arguments?s(l.arguments,o.arguments):l.arguments===o.arguments)}function v(l,o){return(0,E.equals)(l,o,a)}class n{constructor(o,d,m){this._extension=o,this._proxy=d,this._sourceControlHandle=m,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return(0,I.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(o){if((0,I.checkProposedApiEnabled)(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}showValidationMessage(o,d){(0,I.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,d)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=n;class h{constructor(o,d,m,u,y){this._proxy=o,this._commands=d,this._sourceControlHandle=m,this._id=u,this._label=y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=h._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,d){const m=this._resourceStatesCommandsMap.get(o);return m?(0,A.asPromise)(()=>this._commands.executeCommand(m.command,...m.arguments||[],d)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this._resourceStates].sort(b),m=(0,E.sortedDiff)(this._resourceSnapshot,o,b).map(T=>{const R=T.toInsert.map($=>{const B=this._resourceHandlePool++;this._resourceStatesMap.set(B,$);const F=$.resourceUri;let W;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const Q=new S.DisposableStore;W=this._commands.converter.toInternal($.command,Q),this._resourceStatesDisposablesMap.set(B,Q)}else this._resourceStatesCommandsMap.set(B,$.command);const M=f($.decorations),z=$.decorations&&f($.decorations.light)||M,N=$.decorations&&f($.decorations.dark)||M,U=[z,N],x=$.decorations&&$.decorations.tooltip||"",O=$.decorations&&!!$.decorations.strikeThrough,j=$.decorations&&!!$.decorations.faded,H=$.contextValue||"";return{rawResource:[B,F,U,x,O,j,H,W],handle:B}});return{start:T.start,deleteCount:T.deleteCount,toInsert:R}}),u=m.map(({start:T,deleteCount:R,toInsert:$})=>[T,R,$.map(B=>B.rawResource)]),y=m.reverse();for(const{start:T,deleteCount:R,toInsert:$}of y){const B=$.map(W=>W.handle),F=this._handlesSnapshot.splice(T,R,...B);for(const W of F)this._resourceStatesMap.delete(W),this._resourceStatesCommandsMap.delete(W),this._resourceStatesDisposablesMap.get(W)?.dispose(),this._resourceStatesDisposablesMap.delete(W)}return this._resourceSnapshot=o,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}h._handlePool=0;class r{constructor(o,d,m,u,y,T){this._extension=o,this._proxy=d,this._commands=m,this._id=u,this._label=y,this._rootUri=T,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new S.MutableDisposable,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new n(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,u,y,T)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=o;const d=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:d})}get actionButton(){return(0,I.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(o){(0,I.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new S.DisposableStore,this._actionButton=o;const d=o!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:d??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&v(this._statusBarCommands,o))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=o;const d=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:d})}get selected(){return this._selected}createResourceGroup(o,d){const m=new h(this._proxy,this._commands,this.handle,o,d),u=L.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,u),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],d=[];for(const[m,u]of this.createdResourceGroups){u.dispose();const y=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});L.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),y.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const T=m._takeResourceStateSnapshot();T.length>0&&d.push([m.handle,T]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,d),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(d=>{const m=d._takeResourceStateSnapshot();m.length!==0&&o.push([d.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([(0,D.debounce)(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([(0,D.debounce)(100)],r.prototype,"eventuallyUpdateResourceStates",null);let t=class Bi{constructor(o,d,m){this._commands=d,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=o.getProxy(k.MainContext.MainThreadSCM),this._telemetry=o.getProxy(k.MainContext.MainThreadTelemetry),d.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===3){const y=this._sourceControls.get(u.sourceControlHandle);if(!y)return u;const T=y.getResourceGroup(u.groupHandle);return T?T.getResourceState(u.handle):u}else if(u&&u.$mid===4){const y=this._sourceControls.get(u.sourceControlHandle);return y?y.getResourceGroup(u.groupHandle):u}else if(u&&u.$mid===5){const y=this._sourceControls.get(u.handle);return y||u}return u}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,d,m,u){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,d,m,u),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const y=Bi._handlePool++,T=new r(o,this._proxy,this._commands,d,m,u);this._sourceControls.set(y,T);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier))||[];return R.push(T),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(o.identifier),R),T}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const d=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(o.identifier)),m=d&&d[d.length-1];return m&&m.inputBox}$provideOriginalResource(o,d,m){const u=g.URI.revive(d);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,u.toString());const y=this._sourceControls.get(o);return!y||!y.quickDiffProvider||!y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>y.quickDiffProvider.provideOriginalResource(u,m)).then(T=>T||null)}$onInputBoxValueChange(o,d){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(d),Promise.resolve(void 0)}$executeResourceCommand(o,d,m,u){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,d,m);const y=this._sourceControls.get(o);if(!y)return Promise.resolve(void 0);const T=y.getResourceGroup(d);return T?T.$executeResourceCommand(m,u):Promise.resolve(void 0)}$validateInput(o,d,m){this.logService.trace("ExtHostSCM#$validateInput",o);const u=this._sourceControls.get(o);return!u||!u.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>u.inputBox.validateInput(d,m)).then(y=>{if(!y)return Promise.resolve(void 0);const T=p.MarkdownString.fromStrict(y.message);return T?Promise.resolve([T,y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this._sourceControls.get(o)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};t._handlePool=0,t=Ve([$e(2,i.ILogService)],t),e.ExtHostSCM=t});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[253],me([0,1,7,5,167,6,17,13]),function(Y,e,g,L,D,S,A,k){"use strict";var E,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class i{constructor(f,w,_,P,b=g.StatusBarAlignment.Left,s){E.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,st(this,E,f,"f"),st(this,C,w,"f"),this._entryId=i.ID_GEN++,this._extension=_,this._id=P,this._alignment=b,this._priority=this.validatePriority(s)}validatePriority(f){if(!!(0,k.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!i.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,C,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,C,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let w;this._name?w=this._name:w=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let _=this._color;this._backgroundColor&&(_=i.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const P=this._tooltip?A.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,E,"f").$setEntry(this._entryId,f,w,this._text,P,this._command?.internal,_,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=i,E=new WeakMap,C=new WeakMap,i.ID_GEN=0,i.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const w={message:f};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const _=this._messages.indexOf(w);_>=0&&(this._messages.splice(_,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(f,w){this._proxy=f.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(f,w,_,P){return new i(this._proxy,this._commands,f,w,_,P)}setStatusBarMessage(f,w){const _=this._statusMessage.setMessage(f);let P;return typeof w=="number"?P=setTimeout(()=>_.dispose(),w):typeof w!="undefined"&&w.then(()=>_.dispose(),()=>_.dispose()),new g.Disposable(()=>{_.dispose(),clearTimeout(P)})}}e.ExtHostStatusBar=c}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,E){this._proxy.$registerExtensionStorageKeysToSync(k,E)}getValue(k,E,C){return this._proxy.$getValue(k,E).then(i=>i||C)}setValue(k,E,C){return this._proxy.$setValue(k,E,C)}$acceptValue(k,E,C){this._onDidChangeStorage.fire({shared:k,key:E,value:C})}}e.ExtHostStorage=S,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(fe[69],me([0,1,4,27,11,68,2]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let k=class{constructor(C,i,I){this._logService=i,this._extHostFileSystem=I,this._workspace=C.workspace??void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(C){return A.URI.joinPath(this._environment.workspaceStorageHome,C)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const C=this._workspace.id,i=await this._getWorkspaceStorageURI(C);try{return await this._extHostFileSystem.value.stat(i),this._logService.trace("[ExtHostStorage] storage dir already exists",i),i}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",i),await this._extHostFileSystem.value.createDirectory(i),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(i,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:A.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),i}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(C){if(this._value)return A.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return A.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([$e(0,L.IExtHostInitDataService),$e(1,D.ILogService),$e(2,S.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(fe[33],me([0,1,3,5,4,2,14,6,7,168,18,218,21,31,197,64,13,16]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class b{constructor(o,d,m,u){this._proxy=o,this._id=d,this._creationOptions=m,this._name=u,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(T=>this._pidPromiseComplete=T);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(T,R=!0){y._checkDisposed(),y._proxy.$sendText(y._id,T,R)},show(T){y._checkDisposed(),y._proxy.$show(y._id,T)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(o,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,_.withNullAsUndefined)(o.shellPath),shellArgs:(0,_.withNullAsUndefined)(o.shellArgs),cwd:(0,_.withNullAsUndefined)(o.cwd),env:(0,_.withNullAsUndefined)(o.env),icon:(0,_.withNullAsUndefined)(r(o.iconPath)),color:w.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,_.withNullAsUndefined)(o.message),strictEnv:(0,_.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,_.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,_.withNullAsUndefined)(d?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,_.withNullAsUndefined)(d?.useShellEnvironment),location:d?.location||this._serializeParentTerminal(o.location,d?.resolvedExtHostIdentifier)})}async createExtensionTerminal(o,d,m,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:w.ThemeColor.isThemeColor(u)?u.id:void 0,location:this._serializeParentTerminal(o,d)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,d){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&d?{parentTerminal:d}:"viewColumn"in o?{viewColumn:o.viewColumn,preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitCode(o){this._exitStatus=Object.freeze({code:o})}setDimensions(o,d){return o===this._cols&&d===this._rows||o===0||d===0?!1:(this._cols=o,this._rows=d,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(d=>{d!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=b;class s{constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,d){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${d}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput&&this._pty.handleInput(o)}resize(o,d){this._pty.setDimensions&&this._pty.setDimensions({columns:o,rows:d})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(d=>this._onProcessData.fire(d)),this._pty.onDidClose&&this._pty.onDidClose((d=void 0)=>{this._onProcessExit.fire(d===void 0?void 0:d)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(d=>{d&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:d.columns,rows:d.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(d=>{this._onDidChangeProperty.fire({type:"title",value:d})}),this._pty.open(o||void 0),this._pty.setDimensions&&o&&this._pty.setDimensions(o),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let a=1,v=class extends k.Disposable{constructor(o,d){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=d.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[m,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,d){const m=new b(this._proxy,(0,p.generateUuid)(),o,o.name),u=new s(o.pty);return m.createExtensionTerminal(o.location,this._serializeParentTerminal(o,d).resolvedExtHostIdentifier,r(o.iconPath),t(o.color)).then(y=>{const T=this._setupExtHostProcessListeners(y,u);this._terminalProcessDisposables[y]=T}),this._terminals.push(m),m.value}_serializeParentTerminal(o,d){if(d=d||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const m=o.location.parentTerminal;if(m){const u=this._terminals.find(y=>y.value===m);u&&(d.resolvedExtHostIdentifier=u._id)}}else o.location&&typeof o.location!="object"?d.location=o.location:d.location&&typeof d.location=="object"&&"splitActiveTerminal"in d.location&&(d.location={splitActiveTerminal:!0});return d}attachPtyToTerminal(o,d){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const u=new s(d),y=this._setupExtHostProcessListeners(o,u);this._terminalProcessDisposables[o]=y}async $acceptActiveTerminalChanged(o){const d=this._activeTerminal;if(o===null){this._activeTerminal=void 0,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(o);m&&(this._activeTerminal=m,d!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,d){const m=this._getTerminalById(o);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:d})}async $acceptTerminalDimensions(o,d,m){const u=this._getTerminalById(o);u&&u.setDimensions(d,m)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(o,d,m){this._terminalProcesses.get(o)?.resize(d,m)}async $acceptTerminalTitleChange(o,d){const m=this._getTerminalById(o);m&&(m.name=d)}async $acceptTerminalClosed(o,d){const m=this._getTerminalObjectIndexById(this._terminals,o);if(m!==null){const u=this._terminals.splice(m,1)[0];u.setExitCode(d),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(o,d,m,u){if(d){const R=this._getTerminalObjectIndexById(this._terminals,d);if(R!==null){this._terminals[R]._id=o,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const y={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:S.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},T=new b(this._proxy,o,y,m);this._terminals.push(T),this._onDidOpenTerminal.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(o,d){const m=this._getTerminalById(o);m&&m._setProcessId(d)}async $startExtensionTerminal(o,d){const m=this._getTerminalById(o);if(!m)return{message:(0,C.localize)(0,null,o)};m.isOpen||await new Promise(y=>{const T=this.onDidOpenTerminal(async R=>{R===m.value&&(T.dispose(),y())})});const u=this._terminalProcesses.get(o);u?u.startSendingEvents(d):this._extensionTerminalAwaitingStart[o]={initialDimensions:d}}_setupExtHostProcessListeners(o,d){const m=new k.DisposableStore;m.add(d.onProcessReady(y=>this._proxy.$sendProcessReady(o,y.pid,y.cwd))),m.add(d.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(o,y))),this._bufferer.startBuffering(o,d.onProcessData),m.add(d.onProcessExit(y=>this._onProcessExit(o,y))),this._terminalProcesses.set(o,d);const u=this._extensionTerminalAwaitingStart[o];return u&&d instanceof s&&(d.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),m}$acceptProcessAckDataEvent(o,d){this._terminalProcesses.get(o)?.acknowledgeDataEvent(d)}$acceptProcessInput(o,d){this._terminalProcesses.get(o)?.input(d)}$acceptTerminalInteraction(o){const d=this._getTerminalById(o);d?.setInteractedWith()&&this._onDidChangeTerminalState.fire(d.value)}$acceptProcessResize(o,d,m){try{this._terminalProcesses.get(o)?.resize(d,m)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(o,d){this._terminalProcesses.get(o)?.shutdown(d)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(d=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:d}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(d=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:d}))}$acceptProcessRequestLatency(o){return o}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,d,m){if(this._profileProviders.has(d))throw new Error(`Terminal profile provider "${d}" already registered`);return this._profileProviders.set(d,m),this._proxy.$registerProfileProvider(d,o.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(d),this._proxy.$unregisterProfileProvider(d)})}async $createContributedProfileTerminal(o,d){const m=new c.CancellationTokenSource().token;let u=await this._profileProviders.get(o)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(u&&!("options"in u)&&(u={options:u}),!u||!("options"in u))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in u.options){this.createExtensionTerminal(u.options,d);return}this.createTerminalFromOptions(u.options,d)}}async $provideLinks(o,d){const m=this._getTerminalById(o);if(!m)return[];this._terminalLinkCache.delete(o);const u=this._terminalLinkCancellationSource.get(o);u&&u.dispose(!0);const y=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,y);const T=[],R={terminal:m.value,line:d},$=[];for(const W of this._linkProviders)$.push(P.Promises.withAsyncBody(async M=>{y.token.onCancellationRequested(()=>M({provider:W,links:[]}));const z=await W.provideTerminalLinks(R,y.token)||[];y.token.isCancellationRequested||M({provider:W,links:z})}));const B=await Promise.all($);if(y.token.isCancellationRequested)return[];const F=new Map;for(const W of B)W&&W.links.length>0&&T.push(...W.links.map(M=>{const z={id:a++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(z.id,{provider:W.provider,link:M}),z}));return this._terminalLinkCache.set(o,F),T}$activateLink(o,d){const m=this._terminalLinkCache.get(o)?.get(d);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(o,d){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const m=this._terminalProcessDisposables[o];m&&(m.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,d)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,d){const m=this._getTerminalObjectIndexById(o,d);return m!==null?o[m]:null}_getTerminalObjectIndexById(o,d){let m=null;return o.some((u,y)=>u._id===d?(m=y,!0):!1),m}getEnvironmentVariableCollection(o){let d=this._environmentVariableCollections.get(o.identifier.value);return d||(d=new n,this._setEnvironmentVariableCollection(o.identifier.value,d)),d}_syncEnvironmentVariableCollection(o,d){const m=(0,I.serializeEnvironmentVariableCollection)(d.map);this._proxy.$setEnvironmentVariableCollection(o,d.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(o){o.forEach(d=>{const m=d[0],u=new n(d[1]);this._setEnvironmentVariableCollection(m,u)})}$acceptDefaultProfile(o,d){this._defaultProfile=o,this._defaultAutomationProfile=d}_setEnvironmentVariableCollection(o,d){this._environmentVariableCollections.set(o,d),d.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,d)})}};v=Ve([$e(1,A.IExtHostRpcService)],v),e.BaseExtHostTerminalService=v;class n{constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(o)}get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(o,d){this._setIfDiffers(o,{value:d,type:E.EnvironmentVariableMutatorType.Replace})}append(o,d){this._setIfDiffers(o,{value:d,type:E.EnvironmentVariableMutatorType.Append})}prepend(o,d){this._setIfDiffers(o,{value:d,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,d){const m=this.map.get(o);(!m||m.value!==d.value||m.type!==d.type)&&(this.map.set(o,d),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,d){this.map.forEach((m,u)=>o.call(d,u,m,this))}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=n;let h=class extends v{constructor(o){super(!1,o)}createTerminal(o,d,m){throw new i.NotSupportedError}createTerminalFromOptions(o,d){throw new i.NotSupportedError}};h=Ve([$e(0,A.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h;function r(l){if(!(!l||typeof l=="string"))return"id"in l?{id:l.id,color:l.color}:l}function t(l){return w.ThemeColor.isThemeColor(l)?l:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[254],me([0,1,15,22,21,3,75,48,6,25,13,31,5,14,65,17,7,226,126,89]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let v=class{constructor(R,$){this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(c.MainContext.MainThreadTesting),this.observer=new m(this.proxy),this.runTracker=new h(this.proxy),$.registerArgumentProcessor({processArgument:B=>B?.$mid===13?w.TestItem.toItemFromContext(B):B})}createTestController(R,$){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const B=new E.DisposableStore,F=B.add(new P.SingleUseTestCollection(R));F.root.label=$;const W=new Map,M=this.proxy,z={items:F.root.children,get label(){return $},set label(U){$=U,F.root.label=U,M.$updateControllerLabel(R,$)},get id(){return R},createRunProfile:(U,x,O,j,H)=>{let X=(0,k.hash)(U);for(;W.has(X);)X++;const Q=new u(this.proxy,R,X,U,x,O,j,H);return W.set(X,Q),Q},createTestItem(U,x,O){return new f.TestItemImpl(R,U,x,O)},createTestRun:(U,x,O=!0)=>this.runTracker.createTestRun(R,F,U,x,O),set resolveHandler(U){F.resolveHandler=U},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};z.createRunConfiguration=z.createRunProfile,M.$registerTestController(R,$),B.add((0,E.toDisposable)(()=>M.$unregisterTestController(R)));const N={controller:z,collection:F,profiles:W};return this.controllers.set(R,N),B.add((0,E.toDisposable)(()=>this.controllers.delete(R))),B.add(F.onDidGenerateDiff(U=>M.$publishDiff(R,U))),z}createTestObserver(){return this.observer.checkout()}async runTests(R,$=D.CancellationToken.None){const B=r(R);if(!B)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(B.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map(W=>W.id)??[F.collection.root.id],profileGroup:y[B.kind],profileId:B.profileId,controllerId:B.controllerId}],exclude:R.exclude?.map(W=>W.id)},$)}$provideFileCoverage(R,$,B){return(0,g.mapFind)(this.runTracker.trackers,W=>W.id===R?W.getCoverage($):void 0)?.provideFileCoverage(B)??Promise.resolve([])}$resolveFileCoverage(R,$,B,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage($):void 0)?.resolveFileCoverage(B,F)??Promise.resolve([])}$configureRunProfile(R,$){this.controllers.get(R)?.profiles.get($)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map($=>(0,C.deepFreeze)(w.TestResults.to($))).concat(this.results).sort(($,B)=>B.completedAt-$.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,$){const B=this.controllers.get(s.TestId.fromString(R).controllerId)?.collection;B&&(await B.expand(R,$<0?Infinity:$),B.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,$){const B=this.controllers.get(R.controllerId);if(!B)return;const{collection:F,profiles:W}=B,M=W.get(R.profileId);if(!M)return;const z=R.testIds.map(O=>F.tree.get(O)).filter(i.isDefined),N=R.excludeExtIds.map(O=>B.collection.tree.get(O)).filter(i.isDefined).filter(O=>z.some(j=>j.fullId.compare(O.fullId)===2));if(!z.length)return;const U=new _.TestRunRequest(z.some(O=>O.actual instanceof f.TestItemRootImpl)?void 0:z.map(O=>O.actual),N.map(O=>O.actual),M),x=this.runTracker.prepareForMainThreadTestRun(U,t.fromInternal(R,B.collection),$);try{await M.runHandler(U,$)}finally{x.isRunning&&!$.isCancellationRequested&&await S.Event.toPromise(x.onEnd),x.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};v=Ve([$e(0,p.IExtHostRpcService)],v),e.ExtHostTesting=v;class n extends E.Disposable{constructor(R,$,B){super();this.dto=R,this.proxy=$,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new S.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new D.CancellationTokenSource(B)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const $=this.dto.id,B=this.dto.controllerId,F=(0,I.generateUuid)(),W=new l(this.proxy,$,F),M=x=>(O,...j)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),x(O,...j))},z=(x,O)=>{const j=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(x.uri&&x.range){const H={range:w.Range.from(x.range),uri:x.uri};for(const X of j)X.location=X.location||H}this.proxy.$appendTestMessagesInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),j)};let N=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return W.coverageProvider},set coverageProvider(x){W.coverageProvider=x},enqueued:M(x=>{this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),1)}),skipped:M(x=>{this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),5)}),started:M(x=>{this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),2)}),errored:M((x,O,j)=>{z(x,O),this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),6,j)}),failed:M((x,O,j)=>{z(x,O),this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,B).toString(),4,j)}),passed:M((x,O)=>{this.proxy.$updateTestStateInRun($,F,s.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString(),3,O)}),appendOutput:(x,O,j)=>{N||(j&&(this.dto.isIncluded(j)?this.ensureTestIsKnown(j):j=void 0),this.proxy.$appendOutputToRun($,F,L.VSBuffer.fromString(x),O&&w.location.from(O),j&&s.TestId.fromExtHostTestItem(j,B).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask($,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:U,coverage:W}),this.proxy.$startedTestRunTask($,{id:F,name:R,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof f.TestItemImpl))throw new f.InvalidTestItemError(R.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const $=[],B=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if($.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===B))break;R=R.parent||B}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,$)}}class h{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,$,B){return this.getTracker(R,$,B)}cancelRunById(R){for(const $ of this.tracked.values())if($.id===R){$.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,$,B,F,W){const M=this.tracked.get(B);if(M)return M.createRun(F);const z=t.fromPublic(R,$,B,W),N=r(B);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:y[N.kind],id:N.profileId},exclude:B.exclude?.map(x=>x.id)??[],id:z.id,include:B.include?.map(x=>x.id)??[$.root.id],persist:W});const U=this.getTracker(B,z);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),U.createRun(F)}getTracker(R,$,B){const F=new n($,this.proxy,B);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=h;const r=T=>{if(!!T.profile){if(!(T.profile instanceof u))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class t{constructor(R,$,B,F,W,M){this.controllerId=R,this.id=$,this.isPersisted=W,this.colllection=M,this.includePrefix=B.map(z=>z+"\0"),this.excludePrefix=F.map(z=>z+"\0")}static fromPublic(R,$,B,F){return new t(R,(0,I.generateUuid)(),B.include?.map(W=>s.TestId.fromExtHostTestItem(W,R).toString())??[R],B.exclude?.map(W=>s.TestId.fromExtHostTestItem(W,R).toString())??[],F,$)}static fromInternal(R,$){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,$)}isIncluded(R){const $=s.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const B of this.excludePrefix)if($===B||$.startsWith(B))return!1;for(const B of this.includePrefix)if($===B||$.startsWith(B))return!0;return!1}}e.TestRunDto=t;class l{constructor(R,$,B){this.proxy=R,this.runId=$,this.taskId=B}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch($){throw this.fileCoverage=void 0,$}}async resolveFileCoverage(R,$){const B=await this.fileCoverage;let F=B?.[R];return!this._coverageProvider||!B||!F?[]:(F.detailedCoverage||(F=B[R]=await this._coverageProvider.resolveFileCoverage?.(F,$)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class o extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:$,removed:B}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...$].map(F=>F.revived)},get removed(){return[...B].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class d extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,$){return{...R,revived:w.TestItem.toPlain(R.item),depth:$?$.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=d;class m{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map($=>$.revived)},dispose:(0,A.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new d;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class u{constructor(R,$,B,F,W,M,z=!1,N=void 0){this.controllerId=$,this.profileId=B,this._label=F,this.kind=W,this.runHandler=M,this._isDefault=z,this._tag=N,a.set(this,void 0),st(this,a,R,"f");const U=y[W];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${W}`);Oe(this,a,"f").$publishTestRunProfile({profileId:B,controllerId:$,tag:N?w.TestTag.namespace(this.controllerId,N.id):null,label:F,group:U,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,a,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=u,a=new WeakMap;const y={[_.TestRunProfileKind.Coverage]:8,[_.TestRunProfileKind.Debug]:4,[_.TestRunProfileKind.Run]:2}}),define(fe[255],me([0,1,3,15,5,129,17,7]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(c=>c.value)}async showTextDocument(i,I,c){let p;typeof I=="number"?p={position:A.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?p={position:A.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?A.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:p={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(i.uri,p),w=f&&this._extHostDocumentsAndEditors.getEditor(f);if(w)return w.value;throw f?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new S.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const c=this._extHostDocumentsAndEditors.getEditor(i);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const p=I.selections.selections.map(A.Selection.to);c._acceptSelections(p)}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(A.Range.to));c._acceptVisibleRanges(p)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:A.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const p=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),f=I.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:f,kind:p})}if(I.visibleRanges){const p=L.coalesce(I.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:p})}}$acceptEditorPositionData(i){for(const I in i){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const p=A.ViewColumn.to(i[I]);c.value.viewColumn!==p&&(c._acceptViewColumn(p),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:p}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=E}),define(fe[256],me([0,1,2,4,5,6,7]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const p=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(E(p))?.get(c.handle)}return c}})}async $getTimeline(i,I,c,p,f){return this._providers.get(i)?.provideTimeline(g.URI.revive(I),c,p,f)}registerTimelineProvider(i,I,c,p){const f=new S.DisposableStore,w=this.convertTimelineItem(I.id,p,f).bind(this);let _;I.onDidChange&&(_=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const P=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:i,onDidChange:void 0,async provideTimeline(b,s,a,v){v?.resetCache&&(f.clear(),P.get(I.id)?.clear());const n=await I.provideTimeline(b,s,a);if(n==null)return;const h=w(b,v);return{...n,source:I.id,items:n.items.map(h)}},dispose(){for(const b of P.values())b.get(I.id)?.clear();_?.dispose(),f.dispose()}})}convertTimelineItem(i,I,c){return(p,f)=>{let w;if(f?.cacheResults){let _=this._itemsBySourceAndUriMap.get(i);_===void 0&&(_=new Map,this._itemsBySourceAndUriMap.set(i,_));const P=E(p);w=_.get(P),w===void 0&&(w=new Map,_.set(P,w))}return _=>{const{iconPath:P,...b}=_,s=`${i}|${_.id??_.timestamp}`;w?.set(s,_);let a,v,n;return _.iconPath&&(P instanceof A.ThemeIcon?n={id:P.id,color:P.color}:g.URI.isUri(P)?(a=P,v=P):{light:a,dark:v}=P),{...b,id:b.id??void 0,handle:s,source:i,command:_.command?I.toInternal(_.command,c):void 0,icon:a,iconDark:v,themeIcon:n,accessibilityInformation:_.accessibilityInformation}}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,S.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(i.id)?.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=k;function E(C){return C?.toString()}}),define(fe[257],me([0,1,6,10,2,5]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(E){this._openers=new Map,this._proxy=E.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const c=I.schemes.find(p=>!A.supportedSchemes.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,E,I.label),(0,g.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(E,C,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const c=D.URI.revive(C);return I.canOpenExternalUri(c,i)}async $openUri(E,C,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(D.URI.revive(C.resolvedUri),{sourceUri:D.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[258],me([0,1,5,2,6,18,26]),function(Y,e,g,L,D,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(A.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=k.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,D.toDisposable)(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(i))}catch(c){(0,S.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(C){return L.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=k,k.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[70],me([0,1,3,10,2,181,207,88,5]),function(Y,e,g,L,D,S,A,k,E){"use strict";var C,i,I,c,p,f,w,_,P,b,s,a;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class v{constructor(m,u,y,T,R,$,B){C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),w.set(this,""),_.set(this,void 0),P.set(this,!1),b.set(this,!1),s.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,a.set(this,new g.Emitter),this._onDidDispose=Oe(this,a,"f").event,st(this,C,m,"f"),st(this,i,u,"f"),st(this,_,y,"f"),st(this,c,T,"f"),st(this,p,R,"f"),st(this,f,$,"f"),st(this,s,n($),"f"),st(this,I,B,"f")}dispose(){st(this,P,!0,"f"),Oe(this,a,"f").fire(),Oe(this,a,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return st(this,b,!0,"f"),(0,k.asWebviewUri)(m,Oe(this,c,"f").remote)}get cspSource(){const m=Oe(this,f,"f").extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let u=m.toString();return u.endsWith("/")||(u+="/"),u+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,w,"f")}set html(m){this.assertNotDisposed(),Oe(this,w,"f")!==m&&(st(this,w,m,"f"),!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(st(this,b,!0,"f"),Oe(this,I,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,i,"f").$setHtml(Oe(this,C,"f"),m))}get options(){return this.assertNotDisposed(),Oe(this,_,"f")}set options(m){this.assertNotDisposed(),Oe(this,i,"f").$setOptions(Oe(this,C,"f"),t(Oe(this,f,"f"),Oe(this,p,"f"),m)),st(this,_,m,"f")}async postMessage(m){if(Oe(this,P,"f"))return!1;const u=(0,A.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:Oe(this,s,"f")});return Oe(this,i,"f").$postMessage(Oe(this,C,"f"),u.message,...u.buffers)}assertNotDisposed(){if(Oe(this,P,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=v,C=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,w=new WeakMap,_=new WeakMap,P=new WeakMap,b=new WeakMap,s=new WeakMap,a=new WeakMap;function n(d){try{const m=(0,S.normalizeVersion)((0,S.parseVersion)(d.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;class h{constructor(m,u,y,T,R){this.initData=u,this.workspace=y,this._logService=T,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=m.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(m,u,...y){const T=this.getWebview(m);if(T){const{message:R}=(0,A.deserializeWebviewMessage)(u,y);T._onMessageEmitter.fire(R)}}$onMissingCsp(m,u){this._logService.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,u,y){const T=new v(m,this._webviewProxy,l(u),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(m,T),T._onDidDispose(()=>{this._webviews.delete(m)}),T}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=h;function r(d){return{id:d.identifier,location:d.extensionLocation}}e.toExtensionData=r;function t(d,m,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||o(d,m)}}e.serializeWebviewOptions=t;function l(d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots?.map(m=>D.URI.from(m))}}e.reviveOptions=l;function o(d,m){return[...(m?.getWorkspaceFolders()||[]).map(u=>u.uri),d.extensionLocation]}}),define(fe[259],me([0,1,21,48,6,10,23,2,17,70,87,5,7]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class p{constructor(n,h){this.document=n,this._storagePath=h,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(n){return this._edits.add([n])}async undo(n,h){await this.getEdit(n).undo(),h||this.disposeBackup()}async redo(n,h){await this.getEdit(n).redo(),h||this.disposeBackup()}disposeEdits(n){for(const h of n)this._edits.delete(h)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const n=a(this.document.uri)+this._backupCounter++;return(0,A.joinPath)(this._storagePath,n)}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(n){const h=this._edits.get(n,0);if(!h)throw new Error("No edit found");return h}}class f{constructor(){this._documents=new Map}get(n,h){return this._documents.get(this.key(n,h))}add(n,h,r){const t=this.key(n,h.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${n} resource:${h.uri}`);const l=new p(h,r);return this._documents.set(t,l),l}delete(n,h){const r=this.key(n,h.uri);this._documents.delete(r)}key(n,h){return`${n}@@@${h}`}}var w;(function(v){v[v.Text=0]="Text",v[v.Custom=1]="Custom"})(w||(w={}));class _{constructor(){this._providers=new Map}addTextProvider(n,h,r){return this.add(0,n,h,r)}addCustomProvider(n,h,r){return this.add(1,n,h,r)}get(n){return this._providers.get(n)}add(n,h,r,t){if(this._providers.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this._providers.set(h,{type:n,extension:r,provider:t}),new c.Disposable(()=>this._providers.delete(h))}}class P{constructor(n,h,r,t,l){this._extHostDocuments=h,this._extensionStoragePaths=r,this._extHostWebview=t,this._extHostWebviewPanels=l,this._editorProviders=new _,this._documents=new f,this._proxy=n.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(n,h,r,t){const l=new D.DisposableStore;return b(r)?(l.add(this._editorProviders.addTextProvider(h,n,r)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(n),h,t.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(n))):(l.add(this._editorProviders.addCustomProvider(h,n,r)),this.supportEditing(r)&&l.add(r.onDidChangeCustomDocument(o=>{const d=this.getCustomDocumentEntry(h,o.document.uri);if(s(o)){const m=d.addEdit(o);this._proxy.$onDidEdit(o.document.uri,h,m,o.label)}else this._proxy.$onContentChange(o.document.uri,h)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(n),h,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(n))),c.Disposable.from(l,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(h)}))}async $createCustomDocument(n,h,r,t,l){const o=this._editorProviders.get(h);if(!o)throw new Error(`No provider found for '${h}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${h}'`);const d=k.URI.revive(n),m=await o.provider.openCustomDocument(d,{backupId:r,untitledDocumentData:t?.buffer},l);let u;return this.supportEditing(o.provider)&&this._extensionStoragePaths&&(u=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(h,m,u),{editable:this.supportEditing(o.provider)}}async $disposeCustomDocument(n,h){const r=this._editorProviders.get(h);if(!r)throw new Error(`No provider found for '${h}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${h}'`);const t=k.URI.revive(n),{document:l}=this.getCustomDocumentEntry(h,t);this._documents.delete(h,l),l.dispose()}async $resolveWebviewEditor(n,h,r,t,l,o){const d=this._editorProviders.get(r);if(!d)throw new Error(`No provider found for '${r}'`);const m=E.ViewColumn.to(l),u=this._extHostWebview.createNewWebview(h,t.webviewOptions,d.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(h,r,t.title,m,t.panelOptions,u),T=k.URI.revive(n);switch(d.type){case 1:{const{document:R}=this.getCustomDocumentEntry(r,T);return d.provider.resolveCustomEditor(R,y,o)}case 0:{const R=this._extHostDocuments.getDocument(T);return d.provider.resolveCustomTextEditor(R,y,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(n,h,r){this.getCustomDocumentEntry(h,n).disposeEdits(r)}async $onMoveCustomEditor(n,h,r){const t=this._editorProviders.get(r);if(!t)throw new Error(`No provider found for '${r}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const l=this._extHostWebviewPanels.getWebviewPanel(n);if(!l)throw new Error("No webview found");const o=k.URI.revive(h),d=this._extHostDocuments.getDocument(o);await t.provider.moveCustomTextEditor(d,l,g.CancellationToken.None)}async $undo(n,h,r,t){return this.getCustomDocumentEntry(h,n).undo(r,t)}async $redo(n,h,r,t){return this.getCustomDocumentEntry(h,n).redo(r,t)}async $revert(n,h,r){const t=this.getCustomDocumentEntry(h,n);await this.getCustomEditorProvider(h).revertCustomDocument(t.document,r),t.disposeBackup()}async $onSave(n,h,r){const t=this.getCustomDocumentEntry(h,n);await this.getCustomEditorProvider(h).saveCustomDocument(t.document,r),t.disposeBackup()}async $onSaveAs(n,h,r,t){const l=this.getCustomDocumentEntry(h,n);return this.getCustomEditorProvider(h).saveCustomDocumentAs(l.document,k.URI.revive(r),t)}async $backup(n,h,r){const t=this.getCustomDocumentEntry(h,n),o=await this.getCustomEditorProvider(h).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},r);return t.updateBackup(o),o.id}getCustomDocumentEntry(n,h){const r=this._documents.get(n,k.URI.revive(h));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(n){const r=this._editorProviders.get(n)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(n){return!!n.onDidChangeCustomDocument}}e.ExtHostCustomEditors=P;function b(v){return typeof v.resolveCustomTextEditor=="function"}function s(v){return typeof v.undo=="function"&&typeof v.redo=="function"}function a(v){const n=v.scheme===S.Schemas.file||v.scheme===S.Schemas.untitled?v.fsPath:v.toString();return(0,L.hash)(n)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[260],me([0,1,3,6,2,31,17,70,5,7]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";var i,I,c,p,f,w,_,P,b,s,a,v,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class h extends L.Disposable{constructor(o,d,m,u,y,T,R){super();i.set(this,void 0),I.set(this,void 0),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),w.set(this,void 0),_.set(this,void 0),P.set(this,void 0),b.set(this,!0),s.set(this,!0),a.set(this,!1),v.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,v,"f").event,n.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Oe(this,n,"f").event,st(this,i,o,"f"),st(this,I,d,"f"),st(this,c,m,"f"),st(this,f,T,"f"),st(this,P,y,"f"),st(this,w,u,"f"),st(this,p,R,"f")}dispose(){Oe(this,a,"f")||(st(this,a,!0,"f"),Oe(this,v,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,i,"f")),Oe(this,p,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,p,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(o){this.assertNotDisposed(),Oe(this,w,"f")!==o&&(st(this,w,o,"f"),Oe(this,I,"f").$setTitle(Oe(this,i,"f"),o))}get iconPath(){return this.assertNotDisposed(),Oe(this,_,"f")}set iconPath(o){this.assertNotDisposed(),Oe(this,_,"f")!==o&&(st(this,_,o,"f"),Oe(this,I,"f").$setIconPath(Oe(this,i,"f"),D.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,P,"f")=="number"&&Oe(this,P,"f")<0))return Oe(this,P,"f")}get active(){return this.assertNotDisposed(),Oe(this,s,"f")}get visible(){return this.assertNotDisposed(),Oe(this,b,"f")}_updateViewState(o){Oe(this,a,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(st(this,s,o.active,"f"),st(this,b,o.visible,"f"),st(this,P,o.viewColumn,"f"),Oe(this,n,"f").fire({webviewPanel:this}))}reveal(o,d){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,i,"f"),{viewColumn:o?A.ViewColumn.from(o):void 0,preserveFocus:!!d})}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,w=new WeakMap,_=new WeakMap,P=new WeakMap,b=new WeakMap,s=new WeakMap,a=new WeakMap,v=new WeakMap,n=new WeakMap;class r{constructor(o,d,m){this.webviews=d,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=o.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,S.generateUuid)()}createWebviewPanel(o,d,m,u,y={}){const T=typeof u=="object"?u.viewColumn:u,R={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof u=="object"&&!!u.preserveFocus},$=(0,k.shouldSerializeBuffersForPostMessage)(o),B=r.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(o),B,d,{title:m,panelOptions:t(y),webviewOptions:(0,k.serializeWebviewOptions)(o,this.workspace,y),serializeBuffersForPostMessage:$},R);const F=this.webviews.createNewWebview(B,y,o);return this.createNewWebviewPanel(B,d,m,T,y,F)}$onDidChangeWebviewPanelViewStates(o){const d=Object.keys(o);d.sort((m,u)=>{const y=o[m],T=o[u];return y.active?1:T.active?-1:+y.visible-+T.visible});for(const m of d){const u=this.getWebviewPanel(m);if(!u)continue;const y=o[m];u._updateViewState({active:y.active,visible:y.visible,viewColumn:A.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this._webviewPanels.delete(o),this.webviews.deleteWebview(o)}registerWebviewPanelSerializer(o,d,m){if(this._serializers.has(d))throw new Error(`Serializer for '${d}' already registered`);return this._serializers.set(d,{serializer:m,extension:o}),this._proxy.$registerSerializer(d,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(o)}),new C.Disposable(()=>{this._serializers.delete(d),this._proxy.$unregisterSerializer(d)})}async $deserializeWebviewPanel(o,d,m,u){const y=this._serializers.get(d);if(!y)throw new Error(`No serializer found for '${d}'`);const{serializer:T,extension:R}=y,$=this.webviews.createNewWebview(o,m.webviewOptions,R),B=this.createNewWebviewPanel(o,d,m.title,u,m.panelOptions,$);await T.deserializeWebviewPanel(B,m.state)}createNewWebviewPanel(o,d,m,u,y,T){const R=new h(o,this._proxy,d,m,u,y,T);return this._webviewPanels.set(o,R),R}getWebviewPanel(o){return this._webviewPanels.get(o)}}e.ExtHostWebviewPanels=r;function t(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[261],me([0,1,3,6,70,5,7]),function(Y,e,g,L,D,S,A){"use strict";var k,E,C,i,I,c,p,f,w,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class P extends L.Disposable{constructor(a,v,n,h,r,t){super();k.set(this,void 0),E.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),c.set(this,void 0),p.set(this,void 0),f.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,_.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,_,"f").event,st(this,C,n,"f"),st(this,p,h,"f"),st(this,k,a,"f"),st(this,E,v,"f"),st(this,i,r,"f"),st(this,c,t,"f")}dispose(){Oe(this,I,"f")||(st(this,I,!0,"f"),Oe(this,_,"f").fire(),Oe(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,p,"f")}set title(a){this.assertNotDisposed(),Oe(this,p,"f")!==a&&(st(this,p,a,"f"),Oe(this,E,"f").$setWebviewViewTitle(Oe(this,k,"f"),a))}get description(){return this.assertNotDisposed(),Oe(this,f,"f")}set description(a){this.assertNotDisposed(),Oe(this,f,"f")!==a&&(st(this,f,a,"f"),Oe(this,E,"f").$setWebviewViewDescription(Oe(this,k,"f"),a))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,i,"f")}get viewType(){return Oe(this,C,"f")}_setVisible(a){a===Oe(this,c,"f")||Oe(this,I,"f")||(st(this,c,a,"f"),Oe(this,w,"f").fire())}show(a){this.assertNotDisposed(),Oe(this,E,"f").$show(Oe(this,k,"f"),!!a)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,E=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,c=new WeakMap,p=new WeakMap,f=new WeakMap,w=new WeakMap,_=new WeakMap;class b{constructor(a,v){this._extHostWebview=v,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=a.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(a,v,n,h){if(this._viewProviders.has(v))throw new Error(`View provider for '${v}' already registered`);return this._viewProviders.set(v,{provider:n,extension:a}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(a),v,{retainContextWhenHidden:h?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(v),this._proxy.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(a,v,n,h,r){const t=this._viewProviders.get(v);if(!t)throw new Error(`No view provider found for '${v}'`);const{provider:l,extension:o}=t,d=this._extHostWebview.createNewWebview(a,{},o),m=new P(a,this._proxy,v,n,d,!0);this._webviewViews.set(a,m),await l.resolveWebviewView(m,{state:h},r)}async $onDidChangeWebviewViewVisibility(a,v){this.getWebviewView(a)._setVisible(v)}async $disposeWebviewView(a){const v=this.getWebviewView(a);this._webviewViews.delete(a),v.dispose(),this._extHostWebview.deleteWebview(a)}getWebviewView(a){const v=this._webviewViews.get(a);if(!v)throw new Error("No webview found");return v}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,8,4,14]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class $i{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let p;if(typeof I=="string"){p=I;try{I=D.URI.parse(I)}catch(f){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,A.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,p,c)}async asExternalUri(I,c){if((0,A.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const p=await this._proxy.$asExternalUri(I,c);return D.URI.from(p)}};C.InitialState={focused:!0},C=Ve([$e(0,E.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(fe[262],me([0,1,9,81,31,39,6,5,2,14]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let i=class extends A.Disposable{constructor(c,p){super();const f=c.getProxy(k.MainContext.MainThreadDownloadService);p.registerCommand(!1,"_workbench.downloadResource",async w=>{const _=E.URI.file((0,g.join)((0,L.tmpdir)(),(0,D.generateUuid)()));return await f.$download(w,_),_})}};i=Ve([$e(0,C.IExtHostRpcService),$e(1,S.IExtHostCommands)],i),e.ExtHostDownloadService=i}),define(fe[263],me([0,1,132,10,190,31]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends g.ExtHostLoggerService{doCreateLogger(E,C,i){if(E.scheme===L.Schemas.file){const I=new D.SpdLogLogger(i?.name||(0,S.generateUuid)(),E.fsPath,!i?.donotRotate,C);return i?.donotUseFormatters&&I.clearFormatters(),I}return super.doCreateLogger(E,C,i)}}e.ExtHostLoggerService=A}),define(fe[264],me([0,1,62,9,2,69,6,10,16,28]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class i extends S.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(n){const h=await super._getWorkspaceStorageURI(n);if(h.scheme!==k.Schemas.file)return h;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const r=h.fsPath;let t=0;do{let l;t===0?l=r:l=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${t}`:`${r}-${t}`,await I(l);const o=L.join(l,"vscode.lock"),d=await w(this._logService,o,!1);if(d)return this._workspaceStorageLock=d,process.on("exit",()=>{d.dispose()}),D.URI.file(l);t++}while(t<10);return h}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=i;async function I(v){try{await C.Promises.stat(v);return}catch{}try{await C.Promises.mkdir(v,{recursive:!0})}catch{}}const c=1e3,p=10*60*1e3;class f extends A.Disposable{constructor(n,h){super();this.logService=n,this.filename=h,this._timer=this._register(new E.IntervalTimer),this._timer.cancelAndSet(async()=>{const r=await _(n,h);(!r||r.pid!==process.pid)&&(n.info(`Lock '${h}': The lock was lost unexpectedly.`),this._timer.cancel());try{await C.Promises.utimes(h,new Date,new Date)}catch(t){n.error(t),n.info(`Lock '${h}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(n){}}async setWillRelease(n){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${n} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+n};await C.Promises.writeFile(this.filename,JSON.stringify(h),{flag:"w"})}catch(h){this.logService.error(h)}}}async function w(v,n,h){try{const t={pid:process.pid,willReleaseAt:0};await C.Promises.writeFile(n,JSON.stringify(t),{flag:"wx"})}catch(t){v.error(t)}const r=await _(v,n);return!r||r.pid!==process.pid?h?(v.info(`Lock '${n}': Could not acquire lock, giving up.`),null):(v.info(`Lock '${n}': Could not acquire lock, checking if the file is stale.`),s(v,n)):(v.info(`Lock '${n}': Lock acquired.`),new f(v,n))}async function _(v,n){let h;try{h=await C.Promises.readFile(n)}catch(r){return v.error(r),null}try{return JSON.parse(String(h))}catch(r){return v.error(r),null}}async function P(v,n){let h;try{h=await C.Promises.stat(n)}catch(r){return v.error(r),0}return h.mtime.getTime()}function b(v){try{return process.kill(v,0),!0}catch(n){return!1}}async function s(v,n){const h=await _(v,n);if(!h)return v.info(`Lock '${n}': Could not read pid of lock holder.`),a(v,n);if(h.willReleaseAt){let d=h.willReleaseAt-Date.now();if(d<5e3){for(d>0?v.info(`Lock '${n}': The lockfile is scheduled to be released in ${d} ms.`):v.info(`Lock '${n}': The lockfile is scheduled to have been released.`);d>0;){if(await(0,E.timeout)(Math.min(100,d)),await P(v,n)===0)return a(v,n);d=h.willReleaseAt-Date.now()}return a(v,n)}}if(!b(h.pid))return v.info(`Lock '${n}': The pid ${h.pid} appears to be gone.`),a(v,n);const r=await P(v,n),t=Date.now()-r;if(t<=p)return v.info(`Lock '${n}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;v.info(`Lock '${n}': The lock looks stale, waiting for 2s.`),await(0,E.timeout)(2e3);const l=await P(v,n),o=Date.now()-l;return o<=p?(v.info(`Lock '${n}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(v.info(`Lock '${n}': The lock looks stale even after waiting for 2s.`),a(v,n))}async function a(v,n){v.info(`Lock '${n}': Deleting a stale lock.`);try{await C.Promises.unlink(n)}catch(h){}return w(v,n,!0)}}),define(fe[265],me([0,1,31,14,33]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends D.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,E,C){return this.createTerminalFromOptions({name:k,shellPath:E,shellArgs:C})}createTerminalFromOptions(k,E){const C=new D.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),k,k.name);return this._terminals.push(C),C.create(k,this._serializeParentTerminal(k,E)),C.value}};S=Ve([$e(0,L.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(fe[266],me([0,1,5,14,172,6,27,2,38,23,28,7,12,53,3,120,78,11]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,u,y){this.remoteAddress=m,this.localAddress=u,this._dispose=y,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function s(d){const m=d.trim().split(`
`),u=[];return m.forEach(T=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(T);R&&R.length>=3&&u.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),u.reduce((T,R)=>(T[R.socket]=R,T),{})}e.getSockets=s;function a(...d){const m=[].concat(...d.map(n));return[...new Map(m.filter(u=>u.st==="0A").map(u=>{const y=u.local_address.split(":");return{socket:parseInt(u.inode,10),ip:v(y[0]),port:parseInt(y[1],16)}}).map(u=>[u.ip+":"+u.port,u])).values()]}e.loadListeningPorts=a;function v(d){let m="";if(d.length===8)for(let u=d.length-2;u>=0;u-=2)m+=parseInt(d.substr(u,2),16),u!==0&&(m+=".");else for(let u=d.length-4;u>=0;u-=4)m+=parseInt(d.substr(u,4),16).toString(16),u!==0&&(m+=":");return m}e.parseIpAddress=v;function n(d){const m=d.trim().split(`
`),u=m.shift().trim().split(/\s+/).filter(T=>T!=="rx_queue"&&T!=="tm->when");return m.map(T=>T.trim().split(/\s+/).reduce((R,$,B)=>(R[u[B]||B]=$,R),{}))}e.loadConnectionTable=n;function h(d){return!!d.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||d.indexOf("out/vs/server/main.js")!==-1||d.indexOf("_productName=VSCode")!==-1}function r(d){const m=d.trim().split(`
`),u=[];return m.forEach(y=>{const T=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);T&&T.length>=4&&u.push({pid:parseInt(T[1],10),ppid:parseInt(T[2]),cmd:T[3]})}),u}e.getRootProcesses=r;async function t(d,m,u){const y=u.reduce((R,$)=>(R[$.pid]=$,R),{}),T=[];return d.forEach(({socket:R,ip:$,port:B})=>{const F=m[R]?m[R].pid:void 0,W=F?y[F]?.cmd:void 0;F&&W&&!h(W)&&T.push({host:$,port:B,detail:W,pid:F})}),T}e.findPorts=t;function l(d,m,u){const y=new Map,T=r(m);for(const R of d){const $=u.get(R.port);if($){y.set(R.port,$);continue}const B=T.find(F=>F.cmd.includes(`${R.port}`));if(B){let F=B,W;do W=T.find(M=>M.ppid===F.pid),W&&(F=W);while(W);y.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else y.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=l;let o=class extends S.Disposable{constructor(m,u,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(g.MainContext.MainThreadTunnelService),c.isLinux&&u.remote.isRemote&&u.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,u){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${u.remoteAddress.host}:${u.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(u,m.displayName);if(y){const T=new b(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(T),T}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,u){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:m,provider:u}),this._proxy.$registerPortsAttributesProvider(m,y),new I.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(m,u,y,T,R){const $=[];for(const F of m){const W=this._portAttributesProviders.get(F);if(!W)return[];$.push(...await Promise.all(u.map(async M=>W.provider.providePortAttributes(M,y,T,R))))}const B=$.filter(F=>!!F);return B.length>0?B.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let u=new _.MovingAverage,y;for(;this._candidateFindingEnabled;){const T=new Date().getTime(),R=(await this.findCandidatePorts()).filter(B=>(0,w.isLocalhost)(B.host)||(0,w.isAllInterfaces)(B.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(B=>B.port).join(", ")}`);const $=new Date().getTime()-T;u.update($),(!y||JSON.stringify(y)!==JSON.stringify(R))&&(y=R,await this._proxy.$onFoundNewCandidates(y)),await new Promise(B=>setTimeout(()=>B(),this.calculateDelay(u.value)))}}async setTunnelExtensionFunctions(m){if(m){if(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory){this._forwardPortProvider=m.tunnelFactory;let u=m.tunnelFeatures?.privacyOptions??[];m.tunnelFeatures?.public&&u.length===0&&(u=[{id:"private",label:D.localize(0,null),themeIcon:"lock"},{id:"public",label:D.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!m.tunnelFeatures?.elevation,public:!!m.tunnelFeatures?.public,privacyOptions:u})}}else this._forwardPortProvider=void 0;return(0,S.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,u){if(this._extensionTunnels.has(m.host)){const y=this._extensionTunnels.get(m.host);y.has(m.port)&&(u&&y.get(m.port).disposeListener.dispose(),await y.get(m.port).tunnel.dispose(),y.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,u){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(m,u);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const T=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const R=this._register(T.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(T.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:T,disposeListener:R}),p.TunnelDto.fromApiTunnel(T)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const u=await Promise.all(m.map(T=>this._showCandidatePort(T.host,T.port,T.detail??""))),y=m.filter((T,R)=>u[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(T=>T.port).join(", ")} to ${y.map(T=>T.port).join(", ")}`),y}async findCandidatePorts(){let m="",u="";try{m=await i.Promises.readFile("/proc/net/tcp","utf8"),u=await i.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const y=a(m,u),T=await new Promise(N=>{(0,E.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,x,O)=>{N(x)})}),R=s(T),$=await i.Promises.readdir("/proc"),B=[];for(let N of $)try{const U=Number(N),x=C.joinPath(k.URI.file("/proc"),N);if((await i.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(U)){const j=await i.Promises.readlink(C.joinPath(x,"cwd").fsPath),H=await i.Promises.readFile(C.joinPath(x,"cmdline").fsPath,"utf8");B.push({pid:U,cwd:j,cmd:H})}}catch(U){}const F=[],W=y.filter(N=>{const U=R[N.socket];return U||F.push(N),U}),M=t(W,R,B);let z;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(U=>{(0,E.exec)("ps -F -A -l | grep root",(x,O,j)=>{U(O)})});this._foundRootPorts=l(F,N,this._foundRootPorts),z=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${z.join(", ")}`)}return M.then(N=>z?N.concat(z):N)}};o=Ve([$e(0,L.IExtHostRpcService),$e(1,A.IExtHostInitDataService),$e(2,P.ILogService)],o),e.ExtHostTunnelService=o}),define(fe[267],me([0,1,16,22,21,18,3,6,102,231,54]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(y,T){try{return JSON.stringify(y,T)}catch(R){return"null"}}const p="$$ref$$",f={[p]:-1};class w{constructor(T,R){this.jsonString=T,this.referencedBuffers=R}}function _(y,T=null,R=!1){const $=[];return{jsonString:(R?c:JSON.stringify)(y,(F,W)=>{if(typeof W=="undefined")return f;if(typeof W=="object"){if(W instanceof L.VSBuffer){const M=$.push(W)-1;return{[p]:M}}if(T)return T(F,W)}return W}),referencedBuffers:$}}e.stringifyJsonWithBufferRefs=_;function P(y,T,R){return JSON.parse(y,($,B)=>{if(B){const F=B[p];if(typeof F=="number")return T[F];if(R&&B.$mid===1)return R.transformIncoming(B)}return B})}e.parseJsonAndRestoreBufferRefs=P;function b(y,T){return JSON.stringify(y,T)}function s(y){return y?(T,R)=>R&&R.$mid===1?y.transformOutgoing(R):R:null}var a;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const n=()=>{},h=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(T,R=null,$=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new A.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=T,this._logger=R,this._uriTransformer=$,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let B=0,F=i.ProxyIdentifier.count;B<F;B++)this._locals[B]=null,this._proxies[B]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(B=>this._receiveOneMessage(B))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(T=>{this._pendingRPCReplies[T].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(T){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(T){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(T){this._responsiveState!==T&&(this._responsiveState=T,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(T){return this._uriTransformer?(0,E.transformIncomingURIs)(T,this._uriTransformer):T}getProxy(T){const{nid:R,sid:$}=T;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,$)),this._proxies[R]}_createProxy(T,R){let $={get:(B,F)=>(typeof F=="string"&&!B[F]&&F.charCodeAt(0)===36&&(B[F]=(...W)=>this._remoteCall(T,F,W)),F===r?R:B[F])};return new Proxy(Object.create(null),$)}set(T,R){return this._locals[T.nid]=R,R}assertRegistered(T){for(let R=0,$=T.length;R<$;R++){const B=T[R];if(!this._locals[B.nid])throw new Error(`Missing actor ${B.sid} (isMain: ${B.isMain})`)}}_receiveOneMessage(T){if(this._isDisposed)return;const R=T.byteLength,$=l.read(T,0),B=$.readUInt8(),F=$.readUInt32();switch(B){case 1:case 2:{let{rpcId:W,method:M,args:z}=d.deserializeRequestJSONArgs($);this._uriTransformer&&(z=(0,E.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,W,M,z,B===2);break}case 3:case 4:{let{rpcId:W,method:M,args:z}=d.deserializeRequestMixedArgs($);this._uriTransformer&&(z=(0,E.transformIncomingURIs)(z,this._uriTransformer)),this._receiveRequest(R,F,W,M,z,B===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let W=d.deserializeReplyOKJSON($);this._uriTransformer&&(W=(0,E.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply(R,F,W);break}case 10:{const W=d.deserializeReplyOKJSONWithBuffers($,this._uriTransformer);this._receiveReply(R,F,W);break}case 8:{let W=d.deserializeReplyOKVSBuffer($);this._receiveReply(R,F,W);break}case 11:{let W=d.deserializeReplyErrError($);this._uriTransformer&&(W=(0,E.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr(R,F,W);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}_receiveRequest(T,R,$,B,F,W){this._logger&&this._logger.logIncoming(T,R,1,`receiveRequest ${(0,i.getStringIdentifierForProxy)($)}.${B}(`,F);const M=String(R);let z,N;if(W){const x=new D.CancellationTokenSource;F.push(x.token),z=this._invokeHandler($,B,F),N=()=>x.cancel()}else z=this._invokeHandler($,B,F),N=n;this._cancelInvokedHandlers[M]=N;const U=d.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"ack"),this._protocol.send(U),z.then(x=>{delete this._cancelInvokedHandlers[M];const O=d.serializeReplyOK(R,x,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",x),this._protocol.send(O)},x=>{delete this._cancelInvokedHandlers[M];const O=d.serializeReplyErr(R,x);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",x),this._protocol.send(O)})}_receiveCancel(T,R){this._logger&&this._logger.logIncoming(T,R,1,"receiveCancel");const $=String(R);this._cancelInvokedHandlers[$]&&this._cancelInvokedHandlers[$]()}_receiveReply(T,R,$){this._logger&&this._logger.logIncoming(T,R,0,"receiveReply:",$);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B],F.resolveOk($)}_receiveReplyErr(T,R,$){this._logger&&this._logger.logIncoming(T,R,0,"receiveReplyErr:",$);const B=String(R);if(!this._pendingRPCReplies.hasOwnProperty(B))return;const F=this._pendingRPCReplies[B];delete this._pendingRPCReplies[B];let W;$&&($.$isError?(W=new Error,W.name=$.name,W.message=$.message,W.stack=$.stack):W=$),F.resolveErr(W)}_invokeHandler(T,R,$){try{return Promise.resolve(this._doInvokeHandler(T,R,$))}catch(B){return Promise.reject(B)}}_doInvokeHandler(T,R,$){const B=this._locals[T];if(!B)throw new Error("Unknown actor "+(0,i.getStringIdentifierForProxy)(T));let F=B[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,i.getStringIdentifierForProxy)(T));return F.apply(B,$)}_remoteCall(T,R,$){if(this._isDisposed)return Promise.reject(S.canceled());let B=null;if($.length>0&&D.CancellationToken.isCancellationToken($[$.length-1])&&(B=$.pop()),B&&B.isCancellationRequested)return Promise.reject(S.canceled());const F=d.serializeRequestArguments($,this._uriReplacer),W=++this._lastMessageId,M=String(W),z=new C.LazyPromise;B&&B.onCancellationRequested(()=>{const U=d.serializeCancel(W);this._logger&&this._logger.logOutgoing(U.byteLength,W,0,"cancel"),this._protocol.send(d.serializeCancel(W))}),this._pendingRPCReplies[M]=z,this._onWillSendRequest(W);const N=d.serializeRequest(W,T,R,F,!!B);return this._logger&&this._logger.logOutgoing(N.byteLength,W,0,`request: ${(0,i.getStringIdentifierForProxy)(T)}.${R}(`,$),this._protocol.send(N),z}}e.RPCProtocol=t,I=h,t.UNRESPONSIVE_TIME=3*1e3;class l{constructor(T,R){this._buff=T,this._offset=R}static alloc(T,R,$){let B=new l(L.VSBuffer.alloc($+1+4),0);return B.writeUInt8(T),B.writeUInt32(R),B}static read(T,R){return new l(T,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(T){this._buff.writeUInt8(T,this._offset),this._offset+=1}readUInt8(){const T=this._buff.readUInt8(this._offset);return this._offset+=1,T}writeUInt32(T){this._buff.writeUInt32BE(T,this._offset),this._offset+=4}readUInt32(){const T=this._buff.readUInt32BE(this._offset);return this._offset+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this._buff.writeUInt8(T.byteLength,this._offset),this._offset+=1,this._buff.set(T,this._offset),this._offset+=T.byteLength}readShortString(){const T=this._buff.readUInt8(this._offset);this._offset+=1;const $=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,$}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readLongString(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+T).toString();return this._offset+=T,$}writeBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this._buff.writeUInt32BE(T.byteLength,this._offset),this._offset+=4,this._buff.set(T,this._offset),this._offset+=T.byteLength}readVSBuffer(){const T=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+T);return this._offset+=T,R}static sizeMixedArray(T){let R=0;R+=1;for(let $=0,B=T.length;$<B;$++){const F=T[$];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let W=0;W<F.buffers.length;++W)R+=this.sizeVSBuffer(F.buffers[W]);break;case 4:break}}return R}writeMixedArray(T){this._buff.writeUInt8(T.length,this._offset),this._offset+=1;for(let R=0,$=T.length;R<$;R++){const B=T[R];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let F=0;F<B.buffers.length;++F)this.writeBuffer(B.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(T);for(let $=0;$<T;$++)switch(this.readUInt8()){case 1:R[$]=this.readLongString();break;case 2:R[$]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),W=this.readLongString(),M=[];for(let z=0;z<F;++z)M.push(this.readVSBuffer());R[$]=new i.SerializableObjectWithBuffers(P(W,M,null));break;case 4:R[$]=void 0;break}return R}}l.sizeUInt32=4;var o;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(o||(o={}));class d{static _useMixedArgSerialization(T){for(let R=0,$=T.length;R<$;R++)if(T[R]instanceof L.VSBuffer||T[R]instanceof i.SerializableObjectWithBuffers||typeof T[R]=="undefined")return!0;return!1}static serializeRequestArguments(T,R){if(this._useMixedArgSerialization(T)){const $=[];for(let B=0,F=T.length;B<F;B++){const W=T[B];if(W instanceof L.VSBuffer)$[B]={type:2,value:W};else if(typeof W=="undefined")$[B]={type:4};else if(W instanceof i.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:z}=_(W.value,R);$[B]={type:3,value:L.VSBuffer.fromString(M),buffers:z}}else $[B]={type:1,value:L.VSBuffer.fromString(b(W,R))}}return{type:1,args:$}}return{type:0,args:b(T,R)}}static serializeRequest(T,R,$,B,F){switch(B.type){case 0:return this._requestJSONArgs(T,R,$,B.args,F);case 1:return this._requestMixedArgs(T,R,$,B.args,F)}}static _requestJSONArgs(T,R,$,B,F){const W=L.VSBuffer.fromString($),M=L.VSBuffer.fromString(B);let z=0;z+=l.sizeUInt8(),z+=l.sizeShortString(W),z+=l.sizeLongString(M);let N=l.alloc(F?2:1,T,z);return N.writeUInt8(R),N.writeShortString(W),N.writeLongString(M),N.buffer}static deserializeRequestJSONArgs(T){const R=T.readUInt8(),$=T.readShortString(),B=T.readLongString();return{rpcId:R,method:$,args:JSON.parse(B)}}static _requestMixedArgs(T,R,$,B,F){const W=L.VSBuffer.fromString($);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(W),M+=l.sizeMixedArray(B);let z=l.alloc(F?4:3,T,M);return z.writeUInt8(R),z.writeShortString(W),z.writeMixedArray(B),z.buffer}static deserializeRequestMixedArgs(T){const R=T.readUInt8(),$=T.readShortString(),B=T.readMixedArray(),F=new Array(B.length);for(let W=0,M=B.length;W<M;W++){const z=B[W];typeof z=="string"?F[W]=JSON.parse(z):F[W]=z}return{rpcId:R,method:$,args:F}}static serializeAcknowledged(T){return l.alloc(5,T,0).buffer}static serializeCancel(T){return l.alloc(6,T,0).buffer}static serializeReplyOK(T,R,$){if(typeof R=="undefined")return this._serializeReplyOKEmpty(T);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(T,R);if(R instanceof i.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:F}=_(R.value,$,!0);return this._serializeReplyOKJSONWithBuffers(T,B,F)}else return this._serializeReplyOKJSON(T,c(R,$))}static _serializeReplyOKEmpty(T){return l.alloc(7,T,0).buffer}static _serializeReplyOKVSBuffer(T,R){let $=0;$+=l.sizeVSBuffer(R);let B=l.alloc(8,T,$);return B.writeVSBuffer(R),B.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static _serializeReplyOKJSON(T,R){const $=L.VSBuffer.fromString(R);let B=0;B+=l.sizeLongString($);let F=l.alloc(9,T,B);return F.writeLongString($),F.buffer}static _serializeReplyOKJSONWithBuffers(T,R,$){const B=L.VSBuffer.fromString(R);let F=0;F+=l.sizeUInt32,F+=l.sizeLongString(B);for(const M of $)F+=l.sizeVSBuffer(M);let W=l.alloc(10,T,F);W.writeUInt32($.length),W.writeLongString(B);for(const M of $)W.writeBuffer(M);return W.buffer}static deserializeReplyOKJSON(T){const R=T.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(T,R){const $=T.readUInt32(),B=T.readLongString(),F=[];for(let W=0;W<$;++W)F.push(T.readVSBuffer());return new i.SerializableObjectWithBuffers(P(B,F,R))}static serializeReplyErr(T,R){return R?this._serializeReplyErrEror(T,R):this._serializeReplyErrEmpty(T)}static _serializeReplyErrEror(T,R){const $=L.VSBuffer.fromString(c(S.transformErrorForSerialization(R),null));let B=0;B+=l.sizeLongString($);let F=l.alloc(11,T,B);return F.writeLongString($),F.buffer}static deserializeReplyErrError(T){const R=T.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(T){return l.alloc(12,T,0).buffer}}var m;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var u;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(u||(u={}))}),define(fe[268],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[269],me([0,1,10,9,12,2,4,63,43,227,268]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,A.createDecorator)("pathService");let I=class Wi{constructor(p,f,w,_){this.localUserHome=p,this.remoteAgentService=f,this.environmentService=w,this.contextService=_,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||D.OS)(),this.resolveUserHome=(async()=>{const P=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=P?.userHome||p})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(p,f){if(p.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(f.getWorkspace());if(w)return w;const _=f.getWorkspace().folders[0];if(_)return _.uri.scheme;const P=f.getWorkspace().configuration;return P?P.scheme:g.Schemas.file}async userHome(p){return p?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(p=>p===1?L.win32:L.posix)}async fileURI(p){let f="";if(await this.resolveOS===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const _=p.indexOf("/",2);_===-1?(f=p.substring(2),p="/"):(f=p.substring(2,_),p=p.substring(_)||"/")}return S.URI.from({scheme:g.Schemas.file,authority:f,path:p,query:"",fragment:""})}};I=Ve([$e(1,i.IRemoteAgentService),$e(2,C.IWorkbenchEnvironmentService),$e(3,E.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[71],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(A,k){this.line=A,this.character=k}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,k){return new g(0,0)}with(A){return new g(0,0)}}e.Position=g;class L{constructor(A,k,E,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(A,k),this.end=new g(E,C)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new L(0,0,0,0)}with(A){return new L(0,0,0,0)}}e.Range=L;var D;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[32],me([0,1,15,30,25,29,8,4,9,18,71,13]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",f=(c.length+p.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var _;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(_=e.QueryType||(e.QueryType={}));function P(U){return!!U.preview}e.resultIsMatch=P;function b(U){return!!U.resource}e.isFileMatch=b;function s(U){return!!U.message}e.isProgressMessage=s;var a;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(a=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class v{constructor(x){this.resource=x,this.results=[]}}e.FileMatch=v;class n{constructor(x,O,j){this.ranges=O;const H=Array.isArray(O)?O:[O];if(j&&j.matchLines===1&&h(H)){x=(0,A.getNLines)(x,j.matchLines);let X="",Q=0,de=0;const _e=Math.floor(j.charsPerLine/5),Ie=[];for(const Pe of H){const We=Math.max(Pe.startColumn-_e,0),Be=Pe.startColumn+j.charsPerLine;if(We>de+_e+f){const He=c+(We-de)+p;X+=He+x.slice(We,Be),Q+=We-(de+He.length)}else X+=x.slice(de,Be);Ie.push(new t(0,Pe.startColumn-Q,Pe.endColumn-Q)),de=Be}this.preview={text:X,matches:Array.isArray(this.ranges)?Ie:Ie[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:x,matches:(0,g.mapArrayOrNot)(O,Q=>new r(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=n;function h(U){const x=U[0].startLineNumber;for(const O of U)if(O.startLineNumber!==x||O.endLineNumber!==x)return!1;return!0}class r{constructor(x,O,j,H){this.startLineNumber=x,this.startColumn=O,this.endLineNumber=j,this.endColumn=H}}e.SearchRange=r;class t extends r{constructor(x,O,j){super(x,O,x,j)}}e.OneLineRange=t;var l;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(l=e.SearchSortOrder||(e.SearchSortOrder={}));function o(U,x=!0){const O=U&&U.files&&U.files.exclude,j=x&&U&&U.search&&U.search.exclude;if(!O&&!j)return;if(!O||!j)return O||j;let H=Object.create(null);return H=D.mixin(H,D.deepClone(O)),H=D.mixin(H,D.deepClone(j),!0),H}e.getExcludes=o;function d(U,x){return U.excludePattern&&L.match(U.excludePattern,x)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&L.match(U.includePattern,x)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(O=>{const j=O.folder.fsPath;if(S.isEqualOrParent(x,j)){const H=E.relative(j,x);return!O.includePattern||!!L.match(O.includePattern,H)}else return!1}):!1:!0}e.pathIncludedInQuery=d;var m;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class u extends Error{constructor(x,O){super(x);this.code=O}}e.SearchError=u;function y(U){const x=U.message;if((0,C.isPromiseCanceledError)(U))return new u(x,m.canceled);try{const O=JSON.parse(x);return new u(O.message,O.code)}catch(O){return new u(x,m.other)}}e.deserializeSearchError=y;function T(U){const x={message:U.message,code:U.code};return new Error(JSON.stringify(x))}e.serializeSearchError=T;function R(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=R;function $(U){return U.type==="success"}e.isSerializedSearchSuccess=$;function B(U){return!!U.path}e.isSerializedFileMatch=B;function F(U,x){const O=U.searchPath?U.searchPath:U.relativePath;return(0,A.fuzzyContains)(O,x)}e.isFilePatternMatch=F;class W{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function M(U,x){const O={...U||{},...x||{}};return Object.keys(O).filter(j=>{const H=O[j];return typeof H=="boolean"&&H})}e.resolvePatternsForProvider=M;class z{constructor(x,O){this._parsedIncludeExpression=null,this._excludeExpression={...x.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let j=x.includePattern;O.includePattern&&(j?j={...j,...O.includePattern}:j=O.includePattern),j&&(this._parsedIncludeExpression=L.parse(j))}matchesExcludesSync(x,O,j){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,O,j))}includedInQuerySync(x,O,j){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(x,O,j)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(x,O,j))}includedInQuery(x,O,j){const H=this._parsedExcludeExpression(x,O,j),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(x,O,j):!0;return(0,I.isPromise)(H)?H.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=z;function N(U){for(const x in U)if(typeof U[x]!="boolean")return!0;return!1}}),define(fe[35],me([0,1,15,16,21,3,24,10,78,23,8,13,2,170,4,11,191,43,44,27,14,7,32,5]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s,a,v,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(T,R,$){return new C.ExtUri(B=>d(B,$)).isEqual(T,R)}function t(T,R,$){return r(T.uri,R.uri,$)?0:(0,i.compare)(T.uri.toString(),R.uri.toString())}function l(T,R,$){return T.index!==R.index?T.index<R.index?-1:1:r(T.uri,R.uri,$)?(0,i.compare)(T.name,R.name):(0,i.compare)(T.uri.toString(),R.uri.toString())}function o(T,R,$,B){const F=T.slice(0).sort((M,z)=>$(M,z,B)),W=R.slice(0).sort((M,z)=>$(M,z,B));return(0,g.delta)(F,W,(M,z)=>$(M,z,B))}function d(T,R){const $=R.getCapabilities(T.scheme);return!($&&$&1024)}class m extends P.Workspace{constructor(R,$,B,F,W,M,z){super(R,B.map(N=>new P.WorkspaceFolder(N)),F,W,z);this._name=$,this._isUntitled=M,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(z),B.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(R,$,B,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:W,name:M,folders:z,configuration:N,transient:U,isUntitled:x}=R,O=[],j=$;$?z.forEach((de,_e)=>{const Ie=c.URI.revive(de.uri),Pe=m._findFolder(B||$,Ie,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:Ie,name:de.name,index:_e})}):O.push(...z.map(({uri:de,name:_e,index:Ie})=>({uri:c.URI.revive(de),name:_e,index:Ie}))),O.sort((de,_e)=>de.index<_e.index?-1:1);const H=new m(W,M,O,!!U,N?c.URI.revive(N):null,!!x,de=>d(de,F)),{added:X,removed:Q}=o(j?j.workspaceFolders:[],H.workspaceFolders,t,F);return{workspace:H,added:X,removed:Q}}static _findFolder(R,$,B){for(let F=0;F<R.folders.length;F++){const W=R.workspaceFolders[F];if(r(W.uri,$,B))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,$){return $&&this._structure.get(R)&&(R=(0,C.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let u=class{constructor(R,$,B,F){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=B,this._requestIdProvider=new E.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(h.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(h.MainContext.MainThreadMessageService);const W=$.workspace;this._confirmedWorkspace=W?new m(W.id,W.name,[],!!W.transient,W.configuration?c.URI.revive(W.configuration):null,!!W.isUntitled,M=>d(M,B)):void 0}$initializeWorkspace(R,$){this._trusted=$,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,$,B,...F){const W=[];if(Array.isArray(F)&&F.forEach(x=>{c.URI.isUri(x.uri)&&!W.some(O=>r(O.uri,x.uri,this._extHostFileSystemInfo))&&W.push({uri:x.uri,name:x.name||(0,C.basenameOrAuthority)(x.uri)})}),this._unconfirmedWorkspace||[$,B].some(x=>typeof x!="number"||x<0)||B===0&&W.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+B>M.length)return!1;const z=M.slice(0);z.splice($,B,...W.map(x=>({uri:x.uri,name:x.name||(0,C.basenameOrAuthority)(x.uri),index:void 0})));for(let x=0;x<z.length;x++){const O=z[x];if(z.some((j,H)=>H!==x&&r(O.uri,j.uri,this._extHostFileSystemInfo)))return!1}z.forEach((x,O)=>x.index=O);const{added:N,removed:U}=o(M,z,l,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const x=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(x,$,B,W).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,(0,p.localize)(0,null,x,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(z),!0}getWorkspaceFolder(R,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async getWorkspaceFolder2(R,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,$)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,$){let B,F="";if(typeof R=="string"?(B=c.URI.file(R),F=R):typeof R!="undefined"&&(B=R,F=R.fsPath),!B)return F;const W=this.getWorkspaceFolder(B,!0);if(!W)return F;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let M=(0,C.relativePath)(W.uri,B);return $&&W.name&&(M=`${W.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=m.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:$,added:B,removed:F}=m.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:B,removed:F}))}findFiles(R,$,B,F,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if($===null?M=!1:$&&(typeof $=="string"?M=$:M=$.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:z,folder:N}=y(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(z),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(B),W).then(U=>Array.isArray(U)?U.map(x=>c.URI.revive(x)):[])}async findTextInFiles(R,$,B,F,W=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),z=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:N,folder:U}=y($.include),x=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,O={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:z,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:N,excludePattern:x},j=!1;if(this._activeSearchCallbacks[M]=H=>{if(j)return;const X=c.URI.revive(H.resource);H.results.forEach(Q=>{(0,n.resultIsMatch)(Q)?B({uri:X,preview:{text:Q.preview.text,matches:(0,g.mapArrayOrNot)(Q.preview.matches,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(Q.ranges,de=>new v.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):B({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},W.isCancellationRequested)return{};try{const H=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(U),O,M,W);return delete this._activeSearchCallbacks[M],H||{}}catch(H){throw delete this._activeSearchCallbacks[M],H}}$handleTextSearchResult(R,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=Ve([$e(0,a.IExtHostRpcService),$e(1,s.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,w.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function y(T){let R,$;return T&&(typeof T=="string"?R=T:(R=T.pattern,$=T.baseFolder||c.URI.file(T.base))),{includePattern:R,folder:$}}}),define(fe[36],me([0,1,25,3,35,5,7,194,86,13,16,4,14,11,2]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(h,r){if(r){const t=r.split(".");let l=h;for(let o=0;l&&o<t.length;o++)l=l[t[o]];return l}}function _(h){return h instanceof f.URI}function P(h){return h&&h.uri instanceof f.URI&&h.languageId&&typeof h.languageId=="string"}function b(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function s(h){return h&&h.uri instanceof f.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function a(h){if(_(h))return{resource:h};if(P(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(b(h))return{overrideIdentifier:h.languageId};if(s(h))return{resource:h.uri};if(h===null)return{resource:null}}let v=class{constructor(r,t,l){this._proxy=r.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=l,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new n(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,t){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(r,t))}};v=Ve([$e(0,c.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,p.ILogService)],v),e.ExtHostConfiguration=v;class n{constructor(r,t,l,o){this._onDidChangeConfiguration=new L.Emitter,this._proxy=r,this._logService=o,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,t){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,l))}getConfiguration(r,t,l){const o=a(t)||{},d=this._toReadonlyValue(r?w(this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,o,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,o,l?.identifier);function m(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(y){return typeof w(d,y)!="undefined"},get:(y,T)=>{this._validateConfigurationAccess(r?`${r}.${y}`:y,o,l?.identifier);let R=w(d,y);if(typeof R=="undefined")R=T;else{let $;const B=(F,W)=>{let M;const z=()=>{$=$||(0,g.deepClone)(d),M=M||w($,W)};return(0,C.isObject)(F)?new Proxy(F,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return z(),()=>M;if($)return M=M||w($,W),M[U];const x=N[U];return typeof U=="string"?B(x,`${W}.${U}`):x},set:(N,U,x)=>(z(),M&&(M[U]=x),!0),deleteProperty:(N,U)=>(z(),M&&delete M[U],!0),defineProperty:(N,U,x)=>(z(),M&&Object.defineProperty(M,U,x),!0)}):F};R=B(R,y)}return R},update:(y,T,R,$)=>{y=r?`${r}.${y}`:y;const B=m(R);return T!==void 0?this._proxy.$updateConfigurationOption(B,y,T,o,$):this._proxy.$removeConfigurationOption(B,y,o,$)},inspect:y=>{y=r?`${r}.${y}`:y;const T=(0,g.deepClone)(this._configuration.inspect(y,o,this._extHostWorkspace.workspace));if(T)return{key:y,defaultValue:T.default?.value,globalValue:T.user?.value,workspaceValue:T.workspace?.value,workspaceFolderValue:T.workspaceFolder?.value,defaultLanguageValue:T.default?.override,globalLanguageValue:T.user?.override,workspaceLanguageValue:T.workspace?.override,workspaceFolderLanguageValue:T.workspaceFolder?.override,languageIds:T.overrideIdentifiers}}};return typeof d=="object"&&(0,g.mixin)(u,d,!1),Object.freeze(u)}_toReadonlyValue(r){const t=l=>(0,C.isObject)(l)?new Proxy(l,{get:(o,d)=>t(o[d]),set:(o,d,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(d)}' of object`)},deleteProperty:(o,d)=>{throw new Error(`TypeError: Cannot delete read only property '${String(d)}' of object`)},defineProperty:(o,d)=>{throw new Error(`TypeError: Cannot define property '${String(d)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return t(r)}_validateConfigurationAccess(r,t,l){const o=E.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),d=l?`[${l.value}] `:"";if(o===4){typeof t?.resource=="undefined"&&this._logService.warn(`${d}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){t?.resource&&this._logService.warn(`${d}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,t){const l=new k.ConfigurationChangeEvent(r,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(o,d)=>l.affectsConfiguration(o,a(d))})}_toMap(r){return r.reduce((t,l)=>(t.set(l[0],l[1]),t),new Map)}}e.ExtHostConfigProvider=n,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[72],me([0,1,2,16,3,5,7,35,45,36,21,33,14,27,4,10,12,11,67,217,18]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s,a){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var n;(function(W){function M(N){if(N!=null)return N}W.from=M;function z(N){if(N!=null)return N}W.to=z})(n=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var h;(function(W){function M(N){if(N!=null)return N}W.from=M;function z(N){if(N!=null)return N}W.to=z})(h=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function M(N){if(N!=null)return N}W.from=M;function z(N){if(N!=null)return N}W.to=z})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function(W){function M(U){if(U){const x=U;return x&&!!x.process}else return!1}W.is=M;function z(U){if(U==null)return;const x={process:U.process,args:U.args};return U.options&&(x.options=r.from(U.options)),x}W.from=z;function N(U){if(U!=null)return new A.ProcessExecution(U.process,U.args,U.options)}W.to=N})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(W){function M(N){if(N!=null)return N}W.from=M;function z(N){if(N!=null)return N}W.to=z})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var o;(function(W){function M(U){if(U){const x=U;return x&&(!!x.commandLine||!!x.command)}else return!1}W.is=M;function z(U){if(U==null)return;const x={};return U.commandLine!==void 0?x.commandLine=U.commandLine:(x.command=U.command,x.args=U.args),U.options&&(x.options=l.from(U.options)),x}W.from=z;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new A.ShellExecution(U.commandLine,U.options):new A.ShellExecution(U.command,U.args?U.args:[],U.options)}W.to=N})(o=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var d;(function(W){function M(U){if(U){let x=U;return x&&x.customExecution==="customExecution"}else return!1}W.is=M;function z(U){return{customExecution:"customExecution"}}W.from=z;function N(U,x){return x.get(U)}W.to=N})(d=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(W){function M(z,N){let U;return z.scope!==void 0&&typeof z.scope!="number"?U=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=s.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:U}}W.from=M})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(W){function M(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}W.from=M})(u=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(W){function M(U,x){if(U==null)return[];const O=[];for(let j of U){const H=z(j,x);H&&O.push(H)}return O}W.fromMany=M;function z(U,x){if(U==null)return;let O;U.execution instanceof A.ProcessExecution?O=t.from(U.execution):U.execution instanceof A.ShellExecution?O=o.from(U.execution):U.execution&&U.execution instanceof A.CustomExecution&&(O=d.from(U.execution));const j=n.from(U.definition);let H;return U.scope?typeof U.scope=="number"?H=U.scope:H=U.scope.uri:H=A.TaskScope.Workspace,!j||!H?void 0:{_id:U._id,definition:j,name:U.name,source:{extensionId:x.identifier.value,label:U.source,scope:H},execution:O,isBackground:U.isBackground,group:u.from(U.group),presentationOptions:h.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}W.from=z;async function N(U,x,O){if(U==null)return;let j;t.is(U.execution)?j=t.to(U.execution):o.is(U.execution)?j=o.to(U.execution):d.is(U.execution)&&(j=d.to(U._id,O));const H=n.to(U.definition);let X;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?X=U.source.scope:X=await x.resolveWorkspaceFolder(g.URI.revive(U.source.scope)):X=A.TaskScope.Workspace),!H||!X)return;const Q=new A.Task(H,X,U.name,U.source.label,j,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=A.TaskGroup.from(U.group._id),Q.group&&U.group.isDefault&&(Q.group=new A.TaskGroup(Q.group.id,Q.group.label),U.group.isDefault&&(Q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Q.presentationOptions=h.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}W.to=N})(y=e.TaskDTO||(e.TaskDTO={}));var T;(function(W){function M(N){return N}W.from=M;function z(N){if(!!N)return Object.assign(Object.create(null),N)}W.to=z})(T=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,z,N){this._id=z,this._task=N,v.set(this,void 0),st(this,v,M,"f")}get task(){return this._task}terminate(){Oe(this,v,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}v=new WeakMap;var $;(function(W){function M(z){return{id:z._id,task:void 0}}W.from=M})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let B=class{constructor(M,z,N,U,x,O,j,H){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=M.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=U,this._configurationService=x,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=H,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,z,N){if(!N)return new A.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:z,provider:N,extension:M}),this._proxy.$registerTaskProvider(U,z),new A.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(M,z){this._proxy.$registerTaskSystem(M,z)}fetchTasks(M){return this._proxy.$fetchTasks(T.from(M)).then(async z=>{const N=[];for(let U of z){const x=await y.to(U,this._workspaceProvider,this._providedCustomExecutions2);x&&N.push(x)}return N})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(z=>M.push(z)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,z,N){const U=this._providedCustomExecutions2.get(M.id);U&&(this._activeCustomExecutions2.set(M.id,U),this._terminalService.attachPtyToTerminal(z,await U.callback(N))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const z=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:z,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const z=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:M.exitCode})}$provideTasks(M,z){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));const U=[],x=(0,L.asPromise)(()=>N.provider.provideTasks(i.CancellationToken.None)).then(O=>this.provideTasksInternal(z,U,N,O));return new Promise(O=>{x.then(j=>{Promise.all(U).then(()=>{O(j)})})})}async $resolveTask(M,z){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(z.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await y.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const x=await N.provider.resolveTask(U,i.CancellationToken.None);if(!x)return;this.checkDeprecation(x,N);const O=y.from(x,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(x.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(O.execution)&&await this.addCustomExecution(O,x,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,z,N){const U=await this._proxy.$createTaskId(M);!N&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,z.execution)),this._providedCustomExecutions2.set(U,z.execution)}async getTaskExecution(M,z){if(typeof M=="string"){const x=this._taskExecutionPromises.get(M);if(!x)throw new Error("Unexpected: The specified task is missing an execution");return x}let N=this._taskExecutionPromises.get(M.id);if(N)return N;const U=new Promise((x,O)=>{function j(H,X,Q){Q?x(new R(H,X.id,Q)):O("Unexpected: Task does not exist.")}z?j(this,M,z):y.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(H=>j(this,M,H))});return this._taskExecutionPromises.set(M.id,U),U.then(x=>(this._taskExecutions.set(M.id,x),x),x=>Promise.reject(x))}checkDeprecation(M,z){M._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let N=this._notProvidedCustomExecutions.values(),U=N.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=N.next()}};B=Ve([$e(0,c.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,b.IExtHostApiDeprecationService)],B),e.ExtHostTaskBase=B;let F=class extends B{constructor(M,z,N,U,x,O,j,H){super(M,z,N,U,x,O,j,H);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:_.PlatformToString(0)})}async executeTask(M,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const N=y.from(z,M);if(N===void 0)throw new Error("Task is not valid");if(d.is(N.execution))await this.addCustomExecution(N,z,!1);else throw new a.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),z);return this._proxy.$executeTask(N).catch(x=>{throw new Error(x)}),U}provideTasksInternal(M,z,N,U){const x=[];if(U)for(let O of U){this.checkDeprecation(O,N),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const j=y.from(O,N.extension);j&&d.is(j.execution)?(x.push(j),z.push(this.addCustomExecution(j,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:x,extension:N.extension}}async resolveTaskInternal(M){if(d.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,z,N){}};F=Ve([$e(0,c.IExtHostRpcService),$e(1,p.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,E.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,P.ILogService),$e(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(fe[270],me([0,1,15,58,30,80,24,10,9,23,8,13,2,146,177,118,43,127,269,32]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let a=class{constructor(m,u,y,T){this.configurationService=m,this.workspaceContextService=u,this.editorGroupsService=y,this.pathService=T}text(m,u,y={}){m=this.getContentPattern(m,y);const T=this.configurationService.getValue(),R=u&&u.some(B=>!this.configurationService.getValue({resource:B}).search.useRipgrep);return{...this.commonQuery(u?.map(_.toWorkspaceFolder),y),type:2,contentPattern:m,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:T.search.usePCRE2||R||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(m,u){const y=this.configurationService.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const T={...m,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(m,u)&&(T.isCaseSensitive=!0),this.isMultiline(m)&&(T.isMultiline=!0),T}file(m,u={}){return{...this.commonQuery(m,u),type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey}}handleIncludeExclude(m,u){return m?(m=Array.isArray(m)?m.map(t):t(m),u?this.parseSearchPaths(m):{pattern:n(...Array.isArray(m)?m:[m])}):{}}commonQuery(m=[],u={}){const y=this.handleIncludeExclude(u.includePattern,u.expandPatterns),T=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),R=m.length>1,$=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(W=>this.getFolderQueryForSearchPath(W,u,T)):m.map(W=>this.getFolderQueryForRoot(W,u,T,R))).filter(W=>!!W),B={_reason:u._reason,folderQueries:$,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:T.pattern,includePattern:y.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,s.pathIncludedInQuery)(B,N.fsPath)),z=this.commonQueryFromFileList(M);return{...B,...z}}const F=u.extraFileResources&&u.extraFileResources.filter(W=>(0,s.pathIncludedInQuery)(B,W.fsPath));return B.extraFileResources=F&&F.length?F:void 0,B}commonQueryFromFileList(m){const u=[],y=new A.ResourceMap,T={};let R=!1;return m.forEach($=>{if($.scheme===k.Schemas.walkThrough)return;if((0,C.isAbsolutePath)($)){const F=this.workspaceContextService.getWorkspaceFolder($)?.uri??$.with({path:E.dirname($.fsPath)});let W=y.get(F);W||(R=!0,W={folder:F,includePattern:{}},u.push(W),y.set(F,W));const M=E.relative(F.fsPath,$.fsPath);(0,I.assertIsDefined)(W.includePattern)[M.replace(/\\/g,"/")]=!0}else $.fsPath&&(R=!0,T[$.fsPath]=!0)}),{folderQueries:u,includePattern:T,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(m,u){if(u.isSmartCase){if(m.isRegExp){if(i.containsUppercaseCharacter(m.pattern,!0))return!0}else if(i.containsUppercaseCharacter(m.pattern))return!0}return!!m.isCaseSensitive}isMultiline(m){return m.isMultiline||m.isRegExp&&(0,p.isMultilineRegexSource)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const u=z=>E.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),T=(Array.isArray(m)?m:h(m)).map(z=>{const N=this.pathService.resolvedUserHome;return N?(0,S.untildify)(z,N.scheme===k.Schemas.file?N.fsPath:N.path):z}),R=L.groupBy(T,z=>u(z)?"searchPaths":"exprSegments"),$=(R.exprSegments||[]).map(z=>i.rtrim(z,"/")).map(z=>i.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),r(z))),B={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(B.searchPaths=F);const W=g.flatten($),M=n(...W);return M&&(B.pattern=M),B}getExcludesForFolder(m,u){return u.disregardExcludeSettings?void 0:(0,s.getExcludes)(m,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(m){if(!m||!m.length)return[];const u=g.flatten(m.map(T=>{let{pathPortion:R,globPortion:$}=v(T);$&&($=l($));const B=this.expandOneSearchPath(R);return g.flatten(B.map(F=>this.resolveOneSearchPathPattern(F,$)))})),y=new Map;return u.forEach(T=>{const R=T.searchPath.toString(),$=y.get(R);$?T.pattern&&($.pattern=$.pattern||{},$.pattern[T.pattern]=!0):y.set(R,{searchPath:T.searchPath,pattern:T.pattern?n(T.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(m){if(E.isAbsolute(m)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:m})}]:[{searchPath:c.URI.file(E.normalize(m))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(m=t(m),m.startsWith("../")||m===".."){const T=E.posix.resolve(u.path,m);return[{searchPath:u.with({path:T})}]}const y=l(m);return[{searchPath:u,pattern:y}]}else{if(m==="./"||m===".\\")return[];{const u=m.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(R=>{const $=u.match(new RegExp(`^${i.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return $?{match:$,folder:R}:null}).filter(I.isDefined);if(T.length)return T.map(R=>{const $=R.match[1];return{searchPath:R.folder.uri,pattern:$&&l($)}});{const R=m.match(/\.[\/\\](.+)[\/\\]?/),$=R?R[1]:m,B=f.localize(0,null,$);throw new Error(B)}}}}resolveOneSearchPathPattern(m,u){const y=m.pattern&&u?`${m.pattern}/${u}`:m.pattern||u,T=[{searchPath:m.searchPath,pattern:y}];return y&&!y.endsWith("**")&&T.push({searchPath:m.searchPath,pattern:y+"/**"}),T}getFolderQueryForSearchPath(m,u,y){const T=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(m.searchPath),u,y,!1);return T?{...T,includePattern:m.pattern}:null}getFolderQueryForRoot(m,u,y,T){let R;const $=c.URI.isUri(m)?m:m.uri;if(y.searchPaths){const z=y.searchPaths.filter(N=>(0,C.isEqual)(N.searchPath,$))[0];if(z&&!z.pattern)return null;z&&(R=z.pattern)}const B=this.configurationService.getValue({resource:$}),W={...this.getExcludesForFolder(B,u)||{},...R||{}},M=c.URI.isUri(m)?(0,C.basename)(m):m.name;return{folder:$,folderName:T?M:void 0,excludePattern:Object.keys(W).length>0?W:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!B.search.followSymlinks}}};a=Ve([$e(0,w.IConfigurationService),$e(1,_.IWorkspaceContextService),$e(2,P.IEditorGroupsService),$e(3,b.IPathService)],a),e.QueryBuilder=a;function v(d){const m=d.match(/[\*\{\}\(\)\[\]\?]/);if(m){const u=m.index,y=d.substr(0,u).match(/[/|\\][^/\\]*$/);if(y){let T=d.substr(0,y.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:d.substr((y.index||0)+1)}}}return{pathPortion:d}}function n(...d){return d.length?d.reduce((m,u)=>(m[u]=!0,m),Object.create(null)):void 0}function h(d){return D.splitGlobAware(d,",").map(m=>m.trim()).filter(m=>!!m.length)}function r(d){return[`**/${d}/**`,`**/${d}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function t(d){return d.replace(/\\/g,"/")}function l(d){return t(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(d,m){d=g.distinct(d,T=>T.toString());const u=[],y=m.getWorkspace();return d&&d.forEach(T=>{let R;if(m.getWorkbenchState()===2)R=(0,C.relativePath)(y.folders[0].uri,T),R&&R!=="."&&(R="./"+R);else{const $=m.getWorkspaceFolder(T);if($){const B=$.name;if(y.folders.filter(W=>W.name===B).length===1){const W=(0,C.relativePath)($.uri,T);W===""?R=`./${$.name}`:R=`./${$.name}/${W}`}else R=T.fsPath}}R&&u.push(R)}),u}e.resolveResourcesForSearchIncludes=o}),define(fe[271],me([0,1,23,2,21,18,4,270,32,43]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(w,_){const P=_.activationEvents;if(!P)return Promise.resolve(void 0);const b=[],s=[];for(const t of P)if(/^workspaceContains:/.test(t)){const l=t.substr("workspaceContains:".length);l.indexOf("*")>=0||l.indexOf("?")>=0||w.forceUsingSearch?s.push(l):b.push(l)}if(b.length===0&&s.length===0)return Promise.resolve(void 0);let a;const v=new Promise((t,l)=>{a=t}),n=t=>a({activationEvent:t}),h=Promise.all(b.map(t=>c(w,t,n))).then(()=>{}),r=p(w,_.identifier,s,n);return Promise.all([h,r]).then(()=>{a(void 0)}),v}e.checkActivateWorkspaceContainsExtension=I;async function c(w,_,P){for(const b of w.folders)if(await w.exists(g.joinPath(L.URI.revive(b),_))){P(`workspaceContains:${_}`);return}}async function p(w,_,P,b){if(P.length===0)return Promise.resolve(void 0);const s=new D.CancellationTokenSource,a=w.checkExists(w.folders,P,s.token),v=setTimeout(async()=>{s.cancel(),b(`workspaceContainsTimeout:${P.join(",")}`)},i);let n=!1;try{n=await a}catch(h){S.isPromiseCanceledError(h)||S.onUnexpectedError(h)}s.dispose(),clearTimeout(v),n&&b(`workspaceContains:${P.join(",")}`)}function f(w,_,P,b){const s=w.get(A.IInstantiationService),a=w.get(E.ISearchService),n=s.createInstance(k.QueryBuilder).file(_.map(h=>(0,C.toWorkspaceFolder)(L.URI.revive(h))),{_reason:"checkExists",includePattern:P,exists:!0});return a.fileSearch(n,b).then(h=>!!h.limitHit,h=>S.isPromiseCanceledError(h)?!1:Promise.reject(h))}e.checkGlobFileExists=f});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!D:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(Y,g):D?D.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[40],me([0,1,165,9,73,23,16,6,24,2,11,5,36,230,91,35,228,18,26,22,202,7,119,4,27,69,14,85,53,33,3,271,90,204,10]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s,a,v,n,h,r,t,l,o,d,m,u,y,T,R,$){"use strict";var B,F,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,h.createDecorator)("IHostUtils");let M=class Hi extends k.Disposable{constructor(x,O,j,H,X,Q,de,_e,Ie,Pe){super();this._onDidChangeRemoteConnectionData=this._register(new u.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=O,this._extHostContext=j,this._initData=de,this._extHostWorkspace=H,this._extHostConfiguration=X,this._logService=Q,this._extHostTunnelService=Ie,this._extHostTerminalService=Pe,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new T.ExtHostSecretState(this._extHostContext),this._storagePath=_e,this._instaService=x.createChild(new o.ServiceCollection([f.IExtHostStorage,this._storage],[T.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(Be=>We.add(b.ExtensionIdentifier.toKey(Be))),this._activator=new p.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Be,He,G)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Be,P.transformErrorForSerialization(He),G)},actualActivateExtension:async(Be,He)=>{if(We.has(b.ExtensionIdentifier.toKey(Be)))return await this._mainThreadExtensionsProxy.$activateExtension(Be,He),new p.HostExtension;const G=this._registry.getExtensionDescription(Be);return this._activateExtension(G,He)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(x){P.onUnexpectedError(x)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let x=[];try{x=this._registry.getAllExtensionDescriptions().map(X=>X.identifier).filter(X=>this.isActivated(X)).map(X=>this._deactivate(X))}catch(O){}await Promise.all(x)}isActivated(x){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(x):!1}_activateByEvent(x,O){return this._activator.activateByEvent(x,O)}_activateById(x,O){return this._activator.activateById(x,O)}activateByIdWithErrors(x,O){return this._activateById(x,O).then(()=>{const j=this._activator.getActivatedExtension(x);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(x=>this._registry)}getExtensionExports(x){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(x).exports:null}async _realPathExtensionUri(x){if(x.scheme!==$.Schemas.file)return x;const O=await this._hostUtils.realpath(x.fsPath);return C.URI.file(O)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const x=E.TernarySearchTree.forUris(O=>S.extUriBiasedIgnorePathCase.ignorePathCasing(O));for(const O of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(O)){const j=await this._realPathExtensionUri(O.extensionLocation);x.set(j,O)}return x})()),this._extensionPathIndex}_deactivate(x){let O=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(x))return O;const j=this._activator.getActivatedExtension(x);if(!j)return O;try{typeof j.module.deactivate=="function"&&(O=Promise.resolve(j.module.deactivate()).then(void 0,H=>(this._logService.error(H),Promise.resolve(void 0))))}catch(H){this._logService.error(H)}try{(0,k.dispose)(j.subscriptions)}catch(H){this._logService.error(H)}return O}async _activateExtension(x,O){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(x.identifier),this._doActivateExtension(x,O).then(j=>{const H=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(x.identifier,H.codeLoadingTime,H.activateCallTime,H.activateResolvedTime,O),this._logExtensionActivationTimes(x,O,"success",H),j},j=>{throw this._logExtensionActivationTimes(x,O,"failure"),j})}_logExtensionActivationTimes(x,O,j,H){const X=z(x,O);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...X,...H||{},outcome:j})}_doActivateExtension(x,O){const j=z(x,O);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const H=this._getEntryPoint(x);if(!H)return Promise.resolve(new p.EmptyExtension(p.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${O.startup}, activationEvent: '${O.activationEvent}'${x.identifier.value!==O.extensionId.value?`, root cause: ${O.extensionId.value}`:""}`),this._logService.flush();const X=new p.ExtensionActivationTimesBuilder(O.startup);return Promise.all([this._loadCommonJSModule(x.identifier,(0,S.joinPath)(x.extensionLocation,H),X),this._loadExtensionContext(x)]).then(Q=>(D.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),Hi._callActivate(this._logService,x.identifier,Q[0],Q[1],X))).then(Q=>(D.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),Q))}_loadExtensionContext(x){const O=new a.ExtensionGlobalMemento(x,this._storage),j=new a.ExtensionMemento(x.identifier.value,!1,this._storage),H=new R.ExtensionSecrets(x,this._secretState),X=x.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?v.ExtensionMode.Test:v.ExtensionMode.Development:v.ExtensionMode.Production,Q=this._initData.remote.isRemote?v.ExtensionKind.Workspace:v.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([O.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const de=this;let _e;return Object.freeze({globalState:O,workspaceState:j,secrets:H,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(Ie){return L.join(x.extensionLocation.fsPath,Ie)},get storagePath(){return de._storagePath.workspaceValue(x)?.fsPath},get globalStoragePath(){return de._storagePath.globalValue(x).fsPath},get logPath(){return L.join(de._initData.logsLocation.fsPath,x.identifier.value)},get logUri(){return C.URI.joinPath(de._initData.logsLocation,x.identifier.value)},get storageUri(){return de._storagePath.workspaceValue(x)},get globalStorageUri(){return de._storagePath.globalValue(x)},get extensionMode(){return X},get extension(){return _e===void 0&&(_e=new N(de,x.identifier,x,Q)),_e},get extensionRuntime(){return(0,b.checkProposedApiEnabled)(x),de.extensionRuntime},get environmentVariableCollection(){return de._extHostTerminalService.getEnvironmentVariableCollection(x)}})})}static _callActivate(x,O,j,H,X){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(x,O,j,H,X).then(Q=>new p.ActivatedExtension(!1,null,X.build(),j,Q,H.subscriptions))}static _callActivateOptional(x,O,j,H,X){if(typeof j.activate=="function")try{X.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${O.value}`);const Q=typeof global=="object"?global:self,de=j.activate.apply(Q,[H]);return X.activateCallStop(),X.activateResolveStart(),Promise.resolve(de).then(_e=>(X.activateResolveStop(),_e))}catch(Q){return Promise.reject(Q)}else return Promise.resolve(j)}_activateOneStartupFinished(x,O){this._activateById(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:O}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const x of this._registry.getAllExtensionDescriptions())if(x.activationEvents)for(const O of x.activationEvents)O==="onStartupFinished"&&this._activateOneStartupFinished(x,O)}_handleEagerExtensions(){const x=this._activateByEvent("*",!0).then(void 0,X=>{this._logService.error(X)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(X=>this._handleWorkspaceContainsEagerExtensions(X.added)));const O=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(O),H=Promise.all([x,j]).then(()=>{});return Promise.race([H,(0,A.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),H}_handleWorkspaceContainsEagerExtensions(x){return x.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(O=>this._handleWorkspaceContainsEagerExtension(x,O))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(x,O){if(this.isActivated(O.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,H={folders:x.map(Q=>Q.uri),forceUsingSearch:j,exists:Q=>this._hostUtils.exists(Q.fsPath),checkExists:(Q,de,_e)=>this._mainThreadWorkspaceProxy.$checkExists(Q,de,_e)},X=await(0,y.checkActivateWorkspaceContainsExtension)(H,O);if(!!X)return this._activateById(O.identifier,{startup:!0,extensionId:O.identifier,activationEvent:X.activationEvent}).then(void 0,Q=>this._logService.error(Q))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(x){throw console.error(x),x}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:O}=this._initData.environment;if(!x||!O)throw new Error(g.localize(0,null));const j=await this._loadCommonJSModule(null,O,new p.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(g.localize(1,null,O.toString()));return new Promise((H,X)=>{const Q=(Ie,Pe)=>{Ie?X(Ie):H(typeof Pe=="number"&&Pe>0?1:0)},de=(0,S.originalFSPath)(O),_e=j.run(de,Q);_e&&_e.then&&_e.then(()=>{H(0)}).catch(Ie=>{X(Ie.toString())})})}async $extensionTestsExit(x){this._logService.info(`Extension host terminating: test runner requested exit with code ${x}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${x}`),this._logService.flush(),this._hostUtils.exit(x)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,O){return this._resolvers[x]=O,(0,k.toDisposable)(()=>{delete this._resolvers[x]})}async _activateAndGetResolver(x){const O=x.indexOf("+");if(O===-1)throw new Error("Not an authority that can be resolved!");const j=x.substr(0,O);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(x,O){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(x);if(!H)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(H)),D.mark(`code/extHost/willResolveAuthority/${j}`);const X=await H.resolve(x,{resolveAttempt:O});D.mark(`code/extHost/didResolveAuthorityOK/${j}`);const Q={authority:x,host:X.host,port:X.port,connectionToken:X.connectionToken},de={extensionHostEnv:X.extensionHostEnv,isTrusted:X.isTrusted};return{type:"ok",value:{authority:Q,options:de,tunnelInformation:{environmentTunnels:X.environmentTunnels}}}}catch(X){if(D.mark(`code/extHost/didResolveAuthorityError/${j}`),X instanceof v.RemoteAuthorityResolverError)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X}}async $getCanonicalURI(x,O){const{authorityPrefix:j,resolver:H}=await this._activateAndGetResolver(x);if(!H)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const X=C.URI.revive(O);if(typeof H.getCanonicalURI=="undefined")return X;const Q=await(0,A.asPromise)(()=>H.getCanonicalURI(X));return Q||X}$startExtensionHost(x){return this._registry.keepOnly(x),this._startExtensionHost()}$activateByEvent(x,O){return O===1?this._activateByEvent(x,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(x,!1))}async $activate(x,O){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(x)?(await this._activateById(x,O),!0):!1}async $deltaExtensions(x,O){x.forEach(H=>H.extensionLocation=C.URI.revive(H.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(O.map(async H=>{const X=this._registry.getExtensionDescription(H);X&&j.delete(await this._realPathExtensionUri(X.extensionLocation))})),await Promise.all(x.map(async H=>{const X=await this._realPathExtensionUri(H.extensionLocation);j.set(X,H)})),this._registry.deltaExtensions(x,O),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){let O=s.VSBuffer.alloc(x),j=Math.random()%256;for(let H=0;H<x;H++)O.writeUInt8(j,H);return O}async $updateRemoteConnectionData(x){this._remoteConnectionData=x,this._onDidChangeRemoteConnectionData.fire()}};M=Ve([$e(0,h.IInstantiationService),$e(1,e.IHostUtils),$e(2,l.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,i.ILogService),$e(6,r.IExtHostInitDataService),$e(7,t.IExtensionStoragePaths),$e(8,d.IExtHostTunnelService),$e(9,m.IExtHostTerminalService)],M),e.AbstractExtHostExtensionService=M;function z(U,x){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,h.createDecorator)("IExtHostExtensionService");class N{constructor(x,O,j,H){B.set(this,void 0),F.set(this,void 0),W.set(this,void 0),st(this,B,x,"f"),st(this,F,O,"f"),st(this,W,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,S.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=H}get isActive(){return Oe(this,B,"f").isActivated(Oe(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,B,"f").getExtensionExports(Oe(this,W,"f"))}activate(){return Oe(this,B,"f").activateByIdWithErrors(Oe(this,W,"f"),{startup:!1,extensionId:Oe(this,F,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,B=new WeakMap,F=new WeakMap,W=new WeakMap}),define(fe[56],me([0,1,9,2,3,16,5,7,123,35,40,45,219,36,212,14,4,13,37,55]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,_.createDecorator)("IExtHostDebugService");let a=class{constructor(d,m,u,y,T,R){this._workspaceService=m,this._extensionService=u,this._editorsService=y,this._configurationService=T,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=d.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new n(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(B=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(d,m){const u=d;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let y=`debug:${encodeURIComponent(u.path||"")}`,T="?";return m&&(y+=`${T}session=${encodeURIComponent(m.id)}`,T="&"),y+=`${T}ref=${u.sourceReference}`,L.URI.parse(y)}else{if(u.path)return L.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(d){const m=[];for(const u of d.getAllExtensionDescriptions())if(u.contributes){const y=u.contributes.debuggers;if(y&&y.length>0)for(const T of y)(0,f.isDebuggerMainContribution)(T)&&m.push(T.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const d=[];return this._breakpoints.forEach(m=>d.push(m)),d}addBreakpoints(d){this.startBreakpoints();const m=d.filter(T=>{const R=T.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,T),!0)});this.fireBreakpointChanges(m,[],[]);const u=[],y=new Map;for(const T of m)if(T instanceof k.SourceBreakpoint){let R=y.get(T.location.uri.toString());R||(R={type:"sourceMulti",uri:T.location.uri,lines:[]},y.set(T.location.uri.toString(),R),u.push(R)),R.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof k.FunctionBreakpoint&&u.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(u)}removeBreakpoints(d){this.startBreakpoints();const m=d.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],m,[]);const u=m.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),y=m.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),T=m.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(u,y,T)}startDebugging(d,m,u){return this._debugServiceProxy.$startDebugging(d?d.uri:void 0,m,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,debugUI:u.debugUI,suppressSaveBeforeStart:u.suppressSaveBeforeStart})}stopDebugging(d){return this._debugServiceProxy.$stopDebugging(d?d.id:void 0)}registerDebugConfigurationProvider(d,m,u){if(!m)return new k.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:d,handle:y,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(d,u,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,y),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(d,m,u){if(!u)return new k.Disposable(()=>{});if(!this.definesDebugType(d,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:y,factory:u}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,y),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==u),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(d,m){if(!m)return new k.Disposable(()=>{});const u=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:d,handle:u,factory:m}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==m)})}async $runInTerminal(d,m){return Promise.resolve(void 0)}async $substituteVariables(d,m){if(!this._variableResolver){const[T,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,R)}let u;const y=await this.getFolder(d);return y&&(u={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(u,m)}createDebugAdapter(d,m){if(d.type==="implementation")return new t(d.implementation)}createSignService(){}async $startDASession(d,m){const u=this,y=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const R=this.convertToDto(T),$=this.createDebugAdapter(R,y);if(!$)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const B=$;return this._debugAdapters.set(d,B),this.getDebugAdapterTrackers(y).then(F=>(F&&this._debugAdaptersTrackers.set(d,F),B.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,z={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(M.arguments.value);z.body={signature:N},B.sendResponse(z)}else throw new Error("no signer")}catch(N){z.success=!1,z.message=N.message,B.sendResponse(z)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),u._debugServiceProxy.$acceptDAMessage(d,W)}),B.onError(W=>{F&&F.onError&&F.onError(W),this._debugServiceProxy.$acceptDAError(d,W.name,W.message,W.stack)}),B.onExit(W=>{F&&F.onExit&&F.onExit((0,P.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(d,(0,P.withNullAsUndefined)(W),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),B.startSession()))})}$sendDAMessage(d,m){m=(0,f.convertToDAPaths)(m,!1);const u=this._debugAdaptersTrackers.get(d);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(m);const y=this._debugAdapters.get(d);y&&y.sendMessage(m)}$stopDASession(d){const m=this._debugAdaptersTrackers.get(d);this._debugAdaptersTrackers.delete(d),m&&m.onWillStopSession&&m.onWillStopSession();const u=this._debugAdapters.get(d);return this._debugAdapters.delete(d),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(d){const m=[],u=[],y=[];if(d.added)for(const T of d.added){const R=T.id;if(R&&!this._breakpoints.has(R)){let $;if(T.type==="function")$=new k.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")$=new k.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const B=L.URI.revive(T.uri);$=new k.SourceBreakpoint(new k.Location(B,new k.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}$._id=R,this._breakpoints.set(R,$),m.push($)}}if(d.removed)for(const T of d.removed){const R=this._breakpoints.get(T);R&&(this._breakpoints.delete(T),u.push(R))}if(d.changed){for(const T of d.changed)if(T.id){const R=this._breakpoints.get(T.id);if(R){if(R instanceof k.FunctionBreakpoint&&T.type==="function"){const $=R;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.functionName=T.functionName}else if(R instanceof k.SourceBreakpoint&&T.type==="source"){const $=R;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.location=new k.Location(L.URI.revive(T.uri),new k.Position(T.line,T.character))}y.push(R)}}}this.fireBreakpointChanges(m,u,y)}$provideDebugConfigurations(d,m,u){return(0,S.asPromise)(async()=>{const y=this.getConfigProviderByHandle(d);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(m);return y.provideDebugConfigurations(T,u)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(d,m,u,y){return(0,S.asPromise)(async()=>{const T=this.getConfigProviderByHandle(d);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(m);return T.resolveDebugConfiguration(R,u,y)})}$resolveDebugConfigurationWithSubstitutedVariables(d,m,u,y){return(0,S.asPromise)(async()=>{const T=this.getConfigProviderByHandle(d);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(m);return T.resolveDebugConfigurationWithSubstitutedVariables(R,u,y)})}async $provideDebugAdapter(d,m){const u=this.getAdapterDescriptorFactoryByHandle(d);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(m);return this.getAdapterDescriptor(u,y).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(d){const m=await this.getSession(d);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(d){const m=await this.getSession(d);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(d){this._activeDebugSession=d?await this.getSession(d):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(d,m){const u=await this.getSession(d);u&&u._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(d,m){const y={session:await this.getSession(d),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(d){if(d instanceof k.DebugAdapterExecutable)return{type:"executable",command:d.command,args:d.args,options:d.options};if(d instanceof k.DebugAdapterServer)return{type:"server",port:d.port,host:d.host};if(d instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:d.path};if(d instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:d.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(d){const m=this._adapterFactories.filter(u=>u.type===d);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(d){const m=this._adapterFactories.filter(u=>u.handle===d);if(m.length>0)return m[0].factory}getConfigProviderByHandle(d){const m=this._configProviders.filter(u=>u.handle===d);if(m.length>0)return m[0].provider}definesDebugType(d,m){if(d.contributes){const u=d.contributes.debuggers;if(u&&u.length>0){for(const y of u)if(y.label&&y.type&&y.type===m)return!0}}return!1}getDebugAdapterTrackers(d){const u=d.configuration.type,y=this._trackerFactories.filter(T=>T.type===u||T.type==="*").map(T=>(0,S.asPromise)(()=>T.factory.createDebugAdapterTracker(d)).then(R=>R,R=>null));return Promise.race([Promise.all(y).then(T=>{const R=T.filter($=>!!$);if(R.length>0)return new r(R)}),new Promise((T,R)=>{const $=setTimeout(()=>{clearTimeout($),R(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(d,m){const u=m.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new k.DebugAdapterServer(u));if(d){const T=await this._extensionService.getExtensionRegistry();return(0,S.asPromise)(()=>d.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,T))).then(R=>{if(R)return R})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,y))}daExecutableFromPackage(d,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(d,m,u){(d.length>0||m.length>0||u.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:d,removed:m,changed:u}))}async getSession(d){if(d)if(typeof d=="string"){const m=this._debugSessions.get(d);if(m)return m}else{let m=this._debugSessions.get(d.id);if(!m){const u=await this.getFolder(d.folderUri),y=d.parent?this._debugSessions.get(d.parent):void 0;m=new v(this._debugServiceProxy,d.id,d.type,d.name,u,d.configuration,y),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(d){if(d){const m=L.URI.revive(d);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};a=Ve([$e(0,w.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],a),e.ExtHostDebugServiceBase=a;class v{constructor(d,m,u,y,T,R,$){this._debugServiceProxy=d,this._id=m,this._type=u,this._name=y,this._workspaceFolder=T,this._configuration=R,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(d){this._name=d,this._debugServiceProxy.$setDebugSessionName(this._id,d)}get parentSession(){return this._parentSession}_acceptNameChanged(d){this._name=d}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(d,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,d,m)}getDebugProtocolBreakpoint(d){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,d.id)}}e.ExtHostDebugSession=v;class n{constructor(d){this.value=Object.freeze({append(m){d.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=n;class h extends c.AbstractVariableResolverService{constructor(d,m,u,y,T){function R(){if(m){const $=m.activeEditor();if($)return $.document.uri;const B=y.tabs.filter(F=>F.isActive);if(B.length>0){const F=B[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:B[0].resource}}}super({getFolderUri:$=>{const B=d.filter(F=>F.name===$);if(B&&B.length>0)return B[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:($,B)=>u.getConfiguration(void 0,$).get(B),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=R();if($)return g.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const $=R();if($){const B=T.getWorkspaceFolder($);if(B)return g.normalize(B.uri.fsPath)}}},getSelectedText:()=>{if(m){const $=m.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(m){const $=m.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=h;class r{constructor(d){this.trackers=d}onWillStartSession(){this.trackers.forEach(d=>d.onWillStartSession?d.onWillStartSession():void 0)}onWillReceiveMessage(d){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(d):void 0)}onDidSendMessage(d){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(d):void 0)}onWillStopSession(){this.trackers.forEach(d=>d.onWillStopSession?d.onWillStopSession():void 0)}onError(d){this.trackers.forEach(m=>m.onError?m.onError(d):void 0)}onExit(d,m){this.trackers.forEach(u=>u.onExit?u.onExit(d,m):void 0)}}class t extends E.AbstractDebugAdapter{constructor(d){super();this.implementation=d,d.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(d){this.implementation.handleMessage(d)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let l=class extends a{constructor(d,m,u,y,T,R){super(d,m,u,y,T,R)}createVariableResolver(d,m,u){return new h(d,m,u,this._editorTabs)}};l=Ve([$e(0,w.IExtHostRpcService),$e(1,C.IExtHostWorkspace),$e(2,i.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,p.IExtHostConfiguration),$e(5,s.IExtHostEditorTabs)],l),e.WorkerExtHostDebugService=l}),define(fe[272],me([0,1,73,2,5,36,130,26,14,27,4,40,37,11]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(s,a,v,n,h,r,t){this._apiFactory=s,this._extensionRegistry=a,this._instaService=v,this._extHostConfiguration=n,this._extHostExtensionService=h,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,a,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(_,a)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(P,a,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let a of s.nodeModuleName)this._factories.set(a,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(a=>s.alternativeModuleName(a))}};f=Ve([$e(2,i.IInstantiationService),$e(3,S.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,C.IExtHostInitDataService),$e(6,p.ILogService)],f),e.RequireInterceptor=f;class w{constructor(s,a,v,n,h){this._apiFactory=s,this._extensionPaths=a,this._extensionRegistry=v,this._configProvider=n,this._logService=h,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,a){const v=this._extensionPaths.findSubstr(a);if(v){let n=this._extApiImpl.get(k.ExtensionIdentifier.toKey(v.identifier));return n||(n=this._apiFactory(v,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(v.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((h,r)=>n+=`	${r} -> ${h.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let _=class{constructor(s,a,v){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(D.MainContext.MainThreadTelemetry);const{environment:n}=v,h=a.getProxy(D.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;c.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>h.$getPassword(r,t),setPassword:(r,t,l)=>h.$setPassword(r,t,l),deletePassword:(r,t)=>h.$deletePassword(r,t),findPassword:r=>h.$findPassword(r),findCredentials(r){return h.$findCredentials(r)}}}load(s,a){const v=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:v?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const a=s.length;if(a<=7||!this.alternativeNames)return;const v=a-7;if((s.charAt(v)==="/"||s.charAt(v)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};_=Ve([$e(1,E.IExtHostRpcService),$e(2,C.IExtHostInitDataService)],_);let P=class{constructor(s,a,v){this._extensionPaths=s,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=v.getProxy(D.MainContext.MainThreadTelemetry);const n=v.getProxy(D.MainContext.MainThreadWindow);this._impl=(h,r)=>{const t=L.URI.parse(h);return r?this.callOriginal(h,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,h,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,h,{}):this.callOriginal(h,r)}}load(s,a,v){const n=this._extensionPaths.findSubstr(a);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=v(s),this._impl}callOriginal(s,a){return this.sendNoForwardTelemetry(),this._original(s,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};P=Ve([$e(2,E.IExtHostRpcService)],P)}),define(fe[273],me([0,1,171,12,7,213,35,40,45,36,33,14,56,196,16,214,55]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let P=class extends c.ExtHostDebugServiceBase{constructor(a,v,n,h,r,t,l){super(a,v,n,h,r,l);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(a,v){switch(a.type){case"server":return new S.SocketDebugAdapter(a);case"pipeServer":return new S.NamedPipeDebugAdapter(a);case"executable":return new S.ExecutableDebugAdapter(a,v.type)}return super.createDebugAdapter(a,v)}daExecutableFromPackage(a,v){const n=S.ExecutableDebugAdapter.platformAdapterExecutable(v.getAllExtensionDescriptions(),a.type);if(n)return new D.DebugAdapterExecutable(n.command,n.args,n.options)}createSignService(){return new p.SignService}async $runInTerminal(a,v){if(a.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const n=await this._configurationService.getConfigProvider(),h=this._terminalService.getDefaultShell(!0),r=this._terminalService.getDefaultShellArgs(!0),t=a.title||g.localize(0,null),l=JSON.stringify({shell:h,shellArgs:r});let o=await this._integratedTerminalInstances.checkout(l,t),d,m=!1;if(o)d=a.cwd;else{const R={shellPath:h,shellArgs:r,cwd:a.cwd,name:t,iconPath:new D.ThemeIcon("debug")};m=!0,o=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(o,l)}o.show(!0);const u=await o.processId;m?await new Promise(R=>setTimeout(R,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?o.sendText("cls"):h.indexOf("bash")>=0?o.sendText("clear"):L.isWindows?o.sendText("cls"):o.sendText("clear"));const y=(0,w.prepareCommand)(h,a.args,d,a.env);o.sendText(y);const T=this.onDidTerminateDebugSession(R=>{R.id===v&&(this._integratedTerminalInstances.free(o),T.dispose())});return u}else if(a.kind==="external")return(0,w.runInExternalTerminal)(a,await this._configurationService.getConfigProvider());return super.$runInTerminal(a,v)}createVariableResolver(a,v,n){return new c.ExtHostVariableResolverService(a,v,n,this._editorTabs,this._workspaceService)}};P=Ve([$e(0,I.IExtHostRpcService),$e(1,A.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,E.IExtHostDocumentsAndEditors),$e(4,C.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,_.IExtHostEditorTabs)],P),e.ExtHostDebugService=P;class b{constructor(){this._terminalInstances=new Map}async checkout(a,v){const h=[...this._terminalInstances.entries()].map(([r,t])=>(0,f.createCancelablePromise)(async l=>{if(r.name!==v||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await r.processId))return null;const o=Date.now();return t.lastUsedAt+b.minUseDelay>o||l.isCancellationRequested||t.config!==a?null:(t.lastUsedAt=o,r)}));return await(0,f.firstParallel)(h,r=>!!r)}insert(a,v){this._terminalInstances.set(a,{lastUsedAt:Date.now(),config:v})}free(a){const v=this._terminalInstances.get(a);v&&(v.lastUsedAt=-1)}onTerminalClosed(a){this._terminalInstances.delete(a)}}b.minUseDelay=1e3}),define(fe[274],me([0,1,9,2,112,35,56,45,36,43,33,14,27,72,10,11,67,55,23,81]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let a=class extends p.ExtHostTaskBase{constructor(n,h,r,t,l,o,d,m,u){super(n,h,r,t,l,o,d,m);this.workspaceService=r,this.editorTabs=u,h.remote.isRemote&&h.remote.authority?this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:h.remote.authority,platform:process.platform}):this.registerTaskSystem(f.Schemas.file,{scheme:f.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,h){const r=h;if(!h.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const t=p.TaskHandleDTO.from(r,this.workspaceService),l=await this._proxy.$getTaskExecution(t);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.getTaskExecution(l,h);return this._proxy.$executeTask(t).catch(()=>{}),o}else{const t=p.TaskDTO.from(h,n);if(t===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,h,!1);const l=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),h);return this._proxy.$executeTask(t).catch(()=>{}),l}}provideTasksInternal(n,h,r,t){const l=[];if(t)for(let o of t){this.checkDeprecation(o,r),(!o.definition||!n[o.definition.type])&&this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const d=p.TaskDTO.from(o,r.extension);d&&(l.push(d),p.CustomExecutionDTO.is(d.execution)&&h.push(this.addCustomExecution(d,o,!0)))}return{tasks:l,extension:r.extension}}async resolveTaskInternal(n){return n}async getVariableResolver(n){if(this._variableResolver===void 0){const h=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(n,this._editorService,h,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(n){let h=n&&n.length>0?n[0]:void 0;if(!h){const r=L.URI.file((0,s.homedir)());h=new C.WorkspaceFolder({uri:r,name:b.basename(r),index:0})}return{uri:h.uri,name:h.name,index:h.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,h){const r=L.URI.revive(n),t={process:void 0,variables:Object.create(null)},l=await this._workspaceProvider.resolveWorkspaceFolder(r),o=await this._workspaceProvider.getWorkspaceFolders2()??[],d=await this.getVariableResolver(o),m=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(o);for(let u of h.variables)t.variables[u]=await d.resolveAsync(m,u);if(h.process!==void 0){let u;if(h.process.path!==void 0){u=h.process.path.split(g.delimiter);for(let y=0;y<u.length;y++)u[y]=await d.resolveAsync(m,u[y])}t.process=await D.win32.findExecutable(await d.resolveAsync(m,h.process.name),h.process.cwd!==void 0?await d.resolveAsync(m,h.process.cwd):void 0,u)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(n,h,r){return D.win32.findExecutable(n,h,r)}};a=Ve([$e(0,I.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,S.IExtHostWorkspace),$e(3,k.IExtHostDocumentsAndEditors),$e(4,E.IExtHostConfiguration),$e(5,i.IExtHostTerminalService),$e(6,w.ILogService),$e(7,_.IExtHostApiDeprecationService),$e(8,P.IExtHostEditorTabs)],a),e.ExtHostTask=a}),define(fe[275],me([0,1,16,18,73,6,2,5,267,11,83,85,27,189,14,66,40,33]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(a,v,n,h){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=n,this._rpcProtocol=new E.RPCProtocol(a,null,h),v=b._transform(v,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...v}),r.set(f.IExtHostRpcService,new f.ExtHostRpcService(this._rpcProtocol)),r.set(w.IURITransformerService,new w.URITransformerService(h)),r.set(_.IHostUtils,n);const t=new p.InstantiationService(r,!0),l=t.invokeFunction(u=>u.get(P.IExtHostTerminalService));this._disposables.add(l),this._logService=t.invokeFunction(u=>u.get(C.ILogService)),D.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=t.invokeFunction(u=>u.get(_.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const o=new WeakMap;this._extensionService.getExtensionPathIndex().then(u=>{Error.prepareStackTrace=(y,T)=>{let R="",$,B;for(const F of T)R+=`
	at ${F.toString()}`,B=F.getFileName(),!$&&B&&($=u.findSubstr(A.URI.file(B)));return o.set(y,$),`${y.name||"Error"}: ${y.message||""}${R}`}});const d=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(u=>{const y=L.transformErrorForSerialization(u),T=o.get(u);T?d.$onExtensionRuntimeError(T.identifier,y):m.$onUnexpectedError(y)})}terminate(a){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${a}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(n=>{this._logService.error(n)}),this._rpcProtocol.dispose();const v=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,g.timeout)(4e3),v]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(a,v){a.extensions.forEach(h=>h.extensionLocation=A.URI.revive(v.transformIncomingURIs(h.extensionLocation))),a.environment.appRoot=A.URI.revive(v.transformIncomingURIs(a.environment.appRoot));const n=a.environment.extensionDevelopmentLocationURI;return n&&(a.environment.extensionDevelopmentLocationURI=n.map(h=>A.URI.revive(v.transformIncomingURIs(h)))),a.environment.extensionTestsLocationURI=A.URI.revive(v.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=A.URI.revive(v.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=A.URI.revive(v.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=A.URI.revive(v.transformIncomingURIs(a.logsLocation)),a.logFile=A.URI.revive(v.transformIncomingURIs(a.logFile)),a.workspace=v.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=b}),define(fe[276],me([0,1,9,21,51,30,23,46,32]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(c,p,f){this.config=c,this.provider=p,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&S.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&S.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const p=this.config.folderQueries||[];return new Promise((f,w)=>{const _=P=>{this.resultCount++,c(P)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(P=>{const b=P.toString(),s=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,s)||this.matchFile(_,{base:P,basename:s})}),Promise.all(p.map(P=>this.searchInFolder(P,_))).then(P=>{f({limitHit:this.isLimitHit,stats:P[0]||void 0})},P=>{w(new Error((0,D.toErrorMessage)(P)))})})}async searchInFolder(c,p){const f=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(c),_=this.initDirectoryTree(),P=new E.QueryGlobTester(this.config,c),b=!P.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(f),s=k.StopWatch.create();const a=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,f.token),v=s.elapsed(),n=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(a&&a.forEach(h=>{const r=g.posix.relative(c.folder.path,h.path);if(b){const t=g.basename(h.path);this.matchFile(p,{base:c.folder,relativePath:r,basename:t});return}this.addDirectoryEntries(_,c.folder,r,p)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(_,P,p),{providerTime:v,postProcessTime:n.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(c){const p=(0,E.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:f,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},p,f,w){if(f===this.filePattern){const P=g.basename(this.filePattern);this.matchFile(w,{base:p,relativePath:this.filePattern,basename:P})}function _(P){const b=g.basename(P),s=g.dirname(P);let a=c[s];a||(a=c[s]=[],_(s)),a.push({base:p,relativePath:P,basename:b})}_(f)}matchDirectoryTree({rootEntries:c,pathToEntries:p},f,w){const _=this,P=this.filePattern;function b(s){const a=S.hasSiblingFn(()=>s.map(v=>v.basename));for(let v=0,n=s.length;v<n;v++){const h=s[v],{relativePath:r,basename:t}=h;if(f.matchesExcludesSync(r,t,P!==t?a:void 0))continue;const l=p[r];if(l)b(l);else{if(r===P)continue;_.matchFile(w,h)}if(_.isLimitHit)break}}b(c)}matchFile(c,p){(!this.includePattern||p.relativePath&&this.includePattern(p.relativePath,p.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(p))}}class i{constructor(){this.sessions=new Map}fileSearch(c,p,f,w){const _=this.getSessionTokenSource(c.cacheKey),P=new C(c,p,_&&_.token);let b=0;const s=a=>{b+=a.length,f(a.map(v=>this.rawMatchToSearchItem(v)))};return this.doSearch(P,i.BATCH_SIZE,s,w).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:a.stats}}))}clearCache(c){const p=this.getSessionTokenSource(c);p&&p.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:A.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,p,f,w){w.onCancellationRequested(()=>{c.cancel()});const _=b=>{b&&(P.push(b),p>0&&P.length>=p&&(f(P),P=[]))};let P=[];return c.search(_).then(b=>(P.length&&f(P),b),b=>(P.length&&f(P),Promise.reject(b)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(fe[135],me([0,1,15,21,51,30,10,9,23,13,2,32]),function(Y,e,g,L,D,S,A,k,E,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(s,a,v,n){this.query=s,this.provider=a,this.fileUtils=v,this.processType=n,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,a){const v=this.query.folderQueries||[],n=new L.CancellationTokenSource;return a.onCancellationRequested(()=>n.cancel()),new Promise((h,r)=>{this.collector=new f(s);let t=!1;const l=(o,d)=>{if(!t&&!this.isLimitHit){const m=this.resultSize(o);_(o)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,t=!0,n.cancel(),o=this.trimResultToSize(o,this.query.maxResults-this.resultCount));const u=this.resultSize(o);this.resultCount+=u,(u>0||!_(o))&&this.collector.add(o,d)}};Promise.all(v.map((o,d)=>this.searchInFolder(o,m=>l(m,d),n.token))).then(o=>{n.dispose(),this.collector.flush();const d=o.some(m=>!!m&&!!m.limitHit);h({limitHit:this.isLimitHit||d,messages:(0,g.flatten)(o.map(m=>m?.message?(0,C.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},o=>{n.dispose();const d=(0,D.toErrorMessage)(o);r(new Error(d))})})}resultSize(s){return _(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,a){const v=Array.isArray(s.ranges)?s.ranges:[s.ranges],n=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:v.slice(0,a),preview:{matches:n.slice(0,a),text:s.preview.text},uri:s.uri}}async searchInFolder(s,a,v){const n=new I.QueryGlobTester(this.query,s),h=[],r={report:o=>{if(!this.validateProviderResult(o))return;const d=s.folder.scheme===A.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(E.dirname(o.uri))):void 0,m=E.relativePath(s.folder,o.uri);if(m){const u=n.includedInQuery(m,k.basename(m),d);(0,C.isPromise)(u)?h.push(u.then(y=>{y&&a(o)})):u&&a(o)}}},t=this.getSearchOptionsForFolder(s),l=await this.provider.provideTextSearchResults(p(this.query.contentPattern),t,r,v);return h.length&&await Promise.all(h),l}validateProviderResult(s){if(_(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const a=(0,I.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),v=(0,I.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),n={folder:i.URI.from(s.folder),excludes:v,includes:a,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}}e.TextSearchManager=c;function p(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class f{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new P(512,a=>this.sendItems(a))}add(s,a){this._currentFileMatch&&(this._currentFolderIdx!==a||!E.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=a,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(w(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=f;function w(b){return _(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function _(b){return!!b.preview}e.extensionResultIsMatch=_;class P{constructor(s,a){this.maxBatchSize=s,this.cb=a,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,a){!s||this.addItemToBatch(s,a)}addItems(s,a){!s||this.addItemsToBatch(s,a)}addItemToBatch(s,a){this.batch.push(s),this.batchSize+=a,this.onUpdate()}addItemsToBatch(s,a){this.batch=this.batch.concat(s),this.batchSize+=a,this.onUpdate()}onUpdate(){this.totalNumberCompleted<P.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},P.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=P,P.TIMEOUT=4e3,P.START_BATCH_AFTER_COUNT=50}),define(fe[74],me([0,1,6,5,4,276,14,66,11,2,135]),function(Y,e,g,L,D,S,A,k,E,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(w,_,P){this.extHostRpc=w,this._uriTransformer=_,this._logService=P,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,_){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const P=this._handlePool++;return this._textSearchProvider.set(P,_),this._proxy.$registerTextSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}registerFileSearchProvider(w,_){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const P=this._handlePool++;return this._fileSearchProvider.set(P,_),this._proxy.$registerFileSearchProvider(P,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(P),this._proxy.$unregisterProvider(P)})}$provideFileSearchResults(w,_,P,b){const s=c(P),a=this._fileSearchProvider.get(w);if(a)return this._fileSearchManager.fileSearch(s,a,v=>{this._proxy.$handleFileMatch(w,_,v.map(n=>n.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,_,P,b){const s=this._textSearchProvider.get(w);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const a=c(P);return this.createTextSearchManager(a,s).search(n=>this._proxy.$handleTextMatch(w,_,n),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,_){return new i.TextSearchManager(w,_,{readdir:P=>Promise.resolve([]),toCanonicalName:P=>P},"textSearchProvider")}};I=Ve([$e(0,A.IExtHostRpcService),$e(1,k.IURITransformerService),$e(2,E.ILogService)],I),e.ExtHostSearch=I;function c(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(p),extraFileResources:f.extraFileResources&&f.extraFileResources.map(w=>C.URI.revive(w))}}e.reviveQuery=c;function p(f){return{...f,folder:C.URI.revive(f.folder)}}}),define(fe[277],me([0,1,21,18,3,49,2,113,108,147,82,42,5,235,234,39,236,36,237,238,239,221,240,45,40,241,222,244,245,246,133,224,251,252,253,91,33,255,225,17,7,258,70,134,35,26,58,209,243,63,131,72,56,74,11,66,14,27,247,206,53,67,232,256,205,69,68,261,259,260,233,44,254,257,90,55,121,249,71,250,10,192,248,203,242]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s,a,v,n,h,r,t,l,o,d,m,u,y,T,R,$,B,F,W,M,z,N,U,x,O,j,H,X,Q,de,_e,Ie,Pe,We,Be,He,G,ee,ie,ce,Z,re,pe,Me,je,Ke,Ze,rt,ct,ye,at,J,ne,Ee,Qe,et,le,ke,Ne,Xe,nt,ft,tt,ut,Re,De){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(se){const ue=se.get(ie.IExtHostInitDataService),we=se.get(ne.IExtHostFileSystemInfo),ve=se.get(rt.IExtHostConsumerFileSystem),Fe=se.get(r.IExtHostExtensionService),qe=se.get(j.IExtHostWorkspace),ze=se.get(ke.IExtHostTelemetry),Ye=se.get(P.IExtHostConfiguration),lt=se.get(G.IURITransformerService),xe=se.get(ee.IExtHostRpcService),ge=se.get(B.IExtHostStorage),be=se.get(Ze.IExtensionStoragePaths),ae=se.get(He.ILoggerService),K=se.get(He.ILogService),Se=se.get(re.IExtHostTunnelService),Le=se.get(pe.IExtHostApiDeprecationService),it=se.get(O.IExtHostWindow),Ge=se.get(et.IExtHostSecretState),mt=se.get(le.IExtHostEditorTabs);xe.set(c.ExtHostContext.ExtHostFileSystemInfo,we),xe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,ae),xe.set(c.ExtHostContext.ExtHostWorkspace,qe),xe.set(c.ExtHostContext.ExtHostConfiguration,Ye),xe.set(c.ExtHostContext.ExtHostExtensionService,Fe),xe.set(c.ExtHostContext.ExtHostStorage,ge),xe.set(c.ExtHostContext.ExtHostTunnelService,Se),xe.set(c.ExtHostContext.ExtHostWindow,it),xe.set(c.ExtHostContext.ExtHostSecretState,Ge),xe.set(c.ExtHostContext.ExtHostTelemetry,ze),xe.set(c.ExtHostContext.ExtHostEditorTabs,mt);const yt=xe.set(c.ExtHostContext.ExtHostDecorations,se.get(Ie.IExtHostDecorations)),Et=xe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,se.get(h.IExtHostDocumentsAndEditors)),gt=xe.set(c.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=xe.set(c.ExtHostContext.ExtHostTerminalService,se.get(F.IExtHostTerminalService)),vt=xe.set(c.ExtHostContext.ExtHostDebugService,se.get(We.IExtHostDebugService)),Tt=xe.set(c.ExtHostContext.ExtHostSearch,se.get(Be.IExtHostSearch)),Dt=xe.set(c.ExtHostContext.ExtHostTask,se.get(Pe.IExtHostTask)),$t=xe.set(c.ExtHostContext.ExtHostOutputService,se.get(u.IExtHostOutputService)),jt=xe.set(c.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(xe)),kt=xe.set(c.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(xe,Et)),Wt=xe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new a.ExtHostDocumentContentProvider(xe,Et,K)),ii=xe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new v.ExtHostDocumentSaveParticipant(K,kt,xe.getProxy(c.MainContext.MainThreadBulkEdits))),_t=xe.set(c.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(xe,gt,Et,kt,be)),Xt=xe.set(c.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(K,_t)),qt=xe.set(c.ExtHostContext.ExtHostNotebookEditors,new ut.ExtHostNotebookEditors(K,xe,_t)),ni=xe.set(c.ExtHostContext.ExtHostNotebookKernels,new Ne.ExtHostNotebookKernels(xe,ue,_t,gt,K)),ri=xe.set(c.ExtHostContext.ExtHostNotebookRenderers,new nt.ExtHostNotebookRenderers(xe,_t)),At=xe.set(c.ExtHostContext.ExtHostEditors,new W.ExtHostEditors(xe,Et)),Yt=xe.set(c.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(c.MainContext.MainThreadTreeViews),gt,K)),bi=xe.set(c.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(xe.getProxy(c.MainContext.MainThreadEditorInsets),At,ue)),Ht=xe.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,K,we)),zt=xe.set(c.ExtHostContext.ExtHostLanguages,new d.ExtHostLanguages(xe,kt,gt.converter,lt)),wt=xe.set(c.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(xe,lt,kt,gt,Ht,K,Le)),si=xe.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,wt)),Nt=xe.set(c.ExtHostContext.ExtHostFileSystemEventService,new l.ExtHostFileSystemEventService(xe,K,Et)),Ut=xe.set(c.ExtHostContext.ExtHostQuickOpen,(0,T.createExtHostQuickOpen)(xe,qe,gt)),Jt=xe.set(c.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,gt,K)),Ei=xe.set(c.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(xe,gt,kt)),fi=xe.set(c.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(xe.getProxy(c.MainContext.MainThreadProgress))),_i=xe.set(c.ExtHostContext.ExtHosLabelService,new de.ExtHostLabelService(xe)),mi=xe.set(c.ExtHostContext.ExtHostTheming,new Z.ExtHostTheming(xe)),Zt=xe.set(c.ExtHostContext.ExtHostAuthentication,new Me.ExtHostAuthentication(xe)),oi=xe.set(c.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(xe,gt)),Gt=xe.set(c.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(xe,{remote:ue.remote},qe,K,Le)),ai=xe.set(c.ExtHostContext.ExtHostWebviewPanels,new at.ExtHostWebviewPanels(xe,Gt,qe)),Si=xe.set(c.ExtHostContext.ExtHostCustomEditors,new ye.ExtHostCustomEditors(xe,kt,be,Gt,ai)),yi=xe.set(c.ExtHostContext.ExtHostWebviewViews,new ct.ExtHostWebviewViews(xe,Gt)),Kt=xe.set(c.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(xe,gt)),ei=xe.set(c.ExtHostContext.ExtHostUriOpeners,new Qe.ExtHostUriOpeners(xe));xe.set(c.ExtHostContext.ExtHostInteractive,new De.ExtHostInteractive(xe,_t,Et,gt));const Di=(0,X.values)(c.ExtHostContext);xe.assertRegistered(Di);const Ci=new J.ExtHostBulkEdits(xe,Et),li=new f.ExtHostClipboard(xe),ci=new m.ExtHostMessageService(xe,K),Vt=new s.ExtHostDialogs(xe),Mt=new $.ExtHostStatusBar(xe,gt.converter);return p.ExtHostApiCommands.register(gt),function(Ue,Lt,Qt){const St=function(){let te=!Ue.isUnderDevelopment;function he(){te||(K.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(dt){if(Array.isArray(dt))dt.forEach(Ae);else if(typeof dt=="string")he();else{const Ct=dt;typeof Ct.scheme=="undefined"&&he(),typeof Ct.exclusive=="boolean"&&(0,H.checkProposedApiEnabled)(Ue)}return dt}}(),ki={getSession(te,he,Ae){return Ae?.forceNewSession&&(0,H.checkProposedApiEnabled)(Ue),Zt.getSession(Ue,te,he,Ae)},async hasSession(te,he){return(0,H.checkProposedApiEnabled)(Ue),!!await Zt.getSession(Ue,te,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ae,dt){return Zt.registerAuthenticationProvider(te,he,Ae,dt)}},Ii={registerCommand(te,he,Ae){return gt.registerCommand(!0,te,he,Ae,void 0,Ue)},registerTextEditorCommand(te,he,Ae){return gt.registerCommand(!0,te,(...dt)=>{const Ct=At.getActiveTextEditor();if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return Ct.edit(Pt=>{he.apply(Ae,[Ct,Pt,...dt])}).then(Pt=>{Pt||K.warn("Edits from command "+te+" were not applied.")},Pt=>{K.warn("An error occurred while running command "+te,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(te,he,Ae)=>((0,H.checkProposedApiEnabled)(Ue),gt.registerCommand(!0,te,async(...dt)=>{const Ct=Et.activeEditor(!0);if(!Ct){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(Ct.id);he.apply(Ae,[Pt,...dt])},void 0,void 0,Ue)),executeCommand(te,...he){return gt.executeCommand(te,...he)},getCommands(te=!1){return gt.getCommands(te)}},gi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return li.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return it.openUri(te,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ue.environment.appUriScheme)return jt.createAppUri(te);try{return await it.asExternalUri(te,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,tt.matchesScheme)(te,ft.Schemas.http)||(0,tt.matchesScheme)(te,ft.Schemas.https))return te;throw he}},get remoteName(){return(0,_e.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,H.checkProposedApiEnabled)(Ue),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(gi);const pi=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Pi={createTestController(te,he){return Kt.createTestController(te,he)},createTestObserver(){return(0,H.checkProposedApiEnabled)(Ue),Kt.createTestObserver()},runTests(te){return(0,H.checkProposedApiEnabled)(Ue),Kt.runTests(te)},get onDidChangeTestResults(){return(0,H.checkProposedApiEnabled)(Ue),Kt.onResultsChanged},get testResults(){return(0,H.checkProposedApiEnabled)(Ue),Kt.results}},Ti={getExtension(te){const he=Lt.getExtensionDescription(te);if(he)return new r.Extension(Fe,Ue.identifier,he,pi)},get all(){return Lt.getAllExtensionDescriptions().map(te=>new r.Extension(Fe,Ue.identifier,te,pi))},get onDidChange(){return Lt.onDidChange}},ui={createDiagnosticCollection(te){return Ht.createDiagnosticCollection(Ue.identifier,te)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:te=>Ht.getDiagnostics(te),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(te,he){return zt.changeLanguage(te.uri,he)},match(te,he){return(0,i.score)(z.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ae){return wt.registerCodeActionProvider(Ue,St(te),he,Ae)},registerCodeLensProvider(te,he){return wt.registerCodeLensProvider(Ue,St(te),he)},registerDefinitionProvider(te,he){return wt.registerDefinitionProvider(Ue,St(te),he)},registerDeclarationProvider(te,he){return wt.registerDeclarationProvider(Ue,St(te),he)},registerImplementationProvider(te,he){return wt.registerImplementationProvider(Ue,St(te),he)},registerTypeDefinitionProvider(te,he){return wt.registerTypeDefinitionProvider(Ue,St(te),he)},registerHoverProvider(te,he){return wt.registerHoverProvider(Ue,St(te),he,Ue.identifier)},registerEvaluatableExpressionProvider(te,he){return wt.registerEvaluatableExpressionProvider(Ue,St(te),he,Ue.identifier)},registerInlineValuesProvider(te,he){return wt.registerInlineValuesProvider(Ue,St(te),he,Ue.identifier)},registerDocumentHighlightProvider(te,he){return wt.registerDocumentHighlightProvider(Ue,St(te),he)},registerLinkedEditingRangeProvider(te,he){return wt.registerLinkedEditingRangeProvider(Ue,St(te),he)},registerReferenceProvider(te,he){return wt.registerReferenceProvider(Ue,St(te),he)},registerRenameProvider(te,he){return wt.registerRenameProvider(Ue,St(te),he)},registerDocumentSymbolProvider(te,he,Ae){return wt.registerDocumentSymbolProvider(Ue,St(te),he,Ae)},registerWorkspaceSymbolProvider(te){return wt.registerWorkspaceSymbolProvider(Ue,te)},registerDocumentFormattingEditProvider(te,he){return wt.registerDocumentFormattingEditProvider(Ue,St(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return wt.registerDocumentRangeFormattingEditProvider(Ue,St(te),he)},registerOnTypeFormattingEditProvider(te,he,Ae,...dt){return wt.registerOnTypeFormattingEditProvider(Ue,St(te),he,[Ae].concat(dt))},registerDocumentSemanticTokensProvider(te,he,Ae){return wt.registerDocumentSemanticTokensProvider(Ue,St(te),he,Ae)},registerDocumentRangeSemanticTokensProvider(te,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Ue,St(te),he,Ae)},registerSignatureHelpProvider(te,he,Ae,...dt){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Ue,St(te),he,Ae):wt.registerSignatureHelpProvider(Ue,St(te),he,typeof Ae=="undefined"?[]:[Ae,...dt])},registerCompletionItemProvider(te,he,...Ae){return wt.registerCompletionItemProvider(Ue,St(te),he,Ae)},registerInlineCompletionItemProvider(te,he){return(0,H.checkProposedApiEnabled)(Ue),wt.registerInlineCompletionsProvider(Ue,St(te),he)},registerDocumentLinkProvider(te,he){return wt.registerDocumentLinkProvider(Ue,St(te),he)},registerColorProvider(te,he){return wt.registerColorProvider(Ue,St(te),he)},registerFoldingRangeProvider(te,he){return wt.registerFoldingRangeProvider(Ue,St(te),he)},registerSelectionRangeProvider(te,he){return wt.registerSelectionRangeProvider(Ue,te,he)},registerCallHierarchyProvider(te,he){return wt.registerCallHierarchyProvider(Ue,te,he)},registerTypeHierarchyProvider(te,he){return wt.registerTypeHierarchyProvider(Ue,te,he)},setLanguageConfiguration:(te,he)=>wt.setLanguageConfiguration(Ue,te,he),getTokenInformationAtPosition(te,he){return(0,H.checkProposedApiEnabled)(Ue),zt.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return(0,H.checkProposedApiEnabled)(Ue),wt.registerInlayHintsProvider(Ue,te,he)},createLanguageStatusItem(te,he){return(0,H.checkProposedApiEnabled)(Ue),zt.createLanguageStatusItem(Ue,te,he)}},Ai={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Ae){const dt=await(A.URI.isUri(te)?Promise.resolve(vi.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(dt,he,Ae)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Ue,te)},onDidChangeActiveTextEditor(te,he,Ae){return At.onDidChangeActiveTextEditor(te,he,Ae)},onDidChangeVisibleTextEditors(te,he,Ae){return At.onDidChangeVisibleTextEditors(te,he,Ae)},onDidChangeTextEditorSelection(te,he,Ae){return At.onDidChangeTextEditorSelection(te,he,Ae)},onDidChangeTextEditorOptions(te,he,Ae){return At.onDidChangeTextEditorOptions(te,he,Ae)},onDidChangeTextEditorVisibleRanges(te,he,Ae){return At.onDidChangeTextEditorVisibleRanges(te,he,Ae)},onDidChangeTextEditorViewColumn(te,he,Ae){return At.onDidChangeTextEditorViewColumn(te,he,Ae)},onDidCloseTerminal(te,he,Ae){return bt.onDidCloseTerminal(te,he,Ae)},onDidOpenTerminal(te,he,Ae){return bt.onDidOpenTerminal(te,he,Ae)},onDidChangeActiveTerminal(te,he,Ae){return bt.onDidChangeActiveTerminal(te,he,Ae)},onDidChangeTerminalDimensions(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),bt.onDidChangeTerminalDimensions(te,he,Ae)},onDidChangeTerminalState(te,he,Ae){return bt.onDidChangeTerminalState(te,he,Ae)},onDidWriteTerminalData(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),bt.onDidWriteTerminalData(te,he,Ae)},get state(){return it.state},onDidChangeWindowState(te,he,Ae){return it.onDidChangeWindowState(te,he,Ae)},showInformationMessage(te,...he){return ci.showMessage(Ue,S.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return ci.showMessage(Ue,S.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return ci.showMessage(Ue,S.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ae){return Ut.showQuickPick(te,(0,H.isProposedApiEnabled)(Ue),he,Ae)},showWorkspaceFolderPick(te){return Ut.showWorkspaceFolderPick(te)},showInputBox(te,he){return Ut.showInput(te,he)},showOpenDialog(te){return Vt.showOpenDialog(te)},showSaveDialog(te){return Vt.showSaveDialog(te)},createStatusBarItem(te,he,Ae){let dt,Ct,Pt;return typeof te=="string"?(dt=te,Ct=he,Pt=Ae):(Ct=te,Pt=he),Mt.createStatusBarEntry(Ue,dt,Ct,Pt)},setStatusBarMessage(te,he){return Mt.setStatusBarMessage(te,he)},withScmProgress(te){return Le.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),fi.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(he,Ae)=>te({report(dt){}}))},withProgress(te,he){return fi.withProgress(Ue,te,he)},createOutputChannel(te){return $t.createOutputChannel(te,Ue)},createWebviewPanel(te,he,Ae,dt){return ai.createWebviewPanel(Ue,te,he,Ae,dt)},createWebviewTextEditorInset(te,he,Ae,dt){return(0,H.checkProposedApiEnabled)(Ue),bi.createWebviewEditorInset(te,he,Ae,dt,Ue)},createTerminal(te,he,Ae){return typeof te=="object"?("location"in te&&(0,H.checkProposedApiEnabled)(Ue),"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te)):bt.createTerminal(te,he,Ae)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Ue,te,he)},registerTreeDataProvider(te,he){return Yt.registerTreeDataProvider(te,he,Ue)},createTreeView(te,he){return Yt.createTreeView(te,he,Ue)},registerWebviewPanelSerializer:(te,he)=>ai.registerWebviewPanelSerializer(Ue,te,he),registerCustomEditorProvider:(te,he,Ae={})=>Si.registerCustomEditorProvider(Ue,te,he,Ae),registerFileDecorationProvider(te){return yt.registerFileDecorationProvider(te,Ue.identifier)},registerUriHandler(te){return jt.registerUriHandler(Ue.identifier,te)},createQuickPick(){return Ut.createQuickPick(Ue.identifier,(0,H.isProposedApiEnabled)(Ue))},createInputBox(){return Ut.createInputBox(Ue.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ae){return mi.onDidChangeActiveColorTheme(te,he,Ae)},registerWebviewViewProvider(te,he,Ae){return yi.registerWebviewViewProvider(Ue,te,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,H.checkProposedApiEnabled)(Ue),_t.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeActiveNotebookEditor(te,he,Ae)},get visibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ue),_t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),qt.onDidChangeNotebookEditorSelection(te,he,Ae)},onDidChangeNotebookEditorVisibleRanges(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),qt.onDidChangeNotebookEditorVisibleRanges(te,he,Ae)},showNotebookDocument(te,he){return(0,H.checkProposedApiEnabled)(Ue),_t.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),ei.registerExternalUriOpener(Ue.identifier,te,he,Ae)},get tabs(){return(0,H.checkProposedApiEnabled)(Ue),mt.tabs},get activeTab(){return(0,H.checkProposedApiEnabled)(Ue),mt.activeTab},get onDidChangeTabs(){return(0,H.checkProposedApiEnabled)(Ue),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,H.checkProposedApiEnabled)(Ue),mt.onDidChangeActiveTab},getInlineCompletionItemController(te){return(0,H.checkProposedApiEnabled)(Ue),o.InlineCompletionController.get(te)}},vi={get rootPath(){return Le.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return qe.getWorkspaceFolder(te)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(te){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Ae)=>qe.updateWorkspaceFolders(Ue,te,he||0,...Ae),onDidChangeWorkspaceFolders:function(te,he,Ae){return qe.onDidChangeWorkspace(te,he,Ae)},asRelativePath:(te,he)=>qe.getRelativePath(te,he),findFiles:(te,he,Ae,dt)=>qe.findFiles(z.GlobPattern.from(te),z.GlobPattern.from(he),Ae,Ue.identifier,dt),findTextInFiles:(te,he,Ae,dt)=>{let Ct,Pt;return typeof he=="object"?(Ct=he,Pt=Ae):(Ct={},Pt=he,dt=Ae),qe.findTextInFiles(te,Ct||{},Pt,Ue.identifier,dt)},saveAll:te=>qe.saveAll(te),applyEdit(te){return Ci.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ae,dt)=>Nt.createFileSystemWatcher(z.GlobPattern.from(te),he,Ae,dt),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Ae=te;if(typeof te=="string")he=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))he=Promise.resolve(te);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(dt=>kt.ensureDocumentData(dt).then(Ct=>Ct.document))},onDidOpenTextDocument:(te,he,Ae)=>kt.onDidAddDocument(te,he,Ae),onDidCloseTextDocument:(te,he,Ae)=>kt.onDidRemoveDocument(te,he,Ae),onDidChangeTextDocument:(te,he,Ae)=>kt.onDidChangeDocument(te,he,Ae),onDidSaveTextDocument:(te,he,Ae)=>kt.onDidSaveDocument(te,he,Ae),onWillSaveTextDocument:(te,he,Ae)=>ii.getOnWillSaveTextDocumentEvent(Ue)(te,he,Ae),get notebookDocuments(){return _t.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ae;if(A.URI.isUri(te))Ae=te,await _t.openNotebookDocument(te);else if(typeof te=="string")Ae=A.URI.revive(await _t.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ae,dt){return _t.registerNotebookSerializer(Ue,te,he,Ae,(0,H.isProposedApiEnabled)(Ue)?dt:void 0)},registerNotebookContentProvider:(te,he,Ae,dt)=>((0,H.checkProposedApiEnabled)(Ue),_t.registerNotebookContentProvider(Ue,te,he,Ae,(0,H.isProposedApiEnabled)(Ue)?dt:void 0)),onDidChangeConfiguration:(te,he,Ae)=>Qt.onDidChangeConfiguration(te,he,Ae),getConfiguration(te,he){return he=arguments.length===1?void 0:he,Qt.getConfiguration(te,he,Ue)},registerTextDocumentContentProvider(te,he){return Wt.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Le.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Dt.registerTaskProvider(Ue,te,he)),registerFileSystemProvider(te,he,Ae){return si.registerFileSystemProvider(Ue.identifier,te,he,Ae)},get fs(){return ve.value},registerFileSearchProvider:(te,he)=>((0,H.checkProposedApiEnabled)(Ue),Tt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,H.checkProposedApiEnabled)(Ue),Tt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,H.checkProposedApiEnabled)(Ue),Fe.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,H.checkProposedApiEnabled)(Ue),_i.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ae)=>Nt.onDidCreateFile(te,he,Ae),onDidDeleteFiles:(te,he,Ae)=>Nt.onDidDeleteFile(te,he,Ae),onDidRenameFiles:(te,he,Ae)=>Nt.onDidRenameFile(te,he,Ae),onWillCreateFiles:(te,he,Ae)=>Nt.getOnWillCreateFileEvent(Ue)(te,he,Ae),onWillDeleteFiles:(te,he,Ae)=>Nt.getOnWillDeleteFileEvent(Ue)(te,he,Ae),onWillRenameFiles:(te,he,Ae)=>Nt.getOnWillRenameFileEvent(Ue)(te,he,Ae),openTunnel:te=>((0,H.checkProposedApiEnabled)(Ue),Se.openTunnel(Ue,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,H.checkProposedApiEnabled)(Ue),Se.getTunnels()},onDidChangeTunnels:(te,he,Ae)=>((0,H.checkProposedApiEnabled)(Ue),Se.onDidChangeTunnels(te,he,Ae)),registerPortAttributesProvider:(te,he)=>((0,H.checkProposedApiEnabled)(Ue),Se.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>((0,H.checkProposedApiEnabled)(Ue),oi.registerTimelineProvider(te,he,Ue.identifier,gt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:te=>((0,H.checkProposedApiEnabled)(Ue),qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ae)=>qe.onDidGrantWorkspaceTrust(te,he,Ae)},Ri={get inputBox(){return Le.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ue)},createSourceControl(te,he,Ae){return Jt.createSourceControl(Ue,te,he,Ae)}},Li={createCommentController(te,he){return Ei.createCommentController(Ue,te,he)}},Fi={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(te,he,Ae){return vt.onDidStartDebugSession(te,he,Ae)},onDidTerminateDebugSession(te,he,Ae){return vt.onDidTerminateDebugSession(te,he,Ae)},onDidChangeActiveDebugSession(te,he,Ae){return vt.onDidChangeActiveDebugSession(te,he,Ae)},onDidReceiveDebugSessionCustomEvent(te,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(te,he,Ae)},onDidChangeBreakpoints(te,he,Ae){return vt.onDidChangeBreakpoints(te,he,Ae)},registerDebugConfigurationProvider(te,he,Ae){return vt.registerDebugConfigurationProvider(te,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return vt.registerDebugAdapterDescriptorFactory(Ue,te,he)},registerDebugAdapterTrackerFactory(te,he){return vt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(te,he,{parentSession:Ae}):vt.startDebugging(te,he,Ae||{})},stopDebugging(te){return vt.stopDebugging(te)},addBreakpoints(te){return vt.addBreakpoints(te)},removeBreakpoints(te){return vt.removeBreakpoints(te)},asDebugSourceUri(te,he){return vt.asDebugSourceUri(te,he)}},Mi={registerTaskProvider:(te,he)=>Dt.registerTaskProvider(Ue,te,he),fetchTasks:te=>Dt.fetchTasks(te),executeTask:te=>Dt.executeTask(Ue,te),get taskExecutions(){return Dt.taskExecutions},onDidStartTask:(te,he,Ae)=>Dt.onDidStartTask(te,he,Ae),onDidEndTask:(te,he,Ae)=>Dt.onDidEndTask(te,he,Ae),onDidStartTaskProcess:(te,he,Ae)=>Dt.onDidStartTaskProcess(te,he,Ae),onDidEndTaskProcess:(te,he,Ae)=>Dt.onDidEndTaskProcess(te,he,Ae)},Oi={createNotebookController(te,he,Ae,dt,Ct){return ni.createNotebookController(Ue,te,he,Ae,dt,(0,H.isProposedApiEnabled)(Ue)?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>_t.registerNotebookCellStatusBarItemProvider(Ue,te,he),get onDidSaveNotebookDocument(){return(0,H.checkProposedApiEnabled)(Ue),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,H.checkProposedApiEnabled)(Ue),qt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return ri.createRendererMessaging(Ue,te)},onDidChangeNotebookDocumentMetadata(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),Xt.onDidChangeNotebookDocumentMetadata(te,he,Ae)},onDidChangeNotebookCells(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeNotebookCells(te,he,Ae)},onDidChangeNotebookCellExecutionState(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeNotebookCellExecutionState(te,he,Ae)},onDidChangeCellOutputs(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeCellOutputs(te,he,Ae)},onDidChangeCellMetadata(te,he,Ae){return(0,H.checkProposedApiEnabled)(Ue),_t.onDidChangeCellMetadata(te,he,Ae)},createConcatTextDocument(te,he){return(0,H.checkProposedApiEnabled)(Ue),new Ke.ExtHostNotebookConcatDocument(_t,kt,te,he)}};return{version:ue.version,authentication:ki,commands:Ii,comments:Li,debug:Fi,env:gi,extensions:Ti,languages:ui,notebooks:Oi,scm:Ri,tasks:Mi,tests:Pi,window:Ai,workspace:vi,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:C.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:c.UIKind,Uri:A.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Xe.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[278],me([0,1,83,133,35,131,36,39,45,33,72,56,74,91,53,67,134,68,44,90,121,55,132,11,201]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b,s,a,v,n,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(h.ILoggerService,n.ExtHostLoggerService),(0,g.registerSingleton)(h.ILogService,r.ExtHostLogService),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,g.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration),(0,g.registerSingleton)(P.IExtHostConsumerFileSystem,P.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(S.IExtHostDecorations,S.ExtHostDecorations),(0,g.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(p.IExtHostStorage,p.ExtHostStorage),(0,g.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,g.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,g.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,g.registerSingleton)(_.IExtHostWindow,_.ExtHostWindow),(0,g.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,g.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,g.registerSingleton)(a.IExtHostTelemetry,a.ExtHostTelemetry),(0,g.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs)}),define(fe[92],me([0,1,15,11,32,71]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=A;function k(I,c,p,f){const w=(0,g.mapArrayOrNot)(p,E),_=new D.TextSearchMatch(c,w,f),P=_.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,C),uri:I,preview:{text:_.preview.text,matches:(0,g.mapArrayOrNot)(P,C)}}}e.createTextSearchResult=k;function E(I){return new D.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function C(I){return new S.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let i=class{constructor(c,p){this.prefix=c,this.logService=p}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};i=Ve([$e(1,L.ILogService)],i),e.OutputChannel=i}),define(fe[279],me([0,1,95,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function D(n){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(h=>h===n)}e.isUTFEncoding=D,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,A=512,k=512*8,E=512*128;class C{constructor(h){this.iconvLiteDecoder=h}static async create(h){let r;if(h!==e.UTF8)r=(await new Promise((l,o)=>{Y(["iconv-lite-umd"],l,o)})).getDecoder(p(h));else{const t=new TextDecoder;r={write(l){return t.decode(l,{stream:!0})},end(){return t.decode()}}}return new C(r)}write(h){return this.iconvLiteDecoder.write(h)}end(){return this.iconvLiteDecoder.end()}}function i(n,h){const r=h.minBytesRequiredForDetection??h.guessEncoding?k:A;return new Promise((t,l)=>{const o=(0,g.newWriteableStream)(T=>T.join("")),d=[];let m=0,u;const y=async()=>{try{const T=await v({buffer:L.VSBuffer.concat(d),bytesRead:m},h.guessEncoding);T.encoding=await h.overwriteEncoding(T.encoding),u=await C.create(T.encoding);const R=u.write(L.VSBuffer.concat(d).buffer);o.write(R),d.length=0,m=0,t({stream:o,detected:T})}catch(T){l(T)}};(0,g.listenStream)(n,{onData:async T=>{u?o.write(u.write(T.buffer)):(d.push(T),m+=T.byteLength,m>=r&&(n.pause(),await y(),setTimeout(()=>n.resume())))},onError:T=>o.error(T),onEnd:async()=>{u||await y(),o.end(u?.end())}})})}e.toDecodeStream=i;async function I(n,h,r){const l=(await new Promise((m,u)=>{Y(["iconv-lite-umd"],m,u)})).getEncoder(p(h),r);let o=!1,d=!1;return{read(){if(d)return null;const m=n.read();if(typeof m!="string"){if(d=!0,!o&&r?.addBOM)switch(h){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=l.end();return u&&u.length>0?(o=!0,L.VSBuffer.wrap(u)):null}return o=!0,L.VSBuffer.wrap(l.write(m))}}}e.toEncodeReadable=I;async function c(n){return(await new Promise((r,t)=>{Y(["iconv-lite-umd"],r,t)})).encodingExists(p(n))}e.encodingExists=c;function p(n){return n===e.UTF8_with_bom||n===null?e.UTF8:n}e.toNodeEncoding=p;function f(n,h){if(!n||h<e.UTF16be_BOM.length)return null;const r=n.readUInt8(0),t=n.readUInt8(1);if(r===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(r===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(h<e.UTF8_BOM.length)return null;const l=n.readUInt8(2);return r===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&l===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=f;const w=["ascii","utf-16","utf-32"];async function _(n){const h=await new Promise((d,m)=>{Y(["jschardet"],d,m)}),r=n.slice(0,E),t=s(r.buffer),l=h.detect(t);if(!l||!l.encoding)return null;const o=l.encoding.toLowerCase();return 0<=w.indexOf(o)?null:b(l.encoding)}const P={ibm866:"cp866",big5:"cp950"};function b(n){const h=n.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return P[h]||h}function s(n){let h="";for(let r=0;r<n.length;r++)h+=String.fromCharCode(n[r]);return h}function a(n){switch(n){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const h=n.match(/windows(\d+)/);return h?"windows-"+h[1]:n}}e.toCanonicalName=a;function v({buffer:n,bytesRead:h},r){let t=f(n,h),l=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&n){let o=!0,d=!0,m=!1;for(let u=0;u<h&&u<S;u++){const y=u%2==1,T=n.readUInt8(u)===0;if(T&&(m=!0),o&&(y&&!T||!y&&T)&&(o=!1),d&&(y&&T||!y&&!T)&&(d=!1),T&&!o&&!d)break}m&&(o?t=e.UTF16le:d?t=e.UTF16be:l=!0)}return r&&!l&&!t&&n?_(n.slice(0,h)).then(o=>({seemsBinary:!1,encoding:o})):{seemsBinary:l,encoding:t}}e.detectEncodingFromBuffer=v,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,279,28,135]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends D.TextSearchManager{constructor(k,E,C=L,i="searchProcess"){super(k,E,{readdir:I=>C.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},i)}}e.NativeTextSearchManager=S}),define(fe[280],me([0,1,281,295,296,2,26,297]),function(Y,e,g,L,D,S,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function E(c,p,f,w,_,P){const b=P.environment.useHostProxy,s=typeof b=="boolean"?b:!P.remote.isRemote,a=(0,k.createProxyResolver)({resolveProxy:n=>c.resolveProxy(n),getHttpProxySetting:()=>p.getConfiguration("http").get("proxy"),log:(n,h,...r)=>{switch(n){case k.LogLevel.Trace:w.trace(h,...r);break;case k.LogLevel.Debug:w.debug(h,...r);break;case k.LogLevel.Info:w.info(h,...r);break;case k.LogLevel.Warning:w.warn(h,...r);break;case k.LogLevel.Error:w.error(h,...r);break;case k.LogLevel.Critical:w.critical(h,...r);break;case k.LogLevel.Off:break;default:t(n,h,r);break}function t(l,o,...d){w.error("Unknown log level",l),w.error(o,...d)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:n=>{_.$publicLog2("resolveProxy",n)},useHostProxy:s,env:process.env}),v=C(p,a);return I(f,v)}e.connectProxyResolver=E;function C(c,p){const f={config:c.getConfiguration("http").get("proxySupport")||"off"};c.onDidChangeConfiguration(_=>{f.config=c.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!c.getConfiguration("http").get("systemCertificates")};return c.onDidChangeConfiguration(_=>{w.config=!!c.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,k.createHttpPatch)(g,p,{config:"off"},w,!0)),on:Object.assign({},g,(0,k.createHttpPatch)(g,p,{config:"on"},w,!0)),override:Object.assign({},g,(0,k.createHttpPatch)(g,p,{config:"override"},w,!0)),onRequest:Object.assign({},g,(0,k.createHttpPatch)(g,p,f,w,!0)),default:Object.assign(g,(0,k.createHttpPatch)(g,p,f,w,!1))},https:{off:Object.assign({},L,(0,k.createHttpPatch)(L,p,{config:"off"},w,!0)),on:Object.assign({},L,(0,k.createHttpPatch)(L,p,{config:"on"},w,!0)),override:Object.assign({},L,(0,k.createHttpPatch)(L,p,{config:"override"},w,!0)),onRequest:Object.assign({},L,(0,k.createHttpPatch)(L,p,f,w,!0)),default:Object.assign(L,(0,k.createHttpPatch)(L,p,f,w,!1))},tls:Object.assign(D,(0,k.createTlsPatch)(D))}}const i=new Map;function I(c,p){return c.getExtensionPathIndex().then(f=>{const w=Y.__$__nodeRequire("module"),_=w._load;w._load=function(b,s,a){if(b==="tls")return p.tls;if(b!=="http"&&b!=="https")return _.apply(this,arguments);const v=p[b],n=f.findSubstr(S.URI.file(s.filename));let h=i.get(n);if(h||i.set(n,h={}),!h[b]){let r=v.default;n&&(0,A.isProposedApiEnabled)(n)&&(r=v[n.proxySupport]||v.onRequest),h[b]={...r}}return h[b]}})}}),define(fe[282],me([0,1,38,9,79,29,12,8,92,283]),function(Y,e,g,L,D,S,A,k,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const i=C.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(s,a,v,n){const h=c(s,a,v,n),r=a.folder.fsPath;return{cmd:g.spawn(i,h.args,{cwd:r}),rgDiskPath:i,siblingClauses:h.siblingClauses,rgArgs:h,cwd:r}}e.spawnRipgrepCmd=I;function c(s,a,v,n){const h=["--files","--hidden","--case-sensitive"];f([a],v,!1).forEach(t=>{const l=(0,E.anchorGlob)(t);if(h.push("-g",l),A.isMacintosh){const o=(0,D.normalizeNFD)(l);o!==l&&h.push("-g",o)}});const r=p([a],n,void 0,!1);return r.globArgs.forEach(t=>{const l=`!${(0,E.anchorGlob)(t)}`;if(h.push("-g",l),A.isMacintosh){const o=(0,D.normalizeNFD)(l);o!==l&&h.push("-g",o)}}),a.disregardIgnoreFiles!==!1?h.push("--no-ignore"):h.push("--no-ignore-parent"),a.ignoreSymlinks||h.push("--follow"),s.exists&&h.push("--quiet"),h.push("--no-config"),a.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:r.siblingClauses}}function p(s,a,v,n=!0){const h=[];let r={};return s.forEach(t=>{const l=Object.assign({},t.excludePattern||{},a||{}),o=w(l,n?t.folder.fsPath:void 0,v);h.push(...o.globArgs),o.siblingClauses&&(r=Object.assign(r,o.siblingClauses))}),{globArgs:h,siblingClauses:r}}e.foldersToRgExcludeGlobs=p;function f(s,a,v=!0){const n=[];return s.forEach(h=>{const r=Object.assign({},a||{},h.includePattern||{}),t=w(r,v?h.folder.fsPath:void 0);n.push(...t.globArgs)}),n}e.foldersToIncludeGlobs=f;function w(s,a,v){const n=[],h={};return Object.keys(s).forEach(r=>{if(v&&v.has(r)||!r)return;const t=s[r];r=P(a?_(a,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof t=="boolean"&&t?(r.startsWith("\\\\")&&(r+="**"),n.push(b(r))):t&&t.when&&(h[r]=t)}),{globArgs:n,siblingClauses:h}}function _(s,a){return L.isAbsolute(a)?a:L.join(s,a)}e.getAbsoluteGlob=_;function P(s){return s=k.rtrim(s,"\\"),k.rtrim(s,"/")}function b(s){return S.getRoot(s).toLowerCase()==="c:/"?s.replace(/^c:[/\\]/i,"/"):s}e.fixDriveC=b}),define(fe[284],me([0,1,38,62,9,103,15,51,30,79,29,12,46,8,13,28,32,282,100]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const s=new Set;process.on("exit",()=>{s.forEach(r=>r())});class a{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&E.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&E.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(l=>{const o=Object.assign({},l.excludePattern||{},this.config.excludePattern||{}),d=l.folder.fsPath;t.folderQueries.map(m=>m.folder.fsPath).filter(m=>m!==d).forEach(m=>{(0,i.isEqualOrParent)(m,d)&&(o[D.relative(d,m)]=!0)}),this.folderExcludePatterns.set(d,new n(o,d))})}cancel(){this.isCanceled=!0,s.forEach(t=>t())}walk(t,l,o,d,m){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return m(null,this.isLimitHit);l.forEach(u=>{const y=D.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,y)||this.matchFile(o,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(u,y)=>{this.call(this.cmdTraversal,this,u,o,d,T=>{if(T){const R=(0,k.toErrorMessage)(T);console.error(R),this.errors.push(R),y(T,void 0)}else y(null,void 0)})},(u,y)=>{this.fileWalkSW.stop();const T=u?A.coalesce(u)[0]:null;m(T,this.isLimitHit)})}parallel(t,l,o){const d=new Array(t.length),m=new Array(t.length);let u=!1,y=0;if(t.length===0)return o(null,[]);t.forEach((T,R)=>{l(T,($,B)=>{if($?(u=!0,d[R]=null,m[R]=$):(d[R]=B,m[R]=null),++y===t.length)return o(u?m:null,d)})})}call(t,l,...o){try{t.apply(l,o)}catch(d){o[o.length-1](d)}}cmdTraversal(t,l,o,d){const m=t.folder.fsPath,u=I.isMacintosh;let y;const T=()=>y&&y.kill();s.add(T);let R=N=>{s.delete(T),R=()=>{},d(N)},$="";const B=this.initDirectoryTree();let F;const W=(0,P.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);y=W.cmd,F=!Object.keys(W.siblingClauses).length;const M=W.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let z=`${W.rgDiskPath} ${M}
 - cwd: ${W.cwd}`;W.rgArgs.siblingClauses&&(z+=`
 - Sibling clauses: ${JSON.stringify(W.rgArgs.siblingClauses)}`),o({message:z}),this.cmdResultCount=0,this.collectStdout(y,"utf8",o,(N,U,x)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const j=($+(u?C.normalizeNFC(U||""):U)).split(`
`);if(x){const H=j.length;j[H-1]=j[H-1].trim(),j[H-1]||j.pop()}else $=j.pop()||"";if(j.length&&j[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=j.length,F){for(const H of j)if(this.matchFile(l,{base:m,relativePath:H,searchPath:this.getSearchPath(t,H)}),this.isLimitHit){T();break}(x||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,B,m,j,l),x&&(this.matchDirectoryTree(B,m,l),R())})}spawnFindCmd(t){const l=this.folderExcludePatterns.get(t.folder.fsPath),o=l.getBasenameTerms(),d=l.getPathTerms(),m=["-L","."];if(o.length||d.length){m.push("-not","(","(");for(const u of o)m.push("-name",u),m.push("-o");for(const u of d)m.push("-path",u),m.push("-o");m.pop(),m.push(")","-prune",")")}return m.push("-type","f"),g.spawn("find",m,{cwd:t.folder.fsPath})}readStdout(t,l,o){let d="";this.collectStdout(t,l,()=>{},(m,u,y)=>{if(m){o(m);return}d+=u,y&&o(null,d)})}collectStdout(t,l,o,d){let m=(T,R,$)=>{(T||$)&&(m=()=>{},this.cmdSW&&this.cmdSW.stop()),d(T,R,$)},u=!1;t.stdout?(this.forwardData(t.stdout,l,m),t.stdout.once("data",()=>u=!0)):o({message:"stdout is null"});let y;t.stderr?y=this.collectData(t.stderr):o({message:"stderr is null"}),t.on("error",T=>{m(T)}),t.on("close",T=>{let R;!u&&(R=this.decodeData(y,l))&&h(R)?m(new Error(`command failed with error code ${T}: ${this.decodeData(y,l)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),m(null,"",!0))})}forwardData(t,l,o){const d=new S.StringDecoder(l);return t.on("data",m=>{o(null,d.write(m))}),d}collectData(t){const l=[];return t.on("data",o=>{l.push(o)}),l}decodeData(t,l){const o=new S.StringDecoder(l);return t.map(d=>o.write(d)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:l},o,d,m){d.indexOf(this.filePattern)!==-1&&this.matchFile(m,{base:o,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const u=y=>{const T=D.basename(y),R=D.dirname(y);let $=l[R];$||($=l[R]=[],u(R)),$.push({base:o,relativePath:y,basename:T,searchPath:this.getSearchPath(t,y)})};d.forEach(u)}matchDirectoryTree({rootEntries:t,pathToEntries:l},o,d){const m=this,u=this.folderExcludePatterns.get(o),y=this.filePattern;function T(R){m.directoriesWalked++;const $=E.hasSiblingFn(()=>R.map(B=>B.basename));for(let B=0,F=R.length;B<F;B++){const W=R[B],{relativePath:M,basename:z}=W;if(u.test(M,z,y!==z?$:void 0))continue;const N=l[M];if(N)T(N);else{if(m.filesWalked++,M===y)continue;m.matchFile(d,W)}if(m.isLimitHit)break}}T(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,l,o,d,m){const u=t.folder,y=E.hasSiblingFn(()=>o);this.parallel(o,(T,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const $=l?[l,T].join(D.sep):T;if(this.folderExcludePatterns.get(t.folder.fsPath).test($,T,this.config.filePattern!==T?y:void 0))return R(null);const B=[u.fsPath,$].join(D.sep);L.lstat(B,(F,W)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(B,W,(M,z)=>M||this.isCanceled||this.isLimitHit?R(null):z.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(B,W,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?R(null):(this.walkedPaths[U]=!0,w.Promises.readdir(B).then(x=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,$,x,d,O=>R(O||null))},x=>{R(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&f.isNumber(z.size)&&z.size>this.maxFilesize||this.matchFile(d,{base:u.fsPath,relativePath:$,searchPath:this.getSearchPath(t,$)}),R(null,void 0)))})},T=>{const R=T&&A.coalesce(T);return m(R&&R.length>0?R[0]:void 0)})}matchFile(t,l){this.isFileMatch(l)&&(!this.includePattern||this.includePattern(l.relativePath,D.basename(l.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(l))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,_.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,l,o){return l.isSymbolicLink()?L.stat(t,o):o(null,l)}realPathIfNeeded(t,l,o){return l.isSymbolicLink()?L.realpath(t,(d,m)=>d?o(d):o(null,m)):o(null,t)}getSearchPath(t,l){return t.folderName?D.join(t.folderName,l):l}}e.FileWalker=a;class v{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new a(t)}search(t,l,o){this.walker.walk(this.folderQueries,this.extraFiles,t,l,(d,m)=>{o(d,{limitHit:m,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=v;class n{constructor(t,l){this.expression=t,this.root=l,this.init(t)}init(t){let l,o;Object.keys(t).filter(d=>t[d]).forEach(d=>{D.isAbsolute(d)?(l=l||E.getEmptyExpression(),l[d]=t[d]):(o=o||E.getEmptyExpression(),o[d]=t[d])}),this.absoluteParsedExpr=l&&E.parse(l,{trimForExclusions:!0}),this.relativeParsedExpr=o&&E.parse(o,{trimForExclusions:!0})}test(t,l,o){return this.relativeParsedExpr&&this.relativeParsedExpr(t,l,o)||this.absoluteParsedExpr&&this.absoluteParsedExpr(D.join(this.root,t),l,o)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...E.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...E.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(...E.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(...E.getPathTerms(this.relativeParsedExpr)),t}}function h(r){const t=r.trim().split(`
`),l=t[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return p.uppercaseFirstLetter(t[t.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}e.rgErrorMsgForDisplay=h}),define(fe[137],me([0,1,38,298,103,15,58,30,9,8,2,32,71,299,283,92]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const _=f.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class P{constructor(u){this.outputChannel=u}provideTextSearchResults(u,y,T,R){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise(($,B)=>{R.onCancellationRequested(()=>O());const F=h(u,y),W=y.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${_} ${M}
 - cwd: ${W}`);let z=g.spawn(_,F,{cwd:W});z.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),B((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let N=!1;const U=new a(y.maxResults,W,y.previewOptions);U.on("result",de=>{N=!0,H="",T.report(de)});let x=!1;const O=()=>{x=!0,z&&z.kill(),U&&U.cancel()};let j=!1;U.on("hitLimit",()=>{j=!0,O()});let H="";z.stdout.on("data",de=>{U.handleData(de),N||(H+=de)});let X=!1;z.stdout.once("data",()=>X=!0);let Q="";z.stderr.on("data",de=>{const _e=de.toString();this.outputChannel.appendLine(_e),Q+=_e}),z.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),H&&this.outputChannel.appendLine(`Got data without result: ${H}`),this.outputChannel.appendLine(""),x)$({limitHit:j});else{U.flush(),z=null;let de;Q&&!X&&(de=b(Q))?B((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):$({limitHit:j})}})})}}e.RipgrepTextSearchEngine=P;function b(m){const u=m.split(`
`),y=u[0].trim();if(u.some(R=>R.startsWith("regex parse error")))return new I.SearchError(s(u),I.SearchErrorCode.regexParseError);const T=y.match(/grep config error: unknown encoding: (.*)/);if(T)return new I.SearchError(`Unknown encoding: ${T[1]}`,I.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new I.SearchError(y.charAt(0).toUpperCase()+y.substr(1),I.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new I.SearchError(y.charAt(0).toUpperCase()+y.substr(1),I.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(y,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function s(m){const u=["Regex parse error"],y=m.filter(T=>T.startsWith("PCRE2:"));if(y.length>=1){const T=y[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const R=T.split(":")[1];u.push(":"+R)}}return u.join("")}e.buildRegexParseError=s;class a extends L.EventEmitter{constructor(u,y,T){super();this.maxResults=u,this.rootFolder=y,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new D.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,y){return super.on(u,y),this}handleData(u){if(this.isDone)return;const y=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(y)}handleDecodedData(u){let y=u.indexOf(`
`);const T=this.remainder+u;if(y>=0)y+=this.remainder.length;else{this.remainder=T;return}let R=0;for(;y>=0;)this.handleLine(T.substring(R,y).trim()),R=y+1,y=T.indexOf(`
`,R);this.remainder=T.substring(R)}handleLine(u){if(this.isDone||!u)return;let y;try{y=JSON.parse(u)}catch(T){throw new Error(`malformed line from rg: ${u}`)}if(y.type==="match"){const T=v(y.data.path),R=i.URI.file(E.join(this.rootFolder,T)),$=this.createTextSearchMatch(y.data,R);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const T=v(y.data.path),R=i.URI.file(E.join(this.rootFolder,T));this.createTextSearchContext(y.data,R).forEach(B=>this.onResult(B))}}createTextSearchMatch(u,y){const T=u.line_number-1,R=v(u.lines),$=Buffer.from(R);let B=0,F=0,W=T;u.submatches.length===0&&u.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,S.coalesce)(u.submatches.map((z,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=v(z.match),x=$.slice(B,z.start).toString().length,O=F+x,j=n(U),H=W,X=j.numLines+H,Q=j.numLines>0?j.lastLineLength:j.lastLineLength+O;return B=z.end,F=Q,W=X,new c.Range(H,O,X,Q)}));return(0,w.createTextSearchResult)(y,R,M,this.previewOptions)}createTextSearchContext(u,y){const T=v(u.lines),R=u.line_number;return T.replace(/\r?\n$/,"").split(`
`).map(($,B)=>({text:$,uri:y,lineNumber:R+B}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=a;function v(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function n(m){const u=/\n/g;let y=0,T=-1,R;for(;R=u.exec(m);)y++,T=R.index;const $=T>=0?m.length-T-1:m.length;return{numLines:y,lastLineLength:$}}function h(m,u){const y=["--hidden"];y.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:R}=(0,A.groupBy)(u.includes,B=>B.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const B=new Set;R.forEach(F=>{B.add(F)}),y.push("-g","!*"),B.forEach(F=>{r(F).map(w.anchorGlob).forEach(W=>{y.push("-g",W)})})}T&&T.length&&T.forEach(B=>{y.push("-g",B)}),u.excludes.map(w.anchorGlob).forEach(B=>y.push("-g",`!${B}`)),u.maxFileSize&&y.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?y.push("--no-ignore-parent"):y.push("--no-ignore"),u.followSymlinks&&y.push("--follow"),u.encoding&&u.encoding!=="utf8"&&y.push("--encoding",u.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,C.escapeRegExpCharacters)(m.pattern),m.isRegExp=!0),u.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),m.isRegExp&&(m.pattern=t(m.pattern),y.push("--auto-hybrid-regex"));let $;if(m.isWordMatch){const F=(0,C.createRegExp)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(m.isRegExp){let B=o(m.pattern);B=d(B),y.push("--regexp",B)}else $=m.pattern,y.push("--fixed-strings");return y.push("--no-config"),u.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),m.isMultiline&&y.push("--multiline"),u.beforeContext&&y.push("--before-context",u.beforeContext+""),u.afterContext&&y.push("--after-context",u.afterContext+""),y.push("--"),$&&y.push($),y.push("."),y}function r(m){const u=(0,k.splitGlobAware)(m,"/");return u.map((y,T)=>u.slice(0,T+1).join("/"))}e.spreadGlobComponents=r;function t(m){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(u);)m=m.replace(u,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(y);)m=m.replace(y,"$1\\x{$2}");return m}e.unicodeEscapesToPCRE2=t;const l=m=>m.type==="Assertion"&&m.kind==="lookbehind";function o(m){let u;try{u=new p.RegExpParser().parsePattern(m)}catch{return m}let y="",T=0;const R=(F,W,M)=>{y+=m.slice(T,F)+M,T=W},$=[];return new p.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const W=$[0];if(!W)R(F.start,F.end,"\\r?\\n");else if(!$.some(l))if(W.type==="CharacterClass")if(W.negate){const M=m.slice(W.start+2,F.start)+m.slice(F.end,W.end-1);if(W.parent?.type==="Quantifier"){const z=W.parent;R(z.start,z.end,(M?`[^${M}]`:".")+(z.greedy?"+":"*"))}else R(W.start,W.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=m.slice(W.start+1,F.start)+m.slice(F.end,W.end-1);R(W.start,W.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else W.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){$.unshift(F)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(F){$.unshift(F)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(F){$.unshift(F)},onCharacterClassLeave(){$.shift()},onAssertionEnter(F){l(F)&&$.push(F)},onAssertionLeave(F){$[0]===F&&$.shift()}}).visit(u),y+=m.slice(T),y}e.fixRegexNewline=o;function d(m){return m.replace(/\n/g,"\\r?\\n")}e.fixNewline=d}),define(fe[285],me([0,1,21,137,116,10]),function(Y,e,g,L,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(C){this.outputChannel=C,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(C,i,I,c){const p=new L.RipgrepTextSearchEngine(this.outputChannel);if(i.folder.scheme===S.Schemas.userData){const f={...i,folder:i.folder.with({scheme:S.Schemas.file})},w=new D.Progress(_=>I.report({..._,uri:_.uri.with({scheme:i.folder.scheme})}));return this.withToken(c,_=>p.provideTextSearchResults(C,f,w,_))}else return this.withToken(c,f=>p.provideTextSearchResults(C,i,I,f))}async withToken(C,i){const I=k(C);this.inProgress.add(I);const c=await i(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(C=>C.cancel())}}e.RipgrepSearchProvider=A;function k(E){const C=new g.CancellationTokenSource;return E.onCancellationRequested(()=>C.cancel()),C}}),define(fe[286],me([0,1,28,137,136]),function(Y,e,g,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(E){this.query=E}search(E,C,i){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(p){i({message:p})}},c=new D.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((p,f)=>c.search(w=>{C(w.map(A))},E).then(w=>p({limitHit:w.limitHit,type:"success",stats:w.stats}),f))}}e.TextSearchEngineAdapter=S;function A(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((E,C)=>{if(C.ranges){const i=C;return E+(Array.isArray(i.ranges)?i.ranges.length:1)}else return E+1},0)}}}),define(fe[287],me([0,1,15,16,18,3,100,9,46,2,42,32,284,286]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class f{constructor(a="searchProcess"){this.processType=a,this.caches=Object.create(null)}fileSearch(a){let v;const n=P(a),h=new S.Emitter({onFirstListenerDidAdd:()=>{v=(0,L.createCancelablePromise)(r=>this.doFileSearchWithEngine(c.Engine,n,t=>h.fire(t),r)),v.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return h.event}textSearch(a){let v;const n=P(a),h=new S.Emitter({onFirstListenerDidAdd:()=>{v=(0,L.createCancelablePromise)(r=>this.ripgrepTextSearch(n,t=>h.fire(t),r)),v.then(r=>h.fire(r),r=>h.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onLastListenerRemove:()=>{v.cancel()}});return h.event}ripgrepTextSearch(a,v,n){return a.maxFileSize=(0,i.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new p.TextSearchEngineAdapter(a).search(n,v,v)}doFileSearch(a,v,n){return this.doFileSearchWithEngine(c.Engine,a,v,n)}doFileSearchWithEngine(a,v,n,h,r=f.BATCH_SIZE){let t=0;const l=d=>{Array.isArray(d)?(t+=d.length,n(d.map(m=>this.rawMatchToSearchItem(m)))):d.relativePath?(t++,n(this.rawMatchToSearchItem(d))):n(d)};if(v.sortByScore){let d=this.trySortedSearchFromCache(v,l,h);if(!d){const m=v.maxResults?Object.assign({},v,{maxResults:null}):v,u=new a(m);d=this.doSortedSearch(u,v,n,l,h)}return new Promise((m,u)=>{d.then(([y,T])=>{const R=T.map($=>this.rawMatchToSearchItem($));this.sendProgress(R,n,r),m(y)},u)})}const o=new a(v);return this.doSearch(o,l,r,h).then(d=>({limitHit:d.limitHit,type:"success",stats:{detailStats:d.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(a){return{path:a.base?(0,k.join)(a.base,a.relativePath):a.relativePath}}doSortedSearch(a,v,n,h,r){const t=new S.Emitter;let l=(0,L.createCancelablePromise)(d=>{let m=[];const u=y=>{Array.isArray(y)?m=y:(h(y),t.fire(y))};return this.doSearch(a,u,-1,d).then(y=>[y,m])}),o;if(v.cacheKey){o=this.getOrCreateCache(v.cacheKey);const d={promise:l,event:t.event,resolved:!1};o.resultsToSearchCache[v.filePattern||""]=d,l.then(()=>{d.resolved=!0},m=>{delete o.resultsToSearchCache[v.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([d,m])=>{const u=o?o.scorerCache:Object.create(null),y=(typeof v.maxResults!="number"||v.maxResults>0)&&E.StopWatch.create(!1);return this.sortResults(v,m,u,r).then(T=>{const R=y?y.elapsed():-1;return[{type:"success",stats:{detailStats:d.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:v.folderQueries.length,resultCount:T.length},messages:d.messages,limitHit:d.limitHit||typeof v.maxResults=="number"&&m.length>v.maxResults},T]})})}getOrCreateCache(a){const v=this.caches[a];return v||(this.caches[a]=new w)}trySortedSearchFromCache(a,v,n){const h=a.cacheKey&&this.caches[a.cacheKey];if(!h)return;const r=this.getResultsFromCache(h,a.filePattern||"",v,n);if(r)return r.then(([t,l,o])=>{const d=E.StopWatch.create(!1);return this.sortResults(a,l,h.scorerCache,n).then(m=>{const u=d.elapsed(),y={fromCache:!0,detailStats:o,type:this.processType,resultCount:l.length,sortingTime:u};return[{type:"success",limitHit:t.limitHit||typeof a.maxResults=="number"&&l.length>a.maxResults,stats:y},m]})})}sortResults(a,v,n,h){const r=(0,A.prepareQuery)(a.filePattern||""),t=(o,d)=>(0,A.compareItemsByFuzzyScore)(o,d,r,!0,_,n),l=typeof a.maxResults=="number"?a.maxResults:Number.MAX_VALUE;return g.topAsync(v,t,l,1e4,h)}sendProgress(a,v,n){if(n&&n>0)for(let h=0;h<a.length;h+=n)v(a.slice(h,h+n));else v(a)}getResultsFromCache(a,v,n,h){const r=E.StopWatch.create(!1),t=v.indexOf(k.sep)>=0;let l;for(const u in a.resultsToSearchCache)if(v.startsWith(u)){if(t&&u.indexOf(k.sep)<0&&u!=="")continue;const y=a.resultsToSearchCache[u];l={promise:this.preventCancellation(y.promise),event:y.event,resolved:y.resolved};break}if(!l)return null;const o=r.elapsed(),d=E.StopWatch.create(!1),m=l.event(n);return h&&h.onCancellationRequested(()=>{m.dispose()}),l.promise.then(([u,y])=>{if(h&&h.isCancellationRequested)throw(0,D.canceled)();const T=[],R=(0,A.prepareQuery)(v).normalizedLowercase;for(const $ of y)!(0,I.isFilePatternMatch)($,R)||T.push($);return[u,T,{cacheWasResolved:l.resolved,cacheLookupTime:o,cacheFilterTime:d.elapsed(),cacheEntryCount:y.length}]})}doSearch(a,v,n,h){return new Promise((r,t)=>{let l=[];h&&h.onCancellationRequested(()=>a.cancel()),a.search(o=>{o&&(n?(l.push(o),n>0&&l.length>=n&&(v(l),l=[])):v(o))},o=>{v(o)},(o,d)=>{l.length&&v(l),o?t(o):r(d)})})}clearCache(a){return delete this.caches[a],Promise.resolve(void 0)}preventCancellation(a){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(v,n){return a.then(v,n)}catch(v){return this.then(void 0,v)}finally(v){return a.finally(v)}}}}e.SearchService=f,f.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(s){return(0,k.basename)(s.relativePath)}getItemDescription(s){return(0,k.dirname)(s.relativePath)}getItemPath(s){return s.relativePath}};function P(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(b),extraFileResources:s.extraFileResources&&s.extraFileResources.map(a=>C.URI.revive(a))}}function b(s){return{...s,folder:C.URI.revive(s.folder)}}}),define(fe[288],me([0,1,6,10,2,28,11,27,14,74,66,32,287,285,92,136]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let _=class extends C.ExtHostSearch{constructor(b,s,a,v){super(b,a,v);this._pfs=S,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const n=new f.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new p.RipgrepSearchProvider(n)),s.remote.isRemote&&s.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new f.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new p.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,s){const a=this._handlePool++;return this._internalFileSearchProvider=s,this._internalFileSearchHandle=a,this._proxy.$registerFileSearchProvider(a,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(b,s,a,v){const n=(0,C.reviveQuery)(a);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,s,n,v):super.$provideFileSearchResults(b,s,a,v)}doInternalFileSearch(b,s,a,v){const n=h=>{if((0,I.isSerializedFileMatch)(h)&&(h=[h]),Array.isArray(h)){this._proxy.$handleFileMatch(b,s,h.map(r=>D.URI.file(r.path)));return}h.message&&this._logService.debug("ExtHostSearch",h.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(a,n,v)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,s){return new w.NativeTextSearchManager(b,s,void 0,"textSearchProvider")}};_=Ve([$e(0,E.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,i.IURITransformerService),$e(3,A.ILogService)],_),e.NativeExtHostSearch=_}),define(fe[138],me([0,1,300,124,81,22,18,3,6,9,12,31,105,106,301]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(d){this.socket=d,this._errorListener=m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(d){const m=u=>d(S.VSBuffer.wrap(u));return this.socket.on("data",m),{dispose:()=>this.socket.off("data",m)}}onClose(d){const m=u=>{d({type:0,hadError:u,error:void 0})};return this.socket.on("close",m),{dispose:()=>this.socket.off("close",m)}}onEnd(d){return this.socket.on("end",d),{dispose:()=>this.socket.off("end",d)}}write(d){if(!this.socket.destroyed)try{this.socket.write(d.buffer,m=>{if(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}})}catch(m){if(m.code==="EPIPE")return;(0,A.onUnexpectedError)(m)}}end(){this.socket.end()}drain(){return new Promise((d,m)=>{if(this.socket.bufferSize===0){d();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),d()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=w;var _;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(_||(_={}));var P;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(P||(P={}));class b extends E.Disposable{constructor(d,m,u,y){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=d,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=m,this._recordInflateBytes=y,m?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),(0,A.onUnexpectedError)(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(d){return this._onData.event(d)}onClose(d){return this._onClose.event(d)}onEnd(d){return this.socket.onEnd(d)}write(d){this._totalOutgoingDataBytes+=d.byteLength,this._zlibDeflate?(this._zlibDeflate.write(d.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let m=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,m=m.slice(0,m.length-4),this._isEnded||this._write(S.VSBuffer.wrap(m),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(d,!1)}_write(d,m){let u=2;d.byteLength<126?u+=0:d.byteLength<2**16?u+=2:u+=8;const y=S.VSBuffer.alloc(u);if(m?y.writeUInt8(194,0):y.writeUInt8(130,0),d.byteLength<126)y.writeUInt8(d.byteLength,1);else if(d.byteLength<2**16){y.writeUInt8(126,1);let T=1;y.writeUInt8(d.byteLength>>>8&255,++T),y.writeUInt8(d.byteLength>>>0&255,++T)}else{y.writeUInt8(127,1);let T=1;y.writeUInt8(0,++T),y.writeUInt8(0,++T),y.writeUInt8(0,++T),y.writeUInt8(0,++T),y.writeUInt8(d.byteLength>>>24&255,++T),y.writeUInt8(d.byteLength>>>16&255,++T),y.writeUInt8(d.byteLength>>>8&255,++T),y.writeUInt8(d.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=y.byteLength+d.byteLength,this.socket.write(S.VSBuffer.concat([y,d]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(d){if(d.byteLength!==0){for(this._totalIncomingWireBytes+=d.byteLength,this._incomingData.acceptChunk(d);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const m=this._incomingData.peek(this._state.readLen),u=m.readUInt8(0),y=(u&128)>>>7,T=(u&64)>>>6,R=m.readUInt8(1),$=(R&128)>>>7,B=R&127;this._state.state=2,this._state.readLen=2+($?4:0)+(B===126?2:0)+(B===127?8:0),this._state.fin=y,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(T)),this._state.firstFrameOfMessage=Boolean(y),this._state.mask=0}else if(this._state.state===2){const m=this._incomingData.read(this._state.readLen),u=m.readUInt8(1),y=(u&128)>>>7;let T=u&127,R=1;T===126?T=m.readUInt8(++R)*2**8+m.readUInt8(++R):T===127&&(T=m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*0+m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R));let $=0;y&&($=m.readUInt8(++R)*2**24+m.readUInt8(++R)*2**16+m.readUInt8(++R)*2**8+m.readUInt8(++R)),this._state.state=3,this._state.readLen=T,this._state.mask=$}else if(this._state.state===3){const m=this._incomingData.read(this._state.readLen);s(m,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(m.buffer)),this._zlibInflate.write(m.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(S.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=m.byteLength,this._onData.fire(m))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function s(o,d){if(d===0)return;let m=o.byteLength>>>2;for(let B=0;B<m;B++){const F=o.readUInt32BE(B*4);o.writeUInt32BE(F^d,B*4)}let u=m*4,y=o.byteLength-u;const T=d>>>24&255,R=d>>>16&255,$=d>>>8&255;y>=1&&o.writeUInt8(o.readUInt8(u)^T,u),y>=2&&o.writeUInt8(o.readUInt8(u+1)^R,u+1),y>=3&&o.writeUInt8(o.readUInt8(u+2)^$,u+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function v(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let d;return e.XDG_RUNTIME_DIR?d=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):d=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${o}.sock`),h(d),d}e.createRandomIPCHandle=v;function n(o,d,m){const u=(0,g.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${m}-${d}-sock`;let y;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?y=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${m}-${d}.sock`):y=(0,C.join)(o,`${m}-${d}.sock`),h(y),y}e.createStaticIPCHandle=n;function h(o){const d=a[i.platform];typeof d=="number"&&o.length>=d&&console.warn(`WARNING: IPC handle "${o}" is longer than ${d} chars, try a shorter --user-data-dir`)}class r extends c.IPCServer{constructor(d){super(r.toClientConnectionEvent(d));this.server=d}static toClientConnectionEvent(d){const m=k.Event.fromNodeEventEmitter(d,"connection");return k.Event.map(m,u=>({protocol:new p.Protocol(new w(u)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function t(o){return new Promise((d,m)=>{const u=(0,L.createServer)();u.on("error",m),u.listen(o,()=>{u.removeListener("error",m),d(new r(u))})})}e.serve=t;function l(o,d){return new Promise((m,u)=>{const y=(0,L.createConnection)(o,()=>{y.removeListener("error",u),m(p.Client.fromSocket(new w(y),d))});y.once("error",u)})}e.connect=l}),define(fe[289],me([0,1,138,281,62,39,2,200,11]),function(Y,e,g,L,D,S,A,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class C{constructor(c,p,f){this._commands=c,this.logService=p,this._ipcHandlePath=f,this._server=L.createServer((w,_)=>this.onRequest(w,_)),this.setup().catch(w=>(p.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,p){const f=[];c.setEncoding("utf8"),c.on("data",w=>f.push(w)),c.on("end",()=>{const w=JSON.parse(f.join(""));switch(w.type){case"open":this.open(w,p);break;case"openExternal":this.openExternal(w,p);break;case"status":this.getStatus(w,p);break;case"extensionManagement":this.manageExtensions(w,p).catch(this.logService.error);break;default:p.writeHead(404),p.write(`Unknown message type: ${w.type}`,_=>{_&&this.logService.error(_)}),p.end();break}})}open(c,p){let{fileURIs:f,folderURIs:w,forceNewWindow:_,diffMode:P,addMode:b,forceReuseWindow:s,gotoLineMode:a,waitMarkerFilePath:v}=c;const n=[];if(Array.isArray(w))for(const h of w)try{n.push({folderUri:A.URI.parse(h)})}catch(r){}if(Array.isArray(f))for(const h of f)try{(0,k.hasWorkspaceFileExtension)(h)?n.push({workspaceUri:A.URI.parse(h)}):n.push({fileUri:A.URI.parse(h)})}catch(r){}if(n.length){const h=v?A.URI.file(v):void 0,t={forceNewWindow:_,diffMode:P,addMode:b,gotoLineMode:a,forceReuseWindow:s,preferNewWindow:!s&&!h&&!b,waitMarkerFileURI:h};this._commands.executeCommand("_remoteCLI.windowOpen",n,t)}p.writeHead(200),p.end()}async openExternal(c,p){for(const f of c.uris){const w=A.URI.parse(f),_=w.scheme==="file"?w:f;await this._commands.executeCommand("_remoteCLI.openExternal",_)}p.writeHead(200),p.end()}async manageExtensions(c,p){try{const f=P=>P?.map(b=>/\.vsix$/i.test(b)?A.URI.parse(b):b),w={list:c.list,install:f(c.install),uninstall:f(c.uninstall),force:c.force},_=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);p.writeHead(200),p.write(_)}catch(f){p.writeHead(500),p.write(String(f),w=>{w&&this.logService.error(w)})}p.end()}async getStatus(c,p){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");p.writeHead(200),p.write(f),p.end()}catch(f){p.writeHead(500),p.write(String(f),w=>{w&&this.logService.error(w)}),p.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&D.existsSync(this._ipcHandlePath)&&D.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=C;let i=class extends C{constructor(c,p){super(c,p,(0,g.createRandomIPCHandle)())}};i=Ve([$e(0,S.IExtHostCommands),$e(1,E.ILogService)],i),e.CLIServer=i}),define(fe[290],me([0,1,73,277,272,5,280,40,262,2,10,7,289,104]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class f extends D.RequireInterceptor{_installInterceptor(){const P=this,b=Y.__$__nodeRequire("module"),s=b._load;b._load=function(v,n,h){for(let r of P._alternatives){let t=r(v);if(t){v=t;break}}return P._factories.has(v)?P._factories.get(v).load(v,C.URI.file((0,p.realpathSync)(n.filename)),r=>s.apply(this,[r,n,h])):s.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const P=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(E.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const n=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=n.ipcHandlePath}await this._instaService.createInstance(f,P,this._registry).install(),g.mark("code/extHost/didInitAPI");const s=await this._extHostConfiguration.getConfigProvider();await(0,A.connectProxyResolver)(this._extHostWorkspace,s,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const a=process.send,v=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...n)=>n.length===0||!n[0]||n[0].type!=="__$console"?a.apply(process,n):(v.$logExtensionHostMessage(n[0]),!1)}_getEntryPoint(P){return P.main}_loadCommonJSModule(P,b,s){if(b.scheme!==i.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let a=null;s.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{P&&g.mark(`code/extHost/willLoadExtensionCode/${P.value}`),a=Y.__$__nodeRequire(b.fsPath)}catch(v){return Promise.reject(v)}finally{P&&g.mark(`code/extHost/didLoadExtensionCode/${P.value}`),s.codeLoadingStop()}return Promise.resolve(a)}async $setRemoteEnvironment(P){if(!!this._initData.remote.isRemote)for(const b in P){const s=P[b];s===null?delete process.env[b]:process.env[b]=s}}}e.ExtHostExtensionService=w}),define(fe[291],me([0,1,83,265,274,273,288,290,266,56,40,74,72,33,53,69,264,263,11]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(i.IExtHostExtensionService,k.ExtHostExtensionService),(0,g.registerSingleton)(b.ILoggerService,P.ExtHostLoggerService),(0,g.registerSingleton)(w.IExtensionStoragePaths,_.ExtensionStoragePaths),(0,g.registerSingleton)(C.IExtHostDebugService,S.ExtHostDebugService),(0,g.registerSingleton)(I.IExtHostSearch,A.NativeExtHostSearch),(0,g.registerSingleton)(c.IExtHostTask,D.ExtHostTask),(0,g.registerSingleton)(p.IExtHostTerminalService,L.ExtHostTerminalService),(0,g.registerSingleton)(f.IExtHostTunnelService,E.ExtHostTunnelService)}),define(fe[292],me([0,1,124,302,73,18,106,138,193,229,275,22,102,28,104,16,113,278,291]),function(Y,e,g,L,D,S,A,k,E,C,i,I,c,p,f,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const P=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),l=t._load;t._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return l.apply(this,arguments)}})();const b=process.exit.bind(process);function s(t){process.exit=function(l){if(t)b(l);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)}}let a=function(t){b()};function v(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,l)=>{let o=null,d=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,u=3e5,y=new w.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (1)"),m),T=new w.ProcessTimeRunOnceScheduler(()=>a("renderer disconnected for too long (2)"),u);process.on("message",($,B)=>{if($&&$.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from($.initialDataChunk,"base64"));let W;if($.skipWebSocketFrames)W=new k.NodeSocket(B);else{const M=I.VSBuffer.wrap(Buffer.from($.inflateBytes,"base64"));W=new k.WebSocketNodeSocket(new k.NodeSocket(B),$.permessageDeflate,M,!1)}o?(y.cancel(),T.cancel(),o.beginAcceptReconnection(W,F),o.endAcceptReconnection()):(clearTimeout(d),o=new A.PersistentProtocol(W,F),o.onDidDispose(()=>a("renderer disconnected")),t(o),o.onSocketClose(()=>{y.schedule()}))}if($&&$.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;y.isScheduled()&&T.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((l,o)=>{const d=g.createConnection(t,()=>{d.removeListener("error",o),l(new A.PersistentProtocol(new k.NodeSocket(d)))});d.once("error",o),d.on("close",()=>{a("renderer closed the socket")})})}}async function n(){const t=await v();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(l=>{(0,C.isMessageOfType)(l,2)?(this._terminating=!0,a("received terminate message from renderer")):this._onMessage.fire(l)})}send(l){this._terminating||t.send(l)}drain(){return t.drain()}}}function h(t){return new Promise(l=>{const o=t.onMessage(d=>{o.dispose();const m=JSON.parse(d.toString()),u=m.commit,y=E.default.commit;u&&y&&u!==y&&b(55);let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch($){$&&$.code==="EPERM"?(T++,T>=3&&a(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):a(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(m.parentPid)}catch($){(0,S.onUnexpectedError)($)}t.send((0,C.createMessageOfType)(0)),l({protocol:t,initData:m})});t.send((0,C.createMessageOfType)(1))})}async function r(){const t=[];process.on("unhandledRejection",(T,R)=>{t.push(R),setTimeout(()=>{const $=t.indexOf(R);$>=0&&R.catch(B=>{t.splice($,1),(0,S.isPromiseCanceledError)(B)||(console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),T&&(0,S.onUnexpectedError)(T))})},1e3)}),process.on("rejectionHandled",T=>{const R=t.indexOf(T);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(T){(0,S.onUnexpectedError)(T)}),D.mark("code/extHost/willConnectToRenderer");const l=await n();D.mark("code/extHost/didConnectToRenderer");const o=await h(l);D.mark("code/extHost/didWaitForInitData");const{initData:d}=o;s(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=P.useHostProxy!==void 0?P.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,_.boolean)(P.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(R){b(R)}exists(R){return p.Promises.exists(R)}realpath(R){return(0,f.realpath)(R)}};let u=null;if(d.remote.authority&&P.uriTransformerPath)try{const R=Y.__$__nodeRequire(P.uriTransformerPath)(d.remote.authority);u=new c.URITransformer(R)}catch(T){console.error(T)}const y=new i.ExtensionHostMain(o.protocol,d,m,u);a=T=>y.terminate(T)}e.startExtensionHostProcess=r}),define(fe[303],me([0,1,292]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bef4dba21f68bbdb8d9f08fe04b2e1858597722b/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
