/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/files/common/files","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(ne){for(var e=[],u=0,M=ne.length;u<M;u++)e[u]=we[ne[u]];return e};define(we[42],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function u(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=u}),define(we[53],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const u=Object.prototype.hasOwnProperty;function M(t){const _=[];for(let n in t)u.call(t,n)&&_.push(t[n]);return _}e.values=M;function E(t,_){for(let n in t)if(u.call(t,n)&&_({key:n,value:t[n]},function(){delete t[n]})===!1)return}e.forEach=E;function I(t,_){const n=Object.create(null);for(const d of t){const l=_(d);let c=n[l];c||(c=n[l]=[]),c.push(d)}return n}e.groupBy=I;function F(t){const _=Object.create(null);return t&&t.forEach((n,d)=>{_[d]=n}),_}e.fromMap=F;function T(t,_){const n=[],d=[];for(let l of t)_.has(l)||n.push(l);for(let l of _)t.has(l)||d.push(l);return{removed:n,added:d}}e.diffSets=T;function C(t,_){const n=[],d=[];for(let[l,c]of t)_.has(l)||n.push(c);for(let[l,c]of _)t.has(l)||d.push(c);return{removed:n,added:d}}e.diffMaps=C;class P{constructor(){this.map=new Map}add(_,n){let d=this.map.get(_);d||(d=new Set,this.map.set(_,d)),d.add(n)}delete(_,n){const d=this.map.get(_);!d||(d.delete(n),d.size===0&&this.map.delete(_))}forEach(_,n){const d=this.map.get(_);!d||d.forEach(n)}}e.SetMap=P}),define(we[54],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function u(F){return(T,C,P)=>{let t=null,_=null;if(typeof P.value=="function"?(t="value",_=P.value):typeof P.get=="function"&&(t="get",_=P.get),!_)throw new Error("not supported");P[t]=F(_,C)}}e.createDecorator=u;function M(F,T,C){let P=null,t=null;if(typeof C.value=="function"?(P="value",t=C.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(P="get",t=C.get),!t)throw new Error("not supported");const _=`$memoize$${T}`;C[P]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,n)}),this[_]}}e.memoize=M;function E(F,T,C){return u((P,t)=>{const _=`$debounce$${t}`,n=`$debounce$result$${t}`;return function(...d){this[n]||(this[n]=C?C():void 0),clearTimeout(this[_]),T&&(this[n]=T(this[n],...d),d=[this[n]]),this[_]=setTimeout(()=>{P.apply(this,d),this[n]=C?C():void 0},F)}})}e.debounce=E;function I(F,T,C){return u((P,t)=>{const _=`$throttle$timer$${t}`,n=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,l=`$throttle$pending$${t}`;return function(...c){if(this[n]||(this[n]=C?C():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),T&&(this[n]=T(this[n],...c)),this[l])return;const p=this[d]+F;p<=Date.now()?(this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=C?C():void 0):(this[l]=!0,this[_]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),P.apply(this,[this[n]]),this[n]=C?C():void 0},p-Date.now()))}})}e.throttle=I}),define(we[55],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class u{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=u,e.defaultGenerator=new u("id#")}),define(we[102],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var u;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(u=e.ScanError||(e.ScanError={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(r){r.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function F(r,v=!1){let s=0,i=r.length,m="",a=0,g=16,b=0;function h(x){let N=0,j=0;for(;N<x;){const W=r.charCodeAt(s);if(W>=48&&W<=57)j=j*16+W-48;else if(W>=65&&W<=70)j=j*16+W-65+10;else if(W>=97&&W<=102)j=j*16+W-97+10;else break;s++,N++}return N<x&&(j=-1),j}function y(x){s=x,m="",a=0,g=16,b=0}function R(){const x=s;if(r.charCodeAt(s)===48)s++;else for(s++;s<r.length&&P(r.charCodeAt(s));)s++;if(s<r.length&&r.charCodeAt(s)===46)if(s++,s<r.length&&P(r.charCodeAt(s)))for(s++;s<r.length&&P(r.charCodeAt(s));)s++;else return b=3,r.substring(x,s);let N=s;if(s<r.length&&(r.charCodeAt(s)===69||r.charCodeAt(s)===101))if(s++,(s<r.length&&r.charCodeAt(s)===43||r.charCodeAt(s)===45)&&s++,s<r.length&&P(r.charCodeAt(s))){for(s++;s<r.length&&P(r.charCodeAt(s));)s++;N=s}else b=3;return r.substring(x,N)}function A(){let x="",N=s;for(;;){if(s>=i){x+=r.substring(N,s),b=2;break}const j=r.charCodeAt(s);if(j===34){x+=r.substring(N,s),s++;break}if(j===92){if(x+=r.substring(N,s),s++,s>=i){b=2;break}switch(r.charCodeAt(s++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const $=h(4);$>=0?x+=String.fromCharCode($):b=4;break;default:b=5}N=s;continue}if(j>=0&&j<=31)if(C(j)){x+=r.substring(N,s),b=2;break}else b=6;s++}return x}function B(){if(m="",b=0,a=s,s>=i)return a=i,g=17;let x=r.charCodeAt(s);if(T(x)){do s++,m+=String.fromCharCode(x),x=r.charCodeAt(s);while(T(x));return g=15}if(C(x))return s++,m+=String.fromCharCode(x),x===13&&r.charCodeAt(s)===10&&(s++,m+=`
`),g=14;switch(x){case 123:return s++,g=1;case 125:return s++,g=2;case 91:return s++,g=3;case 93:return s++,g=4;case 58:return s++,g=6;case 44:return s++,g=5;case 34:return s++,m=A(),g=10;case 47:const N=s-1;if(r.charCodeAt(s+1)===47){for(s+=2;s<i&&!C(r.charCodeAt(s));)s++;return m=r.substring(N,s),g=12}if(r.charCodeAt(s+1)===42){s+=2;const j=i-1;let W=!1;for(;s<j;){if(r.charCodeAt(s)===42&&r.charCodeAt(s+1)===47){s+=2,W=!0;break}s++}return W||(s++,b=1),m=r.substring(N,s),g=13}return m+=String.fromCharCode(x),s++,g=16;case 45:if(m+=String.fromCharCode(x),s++,s===i||!P(r.charCodeAt(s)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return m+=R(),g=11;default:for(;s<i&&O(x);)s++,x=r.charCodeAt(s);if(a!==s){switch(m=r.substring(a,s),m){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return m+=String.fromCharCode(x),s++,g=16}}function O(x){if(T(x)||C(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function S(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:y,getPosition:()=>s,scan:v?S:B,getToken:()=>g,getTokenValue:()=>m,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>b}}e.createScanner=F;function T(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function P(r){return r>=48&&r<=57}var t;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(t||(t={}));function _(r,v){const s=[],i=new Object;let m;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function b(h,y,R,A){a.value=h,a.offset=y,a.length=R,a.type=A,a.colonOffset=void 0,m=a}try{o(r,{onObjectBegin:(h,y)=>{if(v<=h)throw i;m=void 0,g=v>h,s.push("")},onObjectProperty:(h,y,R)=>{if(v<y||(b(h,y,R,"property"),s[s.length-1]=h,v<=y+R))throw i},onObjectEnd:(h,y)=>{if(v<=h)throw i;m=void 0,s.pop()},onArrayBegin:(h,y)=>{if(v<=h)throw i;m=void 0,s.push(0)},onArrayEnd:(h,y)=>{if(v<=h)throw i;m=void 0,s.pop()},onLiteralValue:(h,y,R)=>{if(v<y||(b(h,y,R,k(h)),v<=y+R))throw i},onSeparator:(h,y,R)=>{if(v<=y)throw i;if(h===":"&&m&&m.type==="property")m.colonOffset=y,g=!1,m=void 0;else if(h===","){const A=s[s.length-1];typeof A=="number"?s[s.length-1]=A+1:(g=!0,s[s.length-1]=""),m=void 0}}})}catch(h){if(h!==i)throw h}return{path:s,previousNode:m,isAtPropertyKey:g,matches:h=>{let y=0;for(let R=0;y<h.length&&R<s.length;R++)if(h[y]===s[R]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.getLocation=_;function n(r,v=[],s=I.DEFAULT){let i=null,m=[];const a=[];function g(h){Array.isArray(m)?m.push(h):i!==null&&(m[i]=h)}return o(r,{onObjectBegin:()=>{const h={};g(h),a.push(m),m=h,i=null},onObjectProperty:h=>{i=h},onObjectEnd:()=>{m=a.pop()},onArrayBegin:()=>{const h=[];g(h),a.push(m),m=h,i=null},onArrayEnd:()=>{m=a.pop()},onLiteralValue:g,onError:(h,y,R)=>{v.push({error:h,offset:y,length:R})}},s),m[0]}e.parse=n;function d(r,v=[],s=I.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(h){i.type==="property"&&(i.length=h-i.offset,i=i.parent)}function a(h){return i.children.push(h),h}o(r,{onObjectBegin:h=>{i=a({type:"object",offset:h,length:-1,parent:i,children:[]})},onObjectProperty:(h,y,R)=>{i=a({type:"property",offset:y,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:h,offset:y,length:R,parent:i})},onObjectEnd:(h,y)=>{i.length=h+y-i.offset,i=i.parent,m(h+y)},onArrayBegin:(h,y)=>{i=a({type:"array",offset:h,length:-1,parent:i,children:[]})},onArrayEnd:(h,y)=>{i.length=h+y-i.offset,i=i.parent,m(h+y)},onLiteralValue:(h,y,R)=>{a({type:k(h),offset:y,length:R,parent:i,value:h}),m(y+R)},onSeparator:(h,y,R)=>{i.type==="property"&&(h===":"?i.colonOffset=y:h===","&&m(y))},onError:(h,y,R)=>{v.push({error:h,offset:y,length:R})}},s);const b=i.children[0];return b&&delete b.parent,b}e.parseTree=d;function l(r,v){if(!r)return;let s=r;for(let i of v)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let m=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===i){s=a.children[1],m=!0;break}if(!m)return}else{const m=i;if(s.type!=="array"||m<0||!Array.isArray(s.children)||m>=s.children.length)return;s=s.children[m]}return s}e.findNodeAtLocation=l;function c(r){if(!r.parent||!r.parent.children)return[];const v=c(r.parent);if(r.parent.type==="property"){const s=r.parent.children[0].value;v.push(s)}else if(r.parent.type==="array"){const s=r.parent.children.indexOf(r);s!==-1&&v.push(s)}return v}e.getNodePath=c;function p(r){switch(r.type){case"array":return r.children.map(p);case"object":const v=Object.create(null);for(let s of r.children){const i=s.children[1];i&&(v[s.children[0].value]=p(i))}return v;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=p;function D(r,v,s=!1){return v>=r.offset&&v<r.offset+r.length||s&&v===r.offset+r.length}e.contains=D;function w(r,v,s=!1){if(D(r,v,s)){const i=r.children;if(Array.isArray(i))for(let m=0;m<i.length&&i[m].offset<=v;m++){const a=w(i[m],v,s);if(a)return a}return r}}e.findNodeAtOffset=w;function o(r,v,s=I.DEFAULT){const i=F(r,!1);function m(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(me){return me?Fe=>me(Fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=m(v.onObjectBegin),b=a(v.onObjectProperty),h=m(v.onObjectEnd),y=m(v.onArrayBegin),R=m(v.onArrayEnd),A=a(v.onLiteralValue),B=a(v.onSeparator),O=m(v.onComment),S=a(v.onError),x=s&&s.disallowComments,N=s&&s.allowTrailingComma;function j(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:x||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(me){case 12:case 13:x?W(10):O();break;case 16:W(1);break;case 15:case 14:break;default:return me}}}function W(me,Fe=[],Ye=[]){if(S(me),Fe.length+Ye.length>0){let Ue=i.getToken();for(;Ue!==17;){if(Fe.indexOf(Ue)!==-1){j();break}else if(Ye.indexOf(Ue)!==-1)break;Ue=j()}}}function $(me){const Fe=i.getTokenValue();return me?A(Fe):b(Fe),j(),!0}function V(){switch(i.getToken()){case 11:let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(W(2),me=0)}catch(Fe){W(2)}A(me);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return j(),!0}function q(){return i.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),i.getToken()===6?(B(":"),j(),pe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function re(){g(),j();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||W(4,[],[]),B(","),j(),i.getToken()===2&&N)break}else me&&W(6,[],[]);q()||W(4,[],[2,5]),me=!0}return h(),i.getToken()!==2?W(7,[2],[]):j(),!0}function ae(){y(),j();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||W(4,[],[]),B(","),j(),i.getToken()===4&&N)break}else me&&W(6,[],[]);pe()||W(4,[],[4,5]),me=!0}return R(),i.getToken()!==4?W(8,[4],[]):j(),!0}function pe(){switch(i.getToken()){case 3:return ae();case 1:return re();case 10:return $(!0);default:return V()}}return j(),i.getToken()===17?s.allowEmptyContent?!0:(W(4,[],[]),!1):pe()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=o;function f(r,v){let s=F(r),i=[],m,a=0,g;do switch(g=s.getPosition(),m=s.scan(),m){case 12:case 13:case 17:a!==g&&i.push(r.substring(a,g)),v!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,v)),a=s.getPosition();break}while(m!==17);return i.join("")}e.stripComments=f;function k(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=k}),define(we[103],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class u{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new u(()=>E(this.getValue()))}}e.Lazy=u}),function(ne,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ne=typeof globalThis!="undefined"?globalThis:ne||self,ne.marked=e())}(this,function(){"use strict";function ne(Ie,ye){for(var De=0;De<ye.length;De++){var Z=ye[De];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(Ie,Z.key,Z)}}function e(Ie,ye,De){return ye&&ne(Ie.prototype,ye),De&&ne(Ie,De),Ie}function u(Ie,ye){if(!!Ie){if(typeof Ie=="string")return M(Ie,ye);var De=Object.prototype.toString.call(Ie).slice(8,-1);if(De==="Object"&&Ie.constructor&&(De=Ie.constructor.name),De==="Map"||De==="Set")return Array.from(Ie);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return M(Ie,ye)}}function M(Ie,ye){(ye==null||ye>Ie.length)&&(ye=Ie.length);for(var De=0,Z=new Array(ye);De<ye;De++)Z[De]=Ie[De];return Z}function E(Ie,ye){var De=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(De)return(De=De.call(Ie)).next.bind(De);if(Array.isArray(Ie)||(De=u(Ie))||ye&&Ie&&typeof Ie.length=="number"){De&&(Ie=De);var Z=0;return function(){return Z>=Ie.length?{done:!0}:{done:!1,value:Ie[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var I={exports:{}};function F(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function T(Ie){I.exports.defaults=Ie}I.exports={defaults:F(),getDefaults:F,changeDefaults:T};var C=/[&<>"']/,P=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return n[ye]};function l(Ie,ye){if(ye){if(C.test(Ie))return Ie.replace(P,d)}else if(t.test(Ie))return Ie.replace(_,d);return Ie}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function p(Ie){return Ie.replace(c,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var D=/(^|[^\[])\^/g;function w(Ie,ye){Ie=Ie.source||Ie,ye=ye||"";var De={replace:function(oe,he){return he=he.source||he,he=he.replace(D,"$1"),Ie=Ie.replace(oe,he),De},getRegex:function(){return new RegExp(Ie,ye)}};return De}var o=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function k(Ie,ye,De){if(Ie){var Z;try{Z=decodeURIComponent(p(De)).replace(o,"").toLowerCase()}catch(oe){return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ye&&!f.test(De)&&(De=m(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(oe){return null}return De}var r={},v=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(Ie,ye){r[" "+Ie]||(v.test(Ie)?r[" "+Ie]=Ie+"/":r[" "+Ie]=h(Ie,"/",!0)),Ie=r[" "+Ie];var De=Ie.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Ie.replace(s,"$1")+ye:ye.charAt(0)==="/"?De?ye:Ie.replace(i,"$1")+ye:Ie+ye}var a={exec:function(){}};function g(Ie){for(var ye=1,De,Z;ye<arguments.length;ye++){De=arguments[ye];for(Z in De)Object.prototype.hasOwnProperty.call(De,Z)&&(Ie[Z]=De[Z])}return Ie}function b(Ie,ye){var De=Ie.replace(/\|/g,function(he,de,ke){for(var Le=!1,Me=de;--Me>=0&&ke[Me]==="\\";)Le=!Le;return Le?"|":" |"}),Z=De.split(/ \|/),oe=0;if(Z[0].trim()||Z.shift(),Z[Z.length-1].trim()||Z.pop(),Z.length>ye)Z.splice(ye);else for(;Z.length<ye;)Z.push("");for(;oe<Z.length;oe++)Z[oe]=Z[oe].trim().replace(/\\\|/g,"|");return Z}function h(Ie,ye,De){var Z=Ie.length;if(Z===0)return"";for(var oe=0;oe<Z;){var he=Ie.charAt(Z-oe-1);if(he===ye&&!De)oe++;else if(he!==ye&&De)oe++;else break}return Ie.substr(0,Z-oe)}function y(Ie,ye){if(Ie.indexOf(ye[1])===-1)return-1;for(var De=Ie.length,Z=0,oe=0;oe<De;oe++)if(Ie[oe]==="\\")oe++;else if(Ie[oe]===ye[0])Z++;else if(Ie[oe]===ye[1]&&(Z--,Z<0))return oe;return-1}function R(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ie,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Ie),ye>>=1,Ie+=Ie;return De+Ie}var B={escape:l,unescape:p,edit:w,cleanUrl:k,resolveUrl:m,noopTest:a,merge:g,splitCells:b,rtrim:h,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:A},O=I.exports.defaults,S=B.rtrim,x=B.splitCells,N=B.escape,j=B.findClosingBracket;function W(Ie,ye,De,Z){var oe=ye.href,he=ye.title?N(ye.title):null,de=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){Z.state.inLink=!0;var ke={type:"link",raw:De,href:oe,title:he,text:de,tokens:Z.inlineTokens(de,[])};return Z.state.inLink=!1,ke}else return{type:"image",raw:De,href:oe,title:he,text:N(de)}}function $(Ie,ye){var De=Ie.match(/^(\s+)(?:```)/);if(De===null)return ye;var Z=De[1];return ye.split(`
`).map(function(oe){var he=oe.match(/^\s+/);if(he===null)return oe;var de=he[0];return de.length>=Z.length?oe.slice(Z.length):oe}).join(`
`)}var V=function(){function Ie(De){this.options=De||O}var ye=Ie.prototype;return ye.space=function(Z){var oe=this.rules.block.newline.exec(Z);if(oe)return oe[0].length>1?{type:"space",raw:oe[0]}:{raw:`
`}},ye.code=function(Z){var oe=this.rules.block.code.exec(Z);if(oe){var he=oe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:oe[0],codeBlockStyle:"indented",text:this.options.pedantic?he:S(he,`
`)}}},ye.fences=function(Z){var oe=this.rules.block.fences.exec(Z);if(oe){var he=oe[0],de=$(he,oe[3]||"");return{type:"code",raw:he,lang:oe[2]?oe[2].trim():oe[2],text:de}}},ye.heading=function(Z){var oe=this.rules.block.heading.exec(Z);if(oe){var he=oe[2].trim();if(/#$/.test(he)){var de=S(he,"#");(this.options.pedantic||!de||/ $/.test(de))&&(he=de.trim())}var ke={type:"heading",raw:oe[0],depth:oe[1].length,text:he,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ye.hr=function(Z){var oe=this.rules.block.hr.exec(Z);if(oe)return{type:"hr",raw:oe[0]}},ye.blockquote=function(Z){var oe=this.rules.block.blockquote.exec(Z);if(oe){var he=oe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:oe[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ye.list=function(Z){var oe=this.rules.block.list.exec(Z);if(oe){var he,de,ke,Le,Me,ze,it,Re,ue,fe,ie=oe[1].trim(),H=ie.length>1,ve={type:"list",raw:"",ordered:H,start:H?+ie.slice(0,-1):"",loose:!1,items:[]};ie=H?"\\d{1,9}\\"+ie.slice(-1):"\\"+ie,this.options.pedantic&&(ie=H?ie:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+ie+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");Z&&!(this.rules.block.hr.test(Z)||!(oe=Ce.exec(Z)));){ue=oe[2].split(`
`),this.options.pedantic?(Le=2,fe=ue[0].trimLeft()):(Le=oe[2].search(/[^ ]/),Le=oe[1].length+(Le>4?1:Le),fe=ue[0].slice(Le-oe[1].length)),ze=!1,he=oe[0],!ue[0]&&/^ *$/.test(ue[1])&&(he=oe[1]+ue.slice(0,2).join(`
`)+`
`,ve.loose=!0,ue=[]);var Ke=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ue.length;Me++){if(Re=ue[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ke.test(Re)){he=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}if(!ze){Re.trim()||(ze=!0),Re.search(/[^ ]/)>=Le?fe+=`
`+Re.slice(Le):fe+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Le||!Re.trim()){fe+=`
`+Re.slice(Le);continue}else{he=oe[1]+ue.slice(0,Me).join(`
`)+`
`;break}}ve.loose||(it?ve.loose=!0:/\n *\n *$/.test(he)&&(it=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(fe),de&&(ke=de[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),ve.items.push({type:"list_item",raw:he,task:!!de,checked:ke,loose:!1,text:fe}),ve.raw+=he,Z=Z.slice(he.length)}ve.items[ve.items.length-1].raw=he.trimRight(),ve.items[ve.items.length-1].text=fe.trimRight(),ve.raw=ve.raw.trimRight();var Ne=ve.items.length;for(Me=0;Me<Ne;Me++)this.lexer.state.top=!1,ve.items[Me].tokens=this.lexer.blockTokens(ve.items[Me].text,[]),ve.items[Me].tokens.some(function(lt){return lt.type==="space"})&&(ve.loose=!0,ve.items[Me].loose=!0);return ve}},ye.html=function(Z){var oe=this.rules.block.html.exec(Z);if(oe){var he={type:"html",raw:oe[0],pre:!this.options.sanitizer&&(oe[1]==="pre"||oe[1]==="script"||oe[1]==="style"),text:oe[0]};return this.options.sanitize&&(he.type="paragraph",he.text=this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]),he.tokens=[],this.lexer.inline(he.text,he.tokens)),he}},ye.def=function(Z){var oe=this.rules.block.def.exec(Z);if(oe){oe[3]&&(oe[3]=oe[3].substring(1,oe[3].length-1));var he=oe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:oe[0],href:oe[2],title:oe[3]}}},ye.table=function(Z){var oe=this.rules.block.table.exec(Z);if(oe){var he={type:"table",header:x(oe[1]).map(function(it){return{text:it}}),align:oe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:oe[3]?oe[3].replace(/\n$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=oe[0];var de=he.align.length,ke,Le,Me,ze;for(ke=0;ke<de;ke++)/^ *-+: *$/.test(he.align[ke])?he.align[ke]="right":/^ *:-+: *$/.test(he.align[ke])?he.align[ke]="center":/^ *:-+ *$/.test(he.align[ke])?he.align[ke]="left":he.align[ke]=null;for(de=he.rows.length,ke=0;ke<de;ke++)he.rows[ke]=x(he.rows[ke],he.header.length).map(function(it){return{text:it}});for(de=he.header.length,Le=0;Le<de;Le++)he.header[Le].tokens=[],this.lexer.inlineTokens(he.header[Le].text,he.header[Le].tokens);for(de=he.rows.length,Le=0;Le<de;Le++)for(ze=he.rows[Le],Me=0;Me<ze.length;Me++)ze[Me].tokens=[],this.lexer.inlineTokens(ze[Me].text,ze[Me].tokens);return he}}},ye.lheading=function(Z){var oe=this.rules.block.lheading.exec(Z);if(oe){var he={type:"heading",raw:oe[0],depth:oe[2].charAt(0)==="="?1:2,text:oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},ye.paragraph=function(Z){var oe=this.rules.block.paragraph.exec(Z);if(oe){var he={type:"paragraph",raw:oe[0],text:oe[1].charAt(oe[1].length-1)===`
`?oe[1].slice(0,-1):oe[1],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},ye.text=function(Z){var oe=this.rules.block.text.exec(Z);if(oe){var he={type:"text",raw:oe[0],text:oe[0],tokens:[]};return this.lexer.inline(he.text,he.tokens),he}},ye.escape=function(Z){var oe=this.rules.inline.escape.exec(Z);if(oe)return{type:"escape",raw:oe[0],text:N(oe[1])}},ye.tag=function(Z){var oe=this.rules.inline.tag.exec(Z);if(oe)return!this.lexer.state.inLink&&/^<a /i.test(oe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(oe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(oe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(oe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:oe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):N(oe[0]):oe[0]}},ye.link=function(Z){var oe=this.rules.inline.link.exec(Z);if(oe){var he=oe[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var de=S(he.slice(0,-1),"\\");if((he.length-de.length)%2==0)return}else{var ke=j(oe[2],"()");if(ke>-1){var Le=oe[0].indexOf("!")===0?5:4,Me=Le+oe[1].length+ke;oe[2]=oe[2].substring(0,ke),oe[0]=oe[0].substring(0,Me).trim(),oe[3]=""}}var ze=oe[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);Re&&(ze=Re[1],it=Re[3])}else it=oe[3]?oe[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(he)?ze=ze.slice(1):ze=ze.slice(1,-1)),W(oe,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},oe[0],this.lexer)}},ye.reflink=function(Z,oe){var he;if((he=this.rules.inline.reflink.exec(Z))||(he=this.rules.inline.nolink.exec(Z))){var de=(he[2]||he[1]).replace(/\s+/g," ");if(de=oe[de.toLowerCase()],!de||!de.href){var ke=he[0].charAt(0);return{type:"text",raw:ke,text:ke}}return W(he,de,he[0],this.lexer)}},ye.emStrong=function(Z,oe,he){he===void 0&&(he="");var de=this.rules.inline.emStrong.lDelim.exec(Z);if(!!de&&!(de[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=de[1]||de[2]||"";if(!ke||ke&&(he===""||this.rules.inline.punctuation.exec(he))){var Le=de[0].length-1,Me,ze,it=Le,Re=0,ue=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ue.lastIndex=0,oe=oe.slice(-1*Z.length+Le);(de=ue.exec(oe))!=null;)if(Me=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Me){if(ze=Me.length,de[3]||de[4]){it+=ze;continue}else if((de[5]||de[6])&&Le%3&&!((Le+ze)%3)){Re+=ze;continue}if(it-=ze,!(it>0)){if(ze=Math.min(ze,ze+it+Re),Math.min(Le,ze)%2){var fe=Z.slice(1,Le+de.index+ze);return{type:"em",raw:Z.slice(0,Le+de.index+ze+1),text:fe,tokens:this.lexer.inlineTokens(fe,[])}}var ie=Z.slice(2,Le+de.index+ze-1);return{type:"strong",raw:Z.slice(0,Le+de.index+ze+1),text:ie,tokens:this.lexer.inlineTokens(ie,[])}}}}}},ye.codespan=function(Z){var oe=this.rules.inline.code.exec(Z);if(oe){var he=oe[2].replace(/\n/g," "),de=/[^ ]/.test(he),ke=/^ /.test(he)&&/ $/.test(he);return de&&ke&&(he=he.substring(1,he.length-1)),he=N(he,!0),{type:"codespan",raw:oe[0],text:he}}},ye.br=function(Z){var oe=this.rules.inline.br.exec(Z);if(oe)return{type:"br",raw:oe[0]}},ye.del=function(Z){var oe=this.rules.inline.del.exec(Z);if(oe)return{type:"del",raw:oe[0],text:oe[2],tokens:this.lexer.inlineTokens(oe[2],[])}},ye.autolink=function(Z,oe){var he=this.rules.inline.autolink.exec(Z);if(he){var de,ke;return he[2]==="@"?(de=N(this.options.mangle?oe(he[1]):he[1]),ke="mailto:"+de):(de=N(he[1]),ke=de),{type:"link",raw:he[0],text:de,href:ke,tokens:[{type:"text",raw:de,text:de}]}}},ye.url=function(Z,oe){var he;if(he=this.rules.inline.url.exec(Z)){var de,ke;if(he[2]==="@")de=N(this.options.mangle?oe(he[0]):he[0]),ke="mailto:"+de;else{var Le;do Le=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(Le!==he[0]);de=N(he[0]),he[1]==="www."?ke="http://"+de:ke=de}return{type:"link",raw:he[0],text:de,href:ke,tokens:[{type:"text",raw:de,text:de}]}}},ye.inlineText=function(Z,oe){var he=this.rules.inline.text.exec(Z);if(he){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):N(he[0]):he[0]:de=N(this.options.smartypants?oe(he[0]):he[0]),{type:"text",raw:he[0],text:de}}},Ie}(),q=B.noopTest,re=B.edit,ae=B.merge,pe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};pe._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,pe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,pe.def=re(pe.def).replace("label",pe._label).replace("title",pe._title).getRegex(),pe.bullet=/(?:[*+-]|\d{1,9}[.)])/,pe.listItemStart=re(/^( *)(bull) */).replace("bull",pe.bullet).getRegex(),pe.list=re(pe.list).replace(/bull/g,pe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+pe.def.source+")").getRegex(),pe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",pe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,pe.html=re(pe.html,"i").replace("comment",pe._comment).replace("tag",pe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),pe.paragraph=re(pe._paragraph).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.blockquote=re(pe.blockquote).replace("paragraph",pe.paragraph).getRegex(),pe.normal=ae({},pe),pe.gfm=ae({},pe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),pe.gfm.table=re(pe.gfm.table).replace("hr",pe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",pe._tag).getRegex(),pe.pedantic=ae({},pe.normal,{html:re(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",pe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:q,paragraph:re(pe.normal._paragraph).replace("hr",pe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",pe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var me={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};me._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",me.punctuation=re(me.punctuation).replace(/punctuation/g,me._punctuation).getRegex(),me.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,me.escapedEmSt=/\\\*|\\_/g,me._comment=re(pe._comment).replace("(?:-->|$)","-->").getRegex(),me.emStrong.lDelim=re(me.emStrong.lDelim).replace(/punct/g,me._punctuation).getRegex(),me.emStrong.rDelimAst=re(me.emStrong.rDelimAst,"g").replace(/punct/g,me._punctuation).getRegex(),me.emStrong.rDelimUnd=re(me.emStrong.rDelimUnd,"g").replace(/punct/g,me._punctuation).getRegex(),me._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,me._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,me._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,me.autolink=re(me.autolink).replace("scheme",me._scheme).replace("email",me._email).getRegex(),me._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,me.tag=re(me.tag).replace("comment",me._comment).replace("attribute",me._attribute).getRegex(),me._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,me._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,me._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,me.link=re(me.link).replace("label",me._label).replace("href",me._href).replace("title",me._title).getRegex(),me.reflink=re(me.reflink).replace("label",me._label).getRegex(),me.reflinkSearch=re(me.reflinkSearch,"g").replace("reflink",me.reflink).replace("nolink",me.nolink).getRegex(),me.normal=ae({},me),me.pedantic=ae({},me.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:re(/^!?\[(label)\]\((.*?)\)/).replace("label",me._label).getRegex(),reflink:re(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",me._label).getRegex()}),me.gfm=ae({},me.normal,{escape:re(me.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),me.gfm.url=re(me.gfm.url,"i").replace("email",me.gfm._extended_email).getRegex(),me.breaks=ae({},me.gfm,{br:re(me.br).replace("{2,}","*").getRegex(),text:re(me.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:pe,inline:me},Ye=V,Ue=I.exports.defaults,Ve=Fe.block,Je=Fe.inline,je=B.repeatString;function Qe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Ie){var ye="",De,Z,oe=Ie.length;for(De=0;De<oe;De++)Z=Ie.charCodeAt(De),Math.random()>.5&&(Z="x"+Z.toString(16)),ye+="&#"+Z+";";return ye}var Q=function(){function Ie(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Ue,this.options.tokenizer=this.options.tokenizer||new Ye,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:Ve.normal,inline:Je.normal};this.options.pedantic?(Z.block=Ve.pedantic,Z.inline=Je.pedantic):this.options.gfm&&(Z.block=Ve.gfm,this.options.breaks?Z.inline=Je.breaks:Z.inline=Je.gfm),this.tokenizer.rules=Z}Ie.lex=function(Z,oe){var he=new Ie(oe);return he.lex(Z)},Ie.lexInline=function(Z,oe){var he=new Ie(oe);return he.inlineTokens(Z)};var ye=Ie.prototype;return ye.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(Z,this.tokens);for(var oe;oe=this.inlineQueue.shift();)this.inlineTokens(oe.src,oe.tokens);return this.tokens},ye.blockTokens=function(Z,oe){var he=this;oe===void 0&&(oe=[]),this.options.pedantic&&(Z=Z.replace(/^ +$/gm,""));for(var de,ke,Le,Me;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(de=it.call({lexer:he},Z,oe))?(Z=Z.substring(de.raw.length),oe.push(de),!0):!1}))){if(de=this.tokenizer.space(Z)){Z=Z.substring(de.raw.length),de.type&&oe.push(de);continue}if(de=this.tokenizer.code(Z)){Z=Z.substring(de.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(de);continue}if(de=this.tokenizer.fences(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.heading(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.hr(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.blockquote(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.list(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.html(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.def(Z)){Z=Z.substring(de.raw.length),ke=oe[oe.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.lheading(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=Z.slice(1),ue=void 0;he.options.extensions.startBlock.forEach(function(fe){ue=fe.call({lexer:this},Re),typeof ue=="number"&&ue>=0&&(it=Math.min(it,ue))}),it<Infinity&&it>=0&&(Le=Z.substring(0,it+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Le))){ke=oe[oe.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(de),Me=Le.length!==Z.length,Z=Z.substring(de.raw.length);continue}if(de=this.tokenizer.text(Z)){Z=Z.substring(de.raw.length),ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+de.raw,ke.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):oe.push(de);continue}if(Z){var ze="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return this.state.top=!0,oe},ye.inline=function(Z,oe){this.inlineQueue.push({src:Z,tokens:oe})},ye.inlineTokens=function(Z,oe){var he=this;oe===void 0&&(oe=[]);var de,ke,Le,Me=Z,ze,it,Re;if(this.tokens.links){var ue=Object.keys(this.tokens.links);if(ue.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ue.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,ze.index)+"["+je("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"["+je("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ie){return(de=ie.call({lexer:he},Z,oe))?(Z=Z.substring(de.raw.length),oe.push(de),!0):!1}))){if(de=this.tokenizer.escape(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.tag(Z)){Z=Z.substring(de.raw.length),ke=oe[oe.length-1],ke&&de.type==="text"&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):oe.push(de);continue}if(de=this.tokenizer.link(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(de.raw.length),ke=oe[oe.length-1],ke&&de.type==="text"&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):oe.push(de);continue}if(de=this.tokenizer.emStrong(Z,Me,Re)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.codespan(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.br(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.del(Z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(de=this.tokenizer.autolink(Z,z)){Z=Z.substring(de.raw.length),oe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(Z,z))){Z=Z.substring(de.raw.length),oe.push(de);continue}if(Le=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var ie=Infinity,H=Z.slice(1),ve=void 0;he.options.extensions.startInline.forEach(function(Ce){ve=Ce.call({lexer:this},H),typeof ve=="number"&&ve>=0&&(ie=Math.min(ie,ve))}),ie<Infinity&&ie>=0&&(Le=Z.substring(0,ie+1))}(),de=this.tokenizer.inlineText(Le,Qe)){Z=Z.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(Re=de.raw.slice(-1)),it=!0,ke=oe[oe.length-1],ke&&ke.type==="text"?(ke.raw+=de.raw,ke.text+=de.text):oe.push(de);continue}if(Z){var fe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(fe);break}else throw new Error(fe)}}return oe},e(Ie,null,[{key:"rules",get:function(){return{block:Ve,inline:Je}}}]),Ie}(),X=I.exports.defaults,se=B.cleanUrl,K=B.escape,te=function(){function Ie(De){this.options=De||X}var ye=Ie.prototype;return ye.code=function(Z,oe,he){var de=(oe||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(Z,de);ke!=null&&ke!==Z&&(he=!0,Z=ke)}return Z=Z.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+K(de,!0)+'">'+(he?Z:K(Z,!0))+`</code></pre>
`:"<pre><code>"+(he?Z:K(Z,!0))+`</code></pre>
`},ye.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ye.html=function(Z){return Z},ye.heading=function(Z,oe,he,de){return this.options.headerIds?"<h"+oe+' id="'+this.options.headerPrefix+de.slug(he)+'">'+Z+"</h"+oe+`>
`:"<h"+oe+">"+Z+"</h"+oe+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(Z,oe,he){var de=oe?"ol":"ul",ke=oe&&he!==1?' start="'+he+'"':"";return"<"+de+ke+`>
`+Z+"</"+de+`>
`},ye.listitem=function(Z){return"<li>"+Z+`</li>
`},ye.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(Z){return"<p>"+Z+`</p>
`},ye.table=function(Z,oe){return oe&&(oe="<tbody>"+oe+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+oe+`</table>
`},ye.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ye.tablecell=function(Z,oe){var he=oe.header?"th":"td",de=oe.align?"<"+he+' align="'+oe.align+'">':"<"+he+">";return de+Z+"</"+he+`>
`},ye.strong=function(Z){return"<strong>"+Z+"</strong>"},ye.em=function(Z){return"<em>"+Z+"</em>"},ye.codespan=function(Z){return"<code>"+Z+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(Z){return"<del>"+Z+"</del>"},ye.link=function(Z,oe,he){if(Z=se(this.options.sanitize,this.options.baseUrl,Z),Z===null)return he;var de='<a href="'+K(Z)+'"';return oe&&(de+=' title="'+oe+'"'),de+=">"+he+"</a>",de},ye.image=function(Z,oe,he){if(Z=se(this.options.sanitize,this.options.baseUrl,Z),Z===null)return he;var de='<img src="'+Z+'" alt="'+he+'"';return oe&&(de+=' title="'+oe+'"'),de+=this.options.xhtml?"/>":">",de},ye.text=function(Z){return Z},Ie}(),ce=function(){function Ie(){}var ye=Ie.prototype;return ye.strong=function(Z){return Z},ye.em=function(Z){return Z},ye.codespan=function(Z){return Z},ye.del=function(Z){return Z},ye.html=function(Z){return Z},ye.text=function(Z){return Z},ye.link=function(Z,oe,he){return""+he},ye.image=function(Z,oe,he){return""+he},ye.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var ye=Ie.prototype;return ye.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(Z,oe){var he=Z,de=0;if(this.seen.hasOwnProperty(he)){de=this.seen[Z];do de++,he=Z+"-"+de;while(this.seen.hasOwnProperty(he))}return oe||(this.seen[Z]=de,this.seen[he]=0),he},ye.slug=function(Z,oe){oe===void 0&&(oe={});var he=this.serialize(Z);return this.getNextSafeSlug(he,oe.dryrun)},Ie}(),Oe=te,We=ce,qe=Pe,et=I.exports.defaults,st=B.unescape,_e=function(){function Ie(De){this.options=De||et,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new qe}Ie.parse=function(Z,oe){var he=new Ie(oe);return he.parse(Z)},Ie.parseInline=function(Z,oe){var he=new Ie(oe);return he.parseInline(Z)};var ye=Ie.prototype;return ye.parse=function(Z,oe){oe===void 0&&(oe=!0);var he="",de,ke,Le,Me,ze,it,Re,ue,fe,ie,H,ve,Ce,Ke,Ne,lt,Et,vt,ut,gt=Z.length;for(de=0;de<gt;de++){if(ie=Z[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ie.type]&&(ut=this.options.extensions.renderers[ie.type].call({parser:this},ie),ut!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ie.type))){he+=ut||"";continue}switch(ie.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(ie.tokens),ie.depth,st(this.parseInline(ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(ie.text,ie.lang,ie.escaped);continue}case"table":{for(ue="",Re="",Me=ie.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(ie.header[ke].tokens),{header:!0,align:ie.align[ke]});for(ue+=this.renderer.tablerow(Re),fe="",Me=ie.rows.length,ke=0;ke<Me;ke++){for(it=ie.rows[ke],Re="",ze=it.length,Le=0;Le<ze;Le++)Re+=this.renderer.tablecell(this.parseInline(it[Le].tokens),{header:!1,align:ie.align[Le]});fe+=this.renderer.tablerow(Re)}he+=this.renderer.table(ue,fe);continue}case"blockquote":{fe=this.parse(ie.tokens),he+=this.renderer.blockquote(fe);continue}case"list":{for(H=ie.ordered,ve=ie.start,Ce=ie.loose,Me=ie.items.length,fe="",ke=0;ke<Me;ke++)Ne=ie.items[ke],lt=Ne.checked,Et=Ne.task,Ke="",Ne.task&&(vt=this.renderer.checkbox(lt),Ce?Ne.tokens.length>0&&Ne.tokens[0].type==="paragraph"?(Ne.tokens[0].text=vt+" "+Ne.tokens[0].text,Ne.tokens[0].tokens&&Ne.tokens[0].tokens.length>0&&Ne.tokens[0].tokens[0].type==="text"&&(Ne.tokens[0].tokens[0].text=vt+" "+Ne.tokens[0].tokens[0].text)):Ne.tokens.unshift({type:"text",text:vt}):Ke+=vt),Ke+=this.parse(Ne.tokens,Ce),fe+=this.renderer.listitem(Ke,Et,lt);he+=this.renderer.list(fe,H,ve);continue}case"html":{he+=this.renderer.html(ie.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(ie.tokens));continue}case"text":{for(fe=ie.tokens?this.parseInline(ie.tokens):ie.text;de+1<gt&&Z[de+1].type==="text";)ie=Z[++de],fe+=`
`+(ie.tokens?this.parseInline(ie.tokens):ie.text);he+=oe?this.renderer.paragraph(fe):fe;continue}default:{var dt='Token with "'+ie.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return he},ye.parseInline=function(Z,oe){oe=oe||this.renderer;var he="",de,ke,Le,Me=Z.length;for(de=0;de<Me;de++){if(ke=Z[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Le=this.options.extensions.renderers[ke.type].call({parser:this},ke),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){he+=Le||"";continue}switch(ke.type){case"escape":{he+=oe.text(ke.text);break}case"html":{he+=oe.html(ke.text);break}case"link":{he+=oe.link(ke.href,ke.title,this.parseInline(ke.tokens,oe));break}case"image":{he+=oe.image(ke.href,ke.title,ke.text);break}case"strong":{he+=oe.strong(this.parseInline(ke.tokens,oe));break}case"em":{he+=oe.em(this.parseInline(ke.tokens,oe));break}case"codespan":{he+=oe.codespan(ke.text);break}case"br":{he+=oe.br();break}case"del":{he+=oe.del(this.parseInline(ke.tokens,oe));break}case"text":{he+=oe.text(ke.text);break}default:{var ze='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return he},Ie}(),nt=Q,G=_e,J=V,ge=te,$e=ce,Ge=Pe,rt=B.merge,ft=B.checkSanitizeDeprecation,ht=B.escape,Dt=I.exports.getDefaults,Tt=I.exports.changeDefaults,It=I.exports.defaults;function Xe(Ie,ye,De){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=rt({},Xe.defaults,ye||{}),ft(ye),De){var Z=ye.highlight,oe;try{oe=nt.lex(Ie,ye)}catch(Le){return De(Le)}var he=function(Me){var ze;if(!Me)try{ye.walkTokens&&Xe.walkTokens(oe,ye.walkTokens),ze=G.parse(oe,ye)}catch(it){Me=it}return ye.highlight=Z,Me?De(Me):De(null,ze)};if(!Z||Z.length<3||(delete ye.highlight,!oe.length))return he();var de=0;Xe.walkTokens(oe,function(Le){Le.type==="code"&&(de++,setTimeout(function(){Z(Le.text,Le.lang,function(Me,ze){if(Me)return he(Me);ze!=null&&ze!==Le.text&&(Le.text=ze,Le.escaped=!0),de--,de===0&&he()})},0))}),de===0&&he();return}try{var ke=nt.lex(Ie,ye);return ye.walkTokens&&Xe.walkTokens(ke,ye.walkTokens),G.parse(ke,ye)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Le.message+"",!0)+"</pre>";throw Le}}Xe.options=Xe.setOptions=function(Ie){return rt(Xe.defaults,Ie),Tt(Xe.defaults),Xe},Xe.getDefaults=Dt,Xe.defaults=It,Xe.use=function(){for(var Ie=this,ye=arguments.length,De=new Array(ye),Z=0;Z<ye;Z++)De[Z]=arguments[Z];var oe=rt.apply(void 0,[{}].concat(De)),he=Xe.defaults.extensions||{renderers:{},childTokens:{}},de;De.forEach(function(ke){if(ke.extensions&&(de=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var ze=he.renderers?he.renderers[Me.name]:null;ze?he.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),ue=0;ue<it;ue++)Re[ue]=arguments[ue];var fe=Me.renderer.apply(this,Re);return fe===!1&&(fe=ze.apply(this,Re)),fe}:he.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Me.level]?he[Me.level].unshift(Me.tokenizer):he[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?he.startBlock?he.startBlock.push(Me.start):he.startBlock=[Me.start]:Me.level==="inline"&&(he.startInline?he.startInline.push(Me.start):he.startInline=[Me.start]))}Me.childTokens&&(he.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Xe.defaults.renderer||new ge,ze=function(ue){var fe=Me[ue];Me[ue]=function(){for(var ie=arguments.length,H=new Array(ie),ve=0;ve<ie;ve++)H[ve]=arguments[ve];var Ce=ke.renderer[ue].apply(Me,H);return Ce===!1&&(Ce=fe.apply(Me,H)),Ce}};for(var it in ke.renderer)ze(it);oe.renderer=Me}(),ke.tokenizer&&function(){var Me=Xe.defaults.tokenizer||new J,ze=function(ue){var fe=Me[ue];Me[ue]=function(){for(var ie=arguments.length,H=new Array(ie),ve=0;ve<ie;ve++)H[ve]=arguments[ve];var Ce=ke.tokenizer[ue].apply(Me,H);return Ce===!1&&(Ce=fe.apply(Me,H)),Ce}};for(var it in ke.tokenizer)ze(it);oe.tokenizer=Me}(),ke.walkTokens){var Le=Xe.defaults.walkTokens;oe.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Le&&Le(Me)}}de&&(oe.extensions=he),Xe.setOptions(oe)})},Xe.walkTokens=function(Ie,ye){for(var De=function(){var de=oe.value;switch(ye(de),de.type){case"table":{for(var ke=E(de.header),Le;!(Le=ke()).done;){var Me=Le.value;Xe.walkTokens(Me.tokens,ye)}for(var ze=E(de.rows),it;!(it=ze()).done;)for(var Re=it.value,ue=E(Re),fe;!(fe=ue()).done;){var ie=fe.value;Xe.walkTokens(ie.tokens,ye)}break}case"list":{Xe.walkTokens(de.items,ye);break}default:Xe.defaults.extensions&&Xe.defaults.extensions.childTokens&&Xe.defaults.extensions.childTokens[de.type]?Xe.defaults.extensions.childTokens[de.type].forEach(function(H){Xe.walkTokens(de[H],ye)}):de.tokens&&Xe.walkTokens(de.tokens,ye)}},Z=E(Ie),oe;!(oe=Z()).done;)De()},Xe.parseInline=function(Ie,ye){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ye=rt({},Xe.defaults,ye||{}),ft(ye);try{var De=nt.lexInline(Ie,ye);return ye.walkTokens&&Xe.walkTokens(De,ye.walkTokens),G.parseInline(De,ye)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ht(Z.message+"",!0)+"</pre>";throw Z}},Xe.Parser=G,Xe.parser=G.parse,Xe.Renderer=ge,Xe.TextRenderer=$e,Xe.Lexer=nt,Xe.lexer=nt.lex,Xe.Tokenizer=J,Xe.Slugger=Ge,Xe.parse=Xe;var pt=Xe;return pt}),define(we[75],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function u(F,T,C){return Math.min(Math.max(F,T),C)}e.clamp=u;function M(F,T){return(T+F%T)%T}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class I{constructor(){this._n=1,this._val=0}update(T){return this._val=this._val+(T-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=I}),function(){function ne(E){const I=[];typeof E=="number"&&I.push("code/timeOrigin",E);function F(C){I.push(C,Date.now())}function T(){const C=[];for(let P=0;P<I.length;P+=2)C.push({name:I[P],startTime:I[P+1]});return C}return{mark:F,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const F of performance.getEntriesByType("mark"))I.push({name:F.name,startTime:Math.round(E+F.startTime)});return I}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function u(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=u(M))}(),define(we[34],be([0,1,3]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new u.Emitter}add(_){const n=this._icons.get(_.id);n?_.description?n.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function I(t,_){return new T(t,_)}e.registerCodicon=I;function F(t){return t?t.replace(/\$\((.*?)\)/g,(_,n)=>` ${n} `).trim():""}e.getCodiconAriaLabel=F;class T{constructor(_,n,d){this.id=_,this.definition=n,this.description=d,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=T;function C(t,_){const n=["codicon","codicon-"+t];return _&&n.push("codicon-modifier-"+_),n}e.getClassNamesArray=C;var P;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+",t.iconNameCharacter="[A-Za-z0-9\\-~]";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function n(c){if(c instanceof T)return["codicon","codicon-"+c.id];const p=_.exec(c.id);if(!p)return n(T.error);let[,D,w]=p;const o=["codicon","codicon-"+D];return w&&o.push("codicon-modifier-"+w.substr(1)),o}t.asClassNameArray=n;function d(c){return n(c).join(" ")}t.asClassName=d;function l(c){return"."+n(c).join(".")}t.asCSSSelector=l})(P=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"})}(T=e.Codicon||(e.Codicon={}))}),define(we[104],be([0,1,16,6]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(o){const f=o;return f?[f.on,f.pause,f.resume,f.destroy].every(k=>typeof k=="function"):!1}e.isReadableStream=E;function I(o){const f=o;return f?E(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=I;function F(o,f){return new T(o,f)}e.newWriteableStream=F;class T{constructor(f,k){this.reducer=f,this.options=k,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(k=>this.pendingWritePromises.push(k))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(k=>k(f))}emitError(f){this.listeners.error.length===0?(0,u.onUnexpectedError)(f):this.listeners.error.slice(0).forEach(k=>k(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,k){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(k),this.resume();break;case"end":this.listeners.end.push(k),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(k),this.state.flowing&&this.flowErrors();break}}removeListener(f,k){if(this.state.destroyed)return;let r;switch(f){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const v=r.indexOf(k);v>=0&&r.splice(v,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const k=[...this.pendingWritePromises];this.pendingWritePromises.length=0,k.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(o,f){const k=[];let r;for(;(r=o.read())!==null;)k.push(r);return f(k)}e.consumeReadable=C;function P(o,f,k){const r=[];let v;for(;(v=o.read())!==null&&r.length<k;)r.push(v);return v===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof v!="undefined"){const s=v;return v=void 0,s}return o.read()}}}e.peekReadable=P;function t(o,f){return new Promise((k,r)=>{const v=[];_(o,{onData:s=>{f&&v.push(s)},onError:s=>{f?r(s):k(void 0)},onEnd:()=>{k(f?f(v):void 0)}})})}e.consumeStream=t;function _(o,f){o.on("error",k=>f.onError(k)),o.on("end",()=>f.onEnd()),o.on("data",k=>f.onData(k))}e.listenStream=_;function n(o,f){return new Promise((k,r)=>{const v=new M.DisposableStore,s=[],i=g=>{if(s.push(g),s.length>f)return v.dispose(),o.pause(),k({stream:o,buffer:s,ended:!1})},m=g=>r(g),a=()=>k({stream:o,buffer:s,ended:!0});v.add((0,M.toDisposable)(()=>o.removeListener("error",m))),o.on("error",m),v.add((0,M.toDisposable)(()=>o.removeListener("end",a))),o.on("end",a),v.add((0,M.toDisposable)(()=>o.removeListener("data",i))),o.on("data",i)})}e.peekStream=n;function d(o,f){const k=F(f);return k.end(o),k}e.toStream=d;function l(){const o=F(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=l;function c(o){let f=!1;return{read:()=>f?null:(f=!0,o)}}e.toReadable=c;function p(o,f,k){const r=F(k);return _(o,{onData:v=>r.write(f.data(v)),onError:v=>r.error(f.error?f.error(v):v),onEnd:()=>r.end()}),r}e.transform=p;function D(o,f,k){let r=!1;return{read:()=>{const v=f.read();return r?v:(r=!0,v!==null?k([o,v]):o)}}}e.prefixedReadable=D;function w(o,f,k){let r=!1;const v=F(k);return _(f,{onData:s=>r?v.write(s):(r=!0,v.write(k([o,s]))),onError:s=>v.error(s),onEnd:()=>{r||(r=!0,v.write(o)),v.end()}}),v}e.prefixedStream=w}),define(we[23],be([0,1,104]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,I;class F{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return M?new F(Buffer.allocUnsafe(i)):new F(new Uint8Array(i))}static wrap(i){return M&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new F(i)}static fromString(i,m){return!(m?.dontUseNodeBuffer||!1)&&M?new F(Buffer.from(i)):(E||(E=new TextEncoder),new F(E.encode(i)))}static concat(i,m){if(typeof m=="undefined"){m=0;for(let b=0,h=i.length;b<h;b++)m+=i[b].byteLength}const a=F.alloc(m);let g=0;for(let b=0,h=i.length;b<h;b++){const y=i[b];a.set(y,g),g+=y.byteLength}return a}toString(){return M?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(i,m){return new F(this.buffer.subarray(i,m))}set(i,m){i instanceof F?this.buffer.set(i.buffer,m):this.buffer.set(i,m)}readUInt32BE(i){return P(this.buffer,i)}writeUInt32BE(i,m){t(this.buffer,i,m)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,m){n(this.buffer,i,m)}readUInt8(i){return d(this.buffer,i)}writeUInt8(i,m){l(this.buffer,i,m)}}e.VSBuffer=F;function T(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0}e.readUInt16LE=T;function C(s,i,m){s[m+0]=i&255,i=i>>>8,s[m+1]=i&255}e.writeUInt16LE=C;function P(s,i){return s[i]*2**24+s[i+1]*2**16+s[i+2]*2**8+s[i+3]}e.readUInt32BE=P;function t(s,i,m){s[m+3]=i,i=i>>>8,s[m+2]=i,i=i>>>8,s[m+1]=i,i=i>>>8,s[m]=i}e.writeUInt32BE=t;function _(s,i){return s[i+0]<<0>>>0|s[i+1]<<8>>>0|s[i+2]<<16>>>0|s[i+3]<<24>>>0}e.readUInt32LE=_;function n(s,i,m){s[m+0]=i&255,i=i>>>8,s[m+1]=i&255,i=i>>>8,s[m+2]=i&255,i=i>>>8,s[m+3]=i&255}e.writeUInt32LE=n;function d(s,i){return s[i]}e.readUInt8=d;function l(s,i,m){s[m]=i}e.writeUInt8=l;function c(s){return u.consumeReadable(s,i=>F.concat(i))}e.readableToBuffer=c;function p(s){return u.toReadable(s)}e.bufferToReadable=p;function D(s){return u.consumeStream(s,i=>F.concat(i))}e.streamToBuffer=D;async function w(s){return s.ended?F.concat(s.buffer):F.concat([...s.buffer,await D(s.stream)])}e.bufferedStreamToBuffer=w;function o(s){return u.toStream(s,i=>F.concat(i))}e.bufferToStream=o;function f(s){return u.transform(s,{data:i=>typeof i=="string"?F.fromString(i):F.wrap(i)},i=>F.concat(i))}e.streamToBufferReadableStream=f;function k(s){return u.newWriteableStream(i=>F.concat(i),s)}e.newWriteableBufferStream=k;function r(s,i){return u.prefixedReadable(s,i,m=>F.concat(m))}e.prefixedBufferReadable=r;function v(s,i){return u.prefixedStream(s,i,m=>F.concat(m))}e.prefixedBufferStream=v});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[20],be([0,1,15,9]),function(ne,e,u,M){"use strict";var E,I,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(s,i,m){let a=s.get(i);return a===void 0&&(a=m,s.set(i,a)),a}e.getOrSet=T;function C(s){const i=[];return s.forEach((m,a)=>{i.push(`${a} => ${m}`)}),`Map(${s.size}) {${i.join(", ")}}`}e.mapToString=C;function P(s){const i=[];return s.forEach(m=>{i.push(m)}),`Set(${s.size}) {${i.join(", ")}}`}e.setToString=P;class t{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const m=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return m-a}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,m=!0){this._splitOnBackslash=i,this._caseSensitive=m}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var d;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(d||(d={}));class l{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,M.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(p||(p={}));class D{constructor(i){this._iter=i}static forUris(i=()=>!1){return new D(new l(i))}static forPaths(){return new D(new n)}static forStrings(){return new D(new t)}static forConfigKeys(){return new D(new _)}clear(){this._root=void 0}fill(i,m){if(m){const a=m.slice(0);(0,u.shuffle)(a);for(let g of a)this.set(g,i)}else{const a=i.slice(0);(0,u.shuffle)(a);for(let g of a)this.set(g[0],g[1])}}set(i,m){const a=this._iter.reset(i);let g;this._root||(this._root=new c,this._root.segment=a.value());const b=[];for(g=this._root;;){const y=a.cmp(g.segment);if(y>0)g.left||(g.left=new c,g.left.segment=a.value()),b.push([-1,g]),g=g.left;else if(y<0)g.right||(g.right=new c,g.right.segment=a.value()),b.push([1,g]),g=g.right;else if(a.hasNext())a.next(),g.mid||(g.mid=new c,g.mid.segment=a.value()),b.push([0,g]),g=g.mid;else break}const h=g.value;g.value=m,g.key=i;for(let y=b.length-1;y>=0;y--){const R=b[y][1];R.updateHeight();const A=R.balanceFactor();if(A<-1||A>1){const B=b[y][0],O=b[y+1][0];if(B===1&&O===1)b[y][1]=R.rotateLeft();else if(B===-1&&O===-1)b[y][1]=R.rotateRight();else if(B===1&&O===-1)R.right=b[y+1][1]=b[y+1][1].rotateRight(),b[y][1]=R.rotateLeft();else if(B===-1&&O===1)R.left=b[y+1][1]=b[y+1][1].rotateLeft(),b[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(b[y-1][0]){case-1:b[y-1][1].left=b[y][1];break;case 1:b[y-1][1].right=b[y][1];break;case 0:b[y-1][1].mid=b[y][1];break}else this._root=b[0][1]}}return h}get(i){return this._getNode(i)?.value}_getNode(i){const m=this._iter.reset(i);let a=this._root;for(;a;){const g=m.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else break}return a}has(i){const m=this._getNode(i);return!(m?.value===void 0&&m?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,m){const a=this._iter.reset(i),g=[];let b=this._root;for(;b;){const h=a.cmp(b.segment);if(h>0)g.push([-1,b]),b=b.left;else if(h<0)g.push([1,b]),b=b.right;else if(a.hasNext())a.next(),g.push([0,b]),b=b.mid;else break}if(!!b){if(m?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const h=this._min(b.right),{key:y,value:R,segment:A}=h;this._delete(h.key,!1),b.key=y,b.value=R,b.segment=A}else{const h=b.left??b.right;if(g.length>0){const[y,R]=g[g.length-1];switch(y){case-1:R.left=h;break;case 0:R.mid=h;break;case 1:R.right=h;break}}else this._root=h}for(let h=g.length-1;h>=0;h--){const y=g[h][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=g[h+1][1]=g[h+1][1].rotateRight()),g[h][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=g[h+1][1]=g[h+1][1].rotateLeft()),g[h][1]=y.rotateRight()),h>0)switch(g[h-1][0]){case-1:g[h-1][1].left=g[h][1];break;case 1:g[h-1][1].right=g[h][1];break;case 0:g[h-1][1].mid=g[h][1];break}else this._root=g[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const m=this._iter.reset(i);let a=this._root,g;for(;a;){const b=m.cmp(a.segment);if(b>0)a=a.left;else if(b<0)a=a.right;else if(m.hasNext())m.next(),g=a.value||g,a=a.mid;else break}return a&&a.value||g}findSuperstr(i){const m=this._iter.reset(i);let a=this._root;for(;a;){const g=m.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(m.hasNext())m.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[m,a]of this)i(a,m)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=m=>{if(!m)return!0;const a=m.balanceFactor();return a<-1||a>1?!1:i(m.left)&&i(m.right)};return i(this._root)}}e.TernarySearchTree=D;class w{constructor(i,m){this.uri=i,this.value=m}}class o{constructor(i,m){this[E]="ResourceMap",i instanceof o?(this.map=new Map(i.map),this.toKey=m??o.defaultToKey):(this.map=new Map,this.toKey=i??o.defaultToKey)}set(i,m){return this.map.set(this.toKey(i),new w(i,m)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,m){typeof m!="undefined"&&(i=i.bind(m));for(let[a,g]of this.map)i(g.value,g.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=o,o.defaultToKey=s=>s.toString();var f;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(f=e.Touch||(e.Touch={}));class k{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,m=0){const a=this._map.get(i);if(!!a)return m!==0&&this.touch(a,m),a.value}set(i,m,a=0){let g=this._map.get(i);if(g)g.value=m,a!==0&&this.touch(g,a);else{switch(g={key:i,value:m,next:void 0,previous:void 0},a){case 0:this.addItemLast(g);break;case 1:this.addItemFirst(g);break;case 2:this.addItemLast(g);break;default:this.addItemLast(g);break}this._map.set(i,g),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const m=this._map.get(i);if(!!m)return this._map.delete(i),this.removeItem(m),this._size--,m.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,m){const a=this._state;let g=this._head;for(;g;){if(m?i.bind(m)(g.value,g.key,this):i(g.value,g.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const i=this,m=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.key,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return g}values(){const i=this,m=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:a.value,done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return g}entries(){const i=this,m=this._state;let a=this._head;const g={[Symbol.iterator](){return g},next(){if(i._state!==m)throw new Error("LinkedMap got modified during iteration.");if(a){const b={value:[a.key,a.value],done:!1};return a=a.next,b}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let m=this._head,a=this.size;for(;m&&a>i;)this._map.delete(m.key),m=m.next,a--;this._head=m,this._size=a,m&&(m.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const m=i.next,a=i.previous;if(!m||!a)throw new Error("Invalid list");m.previous=a,a.next=m}i.next=void 0,i.previous=void 0,this._state++}touch(i,m){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(m!==1&&m!==2)){if(m===1){if(i===this._head)return;const a=i.next,g=i.previous;i===this._tail?(g.next=void 0,this._tail=g):(a.previous=g,g.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(m===2){if(i===this._tail)return;const a=i.next,g=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=g,g.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((m,a)=>{i.push([a,m])}),i}fromJSON(i){this.clear();for(const[m,a]of i)this.set(m,a)}}e.LinkedMap=k;class r extends k{constructor(i,m=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,m),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,m=2){return super.get(i,m)}peek(i){return super.get(i,0)}set(i,m){return super.set(i,m,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class v{constructor(i){F.set(this,void 0),Ze(this,F,i,"f")}get size(){return Te(this,F,"f").size}forEach(i,m){Te(this,F,"f").forEach(i,m)}get(i){return Te(this,F,"f").get(i)}has(i){return Te(this,F,"f").has(i)}entries(){return Te(this,F,"f").entries()}keys(){return Te(this,F,"f").keys()}values(){return Te(this,F,"f").values()}[(F=new WeakMap,Symbol.iterator)](){return Te(this,F,"f").entries()}}e.ReadonlyMapView=v}),define(we[105],be([0,1,20,9]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...K){return function(te,ce){for(let Pe=0,Oe=K.length;Pe<Oe;Pe++){const We=K[Pe](te,ce);if(We)return We}return null}}e.or=E,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(K,te,ce){if(!ce||ce.length<te.length)return null;let Pe;return K?Pe=M.startsWithIgnoreCase(ce,te):Pe=ce.indexOf(te)===0,Pe?te.length>0?[{start:0,end:te.length}]:[]:null}function F(K,te){const ce=te.toLowerCase().indexOf(K.toLowerCase());return ce===-1?null:[{start:ce,end:ce+K.length}]}e.matchesContiguousSubString=F;function T(K,te){return C(K.toLowerCase(),te.toLowerCase(),0,0)}e.matchesSubString=T;function C(K,te,ce,Pe){if(ce===K.length)return[];if(Pe===te.length)return null;if(K[ce]===te[Pe]){let Oe=null;return(Oe=C(K,te,ce+1,Pe+1))?D({start:Pe,end:Pe+1},Oe):null}return C(K,te,ce,Pe+1)}function P(K){return 97<=K&&K<=122}function t(K){return 65<=K&&K<=90}e.isUpper=t;function _(K){return 48<=K&&K<=57}function n(K){return K===32||K===9||K===10||K===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(K=>d.add(K.charCodeAt(0)));function l(K){return n(K)||d.has(K)}function c(K,te){return K===te||l(K)&&l(te)}function p(K){return P(K)||t(K)||_(K)}function D(K,te){return te.length===0?te=[K]:K.end===te[0].start?te[0].start=K.start:te.unshift(K),te}function w(K,te){for(let ce=te;ce<K.length;ce++){const Pe=K.charCodeAt(ce);if(t(Pe)||_(Pe)||ce>0&&!p(K.charCodeAt(ce-1)))return ce}return K.length}function o(K,te,ce,Pe){if(ce===K.length)return[];if(Pe===te.length)return null;if(K[ce]!==te[Pe].toLowerCase())return null;{let Oe=null,We=Pe+1;for(Oe=o(K,te,ce+1,Pe+1);!Oe&&(We=w(te,We))<te.length;)Oe=o(K,te,ce+1,We),We++;return Oe===null?null:D({start:Pe,end:Pe+1},Oe)}}function f(K){let te=0,ce=0,Pe=0,Oe=0,We=0;for(let nt=0;nt<K.length;nt++)We=K.charCodeAt(nt),t(We)&&te++,P(We)&&ce++,p(We)&&Pe++,_(We)&&Oe++;const qe=te/K.length,et=ce/K.length,st=Pe/K.length,_e=Oe/K.length;return{upperPercent:qe,lowerPercent:et,alphaPercent:st,numericPercent:_e}}function k(K){const{upperPercent:te,lowerPercent:ce}=K;return ce===0&&te>.6}function r(K){const{upperPercent:te,lowerPercent:ce,alphaPercent:Pe,numericPercent:Oe}=K;return ce>.2&&te<.8&&Pe>.6&&Oe<.2}function v(K){let te=0,ce=0,Pe=0,Oe=0;for(let We=0;We<K.length;We++)Pe=K.charCodeAt(We),t(Pe)&&te++,P(Pe)&&ce++,n(Pe)&&Oe++;return(te===0||ce===0)&&Oe===0?K.length<=30:te<=5}function s(K,te){if(!te||(te=te.trim(),te.length===0)||!v(K)||te.length>60)return null;const ce=f(te);if(!r(ce)){if(!k(ce))return null;te=te.toLowerCase()}let Pe=null,Oe=0;for(K=K.toLowerCase();Oe<te.length&&(Pe=o(K,te,0,Oe))===null;)Oe=w(te,Oe+1);return Pe}e.matchesCamelCase=s;function i(K,te,ce=!1){if(!te||te.length===0)return null;let Pe=null,Oe=0;for(K=K.toLowerCase(),te=te.toLowerCase();Oe<te.length&&(Pe=m(K,te,0,Oe,ce))===null;)Oe=a(te,Oe+1);return Pe}e.matchesWords=i;function m(K,te,ce,Pe,Oe){if(ce===K.length)return[];if(Pe===te.length)return null;if(c(K.charCodeAt(ce),te.charCodeAt(Pe))){let We=null,qe=Pe+1;if(We=m(K,te,ce+1,Pe+1,Oe),!Oe)for(;!We&&(qe=a(te,qe))<te.length;)We=m(K,te,ce+1,qe,Oe),qe++;return We===null?null:D({start:Pe,end:Pe+1},We)}else return null}function a(K,te){for(let ce=te;ce<K.length;ce++)if(l(K.charCodeAt(ce))||ce>0&&l(K.charCodeAt(ce-1)))return ce;return K.length}const g=E(e.matchesPrefix,s,F),b=E(e.matchesPrefix,s,T),h=new u.LRUCache(1e4);function y(K,te,ce=!1){if(typeof K!="string"||typeof te!="string")return null;let Pe=h.get(K);Pe||(Pe=new RegExp(M.convertSimple2RegExpPattern(K),"i"),h.set(K,Pe));const Oe=Pe.exec(te);return Oe?[{start:Oe.index,end:Oe.index+Oe[0].length}]:ce?b(K,te):g(K,te)}e.matchesFuzzy=y;function R(K,te){const ce=Je(K,K.toLowerCase(),0,te,te.toLowerCase(),0,!0);return ce?B(ce):null}e.matchesFuzzy2=R;function A(K,te,ce,Pe,Oe,We){const qe=Math.min(13,K.length);for(;ce<qe;ce++){const et=Je(K,te,ce,Pe,Oe,We,!1);if(et)return et}return[0,We]}e.anyScore=A;function B(K){if(typeof K=="undefined")return[];const te=[],ce=K[1];for(let Pe=K.length-1;Pe>1;Pe--){const Oe=K[Pe]+ce,We=te[te.length-1];We&&We.end===Oe?We.end=Oe+1:te.push({start:Oe,end:Oe+1})}return te}e.createMatches=B;const O=128;function S(){const K=[],te=[];for(let ce=0;ce<=O;ce++)te[ce]=0;for(let ce=0;ce<=O;ce++)K.push(te.slice(0));return K}function x(K){const te=[];for(let ce=0;ce<=K;ce++)te[ce]=0;return te}const N=x(2*O),j=x(2*O),W=S(),$=S(),V=S(),q=!1;function re(K,te,ce,Pe,Oe){function We(et,st,_e=" "){for(;et.length<st;)et=_e+et;return et}let qe=` |   |${Pe.split("").map(et=>We(et,3)).join("|")}
`;for(let et=0;et<=ce;et++)et===0?qe+=" |":qe+=`${te[et-1]}|`,qe+=K[et].slice(0,Oe+1).map(st=>We(st.toString(),3)).join("|")+`
`;return qe}function ae(K,te,ce,Pe){K=K.substr(te),ce=ce.substr(Pe),console.log(re($,K,K.length,ce,ce.length)),console.log(re(V,K,K.length,ce,ce.length)),console.log(re(W,K,K.length,ce,ce.length))}function pe(K,te){if(te<0||te>=K.length)return!1;const ce=K.codePointAt(te);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(ce)}}function me(K,te){if(te<0||te>=K.length)return!1;switch(K.charCodeAt(te)){case 32:case 9:return!0;default:return!1}}function Fe(K,te,ce){return te[K]!==ce[K]}function Ye(K,te,ce,Pe,Oe,We,qe=!1){for(;te<ce&&Oe<We;)K[te]===Pe[Oe]&&(qe&&(N[te]=Oe),te+=1),Oe+=1;return te===ce}e.isPatternInWord=Ye;var Ue;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Ue||(Ue={}));var Ve;(function(K){K.Default=[-100,0];function te(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}K.isDefault=te})(Ve=e.FuzzyScore||(e.FuzzyScore={}));function Je(K,te,ce,Pe,Oe,We,qe){const et=K.length>O?O:K.length,st=Pe.length>O?O:Pe.length;if(ce>=et||We>=st||et-ce>st-We||!Ye(te,ce,et,Oe,We,st,!0))return;je(et,st,ce,We,te,Oe);let _e=1,nt=1,G=ce,J=We;const ge=[!1];for(_e=1,G=ce;G<et;_e++,G++){const ht=N[G],Dt=j[G],Tt=G+1<et?j[G+1]:st;for(nt=ht-We+1,J=ht;J<Tt;nt++,J++){let It=Number.MIN_SAFE_INTEGER,Xe=!1;J<=Dt&&(It=Qe(K,te,G,ce,Pe,Oe,J,st,We,W[_e-1][nt-1]===0,ge));let pt=0;It!==Number.MAX_SAFE_INTEGER&&(Xe=!0,pt=It+$[_e-1][nt-1]);const Ie=J>ht,ye=Ie?$[_e][nt-1]+(W[_e][nt-1]>0?-5:0):0,De=J>ht+1&&W[_e][nt-1]>0,Z=De?$[_e][nt-2]+(W[_e][nt-2]>0?-5:0):0;if(De&&(!Ie||Z>=ye)&&(!Xe||Z>=pt))$[_e][nt]=Z,V[_e][nt]=3,W[_e][nt]=0;else if(Ie&&(!Xe||ye>=pt))$[_e][nt]=ye,V[_e][nt]=2,W[_e][nt]=0;else if(Xe)$[_e][nt]=pt,V[_e][nt]=1,W[_e][nt]=W[_e-1][nt-1]+1;else throw new Error("not possible")}}if(q&&ae(K,ce,Pe,We),!ge[0]&&!qe)return;_e--,nt--;const $e=[$[_e][nt],We];let Ge=0,rt=0;for(;_e>=1;){let ht=nt;do{const Dt=V[_e][ht];if(Dt===3)ht=ht-2;else if(Dt===2)ht=ht-1;else break}while(ht>=1);Ge>1&&te[ce+_e-1]===Oe[We+nt-1]&&!Fe(ht+We-1,Pe,Oe)&&Ge+1>W[_e][ht]&&(ht=nt),ht===nt?Ge++:Ge=1,rt||(rt=ht),_e--,nt=ht-1,$e.push(nt)}st===et&&($e[0]+=2);const ft=rt-et;return $e[0]-=ft,$e}e.fuzzyScore=Je;function je(K,te,ce,Pe,Oe,We){let qe=K-1,et=te-1;for(;qe>=ce&&et>=Pe;)Oe[qe]===We[et]&&(j[qe]=et,qe--),et--}function Qe(K,te,ce,Pe,Oe,We,qe,et,st,_e,nt){if(te[ce]!==We[qe])return Number.MIN_SAFE_INTEGER;let G=1,J=!1;return qe===ce-Pe?G=K[ce]===Oe[qe]?7:5:Fe(qe,Oe,We)&&(qe===0||!Fe(qe-1,Oe,We))?(G=K[ce]===Oe[qe]?7:5,J=!0):pe(We,qe)&&(qe===0||!pe(We,qe-1))?G=5:(pe(We,qe-1)||me(We,qe-1))&&(G=5,J=!0),G>1&&ce===Pe&&(nt[0]=!0),J||(J=Fe(qe,Oe,We)||pe(We,qe-1)||me(We,qe-1)),ce===Pe?qe>st&&(G-=J?3:5):_e?G+=J?2:0:G+=J?0:1,qe+1===et&&(G-=J?3:5),G}function z(K,te,ce,Pe,Oe,We,qe){return X(K,te,ce,Pe,Oe,We,!0,qe)}e.fuzzyScoreGracefulAggressive=z;function Q(K,te,ce,Pe,Oe,We,qe){return X(K,te,ce,Pe,Oe,We,!1,qe)}e.fuzzyScoreGraceful=Q;function X(K,te,ce,Pe,Oe,We,qe,et){let st=Je(K,te,ce,Pe,Oe,We,et);if(st&&!qe)return st;if(K.length>=3){const _e=Math.min(7,K.length-1);for(let nt=ce+1;nt<_e;nt++){const G=se(K,nt);if(G){const J=Je(G,G.toLowerCase(),ce,Pe,Oe,We,et);J&&(J[0]-=3,(!st||J[0]>st[0])&&(st=J))}}}return st}function se(K,te){if(te+1>=K.length)return;const ce=K[te],Pe=K[te+1];if(ce!==Pe)return K.slice(0,te)+Pe+ce+K.slice(te+2)}}),define(we[106],be([0,1,34,105,9]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const I=new RegExp(`\\$\\(${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?\\)`,"g"),F=new RegExp(u.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${I.source}`,"g");function C(p){return p.replace(T,(D,w)=>w?D:`\\${D}`)}e.escapeIcons=C;const P=new RegExp(`\\\\${I.source}`,"g");function t(p){return p.replace(P,D=>`\\${D}`)}e.markdownEscapeEscapedIcons=t;const _=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function n(p){return p.indexOf(e.iconStartMarker)===-1?p:p.replace(_,(D,w,o,f)=>o?D:w||f||"")}e.stripIcons=n;function d(p){const D=p.indexOf(e.iconStartMarker);return D===-1?{text:p}:l(p,D)}e.parseLabelWithIcons=d;function l(p,D){const w=[];let o="";function f(g){if(g){o+=g;for(const b of g)w.push(v)}}let k=-1,r="",v=0,s,i,m=D;const a=p.length;for(f(p.substr(0,D));m<a;)s=p[m],i=p[m+1],s===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(k=m,f(r),r=e.iconStartMarker,m++):s===")"&&k!==-1?(v+=m-k+1,k=-1,r=""):k!==-1?F.test(s)?r+=s:(f(r),k=-1,r=""):f(s),m++;return f(r),{text:o,iconOffsets:w}}function c(p,D,w=!1){const{text:o,iconOffsets:f}=D;if(!f||f.length===0)return(0,M.matchesFuzzy)(p,o,w);const k=(0,E.ltrim)(o," "),r=o.length-k.length,v=(0,M.matchesFuzzy)(p,k,w);if(v)for(const s of v){const i=f[s.start+r]+r;s.start+=i,s.end+=i}return v}e.matchesFuzzyIconAware=c}),define(we[76],be([0,1,16,106]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class I{constructor(d="",l=!1){if(this.value=d,typeof this.value!="string")throw(0,u.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(d,l=0){return this.value+=P(this.supportThemeIcons?(0,M.escapeIcons)(d):d).replace(/([ \t]+)/g,(c,p)=>"&nbsp;".repeat(p.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,l){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=I;function F(n){return T(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function T(n){return n instanceof I?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function C(n,d){return n===d?!0:!n||!d?!1:n.value===d.value&&n.isTrusted===d.isTrusted&&n.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=C;function P(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=P;function t(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(n){const d=[],l=n.split("|").map(p=>p.trim());n=l[0];const c=l[1];if(c){const p=/height=(\d+)/.exec(c),D=/width=(\d+)/.exec(c),w=p?p[1]:"",o=D?D[1]:"",f=isFinite(parseInt(o)),k=isFinite(parseInt(w));f&&d.push(`width="${o}"`),k&&d.push(`height="${w}"`)}return{href:n,dimensions:d}}e.parseHrefAndDimensions=_}),define(we[35],be([0,1,9]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const I="error",F="warning",T="warn",C="info",P="ignore";function t(n){return n?u.equalsIgnoreCase(I,n)?E.Error:u.equalsIgnoreCase(F,n)||u.equalsIgnoreCase(T,n)?E.Warning:u.equalsIgnoreCase(C,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(n){switch(n){case E.Error:return I;case E.Warning:return F;case E.Info:return C;default:return P}}E.toString=_}(M||(M={})),e.default=M}),define(we[43],be([0,1,17,26,9,10]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function F(s){return s===47||s===92}e.isPathSeparator=F;function T(s){return s.replace(/[\\/]/g,u.posix.sep)}e.toSlashes=T;function C(s){return s.indexOf("/")===-1&&(s=T(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function P(s,i=u.posix.sep){if(!s)return"";const m=s.length,a=s.charCodeAt(0);if(F(a)){if(F(s.charCodeAt(1))&&!F(s.charCodeAt(2))){let b=3;const h=b;for(;b<m&&!F(s.charCodeAt(b));b++);if(h!==b&&!F(s.charCodeAt(b+1))){for(b+=1;b<m;b++)if(F(s.charCodeAt(b)))return s.slice(0,b+1).replace(/[\\/]/g,i)}}return i}else if(D(a)&&s.charCodeAt(1)===58)return F(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let g=s.indexOf("://");if(g!==-1){for(g+=3;g<m;g++)if(F(s.charCodeAt(g)))return s.slice(0,g+1)}return""}e.getRoot=P;function t(s){if(!M.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let m=2;const a=m;for(;m<s.length&&(i=s.charCodeAt(m),i!==92);m++);return!(a===m||(i=s.charCodeAt(m+1),isNaN(i)||i===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(s,i=M.isWindows){const m=i?_:n;return!(!s||s.length===0||/^\s+$/.test(s)||(m.lastIndex=0,m.test(s))||i&&d.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=l;function c(s,i,m){const a=s===i;return!m||a?a:!s||!i?!1:(0,E.equalsIgnoreCase)(s,i)}e.isEqual=c;function p(s,i,m,a=u.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(m){if(!(0,E.startsWithIgnoreCase)(s,i))return!1;if(i.length===s.length)return!0;let b=i.length;return i.charAt(i.length-1)===a&&b--,s.charAt(b)===a}return i.charAt(i.length-1)!==a&&(i+=a),s.indexOf(i)===0}e.isEqualOrParent=p;function D(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=D;function w(s,i){return M.isWindows&&s.endsWith(":")&&(s+=u.sep),(0,u.isAbsolute)(s)||(s=(0,u.join)(i,s)),s=(0,u.normalize)(s),M.isWindows?(s=(0,E.rtrim)(s,u.sep),s.endsWith(":")&&(s+=u.sep)):(s=(0,E.rtrim)(s,u.sep),s||(s=u.sep)),s}e.sanitizeFilePath=w;function o(s){const i=(0,u.normalize)(s);return M.isWindows?s.length>3?!1:f(i)&&(s.length===2||i.charCodeAt(2)===92):i===u.posix.sep}e.isRootOrDriveLetter=o;function f(s,i){return(i!==void 0?i:M.isWindows)?D(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function k(s){return f(s)?s[0]:void 0}e.getDriveLetter=k;function r(s,i,m){return i.length>s.length?-1:s===i?0:(m&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=r;function v(s){const i=s.split(":");let m,a,g;if(i.forEach(b=>{const h=Number(b);(0,I.isNumber)(h)?a===void 0?a=h:g===void 0&&(g=h):m=m?[m,b].join(":"):b}),!m)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:m,line:a!==void 0?a:void 0,column:g!==void 0?g:a!==void 0?1:void 0}}e.parseLineAndColumnAware=v}),define(we[24],be([0,1,10]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.keys(c).forEach(D=>{c[D]&&typeof c[D]=="object"?p[D]=M(c[D]):p[D]=c[D]}),p}e.deepClone=M;function E(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const D=p.shift();Object.freeze(D);for(const w in D)if(I.call(D,w)){const o=D[w];typeof o=="object"&&!Object.isFrozen(o)&&p.push(o)}}return c}e.deepFreeze=E;const I=Object.prototype.hasOwnProperty;function F(c,p){return T(c,p,new Set)}e.cloneAndChange=F;function T(c,p,D){if((0,u.isUndefinedOrNull)(c))return c;const w=p(c);if(typeof w!="undefined")return w;if((0,u.isArray)(c)){const o=[];for(const f of c)o.push(T(f,p,D));return o}if((0,u.isObject)(c)){if(D.has(c))throw new Error("Cannot clone recursive data-structure");D.add(c);const o={};for(let f in c)I.call(c,f)&&(o[f]=T(c[f],p,D));return D.delete(c),o}return c}function C(c,p,D=!0){return(0,u.isObject)(c)?((0,u.isObject)(p)&&Object.keys(p).forEach(w=>{w in c?D&&((0,u.isObject)(c[w])&&(0,u.isObject)(p[w])?C(c[w],p[w],D):c[w]=p[w]):c[w]=p[w]}),c):p}e.mixin=C;function P(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let D,w;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(D=0;D<c.length;D++)if(!P(c[D],p[D]))return!1}else{const o=[];for(w in c)o.push(w);o.sort();const f=[];for(w in p)f.push(w);if(f.sort(),!P(o,f))return!1;for(D=0;D<o.length;D++)if(!P(c[o[D]],p[o[D]]))return!1}return!0}e.equals=P;function t(c){const p=new Set;return JSON.stringify(c,(D,w)=>{if((0,u.isObject)(w)||Array.isArray(w)){if(p.has(w))return"[Circular]";p.add(w)}return w})}e.safeStringify=t;function _(c,p,D){const w=p(c);return typeof w=="undefined"?D:w}e.getOrDefault=_;function n(c,p){const D=Object.create(null);return!c||!p||Object.keys(p).forEach(o=>{const f=c[o],k=p[o];P(f,k)||(D[o]=k)}),D}e.distinct=n;function d(c,p){const D=p.toLowerCase(),w=Object.keys(c).find(o=>o.toLowerCase()===D);return w?c[w]:c[p]}e.getCaseInsensitive=d;function l(c,p){const D=Object.create(null);for(const[w,o]of Object.entries(c))p(w,o)&&(D[w]=o);return D}e.filter=l}),define(we[56],be([0,1,23,9,2]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function I(t){return JSON.stringify(t,C)}e.stringify=I;function F(t){let _=JSON.parse(t);return _=P(_),_}e.parse=F;var T;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(T=e.MarshalledId||(e.MarshalledId={}));function C(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function P(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof u.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let n=0;n<t.length;++n)t[n]=P(t[n],_+1);else for(const n in t)Object.hasOwnProperty.call(t,n)&&(t[n]=P(t[n],_+1))}return t}e.revive=P}),define(we[11],be([0,1,26,2]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.userData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class I{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,P,t){this._hosts[C]=P,this._ports[C]=t}setConnectionToken(C,P){this._connectionTokens[C]=P}rewrite(C){if(this._delegate)return this._delegate(C);const P=C.authority;let t=this._hosts[P];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[P],n=this._connectionTokens[P];let d=`path=${encodeURIComponent(C.path)}`;return typeof n=="string"&&(d+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:u.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new I;class F{asBrowserUri(C,P){const t=this.toUri(C,P);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(u.isNative||typeof u.globals.importScripts=="function"&&u.globals.origin===`${E.vscodeFileResource}://${F.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||F.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(C,P){const t=this.toUri(C,P);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==F.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(C,P){return M.URI.isUri(C)?C:M.URI.parse(P.toUrl(C))}}F.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new F}),define(we[25],be([0,1,43,11,17,26,9,2]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(d){return(0,T.uriToFsPath)(d,!0)}e.originalFSPath=C;class P{constructor(l){this._ignorePathCasing=l}compare(l,c,p=!1){return l===c?0:(0,F.compare)(this.getComparisonKey(l,p),this.getComparisonKey(c,p))}isEqual(l,c,p=!1){return l===c?!0:!l||!c?!1:this.getComparisonKey(l,p)===this.getComparisonKey(c,p)}getComparisonKey(l,c=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,c,p=!1){if(l.scheme===c.scheme){if(l.scheme===M.Schemas.file)return u.isEqualOrParent(C(l),C(c),this._ignorePathCasing(l))&&l.query===c.query&&(p||l.fragment===c.fragment);if((0,e.isEqualAuthority)(l.authority,c.authority))return u.isEqualOrParent(l.path,c.path,this._ignorePathCasing(l),"/")&&l.query===c.query&&(p||l.fragment===c.fragment)}return!1}joinPath(l,...c){return T.URI.joinPath(l,...c)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return E.posix.basename(l.path)}extname(l){return E.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let c;return l.scheme===M.Schemas.file?c=T.URI.file(E.dirname(C(l))).path:(c=E.posix.dirname(l.path),l.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),c="/")),l.with({path:c})}normalizePath(l){if(!l.path.length)return l;let c;return l.scheme===M.Schemas.file?c=T.URI.file(E.normalize(C(l))).path:c=E.posix.normalize(l.path),l.with({path:c})}relativePath(l,c){if(l.scheme!==c.scheme||!(0,e.isEqualAuthority)(l.authority,c.authority))return;if(l.scheme===M.Schemas.file){const w=E.relative(C(l),C(c));return I.isWindows?u.toSlashes(w):w}let p=l.path||"/",D=c.path||"/";if(this._ignorePathCasing(l)){let w=0;for(const o=Math.min(p.length,D.length);w<o&&!(p.charCodeAt(w)!==D.charCodeAt(w)&&p.charAt(w).toLowerCase()!==D.charAt(w).toLowerCase());w++);p=D.substr(0,w)+p.substr(w)}return E.posix.relative(p,D)}resolvePath(l,c){if(l.scheme===M.Schemas.file){const p=T.URI.file(E.resolve(C(l),c));return l.with({authority:p.authority,path:p.path})}return c=u.toPosixPath(c),l.with({path:E.posix.resolve(l.path,c)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,c){return l===c||l!==void 0&&c!==void 0&&(0,F.equalsIgnoreCase)(l,c)}hasTrailingPathSeparator(l,c=E.sep){if(l.scheme===M.Schemas.file){const p=C(l);return p.length>u.getRoot(p).length&&p[p.length-1]===c}else{const p=l.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,c=E.sep){return(0,e.hasTrailingPathSeparator)(l,c)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,c=E.sep){let p=!1;if(l.scheme===M.Schemas.file){const D=C(l);p=D!==void 0&&D.length===u.getRoot(D).length&&D[D.length-1]===c}else{c="/";const D=l.path;p=D.length===1&&D.charCodeAt(D.length-1)===47}return!p&&!(0,e.hasTrailingPathSeparator)(l,c)?l.with({path:l.path+"/"}):l}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(d=>d.scheme===M.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new P(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,l){const c=[];for(let p=0;p<d.length;p++){const D=l(d[p]);d.some((w,o)=>o===p?!1:(0,e.isEqualOrParent)(D,l(w)))||c.push(d[p])}return c}e.distinctParents=t;var _;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function l(c){const p=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(o=>{const[f,k]=o.split(":");f&&k&&p.set(f,k)});const w=c.path.substring(0,c.path.indexOf(";"));return w&&p.set(d.META_DATA_MIME,w),p}d.parseMetaData=l})(_=e.DataUri||(e.DataUri={}));function n(d,l,c){if(l){let p=d.path;return p&&p[0]!==E.posix.sep&&(p=E.posix.sep+p),d.with({scheme:c,authority:l,path:p})}return d.with({scheme:c})}e.toLocalResource=n}),define(we[13],be([0,1,21,16,3,6,25]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function T(W){return!!W&&typeof W.then=="function"}e.isThenable=T;function C(W){const $=new u.CancellationTokenSource,V=W($.token),q=new Promise((re,ae)=>{const pe=$.token.onCancellationRequested(()=>{pe.dispose(),$.dispose(),ae((0,M.canceled)())});Promise.resolve(V).then(me=>{pe.dispose(),$.dispose(),re(me)},me=>{pe.dispose(),$.dispose(),ae(me)})});return new class{cancel(){$.cancel()}then(re,ae){return q.then(re,ae)}catch(re){return this.then(void 0,re)}finally(re){return q.finally(re)}}}e.createCancelablePromise=C;function P(W,$,V){return Promise.race([W,new Promise(q=>$.onCancellationRequested(()=>q(V)))])}e.raceCancellation=P;async function t(W){let $=-1;const V=W.map((re,ae)=>re.then(pe=>($=ae,pe))),q=await Promise.race(V);return W.forEach((re,ae)=>{ae!==$&&re.cancel()}),q}e.raceCancellablePromises=t;function _(W,$,V){let q;const re=setTimeout(()=>{q?.(void 0),V?.()},$);return Promise.race([W.finally(()=>clearTimeout(re)),new Promise(ae=>q=ae)])}e.raceTimeout=_;function n(W){return new Promise(($,V)=>{const q=W();T(q)?q.then($,V):$(q)})}e.asPromise=n;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(V,V).then(q)})}return new Promise((V,q)=>{this.queuedPromise.then(V,q)})}return this.activePromise=$(),new Promise((V,q)=>{this.activePromise.then(re=>{this.activePromise=null,V(re)},re=>{this.activePromise=null,q(re)})})}}e.Throttler=d;class l{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=l;class c{constructor(){this.promiseMap=new Map}queue($,V){const re=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get($)===re&&this.promiseMap.delete($)});return this.promiseMap.set($,re),re}}e.SequencerByKey=c;class p{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,V=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,re)=>{this.doResolve=q,this.doReject=re}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=p;class D{constructor($){this.delayer=new p($),this.throttler=new d}trigger($,V){return this.delayer.trigger(()=>this.throttler.queue($),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class w{constructor(){this._isOpen=!1,this._promise=new Promise(($,V)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=w;class o extends w{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function f(W,$){return $?new Promise((V,q)=>{const re=setTimeout(()=>{ae.dispose(),V()},W),ae=$.onCancellationRequested(()=>{clearTimeout(re),ae.dispose(),q((0,M.canceled)())})}):C(V=>f(W,V))}e.timeout=f;function k(W,$=0){const V=setTimeout(W,$);return(0,I.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=k;function r(W){const $=[];let V=0;const q=W.length;function re(){return V<q?W[V++]():null}function ae(pe){pe!=null&&$.push(pe);const me=re();return me?me.then(ae):Promise.resolve($)}return Promise.resolve(null).then(ae)}e.sequence=r;function v(W,$=q=>!!q,V=null){let q=0;const re=W.length,ae=()=>{if(q>=re)return Promise.resolve(V);const pe=W[q++];return Promise.resolve(pe()).then(Fe=>$(Fe)?Promise.resolve(Fe):ae())};return ae()}e.first=v;function s(W,$=q=>!!q,V=null){if(W.length===0)return Promise.resolve(V);let q=W.length;const re=()=>{q=-1;for(const ae of W)ae.cancel?.()};return new Promise((ae,pe)=>{for(const me of W)me.then(Fe=>{--q>=0&&$(Fe)?(re(),ae(Fe)):q===0&&ae(V)}).catch(Fe=>{--q>=0&&(re(),pe(Fe))})})}e.firstParallel=s;class i{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((V,q)=>{this.outstandingPromises.push({factory:$,c:V,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const V=$.factory();V.then($.c,$.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class m extends i{constructor(){super(1)}}e.Queue=m;class a{constructor(){this.queues=new Map}queueFor($,V=F.extUri){const q=V.getComparisonKey($);let re=this.queues.get(q);return re||(re=new m,E.Event.once(re.onFinished)(()=>{re?.dispose(),this.queues.delete(q)}),this.queues.set(q,re)),re}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=a;class g{constructor($,V){this._token=-1,typeof $=="function"&&typeof V=="number"&&this.setIfNotSet($,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},V)}setIfNotSet($,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},V))}}e.TimeoutTimer=g;class b{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,V){this.cancel(),this._token=setInterval(()=>{$()},V)}}e.IntervalTimer=b;class h{constructor($,V){this.timeoutToken=-1,this.runner=$,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=h;class y{constructor($,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends h{constructor($,V){super($,V);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class A extends I.Disposable{constructor($,V,q,re){super();this.maxWorkChunkSize=$,this.maxPendingWork=V,this.throttleDelay=q,this.handler=re,this.pendingWork=[],this.throttler=this._register(new I.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new h(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=A,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const $=setTimeout(()=>{const q=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,q-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout($))}}}:e.runWhenIdle=(W,$)=>{const V=requestIdleCallback(W,typeof $=="number"?{timeout:$}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(V))}}}}();class B{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function O(W,$,V){let q;for(let re=0;re<V;re++)try{return await W()}catch(ae){q=ae,await f($)}throw q}e.retry=O;class S{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,V,q){return this._pending={taskId:$,cancel:()=>q?.(),promise:V},V.then(()=>this.donePending($),()=>this.donePending($)),V}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let V,q;const re=new Promise((ae,pe)=>{V=ae,q=pe});this._next={run:$,promise:re,promiseResolve:V,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=S;class x{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,V)=>{this.completeCallback=$,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(V=>{this.completeCallback($),this.resolved=!0,V()})}error($){return new Promise(V=>{this.errorCallback($),this.rejected=!0,V()})}cancel(){new Promise($=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=N;var j;(function(W){async function $(q){let re;const ae=await Promise.all(q.map(pe=>pe.then(me=>me,me=>{re||(re=me)})));if(typeof re!="undefined")throw re;return ae}W.settled=$;function V(q){return new Promise(async(re,ae)=>{try{await q(re,ae)}catch(pe){ae(pe)}})}W.withAsyncBody=V})(j=e.Promises||(e.Promises={}))}),define(we[107],be([0,1,13,17]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new u.IdleValue(()=>{const h=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:h,collatorIsNumeric:h.resolvedOptions().numeric}}),I=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),F=new u.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(h,y,R=!1){const A=h||"",B=y||"",O=E.value.collator.compare(A,B);return E.value.collatorIsNumeric&&O===0&&A!==B?A<B?-1:1:O}e.compareFileNames=T;function C(h,y){const R=I.value.collator;return h=h||"",y=y||"",k(R,h,y)}e.compareFileNamesDefault=C;function P(h,y){const R=I.value.collator;return h=h||"",y=y||"",i(h,y)||k(R,h,y)}e.compareFileNamesUpper=P;function t(h,y){const R=I.value.collator;return h=h||"",y=y||"",s(h,y)||k(R,h,y)}e.compareFileNamesLower=t;function _(h,y){return h=h||"",y=y||"",h===y?0:h<y?-1:1}e.compareFileNamesUnicode=_;function n(h,y,R=!1){R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase());const[A,B]=o(h),[O,S]=o(y);return A!==O?A<O?-1:1:B===S?0:B<S?-1:1}e.noIntlCompareFileNames=n;function d(h,y){const[R,A]=o(h),[B,O]=o(y);let S=E.value.collator.compare(A,O);if(S===0){if(E.value.collatorIsNumeric&&A!==O)return A<O?-1:1;if(S=E.value.collator.compare(R,B),E.value.collatorIsNumeric&&S===0&&R!==B)return R<B?-1:1}return S}e.compareFileExtensions=d;function l(h,y){h=h||"",y=y||"";const R=f(h),A=f(y),B=I.value.collator,O=F.value.collator;return k(O,R,A)||k(B,h,y)}e.compareFileExtensionsDefault=l;function c(h,y){h=h||"",y=y||"";const R=f(h),A=f(y),B=I.value.collator,O=F.value.collator;return k(O,R,A)||i(h,y)||k(B,h,y)}e.compareFileExtensionsUpper=c;function p(h,y){h=h||"",y=y||"";const R=f(h),A=f(y),B=I.value.collator,O=F.value.collator;return k(O,R,A)||s(h,y)||k(B,h,y)}e.compareFileExtensionsLower=p;function D(h,y){h=h||"",y=y||"";const R=f(h).toLowerCase(),A=f(y).toLowerCase();return R!==A?R<A?-1:1:h!==y?h<y?-1:1:0}e.compareFileExtensionsUnicode=D;const w=/^(.*?)(\.([^.]*))?$/;function o(h,y=!1){const R=h?w.exec(h):[];let A=[R&&R[1]||"",R&&R[3]||""];return y&&(!A[0]&&A[1]||A[0]&&A[0].charAt(0)===".")&&(A=[A[0]+"."+A[1],""]),A}function f(h){const y=h?w.exec(h):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function k(h,y,R){let A=h.compare(y,R);return A!==0?A:y.length!==R.length?y.length<R.length?-1:1:0}function r(h){const y=h.charAt(0);return y.toLocaleUpperCase()!==y}function v(h){const y=h.charAt(0);return y.toLocaleLowerCase()!==y}function s(h,y){return r(h)&&v(y)?-1:v(h)&&r(y)?1:0}function i(h,y){return v(h)&&r(y)?-1:r(h)&&v(y)?1:0}function m(h,y,R=!1){return R||(h=h&&h.toLowerCase(),y=y&&y.toLowerCase()),h===y?0:h<y?-1:1}function a(h,y,R=!1){const A=h.split(M.sep),B=y.split(M.sep),O=A.length-1,S=B.length-1;let x,N;for(let j=0;;j++){if(x=O===j,N=S===j,x&&N)return T(A[j],B[j],R);if(x)return-1;if(N)return 1;const W=m(A[j],B[j],R);if(W!==0)return W}}e.comparePaths=a;function g(h,y,R){const A=h.toLowerCase(),B=y.toLowerCase(),O=b(h,y,R);if(O)return O;const S=A.endsWith(R),x=B.endsWith(R);if(S!==x)return S?-1:1;const N=T(A,B);return N!==0?N:A.localeCompare(B)}e.compareAnything=g;function b(h,y,R){const A=h.toLowerCase(),B=y.toLowerCase(),O=A.startsWith(R),S=B.startsWith(R);if(O!==S)return O?-1:1;if(O&&S){if(A.length<B.length)return-1;if(A.length>B.length)return 1}return 0}e.compareByPrefix=b}),define(we[28],be([0,1,13,43,20,17,9]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T;const C="**",P="/",t="[/\\\\]",_="[^/\\\\]",n=/\//g;function d(q){switch(q){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function l(q,re){if(!q)return[];const ae=[];let pe=!1,me=!1,Fe="";for(const Ye of q){switch(Ye){case re:if(!pe&&!me){ae.push(Fe),Fe="";continue}break;case"{":pe=!0;break;case"}":pe=!1;break;case"[":me=!0;break;case"]":me=!1;break}Fe+=Ye}return Fe&&ae.push(Fe),ae}e.splitGlobAware=l;function c(q){if(!q)return"";let re="";const ae=l(q,P);if(ae.every(pe=>pe===C))re=".*";else{let pe=!1;ae.forEach((me,Fe)=>{if(me===C){pe||(re+=d(2),pe=!0);return}let Ye=!1,Ue="",Ve=!1,Je="";for(const je of me){if(je!=="}"&&Ye){Ue+=je;continue}if(Ve&&(je!=="]"||!Je)){let Qe;je==="-"?Qe=je:(je==="^"||je==="!")&&!Je?Qe="^":je===P?Qe="":Qe=F.escapeRegExpCharacters(je),Je+=Qe;continue}switch(je){case"{":Ye=!0;continue;case"[":Ve=!0;continue;case"}":re+=`(?:${l(Ue,",").map(Q=>c(Q)).join("|")})`,Ye=!1,Ue="";break;case"]":re+="["+Je+"]",Ve=!1,Je="";break;case"?":re+=_;continue;case"*":re+=d(1);continue;default:re+=F.escapeRegExpCharacters(je)}}Fe<ae.length-1&&(ae[Fe+1]!==C||Fe+2<ae.length)&&(re+=t),pe=!1})}return re}const p=/^\*\*\/\*\.[\w\.-]+$/,D=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,k=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new E.LRUCache(1e4),v=function(){return!1},s=function(){return null};function i(q,re){if(!q)return s;let ae;typeof q!="string"?ae=q.pattern:ae=q,ae=ae.trim();const pe=`${ae}_${!!re.trimForExclusions}`;let me=r.get(pe);if(me)return m(me,q);let Fe;if(p.test(ae)){const Ye=ae.substr(4);me=function(Ue,Ve){return typeof Ue=="string"&&Ue.endsWith(Ye)?ae:null}}else(Fe=D.exec(a(ae,re)))?me=g(Fe[1],ae):(re.trimForExclusions?o:w).test(ae)?me=b(ae,re):(Fe=f.exec(a(ae,re)))?me=h(Fe[1].substr(1),ae,!0):(Fe=k.exec(a(ae,re)))?me=h(Fe[1],ae,!1):me=y(ae);return r.set(pe,me),m(me,q)}function m(q,re){return typeof re=="string"?q:function(ae,pe){return M.isEqualOrParent(ae,re.base)?q(I.relative(re.base,ae),pe):null}}function a(q,re){return re.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function g(q,re){const ae=`/${q}`,pe=`\\${q}`,me=function(Ye,Ue){return typeof Ye!="string"?null:Ue?Ue===q?re:null:Ye===q||Ye.endsWith(ae)||Ye.endsWith(pe)?re:null},Fe=[q];return me.basenames=Fe,me.patterns=[re],me.allBasenames=Fe,me}function b(q,re){const ae=V(q.slice(1,-1).split(",").map(Ue=>i(Ue,re)).filter(Ue=>Ue!==s),q),pe=ae.length;if(!pe)return s;if(pe===1)return ae[0];const me=function(Ue,Ve){for(let Je=0,je=ae.length;Je<je;Je++)if(ae[Je](Ue,Ve))return q;return null},Fe=ae.find(Ue=>!!Ue.allBasenames);Fe&&(me.allBasenames=Fe.allBasenames);const Ye=ae.reduce((Ue,Ve)=>Ve.allPaths?Ue.concat(Ve.allPaths):Ue,[]);return Ye.length&&(me.allPaths=Ye),me}function h(q,re,ae){const pe=I.sep===I.posix.sep,me=pe?q:q.replace(n,I.sep),Fe=I.sep+me,Ye=I.posix.sep+q,Ue=ae?function(Ve,Je){return typeof Ve=="string"&&(Ve===me||Ve.endsWith(Fe)||!pe&&(Ve===q||Ve.endsWith(Ye)))?re:null}:function(Ve,Je){return typeof Ve=="string"&&(Ve===me||!pe&&Ve===q)?re:null};return Ue.allPaths=[(ae?"*/":"./")+q],Ue}function y(q){try{const re=new RegExp(`^${c(q)}$`);return function(ae){return re.lastIndex=0,typeof ae=="string"&&re.test(ae)?q:null}}catch(re){return s}}function R(q,re,ae){return!q||typeof re!="string"?!1:A(q)(re,void 0,ae)}e.match=R;function A(q,re={}){if(!q)return v;if(typeof q=="string"||x(q)){const ae=i(q,re);if(ae===s)return v;const pe=function(me,Fe){return!!ae(me,Fe)};return ae.allBasenames&&(pe.allBasenames=ae.allBasenames),ae.allPaths&&(pe.allPaths=ae.allPaths),pe}return W(q,re)}e.parse=A;function B(q){if(!q)return;let re;return ae=>(re||(re=(q()||Promise.resolve([])).then(pe=>pe?S(pe):{})),re.then(pe=>!!pe[ae]))}e.hasSiblingPromiseFn=B;function O(q){if(!q)return;let re;return ae=>{if(!re){const pe=q();re=pe?S(pe):{}}return!!re[ae]}}e.hasSiblingFn=O;function S(q){const re={};for(const ae of q)re[ae]=!0;return re}function x(q){const re=q;return re&&typeof re.base=="string"&&typeof re.pattern=="string"}e.isRelativePattern=x;function N(q){return q.allBasenames||[]}e.getBasenameTerms=N;function j(q){return q.allPaths||[]}e.getPathTerms=j;function W(q,re){const ae=V(Object.getOwnPropertyNames(q).map(Ue=>$(Ue,q[Ue],re)).filter(Ue=>Ue!==s)),pe=ae.length;if(!pe)return s;if(!ae.some(Ue=>!!Ue.requiresSiblings)){if(pe===1)return ae[0];const Ue=function(je,Qe){for(let z=0,Q=ae.length;z<Q;z++){const X=ae[z](je,Qe);if(X)return X}return null},Ve=ae.find(je=>!!je.allBasenames);Ve&&(Ue.allBasenames=Ve.allBasenames);const Je=ae.reduce((je,Qe)=>Qe.allPaths?je.concat(Qe.allPaths):je,[]);return Je.length&&(Ue.allPaths=Je),Ue}const me=function(Ue,Ve,Je){let je;for(let Qe=0,z=ae.length;Qe<z;Qe++){const Q=ae[Qe];Q.requiresSiblings&&Je&&(Ve||(Ve=I.basename(Ue)),je||(je=Ve.substr(0,Ve.length-I.extname(Ue).length)));const X=Q(Ue,Ve,je,Je);if(X)return X}return null},Fe=ae.find(Ue=>!!Ue.allBasenames);Fe&&(me.allBasenames=Fe.allBasenames);const Ye=ae.reduce((Ue,Ve)=>Ve.allPaths?Ue.concat(Ve.allPaths):Ue,[]);return Ye.length&&(me.allPaths=Ye),me}function $(q,re,ae){if(re===!1)return s;const pe=i(q,ae);if(pe===s)return s;if(typeof re=="boolean")return pe;if(re){const me=re.when;if(typeof me=="string"){const Fe=(Ye,Ue,Ve,Je)=>{if(!Je||!pe(Ye,Ue))return null;const je=me.replace("$(basename)",Ve),Qe=Je(je);return(0,u.isThenable)(Qe)?Qe.then(z=>z?q:null):Qe?q:null};return Fe.requiresSiblings=!0,Fe}}return pe}function V(q,re){const ae=q.filter(Ue=>!!Ue.basenames);if(ae.length<2)return q;const pe=ae.reduce((Ue,Ve)=>{const Je=Ve.basenames;return Je?Ue.concat(Je):Ue},[]);let me;if(re){me=[];for(let Ue=0,Ve=pe.length;Ue<Ve;Ue++)me.push(re)}else me=ae.reduce((Ue,Ve)=>{const Je=Ve.patterns;return Je?Ue.concat(Je):Ue},[]);const Fe=function(Ue,Ve){if(typeof Ue!="string")return null;if(!Ve){let je;for(je=Ue.length;je>0;je--){const Qe=Ue.charCodeAt(je-1);if(Qe===47||Qe===92)break}Ve=Ue.substr(je)}const Je=pe.indexOf(Ve);return Je!==-1?me[Je]:null};Fe.basenames=pe,Fe.patterns=me,Fe.allBasenames=pe;const Ye=q.filter(Ue=>!Ue.basenames);return Ye.push(Fe),Ye}}),define(we[77],be([0,1,43,11,17,26,25,9,2]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,m,a){if(typeof i=="string"&&(i=C.URI.file(i)),a){const b=a.getWorkspaceFolder(i);if(b){const h=a.getWorkspace().folders.length>1;let y;if((0,F.isEqual)(b.uri,i)?y="":y=(0,F.relativePath)(b.uri,i),h){const R=b.name?b.name:(0,F.basename)(b.uri);y=y?R+" \u2022 "+y:R}return y}}if(i.scheme!==M.Schemas.file&&i.scheme!==M.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,u.hasDriveLetter)(i.fsPath))return(0,E.normalize)(_(i.fsPath));let g=(0,E.normalize)(i.fsPath);return!I.isWindows&&m?.userHome&&(g=d(g,m.userHome.fsPath)),g}e.getPathLabel=P;function t(i){if(!i)return;typeof i=="string"&&(i=C.URI.file(i));const m=(0,F.basename)(i)||(i.scheme===M.Schemas.file?i.fsPath:i.path);return I.isWindows&&(0,u.isRootOrDriveLetter)(m)?_(m):m}e.getBaseLabel=t;function _(i,m){return(0,u.hasDriveLetter)(i,m)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function d(i,m){if(I.isWindows||!i||!m)return i;let a=n.original===m?n.normalized:void 0;return a||(a=`${(0,T.rtrim)(m,E.posix.sep)}${E.posix.sep}`,n={original:m,normalized:a}),(I.isLinux?i.startsWith(a):(0,T.startsWithIgnoreCase)(i,a))&&(i=`~/${i.substr(a.length)}`),i}e.tildify=d;function l(i,m){return i.replace(/^~($|\/|\\)/,`${m}$1`)}e.untildify=l;const c="\u2026",p="\\\\",D="~";function w(i,m=E.sep){const a=new Array(i.length);let g=!1;for(let b=0;b<i.length;b++){let h=i[b];if(h===""){a[b]=`.${m}`;continue}if(!h){a[b]=h;continue}g=!0;let y="";h.indexOf(p)===0?(y=h.substr(0,h.indexOf(p)+p.length),h=h.substr(h.indexOf(p)+p.length)):h.indexOf(m)===0?(y=h.substr(0,h.indexOf(m)+m.length),h=h.substr(h.indexOf(m)+m.length)):h.indexOf(D)===0&&(y=h.substr(0,h.indexOf(D)+D.length),h=h.substr(h.indexOf(D)+D.length));const R=h.split(m);for(let A=1;g&&A<=R.length;A++)for(let B=R.length-A;g&&B>=0;B--){g=!1;let O=R.slice(B,B+A).join(m);for(let S=0;!g&&S<i.length;S++)if(S!==b&&i[S]&&i[S].indexOf(O)>-1){const x=B+A===R.length,N=B>0&&i[S].indexOf(m)>-1?m+O:O,j=i[S].endsWith(N);g=!x||j}if(!g){let S="";(R[0].endsWith(":")||y!=="")&&(B===1&&(B=0,A++,O=R[0]+m+O),B>0&&(S=R[0]+m),S=y+S),B>0&&(S=S+c+m),S=S+O,B+A<R.length&&(S=S+m+c),a[b]=S}}g&&(a[b]=h)}return a}e.shorten=w;var o;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function f(i,m=Object.create(null)){const a=[];let g=!1,b="";for(const h of i)if(h==="$"||g&&h==="{")b&&a.push({value:b,type:o.TEXT}),b="",g=!0;else if(h==="}"&&g){const y=m[b];if(typeof y=="string")y.length&&a.push({value:y,type:o.VARIABLE});else if(y){const R=a[a.length-1];(!R||R.type!==o.SEPARATOR)&&a.push({value:y.label,type:o.SEPARATOR})}b="",g=!1}else b+=h;return b&&!g&&a.push({value:b,type:o.TEXT}),a.filter((h,y)=>{if(h.type===o.SEPARATOR){const R=a[y-1],A=a[y+1];return[R,A].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=f;function k(i,m){return I.isMacintosh||m?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=k;function r(i,m){return I.isMacintosh||m?i.replace(/\(&&\w\)|&&/g,""):I.isWindows?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function v(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=v;function s(i){const m=i.indexOf("/")!==-1?E.posix:E.win32,a=m.basename(i),g=m.dirname(i);return a.length?{name:a,parentPath:g}:{name:g,parentPath:""}}e.splitName=s}),define(we[78],be([0,1,28,11,17,25,9]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var T;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(T=e.Mimes||(e.Mimes={}));let C=[],P=[],t=[];function _(i,m=!1){const a=n(i);C.push(a),a.userConfigured?t.push(a):P.push(a),m&&!a.userConfigured&&C.forEach(g=>{g.mime===a.mime||g.userConfigured||(a.extension&&g.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&g.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&g.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&g.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,u.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(E.posix.sep)>=0:!1}}function d(i){i?(C=C.filter(m=>!m.userConfigured),t=[]):(C=[],P=[],t=[])}e.clearTextMimes=d;function l(i,m){let a;if(i)switch(i.scheme){case M.Schemas.file:a=i.fsPath;break;case M.Schemas.data:a=I.DataUri.parseMetaData(i).get(I.DataUri.META_DATA_LABEL);break;default:a=i.path}if(!a)return[T.unknown];a=a.toLowerCase();const g=(0,E.basename)(a),b=c(a,g,t);if(b)return[b,T.text];const h=c(a,g,P);if(h)return[h,T.text];if(m){const y=p(m);if(y)return[y,T.text]}return[T.unknown]}e.guessMimeTypes=l;function c(i,m,a){let g=null,b=null,h=null;for(let y=a.length-1;y>=0;y--){const R=a[y];if(m===R.filenameLowercase){g=R;break}if(R.filepattern&&(!b||R.filepattern.length>b.filepattern.length)){const A=R.filepatternOnPath?i:m;R.filepatternLowercase?.(A)&&(b=R)}R.extension&&(!h||R.extension.length>h.extension.length)&&m.endsWith(R.extensionLowercase)&&(h=R)}return g?g.mime:b?b.mime:h?h.mime:null}function p(i){if((0,F.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let m=C.length-1;m>=0;m--){const a=C[m];if(!a.firstline)continue;const g=i.match(a.firstline);if(g&&g.length>0)return a.mime}return null}function D(i){return i?typeof i=="string"?i===T.binary||i===T.text||i===T.unknown:i.length===1&&D(i[0]):!0}e.isUnspecific=D;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function f(i){const m=(0,E.extname)(i),a=w[m.toLowerCase()];return a!==void 0?a:k(i)}e.getMediaOrTextMime=f;function k(i){const m=(0,E.extname)(i);return o[m.toLowerCase()]}e.getMediaMime=k;function r(i){for(const m in o)if(o[m]===i)return m}e.getExtensionForMimeType=r;const v=/^(.+)\/(.+?)(;.+)?$/;function s(i,m){const a=v.exec(i);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:m?void 0:i}e.normalizeMimeType=s}),define(we[108],be([0,1,2]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(u.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(u.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:u.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function I(t,_,n){if(!t||n>200)return null;if(typeof t=="object"){if(t instanceof u.URI)return _.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const l=I(t[d],_,n+1);l!==null&&(t[d]=l)}}return null}function F(t,_){const n=I(t,_,0);return n===null?t:n}e.transformOutgoingURIs=F;function T(t,_,n,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return n?u.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let l in t)if(Object.hasOwnProperty.call(t,l)){const c=T(t[l],_,n,d+1);c!==null&&(t[l]=c)}}return null}function C(t,_){const n=T(t,_,!1,0);return n===null?t:n}e.transformIncomingURIs=C;function P(t,_){const n=T(t,_,!0,0);return n===null?t:n}e.transformAndReviveIncomingURIs=P}),define(we[36],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return u.test(C)}e.isUUID=M;const E=new Uint8Array(16),I=[];for(let C=0;C<256;C++)I.push(C.toString(16).padStart(2,"0"));let F;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?F=crypto.getRandomValues.bind(crypto):F=function(C){for(let P=0;P<C.length;P++)C[P]=Math.floor(Math.random()*256);return C};function T(){F(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let C=0,P="";return P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P+="-",P+=I[E[C++]],P+=I[E[C++]],P+="-",P+=I[E[C++]],P+=I[E[C++]],P+="-",P+=I[E[C++]],P+=I[E[C++]],P+="-",P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P+=I[E[C++]],P}e.generateUuid=T}),define(we[109],be([0,1,231]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(F){F[F.Regular=0]="Regular",F[F.Whitespace=1]="Whitespace",F[F.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends u.CharacterClassifier{constructor(T){super(0);for(let C=0,P=T.length;C<P;C++)this.set(T.charCodeAt(C),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function I(F){let T={};return C=>(T.hasOwnProperty(C)||(T[C]=F(C)),T[C])}e.getMapForWordSeparators=I(F=>new E(F))}),define(we[79],be([0,1,24]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var I;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(I=e.EndOfLinePreference||(e.EndOfLinePreference={}));var F;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(F=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var T;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(T=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,u.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class P{constructor(o,f){this._findMatchBrand=void 0,this.range=o,this.matches=f}}e.FindMatch=P;var t;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(w){w[w.Disabled=0]="Disabled",w[w.EnabledForActive=1]="EnabledForActive",w[w.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(o,f,k){this.visibleColumn=o,this.className=f,this.horizontalLine=k}}e.IndentGuide=n;class d{constructor(o,f){this.top=o,this.endColumn=f}}e.IndentGuideHorizontalLine=d;var l;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None"})(l=e.PositionAffinity||(e.PositionAffinity={}));var c;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c=e.ModelConstants||(e.ModelConstants={}));class p{constructor(o,f,k,r,v,s){this.identifier=o,this.range=f,this.text=k,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=v,this._isTracked=s}}e.ValidAnnotatedEditOperation=p;class D{constructor(o,f,k){this.reverseEdits=o,this.changes=f,this.trimAutoWhitespaceLineNumbers=k}}e.ApplyEditsResult=D}),define(we[110],be([0,1,9,109,111,44,79]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const T=999;class C{constructor(o,f,k,r){this.searchString=o,this.isRegex=f,this.matchCase=k,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=P(this.searchString):o=this.searchString.indexOf(`
`)>=0;let f=null;try{f=u.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(r){return null}if(!f)return null;let k=!this.isRegex&&!o;return k&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(k=this.matchCase),new t(f,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,k?this.searchString:null)}}e.SearchParams=C;function P(w){if(!w||w.length===0)return!1;for(let o=0,f=w.length;o<f;o++)if(w.charCodeAt(o)===92){if(o++,o>=f)break;const r=w.charCodeAt(o);if(r===110||r===114||r===87)return!0}return!1}e.isMultilineRegexSource=P;class t{constructor(o,f,k){this.regex=o,this.wordSeparators=f,this.simpleSearch=k}}e.SearchData=t;function _(w,o,f){if(!f)return new F.FindMatch(w,null);let k=[];for(let r=0,v=o.length;r<v;r++)k[r]=o[r];return new F.FindMatch(w,k)}e.createFindMatch=_;class n{constructor(o){let f=[],k=0;for(let r=0,v=o.length;r<v;r++)o.charCodeAt(r)===10&&(f[k++]=r);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(o){const f=this._lineFeedsOffsets;let k=0,r=f.length-1;if(r===-1||o<=f[0])return 0;for(;k<r;){const v=k+((r-k)/2>>0);f[v]>=o?r=v-1:f[v+1]>=o?(k=v,r=v):k=v+1}return k+1}}class d{static findMatches(o,f,k,r,v){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(o,k,new D(s.wordSeparators,s.regex),r,v):this._doFindMatchesLineByLine(o,k,s,r,v):[]}static _getMultilineMatchRange(o,f,k,r,v,s){let i,m=0;r?(m=r.findLineFeedCountBeforeOffset(v),i=f+v+m):i=f+v;let a;if(r){let y=r.findLineFeedCountBeforeOffset(v+s.length)-m;a=i+s.length+y}else a=i+s.length;const g=o.getPositionAt(i),b=o.getPositionAt(a);return new I.Range(g.lineNumber,g.column,b.lineNumber,b.column)}static _doFindMatchesMultiline(o,f,k,r,v){const s=o.getOffsetAt(f.getStartPosition()),i=o.getValueInRange(f,1),m=o.getEOL()===`\r
`?new n(i):null,a=[];let g=0,b;for(k.reset(0);b=k.next(i);)if(a[g++]=_(this._getMultilineMatchRange(o,s,i,m,b.index,b[0]),b,r),g>=v)return a;return a}static _doFindMatchesLineByLine(o,f,k,r,v){const s=[];let i=0;if(f.startLineNumber===f.endLineNumber){const a=o.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return i=this._findMatchesInLine(k,a,f.startLineNumber,f.startColumn-1,i,s,r,v),s}const m=o.getLineContent(f.startLineNumber).substring(f.startColumn-1);i=this._findMatchesInLine(k,m,f.startLineNumber,f.startColumn-1,i,s,r,v);for(let a=f.startLineNumber+1;a<f.endLineNumber&&i<v;a++)i=this._findMatchesInLine(k,o.getLineContent(a),a,0,i,s,r,v);if(i<v){const a=o.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);i=this._findMatchesInLine(k,a,f.endLineNumber,0,i,s,r,v)}return s}static _findMatchesInLine(o,f,k,r,v,s,i,m){const a=o.wordSeparators;if(!i&&o.simpleSearch){const h=o.simpleSearch,y=h.length,R=f.length;let A=-y;for(;(A=f.indexOf(h,A+y))!==-1;)if((!a||p(a,f,R,A,y))&&(s[v++]=new F.FindMatch(new I.Range(k,A+1+r,k,A+1+y+r),null),v>=m))return v;return v}const g=new D(o.wordSeparators,o.regex);let b;g.reset(0);do if(b=g.next(f),b&&(s[v++]=_(new I.Range(k,b.index+1+r,k,b.index+1+b[0].length+r),b,i),v>=m))return v;while(b);return v}static findNextMatch(o,f,k,r){const v=f.parseSearchRequest();if(!v)return null;const s=new D(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindNextMatchMultiline(o,k,s,r):this._doFindNextMatchLineByLine(o,k,s,r)}static _doFindNextMatchMultiline(o,f,k,r){const v=new E.Position(f.lineNumber,1),s=o.getOffsetAt(v),i=o.getLineCount(),m=o.getValueInRange(new I.Range(v.lineNumber,v.column,i,o.getLineMaxColumn(i)),1),a=o.getEOL()===`\r
`?new n(m):null;k.reset(f.column-1);let g=k.next(m);return g?_(this._getMultilineMatchRange(o,s,m,a,g.index,g[0]),g,r):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(o,new E.Position(1,1),k,r):null}static _doFindNextMatchLineByLine(o,f,k,r){const v=o.getLineCount(),s=f.lineNumber,i=o.getLineContent(s),m=this._findFirstMatchInLine(k,i,s,f.column,r);if(m)return m;for(let a=1;a<=v;a++){const g=(s+a-1)%v,b=o.getLineContent(g+1),h=this._findFirstMatchInLine(k,b,g+1,1,r);if(h)return h}return null}static _findFirstMatchInLine(o,f,k,r,v){o.reset(r-1);const s=o.next(f);return s?_(new I.Range(k,s.index+1,k,s.index+1+s[0].length),s,v):null}static findPreviousMatch(o,f,k,r){const v=f.parseSearchRequest();if(!v)return null;const s=new D(v.wordSeparators,v.regex);return v.regex.multiline?this._doFindPreviousMatchMultiline(o,k,s,r):this._doFindPreviousMatchLineByLine(o,k,s,r)}static _doFindPreviousMatchMultiline(o,f,k,r){const v=this._doFindMatchesMultiline(o,new I.Range(1,1,f.lineNumber,f.column),k,r,10*T);if(v.length>0)return v[v.length-1];const s=o.getLineCount();return f.lineNumber!==s||f.column!==o.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(o,new E.Position(s,o.getLineMaxColumn(s)),k,r):null}static _doFindPreviousMatchLineByLine(o,f,k,r){const v=o.getLineCount(),s=f.lineNumber,i=o.getLineContent(s).substring(0,f.column-1),m=this._findLastMatchInLine(k,i,s,r);if(m)return m;for(let a=1;a<=v;a++){const g=(v+s-a-1)%v,b=o.getLineContent(g+1),h=this._findLastMatchInLine(k,b,g+1,r);if(h)return h}return null}static _findLastMatchInLine(o,f,k,r){let v=null,s;for(o.reset(0);s=o.next(f);)v=_(new I.Range(k,s.index+1,k,s.index+1+s[0].length),s,r);return v}}e.TextModelSearch=d;function l(w,o,f,k,r){if(k===0)return!0;const v=o.charCodeAt(k-1);if(w.get(v)!==0||v===13||v===10)return!0;if(r>0){const s=o.charCodeAt(k);if(w.get(s)!==0)return!0}return!1}function c(w,o,f,k,r){if(k+r===f)return!0;const v=o.charCodeAt(k+r);if(w.get(v)!==0||v===13||v===10)return!0;if(r>0){const s=o.charCodeAt(k+r-1);if(w.get(s)!==0)return!0}return!1}function p(w,o,f,k,r){return l(w,o,f,k,r)&&c(w,o,f,k,r)}e.isValidMatch=p;class D{constructor(o,f){this._wordSeparators=o,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const f=o.length;let k;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(k=this._searchRegex.exec(o),!k))return null;const r=k.index,v=k[0].length;if(r===this._prevMatchStartIndex&&v===this._prevMatchLength){if(v===0){u.getNextCodePoint(o,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=r,this._prevMatchLength=v,!this._wordSeparators||p(this._wordSeparators,o,f,r,v))return k}while(k);return null}}e.Searcher=D}),define(we[112],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var u;(function(F){F[F.None=0]="None",F[F.Indent=1]="Indent",F[F.IndentOutdent=2]="IndentOutdent",F[F.Outdent=3]="Outdent"})(u=e.IndentAction||(e.IndentAction={}));class M{constructor(T){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=T.open,this.close=T.close,this._standardTokenMask=0,Array.isArray(T.notIn))for(let C=0,P=T.notIn.length;C<P;C++)switch(T.notIn[C]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(T){return(this._standardTokenMask&T)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const C of T)I(this.autoClosingPairsOpenByStart,C.open.charAt(0),C),I(this.autoClosingPairsOpenByEnd,C.open.charAt(C.open.length-1),C),I(this.autoClosingPairsCloseByStart,C.close.charAt(0),C),I(this.autoClosingPairsCloseByEnd,C.close.charAt(C.close.length-1),C),C.close.length===1&&C.open.length===1&&I(this.autoClosingPairsCloseSingleChar,C.close,C)}}e.AutoClosingPairs=E;function I(F,T,C){F.has(T)?F.get(T).push(C):F.set(T,[C])}}),define(we[57],be([0,1,28,17]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(I,F,T,C){if(Array.isArray(I)){let P=0;for(const t of I){const _=E(t,F,T,C);if(_===10)return _;_>P&&(P=_)}return P}else{if(typeof I=="string")return C?I==="*"?5:I===T?10:0:0;if(I){const{language:P,pattern:t,scheme:_,hasAccessToAllModels:n}=I;if(!C&&!n)return 0;let d=0;if(_)if(_===F.scheme)d=10;else if(_==="*")d=5;else return 0;if(P)if(P===T)d=10;else if(P==="*")d=Math.max(d,5);else return 0;if(t){let l;if(typeof t=="string"?l=t:l={...t,base:(0,M.normalize)(t.base)},l===F.fsPath||(0,u.match)(l,F.fsPath))d=10;else return 0}return d}else return 0}}e.score=E}),define(we[113],be([0,1,3,6]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new u.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(F){this._onDidChange.fire({changedLanguages:F,changedColorMap:!1})}register(F,T){return this._map.set(F,T),this.fire([F]),(0,M.toDisposable)(()=>{this._map.get(F)===T&&(this._map.delete(F),this.fire([F]))})}registerPromise(F,T){let C=null,P=!1;return this._promises.set(F,T.then(t=>{this._promises.delete(F),!(P||!t)&&(C=this.register(F,t))})),(0,M.toDisposable)(()=>{P=!0,C&&C.dispose()})}getPromise(F){const T=this.get(F);if(T)return Promise.resolve(T);const C=this._promises.get(F);return C?C.then(P=>this.get(F)):null}get(F){return this._map.get(F)||null}setColorMap(F){this._colorMap=F,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(we[80],be([0,1,23,26]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function I(_){for(let n=0,d=_.length;n<d;n+=4){const l=_[n+0],c=_[n+1],p=_[n+2],D=_[n+3];_[n+0]=D,_[n+1]=p,_[n+2]=c,_[n+3]=l}}function F(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||I(n),u.VSBuffer.wrap(n)}function T(_){const n=_.buffer;if(M.isLittleEndian()||I(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const d=new Uint8Array(n.byteLength);return d.set(n),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function C(_){const n=new Uint32Array(P(_));let d=0;if(n[d++]=_.id,_.type==="full")n[d++]=1,n[d++]=_.data.length,n.set(_.data,d),d+=_.data.length;else{n[d++]=2,n[d++]=_.deltas.length;for(const l of _.deltas)n[d++]=l.start,n[d++]=l.deleteCount,l.data?(n[d++]=l.data.length,n.set(l.data,d),d+=l.data.length):n[d++]=0}return F(n)}e.encodeSemanticTokensDto=C;function P(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const d of _.deltas)d.data&&(n+=d.data.length)}return n}function t(_){const n=T(_);let d=0;const l=n[d++];if(n[d++]===1){const w=n[d++],o=n.subarray(d,d+w);return d+=w,{id:l,type:"full",data:o}}const p=n[d++];let D=[];for(let w=0;w<p;w++){const o=n[d++],f=n[d++],k=n[d++];let r;k>0&&(r=n.subarray(d,d+k),d+=k),D[w]={start:o,deleteCount:f,data:r}}return{id:l,type:"delta",deltas:D}}e.decodeSemanticTokensDto=t}),define(we[114],be([18,19]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(we[115],be([0,1,114]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,E=M*60,I=E*24,F=I*7,T=I*30,C=I*365;function P(_,n){typeof _!="number"&&(_=_.getTime());const d=Math.round((new Date().getTime()-_)/1e3);if(d<-30)return(0,u.localize)(0,null,P(new Date().getTime()+d*1e3,!1));if(d<30)return(0,u.localize)(1,null);let l;return d<M?(l=d,n?l===1?(0,u.localize)(2,null,l):(0,u.localize)(3,null,l):l===1?(0,u.localize)(4,null,l):(0,u.localize)(5,null,l)):d<E?(l=Math.floor(d/M),n?l===1?(0,u.localize)(6,null,l):(0,u.localize)(7,null,l):l===1?(0,u.localize)(8,null,l):(0,u.localize)(9,null,l)):d<I?(l=Math.floor(d/E),n?l===1?(0,u.localize)(10,null,l):(0,u.localize)(11,null,l):l===1?(0,u.localize)(12,null,l):(0,u.localize)(13,null,l)):d<F?(l=Math.floor(d/I),n?l===1?(0,u.localize)(14,null,l):(0,u.localize)(15,null,l):l===1?(0,u.localize)(16,null,l):(0,u.localize)(17,null,l)):d<T?(l=Math.floor(d/F),n?l===1?(0,u.localize)(18,null,l):(0,u.localize)(19,null,l):l===1?(0,u.localize)(20,null,l):(0,u.localize)(21,null,l)):d<C?(l=Math.floor(d/T),n?l===1?(0,u.localize)(22,null,l):(0,u.localize)(23,null,l):l===1?(0,u.localize)(24,null,l):(0,u.localize)(25,null,l)):(l=Math.floor(d/C),n?l===1?(0,u.localize)(26,null,l):(0,u.localize)(27,null,l):l===1?(0,u.localize)(28,null,l):(0,u.localize)(29,null,l))}e.fromNow=P;function t(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=t}),define(we[116],be([18,19]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(we[45],be([0,1,15,10,116]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function I(P,t){return t&&(P.stack||P.stacktrace)?E.localize(0,null,T(P),F(P.stack)||F(P.stacktrace)):T(P)}function F(P){return Array.isArray(P)?P.join(`
`):P}function T(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?E.localize(1,null,P.message):P.message||E.localize(2,null)}function C(P=null,t=!1){if(!P)return E.localize(3,null);if(Array.isArray(P)){const _=u.coalesce(P),n=C(_[0],t);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(P))return P;if(P.detail){const _=P.detail;if(_.error)return I(_.error,t);if(_.exception)return I(_.exception,t)}return P.stack?I(P,t):P.message?P.message:E.localize(5,null)}e.toErrorMessage=C}),define(we[117],be([18,19]),function(ne,e){return ne.create("vs/editor/common/config/editorOptions",e)}),define(we[118],be([0,1,117,26,119]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var I;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(I=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class T{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,ge){this._values[J]=ge}}e.ValidatedEditorOptions=T;class C{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=C;class P{constructor(J,ge,$e,Ge){this.id=J,this.name=ge,this.defaultValue=$e,this.schema=Ge}compute(J,ge,$e){return $e}}class t{constructor(J,ge=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(J){return this.defaultValue}}class _{constructor(J,ge,$e,Ge){this.id=J,this.name=ge,this.defaultValue=$e,this.schema=Ge}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,ge,$e){return $e}}function n(G,J){return typeof G=="undefined"?J:G==="false"?!1:Boolean(G)}e.boolean=n;class d extends _{constructor(J,ge,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="boolean",Ge.default=$e),super(J,ge,$e,Ge)}validate(J){return n(J,this.defaultValue)}}function l(G,J,ge,$e){if(typeof G=="undefined")return J;let Ge=parseInt(G,10);return isNaN(Ge)?J:(Ge=Math.max(ge,Ge),Ge=Math.min($e,Ge),Ge|0)}e.clampedInt=l;class c extends _{constructor(J,ge,$e,Ge,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=$e,ft.minimum=Ge,ft.maximum=rt),super(J,ge,$e,ft),this.minimum=Ge,this.maximum=rt}static clampedInt(J,ge,$e,Ge){return l(J,ge,$e,Ge)}validate(J){return c.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class p extends _{constructor(J,ge,$e,Ge,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=$e),super(J,ge,$e,rt),this.validationFn=Ge}static clamp(J,ge,$e){return J<ge?ge:J>$e?$e:J}static float(J,ge){if(typeof J=="number")return J;if(typeof J=="undefined")return ge;const $e=parseFloat(J);return isNaN($e)?ge:$e}validate(J){return this.validationFn(p.float(J,this.defaultValue))}}class D extends _{static string(J,ge){return typeof J!="string"?ge:J}constructor(J,ge,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.default=$e),super(J,ge,$e,Ge)}validate(J){return D.string(J,this.defaultValue)}}function w(G,J,ge){return typeof G!="string"||ge.indexOf(G)===-1?J:G}e.stringSet=w;class o extends _{constructor(J,ge,$e,Ge,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=Ge,rt.default=$e),super(J,ge,$e,rt),this._allowedValues=Ge}validate(J){return w(J,this.defaultValue,this._allowedValues)}}class f extends P{constructor(J,ge,$e,Ge,rt,ft,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=rt,ht.default=Ge),super(J,ge,$e,ht),this._allowedValues=rt,this._convert=ft}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function k(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[u.localize(0,null),u.localize(1,null),u.localize(2,null)],default:"auto",description:u.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,ge,$e){return $e===0?J.accessibilitySupport:$e}}class v extends P{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:u.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:u.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{insertSpace:n(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(m=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(G){switch(G){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function g(G){switch(G){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class b extends t{constructor(){super(126,[65,33])}compute(J,ge,$e){const Ge=["monaco-editor"];return ge.get(33)&&Ge.push(ge.get(33)),J.extraEditorClassName&&Ge.push(J.extraEditorClassName),ge.get(65)==="default"?Ge.push("mouse-default"):ge.get(65)==="copy"&&Ge.push("mouse-copy"),ge.get(99)&&Ge.push("showUnused"),ge.get(124)&&Ge.push("showDeprecated"),Ge.join(" ")}}class h extends d{constructor(){super(32,"emptySelectionClipboard",!0,{description:u.localize(6,null)})}compute(J,ge,$e){return $e&&J.emptySelectionClipboard}}class y extends P{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:u.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[u.localize(8,null),u.localize(9,null),u.localize(10,null)],description:u.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[u.localize(12,null),u.localize(13,null),u.localize(14,null)],description:u.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:u.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:u.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:u.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{cursorMoveOnType:n(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":w(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":w(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(ge.loop,this.defaultValue.loop)}}}class R extends P{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:u.localize(19,null)},{type:"string",description:u.localize(20,null)}],description:u.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?R.OFF:J==="true"?R.ON:J:Boolean(J)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class A extends t{constructor(){super(43)}compute(J,ge,$e){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:u.localize(22,null)})}validate(J){let ge=p.float(J,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(ge,6,100)}compute(J,ge,$e){return J.fontInfo.fontSize}}class O extends P{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:u.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:u.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(c.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class S extends P{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[u.localize(25,null),u.localize(26,null),u.localize(27,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:u.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:u.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:u.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:u.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:u.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:u.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:u.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:u.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:u.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:u.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:u.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{multiple:w(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??w(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??w(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??w(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??w(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??w(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:u.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:u.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:u.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:u.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:n(ge.enabled,this.defaultValue.enabled),delay:c.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:n(ge.sticky,this.defaultValue.sticky),above:n(ge.above,this.defaultValue.above)}}}var N;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class j extends t{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,ge,$e){return j.computeLayout(ge,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const ge=J.height/J.lineHeight,$e=J.scrollBeyondLastLine?ge-1:0,Ge=(J.viewLineCount+$e)/(J.pixelRatio*J.height),rt=Math.floor(J.viewLineCount/Ge);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:$e,desiredRatio:Ge,minimapLineCount:rt}}static _computeMinimapLayout(J,ge){const $e=J.outerWidth,Ge=J.outerHeight,rt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const ft=ge.stableMinimapLayoutInput,ht=ft&&J.outerHeight===ft.outerHeight&&J.lineHeight===ft.lineHeight&&J.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&J.pixelRatio===ft.pixelRatio&&J.scrollBeyondLastLine===ft.scrollBeyondLastLine&&J.minimap.enabled===ft.minimap.enabled&&J.minimap.side===ft.minimap.side&&J.minimap.size===ft.minimap.size&&J.minimap.showSlider===ft.minimap.showSlider&&J.minimap.renderCharacters===ft.minimap.renderCharacters&&J.minimap.maxColumn===ft.minimap.maxColumn&&J.minimap.scale===ft.minimap.scale&&J.verticalScrollbarWidth===ft.verticalScrollbarWidth&&J.isViewportWrapping===ft.isViewportWrapping,Dt=J.lineHeight,Tt=J.typicalHalfwidthCharacterWidth,It=J.scrollBeyondLastLine,Xe=J.minimap.renderCharacters;let pt=rt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ie=J.minimap.maxColumn,ye=J.minimap.size,De=J.minimap.side,Z=J.verticalScrollbarWidth,oe=J.viewLineCount,he=J.remainingWidth,de=J.isViewportWrapping,ke=Xe?2:3;let Le=Math.floor(rt*Ge);const Me=Le/rt;let ze=!1,it=!1,Re=ke*pt,ue=pt/rt,fe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:lt,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:ut}=j.computeContainedMinimapLineCount({viewLineCount:oe,scrollBeyondLastLine:It,height:Ge,lineHeight:Dt,pixelRatio:rt});if(oe/ut>1)ze=!0,it=!0,pt=1,Re=1,ue=pt/rt;else{let dt=!1,Pt=pt+1;if(ye==="fit"){const _t=Math.ceil((oe+Et)*Re);de&&ht&&he<=ge.stableFitRemainingWidth?(dt=!0,Pt=ge.stableFitMaxMinimapScale):dt=_t>Le}if(ye==="fill"||dt){ze=!0;const _t=pt;Re=Math.min(Dt*rt,Math.max(1,Math.floor(1/vt))),de&&ht&&he<=ge.stableFitRemainingWidth&&(Pt=ge.stableFitMaxMinimapScale),pt=Math.min(Pt,Math.max(1,Math.floor(Re/ke))),pt>_t&&(fe=Math.min(2,pt/_t)),ue=pt/rt/fe,Le=Math.ceil(Math.max(lt,oe+Et)*Re),de?(ge.stableMinimapLayoutInput=J,ge.stableFitRemainingWidth=he,ge.stableFitMaxMinimapScale=pt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const ie=Math.floor(Ie*ue),H=Math.min(ie,Math.max(0,Math.floor((he-Z-2)*ue/(Tt+ue)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(rt*H);const Ce=ve/rt;ve=Math.floor(ve*fe);const Ke=Xe?1:2,Ne=De==="left"?0:$e-H-Z;return{renderMinimap:Ke,minimapLeft:Ne,minimapWidth:H,minimapHeightIsEditorHeight:ze,minimapIsSampling:it,minimapScale:pt,minimapLineHeight:Re,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:Le,minimapCanvasOuterWidth:Ce,minimapCanvasOuterHeight:Me}}static computeLayout(J,ge){const $e=ge.outerWidth|0,Ge=ge.outerHeight|0,rt=ge.lineHeight|0,ft=ge.lineNumbersDigitCount|0,ht=ge.typicalHalfwidthCharacterWidth,Dt=ge.maxDigitWidth,Tt=ge.pixelRatio,It=ge.viewLineCount,Xe=J.get(121),pt=Xe==="inherit"?J.get(120):Xe,Ie=pt==="inherit"?J.get(116):pt,ye=J.get(119),De=J.get(2),Z=ge.isDominatedByLongLines,oe=J.get(49),he=J.get(59).renderType!==0,de=J.get(60),ke=J.get(93),Le=J.get(64),Me=J.get(91),ze=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,ue=Me.horizontalScrollbarSize,fe=J.get(57),ie=J.get(37);let H;if(typeof fe=="string"&&/^\d+(\.\d+)?ch$/.test(fe)){const St=parseFloat(fe.substr(0,fe.length-2));H=c.clampedInt(St*ht,0,0,1e3)}else H=c.clampedInt(fe,0,0,1e3);ie&&(H+=16);let ve=0;if(he){const St=Math.max(ft,de);ve=Math.round(St*Dt)}let Ce=0;oe&&(Ce=rt);let Ke=0,Ne=Ke+Ce,lt=Ne+ve,Et=lt+H;const vt=$e-Ce-ve-H;let ut=!1,gt=!1,dt=-1;De!==2&&(pt==="inherit"&&Z?(ut=!0,gt=!0):Ie==="on"||Ie==="bounded"?gt=!0:Ie==="wordWrapColumn"&&(dt=ye));const Pt=j._computeMinimapLayout({outerWidth:$e,outerHeight:Ge,lineHeight:rt,typicalHalfwidthCharacterWidth:ht,pixelRatio:Tt,scrollBeyondLastLine:ke,minimap:Le,verticalScrollbarWidth:ze,viewLineCount:It,remainingWidth:vt,isViewportWrapping:gt},ge.memory||new C);Pt.renderMinimap!==0&&Pt.minimapLeft===0&&(Ke+=Pt.minimapWidth,Ne+=Pt.minimapWidth,lt+=Pt.minimapWidth,Et+=Pt.minimapWidth);const _t=vt-Pt.minimapWidth,$t=Math.max(1,Math.floor((_t-ze-2)/ht)),jt=it?Re:0;return gt&&(dt=Math.max(1,$t),Ie==="bounded"&&(dt=Math.min(dt,ye))),{width:$e,height:Ge,glyphMarginLeft:Ke,glyphMarginWidth:Ce,lineNumbersLeft:Ne,lineNumbersWidth:ve,decorationsLeft:lt,decorationsWidth:H,contentLeft:Et,contentWidth:_t,minimap:Pt,viewportColumn:$t,isWordWrapMinified:ut,isViewportWrapping:gt,wrappingColumn:dt,verticalScrollbarWidth:ze,horizontalScrollbarHeight:ue,overviewRuler:{top:jt,width:ze,height:Ge-2*jt,right:0}}}}e.EditorLayoutInfoComputer=j;class W extends P{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:u.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class $ extends P{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:u.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:u.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:n(ge.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class V extends p{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>p.clamp(J,0,150),{markdownDescription:u.localize(47,null)})}compute(J,ge,$e){return J.fontInfo.lineHeight}}class q extends P{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:u.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[u.localize(49,null),u.localize(50,null),u.localize(51,null)],default:J.size,description:u.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:u.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:u.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:u.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:u.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:u.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:n(ge.enabled,this.defaultValue.enabled),size:w(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(ge.side,this.defaultValue.side,["right","left"]),showSlider:w(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(ge.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ge.scale,1,1,3),maxColumn:c.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function re(G){return G==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ae extends P{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:u.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{top:c.clampedInt(ge.top,0,0,1e3),bottom:c.clampedInt(ge.bottom,0,0,1e3)}}}class pe extends P{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:u.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:u.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:n(ge.enabled,this.defaultValue.enabled),cycle:n(ge.cycle,this.defaultValue.cycle)}}}class me extends t{constructor(){super(127)}compute(J,ge,$e){return J.pixelRatio}}class Fe extends P{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:u.localize(62,null)},comments:{type:"boolean",default:J.comments,description:u.localize(63,null)},other:{type:"boolean",default:J.other,description:u.localize(64,null)}}}],default:J,description:u.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const ge=J,$e={other:n(ge.other,this.defaultValue.other),comments:n(ge.comments,this.defaultValue.comments),strings:n(ge.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var Ye;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Ye=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ue extends P{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[u.localize(66,null),u.localize(67,null),u.localize(68,null),u.localize(69,null)],default:"on",description:u.localize(70,null)})}validate(J){let ge=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(ge=4,$e=J):J==="interval"?ge=3:J==="relative"?ge=2:J==="on"?ge=1:ge=0),{renderType:ge,renderFn:$e}}}function Ve(G){const J=G.get(86);return J==="editable"?G.get(80):J!=="on"}e.filterValidationDecorations=Ve;class Je extends P{constructor(){const J=[],ge={type:"number",description:u.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:u.localize(72,null),format:"color-hex"}}}]},default:J,description:u.localize(73,null)})}validate(J){if(Array.isArray(J)){let ge=[];for(let $e of J)if(typeof $e=="number")ge.push({column:c.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const Ge=$e;ge.push({column:c.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return ge.sort(($e,Ge)=>$e.column-Ge.column),ge}return this.defaultValue}}function je(G,J){if(typeof G!="string")return J;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends P{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(74,null),u.localize(75,null),u.localize(76,null)],default:"auto",description:u.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[u.localize(78,null),u.localize(79,null),u.localize(80,null)],default:"auto",description:u.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:u.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:u.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:u.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J,$e=c.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=c.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(ge.vertical,this.defaultValue.vertical),horizontal:je(ge.horizontal,this.defaultValue.horizontal),useShadows:n(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:c.clampedInt(ge.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:c.clampedInt(ge.verticalSliderSize,Ge,0,1e3),scrollByPage:n(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends P{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:u.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{enabled:n(ge.enabled,this.defaultValue.enabled),mode:w(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class Q extends P{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:u.localize(86,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class X extends P{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(87,null),u.localize(88,null),u.localize(89,null)],default:J.bracketPairs,description:u.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[u.localize(91,null),u.localize(92,null),u.localize(93,null)],default:J.bracketPairsHorizontal,description:u.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:u.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:u.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:u.localize(97,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{bracketPairs:se(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:se(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function se(G,J,ge){const $e=ge.indexOf(G);return $e===-1?J:ge[$e]}class K extends P{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[u.localize(98,null),u.localize(99,null)],default:J.insertMode,description:u.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:u.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:u.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:u.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:u.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:u.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:u.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:u.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:u.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:u.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:u.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:u.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:u.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:u.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:u.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:u.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:u.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:u.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:u.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:u.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:u.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:u.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:u.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:u.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:u.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:u.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:u.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:u.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:u.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:u.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:u.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:u.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:u.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:u.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:u.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:u.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:u.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:u.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:u.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:u.localize(139,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const ge=J;return{insertMode:w(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(ge.showIcons,this.defaultValue.showIcons),showStatusBar:n(ge.showStatusBar,this.defaultValue.showStatusBar),preview:n(ge.preview,this.defaultValue.preview),previewMode:w(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(ge.showMethods,this.defaultValue.showMethods),showFunctions:n(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:n(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:n(ge.showFields,this.defaultValue.showFields),showVariables:n(ge.showVariables,this.defaultValue.showVariables),showClasses:n(ge.showClasses,this.defaultValue.showClasses),showStructs:n(ge.showStructs,this.defaultValue.showStructs),showInterfaces:n(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:n(ge.showModules,this.defaultValue.showModules),showProperties:n(ge.showProperties,this.defaultValue.showProperties),showEvents:n(ge.showEvents,this.defaultValue.showEvents),showOperators:n(ge.showOperators,this.defaultValue.showOperators),showUnits:n(ge.showUnits,this.defaultValue.showUnits),showValues:n(ge.showValues,this.defaultValue.showValues),showConstants:n(ge.showConstants,this.defaultValue.showConstants),showEnums:n(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:n(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(ge.showKeywords,this.defaultValue.showKeywords),showWords:n(ge.showWords,this.defaultValue.showWords),showColors:n(ge.showColors,this.defaultValue.showColors),showFiles:n(ge.showFiles,this.defaultValue.showFiles),showReferences:n(ge.showReferences,this.defaultValue.showReferences),showFolders:n(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:n(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(ge.showSnippets,this.defaultValue.showSnippets),showUsers:n(ge.showUsers,this.defaultValue.showUsers),showIssues:n(ge.showIssues,this.defaultValue.showIssues)}}}class te extends P{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:u.localize(140,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ce extends t{constructor(){super(128,[80])}compute(J,ge,$e){return ge.get(80)?!0:J.tabFocusMode}}var Pe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Pe=e.WrappingIndent||(e.WrappingIndent={}));function Oe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class We extends t{constructor(){super(130,[129])}compute(J,ge,$e){const Ge=ge.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}const qe="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",st="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?st:qe,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function _e(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=42]="fontFamily",G[G.fontInfo=43]="fontInfo",G[G.fontLigatures=44]="fontLigatures",G[G.fontSize=45]="fontSize",G[G.fontWeight=46]="fontWeight",G[G.formatOnPaste=47]="formatOnPaste",G[G.formatOnType=48]="formatOnType",G[G.glyphMargin=49]="glyphMargin",G[G.gotoLocation=50]="gotoLocation",G[G.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",G[G.hover=52]="hover",G[G.inDiffEditor=53]="inDiffEditor",G[G.inlineSuggest=54]="inlineSuggest",G[G.letterSpacing=55]="letterSpacing",G[G.lightbulb=56]="lightbulb",G[G.lineDecorationsWidth=57]="lineDecorationsWidth",G[G.lineHeight=58]="lineHeight",G[G.lineNumbers=59]="lineNumbers",G[G.lineNumbersMinChars=60]="lineNumbersMinChars",G[G.linkedEditing=61]="linkedEditing",G[G.links=62]="links",G[G.matchBrackets=63]="matchBrackets",G[G.minimap=64]="minimap",G[G.mouseStyle=65]="mouseStyle",G[G.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=67]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",G[G.multiCursorModifier=69]="multiCursorModifier",G[G.multiCursorPaste=70]="multiCursorPaste",G[G.occurrencesHighlight=71]="occurrencesHighlight",G[G.overviewRulerBorder=72]="overviewRulerBorder",G[G.overviewRulerLanes=73]="overviewRulerLanes",G[G.padding=74]="padding",G[G.parameterHints=75]="parameterHints",G[G.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",G[G.quickSuggestions=78]="quickSuggestions",G[G.quickSuggestionsDelay=79]="quickSuggestionsDelay",G[G.readOnly=80]="readOnly",G[G.renameOnType=81]="renameOnType",G[G.renderControlCharacters=82]="renderControlCharacters",G[G.renderFinalNewline=83]="renderFinalNewline",G[G.renderLineHighlight=84]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=86]="renderValidationDecorations",G[G.renderWhitespace=87]="renderWhitespace",G[G.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",G[G.roundedSelection=89]="roundedSelection",G[G.rulers=90]="rulers",G[G.scrollbar=91]="scrollbar",G[G.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=93]="scrollBeyondLastLine",G[G.scrollPredominantAxis=94]="scrollPredominantAxis",G[G.selectionClipboard=95]="selectionClipboard",G[G.selectionHighlight=96]="selectionHighlight",G[G.selectOnLineNumbers=97]="selectOnLineNumbers",G[G.showFoldingControls=98]="showFoldingControls",G[G.showUnused=99]="showUnused",G[G.snippetSuggestions=100]="snippetSuggestions",G[G.smartSelect=101]="smartSelect",G[G.smoothScrolling=102]="smoothScrolling",G[G.stickyTabStops=103]="stickyTabStops",G[G.stopRenderingLineAfter=104]="stopRenderingLineAfter",G[G.suggest=105]="suggest",G[G.suggestFontSize=106]="suggestFontSize",G[G.suggestLineHeight=107]="suggestLineHeight",G[G.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",G[G.suggestSelection=109]="suggestSelection",G[G.tabCompletion=110]="tabCompletion",G[G.tabIndex=111]="tabIndex",G[G.unusualLineTerminators=112]="unusualLineTerminators",G[G.useShadowDOM=113]="useShadowDOM",G[G.useTabStops=114]="useTabStops",G[G.wordSeparators=115]="wordSeparators",G[G.wordWrap=116]="wordWrap",G[G.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=119]="wordWrapColumn",G[G.wordWrapOverride1=120]="wordWrapOverride1",G[G.wordWrapOverride2=121]="wordWrapOverride2",G[G.wrappingIndent=122]="wrappingIndent",G[G.wrappingStrategy=123]="wrappingStrategy",G[G.showDeprecated=124]="showDeprecated",G[G.inlayHints=125]="inlayHints",G[G.editorClassName=126]="editorClassName",G[G.pixelRatio=127]="pixelRatio",G[G.tabFocusMode=128]="tabFocusMode",G[G.layoutInfo=129]="layoutInfo",G[G.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:u.localize(141,null)})),acceptSuggestionOnEnter:_e(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",u.localize(142,null),""],markdownDescription:u.localize(143,null)})),accessibilitySupport:_e(new r),accessibilityPageSize:_e(new c(3,"accessibilityPageSize",10,1,1073741824,{description:u.localize(144,null)})),ariaLabel:_e(new D(4,"ariaLabel",u.localize(145,null))),autoClosingBrackets:_e(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(146,null),u.localize(147,null),""],description:u.localize(148,null)})),autoClosingDelete:_e(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",u.localize(149,null),""],description:u.localize(150,null)})),autoClosingOvertype:_e(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",u.localize(151,null),""],description:u.localize(152,null)})),autoClosingQuotes:_e(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",u.localize(153,null),u.localize(154,null),""],description:u.localize(155,null)})),autoIndent:_e(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],k,{enumDescriptions:[u.localize(156,null),u.localize(157,null),u.localize(158,null),u.localize(159,null),u.localize(160,null)],description:u.localize(161,null)})),automaticLayout:_e(new d(10,"automaticLayout",!1)),autoSurround:_e(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[u.localize(162,null),u.localize(163,null),u.localize(164,null),""],description:u.localize(165,null)})),bracketPairColorization:_e(new Q),bracketPairGuides:_e(new X),stickyTabStops:_e(new d(103,"stickyTabStops",!1,{description:u.localize(166,null)})),codeLens:_e(new d(14,"codeLens",!0,{description:u.localize(167,null)})),codeLensFontFamily:_e(new D(15,"codeLensFontFamily","",{description:u.localize(168,null)})),codeLensFontSize:_e(new c(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:u.localize(169,null)})),colorDecorators:_e(new d(17,"colorDecorators",!0,{description:u.localize(170,null)})),columnSelection:_e(new d(18,"columnSelection",!1,{description:u.localize(171,null)})),comments:_e(new v),contextmenu:_e(new d(20,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new d(21,"copyWithSyntaxHighlighting",!0,{description:u.localize(172,null)})),cursorBlinking:_e(new f(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:u.localize(173,null)})),cursorSmoothCaretAnimation:_e(new d(23,"cursorSmoothCaretAnimation",!1,{description:u.localize(174,null)})),cursorStyle:_e(new f(24,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:u.localize(175,null)})),cursorSurroundingLines:_e(new c(25,"cursorSurroundingLines",0,0,1073741824,{description:u.localize(176,null)})),cursorSurroundingLinesStyle:_e(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[u.localize(177,null),u.localize(178,null)],description:u.localize(179,null)})),cursorWidth:_e(new c(27,"cursorWidth",0,0,1073741824,{markdownDescription:u.localize(180,null)})),disableLayerHinting:_e(new d(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new d(29,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new d(30,"domReadOnly",!1)),dragAndDrop:_e(new d(31,"dragAndDrop",!0,{description:u.localize(181,null)})),emptySelectionClipboard:_e(new h),extraEditorClassName:_e(new D(33,"extraEditorClassName","")),fastScrollSensitivity:_e(new p(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:u.localize(182,null)})),find:_e(new y),fixedOverflowWidgets:_e(new d(36,"fixedOverflowWidgets",!1)),folding:_e(new d(37,"folding",!0,{description:u.localize(183,null)})),foldingStrategy:_e(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[u.localize(184,null),u.localize(185,null)],description:u.localize(186,null)})),foldingHighlight:_e(new d(39,"foldingHighlight",!0,{description:u.localize(187,null)})),foldingImportsByDefault:_e(new d(40,"foldingImportsByDefault",!1,{description:u.localize(188,null)})),unfoldOnClickAfterEndOfLine:_e(new d(41,"unfoldOnClickAfterEndOfLine",!1,{description:u.localize(189,null)})),fontFamily:_e(new D(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:u.localize(190,null)})),fontInfo:_e(new A),fontLigatures2:_e(new R),fontSize:_e(new B),fontWeight:_e(new O),formatOnPaste:_e(new d(47,"formatOnPaste",!1,{description:u.localize(191,null)})),formatOnType:_e(new d(48,"formatOnType",!1,{description:u.localize(192,null)})),glyphMargin:_e(new d(49,"glyphMargin",!0,{description:u.localize(193,null)})),gotoLocation:_e(new S),hideCursorInOverviewRuler:_e(new d(51,"hideCursorInOverviewRuler",!1,{description:u.localize(194,null)})),hover:_e(new x),inDiffEditor:_e(new d(53,"inDiffEditor",!1)),letterSpacing:_e(new p(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>p.clamp(G,-5,20),{description:u.localize(195,null)})),lightbulb:_e(new W),lineDecorationsWidth:_e(new _(57,"lineDecorationsWidth",10)),lineHeight:_e(new V),lineNumbers:_e(new Ue),lineNumbersMinChars:_e(new c(60,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new d(61,"linkedEditing",!1,{description:u.localize(196,null)})),links:_e(new d(62,"links",!0,{description:u.localize(197,null)})),matchBrackets:_e(new o(63,"matchBrackets","always",["always","near","never"],{description:u.localize(198,null)})),minimap:_e(new q),mouseStyle:_e(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new p(66,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:u.localize(199,null)})),mouseWheelZoom:_e(new d(67,"mouseWheelZoom",!1,{markdownDescription:u.localize(200,null)})),multiCursorMergeOverlapping:_e(new d(68,"multiCursorMergeOverlapping",!0,{description:u.localize(201,null)})),multiCursorModifier:_e(new f(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],re,{markdownEnumDescriptions:[u.localize(202,null),u.localize(203,null)],markdownDescription:u.localize(204,null)})),multiCursorPaste:_e(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[u.localize(205,null),u.localize(206,null)],markdownDescription:u.localize(207,null)})),occurrencesHighlight:_e(new d(71,"occurrencesHighlight",!0,{description:u.localize(208,null)})),overviewRulerBorder:_e(new d(72,"overviewRulerBorder",!0,{description:u.localize(209,null)})),overviewRulerLanes:_e(new c(73,"overviewRulerLanes",3,0,3)),padding:_e(new ae),parameterHints:_e(new pe),peekWidgetDefaultFocus:_e(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[u.localize(210,null),u.localize(211,null)],description:u.localize(212,null)})),definitionLinkOpensInPeek:_e(new d(77,"definitionLinkOpensInPeek",!1,{description:u.localize(213,null)})),quickSuggestions:_e(new Fe),quickSuggestionsDelay:_e(new c(79,"quickSuggestionsDelay",10,0,1073741824,{description:u.localize(214,null)})),readOnly:_e(new d(80,"readOnly",!1)),renameOnType:_e(new d(81,"renameOnType",!1,{description:u.localize(215,null),markdownDeprecationMessage:u.localize(216,null)})),renderControlCharacters:_e(new d(82,"renderControlCharacters",!0,{description:u.localize(217,null),restricted:!0})),renderFinalNewline:_e(new d(83,"renderFinalNewline",!0,{description:u.localize(218,null)})),renderLineHighlight:_e(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",u.localize(219,null)],description:u.localize(220,null)})),renderLineHighlightOnlyWhenFocus:_e(new d(85,"renderLineHighlightOnlyWhenFocus",!1,{description:u.localize(221,null)})),renderValidationDecorations:_e(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",u.localize(222,null),u.localize(223,null),u.localize(224,null),""],description:u.localize(225,null)})),revealHorizontalRightPadding:_e(new c(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new d(89,"roundedSelection",!0,{description:u.localize(226,null)})),rulers:_e(new Je),scrollbar:_e(new Qe),scrollBeyondLastColumn:_e(new c(92,"scrollBeyondLastColumn",5,0,1073741824,{description:u.localize(227,null)})),scrollBeyondLastLine:_e(new d(93,"scrollBeyondLastLine",!0,{description:u.localize(228,null)})),scrollPredominantAxis:_e(new d(94,"scrollPredominantAxis",!0,{description:u.localize(229,null)})),selectionClipboard:_e(new d(95,"selectionClipboard",!0,{description:u.localize(230,null),included:M.isLinux})),selectionHighlight:_e(new d(96,"selectionHighlight",!0,{description:u.localize(231,null)})),selectOnLineNumbers:_e(new d(97,"selectOnLineNumbers",!0)),showFoldingControls:_e(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[u.localize(232,null),u.localize(233,null)],description:u.localize(234,null)})),showUnused:_e(new d(99,"showUnused",!0,{description:u.localize(235,null)})),showDeprecated:_e(new d(124,"showDeprecated",!0,{description:u.localize(236,null)})),inlayHints:_e(new $),snippetSuggestions:_e(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[u.localize(237,null),u.localize(238,null),u.localize(239,null),u.localize(240,null)],description:u.localize(241,null)})),smartSelect:_e(new te),smoothScrolling:_e(new d(102,"smoothScrolling",!1,{description:u.localize(242,null)})),stopRenderingLineAfter:_e(new c(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new K),inlineSuggest:_e(new z),suggestFontSize:_e(new c(106,"suggestFontSize",0,0,1e3,{markdownDescription:u.localize(243,null)})),suggestLineHeight:_e(new c(107,"suggestLineHeight",0,0,1e3,{markdownDescription:u.localize(244,null)})),suggestOnTriggerCharacters:_e(new d(108,"suggestOnTriggerCharacters",!0,{description:u.localize(245,null)})),suggestSelection:_e(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[u.localize(246,null),u.localize(247,null),u.localize(248,null)],description:u.localize(249,null)})),tabCompletion:_e(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[u.localize(250,null),u.localize(251,null),u.localize(252,null)],description:u.localize(253,null)})),tabIndex:_e(new c(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[u.localize(254,null),u.localize(255,null),u.localize(256,null)],description:u.localize(257,null)})),useShadowDOM:_e(new d(113,"useShadowDOM",!0)),useTabStops:_e(new d(114,"useTabStops",!0,{description:u.localize(258,null)})),wordSeparators:_e(new D(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:u.localize(259,null)})),wordWrap:_e(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[u.localize(260,null),u.localize(261,null),u.localize(262,null),u.localize(263,null)],description:u.localize(264,null)})),wordWrapBreakAfterCharacters:_e(new D(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new D(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new c(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:u.localize(265,null)})),wordWrapOverride1:_e(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new f(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[u.localize(266,null),u.localize(267,null),u.localize(268,null),u.localize(269,null)],description:u.localize(270,null)})),wrappingStrategy:_e(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[u.localize(271,null),u.localize(272,null)],description:u.localize(273,null)})),editorClassName:_e(new b),pixelRatio:_e(new me),tabFocusMode:_e(new ce),layoutInfo:_e(new j),wrappingInfo:_e(new We)}}),define(we[120],be([18,19]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[121],be([18,19]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[122],be([18,19]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(we[123],be([18,19]),function(ne,e){return ne.create("vs/platform/markers/common/markers",e)}),define(we[124],be([18,19]),function(ne,e){return ne.create("vs/platform/theme/common/iconRegistry",e)}),define(we[125],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[126],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[127],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostProgress",e)}),define(we[128],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[129],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[130],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[131],be([18,19]),function(ne,e){return ne.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[132],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/editor",e)}),define(we[133],be([18,19]),function(ne,e){return ne.create("vs/workbench/common/views",e)}),define(we[134],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[135],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[136],be([18,19]),function(ne,e){return ne.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[137],be([18,19]),function(ne,e){return ne.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[138],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var u;(function(F){F[F.ACTIVATE=1]="ACTIVATE",F[F.RESTORE=2]="RESTORE",F[F.PRESERVE=3]="PRESERVE"})(u=e.EditorActivation||(e.EditorActivation={}));var M;(function(F){F[F.PICK=0]="PICK",F[F.DISABLED=1]="DISABLED",F[F.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(F){F[F.API=0]="API",F[F.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var I;(function(F){F[F.Center=0]="Center",F[F.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",F[F.NearTop=2]="NearTop",F[F.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(I=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[139],be([0,1,121]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=I;function F(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=n.match(M);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=F;function T(n){if(!n)return null;let d=n.majorBase,l=n.majorMustEqual,c=n.minorBase,p=n.minorMustEqual,D=n.patchBase,w=n.patchMustEqual;n.hasCaret&&(d===0||(p=!1),w=!1);let o=0;if(n.preRelease){const f=E.exec(n.preRelease);if(f){const[,k,r,v]=f;o=Date.UTC(Number(k),Number(r)-1,Number(v))}}return{majorBase:d,majorMustEqual:l,minorBase:c,minorMustEqual:p,patchBase:D,patchMustEqual:w,isMinimum:n.hasGreaterEquals,notBefore:o}}e.normalizeVersion=T;function C(n,d,l){let c;typeof n=="string"?c=T(F(n)):c=n;let p;d instanceof Date?p=d.getTime():typeof d=="string"&&(p=new Date(d).getTime());let D;if(typeof l=="string"?D=T(F(l)):D=l,!c||!D)return!1;let w=c.majorBase,o=c.minorBase,f=c.patchBase,k=D.majorBase,r=D.minorBase,v=D.patchBase,s=D.notBefore,i=D.majorMustEqual,m=D.minorMustEqual,a=D.patchMustEqual;return D.isMinimum?w>k?!0:w<k?!1:o>r?!0:o<r||p&&p<s?!1:f>=v:(w===1&&k===0&&(!i||!m||!a)&&(k=1,r=0,v=0,i=!0,m=!1,a=!1),w<k?!1:w>k?!i:o<r?!1:o>r?!m:f<v?!1:f>v?!a:!(p&&p<s))}e.isValidVersion=C;function P(n,d,l,c){return l.isBuiltin||typeof l.main=="undefined"?!0:_(n,d,l.engines.vscode,c)}e.isValidExtensionVersion=P;function t(n,d,l){return n==="*"||_(d,l,n)}e.isEngineValid=t;function _(n,d,l,c=[]){let p=T(F(l));if(!p)return c.push(u.localize(0,null,l)),!1;if(p.majorBase===0){if(!p.majorMustEqual||!p.minorMustEqual)return c.push(u.localize(1,null,l)),!1}else if(!p.majorMustEqual)return c.push(u.localize(2,null,l)),!1;return C(n,d,p)?!0:(c.push(u.localize(3,null,n,l)),!1)}}),define(we[81],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class u{constructor(E,I=[],F=!1){this.ctor=E,this.staticArguments=I,this.supportsDelayedInstantiation=F}}e.SyncDescriptor=u}),define(we[58],be([0,1,81]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(F,T,C){T instanceof u.SyncDescriptor||(T=new u.SyncDescriptor(T,[],C)),M.push([F,T])}e.registerSingleton=E;function I(){return M}e.getSingletonServiceDescriptors=I}),define(we[140],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class u{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}e.Node=u;class M{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let F of this._nodes.values())F.outgoing.size===0&&I.push(F);return I}insertEdge(I,F){const T=this.lookupOrInsertNode(I),C=this.lookupOrInsertNode(F);T.outgoing.set(this._hashFn(F),C),C.incoming.set(this._hashFn(I),T)}removeNode(I){const F=this._hashFn(I);this._nodes.delete(F);for(let T of this._nodes.values())T.outgoing.delete(F),T.incoming.delete(F)}lookupOrInsertNode(I){const F=this._hashFn(I);let T=this._nodes.get(F);return T||(T=new u(I),this._nodes.set(F,T)),T}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[F,T]of this._nodes)I.push(`${F}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,F]of this._nodes){const T=new Set([I]),C=this._findCycle(F,T);if(C)return C}}_findCycle(I,F){for(let[T,C]of I.outgoing){if(F.has(T))return[...F,T].join(" -> ");F.add(T);const P=this._findCycle(C,F);if(P)return P;F.delete(T)}}}e.Graph=M}),define(we[4],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var u;(function(F){F.serviceIds=new Map,F.DI_TARGET="$di$target",F.DI_DEPENDENCIES="$di$dependencies";function T(C){return C[F.DI_DEPENDENCIES]||[]}F.getServiceDependencies=T})(u=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(F,T,C,P){T[u.DI_TARGET]===T?T[u.DI_DEPENDENCIES].push({id:F,index:C,optional:P}):(T[u.DI_DEPENDENCIES]=[{id:F,index:C,optional:P}],T[u.DI_TARGET]=T)}function E(F){if(u.serviceIds.has(F))return u.serviceIds.get(F);const T=function(C,P,t){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(T,C,t,!1)};return T.toString=()=>F,u.serviceIds.set(F,T),T}e.createDecorator=E;function I(F){return F}e.refineServiceDecorator=I}),define(we[141],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,u.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(we[142],be([0,1,3,59,6,20,75,57,141]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(c){return typeof c=="string"?!1:Array.isArray(c)?c.every(P):!!c.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new u.Emitter}get onDidChange(){return this._onDidChange.event}register(p,D){let w={selector:p,provider:D,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(w){let o=this._entries.indexOf(w);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(p){return this.all(p).length>0}all(p){if(!p)return[];this._updateScores(p);const D=[];for(let w of this._entries)w._score>0&&D.push(w.provider);return D}ordered(p){const D=[];return this._orderedForEach(p,w=>D.push(w.provider)),D}orderedGroups(p){const D=[];let w,o;return this._orderedForEach(p,f=>{w&&o===f._score?w.push(f.provider):(o=f._score,w=[f.provider],D.push(w))}),D}_orderedForEach(p,D){if(!!p){this._updateScores(p);for(const w of this._entries)w._score>0&&D(w)}}_updateScores(p){let D={uri:p.uri.toString(),language:p.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===D.language&&this._lastCandidate.uri===D.uri)){this._lastCandidate=D;for(let w of this._entries)if(w._score=(0,T.score)(w.selector,p.uri,p.getLanguageId(),(0,C.shouldSynchronizeModel)(p)),P(w.selector)&&w._score>0){for(let o of this._entries)o._score=0;w._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(p,D){return p._score<D._score?1:p._score>D._score?-1:p._time<D._time?1:p._time>D._time?-1:0}}e.LanguageFeatureRegistry=t;const _=new WeakMap;let n=0;function d(c){let p=_.get(c);return p===void 0&&(p=++n,_.set(c,p)),p}class l{constructor(p,D,w=Number.MAX_SAFE_INTEGER){this._registry=p,this.min=D,this.max=w,this._cache=new I.LRUCache(50,.7)}_key(p){return p.id+this._registry.all(p).reduce((D,w)=>(0,M.doHash)(d(w),D),0)}_clamp(p){return p===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(p*1.3)))}get(p){const D=this._key(p),w=this._cache.get(D);return this._clamp(w?.value)}update(p,D){const w=this._key(p);let o=this._cache.get(w);return o||(o=new F.MovingAverage,this._cache.set(w,o)),o.update(D),this.get(p)}}e.LanguageFeatureRequestDelays=l}),define(we[60],be([0,1,2,44,142,113,34]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var T;(function(h){h[h.Null=0]="Null",h[h.PlainText=1]="PlainText"})(T=e.LanguageId||(e.LanguageId={}));var C;(function(h){h[h.NotSet=-1]="NotSet",h[h.None=0]="None",h[h.Italic=1]="Italic",h[h.Bold=2]="Bold",h[h.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var P;(function(h){h[h.None=0]="None",h[h.DefaultForeground=1]="DefaultForeground",h[h.DefaultBackground=2]="DefaultBackground"})(P=e.ColorId||(e.ColorId={}));var t;(function(h){h[h.Other=0]="Other",h[h.Comment=1]="Comment",h[h.String=2]="String",h[h.RegEx=4]="RegEx"})(t=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(h){h[h.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",h[h.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",h[h.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",h[h.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",h[h.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",h[h.ITALIC_MASK=2048]="ITALIC_MASK",h[h.BOLD_MASK=4096]="BOLD_MASK",h[h.UNDERLINE_MASK=8192]="UNDERLINE_MASK",h[h.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",h[h.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",h[h.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",h[h.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",h[h.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",h[h.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",h[h.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",h[h.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",h[h.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",h[h.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),A="mtk"+R,B=this.getFontStyle(y);return B&1&&(A+=" mtki"),B&2&&(A+=" mtkb"),B&4&&(A+=" mtku"),A}static getInlineStyleFromMetadata(y,R){const A=this.getForeground(y),B=this.getFontStyle(y);let O=`color: ${R[A]};`;return B&1&&(O+="font-style: italic;"),B&2&&(O+="font-weight: bold;"),B&4&&(O+="text-decoration: underline;"),O}}e.TokenMetadata=n;var d;(function(h){h[h.Method=0]="Method",h[h.Function=1]="Function",h[h.Constructor=2]="Constructor",h[h.Field=3]="Field",h[h.Variable=4]="Variable",h[h.Class=5]="Class",h[h.Struct=6]="Struct",h[h.Interface=7]="Interface",h[h.Module=8]="Module",h[h.Property=9]="Property",h[h.Event=10]="Event",h[h.Operator=11]="Operator",h[h.Unit=12]="Unit",h[h.Value=13]="Value",h[h.Constant=14]="Constant",h[h.Enum=15]="Enum",h[h.EnumMember=16]="EnumMember",h[h.Keyword=17]="Keyword",h[h.Text=18]="Text",h[h.Color=19]="Color",h[h.File=20]="File",h[h.Reference=21]="Reference",h[h.Customcolor=22]="Customcolor",h[h.Folder=23]="Folder",h[h.TypeParameter=24]="TypeParameter",h[h.User=25]="User",h[h.Issue=26]="Issue",h[h.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let h=Object.create(null);return h[0]="symbol-method",h[1]="symbol-function",h[2]="symbol-constructor",h[3]="symbol-field",h[4]="symbol-variable",h[5]="symbol-class",h[6]="symbol-struct",h[7]="symbol-interface",h[8]="symbol-module",h[9]="symbol-property",h[10]="symbol-event",h[11]="symbol-operator",h[12]="symbol-unit",h[13]="symbol-value",h[14]="symbol-constant",h[15]="symbol-enum",h[16]="symbol-enum-member",h[17]="symbol-keyword",h[27]="symbol-snippet",h[18]="symbol-text",h[19]="symbol-color",h[20]="symbol-file",h[21]="symbol-reference",h[22]="symbol-customcolor",h[23]="symbol-folder",h[24]="symbol-type-parameter",h[25]="account",h[26]="issues",function(y){const R=h[y];let A=R&&F.iconRegistry.get(R);return A||(console.info("No codicon found for CompletionItemKind "+y),A=F.Codicon.symbolProperty),A.classNames}}(),e.completionKindFromString=function(){let h=Object.create(null);return h.method=0,h.function=1,h.constructor=2,h.field=3,h.variable=4,h.class=5,h.struct=6,h.interface=7,h.module=8,h.property=9,h.event=10,h.operator=11,h.unit=12,h.value=13,h.constant=14,h.enum=15,h["enum-member"]=16,h.enumMember=16,h.keyword=17,h.snippet=27,h.text=18,h.color=19,h.file=20,h.reference=21,h.customcolor=22,h.folder=23,h["type-parameter"]=24,h.typeParameter=24,h.account=25,h.issue=26,function(y,R){let A=h[y];return typeof A=="undefined"&&!R&&(A=9),A}}();var l;(function(h){h[h.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var c;(function(h){h[h.KeepWhitespace=1]="KeepWhitespace",h[h.InsertAsSnippet=4]="InsertAsSnippet"})(c=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(h){h[h.Invoke=0]="Invoke",h[h.TriggerCharacter=1]="TriggerCharacter",h[h.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(h){h[h.Automatic=0]="Automatic",h[h.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var w;(function(h){h[h.Invoke=1]="Invoke",h[h.Auto=2]="Auto"})(w=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(h){h[h.Invoke=1]="Invoke",h[h.TriggerCharacter=2]="TriggerCharacter",h[h.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var f;(function(h){h[h.Text=0]="Text",h[h.Read=1]="Read",h[h.Write=2]="Write"})(f=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function k(h){return h&&u.URI.isUri(h.uri)&&M.Range.isIRange(h.range)&&(M.Range.isIRange(h.originSelectionRange)||M.Range.isIRange(h.targetSelectionRange))}e.isLocationLink=k;var r;(function(h){h[h.File=0]="File",h[h.Module=1]="Module",h[h.Namespace=2]="Namespace",h[h.Package=3]="Package",h[h.Class=4]="Class",h[h.Method=5]="Method",h[h.Property=6]="Property",h[h.Field=7]="Field",h[h.Constructor=8]="Constructor",h[h.Enum=9]="Enum",h[h.Interface=10]="Interface",h[h.Function=11]="Function",h[h.Variable=12]="Variable",h[h.Constant=13]="Constant",h[h.String=14]="String",h[h.Number=15]="Number",h[h.Boolean=16]="Boolean",h[h.Array=17]="Array",h[h.Object=18]="Object",h[h.Key=19]="Key",h[h.Null=20]="Null",h[h.EnumMember=21]="EnumMember",h[h.Struct=22]="Struct",h[h.Event=23]="Event",h[h.Operator=24]="Operator",h[h.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var v;(function(h){h[h.Deprecated=1]="Deprecated"})(v=e.SymbolTag||(e.SymbolTag={}));var s;(function(h){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function A(S){return y.get(S)}h.fromString=A;function B(S){return R.get(S)}h.toString=B;function O(S,x){const N=R.get(S);let j=N&&F.iconRegistry.get("symbol-"+N);return j||(console.info("No codicon found for SymbolKind "+S),j=F.Codicon.symbolProperty),`${x?"inline":"block"} ${j.classNames}`}h.toCssClassName=O})(s=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(y){this.value=y}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var m;(function(h){h[h.Collapsed=0]="Collapsed",h[h.Expanded=1]="Expanded"})(m=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(h){h[h.Editing=0]="Editing",h[h.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var g;(function(h){h[h.Other=0]="Other",h[h.Type=1]="Type",h[h.Parameter=2]="Parameter"})(g=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new I.TokenizationRegistryImpl;var b;(function(h){h[h.None=0]="None",h[h.Option=1]="Option",h[h.Default=2]="Default",h[h.Preferred=3]="Preferred"})(b=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[37],be([0,1,26,9,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let I=u.userAgent||"";const F=new Map;F.set("false",!1),F.set("true",!0),F.set("isMac",u.isMacintosh),F.set("isLinux",u.isLinux),F.set("isWindows",u.isWindows),F.set("isWeb",u.isWeb),F.set("isMacNative",u.isMacintosh&&!u.isWeb),F.set("isEdge",I.indexOf("Edg/")>=0),F.set("isFirefox",I.indexOf("Firefox")>=0),F.set("isChrome",I.indexOf("Chrome")>=0),F.set("isSafari",I.indexOf("Safari")>=0);const T=Object.prototype.hasOwnProperty;var C;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return n.INSTANCE}static true(){return d.INSTANCE}static has(S){return l.create(S)}static equals(S,x){return c.create(S,x)}static notEquals(S,x){return w.create(S,x)}static regex(S,x){return i.create(S,x)}static in(S,x){return p.create(S,x)}static not(S){return o.create(S)}static and(...S){return g.create(S,null)}static or(...S){return b.create(S,null,!0)}static greater(S,x){return k.create(S,x)}static greaterEquals(S,x){return r.create(S,x)}static smaller(S,x){return v.create(S,x)}static smallerEquals(S,x){return s.create(S,x)}static deserialize(S,x=!1){if(!!S)return this._deserializeOrExpression(S,x)}static _deserializeOrExpression(S,x){let N=S.split("||");return b.create(N.map(j=>this._deserializeAndExpression(j,x)),null,!0)}static _deserializeAndExpression(S,x){let N=S.split("&&");return g.create(N.map(j=>this._deserializeOne(j,x)),null)}static _deserializeOne(S,x){if(S=S.trim(),S.indexOf("!=")>=0){let N=S.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("==")>=0){let N=S.split("==");return c.create(N[0].trim(),this._deserializeValue(N[1],x))}if(S.indexOf("=~")>=0){let N=S.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(S.indexOf(" in ")>=0){let N=S.split(" in ");return p.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const N=S.split(">=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const N=S.split(">");return k.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const N=S.split("<=");return s.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const N=S.split("<");return v.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(S)?o.create(S.substr(1).trim()):l.create(S)}static _deserializeValue(S,x){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;let N=/^'([^']*)'$/.exec(S);return N?N[1].trim():S}static _deserializeRegexValue(S,x){if((0,M.isFalsyOrWhitespace)(S)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=S.indexOf("/"),j=S.lastIndexOf("/");if(N===j||N<0){if(x)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}let W=S.slice(N+1,j),$=S[j+1]==="i"?"i":"";try{return new RegExp(W,$)}catch(V){if(x)throw new Error(`bad regexp-value '${S}', parse error: ${V}`);return console.warn(`bad regexp-value '${S}', parse error: ${V}`),null}}}e.ContextKeyExpr=P;function t(O,S){const x=O?O.substituteConstants():void 0,N=S?S.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=t;function _(O,S){return O.cmp(S)}class n{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class d{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class l{constructor(S,x){this.key=S,this.negated=x,this.type=2}static create(S,x=null){const N=F.get(S);return typeof N=="boolean"?N?d.INSTANCE:n.INSTANCE:new l(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:y(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=F.get(this.key);return typeof S=="boolean"?S?d.INSTANCE:n.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class c{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=4}static create(S,x,N=null){if(typeof x=="boolean")return x?l.create(S,N):o.create(S,N);const j=F.get(S);return typeof j=="boolean"?x===(j?"true":"false")?d.INSTANCE:n.INSTANCE:new c(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=F.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?d.INSTANCE:n.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=c;class p{constructor(S,x){this.key=S,this.valueKey=x,this.type=10,this.negated=null}static create(S,x){return new p(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const x=S.getValue(this.valueKey),N=S.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?T.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=D.create(this)),this.negated}}e.ContextKeyInExpr=p;class D{constructor(S){this._actual=S,this.type=11}static create(S){return new D(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new D(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class w{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=5}static create(S,x,N=null){if(typeof x=="boolean")return x?o.create(S,N):l.create(S,N);const j=F.get(S);return typeof j=="boolean"?x===(j?"true":"false")?n.INSTANCE:d.INSTANCE:new w(S,x,N)}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=F.get(this.key);if(typeof S=="boolean"){const x=S?"true":"false";return this.value===x?n.INSTANCE:d.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class o{constructor(S,x){this.key=S,this.negated=x,this.type=3}static create(S,x=null){const N=F.get(S);return typeof N=="boolean"?N?n.INSTANCE:d.INSTANCE:new o(S,x)}cmp(S){return S.type!==this.type?this.type-S.type:y(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=F.get(this.key);return typeof S=="boolean"?S?n.INSTANCE:d.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function f(O,S){if(typeof O=="string"){const x=parseFloat(O);isNaN(x)||(O=x)}return typeof O=="string"||typeof O=="number"?S(O):n.INSTANCE}class k{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=12}static create(S,x,N=null){return f(x,j=>new k(S,j,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=k;class r{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=13}static create(S,x,N=null){return f(x,j=>new r(S,j,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class v{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=14}static create(S,x,N=null){return f(x,j=>new v(S,j,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=v;class s{constructor(S,x,N){this.key=S,this.value=x,this.negated=N,this.type=15}static create(S,x,N=null){return f(x,j=>new s(S,j,N))}cmp(S){return S.type!==this.type?this.type-S.type:R(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=k.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class i{constructor(S,x){this.key=S,this.regexp=x,this.type=7,this.negated=null}static create(S,x){return new i(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return x<N?-1:x>N?1:0}equals(S){if(S.type===this.type){const x=this.regexp?this.regexp.source:"",N=S.regexp?S.regexp.source:"";return this.key===S.key&&x===N}return!1}substituteConstants(){return this}evaluate(S){let x=S.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class m{constructor(S){this._actual=S,this.type=8}static create(S){return new m(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new m(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=m;function a(O){let S=null;for(let x=0,N=O.length;x<N;x++){const j=O[x].substituteConstants();if(O[x]!==j&&S===null){S=[];for(let W=0;W<x;W++)S[W]=O[W]}S!==null&&(S[x]=j)}return S===null?O:S}class g{constructor(S,x){this.expr=S,this.negated=x,this.type=6}static create(S,x){return g._normalizeArr(S,x)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const j=_(this.expr[x],S.expr[x]);if(j!==0)return j}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=a(this.expr);return S===this.expr?this:g.create(S,this.negated)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(S))return!1;return!0}static _normalizeArr(S,x){const N=[];let j=!1;for(const W of S)if(!!W){if(W.type===1){j=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&j)return d.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const $=N.pop(),V=N.length===0,q=b.create(W.expr.map(re=>g.create([re,$],null)),null,V);q&&(N.push(q),N.sort(_))}return N.length===1?N[0]:new g(N,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new g(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){const S=[];for(let x of this.expr)S.push(x.negate());this.negated=b.create(S,this,!0)}return this.negated}}class b{constructor(S,x){this.expr=S,this.negated=x,this.type=9}static create(S,x,N){return b._normalizeArr(S,x,N)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const j=_(this.expr[x],S.expr[x]);if(j!==0)return j}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(S.expr[x]))return!1;return!0}return!1}substituteConstants(){const S=a(this.expr);return S===this.expr?this:b.create(S,this.negated,!1)}evaluate(S){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(S))return!0;return!1}static _normalizeArr(S,x,N){let j=[],W=!1;if(S){for(let $=0,V=S.length;$<V;$++){const q=S[$];if(!!q){if(q.type===0){W=!0;continue}if(q.type===1)return d.INSTANCE;if(q.type===9){j=j.concat(q.expr);continue}j.push(q)}}if(j.length===0&&W)return n.INSTANCE;j.sort(_)}if(j.length!==0){if(j.length===1)return j[0];for(let $=1;$<j.length;$++)j[$-1].equals(j[$])&&(j.splice($,1),$--);if(j.length===1)return j[0];if(N){for(let $=0;$<j.length;$++)for(let V=$+1;V<j.length;V++)A(j[$],j[V])&&(j.splice(V,1),V--);if(j.length===1)return j[0]}return new b(j,x)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(let x of this.expr)S.push(...x.keys());return S}map(S){return new b(this.expr.map(x=>x.map(S)),null)}negate(){if(!this.negated){let S=[];for(let x of this.expr)S.push(x.negate());for(;S.length>1;){const x=S.shift(),N=S.shift(),j=[];for(const $ of B(x))for(const V of B(N))j.push(g.create([$,V],null));const W=S.length===0;S.unshift(b.create(j,null,W))}this.negated=S[0]}return this.negated}}class h extends l{constructor(S,x,N){super(S,null);this._defaultValue=x,typeof N=="object"?h._info.push({...N,key:S}):N!==!0&&h._info.push({key:S,description:N,type:x!=null?typeof x:void 0})}static all(){return h._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return c.create(this.key,S)}notEqualsTo(S){return w.create(this.key,S)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(O,S){return O<S?-1:O>S?1:0}function R(O,S,x,N){return O<x?-1:O>x?1:S<N?-1:S>N?1:0}function A(O,S){if(S.type===6&&O.type!==9&&O.type!==6){for(const j of S.expr)if(O.equals(j))return!0}const x=O.negate(),N=B(x).concat(B(S));N.sort(_);for(let j=0;j<N.length;j++){const $=N[j].negate();for(let V=j+1;V<N.length;V++){const q=N[V];if($.equals(q))return!0}}return!1}e.implies=A;function B(O){return O.type===9?O.expr:[O]}}),define(we[143],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,u.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,u.refineServiceDecorator)(e.IEnvironmentService)}),define(we[46],be([0,1,20,17,9,10,2,122,4]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function P(N){return N.create===!0}e.isFileOpenForWriteOptions=P;var t;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=d;function l(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=l;function c(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function p(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=p;var D;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(j,W){super(j);this.code=W}}e.FileSystemProviderError=w;function o(N,j){const W=new w(N.toString(),j);return k(W,j),W}e.createFileSystemProviderError=o;function f(N){return N||o((0,T.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=f;function k(N,j){return N.name=j?`${j} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=k;function r(N){if(!N)return D.Unknown;if(N instanceof w)return N.code;const j=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!j)return D.Unknown;switch(j[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=r;function v(N){if(N instanceof b)return N.fileOperationResult;switch(r(N)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=v;var s;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(j,W,$){this.resource=j,this.operation=W,this.target=$}isOperation(j){return this.operation===j}}e.FileOperationEvent=i;var m;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class a{constructor(j,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const V of j){const q=$.get(V.type);q?q.push([V.resource,V]):$.set(V.type,[[V.resource,V]])}for(const[V,q]of $)switch(V){case 1:this.added=u.TernarySearchTree.forUris(()=>W),this.added.fill(q);break;case 0:this.updated=u.TernarySearchTree.forUris(()=>W),this.updated.fill(q);break;case 2:this.deleted=u.TernarySearchTree.forUris(()=>W),this.deleted.fill(q);break}}contains(j,...W){return this.doContains(j,{includeChildren:!1},...W)}affects(j,...W){return this.doContains(j,{includeChildren:!0},...W)}doContains(j,W,...$){if(!j)return!1;const V=$.length>0;return!!((!V||$.includes(1))&&(this.added?.get(j)||W.includeChildren&&this.added?.findSuperstr(j))||(!V||$.includes(0))&&(this.updated?.get(j)||W.includeChildren&&this.updated?.findSuperstr(j))||(!V||$.includes(2))&&(this.deleted?.findSubstr(j)||W.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function g(N,j,W){return!N||!j||N===j||j.length>N.length?!1:(j.charAt(j.length-1)!==M.sep&&(j+=M.sep),W?(0,E.startsWithIgnoreCase)(N,j):N.indexOf(j)===0)}e.isParent=g;class b extends Error{constructor(j,W,$){super(j);this.fileOperationResult=W,this.options=$}}e.FileOperationError=b;class h extends b{constructor(j,W,$){super(j,2,$);this.stat=W}}e.NotModifiedSinceFileOperationError=h;var y;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=A;async function B(N,j){if(!j.hasProvider(F.URI.from({scheme:N.scheme})))return new Promise(W=>{const $=j.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===N.scheme&&V.added&&($.dispose(),W())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class O{static formatSize(j){return(0,I.isNumber)(j)||(j=0),j<O.KB?(0,T.localize)(1,null,j.toFixed(0)):j<O.MB?(0,T.localize)(2,null,(j/O.KB).toFixed(2)):j<O.GB?(0,T.localize)(3,null,(j/O.MB).toFixed(2)):j<O.TB?(0,T.localize)(4,null,(j/O.GB).toFixed(2)):(0,T.localize)(5,null,(j/O.TB).toFixed(2))}}e.ByteSize=O,O.KB=1024,O.MB=O.KB*O.KB,O.GB=O.MB*O.KB,O.TB=O.GB*O.KB;var S;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(S=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*O.MB:16*O.GB,maxHeapSize:N===0?700*O.MB:2*700*O.MB}}e.getPlatformLimits=x}),define(we[61],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class u{constructor(...E){this._entries=new Map;for(let[I,F]of E)this.set(I,F)}set(E,I){const F=this._entries.get(E);return this._entries.set(E,I),F}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=u}),define(we[144],be([0,1,13,16,81,140,4,61]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class P extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class t{constructor(l=new T.ServiceCollection,c=!1,p){this._activeInstantiations=new Set,this._services=l,this._strict=c,this._parent=p,this._services.set(F.IInstantiationService,this)}createChild(l){return new t(l,this._strict,this)}invokeFunction(l,...c){let p=n.traceInvocation(l),D=!1;try{return l({get:o=>{if(D)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(o,p);if(!f)throw new Error(`[invokeFunction] unknown service '${o}'`);return f}},...c)}finally{D=!0,p.stop()}}createInstance(l,...c){let p,D;return l instanceof E.SyncDescriptor?(p=n.traceCreation(l.ctor),D=this._createInstance(l.ctor,l.staticArguments.concat(c),p)):(p=n.traceCreation(l),D=this._createInstance(l,c,p)),p.stop(),D}_createInstance(l,c=[],p){let D=F._util.getServiceDependencies(l).sort((f,k)=>f.index-k.index),w=[];for(const f of D){let k=this._getOrCreateServiceInstance(f.id,p);if(!k&&this._strict&&!f.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${f.id}.`);w.push(k)}let o=D.length>0?D[0].index:c.length;if(c.length!==o){console.warn(`[createInstance] First service dependency of ${l.name} at position ${o+1} conflicts with ${c.length} static arguments`);let f=o-c.length;f>0?c=c.concat(new Array(f)):c=c.slice(0,o)}return new l(...[...c,...w])}_setServiceInstance(l,c){if(this._services.get(l)instanceof E.SyncDescriptor)this._services.set(l,c);else if(this._parent)this._parent._setServiceInstance(l,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let c=this._services.get(l);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):c}_getOrCreateServiceInstance(l,c){let p=this._getServiceInstanceOrDescriptor(l);return p instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,p,c.branch(l,!0)):(c.branch(l,!1),p)}_safeCreateAndCacheServiceInstance(l,c,p){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,c,p)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,c,p){const D=new I.Graph(f=>f.id.toString());let w=0;const o=[{id:l,desc:c,_trace:p}];for(;o.length;){const f=o.pop();if(D.lookupOrInsertNode(f),w++>1e3)throw new P(D);for(let k of F._util.getServiceDependencies(f.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(k.id);if(!r&&!k.optional&&console.warn(`[createInstance] ${l} depends on ${k.id} which is NOT registered.`),r instanceof E.SyncDescriptor){const v={id:k.id,desc:r,_trace:f._trace.branch(k.id,!0)};D.insertEdge(f,v),o.push(v)}}}for(;;){const f=D.roots();if(f.length===0){if(!D.isEmpty())throw new P(D);break}for(const{data:k}of f){if(this._getServiceInstanceOrDescriptor(k.id)instanceof E.SyncDescriptor){const v=this._createServiceInstanceWithOwner(k.id,k.desc.ctor,k.desc.staticArguments,k.desc.supportsDelayedInstantiation,k._trace);this._setServiceInstance(k.id,v)}D.removeNode(k)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,c,p=[],D,w){if(this._services.get(l)instanceof E.SyncDescriptor)return this._createServiceInstance(c,p,D,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,c,p,D,w);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(l,c=[],p,D){if(p){const w=new u.IdleValue(()=>this._createInstance(l,c,D));return new Proxy(Object.create(null),{get(o,f){if(f in o)return o[f];let k=w.value,r=k[f];return typeof r!="function"||(r=r.bind(k),o[f]=r),r},set(o,f,k){return w.value[f]=k,!0}})}else return this._createInstance(l,c,D)}}e.InstantiationService=t;var _;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(_||(_={}));class n{constructor(l,c){this.type=l,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return C?new n(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(l){return C?new n(0,l.name):n._None}branch(l,c){let p=new n(2,l.toString());return this._dep.push([l,c,p]),p}stop(){let l=Date.now()-this._start;n._totals+=l;let c=!1;function p(w,o){let f=[],k=new Array(w+1).join("	");for(const[r,v,s]of o._dep)if(v&&s){c=!0,f.push(`${k}CREATES -> ${r}`);let i=p(w+1,s);i&&f.push(i)}else f.push(`${k}uses -> ${r}`);return f.join(`
`)}let D=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(l>2||c)&&console.log(D.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(we[12],be([0,1,45,3,6,26,4]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,F.createDecorator)("logService"),e.ILoggerService=(0,F.createDecorator)("loggerService");function T(){return new Date().toISOString()}var C;(function(v){v[v.Trace=0]="Trace",v[v.Debug=1]="Debug",v[v.Info=2]="Info",v[v.Warning=3]="Warning",v[v.Error=4]="Error",v[v.Critical=5]="Critical",v[v.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function P(v,s,i){switch(s){case C.Trace:v.trace(i);break;case C.Debug:v.debug(i);break;case C.Info:v.info(i);break;case C.Warning:v.warn(i);break;case C.Error:v.error(i);break;case C.Critical:v.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function t(v){let s="";for(let i=0;i<v.length;i++){let m=v[i];if(typeof m=="object")try{m=JSON.stringify(m)}catch(a){}s+=(i>0?" ":"")+m}return s}e.format=t;class _ extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...i){this.checkLogLevel(C.Trace)&&this.log(C.Trace,t([s,...i]))}debug(s,...i){this.checkLogLevel(C.Debug)&&this.log(C.Debug,t([s,...i]))}info(s,...i){this.checkLogLevel(C.Info)&&this.log(C.Info,t([s,...i]))}warn(s,...i){this.checkLogLevel(C.Warning)&&this.log(C.Warning,t([s,...i]))}error(s,...i){if(this.checkLogLevel(C.Error))if(s instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=s.stack,this.log(C.Error,t(m))}else this.log(C.Error,t([s,...i]))}critical(s,...i){this.checkLogLevel(C.Critical)&&this.log(C.Critical,t([s,...i]))}flush(){}}e.AbstractMessageLogger=n;class d extends _{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!I.isWindows}trace(s,...i){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...i):console.log(`[main ${T()}]`,s,...i))}debug(s,...i){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...i):console.log(`[main ${T()}]`,s,...i))}info(s,...i){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,s,...i):console.log(`[main ${T()}]`,s,...i))}warn(s,...i){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,s,...i):console.warn(`[main ${T()}]`,s,...i))}error(s,...i){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,s,...i):console.error(`[main ${T()}]`,s,...i))}critical(s,...i){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,s,...i):console.error(`[main ${T()}]`,s,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class l extends _{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...i){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",s,...i)}debug(s,...i){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...i)}info(s,...i){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",s,...i)}warn(s,...i){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",s,...i)}error(s,...i){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",s,...i)}critical(s,...i){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class c extends _{constructor(s,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(i)}trace(s,...i){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(s),...i])}debug(s,...i){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(s),...i])}info(s,...i){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(s),...i])}warn(s,...i){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(s),...i])}error(s,...i){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(s),...i])}critical(s,...i){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(s),...i])}extractMessage(s){return typeof s=="string"?s:(0,u.toErrorMessage)(s,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=c;class p extends _{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const i of this.logServices)i.setLevel(s);super.setLevel(s)}trace(s,...i){for(const m of this.logServices)m.trace(s,...i)}debug(s,...i){for(const m of this.logServices)m.debug(s,...i)}info(s,...i){for(const m of this.logServices)m.info(s,...i)}warn(s,...i){for(const m of this.logServices)m.warn(s,...i)}error(s,...i){for(const m of this.logServices)m.error(s,...i)}critical(s,...i){for(const m of this.logServices)m.critical(s,...i)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=p;class D extends E.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...i){this.logger.trace(s,...i)}debug(s,...i){this.logger.debug(s,...i)}info(s,...i){this.logger.info(s,...i)}warn(s,...i){this.logger.warn(s,...i)}error(s,...i){this.logger.error(s,...i)}critical(s,...i){this.logger.critical(s,...i)}flush(){this.logger.flush()}}e.LogService=D;class w extends E.Disposable{constructor(s,i){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(m=>{this.logLevel=m,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(m))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,i){let m=this.loggers.get(s.toString());return m||(m=this.doCreateLogger(s,i?.always?C.Trace:this.logLevel,i),this.loggers.set(s.toString(),m),i?.always||this.logLevelChangeableLoggers.push(m)),m}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class o{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(s){}getLevel(){return C.Info}trace(s,...i){}debug(s,...i){}info(s,...i){}warn(s,...i){}error(s,...i){}critical(s,...i){}dispose(){}flush(){}}e.NullLogService=o;function f(v){if(v.verbose)return C.Trace;if(typeof v.logLevel=="string"){const s=k(v.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function k(v){switch(v){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=k;function r(v){switch(v){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(we[82],be([0,1,35,123,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(C){C[C.Unnecessary=1]="Unnecessary",C[C.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var F;(function(C){C[C.Hint=1]="Hint",C[C.Info=2]="Info",C[C.Warning=4]="Warning",C[C.Error=8]="Error"})(F=e.MarkerSeverity||(e.MarkerSeverity={})),function(C){function P(l,c){return c-l}C.compare=P;const t=Object.create(null);t[C.Error]=(0,M.localize)(0,null),t[C.Warning]=(0,M.localize)(1,null),t[C.Info]=(0,M.localize)(2,null);function _(l){return t[l]||""}C.toString=_;function n(l){switch(l){case u.default.Error:return C.Error;case u.default.Warning:return C.Warning;case u.default.Info:return C.Info;case u.default.Ignore:return C.Hint}}C.fromSeverity=n;function d(l){switch(l){case C.Error:return u.default.Error;case C.Warning:return u.default.Warning;case C.Info:return u.default.Info;case C.Hint:return u.default.Ignore}}C.toSeverity=d}(F=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(C){const P="";function t(n){return _(n,!0)}C.makeKey=t;function _(n,d){let l=[P];return n.source?l.push(n.source.replace("\xA6","\\\xA6")):l.push(P),n.code?typeof n.code=="string"?l.push(n.code.replace("\xA6","\\\xA6")):l.push(n.code.value.replace("\xA6","\\\xA6")):l.push(P),n.severity!==void 0&&n.severity!==null?l.push(F.toString(n.severity)):l.push(P),n.message&&d?l.push(n.message.replace("\xA6","\\\xA6")):l.push(P),n.startLineNumber!==void 0&&n.startLineNumber!==null?l.push(n.startLineNumber.toString()):l.push(P),n.startColumn!==void 0&&n.startColumn!==null?l.push(n.startColumn.toString()):l.push(P),n.endLineNumber!==void 0&&n.endLineNumber!==null?l.push(n.endLineNumber.toString()):l.push(P),n.endColumn!==void 0&&n.endColumn!==null?l.push(n.endColumn.toString()):l.push(P),l.push(P),l.join("\xA6")}C.makeKeyOptionalMessage=_})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(we[145],be([0,1,3,35,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var I;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(I=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var F;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(F=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new C,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=T;class C{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=C}),define(we[146],be([0,1,6,9,2,4]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return u.Disposable.None},registerValidator(){return u.Disposable.None},registerExternalUriResolver(){return u.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return u.Disposable.None},async open(){return!1},async resolveExternalUri(C){return{resolved:C,dispose(){}}}});function F(C,P){return E.URI.isUri(C)?(0,M.equalsIgnoreCase)(C.scheme,P):(0,M.startsWithIgnoreCase)(C,P+":")}e.matchesScheme=F;function T(C,...P){return P.some(t=>F(C,t))}e.matchesSomeScheme=T});var xe=this&&this.__decorate||function(ne,e,u,M){var E=arguments.length,I=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,u):M,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ne,e,u,M);else for(var T=ne.length-1;T>=0;T--)(F=ne[T])&&(I=(E<3?F(I):E>3?F(e,u,I):F(e,u))||I);return E>3&&I&&Object.defineProperty(e,u,I),I},Be=this&&this.__param||function(ne,e){return function(u,M){e(u,M,ne)}};define(we[147],be([0,1,13,21,6,4]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,I.createDecorator)("progressService");var F;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(F=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let C=class extends E.Disposable{constructor(_,n){super();this.deferred=new u.DeferredPromise,n.withProgress(_,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};C=xe([Be(1,e.IProgressService)],C),e.UnmanagedProgress=C;class P extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,d=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:d.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,I.createDecorator)("editorProgressService")}),define(we[29],be([0,1,42,10]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(F,T){u.ok(M.isString(F)),u.ok(M.isObject(T)),u.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,T)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}e.Registry=new E}),define(we[83],be([0,1,3,29]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class I{constructor(){this._onDidChangeSchema=new u.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,P){this.schemasById[E(C)]=P,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new I;M.Registry.add(e.Extensions.JSONContribution,F)}),define(we[62],be([0,1,15,3,10,120,83,29]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const t=T.Registry.as(F.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,f=!0){this.registerConfigurations([o],f)}registerConfigurations(o,f=!0){const k=this.doRegisterConfigurations(o,f);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(k)}deregisterConfigurations(o){const f=this.doDeregisterConfigurations(o);t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}updateConfigurations({add:o,remove:f}){const k=[];k.push(...this.doDeregisterConfigurations(f)),k.push(...this.doRegisterConfigurations(o,!1)),t.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,u.distinct)(k))}registerDefaultConfigurations(o){const f=[],k=[];for(const r of o)for(const v in r)if(f.push(v),e.OVERRIDE_PROPERTY_PATTERN.test(v)){this.defaultValues[v]={...this.defaultValues[v]||{},...r[v]};const s={type:"object",default:this.defaultValues[v],description:I.localize(1,null,v),$ref:e.resourceLanguageSettingsSchemaId};k.push(d(v)),this.configurationProperties[v]=s,this.defaultLanguageConfigurationOverridesNode.properties[v]=s}else{this.defaultValues[v]=r[v];const s=this.configurationProperties[v];s&&(this.updatePropertyDefaultValue(v,s),this.updateSchema(v,s))}this.registerOverrideIdentifiers(k),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(o){const f=[];for(const k of o)for(const r in k)if(f.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const v=this.configurationProperties[r];v&&(this.updatePropertyDefaultValue(r,v),this.updateSchema(r,v))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const f of o)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,f){const k=[];return o.forEach(r=>{k.push(...this.validateAndRegisterProperties(r,f,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),k}doDeregisterConfigurations(o){const f=[],k=r=>{if(r.properties)for(const v in r.properties)f.push(v),delete this.configurationProperties[v],this.removeFromSchema(v,r.properties[v]);r.allOf&&r.allOf.forEach(v=>k(v))};for(const r of o){k(r);const v=this.configurationContributors.indexOf(r);v!==-1&&this.configurationContributors.splice(v,1)}return f}validateAndRegisterProperties(o,f=!0,k,r=3){r=E.isUndefinedOrNull(o.scope)?r:o.scope;let v=[],s=o.properties;if(s)for(let m in s){if(f&&p(m)){delete s[m];continue}const a=s[m];if(this.updatePropertyDefaultValue(m,a),e.OVERRIDE_PROPERTY_PATTERN.test(m)?a.scope=void 0:(a.scope=E.isUndefinedOrNull(a.scope)?r:a.scope,a.restricted=E.isUndefinedOrNull(a.restricted)?!!k?.restrictedConfigurations?.includes(m):a.restricted),s[m].hasOwnProperty("included")&&!s[m].included){this.excludedConfigurationProperties[m]=s[m],delete s[m];continue}else this.configurationProperties[m]=s[m];!s[m].deprecationMessage&&s[m].markdownDeprecationMessage&&(s[m].deprecationMessage=s[m].markdownDeprecationMessage),v.push(m)}let i=o.allOf;if(i)for(let m of i)v.push(...this.validateAndRegisterProperties(m,f,k,r));return v}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const f=k=>{let r=k.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let v=k.allOf;v&&v.forEach(f)};f(o)}updateSchema(o,f){switch(e.allSettings.properties[o]=f,f.scope){case 1:e.applicationSettings.properties[o]=f;break;case 2:e.machineSettings.properties[o]=f;break;case 6:e.machineOverridableSettings.properties[o]=f;break;case 3:e.windowSettings.properties[o]=f;break;case 4:e.resourceSettings.properties[o]=f;break;case 5:e.resourceSettings.properties[o]=f,this.resourceLanguageSettingsSchema.properties[o]=f;break}}removeFromSchema(o,f){switch(delete e.allSettings.properties[o],f.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const f=`[${o}]`,k={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,k),e.allSettings.properties[f]=k,e.applicationSettings.properties[f]=k,e.machineSettings.properties[f]=k,e.machineOverridableSettings.properties[f]=k,e.windowSettings.properties[f]=k,e.resourceSettings.properties[f]=k}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,f){let k=this.defaultValues[o];E.isUndefined(k)&&(k=f.default),E.isUndefined(k)&&(k=l(f.type)),f.default=k}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function d(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=d;function l(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const c=new _;T.Registry.add(e.Extensions.Configuration,c);function p(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?I.localize(5,null,w):c.getConfigurationProperties()[w]!==void 0?I.localize(6,null,w):null:I.localize(4,null)}e.validateProperty=p;function D(){const w=[],o=c.getConfigurationProperties();for(const f of Object.keys(o))w.push([f,o[f].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=D}),define(we[84],be([0,1,24,10,2,62,4,29]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,F.createDecorator)("configurationService");function C(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof E.URI)}e.isConfigurationOverrides=C;var P;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(v,s){const i=s?v?s.keys.filter(R=>v.keys.indexOf(R)===-1):[...s.keys]:[],m=v?s?v.keys.filter(R=>s.keys.indexOf(R)===-1):[...v.keys]:[],a=[];if(s&&v){for(const R of v.keys)if(s.keys.indexOf(R)!==-1){const A=D(v.contents,R),B=D(s.contents,R);u.equals(A,B)||a.push(R)}}const g=[],b=R=>{const A={};for(const B of R)for(const O of B.identifiers)A[k(O)]=B;return A},h=s?b(s.overrides):{},y=v?b(v.overrides):{};if(Object.keys(h).length)for(const R of i){const A=h[R];A&&g.push([(0,I.overrideIdentifierFromKey)(R),A.keys])}if(Object.keys(y).length)for(const R of m){const A=y[R];A&&g.push([(0,I.overrideIdentifierFromKey)(R),A.keys])}if(Object.keys(h).length&&Object.keys(y).length)for(const R of a){const A=y[R],B=h[R];if(A&&B){const O=_({contents:A.contents,keys:A.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});g.push([(0,I.overrideIdentifierFromKey)(R),[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:m,updated:a,overrides:g}}e.compare=_;function n(v,s){const i=[];for(const m of Object.keys(v))if(I.OVERRIDE_PROPERTY_PATTERN.test(m)){const a={};for(const g in v[m])a[g]=v[m][g];i.push({identifiers:[(0,I.overrideIdentifierFromKey)(m).trim()],keys:Object.keys(a),contents:d(a,s)})}return i}e.toOverrides=n;function d(v,s){const i=Object.create(null);for(let m in v)l(i,m,v[m],s);return i}e.toValuesTree=d;function l(v,s,i,m){const a=s.split("."),g=a.pop();let b=v;for(let h=0;h<a.length;h++){let y=a[h],R=b[y];switch(typeof R){case"undefined":R=b[y]=Object.create(null);break;case"object":break;default:m(`Ignoring ${s} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(R)}`);return}b=R}if(typeof b=="object"&&b!==null)try{b[g]=i}catch(h){m(`Ignoring ${s} as ${a.join(".")} is ${JSON.stringify(b)}`)}else m(`Ignoring ${s} as ${a.join(".")} is ${JSON.stringify(b)}`)}e.addToValueTree=l;function c(v,s){const i=s.split(".");p(v,i)}e.removeFromValueTree=c;function p(v,s){const i=s.shift();if(s.length===0){delete v[i];return}if(Object.keys(v).indexOf(i)!==-1){const m=v[i];typeof m=="object"&&!Array.isArray(m)&&(p(m,s),Object.keys(m).length===0&&delete v[i])}}function D(v,s,i){function m(b,h){let y=b;for(const R of h){if(typeof y!="object"||y===null)return;y=y[R]}return y}const a=s.split("."),g=m(v,a);return typeof g=="undefined"?i:g}e.getConfigurationValue=D;function w(v,s,i){Object.keys(s).forEach(m=>{m!=="__proto__"&&(m in v?M.isObject(v[m])&&M.isObject(s[m])?w(v[m],s[m],i):i&&(v[m]=s[m]):v[m]=s[m])})}e.merge=w;function o(){const v=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(v)}e.getConfigurationKeys=o;function f(){const v=Object.create(null),s=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let i in s){let m=s[i].default;l(v,i,m,a=>console.error(`Conflict in default settings: ${a}`))}return v}e.getDefaultValues=f;function k(v){return`[${v}]`}e.keyFromOverrideIdentifier=k;function r(v,s,i){const m=v.inspect(s),a=v.inspect(i);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:m.defaultValue}e.getMigratedSettingValue=r}),define(we[148],be([0,1,15,3,102,6,20,24,10,2,84,62,29]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(r={},v=[],s=[]){this._contents=r,this._keys=v,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,t.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,v){const s=this.getContentsForOverrideIdentifer(v);return s?r?(0,t.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){for(const v of this.overrides)if(v.identifiers.indexOf(r)!==-1)return v.keys;return[]}override(r){let v=this.overrideConfigurations.get(r);return v||(v=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,v)),v}merge(...r){const v=T.deepClone(this.contents),s=T.deepClone(this.overrides),i=[...this.keys];for(const m of r){this.mergeContents(v,m.contents);for(const a of m.overrides){const[g]=s.filter(b=>u.equals(b.identifiers,a.identifiers));g?this.mergeContents(g.contents,a.contents):s.push(T.deepClone(a))}for(const a of m.keys)i.indexOf(a)===-1&&i.push(a)}return new d(v,i,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const v=this.getContentsForOverrideIdentifer(r);if(!v||typeof v!="object"||!Object.keys(v).length)return this;let s={};for(const i of u.distinct([...Object.keys(this.contents),...Object.keys(v)])){let m=this.contents[i],a=v[i];a&&(typeof m=="object"&&typeof a=="object"?(m=T.deepClone(m),this.mergeContents(m,a)):m=a),s[i]=m}return new d(s,this.keys,this.overrides)}mergeContents(r,v){for(const s of Object.keys(v)){if(s in r&&C.isObject(r[s])&&C.isObject(v[s])){this.mergeContents(r[s],v[s]);continue}r[s]=T.deepClone(v[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?T.deepFreeze(r):r}getContentsForOverrideIdentifer(r){for(const v of this.overrides)if(v.identifiers.indexOf(r)!==-1)return v.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,v){this.addKey(r),(0,t.addToValueTree)(this.contents,r,v,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,t.removeFromValueTree)(this.contents,r)}addKey(r){let v=this.keys.length;for(let s=0;s<v;s++)r.indexOf(this.keys[s])===0&&(v=s);this.keys.splice(v,1,r)}removeKey(r){let v=this.keys.indexOf(r);return v!==-1?(this.keys.splice(v,1),!0):!1}}e.ConfigurationModel=d;class l extends d{constructor(){const r=(0,t.getDefaultValues)(),v=(0,t.getConfigurationKeys)(),s=[];for(const i of Object.keys(r))_.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,_.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(r[i]),contents:(0,t.toValuesTree)(r[i],m=>console.error(`Conflict in default settings file: ${m}`))});super(r,v,s)}}e.DefaultConfigurationModel=l;class c{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,v){if(!C.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,v)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,v){this._raw=r;const{contents:s,keys:i,overrides:m,restricted:a}=this.doParseRaw(r,v);this._configurationModel=new d(s,i,m),this._restrictedConfigurations=a||[]}doParseContent(r){let v={},s=null,i=[],m=[],a=[];function g(h){Array.isArray(i)?i.push(h):s!==null&&(i[s]=h)}let b={onObjectBegin:()=>{let h={};g(h),m.push(i),i=h,s=null},onObjectProperty:h=>{s=h},onObjectEnd:()=>{i=m.pop()},onArrayBegin:()=>{let h=[];g(h),m.push(i),i=h,s=null},onArrayEnd:()=>{i=m.pop()},onLiteralValue:g,onError:(h,y,R)=>{a.push({error:h,offset:y,length:R})}};if(r)try{E.visit(r,b),v=i[0]||{}}catch(h){console.error(`Error while parsing settings file ${this._name}: ${h}`),this._parseErrors=[h]}return v}doParseRaw(r,v){const s=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),i=this.filter(r,s,!0,v);r=i.raw;const m=(0,t.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`)),a=Object.keys(r),g=(0,t.toOverrides)(r,b=>console.error(`Conflict in settings file ${this._name}: ${b}`));return{contents:m,keys:a,overrides:g,restricted:i.restricted}}filter(r,v,s,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:r,restricted:[]};const m={},a=[];for(let g in r)if(_.OVERRIDE_PROPERTY_PATTERN.test(g)&&s){const b=this.filter(r[g],v,!1,i);m[g]=b.raw,a.push(...b.restricted)}else{const b=v[g],h=b?typeof b.scope!="undefined"?b.scope:3:void 0;b?.restricted&&a.push(g),(h===void 0||i.scopes===void 0||i.scopes.includes(h))&&(i.skipRestricted&&b?.restricted||(m[g]=r[g]))}return{raw:m,restricted:a}}}e.ConfigurationModelParser=c;class p extends I.Disposable{constructor(r,v,s,i){super();this.userSettingsResource=r,this.scopes=v,this.fileService=i,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,m=>m.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class D{constructor(r,v,s=new d,i=new d,m=new F.ResourceMap,a=new d,g=new F.ResourceMap,b=!0){this._defaultConfiguration=r,this._localUserConfiguration=v,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=m,this._memoryConfiguration=a,this._memoryConfigurationByResource=g,this._freeze=b,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(r,v,s){return this.getConsolidateConfigurationModel(v,s).getValue(r)}updateValue(r,v,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new d,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,v===void 0?i.removeValue(r):i.setValue(r,v),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,v,s){const i=this.getConsolidateConfigurationModel(v,s),m=this.getFolderConfigurationModelForResource(v.resource,s),a=v.resource?this._memoryConfigurationByResource.get(v.resource)||this._memoryConfiguration:this._memoryConfiguration,g=v.overrideIdentifier?this._defaultConfiguration.freeze().override(v.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),b=v.overrideIdentifier?this.userConfiguration.freeze().override(v.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),h=v.overrideIdentifier?this.localUserConfiguration.freeze().override(v.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),y=v.overrideIdentifier?this.remoteUserConfiguration.freeze().override(v.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),R=s?v.overrideIdentifier?this._workspaceConfiguration.freeze().override(v.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,A=m?v.overrideIdentifier?m.freeze().override(v.overrideIdentifier).getValue(r):m.freeze().getValue(r):void 0,B=v.overrideIdentifier?a.override(v.overrideIdentifier).getValue(r):a.getValue(r),O=i.getValue(r),S=u.distinct(u.flatten(i.overrides.map(x=>x.identifiers))).filter(x=>i.getOverrideValue(r,x)!==void 0);return{defaultValue:g,userValue:b,userLocalValue:h,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:A,memoryValue:B,value:O,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:v.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,user:b!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:v.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,userLocal:h!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:v.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:v.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:v.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,workspaceFolder:A!==void 0?{value:m?.freeze().getValue(r),override:v.overrideIdentifier?m?.freeze().getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:a.getValue(r),override:v.overrideIdentifier?a.getOverrideValue(r,v.overrideIdentifier):void 0}:void 0,overrideIdentifiers:S.length?S:void 0}}keys(r){const v=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:v?v.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,v){this._folderConfigurations.set(r,v),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,v){const s=v.filter(i=>_.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const m=(0,_.overrideIdentifierFromKey)(i),a=this._defaultConfiguration.getKeysForOverrideIdentifier(m),g=r.getKeysForOverrideIdentifier(m),b=[...g.filter(h=>a.indexOf(h)===-1),...a.filter(h=>g.indexOf(h)===-1),...a.filter(h=>!T.equals(this._defaultConfiguration.override(m).getValue(h),r.override(m).getValue(h)))];return[m,b]});return this.updateDefaultConfiguration(r),{keys:v,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:v,updated:s,removed:i,overrides:m}=(0,t.compare)(this.localUserConfiguration,r),a=[...v,...s,...i];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:m}}compareAndUpdateRemoteUserConfiguration(r){const{added:v,updated:s,removed:i,overrides:m}=(0,t.compare)(this.remoteUserConfiguration,r);let a=[...v,...s,...i];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:m}}compareAndUpdateWorkspaceConfiguration(r){const{added:v,updated:s,removed:i,overrides:m}=(0,t.compare)(this.workspaceConfiguration,r);let a=[...v,...s,...i];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:m}}compareAndUpdateFolderConfiguration(r,v){const s=this.folderConfigurations.get(r),{added:i,updated:m,removed:a,overrides:g}=(0,t.compare)(s,v);let b=[...i,...m,...a];return(b.length||!s)&&this.updateFolderConfiguration(r,v),{keys:b,overrides:g}}compareAndDeleteFolderConfiguration(r){const v=this.folderConfigurations.get(r);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:i,removed:m,overrides:a}=(0,t.compare)(v,void 0);return{keys:[...s,...i,...m],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,v){let s=this.getConsolidatedConfigurationModelForResource(r,v);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},v){let s=this.getWorkspaceConsolidatedConfiguration();if(v&&r){const i=v.getFolder(r);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const m=this._memoryConfigurationByResource.get(r);m&&(s=s.merge(m))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let v=this._foldersConsolidatedConfigurations.get(r);if(!v){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(r);i?(v=s.merge(i),this._freeze&&(v=v.freeze()),this._foldersConsolidatedConfigurations.set(r,v)):v=s}return v}getFolderConfigurationModelForResource(r,v){if(v&&r){const s=v.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,v)=>{const{contents:s,overrides:i,keys:m}=this._folderConfigurations.get(v);return r.push([v,{contents:s,overrides:i,keys:m}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(v=>r.add(v)),this.userConfiguration.freeze().keys.forEach(v=>r.add(v)),this._workspaceConfiguration.freeze().keys.forEach(v=>r.add(v)),this._folderConfigurations.forEach(v=>v.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const v=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>v.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>v.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>v.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(i=>v.add(i))),[...v.values()]}static parse(r){const v=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),i=this.parseConfigurationModel(r.workspace),m=r.folders.reduce((a,g)=>(a.set(P.URI.revive(g[0]),this.parseConfigurationModel(g[1])),a),new F.ResourceMap);return new D(v,s,new d,i,m,new d,new F.ResourceMap,!1)}static parseConfigurationModel(r){return new d(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=D;function w(...k){if(k.length===0)return{keys:[],overrides:[]};if(k.length===1)return k[0];const r=new Set,v=new Map;for(const i of k)i.keys.forEach(m=>r.add(m)),i.overrides.forEach(([m,a])=>{const g=(0,F.getOrSet)(v,m,new Set);a.forEach(b=>g.add(b))});const s=[];return v.forEach((i,m)=>s.push([m,[...i.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=w;class o{constructor(r,v,s,i){this.change=r,this.previous=v,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const m=new Set;r.keys.forEach(g=>m.add(g)),r.overrides.forEach(([,g])=>g.forEach(b=>m.add(b))),this.affectedKeys=[...m.values()];const a=new d;this.affectedKeys.forEach(g=>a.setValue(g,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=D.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,v){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(v){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,v,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(r,v,this.currentWorkspace);return!T.equals(s,i)}return!0}return!1}doesAffectedKeysTreeContains(r,v){let s=(0,t.toValuesTree)({[v]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(r=r[i],!r)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=o;class f extends o{constructor(r,v,s,i){super({keys:r.allKeys(),overrides:[]},void 0,r,v);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f}),define(we[85],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,u.createDecorator)("remoteAuthorityResolverService");var M;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(F,T=M.Unknown,C){super(F);this._message=F,this._code=T,this._detail=C,this.isHandled=T===M.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(F){return F instanceof E&&F._code===M.TemporarilyNotAvailable}static isNoResolverFound(F){return F instanceof E&&F._code===M.NoResolverFound}static isHandled(F){return F instanceof E&&F.isHandled}}e.RemoteAuthorityResolverError=E}),define(we[63],be([0,1,11]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(P){return P.scheme===u.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=M;function E(P){if(!P)return;const t=P.indexOf("+");return t<0?P:P.substr(0,t)}e.getRemoteName=E;function I(P){return P.scheme!==u.Schemas.file&&P.scheme!==u.Schemas.vscodeRemote}e.isVirtualResource=I;function F(P){if(P.folders.length)return P.folders.every(t=>I(t.uri))?P.folders[0].uri:void 0;if(P.configuration&&I(P.configuration))return P.configuration}e.getVirtualWorkspaceLocation=F;function T(P){return F(P)?.scheme}e.getVirtualWorkspaceScheme=T;function C(P){return F(P)!==void 0}e.isVirtualWorkspace=C}),define(we[22],be([0,1,9,4,63]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=I;function F(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=F,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class C{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,p){if(typeof c=="undefined"||c===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof c=="string"||typeof p=="string"){let D=typeof c=="string"?c:c.value,w=typeof p=="string"?p:p.value;return u.equalsIgnoreCase(D,w)}return c._lower===p._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.ExtensionIdentifier=C;function P(l){return Boolean(l.enableProposedApi)}e.isProposedApiEnabled=P;function t(l){if(!P(l))throw new Error(`[${l.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=t;function _(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function n(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=n;function d(l,c){if(c&&P(l)){const p=`onResolveRemoteAuthority:${(0,E.getRemoteName)(c)}`;return l.activationEvents?.indexOf(p)!==-1}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[149],be([0,1,9,22]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(l,c){return l.uuid&&c.uuid?l.uuid===c.uuid:l.id===c.id?!0:(0,u.compareIgnoreCase)(l.id,c.id)===0}e.areSameExtensions=E;class I{constructor(c,p){this.version=p,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof I?E(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=I;function F(l,c){return`${l}.${c}`}e.getExtensionId=F;function T(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=T;function C(l,c){return T(F(l,c))}e.getGalleryExtensionId=C;function P(l,c){const p=[],D=w=>{for(const o of p)if(o.some(f=>E(c(f),c(w))))return o;return null};for(const w of l){const o=D(w);o?o.push(w):p.push([w])}return p}e.groupByExtension=P;function t(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(l){const c=new Set;for(const p of l)p.malicious&&c.add(p.id.id);return c}e.getMaliciousExtensionsSet=n;function d(l,c){const p=[],D=c.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const w=D.shift();if(w&&p.every(o=>!E(o.identifier,{id:w}))){const o=l.filter(f=>E(f.identifier,{id:w}));o.length===1&&(p.push(o[0]),D.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.getExtensionDependencies=d}),define(we[150],be([0,1,3,26,4,12]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var F;(function(l){l.Http="http",l.Https="https"})(F=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!c)return{address:c[1],port:+c[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function t(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=t,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=_;function n(l,c){return c?c!==1&&l<1024:!M.isWindows&&l<1024}e.isPortPrivileged=n;let d=class{constructor(c){this.logService=c,this._onTunnelOpened=new u.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new u.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new u.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(c,p){return this._tunnelProvider=c,c?(this._canElevate=p.elevation,this._privacyOptions=p.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const c=[],p=Array.from(this._tunnels.values());for(let D of p){const w=Array.from(D.values());for(let o of w){const f=await o.value;f&&c.push(f)}}return c}async dispose(){for(const c of this._tunnels.values()){for(const{value:p}of c.values())await p.then(D=>D?.dispose());c.clear()}this._tunnels.clear()}openTunnel(c,p,D,w,o=!1,f=T.Private,k){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${D} on local port ${w}.`),!c)return;p||(p="localhost");const r=this.retainOrCreateTunnel(c,p,D,w,o,f,k);return r?r.then(v=>{if(!v){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,D);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(v);return(v.tunnelRemoteHost!==p||v.tunnelRemotePort!==D)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const p=this._tunnels.get(c.tunnelRemoteHost);if(p){const D=p.get(c.tunnelRemotePort);D&&(D.refcount--,await this.tryDisposeTunnel(c.tunnelRemoteHost,c.tunnelRemotePort,D))}}}}async tryDisposeTunnel(c,p,D){if(D.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${p}.`);const w=D.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(c)&&this._tunnels.get(c).delete(p),w}}async closeTunnel(c,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${p} `);const D=this._tunnels.get(c);if(D&&D.has(p)){const w=D.get(p);w.refcount=0,await this.tryDisposeTunnel(c,p,w)}}addTunnelToMap(c,p,D){this._tunnels.has(c)||this._tunnels.set(c,new Map),this._tunnels.get(c).set(p,{refcount:1,value:D})}async removeEmptyTunnelFromMap(c,p){const D=this._tunnels.get(c);D&&(await D.get(p)||D.delete(p),D.size===0&&this._tunnels.delete(c))}getTunnelFromMap(c,p){let D=[c];t(c)?(D.push(...e.LOCALHOST_ADDRESSES),D.push(...e.ALL_INTERFACES_ADDRESSES)):_(c)&&D.push(...e.ALL_INTERFACES_ADDRESSES);const w=D.map(o=>this._tunnels.get(o));for(const o of w){const f=o?.get(p);if(f)return f}}canTunnel(c){return!!P(c)}createWithProvider(c,p,D,w,o,f,k){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${D} on local port ${w}.`);const v={elevationRequired:o?n(w===void 0?D:w):!1},s={remoteAddress:{host:p,port:D},localAddressPort:w,privacy:f,public:f!==T.Private,protocol:k},i=c.forwardPort(s,v);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(p,D,i),i}};d=xe([Be(0,I.ILogService)],d),e.AbstractTunnelService=d}),define(we[151],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class u{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,I,F=5){let T;return T=I(C=>{const P=typeof C=="string"?C:C.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(P);return}const _=setTimeout(()=>this.flushBuffer(E),F);t={data:[P],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),T.dispose()}},this._terminalBufferMap.set(E,t)}),T}stopBuffering(E){const I=this._terminalBufferMap.get(E);I&&I.dispose()}flushBuffer(E){const I=this._terminalBufferMap.get(E);I&&(this._terminalBufferMap.delete(E),this._callback(E,I.data.join("")))}}e.TerminalDataBufferer=u}),define(we[152],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var u;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(u=e.ColorScheme||(e.ColorScheme={}))}),define(we[47],be([0,1,34,3,6,4,29,152]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,I.createDecorator)("themeService");var C;(function(p){function D(w){return w&&typeof w=="object"&&typeof w.id=="string"}p.isThemeColor=D})(C=e.ThemeColor||(e.ThemeColor={}));function P(p){return{id:p}}e.themeColorFromId=P;var t;(function(p){function D(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color=="undefined"||C.isThemeColor(v.color))}p.isThemeIcon=D;const w=new RegExp(`^\\$\\((${u.CSSIcon.iconNameExpression}(?:${u.CSSIcon.iconModifierExpression})?)\\)$`);function o(v){const s=w.exec(v);if(!s)return;let[,i]=s;return{id:i}}p.fromString=o;function f(v,s){let i=v.id;const m=i.lastIndexOf("~");return m!==-1&&(i=i.substring(0,m)),s&&(i=`${i}~${s}`),{id:i}}p.modify=f;function k(v,s){return v.id===s.id&&v.color?.id===s.color?.id}p.isEqual=k;function r(v,s){return{id:v.id,color:s?P(s):void 0}}p.asThemeIcon=r,p.asClassNameArray=u.CSSIcon.asClassNameArray,p.asClassName=u.CSSIcon.asClassName,p.asCSSSelector=u.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=u.Codicon.file,e.FolderThemeIcon=u.Codicon.folder;function _(p){switch(p){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,E.toDisposable)(()=>{const w=this.themingParticipants.indexOf(D);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new n;F.Registry.add(e.Extensions.ThemingContribution,d);function l(p){return d.onColorThemeChange(p)}e.registerThemingParticipant=l;class c extends E.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,w){let o=this.theme.getColor(D);return o&&w&&(o=w(o,this.theme)),o?o.toString():null}}e.Themable=c}),define(we[153],be([0,1,13,34,3,124,83,29,47]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,I.localize)(0,null)},fontCharacter:{type:"string",description:(0,I.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(D,w,o,f){const k=this.iconsById[D];if(k){if(o&&!k.description){k.description=o,this.iconSchema.properties[D].markdownDescription=`${o} $(${D})`;const s=this.iconReferenceSchema.enum.indexOf(D);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=o),this._onDidChange.fire()}return k}let r={id:D,description:o,defaults:w,deprecationMessage:f};this.iconsById[D]=r;let v={$ref:"#/definitions/icons"};return f&&(v.deprecationMessage=f),o&&(v.markdownDescription=`${o}: $(${D})`),this.iconSchema.properties[D]=v,this.iconReferenceSchema.enum.push(D),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:D}}deregisterIcon(D){delete this.iconsById[D],delete this.iconSchema.properties[D];const w=this.iconReferenceSchema.enum.indexOf(D);w!==-1&&(this.iconReferenceSchema.enum.splice(w,1),this.iconReferenceSchema.enumDescriptions.splice(w,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(D=>this.iconsById[D])}getIcon(D){return this.iconsById[D]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(D,w){const o=this.iconFontsById[D];if(o)return o;let f={id:D,definition:w};return this.iconFontsById[D]=f,this._onDidChange.fire(),f}deregisterIconFont(D){delete this.iconFontsById[D]}getIconFonts(){return Object.keys(this.iconFontsById).map(D=>this.iconFontsById[D])}getIconFont(D){return this.iconFontsById[D]}toString(){const D=(k,r)=>k.id.localeCompare(r.id),w=k=>{for(;C.ThemeIcon.isThemeIcon(k.defaults);)k=this.iconsById[k.defaults.id];return`codicon codicon-${k?k.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const f=Object.keys(this.iconsById).map(k=>this.iconsById[k]);for(const k of f.filter(r=>!!r.description).sort(D))o.push(`|<i class="${w(k)}"></i>|${k.id}|${C.ThemeIcon.isThemeIcon(k.defaults)?k.defaults.id:k.id}|${k.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const k of f.filter(r=>!C.ThemeIcon.isThemeIcon(r.defaults)).sort(D))o.push(`|<i class="${w(k)}"></i>|${k.id}|`);return o.join(`
`)}}const t=new P;T.Registry.add(e.Extensions.IconContribution,t);function _(p,D,w,o){return t.registerIcon(p,D,w,o)}e.registerIcon=_;function n(){return t}e.getIconRegistry=n;function d(){for(const p of M.iconRegistry.all)t.registerIcon(p.id,p.definition,p.description);M.iconRegistry.onDidRegister(p=>t.registerIcon(p.id,p.definition,p.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let l=T.Registry.as(F.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,t.getIconSchema());const c=new u.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,I.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,I.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,I.localize)(4,null)),e.syncing=C.ThemeIcon.modify(M.Codicon.sync,"spin")}),define(we[48],be([0,1,20,25,2,4]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,I.createDecorator)("contextService");var F;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(F=e.WorkbenchState||(e.WorkbenchState={}));function T(n){const d=n;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=T;function C(n){const d=n;return!!(d&&typeof d=="object"&&E.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=C;class P{constructor(d,l,c,p,D){this._id=d,this._transient=c,this._configuration=p,this._ignorePathCasing=D,this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(d){this._id=d.id,this._configuration=d.configuration,this._transient=d.transient,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=u.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=P;class t{constructor(d,l){this.raw=l,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,M.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(n){return new t({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(we[64],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class u{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const I=this._idPool++;return this._data.set(I,E),this.logDebugInfo(),I}get(E,I){return this._data.has(E)?this._data.get(E)[I]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!u.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=u,u.enableDebugLogging=!1}),define(we[30],be([0,1,11,25,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class I{constructor(){this._systemSchemes=new Set(Object.keys(u.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(T=>{const C=this._providerInfo.get(T.scheme);return!(C===void 0||C&1024)})}$acceptProviderInfos(T,C){C===null?this._providerInfo.delete(T):this._providerInfo.set(T,C)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=I,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,u.createDecorator)("IExtHostInitDataService")}),define(we[154],be([0,1,12,27]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let E=class extends u.LogService{constructor(F,T){super(F.createLogger(T.logFile))}};E=xe([Be(0,u.ILoggerService),Be(1,M.IExtHostInitDataService)],E),e.ExtHostLogService=E}),define(we[155],be([0,1,13]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(F,T,C){this._deferredPromises=new Map,this._id=F,this._shared=T,this._storage=C,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new u.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of P.values())t.complete()}catch(t){for(const _ of P.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,F])=>F!==void 0).map(([F])=>F)}get whenReady(){return this._init}get(F,T){let C=this._value[F];return typeof C=="undefined"&&(C=T),C}update(F,T){this._value[F]=T;let C=this._deferredPromises.get(F);if(C!==void 0)return C.p;const P=new u.DeferredPromise;return this._deferredPromises.set(F,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(F,T){super(F.identifier.value,!0,T);this._extension=F}setKeysForSync(F){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},F)}}e.ExtensionGlobalMemento=E}),define(we[156],be([0,1,3,2,12]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let I=class{constructor(T,C){this._logService=T,this._notebooksAndEditors=C,this._onDidChangeNotebookDocumentMetadata=new u.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new u.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(T,C,P){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptModelChanged(C.value,P)}$acceptDirtyStateChanged(T,C){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T)).acceptDirty(C)}$acceptModelSaved(T){const C=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));this._onDidSaveNotebookDocument.fire(C.apiNotebook)}$acceptDocumentPropertiesChanged(T,C){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",T.path,C);const P=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(T));P.acceptDocumentPropertiesChanged(C),C.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:P.apiNotebook})}};I=xe([Be(0,E.ILogService)],I),e.ExtHostNotebookDocuments=I}),define(we[14],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,u.createDecorator)("IExtHostRpcService");class M{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=M});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[157],be([0,1,22,3]),function(ne,e,u,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class I{constructor(T,C){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=u.ExtensionIdentifier.toKey(T.identifier),Ze(this,E,C,"f"),Te(this,E,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(T){return Te(this,E,"f").get(this._id,T)}store(T,C){return Te(this,E,"f").store(this._id,T,C)}delete(T){return Te(this,E,"f").delete(this._id,T)}}e.ExtensionSecrets=I,E=new WeakMap}),define(we[86],be([0,1,4,3]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(F){this._enabled=F}$onDidChangeTelemetryEnabled(F){this._enabled=F,this._onDidChangeTelemetryEnabled.fire(F)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,u.createDecorator)("IExtHostTelemetry")}),define(we[49],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var u;(function(w){w[w.Upsert=0]="Upsert",w[w.RemoveChild=1]="RemoveChild",w[w.Invalidated=2]="Invalidated",w[w.SetProp=3]="SetProp",w[w.Bulk=4]="Bulk"})(u=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(w,o)=>{const f={controllerId:o};return M.set(w,f),f};e.createPrivateApiFor=E;const I=w=>M.get(w);e.getPrivateApiFor=I;const F=(w,o,f,k)=>{let r=f;return{enumerable:!0,configurable:!1,get(){return r},set(v){if(!k(r,v)){const s=r;r=v,w.listener?.({op:3,key:o,value:v,previous:s})}}}},T=(w,o)=>w===o,C={range:(w,o)=>w===o?!0:!w||!o?!1:w.isEqual(o),label:T,description:T,busy:T,error:T,canResolveChildren:T,tags:(w,o)=>!(w.length!==o.length||w.some(f=>!o.find(k=>f.id===k.id)))},P=Object.keys(C),t=(w,o)=>({range:F(w,"range",void 0,C.range),label:F(w,"label",o,C.label),description:F(w,"description",void 0,C.description),canResolveChildren:F(w,"canResolveChildren",!1,C.canResolveChildren),busy:F(w,"busy",!1,C.busy),error:F(w,"error",void 0,C.error),tags:F(w,"tags",[],C.tags)}),_=(w,o)=>{const f=new Map;for(const k of P)C[k](w[k],o[k])||f.set(k,o[k]);return f};e.diffTestItems=_;class n extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=n;class d extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class l extends Error{constructor(o,f,k){super(`TestItem with ID "${o}" is from controller "${f}" and cannot be added as a child of an item from controller "${k}".`)}}e.MixedTestItemController=l;const c=w=>{const o=(0,e.getPrivateApiFor)(w);let f=new Map;return{get size(){return f.size},forEach(k,r){for(const v of f.values())k.call(r,v,this)},replace(k){const r=new Map,v=new Set(f.keys()),s={op:4,ops:[]};for(const i of k){if(!(i instanceof p))throw new d(i.id);const m=(0,e.getPrivateApiFor)(i).controllerId;if(m!==o.controllerId)throw new l(i.id,m,o.controllerId);if(r.has(i.id))throw new n(i.id);r.set(i.id,i),v.delete(i.id),s.ops.push({op:0,item:i})}for(const i of v.keys())s.ops.push({op:1,id:i});o.listener?.(s),f=r},add(k){if(!(k instanceof p))throw new d(k.id);f.set(k.id,k),o.listener?.({op:0,item:k})},delete(k){f.delete(k)&&o.listener?.({op:1,id:k})},get(k){return f.get(k)},toJSON(){return Array.from(f.values())},[Symbol.iterator](){return f.values()}}};class p{constructor(o,f,k,r){if(f.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(f)} symbol`);const v=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:f,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return v.parent instanceof D?void 0:v.parent}},children:{value:c(this),enumerable:!0,writable:!1},...t(v,k)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=p;class D extends p{constructor(o,f){super(o,o,f,void 0)}}e.TestItemRootImpl=D}),define(we[65],be([0,1,4,150,3,14]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var F;(function(C){function P(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}C.fromApiTunnel=P;function t(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}C.fromServiceTunnel=t})(F=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,u.createDecorator)("IExtHostTunnelService");let T=class{constructor(P){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,t){}async getTunnels(){return[]}async setTunnelExtensionFunctions(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,t){return{dispose:()=>{}}}async $providePortAttributes(P,t,_,n,d){return[]}async $forwardPort(P,t){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=xe([Be(0,I.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[7],be([0,1,15,16,76,20,78,9,10,2,36,46,85]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n){"use strict";var d,l,c,p,D,w,o,f,k,r,v,s,i,m,a,g,b,h,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(U){function L(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(L,U),Object.setPrototypeOf(L.prototype,U.prototype),L}let B=D=class{constructor(L){d.set(this,void 0),Ze(this,d,L,"f")}static from(...L){let ee=L;return new D(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof Te(this,d,"f")=="function"&&(Te(this,d,"f").call(this),Ze(this,d,void 0,"f"))}};d=new WeakMap,B=D=xe([A],B),e.Disposable=B;let O=w=class{constructor(L,ee){if(L<0)throw(0,M.illegalArgument)("line must be non-negative");if(ee<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isBefore(ee)&&(ee=He)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof w)return!0;let{line:ee,character:Ee}=L;return typeof ee=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,M.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&ee===0?this:new w(this.line+Ee,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,M.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),Ee===this.line&&ee===this.character?this:new w(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};O=w=xe([A],O),e.Position=O;let S=o=class{constructor(L,ee,Ee,He){let tt,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(tt=new O(L,ee),at=new O(Ee,He)):L instanceof O&&ee instanceof O&&(tt=L,at=ee),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(L){return L instanceof o?!0:L?O.isPosition(L.start)&&O.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof o?this.contains(L._start)&&this.contains(L._end):L instanceof O?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=O.Max(L.start,this._start),Ee=O.Min(L.end,this._end);if(!ee.isAfter(Ee))return new o(ee,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=O.Min(L.start,this._start),Ee=O.Max(L.end,this.end);return new o(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,M.illegalArgument)();let Ee;return L?O.isPosition(L)?Ee=L:(Ee=L.start||this.start,ee=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new o(Ee,ee)}toJSON(){return[this.start,this.end]}};S=o=xe([A],S),e.Range=S;let x=f=class extends S{constructor(L,ee,Ee,He){let tt,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(tt=new O(L,ee),at=new O(Ee,He)):L instanceof O&&ee instanceof O&&(tt=L,at=ee),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(L){return L instanceof f?!0:L?S.isRange(L)&&O.isPosition(L.anchor)&&O.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=f=xe([A],x),e.Selection=x;class N{constructor(L,ee,Ee){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,M.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,M.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=N;class j extends Error{constructor(L,ee=n.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,j.prototype)}static NotAvailable(L,ee){return new j(L,n.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new j(L,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=j;var W;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var $;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=k=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof k?!0:L?S.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new k(L,ee)}static insert(L,ee){return k.replace(new S(L,L),ee)}static delete(L){return k.replace(L,"")}static setEndOfLine(L){const ee=new k(new S(new O(0,0),new O(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!S.isRange(L))throw(0,M.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,M.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,M.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=k=xe([A],V),e.TextEdit=V;var q;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let re=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,Ee,He){this._edits.push({_type:1,from:L,to:ee,options:Ee,metadata:He})}createFile(L,ee,Ee){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:Ee})}deleteFile(L,ee,Ee){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(L,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,Ee,He,tt){let at,ct,Ct=[],Rt;if(Vt.isNotebookRange(ee)&&Lt.isNotebookCellDataArray(Ee)&&!Lt.isNotebookCellDataArray(He)?(at=ee.start,ct=ee.end,Ct=Ee,Rt=He):typeof ee=="number"&&typeof Ee=="number"&&Lt.isNotebookCellDataArray(He)&&(at=ee,ct=Ee,Ct=He,Rt=tt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||Ct.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:ct-at,cells:Ct,metadata:Rt})}replaceNotebookCellMetadata(L,ee,Ee,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ee,metadata:Ee}})}replace(L,ee,Ee,He){this._edits.push({_type:2,uri:L,edit:new V(ee,Ee),metadata:He})}insert(L,ee,Ee,He){this.replace(L,new S(ee,ee),Ee,He)}delete(L,ee,Ee){this.replace(L,ee,"",Ee)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const Ee of ee)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const He=this._edits[Ee];He._type===2&&He.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}(0,u.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&ee.push(Ee.edit);return ee}entries(){const L=new I.ResourceMap;for(let ee of this._edits)if(ee._type===2){let Ee=L.get(ee.uri);Ee||(Ee=[ee.uri,[]],L.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};re=xe([A],re),e.WorkspaceEdit=re;let ae=r=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof r?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=r._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const Ee=new r;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=r._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const Ee=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const Ee=new r;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};ae=r=xe([A],ae),e.SnippetString=ae;var pe;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(pe=e.DiagnosticTag||(e.DiagnosticTag={}));var me;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(me=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=v=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof S)this.range=ee;else if(ee instanceof O)this.range=new S(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof v?!0:L?S.isRange(L.range)&&P.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=v=xe([A],Fe),e.Location=Fe;let Ye=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&S.isRange(L.location.range)&&P.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};Ye=xe([A],Ye),e.DiagnosticRelatedInformation=Ye;let Ue=class{constructor(L,ee,Ee=me.Error){if(!S.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=Ee}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,u.equals)(L.tags,ee.tags)&&(0,u.equals)(L.relatedInformation,ee.relatedInformation,Ye.isEqual)}};Ue=xe([A],Ue),e.Diagnostic=Ue;let Ve=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};Ve=xe([A],Ve),e.Hover=Ve;var Je;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Je=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(L,ee=Je.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Je[this.kind]}}};je=xe([A],je),e.DocumentHighlight=je;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var z;(function(U){U[U.Deprecated=1]="Deprecated"})(z=e.SymbolTag||(e.SymbolTag={}));let Q=s=class{constructor(L,ee,Ee,He,tt){this.name=L,this.kind=ee,this.containerName=tt,typeof Ee=="string"&&(this.containerName=Ee),He instanceof Fe?this.location=He:Ee instanceof S&&(this.location=new Fe(He,Ee)),s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};Q=s=xe([A],Q),e.SymbolInformation=Q;let X=i=class{constructor(L,ee,Ee,He,tt){this.name=L,this.detail=ee,this.kind=Ee,this.range=He,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(i.validate)}};X=i=xe([A],X),e.DocumentSymbol=X;var se;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(se=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let K=class{constructor(L,ee){this.title=L,this.kind=ee}};K=xe([A],K),e.CodeAction=K;let te=m=class{constructor(L){this.value=L}append(L){return new m(this.value?this.value+m.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+m.sep)}};te.sep=".",te=m=xe([A],te),e.CodeActionKind=te,te.Empty=new te(""),te.QuickFix=te.Empty.append("quickfix"),te.Refactor=te.Empty.append("refactor"),te.RefactorExtract=te.Refactor.append("extract"),te.RefactorInline=te.Refactor.append("inline"),te.RefactorRewrite=te.Refactor.append("rewrite"),te.Source=te.Empty.append("source"),te.SourceOrganizeImports=te.Source.append("organizeImports"),te.SourceFixAll=te.Source.append("fixAll");let ce=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ce=xe([A],ce),e.SelectionRange=ce;class Pe{constructor(L,ee,Ee,He,tt,at){this.kind=L,this.name=ee,this.detail=Ee,this.uri=He,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Oe{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=Oe;class We{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=We;var qe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};et=xe([A],et),e.CodeLens=et;let st=a=class{constructor(L,ee=!1){l.set(this,void 0),Ze(this,l,new E.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof a?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Te(this,l,"f").value}set value(L){Te(this,l,"f").value=L}get isTrusted(){return Te(this,l,"f").isTrusted}set isTrusted(L){Te(this,l,"f").isTrusted=L}get supportThemeIcons(){return Te(this,l,"f").supportThemeIcons}set supportThemeIcons(L){Te(this,l,"f").supportThemeIcons=L}get supportHtml(){return Te(this,l,"f").supportHtml}set supportHtml(L){Te(this,l,"f").supportHtml=L}appendText(L){return Te(this,l,"f").appendText(L),this}appendMarkdown(L){return Te(this,l,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Te(this,l,"f").appendCodeblock(ee??"",L),this}};l=new WeakMap,st=a=xe([A],st),e.MarkdownString=st;let _e=class{constructor(L,ee){this.label=L,this.documentation=ee}};_e=xe([A],_e),e.ParameterInformation=_e;let nt=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};nt=xe([A],nt),e.SignatureInformation=nt;let G=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};G=xe([A],G),e.SignatureHelp=G;var J;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(L,ee,Ee){this.text=L,this.position=ee,this.kind=Ee}};$e=xe([A],$e),e.InlayHint=$e;var Ge;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ge=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(U){U[U.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let ht=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ht=xe([A],ht),e.CompletionItem=ht;let Dt=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};Dt=xe([A],Dt),e.CompletionList=Dt;let Tt=class{constructor(L,ee,Ee){this.text=L,this.range=ee,this.command=Ee}};Tt=xe([A],Tt),e.InlineSuggestion=Tt;let It=class{constructor(L){this.items=L}};It=xe([A],It),e.InlineSuggestions=It;var Xe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Xe=e.ViewColumn||(e.ViewColumn={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ye;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var De;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(De=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Z;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var oe;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oe=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var he;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function L(ee){switch(ee){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=L}(Z=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let de=class{constructor(L,ee){if(ee&&!P.URI.isUri(ee))throw(0,M.illegalArgument)("target");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.target=ee}};de=xe([A],de),e.DocumentLink=de;let ke=class{constructor(L,ee,Ee,He){this.red=L,this.green=ee,this.blue=Ee,this.alpha=He}};ke=xe([A],ke),e.Color=ke;let Le=class{constructor(L,ee){if(ee&&!(ee instanceof ke))throw(0,M.illegalArgument)("color");if(!S.isRange(L)||L.isEmpty)throw(0,M.illegalArgument)("range");this.range=L,this.color=ee}};Le=xe([A],Le),e.ColorInformation=Le;let Me=class{constructor(L){if(!L||typeof L!="string")throw(0,M.illegalArgument)("label");this.label=L}};Me=xe([A],Me),e.ColorPresentation=Me;var ze;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(L,ee,Ee){if(this.startIndex=L,this.length=ee,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,M.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,M.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ue;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ue=e.TerminalLocation||(e.TerminalLocation={}));class fe{constructor(L){this.options=L,typeof L!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=fe;var ie;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ie=e.TaskRevealKind||(e.TaskRevealKind={}));var H;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(H=e.TaskPanelKind||(e.TaskPanelKind={}));let ve=g=class{constructor(L,ee){if(this.label=ee,typeof L!="string"||typeof ee!="string")throw(0,M.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};ve.Clean=new g("clean","Clean"),ve.Build=new g("build","Build"),ve.Rebuild=new g("rebuild","Rebuild"),ve.Test=new g("test","Test"),ve=g=xe([A],ve),e.TaskGroup=ve;function Ce(U){let L="";for(let ee=0;ee<U.length;ee++)L+=U[ee].replace(/,/g,",,")+",";return L}let Ke=class{constructor(L,ee,Ee){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,M.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return Ce(L)}};Ke=xe([A],Ke),e.ProcessExecution=Ke;let Ne=class{constructor(L,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L,this._args=ee,this._options=Ee}else{if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,M.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return Ce(L)}};Ne=xe([A],Ne),e.ShellExecution=Ne;var lt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(lt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class vt{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,t.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=vt;let ut=b=class{constructor(L,ee,Ee,He,tt,at){this.__deprecated=!1,this._definition=this.definition=L;let ct;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=He,ct=tt,this.__deprecated=!0):ee===Et.Global||ee===Et.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=tt,ct=at):(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=tt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ke?this._definition={type:b.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ne?this._definition={type:b.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:b.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:b.EmptyType,id:(0,t.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(b.EmptyType===ee||b.ProcessType===ee||b.ShellType===ee||b.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=b=xe([A],ut),e.Task=ut;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(L,ee=Pt.None){this.collapsibleState=ee,P.URI.isUri(L)?this.resourceUri=L:this.label=L}};dt=xe([A],dt),e.TreeItem=dt;var Pt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Pt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(L,ee){this.id=L,this.color=ee}};_t=xe([A],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let $t=class{constructor(L){this.id=L}};$t=xe([A],$t),e.ThemeColor=$t;var jt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(L,ee){if(typeof L!="string"&&(!L||!P.URI.isUri(L)&&!P.URI.isUri(L.uri)))throw(0,M.illegalArgument)("base");if(typeof ee!="string")throw(0,M.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=P.URI.file(L),this.base=L):P.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};St=xe([A],St),e.RelativePattern=St;let Wt=class{constructor(L,ee,Ee,He){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,t.generateUuid)()),this._id}};Wt=xe([A],Wt),e.Breakpoint=Wt;let ii=class extends Wt{constructor(L,ee,Ee,He,tt){super(ee,Ee,He,tt);if(L===null)throw(0,M.illegalArgument)("location");this.location=L}};ii=xe([A],ii),e.SourceBreakpoint=ii;let wt=class extends Wt{constructor(L,ee,Ee,He,tt){super(ee,Ee,He,tt);this.functionName=L}};wt=xe([A],wt),e.FunctionBreakpoint=wt;let Yt=class extends Wt{constructor(L,ee,Ee,He,tt,at,ct){super(He,tt,at,ct);if(!ee)throw(0,M.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=Ee}};Yt=xe([A],Yt),e.DataBreakpoint=Yt;let qt=class{constructor(L,ee,Ee){this.command=L,this.args=ee||[],this.options=Ee}};qt=xe([A],qt),e.DebugAdapterExecutable=qt;let ni=class{constructor(L,ee){this.port=L,this.host=ee}};ni=xe([A],ni),e.DebugAdapterServer=ni;let ri=class{constructor(L){this.path=L}};ri=xe([A],ri),e.DebugAdapterNamedPipeServer=ri;let At=class{constructor(L){this.implementation=L}};At=xe([A],At),e.DebugAdapterInlineImplementation=At;let Jt=class{constructor(L,ee){this.range=L,this.expression=ee}};Jt=xe([A],Jt),e.EvaluatableExpression=Jt;var bi;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(L,ee){this.range=L,this.text=ee}};zt=xe([A],zt),e.InlineValueText=zt;let Ht=class{constructor(L,ee,Ee=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=Ee}};Ht=xe([A],Ht),e.InlineValueVariableLookup=Ht;let mt=class{constructor(L,ee){this.range=L,this.expression=ee}};mt=xe([A],mt),e.InlineValueEvaluatableExpression=mt;let si=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};si=xe([A],si),e.InlineValueContext=si;var Nt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=h=class extends Error{constructor(L,ee=_.FileSystemProviderErrorCode.Unknown,Ee){super(P.URI.isUri(L)?L.toString(!0):L);this.code=Ee?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new h(L,_.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,_.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,_.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,_.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,_.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,_.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}};xt=h=xe([A],xt),e.FileSystemError=xt;let Xt=class{constructor(L,ee,Ee){this.start=L,this.end=ee,this.kind=Ee}};Xt=xe([A],Xt),e.FoldingRange=Xt;var Ei;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=mi;function Zt(U){return typeof U=="undefined"||(0,C.isStringArray)(U)}class oi{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,Ee=L.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,Ee=L.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,Ee,He,tt){if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(L,ee,Ee,He,tt);if(S.isRange(L)&&typeof ee=="string"&&Zt(Ee))return this._push(L,ee,Ee);throw(0,M.illegalArgument)()}_push(L,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,tt=L.start.character,at=L.end.character-L.start.character,ct=this._tokenTypeStrToInt.get(ee);let Ct=0;if(Ee)for(const Rt of Ee){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);Ct|=1<<Mt>>>0}this._pushEncoded(He,tt,at,ct,Ct)}_pushEncoded(L,ee,Ee,He,tt){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Ct=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<Ct;Ot++){let Ut=this._data[5*Ot],di=this._data[5*Ot+1];Ut===0?(Ut=Rt,di+=Mt):Ut+=Rt,this._data[5*Ot]=Ut,this._data[5*Ot+1]=di,Rt=Ut,Mt=di}}let at=L,ct=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=He,this._data[this._dataLen++]=tt,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const Ee=L.length/5|0;for(let ct=0;ct<Ee;ct++)ee[ct]=ct;ee.sort((ct,Ct)=>{const Rt=L[5*ct],Mt=L[5*Ct];if(Rt===Mt){const Ot=L[5*ct+1],Ut=L[5*Ct+1];return Ot-Ut}return Rt-Mt});const He=new Uint32Array(L.length);let tt=0,at=0;for(let ct=0;ct<Ee;ct++){const Ct=5*ee[ct],Rt=L[Ct+0],Mt=L[Ct+1],Ot=L[Ct+2],Ut=L[Ct+3],di=L[Ct+4],Ui=Rt-tt,Gi=Ui===0?Mt-at:Mt,hi=5*ct;He[hi+0]=Ui,He[hi+1]=Gi,He[hi+2]=Ot,He[hi+3]=Ut,He[hi+4]=di,tt=Rt,at=Mt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),L):new Gt(oi._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=oi;class Gt{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=Gt;class ai{constructor(L,ee,Ee){this.start=L,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=ai;class yi{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=yi;var Si;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new _t("arrow-left")},ei=xe([A],ei),e.QuickInputButtons=ei;var Di;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(L,ee,Ee){this.badge=L,this.tooltip=ee,this.color=Ee}static validate(L){if(L.badge){let ee=(0,T.nextCharLength)(L.badge,0);if(ee<L.badge.length&&(ee+=(0,T.nextCharLength)(L.badge,ee)),L.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ci;let li=class{constructor(L){this.kind=L}};li=xe([A],li),e.ColorTheme=li;var ui;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(ui=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(L,ee){if(L<0)throw(0,M.illegalArgument)("start must be positive");if(ee<0)throw(0,M.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof Vt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,Ee=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(Ee=L.end),ee===this._start&&Ee===this._end?this:new Vt(ee,Ee)}}e.NotebookRange=Vt;class Lt{constructor(L,ee,Ee,He,tt,at,ct){this.kind=L,this.value=ee,this.languageId=Ee,this.mime=He,this.outputs=tt??[],this.metadata=at,this.executionSummary=ct,Lt.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Lt.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Lt;class Ae{constructor(L){this.cells=L}}e.NotebookData=Ae;class Ft{constructor(L,ee){this.data=L,this.mime=ee;const Ee=(0,F.normalizeMimeType)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}static isNotebookCellOutputItem(L){return L instanceof Ft?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return Ft.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return Ft.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return Ft.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new Ft(L,ee)}static text(L,ee=F.Mimes.text){const Ee=Te(Ft,c,"f",p).encode(String(L));return new Ft(Ee,ee)}static json(L,ee="application/json"){const Ee=JSON.stringify(L,void 0,"	");return Ft.text(Ee,ee)}}e.NotebookCellOutputItem=Ft,c=Ft,p={value:new TextEncoder};class Qt{constructor(L,ee,Ee){this.items=Qt.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,t.generateUuid)(),this.metadata=ee??Ee)}static isNotebookCellOutput(L){return L instanceof Qt?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&(0,C.isArray)(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const Ee=new Set,He=new Set;for(let tt=0;tt<L.length;tt++){const at=L[tt],ct=(0,F.normalizeMimeType)(at.mime);if(!Ee.has(ct)){Ee.add(ct);continue}He.add(tt),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return He.size===0?L:L.filter((tt,at)=>!He.has(at))}}e.NotebookCellOutput=Qt;var bt;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ii;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ii=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(L,ee){this.text=L,this.alignment=ee}}e.NotebookCellStatusBarItem=pi;var Pi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(L,ee=[]){this.uri=L,this.provides=(0,u.asArray)(ee)}}e.NotebookRendererScript=Ti;let ci=class{constructor(L,ee){this.label=L,this.timestamp=ee}};ci=xe([A],ci),e.TimelineItem=ci;var Ai;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var vi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(vi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=Fi;class Mi{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var Oi;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Oi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Y=class{constructor(L=void 0,ee=void 0,Ee=void 0){this.include=L,this.exclude=ee,this.profile=Ee}};Y=xe([A],Y),e.TestRunRequest=Y;let le=y=class{constructor(L){this.message=L}static diff(L,ee,Ee){const He=new y(L);return He.expectedOutput=ee,He.actualOutput=Ee,He}};le=y=xe([A],le),e.TestMessage=le;let Se=class{constructor(L){this.id=L}};Se=xe([A],Se),e.TestTag=Se;let ot=class{constructor(L,ee){this.covered=L,this.total=ee}};ot=xe([A],ot),e.CoveredCount=ot;let yt=R=class{constructor(L,ee,Ee,He){this.uri=L,this.statementCoverage=ee,this.branchCoverage=Ee,this.functionCoverage=He}static fromDetails(L,ee){const Ee=new ot(0,0),He=new ot(0,0),tt=new ot(0,0);for(const ct of ee)if("branches"in ct){Ee.total+=1,Ee.covered+=ct.executionCount>0?1:0;for(const Ct of ct.branches)He.total+=1,He.covered+=Ct.executionCount>0?1:0}else tt.total+=1,tt.covered+=ct.executionCount>0?1:0;const at=new R(L,Ee,He.total>0?He:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=ee,at}};yt=R=xe([A],yt),e.FileCoverage=yt;let kt=class{constructor(L,ee,Ee=[]){this.executionCount=L,this.location=ee,this.branches=Ee}};kt=xe([A],kt),e.StatementCoverage=kt;let Ni=class{constructor(L,ee){this.executionCount=L,this.location=ee}};Ni=xe([A],Ni),e.BranchCoverage=Ni;let xi=class{constructor(L,ee){this.executionCount=L,this.location=ee}};xi=xe([A],xi),e.FunctionCoverage=xi;var Hi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(L,ee,Ee,He,tt,at){this.kind=L,this.name=ee,this.detail=Ee,this.uri=He,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=qi}),define(we[87],be([0,1,42,11,9,232,119,7,15]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function t(l,c){c?P.set(l,c):P.delete(l)}e.setWordDefinitionFor=t;function _(l){return P.get(l)}e.getWordDefinitionFor=_;class n extends I.MirrorTextModel{constructor(c,p,D,w,o,f,k,r){super(p,D,w,o);this._proxy=c,this._languageId=f,this._isDirty=k,this._notebook=r,this._isDisposed=!1}dispose(){(0,u.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(c){return(0,C.equals)(this._lines,c)}get document(){if(!this._document){const c=this;this._document={get uri(){return c._uri},get fileName(){return c._uri.fsPath},get isUntitled(){return c._uri.scheme===M.Schemas.untitled},get languageId(){return c._languageId},get version(){return c._versionId},get isClosed(){return c._isDisposed},get isDirty(){return c._isDirty},get notebook(){return c._notebook},save(){return c._save()},getText(p){return p?c._getTextInRange(p):c.getText()},get eol(){return c._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return c._lines.length},lineAt(p){return c._lineAt(p)},offsetAt(p){return c._offsetAt(p)},positionAt(p){return c._positionAt(p)},validateRange(p){return c._validateRange(p)},validatePosition(p){return c._validatePosition(p)},getWordRangeAtPosition(p,D){return c._getWordRangeAtPosition(p,D)}}}return Object.freeze(this._document)}_acceptLanguageId(c){(0,u.ok)(!this._isDisposed),this._languageId=c}_acceptIsDirty(c){(0,u.ok)(!this._isDisposed),this._isDirty=c}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(c){const p=this._validateRange(c);if(p.isEmpty)return"";if(p.isSingleLine)return this._lines[p.start.line].substring(p.start.character,p.end.character);const D=this._eol,w=p.start.line,o=p.end.line,f=[];f.push(this._lines[w].substring(p.start.character));for(let k=w+1;k<o;k++)f.push(this._lines[k]);return f.push(this._lines[o].substring(0,p.end.character)),f.join(D)}_lineAt(c){let p;if(c instanceof T.Position?p=c.line:typeof c=="number"&&(p=c),typeof p!="number"||p<0||p>=this._lines.length||Math.floor(p)!==p)throw new Error("Illegal value for `line`");return new d(p,this._lines[p],p===this._lines.length-1)}_offsetAt(c){return c=this._validatePosition(c),this._ensureLineStarts(),this._lineStarts.getPrefixSum(c.line-1)+c.character}_positionAt(c){c=Math.floor(c),c=Math.max(0,c),this._ensureLineStarts();const p=this._lineStarts.getIndexOf(c),D=this._lines[p.index].length;return new T.Position(p.index,Math.min(p.remainder,D))}_validateRange(c){if(!(c instanceof T.Range))throw new Error("Invalid argument");const p=this._validatePosition(c.start),D=this._validatePosition(c.end);return p===c.start&&D===c.end?c:new T.Range(p.line,p.character,D.line,D.character)}_validatePosition(c){if(!(c instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return c.with(0,0);let{line:p,character:D}=c,w=!1;if(p<0)p=0,D=0,w=!0;else if(p>=this._lines.length)p=this._lines.length-1,D=this._lines[p].length,w=!0;else{const o=this._lines[p].length;D<0?(D=0,w=!0):D>o&&(D=o,w=!0)}return w?new T.Position(p,D):c}_getWordRangeAtPosition(c,p){const D=this._validatePosition(c);if(!p)p=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(p))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${p.source}' because it matches the empty string.`);const w=(0,F.getWordAtText)(D.character+1,(0,F.ensureValidWordDefinition)(p),this._lines[D.line],0);if(w)return new T.Range(D.line,w.startColumn-1,D.line,w.endColumn-1)}}e.ExtHostDocumentData=n;class d{constructor(c,p,D){this._line=c,this._text=p,this._isLastLine=D}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(we[158],be([0,1,7,3,233,6,57,20,2,36]),function(ne,e,u,M,E,I,F,T,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(n,d,l,c){this._notebook=l,this._selector=c,this._disposables=new I.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=C.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(D=>{const w=this._cellUris.get(D.document.uri);w!==void 0&&(this._cellLengths.setValue(w,this._cells[w].document.getText().length+1),this._cellLines.setValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const p=D=>{D===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(D=>p(D.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new T.ResourceMap;const n=[],d=[];for(const l of this._notebook.getCells())l.kind===u.NotebookCellKind.Code&&(!this._selector||(0,F.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),n.push(l.document.getText().length+1),d.push(l.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(n){if(!n){let w="";for(const o of this._cells)w+=o.document.getText()+`
`;return w=w.slice(0,-1),w}if(n.isEmpty)return"";const d=this.locationAt(n.start),l=this.locationAt(n.end),c=this._cellUris.get(d.uri),p=this._cellUris.get(l.uri);if(c===void 0||p===void 0)return"";if(c===p)return this._cells[c].document.getText(new u.Range(d.range.start,l.range.end));const D=[this._cells[c].document.getText(new u.Range(d.range.start,new u.Position(this._cells[c].document.lineCount,0)))];for(let w=c+1;w<p;w++)D.push(this._cells[w].document.getText());return D.push(this._cells[p].document.getText(new u.Range(new u.Position(0,0),l.range.end))),D.join(`
`)}offsetAt(n){const d=this._cellLines.getIndexOf(n.line),l=this._cellLengths.getPrefixSum(d.index-1),c=this._cells[d.index].document.offsetAt(n.with(d.remainder));return l+c}positionAt(n){if(typeof n=="number"){const l=this._cellLengths.getIndexOf(n),c=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(c)}const d=this._cellUris.get(n.uri);if(d!==void 0){const l=this._cellLines.getPrefixSum(d-1);return new u.Position(l+n.range.start.line,n.range.start.character)}return new u.Position(0,0)}locationAt(n){u.Range.isRange(n)||(n=new u.Range(n,n));const d=this._cellLines.getIndexOf(n.start.line);let l=d;n.isEmpty||(l=this._cellLines.getIndexOf(n.end.line));const c=new u.Position(d.remainder,n.start.character),p=new u.Position(l.remainder,n.end.character),D=new u.Range(c,p),w=this._cells[d.index];return new u.Location(w.document.uri,w.document.validateRange(D))}contains(n){return this._cellUris.has(n)}validateRange(n){const d=this.validatePosition(n.start),l=this.validatePosition(n.end);return n.with(d,l)}validatePosition(n){const d=this._cellLines.getIndexOf(n.line),l=new u.Position(d.remainder,n.character),c=this._cells[d.index].document.validatePosition(l),p=this._cellLines.getPrefixSum(d.index-1);return new u.Position(p+c.line,c.character)}}e.ExtHostNotebookConcatDocument=t}),define(we[159],be([0,1,7,14,3]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let I=class{constructor(T){this._actual=new u.ColorTheme(u.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let C=T==="light"?u.ColorThemeKind.Light:T==="dark"?u.ColorThemeKind.Dark:u.ColorThemeKind.HighContrast;this._actual=new u.ColorTheme(C),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};I=xe([Be(0,M.IExtHostRpcService)],I),e.ExtHostTheming=I}),define(we[66],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,u.createDecorator)("IURITransformerService");class M{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=F=>F,this.transformOutgoing=F=>F,this.transformOutgoingURI=F=>F,this.transformOutgoingScheme=F=>F)}}e.URITransformerService=M}),define(we[160],be([0,1,23]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(C){let P=this.buffers.indexOf(C);return P<0&&(P=this.buffers.length,this.buffers.push(C)),P}}function E(T,C){if(C.serializeBuffersForPostMessage){const P=new M,t=(d,l)=>{if(l instanceof ArrayBuffer){const c=P.add(l);return{$$vscode_array_buffer_reference$$:!0,index:c}}else if(ArrayBuffer.isView(l)){const c=I(l);if(c){const p=P.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:p,view:{type:c,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},_=JSON.stringify(T,t),n=P.buffers.map(d=>{const l=new Uint8Array(d);return u.VSBuffer.wrap(l)});return{message:_,buffers:n}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=E;function I(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function F(T,C){const P=C.map(n=>{const d=new ArrayBuffer(n.byteLength);return new Uint8Array(d).set(n.buffer),d}),t=C.length?(n,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const l=d,{index:c}=l,p=P[c];if(l.view)switch(l.view.type){case 1:return new Int8Array(p,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(p,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(p,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(p,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(p,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(p,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(p,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(p,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(p,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(p,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(p,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return p}return d}:void 0;return{message:JSON.parse(T,t),arrayBuffers:P}}e.deserializeWebviewMessage=F}),define(we[161],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var u;(function(M){function E(F){const T={items:new Map};return F.types.forEach((C,P)=>{T.items.set(C,{asString:async()=>F.items[P].asString})}),T}M.toITreeDataTransfer=E;async function I(F){const T={types:[],items:[]},C=Array.from(F.items.entries());for(const P of C)T.types.push(P[0]),T.items.push({asString:await P[1].asString()});return T}M.toTreeDataTransferDTO=I})(u=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[67],be([0,1,11,2]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(T,C){return T.scheme===u.Schemas.http||T.scheme===u.Schemas.https?T:(C&&C.authority&&C.isRemote&&T.scheme===u.Schemas.file&&(T=M.URI.from({scheme:u.Schemas.vscodeRemote,authority:C.authority,path:T.path})),M.URI.from({scheme:u.Schemas.https,authority:`${T.scheme}+${I(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=E;function I(T){return T.replace(/./g,C=>{const P=C.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?C:"-"+P.toString(16).padStart(4,"0")})}function F(T){return T.replace(/-([0-9a-f]{4})/g,(C,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=F}),define(we[162],be([0,1,3,6,67]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class I{constructor(T,C,P){this._proxy=T,this._editors=C,this._initData=P,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const t=C.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,C,P,t,_){let n;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===T){n=o;break}if(!n)throw new Error("not a visible editor");const d=this,l=this._handlePool++,c=new u.Emitter,p=new u.Emitter,D=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,E.asWebviewUri)(o,d._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(o){this._options=o,d._proxy.$setOptions(l,o)}get options(){return this._options}set html(o){this._html=o,d._proxy.$setHtml(l,o)}get html(){return this._html}get onDidReceiveMessage(){return c.event}postMessage(o){return d._proxy.$postMessage(l,o)}},w=new class{constructor(){this.editor=T,this.line=C,this.height=P,this.webview=D,this.onDidDispose=p.event}dispose(){d._insets.has(l)&&(d._insets.delete(l),d._proxy.$disposeEditorInset(l),p.fire(),p.dispose(),c.dispose())}};return this._proxy.$createEditorInset(l,n.id,n.value.document.uri,C+1,P,t||{},_.identifier,_.extensionLocation),this._insets.set(l,{editor:T,inset:w,onDidReceiveMessage:c}),w}$onDidDispose(T){const C=this._insets.get(T);C&&C.inset.dispose()}$onDidReceiveMessage(T,C){const P=this._insets.get(T);P&&P.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=I}),define(we[163],be([0,1,132,10,2,6,4,37,29,46,15,11]),function(ne,e,u,M,E,I,F,T,C,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.ActiveEditorDirtyContext=new T.RawContextKey("activeEditorIsDirty",!1,(0,u.localize)(2,null)),e.ActiveEditorPinnedContext=new T.RawContextKey("activeEditorIsNotPreview",!1,(0,u.localize)(3,null)),e.ActiveEditorStickyContext=new T.RawContextKey("activeEditorIsPinned",!1,(0,u.localize)(4,null)),e.ActiveEditorReadonlyContext=new T.RawContextKey("activeEditorIsReadonly",!1,(0,u.localize)(5,null)),e.ActiveEditorCanRevertContext=new T.RawContextKey("activeEditorCanRevert",!1,(0,u.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new T.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new T.RawContextKey("activeEditor",null,{type:"string",description:(0,u.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new T.RawContextKey("activeEditorAvailableEditorIds","",(0,u.localize)(8,null)),e.TextCompareEditorVisibleContext=new T.RawContextKey("textCompareEditorVisible",!1,(0,u.localize)(9,null)),e.TextCompareEditorActiveContext=new T.RawContextKey("textCompareEditorActive",!1,(0,u.localize)(10,null)),e.SideBySideEditorActiveContext=new T.RawContextKey("sideBySideEditorActive",!1,(0,u.localize)(11,null)),e.EditorGroupEditorsCountContext=new T.RawContextKey("groupEditorsCount",0,(0,u.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new T.RawContextKey("activeEditorGroupEmpty",!1,(0,u.localize)(13,null)),e.ActiveEditorGroupIndexContext=new T.RawContextKey("activeEditorGroupIndex",0,(0,u.localize)(14,null)),e.ActiveEditorGroupLastContext=new T.RawContextKey("activeEditorGroupLast",!1,(0,u.localize)(15,null)),e.ActiveEditorGroupLockedContext=new T.RawContextKey("activeEditorGroupLocked",!1,(0,u.localize)(16,null)),e.MultipleEditorGroupsContext=new T.RawContextKey("multipleEditorGroups",!1,(0,u.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new T.RawContextKey("editorIsOpen",!1,(0,u.localize)(18,null)),e.InEditorZenModeContext=new T.RawContextKey("inZenMode",!1,(0,u.localize)(19,null)),e.IsCenteredLayoutContext=new T.RawContextKey("isCenteredLayout",!1,(0,u.localize)(20,null)),e.SplitEditorsVertically=new T.RawContextKey("splitEditorsVertically",!1,(0,u.localize)(21,null)),e.EditorAreaVisibleContext=new T.RawContextKey("editorAreaVisible",!0,(0,u.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(O,S,x){for(const N of x.visibleEditorPanes)if(N.group.id===S&&O.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function d(O){if(k(O))return!1;const S=O;return E.URI.isUri(S?.resource)}e.isResourceEditorInput=d;function l(O){if(k(O))return!1;const S=O;return S?.original!==void 0&&S.modified!==void 0}e.isResourceDiffEditorInput=l;function c(O){if(k(O)||l(O))return!1;const S=O;return S?.primary!==void 0&&S.secondary!==void 0}e.isResourceSideBySideEditorInput=c;function p(O){if(k(O))return!1;const S=O;return S?S.resource===void 0||S.resource.scheme===_.Schemas.untitled||S.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=p;var D;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(D=e.Verbosity||(e.Verbosity={}));var w;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(w=e.SaveReason||(e.SaveReason={}));var o;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class f extends I.Disposable{}e.AbstractEditorInput=f;function k(O){return O instanceof f}e.isEditorInput=k;function r(O){const S=O;return E.URI.isUri(S?.preferredResource)}function v(O){const S=O;return k(S?.primary)&&k(S?.secondary)}e.isSideBySideEditorInput=v;function s(O){const S=O;return k(S?.modified)&&k(S?.original)}e.isDiffEditorInput=s;function i(O){return k(O?.editor)}e.isEditorInputWithOptions=i;function m(O){const S=O;return i(O)&&S?.group!==void 0}e.isEditorInputWithOptionsAndGroup=m;function a(O){const S=O;return typeof S?.groupId=="number"&&k(S.editor)}e.isEditorIdentifier=a;var g;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(g=e.EditorCloseContext||(e.EditorCloseContext={}));var b;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(b=e.SideBySideEditor||(e.SideBySideEditor={}));class h{getOriginalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:j,secondary:W}=this.getSideEditors(S);if(j&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getOriginalUri(j,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getOriginalUri(j,{filterByScheme:x.filterByScheme})??this.getOriginalUri(W,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?j:W}}if(l(S)||c(S))return;const N=r(S)?S.preferredResource:S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(S){return v(S)||c(S)?{primary:S.primary,secondary:S.secondary}:s(S)||l(S)?{primary:S.modified,secondary:S.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(S,x){if(!S)return;if(x?.supportSideBySide){const{primary:j,secondary:W}=this.getSideEditors(S);if(j&&W){if(x?.supportSideBySide===b.BOTH)return{primary:this.getCanonicalUri(j,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===b.ANY)return this.getCanonicalUri(j,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:x.filterByScheme});S=x.supportSideBySide===b.PRIMARY?j:W}}if(l(S)||c(S))return;const N=S.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(S,x){if(Array.isArray(x)){if(x.some(N=>S.scheme===N))return S}else if(x===S.scheme)return S}}e.EditorResourceAccessor=new h;var y;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(S){const x=this.instantiationService=S.get(F.IInstantiationService);for(const[N,j]of this.editorSerializerConstructors)this.createEditorSerializer(N,j,x);this.editorSerializerConstructors.clear()}createEditorSerializer(S,x,N){const j=N.createInstance(x);this.editorSerializerInstances.set(S,j)}registerFileEditorFactory(S){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=S}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(S,x){if(this.editorSerializerConstructors.has(S)||this.editorSerializerInstances.has(S))throw new Error(`A editor serializer with type ID '${S}' was already registered.`);return this.instantiationService?this.createEditorSerializer(S,x,this.instantiationService):this.editorSerializerConstructors.set(S,x),(0,I.toDisposable)(()=>{this.editorSerializerConstructors.delete(S),this.editorSerializerInstances.delete(S)})}getEditorSerializer(S){return this.editorSerializerInstances.get(typeof S=="string"?S:S.typeId)}}C.Registry.add(e.EditorExtensions.EditorFactory,new R);async function A(O,S){if(!O||!O.length)return[];const x=await Promise.all(O.map(async N=>{const j=E.URI.revive(N.fileUri);if(!j||!await S.canHandleResource(j))return;let $=N.exists,V=N.type;if(typeof $!="boolean"||typeof V!="number")try{V=(await S.resolve(j)).isFile?P.FileType.File:P.FileType.Unknown,$=!0}catch{$=!1}if(!$&&N.openOnlyIfExists||V!==P.FileType.File)return;const q={selection:$?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let re;return $?re={resource:j,options:q}:re={resource:j,options:q,forceUntitled:!0},re}));return(0,t.coalesce)(x)}e.pathsToEditors=A;var B;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(we[164],be([0,1,3,37,133,4,6,20,29,15,53,24,34,153]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var l;(function(m){m.ViewContainersRegistry="workbench.registry.view.containers",m.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var c;(function(m){m[m.Sidebar=0]="Sidebar",m[m.Panel=1]="Panel",m[m.AuxiliaryBar=2]="AuxiliaryBar"})(c=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function p(m){switch(m){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=p;function D(m){return`viewContainer.${m}.enabled`}e.getEnabledViewContainerContextKey=D;class w extends F.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new u.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new u.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(a,g,b){const h=this.get(a.id);if(h)return h;const y=a;return y.openCommandActionDescriptor=b?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,T.getOrSet)(this.viewContainers,g,[]).push(y),b?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:g}),y}deregisterViewContainer(a){for(const g of this.viewContainers.keys()){const b=this.viewContainers.get(g),h=b?.indexOf(a);if(h!==-1){b?.splice(h,1),b.length===0&&this.viewContainers.delete(g),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:g});return}}}get(a){return this.all.filter(g=>g.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(g=>this.getViewContainers(g).filter(b=>b?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(g=>this.getViewContainerLocation(g)===a)}}C.Registry.add(l.ViewContainersRegistry,new w);var o;(function(m){m.Open="2_open",m.Debug="4_debug",m.SCM="5_scm",m.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function f(m,a){const g=m.group??o.More,b=a.group??o.More;return g!==b?g.localeCompare(b):(m.order??5)-(a.order??5)}class k extends F.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new u.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new u.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new u.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new u.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(a,g){this.registerViews2([{views:a,viewContainer:g}])}registerViews2(a){a.forEach(({views:g,viewContainer:b})=>this.addViews(g,b)),this._onViewsRegistered.fire(a)}deregisterViews(a,g){const b=this.removeViews(a,g);b.length&&this._onViewsDeregistered.fire({views:b,viewContainer:g})}moveViews(a,g){for(const b of this._views.keys())if(b!==g){const h=this.removeViews(a,b);h.length&&(this.addViews(h,g),this._onDidChangeContainer.fire({views:h,from:b,to:g}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const g of this._viewContainers){const b=(this._views.get(g)||[]).filter(h=>h.id===a)[0];if(b)return b}return null}getViewContainer(a){for(const g of this._viewContainers)if((this._views.get(g)||[]).filter(h=>h.id===a)[0])return g;return null}registerViewWelcomeContent(a,g){return this._viewWelcomeContents.add(a,g),this._onDidChangeViewWelcomeContent.fire(a),(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(a,g),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,g){const b=new Map;for(const[h,y]of g)this._viewWelcomeContents.add(a,y),b.set(h,(0,F.toDisposable)(()=>{this._viewWelcomeContents.delete(a,y),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),b}getViewWelcomeContent(a){const g=[];return this._viewWelcomeContents.forEach(a,b=>g.push(b)),g.sort(f)}addViews(a,g){let b=this._views.get(g);b||(b=[],this._views.set(g,b),this._viewContainers.push(g));for(const h of a){if(this.getView(h.id)!==null)throw new Error((0,E.localize)(1,null,h.id));b.push(h)}}removeViews(a,g){const b=this._views.get(g);if(!b)return[];const h=[],y=[];for(const R of b)a.includes(R)?h.push(R):y.push(R);return h.length&&(y.length?this._views.set(g,y):(this._views.delete(g),this._viewContainers.splice(this._viewContainers.indexOf(g),1))),h}}C.Registry.add(l.ViewsRegistry,new k),e.IViewsService=(0,I.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function r(m){return`view.${m}.visible`}e.getVisbileViewContextKey=r,e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var v;(function(m){m[m.Default=0]="Default",m[m.Expand=1]="Expand"})(v=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(m){m[m.None=0]="None",m[m.Collapsed=1]="Collapsed",m[m.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(a,g){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,a),this._hasResolve=!!g,this.resolve=async b=>{if(g&&!this.resolved){const h=await g(b);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}b.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(we[165],be([0,1,3,13,134]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class I{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new u.Emitter,this._onExit=new u.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,C,P,t){const _={command:T};if(C&&Object.keys(C).length>0&&(_.arguments=C),this.internalSend("request",_),typeof t=="number"){const n=setTimeout(()=>{clearTimeout(n);const d=this.pendingRequests.get(_.seq);if(d){this.pendingRequests.delete(_.seq);const l={type:"response",seq:0,request_seq:_.seq,success:!1,command:T,message:(0,E.localize)(0,null,t,T)};d(l)}},t)}return P&&this.pendingRequests.set(_.seq,P),_.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,C){return T.type!=="event"||C.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,M.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback&&this.eventCallback(T);break;case"request":this.requestCallback&&this.requestCallback(T);break;case"response":const C=T,P=this.pendingRequests.get(C.request_seq);P&&(this.pendingRequests.delete(C.request_seq),P(C));break}}}internalSend(T,C){C.type=T,C.seq=this.sequence++,this.sendMessage(C)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((C,P)=>T.set(P,C)),await(0,M.timeout)(500),T.forEach((C,P)=>{C({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=I}),define(we[166],be([0,1,9,2,17,24,11]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function C(s,i,m){return s.replace(T,function(a,g){return i&&g.length>0&&g[0]!=="_"?a:m&&m.hasOwnProperty(g)?m[g]:a})}e.formatPII=C;function P(s){const i={};for(const m of Object.keys(s))m.startsWith("!")||(i[m]=s[m]);return i}e.filterExceptionsFromTelemetry=P;function t(s){return s.configuration.request==="attach"&&!_(s)&&(!s.parentSession||t(s.parentSession))}e.isSessionAttach=t;function _(s){let i=s.configuration.type;if(!!i)return i==="vslsShare"&&(i=s.configuration.adapterProxy.configuration.type),(0,u.equalsIgnoreCase)(i,"extensionhost")||(0,u.equalsIgnoreCase)(i,"pwa-extensionhost")?s:s.parentSession?_(s.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(s){return s.type&&(s.label||s.program||s.runtime)}e.isDebuggerMainContribution=n;function d(s,i,m){let a,g=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,h=null;for(;h=b.exec(s);){let y=h.index+1,R=y+h[0].length;if(y<=i&&R>=m){a=h[0],g=y;break}}if(a){let y=/\w+/g,R=null;for(;(R=y.exec(a))&&!(R.index+1+g+R[0].length>=m););R&&(a=a.substring(0,y.lastIndex))}return a?{start:g,end:g+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(s){return!!(s&&s.match(l))}e.isUri=c;function p(s){if(typeof s.path=="string"&&!(typeof s.sourceReference=="number"&&s.sourceReference>0)){if(c(s.path))return M.URI.parse(s.path);if((0,E.isAbsolute)(s.path))return M.URI.file(s.path)}return s.path}function D(s){if(typeof s.path=="object"){const i=M.URI.revive(s.path);if(i)return i.scheme===F.Schemas.file?i.fsPath:i.toString()}return s.path}function w(s,i){const m=i?p:D,a=(0,I.deepClone)(s);return f(a,(g,b)=>{g&&b&&(b.path=m(b))}),a}e.convertToDAPaths=w;function o(s,i){const m=i?p:D,a=(0,I.deepClone)(s);return f(a,(g,b)=>{!g&&b&&(b.path=m(b))}),a}e.convertToVSCPaths=o;function f(s,i){switch(s.type){case"event":const m=s;switch(m.event){case"output":i(!1,m.body.source);break;case"loadedSource":i(!1,m.body.source);break;case"breakpoint":i(!1,m.body.breakpoint.source);break;default:break}break;case"request":const a=s;switch(a.command){case"setBreakpoints":i(!0,a.arguments.source);break;case"breakpointLocations":i(!0,a.arguments.source);break;case"source":i(!0,a.arguments.source);break;case"gotoTargets":i(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(b=>i(!1,b));break;default:break}break;case"response":const g=s;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(b=>i(!1,b.source));break;case"loadedSources":g.body.sources.forEach(b=>i(!1,b));break;case"scopes":g.body.scopes.forEach(b=>i(!1,b.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(b=>i(!1,b.source));break;case"setBreakpoints":g.body.breakpoints.forEach(b=>i(!1,b.source));break;default:break}break}}function k(s){return s.filter(i=>!i.presentation?.hidden).sort((i,m)=>i.presentation?m.presentation?i.presentation.group?m.presentation.group?i.presentation.group!==m.presentation.group?i.presentation.group.localeCompare(m.presentation.group):r(i.presentation.order,m.presentation.order):-1:m.presentation.group?1:r(i.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=k;function r(s,i){return typeof s!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:s-i}async function v(s,i){const m=s.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(m!=="none"&&(await i.saveAll(),m==="allEditorsInActiveGroup")){const a=i.activeEditorPane;a&&await i.save({editor:a.input,groupId:a.group.id})}await s.reloadConfiguration()}e.saveAllBeforeDebugStart=v}),define(we[88],be([0,1,28,167,78,11,17,26,37]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var P;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(P=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var t;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(t=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var p;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(p=e.CellEditType||(e.CellEditType={}));var D;(function(y){y.scheme=I.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function A(N,j){return N.with({scheme:y.scheme,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==I.Schemas.file?N.scheme:""}`})}y.generate=A;function B(N){if(N.scheme!==y.scheme)return;const j=R.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||I.Schemas.file,fragment:null})}:void 0}y.parse=B;function O(N){if(N.scheme!==I.Schemas.vscodeNotebookCellMetadata)return;const j=R.exec(N.fragment);return j?{handle:Number(j[1]),notebook:N.with({scheme:N.fragment.substr(j[0].length)||I.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=O;function S(N,j,W){return N.with({scheme:W,fragment:`ch${j.toString().padStart(7,"0")}${N.scheme!==I.Schemas.file?N.scheme:""}`})}y.generateCellUri=S;function x(N,j){if(N.scheme!==j)return;const W=R.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||I.Schemas.file,fragment:null})}:void 0}y.parseCellUri=x})(D=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(y){return w.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function f(y){return w.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=f;function k(y){return w.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=k;const r=y=>T.isWindows?y.replace(/\//g,"\\"):y;class v{constructor(R=[],A=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=A,this.order=[...new Set(R)].map(B=>({pattern:B,matches:u.parse(r(B))}))}sort(R){const A=new Map(M.Iterable.map(R,O=>[O,r(O)]));let B=[];for(const{matches:O}of this.order)for(const[S,x]of A)if(O(x)){B.push(S),A.delete(S);break}return A.size&&(B=B.concat([...A.keys()].sort((O,S)=>this.defaultOrder.indexOf(O)-this.defaultOrder.indexOf(S)))),B}prioritize(R,A){const B=this.findIndex(R);if(B===-1){this.order.unshift({pattern:R,matches:u.parse(r(R))});return}const O=new Set(A.map(x=>this.findIndex(x,B)));O.delete(-1);const S=Array.from(O).sort();this.order.splice(B+1,0,...S.map(x=>this.order[x]));for(let x=S.length-1;x>=0;x--)this.order.splice(S[x],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,A=this.order.length){const B=r(R);for(let O=0;O<A;O++)if(this.order[O].matches(B))return O;return-1}}e.MimeTypeDisplayOrder=v;function s(y,R,A,B=(O,S)=>O===S){const O=[];function S(j,W,$){if(W===0&&$.length===0)return;const V=O[O.length-1];V&&V.start+V.deleteCount===j?(V.deleteCount+=W,V.toInsert.push(...$)):O.push({start:j,deleteCount:W,toInsert:$})}let x=0,N=0;for(;;){if(x===y.length){S(x,0,R.slice(N));break}if(N===R.length){S(x,y.length-x,[]);break}const j=y[x],W=R[N];if(B(j,W)){x+=1,N+=1;continue}A(W)?(S(x,1,[]),x+=1):(S(x,0,[W]),N+=1)}return O}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new C.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(y){y.default="default",y.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function m(y){const R=y;return!!((typeof R.include=="string"||u.isRelativePattern(R.include))&&(typeof R.exclude=="string"||u.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=m;function a(y,R,A){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let B=m(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,O=m(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(u.match(B,(0,F.basename)(A.fsPath).toLowerCase()))return!(O&&u.match(O,(0,F.basename)(A.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class g{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let A=0;A<this.textModel.cells.length;A++)R[A]=this.textModel.cells[A].getHashValue();return R}}e.CellSequence=g,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var b;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class h{static create(R){return`${h._prefix}${R}`}static parse(R){if(R.startsWith(h._prefix))return R.substr(h._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=h,h._prefix="notebook/"}),define(we[168],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,u.createDecorator)("INotebookExecutionService")}),define(we[169],be([0,1,4,37]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,u.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[170],be([0,1,136,4,37]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,u.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,u.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,u.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[171],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function u(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=u;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(we[89],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var u;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(u=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var I;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(I=e.TestItemExpandState||(e.TestItemExpandState={}));const F=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=F;var T;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(T=e.DetailType||(e.DetailType={}));var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));class P{add(n){}update(n){}remove(n,d){}complete(){}}e.IncrementalChangeCollector=P;class t{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const d=this.createChangeCollector();for(const l of n)switch(l[0]){case 0:{const c=l[1];if(c.parent){if(this.items.has(c.parent)){const p=this.items.get(c.parent);p.children.add(c.item.extId);const D=this.createItem(c,p);this.items.set(c.item.extId,D),d.add(D)}}else{const p=this.createItem(c);this.roots.add(p),this.items.set(c.item.extId,p),d.add(p)}c.expand===2&&this.busyControllerCount++;break}case 1:{const c=l[1],p=this.items.get(c.extId);if(!p)break;c.expand!==void 0&&(p.expand===2&&this.busyControllerCount--,c.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(p,c),d.update(p);break}case 2:{const c=this.items.get(l[1]);if(!c)break;c.parent?this.items.get(c.parent).children.delete(c.item.extId):this.roots.delete(c);const p=[[l[1]]];for(;p.length;)for(const D of p.pop()){const w=this.items.get(D);w&&(p.push(w.children),this.items.delete(D),d.remove(w,w!==c),w.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}d.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new P}}e.AbstractIncrementalTestCollection=t}),define(we[68],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(I){I.Delimiter="\0"})(u=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(F,T=F.length){if(this.path=F,this.viewEnd=T,F.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(F,T,C=F.parent){if(F.id===T)return new E([T]);let P=[F.id];for(let t=C;t&&t.id!==T;t=t.parent)P.push(t.id);return P.push(T),new E(P.reverse())}static isRoot(F){return!F.includes("\0")}static fromString(F){return new E(F.split("\0"))}static join(F,T){return new E([...F.path,T])}static joinToString(F,T){return F.toString()+"\0"+T}static compare(F,T){return F===T?0:T.startsWith(F+"\0")?2:F.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let F=1;F<=this.viewEnd;F++)yield new E(this.path,F)}compare(F){if(typeof F=="string")return E.compare(this.toString(),F);for(let T=0;T<F.viewEnd&&T<this.viewEnd;T++)if(F.path[T]!==this.path[T])return 1;return F.viewEnd>this.viewEnd?2:F.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let F=1;F<this.viewEnd;F++)this.stringifed+="\0",this.stringifed+=this.path[F]}return this.stringifed}}e.TestId=E}),define(we[172],be([0,1,17,90,10,24,26,77,137]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(_,n,d){this._contributedVariables=new Map,this._context=_,this._labelService=n,d&&(this._envVariablesPromise=d.then(l=>this.prepareEnv(l)))}prepareEnv(_){if(F.isWindows){const n=Object.create(null);return Object.keys(_).forEach(d=>{n[d.toLowerCase()]=_[d]}),n}return _}resolveWithEnvironment(_,n,d){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,d)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,d,l){const c=I.deepClone(n);return F.isWindows&&c.windows?Object.keys(c.windows).forEach(p=>c[p]=c.windows[p]):F.isMacintosh&&c.osx?Object.keys(c.osx).forEach(p=>c[p]=c.osx[p]):F.isLinux&&c.linux&&Object.keys(c.linux).forEach(p=>c[p]=c.linux[p]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,c,d,l)}async resolveAnyAsync(_,n,d){return this.resolveAnyBase(_,n,d)}async resolveAnyMap(_,n,d){const l=new Map;return{newConfig:await this.resolveAnyBase(_,n,d,l),resolvedVariables:l}}resolveWithInteractionReplace(_,n,d,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,d,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,d,l,c){if(E.isString(d))return this.resolveString(_,n,d,l,c);if(E.isArray(d))return d.map(p=>this.recursiveResolve(_,n,p,l,c));if(E.isObject(d)){let p=Object.create(null);return Object.keys(d).forEach(D=>{const w=this.resolveString(_,n,D,l,c);p[w]=this.recursiveResolve(_,n,d[D],l,c)}),p}return d}resolveString(_,n,d,l,c){return d.replace(P.VARIABLE_REGEXP,(D,w)=>{if(w.includes(P.VARIABLE_LHS))return D;let o=this.evaluateSingleVariable(_,D,w,n,l);return c&&c.set(w,o),o!==D&&E.isString(o)&&o.match(P.VARIABLE_REGEXP)&&(o=this.resolveString(_,n,o,l,c)),o})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,d,l,c){let p;const D=d.split(":");D.length>1&&(d=D[0],p=D[1]);const w=()=>{const k=this._context.getFilePath();if(k)return k;throw new Error((0,C.localize)(0,null,n))},o=()=>{const k=w();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,C.localize)(1,null,n,u.basename(k)))},f=()=>{if(p){const k=this._context.getFolderUri(p);if(k)return k;throw new Error((0,C.localize)(2,null,n,p))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,C.localize)(3,null,n)):new Error((0,C.localize)(4,null,n))};switch(d){case"env":if(p){if(_){const k=_[F.isWindows?p.toLowerCase():p];if(E.isString(k))return k}return""}throw new Error((0,C.localize)(5,null,n));case"config":if(p){const k=this._context.getConfigurationValue(l,p);if(E.isUndefinedOrNull(k))throw new Error((0,C.localize)(6,null,n,p));if(E.isObject(k))throw new Error((0,C.localize)(7,null,n,p));return k}throw new Error((0,C.localize)(8,null,n));case"command":return this.resolveFromMap(n,p,c,"command");case"input":return this.resolveFromMap(n,p,c,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(f()));case"cwd":return l||p?(0,T.normalizeDriveLetter)(this.fsPath(f())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return u.basename(this.fsPath(f()));case"lineNumber":const k=this._context.getLineNumber();if(k)return k;throw new Error((0,C.localize)(9,null,n));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error((0,C.localize)(10,null,n));case"file":return w();case"fileWorkspaceFolder":return o();case"relativeFile":return l||p?u.relative(this.fsPath(f()),w()):w();case"relativeFileDirname":const v=u.dirname(w());if(l||p){const a=u.relative(this.fsPath(f()),v);return a.length===0?".":a}return v;case"fileDirname":return u.dirname(w());case"fileExtname":return u.extname(w());case"fileBasename":return u.basename(w());case"fileBasenameNoExtension":const s=u.basename(w());return s.slice(0,s.length-u.extname(s).length);case"fileDirnameBasename":return u.basename(u.dirname(w()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const m=this._context.getAppRoot();return m||n;case"pathSeparator":return u.sep;default:try{const a=p?`${d}:${p}`:d;return this.resolveFromMap(n,a,c,void 0)}catch(a){return n}}}}resolveFromMap(_,n,d,l){if(n&&d){const c=l===void 0?d[n]:d[l+":"+n];if(typeof c=="string")return c;throw new Error((0,C.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[91],be([0,1,4,163]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,u.createDecorator)("editorGroupsService");var E;(function(c){c[c.UP=0]="UP",c[c.DOWN=1]="DOWN",c[c.LEFT=2]="LEFT",c[c.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var I;(function(c){c[c.HORIZONTAL=0]="HORIZONTAL",c[c.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var F;(function(c){c[c.FIRST=0]="FIRST",c[c.LAST=1]="LAST",c[c.NEXT=2]="NEXT",c[c.PREVIOUS=3]="PREVIOUS"})(F=e.GroupLocation||(e.GroupLocation={}));var T;(function(c){c[c.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",c[c.EVEN=1]="EVEN",c[c.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(c){c[c.COPY_EDITORS=0]="COPY_EDITORS",c[c.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));function P(c){const p=c;return(0,M.isEditorInput)(p?.editor)&&(0,M.isEditorInput)(p?.replacement)}e.isEditorReplacement=P;var t;(function(c){c[c.CREATION_TIME=0]="CREATION_TIME",c[c.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",c[c.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(c){c[c.GROUP_ACTIVE=0]="GROUP_ACTIVE",c[c.GROUP_INDEX=1]="GROUP_INDEX",c[c.GROUP_LOCKED=2]="GROUP_LOCKED",c[c.EDITOR_OPEN=3]="EDITOR_OPEN",c[c.EDITOR_CLOSE=4]="EDITOR_CLOSE",c[c.EDITOR_MOVE=5]="EDITOR_MOVE",c[c.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",c[c.EDITOR_LABEL=7]="EDITOR_LABEL",c[c.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",c[c.EDITOR_PIN=9]="EDITOR_PIN",c[c.EDITOR_STICKY=10]="EDITOR_STICKY",c[c.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(c){c[c.NEW_EDITOR=1]="NEW_EDITOR",c[c.MOVE_EDITOR=2]="MOVE_EDITOR",c[c.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function d(c){const p=c;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=d;function l(c){return c.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=l}),define(we[173],be([0,1,4,91]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,u.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(I){const F=I;return typeof I=="number"||(0,M.isEditorGroup)(F)}e.isPreferredGroup=E}),define(we[8],be([0,1,15,23,76,234,56,24,10,2,44,60,138,82,49,88,68,173,7]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ue){function fe(H){const{selectionStartLineNumber:ve,selectionStartColumn:Ce,positionLineNumber:Ke,positionColumn:Ne}=H,lt=new w.Position(ve-1,Ce-1),Et=new w.Position(Ke-1,Ne-1);return new w.Selection(lt,Et)}ue.to=fe;function ie(H){const{anchor:ve,active:Ce}=H;return{selectionStartLineNumber:ve.line+1,selectionStartColumn:ve.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}ue.from=ie})(o=e.Selection||(e.Selection={}));var f;(function(ue){function fe(H){if(!H)return;const{start:ve,end:Ce}=H;return{startLineNumber:ve.line+1,startColumn:ve.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}ue.from=fe;function ie(H){if(!H)return;const{startLineNumber:ve,startColumn:Ce,endLineNumber:Ke,endColumn:Ne}=H;return new w.Range(ve-1,Ce-1,Ke-1,Ne-1)}ue.to=ie})(f=e.Range||(e.Range={}));var k;(function(ue){function fe(ie){switch(ie){case 1:return w.StandardTokenType.Comment;case 0:return w.StandardTokenType.Other;case 4:return w.StandardTokenType.RegEx;case 2:return w.StandardTokenType.String}}ue.to=fe})(k=e.TokenType||(e.TokenType={}));var r;(function(ue){function fe(H){return new w.Position(H.lineNumber-1,H.column-1)}ue.to=fe;function ie(H){return{lineNumber:H.line+1,column:H.character+1}}ue.from=ie})(r=e.Position||(e.Position={}));var v;(function(ue){function fe(ve,Ce){return(0,u.coalesce)((0,u.asArray)(ve).map(Ke=>ie(Ke,Ce)))}ue.from=fe;function ie(ve,Ce){if(typeof ve=="string")return{$serialized:!0,language:ve};if(ve)return{$serialized:!0,language:ve.language,scheme:H(ve.scheme,Ce),pattern:typeof ve.pattern=="undefined"?void 0:rt.from(ve.pattern),exclusive:ve.exclusive}}function H(ve,Ce){return Ce&&typeof ve=="string"?Ce.transformOutgoingScheme(ve):ve}})(v=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(ue){function fe(H){switch(H){case w.DiagnosticTag.Unnecessary:return 1;case w.DiagnosticTag.Deprecated:return 2}}ue.from=fe;function ie(H){switch(H){case 1:return w.DiagnosticTag.Unnecessary;case 2:return w.DiagnosticTag.Deprecated;default:return}}ue.to=ie})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ue){function fe(H){let ve;return H.code&&((0,C.isString)(H.code)||(0,C.isNumber)(H.code)?ve=String(H.code):ve={value:String(H.code.value),target:H.code.target}),{...f.from(H.range),message:H.message,source:H.source,code:ve,severity:a.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(m.from),tags:Array.isArray(H.tags)?(0,u.coalesce)(H.tags.map(s.from)):void 0}}ue.from=fe;function ie(H){const ve=new w.Diagnostic(f.to(H),H.message,a.to(H.severity));return ve.source=H.source,ve.code=(0,C.isString)(H.code)?H.code:H.code?.value,ve.relatedInformation=H.relatedInformation&&H.relatedInformation.map(m.to),ve.tags=H.tags&&(0,u.coalesce)(H.tags.map(s.to)),ve}ue.to=ie})(i=e.Diagnostic||(e.Diagnostic={}));var m;(function(ue){function fe(H){return{...f.from(H.location.range),message:H.message,resource:H.location.uri}}ue.from=fe;function ie(H){return new w.DiagnosticRelatedInformation(new w.Location(H.resource,f.to(H)),H.message)}ue.to=ie})(m=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(ue){function fe(H){switch(H){case w.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case w.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case w.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case w.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ue.from=fe;function ie(H){switch(H){case d.MarkerSeverity.Info:return w.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return w.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return w.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return w.DiagnosticSeverity.Hint;default:return w.DiagnosticSeverity.Error}}ue.to=ie})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var g;(function(ue){function fe(H){return typeof H=="number"&&H>=w.ViewColumn.One?H-1:H===w.ViewColumn.Beside?D.SIDE_GROUP:D.ACTIVE_GROUP}ue.from=fe;function ie(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ue.to=ie})(g=e.ViewColumn||(e.ViewColumn={}));function b(ue){return typeof ue.range!="undefined"}function h(ue){return ue.length===0?!0:!!b(ue[0])}e.isDecorationOptionsArr=h;var y;(function(ue){function fe(Ne){return Ne.map(ue.from)}ue.fromMany=fe;function ie(Ne){return Ne&&typeof Ne=="object"&&typeof Ne.language=="string"&&typeof Ne.value=="string"}function H(Ne){let lt;if(ie(Ne)){const{language:gt,value:dt}=Ne;lt={value:"```"+gt+`
`+dt+"\n```\n"}}else w.MarkdownString.isMarkdownString(Ne)?lt={value:Ne.value,isTrusted:Ne.isTrusted,supportThemeIcons:Ne.supportThemeIcons,supportHtml:Ne.supportHtml}:typeof Ne=="string"?lt={value:Ne}:lt={value:""};const Et=Object.create(null);lt.uris=Et;const vt=gt=>{try{let dt=P.URI.parse(gt,!0);dt=dt.with({query:ve(dt.query,Et)}),Et[gt]=dt}catch(dt){}return""},ut=new I.Renderer;return ut.link=vt,ut.image=gt=>vt(E.parseHrefAndDimensions(gt).href),I(lt.value,{renderer:ut}),lt}ue.from=H;function ve(Ne,lt){if(!Ne)return Ne;let Et;try{Et=(0,F.parse)(Ne)}catch(ut){}if(!Et)return Ne;let vt=!1;return Et=(0,T.cloneAndChange)(Et,ut=>{if(P.URI.isUri(ut)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[gt]=ut,vt=!0,gt}else return}),vt?JSON.stringify(Et):Ne}function Ce(Ne){const lt=new w.MarkdownString(Ne.value,Ne.supportThemeIcons);return lt.isTrusted=Ne.isTrusted,lt.supportHtml=Ne.supportHtml,lt}ue.to=Ce;function Ke(Ne){if(!!Ne)return typeof Ne=="string"?Ne:ue.from(Ne)}ue.fromStrict=Ke})(y=e.MarkdownString||(e.MarkdownString={}));function R(ue){return h(ue)?ue.map(fe=>({range:f.from(fe.range),hoverMessage:Array.isArray(fe.hoverMessage)?y.fromMany(fe.hoverMessage):fe.hoverMessage?y.from(fe.hoverMessage):void 0,renderOptions:fe.renderOptions})):ue.map(fe=>({range:f.from(fe)}))}e.fromRangeOrRangeWithMessage=R;function A(ue){return typeof ue=="undefined"?ue:typeof ue=="string"?P.URI.file(ue):ue}e.pathOrURIToURI=A;var B;(function(ue){function fe(ie){return typeof ie=="undefined"?ie:{contentText:ie.contentText,contentIconPath:ie.contentIconPath?A(ie.contentIconPath):void 0,border:ie.border,borderColor:ie.borderColor,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,color:ie.color,backgroundColor:ie.backgroundColor,margin:ie.margin,width:ie.width,height:ie.height}}ue.from=fe})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(ue){function fe(ie){return typeof ie=="undefined"?ie:{backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?A(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?B.from(ie.before):void 0,after:ie.after?B.from(ie.after):void 0}}ue.from=fe})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var S;(function(ue){function fe(ie){if(typeof ie=="undefined")return ie;switch(ie){case w.DecorationRangeBehavior.OpenOpen:return 0;case w.DecorationRangeBehavior.ClosedClosed:return 1;case w.DecorationRangeBehavior.OpenClosed:return 2;case w.DecorationRangeBehavior.ClosedOpen:return 3}}ue.from=fe})(S=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ue){function fe(ie){return{isWholeLine:ie.isWholeLine,rangeBehavior:ie.rangeBehavior?S.from(ie.rangeBehavior):void 0,overviewRulerLane:ie.overviewRulerLane,light:ie.light?O.from(ie.light):void 0,dark:ie.dark?O.from(ie.dark):void 0,backgroundColor:ie.backgroundColor,outline:ie.outline,outlineColor:ie.outlineColor,outlineStyle:ie.outlineStyle,outlineWidth:ie.outlineWidth,border:ie.border,borderColor:ie.borderColor,borderRadius:ie.borderRadius,borderSpacing:ie.borderSpacing,borderStyle:ie.borderStyle,borderWidth:ie.borderWidth,fontStyle:ie.fontStyle,fontWeight:ie.fontWeight,textDecoration:ie.textDecoration,cursor:ie.cursor,color:ie.color,opacity:ie.opacity,letterSpacing:ie.letterSpacing,gutterIconPath:ie.gutterIconPath?A(ie.gutterIconPath):void 0,gutterIconSize:ie.gutterIconSize,overviewRulerColor:ie.overviewRulerColor,before:ie.before?B.from(ie.before):void 0,after:ie.after?B.from(ie.after):void 0}}ue.from=fe})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ue){function fe(H){return{text:H.newText,eol:H.newEol&&G.from(H.newEol),range:f.from(H.range)}}ue.from=fe;function ie(H){const ve=new w.TextEdit(f.to(H.range),H.text);return ve.newEol=typeof H.eol=="undefined"?void 0:G.to(H.eol),ve}ue.to=ie})(N=e.TextEdit||(e.TextEdit={}));var j;(function(ue){function fe(H,ve,Ce){const Ke={edits:[]};if(H instanceof w.WorkspaceEdit)for(let Ne of H._allEntries())if(Ne._type===1)Ke.edits.push({_type:1,oldUri:Ne.from,newUri:Ne.to,options:Ne.options,metadata:Ne.metadata});else if(Ne._type===2){const lt=ve?.getDocument(Ne.uri);Ke.edits.push({_type:2,resource:Ne.uri,edit:N.from(Ne.edit),modelVersionId:lt?.version,metadata:Ne.metadata})}else Ne._type===3?Ke.edits.push({_type:3,metadata:Ne.metadata,resource:Ne.uri,edit:Ne.edit,notebookMetadata:Ne.notebookMetadata,notebookVersionId:Ce?.getNotebookDocument(Ne.uri,!0)?.apiNotebook.version}):Ne._type===5&&Ke.edits.push({_type:3,metadata:Ne.metadata,resource:Ne.uri,notebookVersionId:Ce?.getNotebookDocument(Ne.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ne.index,count:Ne.count,cells:Ne.cells.map(Xe.from)}});return Ke}ue.from=fe;function ie(H){const ve=new w.WorkspaceEdit;for(const Ce of H.edits)Ce.edit?ve.replace(P.URI.revive(Ce.resource),f.to(Ce.edit.range),Ce.edit.text):ve.renameFile(P.URI.revive(Ce.oldUri),P.URI.revive(Ce.newUri),Ce.options);return ve}ue.to=ie})(j=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ue){const fe=Object.create(null);fe[w.SymbolKind.File]=0,fe[w.SymbolKind.Module]=1,fe[w.SymbolKind.Namespace]=2,fe[w.SymbolKind.Package]=3,fe[w.SymbolKind.Class]=4,fe[w.SymbolKind.Method]=5,fe[w.SymbolKind.Property]=6,fe[w.SymbolKind.Field]=7,fe[w.SymbolKind.Constructor]=8,fe[w.SymbolKind.Enum]=9,fe[w.SymbolKind.Interface]=10,fe[w.SymbolKind.Function]=11,fe[w.SymbolKind.Variable]=12,fe[w.SymbolKind.Constant]=13,fe[w.SymbolKind.String]=14,fe[w.SymbolKind.Number]=15,fe[w.SymbolKind.Boolean]=16,fe[w.SymbolKind.Array]=17,fe[w.SymbolKind.Object]=18,fe[w.SymbolKind.Key]=19,fe[w.SymbolKind.Null]=20,fe[w.SymbolKind.EnumMember]=21,fe[w.SymbolKind.Struct]=22,fe[w.SymbolKind.Event]=23,fe[w.SymbolKind.Operator]=24,fe[w.SymbolKind.TypeParameter]=25;function ie(ve){return typeof fe[ve]=="number"?fe[ve]:6}ue.from=ie;function H(ve){for(const Ce in fe)if(fe[Ce]===ve)return Number(Ce);return w.SymbolKind.Property}ue.to=H})(W=e.SymbolKind||(e.SymbolKind={}));var $;(function(ue){function fe(H){switch(H){case w.SymbolTag.Deprecated:return 1}}ue.from=fe;function ie(H){switch(H){case 1:return w.SymbolTag.Deprecated}}ue.to=ie})($=e.SymbolTag||(e.SymbolTag={}));var V;(function(ue){function fe(H){return{name:H.name,kind:W.from(H.kind),tags:H.tags&&H.tags.map($.from),containerName:H.containerName,location:me.from(H.location)}}ue.from=fe;function ie(H){const ve=new w.SymbolInformation(H.name,W.to(H.kind),H.containerName,me.to(H.location));return ve.tags=H.tags&&H.tags.map($.to),ve}ue.to=ie})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var q;(function(ue){function fe(H){const ve={name:H.name||"!!MISSING: name!!",detail:H.detail,range:f.from(H.range),selectionRange:f.from(H.selectionRange),kind:W.from(H.kind),tags:H.tags?.map($.from)??[]};return H.children&&(ve.children=H.children.map(fe)),ve}ue.from=fe;function ie(H){const ve=new w.DocumentSymbol(H.name,H.detail,W.to(H.kind),f.to(H.range),f.to(H.selectionRange));return(0,u.isNonEmptyArray)(H.tags)&&(ve.tags=H.tags.map($.to)),H.children&&(ve.children=H.children.map(ie)),ve}ue.to=ie})(q=e.DocumentSymbol||(e.DocumentSymbol={}));var re;(function(ue){function fe(H){const ve=new w.CallHierarchyItem(W.to(H.kind),H.name,H.detail||"",P.URI.revive(H.uri),f.to(H.range),f.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ue.to=fe;function ie(H,ve,Ce){if(ve=ve??H._sessionId,Ce=Ce??H._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,name:H.name,detail:H.detail,kind:W.from(H.kind),uri:H.uri,range:f.from(H.range),selectionRange:f.from(H.selectionRange),tags:H.tags?.map($.from)}}ue.from=ie})(re=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ae;(function(ue){function fe(ie){return new w.CallHierarchyIncomingCall(re.to(ie.from),ie.fromRanges.map(H=>f.to(H)))}ue.to=fe})(ae=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var pe;(function(ue){function fe(ie){return new w.CallHierarchyOutgoingCall(re.to(ie.to),ie.fromRanges.map(H=>f.to(H)))}ue.to=fe})(pe=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(ue){function fe(H){return{range:H.range&&f.from(H.range),uri:H.uri}}ue.from=fe;function ie(H){return new w.Location(P.URI.revive(H.uri),f.to(H.range))}ue.to=ie})(me=e.location||(e.location={}));var Fe;(function(ue){function fe(H){const ve=H,Ce=H;return{originSelectionRange:ve.originSelectionRange?f.from(ve.originSelectionRange):void 0,uri:ve.targetUri?ve.targetUri:Ce.uri,range:f.from(ve.targetRange?ve.targetRange:Ce.range),targetSelectionRange:ve.targetSelectionRange?f.from(ve.targetSelectionRange):void 0}}ue.from=fe;function ie(H){return{targetUri:P.URI.revive(H.uri),targetRange:f.to(H.range),targetSelectionRange:H.targetSelectionRange?f.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?f.to(H.originSelectionRange):void 0}}ue.to=ie})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ye;(function(ue){function fe(H){return{range:f.from(H.range),contents:y.fromMany(H.contents)}}ue.from=fe;function ie(H){return new w.Hover(H.contents.map(y.to),f.to(H.range))}ue.to=ie})(Ye=e.Hover||(e.Hover={}));var Ue;(function(ue){function fe(H){return{range:f.from(H.range),expression:H.expression}}ue.from=fe;function ie(H){return new w.EvaluatableExpression(f.to(H.range),H.expression)}ue.to=ie})(Ue=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Ve;(function(ue){function fe(H){if(H instanceof w.InlineValueText)return{type:"text",range:f.from(H.range),text:H.text};if(H instanceof w.InlineValueVariableLookup)return{type:"variable",range:f.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof w.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ue.from=fe;function ie(H){switch(H.type){case"text":return{range:f.to(H.range),text:H.text};case"variable":return{range:f.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:f.to(H.range),expression:H.expression}}}ue.to=ie})(Ve=e.InlineValue||(e.InlineValue={}));var Je;(function(ue){function fe(H){return{frameId:H.frameId,stoppedLocation:f.from(H.stoppedLocation)}}ue.from=fe;function ie(H){return new w.InlineValueContext(H.frameId,f.to(H.stoppedLocation))}ue.to=ie})(Je=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ue){function fe(H){return{range:f.from(H.range),kind:H.kind}}ue.from=fe;function ie(H){return new w.DocumentHighlight(f.to(H.range),H.kind)}ue.to=ie})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ue){function fe(ie){switch(ie){case 1:return w.CompletionTriggerKind.TriggerCharacter;case 2:return w.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return w.CompletionTriggerKind.Invoke}}ue.to=fe})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(ue){function fe(ie){return{triggerKind:Qe.to(ie.triggerKind),triggerCharacter:ie.triggerCharacter}}ue.to=fe})(z=e.CompletionContext||(e.CompletionContext={}));var Q;(function(ue){function fe(H){switch(H){case w.CompletionItemTag.Deprecated:return 1}}ue.from=fe;function ie(H){switch(H){case 1:return w.CompletionItemTag.Deprecated}}ue.to=ie})(Q=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(ue){const fe=new Map([[w.CompletionItemKind.Method,0],[w.CompletionItemKind.Function,1],[w.CompletionItemKind.Constructor,2],[w.CompletionItemKind.Field,3],[w.CompletionItemKind.Variable,4],[w.CompletionItemKind.Class,5],[w.CompletionItemKind.Interface,7],[w.CompletionItemKind.Struct,6],[w.CompletionItemKind.Module,8],[w.CompletionItemKind.Property,9],[w.CompletionItemKind.Unit,12],[w.CompletionItemKind.Value,13],[w.CompletionItemKind.Constant,14],[w.CompletionItemKind.Enum,15],[w.CompletionItemKind.EnumMember,16],[w.CompletionItemKind.Keyword,17],[w.CompletionItemKind.Snippet,27],[w.CompletionItemKind.Text,18],[w.CompletionItemKind.Color,19],[w.CompletionItemKind.File,20],[w.CompletionItemKind.Reference,21],[w.CompletionItemKind.Folder,23],[w.CompletionItemKind.Event,10],[w.CompletionItemKind.Operator,11],[w.CompletionItemKind.TypeParameter,24],[w.CompletionItemKind.Issue,26],[w.CompletionItemKind.User,25]]);function ie(Ce){return fe.get(Ce)??9}ue.from=ie;const H=new Map([[0,w.CompletionItemKind.Method],[1,w.CompletionItemKind.Function],[2,w.CompletionItemKind.Constructor],[3,w.CompletionItemKind.Field],[4,w.CompletionItemKind.Variable],[5,w.CompletionItemKind.Class],[7,w.CompletionItemKind.Interface],[6,w.CompletionItemKind.Struct],[8,w.CompletionItemKind.Module],[9,w.CompletionItemKind.Property],[12,w.CompletionItemKind.Unit],[13,w.CompletionItemKind.Value],[14,w.CompletionItemKind.Constant],[15,w.CompletionItemKind.Enum],[16,w.CompletionItemKind.EnumMember],[17,w.CompletionItemKind.Keyword],[27,w.CompletionItemKind.Snippet],[18,w.CompletionItemKind.Text],[19,w.CompletionItemKind.Color],[20,w.CompletionItemKind.File],[21,w.CompletionItemKind.Reference],[23,w.CompletionItemKind.Folder],[10,w.CompletionItemKind.Event],[11,w.CompletionItemKind.Operator],[24,w.CompletionItemKind.TypeParameter],[25,w.CompletionItemKind.User],[26,w.CompletionItemKind.Issue]]);function ve(Ce){return H.get(Ce)??w.CompletionItemKind.Property}ue.to=ve})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var se;(function(ue){function fe(ie,H){const ve=new w.CompletionItem(ie.label);return ve.insertText=ie.insertText,ve.kind=X.to(ie.kind),ve.tags=ie.tags?.map(Q.to),ve.detail=ie.detail,ve.documentation=E.isMarkdownString(ie.documentation)?y.to(ie.documentation):ie.documentation,ve.sortText=ie.sortText,ve.filterText=ie.filterText,ve.preselect=ie.preselect,ve.commitCharacters=ie.commitCharacters,t.Range.isIRange(ie.range)?ve.range=f.to(ie.range):typeof ie.range=="object"&&(ve.range={inserting:f.to(ie.range.insert),replacing:f.to(ie.range.replace)}),ve.keepWhitespace=typeof ie.insertTextRules=="undefined"?!1:Boolean(ie.insertTextRules&1),typeof ie.insertTextRules!="undefined"&&ie.insertTextRules&4?ve.insertText=new w.SnippetString(ie.insertText):(ve.insertText=ie.insertText,ve.textEdit=ve.range instanceof w.Range?new w.TextEdit(ve.range,ve.insertText):void 0),ie.additionalTextEdits&&ie.additionalTextEdits.length>0&&(ve.additionalTextEdits=ie.additionalTextEdits.map(Ce=>N.to(Ce))),ve.command=H&&ie.command?H.fromInternal(ie.command):void 0,ve}ue.to=fe})(se=e.CompletionItem||(e.CompletionItem={}));var K;(function(ue){function fe(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0}}ue.from=fe;function ie(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation}}ue.to=ie})(K=e.ParameterInformation||(e.ParameterInformation={}));var te;(function(ue){function fe(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(K.from):[],activeParameter:H.activeParameter}}ue.from=fe;function ie(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(K.to):[],activeParameter:H.activeParameter}}ue.to=ie})(te=e.SignatureInformation||(e.SignatureInformation={}));var ce;(function(ue){function fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(te.from):[]}}ue.from=fe;function ie(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(te.to):[]}}ue.to=ie})(ce=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ue){function fe(H){return{text:H.text,position:r.from(H.position),kind:Oe.from(H.kind??w.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}ue.from=fe;function ie(H){const ve=new w.InlayHint(H.text,r.to(H.position),Oe.to(H.kind));return ve.whitespaceAfter=H.whitespaceAfter,ve.whitespaceBefore=H.whitespaceBefore,ve}ue.to=ie})(Pe=e.InlayHint||(e.InlayHint={}));var Oe;(function(ue){function fe(H){return H}ue.from=fe;function ie(H){return H}ue.to=ie})(Oe=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(ue){function fe(H){return{range:f.from(H.range),url:H.target,tooltip:H.tooltip}}ue.from=fe;function ie(H){let ve;if(H.url)try{ve=typeof H.url=="string"?P.URI.parse(H.url,!0):P.URI.revive(H.url)}catch(Ce){}return new w.DocumentLink(f.to(H.range),ve)}ue.to=ie})(We=e.DocumentLink||(e.DocumentLink={}));var qe;(function(ue){function fe(H){const ve=new w.ColorPresentation(H.label);return H.textEdit&&(ve.textEdit=N.to(H.textEdit)),H.additionalTextEdits&&(ve.additionalTextEdits=H.additionalTextEdits.map(Ce=>N.to(Ce))),ve}ue.to=fe;function ie(H){return{label:H.label,textEdit:H.textEdit?N.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(ve=>N.from(ve)):void 0}}ue.from=ie})(qe=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ue){function fe(H){return new w.Color(H[0],H[1],H[2],H[3])}ue.to=fe;function ie(H){return[H.red,H.green,H.blue,H.alpha]}ue.from=ie})(et=e.Color||(e.Color={}));var st;(function(ue){function fe(H){return{range:f.from(H.range)}}ue.from=fe;function ie(H){return new w.SelectionRange(f.to(H.range))}ue.to=ie})(st=e.SelectionRange||(e.SelectionRange={}));var _e;(function(ue){function fe(ie){switch(ie){case 2:return w.TextDocumentSaveReason.AfterDelay;case 1:return w.TextDocumentSaveReason.Manual;case 3:case 4:return w.TextDocumentSaveReason.FocusOut}}ue.to=fe})(_e=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ue){function fe(H){switch(H){case w.TextEditorLineNumbersStyle.Off:return 0;case w.TextEditorLineNumbersStyle.Relative:return 2;case w.TextEditorLineNumbersStyle.On:default:return 1}}ue.from=fe;function ie(H){switch(H){case 0:return w.TextEditorLineNumbersStyle.Off;case 2:return w.TextEditorLineNumbersStyle.Relative;case 1:default:return w.TextEditorLineNumbersStyle.On}}ue.to=ie})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var G;(function(ue){function fe(H){if(H===w.EndOfLine.CRLF)return 1;if(H===w.EndOfLine.LF)return 0}ue.from=fe;function ie(H){if(H===1)return w.EndOfLine.CRLF;if(H===0)return w.EndOfLine.LF}ue.to=ie})(G=e.EndOfLine||(e.EndOfLine={}));var J;(function(ue){function fe(ie){if(typeof ie=="object")return ie.viewId;switch(ie){case w.ProgressLocation.SourceControl:return 3;case w.ProgressLocation.Window:return 10;case w.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ue.from=fe})(J=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ue){function fe(ie){const H={start:ie.start+1,end:ie.end+1};return ie.kind&&(H.kind=$e.from(ie.kind)),H}ue.from=fe})(ge=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ue){function fe(ie){if(ie)switch(ie){case w.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case w.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case w.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ue.from=fe})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ge;(function(ue){function fe(ie){if(ie)return{pinned:typeof ie.preview=="boolean"?!ie.preview:void 0,inactive:ie.background,preserveFocus:ie.preserveFocus,selection:typeof ie.selection=="object"?f.from(ie.selection):void 0,override:typeof ie.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ue.from=fe})(Ge=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(ue){function fe(H){return H instanceof w.RelativePattern||typeof H=="string"?H:ie(H)?new w.RelativePattern(H.base,H.pattern):H}ue.from=fe;function ie(H){const ve=H;return ve&&typeof ve.base=="string"&&typeof ve.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(ue){function fe(ie){if(ie){if(Array.isArray(ie))return ie.map(fe);if(typeof ie=="string")return ie;{const H=ie;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:rt.from(H.pattern),exclusive:H.exclusive}}}else return}ue.from=fe})(ft=e.LanguageSelector||(e.LanguageSelector={}));var ht;(function(ue){function fe(H){return{start:H.start,end:H.end}}ue.from=fe;function ie(H){return new w.NotebookRange(H.start,H.end)}ue.to=ie})(ht=e.NotebookRange||(e.NotebookRange={}));var Dt;(function(ue){function fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ue.to=fe;function ie(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ue.from=ie})(Dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Tt;(function(ue){function fe(H){switch(H){case w.NotebookCellKind.Markup:return c.CellKind.Markup;case w.NotebookCellKind.Code:default:return c.CellKind.Code}}ue.from=fe;function ie(H){switch(H){case c.CellKind.Markup:return w.NotebookCellKind.Markup;case c.CellKind.Code:default:return w.NotebookCellKind.Code}}ue.to=ie})(Tt=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(ue){function fe(H){const ve={metadata:H.metadata??Object.create(null),cells:[]};for(let Ce of H.cells)w.NotebookCellData.validate(Ce),ve.cells.push(Xe.from(Ce));return ve}ue.from=fe;function ie(H){const ve=new w.NotebookData(H.cells.map(Xe.to));return(0,C.isEmptyObject)(H.metadata)||(ve.metadata=H.metadata),ve}ue.to=ie})(It=e.NotebookData||(e.NotebookData={}));var Xe;(function(ue){function fe(H){return{cellKind:Tt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Dt.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ie.from):[]}}ue.from=fe;function ie(H){return new w.NotebookCellData(Tt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ie.to):void 0,H.metadata,H.internalMetadata?Dt.to(H.internalMetadata):void 0)}ue.to=ie})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(ue){function fe(H){return{mime:H.mime,valueBytes:M.VSBuffer.wrap(H.data)}}ue.from=fe;function ie(H){return new w.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}ue.to=ie})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ue){function fe(H){return{outputId:H.id,items:H.items.map(pt.from),metadata:H.metadata}}ue.from=fe;function ie(H){const ve=H.items.map(pt.to);return new w.NotebookCellOutput(ve,H.outputId,H.metadata)}ue.to=ie})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ye;(function(ue){function fe(Ce){if(Ce!=null){if(Ce instanceof w.RelativePattern||typeof Ce=="string")return Ce;if(ve(Ce))return new w.RelativePattern(Ce.base,Ce.pattern);if(H(Ce))return{include:rt.from(Ce.include)||void 0,exclude:rt.from(Ce.exclude)||void 0}}}ue.from=fe;function ie(Ce){return typeof Ce=="string"?Ce:ve(Ce)?{base:Ce.base,pattern:Ce.pattern}:{include:Ce.include,exclude:Ce.exclude}}ue.to=ie;function H(Ce){const Ke=Ce,Ne=rt.from(Ke.include);if(!(Ne&&Ne instanceof w.RelativePattern||typeof Ne=="string"))return!1;const lt=rt.from(Ke.exclude);return!!(lt&&lt instanceof w.RelativePattern||typeof lt=="string")}function ve(Ce){const Ke=Ce;return Ke&&typeof Ke.base=="string"&&typeof Ke.pattern=="string"}})(ye=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var De;(function(ue){function fe(ie){return{backgroundColor:ie.backgroundColor,borderColor:ie.borderColor,top:ie.top?B.from(ie.top):void 0}}ue.from=fe})(De=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Z;(function(ue){function fe(ie,H,ve){const Ce=typeof ie.command=="string"?{title:"",command:ie.command}:ie.command;return{alignment:ie.alignment===w.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Ce,ve),text:ie.text,tooltip:ie.tooltip,accessibilityInformation:ie.accessibilityInformation,priority:ie.priority}}ue.from=fe})(Z=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var oe;(function(ue){function fe(ie){return{transientOutputs:ie?.transientOutputs??!1,transientCellMetadata:ie?.transientCellMetadata??{},transientDocumentMetadata:ie?.transientDocumentMetadata??{}}}ue.from=fe})(oe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var he;(function(ue){function fe(H){return{uri:H.uri,provides:H.provides}}ue.from=fe;function ie(H){return new w.NotebookRendererScript(P.URI.revive(H.uri),H.provides)}ue.to=ie})(he=e.NotebookRendererScript||(e.NotebookRendererScript={}));var de;(function(ue){function fe(H){return{message:y.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location?me.from(H.location):void 0}}ue.from=fe;function ie(H){const ve=new w.TestMessage(typeof H.message=="string"?H.message:y.to(H.message));return ve.actualOutput=H.actual,ve.expectedOutput=H.expected,ve.location=H.location?me.to(H.location):void 0,ve}ue.to=ie})(de=e.TestMessage||(e.TestMessage={}));var ke;(function(ue){let fe;(function(ie){ie.Delimiter="\0"})(fe||(fe={})),ue.namespace=(ie,H)=>ie+"\0"+H,ue.denamespace=ie=>{const H=ie.indexOf("\0");return{ctrlId:ie.slice(0,H),tagId:ie.slice(H+1)}}})(ke=e.TestTag||(e.TestTag={}));var Le;(function(ue){function fe(Ce){const Ke=(0,l.getPrivateApiFor)(Ce).controllerId;return{extId:p.TestId.fromExtHostTestItem(Ce,Ke).toString(),label:Ce.label,uri:Ce.uri,tags:Ce.tags.map(Ne=>ke.namespace(Ke,Ne.id)),range:f.from(Ce.range)||null,description:Ce.description||null,error:Ce.error&&y.fromStrict(Ce.error)||null}}ue.from=fe;function ie(Ce){return{parent:void 0,error:void 0,id:p.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:P.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(Ke=>{const{tagId:Ne}=ke.denamespace(Ke);return new w.TestTag(Ne)}),range:f.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0}}ue.toPlain=ie;function H(Ce){const Ke=p.TestId.fromString(Ce.extId),Ne=new l.TestItemImpl(Ke.controllerId,Ke.localId,Ce.label,P.URI.revive(Ce.uri));return Ne.range=f.to(Ce.range||void 0),Ne.description=Ce.description||void 0,Ne}function ve(Ce){let Ke;for(const Ne of Ce.tests){const lt=H(Ne.item);(0,l.getPrivateApiFor)(lt).parent=Ke,Ke=lt}return Ke}ue.toItemFromContext=ve})(Le=e.TestItem||(e.TestItem={})),function(ue){function fe(H){return{id:H.id}}ue.from=fe;function ie(H){return new w.TestTag(H.id)}ue.to=ie}(ke=e.TestTag||(e.TestTag={}));var Me;(function(ue){const fe=(H,ve)=>{const Ce={...Le.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(Ne=>Ne.type===0).map(de.to)})),children:H.children.map(Ke=>ve.get(Ke)).filter(C.isDefined).map(Ke=>fe(Ke,ve))};for(const Ke of Ce.children)Ke.parent=Ce;return Ce};function ie(H){const ve=[],Ce=new Map;for(const Ke of H.items)Ce.set(Ke.item.extId,Ke),H.request.targets.some(Ne=>Ne.controllerId===Ke.controllerId&&Ne.testIds.includes(Ke.item.extId))&&ve.push(Ke);return{completedAt:H.completedAt,results:ve.map(Ke=>fe(Ke,Ce))}}ue.to=ie})(Me=e.TestResults||(e.TestResults={}));var ze;(function(ue){function fe(Ce){return{covered:Ce.covered,total:Ce.covered}}function ie(Ce){return"line"in Ce?r.from(Ce):f.from(Ce)}function H(Ce){return"branches"in Ce?{count:Ce.executionCount,location:ie(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(Ke=>({count:Ke.executionCount,location:Ke.location&&ie(Ke.location)})):void 0}:{type:0,count:Ce.executionCount,location:ie(Ce.location)}}ue.fromDetailed=H;function ve(Ce){return{uri:Ce.uri,statement:fe(Ce.statementCoverage),branch:Ce.branchCoverage&&fe(Ce.branchCoverage),function:Ce.functionCoverage&&fe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(H)}}ue.fromFile=ve})(ze=e.TestCoverage||(e.TestCoverage={}));var it;(function(ue){function fe(ie){switch(ie){case 1:return w.CodeActionTriggerKind.Invoke;case 2:return w.CodeActionTriggerKind.Automatic}}ue.to=fe})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ue){function fe(H){const ve=new w.TypeHierarchyItem(W.to(H.kind),H.name,H.detail||"",P.URI.revive(H.uri),f.to(H.range),f.to(H.selectionRange));return ve._sessionId=H._sessionId,ve._itemId=H._itemId,ve}ue.to=fe;function ie(H,ve,Ce){if(ve=ve??H._sessionId,Ce=Ce??H._itemId,ve===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:ve,_itemId:Ce,kind:W.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:f.from(H.range),selectionRange:f.from(H.selectionRange),tags:H.tags?.map($.from)}}ue.from=ie})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[174],be([0,1,2,16,7,8,235]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(P,t,_,n={timeout:1500,errors:3}){this._logService=P,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new F.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(t,_,n)=>{const l={dispose:this._callbacks.push([t,_,P])};return Array.isArray(n)&&n.push(l),l}}async $participateInSave(P,t){const _=u.URI.revive(P);let n=!1;const d=setTimeout(()=>n=!0,this._thresholds.timeout),l=[];try{for(let c of[...this._callbacks]){if(n)break;const p=this._documents.getDocument(_),D=await this._deliverEventAsyncAndBlameBadListeners(c,{document:p,reason:I.TextDocumentSaveReason.to(t)});l.push(D)}}finally{clearTimeout(d)}return l}_deliverEventAsyncAndBlameBadListeners([P,t,_],n){const d=this._badListeners.get(P);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,P,t,n).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const c=this._badListeners.get(P);this._badListeners.set(P,c?c+1:1),typeof c=="number"&&c>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,t,_,n){const d=[],l=Date.now(),{document:c,reason:p}=n,{version:D}=c,w=Object.freeze({document:c,reason:p,waitUntil(o){if(Object.isFrozen(d))throw(0,M.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(o))}});try{t.apply(_,[w])}catch(o){return Promise.reject(o)}return Object.freeze(d),new Promise((o,f)=>{const k=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(k),o(r)}).catch(r=>{clearTimeout(k),f(r)})}).then(o=>{const f={edits:[]};for(const k of o)if(Array.isArray(k)&&k.every(r=>r instanceof E.TextEdit))for(const{newText:r,newEol:v,range:s}of k)f.edits.push({_type:2,resource:c.uri,edit:{range:s&&I.Range.from(s),text:r,eol:v&&I.EndOfLine.from(v)}});if(f.edits.length!==0)return D===c.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(we[175],be([0,1,3,28,2,8,7]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class T{constructor(t,_,n,d,l){this._onDidCreate=new u.Emitter,this._onDidChange=new u.Emitter,this._onDidDelete=new u.Emitter,this._config=0,n&&(this._config+=1),d&&(this._config+=2),l&&(this._config+=4);const c=(0,M.parse)(_),p=t(D=>{if(!n)for(let w of D.created){const o=E.URI.revive(w);c(o.fsPath)&&this._onDidCreate.fire(o)}if(!d)for(let w of D.changed){const o=E.URI.revive(w);c(o.fsPath)&&this._onDidChange.fire(o)}if(!l)for(let w of D.deleted){const o=E.URI.revive(w);c(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=F.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(t,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new u.Emitter,this._onDidRenameFile=new u.Emitter,this._onDidCreateFile=new u.Emitter,this._onDidDeleteFile=new u.Emitter,this._onWillRenameFile=new u.AsyncEmitter,this._onWillCreateFile=new u.AsyncEmitter,this._onWillDeleteFile=new u.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,n,d){return new T(this._onFileSystemEvent.event,t,_,n,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(n,d,l)=>{const c=function(D){n.call(d,D)};return c.extension=t,_.event(c,void 0,l)}}async $onWillRunFileOperation(t,_,n,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(l=>({oldUri:E.URI.revive(l.source),newUri:E.URI.revive(l.target)}))},n,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(l=>E.URI.revive(l.target))},n,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(l=>E.URI.revive(l.target))},n,d)}}async _fireWillEvent(t,_,n,d){const l=new Set,c=[];if(await t.fireAsync(_,d,async(D,w)=>{const o=Date.now(),f=await Promise.resolve(D);f instanceof F.WorkspaceEdit&&(c.push(f),l.add(w.extension.displayName??w.extension.identifier.value)),Date.now()-o>n&&this._logService.warn("SLOW file-participant",w.extension.identifier)}),d.isCancellationRequested||c.length===0)return;const p={edits:[]};for(let D of c){let{edits:w}=I.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(w)}return{edit:p,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=C}),define(we[176],be([0,1,11,24,2,8,7,88]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class C{constructor(n,d,l,c){this.start=n,this.deletedCount=d,this.deletedItems=l,this.items=c}static asApiEvents(n){return n.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(l=>l.apiCell)}))}}class P{constructor(n,d,l){this.notebook=n,this._extHostDocument=d,this._cellData=l,this.handle=l.handle,this.uri=E.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(I.NotebookCellOutput.to),this._internalMetadata=l.internalMetadata??{},this._metadata=Object.freeze(l.metadata??{}),this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(l.internalMetadata??{}))}static asModelAddData(n,d){return{EOL:d.eol,lines:d.source,languageId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:I.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return n._mime},set mime(l){n._mime=l},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(I.NotebookCellOutput.to)}setOutputItems(n,d,l){const c=l.map(I.NotebookCellOutputItem.to),p=this._outputs.find(D=>D.id===n);p&&(d||(p.items.length=0),p.items.push(...c))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(I.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=P;class t{constructor(n,d,l,c,p,D){this._proxy=n,this._textDocumentsAndEditors=d,this._textDocuments=l,this._emitter=c,this.uri=p,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=D.viewType,this._metadata=Object.freeze(D.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,D.cells]],!0),this._versionId=D.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===u.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(d){return d=n._validateIndex(d),n._cells[d].apiCell},getCells(d){return(d?n._getCells(d):n._cells).map(c=>c.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,d){this._versionId=n.versionId,this._isDirty=d;for(const l of n.rawEvents)l.kind===T.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===T.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===T.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===T.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===T.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===T.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(l.index,l.mime):l.kind===T.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(l.index,l.metadata):l.kind===T.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(l.index,l.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let d=n.start|0,l=n.end|0;return d<0&&(d=0),l>this._cells.length&&(l=this._cells.length),n.with({start:d,end:l})}_getCells(n){n=this._validateRange(n);const d=[];for(let l=n.start;l<n.end;l++)d.push(this._cells[l]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,d){if(this._disposed)return;const l=[],c=[],p=[];n.reverse().forEach(D=>{const o=D[2].map(r=>{const v=new P(this,this._textDocumentsAndEditors,r);return d||c.push(P.asModelAddData(this.apiNotebook,r)),v}),f=new C(D[0],D[1],[],o),k=this._cells.splice(D[0],D[1],...o);for(const r of k)p.push(r.uri),f.deletedItems.push(r.apiCell);l.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:p}),d||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(l)}))}_moveCell(n,d){const l=this._cells.splice(n,1);this._cells.splice(d,0,...l);const c=[new C(n,1,l.map(p=>p.apiCell),[]),new C(d,0,[],l)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:C.asApiEvents(c)}))}_setCellOutputs(n,d){const l=this._cells[n];l.setOutputs(d),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(n,d,l,c){const p=this._cells[n];p.setOutputItems(d,l,c),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[p.apiCell]}))}_changeCellLanguage(n,d){const l=this._cells[n];l.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(l.uri,d)}_changeCellMime(n,d){const l=this._cells[n];l.apiCell.mime=d}_changeCellMetadata(n,d){const l=this._cells[n],c=l.apiCell.metadata;l.setMetadata(d);const p=l.apiCell.metadata;(0,M.equals)(c,p)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell}))}_changeCellInternalMetadata(n,d){const l=this._cells[n],c=l.internalMetadata;if(l.setInternalMetadata(d),c.runState!==d.runState){const p=d.runState??F.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:l.apiCell,state:p}))}}getCellFromApiCell(n){return this._cells.find(d=>d.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(d=>d.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(we[92],be([0,1,7,8,16]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class I{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:C,metadata:P})}replaceCells(C,P,t){this._throwIfFinalized(),!(C===P&&t.length===0)&&this._collectedEdits.push({editType:1,index:C,count:P-C,cells:t.map(M.NotebookCellData.from)})}}class F{constructor(C,P,t,_,n,d){this.id=C,this._proxy=P,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=d}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},set selections(P){if(!Array.isArray(P)||!P.every(u.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");C._selections=P,C._trySetSelections(P)},get visibleRanges(){return C._visibleRanges},revealRange(P,t){C._proxy.$tryRevealRange(C.id,M.NotebookRange.from(P),t??u.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(P){const t=new I(this.document.version);return P(t),C._applyEdit(t.finalize())},setDecorations(P,t){return C.setDecorations(P,t)}},F.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_trySetSelections(C){this._proxy.$trySetSelections(this.id,C.map(M.NotebookRange.from))}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const P=[];let t=-1;for(let _=0;_<C.cellEdits.length;_++){if(t<0){P.push(C.cellEdits[_]),t++;continue}const d=P[t],l=C.cellEdits[_];if(d.editType===1&&l.editType===1&&d.index===l.index){d.cells.push(...C.cellEdits[_].cells),d.count+=C.cellEdits[_].count;continue}P.push(C.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,P)}setDecorations(C,P){if(!(P.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return P.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(P),C.key)}}e.ExtHostNotebookEditor=F,F.apiEditorsToExtHost=new WeakMap}),define(we[177],be([0,1,8,147,127,21,54,16]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,d,l){const c=this._handles++,{title:p,location:D,cancellable:w}=d,o={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(c,{location:u.ProgressLocation.from(D),title:p,source:o,cancellable:w},n).catch(T.onUnexpectedExternalError),this._withProgress(c,l,!!w)}_withProgress(n,d,l){let c;l&&(c=new I.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,c));const p=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),c&&c.dispose()};let D;try{D=d(new t(this._proxy,n),l&&c?c.token:I.CancellationToken.None)}catch(w){throw p(n),w}return D.then(w=>p(n),w=>p(n)),D}$acceptProgressCanceled(n){const d=this._mapHandleToCancellationSource.get(n);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=C;function P(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class t extends M.Progress{constructor(n,d){super(l=>this.throttledReport(l));this._proxy=n,this._handle=d}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}xe([(0,F.throttle)(100,(_,n)=>P(_,n),()=>Object.create(null))],t.prototype,"throttledReport",null)}),define(we[93],be([0,1,42,16,55,8,7]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(n,d,l){const c=T._Keys.nextId();n.$registerTextEditorDecorationType(d.identifier,c,I.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:c,dispose(){n.$removeTextEditorDecorationType(c)}})}}e.TextEditorDecorationType=T,T._Keys=new E.IdGenerator("TextEditorDecorationType");class C{constructor(n,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,d){this._throwIfFinalized();let l=null;if(n instanceof F.Position)l=new F.Range(n,n);else if(n instanceof F.Range)l=n;else throw new Error("Unrecognized location");this._pushEdit(l,d,!1)}insert(n,d){this._throwIfFinalized(),this._pushEdit(new F.Range(n,n),d,!0)}delete(n){this._throwIfFinalized();let d=null;if(n instanceof F.Range)d=n;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(n,d,l){const c=this._document.validateRange(n);this._collectedEdits.push({range:c,text:d,forceMoveMarkers:l})}setEndOfLine(n){if(this._throwIfFinalized(),n!==F.EndOfLine.LF&&n!==F.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=C;class P{constructor(n,d,l,c){this._proxy=n,this._id=d,this._accept(l),this._logService=c;const p=this;this.value={get tabSize(){return p._tabSize},set tabSize(D){p._setTabSize(D)},get insertSpaces(){return p._insertSpaces},set insertSpaces(D){p._setInsertSpaces(D)},get cursorStyle(){return p._cursorStyle},set cursorStyle(D){p._setCursorStyle(D)},get lineNumbers(){return p._lineNumbers},set lineNumbers(D){p._setLineNumbers(D)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=I.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const d=Math.floor(n);return d>0?d:null}if(typeof n=="string"){const d=parseInt(n,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(n){const d=this._validateTabSize(n);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const d=this._validateInsertSpaces(n);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:I.TextEditorLineNumbersStyle.from(n)})))}assign(n){const d={};let l=!1;if(typeof n.tabSize!="undefined"){const c=this._validateTabSize(n.tabSize);c==="auto"?(l=!0,d.tabSize=c):typeof c=="number"&&this._tabSize!==c&&(this._tabSize=c,l=!0,d.tabSize=c)}if(typeof n.insertSpaces!="undefined"){const c=this._validateInsertSpaces(n.insertSpaces);c==="auto"?(l=!0,d.insertSpaces=c):this._insertSpaces!==c&&(this._insertSpaces=c,l=!0,d.insertSpaces=c)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,l=!0,d.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,l=!0,d.lineNumbers=I.TextEditorLineNumbersStyle.from(n.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(n){n.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=P;class t{constructor(n,d,l,c,p,D,w,o){this.id=n,this._proxy=d,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=p,this._options=new P(this._proxy,this.id,D,l),this._visibleRanges=w,this._viewColumn=o;const f=this;this.value=Object.freeze({get document(){return c.getValue()},set document(k){throw(0,M.readonly)("document")},get selection(){return f._selections&&f._selections[0]},set selection(k){if(!(k instanceof F.Selection))throw(0,M.illegalArgument)("selection");f._selections=[k],f._trySetSelection()},get selections(){return f._selections},set selections(k){if(!Array.isArray(k)||k.some(r=>!(r instanceof F.Selection)))throw(0,M.illegalArgument)("selections");f._selections=k,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(k){throw(0,M.readonly)("visibleRanges")},get options(){return f._options.value},set options(k){f._disposed||f._options.assign(k)},get viewColumn(){return f._viewColumn},set viewColumn(k){throw(0,M.readonly)("viewColumn")},edit(k,r={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const v=new C(c.getValue(),r);return k(v),f._applyEdit(v)},insertSnippet(k,r,v={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!r||Array.isArray(r)&&r.length===0)s=f._selections.map(i=>I.Range.from(i));else if(r instanceof F.Position){const{lineNumber:i,column:m}=I.Position.from(r);s=[{startLineNumber:i,startColumn:m,endLineNumber:i,endColumn:m}]}else if(r instanceof F.Range)s=[I.Range.from(r)];else{s=[];for(const i of r)if(i instanceof F.Range)s.push(I.Range.from(i));else{const{lineNumber:m,column:a}=I.Position.from(i);s.push({startLineNumber:m,startColumn:a,endLineNumber:m,endColumn:a})}}return d.$tryInsertSnippet(n,k.value,s,v)},setDecorations(k,r){const v=r.length===0;v&&!f._hasDecorationsForKey.has(k.key)||(v?f._hasDecorationsForKey.delete(k.key):f._hasDecorationsForKey.add(k.key),f._runOnProxy(()=>{if(I.isDecorationOptionsArr(r))return d.$trySetDecorations(n,k.key,I.fromRangeOrRangeWithMessage(r));{const s=new Array(4*r.length);for(let i=0,m=r.length;i<m;i++){const a=r[i];s[4*i]=a.start.line+1,s[4*i+1]=a.start.character+1,s[4*i+2]=a.end.line+1,s[4*i+3]=a.end.character+1}return d.$trySetDecorationsFast(n,k.key,s)}}))},revealRange(k,r){f._runOnProxy(()=>d.$tryRevealRange(n,I.Range.from(k),r||F.TextEditorRevealType.Default))},show(k){d.$tryShowEditor(n,I.ViewColumn.from(k))},hide(){d.$tryHideEditor(n)}})}dispose(){(0,u.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,u.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,u.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,u.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,u.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(I.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const d=n.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const l=d.edits.map(p=>p.range);l.sort((p,D)=>p.end.line===D.end.line?p.end.character===D.end.character?p.start.line===D.start.line?p.start.character-D.start.character:p.start.line-D.start.line:p.end.character-D.end.character:p.end.line-D.end.line);for(let p=0,D=l.length-1;p<D;p++){const w=l[p].end;if(l[p+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=d.edits.map(p=>({range:I.Range.from(p.range),text:p.text,forceMoveMarkers:p.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,c,{setEndOfLine:typeof d.setEndOfLine=="number"?I.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(we[178],be([0,1,130,25,2,3,6,164,13,7,10,15,8,21,161]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function c(w,o){if((0,t.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let f;return Array.isArray(w.highlights)&&(f=w.highlights.filter(k=>k.length===2&&typeof k[0]=="number"&&typeof k[1]=="number"),f=f.length?f:void 0),{label:w.label,highlights:f}}}class p{constructor(o,f,k){this._proxy=o,this.commands=f,this.logService=k,this.treeViews=new Map;function r(v){return v&&v.$treeViewId&&v.$treeItemHandle}f.registerArgumentProcessor({processArgument:v=>r(v)?this.convertArgument(v):Array.isArray(v)&&v.length>0?v.map(s=>r(s)?this.convertArgument(s):s):v})}registerTreeDataProvider(o,f,k){const r=this.createTreeView(o,{treeDataProvider:f},k);return{dispose:()=>r.dispose()}}createTreeView(o,f,k){if(!f||!f.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=f.dragAndDropController!==void 0,v=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!f.showCollapseAll,canSelectMany:!!f.canSelectMany,canDragAndDrop:r}),s=this.createExtHostTreeView(o,f,k);return{get onDidCollapseElement(){return s.onDidCollapseElement},get onDidExpandElement(){return s.onDidExpandElement},get selection(){return s.selectedElements},get onDidChangeSelection(){return s.onDidChangeSelection},get visible(){return s.visible},get onDidChangeVisibility(){return s.onDidChangeVisibility},get message(){return s.message},set message(i){s.message=i},get title(){return s.title},set title(i){s.title=i},get description(){return s.description},set description(i){s.description=i},reveal:(i,m)=>s.reveal(i,m),dispose:async()=>{await v,this.treeViews.delete(o),s.dispose()}}}$getChildren(o,f){const k=this.treeViews.get(o);return k?k.getChildren(f):Promise.reject(new Error((0,u.localize)(0,null,o)))}async $onDrop(o,f,k){const r=this.treeViews.get(o);if(!r)return Promise.reject(new Error((0,u.localize)(1,null,o)));const v=l.TreeDataTransferConverter.toITreeDataTransfer(f);if(v.items.has(T.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await v.items.get(T.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(m=>r.getExtensionElement(m)).filter(m=>!!m);i.length>0?v.items.set(T.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):v.items.delete(T.TREE_ITEM_DATA_TRANSFER_TYPE)}return r.onDrop(v,k)}async $hasResolve(o){const f=this.treeViews.get(o);if(!f)throw new Error((0,u.localize)(2,null,o));return f.hasResolve}$resolve(o,f,k){const r=this.treeViews.get(o);if(!r)throw new Error((0,u.localize)(3,null,o));return r.resolveTreeItem(f,k)}$setExpanded(o,f,k){const r=this.treeViews.get(o);if(!r)throw new Error((0,u.localize)(4,null,o));r.setExpanded(f,k)}$setSelection(o,f){const k=this.treeViews.get(o);if(!k)throw new Error((0,u.localize)(5,null,o));k.setSelection(f)}$setVisible(o,f){const k=this.treeViews.get(o);if(!k)throw new Error((0,u.localize)(6,null,o));k.setVisible(f)}createExtHostTreeView(o,f,k){const r=new D(o,f,this._proxy,this.commands.converter,this.logService,k);return this.treeViews.set(o,r),r}convertArgument(o){const f=this.treeViews.get(o.$treeViewId);return f?f.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=p;class D extends F.Disposable{constructor(o,f,k,r,v,s){super();if(this.viewId=o,this.proxy=k,this.commands=r,this.logService=v,this.extension=s,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new I.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new I.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new I.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new I.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new I.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,s.contributes&&s.contributes.views)for(const a in s.contributes.views)for(const g of s.contributes.views[a])g.id===o&&(this._title=g.name);this.dataProvider=f.treeDataProvider,this.dndController=f.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(a=>this._onDidChangeData.fire({message:!1,element:a}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let i,m;this._register(I.Event.debounce(this._onDidChangeData.event,(a,g)=>(a||(a={message:!1,elements:[]}),g.element!==!1&&(i||(i=new Promise(b=>m=b),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(g.element)?a.elements.push(...g.element):a.elements.push(g.element)),g.message&&(a.message=!0),a),200,!0)(({message:a,elements:g})=>{g.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const b=m;return i=null,this.refresh(g).then(()=>b())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,t.isUndefinedOrNull)(o))}async getChildren(o){const f=o?this.getExtensionElement(o):void 0;if(o&&!f)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let k=this.getChildrenNodes(o);return k||(k=await this.fetchChildrenNodes(f)),k?k.map(r=>r.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,f){f=f||{select:!0,focus:!1};const k=(0,t.isUndefinedOrNull)(f.select)?!0:f.select,r=(0,t.isUndefinedOrNull)(f.focus)?!1:f.focus,v=(0,t.isUndefinedOrNull)(f.expand)?!1:f.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(s=>this.resolveTreeNode(o,s[s.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:s.map(m=>m.item)},{select:k,focus:r,expand:v})),s=>this.logService.error(s)):this.proxy.$reveal(this.viewId,void 0,{select:k,focus:r,expand:v})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,f){const k=this.getExtensionElement(o);k&&(f?this._onDidExpandElement.fire(Object.freeze({element:k})):this._onDidCollapseElement.fire(Object.freeze({element:k})))}setSelection(o){(0,_.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,f){const k=this.getExtensionElement(f);if(!!k)return(0,C.asPromise)(()=>this.dndController?.onDrop(o,k))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,f){if(!this.dataProvider.resolveTreeItem)return;const k=this.elements.get(o);if(k){const r=this.nodes.get(k);if(r){const v=await this.dataProvider.resolveTreeItem(r.extensionItem,k,f)??r.extensionItem;return r.item.tooltip=this.getTooltip(v.tooltip),r.item.command=this.getCommand(r.disposableStore,v.command),r.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(f=>f?this.resolveUnknownParentChain(f).then(k=>this.resolveTreeNode(f,k[k.length-1]).then(r=>(k.push(r),k))):Promise.resolve([]))}resolveParent(o){const f=this.nodes.get(o);return f?Promise.resolve(f.parent?this.elements.get(f.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,f){const k=this.nodes.get(o);return k?Promise.resolve(k):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(r=>this.createHandle(o,r,f,!0)).then(r=>this.getChildren(f?f.item.handle:void 0).then(()=>{const v=this.getExtensionElement(r);if(v){const s=this.nodes.get(v);if(s)return Promise.resolve(s)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(o){if(o){let f;if(typeof o=="string"){const k=this.getExtensionElement(o);f=k?this.nodes.get(k):void 0}else f=o;return f&&f.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const f=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const k=o?this.nodes.get(o):void 0,r=await this.dataProvider.getChildren(o);if(f.token.isCancellationRequested)return;const v=await Promise.all((0,_.coalesce)(r||[]).map(async s=>{const i=await this.dataProvider.getTreeItem(s);return i&&!f.token.isCancellationRequested?this.createAndRegisterTreeNode(s,i,k):null}));return f.token.isCancellationRequested?void 0:(0,_.coalesce)(v)}finally{f.dispose()}}refresh(o){if(o.some(k=>!k))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const k=this.getHandlesToRefresh(o);if(k.length)return this.refreshHandles(k)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const f=new Set,k=o.map(v=>this.nodes.get(v));for(const v of k)if(v&&!f.has(v.item.handle)){let s=v;for(;s&&s.parent&&k.findIndex(i=>s&&s.parent&&i&&i.item.handle===s.parent.item.handle)===-1;){const i=this.elements.get(s.parent.item.handle);s=i?this.nodes.get(i):void 0}s&&!s.parent&&f.add(v.item.handle)}const r=[];return f.forEach(v=>{const s=this.elements.get(v);if(s){const i=this.nodes.get(s);i&&(!i.parent||!f.has(i.parent.item.handle))&&r.push(v)}}),r}refreshHandles(o){const f={};return Promise.all(o.map(k=>this.refreshNode(k).then(r=>{r&&(f[k]=r.item)}))).then(()=>Object.keys(f).length?this.proxy.$refresh(this.viewId,f):void 0)}refreshNode(o){const f=this.getExtensionElement(o);if(f){const k=this.nodes.get(f);if(k)return this.clearChildren(f),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(r=>{if(r){const v=this.createTreeNode(f,r,k.parent);return this.updateNodeCache(f,v,k,k.parent),k.dispose(),v}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,f,k){const r=this.createTreeNode(o,f,k);if(f.id&&this.elements.has(r.item.handle))throw new Error((0,u.localize)(7,null,f.id));return this.addNodeToCache(o,r),this.addNodeToParentCache(r,k),r}getTooltip(o){return P.MarkdownString.isMarkdownString(o)?n.MarkdownString.from(o):o}getCommand(o,f){return f?this.commands.toInternal(f,o):void 0}createTreeNode(o,f,k){const r=new F.DisposableStore,v=this.createHandle(o,f,k),s=this.getLightIconPath(f);return{item:{handle:v,parentHandle:k?k.item.handle:void 0,label:c(f.label,this.extension),description:f.description,resourceUri:f.resourceUri,tooltip:this.getTooltip(f.tooltip),command:this.getCommand(r,f.command),contextValue:f.contextValue,icon:s,iconDark:this.getDarkIconPath(f)||s,themeIcon:this.getThemeIcon(f),collapsibleState:(0,t.isUndefinedOrNull)(f.collapsibleState)?P.TreeItemCollapsibleState.None:f.collapsibleState,accessibilityInformation:f.accessibilityInformation},extensionItem:f,parent:k,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(o){return o.iconPath instanceof P.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:f,label:k,resourceUri:r},v,s){if(f)return`${D.ID_HANDLE_PREFIX}/${f}`;const i=c(k,this.extension),m=v?v.item.handle:D.LABEL_HANDLE_PREFIX;let a=i?i.label:r?(0,M.basename)(r):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const g=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,b=this.getChildrenNodes(v)||[];let h,y=0;do{if(h=`${m}/${y}:${a}`,s||!this.elements.has(h)||g===h)break;y++}while(y<=b.length);return h}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon))return typeof o.iconPath=="string"||E.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof P.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return E.URI.isUri(o)?o:E.URI.file(o)}addNodeToCache(o,f){this.elements.set(f.item.handle,o),this.nodes.set(o,f)}updateNodeCache(o,f,k,r){this.elements.delete(f.item.handle),this.nodes.delete(o),f.item.handle!==k.item.handle&&this.elements.delete(k.item.handle),this.addNodeToCache(o,f);const v=this.getChildrenNodes(r)||[],s=v.filter(i=>i.item.handle===k.item.handle)[0];s&&v.splice(v.indexOf(s),1,f)}addNodeToParentCache(o,f){f?(f.children||(f.children=[]),f.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const f=this.nodes.get(o);if(f){if(f.children)for(const k of f.children){const r=this.elements.get(k.item.handle);r&&this.clear(r)}f.children=void 0}}else this.clearAll()}clear(o){const f=this.nodes.get(o);if(f){if(f.children)for(const k of f.children){const r=this.elements.get(k.item.handle);r&&this.clear(r)}this.nodes.delete(o),this.elements.delete(f.item.handle),f.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}D.LABEL_HANDLE_PREFIX="0",D.ID_HANDLE_PREFIX="1"}),define(we[179],be([0,1,13,3,6,10,49,8,89,68]),function(ne,e,u,M,E,I,F,T,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new u.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new F.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const d=this.diff[this.diff.length-1];if(d&&n[0]===1){if(d[0]===1&&d[1].extId===n[1].extId){(0,C.applyTestItemUpdate)(d[1],n[1]);return}if(d[0]===0&&d[1].item.extId===n[1].extId){(0,C.applyTestItemUpdate)(d[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,d){const l=this.tree.get(n);if(!!l){if((l.expandLevels===void 0||d>l.expandLevels)&&(l.expandLevels=d),l.expand===1){const c=this.resolveChildren(l);return c.isOpen()?this.expandChildren(l,d-1):c.wait().then(()=>this.expandChildren(l,d-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,d-1)):this.expandChildren(l,d-1)}}dispose(){for(const n of this.tree.values())(0,F.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,d){switch(d.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(P.TestId.joinToString(n.fullId,d.id));break;case 0:this.upsertItem(d.item,n);break;case 4:for(const w of d.ops)this.onTestItemEvent(n,w);break;case 3:const{key:l,value:c,previous:p}=d,D=n.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(c,p,D);break;case"range":this.pushDiff([1,{extId:D,item:{range:T.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:D,item:{error:T.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:D,item:{[l]:c??null}}]);break}break;default:(0,I.assertNever)(d)}}upsertItem(n,d){if(!(n instanceof F.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const l=P.TestId.fromExtHostTestItem(n,this.root.id,d?.actual),c=(0,F.getPrivateApiFor)(n);c.parent&&c.parent!==d?.actual&&c.parent.children.delete(n.id);let p=this.tree.get(l.toString());if(!p){p={fullId:l,actual:n,parent:d?l.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(p.fullId.toString(),p),this.setItemParent(n,d),this.pushDiff([0,{parent:p.parent&&p.parent.toString(),controllerId:this.controllerId,expand:p.expand,item:T.TestItem.from(n)}]),this.connectItemAndChildren(n,p,d);return}if(p.actual===n){this.connectItem(n,p,d);return}const D=p.actual.children,w=p.actual,o=(0,F.diffTestItems)(w,n);(0,F.getPrivateApiFor)(w).listener=void 0,p.actual=n,p.expand=0;for(const[f,k]of o)this.onTestItemEvent(p,{op:3,key:f,value:k,previous:w[f]});this.connectItemAndChildren(n,p,d);for(const f of D)n.children.get(f.id)||this.removeItem(P.TestId.joinToString(l,f.id))}diffTagRefs(n,d,l){const c=new Set(d.map(p=>p.id));for(const p of n)c.delete(p.id)||this.incrementTagRefs(p);this.pushDiff([1,{extId:l,item:{tags:n.map(p=>T.TestTag.namespace(this.controllerId,p.id))}}]),c.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const d=this.tags.get(n.id);d?d.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:T.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const d=this.tags.get(n);d&&!--d.refCount&&(this.tags.delete(n),this.pushDiff([6,T.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,d){(0,F.getPrivateApiFor)(n).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(n,d,l){this.setItemParent(n,l);const c=(0,F.getPrivateApiFor)(n);c.parent=l?.actual,c.listener=p=>this.onTestItemEvent(d,p),this.updateExpandability(d)}connectItemAndChildren(n,d,l){this.connectItem(n,d,l);for(const c of n.children)this.upsertItem(c,d)}updateExpandability(n){let d;this._resolveHandler?n.resolveBarrier?d=n.resolveBarrier.isOpen()?3:2:d=n.actual.canResolveChildren?1:0:d=0,d!==n.expand&&(n.expand=d,this.pushDiff([1,{extId:n.fullId.toString(),expand:d}]),d===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,d){if(d<0)return;const l=[];for(const c of n.actual.children){const p=this.expand(P.TestId.joinToString(n.fullId,c.id),d);(0,u.isThenable)(p)&&l.push(p)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const p=new u.Barrier;return p.open(),p}n.expand=2,this.pushExpandStateUpdate(n);const d=n.resolveBarrier=new u.Barrier,l=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=p.stack||p.message||String(p))};let c;try{c=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(p){l(p)}return(0,u.isThenable)(c)?c.catch(l).then(()=>{d.open(),this.updateExpandability(n)}):(d.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const d=this.tree.get(n);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const l=[d];for(;l.length;){const c=l.pop();if(!!c){(0,F.getPrivateApiFor)(c.actual).listener=void 0;for(const p of c.actual.tags)this.decrementTagRefs(p.id);this.tree.delete(c.fullId.toString());for(const p of c.actual.children)l.push(this.tree.get(P.TestId.joinToString(c.fullId,p.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=t}),define(we[180],be([0,1,4,143]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,u.refineServiceDecorator)(M.IEnvironmentService)}),define(we[181],be([0,1,22,3,17]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class I{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=I;class F{constructor(t){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(C),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(u.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(u.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${u.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(n=>_.add(u.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(u.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const n=F._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(d=>d.identifier)),_.length>0){const d=new Set;_.forEach(l=>d.add(u.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!d.has(u.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new I(n)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(p){this._nodesSet.has(p)||(this._nodesSet.add(p),this._nodesArr.push(p))}addArc(p,D){this.addNode(p),this.addNode(D),this._arcs.has(p)?this._arcs.get(p).push(D):this._arcs.set(p,[D])}getArcs(p){return this._arcs.has(p)?this._arcs.get(p):[]}hasOnlyGoodArcs(p,D){const w=_.getArcs(p);for(let o=0;o<w.length;o++)if(!D.has(w[o]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let p of t){const D=u.ExtensionIdentifier.toKey(p.identifier);if(n.set(D,p),p.extensionDependencies)for(let w of p.extensionDependencies){const o=u.ExtensionIdentifier.toKey(w);_.addArc(D,o)}}let d=new Set;_.getNodes().filter(p=>_.getArcs(p).length===0).forEach(p=>d.add(p));let l=_.getNodes().filter(p=>!d.has(p)),c;do{c=!1;for(let p=0;p<l.length;p++){const D=l[p];_.hasOnlyGoodArcs(D,d)&&(l.splice(p,1),p--,d.add(D),c=!0)}}while(c);return l.map(p=>n.get(p))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(u.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(u.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=F;var T;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(T||(T={}));function C(P,t){const _=P.isBuiltin?0:P.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==n)return _-n;const d=E.posix.basename(P.extensionLocation.path),l=E.posix.basename(t.extensionLocation.path);return d<l?-1:d>l?1:0}}),define(we[182],be([0,1,23]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function I(T){const C=u.VSBuffer.alloc(1);switch(T){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.createMessageOfType=I;function F(T,C){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.isMessageOfType=F}),define(we[94],be([0,1,3,2,4,22,149]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var T;(function(w){w[w.None=0]="None",w[w.LocalProcess=1]="LocalProcess",w[w.LocalWebWorker=2]="LocalWebWorker",w[w.Remote=3]="Remote"})(T=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function C(w){switch(w){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=C;class P{constructor(o){this.dependency=o}}e.MissingExtensionDependency=P;var t;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(t=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(w){switch(w){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;class n{constructor(o,f,k,r){this.codeLoadingTime=o,this.activateCallTime=f,this.activateResolvedTime=k,this.activationReason=r}}e.ActivationTimes=n;class d{constructor(o,f){this.description=o,this.value=f}}e.ExtensionPointContribution=d,e.ExtensionHostLogFileName="exthost";var l;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(l=e.ActivationKind||(e.ActivationKind={}));function c(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,F.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=c;function p(w,o){return{identifier:new I.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!o,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid}}e.toExtensionDescription=p;class D{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None}activateByEvent(o){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(o){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(o){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(o){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(o,f){return Promise.resolve()}_onWillActivateExtension(o){}_onDidActivateExtension(o,f,k,r,v){}_onDidActivateExtensionError(o,f){}_onExtensionRuntimeError(o,f){}_onExtensionHostExit(o){}}e.NullExtensionService=D}),define(we[183],be([0,1,22,94,12]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const I=Promise.resolve(void 0);class F{constructor(l,c,p,D){this.startup=l,this.codeLoadingTime=c,this.activateCallTime=p,this.activateResolvedTime=D}}e.ExtensionActivationTimes=F,F.NONE=new F(!1,-1,-1,-1);class T{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,c){return l===-1||c===-1?-1:c-l}build(){return new F(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=T;class C{constructor(l,c,p,D,w,o){this.activationFailed=l,this.activationFailedError=c,this.activationTimes=p,this.module=D,this.exports=w,this.subscriptions=o}}e.ActivatedExtension=C;class P extends C{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class t extends C{constructor(){super(!1,null,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends C{constructor(l){super(!0,l,F.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(l,c,p,D,w){this._logService=w,this._registry=l,this._resolvedExtensionsSet=new Set,c.forEach(o=>this._resolvedExtensionsSet.add(u.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,p.forEach(o=>this._hostExtensionsMap.set(u.ExtensionIdentifier.toKey(o),o)),this._host=D,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const c=u.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(c)}getActivatedExtension(l){const c=u.ExtensionIdentifier.toKey(l),p=this._activatedExtensions.get(c);if(!p)throw new Error("Extension `"+l.value+"` is not known or not activated");return p}activateByEvent(l,c){if(this._alreadyActivatedEvents[l])return I;const p=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(p.map(D=>({id:D.identifier,reason:{startup:c,extensionId:D.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,c){const p=this._registry.getExtensionDescription(l);if(!p)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:p.identifier,reason:c}])}_handleActivateRequest(l,c,p){if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(l.id))){c[u.ExtensionIdentifier.toKey(l.id)]=l;return}const D=this._registry.getExtensionDescription(l.id);if(!D){const f=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,f,new M.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(l.id),new _(f));return}const w=typeof D.extensionDependencies=="undefined"?[]:D.extensionDependencies;let o=!0;for(let f=0,k=w.length;f<k;f++){const r=w[f];if(this._resolvedExtensionsSet.has(u.ExtensionIdentifier.toKey(r)))continue;const v=this._activatedExtensions.get(u.ExtensionIdentifier.toKey(r));if(v&&!v.activationFailed)continue;if(v&&v.activationFailed){const a=D.displayName||D.identifier.value,g=this._registry.getExtensionDescription(r),b=g&&g.displayName||r,h=new Error(`Cannot activate the '${a}' extension because its dependency '${b}' failed to activate`);h.detail=v.activationFailedError,this._host.onExtensionActivationError(D.identifier,h,null),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(D.identifier),new _(h));return}if(this._hostExtensionsMap.has(u.ExtensionIdentifier.toKey(r))){o=!1,c[u.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(u.ExtensionIdentifier.toKey(r)),reason:l.reason};continue}const s=this._registry.getExtensionDescription(r);if(s){if(!s.main&&!s.browser)continue;o=!1,c[u.ExtensionIdentifier.toKey(r)]={id:s.identifier,reason:l.reason};continue}const i=D.displayName||D.identifier.value,m=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${r}'`);this._host.onExtensionActivationError(D.identifier,m,new M.MissingExtensionDependency(r)),this._activatedExtensions.set(u.ExtensionIdentifier.toKey(D.identifier),new _(m));return}o?c[u.ExtensionIdentifier.toKey(D.identifier)]=l:p.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(w=>!this._activatedExtensions.has(u.ExtensionIdentifier.toKey(w.id))),l.length===0))return Promise.resolve(void 0);const c=Object.create(null),p=[];for(let w=0,o=l.length;w<o;w++)this._handleActivateRequest(l[w],c,p);for(let w=0,o=p.length;w<o;w++){const f=u.ExtensionIdentifier.toKey(p[w].id);c[f]&&delete c[f]}const D=Object.keys(c).map(w=>c[w]);return p.length===0?Promise.all(D.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(D).then(w=>this._activateExtensions(p))}_activateExtension(l,c){const p=u.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(p))return Promise.resolve(void 0);const D=this._activatingExtensions.get(p);if(D)return D;const w=this._host.actualActivateExtension(l,c).then(void 0,o=>{const f=new Error;return o&&o.name&&(f.name=o.name),o&&o.message?f.message=`Activating extension '${l.value}' failed: ${o.message}.`:f.message=`Activating extension '${l.value}' failed: ${o}.`,o&&o.stack&&(f.stack=o.stack),this._host.onExtensionActivationError(l,f,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(o),new _(o)}).then(o=>{this._activatedExtensions.set(p,o),this._activatingExtensions.delete(p)});return this._activatingExtensions.set(p,w),w}};n=xe([Be(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(we[184],be([0,1,16]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((I,F)=>{this._actualOk=I,this._actualErr=F,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(I){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=I,this._actual&&this._actualOk(I))}resolveErr(I){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=I,this._actual?this._actualErr(I):(0,u.onUnexpectedError)(I))}then(I,F){return this._ensureActual().then(I,F)}catch(I){return this._ensureActual().then(void 0,I)}finally(I){return this._ensureActual().finally(I)}}e.LazyPromise=M}),define(we[38],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class u{constructor(P,t){this._proxyIdentifierBrand=void 0,this.isMain=P,this.sid=t,this.nid=++u.count}}e.ProxyIdentifier=u,u.count=0;const M=[];function E(C){const P=new u(!0,C);return M[P.nid]=P,P}e.createMainContextProxyIdentifier=E;function I(C){const P=new u(!1,C);return M[P.nid]=P,P}e.createExtHostContextProxyIdentifier=I;function F(C){return M[C].sid}e.getStringIdentifierForProxy=F;class T{constructor(P){this.value=P}}e.SerializableObjectWithBuffers=T}),define(we[5],be([0,1,56,2,38]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var I;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var F;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(F=e.TextEditorRevealType||(e.TextEditorRevealType={}));var T;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var C;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(C=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(o){o.name="$ident";function f(r,v){return Object.defineProperty(r,o.name,{value:v,enumerable:!0}),r}o.mixin=f;function k(r){return r[o.name]}o.of=k})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(f){return f._id=d._n++,f}}e.IdObject=d,d._n=0;var l;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function D(o){if(o&&o.edits)for(const f of o.edits)typeof f.resource=="object"?f.resource=M.URI.revive(f.resource):(f.newUri=M.URI.revive(f.newUri),f.oldUri=M.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,u.revive)(f.metadata));return o}e.reviveWorkspaceEditDto=D;var w;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[69],be([0,1,5,3,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class I{constructor(T){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(u.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,C){return this._proxy.$getPassword(T,C)}store(T,C,P){return this._proxy.$setPassword(T,C,P)}delete(T,C){return this._proxy.$deletePassword(T,C)}}e.ExtHostSecretState=I,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(we[70],be([0,1,4,12,5,14]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,u.createDecorator)("IExtHostApiDeprecationService");let F=class{constructor(C,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=C.getProxy(E.MainContext.MainThreadTelemetry)}report(C,P,t){const _=this.getUsageKey(C,P);this._reportedUsages.has(_)||(this._reportedUsages.add(_),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${C}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:C}))}getUsageKey(C,P){return`${C}-${P.identifier.value}`}};F=xe([Be(0,I.IExtHostRpcService),Be(1,M.ILogService)],F),e.ExtHostApiDeprecationService=F,e.NullApiDeprecationService=Object.freeze(new class{report(T,C,P){}})}),define(we[185],be([0,1,3,5,7,22]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class F{constructor(C){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new u.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=C.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(C){return this._providers=C,Promise.resolve()}async getSession(C,P,t,_={}){const n=I.ExtensionIdentifier.toKey(C.identifier),d=this._inFlightRequests.get(n)||[],l=[...t].sort().join(" ");let c=d.find(p=>p.scopes===l);if(c)return c.result;{const p=this._getSession(C,n,P,t,_);c={scopes:l,result:p},d.push(c),this._inFlightRequests.set(n,d);try{await p}finally{const D=d.findIndex(w=>w.scopes===l);D>-1&&(d.splice(D),this._inFlightRequests.set(n,d))}return p}}async _getSession(C,P,t,_,n={}){await this._proxy.$ensureProvider(t);const d=C.displayName||C.name;return this._proxy.$getSession(t,_,P,d,n)}async removeSession(C,P){const t=this._authenticationProviders.get(C);return t?t.provider.removeSession(P):this._proxy.$removeSession(C,P)}registerAuthenticationProvider(C,P,t,_){if(this._authenticationProviders.get(C))throw new Error(`An authentication provider with id '${C}' is already registered.`);this._authenticationProviders.set(C,{label:P,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===C)||this._providers.push({id:C,label:P});const n=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(C,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(C,P,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(C);const d=this._providers.findIndex(l=>l.id===C);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(C)})}$createSession(C,P){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$removeSession(C,P){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$getSessions(C,P){const t=this._authenticationProviders.get(C);if(t)return Promise.resolve(t.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${C}`)}$onDidChangeAuthenticationSessions(C,P){return this._onDidChangeSessions.fire({provider:{id:C,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=F}),define(we[186],be([0,1,5,14,8]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let I=class{constructor(T,C){this._extHostDocumentsAndEditors=C,this._proxy=T.getProxy(u.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(T){const C=E.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(C)}};I=xe([Be(0,M.IExtHostRpcService)],I),e.ExtHostBulkEdits=I}),define(we[187],be([0,1,5]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(I){const F=I.getProxy(u.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return F.$readText()},writeText(T){return F.$writeText(T)}})}}e.ExtHostClipboard=M}),define(we[39],be([0,1,10,7,8,24,5,15,12,56,44,111,2,6,4,14,49,23,38,45]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let f=class{constructor(m,a){this._commands=new Map,this._apiCommands=new Map,this._proxy=m.getProxy(F.MainContext.MainThreadCommands),this._logService=a,this.converter=new k(this,g=>{const b=this._apiCommands.get(g);return b?.result===v.Void?b:void 0},a),this._argumentProcessors=[{processArgument(g){return(0,P.revive)(g)}},{processArgument(g){return(0,I.cloneAndChange)(g,function(b){if(t.Range.isIRange(b))return E.Range.to(b);if(_.Position.isIPosition(b))return E.Position.to(b);if(t.Range.isIRange(b.range)&&n.URI.isUri(b.uri))return E.location.to(b);if(b instanceof D.VSBuffer)return b.buffer.buffer;if(!Array.isArray(b))return b})}}]}registerArgumentProcessor(m){this._argumentProcessors.push(m)}registerApiCommand(m){const a=this.registerCommand(!1,m.id,async(...g)=>{const b=m.args.map((y,R)=>{if(!y.validate(g[R]))throw new Error(`Invalid argument '${y.name}' when running '${m.id}', received: ${g[R]}`);return y.convert(g[R])}),h=await this.executeCommand(m.internalId,...b);return m.result.convert(h,g,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this._apiCommands.set(m.id,m),new M.Disposable(()=>{a.dispose(),this._apiCommands.delete(m.id)})}registerCommand(m,a,g,b,h,y){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:g,thisArg:b,description:h,extension:y}),m&&this._proxy.$registerCommand(a),new M.Disposable(()=>{this._commands.delete(a)&&m&&this._proxy.$unregisterCommand(a)})}executeCommand(m,...a){return this._logService.trace("ExtHostCommands#executeCommand",m),this._doExecuteCommand(m,a,!0)}async _doExecuteCommand(m,a,g){if(this._commands.has(m))return this._executeContributedCommand(m,a,!1);{let b=!1;const h=(0,I.cloneAndChange)(a,function(y){if(y instanceof M.Position)return E.Position.from(y);if(y instanceof M.Range)return E.Range.from(y);if(y instanceof M.Location)return E.location.from(y);if(M.NotebookRange.isNotebookRange(y))return E.NotebookRange.from(y);if(y instanceof ArrayBuffer)return b=!0,D.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return b=!0,D.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(m,b?new w.SerializableObjectWithBuffers(h):h,g);return(0,P.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(m,a,!1);throw y}}}async _executeContributedCommand(m,a,g){const b=this._commands.get(m);if(!b)throw new Error("Unknown command");let{callback:h,thisArg:y,description:R}=b;if(R)for(let A=0;A<R.args.length;A++)try{(0,u.validateConstraint)(a[A],R.args[A].constraint)}catch(B){throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${R.args[A].name}' - ${R.args[A].description}`)}try{return await h.apply(y,a)}catch(A){if(m===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...a);B&&(m=B.command)}throw this._logService.error(A,m,b.extension?.identifier),g?new class extends Error{constructor(){super((0,o.toErrorMessage)(A));this.id=m,this.source=b.extension?.displayName??b.extension?.name}}:A}}$executeContributedCommand(m,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",m),this._commands.has(m)?(a=a.map(g=>this._argumentProcessors.reduce((b,h)=>h.processArgument(b),g)),this._executeContributedCommand(m,a,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this._logService.trace("ExtHostCommands#getCommands",m),this._proxy.$getCommands().then(a=>(m&&(a=a.filter(g=>g[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(let[a,g]of this._commands){let{description:b}=g;b&&(m[a]=b)}return Promise.resolve(m)}};f=xe([Be(0,c.IExtHostRpcService),Be(1,C.ILogService)],f),e.ExtHostCommands=f,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class k{constructor(m,a,g){this._commands=m,this._lookupApiCommand=a,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(m,a){if(!m)return;const g={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return g;const b=this._lookupApiCommand(m.command);if(b)g.id=b.internalId,g.arguments=b.args.map((h,y)=>h.convert(m.arguments&&m.arguments[y]));else if((0,T.isNonEmptyArray)(m.arguments)){const h=++this._cachIdPool;this._cache.set(h,m),a.add((0,d.toDisposable)(()=>{this._cache.delete(h),this._logService.trace("CommandsConverter#DISPOSE",h)})),g.$ident=h,g.id=this.delegatingCommandId,g.arguments=[h],this._logService.trace("CommandsConverter#CREATE",m.command,h)}return g}fromInternal(m){const a=F.ObjectIdentifier.of(m);return typeof a=="number"?this._cache.get(a):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this._cache.get(m[0])}_executeConvertedCommand(...m){const a=this.getActualCommand(...m);return this._logService.trace("CommandsConverter#EXECUTE",m[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=k;class r{constructor(m,a,g,b){this.name=m,this.description=a,this.validate=g,this.convert=b}optional(){return new r(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,a){return new r(m??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),r.Position=new r("position","A position in a text document",i=>M.Position.isPosition(i),E.Position.from),r.Range=new r("range","A range in a text document",i=>M.Range.isRange(i),E.Range.from),r.Selection=new r("selection","A selection in a text document",i=>M.Selection.isSelection(i),E.Selection.from),r.Number=new r("number","",i=>typeof i=="number",i=>i),r.String=new r("string","",i=>typeof i=="string",i=>i),r.CallHierarchyItem=new r("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",i=>i instanceof p.TestItemImpl,E.TestItem.from);class v{constructor(m,a){this.description=m,this.convert=a}}e.ApiCommandResult=v,v.Void=new v("no result",i=>i);class s{constructor(m,a,g,b,h){this.id=m,this.internalId=a,this.description=g,this.args=b,this.result=h}}e.ApiCommand=s}),define(we[188],be([0,1,8,7,60,39,15,80]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const C=[new I.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(u.DocumentHighlight.to))),new I.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,d)=>{if((0,F.isFalsyOrEmpty)(n))return;class l extends M.SymbolInformation{static to(p){const D=new l(p.name,u.SymbolKind.to(p.kind),p.containerName||"",new M.Location(d[0],u.Range.to(p.range)));return D.detail=p.detail,D.range=D.location.range,D.selectionRange=u.Range.to(p.selectionRange),D.children=p.children?p.children.map(l.to):[],D}}return n.map(l.to)})),new I.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new I.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range,new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new I.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,new I.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new I.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new I.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(u.TextEdit.to))),new I.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new I.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(u.location.to))),new I.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(u.Hover.to))),new I.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(d=>M.Position.isPosition(d)),n=>n.map(u.Position.from))],new I.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(d=>{let l;for(const c of d.reverse())l=new M.SelectionRange(u.Range.to(c),l);return l}))),new I.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[I.ApiCommandArgument.String.with("query","Search string")],new I.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const d=[];if(Array.isArray(n))for(let l of n)d.push(...l[1].map(u.WorkspaceSymbol.to));return d})),new I.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyItem.to))),new I.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyIncomingCall.to))),new I.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[I.ApiCommandArgument.CallHierarchyItem],new I.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(u.CallHierarchyOutgoingCall.to))),new I.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:u.Range.to(n.range),placeholder:n.text}})),new I.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("newName","The new symbol name")],new I.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return u.WorkspaceEdit.to(n)}})),new I.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new I.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(u.DocumentLink.to))),new I.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,T.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range.optional()],new I.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new I.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const d=(0,T.decodeSemanticTokensDto)(n);if(d.type==="full")return new M.SemanticTokens(d.data,void 0)})),new I.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new I.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,d,l)=>{if(!n)return new M.CompletionList([]);const c=n.suggestions.map(p=>u.CompletionItem.to(p,l));return new M.CompletionList(c,n.incomplete)})),new I.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position,I.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new I.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return u.SignatureHelp.to(n)})),new I.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new I.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,d,l)=>t(c=>new M.CodeLens(u.Range.to(c.range),c.command&&l.fromInternal(c.command)))(n))),new I.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?u.Selection.from(n):u.Range.from(n)),I.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),I.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new I.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,d,l)=>t(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(c.command)}else{const p=new M.CodeAction(c.title,c.kind?new M.CodeActionKind(c.kind):void 0);return c.edit&&(p.edit=u.WorkspaceEdit.to(c.edit)),c.command&&(p.command=l.fromInternal(c.command)),p.isPreferred=c.isPreferred,p}})(n))),new I.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[I.ApiCommandArgument.Uri],new I.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(d=>new M.ColorInformation(u.Range.to(d.range),u.Color.to(d.color))):[])),new I.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new I.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,u.Color.from),new I.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:u.Range.from(n.range)}))],new I.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(u.ColorPresentation.to):[])),new I.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(u.InlayHint.to))),new I.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new I.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(d=>u.NotebookExclusiveDocumentPattern.to(d))})))),new I.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Range],new I.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(u.InlineValue.to))),new I.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[I.ApiCommandArgument.Uri,new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)])).optional(),I.ApiCommandArgument.String.with("label","").optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[I.ApiCommandArgument.Uri.with("resource","Resource to open"),I.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)])).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[I.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),I.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),I.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new I.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[u.ViewColumn.from(n.viewColumn),u.TextEditorOpenOptions.from(n)]).optional()],I.ApiCommandResult.Void),new I.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[I.ApiCommandArgument.Uri,I.ApiCommandArgument.Position],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new I.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[I.ApiCommandArgument.TypeHierarchyItem],new I.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(u.TypeHierarchyItem.to))),new I.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[I.ApiCommandArgument.TestItem],I.ApiCommandResult.Void)];class P{static register(d){C.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=P;function t(n){return d=>{if(Array.isArray(d))return d.map(n)}}function _(n){if(!Array.isArray(n))return;const d=[];for(const l of n)E.isLocationLink(l)?d.push(u.DefinitionLink.to(l)):d.push(u.location.to(l));return d}}),define(we[189],be([0,1,13,54,3,6,2,60,22,8,7,5]),function(ne,e,u,M,E,I,F,T,C,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(d,l,c){const p=d.getProxy(_.MainContext.MainThreadComments);class D{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,l.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const m=this._commentControllers.get(i.handle);return m||i}else if(i&&i.$mid===7){const m=this._commentControllers.get(i.commentControlHandle);if(!m)return i;const a=m.getCommentThread(i.commentThreadHandle);return a||i}else if(i&&i.$mid===8){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const a=m.getCommentThread(i.thread.commentThreadHandle);return a?{thread:a,text:i.text}:i}else if(i&&i.$mid===9){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const a=m.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let g=i.commentUniqueId,b=a.getCommentByUniqueId(g);return b||i}else if(i&&i.$mid===10){const m=this._commentControllers.get(i.thread.commentControlHandle);if(!m)return i;const a=m.getCommentThread(i.thread.commentThreadHandle);if(!a)return i;let g=i.text,b=i.commentUniqueId,h=a.getCommentByUniqueId(b);return h?(h.body=g,h):i}return i}})}createCommentController(i,m,a){const g=D.handlePool++,b=new o(i,g,m,a);this._commentControllers.set(b.handle,b);const h=this._commentControllersByExtension.get(C.ExtensionIdentifier.toKey(i.identifier))||[];return h.push(b),this._commentControllersByExtension.set(C.ExtensionIdentifier.toKey(i.identifier),h),b.value}$createCommentThreadTemplate(i,m,a){const g=this._commentControllers.get(i);!g||g.$createCommentThreadTemplate(m,a)}async $updateCommentThreadTemplate(i,m,a){const g=this._commentControllers.get(i);!g||g.$updateCommentThreadTemplate(m,a)}$deleteCommentThread(i,m){const a=this._commentControllers.get(i);a&&a.$deleteCommentThread(m)}$provideCommentingRanges(i,m,a){const g=this._commentControllers.get(i);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=c.getDocument(F.URI.revive(m));return(0,u.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(b,a)).then(h=>h?h.map(y=>P.Range.from(y)):void 0)}$toggleReaction(i,m,a,g,b){const h=this._commentControllers.get(i);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,u.asPromise)(()=>{const y=h.getCommentThread(m);if(y){const R=y.getCommentByUniqueId(g.uniqueIdInThread);if(h!==void 0&&R&&h.reactionHandler)return h.reactionHandler(R,r(b))}return Promise.resolve(void 0)})}dispose(){}}D.handlePool=0;class w{constructor(i,m,a,g,b,h,y){this._commentControllerHandle=m,this._id=a,this._uri=g,this._range=b,this._comments=h,this.handle=w._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputDisposables.value=new I.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),p.$createCommentThread(m,this.handle,this._id,this._uri,P.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this._localDisposables.push({dispose:()=>{p.$deleteCommentThread(m,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(A){R.range=A},get comments(){return R.comments},set comments(A){R.comments=A},get collapsibleState(){return R.collapsibleState},set collapsibleState(A){R.collapsibleState=A},get canReply(){return R.canReply},set canReply(A){R.canReply=A},get contextValue(){return R.contextValue},set contextValue(A){R.contextValue=A},get label(){return R.label},set label(A){R.label=A},dispose:()=>{R.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new I.DisposableStore);const i=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),m={};i("range")&&(m.range=P.Range.from(this._range)),i("label")&&(m.label=this.label),i("contextValue")&&(m.contextValue=this.contextValue??null),i("comments")&&(m.comments=this._comments.map(a=>f(this,a,this._commentsMap))),i("collapsibleState")&&(m.collapseState=v(this._collapseState)),i("canReply")&&(m.canReply=this.canReply),this.modifications={},p.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(i){for(let m of this._commentsMap){let a=m[0],g=m[1];if(i===g)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}w._handlePool=0,xe([(0,M.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(i,m,a,g){this._extension=i,this._handle=m,this._id=a,this._label=g,this._threads=new Map,p.$registerCommentController(this.handle,a,g);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(h){b.options=h},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(h){b.commentingRangeProvider=h},get reactionHandler(){return b.reactionHandler},set reactionHandler(h){b.reactionHandler=h},createCommentThread(h,y,R){return b.createCommentThread(h,y,R).value},dispose:()=>{b.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{p.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,p.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,p.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,p.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,m,a,g){if(typeof i=="string"){const b=new w(this.id,this.handle,i,m,a,g,this._extension.identifier);return this._threads.set(b.handle,b),b}else{const b=new w(this.id,this.handle,void 0,i,m,a,this._extension.identifier);return this._threads.set(b.handle,b),b}}$createCommentThreadTemplate(i,m){const a=new w(this.id,this.handle,void 0,F.URI.revive(i),P.Range.to(m),[],this._extension.identifier);return a.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(i,m){let a=this._threads.get(i);a&&(a.range=P.Range.to(m))}$deleteCommentThread(i){let m=this._threads.get(i);m&&m.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function f(s,i,m){let a=m.get(i);a||(a=++s.commentHandle,m.set(i,a));const g=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:a,body:P.MarkdownString.from(i.body),userName:i.author.name,userIconPath:g,label:i.label,commentReactions:i.reactions?i.reactions.map(b=>k(b)):void 0}}function k(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function r(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?F.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function v(s){if(s!==void 0)switch(s){case t.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}return new D}e.createExtHostComments=n}),define(we[95],be([0,1,2,5,7,4,14,12,15,9,17]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(d,l){this._logService=l,this._provider=new Map,this._proxy=d.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,l){const c=wi._handlePool++;this._provider.set(c,{provider:d,extensionId:l}),this._proxy.$registerDecorationProvider(c,l.value);const p=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(D=>{if(!D){this._proxy.$onDidChange(c,null);return}let w=(0,C.asArray)(D);if(w.length<=wi._maxEventSize){this._proxy.$onDidChange(c,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,w.length);const o=w.map(r=>({uri:r,rank:(0,P.count)(r.path,"/")})),f=(0,C.groupBy)(o,(r,v)=>r.rank-v.rank||(0,P.compare)(r.uri.path,v.uri.path));let k=[];e:for(let r of f){let v;for(let s of r){let i=(0,t.dirname)(s.uri.path);if(v!==i&&(v=i,k.push(s.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(c,k)});return new E.Disposable(()=>{p?.dispose(),this._proxy.$unregisterDecorationProvider(c),this._provider.delete(c)})}async $provideDecorations(d,l,c){if(!this._provider.has(d))return Object.create(null);const p=Object.create(null),{provider:D,extensionId:w}=this._provider.get(d);return await Promise.all(l.map(async o=>{try{const{uri:f,id:k}=o,r=await Promise.resolve(D.provideFileDecoration(u.URI.revive(f),c));if(!r)return;try{E.FileDecoration.validate(r),p[k]=[r.propagate,r.tooltip,r.badge,r.color]}catch(v){this._logService.warn(`INVALID decoration from extension '${w.value}': ${v}`)}}catch(f){this._logService.error(f)}})),p}};_._handlePool=0,_._maxEventSize=250,_=xe([Be(0,F.IExtHostRpcService),Be(1,T.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,I.createDecorator)("IExtHostDecorations")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[190],be([0,1,125,82,2,5,7,8,3,12,20,30]),function(ne,e,u,M,E,I,F,T,C,P,t,_){"use strict";var n,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class c{constructor(w,o,f,k,r,v){this._name=w,this._owner=o,this._maxDiagnosticsPerFile=f,n.set(this,void 0),d.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Ze(this,l,new t.ResourceMap(s=>k.getComparisonKey(s)),"f"),Ze(this,n,r,"f"),Ze(this,d,v,"f")}dispose(){this._isDisposed||(Te(this,d,"f").fire([...Te(this,l,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(w,o){if(!w){this.clear();return}this._checkDisposed();let f=[];if(E.URI.isUri(w)){if(!o){this.delete(w);return}Te(this,l,"f").set(w,o.slice()),f=[w]}else if(Array.isArray(w)){f=[];let r;w=[...w].sort(c._compareIndexedTuplesByUri);for(const v of w){const[s,i]=v;if((!r||s.toString()!==r.toString())&&(r&&Te(this,l,"f").get(r).length===0&&Te(this,l,"f").delete(r),r=s,f.push(s),Te(this,l,"f").set(s,[])),i){const m=Te(this,l,"f").get(s);m&&m.push(...i)}else{const m=Te(this,l,"f").get(s);m&&(m.length=0)}}}if(Te(this,d,"f").fire(f),!Te(this,n,"f"))return;const k=[];for(let r of f){let v=[];const s=Te(this,l,"f").get(r);if(s)if(s.length>this._maxDiagnosticsPerFile){v=[];const i=[F.DiagnosticSeverity.Error,F.DiagnosticSeverity.Warning,F.DiagnosticSeverity.Information,F.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(let a of s)if(a.severity===i[m]&&v.push(T.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;v.push({severity:M.MarkerSeverity.Info,message:(0,u.localize)(0,null,s.length-this._maxDiagnosticsPerFile),startLineNumber:v[v.length-1].startLineNumber,startColumn:v[v.length-1].startColumn,endLineNumber:v[v.length-1].endLineNumber,endColumn:v[v.length-1].endColumn})}else v=s.map(i=>T.Diagnostic.from(i));k.push([r,v])}Te(this,n,"f").$changeMany(this._owner,k)}delete(w){this._checkDisposed(),Te(this,d,"f").fire([w]),Te(this,l,"f").delete(w),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[w,void 0]])}clear(){this._checkDisposed(),Te(this,d,"f").fire([...Te(this,l,"f").keys()]),Te(this,l,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(w,o){this._checkDisposed();for(let f of Te(this,l,"f").keys())w.apply(o,[f,this.get(f),this])}get(w){this._checkDisposed();const o=Te(this,l,"f").get(w);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(w){return this._checkDisposed(),Array.isArray(Te(this,l,"f").get(w))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(w,o){return w[0].toString()<o[0].toString()?-1:w[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=c,n=new WeakMap,d=new WeakMap,l=new WeakMap;let p=class ti{constructor(w,o,f){this._logService=o,this._fileSystemInfoService=f,this._collections=new Map,this._onDidChangeDiagnostics=new C.DebounceEmitter({merge:k=>k.flat(),delay:50}),this.onDidChangeDiagnostics=C.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=w.getProxy(I.MainContext.MainThreadDiagnostics)}static _mapper(w){const o=new t.ResourceMap;for(const f of w)o.set(f,f);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(w,o){const{_collections:f,_proxy:k,_onDidChangeDiagnostics:r,_logService:v,_fileSystemInfoService:s}=this,i=new class{$changeMany(g,b){k.$changeMany(g,b),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,g,b.length===0?"CLEARING":b)}$clear(g){k.$clear(g),v.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,g)}dispose(){k.dispose()}};let m;if(!o)o="_generated_diagnostic_collection_name_#"+ti._idPool++,m=o;else if(!f.has(o))m=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do m=o+ti._idPool++;while(f.has(m))}return new class extends c{constructor(){super(o,m,ti._maxDiagnosticsPerFile,s.extUri,i,r);f.set(m,this)}dispose(){super.dispose(),f.delete(m)}}}getDiagnostics(w){if(w)return this._getDiagnostics(w);{const o=new Map,f=[];for(const k of this._collections.values())k.forEach((r,v)=>{let s=o.get(r.toString());typeof s=="undefined"&&(s=f.length,o.set(r.toString(),s),f.push([r,[]])),f[s][1]=f[s][1].concat(...v)});return f}}_getDiagnostics(w){let o=[];for(let f of this._collections.values())f.has(w)&&(o=o.concat(f.get(w)));return o}$acceptMarkersChange(w){if(!this._mirrorCollection){const o="_generated_mirror",f=new c(o,o,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,f),this._mirrorCollection=f}for(const[o,f]of w)this._mirrorCollection.set(E.URI.revive(o),f.map(T.Diagnostic.to))}};p._idPool=0,p._maxDiagnosticsPerFile=1e3,p=xe([Be(1,P.ILogService),Be(2,_.IExtHostFileSystemInfo)],p),e.ExtHostDiagnostics=p}),define(we[191],be([0,1,2,5]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(F){this._proxy=F.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(F){return this._proxy.$showOpenDialog(F).then(T=>T?T.map(C=>u.URI.revive(C)):void 0)}showSaveDialog(F){return this._proxy.$showSaveDialog(F).then(T=>T?u.URI.revive(T):void 0)}}e.ExtHostDialogs=E}),define(we[192],be([0,1,16,2,7,5,11,21,9]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(_,n,d){this._documentsAndEditors=n,this._logService=d,this._documentContentProviders=new Map,this._proxy=_.getProxy(I.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(F.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const d=P._handlePool++;this._documentContentProviders.set(d,n),this._proxy.$registerTextContentProvider(d,_);let l;return typeof n.onDidChange=="function"&&(l=n.onDidChange(c=>{if(c.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(c)&&this.$provideTextDocumentContent(d,c).then(p=>{if(!p&&typeof p!="string")return;const D=this._documentsAndEditors.getDocument(c);if(!D)return;const w=(0,C.splitLines)(p);if(!D.equalLines(w))return this._proxy.$onVirtualDocumentChange(c,p)},u.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(_,n){const d=this._documentContentProviders.get(_);return d?Promise.resolve(d.provideTextDocumentContent(M.URI.revive(n),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(we[193],be([0,1,3,6,2,5,87,8,10,24,7]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(d,l){this._onDidAddDocument=new u.Emitter,this._onDidRemoveDocument=new u.Emitter,this._onDidChangeDocument=new u.Emitter,this._onDidSaveDocument=new u.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(I.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const p of c)this._onDidRemoveDocument.fire(p.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const p of c)this._onDidAddDocument.fire(p.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const l=this._documentsAndEditors.getDocument(d);if(l)return l}getDocument(d){const l=this.getDocumentData(d);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return l.document}ensureDocumentData(d){const l=this._documentsAndEditors.getDocument(d);if(l)return Promise.resolve(l);let c=this._documentLoader.get(d.toString());return c||(c=this._proxy.$tryOpenDocument(d).then(p=>{this._documentLoader.delete(d.toString());const D=E.URI.revive(p);return(0,C.assertIsDefined)(this._documentsAndEditors.getDocument(D))},p=>(this._documentLoader.delete(d.toString()),Promise.reject(p))),this._documentLoader.set(d.toString(),c)),c}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(l=>E.URI.revive(l))}$acceptModelModeChanged(d,l){const c=E.URI.revive(d),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");this._onDidRemoveDocument.fire(p.document),p._acceptLanguageId(l),this._onDidAddDocument.fire(p.document)}$acceptModelSaved(d){const l=E.URI.revive(d),c=this._documentsAndEditors.getDocument(l);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(d,l){const c=E.URI.revive(d),p=this._documentsAndEditors.getDocument(c);if(!p)throw new Error("unknown document");p._acceptIsDirty(l),this._onDidChangeDocument.fire({document:p.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,l,c){const p=E.URI.revive(d),D=this._documentsAndEditors.getDocument(p);if(!D)throw new Error("unknown document");D._acceptIsDirty(c),D.onEvents(l);let w;l.isUndoing?w=t.TextDocumentChangeReason.Undo:l.isRedoing&&(w=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:D.document,contentChanges:l.changes.map(o=>({range:T.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:w}))}setWordDefinitionFor(d,l){(0,F.setWordDefinitionFor)(d,l)}}e.ExtHostDocuments=_}),define(we[50],be([0,1,42,3,6,2,4,5,87,14,93,8,12,20,11,167,103]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class D{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(f,k){this._extHostRpc=f,this._logService=k,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const k=[],r=[],v=[];if(f.removedDocuments)for(const s of f.removedDocuments){const i=I.URI.revive(s),m=this._documents.get(i);m?.unref()&&(this._documents.delete(i),k.push(m.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const i=I.URI.revive(s.uri);let m=this._documents.get(i);if(m&&i.scheme!==l.Schemas.vscodeNotebookCell&&i.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);m||(m=new D(new C.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this._documents.set(i,m),r.push(m.value)),m.ref()}if(f.removedEditors)for(const s of f.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&v.push(i)}if(f.addedEditors)for(const s of f.addedEditors){const i=I.URI.revive(s.documentUri);u.ok(this._documents.has(i),`document '${i}' does not exist`),u.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const m=this._documents.get(i).value,a=new t.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new p.Lazy(()=>m.document),s.selections.map(_.Selection.to),s.options,s.visibleRanges.map(g=>_.Range.to(g)),typeof s.editorPosition=="number"?_.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,a)}f.newActiveEditor!==void 0&&(u.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),(0,E.dispose)(k),(0,E.dispose)(v),f.removedDocuments&&this._onDidRemoveDocuments.fire(k),f.addedDocuments&&this._onDidAddDocuments.fire(r),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){return this._documents.get(f)?.value}allDocuments(){return c.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const k=this._editors.get(this._activeEditorId);return f?k:k?.value}allEditors(){return[...this._editors.values()]}};w=xe([Be(0,P.IExtHostRpcService),Be(1,n.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=(0,F.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[71],be([0,1,8,5,2,3,4,14,13]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,F.createDecorator)("IExtHostEditorTabs");let P=class{constructor(_){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new I.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((l,c)=>(l.isActive&&(n=c),Object.freeze({label:l.label,viewColumn:u.ViewColumn.to(l.viewColumn),index:c,resource:E.URI.revive(l.resource),additionalResourcesAndViewIds:l.additionalResourcesAndViewIds.map(({resource:p,viewId:D})=>({resource:E.URI.revive(p),viewId:D})),viewId:l.editorId,isActive:l.isActive,move:async(p,D)=>{this._proxy.$moveTab(l,p,u.ViewColumn.from(D)),await(0,C.raceTimeout)(I.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(l),await(0,C.raceTimeout)(I.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((l,c)=>l.viewColumn===c.viewColumn?l.index-c.index:l.viewColumn-c.viewColumn);const d=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==d&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};P=xe([Be(0,T.IExtHostRpcService)],P),e.ExtHostEditorTabs=P}),define(we[194],be([0,1,2,5,6,7,8,236,9,23]),function(ne,e,u,M,E,I,F,T,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const l=this._schemes.indexOf(d);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),l=[];let c,p,D=14,w=14;for(const o of d){let f=c?(0,C.commonPrefixLength)(c,o):0;for(f===0?p=1:p=w;f<o.length;f++)f+1===o.length?(D=w,w=9):w+=1,l.push([p,o.toUpperCase().charCodeAt(f),w]),l.push([p,o.toLowerCase().charCodeAt(f),w]),p=w;c=o,w=D}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new T.StateMachine(l)}}provideDocumentLinks(d){this._initStateMachine();const l=[],c=T.LinkComputer.computeLinks({getLineContent(p){return d.lineAt(p-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const p of c){const D=F.DocumentLink.to(p);D.target&&l.push(D)}return l}}class _{constructor(d,l){this._extHostLanguageFeatures=l,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,l,c,p={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const D=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(D,c);let w=2;p.isCaseSensitive&&(w+=1024),p.isReadonly&&(w+=2048),typeof c.copy=="function"&&(w+=8),typeof c.open=="function"&&typeof c.close=="function"&&typeof c.read=="function"&&typeof c.write=="function"&&(w+=4),this._proxy.$registerFileSystemProvider(D,l,w).catch(f=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${l}`),console.error(f)});const o=c.onDidChangeFile(f=>{const k=[];for(const r of f){let{uri:v,type:s}=r;if(v.scheme!==l)continue;let i;switch(s){case I.FileChangeType.Changed:i=0;break;case I.FileChangeType.Created:i=1;break;case I.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}k.push({resource:v,type:i})}this._proxy.$onFileSystemChange(D,k)});return(0,E.toDisposable)(()=>{o.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(D),this._proxy.$unregisterProvider(D)})}static _asIStat(d){const{type:l,ctime:c,mtime:p,size:D,permissions:w}=d;return{type:l,ctime:c,mtime:p,size:D,permissions:w}}$stat(d,l){return Promise.resolve(this._getFsProvider(d).stat(u.URI.revive(l))).then(c=>_._asIStat(c))}$readdir(d,l){return Promise.resolve(this._getFsProvider(d).readDirectory(u.URI.revive(l)))}$readFile(d,l){return Promise.resolve(this._getFsProvider(d).readFile(u.URI.revive(l))).then(c=>P.VSBuffer.wrap(c))}$writeFile(d,l,c,p){return Promise.resolve(this._getFsProvider(d).writeFile(u.URI.revive(l),c.buffer,p))}$delete(d,l,c){return Promise.resolve(this._getFsProvider(d).delete(u.URI.revive(l),c))}$rename(d,l,c,p){return Promise.resolve(this._getFsProvider(d).rename(u.URI.revive(l),u.URI.revive(c),p))}$copy(d,l,c,p){const D=this._getFsProvider(d);if(!D.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(D.copy(u.URI.revive(l),u.URI.revive(c),p))}$mkdir(d,l){return Promise.resolve(this._getFsProvider(d).createDirectory(u.URI.revive(l)))}$watch(d,l,c,p){const D=this._getFsProvider(d).watch(u.URI.revive(c),p);this._watches.set(l,D)}$unwatch(d,l){const c=this._watches.get(l);c&&(c.dispose(),this._watches.delete(l))}$open(d,l,c){const p=this._getFsProvider(d);if(!p.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(p.open(u.URI.revive(l),c))}$close(d,l){const c=this._getFsProvider(d);if(!c.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(c.close(l))}$read(d,l,c,p){const D=this._getFsProvider(d);if(!D.read)throw new Error('FileSystemProvider does not implement "read"');const w=P.VSBuffer.alloc(p);return Promise.resolve(D.read(l,c,w.buffer,0,p)).then(o=>w.slice(0,o))}$write(d,l,c,p){const D=this._getFsProvider(d);if(!D.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(D.write(l,c,p.buffer,0,p.byteLength))}_getFsProvider(d){const l=this._fsProvider.get(d);if(!l){const c=new Error;throw c.name="ENOPRO",c.message="no provider",c}return l}}e.ExtHostFileSystem=_}),define(we[51],be([0,1,5,46,7,23,4,14,30]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Bt{constructor(_,n){const d=_.getProxy(u.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return d.$stat(l).catch(Bt._handleError)},readDirectory(l){return d.$readdir(l).catch(Bt._handleError)},createDirectory(l){return d.$mkdir(l).catch(Bt._handleError)},async readFile(l){return d.$readFile(l).then(c=>c.buffer).catch(Bt._handleError)},writeFile(l,c){return d.$writeFile(l,I.VSBuffer.wrap(c)).catch(Bt._handleError)},delete(l,c){return d.$delete(l,{recursive:!1,useTrash:!1,...c}).catch(Bt._handleError)},rename(l,c,p){return d.$rename(l,c,{overwrite:!1,...p}).catch(Bt._handleError)},copy(l,c,p){return d.$copy(l,c,{overwrite:!1,...p}).catch(Bt._handleError)},isWritableFileSystem(l){const c=n.getCapabilities(l);if(typeof c=="number")return!(c&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};P=xe([Be(0,T.IExtHostRpcService),Be(1,C.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,F.createDecorator)("IExtHostConsumerFileSystem")}),define(we[195],be([0,1,2,39]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(F,T,C,P){this._extHostNotebooks=T,this._textDocumentsAndEditors=C,this._commands=P;const t=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:u.URI.revive(_.notebookUri),inputUri:u.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(F,T,C,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:C,uri:F,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(u.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(F,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[F]})}}e.ExtHostInteractive=E}),define(we[196],be([0,1,6,5]),function(ne,e,u,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(F){this._handlePool=0,this._proxy=F.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(F){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,F),(0,u.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=E}),define(we[197],be([0,1,2,24,8,7,5,9,44,15,10,237,6,80,55,64,198,16,3]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(z,Q){this._documents=z,this._provider=Q}async provideDocumentSymbols(z,Q){const X=this._documents.getDocument(z),se=await this._provider.provideDocumentSymbols(X,Q);if(!(0,P.isFalsyOrEmpty)(se))return se[0]instanceof I.DocumentSymbol?se.map(E.DocumentSymbol.from):o._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((se,K)=>{let te=se.location.range.start.compareTo(K.location.range.start);return te===0&&(te=K.location.range.end.compareTo(se.location.range.end)),te});const Q=[],X=[];for(const se of z){const K={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(X.length===0){X.push(K),Q.push(K);break}const te=X[X.length-1];if(C.Range.containsRange(te.range,K.range)&&!C.Range.equalsRange(te.range,K.range)){te.children&&te.children.push(K),X.push(K);break}X.pop()}}return Q}}class f{constructor(z,Q,X){this._documents=z,this._commands=Q,this._provider=X,this._cache=new c.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Q){const X=this._documents.getDocument(z),se=await this._provider.provideCodeLenses(X,Q);if(!se||Q.isCancellationRequested)return;const K=this._cache.add(se),te=new n.DisposableStore;this._disposables.set(K,te);const ce={cacheId:K,lenses:[]};for(let Pe=0;Pe<se.length;Pe++)ce.lenses.push({cacheId:[K,Pe],range:E.Range.from(se[Pe].range),command:this._commands.toInternal(se[Pe].command,te)});return ce}async resolveCodeLens(z,Q){const X=z.cacheId&&this._cache.get(...z.cacheId);if(!X)return;let se;if(typeof this._provider.resolveCodeLens!="function"||X.isResolved?se=X:se=await this._provider.resolveCodeLens(X,Q),se||(se=X),Q.isCancellationRequested)return;const K=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!K)return z.command=this._commands.toInternal(se.command??f._badCmd,K),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}f._badCmd={command:"missing",title:"!!MISSING: command!!"};function k(Qe){return Array.isArray(Qe)?Qe.map(E.DefinitionLink.from):Qe?[E.DefinitionLink.from(Qe)]:[]}class r{constructor(z,Q){this._documents=z,this._provider=Q}async provideDefinition(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideDefinition(se,K,X);return k(te)}}class v{constructor(z,Q){this._documents=z,this._provider=Q}async provideDeclaration(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideDeclaration(se,K,X);return k(te)}}class s{constructor(z,Q){this._documents=z,this._provider=Q}async provideImplementation(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideImplementation(se,K,X);return k(te)}}class i{constructor(z,Q){this._documents=z,this._provider=Q}async provideTypeDefinition(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideTypeDefinition(se,K,X);return k(te)}}class m{constructor(z,Q){this._documents=z,this._provider=Q}async provideHover(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideHover(se,K,X);if(!(!te||(0,P.isFalsyOrEmpty)(te.contents)))return te.range||(te.range=se.getWordRangeAtPosition(K)),te.range||(te.range=new I.Range(K,K)),E.Hover.from(te)}}class a{constructor(z,Q){this._documents=z,this._provider=Q}async provideEvaluatableExpression(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideEvaluatableExpression(se,K,X);if(te)return E.EvaluatableExpression.from(te)}}class g{constructor(z,Q){this._documents=z,this._provider=Q}async provideInlineValues(z,Q,X,se){const K=this._documents.getDocument(z),te=await this._provider.provideInlineValues(K,E.Range.to(Q),E.InlineValueContext.to(X),se);if(Array.isArray(te))return te.map(ce=>E.InlineValue.from(ce))}}class b{constructor(z,Q){this._documents=z,this._provider=Q}async provideDocumentHighlights(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideDocumentHighlights(se,K,X);if(Array.isArray(te))return te.map(E.DocumentHighlight.from)}}class h{constructor(z,Q){this._documents=z,this._provider=Q}async provideLinkedEditingRanges(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.provideLinkedEditingRanges(se,K,X);if(te&&Array.isArray(te.ranges))return{ranges:(0,P.coalesce)(te.ranges.map(E.Range.from)),wordPattern:te.wordPattern}}}class y{constructor(z,Q){this._documents=z,this._provider=Q}async provideReferences(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Position.to(Q),ce=await this._provider.provideReferences(K,te,X,se);if(Array.isArray(ce))return ce.map(E.location.from)}}class R{constructor(z,Q,X,se,K,te,ce){this._documents=z,this._commands=Q,this._diagnostics=X,this._provider=se,this._logService=K,this._extension=te,this._apiDeprecation=ce,this._cache=new c.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,Q,X,se){const K=this._documents.getDocument(z),te=_.Selection.isISelection(Q)?E.Selection.to(Q):E.Range.to(Q),ce=[];for(const st of this._diagnostics.getDiagnostics(z))if(te.intersection(st.range)&&ce.push(st)>R._maxCodeActionsPerFile)break;const Pe={diagnostics:ce,only:X.only?new I.CodeActionKind(X.only):void 0,triggerKind:E.CodeActionTriggerKind.to(X.trigger)},Oe=await this._provider.provideCodeActions(K,te,Pe,se);if(!(0,P.isNonEmptyArray)(Oe)||se.isCancellationRequested)return;const We=this._cache.add(Oe),qe=new n.DisposableStore;this._disposables.set(We,qe);const et=[];for(let st=0;st<Oe.length;st++){const _e=Oe[st];!_e||(R._isCommand(_e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this._commands.toInternal(_e,qe)})):(Pe.only&&(_e.kind?Pe.only.contains(_e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[We,st],title:_e.title,command:_e.command&&this._commands.toInternal(_e.command,qe),diagnostics:_e.diagnostics&&_e.diagnostics.map(E.Diagnostic.from),edit:_e.edit&&E.WorkspaceEdit.from(_e.edit),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})))}return{cacheId:We,actions:et}}async resolveCodeAction(z,Q){const[X,se]=z,K=this._cache.get(X,se);if(!K||R._isCommand(K)||!this._provider.resolveCodeAction)return;const te=await this._provider.resolveCodeAction(K,Q)??K;return te?.edit?E.WorkspaceEdit.from(te.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class A{constructor(z,Q){this._documents=z,this._provider=Q}async provideDocumentFormattingEdits(z,Q,X){const se=this._documents.getDocument(z),K=await this._provider.provideDocumentFormattingEdits(se,Q,X);if(Array.isArray(K))return K.map(E.TextEdit.from)}}class B{constructor(z,Q){this._documents=z,this._provider=Q}async provideDocumentRangeFormattingEdits(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Range.to(Q),ce=await this._provider.provideDocumentRangeFormattingEdits(K,te,X,se);if(Array.isArray(ce))return ce.map(E.TextEdit.from)}}class O{constructor(z,Q){this._documents=z,this._provider=Q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,Q,X,se,K){const te=this._documents.getDocument(z),ce=E.Position.to(Q),Pe=await this._provider.provideOnTypeFormattingEdits(te,ce,X,se,K);if(Array.isArray(Pe))return Pe.map(E.TextEdit.from)}}class S{constructor(z,Q){this._provider=z,this._logService=Q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,Q){const X=F.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(z,Q);if((0,P.isNonEmptyArray)(se))for(const K of se){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const te=F.IdObject.mixin(E.WorkspaceSymbol.from(K));this._symbolCache.set(te._id,K),X.symbols.push(te)}return X.symbols.length>0&&this._resultCache.set(X._id,[X.symbols[0]._id,X.symbols[X.symbols.length-1]._id]),X}async resolveWorkspaceSymbol(z,Q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const X=this._symbolCache.get(z._id);if(X){const se=await this._provider.resolveWorkspaceSymbol(X,Q);return se&&(0,M.mixin)(z,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(z){const Q=this._resultCache.get(z);if(Q){for(let[X,se]=Q;X<=se;X++)this._symbolCache.delete(X);this._resultCache.delete(z)}}}class x{constructor(z,Q,X){this._documents=z,this._provider=Q,this._logService=X}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Position.to(Q);try{const ce=await this._provider.provideRenameEdits(K,te,X,se);return ce?E.WorkspaceEdit.from(ce):void 0}catch(ce){const Pe=x._asMessage(ce);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(z,Q,X){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(z),K=E.Position.to(Q);try{const te=await this._provider.prepareRename(se,K,X);let ce,Pe;if(I.Range.isRange(te)?(ce=te,Pe=se.getText(te)):(0,t.isObject)(te)&&(ce=te.range,Pe=te.placeholder),!ce||!Pe)return;if(ce.start.line>K.line||ce.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(ce),text:Pe}}catch(te){const ce=x._asMessage(te);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(te)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class N{constructor(z,Q){this.resultId=z,this.tokens=Q}}class j{constructor(z,Q){this._documents=z,this._provider=Q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,Q,X){const se=this._documents.getDocument(z),K=Q!==0?this._previousResults.get(Q):null;let te=typeof K?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,K.resultId,X):await this._provider.provideDocumentSemanticTokens(se,X);return K&&this._previousResults.delete(Q),te?(te=j._fixProvidedSemanticTokens(te),this._send(j._convertToEdits(K,te),te)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return j._isSemanticTokens(z)?j._isCorrectSemanticTokens(z)?z:new I.SemanticTokens(new Uint32Array(z.data),z.resultId):j._isSemanticTokensEdits(z)?j._isCorrectSemanticTokensEdits(z)?z:new I.SemanticTokensEdits(z.edits.map(Q=>new I.SemanticTokensEdit(Q.start,Q.deleteCount,Q.data?new Uint32Array(Q.data):Q.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Q of z.edits)if(!(Q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Q){if(!j._isSemanticTokens(Q)||!z||!z.tokens)return Q;const X=z.tokens,se=X.length,K=Q.data,te=K.length;let ce=0;const Pe=Math.min(se,te);for(;ce<Pe&&X[ce]===K[ce];)ce++;if(ce===se&&ce===te)return new I.SemanticTokensEdits([],Q.resultId);let Oe=0;const We=Pe-ce;for(;Oe<We&&X[se-Oe-1]===K[te-Oe-1];)Oe++;return new I.SemanticTokensEdits([{start:ce,deleteCount:se-ce-Oe,data:K.subarray(ce,te-Oe)}],Q.resultId)}_send(z,Q){if(j._isSemanticTokens(z)){const X=this._nextResultId++;return this._previousResults.set(X,new N(z.resultId,z.data)),(0,d.encodeSemanticTokensDto)({id:X,type:"full",data:z.data})}if(j._isSemanticTokensEdits(z)){const X=this._nextResultId++;return j._isSemanticTokens(Q)?this._previousResults.set(X,new N(Q.resultId,Q.data)):this._previousResults.set(X,new N(z.resultId)),(0,d.encodeSemanticTokensDto)({id:X,type:"delta",deltas:(z.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=j;class W{constructor(z,Q){this._documents=z,this._provider=Q}async provideDocumentRangeSemanticTokens(z,Q,X){const se=this._documents.getDocument(z),K=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(Q),X);return K?this._send(K):null}_send(z){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=W;class ${constructor(z,Q,X,se,K){this._documents=z,this._commands=Q,this._provider=X,this._apiDeprecation=se,this._extension=K,this._cache=new c.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Position.to(Q),ce=K.getWordRangeAtPosition(te)||new I.Range(te,te),Pe=ce.with({end:te}),Oe=new p.StopWatch(!0),We=await this._provider.provideCompletionItems(K,te,se,E.CompletionContext.to(X));if(!We||se.isCancellationRequested)return;const qe=Array.isArray(We)?new I.CompletionList(We):We,et=$.supportsResolving(this._provider)?this._cache.add(qe.items):this._cache.add([]),st=new n.DisposableStore;this._disposables.set(et,st);const _e=[],nt={x:et,b:_e,a:{replace:E.Range.from(ce),insert:E.Range.from(Pe)},c:qe.isIncomplete||void 0,d:Oe.elapsed()};for(let G=0;G<qe.items.length;G++){const J=qe.items[G],ge=this._convertCompletionItem(J,[et,G],Pe,ce);_e.push(ge)}return nt}async resolveCompletionItem(z,Q){if(typeof this._provider.resolveCompletionItem!="function")return;const X=this._cache.get(...z);if(!X)return;const se=await this._provider.resolveCompletionItem(X,Q);if(!!se)return this._convertCompletionItem(se,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Q,X,se){const K=this._disposables.get(Q[0]);if(!K)throw Error("DisposableStore is missing...");const te={x:Q,a:z.label,b:z.kind!==void 0?E.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(E.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(z.command,K)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),te.h=z.textEdit.newText):typeof z.insertText=="string"?te.h=z.insertText:z.insertText instanceof I.SnippetString&&(te.h=z.insertText.value,te.i|=4);let ce;return z.textEdit?ce=z.textEdit.range:z.range&&(ce=z.range),I.Range.isRange(ce)?te.j=E.Range.from(ce):ce&&(!X?.isEqual(ce.inserting)||!se?.isEqual(ce.replacing))&&(te.j={insert:E.Range.from(ce.inserting),replace:E.Range.from(ce.replacing)}),te}}class V{constructor(z,Q,X){this._documents=z,this._provider=Q,this._commands=X,this._cache=new c.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Position.to(Q),ce=await this._provider.provideInlineCompletionItems(K,te,{selectedCompletionInfo:X.selectedSuggestionInfo?{range:E.Range.to(X.selectedSuggestionInfo.range),text:X.selectedSuggestionInfo.text}:void 0,triggerKind:X.triggerKind},se);if(!ce||se.isCancellationRequested)return;const Pe=(0,t.isArray)(ce)?{items:ce}:ce,Oe=this._cache.add(Pe.items);let We;return{pid:Oe,items:Pe.items.map((qe,et)=>{let st;return qe.command&&(We||(We=new n.DisposableStore,this._disposables.set(Oe,We)),st=this._commands.toInternal(qe.command,We)),{text:qe.text,range:qe.range?E.Range.from(qe.range):void 0,command:st,idx:et}})}}disposeCompletions(z){this._cache.delete(z);const Q=this._disposables.get(z);Q&&Q.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,Q){const X=this._cache.get(z,Q);X&&q.get(this._provider).fireOnDidShowCompletionItem({completionItem:X})}}class q{constructor(){this._onDidShowCompletionItemEmitter=new w.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let Q=q.map.get(z);return Q||(Q=new q,q.map.set(z,Q)),Q}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=q,q.map=new WeakMap;class re{constructor(z,Q){this._documents=z,this._provider=Q,this._cache=new c.Cache("SignatureHelp")}async provideSignatureHelp(z,Q,X,se){const K=this._documents.getDocument(z),te=E.Position.to(Q),ce=this.reviveContext(X),Pe=await this._provider.provideSignatureHelp(K,te,se,ce);if(Pe){const Oe=this._cache.add([Pe]);return{...E.SignatureHelp.from(Pe),id:Oe}}}reviveContext(z){let Q;if(z.activeSignatureHelp){const X=E.SignatureHelp.to(z.activeSignatureHelp),se=this._cache.get(z.activeSignatureHelp.id,0);se?(Q=se,Q.activeSignature=X.activeSignature,Q.activeParameter=X.activeParameter):Q=X}return{...z,activeSignatureHelp:Q}}releaseSignatureHelp(z){this._cache.delete(z)}}class ae{constructor(z,Q){this._documents=z,this._provider=Q}async provideInlayHints(z,Q,X){const se=this._documents.getDocument(z),K=await this._provider.provideInlayHints(se,E.Range.to(Q),X);return K?{hints:K.map(E.InlayHint.from)}:void 0}}class pe{constructor(z,Q){this._documents=z,this._provider=Q,this._cache=new c.Cache("DocumentLink")}async provideLinks(z,Q){const X=this._documents.getDocument(z),se=await this._provider.provideDocumentLinks(X,Q);if(!(!Array.isArray(se)||se.length===0)&&!Q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(pe._validateLink).map(E.DocumentLink.from)};{const K=this._cache.add(se),te={links:[],id:K};for(let ce=0;ce<se.length;ce++){if(!pe._validateLink(se[ce]))continue;const Pe=E.DocumentLink.from(se[ce]);Pe.cacheId=[K,ce],te.links.push(Pe)}return te}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,Q){if(typeof this._provider.resolveDocumentLink!="function")return;const X=this._cache.get(...z);if(!X)return;const se=await this._provider.resolveDocumentLink(X,Q);if(!(!se||!pe._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(z){this._cache.delete(z)}}class me{constructor(z,Q){this._documents=z,this._provider=Q}async provideColors(z,Q){const X=this._documents.getDocument(z),se=await this._provider.provideDocumentColors(X,Q);return Array.isArray(se)?se.map(te=>({color:E.Color.from(te.color),range:E.Range.from(te.range)})):[]}async provideColorPresentations(z,Q,X){const se=this._documents.getDocument(z),K=E.Range.to(Q.range),te=E.Color.to(Q.color),ce=await this._provider.provideColorPresentations(te,{document:se,range:K},X);if(!!Array.isArray(ce))return ce.map(E.ColorPresentation.from)}}class Fe{constructor(z,Q){this._documents=z,this._provider=Q}async provideFoldingRanges(z,Q,X){const se=this._documents.getDocument(z),K=await this._provider.provideFoldingRanges(se,Q,X);if(!!Array.isArray(K))return K.map(E.FoldingRange.from)}}class Ye{constructor(z,Q,X){this._documents=z,this._provider=Q,this._logService=X}async provideSelectionRanges(z,Q,X){const se=this._documents.getDocument(z),K=Q.map(E.Position.to),te=await this._provider.provideSelectionRanges(se,K,X);if(!(0,P.isNonEmptyArray)(te))return[];if(te.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let Pe=0;Pe<K.length;Pe++){const Oe=[];ce.push(Oe);let We=K[Pe],qe=te[Pe];for(;;){if(!qe.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Oe.push(E.SelectionRange.from(qe)),!qe.parent)break;We=qe.range,qe=qe.parent}}return ce}}class Ue{constructor(z,Q){this._documents=z,this._provider=Q,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.prepareCallHierarchy(se,K,X);if(!te)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(ce,Pe)):[this._cacheAndConvertItem(ce,te)]}async provideCallsTo(z,Q,X){const se=this._itemFromCache(z,Q);if(!se)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(se,X);if(!!K)return K.map(te=>({from:this._cacheAndConvertItem(z,te.from),fromRanges:te.fromRanges.map(ce=>E.Range.from(ce))}))}async provideCallsFrom(z,Q,X){const se=this._itemFromCache(z,Q);if(!se)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(se,X);if(!!K)return K.map(te=>({to:this._cacheAndConvertItem(z,te.to),fromRanges:te.fromRanges.map(ce=>E.Range.from(ce))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Q){const X=this._cache.get(z),se=E.CallHierarchyItem.from(Q,z,X.size.toString(36));return X.set(se._itemId,Q),se}_itemFromCache(z,Q){return this._cache.get(z)?.get(Q)}}class Ve{constructor(z,Q){this._documents=z,this._provider=Q,this._idPool=new l.IdGenerator(""),this._cache=new Map}async prepareSession(z,Q,X){const se=this._documents.getDocument(z),K=E.Position.to(Q),te=await this._provider.prepareTypeHierarchy(se,K,X);if(!te)return;const ce=this._idPool.nextId();return this._cache.set(ce,new Map),Array.isArray(te)?te.map(Pe=>this._cacheAndConvertItem(ce,Pe)):[this._cacheAndConvertItem(ce,te)]}async provideSupertypes(z,Q,X){const se=this._itemFromCache(z,Q);if(!se)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySupertypes(se,X);if(!!K)return K.map(te=>this._cacheAndConvertItem(z,te))}async provideSubtypes(z,Q,X){const se=this._itemFromCache(z,Q);if(!se)throw new Error("missing type hierarchy item");const K=await this._provider.provideTypeHierarchySubtypes(se,X);if(!!K)return K.map(te=>this._cacheAndConvertItem(z,te))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Q){const X=this._cache.get(z),se=E.TypeHierarchyItem.from(Q,z,X.size.toString(36));return X.set(se._itemId,Q),se}_itemFromCache(z,Q){return this._cache.get(z)?.get(Q)}}class Je{constructor(z,Q){this.adapter=z,this.extension=Q}}class je{constructor(z,Q,X,se,K,te,ce){this._adapter=new Map,this._uriTransformer=Q,this._proxy=z.getProxy(F.MainContext.MainThreadLanguageFeatures),this._documents=X,this._commands=se,this._diagnostics=K,this._logService=te,this._apiDeprecation=ce}_transformDocumentSelector(z){return E.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new I.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return je._handlePool++}_withAdapter(z,Q,X,se,K=!1){const te=this._adapter.get(z);if(!te)return Promise.resolve(se);if(te.adapter instanceof Q){let ce;te.extension&&(ce=Date.now(),this._logService.trace(`[${te.extension.identifier.value}] INVOKE provider '${Q.name}'`));const Pe=X(te.adapter,te.extension),Oe=te.extension;return Oe&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Oe.identifier.value}] provider DONE after ${Date.now()-ce}ms`),We=>{K&&We instanceof D.CancellationError||(this._logService.error(`[${Oe.identifier.value}] provider FAILED`),this._logService.error(We))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Q){const X=this._nextHandle();return this._adapter.set(X,new Je(z,Q)),X}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Q,X,se){const K=this._addNewAdapter(new o(this._documents,X),z),te=se&&se.label||je._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(Q),te),this._createDisposable(K)}$provideDocumentSymbols(z,Q,X){return this._withAdapter(z,o,se=>se.provideDocumentSymbols(u.URI.revive(Q),X),void 0)}registerCodeLensProvider(z,Q,X){const se=this._nextHandle(),K=typeof X.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new f(this._documents,this._commands.converter,X),z)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(Q),K);let te=this._createDisposable(se);if(K!==void 0){const ce=X.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(K));te=I.Disposable.from(te,ce)}return te}$provideCodeLenses(z,Q,X){return this._withAdapter(z,f,se=>se.provideCodeLenses(u.URI.revive(Q),X),void 0)}$resolveCodeLens(z,Q,X){return this._withAdapter(z,f,se=>se.resolveCodeLens(Q,X),void 0)}$releaseCodeLenses(z,Q){this._withAdapter(z,f,X=>Promise.resolve(X.releaseCodeLenses(Q)),void 0)}registerDefinitionProvider(z,Q,X){const se=this._addNewAdapter(new r(this._documents,X),z);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDefinition(z,Q,X,se){return this._withAdapter(z,r,K=>K.provideDefinition(u.URI.revive(Q),X,se),[])}registerDeclarationProvider(z,Q,X){const se=this._addNewAdapter(new v(this._documents,X),z);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDeclaration(z,Q,X,se){return this._withAdapter(z,v,K=>K.provideDeclaration(u.URI.revive(Q),X,se),[])}registerImplementationProvider(z,Q,X){const se=this._addNewAdapter(new s(this._documents,X),z);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideImplementation(z,Q,X,se){return this._withAdapter(z,s,K=>K.provideImplementation(u.URI.revive(Q),X,se),[])}registerTypeDefinitionProvider(z,Q,X){const se=this._addNewAdapter(new i(this._documents,X),z);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideTypeDefinition(z,Q,X,se){return this._withAdapter(z,i,K=>K.provideTypeDefinition(u.URI.revive(Q),X,se),[])}registerHoverProvider(z,Q,X,se){const K=this._addNewAdapter(new m(this._documents,X),z);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideHover(z,Q,X,se){return this._withAdapter(z,m,K=>K.provideHover(u.URI.revive(Q),X,se),void 0)}registerEvaluatableExpressionProvider(z,Q,X,se){const K=this._addNewAdapter(new a(this._documents,X),z);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(Q)),this._createDisposable(K)}$provideEvaluatableExpression(z,Q,X,se){return this._withAdapter(z,a,K=>K.provideEvaluatableExpression(u.URI.revive(Q),X,se),void 0)}registerInlineValuesProvider(z,Q,X,se){const K=typeof X.onDidChangeInlineValues=="function"?this._nextHandle():void 0,te=this._addNewAdapter(new g(this._documents,X),z);this._proxy.$registerInlineValuesProvider(te,this._transformDocumentSelector(Q),K);let ce=this._createDisposable(te);if(K!==void 0){const Pe=X.onDidChangeInlineValues(Oe=>this._proxy.$emitInlineValuesEvent(K));ce=I.Disposable.from(ce,Pe)}return ce}$provideInlineValues(z,Q,X,se,K){return this._withAdapter(z,g,te=>te.provideInlineValues(u.URI.revive(Q),X,se,K),void 0)}registerDocumentHighlightProvider(z,Q,X){const se=this._addNewAdapter(new b(this._documents,X),z);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDocumentHighlights(z,Q,X,se){return this._withAdapter(z,b,K=>K.provideDocumentHighlights(u.URI.revive(Q),X,se),void 0)}registerLinkedEditingRangeProvider(z,Q,X){const se=this._addNewAdapter(new h(this._documents,X),z);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideLinkedEditingRanges(z,Q,X,se){return this._withAdapter(z,h,async K=>{const te=await K.provideLinkedEditingRanges(u.URI.revive(Q),X,se);if(te)return{ranges:te.ranges,wordPattern:te.wordPattern?je._serializeRegExp(te.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Q,X){const se=this._addNewAdapter(new y(this._documents,X),z);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideReferences(z,Q,X,se,K){return this._withAdapter(z,y,te=>te.provideReferences(u.URI.revive(Q),X,se,K),void 0)}registerCodeActionProvider(z,Q,X,se){const K=new n.DisposableStore,te=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,X,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(te,this._transformDocumentSelector(Q),{providedKinds:se?.providedCodeActionKinds?.map(ce=>ce.value),documentation:se?.documentation?.map(ce=>({kind:ce.kind.value,command:this._commands.converter.toInternal(ce.command,K)}))},je._extLabel(z),Boolean(X.resolveCodeAction)),K.add(this._createDisposable(te)),K}$provideCodeActions(z,Q,X,se,K){return this._withAdapter(z,R,te=>te.provideCodeActions(u.URI.revive(Q),X,se,K),void 0)}$resolveCodeAction(z,Q,X){return this._withAdapter(z,R,se=>se.resolveCodeAction(Q,X),void 0)}$releaseCodeActions(z,Q){this._withAdapter(z,R,X=>Promise.resolve(X.releaseCodeActions(Q)),void 0)}registerDocumentFormattingEditProvider(z,Q,X){const se=this._addNewAdapter(new A(this._documents,X),z);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(Q),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentFormattingEdits(z,Q,X,se){return this._withAdapter(z,A,K=>K.provideDocumentFormattingEdits(u.URI.revive(Q),X,se),void 0)}registerDocumentRangeFormattingEditProvider(z,Q,X){const se=this._addNewAdapter(new B(this._documents,X),z);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(Q),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(z,Q,X,se,K){return this._withAdapter(z,B,te=>te.provideDocumentRangeFormattingEdits(u.URI.revive(Q),X,se,K),void 0)}registerOnTypeFormattingEditProvider(z,Q,X,se){const K=this._addNewAdapter(new O(this._documents,X),z);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(Q),se,z.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits(z,Q,X,se,K,te){return this._withAdapter(z,O,ce=>ce.provideOnTypeFormattingEdits(u.URI.revive(Q),X,se,K,te),void 0)}registerWorkspaceSymbolProvider(z,Q){const X=this._addNewAdapter(new S(Q,this._logService),z);return this._proxy.$registerNavigateTypeSupport(X),this._createDisposable(X)}$provideWorkspaceSymbols(z,Q,X){return this._withAdapter(z,S,se=>se.provideWorkspaceSymbols(Q,X),{symbols:[]})}$resolveWorkspaceSymbol(z,Q,X){return this._withAdapter(z,S,se=>se.resolveWorkspaceSymbol(Q,X),void 0)}$releaseWorkspaceSymbols(z,Q){this._withAdapter(z,S,X=>X.releaseWorkspaceSymbols(Q),void 0)}registerRenameProvider(z,Q,X){const se=this._addNewAdapter(new x(this._documents,X,this._logService),z);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(Q),x.supportsResolving(X)),this._createDisposable(se)}$provideRenameEdits(z,Q,X,se,K){return this._withAdapter(z,x,te=>te.provideRenameEdits(u.URI.revive(Q),X,se,K),void 0)}$resolveRenameLocation(z,Q,X,se){return this._withAdapter(z,x,K=>K.resolveRenameLocation(u.URI.revive(Q),X,se),void 0)}registerDocumentSemanticTokensProvider(z,Q,X,se){const K=this._nextHandle(),te=typeof X.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Je(new j(this._documents,X),z)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(Q),se,te);let ce=this._createDisposable(K);if(te){const Pe=X.onDidChangeSemanticTokens(Oe=>this._proxy.$emitDocumentSemanticTokensEvent(te));ce=I.Disposable.from(ce,Pe)}return ce}$provideDocumentSemanticTokens(z,Q,X,se){return this._withAdapter(z,j,K=>K.provideDocumentSemanticTokens(u.URI.revive(Q),X,se),null,!0)}$releaseDocumentSemanticTokens(z,Q){this._withAdapter(z,j,X=>X.releaseDocumentSemanticColoring(Q),void 0)}registerDocumentRangeSemanticTokensProvider(z,Q,X,se){const K=this._addNewAdapter(new W(this._documents,X),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(Q),se),this._createDisposable(K)}$provideDocumentRangeSemanticTokens(z,Q,X,se){return this._withAdapter(z,W,K=>K.provideDocumentRangeSemanticTokens(u.URI.revive(Q),X,se),null,!0)}registerCompletionItemProvider(z,Q,X,se){const K=this._addNewAdapter(new $(this._documents,this._commands.converter,X,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(Q),se,$.supportsResolving(X),`${z.identifier.value}(${se.join("")})`),this._createDisposable(K)}$provideCompletionItems(z,Q,X,se,K){return this._withAdapter(z,$,te=>te.provideCompletionItems(u.URI.revive(Q),X,se,K),void 0)}$resolveCompletionItem(z,Q,X){return this._withAdapter(z,$,se=>se.resolveCompletionItem(Q,X),void 0)}$releaseCompletionItems(z,Q){this._withAdapter(z,$,X=>X.releaseCompletionItems(Q),void 0)}registerInlineCompletionsProvider(z,Q,X){const se=this._addNewAdapter(new V(this._documents,X,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideInlineCompletions(z,Q,X,se,K){return this._withAdapter(z,V,te=>te.provideInlineCompletions(u.URI.revive(Q),X,se,K),void 0)}$handleInlineCompletionDidShow(z,Q,X){this._withAdapter(z,V,async se=>{se.handleDidShowCompletionItem(Q,X)},void 0)}$freeInlineCompletionsList(z,Q){this._withAdapter(z,V,async X=>{X.disposeCompletions(Q)},void 0)}registerSignatureHelpProvider(z,Q,X,se){const K=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,te=this._addNewAdapter(new re(this._documents,X),z);return this._proxy.$registerSignatureHelpProvider(te,this._transformDocumentSelector(Q),K),this._createDisposable(te)}$provideSignatureHelp(z,Q,X,se,K){return this._withAdapter(z,re,te=>te.provideSignatureHelp(u.URI.revive(Q),X,se,K),void 0)}$releaseSignatureHelp(z,Q){this._withAdapter(z,re,X=>X.releaseSignatureHelp(Q),void 0)}registerInlayHintsProvider(z,Q,X){const se=typeof X.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new ae(this._documents,X),z);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(Q),se);let te=this._createDisposable(K);if(se!==void 0){const ce=X.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(se));te=I.Disposable.from(te,ce)}return te}$provideInlayHints(z,Q,X,se){return this._withAdapter(z,ae,K=>K.provideInlayHints(u.URI.revive(Q),X,se),void 0)}registerDocumentLinkProvider(z,Q,X){const se=this._addNewAdapter(new pe(this._documents,X),z);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(Q),typeof X.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(z,Q,X){return this._withAdapter(z,pe,se=>se.provideLinks(u.URI.revive(Q),X),void 0)}$resolveDocumentLink(z,Q,X){return this._withAdapter(z,pe,se=>se.resolveLink(Q,X),void 0)}$releaseDocumentLinks(z,Q){this._withAdapter(z,pe,X=>X.releaseLinks(Q),void 0)}registerColorProvider(z,Q,X){const se=this._addNewAdapter(new me(this._documents,X),z);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideDocumentColors(z,Q,X){return this._withAdapter(z,me,se=>se.provideColors(u.URI.revive(Q),X),[])}$provideColorPresentations(z,Q,X,se){return this._withAdapter(z,me,K=>K.provideColorPresentations(u.URI.revive(Q),X,se),void 0)}registerFoldingRangeProvider(z,Q,X){const se=this._nextHandle(),K=typeof X.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Je(new Fe(this._documents,X),z)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(Q),K);let te=this._createDisposable(se);if(K!==void 0){const ce=X.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));te=I.Disposable.from(te,ce)}return te}$provideFoldingRanges(z,Q,X,se){return this._withAdapter(z,Fe,K=>K.provideFoldingRanges(u.URI.revive(Q),X,se),void 0)}registerSelectionRangeProvider(z,Q,X){const se=this._addNewAdapter(new Ye(this._documents,X,this._logService),z);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$provideSelectionRanges(z,Q,X,se){return this._withAdapter(z,Ye,K=>K.provideSelectionRanges(u.URI.revive(Q),X,se),[])}registerCallHierarchyProvider(z,Q,X){const se=this._addNewAdapter(new Ue(this._documents,X),z);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$prepareCallHierarchy(z,Q,X,se){return this._withAdapter(z,Ue,K=>Promise.resolve(K.prepareSession(u.URI.revive(Q),X,se)),void 0)}$provideCallHierarchyIncomingCalls(z,Q,X,se){return this._withAdapter(z,Ue,K=>K.provideCallsTo(Q,X,se),void 0)}$provideCallHierarchyOutgoingCalls(z,Q,X,se){return this._withAdapter(z,Ue,K=>K.provideCallsFrom(Q,X,se),void 0)}$releaseCallHierarchy(z,Q){this._withAdapter(z,Ue,X=>Promise.resolve(X.releaseSession(Q)),void 0)}registerTypeHierarchyProvider(z,Q,X){const se=this._addNewAdapter(new Ve(this._documents,X),z);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(Q)),this._createDisposable(se)}$prepareTypeHierarchy(z,Q,X,se){return this._withAdapter(z,Ve,K=>Promise.resolve(K.prepareSession(u.URI.revive(Q),X,se)),void 0)}$provideTypeHierarchySupertypes(z,Q,X,se){return this._withAdapter(z,Ve,K=>K.provideSupertypes(Q,X,se),void 0)}$provideTypeHierarchySubtypes(z,Q,X,se){return this._withAdapter(z,Ve,K=>K.provideSubtypes(Q,X,se),void 0)}$releaseTypeHierarchy(z,Q){this._withAdapter(z,Ve,X=>Promise.resolve(X.releaseSession(Q)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,T.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:je._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:je._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?je._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?je._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:je._serializeRegExp(z.beforeText),afterText:z.afterText?je._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?je._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(je._serializeOnEnterRule)}setLanguageConfiguration(z,Q,X){let{wordPattern:se}=X;if(se&&(0,T.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(Q,se):this._documents.setWordDefinitionFor(Q,void 0),X.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),X.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const K=this._nextHandle(),te={comments:X.comments,brackets:X.brackets,wordPattern:X.wordPattern?je._serializeRegExp(X.wordPattern):void 0,indentationRules:X.indentationRules?je._serializeIndentationRule(X.indentationRules):void 0,onEnterRules:X.onEnterRules?je._serializeOnEnterRules(X.onEnterRules):void 0,__electricCharacterSupport:X.__electricCharacterSupport,__characterPairSupport:X.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,Q,te),this._createDisposable(K)}$setWordDefinitions(z){for(const Q of z)this._documents.setWordDefinitionFor(Q.languageId,new RegExp(Q.regexSource,Q.regexFlags))}}e.ExtHostLanguageFeatures=je,je._handlePool=0}),define(we[199],be([0,1,5,8,7,35,13,6]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class C{constructor(t,_,n,d){this._documents=_,this._commands=n,this._uriTransformer=d,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=t.getProxy(u.MainContext.MainThreadLanguages)}$acceptLanguageIds(t){this._languageIds=t}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(t,_){await this._proxy.$changeLanguage(t,_);const n=this._documents.getDocumentData(t);if(!n)throw new Error(`document '${t.toString}' NOT found`);return n.document}async tokenAtPosition(t,_){const n=t.version,d=M.Position.from(_),l=await this._proxy.$tokensAtPosition(t.uri,d),c={type:E.StandardTokenType.Other,range:t.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!l)return c;const p={range:M.Range.to(l.range),type:M.TokenType.to(l.type)};return!p.range.contains(_)||n!==t.version?c:p}createLanguageStatusItem(t,_,n){const d=this._handlePool++,l=this._proxy,c=this._ids,p=`${t.identifier.value}/${_}`;if(c.has(p))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);c.add(p);const D={selector:n,id:_,name:t.displayName??t.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let w,o=new T.DisposableStore;const f=()=>{w?.dispose(),w=(0,F.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(d,{id:p,name:D.name??t.displayName??t.name,source:t.displayName??t.name,selector:M.DocumentSelector.from(D.selector,this._uriTransformer),label:D.text,detail:D.detail??"",severity:D.severity===E.LanguageStatusSeverity.Error?I.default.Error:D.severity===E.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:D.command&&this._commands.toInternal(D.command,o),accessibilityInfo:D.accessibilityInformation})},0)},k={dispose(){o.dispose(),w?.dispose(),l.$removeLanguageStatus(d),c.delete(p)},get id(){return D.id},get name(){return D.name},set name(r){D.name=r,f()},get selector(){return D.selector},set selector(r){D.selector=r,f()},get text(){return D.text},set text(r){D.text=r,f()},get detail(){return D.detail},set detail(r){D.detail=r,f()},get severity(){return D.severity},set severity(r){D.severity=r,f()},get accessibilityInformation(){return D.accessibilityInformation},set accessibilityInformation(r){D.accessibilityInformation=r,f()},get command(){return D.command},set command(r){D.command=r,f()}};return f(),k}}e.ExtHostLanguages=C}),define(we[200],be([0,1,12,5,27,14,3]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends u.AbstractLoggerService{constructor(t,_){const n=new F.Emitter;super(_.logLevel,n.event);this._proxy=t.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(t){this._onDidChangeLogLevel.fire(t)}doCreateLogger(t,_,n){return new C(this._proxy,t,_,n)}};T=xe([Be(0,I.IExtHostRpcService),Be(1,E.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class C extends u.AbstractMessageLogger{constructor(t,_,n,d){super(d?.always);this.proxy=t,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,d).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(t,_){const n=[[t,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(t){this.proxy.$log(this.file,t)}}}),define(we[201],be([0,1,5,22,12]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function I(T){return T&&T.title}let F=class{constructor(C,P){this._logService=P,this._proxy=C.getProxy(u.MainContext.MainThreadMessageService)}showMessage(C,P,t,_,n){const d={extension:C};let l;typeof _=="string"||I(_)?l=[_,...n]:(d.modal=_?.modal,d.useCustom=_?.useCustom,d.detail=_?.detail,l=n),d.useCustom&&(0,M.checkProposedApiEnabled)(C);const c=[];for(let p=0;p<l.length;p++){const D=l[p];if(typeof D=="string")c.push({title:D,handle:p,isCloseAffordance:!1});else if(typeof D=="object"){let{title:w,isCloseAffordance:o}=D;c.push({title:w,isCloseAffordance:!!o,handle:p})}else this._logService.warn("Invalid message item:",D)}return this._proxy.$showMessage(P,t,d,c).then(p=>{if(typeof p=="number")return l[p]})}};F=xe([Be(1,E.ILogService)],F),e.ExtHostMessageService=F}),define(we[202],be([0,1,23,3,59,6,20,9,10,2,64,5,8,7,38,176,92]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class D{constructor(o,f,k,r,v){this._textDocumentsAndEditors=k,this._textDocuments=r,this._extensionStoragePaths=v,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new F.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=f.converter,f.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===12){const i=s.notebookEditor?.notebookUri,m=s.cell.handle,g=this._documents.get(i)?.getCell(m);if(g)return g.apiCell}return s}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const f=this._editors.get(o);if(!f)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return f}getIdByEditor(o){for(const[f,k]of this._editors)if(k.apiEditor===o)return f}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,f){const k=this._documents.get(o);if(!k&&!f)throw new Error(`NO notebook document for '${o}'`);return k}_getProviderData(o){const f=this._notebookContentProviders.get(o);if(!f)throw new Error(`NO provider for '${o}'`);return f}registerNotebookContentProvider(o,f,k,r,v){if((0,T.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(f))throw new Error(`Notebook provider for '${f}' already registered`);this._notebookContentProviders.set(f,{extension:o,provider:k});let s;return k.onDidChangeNotebookContentOptions&&(s=k.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(k.options);this._notebookProxy.$updateNotebookProviderOptions(f,i)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(r),D._convertNotebookRegistrationData(o,v)),new d.Disposable(()=>{s?.dispose(),this._notebookContentProviders.delete(f),this._notebookProxy.$unregisterNotebookProvider(f)})}static _convertNotebookRegistrationData(o,f){if(!f)return;const k=f.filenamePattern.map(r=>n.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(f.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${f.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:f.displayName,filenamePattern:k,exclusive:f.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,f,k){const r=D._notebookStatusBarItemProviderHandlePool++,v=typeof k.onDidChangeCellStatusBarItems=="function"?D._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,k),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,v,f);let s;return v!==void 0&&(s=k.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(v))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,v),s&&s.dispose()})}async createNotebookDocument(o){const f=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&n.NotebookData.from(o.content)});return P.URI.revive(f)}async openNotebookDocument(o){const f=this._documents.get(o);if(f)return f.apiNotebook;const k=await this._notebookDocumentsProxy.$tryOpenNotebook(o),r=this._documents.get(P.URI.revive(k));return(0,C.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(o,f){P.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let k;typeof f=="object"?k={position:n.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus,selections:f.selections&&f.selections.map(n.NotebookRange.from),pinned:typeof f.preview=="boolean"?!f.preview:void 0}:k={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,k),v=r&&this._editors.get(r)?.apiEditor;if(v)return v;throw r?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,f,k,r){const v=this._notebookStatusBarItemProviders.get(o),s=P.URI.revive(f),i=this._documents.get(s);if(!i||!v)return;const m=i.getCellFromIndex(k);if(!m)return;const a=await v.provideCellStatusBarItems(m.apiCell,r);if(!a)return;const g=new I.DisposableStore,b=this._statusBarCache.add([g]),y=(Array.isArray(a)?a:[a]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,g));return{cacheId:b,items:y}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,f,k,r,v){if((0,T.isFalsyOrWhitespace)(f))throw new Error("viewType cannot be empty or just whitespace");const s=this._handlePool++;return this._notebookSerializer.set(s,k),this._notebookProxy.$registerNotebookSerializer(s,{id:o.identifier,location:o.extensionLocation},f,n.NotebookDocumentContentOptions.from(r),D._convertNotebookRegistrationData(o,v)),(0,I.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(s)})}async $dataToNotebook(o,f,k){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const v=await r.deserializeNotebook(f.buffer,k);return new l.SerializableObjectWithBuffers(n.NotebookData.from(v))}async $notebookToData(o,f,k){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const v=await r.serializeNotebook(n.NotebookData.to(f.value),k);return u.VSBuffer.wrap(v)}async $openNotebook(o,f,k,r,v){const{provider:s}=this._getProviderData(o),i=await s.openNotebook(P.URI.revive(f),{backupId:k,untitledDocumentData:r?.buffer},v);return new l.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(o,f,k){const r=this.getNotebookDocument(P.URI.revive(f)),{provider:v}=this._getProviderData(o);return await v.saveNotebook(r.apiNotebook,k),!0}async $saveNotebookAs(o,f,k,r){const v=this.getNotebookDocument(P.URI.revive(f)),{provider:s}=this._getProviderData(o);return await s.saveNotebookAs(P.URI.revive(k),v.apiNotebook,r),!0}async $backupNotebook(o,f,k){const r=this.getNotebookDocument(P.URI.revive(f)),v=this._getProviderData(o),s=this._extensionStoragePaths.workspaceValue(v.extension)??this._extensionStoragePaths.globalValue(v.extension),i=String((0,E.hash)([r.uri.toString(),this._backupIdPool++])),m=P.URI.joinPath(s,i),a=await v.provider.backupNotebook(r.apiNotebook,{destination:m},k);return r.updateBackup(a),a.id}_createExtHostEditor(o,f,k){if(this._editors.has(f))throw new Error(`editor with id ALREADY EXSIST: ${f}`);const r=new p.ExtHostNotebookEditor(f,this._notebookEditorsProxy,o,k.visibleRanges.map(n.NotebookRange.to),k.selections.map(n.NotebookRange.to),typeof k.viewColumn=="number"?n.ViewColumn.to(k.viewColumn):void 0);this._editors.set(f,r)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const k of o.value.removedDocuments){const r=P.URI.revive(k),v=this._documents.get(r);v&&(v.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(s=>s.document.uri)}),this._onDidCloseNotebookDocument.fire(v.apiNotebook));for(const s of this._editors.values())s.notebookData.uri.toString()===r.toString()&&this._editors.delete(s.id)}if(o.value.addedDocuments){const k=[];for(const r of o.value.addedDocuments){const v=P.URI.revive(r.uri);if(this._documents.has(v))throw new Error(`adding EXISTING notebook ${v} `);const s=this,i=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){s._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){s._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){s._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){s._onDidChangeCellExecutionState.fire(m)}},v,r);k.push(...r.cells.map(m=>c.ExtHostCell.asModelAddData(i.apiNotebook,m))),this._documents.get(v)?.dispose(),this._documents.set(v,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(o.value.addedEditors)for(const k of o.value.addedEditors){if(this._editors.has(k.id))return;const r=P.URI.revive(k.documentUri),v=this._documents.get(r);v&&this._createExtHostEditor(v,k.id,k)}const f=[];if(o.value.removedEditors)for(const k of o.value.removedEditors){const r=this._editors.get(k);r&&(this._editors.delete(k),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),f.push(r))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const k=new Set;this._visibleNotebookEditors.forEach(r=>k.add(r.id));for(const r of this._editors.values()){const v=k.has(r.id);r._acceptVisibility(v)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=D,D._notebookStatusBarItemProviderHandlePool=0}),define(we[203],be([0,1,3,55,12,5,14,8]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class C{constructor(_,n){const d=C._Keys.nextId();_.$registerNotebookEditorDecorationType(d,T.NotebookDecorationRenderOptions.from(n)),this.value={key:d,dispose(){_.$removeNotebookEditorDecorationType(d)}}}}C._Keys=new M.IdGenerator("NotebookEditorDecorationType");let P=class{constructor(_,n,d){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new u.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new u.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new C(this._extHostRpc.getProxy(I.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const d=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&d._acceptVisibleRanges(n.visibleRanges.ranges.map(T.NotebookRange.to)),n.selections&&d._acceptSelections(n.selections.selections.map(T.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(T.ViewColumn.to(_[n]))}};P=xe([Be(0,E.ILogService),Be(1,F.IExtHostRpcService)],P),e.ExtHostNotebookEditors=P}),define(we[204],be([0,1,15,13,21,3,6,20,2,22,12,5,39,8,7,67,168,38]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(v,s,i,m,a){this._initData=s,this._extHostNotebook=i,this._commands=m,this._logService=a,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=v.getProxy(_.MainContext.MainThreadNotebookKernels);const g=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",b=>!0,b=>{if(b&&"notebookEditor"in b&&"id"in b){const h=this._extHostNotebook.getIdByEditor(b.notebookEditor);return{id:b.id,extension:b.extension,notebookEditorId:h}}else if(b&&"notebookEditor"in b){const h=this._extHostNotebook.getIdByEditor(b.notebookEditor);if(h===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${b.notebookEditor.document.uri.toString()}`);return{notebookEditorId:h}}return b})],n.ApiCommandResult.Void);this._commands.registerApiCommand(g)}createNotebookController(v,s,i,m,a,g){for(let q of this._kernelData.values())if(q.controller.id===s&&P.ExtensionIdentifier.equals(v.identifier,q.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const b=this._handlePool++,h=this;this._logService.trace(`NotebookController[${b}], CREATED by ${v.identifier.value}, ${s}`);const y=()=>console.warn(`NO execute handler from notebook controller '${S.id}' of extension: '${v.identifier}'`);let R=!1;const A=new F.DisposableStore,B=new I.Emitter,O=new I.Emitter,S={id:`${v.identifier.value}/${s}`,notebookType:i,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:m||v.identifier.value,preloads:g?g.map(d.NotebookRendererScript.from):[]};let x=a??y,N;this._proxy.$addKernel(b,S).catch(q=>{console.log(q),R=!0});let j=0;const W=()=>{if(R)return;const q=++j;Promise.resolve().then(()=>{q===j&&this._proxy.$updateKernel(b,S)})},$=new T.ResourceMap,V={get id(){return s},get notebookType(){return S.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return S.label},set label(q){S.label=q??v.displayName??v.name,W()},get detail(){return S.detail??""},set detail(q){S.detail=q,W()},get description(){return S.description??""},set description(q){S.description=q,W()},get kind(){return(0,P.checkProposedApiEnabled)(v),S.kind??""},set kind(q){(0,P.checkProposedApiEnabled)(v),S.kind=q,W()},get supportedLanguages(){return S.supportedLanguages},set supportedLanguages(q){S.supportedLanguages=q,W()},get supportsExecutionOrder(){return S.supportsExecutionOrder??!1},set supportsExecutionOrder(q){S.supportsExecutionOrder=q,W()},get rendererScripts(){return S.preloads?S.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(q){x=q??y},get interruptHandler(){return N},set interruptHandler(q){N=q,S.supportsInterrupt=Boolean(q),W()},createNotebookCellExecution(q){if(R)throw new Error("notebook controller is DISPOSED");if(!$.has(q.notebook.uri))throw h._logService.trace(`NotebookController[${b}] NOT associated to notebook, associated to THESE notebooks:`,Array.from($.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${q.notebook.uri.toString()}`);return h._createNotebookCellExecution(q)},dispose:()=>{R||(this._logService.trace(`NotebookController[${b}], DISPOSED`),R=!0,this._kernelData.delete(b),A.dispose(),B.dispose(),O.dispose(),this._proxy.$removeKernel(b))},updateNotebookAffinity(q,re){h._proxy.$updateNotebookPriority(b,q.uri,re)},onDidReceiveMessage:O.event,postMessage(q,re){return(0,P.checkProposedApiEnabled)(v),h._proxy.$postMessage(b,re&&h._extHostNotebook.getIdByEditor(re),q)},asWebviewUri(q){return(0,P.checkProposedApiEnabled)(v),(0,c.asWebviewUri)(q,h._initData.remote)}};return this._kernelData.set(b,{extensionId:v.identifier,controller:V,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:$}),V}$acceptNotebookAssociation(v,s,i){const m=this._kernelData.get(v);if(m){const a=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));i?m.associatedNotebooks.set(a.uri,!0):m.associatedNotebooks.delete(a.uri),this._logService.trace(`NotebookController[${v}] ASSOCIATE notebook`,a.uri.toString(),i),m.onDidChangeSelection.fire({selected:i,notebook:a.apiNotebook})}}async $executeCells(v,s,i){const m=this._kernelData.get(v);if(!m)return;const a=this._extHostNotebook.getNotebookDocument(C.URI.revive(s)),g=[];for(let b of i){const h=a.getCell(b);h&&g.push(h.apiCell)}try{this._logService.trace(`NotebookController[${v}] EXECUTE cells`,a.uri.toString(),g.length),await m.controller.executeHandler.call(m.controller,g,a.apiNotebook,m.controller)}catch(b){this._logService.error(`NotebookController[${v}] execute cells FAILED`,b),console.error(b)}}async $cancelCells(v,s,i){const m=this._kernelData.get(v);if(!m)return;const a=this._extHostNotebook.getNotebookDocument(C.URI.revive(s));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,a.apiNotebook);else for(let g of i){const b=a.getCell(g);b&&this._activeExecutions.get(b.uri)?.cancel()}}$acceptKernelMessageFromRenderer(v,s,i){const m=this._kernelData.get(v);if(!m)return;const a=this._extHostNotebook.getEditorById(s);m.onDidReceiveMessage.fire(Object.freeze({editor:a.apiEditor,message:i}))}_createNotebookCellExecution(v){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const i=this._extHostNotebook.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!i)throw new Error("invalid cell");if(this._activeExecutions.has(i.uri))throw new Error(`duplicate execution for ${i.uri}`);const m=new f(i.notebook,i,this._proxy);this._activeExecutions.set(i.uri,m);const a=m.onDidChangeState(()=>{m.state===o.Resolved&&(m.dispose(),a.dispose(),this._activeExecutions.delete(i.uri))});return m.asApiObject()}};w=xe([Be(4,t.ILogService)],w),e.ExtHostNotebookKernels=w;var o;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(o||(o={}));class f extends F.Disposable{constructor(v,s,i){super();this._document=v,this._cell=s,this._proxy=i,this._handle=f.HANDLE++,this._onDidChangeState=new I.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new k(10,m=>this.update(m)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(v){await this._collector.addItem(v)}async update(v){const s=Array.isArray(v)?v:[v];return this._proxy.$updateExecutions(new D.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(v){let s=this._cell;if(v&&(s=this._document.getCellFromApiCell(v)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(v){return v.map(s=>{const i=l.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return i===s.items?d.NotebookCellOutput.from(s):d.NotebookCellOutput.from({items:i,id:s.id,metadata:s.metadata})})}async updateOutputs(v,s,i){const m=this.cellIndexToHandle(s),a=this.validateAndConvertOutputs((0,u.asArray)(v));return this.updateSoon({editType:p.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:m,append:i,outputs:a})}async updateOutputItems(v,s,i){return v=l.NotebookCellOutput.ensureUniqueMimeTypes((0,u.asArray)(v),!0),this.updateSoon({editType:p.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:v.map(d.NotebookCellOutputItem.from),outputId:s.id,append:i})}asApiObject(){const v=this;return Object.freeze({get token(){return v._tokenSource.token},get cell(){return v._cell.apiCell},get executionOrder(){return v._executionOrder},set executionOrder(i){v._executionOrder=i,v.update([{editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:v._handle,executionOrder:v._executionOrder}])},start(i){if(v._state===o.Resolved||v._state===o.Started)throw new Error("Cannot call start again");v._state=o.Started,v._onDidChangeState.fire(),v.update({editType:p.CellExecutionUpdateType.ExecutionState,executionHandle:v._handle,runStartTime:i})},end(i,m){if(v._state===o.Resolved)throw new Error("Cannot call resolve twice");v._state=o.Resolved,v._onDidChangeState.fire(),v.updateSoon({editType:p.CellExecutionUpdateType.Complete,executionHandle:v._handle,runEndTime:m,lastRunSuccess:i}),v._collector.flush(),v._proxy.$removeExecution(v._handle)},clearOutput(i){return v.verifyStateForOutput(),v.updateOutputs([],i,!1)},appendOutput(i,m){return v.verifyStateForOutput(),v.updateOutputs(i,m,!0)},replaceOutput(i,m){return v.verifyStateForOutput(),v.updateOutputs(i,m,!1)},appendOutputItems(i,m){return v.verifyStateForOutput(),v.updateOutputItems(i,m,!0)},replaceOutputItems(i,m){return v.verifyStateForOutput(),v.updateOutputItems(i,m,!1)}})}}f.HANDLE=0;class k{constructor(v,s){this.delay=v,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(v){return this.batch.push(v),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const v=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>v.complete())}}}),define(we[205],be([0,1,3,22,5,92]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class F{constructor(C,P){this._extHostNotebook=P,this._rendererMessageEmitters=new Map,this.proxy=C.getProxy(E.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(C,P,t){const _=this._extHostNotebook.getEditorById(C);this._rendererMessageEmitters.get(P)?.fire({editor:_.apiEditor,message:t})}createRendererMessaging(C,P){if(!C.contributes?.notebookRenderer?.some(d=>d.id===P))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${P})`);const t=(0,M.isProposedApiEnabled)(C),_=new WeakMap;return{onDidReceiveMessage:(d,l,c)=>{const p=t?d:D=>{const w={};_.set(w,D.editor),d({editor:w,message:D.message})};return this.getOrCreateEmitterFor(P).event(p,l,c)},postMessage:(d,l)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,l]=[l,d]);const c=t?l:_.get(l),p=c&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(c);return this.proxy.$postMessage(p?.id,P,d)}}}getOrCreateEmitterFor(C){let P=this._rendererMessageEmitters.get(C);return P||(P=new u.Emitter({onLastListenerRemove:()=>{P?.dispose(),this._rendererMessageEmitters.delete(C)}}),this._rendererMessageEmitters.set(C,P),P)}}e.ExtHostNotebookRenderers=F}),define(we[96],be([0,1,5,6,4,14,12,169,51,27,30,115,23]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class d extends M.Disposable{constructor(p,D,w,o){super();this.id=p,this.name=D,this.logger=w,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(p){this.append(p+`
`)}append(p){this.write(p),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const p=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,p)}replace(p){const D=this.offset;this.write(p),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,D),this.visible&&this.logger.flush()}show(p,D){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof p=="boolean"?p:D))}hide(){this.proxy.$close(this.id)}write(p){this.offset+=n.VSBuffer.fromString(p).byteLength,this.logger.info(p)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=d;let l=class{constructor(p,D,w,o,f){this.extHostFileSystem=w,this.extHostFileSystemInfo=o,this.loggerService=f,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=p.getProxy(u.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(D.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(p){this.visibleChannelId=p;for(const[D,w]of this.channels)w.visible=D===this.visibleChannelId}createOutputChannel(p,D){if(p=p.trim(),!p)throw new Error("illegal argument `name`. must not be falsy");const w=this.doCreateOutputChannel(p,D);return w.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(p,w)}async doCreateOutputChannel(p,D){const w=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(w,`${this.namePool++}-${p.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),k=await this.proxy.$register(p,!1,o,D.identifier.value);return new d(k,p,f,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(p,D){let w=!1;const o=()=>{if(w)throw new Error("Channel has been closed")};return{get name(){return p},append(f){o(),D.then(k=>k.append(f))},appendLine(f){o(),D.then(k=>k.appendLine(f))},clear(){o(),D.then(f=>f.clear())},replace(f){o(),D.then(k=>k.replace(f))},show(f,k){o(),D.then(r=>r.show(f,k))},hide(){o(),D.then(f=>f.hide())},dispose(){w=!0,D.then(f=>f.dispose())}}}};l=xe([Be(0,I.IExtHostRpcService),Be(1,P.IExtHostInitDataService),Be(2,C.IExtHostConsumerFileSystem),Be(3,t.IExtHostFileSystemInfo),Be(4,F.ILoggerService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(we[206],be([0,1,13,21,3,6,5,2,7,16,15,35,47]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(l,c,p){const D=l.getProxy(F.MainContext.MainThreadQuickOpen);class w{constructor(a,g){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=g}showQuickPick(a,g,b,h=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(a),R=++this._instances,A=D.$show(R,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},h),B={},O=A.then(()=>B);return Promise.race([O,y]).then(S=>{if(S!==B)return y.then(x=>{const N=[];for(let j=0;j<x.length;j++){const W=x[j];let $,V,q,re,ae;typeof W=="string"?$=W:($=W.label,V=W.description,q=W.detail,re=W.picked,ae=W.alwaysShow),N.push({label:$,description:V,handle:j,detail:q,picked:re,alwaysShow:ae})}return b&&typeof b.onDidSelectItem=="function"&&(this._onDidSelectItem=j=>{b.onDidSelectItem(x[j])}),D.$setItems(R,N),A.then(j=>{if(typeof j=="number")return x[j];if(Array.isArray(j))return j.map(W=>x[W])})})}).then(void 0,S=>{if(!(0,P.isPromiseCanceledError)(S))return D.$setError(R,S),Promise.reject(S)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,g=M.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,D.$input(a,typeof this._validateInput=="function",g).then(void 0,b=>{if(!(0,P.isPromiseCanceledError)(b))return Promise.reject(b)})}$validateInput(a){return this._validateInput?(0,u.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,g=M.CancellationToken.None){const b=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!b)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(a,g){const b=new s(a,()=>this._sessions.delete(b._id));return this._sessions.set(b._id,b),b}createInputBox(a){const g=new i(a,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}$onDidChangeValue(a,g){const b=this._sessions.get(a);b&&b._fireDidChangeValue(g)}$onDidAccept(a){const g=this._sessions.get(a);g&&g._fireDidAccept()}$onDidChangeActive(a,g){const b=this._sessions.get(a);b instanceof s&&b._fireDidChangeActive(g)}$onDidChangeSelection(a,g){const b=this._sessions.get(a);b instanceof s&&b._fireDidChangeSelection(g)}$onDidTriggerButton(a,g){const b=this._sessions.get(a);b&&b._fireDidTriggerButton(g)}$onDidTriggerItemButton(a,g,b){const h=this._sessions.get(a);h instanceof s&&h._fireDidTriggerItemButton(g,b)}$onDidHide(a){const g=this._sessions.get(a);g&&g._fireDidHide()}}class o{constructor(a,g){this._extensionId=a,this._onDidDispose=g,this._id=s._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((g,b)=>{const h=g===C.QuickInputButtons.Back?-1:b;this._handlesToButtons.set(h,g)}),this.update({buttons:a.map((g,b)=>({...v(g),tooltip:g.tooltip,handle:g===C.QuickInputButtons.Back?-1:b}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const g=this._handlesToButtons.get(a);g&&this._onDidTriggerButtonEmitter.fire(g)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,I.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),D.$dispose(this._id))}update(a){if(!this._disposed){for(const g of Object.keys(a)){const b=a[g];this._pendingUpdate[g]=b===void 0?null:b}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){D.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function f(m){if(m instanceof C.ThemeIcon)return{id:m.id};const a=r(m),g=k(m);return{dark:typeof a=="string"?T.URI.file(a):a,light:typeof g=="string"?T.URI.file(g):g}}function k(m){return typeof m=="object"&&"light"in m?m.light:m}function r(m){return typeof m=="object"&&"dark"in m?m.dark:m}function v(m){const a=f(m.iconPath);let g,b;return"id"in a?b=n.ThemeIcon.asClassName(a):g=a,{iconPath:g,iconClass:b}}class s extends o{constructor(a,g){super(a,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((g,b)=>{this._handlesToItems.set(b,g),this._itemsToHandles.set(g,b)}),this.update({items:a.map((g,b)=>({label:g.label,description:g.description,handle:b,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,buttons:g.buttons?.map((h,y)=>({...v(h),tooltip:h.tooltip,handle:y}))}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(g=>this._itemsToHandles.has(g)),this.update({activeItems:this._activeItems.map(g=>this._itemsToHandles.get(g))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(g=>this._itemsToHandles.has(g)),this.update({selectedItems:this._selectedItems.map(g=>this._itemsToHandles.get(g))})}_fireDidChangeActive(a){const g=(0,t.coalesce)(a.map(b=>this._handlesToItems.get(b)));this._activeItems=g,this._onDidChangeActiveEmitter.fire(g)}_fireDidChangeSelection(a){const g=(0,t.coalesce)(a.map(b=>this._handlesToItems.get(b)));this._selectedItems=g,this._onDidChangeSelectionEmitter.fire(g)}_fireDidTriggerItemButton(a,g){const b=this._handlesToItems.get(a);if(!b||!b.buttons||!b.buttons.length)return;const h=b.buttons[g];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:b})}}class i extends o{constructor(a,g){super(a,g);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?_.default.Error:_.default.Ignore})}}return new w(c,p)}e.createExtHostQuickOpen=d}),define(we[207],be([0,1,2,3,54,6,13,5,15,107,12,22,47,8]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(m){if(m)return typeof m.iconPath=="string"?u.URI.file(m.iconPath):u.URI.isUri(m.iconPath)||n.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function c(m,a){if(!m.iconPath&&!a.iconPath)return 0;if(m.iconPath){if(!a.iconPath)return 1}else return-1;const g=typeof m.iconPath=="string"?m.iconPath:u.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,b=typeof a.iconPath=="string"?a.iconPath:u.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id;return(0,P.comparePaths)(g,b)}function p(m,a){let g=0;if(m.strikeThrough!==a.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==a.faded)return m.faded?1:-1;if(m.tooltip!==a.tooltip)return(m.tooltip||"").localeCompare(a.tooltip||"");if(g=c(m,a),g!==0)return g;if(m.light&&a.light)g=c(m.light,a.light);else{if(m.light)return 1;if(a.light)return-1}if(g!==0)return g;if(m.dark&&a.dark)g=c(m.dark,a.dark);else{if(m.dark)return 1;if(a.dark)return-1}return g}function D(m,a){if(m.command!==a.command)return m.command<a.command?-1:1;if(m.title!==a.title)return m.title<a.title?-1:1;if(m.tooltip!==a.tooltip){if(m.tooltip!==void 0&&a.tooltip!==void 0)return m.tooltip<a.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(m.arguments===a.arguments)return 0;if(m.arguments)if(a.arguments){if(m.arguments.length!==a.arguments.length)return m.arguments.length-a.arguments.length}else return 1;else return-1;for(let g=0;g<m.arguments.length;g++){const b=m.arguments[g],h=a.arguments[g];if(b!==h)return b<h?-1:1}return 0}function w(m,a){let g=(0,P.comparePaths)(m.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(g!==0)return g;if(m.command&&a.command)g=D(m.command,a.command);else{if(m.command)return 1;if(a.command)return-1}if(g!==0)return g;if(m.decorations&&a.decorations)g=p(m.decorations,a.decorations);else{if(m.decorations)return 1;if(a.decorations)return-1}return g}function o(m,a){for(let g=0;g<m.length;g++)if(m[g]!==a[g])return!1;return!0}function f(m,a){return m.command===a.command&&m.title===a.title&&m.tooltip===a.tooltip&&(m.arguments&&a.arguments?o(m.arguments,a.arguments):m.arguments===a.arguments)}function k(m,a){return(0,C.equals)(m,a,f)}class r{constructor(a,g,b){this._extension=a,this._proxy=g,this._sourceControlHandle=b,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,_.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,_.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}showValidationMessage(a,g){(0,_.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,g)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=r;class v{constructor(a,g,b,h,y){this._proxy=a,this._commands=g,this._sourceControlHandle=b,this._id=h,this._label=y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=v._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,g){const b=this._resourceStatesCommandsMap.get(a);return b?(0,F.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const a=[...this._resourceStates].sort(w),b=(0,C.sortedDiff)(this._resourceSnapshot,a,w).map(R=>{const A=R.toInsert.map(B=>{const O=this._resourceHandlePool++;this._resourceStatesMap.set(O,B);const S=B.resourceUri;let x;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const me=new I.DisposableStore;x=this._commands.converter.toInternal(B.command,me),this._resourceStatesDisposablesMap.set(O,me)}else this._resourceStatesCommandsMap.set(O,B.command);const N=l(B.decorations),j=B.decorations&&l(B.decorations.light)||N,W=B.decorations&&l(B.decorations.dark)||N,$=[j,W],V=B.decorations&&B.decorations.tooltip||"",q=B.decorations&&!!B.decorations.strikeThrough,re=B.decorations&&!!B.decorations.faded,ae=B.contextValue||"";return{rawResource:[O,S,$,V,q,re,ae,x],handle:O}});return{start:R.start,deleteCount:R.deleteCount,toInsert:A}}),h=b.map(({start:R,deleteCount:A,toInsert:B})=>[R,A,B.map(O=>O.rawResource)]),y=b.reverse();for(const{start:R,deleteCount:A,toInsert:B}of y){const O=B.map(x=>x.handle),S=this._handlesSnapshot.splice(R,A,...O);for(const x of S)this._resourceStatesMap.delete(x),this._resourceStatesCommandsMap.delete(x),this._resourceStatesDisposablesMap.get(x)?.dispose(),this._resourceStatesDisposablesMap.delete(x)}return this._resourceSnapshot=a,h}dispose(){this._disposed=!0,this._onDidDispose.fire()}}v._handlePool=0;class s{constructor(a,g,b,h,y,R){this._extension=a,this._proxy=g,this._commands=b,this._id=h,this._label=y,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new I.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new I.MutableDisposable,this._statusBarDisposables=new I.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=s._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new r(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,h,y,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new I.DisposableStore,this._acceptInputCommand=a;const g=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get actionButton(){return(0,_.checkProposedApiEnabled)(this._extension),this._actionButton}set actionButton(a){(0,_.checkProposedApiEnabled)(this._extension),this._actionButtonDisposables.value=new I.DisposableStore,this._actionButton=a;const g=a!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:g??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(this._statusBarCommands&&a&&k(this._statusBarCommands,a))return;this._statusBarDisposables.value=new I.DisposableStore,this._statusBarCommands=a;const g=(a||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}get selected(){return this._selected}createResourceGroup(a,g){const b=new v(this._proxy,this._commands,this.handle,a,g),h=M.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,h),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const a=[],g=[];for(const[b,h]of this.createdResourceGroups){h.dispose();const y=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});M.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),y.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),a.push([b.handle,b.id,b.label,b.features]);const R=b._takeResourceStateSnapshot();R.length>0&&g.push([b.handle,R]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,a,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(g=>{const b=g._takeResourceStateSnapshot();b.length!==0&&a.push([g.handle,b])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}s._handlePool=0,xe([(0,E.debounce)(100)],s.prototype,"eventuallyAddResourceGroups",null),xe([(0,E.debounce)(100)],s.prototype,"eventuallyUpdateResourceStates",null);let i=class Bi{constructor(a,g,b){this._commands=g,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=a.getProxy(T.MainContext.MainThreadSCM),this._telemetry=a.getProxy(T.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===3){const y=this._sourceControls.get(h.sourceControlHandle);if(!y)return h;const R=y.getResourceGroup(h.groupHandle);return R?R.getResourceState(h.handle):h}else if(h&&h.$mid===4){const y=this._sourceControls.get(h.sourceControlHandle);return y?y.getResourceGroup(h.groupHandle):h}else if(h&&h.$mid===5){const y=this._sourceControls.get(h.handle);return y||h}return h}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,g,b,h){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,g,b,h),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const y=Bi._handlePool++,R=new s(a,this._proxy,this._commands,g,b,h);this._sourceControls.set(y,R);const A=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(a.identifier))||[];return A.push(R),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(a.identifier),A),R}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const g=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(a.identifier)),b=g&&g[g.length-1];return b&&b.inputBox}$provideOriginalResource(a,g,b){const h=u.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,h.toString());const y=this._sourceControls.get(a);return!y||!y.quickDiffProvider||!y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,F.asPromise)(()=>y.quickDiffProvider.provideOriginalResource(h,b)).then(R=>R||null)}$onInputBoxValueChange(a,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const b=this._sourceControls.get(a);return b&&b.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(a,g,b,h){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,g,b);const y=this._sourceControls.get(a);if(!y)return Promise.resolve(void 0);const R=y.getResourceGroup(g);return R?R.$executeResourceCommand(b,h):Promise.resolve(void 0)}$validateInput(a,g,b){this.logService.trace("ExtHostSCM#$validateInput",a);const h=this._sourceControls.get(a);return!h||!h.inputBox.validateInput?Promise.resolve(void 0):(0,F.asPromise)(()=>h.inputBox.validateInput(g,b)).then(y=>{if(!y)return Promise.resolve(void 0);const R=d.MarkdownString.fromStrict(y.message);return R?Promise.resolve([R,y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(a){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&this._sourceControls.get(a)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};i._handlePool=0,i=xe([Be(2,t.ILogService)],i),e.ExtHostSCM=i});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[208],be([0,1,7,5,128,6,8,10]),function(ne,e,u,M,E,I,F,T){"use strict";var C,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class t{constructor(l,c,p,D,w=u.StatusBarAlignment.Left,o){C.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new I.DisposableStore,Ze(this,C,l,"f"),Ze(this,P,c,"f"),this._entryId=t.ID_GEN++,this._extension=p,this._id=D,this._alignment=w,this._priority=this.validatePriority(o)}validatePriority(l){if(!!(0,T.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!t.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:Te(this,P,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:Te(this,P,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,C,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let c;this._name?c=this._name:c=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let p=this._color;this._backgroundColor&&(p=t.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const D=this._tooltip?F.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,C,"f").$setEntry(this._entryId,l,c,this._text,D,this._command?.internal,p,this._backgroundColor,this._alignment===u.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=t,C=new WeakMap,P=new WeakMap,t.ID_GEN=0,t.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new u.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const c={message:l};return this._messages.unshift(c),this._update(),new u.Disposable(()=>{const p=this._messages.indexOf(c);p>=0&&(this._messages.splice(p,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(l,c){this._proxy=l.getProxy(M.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new _(this)}createStatusBarEntry(l,c,p,D){return new t(this._proxy,this._commands,l,c,p,D)}setStatusBarMessage(l,c){const p=this._statusMessage.setMessage(l);let D;return typeof c=="number"?D=setTimeout(()=>p.dispose(),c):typeof c!="undefined"&&c.then(()=>p.dispose(),()=>p.dispose()),new u.Disposable(()=>{p.dispose(),clearTimeout(D)})}}e.ExtHostStatusBar=n}),define(we[72],be([0,1,5,3,4]),function(ne,e,u,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class I{constructor(T){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(u.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,C){this._proxy.$registerExtensionStorageKeysToSync(T,C)}getValue(T,C,P){return this._proxy.$getValue(T,C).then(t=>t||P)}setValue(T,C,P){return this._proxy.$setValue(T,C,P)}$acceptValue(T,C,P){this._onDidChangeStorage.fire({shared:T,key:C,value:P})}}e.ExtHostStorage=I,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(we[73],be([0,1,4,27,12,51,2]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,u.createDecorator)("IExtensionStoragePaths");let T=class{constructor(P,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(P){return F.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,t=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(F.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:F.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(P){if(this._value)return F.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return F.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=xe([Be(0,M.IExtHostInitDataService),Be(1,E.ILogService),Be(2,I.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(we[40],be([0,1,3,5,4,2,14,6,7,129,16,171,21,36,151,47,10,13]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class w{constructor(a,g,b,h){this._proxy=a,this._id=g,this._creationOptions=b,this._name=h,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,A=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,A)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(a,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,p.withNullAsUndefined)(a.shellPath),shellArgs:(0,p.withNullAsUndefined)(a.shellArgs),cwd:(0,p.withNullAsUndefined)(a.cwd),env:(0,p.withNullAsUndefined)(a.env),icon:(0,p.withNullAsUndefined)(s(a.iconPath)),color:c.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,p.withNullAsUndefined)(a.message),strictEnv:(0,p.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,p.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,p.withNullAsUndefined)(g?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,p.withNullAsUndefined)(g?.useShellEnvironment),location:g?.location||this._serializeParentTerminal(a.location,g?.resolvedExtHostIdentifier)})}async createExtensionTerminal(a,g,b,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:b,color:c.ThemeColor.isThemeColor(h)?h.id:void 0,location:this._serializeParentTerminal(a,g)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(a,g){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in a?{viewColumn:a.viewColumn,preserveFocus:a.preserveFocus}:void 0:a}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,g){return a===this._cols&&g===this._rows||a===0||g===0?!1:(this._cols=a,this._rows=g,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(g=>{g!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=w;class o{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new u.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new u.Emitter,this._onDidChangeProperty=new u.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new u.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${g}`)}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,g){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:g})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(g=>this._onProcessData.fire(g)),this._pty.onDidClose&&this._pty.onDidClose((g=void 0)=>{this._onProcessExit.fire(g===void 0?void 0:g)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(g=>{g&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(g=>{this._onDidChangeProperty.fire({type:"title",value:g})}),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let f=1,k=class extends T.Disposable{constructor(a,g){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new u.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new u.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new u.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new u.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new u.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=g.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new u.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[b,h]of this._terminalProcesses)h.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,g){const b=new w(this._proxy,(0,d.generateUuid)(),a,a.name),h=new o(a.pty);return b.createExtensionTerminal(a.location,this._serializeParentTerminal(a,g).resolvedExtHostIdentifier,s(a.iconPath),i(a.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,h);this._terminalProcessDisposables[y]=R}),this._terminals.push(b),b.value}_serializeParentTerminal(a,g){if(g=g||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const b=a.location.parentTerminal;if(b){const h=this._terminals.find(y=>y.value===b);h&&(g.resolvedExtHostIdentifier=h._id)}}else a.location&&typeof a.location!="object"?g.location=a.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(a,g){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const h=new o(g),y=this._setupExtHostProcessListeners(a,h);this._terminalProcessDisposables[a]=y}async $acceptActiveTerminalChanged(a){const g=this._activeTerminal;if(a===null){this._activeTerminal=void 0,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const b=this._getTerminalById(a);b&&(this._activeTerminal=b,g!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,g){const b=this._getTerminalById(a);b&&this._onDidWriteTerminalData.fire({terminal:b.value,data:g})}async $acceptTerminalDimensions(a,g,b){const h=this._getTerminalById(a);h&&h.setDimensions(g,b)&&this._onDidChangeTerminalDimensions.fire({terminal:h.value,dimensions:h.value.dimensions})}async $acceptTerminalMaximumDimensions(a,g,b){this._terminalProcesses.get(a)?.resize(g,b)}async $acceptTerminalTitleChange(a,g){const b=this._getTerminalById(a);b&&(b.name=g)}async $acceptTerminalClosed(a,g){const b=this._getTerminalObjectIndexById(this._terminals,a);if(b!==null){const h=this._terminals.splice(b,1)[0];h.setExitCode(g),this._onDidCloseTerminal.fire(h.value)}}$acceptTerminalOpened(a,g,b,h){if(g){const A=this._getTerminalObjectIndexById(this._terminals,g);if(A!==null){this._terminals[A]._id=a,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const y={name:h.name,shellPath:h.executable,shellArgs:h.args,cwd:typeof h.cwd=="string"?h.cwd:I.URI.revive(h.cwd),env:h.env,hideFromUser:h.hideFromUser},R=new w(this._proxy,a,y,b);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(a,g){const b=this._getTerminalById(a);b&&b._setProcessId(g)}async $startExtensionTerminal(a,g){const b=this._getTerminalById(a);if(!b)return{message:(0,P.localize)(0,null,a)};b.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async A=>{A===b.value&&(R.dispose(),y())})});const h=this._terminalProcesses.get(a);h?h.startSendingEvents(g):this._extensionTerminalAwaitingStart[a]={initialDimensions:g}}_setupExtHostProcessListeners(a,g){const b=new T.DisposableStore;b.add(g.onProcessReady(y=>this._proxy.$sendProcessReady(a,y.pid,y.cwd))),b.add(g.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(a,y))),this._bufferer.startBuffering(a,g.onProcessData),b.add(g.onProcessExit(y=>this._onProcessExit(a,y))),this._terminalProcesses.set(a,g);const h=this._extensionTerminalAwaitingStart[a];return h&&g instanceof o&&(g.startSendingEvents(h.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),b}$acceptProcessAckDataEvent(a,g){this._terminalProcesses.get(a)?.acknowledgeDataEvent(g)}$acceptProcessInput(a,g){this._terminalProcesses.get(a)?.input(g)}$acceptTerminalInteraction(a){const g=this._getTerminalById(a);g?.setInteractedWith()&&this._onDidChangeTerminalState.fire(g.value)}$acceptProcessResize(a,g,b){try{this._terminalProcesses.get(a)?.resize(g,b)}catch(h){if(h.code!=="EPIPE"&&h.code!=="ERR_IPC_CHANNEL_CLOSED")throw h}}$acceptProcessShutdown(a,g){this._terminalProcesses.get(a)?.shutdown(g)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(g=>this._proxy.$sendProcessProperty(a,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(g=>this._proxy.$sendProcessProperty(a,{type:"cwd",value:g}))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new C.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,g,b){if(this._profileProviders.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this._profileProviders.set(g,b),this._proxy.$registerProfileProvider(g,a.identifier.value),new C.Disposable(()=>{this._profileProviders.delete(g),this._proxy.$unregisterProfileProvider(g)})}async $createContributedProfileTerminal(a,g){const b=new n.CancellationTokenSource().token;let h=await this._profileProviders.get(a)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(h&&!("options"in h)&&(h={options:h}),!h||!("options"in h))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in h.options){this.createExtensionTerminal(h.options,g);return}this.createTerminalFromOptions(h.options,g)}}async $provideLinks(a,g){const b=this._getTerminalById(a);if(!b)return[];this._terminalLinkCache.delete(a);const h=this._terminalLinkCancellationSource.get(a);h&&h.dispose(!0);const y=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,y);const R=[],A={terminal:b.value,line:g},B=[];for(const x of this._linkProviders)B.push(D.Promises.withAsyncBody(async N=>{y.token.onCancellationRequested(()=>N({provider:x,links:[]}));const j=await x.provideTerminalLinks(A,y.token)||[];y.token.isCancellationRequested||N({provider:x,links:j})}));const O=await Promise.all(B);if(y.token.isCancellationRequested)return[];const S=new Map;for(const x of O)x&&x.links.length>0&&R.push(...x.links.map(N=>{const j={id:f++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return S.set(j.id,{provider:x.provider,link:N}),j}));return this._terminalLinkCache.set(a,S),R}$activateLink(a,g){const b=this._terminalLinkCache.get(a)?.get(g);!b||b.provider.handleTerminalLink(b.link)}_onProcessExit(a,g){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const b=this._terminalProcessDisposables[a];b&&(b.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,g)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,g){const b=this._getTerminalObjectIndexById(a,g);return b!==null?a[b]:null}_getTerminalObjectIndexById(a,g){let b=null;return a.some((h,y)=>h._id===g?(b=y,!0):!1),b}getEnvironmentVariableCollection(a){let g=this._environmentVariableCollections.get(a.identifier.value);return g||(g=new r,this._setEnvironmentVariableCollection(a.identifier.value,g)),g}_syncEnvironmentVariableCollection(a,g){const b=(0,_.serializeEnvironmentVariableCollection)(g.map);this._proxy.$setEnvironmentVariableCollection(a,g.persistent,b.length===0?void 0:b)}$initEnvironmentVariableCollections(a){a.forEach(g=>{const b=g[0],h=new r(g[1]);this._setEnvironmentVariableCollection(b,h)})}$acceptDefaultProfile(a,g){this._defaultProfile=a,this._defaultAutomationProfile=g}_setEnvironmentVariableCollection(a,g){this._environmentVariableCollections.set(a,g),g.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,g)})}};k=xe([Be(1,F.IExtHostRpcService)],k),e.BaseExtHostTerminalService=k;class r{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new u.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,g){this._setIfDiffers(a,{value:g,type:C.EnvironmentVariableMutatorType.Replace})}append(a,g){this._setIfDiffers(a,{value:g,type:C.EnvironmentVariableMutatorType.Append})}prepend(a,g){this._setIfDiffers(a,{value:g,type:C.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,g){const b=this.map.get(a);(!b||b.value!==g.value||b.type!==g.type)&&(this.map.set(a,g),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,g){this.map.forEach((b,h)=>a.call(g,h,b,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let v=class extends k{constructor(a){super(!1,a)}createTerminal(a,g,b){throw new t.NotSupportedError}createTerminalFromOptions(a,g){throw new t.NotSupportedError}};v=xe([Be(0,F.IExtHostRpcService)],v),e.WorkerExtHostTerminalService=v;function s(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function i(m){return c.ThemeColor.isThemeColor(m)?m:void 0}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[209],be([0,1,15,23,21,3,238,59,6,24,10,36,5,14,49,8,7,179,89,68]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let k=class{constructor(A,B){this.resultsChangedEmitter=new I.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(n.MainContext.MainThreadTesting),this.observer=new b(this.proxy),this.runTracker=new v(this.proxy),B.registerArgumentProcessor({processArgument:O=>O?.$mid===13?c.TestItem.toItemFromContext(O):O})}createTestController(A,B){if(this.controllers.has(A))throw new Error(`Attempt to insert a duplicate controller with ID "${A}"`);const O=new C.DisposableStore,S=O.add(new D.SingleUseTestCollection(A));S.root.label=B;const x=new Map,N=this.proxy,j={items:S.root.children,get label(){return B},set label($){B=$,S.root.label=$,N.$updateControllerLabel(A,B)},get id(){return A},createRunProfile:($,V,q,re,ae)=>{let pe=(0,T.hash)($);for(;x.has(pe);)pe++;const me=new h(this.proxy,A,pe,$,V,q,re,ae);return x.set(pe,me),me},createTestItem($,V,q){return new l.TestItemImpl(A,$,V,q)},createTestRun:($,V,q=!0)=>this.runTracker.createTestRun(A,S,$,V,q),set resolveHandler($){S.resolveHandler=$},get resolveHandler(){return S.resolveHandler},dispose:()=>{O.dispose()}};j.createRunConfiguration=j.createRunProfile,N.$registerTestController(A,B),O.add((0,C.toDisposable)(()=>N.$unregisterTestController(A)));const W={controller:j,collection:S,profiles:x};return this.controllers.set(A,W),O.add((0,C.toDisposable)(()=>this.controllers.delete(A))),O.add(S.onDidGenerateDiff($=>N.$publishDiff(A,$))),j}createTestObserver(){return this.observer.checkout()}async runTests(A,B=E.CancellationToken.None){const O=s(A);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const S=this.controllers.get(O.controllerId);if(!S)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:A.include?.map(x=>x.id)??[S.collection.root.id],profileGroup:y[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:A.exclude?.map(x=>x.id)},B)}$provideFileCoverage(A,B,O){return(0,u.mapFind)(this.runTracker.trackers,x=>x.id===A?x.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(A,B,O,S){return(0,u.mapFind)(this.runTracker.trackers,N=>N.id===A?N.getCoverage(B):void 0)?.resolveFileCoverage(O,S)??Promise.resolve([])}$configureRunProfile(A,B){this.controllers.get(A)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(A){this.results=Object.freeze(A.map(B=>(0,P.deepFreeze)(c.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(A,B){const O=this.controllers.get(o.TestId.fromString(A).controllerId)?.collection;O&&(await O.expand(A,B<0?Infinity:B),O.flushDiff())}$acceptDiff(A){this.observer.applyDiff(A)}async $runControllerTests(A,B){const O=this.controllers.get(A.controllerId);if(!O)return;const{collection:S,profiles:x}=O,N=x.get(A.profileId);if(!N)return;const j=A.testIds.map(q=>S.tree.get(q)).filter(t.isDefined),W=A.excludeExtIds.map(q=>O.collection.tree.get(q)).filter(t.isDefined).filter(q=>j.some(re=>re.fullId.compare(q.fullId)===2));if(!j.length)return;const $=new p.TestRunRequest(j.some(q=>q.actual instanceof l.TestItemRootImpl)?void 0:j.map(q=>q.actual),W.map(q=>q.actual),N),V=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(A,O.collection),B);try{await N.runHandler($,B)}finally{V.isRunning&&!B.isCancellationRequested&&await I.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(A){A===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(A)}};k=xe([Be(0,d.IExtHostRpcService)],k),e.ExtHostTesting=k;class r extends C.Disposable{constructor(A,B,O){super();this.dto=A,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new I.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(O)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:S}of this.tasks.values())S.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(A){return this.tasks.get(A)?.coverage}createRun(A){const B=this.dto.id,O=this.dto.controllerId,S=(0,_.generateUuid)(),x=new m(this.proxy,B,S),N=V=>(q,...re)=>{if(W){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(q)||(this.ensureTestIsKnown(q),V(q,...re))},j=(V,q)=>{const re=q instanceof Array?q.map(c.TestMessage.from):[c.TestMessage.from(q)];if(V.uri&&V.range){const ae={range:c.Range.from(V.range),uri:V.uri};for(const pe of re)pe.location=pe.location||ae}this.proxy.$appendTestMessagesInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),re)};let W=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:A,get coverageProvider(){return x.coverageProvider},set coverageProvider(V){x.coverageProvider=V},enqueued:N(V=>{this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),1)}),skipped:N(V=>{this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),5)}),started:N(V=>{this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),2)}),errored:N((V,q,re)=>{j(V,q),this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),6,re)}),failed:N((V,q,re)=>{j(V,q),this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,O).toString(),4,re)}),passed:N((V,q)=>{this.proxy.$updateTestStateInRun(B,S,o.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,q)}),appendOutput:(V,q,re)=>{W||(re&&(this.dto.isIncluded(re)?this.ensureTestIsKnown(re):re=void 0),this.proxy.$appendOutputToRun(B,S,M.VSBuffer.fromString(V),q&&c.location.from(q),re&&o.TestId.fromExtHostTestItem(re,O).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(B,S),this.tasks.delete(S),this.isRunning||this.dispose())}};return this.tasks.set(S,{run:$,coverage:x}),this.proxy.$startedTestRunTask(B,{id:S,name:A,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(A){if(!(A instanceof l.TestItemImpl))throw new l.InvalidTestItemError(A.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(A,this.dto.controllerId).toString()))return;const B=[],O=this.dto.colllection.root;for(;;){const S=c.TestItem.from(A);if(B.unshift(S),this.sharedTestIds.has(S.extId)||(this.sharedTestIds.add(S.extId),A===O))break;A=A.parent||O}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class v{constructor(A){this.proxy=A,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(A,B,O){return this.getTracker(A,B,O)}cancelRunById(A){for(const B of this.tracked.values())if(B.id===A){B.dispose();return}}cancelAllRuns(){for(const A of this.tracked.values())A.dispose()}createTestRun(A,B,O,S,x){const N=this.tracked.get(O);if(N)return N.createRun(S);const j=i.fromPublic(A,B,O,x),W=s(O);this.proxy.$startedExtensionTestRun({controllerId:A,profile:W&&{group:y[W.kind],id:W.profileId},exclude:O.exclude?.map(V=>V.id)??[],id:j.id,include:O.include?.map(V=>V.id)??[B.root.id],persist:x});const $=this.getTracker(O,j);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(j.id)),$.createRun(S)}getTracker(A,B,O){const S=new r(B,this.proxy,O);return this.tracked.set(A,S),S.onEnd(()=>this.tracked.delete(A)),S}}e.TestRunCoordinator=v;const s=R=>{if(!!R.profile){if(!(R.profile instanceof h))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class i{constructor(A,B,O,S,x,N){this.controllerId=A,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=O.map(j=>j+"\0"),this.excludePrefix=S.map(j=>j+"\0")}static fromPublic(A,B,O,S){return new i(A,(0,_.generateUuid)(),O.include?.map(x=>o.TestId.fromExtHostTestItem(x,A).toString())??[A],O.exclude?.map(x=>o.TestId.fromExtHostTestItem(x,A).toString())??[],S,B)}static fromInternal(A,B){return new i(A.controllerId,A.runId,A.testIds,A.excludeExtIds,!0,B)}isIncluded(A){const B=o.TestId.fromExtHostTestItem(A,this.controllerId).toString()+"\0";for(const O of this.excludePrefix)if(B===O||B.startsWith(O))return!1;for(const O of this.includePrefix)if(B===O||B.startsWith(O))return!0;return!1}}e.TestRunDto=i;class m{constructor(A,B,O){this.proxy=A,this.runId=B,this.taskId=O}set coverageProvider(A){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!A||(this._coverageProvider=A,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(A){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(A))());try{return(await this.fileCoverage)?.map(c.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(A,B){const O=await this.fileCoverage;let S=O?.[A];return!this._coverageProvider||!O||!S?[]:(S.detailedCoverage||(S=O[A]=await this._coverageProvider.resolveFileCoverage?.(S,B)??S),S.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class a extends w.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,c.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:B,removed:O}=this;return{get added(){return[...A].map(S=>S.revived)},get updated(){return[...B].map(S=>S.revived)},get removed(){return[...O].map(S=>S.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class g extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new I.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,B){return{...A,revived:c.TestItem.toPlain(A.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=g;class b{constructor(A){this.proxy=A}checkout(){this.current||(this.current=this.createObserverData());const A=this.current;return A.observers++,{onDidChangeTest:A.tests.onDidChangeTests,get tests(){return[...A.tests.rootTests].map(B=>B.revived)},dispose:(0,F.once)(()=>{--A.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(A){return this.current?.tests.getMirroredTestDataByReference(A)}applyDiff(A){this.current?.tests.apply(A)}createObserverData(){const A=new g;return this.proxy.$subscribeToDiffs(),{observers:0,tests:A}}}class h{constructor(A,B,O,S,x,N,j=!1,W=void 0){this.controllerId=B,this.profileId=O,this._label=S,this.kind=x,this.runHandler=N,this._isDefault=j,this._tag=W,f.set(this,void 0),Ze(this,f,A,"f");const $=y[x];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Te(this,f,"f").$publishTestRunProfile({profileId:O,controllerId:B,tag:W?c.TestTag.namespace(this.controllerId,W.id):null,label:S,group:$,isDefault:j,hasConfigurationHandler:!1})}get label(){return this._label}set label(A){A!==this._label&&(this._label=A,Te(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:A}))}get isDefault(){return this._isDefault}set isDefault(A){A!==this._isDefault&&(this._isDefault=A,Te(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:A}))}get tag(){return this._tag}set tag(A){A?.id!==this._tag?.id&&(this._tag=A,Te(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:A?c.TestTag.namespace(this.controllerId,A.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(A){A!==this._configureHandler&&(this._configureHandler=A,Te(this,f,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!A}))}dispose(){Te(this,f,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=h,f=new WeakMap;const y={[p.TestRunProfileKind.Coverage]:8,[p.TestRunProfileKind.Debug]:4,[p.TestRunProfileKind.Run]:2}}),define(we[210],be([0,1,3,15,5,93,8,7]),function(ne,e,u,M,E,I,F,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class C{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new u.Emitter,this._onDidChangeTextEditorOptions=new u.Emitter,this._onDidChangeTextEditorVisibleRanges=new u.Emitter,this._onDidChangeTextEditorViewColumn=new u.Emitter,this._onDidChangeActiveTextEditor=new u.Emitter,this._onDidChangeVisibleTextEditors=new u.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(n=>n.value)}async showTextDocument(t,_,n){let d;typeof _=="number"?d={position:F.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?d={position:F.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?F.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:d={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(t.uri,d),c=l&&this._extHostDocumentsAndEditors.getEditor(l);if(c)return c.value;throw l?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new I.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const n=this._extHostDocumentsAndEditors.getEditor(t);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const d=_.selections.selections.map(F.Selection.to);n._acceptSelections(d)}if(_.visibleRanges){const d=M.coalesce(_.visibleRanges.map(F.Range.to));n._acceptVisibleRanges(d)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:F.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const d=T.TextEditorSelectionChangeKind.fromValue(_.selections.source),l=_.selections.selections.map(F.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:l,kind:d})}if(_.visibleRanges){const d=M.coalesce(_.visibleRanges.map(F.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const _ in t){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const d=F.ViewColumn.to(t[_]);n.value.viewColumn!==d&&(n._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=C}),define(we[211],be([0,1,2,4,5,6,7]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class T{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const d=n.uri===void 0?void 0:u.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(C(d))?.get(n.handle)}return n}})}async $getTimeline(t,_,n,d,l){return this._providers.get(t)?.provideTimeline(u.URI.revive(_),n,d,l)}registerTimelineProvider(t,_,n,d){const l=new I.DisposableStore,c=this.convertTimelineItem(_.id,d,l).bind(this);let p;_.onDidChange&&(p=_.onDidChange(w=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...w,id:_.id}),this));const D=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(w,o,f,k){k?.resetCache&&(l.clear(),D.get(_.id)?.clear());const r=await _.provideTimeline(w,o,f);if(r==null)return;const v=c(w,k);return{...r,source:_.id,items:r.items.map(v)}},dispose(){for(const w of D.values())w.get(_.id)?.clear();p?.dispose(),l.dispose()}})}convertTimelineItem(t,_,n){return(d,l)=>{let c;if(l?.cacheResults){let p=this._itemsBySourceAndUriMap.get(t);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(t,p));const D=C(d);c=p.get(D),c===void 0&&(c=new Map,p.set(D,c))}return p=>{const{iconPath:D,...w}=p,o=`${t}|${p.id??p.timestamp}`;c?.set(o,p);let f,k,r;return p.iconPath&&(D instanceof F.ThemeIcon?r={id:D.id,color:D.color}:u.URI.isUri(D)?(f=D,k=D):{light:f,dark:k}=D),{...w,id:w.id??void 0,handle:o,source:t,command:p.command?_.toInternal(p.command,n):void 0,icon:f,iconDark:k,themeIcon:r,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,I.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=T;function C(P){return P?.toString()}}),define(we[212],be([0,1,6,11,2,5]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class F{constructor(C){this._openers=new Map,this._proxy=C.getProxy(I.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(C,P,t,_){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const n=_.schemes.find(d=>!F.supportedSchemes.has(d));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,t),this._proxy.$registerUriOpener(P,_.schemes,C,_.label),(0,u.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(C,P,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener with id: ${C}`);const n=E.URI.revive(P);return _.canOpenExternalUri(n,t)}async $openUri(C,P,t){const _=this._openers.get(C);if(!_)throw new Error(`Unknown opener id: '${C}'`);return _.openExternalUri(E.URI.revive(P.resolvedUri),{sourceUri:E.URI.revive(P.sourceUri)},t)}}e.ExtHostUriOpeners=F,F.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(we[213],be([0,1,5,2,6,16,22]),function(ne,e,u,M,E,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(u.MainContext.MainThreadUrls)}registerUriHandler(P,t){if(this.handles.has(F.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const _=T.HandlePool++;return this.handles.add(F.ExtensionIdentifier.toKey(P)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,P),(0,E.toDisposable)(()=>{this.handles.delete(F.ExtensionIdentifier.toKey(P)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(P,t){const _=this.handlers.get(P);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(t))}catch(n){(0,I.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(P){return M.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=T,T.HandlePool=0});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[52],be([0,1,3,11,2,139,160,67,5]),function(ne,e,u,M,E,I,F,T,C){"use strict";var P,t,_,n,d,l,c,p,D,w,o,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class k{constructor(b,h,y,R,A,B,O){P.set(this,void 0),t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),d.set(this,void 0),l.set(this,void 0),c.set(this,""),p.set(this,void 0),D.set(this,!1),w.set(this,!1),o.set(this,!1),this._onMessageEmitter=new u.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new u.Emitter),this._onDidDispose=Te(this,f,"f").event,Ze(this,P,b,"f"),Ze(this,t,h,"f"),Ze(this,p,y,"f"),Ze(this,n,R,"f"),Ze(this,d,A,"f"),Ze(this,l,B,"f"),Ze(this,o,r(B),"f"),Ze(this,_,O,"f")}dispose(){Ze(this,D,!0,"f"),Te(this,f,"f").fire(),Te(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return Ze(this,w,!0,"f"),(0,T.asWebviewUri)(b,Te(this,n,"f").remote)}get cspSource(){const b=Te(this,l,"f").extensionLocation;if(b.scheme===M.Schemas.https||b.scheme===M.Schemas.http){let h=b.toString();return h.endsWith("/")||(h+="/"),h+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,c,"f")}set html(b){this.assertNotDisposed(),Te(this,c,"f")!==b&&(Ze(this,c,b,"f"),!Te(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(Ze(this,w,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,t,"f").$setHtml(Te(this,P,"f"),b))}get options(){return this.assertNotDisposed(),Te(this,p,"f")}set options(b){this.assertNotDisposed(),Te(this,t,"f").$setOptions(Te(this,P,"f"),i(Te(this,l,"f"),Te(this,d,"f"),b)),Ze(this,p,b,"f")}async postMessage(b){if(Te(this,D,"f"))return!1;const h=(0,F.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Te(this,o,"f")});return Te(this,t,"f").$postMessage(Te(this,P,"f"),h.message,...h.buffers)}assertNotDisposed(){if(Te(this,D,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=k,P=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,l=new WeakMap,c=new WeakMap,p=new WeakMap,D=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap;function r(g){try{const b=(0,I.normalizeVersion)((0,I.parseVersion)(g.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class v{constructor(b,h,y,R,A){this.initData=h,this.workspace=y,this._logService=R,this._deprecationService=A,this._webviews=new Map,this._webviewProxy=b.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(b,h,...y){const R=this.getWebview(b);if(R){const{message:A}=(0,F.deserializeWebviewMessage)(h,y);R._onMessageEmitter.fire(A)}}$onMissingCsp(b,h){this._logService.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,h,y){const R=new k(b,this._webviewProxy,m(h),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(b,R),R._onDidDispose(()=>{this._webviews.delete(b)}),R}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=v;function s(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=s;function i(g,b,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||a(g,b)}}e.serializeWebviewOptions=i;function m(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(b=>E.URI.from(b))}}e.reviveOptions=m;function a(g,b){return[...(b?.getWorkspaceFolders()||[]).map(h=>h.uri),g.extensionLocation]}}),define(we[214],be([0,1,21,59,6,11,25,2,8,52,64,5,7]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(r,v){this.document=r,this._storagePath=v,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,v){await this.getEdit(r).undo(),v||this.disposeBackup()}async redo(r,v){await this.getEdit(r).redo(),v||this.disposeBackup()}disposeEdits(r){for(const v of r)this._edits.delete(v)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=f(this.document.uri)+this._backupCounter++;return(0,F.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const v=this._edits.get(r,0);if(!v)throw new Error("No edit found");return v}}class l{constructor(){this._documents=new Map}get(r,v){return this._documents.get(this.key(r,v))}add(r,v,s){const i=this.key(r,v.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${r} resource:${v.uri}`);const m=new d(v,s);return this._documents.set(i,m),m}delete(r,v){const s=this.key(r,v.uri);this._documents.delete(s)}key(r,v){return`${r}@@@${v}`}}var c;(function(k){k[k.Text=0]="Text",k[k.Custom=1]="Custom"})(c||(c={}));class p{constructor(){this._providers=new Map}addTextProvider(r,v,s){return this.add(0,r,v,s)}addCustomProvider(r,v,s){return this.add(1,r,v,s)}get(r){return this._providers.get(r)}add(r,v,s,i){if(this._providers.has(v))throw new Error(`Provider for viewType:${v} already registered`);return this._providers.set(v,{type:r,extension:s,provider:i}),new n.Disposable(()=>this._providers.delete(v))}}class D{constructor(r,v,s,i,m){this._extHostDocuments=v,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=m,this._editorProviders=new p,this._documents=new l,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,v,s,i){const m=new E.DisposableStore;return w(s)?(m.add(this._editorProviders.addTextProvider(v,r,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(r),v,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(r))):(m.add(this._editorProviders.addCustomProvider(v,r,s)),this.supportEditing(s)&&m.add(s.onDidChangeCustomDocument(a=>{const g=this.getCustomDocumentEntry(v,a.document.uri);if(o(a)){const b=g.addEdit(a);this._proxy.$onDidEdit(a.document.uri,v,b,a.label)}else this._proxy.$onContentChange(a.document.uri,v)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(r),v,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(r))),n.Disposable.from(m,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(v)}))}async $createCustomDocument(r,v,s,i,m){const a=this._editorProviders.get(v);if(!a)throw new Error(`No provider found for '${v}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${v}'`);const g=T.URI.revive(r),b=await a.provider.openCustomDocument(g,{backupId:s,untitledDocumentData:i?.buffer},m);let h;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(h=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(v,b,h),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(r,v){const s=this._editorProviders.get(v);if(!s)throw new Error(`No provider found for '${v}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${v}'`);const i=T.URI.revive(r),{document:m}=this.getCustomDocumentEntry(v,i);this._documents.delete(v,m),m.dispose()}async $resolveWebviewEditor(r,v,s,i,m,a){const g=this._editorProviders.get(s);if(!g)throw new Error(`No provider found for '${s}'`);const b=C.ViewColumn.to(m),h=this._extHostWebview.createNewWebview(v,i.webviewOptions,g.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(v,s,i.title,b,i.panelOptions,h),R=T.URI.revive(r);switch(g.type){case 1:{const{document:A}=this.getCustomDocumentEntry(s,R);return g.provider.resolveCustomEditor(A,y,a)}case 0:{const A=this._extHostDocuments.getDocument(R);return g.provider.resolveCustomTextEditor(A,y,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,v,s){this.getCustomDocumentEntry(v,r).disposeEdits(s)}async $onMoveCustomEditor(r,v,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const m=this._extHostWebviewPanels.getWebviewPanel(r);if(!m)throw new Error("No webview found");const a=T.URI.revive(v),g=this._extHostDocuments.getDocument(a);await i.provider.moveCustomTextEditor(g,m,u.CancellationToken.None)}async $undo(r,v,s,i){return this.getCustomDocumentEntry(v,r).undo(s,i)}async $redo(r,v,s,i){return this.getCustomDocumentEntry(v,r).redo(s,i)}async $revert(r,v,s){const i=this.getCustomDocumentEntry(v,r);await this.getCustomEditorProvider(v).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(r,v,s){const i=this.getCustomDocumentEntry(v,r);await this.getCustomEditorProvider(v).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(r,v,s,i){const m=this.getCustomDocumentEntry(v,r);return this.getCustomEditorProvider(v).saveCustomDocumentAs(m.document,T.URI.revive(s),i)}async $backup(r,v,s){const i=this.getCustomDocumentEntry(v,r),a=await this.getCustomEditorProvider(v).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(a),a.id}getCustomDocumentEntry(r,v){const s=this._documents.get(r,T.URI.revive(v));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(r){const s=this._editorProviders.get(r)?.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=D;function w(k){return typeof k.resolveCustomTextEditor=="function"}function o(k){return typeof k.undo=="function"&&typeof k.redo=="function"}function f(k){const r=k.scheme===I.Schemas.file||k.scheme===I.Schemas.untitled?k.fsPath:k.toString();return(0,M.hash)(r)+""}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[215],be([0,1,3,6,2,36,8,52,5,7]),function(ne,e,u,M,E,I,F,T,C,P){"use strict";var t,_,n,d,l,c,p,D,w,o,f,k,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class v extends M.Disposable{constructor(a,g,b,h,y,R,A){super();t.set(this,void 0),_.set(this,void 0),n.set(this,void 0),d.set(this,void 0),l.set(this,void 0),c.set(this,void 0),p.set(this,void 0),D.set(this,void 0),w.set(this,!0),o.set(this,!0),f.set(this,!1),k.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,k,"f").event,r.set(this,this._register(new u.Emitter)),this.onDidChangeViewState=Te(this,r,"f").event,Ze(this,t,a,"f"),Ze(this,_,g,"f"),Ze(this,n,b,"f"),Ze(this,l,R,"f"),Ze(this,D,y,"f"),Ze(this,c,h,"f"),Ze(this,d,A,"f")}dispose(){Te(this,f,"f")||(Ze(this,f,!0,"f"),Te(this,k,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,t,"f")),Te(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,d,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,c,"f")}set title(a){this.assertNotDisposed(),Te(this,c,"f")!==a&&(Ze(this,c,a,"f"),Te(this,_,"f").$setTitle(Te(this,t,"f"),a))}get iconPath(){return this.assertNotDisposed(),Te(this,p,"f")}set iconPath(a){this.assertNotDisposed(),Te(this,p,"f")!==a&&(Ze(this,p,a,"f"),Te(this,_,"f").$setIconPath(Te(this,t,"f"),E.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Te(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,D,"f")=="number"&&Te(this,D,"f")<0))return Te(this,D,"f")}get active(){return this.assertNotDisposed(),Te(this,o,"f")}get visible(){return this.assertNotDisposed(),Te(this,w,"f")}_updateViewState(a){Te(this,f,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Ze(this,o,a.active,"f"),Ze(this,w,a.visible,"f"),Ze(this,D,a.viewColumn,"f"),Te(this,r,"f").fire({webviewPanel:this}))}reveal(a,g){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,t,"f"),{viewColumn:a?F.ViewColumn.from(a):void 0,preserveFocus:!!g})}assertNotDisposed(){if(Te(this,f,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,l=new WeakMap,c=new WeakMap,p=new WeakMap,D=new WeakMap,w=new WeakMap,o=new WeakMap,f=new WeakMap,k=new WeakMap,r=new WeakMap;class s{constructor(a,g,b){this.webviews=g,this.workspace=b,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(C.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,I.generateUuid)()}createWebviewPanel(a,g,b,h,y={}){const R=typeof h=="object"?h.viewColumn:h,A={viewColumn:F.ViewColumn.from(R),preserveFocus:typeof h=="object"&&!!h.preserveFocus},B=(0,T.shouldSerializeBuffersForPostMessage)(a),O=s.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(a),O,g,{title:b,panelOptions:i(y),webviewOptions:(0,T.serializeWebviewOptions)(a,this.workspace,y),serializeBuffersForPostMessage:B},A);const S=this.webviews.createNewWebview(O,y,a);return this.createNewWebviewPanel(O,g,b,R,y,S)}$onDidChangeWebviewPanelViewStates(a){const g=Object.keys(a);g.sort((b,h)=>{const y=a[b],R=a[h];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const b of g){const h=this.getWebviewPanel(b);if(!h)continue;const y=a[b];h._updateViewState({active:y.active,visible:y.visible,viewColumn:F.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,g,b){if(this._serializers.has(g))throw new Error(`Serializer for '${g}' already registered`);return this._serializers.set(g,{serializer:b,extension:a}),this._proxy.$registerSerializer(g,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(a)}),new P.Disposable(()=>{this._serializers.delete(g),this._proxy.$unregisterSerializer(g)})}async $deserializeWebviewPanel(a,g,b,h){const y=this._serializers.get(g);if(!y)throw new Error(`No serializer found for '${g}'`);const{serializer:R,extension:A}=y,B=this.webviews.createNewWebview(a,b.webviewOptions,A),O=this.createNewWebviewPanel(a,g,b.title,h,b.panelOptions,B);await R.deserializeWebviewPanel(O,b.state)}createNewWebviewPanel(a,g,b,h,y,R){const A=new v(a,this._proxy,g,b,h,y,R);return this._webviewPanels.set(a,A),A}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=s;function i(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[216],be([0,1,3,6,52,5,7]),function(ne,e,u,M,E,I,F){"use strict";var T,C,P,t,_,n,d,l,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends M.Disposable{constructor(f,k,r,v,s,i){super();T.set(this,void 0),C.set(this,void 0),P.set(this,void 0),t.set(this,void 0),_.set(this,!1),n.set(this,void 0),d.set(this,void 0),l.set(this,void 0),c.set(this,this._register(new u.Emitter)),this.onDidChangeVisibility=Te(this,c,"f").event,p.set(this,this._register(new u.Emitter)),this.onDidDispose=Te(this,p,"f").event,Ze(this,P,r,"f"),Ze(this,d,v,"f"),Ze(this,T,f,"f"),Ze(this,C,k,"f"),Ze(this,t,s,"f"),Ze(this,n,i,"f")}dispose(){Te(this,_,"f")||(Ze(this,_,!0,"f"),Te(this,p,"f").fire(),Te(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,d,"f")}set title(f){this.assertNotDisposed(),Te(this,d,"f")!==f&&(Ze(this,d,f,"f"),Te(this,C,"f").$setWebviewViewTitle(Te(this,T,"f"),f))}get description(){return this.assertNotDisposed(),Te(this,l,"f")}set description(f){this.assertNotDisposed(),Te(this,l,"f")!==f&&(Ze(this,l,f,"f"),Te(this,C,"f").$setWebviewViewDescription(Te(this,T,"f"),f))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,t,"f")}get viewType(){return Te(this,P,"f")}_setVisible(f){f===Te(this,n,"f")||Te(this,_,"f")||(Ze(this,n,f,"f"),Te(this,c,"f").fire())}show(f){this.assertNotDisposed(),Te(this,C,"f").$show(Te(this,T,"f"),!!f)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}T=new WeakMap,C=new WeakMap,P=new WeakMap,t=new WeakMap,_=new WeakMap,n=new WeakMap,d=new WeakMap,l=new WeakMap,c=new WeakMap,p=new WeakMap;class w{constructor(f,k){this._extHostWebview=k,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(I.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,k,r,v){if(this._viewProviders.has(k))throw new Error(`View provider for '${k}' already registered`);return this._viewProviders.set(k,{provider:r,extension:f}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(f),k,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new F.Disposable(()=>{this._viewProviders.delete(k),this._proxy.$unregisterWebviewViewProvider(k)})}async $resolveWebviewView(f,k,r,v,s){const i=this._viewProviders.get(k);if(!i)throw new Error(`No view provider found for '${k}'`);const{provider:m,extension:a}=i,g=this._extHostWebview.createNewWebview(f,{},a),b=new D(f,this._proxy,k,r,g,!0);this._webviewViews.set(f,b),await m.resolveWebviewView(b,{state:v},s)}async $onDidChangeWebviewViewVisibility(f,k){this.getWebviewView(f)._setVisible(k)}async $disposeWebviewView(f){const k=this.getWebviewView(f);this._webviewViews.delete(f),k.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const k=this._webviewViews.get(f);if(!k)throw new Error("No webview found");return k}}e.ExtHostWebviewViews=w}),define(we[97],be([0,1,3,5,2,11,9,4,14]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class $i{constructor(_){this._onDidChangeWindowState=new u.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let d;if(typeof _=="string"){d=_;try{_=E.URI.parse(_)}catch(l){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,F.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,d,n)}async asExternalUri(_,n){if((0,F.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(_,n);return E.URI.from(d)}};P.InitialState={focused:!0},P=xe([Be(0,C.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(we[217],be([0,1,13,23,21,16,3,6,108,184,38]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(y,R){try{return JSON.stringify(y,R)}catch(A){return"null"}}const d="$$ref$$",l={[d]:-1};class c{constructor(R,A){this.jsonString=R,this.referencedBuffers=A}}function p(y,R=null,A=!1){const B=[];return{jsonString:(A?n:JSON.stringify)(y,(S,x)=>{if(typeof x=="undefined")return l;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=B.push(x)-1;return{[d]:N}}if(R)return R(S,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=p;function D(y,R,A){return JSON.parse(y,(B,O)=>{if(O){const S=O[d];if(typeof S=="number")return R[S];if(A&&O.$mid===1)return A.transformIncoming(O)}return O})}e.parseJsonAndRestoreBufferRefs=D;function w(y,R){return JSON.stringify(y,R)}function o(y){return y?(R,A)=>A&&A.$mid===1?y.transformOutgoing(A):A:null}var f;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var k;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(k=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},v=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(R,A=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new F.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=A,this._uriTransformer=B,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let O=0,S=t.ProxyIdentifier.count;O<S;O++)this._locals[O]=null,this._proxies[O]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new u.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(O=>this._receiveOneMessage(O))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(I.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,C.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:A,sid:B}=R;return this._proxies[A]||(this._proxies[A]=this._createProxy(A,B)),this._proxies[A]}_createProxy(R,A){let B={get:(O,S)=>(typeof S=="string"&&!O[S]&&S.charCodeAt(0)===36&&(O[S]=(...x)=>this._remoteCall(R,S,x)),S===s?A:O[S])};return new Proxy(Object.create(null),B)}set(R,A){return this._locals[R.nid]=A,A}assertRegistered(R){for(let A=0,B=R.length;A<B;A++){const O=R[A];if(!this._locals[O.nid])throw new Error(`Missing actor ${O.sid} (isMain: ${O.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const A=R.byteLength,B=m.read(R,0),O=B.readUInt8(),S=B.readUInt32();switch(O){case 1:case 2:{let{rpcId:x,method:N,args:j}=g.deserializeRequestJSONArgs(B);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(A,S,x,N,j,O===2);break}case 3:case 4:{let{rpcId:x,method:N,args:j}=g.deserializeRequestMixedArgs(B);this._uriTransformer&&(j=(0,C.transformIncomingURIs)(j,this._uriTransformer)),this._receiveRequest(A,S,x,N,j,O===4);break}case 5:{this._logger&&this._logger.logIncoming(A,S,0,"ack"),this._onDidReceiveAcknowledge(S);break}case 6:{this._receiveCancel(A,S);break}case 7:{this._receiveReply(A,S,void 0);break}case 9:{let x=g.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(A,S,x);break}case 10:{const x=g.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(A,S,x);break}case 8:{let x=g.deserializeReplyOKVSBuffer(B);this._receiveReply(A,S,x);break}case 11:{let x=g.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(A,S,x);break}case 12:{this._receiveReplyErr(A,S,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,A,B,O,S,x){this._logger&&this._logger.logIncoming(R,A,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(B)}.${O}(`,S);const N=String(A);let j,W;if(x){const V=new E.CancellationTokenSource;S.push(V.token),j=this._invokeHandler(B,O,S),W=()=>V.cancel()}else j=this._invokeHandler(B,O,S),W=r;this._cancelInvokedHandlers[N]=W;const $=g.serializeAcknowledged(A);this._logger&&this._logger.logOutgoing($.byteLength,A,1,"ack"),this._protocol.send($),j.then(V=>{delete this._cancelInvokedHandlers[N];const q=g.serializeReplyOK(A,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,A,1,"reply:",V),this._protocol.send(q)},V=>{delete this._cancelInvokedHandlers[N];const q=g.serializeReplyErr(A,V);this._logger&&this._logger.logOutgoing(q.byteLength,A,1,"replyErr:",V),this._protocol.send(q)})}_receiveCancel(R,A){this._logger&&this._logger.logIncoming(R,A,1,"receiveCancel");const B=String(A);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(R,A,B){this._logger&&this._logger.logIncoming(R,A,0,"receiveReply:",B);const O=String(A);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O],S.resolveOk(B)}_receiveReplyErr(R,A,B){this._logger&&this._logger.logIncoming(R,A,0,"receiveReplyErr:",B);const O=String(A);if(!this._pendingRPCReplies.hasOwnProperty(O))return;const S=this._pendingRPCReplies[O];delete this._pendingRPCReplies[O];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),S.resolveErr(x)}_invokeHandler(R,A,B){try{return Promise.resolve(this._doInvokeHandler(R,A,B))}catch(O){return Promise.reject(O)}}_doInvokeHandler(R,A,B){const O=this._locals[R];if(!O)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(R));let S=O[A];if(typeof S!="function")throw new Error("Unknown method "+A+" on actor "+(0,t.getStringIdentifierForProxy)(R));return S.apply(O,B)}_remoteCall(R,A,B){if(this._isDisposed)return Promise.reject(I.canceled());let O=null;if(B.length>0&&E.CancellationToken.isCancellationToken(B[B.length-1])&&(O=B.pop()),O&&O.isCancellationRequested)return Promise.reject(I.canceled());const S=g.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),j=new P.LazyPromise;O&&O.onCancellationRequested(()=>{const $=g.serializeCancel(x);this._logger&&this._logger.logOutgoing($.byteLength,x,0,"cancel"),this._protocol.send(g.serializeCancel(x))}),this._pendingRPCReplies[N]=j,this._onWillSendRequest(x);const W=g.serializeRequest(x,R,A,S,!!O);return this._logger&&this._logger.logOutgoing(W.byteLength,x,0,`request: ${(0,t.getStringIdentifierForProxy)(R)}.${A}(`,B),this._protocol.send(W),j}}e.RPCProtocol=i,_=v,i.UNRESPONSIVE_TIME=3*1e3;class m{constructor(R,A){this._buff=R,this._offset=A}static alloc(R,A,B){let O=new m(M.VSBuffer.alloc(B+1+4),0);return O.writeUInt8(R),O.writeUInt32(A),O}static read(R,A){return new m(R,A)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const A=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,A}static sizeMixedArray(R){let A=0;A+=1;for(let B=0,O=R.length;B<O;B++){const S=R[B];switch(A+=1,S.type){case 1:A+=this.sizeLongString(S.value);break;case 2:A+=this.sizeVSBuffer(S.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(S.value);for(let x=0;x<S.buffers.length;++x)A+=this.sizeVSBuffer(S.buffers[x]);break;case 4:break}}return A}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let A=0,B=R.length;A<B;A++){const O=R[A];switch(O.type){case 1:this.writeUInt8(1),this.writeLongString(O.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(O.value);break;case 3:this.writeUInt8(3),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let S=0;S<O.buffers.length;++S)this.writeBuffer(O.buffers[S]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let A=new Array(R);for(let B=0;B<R;B++)switch(this.readUInt8()){case 1:A[B]=this.readLongString();break;case 2:A[B]=this.readVSBuffer();break;case 3:const S=this.readUInt32(),x=this.readLongString(),N=[];for(let j=0;j<S;++j)N.push(this.readVSBuffer());A[B]=new t.SerializableObjectWithBuffers(D(x,N,null));break;case 4:A[B]=void 0;break}return A}}m.sizeUInt32=4;var a;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(a||(a={}));class g{static _useMixedArgSerialization(R){for(let A=0,B=R.length;A<B;A++)if(R[A]instanceof M.VSBuffer||R[A]instanceof t.SerializableObjectWithBuffers||typeof R[A]=="undefined")return!0;return!1}static serializeRequestArguments(R,A){if(this._useMixedArgSerialization(R)){const B=[];for(let O=0,S=R.length;O<S;O++){const x=R[O];if(x instanceof M.VSBuffer)B[O]={type:2,value:x};else if(typeof x=="undefined")B[O]={type:4};else if(x instanceof t.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:j}=p(x.value,A);B[O]={type:3,value:M.VSBuffer.fromString(N),buffers:j}}else B[O]={type:1,value:M.VSBuffer.fromString(w(x,A))}}return{type:1,args:B}}return{type:0,args:w(R,A)}}static serializeRequest(R,A,B,O,S){switch(O.type){case 0:return this._requestJSONArgs(R,A,B,O.args,S);case 1:return this._requestMixedArgs(R,A,B,O.args,S)}}static _requestJSONArgs(R,A,B,O,S){const x=M.VSBuffer.fromString(B),N=M.VSBuffer.fromString(O);let j=0;j+=m.sizeUInt8(),j+=m.sizeShortString(x),j+=m.sizeLongString(N);let W=m.alloc(S?2:1,R,j);return W.writeUInt8(A),W.writeShortString(x),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(R){const A=R.readUInt8(),B=R.readShortString(),O=R.readLongString();return{rpcId:A,method:B,args:JSON.parse(O)}}static _requestMixedArgs(R,A,B,O,S){const x=M.VSBuffer.fromString(B);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(x),N+=m.sizeMixedArray(O);let j=m.alloc(S?4:3,R,N);return j.writeUInt8(A),j.writeShortString(x),j.writeMixedArray(O),j.buffer}static deserializeRequestMixedArgs(R){const A=R.readUInt8(),B=R.readShortString(),O=R.readMixedArray(),S=new Array(O.length);for(let x=0,N=O.length;x<N;x++){const j=O[x];typeof j=="string"?S[x]=JSON.parse(j):S[x]=j}return{rpcId:A,method:B,args:S}}static serializeAcknowledged(R){return m.alloc(5,R,0).buffer}static serializeCancel(R){return m.alloc(6,R,0).buffer}static serializeReplyOK(R,A,B){if(typeof A=="undefined")return this._serializeReplyOKEmpty(R);if(A instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,A);if(A instanceof t.SerializableObjectWithBuffers){const{jsonString:O,referencedBuffers:S}=p(A.value,B,!0);return this._serializeReplyOKJSONWithBuffers(R,O,S)}else return this._serializeReplyOKJSON(R,n(A,B))}static _serializeReplyOKEmpty(R){return m.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,A){let B=0;B+=m.sizeVSBuffer(A);let O=m.alloc(8,R,B);return O.writeVSBuffer(A),O.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,A){const B=M.VSBuffer.fromString(A);let O=0;O+=m.sizeLongString(B);let S=m.alloc(9,R,O);return S.writeLongString(B),S.buffer}static _serializeReplyOKJSONWithBuffers(R,A,B){const O=M.VSBuffer.fromString(A);let S=0;S+=m.sizeUInt32,S+=m.sizeLongString(O);for(const N of B)S+=m.sizeVSBuffer(N);let x=m.alloc(10,R,S);x.writeUInt32(B.length),x.writeLongString(O);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(R){const A=R.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(R,A){const B=R.readUInt32(),O=R.readLongString(),S=[];for(let x=0;x<B;++x)S.push(R.readVSBuffer());return new t.SerializableObjectWithBuffers(D(O,S,A))}static serializeReplyErr(R,A){return A?this._serializeReplyErrEror(R,A):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,A){const B=M.VSBuffer.fromString(n(I.transformErrorForSerialization(A),null));let O=0;O+=m.sizeLongString(B);let S=m.alloc(11,R,O);return S.writeLongString(B),S.buffer}static deserializeReplyErrError(R){const A=R.readLongString();return JSON.parse(A)}static _serializeReplyErrEmpty(R){return m.alloc(12,R,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var h;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(h||(h={}))}),define(we[218],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const u=function(I){const F=T=>{self.removeEventListener("message",F);const C=T.data;Object.defineProperties(self,{postMessage:{value(P,t){C.postMessage(P,t)}},onmessage:{get(){return C.onmessage},set(P){C.onmessage=P}}}),C.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),C.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(I)};self.addEventListener("message",F)}.toString();class M extends EventTarget{constructor(I,F,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const C=`((${u})('${F}'))`,P=new Blob([C],{type:"application/javascript"}),t=URL.createObjectURL(P),_=new MessageChannel,n=t,d={type:"_newWorker",id:n,port:_.port2,url:t,options:T};I(d,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:n};_.port1.postMessage(l),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(l){_.port1.onmessage=l}},onmessageerror:{get(){return _.port1.onmessageerror},set(l){_.port1.onmessageerror=l}}}),_.port1.addEventListener("messageerror",l=>{const c=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(c)}),_.port1.addEventListener("message",l=>{const c=new MessageEvent("message",{data:l.data});this.dispatchEvent(c)}),_.port1.start()}}e.NestedWorker=M}),define(we[219],be([0,1,4]),function(ne,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,u.createDecorator)("remoteAgentService")}),define(we[220],be([0,1,11,17,26,2,4,63,48,180,219]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,F.createDecorator)("pathService");let _=class Wi{constructor(d,l,c,p){this.localUserHome=d,this.remoteAgentService=l,this.environmentService=c,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const D=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=D?.userHome||d})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,l){if(d.remoteAuthority)return u.Schemas.vscodeRemote;const c=(0,T.getVirtualWorkspaceScheme)(l.getWorkspace());if(c)return c;const p=l.getWorkspace().folders[0];if(p)return p.uri.scheme;const D=l.getWorkspace().configuration;return D?D.scheme:u.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?M.win32:M.posix)}async fileURI(d){let l="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const p=d.indexOf("/",2);p===-1?(l=d.substring(2),d="/"):(l=d.substring(2,p),d=d.substring(p)||"/")}return I.URI.from({scheme:u.Schemas.file,authority:l,path:d,query:"",fragment:""})}};_=xe([Be(1,t.IRemoteAgentService),Be(2,P.IWorkbenchEnvironmentService),Be(3,C.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(we[98],be([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class u{constructor(F,T){this.line=F,this.character=T}isBefore(F){return!1}isBeforeOrEqual(F){return!1}isAfter(F){return!1}isAfterOrEqual(F){return!1}isEqual(F){return!1}compareTo(F){return 0}translate(F,T){return new u(0,0)}with(F){return new u(0,0)}}e.Position=u;class M{constructor(F,T,C,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(F,T),this.end=new u(C,P)}contains(F){return!1}isEqual(F){return!1}intersection(F){}union(F){return new M(0,0,0,0)}with(F){return new M(0,0,0,0)}}e.Range=M;var E;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],be([0,1,15,28,24,43,9,4,17,16,98,10]),function(ne,e,u,M,E,I,F,T,C,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",d=" characters skipped \u27EB",l=(n.length+d.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var c;(function($){$[$.file=0]="file",$[$.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var p;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(p=e.QueryType||(e.QueryType={}));function D($){return!!$.preview}e.resultIsMatch=D;function w($){return!!$.resource}e.isFileMatch=w;function o($){return!!$.message}e.isProgressMessage=o;var f;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class k{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=k;class r{constructor(V,q,re){this.ranges=q;const ae=Array.isArray(q)?q:[q];if(re&&re.matchLines===1&&v(ae)){V=(0,F.getNLines)(V,re.matchLines);let pe="",me=0,Fe=0;const Ye=Math.floor(re.charsPerLine/5),Ue=[];for(const Ve of ae){const Je=Math.max(Ve.startColumn-Ye,0),je=Ve.startColumn+re.charsPerLine;if(Je>Fe+Ye+l){const Qe=n+(Je-Fe)+d;pe+=Qe+V.slice(Je,je),me+=Je-(Fe+Qe.length)}else pe+=V.slice(Fe,je);Ue.push(new i(0,Ve.startColumn-me,Ve.endColumn-me)),Fe=je}this.preview={text:pe,matches:Array.isArray(this.ranges)?Ue:Ue[0]}}else{const pe=Array.isArray(q)?q[0].startLineNumber:q.startLineNumber;this.preview={text:V,matches:(0,u.mapArrayOrNot)(q,me=>new s(me.startLineNumber-pe,me.startColumn,me.endLineNumber-pe,me.endColumn))}}}}e.TextSearchMatch=r;function v($){const V=$[0].startLineNumber;for(const q of $)if(q.startLineNumber!==V||q.endLineNumber!==V)return!1;return!0}class s{constructor(V,q,re,ae){this.startLineNumber=V,this.startColumn=q,this.endLineNumber=re,this.endColumn=ae}}e.SearchRange=s;class i extends s{constructor(V,q,re){super(V,q,V,re)}}e.OneLineRange=i;var m;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function a($,V=!0){const q=$&&$.files&&$.files.exclude,re=V&&$&&$.search&&$.search.exclude;if(!q&&!re)return;if(!q||!re)return q||re;let ae=Object.create(null);return ae=E.mixin(ae,E.deepClone(q)),ae=E.mixin(ae,E.deepClone(re),!0),ae}e.getExcludes=a;function g($,V){return $.excludePattern&&M.match($.excludePattern,V)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&M.match($.includePattern,V)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(q=>{const re=q.folder.fsPath;if(I.isEqualOrParent(V,re)){const ae=C.relative(re,V);return!q.includePattern||!!M.match(q.includePattern,ae)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var b;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class h extends Error{constructor(V,q){super(V);this.code=q}}e.SearchError=h;function y($){const V=$.message;if((0,P.isPromiseCanceledError)($))return new h(V,b.canceled);try{const q=JSON.parse(V);return new h(q.message,q.code)}catch(q){return new h(V,b.other)}}e.deserializeSearchError=y;function R($){const V={message:$.message,code:$.code};return new Error(JSON.stringify(V))}e.serializeSearchError=R;function A($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=A;function B($){return $.type==="success"}e.isSerializedSearchSuccess=B;function O($){return!!$.path}e.isSerializedFileMatch=O;function S($,V){const q=$.searchPath?$.searchPath:$.relativePath;return(0,F.fuzzyContains)(q,V)}e.isFilePatternMatch=S;class x{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N($,V){const q={...$||{},...V||{}};return Object.keys(q).filter(re=>{const ae=q[re];return typeof ae=="boolean"&&ae})}e.resolvePatternsForProvider=N;class j{constructor(V,q){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...q.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let re=V.includePattern;q.includePattern&&(re?re={...re,...q.includePattern}:re=q.includePattern),re&&(this._parsedIncludeExpression=M.parse(re))}matchesExcludesSync(V,q,re){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,q,re))}includedInQuerySync(V,q,re){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,q,re)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,q,re))}includedInQuery(V,q,re){const ae=this._parsedExcludeExpression(V,q,re),pe=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,q,re):!0;return(0,_.isPromise)(ae)?ae.then(me=>me?!1:pe()):pe()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=j;function W($){for(const V in $)if(typeof $[V]!="boolean")return!0;return!1}}),define(we[31],be([0,1,15,13,21,3,20,11,75,25,9,10,2,131,4,12,145,48,30,27,14,7,41,5]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o,f,k,r,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,A,B){return new P.ExtUri(O=>g(O,B)).isEqual(R,A)}function i(R,A,B){return s(R.uri,A.uri,B)?0:(0,t.compare)(R.uri.toString(),A.uri.toString())}function m(R,A,B){return R.index!==A.index?R.index<A.index?-1:1:s(R.uri,A.uri,B)?(0,t.compare)(R.name,A.name):(0,t.compare)(R.uri.toString(),A.uri.toString())}function a(R,A,B,O){const S=R.slice(0).sort((N,j)=>B(N,j,O)),x=A.slice(0).sort((N,j)=>B(N,j,O));return(0,u.delta)(S,x,(N,j)=>B(N,j,O))}function g(R,A){const B=A.getCapabilities(R.scheme);return!(B&&B&1024)}class b extends D.Workspace{constructor(A,B,O,S,x,N,j){super(A,O.map(W=>new D.WorkspaceFolder(W)),S,x,j);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=F.TernarySearchTree.forUris(j),O.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(A,B,O,S){if(!A)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:j,configuration:W,transient:$,isUntitled:V}=A,q=[],re=B;B?j.forEach((Fe,Ye)=>{const Ue=n.URI.revive(Fe.uri),Ve=b._findFolder(O||B,Ue,S);Ve?(Ve.name=Fe.name,Ve.index=Fe.index,q.push(Ve)):q.push({uri:Ue,name:Fe.name,index:Ye})}):q.push(...j.map(({uri:Fe,name:Ye,index:Ue})=>({uri:n.URI.revive(Fe),name:Ye,index:Ue}))),q.sort((Fe,Ye)=>Fe.index<Ye.index?-1:1);const ae=new b(x,N,q,!!$,W?n.URI.revive(W):null,!!V,Fe=>g(Fe,S)),{added:pe,removed:me}=a(re?re.workspaceFolders:[],ae.workspaceFolders,i,S);return{workspace:ae,added:pe,removed:me}}static _findFolder(A,B,O){for(let S=0;S<A.folders.length;S++){const x=A.workspaceFolders[S];if(s(x.uri,B,O))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(A,B){return B&&this._structure.get(A)&&(A=(0,P.dirname)(A)),this._structure.findSubstr(A)}resolveWorkspaceFolder(A){return this._structure.get(A)}}let h=class{constructor(A,B,O,S){this._onDidChangeWorkspace=new I.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new I.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=S,this._extHostFileSystemInfo=O,this._requestIdProvider=new C.Counter,this._barrier=new M.Barrier,this._proxy=A.getProxy(v.MainContext.MainThreadWorkspace),this._messageService=A.getProxy(v.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new b(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>g(N,O)):void 0}$initializeWorkspace(A,B){this._trusted=B,this.$acceptWorkspaceData(A),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:T.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(A,B,O,...S){const x=[];if(Array.isArray(S)&&S.forEach(V=>{n.URI.isUri(V.uri)&&!x.some(q=>s(q.uri,V.uri,this._extHostFileSystemInfo))&&x.push({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[B,O].some(V=>typeof V!="number"||V<0)||O===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+O>N.length)return!1;const j=N.slice(0);j.splice(B,O,...x.map(V=>({uri:V.uri,name:V.name||(0,P.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<j.length;V++){const q=j[V];if(j.some((re,ae)=>ae!==V&&s(q.uri,re.uri,this._extHostFileSystemInfo)))return!1}j.forEach((V,q)=>V.index=q);const{added:W,removed:$}=a(N,j,m,this._extHostFileSystemInfo);if(W.length===0&&$.length===0)return!1;if(this._proxy){const V=A.displayName||A.name;this._proxy.$updateWorkspaceFolders(V,B,O,x).then(void 0,q=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(p.Severity.Error,(0,d.localize)(0,null,V,q.toString()),{extension:A},[])})}return this.trySetWorkspaceFolders(j),!0}getWorkspaceFolder(A,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,B)}async getWorkspaceFolder2(A,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(A,B)}async resolveWorkspaceFolder(A){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(A)}getPath(){if(!this._actualWorkspace)return;const{folders:A}=this._actualWorkspace;if(A.length!==0)return A[0].uri.fsPath}getRelativePath(A,B){let O,S="";if(typeof A=="string"?(O=n.URI.file(A),S=A):typeof A!="undefined"&&(O=A,S=A.fsPath),!O)return S;const x=this.getWorkspaceFolder(O,!0);if(!x)return S;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,P.relativePath)(x.uri,O);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(A){this._actualWorkspace&&(this._unconfirmedWorkspace=b.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:A,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(A){const{workspace:B,added:O,removed:S}=b.toExtHostWorkspace(A,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:O,removed:S}))}findFiles(A,B,O,S,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${S.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:j,folder:W}=y(A);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(j),(0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(O),x).then($=>Array.isArray($)?$.map(V=>n.URI.revive(V)):[])}async findTextInFiles(A,B,O,S,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${S.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),j=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:W,folder:$}=y(B.include),V=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,q={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:j,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:W,excludePattern:V},re=!1;if(this._activeSearchCallbacks[N]=ae=>{if(re)return;const pe=n.URI.revive(ae.resource);ae.results.forEach(me=>{(0,r.resultIsMatch)(me)?O({uri:pe,preview:{text:me.preview.text,matches:(0,u.mapArrayOrNot)(me.preview.matches,Fe=>new k.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,u.mapArrayOrNot)(me.ranges,Fe=>new k.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):O({uri:pe,text:me.text,lineNumber:me.lineNumber})})},x.isCancellationRequested)return{};try{const ae=await this._proxy.$startTextSearch(A,(0,_.withUndefinedAsNull)($),q,N,x);return delete this._activeSearchCallbacks[N],ae||{}}catch(ae){throw delete this._activeSearchCallbacks[N],ae}}$handleTextSearchResult(A,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](A)}saveAll(A){return this._proxy.$saveAll(A)}resolveProxy(A){return this._proxy.$resolveProxy(A)}get trusted(){return this._trusted}requestWorkspaceTrust(A){return this._proxy.$requestWorkspaceTrust(A)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};h=xe([Be(0,f.IExtHostRpcService),Be(1,o.IExtHostInitDataService),Be(2,w.IExtHostFileSystemInfo),Be(3,c.ILogService)],h),e.ExtHostWorkspace=h,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function y(R){let A,B;return R&&(typeof R=="string"?A=R:(A=R.pattern,B=R.baseFolder||n.URI.file(R.base))),{includePattern:A,folder:B}}}),define(we[32],be([0,1,24,3,31,5,7,148,62,10,13,4,14,12,2]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function c(v,s){if(s){const i=s.split(".");let m=v;for(let a=0;m&&a<i.length;a++)m=m[i[a]];return m}}function p(v){return v instanceof l.URI}function D(v){return v&&v.uri instanceof l.URI&&v.languageId&&typeof v.languageId=="string"}function w(v){return v&&!v.uri&&v.languageId&&typeof v.languageId=="string"}function o(v){return v&&v.uri instanceof l.URI&&(!v.name||typeof v.name=="string")&&(!v.index||typeof v.index=="number")}function f(v){if(p(v))return{resource:v};if(D(v))return{resource:v.uri,overrideIdentifier:v.languageId};if(w(v))return{overrideIdentifier:v.languageId};if(o(v))return{resource:v.uri};if(v===null)return{resource:null}}let k=class{constructor(s,i,m){this._proxy=s.getProxy(I.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=m,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new r(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(m=>m.$acceptConfigurationChanged(s,i))}};k=xe([Be(0,n.IExtHostRpcService),Be(1,E.IExtHostWorkspace),Be(2,d.ILogService)],k),e.ExtHostConfiguration=k;class r{constructor(s,i,m,a){this._onDidChangeConfiguration=new M.Emitter,this._proxy=s,this._logService=a,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(m),this._configurationScopes=this._toMap(m.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const m={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,m))}getConfiguration(s,i,m){const a=f(i)||{},g=this._toReadonlyValue(s?c(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,a,m?.identifier);function b(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case F.ConfigurationTarget.Global:return 1;case F.ConfigurationTarget.Workspace:return 4;case F.ConfigurationTarget.WorkspaceFolder:return 5}}const h={has(y){return typeof c(g,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(s?`${s}.${y}`:y,a,m?.identifier);let A=c(g,y);if(typeof A=="undefined")A=R;else{let B;const O=(S,x)=>{let N;const j=()=>{B=B||(0,u.deepClone)(g),N=N||c(B,x)};return(0,P.isObject)(S)?new Proxy(S,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return j(),()=>N;if(B)return N=N||c(B,x),N[$];const V=W[$];return typeof $=="string"?O(V,`${x}.${$}`):V},set:(W,$,V)=>(j(),N&&(N[$]=V),!0),deleteProperty:(W,$)=>(j(),N&&delete N[$],!0),defineProperty:(W,$,V)=>(j(),N&&Object.defineProperty(N,$,V),!0)}):S};A=O(A,y)}return A},update:(y,R,A,B)=>{y=s?`${s}.${y}`:y;const O=b(A);return R!==void 0?this._proxy.$updateConfigurationOption(O,y,R,a,B):this._proxy.$removeConfigurationOption(O,y,a,B)},inspect:y=>{y=s?`${s}.${y}`:y;const R=(0,u.deepClone)(this._configuration.inspect(y,a,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof g=="object"&&(0,u.mixin)(h,g,!1),Object.freeze(h)}_toReadonlyValue(s){const i=m=>(0,P.isObject)(m)?new Proxy(m,{get:(a,g)=>i(a[g]),set:(a,g,b)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(a,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(a,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):m;return i(s)}_validateConfigurationAccess(s,i,m){const a=C.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),g=m?`[${m.value}] `:"";if(a===4){typeof i?.resource=="undefined"&&this._logService.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){i?.resource&&this._logService.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const m=new T.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,g)=>m.affectsConfiguration(a,f(g))})}_toMap(s){return s.reduce((i,m)=>(i.set(m[0],m[1]),i),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[99],be([0,1,2,13,3,5,7,31,50,32,21,40,14,27,4,11,26,12,70,170,16]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o,f){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(x){function N(W){if(W!=null)return W}x.from=N;function j(W){if(W!=null)return W}x.to=j})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var v;(function(x){function N(W){if(W!=null)return W}x.from=N;function j(W){if(W!=null)return W}x.to=j})(v=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(x){function N(W){if(W!=null)return W}x.from=N;function j(W){if(W!=null)return W}x.to=j})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N($){if($){const V=$;return V&&!!V.process}else return!1}x.is=N;function j($){if($==null)return;const V={process:$.process,args:$.args};return $.options&&(V.options=s.from($.options)),V}x.from=j;function W($){if($!=null)return new F.ProcessExecution($.process,$.args,$.options)}x.to=W})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var m;(function(x){function N(W){if(W!=null)return W}x.from=N;function j(W){if(W!=null)return W}x.to=j})(m=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function(x){function N($){if($){const V=$;return V&&(!!V.commandLine||!!V.command)}else return!1}x.is=N;function j($){if($==null)return;const V={};return $.commandLine!==void 0?V.commandLine=$.commandLine:(V.command=$.command,V.args=$.args),$.options&&(V.options=m.from($.options)),V}x.from=j;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new F.ShellExecution($.commandLine,$.options):new F.ShellExecution($.command,$.args?$.args:[],$.options)}x.to=W})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var g;(function(x){function N($){if($){let V=$;return V&&V.customExecution==="customExecution"}else return!1}x.is=N;function j($){return{customExecution:"customExecution"}}x.from=j;function W($,V){return V.get($)}x.to=W})(g=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var b;(function(x){function N(j,W){let $;return j.scope!==void 0&&typeof j.scope!="number"?$=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===F.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=o.USER_TASKS_GROUP_KEY),{id:j._id,workspaceFolder:$}}x.from=N})(b=e.TaskHandleDTO||(e.TaskHandleDTO={}));var h;(function(x){function N(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}x.from=N})(h=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(x){function N($,V){if($==null)return[];const q=[];for(let re of $){const ae=j(re,V);ae&&q.push(ae)}return q}x.fromMany=N;function j($,V){if($==null)return;let q;$.execution instanceof F.ProcessExecution?q=i.from($.execution):$.execution instanceof F.ShellExecution?q=a.from($.execution):$.execution&&$.execution instanceof F.CustomExecution&&(q=g.from($.execution));const re=r.from($.definition);let ae;return $.scope?typeof $.scope=="number"?ae=$.scope:ae=$.scope.uri:ae=F.TaskScope.Workspace,!re||!ae?void 0:{_id:$._id,definition:re,name:$.name,source:{extensionId:V.identifier.value,label:$.source,scope:ae},execution:q,isBackground:$.isBackground,group:h.from($.group),presentationOptions:v.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}x.from=j;async function W($,V,q){if($==null)return;let re;i.is($.execution)?re=i.to($.execution):a.is($.execution)?re=a.to($.execution):g.is($.execution)&&(re=g.to($._id,q));const ae=r.to($.definition);let pe;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?pe=$.source.scope:pe=await V.resolveWorkspaceFolder(u.URI.revive($.source.scope)):pe=F.TaskScope.Workspace),!ae||!pe)return;const me=new F.Task(ae,pe,$.name,$.source.label,re,$.problemMatchers);return $.isBackground!==void 0&&(me.isBackground=$.isBackground),$.group!==void 0&&(me.group=F.TaskGroup.from($.group._id),me.group&&$.group.isDefault&&(me.group=new F.TaskGroup(me.group.id,me.group.label),$.group.isDefault&&(me.group.isDefault=$.group.isDefault))),$.presentationOptions&&(me.presentationOptions=v.to($.presentationOptions)),$._id&&(me._id=$._id),$.detail&&(me.detail=$.detail),me}x.to=W})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(x){function N(W){return W}x.from=N;function j(W){if(!!W)return Object.assign(Object.create(null),W)}x.to=j})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class A{constructor(N,j,W){this._id=j,this._task=W,k.set(this,void 0),Ze(this,k,N,"f")}get task(){return this._task}terminate(){Te(this,k,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}k=new WeakMap;var B;(function(x){function N(j){return{id:j._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let O=class{constructor(N,j,W,$,V,q,re,ae){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=N.getProxy(I.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=V,this._terminalService=q,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=ae,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,j,W){if(!W)return new F.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:j,provider:W,extension:N}),this._proxy.$registerTaskProvider($,j),new F.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,j){this._proxy.$registerTaskSystem(N,j)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async j=>{const W=[];for(let $ of j){const V=await y.to($,this._workspaceProvider,this._providedCustomExecutions2);V&&W.push(V)}return W})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(j=>N.push(j)),N}terminateTask(N){if(!(N instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,j,W){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(j,await $.callback(W))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const j=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:j})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:j,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const j=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:j,exitCode:N.exitCode})}$provideTasks(N,j){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));const $=[],V=(0,M.asPromise)(()=>W.provider.provideTasks(t.CancellationToken.None)).then(q=>this.provideTasksInternal(j,$,W,q));return new Promise(q=>{V.then(re=>{Promise.all($).then(()=>{q(re)})})})}async $resolveTask(N,j){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));if(j.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await y.to(j,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const V=await W.provider.resolveTask($,t.CancellationToken.None);if(!V)return;this.checkDeprecation(V,W);const q=y.from(V,W.extension);if(!q)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(q.execution)&&await this.addCustomExecution(q,V,!0),await this.resolveTaskInternal(q)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,j,W){const $=await this._proxy.$createTaskId(N);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,j.execution)),this._providedCustomExecutions2.set($,j.execution)}async getTaskExecution(N,j){if(typeof N=="string"){const V=this._taskExecutionPromises.get(N);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let W=this._taskExecutionPromises.get(N.id);if(W)return W;const $=new Promise((V,q)=>{function re(ae,pe,me){me?V(new A(ae,pe.id,me)):q("Unexpected: Task does not exist.")}j?re(this,N,j):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(ae=>re(this,N,ae))});return this._taskExecutionPromises.set(N.id,$),$.then(V=>(this._taskExecutions.set(N.id,V),V),V=>Promise.reject(V))}checkDeprecation(N,j){N._deprecated&&this._deprecationService.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let W=this._notProvidedCustomExecutions.values(),$=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};O=xe([Be(0,n.IExtHostRpcService),Be(1,d.IExtHostInitDataService),Be(2,T.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,D.ILogService),Be(7,w.IExtHostApiDeprecationService)],O),e.ExtHostTaskBase=O;let S=class extends O{constructor(N,j,W,$,V,q,re,ae){super(N,j,W,$,V,q,re,ae);this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:p.PlatformToString(0)})}async executeTask(N,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const W=y.from(j,N);if(W===void 0)throw new Error("Task is not valid");if(g.is(W.execution))await this.addCustomExecution(W,j,!1);else throw new f.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),j);return this._proxy.$executeTask(W).catch(V=>{throw new Error(V)}),$}provideTasksInternal(N,j,W,$){const V=[];if($)for(let q of $){this.checkDeprecation(q,W),(!q.definition||!N[q.definition.type])&&this._logService.warn(`The task [${q.source}, ${q.name}] uses an undefined task type. The task will be ignored in the future.`);const re=y.from(q,W.extension);re&&g.is(re.execution)?(V.push(re),j.push(this.addCustomExecution(re,q,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:W.extension}}async resolveTaskInternal(N){if(g.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,j,W){}};S=xe([Be(0,n.IExtHostRpcService),Be(1,d.IExtHostInitDataService),Be(2,T.IExtHostWorkspace),Be(3,C.IExtHostDocumentsAndEditors),Be(4,P.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,D.ILogService),Be(7,w.IExtHostApiDeprecationService)],S),e.WorkerExtHostTask=S,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(we[221],be([0,1,15,53,28,77,20,11,17,25,9,10,2,110,135,84,48,91,220,41]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(b,h,y,R){this.configurationService=b,this.workspaceContextService=h,this.editorGroupsService=y,this.pathService=R}text(b,h,y={}){b=this.getContentPattern(b,y);const R=this.configurationService.getValue(),A=h&&h.some(O=>!this.configurationService.getValue({resource:O}).search.useRipgrep);return{...this.commonQuery(h?.map(p.toWorkspaceFolder),y),type:2,contentPattern:b,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||A||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(b,h){const y=this.configurationService.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const R={...b,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(b,h)&&(R.isCaseSensitive=!0),this.isMultiline(b)&&(R.isMultiline=!0),R}file(b,h={}){return{...this.commonQuery(b,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}handleIncludeExclude(b,h){return b?(b=Array.isArray(b)?b.map(i):i(b),h?this.parseSearchPaths(b):{pattern:r(...Array.isArray(b)?b:[b])}):{}}commonQuery(b=[],h={}){const y=this.handleIncludeExclude(h.includePattern,h.expandPatterns),R=this.handleIncludeExclude(h.excludePattern,h.expandPatterns),A=b.length>1,B=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,h,R)):b.map(x=>this.getFolderQueryForRoot(x,h,R,A))).filter(x=>!!x),O={_reason:h._reason,folderQueries:B,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=u.coalesce(u.flatten(this.editorGroupsService.groups.map(W=>W.editors.map($=>$.resource)))).filter(W=>(0,o.pathIncludedInQuery)(O,W.fsPath)),j=this.commonQueryFromFileList(N);return{...O,...j}}const S=h.extraFileResources&&h.extraFileResources.filter(x=>(0,o.pathIncludedInQuery)(O,x.fsPath));return O.extraFileResources=S&&S.length?S:void 0,O}commonQueryFromFileList(b){const h=[],y=new F.ResourceMap,R={};let A=!1;return b.forEach(B=>{if(B.scheme===T.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(B)){const S=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:C.dirname(B.fsPath)});let x=y.get(S);x||(A=!0,x={folder:S,includePattern:{}},h.push(x),y.set(S,x));const N=C.relative(S.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(A=!0,R[B.fsPath]=!0)}),{folderQueries:h,includePattern:R,usingSearchPaths:!0,excludePattern:A?void 0:{"**/*":!0}}}isCaseSensitive(b,h){if(h.isSmartCase){if(b.isRegExp){if(t.containsUppercaseCharacter(b.pattern,!0))return!0}else if(t.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}isMultiline(b){return b.isMultiline||b.isRegExp&&(0,d.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const h=j=>C.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),R=(Array.isArray(b)?b:v(b)).map(j=>{const W=this.pathService.resolvedUserHome;return W?(0,I.untildify)(j,W.scheme===T.Schemas.file?W.fsPath:W.path):j}),A=M.groupBy(R,j=>h(j)?"searchPaths":"exprSegments"),B=(A.exprSegments||[]).map(j=>t.rtrim(j,"/")).map(j=>t.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),s(j))),O={},S=this.expandSearchPathPatterns(A.searchPaths||[]);S&&S.length&&(O.searchPaths=S);const x=u.flatten(B),N=r(...x);return N&&(O.pattern=N),O}getExcludesForFolder(b,h){return h.disregardExcludeSettings?void 0:(0,o.getExcludes)(b,!h.disregardSearchExcludeSettings)}expandSearchPathPatterns(b){if(!b||!b.length)return[];const h=u.flatten(b.map(R=>{let{pathPortion:A,globPortion:B}=k(R);B&&(B=m(B));const O=this.expandOneSearchPath(A);return u.flatten(O.map(S=>this.resolveOneSearchPathPattern(S,B)))})),y=new Map;return h.forEach(R=>{const A=R.searchPath.toString(),B=y.get(A);B?R.pattern&&(B.pattern=B.pattern||{},B.pattern[R.pattern]=!0):y.set(A,{searchPath:R.searchPath,pattern:R.pattern?r(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(b){if(C.isAbsolute(b)){const h=this.workspaceContextService.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==T.Schemas.file?[{searchPath:h[0].uri.with({path:b})}]:[{searchPath:n.URI.file(C.normalize(b))}]}if(this.workspaceContextService.getWorkbenchState()===2){const h=this.workspaceContextService.getWorkspace().folders[0].uri;if(b=i(b),b.startsWith("../")||b===".."){const R=C.posix.resolve(h.path,b);return[{searchPath:h.with({path:R})}]}const y=m(b);return[{searchPath:h,pattern:y}]}else{if(b==="./"||b===".\\")return[];{const h=b.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(A=>{const B=h.match(new RegExp(`^${t.escapeRegExpCharacters(A.name)}(?:/(.*)|$)`));return B?{match:B,folder:A}:null}).filter(_.isDefined);if(R.length)return R.map(A=>{const B=A.match[1];return{searchPath:A.folder.uri,pattern:B&&m(B)}});{const A=b.match(/\.[\/\\](.+)[\/\\]?/),B=A?A[1]:b,O=l.localize(0,null,B);throw new Error(O)}}}}resolveOneSearchPathPattern(b,h){const y=b.pattern&&h?`${b.pattern}/${h}`:b.pattern||h,R=[{searchPath:b.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:b.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(b,h,y){const R=this.getFolderQueryForRoot((0,p.toWorkspaceFolder)(b.searchPath),h,y,!1);return R?{...R,includePattern:b.pattern}:null}getFolderQueryForRoot(b,h,y,R){let A;const B=n.URI.isUri(b)?b:b.uri;if(y.searchPaths){const j=y.searchPaths.filter(W=>(0,P.isEqual)(W.searchPath,B))[0];if(j&&!j.pattern)return null;j&&(A=j.pattern)}const O=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(O,h)||{},...A||{}},N=n.URI.isUri(b)?(0,P.basename)(b):b.name;return{folder:B,folderName:R?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!O.search.followSymlinks}}};f=xe([Be(0,c.IConfigurationService),Be(1,p.IWorkspaceContextService),Be(2,D.IEditorGroupsService),Be(3,w.IPathService)],f),e.QueryBuilder=f;function k(g){const b=g.match(/[\*\{\}\(\)\[\]\?]/);if(b){const h=b.index,y=g.substr(0,h).match(/[/|\\][^/\\]*$/);if(y){let R=g.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:g.substr((y.index||0)+1)}}}return{pathPortion:g}}function r(...g){return g.length?g.reduce((b,h)=>(b[h]=!0,b),Object.create(null)):void 0}function v(g){return E.splitGlobAware(g,",").map(b=>b.trim()).filter(b=>!!b.length)}function s(g){return[`**/${g}/**`,`**/${g}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function i(g){return g.replace(/\\/g,"/")}function m(g){return i(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(g,b){g=u.distinct(g,R=>R.toString());const h=[],y=b.getWorkspace();return g&&g.forEach(R=>{let A;if(b.getWorkbenchState()===2)A=(0,P.relativePath)(y.folders[0].uri,R),A&&A!=="."&&(A="./"+A);else{const B=b.getWorkspaceFolder(R);if(B){const O=B.name;if(y.folders.filter(x=>x.name===O).length===1){const x=(0,P.relativePath)(B.uri,R);x===""?A=`./${B.name}`:A=`./${B.name}/${x}`}else A=R.fsPath}}A&&h.push(A)}),h}e.resolveResourcesForSearchIncludes=a}),define(we[222],be([0,1,25,2,21,16,4,221,41,48]),function(ne,e,u,M,E,I,F,T,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(c,p){const D=p.activationEvents;if(!D)return Promise.resolve(void 0);const w=[],o=[];for(const i of D)if(/^workspaceContains:/.test(i)){const m=i.substr("workspaceContains:".length);m.indexOf("*")>=0||m.indexOf("?")>=0||c.forceUsingSearch?o.push(m):w.push(m)}if(w.length===0&&o.length===0)return Promise.resolve(void 0);let f;const k=new Promise((i,m)=>{f=i}),r=i=>f({activationEvent:i}),v=Promise.all(w.map(i=>n(c,i,r))).then(()=>{}),s=d(c,p.identifier,o,r);return Promise.all([v,s]).then(()=>{f(void 0)}),k}e.checkActivateWorkspaceContainsExtension=_;async function n(c,p,D){for(const w of c.folders)if(await c.exists(u.joinPath(M.URI.revive(w),p))){D(`workspaceContains:${p}`);return}}async function d(c,p,D,w){if(D.length===0)return Promise.resolve(void 0);const o=new E.CancellationTokenSource,f=c.checkExists(c.folders,D,o.token),k=setTimeout(async()=>{o.cancel(),w(`workspaceContainsTimeout:${D.join(",")}`)},t);let r=!1;try{r=await f}catch(v){I.isPromiseCanceledError(v)||I.onUnexpectedError(v)}o.dispose(),clearTimeout(k),r&&w(`workspaceContains:${D.join(",")}`)}function l(c,p,D,w){const o=c.get(F.IInstantiationService),f=c.get(C.ISearchService),r=o.createInstance(T.QueryBuilder).file(p.map(v=>(0,P.toWorkspaceFolder)(M.URI.revive(v))),{_reason:"checkExists",includePattern:D,exists:!0});return f.fileSearch(r,w).then(v=>!!v.limitHit,v=>I.isPromiseCanceledError(v)?!1:Promise.reject(v))}e.checkGlobFileExists=l});var Ze=this&&this.__classPrivateFieldSet||function(ne,e,u,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ne!==e||!E:!e.has(ne))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(ne,u):E?E.value=u:e.set(ne,u),u},Te=this&&this.__classPrivateFieldGet||function(ne,e,u,M){if(u==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ne!==e||!M:!e.has(ne))throw new TypeError("Cannot read private member from an object whose class did not declare it");return u==="m"?M:u==="a"?M.call(ne):M?M.value:e.get(ne)};define(we[33],be([0,1,126,17,74,25,13,6,20,2,12,5,32,183,72,31,181,16,22,23,155,7,85,4,27,73,14,61,65,40,3,222,69,157,11]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o,f,k,r,v,s,i,m,a,g,b,h,y,R,A,B){"use strict";var O,S,x;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,v.createDecorator)("IHostUtils");let N=class zi extends T.Disposable{constructor(V,q,re,ae,pe,me,Fe,Ye,Ue,Ve){super();this._onDidChangeRemoteConnectionData=this._register(new h.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=q,this._extHostContext=re,this._initData=Fe,this._extHostWorkspace=ae,this._extHostConfiguration=pe,this._logService=me,this._extHostTunnelService=Ue,this._extHostTerminalService=Ve,this._disposables=new T.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new F.Barrier,this._readyToStartExtensionHost=new F.Barrier,this._readyToRunExtensions=new F.Barrier,this._eagerExtensionsActivated=new F.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=Ye,this._instaService=V.createChild(new a.ServiceCollection([l.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const Je=new Set;this._initData.hostExtensions.forEach(je=>Je.add(w.ExtensionIdentifier.toKey(je))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(je,Qe,z)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(je,D.transformErrorForSerialization(Qe),z)},actualActivateExtension:async(je,Qe)=>{if(Je.has(w.ExtensionIdentifier.toKey(je)))return await this._mainThreadExtensionsProxy.$activateExtension(je,Qe),new d.HostExtension;const z=this._registry.getExtensionDescription(je);return this._activateExtension(z,Qe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(V){D.onUnexpectedError(V)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let V=[];try{V=this._registry.getAllExtensionDescriptions().map(pe=>pe.identifier).filter(pe=>this.isActivated(pe)).map(pe=>this._deactivate(pe))}catch(q){}await Promise.all(V)}isActivated(V){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(V):!1}_activateByEvent(V,q){return this._activator.activateByEvent(V,q)}_activateById(V,q){return this._activator.activateById(V,q)}activateByIdWithErrors(V,q){return this._activateById(V,q).then(()=>{const re=this._activator.getActivatedExtension(V);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(V=>this._registry)}getExtensionExports(V){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(V).exports:null}async _realPathExtensionUri(V){if(V.scheme!==B.Schemas.file)return V;const q=await this._hostUtils.realpath(V.fsPath);return P.URI.file(q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const V=C.TernarySearchTree.forUris(q=>I.extUriBiasedIgnorePathCase.ignorePathCasing(q));for(const q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(q)){const re=await this._realPathExtensionUri(q.extensionLocation);V.set(re,q)}return V})()),this._extensionPathIndex}_deactivate(V){let q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(V))return q;const re=this._activator.getActivatedExtension(V);if(!re)return q;try{typeof re.module.deactivate=="function"&&(q=Promise.resolve(re.module.deactivate()).then(void 0,ae=>(this._logService.error(ae),Promise.resolve(void 0))))}catch(ae){this._logService.error(ae)}try{(0,T.dispose)(re.subscriptions)}catch(ae){this._logService.error(ae)}return q}async _activateExtension(V,q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(V.identifier),this._doActivateExtension(V,q).then(re=>{const ae=re.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(V.identifier,ae.codeLoadingTime,ae.activateCallTime,ae.activateResolvedTime,q),this._logExtensionActivationTimes(V,q,"success",ae),re},re=>{throw this._logExtensionActivationTimes(V,q,"failure"),re})}_logExtensionActivationTimes(V,q,re,ae){const pe=j(V,q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...pe,...ae||{},outcome:re})}_doActivateExtension(V,q){const re=j(V,q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",re);const ae=this._getEntryPoint(V);if(!ae)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${V.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this._logService.flush();const pe=new d.ExtensionActivationTimesBuilder(q.startup);return Promise.all([this._loadCommonJSModule(V.identifier,(0,I.joinPath)(V.extensionLocation,ae),pe),this._loadExtensionContext(V)]).then(me=>(E.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),zi._callActivate(this._logService,V.identifier,me[0],me[1],pe))).then(me=>(E.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),me))}_loadExtensionContext(V){const q=new f.ExtensionGlobalMemento(V,this._storage),re=new f.ExtensionMemento(V.identifier.value,!1,this._storage),ae=new A.ExtensionSecrets(V,this._secretState),pe=V.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?k.ExtensionMode.Test:k.ExtensionMode.Development:k.ExtensionMode.Production,me=this._initData.remote.isRemote?k.ExtensionKind.Workspace:k.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([q.whenReady,re.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let Ye;return Object.freeze({globalState:q,workspaceState:re,secrets:ae,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Ue){return M.join(V.extensionLocation.fsPath,Ue)},get storagePath(){return Fe._storagePath.workspaceValue(V)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(V).fsPath},get logPath(){return M.join(Fe._initData.logsLocation.fsPath,V.identifier.value)},get logUri(){return P.URI.joinPath(Fe._initData.logsLocation,V.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(V)},get globalStorageUri(){return Fe._storagePath.globalValue(V)},get extensionMode(){return pe},get extension(){return Ye===void 0&&(Ye=new W(Fe,V.identifier,V,me)),Ye},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(V),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(V)}})})}static _callActivate(V,q,re,ae,pe){return re=re||{activate:void 0,deactivate:void 0},this._callActivateOptional(V,q,re,ae,pe).then(me=>new d.ActivatedExtension(!1,null,pe.build(),re,me,ae.subscriptions))}static _callActivateOptional(V,q,re,ae,pe){if(typeof re.activate=="function")try{pe.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${q.value}`);const me=typeof global=="object"?global:self,Fe=re.activate.apply(me,[ae]);return pe.activateCallStop(),pe.activateResolveStart(),Promise.resolve(Fe).then(Ye=>(pe.activateResolveStop(),Ye))}catch(me){return Promise.reject(me)}else return Promise.resolve(re)}_activateOneStartupFinished(V,q){this._activateById(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:q}).then(void 0,re=>{this._logService.error(re)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const V of this._registry.getAllExtensionDescriptions())if(V.activationEvents)for(const q of V.activationEvents)q==="onStartupFinished"&&this._activateOneStartupFinished(V,q)}_handleEagerExtensions(){const V=this._activateByEvent("*",!0).then(void 0,pe=>{this._logService.error(pe)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(pe=>this._handleWorkspaceContainsEagerExtensions(pe.added)));const q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],re=this._handleWorkspaceContainsEagerExtensions(q),ae=Promise.all([V,re]).then(()=>{});return Promise.race([ae,(0,F.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ae}_handleWorkspaceContainsEagerExtensions(V){return V.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(q=>this._handleWorkspaceContainsEagerExtension(V,q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(V,q){if(this.isActivated(q.identifier))return;const re=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ae={folders:V.map(me=>me.uri),forceUsingSearch:re,exists:me=>this._hostUtils.exists(me.fsPath),checkExists:(me,Fe,Ye)=>this._mainThreadWorkspaceProxy.$checkExists(me,Fe,Ye)},pe=await(0,y.checkActivateWorkspaceContainsExtension)(ae,q);if(!!pe)return this._activateById(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:pe.activationEvent}).then(void 0,me=>this._logService.error(me))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(V){throw console.error(V),V}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:q}=this._initData.environment;if(!V||!q)throw new Error(u.localize(0,null));const re=await this._loadCommonJSModule(null,q,new d.ExtensionActivationTimesBuilder(!1));if(!re||typeof re.run!="function")throw new Error(u.localize(1,null,q.toString()));return new Promise((ae,pe)=>{const me=(Ue,Ve)=>{Ue?pe(Ue):ae(typeof Ve=="number"&&Ve>0?1:0)},Fe=(0,I.originalFSPath)(q),Ye=re.run(Fe,me);Ye&&Ye.then&&Ye.then(()=>{ae(0)}).catch(Ue=>{pe(Ue.toString())})})}async $extensionTestsExit(V){this._logService.info(`Extension host terminating: test runner requested exit with code ${V}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${V}`),this._logService.flush(),this._hostUtils.exit(V)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,q){return this._resolvers[V]=q,(0,T.toDisposable)(()=>{delete this._resolvers[V]})}async _activateAndGetResolver(V){const q=V.indexOf("+");if(q===-1)throw new Error("Not an authority that can be resolved!");const re=V.substr(0,q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this._resolvers[re]}}async $resolveAuthority(V,q){const{authorityPrefix:re,resolver:ae}=await this._activateAndGetResolver(V);if(!ae)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${re}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ae)),E.mark(`code/extHost/willResolveAuthority/${re}`);const pe=await ae.resolve(V,{resolveAttempt:q});E.mark(`code/extHost/didResolveAuthorityOK/${re}`);const me={authority:V,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},Fe={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted};return{type:"ok",value:{authority:me,options:Fe,tunnelInformation:{environmentTunnels:pe.environmentTunnels}}}}catch(pe){if(E.mark(`code/extHost/didResolveAuthorityError/${re}`),pe instanceof k.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}async $getCanonicalURI(V,q){const{authorityPrefix:re,resolver:ae}=await this._activateAndGetResolver(V);if(!ae)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${re}`);const pe=P.URI.revive(q);if(typeof ae.getCanonicalURI=="undefined")return pe;const me=await(0,F.asPromise)(()=>ae.getCanonicalURI(pe));return me||pe}$startExtensionHost(V){return this._registry.keepOnly(V),this._startExtensionHost()}$activateByEvent(V,q){return q===1?this._activateByEvent(V,!1):this._readyToRunExtensions.wait().then(re=>this._activateByEvent(V,!1))}async $activate(V,q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(V)?(await this._activateById(V,q),!0):!1}async $deltaExtensions(V,q){V.forEach(ae=>ae.extensionLocation=P.URI.revive(ae.extensionLocation));const re=await this.getExtensionPathIndex();return await Promise.all(q.map(async ae=>{const pe=this._registry.getExtensionDescription(ae);pe&&re.delete(await this._realPathExtensionUri(pe.extensionLocation))})),await Promise.all(V.map(async ae=>{const pe=await this._realPathExtensionUri(ae.extensionLocation);re.set(pe,ae)})),this._registry.deltaExtensions(V,q),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){let q=o.VSBuffer.alloc(V),re=Math.random()%256;for(let ae=0;ae<V;ae++)q.writeUInt8(re,ae);return q}async $updateRemoteConnectionData(V){this._remoteConnectionData=V,this._onDidChangeRemoteConnectionData.fire()}};N=xe([Be(0,v.IInstantiationService),Be(1,e.IHostUtils),Be(2,m.IExtHostRpcService),Be(3,c.IExtHostWorkspace),Be(4,n.IExtHostConfiguration),Be(5,t.ILogService),Be(6,s.IExtHostInitDataService),Be(7,i.IExtensionStoragePaths),Be(8,g.IExtHostTunnelService),Be(9,b.IExtHostTerminalService)],N),e.AbstractExtHostExtensionService=N;function j($,V){return{id:$.identifier.value,name:$.name,extensionVersion:$.version,publisherDisplayName:$.publisher,activationEvents:$.activationEvents?$.activationEvents.join(","):null,isBuiltin:$.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}e.IExtHostExtensionService=(0,v.createDecorator)("IExtHostExtensionService");class W{constructor(V,q,re,ae){O.set(this,void 0),S.set(this,void 0),x.set(this,void 0),Ze(this,O,V,"f"),Ze(this,S,q,"f"),Ze(this,x,re.identifier,"f"),this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=M.normalize((0,I.originalFSPath)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=ae}get isActive(){return Te(this,O,"f").isActivated(Te(this,x,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,O,"f").getExtensionExports(Te(this,x,"f"))}activate(){return Te(this,O,"f").activateByIdWithErrors(Te(this,x,"f"),{startup:!1,extensionId:Te(this,S,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=W,O=new WeakMap,S=new WeakMap,x=new WeakMap}),define(we[100],be([0,1,17,2,3,13,5,7,165,31,33,50,172,32,166,14,4,10,90,71]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,p.createDecorator)("IExtHostDebugService");let f=class{constructor(g,b,h,y,R,A){this._workspaceService=b,this._extensionService=h,this._editorsService=y,this._configurationService=R,this._editorTabs=A,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=g.getProxy(F.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(O=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,b){const h=g;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,R="?";return b&&(y+=`${R}session=${encodeURIComponent(b.id)}`,R="&"),y+=`${R}ref=${h.sourceReference}`,M.URI.parse(y)}else{if(h.path)return M.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const b=[];for(const h of g.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,l.isDebuggerMainContribution)(R)&&b.push(R.type)}this._debugServiceProxy.$registerDebugTypes(b)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(b=>g.push(b)),g}addBreakpoints(g){this.startBreakpoints();const b=g.filter(R=>{const A=R.id;return this._breakpoints.has(A)?!1:(this._breakpoints.set(A,R),!0)});this.fireBreakpointChanges(b,[],[]);const h=[],y=new Map;for(const R of b)if(R instanceof T.SourceBreakpoint){let A=y.get(R.location.uri.toString());A||(A={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),A),h.push(A)),A.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof T.FunctionBreakpoint&&h.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(h)}removeBreakpoints(g){this.startBreakpoints();const b=g.filter(A=>this._breakpoints.delete(A.id));this.fireBreakpointChanges([],b,[]);const h=b.filter(A=>A instanceof T.SourceBreakpoint).map(A=>A.id),y=b.filter(A=>A instanceof T.FunctionBreakpoint).map(A=>A.id),R=b.filter(A=>A instanceof T.DataBreakpoint).map(A=>A.id);return this._debugServiceProxy.$unregisterBreakpoints(h,y,R)}startDebugging(g,b,h){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,b,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===T.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,debugUI:h.debugUI,suppressSaveBeforeStart:h.suppressSaveBeforeStart})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,b,h){if(!b)return new T.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:y,provider:b}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,h,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,y),new T.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==b),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(g,b,h){if(!h)return new T.Disposable(()=>{});if(!this.definesDebugType(g,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.getAdapterDescriptorFactoryByType(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:b,handle:y,factory:h}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(b,y),new T.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==h),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(g,b){if(!b)return new T.Disposable(()=>{});const h=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:h,factory:b}),new T.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==b)})}async $runInTerminal(g,b){return Promise.resolve(void 0)}async $substituteVariables(g,b){if(!this._variableResolver){const[R,A]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,A)}let h;const y=await this.getFolder(g);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(h,b)}createDebugAdapter(g,b){if(g.type==="implementation")return new i(g.implementation)}createSignService(){}async $startDASession(g,b){const h=this,y=await this.getSession(b);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const A=this.convertToDto(R),B=this.createDebugAdapter(A,y);if(!B)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const O=B;return this._debugAdapters.set(g,O),this.getDebugAdapterTrackers(y).then(S=>(S&&this._debugAdaptersTrackers.set(g,S),O.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,j={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(N.arguments.value);j.body={signature:W},O.sendResponse(j)}else throw new Error("no signer")}catch(W){j.success=!1,j.message=W.message,O.sendResponse(j)}}else S&&S.onDidSendMessage&&S.onDidSendMessage(x),x=(0,l.convertToVSCPaths)(x,!0),h._debugServiceProxy.$acceptDAMessage(g,x)}),O.onError(x=>{S&&S.onError&&S.onError(x),this._debugServiceProxy.$acceptDAError(g,x.name,x.message,x.stack)}),O.onExit(x=>{S&&S.onExit&&S.onExit((0,D.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,D.withNullAsUndefined)(x),void 0)}),S&&S.onWillStartSession&&S.onWillStartSession(),O.startSession()))})}$sendDAMessage(g,b){b=(0,l.convertToDAPaths)(b,!1);const h=this._debugAdaptersTrackers.get(g);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(b);const y=this._debugAdapters.get(g);y&&y.sendMessage(b)}$stopDASession(g){const b=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),b&&b.onWillStopSession&&b.onWillStopSession();const h=this._debugAdapters.get(g);return this._debugAdapters.delete(g),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const b=[],h=[],y=[];if(g.added)for(const R of g.added){const A=R.id;if(A&&!this._breakpoints.has(A)){let B;if(R.type==="function")B=new T.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")B=new T.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const O=M.URI.revive(R.uri);B=new T.SourceBreakpoint(new T.Location(O,new T.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}B._id=A,this._breakpoints.set(A,B),b.push(B)}}if(g.removed)for(const R of g.removed){const A=this._breakpoints.get(R);A&&(this._breakpoints.delete(R),h.push(A))}if(g.changed){for(const R of g.changed)if(R.id){const A=this._breakpoints.get(R.id);if(A){if(A instanceof T.FunctionBreakpoint&&R.type==="function"){const B=A;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.functionName=R.functionName}else if(A instanceof T.SourceBreakpoint&&R.type==="source"){const B=A;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.location=new T.Location(M.URI.revive(R.uri),new T.Position(R.line,R.character))}y.push(A)}}}this.fireBreakpointChanges(b,h,y)}$provideDebugConfigurations(g,b,h){return(0,I.asPromise)(async()=>{const y=this.getConfigProviderByHandle(g);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(b);return y.provideDebugConfigurations(R,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(g,b,h,y){return(0,I.asPromise)(async()=>{const R=this.getConfigProviderByHandle(g);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.getFolder(b);return R.resolveDebugConfiguration(A,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables(g,b,h,y){return(0,I.asPromise)(async()=>{const R=this.getConfigProviderByHandle(g);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.getFolder(b);return R.resolveDebugConfigurationWithSubstitutedVariables(A,h,y)})}async $provideDebugAdapter(g,b){const h=this.getAdapterDescriptorFactoryByHandle(g);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(b);return this.getAdapterDescriptor(h,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(g){const b=await this.getSession(g);this._onDidStartDebugSession.fire(b)}async $acceptDebugSessionTerminated(g){const b=await this.getSession(g);b&&(this._onDidTerminateDebugSession.fire(b),this._debugSessions.delete(b.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,b){const h=await this.getSession(g);h&&h._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(g,b){const y={session:await this.getSession(g),event:b.event,body:b.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(g){if(g instanceof T.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof T.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof T.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof T.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const b=this._adapterFactories.filter(h=>h.type===g);if(b.length>0)return b[0].factory}getAdapterDescriptorFactoryByHandle(g){const b=this._adapterFactories.filter(h=>h.handle===g);if(b.length>0)return b[0].factory}getConfigProviderByHandle(g){const b=this._configProviders.filter(h=>h.handle===g);if(b.length>0)return b[0].provider}definesDebugType(g,b){if(g.contributes){const h=g.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===b)return!0}}return!1}getDebugAdapterTrackers(g){const h=g.configuration.type,y=this._trackerFactories.filter(R=>R.type===h||R.type==="*").map(R=>(0,I.asPromise)(()=>R.factory.createDebugAdapterTracker(g)).then(A=>A,A=>null));return Promise.race([Promise.all(y).then(R=>{const A=R.filter(B=>!!B);if(A.length>0)return new s(A)}),new Promise((R,A)=>{const B=setTimeout(()=>{clearTimeout(B),A(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(g,b){const h=b.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new T.DebugAdapterServer(h));if(g){const R=await this._extensionService.getExtensionRegistry();return(0,I.asPromise)(()=>g.createDebugAdapterDescriptor(b,this.daExecutableFromPackage(b,R))).then(A=>{if(A)return A})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(b,y))}daExecutableFromPackage(g,b){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,b,h){(g.length>0||b.length>0||h.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:b,changed:h}))}async getSession(g){if(g)if(typeof g=="string"){const b=this._debugSessions.get(g);if(b)return b}else{let b=this._debugSessions.get(g.id);if(!b){const h=await this.getFolder(g.folderUri),y=g.parent?this._debugSessions.get(g.parent):void 0;b=new k(this._debugServiceProxy,g.id,g.type,g.name,h,g.configuration,y),this._debugSessions.set(b.id,b),this._debugServiceProxy.$sessionCached(b.id)}return b}throw new Error("cannot find session")}getFolder(g){if(g){const b=M.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}};f=xe([Be(0,c.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,t.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,d.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class k{constructor(g,b,h,y,R,A,B){this._debugServiceProxy=g,this._id=b,this._type=h,this._name=y,this._workspaceFolder=R,this._configuration=A,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}get parentSession(){return this._parentSession}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,b){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,b)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=k;class r{constructor(g){this.value=Object.freeze({append(b){g.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.ExtHostDebugConsole=r;class v extends n.AbstractVariableResolverService{constructor(g,b,h,y,R){function A(){if(b){const B=b.activeEditor();if(B)return B.document.uri;const O=y.tabs.filter(S=>S.isActive);if(O.length>0){const S=O[0].resource;return S&&(S.primary||S.secondary)?S.primary??S.secondary:O[0].resource}}}super({getFolderUri:B=>{const O=g.filter(S=>S.name===B);if(O&&O.length>0)return O[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(B,O)=>h.getConfiguration(void 0,B).get(O),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=A();if(B)return u.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const B=A();if(B){const O=R.getWorkspaceFolder(B);if(O)return u.normalize(O.uri.fsPath)}}},getSelectedText:()=>{if(b){const B=b.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(b){const B=b.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=v;class s{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(b=>b.onError?b.onError(g):void 0)}onExit(g,b){this.trackers.forEach(h=>h.onExit?h.onExit(g,b):void 0)}}class i extends C.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let m=class extends f{constructor(g,b,h,y,R,A){super(g,b,h,y,R,A)}createVariableResolver(g,b,h){return new v(g,b,h,this._editorTabs)}};m=xe([Be(0,c.IExtHostRpcService),Be(1,P.IExtHostWorkspace),Be(2,t.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,d.IExtHostConfiguration),Be(5,o.IExtHostEditorTabs)],m),e.WorkerExtHostDebugService=m}),define(we[223],be([0,1,74,2,5,32,94,22,14,27,4,33,90,12]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(o,f,k,r,v,s,i){this._apiFactory=o,this._extensionRegistry=f,this._instaService=k,this._extHostConfiguration=r,this._extHostExtensionService=v,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),u.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new c(this._apiFactory,f,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(p,f)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(D,f,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let f of o.nodeModuleName)this._factories.set(f,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(f=>o.alternativeModuleName(f))}};l=xe([Be(2,t.IInstantiationService),Be(3,I.IExtHostConfiguration),Be(4,_.IExtHostExtensionService),Be(5,P.IExtHostInitDataService),Be(6,d.ILogService)],l),e.RequireInterceptor=l;class c{constructor(o,f,k,r,v){this._apiFactory=o,this._extensionPaths=f,this._extensionRegistry=k,this._configProvider=r,this._logService=v,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,f){const k=this._extensionPaths.findSubstr(f);if(k){let r=this._extApiImpl.get(T.ExtensionIdentifier.toKey(k.identifier));return r||(r=this._apiFactory(k,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(k.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((v,s)=>r+=`	${s} -> ${v.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(F.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(o,f,k){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=f.getProxy(E.MainContext.MainThreadTelemetry);const{environment:r}=k,v=f.getProxy(E.MainContext.MainThreadKeytar);if(r.appRoot){let s=r.appRoot.fsPath;n.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,i)=>v.$getPassword(s,i),setPassword:(s,i,m)=>v.$setPassword(s,i,m),deletePassword:(s,i)=>v.$deletePassword(s,i),findPassword:s=>v.$findPassword(s),findCredentials(s){return v.$findCredentials(s)}}}load(o,f){const k=this._extensionPaths.findSubstr(f);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:k?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const f=o.length;if(f<=7||!this.alternativeNames)return;const k=f-7;if((o.charAt(k)==="/"||o.charAt(k)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};p=xe([Be(1,C.IExtHostRpcService),Be(2,P.IExtHostInitDataService)],p);let D=class{constructor(o,f,k){this._extensionPaths=o,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=k.getProxy(E.MainContext.MainThreadTelemetry);const r=k.getProxy(E.MainContext.MainThreadWindow);this._impl=(v,s)=>{const i=M.URI.parse(v);return s?this.callOriginal(v,s):i.scheme==="http"||i.scheme==="https"?r.$openUri(i,v,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?r.$openUri(i,v,{}):this.callOriginal(v,s)}}load(o,f,k){const r=this._extensionPaths.findSubstr(f);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=k(o),this._impl}callOriginal(o,f){return this.sendNoForwardTelemetry(),this._original(o,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};D=xe([Be(2,C.IExtHostRpcService)],D)}),define(we[224],be([0,1,13,16,74,6,2,5,217,12,58,61,27,144,14,66,33,40]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(f,k,r,v){this._disposables=new I.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new C.RPCProtocol(f,null,v),k=w._transform(k,this._rpcProtocol);const s=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());s.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...k}),s.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),s.set(c.IURITransformerService,new c.URITransformerService(v)),s.set(p.IHostUtils,r);const i=new d.InstantiationService(s,!0),m=i.invokeFunction(h=>h.get(D.IExtHostTerminalService));this._disposables.add(m),this._logService=i.invokeFunction(h=>h.get(P.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",k),this._extensionService=i.invokeFunction(h=>h.get(p.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const a=new WeakMap;this._extensionService.getExtensionPathIndex().then(h=>{Error.prepareStackTrace=(y,R)=>{let A="",B,O;for(const S of R)A+=`
	at ${S.toString()}`,O=S.getFileName(),!B&&O&&(B=h.findSubstr(F.URI.file(O)));return a.set(y,B),`${y.name||"Error"}: ${y.message||""}${A}`}});const g=this._rpcProtocol.getProxy(T.MainContext.MainThreadExtensionService),b=this._rpcProtocol.getProxy(T.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(h=>{const y=M.transformErrorForSerialization(h),R=a.get(h);R?g.$onExtensionRuntimeError(R.identifier,y):b.$onUnexpectedError(y)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const k=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,u.timeout)(4e3),k]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,k){f.extensions.forEach(v=>v.extensionLocation=F.URI.revive(k.transformIncomingURIs(v.extensionLocation))),f.environment.appRoot=F.URI.revive(k.transformIncomingURIs(f.environment.appRoot));const r=f.environment.extensionDevelopmentLocationURI;return r&&(f.environment.extensionDevelopmentLocationURI=r.map(v=>F.URI.revive(k.transformIncomingURIs(v)))),f.environment.extensionTestsLocationURI=F.URI.revive(k.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=F.URI.revive(k.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=F.URI.revive(k.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=F.URI.revive(k.transformIncomingURIs(f.logsLocation)),f.logFile=F.URI.revive(k.transformIncomingURIs(f.logFile)),f.workspace=k.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=w}),define(we[225],be([0,1,17,21,45,28,25,198,41]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(n,d,l){this.config=n,this.provider=d,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&I.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&I.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const d=this.config.folderQueries||[];return new Promise((l,c)=>{const p=D=>{this.resultCount++,n(D)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(D=>{const w=D.toString(),o=u.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,o)||this.matchFile(p,{base:D,basename:o})}),Promise.all(d.map(D=>this.searchInFolder(D,p))).then(D=>{l({limitHit:this.isLimitHit,stats:D[0]||void 0})},D=>{c(new Error((0,E.toErrorMessage)(D)))})})}async searchInFolder(n,d){const l=new M.CancellationTokenSource,c=this.getSearchOptionsForFolder(n),p=this.initDirectoryTree(),D=new C.QueryGlobTester(this.config,n),w=!D.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(l),o=T.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},c,l.token),k=o.elapsed(),r=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(v=>{const s=u.posix.relative(n.folder.path,v.path);if(w){const i=u.basename(v.path);this.matchFile(d,{base:n.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(p,n.folder,s,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(p,D,d),{providerTime:k,postProcessTime:r.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(n){const d=(0,C.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),l=(0,C.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:l,includes:d,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},d,l,c){if(l===this.filePattern){const D=u.basename(this.filePattern);this.matchFile(c,{base:d,relativePath:this.filePattern,basename:D})}function p(D){const w=u.basename(D),o=u.dirname(D);let f=n[o];f||(f=n[o]=[],p(o)),f.push({base:d,relativePath:D,basename:w})}p(l)}matchDirectoryTree({rootEntries:n,pathToEntries:d},l,c){const p=this,D=this.filePattern;function w(o){const f=I.hasSiblingFn(()=>o.map(k=>k.basename));for(let k=0,r=o.length;k<r;k++){const v=o[k],{relativePath:s,basename:i}=v;if(l.matchesExcludesSync(s,i,D!==i?f:void 0))continue;const m=d[s];if(m)w(m);else{if(s===D)continue;p.matchFile(c,v)}if(p.isLimitHit)break}}w(n)}matchFile(n,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(d))}}class t{constructor(){this.sessions=new Map}fileSearch(n,d,l,c){const p=this.getSessionTokenSource(n.cacheKey),D=new P(n,d,p&&p.token);let w=0;const o=f=>{w+=f.length,l(f.map(k=>this.rawMatchToSearchItem(k)))};return this.doSearch(D,t.BATCH_SIZE,o,c).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:f.stats}}))}clearCache(n){const d=this.getSessionTokenSource(n);d&&d.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:F.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,d,l,c){c.onCancellationRequested(()=>{n.cancel()});const p=w=>{w&&(D.push(w),d>0&&D.length>=d&&(l(D),D=[]))};let D=[];return n.search(p).then(w=>(D.length&&l(D),w),w=>(D.length&&l(D),Promise.reject(w)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(we[226],be([0,1,15,21,45,28,11,17,25,10,2,41]),function(ne,e,u,M,E,I,F,T,C,P,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(o,f,k,r){this.query=o,this.provider=f,this.fileUtils=k,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,f){const k=this.query.folderQueries||[],r=new M.CancellationTokenSource;return f.onCancellationRequested(()=>r.cancel()),new Promise((v,s)=>{this.collector=new l(o);let i=!1;const m=(a,g)=>{if(!i&&!this.isLimitHit){const b=this.resultSize(a);p(a)&&typeof this.query.maxResults=="number"&&this.resultCount+b>this.query.maxResults&&(this.isLimitHit=!0,i=!0,r.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const h=this.resultSize(a);this.resultCount+=h,(h>0||!p(a))&&this.collector.add(a,g)}};Promise.all(k.map((a,g)=>this.searchInFolder(a,b=>m(b,g),r.token))).then(a=>{r.dispose(),this.collector.flush();const g=a.some(b=>!!b&&!!b.limitHit);v({limitHit:this.isLimitHit||g,messages:(0,u.flatten)(a.map(b=>b?.message?(0,P.isArray)(b.message)?b.message:[b.message]:[])),stats:{type:this.processType}})},a=>{r.dispose();const g=(0,E.toErrorMessage)(a);s(new Error(g))})})}resultSize(o){return p(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,f){const k=Array.isArray(o.ranges)?o.ranges:[o.ranges],r=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:k.slice(0,f),preview:{matches:r.slice(0,f),text:o.preview.text},uri:o.uri}}async searchInFolder(o,f,k){const r=new _.QueryGlobTester(this.query,o),v=[],s={report:a=>{if(!this.validateProviderResult(a))return;const g=o.folder.scheme===F.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(C.dirname(a.uri))):void 0,b=C.relativePath(o.folder,a.uri);if(b){const h=r.includedInQuery(b,T.basename(b),g);(0,P.isPromise)(h)?v.push(h.then(y=>{y&&f(a)})):h&&f(a)}}},i=this.getSearchOptionsForFolder(o),m=await this.provider.provideTextSearchResults(d(this.query.contentPattern),i,s,k);return v.length&&await Promise.all(v),m}validateProviderResult(o){if(p(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const f=(0,_.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),k=(0,_.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),r={folder:t.URI.from(o.folder),excludes:k,includes:f,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=n;function d(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class l{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new D(512,f=>this.sendItems(f))}add(o,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!C.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(c(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=l;function c(w){return p(w)?{preview:{matches:(0,u.mapArrayOrNot)(w.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:w.preview.text},ranges:(0,u.mapArrayOrNot)(w.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function p(w){return!!w.preview}e.extensionResultIsMatch=p;class D{constructor(o,f){this.maxBatchSize=o,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,f){!o||this.addItemToBatch(o,f)}addItems(o,f){!o||this.addItemsToBatch(o,f)}addItemToBatch(o,f){this.batch.push(o),this.batchSize+=f,this.onUpdate()}addItemsToBatch(o,f){this.batch=this.batch.concat(o),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<D.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},D.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=D,D.TIMEOUT=4e3,D.START_BATCH_AFTER_COUNT=50}),define(we[101],be([0,1,6,5,4,225,14,66,12,2,226]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(c,p,D){this.extHostRpc=c,this._uriTransformer=p,this._logService=D,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new I.FileSearchManager}_transformScheme(c){return this._uriTransformer.transformOutgoingScheme(c)}registerTextSearchProvider(c,p){if(this._textSearchUsedSchemes.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this._textSearchUsedSchemes.add(c);const D=this._handlePool++;return this._textSearchProvider.set(D,p),this._proxy.$registerTextSearchProvider(D,this._transformScheme(c)),(0,u.toDisposable)(()=>{this._textSearchUsedSchemes.delete(c),this._textSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}registerFileSearchProvider(c,p){if(this._fileSearchUsedSchemes.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this._fileSearchUsedSchemes.add(c);const D=this._handlePool++;return this._fileSearchProvider.set(D,p),this._proxy.$registerFileSearchProvider(D,this._transformScheme(c)),(0,u.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(c),this._fileSearchProvider.delete(D),this._proxy.$unregisterProvider(D)})}$provideFileSearchResults(c,p,D,w){const o=n(D),f=this._fileSearchProvider.get(c);if(f)return this._fileSearchManager.fileSearch(o,f,k=>{this._proxy.$handleFileMatch(c,p,k.map(r=>r.resource))},w);throw new Error("unknown provider: "+c)}$clearCache(c){return this._fileSearchManager.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,p,D,w){const o=this._textSearchProvider.get(c);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const f=n(D);return this.createTextSearchManager(f,o).search(r=>this._proxy.$handleTextMatch(c,p,r),w)}$enableExtensionHostSearch(){}createTextSearchManager(c,p){return new t.TextSearchManager(c,p,{readdir:D=>Promise.resolve([]),toCanonicalName:D=>D},"textSearchProvider")}};_=xe([Be(0,F.IExtHostRpcService),Be(1,T.IURITransformerService),Be(2,C.ILogService)],_),e.ExtHostSearch=_;function n(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(d),extraFileResources:l.extraFileResources&&l.extraFileResources.map(c=>P.URI.revive(c))}}e.reviveQuery=n;function d(l){return{...l,folder:P.URI.revive(l.folder)}}}),define(we[227],be([0,1,21,16,3,35,2,118,79,112,57,46,5,188,187,39,189,32,190,191,192,174,193,50,33,194,175,197,199,201,96,177,206,207,208,72,40,210,178,8,7,213,52,97,31,22,53,162,196,63,95,99,100,101,12,66,14,27,202,159,65,70,185,211,158,73,51,216,214,215,186,30,209,212,69,71,86,204,98,205,11,146,203,156,195]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o,f,k,r,v,s,i,m,a,g,b,h,y,R,A,B,O,S,x,N,j,W,$,V,q,re,ae,pe,me,Fe,Ye,Ue,Ve,Je,je,Qe,z,Q,X,se,K,te,ce,Pe,Oe,We,qe,et,st,_e,nt,G,J,ge,$e,Ge,rt,ft,ht,Dt,Tt,It,Xe,pt,Ie,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function De(Z){const oe=Z.get(X.IExtHostInitDataService),he=Z.get(J.IExtHostFileSystemInfo),de=Z.get(et.IExtHostConsumerFileSystem),ke=Z.get(s.IExtHostExtensionService),Le=Z.get(re.IExtHostWorkspace),Me=Z.get(ft.IExtHostTelemetry),ze=Z.get(D.IExtHostConfiguration),it=Z.get(z.IURITransformerService),Re=Z.get(Q.IExtHostRpcService),ue=Z.get(O.IExtHostStorage),fe=Z.get(qe.IExtensionStoragePaths),ie=Z.get(Qe.ILoggerService),H=Z.get(Qe.ILogService),ve=Z.get(te.IExtHostTunnelService),Ce=Z.get(ce.IExtHostApiDeprecationService),Ke=Z.get(q.IExtHostWindow),Ne=Z.get(Ge.IExtHostSecretState),lt=Z.get(rt.IExtHostEditorTabs);Re.set(n.ExtHostContext.ExtHostFileSystemInfo,he),Re.set(n.ExtHostContext.ExtHostLogLevelServiceShape,ie),Re.set(n.ExtHostContext.ExtHostWorkspace,Le),Re.set(n.ExtHostContext.ExtHostConfiguration,ze),Re.set(n.ExtHostContext.ExtHostExtensionService,ke),Re.set(n.ExtHostContext.ExtHostStorage,ue),Re.set(n.ExtHostContext.ExtHostTunnelService,ve),Re.set(n.ExtHostContext.ExtHostWindow,Ke),Re.set(n.ExtHostContext.ExtHostSecretState,Ne),Re.set(n.ExtHostContext.ExtHostTelemetry,Me),Re.set(n.ExtHostContext.ExtHostEditorTabs,lt);const Et=Re.set(n.ExtHostContext.ExtHostDecorations,Z.get(Ue.IExtHostDecorations)),vt=Re.set(n.ExtHostContext.ExtHostDocumentsAndEditors,Z.get(v.IExtHostDocumentsAndEditors)),ut=Re.set(n.ExtHostContext.ExtHostCommands,Z.get(c.IExtHostCommands)),gt=Re.set(n.ExtHostContext.ExtHostTerminalService,Z.get(S.IExtHostTerminalService)),dt=Re.set(n.ExtHostContext.ExtHostDebugService,Z.get(Je.IExtHostDebugService)),Pt=Re.set(n.ExtHostContext.ExtHostSearch,Z.get(je.IExtHostSearch)),_t=Re.set(n.ExtHostContext.ExtHostTask,Z.get(Ve.IExtHostTask)),$t=Re.set(n.ExtHostContext.ExtHostOutputService,Z.get(h.IExtHostOutputService)),jt=Re.set(n.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(Re)),St=Re.set(n.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Re,vt)),Wt=Re.set(n.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Re,vt,H)),ii=Re.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new k.ExtHostDocumentSaveParticipant(H,St,Re.getProxy(n.MainContext.MainThreadBulkEdits))),wt=Re.set(n.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(Re,ut,vt,St,fe)),Yt=Re.set(n.ExtHostContext.ExtHostNotebookDocuments,new Ie.ExtHostNotebookDocuments(H,wt)),qt=Re.set(n.ExtHostContext.ExtHostNotebookEditors,new pt.ExtHostNotebookEditors(H,Re,wt)),ni=Re.set(n.ExtHostContext.ExtHostNotebookKernels,new ht.ExtHostNotebookKernels(Re,oe,wt,ut,H)),ri=Re.set(n.ExtHostContext.ExtHostNotebookRenderers,new Tt.ExtHostNotebookRenderers(Re,wt)),At=Re.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,vt)),Jt=Re.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(n.MainContext.MainThreadTreeViews),ut,H)),bi=Re.set(n.ExtHostContext.ExtHostEditorInsets,new me.ExtHostEditorInsets(Re.getProxy(n.MainContext.MainThreadEditorInsets),At,oe)),zt=Re.set(n.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Re,H,he)),Ht=Re.set(n.ExtHostContext.ExtHostLanguages,new g.ExtHostLanguages(Re,St,ut.converter,it)),mt=Re.set(n.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(Re,it,St,ut,zt,H,Ce)),si=Re.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Re,mt)),Nt=Re.set(n.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Re,H,vt)),xt=Re.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Re,Le,ut)),Xt=Re.set(n.ExtHostContext.ExtHostSCM,new A.ExtHostSCM(Re,ut,H)),Ei=Re.set(n.ExtHostContext.ExtHostComments,(0,p.createExtHostComments)(Re,ut,St)),fi=Re.set(n.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Re.getProxy(n.MainContext.MainThreadProgress))),_i=Re.set(n.ExtHostContext.ExtHosLabelService,new Fe.ExtHostLabelService(Re)),mi=Re.set(n.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Re)),Zt=Re.set(n.ExtHostContext.ExtHostAuthentication,new Pe.ExtHostAuthentication(Re)),oi=Re.set(n.ExtHostContext.ExtHostTimeline,new Oe.ExtHostTimeline(Re,ut)),Gt=Re.set(n.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(Re,{remote:oe.remote},Le,H,Ce)),ai=Re.set(n.ExtHostContext.ExtHostWebviewPanels,new nt.ExtHostWebviewPanels(Re,Gt,Le)),yi=Re.set(n.ExtHostContext.ExtHostCustomEditors,new _e.ExtHostCustomEditors(Re,St,fe,Gt,ai)),Si=Re.set(n.ExtHostContext.ExtHostWebviewViews,new st.ExtHostWebviewViews(Re,Gt)),Kt=Re.set(n.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Re,ut)),ei=Re.set(n.ExtHostContext.ExtHostUriOpeners,new $e.ExtHostUriOpeners(Re));Re.set(n.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(Re,wt,vt,ut));const Di=(0,pe.values)(n.ExtHostContext);Re.assertRegistered(Di);const Ci=new G.ExtHostBulkEdits(Re,vt),li=new l.ExtHostClipboard(Re),ui=new b.ExtHostMessageService(Re,H),Vt=new o.ExtHostDialogs(Re),Lt=new B.ExtHostStatusBar(Re,ut.converter);return d.ExtHostApiCommands.register(ut),function(Ae,Ft,Qt){const bt=function(){let Y=!Ae.isUnderDevelopment;function le(){Y||(H.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(ot){if(Array.isArray(ot))ot.forEach(Se);else if(typeof ot=="string")le();else{const yt=ot;typeof yt.scheme=="undefined"&&le(),typeof yt.exclusive=="boolean"&&(0,ae.checkProposedApiEnabled)(Ae)}return ot}}(),ki={getSession(Y,le,Se){return Se?.forceNewSession&&(0,ae.checkProposedApiEnabled)(Ae),Zt.getSession(Ae,Y,le,Se)},async hasSession(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),!!await Zt.getSession(Ae,Y,le,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,le,Se,ot){return Zt.registerAuthenticationProvider(Y,le,Se,ot)}},Ii={registerCommand(Y,le,Se){return ut.registerCommand(!0,Y,le,Se,void 0,Ae)},registerTextEditorCommand(Y,le,Se){return ut.registerCommand(!0,Y,(...ot)=>{const yt=At.getActiveTextEditor();if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}return yt.edit(kt=>{le.apply(Se,[yt,kt,...ot])}).then(kt=>{kt||H.warn("Edits from command "+Y+" were not applied.")},kt=>{H.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Ae),ut.registerCommand(!0,Y,async(...ot)=>{const yt=vt.activeEditor(!0);if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(yt.id);le.apply(Se,[kt,...ot])},void 0,void 0,Ae)),executeCommand(Y,...le){return ut.executeCommand(Y,...le)},getCommands(Y=!1){return ut.getCommands(Y)}},gi={get machineId(){return oe.telemetryInfo.machineId},get sessionId(){return oe.telemetryInfo.sessionId},get language(){return oe.environment.appLanguage},get appName(){return oe.environment.appName},get appRoot(){return oe.environment.appRoot?.fsPath??""},get appHost(){return oe.environment.appHost},get uriScheme(){return oe.environment.appUriScheme},get clipboard(){return li.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(oe.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,le){return Ke.openUri(Y,{allowTunneling:!!oe.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===oe.environment.appUriScheme)return jt.createAppUri(Y);try{return await Ke.asExternalUri(Y,{allowTunneling:!!oe.remote.authority})}catch(le){if((0,Xe.matchesScheme)(Y,It.Schemas.http)||(0,Xe.matchesScheme)(Y,It.Schemas.https))return Y;throw le}},get remoteName(){return(0,Ye.getRemoteName)(oe.remote.authority)},get remoteAuthority(){return(0,ae.checkProposedApiEnabled)(Ae),oe.remote.authority},get uiKind(){return oe.uiKind}};oe.environment.extensionTestsLocationURI||Object.freeze(gi);const pi=oe.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Pi={createTestController(Y,le){return Kt.createTestController(Y,le)},createTestObserver(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.createTestObserver()},runTests(Y){return(0,ae.checkProposedApiEnabled)(Ae),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.onResultsChanged},get testResults(){return(0,ae.checkProposedApiEnabled)(Ae),Kt.results}},Ti={getExtension(Y){const le=Ft.getExtensionDescription(Y);if(le)return new s.Extension(ke,Ae.identifier,le,pi)},get all(){return Ft.getAllExtensionDescriptions().map(Y=>new s.Extension(ke,Ae.identifier,Y,pi))},get onDidChange(){return Ft.onDidChange}},ci={createDiagnosticCollection(Y){return zt.createDiagnosticCollection(Ae.identifier,Y)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:Y=>zt.getDiagnostics(Y),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Y,le){return Ht.changeLanguage(Y.uri,le)},match(Y,le){return(0,t.score)(j.LanguageSelector.from(Y),le.uri,le.languageId,!0)},registerCodeActionsProvider(Y,le,Se){return mt.registerCodeActionProvider(Ae,bt(Y),le,Se)},registerCodeLensProvider(Y,le){return mt.registerCodeLensProvider(Ae,bt(Y),le)},registerDefinitionProvider(Y,le){return mt.registerDefinitionProvider(Ae,bt(Y),le)},registerDeclarationProvider(Y,le){return mt.registerDeclarationProvider(Ae,bt(Y),le)},registerImplementationProvider(Y,le){return mt.registerImplementationProvider(Ae,bt(Y),le)},registerTypeDefinitionProvider(Y,le){return mt.registerTypeDefinitionProvider(Ae,bt(Y),le)},registerHoverProvider(Y,le){return mt.registerHoverProvider(Ae,bt(Y),le,Ae.identifier)},registerEvaluatableExpressionProvider(Y,le){return mt.registerEvaluatableExpressionProvider(Ae,bt(Y),le,Ae.identifier)},registerInlineValuesProvider(Y,le){return mt.registerInlineValuesProvider(Ae,bt(Y),le,Ae.identifier)},registerDocumentHighlightProvider(Y,le){return mt.registerDocumentHighlightProvider(Ae,bt(Y),le)},registerLinkedEditingRangeProvider(Y,le){return mt.registerLinkedEditingRangeProvider(Ae,bt(Y),le)},registerReferenceProvider(Y,le){return mt.registerReferenceProvider(Ae,bt(Y),le)},registerRenameProvider(Y,le){return mt.registerRenameProvider(Ae,bt(Y),le)},registerDocumentSymbolProvider(Y,le,Se){return mt.registerDocumentSymbolProvider(Ae,bt(Y),le,Se)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Ae,Y)},registerDocumentFormattingEditProvider(Y,le){return mt.registerDocumentFormattingEditProvider(Ae,bt(Y),le)},registerDocumentRangeFormattingEditProvider(Y,le){return mt.registerDocumentRangeFormattingEditProvider(Ae,bt(Y),le)},registerOnTypeFormattingEditProvider(Y,le,Se,...ot){return mt.registerOnTypeFormattingEditProvider(Ae,bt(Y),le,[Se].concat(ot))},registerDocumentSemanticTokensProvider(Y,le,Se){return mt.registerDocumentSemanticTokensProvider(Ae,bt(Y),le,Se)},registerDocumentRangeSemanticTokensProvider(Y,le,Se){return mt.registerDocumentRangeSemanticTokensProvider(Ae,bt(Y),le,Se)},registerSignatureHelpProvider(Y,le,Se,...ot){return typeof Se=="object"?mt.registerSignatureHelpProvider(Ae,bt(Y),le,Se):mt.registerSignatureHelpProvider(Ae,bt(Y),le,typeof Se=="undefined"?[]:[Se,...ot])},registerCompletionItemProvider(Y,le,...Se){return mt.registerCompletionItemProvider(Ae,bt(Y),le,Se)},registerInlineCompletionItemProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),mt.registerInlineCompletionsProvider(Ae,bt(Y),le)},registerDocumentLinkProvider(Y,le){return mt.registerDocumentLinkProvider(Ae,bt(Y),le)},registerColorProvider(Y,le){return mt.registerColorProvider(Ae,bt(Y),le)},registerFoldingRangeProvider(Y,le){return mt.registerFoldingRangeProvider(Ae,bt(Y),le)},registerSelectionRangeProvider(Y,le){return mt.registerSelectionRangeProvider(Ae,Y,le)},registerCallHierarchyProvider(Y,le){return mt.registerCallHierarchyProvider(Ae,Y,le)},registerTypeHierarchyProvider(Y,le){return mt.registerTypeHierarchyProvider(Ae,Y,le)},setLanguageConfiguration:(Y,le)=>mt.setLanguageConfiguration(Ae,Y,le),getTokenInformationAtPosition(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),Ht.tokenAtPosition(Y,le)},registerInlayHintsProvider(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),mt.registerInlayHintsProvider(Ae,Y,le)},createLanguageStatusItem(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),Ht.createLanguageStatusItem(Ae,Y,le)}},Ai={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,le,Se){const ot=await(F.URI.isUri(Y)?Promise.resolve(vi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(ot,le,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Ae,Y)},onDidChangeActiveTextEditor(Y,le,Se){return At.onDidChangeActiveTextEditor(Y,le,Se)},onDidChangeVisibleTextEditors(Y,le,Se){return At.onDidChangeVisibleTextEditors(Y,le,Se)},onDidChangeTextEditorSelection(Y,le,Se){return At.onDidChangeTextEditorSelection(Y,le,Se)},onDidChangeTextEditorOptions(Y,le,Se){return At.onDidChangeTextEditorOptions(Y,le,Se)},onDidChangeTextEditorVisibleRanges(Y,le,Se){return At.onDidChangeTextEditorVisibleRanges(Y,le,Se)},onDidChangeTextEditorViewColumn(Y,le,Se){return At.onDidChangeTextEditorViewColumn(Y,le,Se)},onDidCloseTerminal(Y,le,Se){return gt.onDidCloseTerminal(Y,le,Se)},onDidOpenTerminal(Y,le,Se){return gt.onDidOpenTerminal(Y,le,Se)},onDidChangeActiveTerminal(Y,le,Se){return gt.onDidChangeActiveTerminal(Y,le,Se)},onDidChangeTerminalDimensions(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),gt.onDidChangeTerminalDimensions(Y,le,Se)},onDidChangeTerminalState(Y,le,Se){return gt.onDidChangeTerminalState(Y,le,Se)},onDidWriteTerminalData(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),gt.onDidWriteTerminalData(Y,le,Se)},get state(){return Ke.state},onDidChangeWindowState(Y,le,Se){return Ke.onDidChangeWindowState(Y,le,Se)},showInformationMessage(Y,...le){return ui.showMessage(Ae,I.default.Info,Y,le[0],le.slice(1))},showWarningMessage(Y,...le){return ui.showMessage(Ae,I.default.Warning,Y,le[0],le.slice(1))},showErrorMessage(Y,...le){return ui.showMessage(Ae,I.default.Error,Y,le[0],le.slice(1))},showQuickPick(Y,le,Se){return xt.showQuickPick(Y,(0,ae.isProposedApiEnabled)(Ae),le,Se)},showWorkspaceFolderPick(Y){return xt.showWorkspaceFolderPick(Y)},showInputBox(Y,le){return xt.showInput(Y,le)},showOpenDialog(Y){return Vt.showOpenDialog(Y)},showSaveDialog(Y){return Vt.showSaveDialog(Y)},createStatusBarItem(Y,le,Se){let ot,yt,kt;return typeof Y=="string"?(ot=Y,yt=le,kt=Se):(yt=Y,kt=le),Lt.createStatusBarEntry(Ae,ot,yt,kt)},setStatusBarMessage(Y,le){return Lt.setStatusBarMessage(Y,le)},withScmProgress(Y){return Ce.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(le,Se)=>Y({report(ot){}}))},withProgress(Y,le){return fi.withProgress(Ae,Y,le)},createOutputChannel(Y){return $t.createOutputChannel(Y,Ae)},createWebviewPanel(Y,le,Se,ot){return ai.createWebviewPanel(Ae,Y,le,Se,ot)},createWebviewTextEditorInset(Y,le,Se,ot){return(0,ae.checkProposedApiEnabled)(Ae),bi.createWebviewEditorInset(Y,le,Se,ot,Ae)},createTerminal(Y,le,Se){return typeof Y=="object"?("location"in Y&&(0,ae.checkProposedApiEnabled)(Ae),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,le,Se)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,le){return gt.registerProfileProvider(Ae,Y,le)},registerTreeDataProvider(Y,le){return Jt.registerTreeDataProvider(Y,le,Ae)},createTreeView(Y,le){return Jt.createTreeView(Y,le,Ae)},registerWebviewPanelSerializer:(Y,le)=>ai.registerWebviewPanelSerializer(Ae,Y,le),registerCustomEditorProvider:(Y,le,Se={})=>yi.registerCustomEditorProvider(Ae,Y,le,Se),registerFileDecorationProvider(Y){return Et.registerFileDecorationProvider(Y,Ae.identifier)},registerUriHandler(Y){return jt.registerUriHandler(Ae.identifier,Y)},createQuickPick(){return xt.createQuickPick(Ae.identifier,(0,ae.isProposedApiEnabled)(Ae))},createInputBox(){return xt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,le,Se){return mi.onDidChangeActiveColorTheme(Y,le,Se)},registerWebviewViewProvider(Y,le,Se){return Si.registerWebviewViewProvider(Ae,Y,le,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ae.checkProposedApiEnabled)(Ae),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeActiveNotebookEditor(Y,le,Se)},get visibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Ae),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),qt.onDidChangeNotebookEditorSelection(Y,le,Se)},onDidChangeNotebookEditorVisibleRanges(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),qt.onDidChangeNotebookEditorVisibleRanges(Y,le,Se)},showNotebookDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),wt.showNotebookDocument(Y,le)},registerExternalUriOpener(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),ei.registerExternalUriOpener(Ae.identifier,Y,le,Se)},get tabs(){return(0,ae.checkProposedApiEnabled)(Ae),lt.tabs},get activeTab(){return(0,ae.checkProposedApiEnabled)(Ae),lt.activeTab},get onDidChangeTabs(){return(0,ae.checkProposedApiEnabled)(Ae),lt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ae.checkProposedApiEnabled)(Ae),lt.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ae.checkProposedApiEnabled)(Ae),a.InlineCompletionController.get(Y)}},vi={get rootPath(){return Ce.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw M.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,le,...Se)=>Le.updateWorkspaceFolders(Ae,Y,le||0,...Se),onDidChangeWorkspaceFolders:function(Y,le,Se){return Le.onDidChangeWorkspace(Y,le,Se)},asRelativePath:(Y,le)=>Le.getRelativePath(Y,le),findFiles:(Y,le,Se,ot)=>Le.findFiles(j.GlobPattern.from(Y),j.GlobPattern.from(le),Se,Ae.identifier,ot),findTextInFiles:(Y,le,Se,ot)=>{let yt,kt;return typeof le=="object"?(yt=le,kt=Se):(yt={},kt=le,ot=Se),Le.findTextInFiles(Y,yt||{},kt,Ae.identifier,ot)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Ci.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,le,Se,ot)=>Nt.createFileSystemWatcher(j.GlobPattern.from(Y),le,Se,ot),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let le;const Se=Y;if(typeof Y=="string")le=Promise.resolve(F.URI.file(Y));else if(F.URI.isUri(Y))le=Promise.resolve(Y);else if(!Se||typeof Se=="object")le=St.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ot=>St.ensureDocumentData(ot).then(yt=>yt.document))},onDidOpenTextDocument:(Y,le,Se)=>St.onDidAddDocument(Y,le,Se),onDidCloseTextDocument:(Y,le,Se)=>St.onDidRemoveDocument(Y,le,Se),onDidChangeTextDocument:(Y,le,Se)=>St.onDidChangeDocument(Y,le,Se),onDidSaveTextDocument:(Y,le,Se)=>St.onDidSaveDocument(Y,le,Se),onWillSaveTextDocument:(Y,le,Se)=>ii.getOnWillSaveTextDocumentEvent(Ae)(Y,le,Se),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,le){let Se;if(F.URI.isUri(Y))Se=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Se=F.URI.revive(await wt.createNotebookDocument({viewType:Y,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,le,Se,ot){return wt.registerNotebookSerializer(Ae,Y,le,Se,(0,ae.isProposedApiEnabled)(Ae)?ot:void 0)},registerNotebookContentProvider:(Y,le,Se,ot)=>((0,ae.checkProposedApiEnabled)(Ae),wt.registerNotebookContentProvider(Ae,Y,le,Se,(0,ae.isProposedApiEnabled)(Ae)?ot:void 0)),onDidChangeConfiguration:(Y,le,Se)=>Qt.onDidChangeConfiguration(Y,le,Se),getConfiguration(Y,le){return le=arguments.length===1?void 0:le,Qt.getConfiguration(Y,le,Ae)},registerTextDocumentContentProvider(Y,le){return Wt.registerTextDocumentContentProvider(Y,le)},registerTaskProvider:(Y,le)=>(Ce.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Ae,Y,le)),registerFileSystemProvider(Y,le,Se){return si.registerFileSystemProvider(Ae.identifier,Y,le,Se)},get fs(){return de.value},registerFileSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),Pt.registerFileSearchProvider(Y,le)),registerTextSearchProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),Pt.registerTextSearchProvider(Y,le)),registerRemoteAuthorityResolver:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),ke.registerRemoteAuthorityResolver(Y,le)),registerResourceLabelFormatter:Y=>((0,ae.checkProposedApiEnabled)(Ae),_i.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,le,Se)=>Nt.onDidCreateFile(Y,le,Se),onDidDeleteFiles:(Y,le,Se)=>Nt.onDidDeleteFile(Y,le,Se),onDidRenameFiles:(Y,le,Se)=>Nt.onDidRenameFile(Y,le,Se),onWillCreateFiles:(Y,le,Se)=>Nt.getOnWillCreateFileEvent(Ae)(Y,le,Se),onWillDeleteFiles:(Y,le,Se)=>Nt.getOnWillDeleteFileEvent(Ae)(Y,le,Se),onWillRenameFiles:(Y,le,Se)=>Nt.getOnWillRenameFileEvent(Ae)(Y,le,Se),openTunnel:Y=>((0,ae.checkProposedApiEnabled)(Ae),ve.openTunnel(Ae,Y).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ae.checkProposedApiEnabled)(Ae),ve.getTunnels()},onDidChangeTunnels:(Y,le,Se)=>((0,ae.checkProposedApiEnabled)(Ae),ve.onDidChangeTunnels(Y,le,Se)),registerPortAttributesProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),ve.registerPortsAttributesProvider(Y,le)),registerTimelineProvider:(Y,le)=>((0,ae.checkProposedApiEnabled)(Ae),oi.registerTimelineProvider(Y,le,Ae.identifier,ut.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ae.checkProposedApiEnabled)(Ae),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,le,Se)=>Le.onDidGrantWorkspaceTrust(Y,le,Se)},Ri={get inputBox(){return Ce.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ae)},createSourceControl(Y,le,Se){return Xt.createSourceControl(Ae,Y,le,Se)}},Fi={createCommentController(Y,le){return Ei.createCommentController(Ae,Y,le)}},Mi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(Y,le,Se){return dt.onDidStartDebugSession(Y,le,Se)},onDidTerminateDebugSession(Y,le,Se){return dt.onDidTerminateDebugSession(Y,le,Se)},onDidChangeActiveDebugSession(Y,le,Se){return dt.onDidChangeActiveDebugSession(Y,le,Se)},onDidReceiveDebugSessionCustomEvent(Y,le,Se){return dt.onDidReceiveDebugSessionCustomEvent(Y,le,Se)},onDidChangeBreakpoints(Y,le,Se){return dt.onDidChangeBreakpoints(Y,le,Se)},registerDebugConfigurationProvider(Y,le,Se){return dt.registerDebugConfigurationProvider(Y,le,Se||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,le){return dt.registerDebugAdapterDescriptorFactory(Ae,Y,le)},registerDebugAdapterTrackerFactory(Y,le){return dt.registerDebugAdapterTrackerFactory(Y,le)},startDebugging(Y,le,Se){return!Se||typeof Se=="object"&&"configuration"in Se?dt.startDebugging(Y,le,{parentSession:Se}):dt.startDebugging(Y,le,Se||{})},stopDebugging(Y){return dt.stopDebugging(Y)},addBreakpoints(Y){return dt.addBreakpoints(Y)},removeBreakpoints(Y){return dt.removeBreakpoints(Y)},asDebugSourceUri(Y,le){return dt.asDebugSourceUri(Y,le)}},Li={registerTaskProvider:(Y,le)=>_t.registerTaskProvider(Ae,Y,le),fetchTasks:Y=>_t.fetchTasks(Y),executeTask:Y=>_t.executeTask(Ae,Y),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(Y,le,Se)=>_t.onDidStartTask(Y,le,Se),onDidEndTask:(Y,le,Se)=>_t.onDidEndTask(Y,le,Se),onDidStartTaskProcess:(Y,le,Se)=>_t.onDidStartTaskProcess(Y,le,Se),onDidEndTaskProcess:(Y,le,Se)=>_t.onDidEndTaskProcess(Y,le,Se)},Oi={createNotebookController(Y,le,Se,ot,yt){return ni.createNotebookController(Ae,Y,le,Se,ot,(0,ae.isProposedApiEnabled)(Ae)?yt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,le)=>wt.registerNotebookCellStatusBarItemProvider(Ae,Y,le),get onDidSaveNotebookDocument(){return(0,ae.checkProposedApiEnabled)(Ae),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ae.checkProposedApiEnabled)(Ae),qt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ri.createRendererMessaging(Ae,Y)},onDidChangeNotebookDocumentMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),Yt.onDidChangeNotebookDocumentMetadata(Y,le,Se)},onDidChangeNotebookCells(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeNotebookCells(Y,le,Se)},onDidChangeNotebookCellExecutionState(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeNotebookCellExecutionState(Y,le,Se)},onDidChangeCellOutputs(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeCellOutputs(Y,le,Se)},onDidChangeCellMetadata(Y,le,Se){return(0,ae.checkProposedApiEnabled)(Ae),wt.onDidChangeCellMetadata(Y,le,Se)},createConcatTextDocument(Y,le){return(0,ae.checkProposedApiEnabled)(Ae),new We.ExtHostNotebookConcatDocument(wt,St,Y,le)}};return{version:oe.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:gi,extensions:Ti,languages:ci,notebooks:Oi,scm:Ri,tasks:Li,tests:Pi,window:Ai,workspace:vi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:u.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:P.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:n.UIKind,Uri:F.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:Dt.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=De}),define(we[228],be([0,1,58,96,31,95,32,39,50,40,99,100,101,72,65,70,97,51,30,69,86,71,200,12,154]),function(ne,e,u,M,E,I,F,T,C,P,t,_,n,d,l,c,p,D,w,o,f,k,r,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(v.ILoggerService,r.ExtHostLoggerService),(0,u.registerSingleton)(v.ILogService,s.ExtHostLogService),(0,u.registerSingleton)(c.IExtHostApiDeprecationService,c.ExtHostApiDeprecationService),(0,u.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,u.registerSingleton)(F.IExtHostConfiguration,F.ExtHostConfiguration),(0,u.registerSingleton)(D.IExtHostConsumerFileSystem,D.ExtHostConsumerFileSystem),(0,u.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,u.registerSingleton)(I.IExtHostDecorations,I.ExtHostDecorations),(0,u.registerSingleton)(C.IExtHostDocumentsAndEditors,C.ExtHostDocumentsAndEditors),(0,u.registerSingleton)(w.IExtHostFileSystemInfo,w.ExtHostFileSystemInfo),(0,u.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,u.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,u.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,u.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,u.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,u.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,u.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,u.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,u.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,u.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry),(0,u.registerSingleton)(k.IExtHostEditorTabs,k.ExtHostEditorTabs)}),define(we[229],be([0,1,227,33,223,7,13,5,11]),function(ne,e,u,M,E,I,F,T,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var P;(function(l){const c=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(D,...w)=>{w.forEach(r=>{if(!self.trustedTypes?.isScript(r))throw new Error("TrustedScripts only, please")});const o=w.slice(0,-1).join(","),f=w.pop().toString();return`(function anonymous(${o}) {${f}
})`}});function p(...D){return c?self.eval(c.createScript("",...D)):new Function(...D)}l.create=p})(P||(P={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(c,p){for(let D of this._alternatives){let w=D(c);if(w){c=w;break}}if(this._factories.has(c))return this._factories.get(c).load(c,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const c=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);d(c,this._initData.environment.isExtensionDevelopmentDebug);const p=this._instaService.invokeFunction(u.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,p,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(c){return c.browser}async _loadCommonJSModule(c,p,D){p=p.with({path:n(p.path,".js")}),c&&performance.mark(`code/extHost/willFetchExtensionCode/${c.value}`);const w=await fetch(C.FileAccess.asBrowserUri(p).toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c.value}`),w.status!==200)throw new Error(w.statusText);const o=await w.text(),f=`${p.toString(!0)}#vscode-extension`,k=`${o}
//# sourceURL=${f}`;let r;try{r=P.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(k)??k)}catch(m){throw console.error(c?`Loading code for extension ${c.value} failed: ${m.message}`:`Loading code failed: ${m.message}`),console.error(`${p.toString(!0)}${typeof m.line=="number"?` line ${m.line}`:""}${typeof m.column=="number"?` column ${m.column}`:""}`),console.error(m),m}const v={},s={exports:v},i=m=>{const a=this._fakeModules.getModule(m,p);if(a===void 0)throw new Error(`Cannot load module '${m}'`);return a};try{return D.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c.value}`),r(s,v,i),s.exports!==v?s.exports:v}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c.value}`),D.codeLoadingStop()}}async $setRemoteEnvironment(c){}async _waitForDebuggerAttachment(c=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+c;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,F.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:l=>l});function n(l,c){return l.endsWith(c)?l:l+c}function d(l,c){p("info","log"),p("log","log"),p("warn","warn"),p("error","error");function p(o,f){const k=console[o];console[o]=function(){l.$logExtensionHostMessage({type:"__$console",severity:f,arguments:w(arguments)}),c&&k.apply(console,arguments)}}const D=1e5;function w(o){const f=[],k=[];if(o.length)for(let r=0;r<o.length;r++){if(typeof o[r]=="undefined")o[r]="undefined";else if(o[r]instanceof Error){const v=o[r];v.stack?o[r]=v.stack:o[r]=v.toString()}k.push(o[r])}try{const r=JSON.stringify(k,function(v,s){if(s&&typeof s=="object"){if(f.indexOf(s)!==-1)return"[Circular]";f.push(s)}return s});return r.length>D?"Output omitted for a large object that exceeds the limits":r}catch(r){return`Output omitted for an object that cannot be inspected ('${r.toString()}')`}}}}),define(we[230],be([0,1,58,33,73,229]),function(ne,e,u,M,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.registerSingleton)(M.IExtHostExtensionService,I.ExtHostExtensionService),(0,u.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(we[239],be([0,1,23,3,182,224,218,17,74,11,2,228,230]),function(ne,e,u,M,E,I,F,T,C,P,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(o,f){return o instanceof Request||/^file:/i.test(String(o))&&(o=P.FileAccess.asBrowserUri(t.URI.parse(String(o))).toString(!0)),d(o,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(o,f,k,r,v){return/^file:/i.test(f.toString())&&(f=P.FileAccess.asBrowserUri(t.URI.parse(f.toString())).toString(!0)),super.open(o,f,k??!0,r,v)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const o=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:k=>k}),f=self.Worker;Worker=function(k,r){/^file:/i.test(k.toString())&&(k=P.FileAccess.asBrowserUri(t.URI.parse(k.toString())).toString(!0));const s=`(${function(g){function b(A){return typeof A=="string"||A instanceof URL?String(A).replace(/^file:\/\//i,"vscode-file://vscode-app"):A}const h=fetch.bind(self);self.fetch=function(A,B){return A instanceof Request?h(A,B):h(b(A),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(A,B,O,S,x){return super.open(A,b(B),O??!0,S,x)}};const y=importScripts.bind(self);self.importScripts=(...A)=>{y(...A.map(b))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:A=>A}):void 0;y(R?R.createScriptURL(g):g)}.toString()}('${k}'))`;r=r||{},r.name=r.name||T.basename(k.toString());const i=new Blob([s],{type:"application/javascript"}),m=URL.createObjectURL(i);return new f(o?o.createScriptURL(m):m,r)}}else self.Worker=class extends F.NestedWorker{constructor(o,f){super(n,o,{name:T.basename(o.toString()),...f})}};const l=new class{constructor(){this.pid=void 0}exit(o){_()}async exists(o){return!0}async realpath(o){return o}};class c{constructor(){const f=new MessageChannel,k=new M.Emitter;let r=!1;n(f.port2,[f.port2]),f.port1.onmessage=v=>{const{data:s}=v;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const i=u.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,E.isMessageOfType)(i,2)){r=!0,D("received terminate message from renderer");return}k.fire(i)},this.protocol={onMessage:k.event,send:v=>{if(!r){const s=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);f.port1.postMessage(s,[s])}}}}}function p(o){return new Promise(f=>{const k=o.onMessage(r=>{k.dispose();const v=JSON.parse(r.toString());o.send((0,E.createMessageOfType)(0)),f({protocol:o,initData:v})});o.send((0,E.createMessageOfType)(1))})}let D=o=>_();function w(){const o=new c;C.mark("code/extHost/willConnectToRenderer"),p(o.protocol).then(f=>{C.mark("code/extHost/didWaitForInitData");const k=new I.ExtensionHostMain(f.protocol,f.initData,l,null);D=r=>k.terminate(r)})}e.create=w})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bef4dba21f68bbdb8d9f08fe04b2e1858597722b/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
